<?php

// no direct access
defined('_JEXEC') or die;

jimport('joomla.application.component.controller');
//include_once(JPATH_ROOT.DS.'components'.DS.'com_zweather'.DS.'models'.DS.'location.php');
//include_once(JPATH_ROOT.DS.'components'.DS.'com_zweather'.DS.'models'.DS.'locations.php');
//include_once('models'.DS.'location.php');
include_once('models'.DS.'locations.php');


class ZWeatherController extends JController
{

	protected $default_view = 'locations';

	/**
	 * Method to display a view.
	 *
	 * @param	boolean			If true, the view output will be cached
	 * @param	array			An array of safe url parameters and their variable types, for valid values see {@link JFilterInput::clean()}.
	 *
	 * @return	JController		This object to support chaining.
	 * @since	1.5
	 */
	public function display($cachable = false, $urlparams = false)
	{
		$zc_rssnews_url = "http://www.zcontent.net/rssnews";
		$zc_rss_age = "86400";
		
		//require_once JPATH_COMPONENT.'/helpers/content.php';

		// Load the submenu.
		//ContentHelper::addSubmenu(JRequest::getCmd('view', 'articles'));

		$view		= JRequest::getCmd('view', 'locations');
		$layout 	= JRequest::getCmd('layout', 'locations');
		$id			= JRequest::getInt('id');
		// Check for edit form.
		if ($view == 'location' && $layout == 'edit' && !$this->checkEditId('com_zweather.edit.location', $id)) {
			// Somehow the person just went to the form - we don't allow that.
			$this->setError(JText::sprintf('JLIB_APPLICATION_ERROR_UNHELD_ID', $id));
			$this->setMessage($this->getError(), 'error');
			$this->setRedirect(JRoute::_('index.php?option=com_zweather&view=locations', false));

			return false;
		}
		$task = JRequest::getCmd('task','locations');
		//print_r($_REQUEST);
		$cids = JRequest::getVar('cid');
		switch($task){
			case "rssnews":
				echo ZWeatherController::getRSSHTML($zc_rssnews_url, "rssnews", $zc_rss_age);
				exit;
				break;
			case "refresh":
				$model = new ZWeatherModelLocations();
				$model->refresh($cids);
				break;
			case "ziplookup":
				ZWeatherController::getLatLong(JRequest::getVar("zipcode"));
				exit;
				break;
		}
		parent::display();

		return $this;
	}

	function _getURL($url){
		$xmlstr = "";
		$fxml = @fopen($url, 'r');
		if($fxml) {
			while (!feof($fxml)) {
				$xmlstr .= fread($fxml, 8192);
			}
			fclose($fxml);
		}
		return $xmlstr;
	}
	
	function getRSSXML($url) {
		$cache = JFactory::getCache('com_zweather','callback');
		$cache->setLifeTime(60*60*12); // check every 12 hours
		$cache->setCaching(true); // always cache this, even if caching is turned off
		$xmlstr = $cache->get('ZWeatherController::_getURL',array($url),$url);
		return $xmlstr;
	}
	
	static function getRSSHTML($url, $id, $rssage) {
	
			$xmlstr = ZWeatherController::getRSSXML($url);
			$htmlstr = "";
			//echo "strlen: " . strlen($xmlstr) . "<br/>\n";
	
			if (strlen($xmlstr) == 0){
				echo JText::_("ZC_ERROR_LOADING_RSS_FEED");
			}
			else{
				//php5 only
				$xml = new SimpleXMLElement($xmlstr);
	
				$channel_title = $xml->channel[0]->title;
				$channel_desc = $xml->channel[0]->description;
				$channel_link = $xml->channel[0]->link;
				$htmlstr .= "<div class='rsssection'><div class='rssheading'>$channel_title</div>\n";
				if(strlen($channel_desc) > 0){
					$htmlstr .= "<div class='rssdescription'>\n"
					. "$channel_desc<br/>\n"
					. "<a href=\"$channel_link\">website</a></div>\n";
				}
				//echo "count: " . count($xml->channel->item) . "<br/>\n";
				foreach ($xml->channel[0]->item as $item){
					//$htmlstr .= "Item<br/>\n";
					$item_title = $item->title;
					$item_desc = $item->description;
					$item_link = $item->link;
					$item_date = $item->pubDate;
	
					$htmlstr .= "<div class='rsssection'>\n";
					$htmlstr .= "<div class='rsssection_header'>{$item_title}</div>\n";
					$date = substr($item_date,0,16);
					$htmlstr .=  "<div class='rssdate'>{$date}</div>\n";
					if(strlen($item_desc) > 0)
						$htmlstr .= "<div class='rssdescription'> {$item_desc}<br/>"
						. "<a href=\"{$item_link}\" target=\"_blank\">more...</a></div>\n";
					$htmlstr .= "</div>\n";
	
				}
	
			return $htmlstr;
		}
	}

	function getLatLong($zip){
		$zip = trim($zip);
		if(strlen($zip) != 5)
			return false;
		$url='http://graphical.weather.gov/xml/sample_products/browser_interface/ndfdXMLclient.php?listZipCodeList=' . $zip;
		$xml = JFactory::getXML($url);
		$latlng = $xml->latLonList;
		echo "$latlng";
		exit;		
	}
	
	
}
