<?php

// no direct access
defined('_JEXEC') or die;

jimport('joomla.application.component.modellist');
JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_zweather'.DS.'tables');
//JTable::addIncludePath(JPATH_BASE.DS.'components'.DS.'com_zweather'.DS.'tables');
include_once(JPATH_ROOT.DS.'components'.DS.'com_zweather'.DS.'helpers'.DS.'zweather.php');

class ZWeatherModelLocations extends JModelList
{
	protected $text_prefix = "COM_ZWEATHER";
	/**
	 * Constructor.
	 *
	 * @param	array	An optional associative array of configuration settings.
	 * @see		JController
	 * @since	1.6
	 */
	public function __construct($config = array())
	{
		if (empty($config['filter_fields'])) {
			$config['filter_fields'] = array(
				'id', 'a.id',
				'title', 'a.title',
				'latitude', 'a.latitude',
				'longitude', 'a.longitude',
				'observation_loc','a.observatoin_loc',
				'default_loc', 'a.default_loc',
				'cap_zone', 'a.cap_zone',
				'ordering', 'a.ordering',
				'checked_out', 'a.checked_out',
				'checked_out_time', 'a.checked_out_time',
				'published', 'a.published',
				'publish_up', 'a.publish_up',
				'publish_down', 'a.publish_down',
				'params', 'a.params',
			);
		}

		parent::__construct($config);
	}

	/**
	 * Method to auto-populate the model state.
	 *
	 * Note. Calling getState in this method will result in recursion.
	 *
	 * @return	void
	 * @since	1.6
	 */
	protected function populateState($ordering = null, $direction = null)
	{
		// Initialise variables.
		$app = JFactory::getApplication();

		// Adjust the context to support modal layouts.
		if ($layout = JRequest::getVar('layout')) {
			$this->context .= '.'.$layout;
		}

		$search = $this->getUserStateFromRequest($this->context.'.filter.search', 'filter_search');
		$this->setState('filter.search', $search);

		$published = $this->getUserStateFromRequest($this->context.'.filter.published', 'filter_published', '');
		$this->setState('filter.published', $published);

		// List state information.
		parent::populateState('a.title', 'asc');
	}

	/**
	 * Method to get a store id based on model configuration state.
	 *
	 * This is necessary because the model is used by the component and
	 * different modules that might need different sets of data or different
	 * ordering requirements.
	 *
	 * @param	string		$id	A prefix for the store id.
	 *
	 * @return	string		A store id.
	 * @since	1.6
	 */
	protected function getStoreId($id = '')
	{
		// Compile the store id.
		$id	.= ':'.$this->getState('filter.search');
		$id	.= ':'.$this->getState('filter.published');

		return parent::getStoreId($id);
	}

	function publish(&$pks, $value = 1)
	{
		/*
		$t =& JTable::getInstance("Location", "ZWeatherTable");
		if($t == null){
			echo "table is null";
			exit;
		}
		*/
		$t = $this->getTable();
		$result = $t->publish($pks, $value);

		return $result;
	}

	/**
	 * Method to delete record(s)
	 *
	 * @access    public
	 * @return    boolean    True on success
	 */
	function delete()
	{
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$row =& $this->getTable();
		 
		foreach($cids as $cid) {
			if (!$row->delete( $cid )) {
				$this->setError( $row->getErrorMsg() );
				return false;
			}
		}
		 
		return true;
	}	
	
	function setDefault( $cid) {
		$db		= $this->getDbo();
		$msg = '';
		$db->setQuery( "UPDATE #__zweather_locations SET default_loc='0' WHERE default_loc='1'" );
		$db->query();
		$db->setQuery( "UPDATE #__zweather_locations SET default_loc='1' WHERE id = " . $cid[0] );
		$db->query();
		return true;
	}

	public function getTable($type = "Locations", $prefix = 'JTable', $config = array()){
		$this->addTablePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_zweather'.DS.'tables');
		return JTable::getInstance($type, $prefix, $config);
	}

	protected function getListQuery()
	{
		// Create a new query object.
		$db		= $this->getDbo();
		$query	= $db->getQuery(true);
		$user	= JFactory::getUser();

		// Select the required fields from the table.
		$query->select(
			$this->getState(
				'list.select',
				'a.id, a.title, a.latitude, a.longitude, a.observation_loc, a.default_loc, a.cap_zone, ' .
				'a.ordering, a.created, a.created_by, a.modified, a.modified_by,'.
				'a.checked_out, a.checked_out_time, a.published, a.publish_up, a.publish_down, a.params'
			)
		);
		$query->from('#__zweather_locations AS a');

		// Join over the users for the checked out user.
		$query->select('uc.name AS editor');
		$query->join('LEFT', '#__users AS uc ON uc.id=a.checked_out');

		// Filter by published state
		$published = $this->getState('filter.published');
		if (is_numeric($published)) {
			$query->where('a.published = ' . (int) $published);
		}
		elseif ($published === '') {
			$query->where('(a.published = 0 OR a.published = 1)');
		}

		// Filter by search in name.
		$search = $this->getState('filter.search');
		if (!empty($search)) {
			if (stripos($search, 'id:') === 0) {
				$query->where('a.id = '.(int) substr($search, 3));
			}
			else {
				$search = $db->Quote('%'.$db->getEscaped($search, true).'%');
				$query->where('(a.title LIKE '.$search.')');
			}
		}

		// Add the list ordering clause.
		$orderCol	= $this->state->get('list.ordering');
		$orderDirn	= $this->state->get('list.direction');
		if ($orderCol == 'a.ordering' || $orderCol == 'title') {
			$orderCol = 'title '.$orderDirn.', a.ordering';
		}
		$query->order($db->getEscaped($orderCol.' '.$orderDirn));

		return $query;
	}

	function refresh($cids){
		$helper = new ZWeatherHelper();
		$params = JComponentHelper::getParams('com_zweather');
		$params->set('debug_nocache',1); // force cache refresh
		foreach($cids as $cid){
			set_time_limit(30); // set time limit per loop iteration, hopefully it won't timeout on us
			$loc = JTable::getInstance("locations");
			//echo "loc($cid): $loc<br/>\n";
			//print_r($loc); exit;
			$loc->load($cid);
			$helper->latitude = $loc->latitude;
			$helper->longitude = $loc->longitude;
			$helper->id = $cid;
			$helper->observation_loc = $loc->observation_loc;
			$helper->cap_zone = $loc->cap_zone;
			//echo "($cid) " . $helper->latitude . " / " . $helper->longitude . "<br/>\n";
			$helper->getForecastXML($params);
			$helper->getForecast12XML($params);
			$helper->getForecast3XML($params);
			$helper->getObservationXML($params);
			$helper->getAlertXML($params);
		}
	}
	
	}
