DROP TABLE IF EXISTS `tkt_assets`;
CREATE TABLE `tkt_assets` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set parent.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `level` int(10) unsigned NOT NULL COMMENT 'The cached level in the nested tree.',
  `name` varchar(50) NOT NULL COMMENT 'The unique name for the asset.\n',
  `title` varchar(100) NOT NULL COMMENT 'The descriptive title for the asset.',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_asset_name` (`name`),
  KEY `idx_lft_rgt` (`lft`,`rgt`),
  KEY `idx_parent_id` (`parent_id`)
) ENGINE=MyISAM AUTO_INCREMENT=512 DEFAULT CHARSET=utf8;

INSERT INTO tkt_assets
(`id`, `parent_id`, `lft`, `rgt`, `level`, `name`, `title`, `rules`) VALUES 
('1', '0', '1', '1092', '0', 'root.1', 'Root Asset', '{\"core.login.site\":{\"6\":1,\"2\":1},\"core.login.admin\":{\"6\":1},\"core.admin\":{\"8\":1},\"core.manage\":{\"7\":1},\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
('2', '1', '2', '3', '1', 'com_admin', 'com_admin', '{}'),
('3', '1', '4', '11', '1', 'com_banners', 'com_banners', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('4', '1', '12', '13', '1', 'com_cache', 'com_cache', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}'),
('5', '1', '14', '15', '1', 'com_checkin', 'com_checkin', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}'),
('6', '1', '16', '17', '1', 'com_config', 'com_config', '{}'),
('7', '1', '18', '87', '1', 'com_contact', 'com_contact', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('8', '1', '88', '955', '1', 'com_content', 'com_content', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1},\"core.edit.own\":[]}'),
('9', '1', '956', '957', '1', 'com_cpanel', 'com_cpanel', '{}'),
('10', '1', '958', '959', '1', 'com_installer', 'com_installer', '{\"core.admin\":[],\"core.manage\":{\"7\":0},\"core.delete\":{\"7\":0},\"core.edit.state\":{\"7\":0}}'),
('11', '1', '960', '961', '1', 'com_languages', 'com_languages', '{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('12', '1', '962', '963', '1', 'com_login', 'com_login', '{}'),
('13', '1', '964', '965', '1', 'com_mailto', 'com_mailto', '{}'),
('14', '1', '966', '967', '1', 'com_massmail', 'com_massmail', '{}'),
('15', '1', '968', '969', '1', 'com_media', 'com_media', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":{\"5\":1},\"core.edit\":[],\"core.edit.state\":[]}'),
('16', '1', '970', '971', '1', 'com_menus', 'com_menus', '{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('17', '1', '37', '38', '1', 'com_messages', 'com_messages', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}'),
('18', '1', '974', '975', '1', 'com_modules', 'com_modules', '{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('19', '1', '976', '983', '1', 'com_newsfeeds', 'com_newsfeeds', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('20', '1', '984', '985', '1', 'com_plugins', 'com_plugins', '{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('21', '1', '986', '987', '1', 'com_redirect', 'com_redirect', '{\"core.admin\":{\"7\":1},\"core.manage\":[]}'),
('22', '1', '988', '989', '1', 'com_search', 'com_search', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1}}'),
('23', '1', '990', '991', '1', 'com_templates', 'com_templates', '{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('24', '1', '992', '995', '1', 'com_users', 'com_users', '{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('25', '1', '996', '1013', '1', 'com_weblinks', 'com_weblinks', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1,\"10\":0,\"12\":0},\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1}}'),
('26', '1', '1014', '1015', '1', 'com_wrapper', 'com_wrapper', '{}'),
('33', '1', '1076', '1077', '1', 'com_finder', 'com_finder', '{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1}}'),
('34', '8', '105', '112', '2', 'com_content.category.9', 'Uncategorised', '{\"core.create\":{\"10\":0,\"12\":0},\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('35', '3', '7', '8', '2', 'com_banners.category.10', 'Uncategorised', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('36', '7', '23', '24', '2', 'com_contact.category.11', 'Uncategorised', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('37', '19', '979', '980', '2', 'com_newsfeeds.category.12', 'Uncategorised', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('38', '25', '1003', '1004', '2', 'com_weblinks.category.13', 'Uncategorised', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('39', '8', '113', '276', '2', 'com_content.category.14', 'Sample Data-Articles', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('40', '3', '9', '10', '2', 'com_banners.category.15', 'Sample Data-Banners', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('41', '7', '25', '86', '2', 'com_contact.category.16', 'Sample Data-Contact', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('42', '19', '981', '982', '2', 'com_newsfeeds.category.17', 'Sample Data-Newsfeeds', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('43', '25', '1005', '1012', '2', 'com_weblinks.category.18', 'Sample Data-Weblinks', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('44', '39', '114', '233', '3', 'com_content.category.19', 'Joomla!', '{\"core.create\":{\"10\":0,\"12\":0},\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('45', '44', '115', '212', '4', 'com_content.category.20', 'Extensions', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('46', '45', '116', '127', '5', 'com_content.category.21', 'Components', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('47', '45', '128', '185', '5', 'com_content.category.22', 'Modules', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('48', '45', '186', '195', '5', 'com_content.category.23', 'Templates', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('49', '45', '196', '197', '5', 'com_content.category.24', 'Languages', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('50', '45', '198', '211', '5', 'com_content.category.25', 'Plugins', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('51', '39', '234', '257', '3', 'com_content.category.26', 'Park Site', '{\"core.create\":{\"10\":0,\"12\":0},\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('52', '51', '235', '240', '4', 'com_content.category.27', 'Park Blog', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('53', '51', '241', '254', '4', 'com_content.category.28', 'Photo Gallery', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('54', '39', '258', '271', '3', 'com_content.category.29', 'Fruit Shop Site', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('55', '54', '259', '264', '4', 'com_content.category.30', 'Growers', '{\"core.create\":{\"12\":0},\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":{\"10\":1}}'),
('56', '43', '1006', '1007', '3', 'com_weblinks.category.31', 'Park Links', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');

INSERT INTO tkt_assets
(`id`, `parent_id`, `lft`, `rgt`, `level`, `name`, `title`, `rules`) VALUES 
('57', '43', '1008', '1011', '3', 'com_weblinks.category.32', 'Joomla! Specific Links', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('58', '57', '1009', '1010', '4', 'com_weblinks.category.33', 'Other Resources', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('59', '41', '26', '27', '3', 'com_contact.category.34', 'Park Site', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('60', '41', '28', '85', '3', 'com_contact.category.35', 'Shop Site', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('61', '60', '29', '30', '4', 'com_contact.category.36', 'Staff', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('62', '60', '31', '84', '4', 'com_contact.category.37', 'Fruit Encyclopedia', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('63', '62', '32', '33', '5', 'com_contact.category.38', 'A', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('64', '62', '34', '35', '5', 'com_contact.category.39', 'B', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('65', '62', '36', '37', '5', 'com_contact.category.40', 'C', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('66', '62', '38', '39', '5', 'com_contact.category.41', 'D', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('67', '62', '40', '41', '5', 'com_contact.category.42', 'E', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('68', '62', '42', '43', '5', 'com_contact.category.43', 'F', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('69', '62', '44', '45', '5', 'com_contact.category.44', 'G', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('70', '62', '46', '47', '5', 'com_contact.category.45', 'H', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('71', '62', '48', '49', '5', 'com_contact.category.46', 'I', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('72', '62', '50', '51', '5', 'com_contact.category.47', 'J', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('73', '62', '52', '53', '5', 'com_contact.category.48', 'K', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('74', '62', '54', '55', '5', 'com_contact.category.49', 'L', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('75', '62', '56', '57', '5', 'com_contact.category.50', 'M', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('76', '62', '58', '59', '5', 'com_contact.category.51', 'N', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('77', '62', '60', '61', '5', 'com_contact.category.52', 'O', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('78', '62', '62', '63', '5', 'com_contact.category.53', 'P', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('79', '62', '64', '65', '5', 'com_contact.category.54', 'Q', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('80', '62', '66', '67', '5', 'com_contact.category.55', 'R', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('81', '62', '68', '69', '5', 'com_contact.category.56', 'S', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('82', '62', '70', '71', '5', 'com_contact.category.57', 'T', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('83', '62', '72', '73', '5', 'com_contact.category.58', 'U', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('84', '62', '74', '75', '5', 'com_contact.category.59', 'V', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('85', '62', '76', '77', '5', 'com_contact.category.60', 'W', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('86', '62', '78', '79', '5', 'com_contact.category.61', 'X', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('87', '62', '80', '81', '5', 'com_contact.category.62', 'Y', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('88', '62', '82', '83', '5', 'com_contact.category.63', 'Z', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('89', '46', '117', '118', '6', 'com_content.article.1', 'Administrator Components', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('90', '93', '130', '131', '7', 'com_content.article.2', 'Archive Module', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('91', '93', '132', '133', '7', 'com_content.article.3', 'Article Categories Module', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('92', '93', '134', '135', '7', 'com_content.article.4', 'Articles Category Module', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('93', '47', '129', '144', '6', 'com_content.category.64', 'Content Modules', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('94', '47', '145', '152', '6', 'com_content.category.65', 'User Modules', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('95', '47', '153', '164', '6', 'com_content.category.66', 'Display Modules', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('96', '47', '165', '176', '6', 'com_content.category.67', 'Utility Modules', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('97', '48', '187', '188', '6', 'com_content.category.68', 'Atomic', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('98', '48', '189', '190', '6', 'com_content.category.69', 'Beez 20', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('99', '48', '191', '192', '6', 'com_content.category.70', 'Beez5', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('100', '48', '193', '194', '6', 'com_content.category.71', 'Milky Way', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('101', '50', '199', '200', '6', 'com_content.article.5', 'Authentication', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('102', '51', '255', '256', '4', 'com_content.article.6', 'Australian Parks ', '{\"core.delete\":[],\"core.edit\":{\"2\":1},\"core.edit.state\":[]}'),
('103', '95', '154', '155', '7', 'com_content.article.7', 'Banner Module', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('104', '44', '213', '214', '4', 'com_content.article.8', 'Beginners', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('105', '46', '119', '120', '6', 'com_content.article.9', 'Contact', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('106', '46', '121', '122', '6', 'com_content.article.10', 'Content', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');

INSERT INTO tkt_assets
(`id`, `parent_id`, `lft`, `rgt`, `level`, `name`, `title`, `rules`) VALUES 
('107', '109', '249', '250', '6', 'com_content.article.11', 'Cradle Mountain', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('108', '53', '242', '247', '5', 'com_content.category.72', 'Animals', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('109', '53', '248', '253', '5', 'com_content.category.73', 'Scenery', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('110', '95', '156', '157', '7', 'com_content.article.12', 'Custom HTML Module', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('111', '54', '265', '266', '4', 'com_content.article.13', 'Directions', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('112', '50', '201', '202', '6', 'com_content.article.14', 'Editors', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('113', '50', '203', '204', '6', 'com_content.article.15', 'Editors-xtd', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('114', '95', '158', '159', '7', 'com_content.article.16', 'Feed Display', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('115', '52', '236', '237', '5', 'com_content.article.17', 'First Blog Post', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('116', '52', '238', '239', '5', 'com_content.article.18', 'Second Blog Post', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('117', '95', '160', '161', '7', 'com_content.article.19', 'Footer Module', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('118', '54', '267', '268', '4', 'com_content.article.20', 'Fruit Shop', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('119', '44', '215', '216', '4', 'com_content.article.21', 'Getting Help', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('120', '44', '217', '218', '4', 'com_content.article.22', 'Getting Started', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('121', '55', '260', '261', '5', 'com_content.article.23', 'Happy Orange Orchard', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('122', '44', '219', '220', '4', 'com_content.article.24', 'Joomla!', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('123', '108', '243', '244', '6', 'com_content.article.25', 'Koala', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('124', '96', '166', '167', '7', 'com_content.article.26', 'Language Switcher', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('125', '93', '136', '137', '7', 'com_content.article.27', 'Latest Articles Module', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('126', '94', '146', '147', '7', 'com_content.article.28', 'Login Module', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('127', '166', '180', '181', '7', 'com_content.article.29', 'Menu Module', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('128', '93', '138', '139', '7', 'com_content.article.30', 'Most Read Content', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('129', '93', '140', '141', '7', 'com_content.article.31', 'News Flash', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('130', '44', '221', '222', '4', 'com_content.article.32', 'Parameters', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('131', '108', '245', '246', '6', 'com_content.article.33', 'Phyllopteryx', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('132', '109', '251', '252', '6', 'com_content.article.34', 'Pinnacles', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('133', '44', '223', '224', '4', 'com_content.article.35', 'Professionals', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('134', '95', '162', '163', '7', 'com_content.article.36', 'Random Image Module', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('135', '93', '142', '143', '7', 'com_content.article.37', 'Related Items Module', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('136', '44', '225', '226', '4', 'com_content.article.38', 'Sample Sites', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('137', '46', '123', '124', '6', 'com_content.article.39', 'Search', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('138', '96', '168', '169', '7', 'com_content.article.40', 'Search Module', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('139', '50', '205', '206', '6', 'com_content.article.41', 'Search ', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('140', '39', '272', '273', '3', 'com_content.article.42', 'Site Map', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('141', '34', '110', '111', '3', 'com_content.article.43', 'Example Pages and Menu Links', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('142', '96', '170', '171', '7', 'com_content.article.44', 'Statistics Module', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('143', '96', '172', '173', '7', 'com_content.article.45', 'Syndicate Module', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('144', '50', '207', '208', '6', 'com_content.article.46', 'System', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('145', '44', '227', '228', '4', 'com_content.article.47', 'The Joomla! Community', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('146', '247', '497', '498', '4', 'com_content.article.48', 'Stockade Main', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('147', '248', '671', '672', '4', 'com_content.article.49', 'QOW #187', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('148', '44', '229', '230', '4', 'com_content.article.50', 'Upgraders', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('149', '252', '883', '884', '4', 'com_content.article.51', 'TC layout', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('150', '46', '125', '126', '6', 'com_content.article.52', 'Users', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('151', '44', '231', '232', '4', 'com_content.article.53', 'Using Joomla!', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('152', '184', '281', '282', '4', 'com_content.article.54', 'About CSB 2047', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('153', '186', '303', '304', '4', 'com_content.article.55', 'Battalion', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('154', '94', '148', '149', '7', 'com_content.article.56', 'Who\'s Online', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('155', '258', '909', '910', '4', 'com_content.article.57', 'Wed Stockade Leader Schedule', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('156', '55', '262', '263', '5', 'com_content.article.58', 'Wonderful Watermelon', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');

INSERT INTO tkt_assets
(`id`, `parent_id`, `lft`, `rgt`, `level`, `name`, `title`, `rules`) VALUES 
('157', '96', '174', '175', '7', 'com_content.article.59', 'Wrapper Module', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('158', '247', '503', '504', '4', 'com_content.article.60', 'Stockade Begins', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('159', '166', '182', '183', '7', 'com_content.article.61', 'Breadcrumbs Module', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('160', '247', '501', '502', '4', 'com_content.article.62', 'Balloon Map 08', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('162', '248', '663', '664', '4', 'com_content.article.64', 'QOW #189', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('163', '248', '667', '668', '4', 'com_content.article.65', 'QOW #190', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('165', '94', '150', '151', '7', 'com_content.article.66', 'Latest Users Module', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('166', '47', '179', '184', '6', 'com_content.category.75', 'Navigation Modules', '{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
('167', '54', '269', '270', '4', 'com_content.category.76', 'Recipes', '{\"core.create\":{\"12\":1,\"10\":1},\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":{\"12\":1,\"10\":1}}'),
('168', '249', '739', '740', '4', 'com_content.article.67', 'GAME NIGHT', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('169', '24', '993', '994', '2', 'com_users.category.77', 'Uncategorised', ''),
('170', '50', '209', '210', '6', 'com_content.article.68', 'Captcha', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('171', '248', '659', '660', '4', 'com_content.article.69', 'QOW #191', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('172', '248', '655', '656', '4', 'com_content.article.70', 'QOW #192', '{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
('173', '1', '1078', '1079', '1', 'com_joomlaupdate', 'com_joomlaupdate', '{\"core.admin\":[],\"core.manage\":[],\"core.delete\":[],\"core.edit.state\":[]}'),
('174', '1', '1080', '1081', '1', 'com_gcalendar', 'com_gcalendar', '{}'),
('175', '1', '1082', '1083', '1', 'com_zweather', 'com_zweather', '{}'),
('180', '1', '1084', '1085', '1', 'com_j2xmlimporter', 'j2xmlimporter', '{}'),
('181', '8', '277', '284', '2', 'com_content.category.78', 'About 2047', ''),
('182', '8', '285', '312', '2', 'com_content.category.79', 'Battalion', ''),
('183', '8', '313', '324', '2', 'com_content.category.80', 'Battalion Leader Section', ''),
('184', '181', '278', '283', '3', 'com_content.category.81', 'About 2047', ''),
('185', '182', '286', '291', '3', 'com_content.category.82', 'About Battalion', ''),
('186', '182', '292', '305', '3', 'com_content.category.83', 'Battalion', ''),
('187', '182', '306', '311', '3', 'com_content.category.84', 'Facebook/Twitter BTN', ''),
('188', '183', '314', '323', '3', 'com_content.category.85', 'Battalion Leader Section & Info', ''),
('189', '34', '106', '107', '3', 'com_content.article.322', 'Alumni landing page', ''),
('190', '34', '108', '109', '3', 'com_content.article.177', 'Leader Biographies', ''),
('191', '184', '279', '280', '4', 'com_content.article.104', 'Weather Policy Box', ''),
('192', '185', '287', '288', '4', 'com_content.article.293', 'Canoe Trip PDF', ''),
('193', '185', '289', '290', '4', 'com_content.article.185', 'About Battalion #2047', ''),
('194', '186', '293', '294', '4', 'com_content.article.368', 'No Battalion Tonight', ''),
('195', '186', '295', '296', '4', 'com_content.article.296', 'Battalion Begins Tonight!', ''),
('196', '186', '297', '298', '4', 'com_content.article.237', 'Battalion', ''),
('197', '186', '299', '300', '4', 'com_content.article.233', 'Winter Camporama', ''),
('198', '186', '301', '302', '4', 'com_content.article.189', 'Registration Form', ''),
('199', '187', '307', '308', '4', 'com_content.article.407', 'Twitter Feed btn', ''),
('200', '187', '309', '310', '4', 'com_content.article.406', 'Facebook Feed BTN', ''),
('201', '188', '315', '316', '4', 'com_content.article.414', 'Squad Meeting 9-16-13', ''),
('202', '188', '317', '318', '4', 'com_content.article.413', 'Squad Meeting 9-23-13', ''),
('203', '188', '319', '320', '4', 'com_content.article.412', 'Squad Meeting 9-30-13', ''),
('204', '188', '321', '322', '4', 'com_content.article.411', 'Squad Meetings 10-7-13', ''),
('205', '8', '325', '460', '2', 'com_content.category.86', 'Parent Letters', ''),
('206', '205', '326', '459', '3', 'com_content.category.87', 'Parent Letters', ''),
('207', '206', '327', '328', '4', 'com_content.article.394', '2-26-13 Tues & Wed Stockade Letter', ''),
('208', '206', '329', '330', '4', 'com_content.article.156', '3/3/10 Parent Letter - Stockade & TC', ''),
('209', '206', '331', '332', '4', 'com_content.article.254', '3-1-11 Parent Letter Tues & Wed Stockade Letter', ''),
('210', '206', '333', '334', '4', 'com_content.article.345', '5-1-12 Parent Letter Stockade Tuesday & Wednesday', ''),
('211', '206', '335', '336', '4', 'com_content.article.393', '2-19-13 Tues & Wed Stockade Letter', ''),
('212', '206', '337', '338', '4', 'com_content.article.152', '2/24/10 Parent Letter - Stockade & TC', '');

INSERT INTO tkt_assets
(`id`, `parent_id`, `lft`, `rgt`, `level`, `name`, `title`, `rules`) VALUES 
('213', '206', '339', '340', '4', 'com_content.article.251', '2-22-11 Parent Letter Tues & Wed Stockade Letter', ''),
('214', '206', '341', '342', '4', 'com_content.article.344', '4-17-12 Parent Letter Stockade Tuesday & Wednesday', ''),
('215', '206', '343', '344', '4', 'com_content.article.391', '2-12-13 Tues & Wed Stockade Letter', ''),
('216', '206', '345', '346', '4', 'com_content.article.101', 'Stockade Letter 3/4/09', ''),
('217', '206', '347', '348', '4', 'com_content.article.150', '2/10/10 Parent Letter - Stockade & TC', ''),
('218', '206', '349', '350', '4', 'com_content.article.246', '2-9-11 Parent Letter Tues & Wed Stockade Letter', ''),
('219', '206', '351', '352', '4', 'com_content.article.334', '2-28-12 Parent Letter Stockade Tuesday & Wednesday', ''),
('220', '206', '353', '354', '4', 'com_content.article.386', '2-6-13 Wednesday Stockade Letter', ''),
('221', '206', '355', '356', '4', 'com_content.article.147', '2/3/10 Parent Letter - Stockade & TC', ''),
('222', '206', '357', '358', '4', 'com_content.article.98', 'Stockade Letter 2/25/09', ''),
('223', '206', '359', '360', '4', 'com_content.article.238', '1-25-11 Tues & Wed Stockade Letter', ''),
('224', '206', '361', '362', '4', 'com_content.article.333', '2-21-12 Parent Letter Stockade Tuesday & Wednesday', ''),
('225', '206', '363', '364', '4', 'com_content.article.385', 'Battalion Letter 1-28-13', ''),
('226', '206', '365', '366', '4', 'com_content.article.142', '1-13-10 Parent Letter - Stockade', ''),
('227', '8', '461', '468', '2', 'com_content.category.88', 'News', ''),
('228', '8', '469', '472', '2', 'com_content.category.89', 'FAQs', ''),
('229', '8', '473', '864', '2', 'com_content.category.90', 'Stockade', ''),
('230', '8', '865', '886', '2', 'com_content.category.91', 'Tree Climbers', ''),
('231', '8', '887', '890', '2', 'com_content.category.92', 'Parent Info', ''),
('232', '8', '891', '894', '2', 'com_content.category.93', 'Directions etc.', ''),
('233', '8', '895', '898', '2', 'com_content.category.94', 'Leader Contact', ''),
('234', '8', '899', '902', '2', 'com_content.category.95', 'Boy Contact Info Stockade', ''),
('235', '8', '903', '906', '2', 'com_content.category.96', 'Game Room', ''),
('236', '8', '907', '912', '2', 'com_content.category.97', 'STK LDR Schedule', ''),
('237', '8', '913', '916', '2', 'com_content.category.98', 'BTN Ldr Schedule', ''),
('238', '8', '917', '920', '2', 'com_content.category.99', 'Left Announcement Box', ''),
('239', '8', '921', '924', '2', 'com_content.category.100', 'Boy Contact Info Tree Climbers', ''),
('240', '8', '925', '932', '2', 'com_content.category.101', 'Teen Contact Battalion', ''),
('241', '8', '933', '948', '2', 'com_content.category.102', 'Stockade Leader Section', ''),
('242', '8', '949', '954', '2', 'com_content.category.103', 'Thank You for your Donation', ''),
('243', '227', '462', '465', '3', 'com_content.category.104', 'Latest', ''),
('244', '227', '466', '467', '3', 'com_content.category.105', 'Newsflash', ''),
('245', '228', '470', '471', '3', 'com_content.category.106', 'General', ''),
('246', '229', '474', '483', '3', 'com_content.category.107', 'About Stockade', ''),
('247', '229', '484', '507', '3', 'com_content.category.108', 'Stockade', ''),
('248', '229', '508', '719', '3', 'com_content.category.109', 'Question of the Week', ''),
('249', '229', '720', '855', '3', 'com_content.category.110', 'Stockade Special', ''),
('250', '229', '856', '863', '3', 'com_content.category.111', 'Facebook/Twitter Stockade', ''),
('251', '230', '866', '871', '3', 'com_content.category.112', 'About Tree Climbers', ''),
('252', '230', '872', '885', '3', 'com_content.category.113', 'Tree Climbers', ''),
('253', '231', '888', '889', '3', 'com_content.category.114', 'Parent Information', ''),
('254', '232', '892', '893', '3', 'com_content.category.115', 'Who, Where', ''),
('255', '233', '896', '897', '3', 'com_content.category.116', 'Adult Contact', ''),
('256', '234', '900', '901', '3', 'com_content.category.117', 'Boy Contact Info Stockade', ''),
('257', '235', '904', '905', '3', 'com_content.category.118', 'Game Room', ''),
('258', '236', '908', '911', '3', 'com_content.category.119', 'STK LDR Schedule', ''),
('259', '237', '914', '915', '3', 'com_content.category.120', 'BTN LDR Schedule', ''),
('260', '238', '918', '919', '3', 'com_content.category.121', 'Left Announcement Box', ''),
('261', '239', '922', '923', '3', 'com_content.category.122', 'Boy Contact Info Tree Climbers', ''),
('262', '240', '926', '931', '3', 'com_content.category.123', 'Teen Contact Battalion', '');

INSERT INTO tkt_assets
(`id`, `parent_id`, `lft`, `rgt`, `level`, `name`, `title`, `rules`) VALUES 
('263', '241', '934', '947', '3', 'com_content.category.124', 'Stockade Leader Only', ''),
('264', '242', '950', '953', '3', 'com_content.category.125', 'Thank you for your donation', ''),
('265', '249', '721', '722', '4', 'com_content.article.256', 'Tuesday Stockade Animation #1', ''),
('266', '249', '723', '724', '4', 'com_content.article.236', 'Creature feature - entire video', ''),
('267', '249', '725', '726', '4', 'com_content.article.218', 'Tuesday Stockade Sledding Movie', ''),
('268', '249', '727', '728', '4', 'com_content.article.97', 'Weather Policy', ''),
('269', '249', '729', '730', '4', 'com_content.article.112', 'Stockade Movie Night - Iron Giant', ''),
('270', '249', '731', '732', '4', 'com_content.article.244', 'Pinewood Derby Workday #2', ''),
('271', '249', '733', '734', '4', 'com_content.article.234', 'Creature Feature Photo Album 2011', ''),
('272', '249', '735', '736', '4', 'com_content.article.204', 'Police Dept Field Trip', ''),
('273', '249', '737', '738', '4', 'com_content.article.235', 'Derby Workday #1', ''),
('274', '249', '741', '742', '4', 'com_content.article.207', 'Wheel Game Night', ''),
('275', '249', '743', '744', '4', 'com_content.article.231', 'This week at Stockade!', ''),
('276', '249', '745', '746', '4', 'com_content.article.82', 'Down and Derby', ''),
('277', '249', '747', '748', '4', 'com_content.article.74', 'Overnight', ''),
('278', '249', '749', '750', '4', 'com_content.article.110', 'Drive-In Movie Night! Karate Kid', ''),
('279', '249', '751', '752', '4', 'com_content.article.213', 'Tuesday Stockade Sledding', ''),
('280', '249', '753', '754', '4', 'com_content.article.141', 'No Sledding notice', ''),
('281', '249', '755', '756', '4', 'com_content.article.102', 'Pinewood Derby 10', ''),
('282', '249', '757', '758', '4', 'com_content.article.208', 'West Seneca police Visit Photos', ''),
('283', '249', '759', '760', '4', 'com_content.article.144', 'Creature #8, 2011', ''),
('284', '249', '761', '762', '4', 'com_content.article.138', 'Stockade Movie Night, January 16, 7pm', ''),
('285', '249', '763', '764', '4', 'com_content.article.136', 'JJ Skiing', ''),
('286', '249', '765', '766', '4', 'com_content.article.120', 'Stockade Balloon Launch 2009', ''),
('287', '249', '767', '768', '4', 'com_content.article.107', 'North and South Post Skills Competition', ''),
('288', '263', '935', '936', '4', 'com_content.article.367', 'Stockade Posts tentative 12/13', ''),
('289', '263', '937', '938', '4', 'com_content.article.338', 'Camporama 12 Information', ''),
('290', '263', '939', '940', '4', 'com_content.article.337', 'Stockarama 12 Event Information', ''),
('291', '263', '941', '942', '4', 'com_content.article.336', 'Stockarama 12 Verses', ''),
('292', '263', '943', '944', '4', 'com_content.article.264', 'Stockade - 2011 Stockarama Information', ''),
('293', '263', '945', '946', '4', 'com_content.article.263', 'Leader Section test', ''),
('294', '262', '927', '928', '4', 'com_content.article.188', 'Battalion Directory', ''),
('295', '262', '929', '930', '4', 'com_content.article.126', 'Battalion Teen Contact 2009 - 2010', ''),
('296', '264', '951', '952', '4', 'com_content.article.292', 'Thank you', ''),
('297', '251', '867', '868', '4', 'com_content.article.243', 'No Tree Climbers', ''),
('298', '251', '869', '870', '4', 'com_content.article.184', 'About Tree Climbers', ''),
('299', '252', '873', '874', '4', 'com_content.article.299', 'TREE CLIMBERS BEGINS TONIGHT!', ''),
('300', '252', '875', '876', '4', 'com_content.article.343', 'No Tree Climbers', ''),
('301', '252', '877', '878', '4', 'com_content.article.139', 'Pinewood Derby \'10', ''),
('302', '252', '879', '880', '4', 'com_content.article.219', 'Creature Feature 2012 TC', ''),
('303', '252', '881', '882', '4', 'com_content.article.221', 'Derby Time! 11', ''),
('304', '248', '509', '510', '4', 'com_content.article.155', 'QOW #236', ''),
('305', '248', '511', '512', '4', 'com_content.article.154', 'QOW #235', ''),
('306', '248', '513', '514', '4', 'com_content.article.153', 'QOW #234', ''),
('307', '248', '515', '516', '4', 'com_content.article.167', 'QOW# 241', ''),
('308', '248', '517', '518', '4', 'com_content.article.117', 'QOW #215', ''),
('309', '248', '519', '520', '4', 'com_content.article.163', 'QOW #240', ''),
('310', '248', '521', '522', '4', 'com_content.article.95', 'QOW #209', ''),
('311', '248', '523', '524', '4', 'com_content.article.106', 'QOW #212', ''),
('312', '248', '525', '526', '4', 'com_content.article.116', 'QOW #216', '');

INSERT INTO tkt_assets
(`id`, `parent_id`, `lft`, `rgt`, `level`, `name`, `title`, `rules`) VALUES 
('313', '248', '527', '528', '4', 'com_content.article.161', 'QOW #239', ''),
('314', '248', '529', '530', '4', 'com_content.article.94', 'QOW #208', ''),
('315', '248', '531', '532', '4', 'com_content.article.160', 'QOW #238', ''),
('316', '248', '533', '534', '4', 'com_content.article.93', 'QOW #207', ''),
('317', '248', '535', '536', '4', 'com_content.article.92', 'QOW #206', ''),
('318', '248', '537', '538', '4', 'com_content.article.88', 'QOW #203', ''),
('319', '248', '539', '540', '4', 'com_content.article.87', 'QOW #202', ''),
('320', '248', '541', '542', '4', 'com_content.article.89', 'QOW #205', ''),
('321', '248', '543', '544', '4', 'com_content.article.146', 'QOW #231', ''),
('322', '248', '545', '546', '4', 'com_content.article.86', 'QOW #201', ''),
('323', '248', '547', '548', '4', 'com_content.article.137', 'QOW #228', ''),
('324', '248', '549', '550', '4', 'com_content.article.80', 'QOW #200', ''),
('325', '248', '551', '552', '4', 'com_content.article.127', 'QOW #224', ''),
('326', '248', '553', '554', '4', 'com_content.article.145', 'QOW 230', ''),
('327', '248', '555', '556', '4', 'com_content.article.143', 'QOW #229', ''),
('328', '248', '557', '558', '4', 'com_content.article.108', 'QOW #213', ''),
('329', '248', '559', '560', '4', 'com_content.article.130', 'QOW #227', ''),
('330', '248', '561', '562', '4', 'com_content.article.125', 'QOW #223', ''),
('331', '248', '563', '564', '4', 'com_content.article.124', 'QOW #222', ''),
('332', '248', '565', '566', '4', 'com_content.article.123', 'QOW #221', ''),
('333', '248', '567', '568', '4', 'com_content.article.103', 'QOW #211', ''),
('334', '248', '569', '570', '4', 'com_content.article.122', 'QOW #220', ''),
('335', '248', '571', '572', '4', 'com_content.article.119', 'QOW #218', ''),
('336', '248', '573', '574', '4', 'com_content.article.96', 'QOW #210', ''),
('337', '248', '575', '576', '4', 'com_content.article.115', 'QOW #219', ''),
('338', '248', '577', '578', '4', 'com_content.article.114', 'QOW #214', ''),
('339', '248', '579', '580', '4', 'com_content.article.90', 'QOW #204', ''),
('340', '248', '581', '582', '4', 'com_content.article.79', 'QOW #199', ''),
('341', '248', '583', '584', '4', 'com_content.article.78', 'QOW #198', ''),
('342', '248', '585', '586', '4', 'com_content.article.77', 'QOW #197', ''),
('343', '248', '587', '588', '4', 'com_content.article.76', 'QOW #196', ''),
('344', '248', '589', '590', '4', 'com_content.article.75', 'QOW #195', ''),
('345', '248', '591', '592', '4', 'com_content.article.72', 'QOW #194', ''),
('346', '248', '593', '594', '4', 'com_content.article.71', 'QOW #193', ''),
('347', '247', '485', '486', '4', 'com_content.article.388', 'Stockade Meeting Tonight - 2-27-13', ''),
('348', '247', '487', '488', '4', 'com_content.article.387', 'Wednesday Stockade Meeting Tonight!', ''),
('349', '247', '489', '490', '4', 'com_content.article.377', 'No Stockade - Halloween', ''),
('350', '247', '491', '492', '4', 'com_content.article.342', 'No Wednesday Stockade', ''),
('351', '247', '493', '494', '4', 'com_content.article.341', 'No Tuesday Stockade Tonight', ''),
('352', '247', '495', '496', '4', 'com_content.article.217', 'Slooh Telescope', ''),
('353', '247', '499', '500', '4', 'com_content.article.179', 'Stockade 2 nights', ''),
('354', '247', '505', '506', '4', 'com_content.article.81', 'Jim s DrawingCam', ''),
('355', '249', '769', '770', '4', 'com_content.article.410', 'Stockade Scavenger Hunt 2013', ''),
('356', '249', '771', '772', '4', 'com_content.article.409', 'Stockade Scavenger Hunt 5', ''),
('357', '249', '773', '774', '4', 'com_content.article.347', 'Attending Stockarama or Camporama?', ''),
('358', '249', '775', '776', '4', 'com_content.article.324', 'Scav Hunt items due', ''),
('359', '249', '777', '778', '4', 'com_content.article.276', 'Stockarama \'13', ''),
('360', '249', '779', '780', '4', 'com_content.article.397', 'Regional Derby Race!', ''),
('361', '249', '781', '782', '4', 'com_content.article.396', 'Pinewood Derby Tonight @ 7pm!', ''),
('362', '249', '783', '784', '4', 'com_content.article.298', 'Wednesday Stockade Begins Tonight!', '');

INSERT INTO tkt_assets
(`id`, `parent_id`, `lft`, `rgt`, `level`, `name`, `title`, `rules`) VALUES 
('363', '249', '785', '786', '4', 'com_content.article.395', 'Pinewood Derby 2013!', ''),
('364', '249', '787', '788', '4', 'com_content.article.260', 'Stockade Loop Races!', ''),
('365', '249', '789', '790', '4', 'com_content.article.392', 'Stockade Derby Workday 3 - Today!', ''),
('366', '249', '791', '792', '4', 'com_content.article.297', 'Tuesday Stockade Begins Tonight!', ''),
('367', '249', '793', '794', '4', 'com_content.article.390', 'Derby Test Day Today!', ''),
('368', '249', '795', '796', '4', 'com_content.article.389', 'Derby Test Day 2014!', ''),
('369', '249', '797', '798', '4', 'com_content.article.323', 'Scavenger Hunt - 1 Week extension', ''),
('370', '249', '799', '800', '4', 'com_content.article.381', 'Creature Feature \'13', ''),
('371', '249', '801', '802', '4', 'com_content.article.380', 'Tuesday Stockade Chuck E Cheese Night!', ''),
('372', '249', '803', '804', '4', 'com_content.article.313', 'Scavenger Hunt 4', ''),
('373', '249', '805', '806', '4', 'com_content.article.290', 'Final Wednesday Meeting Tonight!', ''),
('374', '249', '807', '808', '4', 'com_content.article.376', 'No Stockade - Bad Weather!', ''),
('375', '249', '809', '810', '4', 'com_content.article.291', 'Final Tuesday Stockade June 14th', ''),
('376', '249', '811', '812', '4', 'com_content.article.173', 'Derby Time! 12', ''),
('377', '249', '813', '814', '4', 'com_content.article.361', 'Survey Tuesday Stockade', ''),
('378', '249', '815', '816', '4', 'com_content.article.359', 'Stockade movie Night - the original Karate Kid!', ''),
('379', '249', '817', '818', '4', 'com_content.article.357', 'Derby Time! 2014', ''),
('380', '249', '819', '820', '4', 'com_content.article.352', 'Tuesday Stockade Ends', ''),
('381', '249', '821', '822', '4', 'com_content.article.245', 'Test Day #2 - 9am -Noon', ''),
('382', '249', '823', '824', '4', 'com_content.article.335', 'Pinewood Derby 2012 Results!', ''),
('383', '249', '825', '826', '4', 'com_content.article.311', 'Stockade Movie Night - Treasure Planet! you tube embed view only without editor', ''),
('384', '249', '827', '828', '4', 'com_content.article.286', 'Tuesday Stockade Fishing', ''),
('385', '249', '829', '830', '4', 'com_content.article.240', 'Paradise Island Photos - Tuesday Stockade', ''),
('386', '249', '831', '832', '4', 'com_content.article.83', 'Creature Feature 2012', ''),
('387', '249', '833', '834', '4', 'com_content.article.230', 'Tuesday Stockade - Paradise Island Special', ''),
('388', '249', '835', '836', '4', 'com_content.article.172', 'Pinewood Derby 11', ''),
('389', '249', '837', '838', '4', 'com_content.article.257', 'Regional Finals', ''),
('390', '249', '839', '840', '4', 'com_content.article.171', 'Stockade Movie Night', ''),
('391', '249', '841', '842', '4', 'com_content.article.285', 'Wednesday Stockade Fishing 2011', ''),
('392', '249', '843', '844', '4', 'com_content.article.255', 'Derby Cars are Due', ''),
('393', '249', '845', '846', '4', 'com_content.article.283', '2011 Stockarama Photo Album', ''),
('394', '249', '847', '848', '4', 'com_content.article.248', 'Derby Work Day #3', ''),
('395', '249', '849', '850', '4', 'com_content.article.100', 'Derby Test Day Car Camera!', ''),
('396', '249', '851', '852', '4', 'com_content.article.267', 'Stockade Movie Night - Tron', ''),
('397', '249', '853', '854', '4', 'com_content.article.151', 'Movie Night June 5, 2010', ''),
('398', '206', '367', '368', '4', 'com_content.article.212', '11-30-10 Tuesday Stockade letter', ''),
('399', '206', '369', '370', '4', 'com_content.article.320', '11-15-11 Parent Letter Stockade Tues & Wed', ''),
('400', '206', '371', '372', '4', 'com_content.article.366', '10-2-12 Tues & Wed Stockade Letter', ''),
('401', '206', '373', '374', '4', 'com_content.article.113', 'Stockade Parent Letter 9/9/09', ''),
('402', '206', '375', '376', '4', 'com_content.article.319', '11-15-11 Parent Letter TUESDAY Stockade', ''),
('403', '206', '377', '378', '4', 'com_content.article.364', '9-6-12 Tree Climbers Memo', ''),
('404', '206', '379', '380', '4', 'com_content.article.210', '11-23-10 Tuesday Stockade letter', ''),
('405', '206', '381', '382', '4', 'com_content.article.314', '10-19-11 Parent Letter Stockade', ''),
('406', '206', '383', '384', '4', 'com_content.article.363', '12-13 Informational Brochure', ''),
('407', '206', '385', '386', '4', 'com_content.article.206', '11-16-10 Tuesday Stockade Parent Letter', ''),
('408', '206', '387', '388', '4', 'com_content.article.312', '10-19-11 Stockade Scavenger Hunt 4', ''),
('409', '206', '389', '390', '4', 'com_content.article.362', '9-11-12 Stockade First Night Letter', ''),
('410', '206', '391', '392', '4', 'com_content.article.202', '11-10-10 Wednesday Stockade Parent Letter', ''),
('411', '206', '393', '394', '4', 'com_content.article.310', '10-11-11 Parent Letter Stockade', ''),
('412', '206', '395', '396', '4', 'com_content.article.360', '8-16-12 Parent Letter Tuesday Stockade', '');

INSERT INTO tkt_assets
(`id`, `parent_id`, `lft`, `rgt`, `level`, `name`, `title`, `rules`) VALUES 
('413', '206', '397', '398', '4', 'com_content.article.199', '10-19-2010 Stockade Parent Letter', ''),
('414', '206', '399', '400', '4', 'com_content.article.295', 'First Night Send Home - Stockade', ''),
('415', '206', '401', '402', '4', 'com_content.article.358', 'Derby Rules & Instructions 2013', ''),
('416', '206', '403', '404', '4', 'com_content.article.196', '10-5-2010 Stockade Parent Letter', ''),
('417', '206', '405', '406', '4', 'com_content.article.294', '2011-12 Permission Slip', ''),
('418', '206', '407', '408', '4', 'com_content.article.190', 'Permission Slip 2010-11', ''),
('419', '206', '409', '410', '4', 'com_content.article.282', '5-18-11 Parent Letter Wed Stockade', ''),
('420', '206', '411', '412', '4', 'com_content.article.349', 'Stockarama Gear List', ''),
('421', '206', '413', '414', '4', 'com_content.article.191', '9/14/10 Stockade Parent Letter', ''),
('422', '206', '415', '416', '4', 'com_content.article.281', '5-10-11 Parent Letter Tues & Wed Stockade', ''),
('423', '206', '417', '418', '4', 'com_content.article.211', 'Paradise Island permission slip', ''),
('424', '246', '475', '476', '4', 'com_content.article.402', 'Wednesday Stockade is Fishing Tonight', ''),
('425', '246', '477', '478', '4', 'com_content.article.287', 'Parent Survey 2011', ''),
('426', '246', '479', '480', '4', 'com_content.article.242', 'No Stockade', ''),
('427', '246', '481', '482', '4', 'com_content.article.182', 'About Stockade #2047', ''),
('428', '250', '857', '858', '4', 'com_content.article.405', 'Facebook Feed', ''),
('429', '250', '859', '860', '4', 'com_content.article.371', 'twitter test', ''),
('430', '250', '861', '862', '4', 'com_content.article.408', 'FishCam', ''),
('431', '248', '595', '596', '4', 'com_content.article.375', 'QOW #293 - Wednesday Stockade', ''),
('432', '248', '597', '598', '4', 'com_content.article.374', 'QOW #292 - Tuesday Stockade', ''),
('433', '248', '599', '600', '4', 'com_content.article.216', 'QOW #254', ''),
('434', '248', '601', '602', '4', 'com_content.article.330', 'QOW #289 Wednesday', ''),
('435', '248', '603', '604', '4', 'com_content.article.370', 'QOW #291 - Wednesday Stockade', ''),
('436', '248', '605', '606', '4', 'com_content.article.329', 'QOW #288 Tuesday', ''),
('437', '248', '607', '608', '4', 'com_content.article.369', 'QOW #290 - Tuesday Stockade', ''),
('438', '248', '609', '610', '4', 'com_content.article.326', 'QOW #287 Wednesday', ''),
('439', '248', '611', '612', '4', 'com_content.article.317', 'QOW #283 Wednesday', ''),
('440', '248', '613', '614', '4', 'com_content.article.288', 'QOW #271 Wednesday', ''),
('441', '248', '615', '616', '4', 'com_content.article.325', 'QOW #286 Tuesday', ''),
('442', '248', '617', '618', '4', 'com_content.article.316', 'QOW #284 Tuesday', ''),
('443', '248', '619', '620', '4', 'com_content.article.318', 'QOW #285 Wednesday', ''),
('444', '248', '621', '622', '4', 'com_content.article.315', 'QOW #282 Tuesday', ''),
('445', '248', '623', '624', '4', 'com_content.article.309', 'QOW #278 - Tuesday Stockade', ''),
('446', '248', '625', '626', '4', 'com_content.article.269', 'QOW #268 Wednesday', ''),
('447', '248', '627', '628', '4', 'com_content.article.308', 'QOW #279 - Wednesday Stockade', ''),
('448', '248', '629', '630', '4', 'com_content.article.307', 'QOW #277 - Wednesday Stockade', ''),
('449', '248', '631', '632', '4', 'com_content.article.306', 'QOW #276 - Tuesday Stockade', ''),
('450', '248', '633', '634', '4', 'com_content.article.241', 'QOW #257', ''),
('451', '248', '635', '636', '4', 'com_content.article.305', 'QOW #275 Puzzle - Wednesday Stockade', ''),
('452', '248', '637', '638', '4', 'com_content.article.280', 'QOW #270 Wednesday', ''),
('453', '248', '639', '640', '4', 'com_content.article.304', 'QOW #274 - Tuesday Stockade - puzzle', ''),
('454', '248', '641', '642', '4', 'com_content.article.303', 'QOW #281 - Wednesday Stockade', ''),
('455', '248', '643', '644', '4', 'com_content.article.214', 'QOW #253', ''),
('456', '248', '645', '646', '4', 'com_content.article.302', 'QOW #280 - Tuesday Stockade', ''),
('457', '248', '647', '648', '4', 'com_content.article.301', 'QOW #273 - Wednesday Stockade', ''),
('458', '248', '649', '650', '4', 'com_content.article.300', 'QOW #272 - Tuesday Stockade', ''),
('459', '248', '651', '652', '4', 'com_content.article.268', 'QOW #267 Tuesday', ''),
('460', '248', '653', '654', '4', 'com_content.article.195', 'QOW #247 Puzzle', ''),
('461', '248', '657', '658', '4', 'com_content.article.279', 'QOW #269 Tuesday', ''),
('462', '248', '661', '662', '4', 'com_content.article.63', 'QOW #188', '');

INSERT INTO tkt_assets
(`id`, `parent_id`, `lft`, `rgt`, `level`, `name`, `title`, `rules`) VALUES 
('463', '248', '665', '666', '4', 'com_content.article.266', 'QOW #266 Wednesday', ''),
('464', '248', '669', '670', '4', 'com_content.article.265', 'QOW #265 Tuesday', ''),
('465', '248', '673', '674', '4', 'com_content.article.226', 'QOW #256', ''),
('466', '248', '675', '676', '4', 'com_content.article.203', 'QOW #252', ''),
('467', '248', '677', '678', '4', 'com_content.article.262', 'QOW #264 Wednesday', ''),
('468', '248', '679', '680', '4', 'com_content.article.261', 'QOW #263 Tuesday', ''),
('469', '248', '681', '682', '4', 'com_content.article.201', 'QOW #251', ''),
('470', '248', '683', '684', '4', 'com_content.article.259', 'QOW #262 Wednesday', ''),
('471', '248', '685', '686', '4', 'com_content.article.224', 'QOW #255', ''),
('472', '248', '687', '688', '4', 'com_content.article.258', 'QOW # 261 Tuesday', ''),
('473', '248', '689', '690', '4', 'com_content.article.129', 'QOW #226', ''),
('474', '248', '691', '692', '4', 'com_content.article.253', 'QOW #260 Wednesday', ''),
('475', '248', '693', '694', '4', 'com_content.article.252', 'QOW #259 - Tuesday Stockade', ''),
('476', '248', '695', '696', '4', 'com_content.article.247', 'QOW #258', ''),
('477', '248', '697', '698', '4', 'com_content.article.200', 'QOW #250', ''),
('478', '248', '699', '700', '4', 'com_content.article.198', 'QOW #249', ''),
('479', '248', '701', '702', '4', 'com_content.article.197', 'QOW #248', ''),
('480', '248', '703', '704', '4', 'com_content.article.109', 'QOW over for the year', ''),
('481', '248', '705', '706', '4', 'com_content.article.194', 'QOW #246', ''),
('482', '248', '707', '708', '4', 'com_content.article.149', 'QOW 232', ''),
('483', '248', '709', '710', '4', 'com_content.article.183', 'QOW #244', ''),
('484', '248', '711', '712', '4', 'com_content.article.180', 'QOW #243', ''),
('485', '248', '713', '714', '4', 'com_content.article.128', 'QOW #225', ''),
('486', '248', '715', '716', '4', 'com_content.article.169', 'QOW #242', ''),
('487', '248', '717', '718', '4', 'com_content.article.157', 'QOW #237', ''),
('488', '206', '419', '420', '4', 'com_content.article.232', 'Battalion Winter Camporama Information', ''),
('489', '206', '421', '422', '4', 'com_content.article.332', '2-15-12 Parent Letter Stockade Tuesday & Wednesday', ''),
('490', '206', '423', '424', '4', 'com_content.article.383', '1-9-13 Wednesday Stockade Letter', ''),
('491', '206', '425', '426', '4', 'com_content.article.140', '1-6-10 Parent Letter - Stockade', ''),
('492', '206', '427', '428', '4', 'com_content.article.228', '1-12-11 Wednesday Stockade Letter', ''),
('493', '206', '429', '430', '4', 'com_content.article.331', '1-31-12 Parent Letter Stockade Tuesday & Wednesday', ''),
('494', '206', '431', '432', '4', 'com_content.article.382', '1-8-13 Tuesday Stockade Letter', ''),
('495', '206', '433', '434', '4', 'com_content.article.135', '12/16/09 Stockade Parent Letter', ''),
('496', '206', '435', '436', '4', 'com_content.article.225', '1-11-11 Tuesday Stockade Letter', ''),
('497', '206', '437', '438', '4', 'com_content.article.328', '2012 Pinewood Derby Instructions and Information', ''),
('498', '206', '439', '440', '4', 'com_content.article.379', '12-5-12 Wednesday Stockade Letter', ''),
('499', '206', '441', '442', '4', 'com_content.article.134', '11/18/09 Parent Letter Stockade', ''),
('500', '206', '443', '444', '4', 'com_content.article.223', '1-5-11 Stockade Letter', ''),
('501', '206', '445', '446', '4', 'com_content.article.327', '1-4-12 Parent Letter Stockade Tuesday & Wednesday', ''),
('502', '206', '447', '448', '4', 'com_content.article.378', '11-27-12 Tuesday Stockade Letter', ''),
('503', '206', '449', '450', '4', 'com_content.article.133', '11/4/09 Parent Letter - Stockade', ''),
('504', '206', '451', '452', '4', 'com_content.article.220', 'Pinewood Derby Rules & Information 2011', ''),
('505', '206', '453', '454', '4', 'com_content.article.321', '11-29-11 Parent Letter Stockade Tuesday', ''),
('506', '206', '455', '456', '4', 'com_content.article.372', '10-23-12 Tues & Wed Stockade Letter', ''),
('507', '206', '457', '458', '4', 'com_content.article.121', 'Stockade Parent Letter 9/23/09', ''),
('508', '243', '463', '464', '4', 'com_content.article.681', 'Welcome to #2047', '{\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1}}'),
('509', '1', '1086', '1087', '1', 'com_imageshow', 'imageshow', '{}'),
('510', '1', '1088', '1089', '1', 'com_poweradmin', 'poweradmin', '{}'),
('511', '1', '1090', '1091', '1', 'com_uniform', 'uniform', '{}');

DROP TABLE IF EXISTS `tkt_associations`;
CREATE TABLE `tkt_associations` (
  `id` varchar(50) NOT NULL COMMENT 'A reference to the associated item.',
  `context` varchar(50) NOT NULL COMMENT 'The context of the associated item.',
  `key` char(32) NOT NULL COMMENT 'The key for the association computed from an md5 on associated ids.',
  PRIMARY KEY (`context`,`id`),
  KEY `idx_key` (`key`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_banner_clients`;
CREATE TABLE `tkt_banner_clients` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `contact` varchar(255) NOT NULL DEFAULT '',
  `email` varchar(255) NOT NULL DEFAULT '',
  `extrainfo` text NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `metakey` text NOT NULL,
  `own_prefix` tinyint(4) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  PRIMARY KEY (`id`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;

INSERT INTO tkt_banner_clients
(`id`, `name`, `contact`, `email`, `extrainfo`, `state`, `checked_out`, `checked_out_time`, `metakey`, `own_prefix`, `metakey_prefix`, `purchase_type`, `track_clicks`, `track_impressions`) VALUES 
('1', 'Joomla!', 'Administrator', 'email@email.com', '', '1', '0', '0000-00-00 00:00:00', '', '0', '', '-1', '-1', '-1'),
('2', 'Shop', 'Example', 'example@example.com', '', '1', '0', '0000-00-00 00:00:00', '', '0', '', '-1', '0', '0'),
('3', 'Bookstore', 'Bookstore Example', 'example@example.com', '', '1', '0', '0000-00-00 00:00:00', '', '0', '', '-1', '0', '0');

DROP TABLE IF EXISTS `tkt_banner_tracks`;
CREATE TABLE `tkt_banner_tracks` (
  `track_date` datetime NOT NULL,
  `track_type` int(10) unsigned NOT NULL,
  `banner_id` int(10) unsigned NOT NULL,
  `count` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`track_date`,`track_type`,`banner_id`),
  KEY `idx_track_date` (`track_date`),
  KEY `idx_track_type` (`track_type`),
  KEY `idx_banner_id` (`banner_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_banners`;
CREATE TABLE `tkt_banners` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL DEFAULT '0',
  `type` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `imptotal` int(11) NOT NULL DEFAULT '0',
  `impmade` int(11) NOT NULL DEFAULT '0',
  `clicks` int(11) NOT NULL DEFAULT '0',
  `clickurl` varchar(200) NOT NULL DEFAULT '',
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `description` text NOT NULL,
  `custombannercode` varchar(2048) NOT NULL,
  `sticky` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `params` text NOT NULL,
  `own_prefix` tinyint(1) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `reset` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `language` char(7) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `idx_state` (`state`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`),
  KEY `idx_banner_catid` (`catid`),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;

INSERT INTO tkt_banners
(`id`, `cid`, `type`, `name`, `alias`, `imptotal`, `impmade`, `clicks`, `clickurl`, `state`, `catid`, `description`, `custombannercode`, `sticky`, `ordering`, `metakey`, `params`, `own_prefix`, `metakey_prefix`, `purchase_type`, `track_clicks`, `track_impressions`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `reset`, `created`, `language`) VALUES 
('2', '3', '0', 'Shop 1', 'shop-1', '0', '111', '2', 'http://shop.joomla.org/amazoncom-bookstores.html', '1', '15', 'Get books about Joomla! at the Joomla! Book Shop.', '', '0', '1', '', '{\"imageurl\":\"images\\/banners\\/white.png\",\"width\":\"\",\"height\":\"\",\"alt\":\"Joomla! Books\"}', '0', '', '-1', '0', '0', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '2011-01-01 00:00:01', 'en-GB'),
('3', '2', '0', 'Shop 2', 'shop-2', '0', '161', '2', 'http://shop.joomla.org', '1', '15', 'T Shirts, caps and more from the Joomla! Shop.', '', '0', '2', '', '{\"imageurl\":\"images\\/banners\\/white.png\",\"width\":\"\",\"height\":\"\",\"alt\":\"Joomla! Shop\"}', '0', '', '-1', '0', '0', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '2011-01-01 00:00:01', 'en-GB'),
('4', '1', '0', 'Support Joomla!', 'support-joomla', '0', '80', '1', 'http://contribute.joomla.org', '1', '15', 'Your contributions of time, talent and money make Joomla possible.', '', '0', '3', '', '{\"imageurl\":\"images\\/banners\\/white.png\",\"width\":\"\",\"height\":\"\",\"alt\":\"\"}', '0', '', '-1', '0', '0', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 'en-GB');

DROP TABLE IF EXISTS `tkt_categories`;
CREATE TABLE `tkt_categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `lft` int(11) NOT NULL DEFAULT '0',
  `rgt` int(11) NOT NULL DEFAULT '0',
  `level` int(10) unsigned NOT NULL DEFAULT '0',
  `path` varchar(255) NOT NULL DEFAULT '',
  `extension` varchar(50) NOT NULL DEFAULT '',
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `description` mediumtext NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `metadesc` varchar(1024) NOT NULL COMMENT 'The meta description for the page.',
  `metakey` varchar(1024) NOT NULL COMMENT 'The meta keywords for the page.',
  `metadata` varchar(2048) NOT NULL COMMENT 'JSON encoded metadata properties.',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `cat_idx` (`extension`,`published`,`access`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_path` (`path`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM AUTO_INCREMENT=126 DEFAULT CHARSET=utf8;

INSERT INTO tkt_categories
(`id`, `asset_id`, `parent_id`, `lft`, `rgt`, `level`, `path`, `extension`, `title`, `alias`, `note`, `description`, `published`, `checked_out`, `checked_out_time`, `access`, `params`, `metadesc`, `metakey`, `metadata`, `created_user_id`, `created_time`, `modified_user_id`, `modified_time`, `hits`, `language`) VALUES 
('1', '0', '0', '0', '231', '0', '', 'system', 'ROOT', 'root', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('9', '34', '1', '131', '132', '1', 'uncategorised', 'com_content', 'Uncategorised', 'uncategorised', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '42', '2011-01-01 00:00:01', '0', '*'),
('10', '35', '1', '129', '130', '1', 'uncategorised', 'com_banners', 'Uncategorised', 'uncategorised', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\",\"foobar\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('11', '36', '1', '125', '126', '1', 'uncategorised', 'com_contact', 'Uncategorised', 'uncategorised', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('12', '37', '1', '61', '62', '1', 'uncategorised', 'com_newsfeeds', 'Uncategorised', 'uncategorised', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('13', '38', '1', '57', '58', '1', 'uncategorised', 'com_weblinks', 'Uncategorised', 'uncategorised', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('14', '39', '1', '9', '56', '1', 'sample-data-articles', 'com_content', 'Sample Data-Articles', 'sample-data-articles', '', '', '-2', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('15', '40', '1', '127', '128', '1', 'sample-data-banners', 'com_banners', 'Sample Data-Banners', 'sample-data-banners', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\",\"foobar\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('16', '41', '1', '63', '124', '1', 'sample-data-contact', 'com_contact', 'Sample Data-Contact', 'sample-data-contact', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('17', '42', '1', '59', '60', '1', 'sample-data-newsfeeds', 'com_newsfeeds', 'Sample Data-Newsfeeds', 'sample-data-newsfeeds', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('18', '43', '1', '1', '8', '1', 'sample-data-weblinks', 'com_weblinks', 'Sample Data-Weblinks', 'sample-data-weblinks', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('19', '44', '14', '10', '39', '2', 'sample-data-articles/joomla', 'com_content', 'Joomla!', 'joomla', '', '', '-2', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '42', '2011-01-01 00:00:01', '0', '*'),
('20', '45', '19', '11', '38', '3', 'sample-data-articles/joomla/extensions', 'com_content', 'Extensions', 'extensions', '', '<p>The Joomla! content management system lets you create webpages of various types using extensions. There are 5 basic types of extensions: components, modules, templates, languages, and plugins. Your website includes the extensions you need to create a basic website in English, but thousands of additional extensions of all types are available. The <a href=\"http://extensions.joomla.org\" style=\"color: #1b57b1; text-decoration: none; font-weight: normal;\">Joomla! Extensions Directory</a> is the largest directory of Joomla extensions.</p>', '-2', '0', '0000-00-00 00:00:00', '1', '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '42', '2011-12-27 11:57:22', '0', '*'),
('21', '46', '20', '12', '13', '4', 'sample-data-articles/joomla/extensions/components', 'com_content', 'Components', 'components', '', '<p><img class=\"image-left\" src=\"administrator/templates/bluestork/images/header/icon-48-component.png\" border=\"0\" alt=\"Component Image\" />Components are larger extensions that produce the major content for your site. Each component has one or more \"views\" that control how content is displayed. In the Joomla administrator there are additional extensions such as Menus, Redirection, and the extension managers.</p>', '-2', '0', '0000-00-00 00:00:00', '1', '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '42', '2011-12-27 11:58:12', '0', '*'),
('22', '47', '20', '14', '25', '4', 'sample-data-articles/joomla/extensions/modules', 'com_content', 'Modules', 'modules', '', '<p><img class=\"image-left\" src=\"administrator/templates/bluestork/images/header/icon-48-module.png\" border=\"0\" alt=\"Media Image\" />Modules are small blocks of content that can be displayed in positions on a web page. The menus on this site are displayed in modules. The core of Joomla! includes 24 separate modules ranging from login to search to random images. Each module has a name that starts mod_ but when it displays it has a title. In the descriptions in this section, the titles are the same as the names.</p>', '-2', '0', '0000-00-00 00:00:00', '1', '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '42', '2011-12-27 11:59:44', '0', '*'),
('23', '48', '20', '26', '33', '4', 'sample-data-articles/joomla/extensions/templates', 'com_content', 'Templates', 'templates', '', '<p><img src=\"administrator/templates/bluestork/images/header/icon-48-themes.png\" border=\"0\" alt=\"Media Image\" align=\"left\" />Templates give your site its look and feel. They determine layout, colours, typefaces, graphics and other aspects of design that make your site unique. Your installation of Joomla comes prepackaged with three front end templates and two backend templates. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Template_Manager_Templates\">Help</a></p>', '-2', '0', '0000-00-00 00:00:00', '1', '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '42', '2011-12-27 12:04:51', '0', '*'),
('24', '49', '20', '34', '35', '4', 'sample-data-articles/joomla/extensions/languages', 'com_content', 'Languages', 'languages', '', '<p><img src=\"administrator/templates/bluestork/images/header/icon-48-language.png\" border=\"0\" alt=\"Languages Image\" align=\"left\" />Joomla! installs in English, but translations of the interfaces, sample data and help screens are available in dozens of languages. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Language_Manager_Installed\">Help</a></p>\r\n<p><a href=\"http://community.joomla.org/translations.html\">Translation information</a></p>\r\n<p>If there is no language pack available for your language, instructions are available for creating your own translation, which you can also contribute to the community by starting a translation team to create an accredited translation. </p>\r\n<p>Translations of the interfaces are installed using the extensions manager in the site administrator and then managed using the language manager.</p>\r\n<p>If you have two or more languages installed you may enable the language switcher plugin and module. They should always be used together. If you create multilingual content and mark your content, menu items or modules as being in specific languages and follow <a href=\"http://docs.joomla.org/Language_Switcher_Tutorial_for_Joomla_1.6\">the complete instructions</a> your users will be able to select a specific content language using the module. By default both the plugin and module are disabled.</p>\r\n<p>Joomla 2.5 installs with a language override manager that allows you to change the specific words (such as Edit or Search) used in the Joomla application.</p>\r\n<p>There are a number of extensions that can help you manage translations of content available in the<a href=\"http://extensions.joomla.org\"> Joomla! Extensions Directory</a>.</p>', '-2', '0', '0000-00-00 00:00:00', '1', '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '42', '2012-01-17 16:18:40', '0', '*'),
('25', '50', '20', '36', '37', '4', 'sample-data-articles/joomla/extensions/plugins', 'com_content', 'Plugins', 'plugins', '', '<p><img src=\"administrator/templates/bluestork/images/header/icon-48-plugin.png\" border=\"0\" alt=\"Plugin Image\" align=\"left\" />Plugins are small task oriented extensions that enhance the Joomla! framework. Some are associated with particular extensions and others, such as editors, are used across all of Joomla. Most beginning users do not need to change any of the plugins that install with Joomla. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Plugin_Manager_Edit\">Help</a></p>', '-2', '0', '0000-00-00 00:00:00', '1', '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '42', '2011-12-27 12:11:56', '0', '*'),
('26', '51', '14', '40', '49', '2', 'sample-data-articles/park-site', 'com_content', 'Park Site', 'park-site', '', '', '-2', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '42', '2011-01-01 00:00:01', '0', 'en-GB'),
('27', '52', '26', '41', '42', '3', 'sample-data-articles/park-site/park-blog', 'com_content', 'Park Blog', 'park-blog', '', '<p><span style=\"font-size: 12px;\">Here is where I will blog all about the parks of Australia.</span></p>\r\n<p><em>You can make a blog on your website by creating a category to write your blog posts in (this one is called Park Blog). Each blog post will be an article in that category. If you make a category blog menu link with 1 column it will look like this page, if you display the category description then this part is displayed. </em></p>\r\n<p><em>To enhance your blog you may want to add extensions for <a href=\"http://extensions.joomla.org/extensions/contacts-and-feedback/articles-comments\" style=\"color: #1b57b1; text-decoration: none; font-weight: normal;\">comments</a>,<a href=\"http://extensions.joomla.org/extensions/social-web\" style=\"color: #1b57b1; text-decoration: none; font-weight: normal;\"> interacting with social network sites</a>, <a href=\"http://extensions.joomla.org/extensions/content-sharing\" style=\"color: #1b57b1; text-decoration: none; font-weight: normal;\">tagging</a>, and <a href=\"http://extensions.joomla.org/extensions/content-sharing\" style=\"color: #1b57b1; text-decoration: none; font-weight: normal;\">keeping in contact with your readers</a>. You can also enable the syndication that is included in Joomla (in the Integration Options set Show Feed Link to Show and make sure to display the syndication module on the page).</em></p>', '-2', '0', '0000-00-00 00:00:00', '1', '{\"category_layout\":\"\",\"image\":\"images\\/sampledata\\/parks\\/banner_cradle.jpg\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '42', '2011-12-27 12:15:40', '0', 'en-GB'),
('28', '53', '26', '43', '48', '3', 'sample-data-articles/park-site/photo-gallery', 'com_content', 'Photo Gallery', 'photo-gallery', '', '<p><img src=\"images/sampledata/parks/banner_cradle.jpg\" border=\"0\" /></p>\r\n<p>These are my photos from parks I have visited (I didn\'t take them, they are all from <a href=\"http://commons.wikimedia.org/wiki/Main_Page\">Wikimedia Commons</a>).</p>\r\n<p><em>This shows you how to make a simple image gallery using articles in com_content. </em></p>\r\n<p><em>In each article put a thumbnail image before a \"readmore\" and the full size image after it. Set the article to Show Intro Text: Hide. </em></p>', '-2', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '42', '2011-01-01 00:00:01', '0', 'en-GB'),
('29', '54', '14', '50', '55', '2', 'sample-data-articles/fruit-shop-site', 'com_content', 'Fruit Shop Site', 'fruit-shop-site', '', '', '-2', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '42', '2011-01-01 00:00:01', '0', '*'),
('30', '55', '29', '51', '52', '3', 'sample-data-articles/fruit-shop-site/growers', 'com_content', 'Growers', 'growers', '', '<p>We search the whole countryside for the best fruit growers.</p>\r\n<p><em>You can let each supplier have a page that he or she can edit. To see this in action you will need to create a user who is in the suppliers group.  </em></p>\r\n<p><em>Create one page in the growers category for that user and make that supplier the author of the page. That user will be able to edit his or her page. </em></p>\r\n<p><em>This illustrates the use of the Edit Own permission. </em></p>', '-2', '0', '0000-00-00 00:00:00', '1', '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '42', '2011-12-27 12:17:40', '0', '*'),
('31', '56', '18', '2', '3', '2', 'sample-data-weblinks/park-links', 'com_weblinks', 'Park Links', 'park-links', '', '<p>Here are links to some of my favorite parks.</p>\r\n<p><em>The weblinks component provides an easy way to make links to external sites that are consistently formatted and categorised. You can create weblinks from the front end of your site.</em></p>', '1', '0', '0000-00-00 00:00:00', '1', '{\"category_layout\":\"\",\"image\":\"images\\/sampledata\\/parks\\/banner_cradle.jpg\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '42', '2011-01-01 00:00:01', '0', 'en-GB'),
('32', '57', '18', '4', '7', '2', 'sample-data-weblinks/joomla-specific-links', 'com_weblinks', 'Joomla! Specific Links', 'joomla-specific-links', '', '<p>A selection of links that are all related to the Joomla Project.</p>', '1', '0', '0000-00-00 00:00:00', '1', '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '42', '2011-12-27 12:32:00', '0', '*'),
('33', '58', '32', '5', '6', '3', 'sample-data-weblinks/joomla-specific-links/other-resources', 'com_weblinks', 'Other Resources', 'other-resources', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('34', '59', '16', '64', '65', '2', 'sample-data-contact/park-site', 'com_contact', 'Park Site', 'park-site', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '42', '2011-01-01 00:00:01', '0', 'en-GB'),
('35', '60', '16', '66', '123', '2', 'sample-data-contact/shop-site', 'com_contact', 'Shop Site', 'shop-site', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('36', '61', '35', '67', '68', '3', 'sample-data-contact/shop-site/staff', 'com_contact', 'Staff', 'staff', '', '<p>Please feel free to contact our staff at any time should you need assistance.</p>', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('37', '62', '35', '69', '122', '3', 'sample-data-contact/shop-site/fruit-encyclopedia', 'com_contact', 'Fruit Encyclopedia', 'fruit-encyclopedia', '', '<p> </p><p>Our directory of information about different kinds of fruit.</p><p>We love fruit and want the world to know more about all of its many varieties.</p><p>Although it is small now, we work on it whenever we have a chance.</p><p>All of the images can be found in <a href=\"http://commons.wikimedia.org/wiki/Main_Page\">Wikimedia Commons</a>.</p><p><img src=\"images/sampledata/fruitshop/apple.jpg\" border=\"0\" alt=\"Apples\" title=\"Apples\" /></p><p><em>This encyclopedia is implemented using the contact component, each fruit a separate contact and a category for each letter. A CSS style is used to create the horizontal layout of the alphabet headings. </em></p><p><em>If you wanted to, you could allow some users (such as your growers) to have access to just this category in the contact component and let them help you to create new content for the encyclopedia.</em></p><p> </p>', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('38', '63', '37', '70', '71', '4', 'sample-data-contact/shop-site/fruit-encyclopedia/a', 'com_contact', 'A', 'a', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('39', '64', '37', '72', '73', '4', 'sample-data-contact/shop-site/fruit-encyclopedia/b', 'com_contact', 'B', 'b', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('40', '65', '37', '74', '75', '4', 'sample-data-contact/shop-site/fruit-encyclopedia/c', 'com_contact', 'C', 'c', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('41', '66', '37', '76', '77', '4', 'sample-data-contact/shop-site/fruit-encyclopedia/d', 'com_contact', 'D', 'd', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('42', '67', '37', '78', '79', '4', 'sample-data-contact/shop-site/fruit-encyclopedia/e', 'com_contact', 'E', 'e', '', '', '0', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('43', '68', '37', '80', '81', '4', 'sample-data-contact/shop-site/fruit-encyclopedia/f', 'com_contact', 'F', 'f', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('44', '69', '37', '82', '83', '4', 'sample-data-contact/shop-site/fruit-encyclopedia/g', 'com_contact', 'G', 'g', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('45', '70', '37', '84', '85', '4', 'sample-data-contact/shop-site/fruit-encyclopedia/h', 'com_contact', 'H', 'h', '', '', '0', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('46', '71', '37', '86', '87', '4', 'sample-data-contact/shop-site/fruit-encyclopedia/i', 'com_contact', 'I', 'i', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('47', '72', '37', '88', '89', '4', 'sample-data-contact/shop-site/fruit-encyclopedia/j', 'com_contact', 'J', 'j', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('48', '73', '37', '90', '91', '4', 'sample-data-contact/shop-site/fruit-encyclopedia/k', 'com_contact', 'K', 'k', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('49', '74', '37', '92', '93', '4', 'sample-data-contact/shop-site/fruit-encyclopedia/l', 'com_contact', 'L', 'l', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('50', '75', '37', '94', '95', '4', 'sample-data-contact/shop-site/fruit-encyclopedia/m', 'com_contact', 'M', 'm', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('51', '76', '37', '96', '97', '4', 'sample-data-contact/shop-site/fruit-encyclopedia/n', 'com_contact', 'N', 'n', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('52', '77', '37', '98', '99', '4', 'sample-data-contact/shop-site/fruit-encyclopedia/o', 'com_contact', 'O', 'o', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('53', '78', '37', '100', '101', '4', 'sample-data-contact/shop-site/fruit-encyclopedia/p', 'com_contact', 'P', 'p', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('54', '79', '37', '102', '103', '4', 'sample-data-contact/shop-site/fruit-encyclopedia/q', 'com_contact', 'Q', 'q', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('55', '80', '37', '104', '105', '4', 'sample-data-contact/shop-site/fruit-encyclopedia/r', 'com_contact', 'R', 'r', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('56', '81', '37', '106', '107', '4', 'sample-data-contact/shop-site/fruit-encyclopedia/s', 'com_contact', 'S', 's', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('57', '82', '37', '108', '109', '4', 'sample-data-contact/shop-site/fruit-encyclopedia/t', 'com_contact', 'T', 't', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*');

INSERT INTO tkt_categories
(`id`, `asset_id`, `parent_id`, `lft`, `rgt`, `level`, `path`, `extension`, `title`, `alias`, `note`, `description`, `published`, `checked_out`, `checked_out_time`, `access`, `params`, `metadesc`, `metakey`, `metadata`, `created_user_id`, `created_time`, `modified_user_id`, `modified_time`, `hits`, `language`) VALUES 
('58', '83', '37', '110', '111', '4', 'sample-data-contact/shop-site/fruit-encyclopedia/u', 'com_contact', 'U', 'u', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('59', '84', '37', '112', '113', '4', 'sample-data-contact/shop-site/fruit-encyclopedia/v', 'com_contact', 'V', 'v', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('60', '85', '37', '114', '115', '4', 'sample-data-contact/shop-site/fruit-encyclopedia/w', 'com_contact', 'W', 'w', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('61', '86', '37', '116', '117', '4', 'sample-data-contact/shop-site/fruit-encyclopedia/x', 'com_contact', 'X', 'x', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('62', '87', '37', '118', '119', '4', 'sample-data-contact/shop-site/fruit-encyclopedia/y', 'com_contact', 'Y', 'y', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('63', '88', '37', '120', '121', '4', 'sample-data-contact/shop-site/fruit-encyclopedia/z', 'com_contact', 'Z', 'z', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('64', '93', '22', '15', '16', '5', 'sample-data-articles/joomla/extensions/modules/articles-modules', 'com_content', 'Content Modules', 'articles-modules', '', '<p>Content modules display article and other information from the content component.</p>', '-2', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '42', '2011-01-01 00:00:01', '0', '*'),
('65', '94', '22', '17', '18', '5', 'sample-data-articles/joomla/extensions/modules/user-modules', 'com_content', 'User Modules', 'user-modules', '', '<p>User modules interact with the user system, allowing users to login, show who is logged-in, and showing the most recently registered users.</p>', '-2', '0', '0000-00-00 00:00:00', '1', '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '42', '2011-12-27 12:00:50', '0', '*'),
('66', '95', '22', '19', '20', '5', 'sample-data-articles/joomla/extensions/modules/display-modules', 'com_content', 'Display Modules', 'display-modules', '', '<p>These modules display information from components other than content and user. These include weblinks, news feeds and the media manager.</p>', '-2', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('67', '96', '22', '21', '22', '5', 'sample-data-articles/joomla/extensions/modules/utility-modules', 'com_content', 'Utility Modules', 'utility-modules', '', '<p>Utility modules provide useful functionality such as search, syndication and statistics.</p>', '-2', '0', '0000-00-00 00:00:00', '1', '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '42', '2011-12-27 12:01:34', '0', '*'),
('68', '97', '23', '31', '32', '5', 'sample-data-articles/joomla/extensions/templates/atomic', 'com_content', 'Atomic', 'atomic', '', '<p><img src=\"templates/atomic/template_thumbnail.png\" border=\"0\" alt=\"The Atomic Template\" style=\"border: 0; float: right;\" /></p>\r\n<p>Atomic is a minimal template designed to be a skeleton for making your own template and to learn about Joomla! templating.</p>\r\n<ul>\r\n<li><a href=\"index.php?Itemid=285\">Home Page</a></li>\r\n<li><a href=\"index.php?Itemid=316\">Typography</a></li>\r\n</ul>', '-2', '0', '0000-00-00 00:00:00', '1', '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '42', '2011-12-27 12:08:16', '0', '*'),
('69', '98', '23', '27', '28', '5', 'sample-data-articles/joomla/extensions/templates/beez-20', 'com_content', 'Beez 20', 'beez-20', '', '<p><img src=\"templates/beez_20/template_thumbnail.png\" border=\"0\" alt=\"Beez_20 thumbnail\" align=\"right\" style=\"float: right;\" /></p>\r\n<p>Beez 2.0 is a versatile, easy to customise template that works for a variety of sites. It meets major accessibility standards and demonstrates a range of css and javascript techniques. It is the default template that installs with Joomla!</p>\r\n<ul>\r\n<li><a href=\"index.php?Itemid=424\">Home Page</a></li>\r\n<li><a href=\"index.php?Itemid=423\">Typography</a></li>\r\n</ul>', '-2', '0', '0000-00-00 00:00:00', '1', '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '42', '2011-01-01 00:00:01', '0', '*'),
('70', '99', '23', '29', '30', '5', 'sample-data-articles/joomla/extensions/templates/beez-5', 'com_content', 'Beez 5', 'beez-5', '', '<p><img src=\"templates/beez5/template_thumbnail.png\" border=\"0\" alt=\"Beez5 Thumbnail\" align=\"right\" style=\"float: right;\" /></p>\r\n<p>Beez 5 is an html5 implementation of a Joomla! template. It uses a number of html5 techniques to enhance the presentation of a site. It is used as the template for the Fruit Shop sample site.</p>\r\n<ul>\r\n<li><a href=\"index.php?Itemid=458\">Home Page</a></li>\r\n<li><a href=\"index.php?Itemid=457\">Typography</a></li>\r\n</ul>', '-2', '0', '0000-00-00 00:00:00', '1', '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '42', '2011-12-27 12:06:57', '0', '*'),
('72', '108', '28', '44', '45', '4', 'sample-data-articles/park-site/photo-gallery/animals', 'com_content', 'Animals', 'animals', '', '', '-2', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '42', '2011-01-01 00:00:01', '0', 'en-GB'),
('73', '109', '28', '46', '47', '4', 'sample-data-articles/park-site/photo-gallery/scenery', 'com_content', 'Scenery', 'scenery', '', '', '-2', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '42', '2011-01-01 00:00:01', '0', 'en-GB'),
('75', '166', '22', '23', '24', '5', 'sample-data-articles/joomla/extensions/modules/navigation-modules', 'com_content', 'Navigation Modules', 'navigation-modules', '', '<p>Navigation modules help your visitors move through your site and find what they need.</p>\r\n<p>Menus provide your site with structure and help your visitors navigate your site.  Although they are all based on the same menu module, the variety of ways menus are used in the sample data show how flexible this module is.</p>\r\n<p>A menu can range from extremely simple (for example the top menu or the menu for the Australian Parks sample site) to extremely complex (for example the About Joomla! menu with its many levels). They can also be used for other types of presentation such as the site map linked from the \"This Site\" menu.</p>\r\n<p>Breadcrumbs provide users with information about where they are in a site.</p>', '-2', '0', '0000-00-00 00:00:00', '1', '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '42', '2011-01-01 00:00:01', '0', '*'),
('76', '167', '29', '53', '54', '3', 'sample-data-articles/fruit-shop-site/recipes', 'com_content', 'Recipes', 'recipes', '', '<p>Customers and suppliers can post their favorite recipes for fruit here.</p>\r\n<p>A good idea is to promote the use of metadata keywords to make finding other recipes for the same fruit easier.</p>\r\n<p><em>To see this in action, create a user assigned to the customer group and a user assigned to the suppliers group. These users will be able to create their own recipe pages and edit those pages. They will not be able to edit other users\' pages.</em><br /><br /></p>', '-2', '0', '0000-00-00 00:00:00', '1', '{\"category_layout\":\"\",\"image\":\"\"}', '', '', '{\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '42', '2011-12-27 12:18:25', '0', '*'),
('77', '169', '1', '133', '134', '1', 'uncategorised', 'com_users', 'Uncategorised', 'uncategorised', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{\"target\":\"\",\"image\":\"\"}', '', '', '{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}', '242', '2011-01-01 00:00:01', '0', '2011-01-01 00:00:01', '0', '*'),
('78', '181', '1', '135', '138', '1', 'about-2047', 'com_content', 'About 2047', 'about-2047', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:52:08', '0', '0000-00-00 00:00:00', '0', '*'),
('79', '182', '1', '139', '146', '1', 'battalion', 'com_content', 'Battalion', 'battalion', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:52:08', '0', '0000-00-00 00:00:00', '0', '*'),
('80', '183', '1', '147', '150', '1', 'battalion-leader-section', 'com_content', 'Battalion Leader Section', 'battalion-leader-section', '', 'Battalion leader only information', '1', '0', '0000-00-00 00:00:00', '3', '{}', '', '', '', '242', '2013-09-21 14:52:08', '0', '0000-00-00 00:00:00', '0', '*'),
('81', '184', '78', '136', '137', '2', 'about-2047/about-2047', 'com_content', 'About 2047', 'about-2047', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:52:08', '0', '0000-00-00 00:00:00', '0', '*'),
('82', '185', '79', '140', '141', '2', 'battalion/about-battalion', 'com_content', 'About Battalion', 'about-battalion', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:52:08', '0', '0000-00-00 00:00:00', '0', '*'),
('83', '186', '79', '142', '143', '2', 'battalion/battalion', 'com_content', 'Battalion', 'battalion', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:52:08', '0', '0000-00-00 00:00:00', '0', '*'),
('84', '187', '79', '144', '145', '2', 'battalion/facebooktwitter-btn', 'com_content', 'Facebook/Twitter BTN', 'facebooktwitter-btn', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:52:08', '0', '0000-00-00 00:00:00', '0', '*'),
('85', '188', '80', '148', '149', '2', 'battalion-leader-section/battalion-leader-section-a-info', 'com_content', 'Battalion Leader Section & Info', 'battalion-leader-section-a-info', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:52:08', '0', '0000-00-00 00:00:00', '0', '*'),
('86', '205', '1', '151', '154', '1', 'parent-letters', 'com_content', 'Parent Letters', 'parent-letters', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:54:18', '0', '0000-00-00 00:00:00', '0', '*'),
('87', '206', '86', '152', '153', '2', 'parent-letters/parent-letters', 'com_content', 'Parent Letters', 'parent-letters', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:54:18', '0', '0000-00-00 00:00:00', '0', '*'),
('88', '227', '1', '155', '160', '1', 'news', 'com_content', 'News', 'news', '', '', '1', '242', '2013-09-23 15:02:15', '1', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('89', '228', '1', '161', '164', '1', 'faqs', 'com_content', 'FAQs', 'faqs', '', 'From the list below choose one of our FAQs topics, then select an FAQ to read. If you have a question which is not in this section, please contact us.', '0', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('90', '229', '1', '165', '176', '1', 'stockade', 'com_content', 'Stockade', 'stockade', '', '<div style=\"text-align: center;\"></div>\n<br />', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('91', '230', '1', '177', '182', '1', 'tree-climbers', 'com_content', 'Tree Climbers', 'tree-climbers', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('92', '231', '1', '183', '186', '1', 'parent-info', 'com_content', 'Parent Info', 'parent-info', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('93', '232', '1', '187', '190', '1', 'directions-etc', 'com_content', 'Directions etc.', 'directions-etc', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('94', '233', '1', '191', '194', '1', 'leader-contact', 'com_content', 'Leader Contact', 'leader-contact', '', '', '1', '0', '0000-00-00 00:00:00', '3', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('95', '234', '1', '195', '198', '1', 'boy-contact-info', 'com_content', 'Boy Contact Info Stockade', 'boy-contact-info', '', '', '1', '0', '0000-00-00 00:00:00', '3', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('96', '235', '1', '199', '202', '1', 'game-room', 'com_content', 'Game Room', 'game-room', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('97', '236', '1', '203', '206', '1', 'stk-ldr-schedule', 'com_content', 'STK LDR Schedule', 'stk-ldr-schedule', '', '', '1', '0', '0000-00-00 00:00:00', '3', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('98', '237', '1', '207', '210', '1', 'btn-ldr-schedule', 'com_content', 'BTN Ldr Schedule', 'btn-ldr-schedule', '', '', '1', '0', '0000-00-00 00:00:00', '3', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('99', '238', '1', '211', '214', '1', 'left-announcement-box', 'com_content', 'Left Announcement Box', 'left-announcement-box', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('100', '239', '1', '215', '218', '1', 'boy-contact-info-tree-climbers', 'com_content', 'Boy Contact Info Tree Climbers', 'boy-contact-info-tree-climbers', '', '', '1', '0', '0000-00-00 00:00:00', '3', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('101', '240', '1', '219', '222', '1', 'teen-contact-battalion', 'com_content', 'Teen Contact Battalion', 'teen-contact-battalion', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('102', '241', '1', '223', '226', '1', 'leader-section', 'com_content', 'Stockade Leader Section', 'leader-section', '', 'Leader only information', '1', '0', '0000-00-00 00:00:00', '3', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('103', '242', '1', '227', '230', '1', 'thank-you-for-your-donation', 'com_content', 'Thank You for your Donation', 'thank-you-for-your-donation', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('104', '243', '88', '156', '157', '2', 'news/latest-news', 'com_content', 'Latest', 'latest-news', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('105', '244', '88', '158', '159', '2', 'news/newsflash', 'com_content', 'Newsflash', 'newsflash', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('106', '245', '89', '162', '163', '2', 'faqs/general', 'com_content', 'General', 'general', '', 'General questions about the Joomla! CMS', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('107', '246', '90', '166', '167', '2', 'stockade/about-stockade', 'com_content', 'About Stockade', 'about-stockade', '', '<ul>\n<li></li>\n</ul>\n<p><a href=\"index.php?option=com_content&amp;view=category&amp;id=44:battalion&amp;layout=blog&amp;Itemid=54\"><strong>Battalion</strong></a><strong> </strong>(Monday\'s 7-8:30pm) is a group for young men aged 12 - 18.</p>\n<ul>\n<li>A group whose purpose is to build leadership capabilities in today\'s teen. </li>\n<li></li>\n<li>An organized and structured weekly meeting where teen\'s are given leadership responsibilities. </li>\n<li>Games, Squad Meeting (small groups), Captain\'s Special and Council Ring make up the weekly meeting. </li>\n<li>Special  activities consist of overnight\'s, camping, canoe trips, rocket cars to  name a few. In the past Battalion has also made their own wood strip  canoes for our yearly canoe trips.</li>\n<li></li>\n</ul>\n<div align=\"center\"><a href=\"leaders.html\" target=\"_blank\"><strong>|</strong></a><a href=\"index.php?option=com_content&amp;view=article&amp;id=177&amp;Itemid=102\"><strong> </strong></a><a href=\"index.php?option=com_content&amp;view=article&amp;id=177&amp;Itemid=102\">About the Leaders</a> <strong>|</strong></div>\n<div align=\"center\"><strong><br /></strong></div>\n<p><strong>Christian Service Brigade #2047 </strong>is one 40+ Brigade Units in our region.<strong> </strong><a href=\"http://www.csbministries.org/\">Christian Service Brigade</a> was founded in 1936 and since then has grown to have units throughout  the USA and Canada as well as related organizations worlwide.</p>\n<p> </p>\n<p>Our  Tree Climber\'s, Stockade and Battalion are outreach ministries from the  Wesleyan Church of Orchard Park. In Brigade we believe and teach basic  Christian beliefs. Boy\'s attending Brigade <strong>do not</strong> have to be attender\'s of this church or any other. Nearly 75% of the  boys who attend our group come from outside of our church with nearly  half attending local Catholic Churches, Lutheran, Presbyterian and  others in Orchard Park, Hamburg and East Aurora. The Wesleyan Church of  Orchard Park was founded nearly 110 years ago. Click to learn more about  the <a href=\"http://www.opwc.org\" target=\"_blank\">Wesleyan Church of Orchard Park</a> .</p>\n<p> </p>\n<p>Besides  the weekly meetings, CSB also offers boy\'s and teen\'s various  experiences through Camps which are located in the USA and Canada. Our  regional camp is <a href=\"http://www.camphickoryhill.org\" target=\"_blank\">Camp Hickory Hill</a> in Varysburg, NY.</p>\n<p>If you have any questions on Christian Service Brigade #2047 <a href=\"mailto:jim@2047.org\">email here</a>.</p>', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('108', '247', '90', '168', '169', '2', 'stockade/stockade', 'com_content', 'Stockade', 'stockade', '', '', '1', '242', '2013-09-22 02:34:33', '1', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('109', '248', '90', '170', '171', '2', 'stockade/question-of-the-week', 'com_content', 'Question of the Week', 'question-of-the-week', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*');

INSERT INTO tkt_categories
(`id`, `asset_id`, `parent_id`, `lft`, `rgt`, `level`, `path`, `extension`, `title`, `alias`, `note`, `description`, `published`, `checked_out`, `checked_out_time`, `access`, `params`, `metadesc`, `metakey`, `metadata`, `created_user_id`, `created_time`, `modified_user_id`, `modified_time`, `hits`, `language`) VALUES 
('110', '249', '90', '172', '173', '2', 'stockade/stockade-special', 'com_content', 'Stockade Special', 'stockade-special', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('111', '250', '90', '174', '175', '2', 'stockade/facebooktwitter-stockade', 'com_content', 'Facebook/Twitter Stockade', 'facebooktwitter-stockade', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('112', '251', '91', '178', '179', '2', 'tree-climbers/about-tree-climbers', 'com_content', 'About Tree Climbers', 'about-tree-climbers', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('113', '252', '91', '180', '181', '2', 'tree-climbers/tree-climbers', 'com_content', 'Tree Climbers', 'tree-climbers', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('114', '253', '92', '184', '185', '2', 'parent-info/parent-information', 'com_content', 'Parent Information', 'parent-information', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('115', '254', '93', '188', '189', '2', 'directions-etc/who-where', 'com_content', 'Who, Where', 'who-where', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('116', '255', '94', '192', '193', '2', 'leader-contact/adult-contact', 'com_content', 'Adult Contact', 'adult-contact', '', '', '1', '0', '0000-00-00 00:00:00', '3', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('117', '256', '95', '196', '197', '2', 'boy-contact-info/boy-contact-info', 'com_content', 'Boy Contact Info Stockade', 'boy-contact-info', '', '', '1', '0', '0000-00-00 00:00:00', '3', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('118', '257', '96', '200', '201', '2', 'game-room/game-room', 'com_content', 'Game Room', 'game-room', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('119', '258', '97', '204', '205', '2', 'stk-ldr-schedule/stk-ldr-schedule', 'com_content', 'STK LDR Schedule', 'stk-ldr-schedule', '', '', '1', '0', '0000-00-00 00:00:00', '3', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('120', '259', '98', '208', '209', '2', 'btn-ldr-schedule/btn-ldr-schedule', 'com_content', 'BTN LDR Schedule', 'btn-ldr-schedule', '', '', '1', '0', '0000-00-00 00:00:00', '3', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('121', '260', '99', '212', '213', '2', 'left-announcement-box/left-announcement-box', 'com_content', 'Left Announcement Box', 'left-announcement-box', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('122', '261', '100', '216', '217', '2', 'boy-contact-info-tree-climbers/boy-contact-info-tree-climbers', 'com_content', 'Boy Contact Info Tree Climbers', 'boy-contact-info-tree-climbers', '', '', '1', '0', '0000-00-00 00:00:00', '3', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('123', '262', '101', '220', '221', '2', 'teen-contact-battalion/teen-contact-battalion', 'com_content', 'Teen Contact Battalion', 'teen-contact-battalion', '', '', '1', '0', '0000-00-00 00:00:00', '3', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('124', '263', '102', '224', '225', '2', 'leader-section/leader-only', 'com_content', 'Stockade Leader Only', 'leader-only', '', '', '1', '0', '0000-00-00 00:00:00', '3', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*'),
('125', '264', '103', '228', '229', '2', 'thank-you-for-your-donation/thank-you-for-your-donation', 'com_content', 'Thank you for your donation', 'thank-you-for-your-donation', '', '', '1', '0', '0000-00-00 00:00:00', '1', '{}', '', '', '', '242', '2013-09-21 14:54:26', '0', '0000-00-00 00:00:00', '0', '*');

DROP TABLE IF EXISTS `tkt_contact_details`;
CREATE TABLE `tkt_contact_details` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `con_position` varchar(255) DEFAULT NULL,
  `address` text,
  `suburb` varchar(100) DEFAULT NULL,
  `state` varchar(100) DEFAULT NULL,
  `country` varchar(100) DEFAULT NULL,
  `postcode` varchar(100) DEFAULT NULL,
  `telephone` varchar(255) DEFAULT NULL,
  `fax` varchar(255) DEFAULT NULL,
  `misc` mediumtext,
  `image` varchar(255) DEFAULT NULL,
  `imagepos` varchar(20) DEFAULT NULL,
  `email_to` varchar(255) DEFAULT NULL,
  `default_con` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `catid` int(11) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `mobile` varchar(255) NOT NULL DEFAULT '',
  `webpage` varchar(255) NOT NULL DEFAULT '',
  `sortname1` varchar(255) NOT NULL,
  `sortname2` varchar(255) NOT NULL,
  `sortname3` varchar(255) NOT NULL,
  `language` char(7) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;

INSERT INTO tkt_contact_details
(`id`, `name`, `alias`, `con_position`, `address`, `suburb`, `state`, `country`, `postcode`, `telephone`, `fax`, `misc`, `image`, `imagepos`, `email_to`, `default_con`, `published`, `checked_out`, `checked_out_time`, `ordering`, `params`, `user_id`, `catid`, `access`, `mobile`, `webpage`, `sortname1`, `sortname2`, `sortname3`, `language`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `featured`, `xreference`, `publish_up`, `publish_down`) VALUES 
('1', 'Contact Name Here', 'name', 'Position', 'Street Address', 'Suburb', 'State', 'Country', 'Zip Code', 'Telephone', 'Fax', '<p>Information about or by the contact.</p>', 'images/powered_by.png', 'top', 'email@example.com', '1', '-2', '0', '0000-00-00 00:00:00', '1', '{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"1\",\"linka_name\":\"Twitter\",\"linka\":\"http:\\/\\/twitter.com\\/joomla\",\"linkb_name\":\"YouTube\",\"linkb\":\"http:\\/\\/www.youtube.com\\/user\\/joomla\",\"linkc_name\":\"Facebook\",\"linkc\":\"http:\\/\\/www.facebook.com\\/joomla\",\"linkd_name\":\"FriendFeed\",\"linkd\":\"http:\\/\\/friendfeed.com\\/joomla\",\"linke_name\":\"Scribed\",\"linke\":\"http:\\/\\/www.scribd.com\\/people\\/view\\/504592-joomla\",\"contact_layout\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\"}', '0', '16', '1', '', '', 'last', 'first', 'middle', 'en-GB', '2011-01-01 00:00:01', '242', '', '2011-12-27 12:23:32', '42', '', '', '{\"robots\":\"\",\"rights\":\"\"}', '1', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
('2', 'Webmaster', 'webmaster', '', '', '', '', '', '', '', '', '', '', '', 'webmaster@example.com', '0', '-2', '0', '0000-00-00 00:00:00', '1', '{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linka\":\"\",\"linkb_name\":\"\",\"linkb\":\"\",\"linkc_name\":\"\",\"linkc\":\"\",\"linkd_name\":\"\",\"linkd\":\"\",\"linke_name\":\"\",\"linke\":\"\",\"show_email_form\":\"1\",\"show_email_copy\":\"1\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"1\",\"custom_reply\":\"\",\"redirect\":\"\"}', '0', '34', '1', '', '', '', '', '', 'en-GB', '2011-01-01 00:00:01', '242', '', '2011-01-01 00:00:01', '42', '', '', '{\"robots\":\"\",\"rights\":\"\"}', '1', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
('3', 'Owner', 'owner', '', '', '', '', '', '', '', '', '<p>I\'m the owner of this store.</p>', '', '', '', '0', '-2', '0', '0000-00-00 00:00:00', '2', '{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linka\":\"\",\"linkb_name\":\"\",\"linkb\":\"\",\"linkc_name\":\"\",\"linkc\":\"\",\"linkd_name\":\"\",\"linkd\":\"\",\"linke_name\":\"\",\"linke\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\"}', '0', '36', '1', '', '', '', '', '', '*', '2011-01-01 00:00:01', '242', '', '2011-01-01 00:00:01', '42', '', '', '{\"robots\":\"\",\"rights\":\"\"}', '1', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
('4', 'Buyer', 'buyer', '', '', '', '', '', '', '', '', '<p>I am in charge of buying fruit. If you sell good fruit, contact me.</p>', '', '', '', '0', '-2', '0', '0000-00-00 00:00:00', '1', '{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"0\",\"linka_name\":\"\",\"linka\":\"\",\"linkb_name\":\"\",\"linkb\":\"\",\"linkc_name\":\"\",\"linkc\":\"\",\"linkd_name\":\"\",\"linkd\":\"\",\"linke_name\":\"\",\"linke\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\"}', '0', '36', '1', '', '', '', '', '', '*', '2011-01-01 00:00:01', '242', '', '2011-01-01 00:00:01', '42', '', '', '{\"robots\":\"\",\"rights\":\"\"}', '1', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
('5', 'Bananas', 'bananas', 'Scientific Name: Musa', 'Image Credit: Enzik\r\nRights: Creative Commons Share Alike Unported 3.0\r\nSource: http://commons.wikimedia.org/wiki/File:Bananas_-_Morocco.jpg', '', 'Type: Herbaceous', 'Large Producers: India, China, Brasil', '', '', '', '<p>Bananas are a great source of potassium.</p>\r\n<p> </p>', 'images/sampledata/fruitshop/bananas_2.jpg', '', '', '0', '-2', '0', '0000-00-00 00:00:00', '1', '{\"show_contact_category\":\"show_with_link\",\"show_contact_list\":\"\",\"presentation_style\":\"plain\",\"show_name\":\"\",\"show_position\":\"1\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"1\",\"show_postcode\":\"\",\"show_country\":\"1\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"1\",\"linka_name\":\"Wikipedia: Banana English\",\"linka\":\"http:\\/\\/en.wikipedia.org\\/wiki\\/Banana\",\"linkb_name\":\"Wikipedia:  \\u0939\\u093f\\u0928\\u094d\\u0926\\u0940 \\u0915\\u0947\\u0932\\u093e\",\"linkb\":\"http:\\/\\/hi.wikipedia.org\\/wiki\\/%E0%A4%95%E0%A5%87%E0%A4%B2%E0%A4%BE\",\"linkc_name\":\"Wikipedia:Banana Portugu\\u00eas\",\"linkc\":\"http:\\/\\/pt.wikipedia.org\\/wiki\\/Banana\",\"linkd_name\":\"Wikipedia: \\u0411\\u0430\\u043d\\u0430\\u043d  \\u0420\\u0443\\u0441\\u0441\\u043a\\u0438\\u0439\",\"linkd\":\"http:\\/\\/ru.wikipedia.org\\/\\u0411\\u0430\\u043d\\u0430\\u043d\",\"linke_name\":\"\",\"linke\":\"\",\"contact_layout\":\"beez5:encyclopedia\"}', '0', '39', '1', '', '', '', '', '', '*', '2011-01-01 00:00:01', '242', '', '2011-01-01 00:00:01', '42', '', '', '{\"robots\":\"\",\"rights\":\"\"}', '0', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
('6', 'Apples', 'apples', 'Scientific Name: Malus domestica', 'Image Credit: Fievet\r\nRights: Public Domain\r\nSource: http://commons.wikimedia.org/wiki/File:Pommes_vertes.JPG', '', 'Family: Rosaceae', 'Large: Producers: China, United States', '', '', '', '<p>Apples are a versatile fruit, used for eating, cooking, and preserving.</p>\r\n<p>There are more that 7500 different kinds of apples grown around the world.</p>', 'images/sampledata/fruitshop/apple.jpg', '', '', '0', '-2', '0', '0000-00-00 00:00:00', '1', '{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"plain\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"1\",\"linka_name\":\"Wikipedia: Apples English\",\"linka\":\"http:\\/\\/en.wikipedia.org\\/wiki\\/Apple\",\"linkb_name\":\"Wikipedia: Manzana Espa\\u00f1ol \",\"linkb\":\"http:\\/\\/es.wikipedia.org\\/wiki\\/Manzana\",\"linkc_name\":\"Wikipedia: \\u82f9\\u679c \\u4e2d\\u6587\",\"linkc\":\"http:\\/\\/zh.wikipedia.org\\/zh\\/\\u82f9\\u679c\",\"linkd_name\":\"Wikipedia: Tofaa Kiswahili\",\"linkd\":\"http:\\/\\/sw.wikipedia.org\\/wiki\\/Tofaa\",\"linke_name\":\"\",\"linke\":\"\",\"contact_layout\":\"beez5:encyclopedia\"}', '0', '38', '1', '', '', '', '', '', '*', '2011-01-01 00:00:01', '242', '', '2011-01-01 00:00:01', '42', '', '', '{\"robots\":\"\",\"rights\":\"\"}', '0', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
('7', 'Tamarind', 'tamarind', 'Scientific Name: Tamarindus indica', 'Image Credit: Franz Eugen Köhler, Köhler\'s Medizinal-Pflanzen \r\nRights: Public Domain\r\nSource:http://commons.wikimedia.org/wiki/File:Koeh-134.jpg', '', 'Family: Fabaceae', 'Large Producers: India, United States', '', '', '', '<p>Tamarinds are a versatile fruit used around the world. In its young form it is used in hot sauces; ripened it is the basis for many refreshing drinks.</p>\r\n<p> </p>', 'images/sampledata/fruitshop/tamarind.jpg', '', '', '0', '-2', '0', '0000-00-00 00:00:00', '1', '{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"plain\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"1\",\"linka_name\":\"Wikipedia: Tamarind English\",\"linka\":\"http:\\/\\/en.wikipedia.org\\/wiki\\/Tamarind\",\"linkb_name\":\"Wikipedia: \\u09a4\\u09c7\\u0981\\u09a4\\u09c1\\u09b2  \\u09ac\\u09be\\u0982\\u09b2\\u09be  \",\"linkb\":\"http:\\/\\/bn.wikipedia.org\\/wiki\\/\\u09a4\\u09c7\\u0981\\u09a4\\u09c1\\u09b2 \",\"linkc_name\":\"Wikipedia: Tamarinier Fran\\u00e7ais\",\"linkc\":\"http:\\/\\/fr.wikipedia.org\\/wiki\\/Tamarinier\",\"linkd_name\":\"Wikipedia:Tamaline lea faka-Tonga\",\"linkd\":\"http:\\/\\/to.wikipedia.org\\/wiki\\/Tamaline\",\"linke_name\":\"\",\"linke\":\"\",\"contact_layout\":\"beez5:encyclopedia\"}', '0', '57', '1', '', '', '', '', '', '*', '2011-01-01 00:00:01', '242', '', '2011-01-01 00:00:01', '42', '', '', '{\"robots\":\"\",\"rights\":\"\"}', '0', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
('8', 'Shop Address', 'shop-address', '', '', 'Our City', 'Our Province', 'Our Country', '', '555-555-5555', '', '<p>Here are directions for how to get to our shop.</p>', '', '', '', '0', '-2', '0', '0000-00-00 00:00:00', '1', '{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linka\":\"\",\"linkb_name\":\"\",\"linkb\":\"\",\"linkc_name\":\"\",\"linkc\":\"\",\"linkd_name\":\"\",\"linkd\":\"\",\"linke_name\":\"\",\"linke\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\"}', '0', '35', '1', '', '', '', '', '', '*', '2011-01-01 00:00:01', '242', '', '2011-01-01 00:00:01', '42', '', '', '{\"robots\":\"\",\"rights\":\"\"}', '1', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
('9', 'CSB #2047', 'csb-2047', '', '', '', '', '', '', '', '', '<p>Contact 2047 at:</p>\r\n<p>office@2047.org</p>\r\n<p>716-662-0335</p>\r\n<hr />\r\n<p><em>Group Meeting Address:</em></p>\r\n<p><em>Wesleyan Church of Orchard Park</em><br /><em>7295 Ellicott Rd</em><br /><em>Orchard Park NY 14127</em></p>\r\n<hr />\r\n<p><em>Mailing Address:</em></p>\r\n<p>2047<br />PO Box 504<br />Orchard Park, NY 14127</p>', '', '', '', '0', '1', '242', '2013-09-22 02:31:10', '3', '{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linka\":false,\"linkb_name\":\"\",\"linkb\":false,\"linkc_name\":\"\",\"linkc\":false,\"linkd_name\":\"\",\"linkd\":false,\"linke_name\":\"\",\"linke\":\"\",\"contact_layout\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\"}', '0', '16', '1', '', '', '', '', '', '*', '2013-09-22 02:31:10', '242', '', '0000-00-00 00:00:00', '0', '', '', '{\"robots\":\"\",\"rights\":\"\"}', '0', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00');

DROP TABLE IF EXISTS `tkt_content`;
CREATE TABLE `tkt_content` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `title` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `title_alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '' COMMENT 'Deprecated in Joomla! 3.0',
  `introtext` mediumtext NOT NULL,
  `fulltext` mediumtext NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `sectionid` int(10) unsigned NOT NULL DEFAULT '0',
  `mask` int(10) unsigned NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `images` text NOT NULL,
  `urls` text NOT NULL,
  `attribs` varchar(5120) NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `parentid` int(10) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `language` char(7) NOT NULL COMMENT 'The language code for the article.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM AUTO_INCREMENT=682 DEFAULT CHARSET=utf8;

INSERT INTO tkt_content
(`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES 
('1', '89', 'Administrator Components', 'administrator-components', '', '<p>All components are also used in the administrator area of your website. In addition to the ones listed here, there are components in the administrator that do not have direct front end displays, but do help shape your site. The most important ones for most users are</p>\r\n<ul>\r\n<li>Media Manager</li>\r\n<li>Extensions Manager</li>\r\n<li>Menu Manager</li>\r\n<li>Global Configuration</li>\r\n<li>Banners</li>\r\n<li>Redirect</li>\r\n</ul>\r\n<hr title=\"Media Manager\" alt=\"Media Manager\" class=\"system-pagebreak\" style=\"color: gray; border: 1px dashed gray;\" />\r\n<p> </p>\r\n<h3>Media Manager</h3>\r\n<p>The media manager component lets you upload and insert images into content throughout your site. Optionally, you can enable the flash uploader which will allow you to to upload multiple images. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Content_Media_Manager\">Help</a></p>\r\n<hr title=\"Extensions Manager\" alt=\"Extensions Manager\" class=\"system-pagebreak\" style=\"color: gray; border: 1px dashed gray;\" />\r\n<h3>Extensions Manager</h3>\r\n<p>The extensions manager lets you install, update, uninstall and manage all of your extensions. The extensions manager has been extensively redesigned, although the core install and uninstall functionality remains the same as in Joomla! 1.5. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Extension_Manager_Install\">Help</a></p>\r\n<hr title=\"Menu Manager\" alt=\"Menu Manager\" class=\"system-pagebreak\" style=\"color: gray; border: 1px dashed gray;\" />\r\n<h3>Menu Manager</h3>\r\n<p>The menu manager lets you create the menus you see displayed on your site. It also allows you to assign modules and template styles to specific menu links. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Menus_Menu_Manager\">Help</a></p>\r\n<hr title=\"Global Configuration\" alt=\"Global Configuration\" class=\"system-pagebreak\" style=\"color: gray; border: 1px dashed gray;\" />\r\n<h3>Global Configuration</h3>\r\n<p>The global configuration is where the site administrator configures things such as whether search engine friendly urls are enabled, the site meta data (descriptive text used by search engines and indexers) and other functions. For many beginning users simply leaving the settings on default is a good way to begin, although when your site is ready for the public you will want to change the meta data to match its content. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Site_Global_Configuration\">Help</a></p>\r\n<hr title=\"Banners\" alt=\"Banners\" class=\"system-pagebreak\" style=\"color: gray; border: 1px dashed gray;\" />\r\n<h3>Banners</h3>\r\n<p>The banners component provides a simple way to display a rotating image in a module and, if you wish to have advertising, a way to track the number of times an image is viewed and clicked. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Components_Banners_Banners_Edit\">Help</a></p>\r\n<hr title=\"Redirect\" class=\"system-pagebreak\" />\r\n<h3><br />Redirect</h3>\r\n<p>The redirect component is used to manage broken links that produce Page Not Found (404) errors. If enabled it will allow you to redirect broken links to specific pages. It can also be used to manage migration related URL changes. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Components_Redirect_Manager\">Help</a></p>', '', '1', '0', '0', '21', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-12-27 11:03:19', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '9', '0', '7', '', '', '1', '2', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('2', '90', 'Archive Module', 'archive-module', '', '<p>This module shows a list of the calendar months containing archived articles. After you have changed the status of an article to archived, this list will be automatically generated. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Articles_Archive\" title=\"Archive Module\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule articles_archive,Archived Articles}</div>', '', '1', '0', '0', '64', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-09-17 22:18:05', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}', '5', '0', '5', 'modules, content', '', '1', '5', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('3', '91', 'Article Categories Module', 'article-categories-module', '', '<p>This module displays a list of categories from one parent category. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Articles_Categories\" title=\"Categories Module\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule articles_categories,Articles Categories}</div>\r\n<p> </p>', '', '1', '0', '0', '64', '2011-01-01 00:00:01', '242', '', '2011-09-17 22:13:31', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}', '5', '0', '6', 'modules, content', '', '1', '6', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('4', '92', 'Articles Category Module', 'articles-category-module', '', '<p>This module allows you to display the articles in a specific category. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Articles_Category\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule articles_category,Articles Category}</div>', '', '1', '0', '0', '64', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-09-17 22:18:26', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}', '8', '0', '7', '', 'articles,content', '1', '10', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('5', '101', 'Authentication', 'authentication', '', '<p>The authentication plugins operate when users login to your site or administrator. The Joomla! authentication plugin is in operation by default but you can enable Gmail or LDAP or install a plugin for a different system. An example is included that may be used to create a new authentication plugin.</p>\r\n<p>Default on:</p>\r\n<ul>\r\n<li>Joomla <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Authentication_-_GMail\">Help</a></li>\r\n</ul>\r\n<p>Default off:</p>\r\n<ul>\r\n<li>Gmail <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Authentication_-_GMail\">Help</a></li>\r\n<li>LDAP <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Authentication_-_LDAP\">Help</a></li>\r\n</ul>', '', '1', '0', '0', '25', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-12-27 11:04:13', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '4', '0', '3', '', '', '1', '1', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('6', '102', 'Australian Parks ', 'australian-parks', '', '<p><img src=\"images/sampledata/parks/banner_cradle.jpg\" border=\"0\" alt=\"Cradle Park Banner\" /></p>\r\n<p>Welcome!</p>\r\n<p>This is a basic site about the beautiful and fascinating parks of Australia.</p>\r\n<p>On this site you can read all about my travels to different parks, see photos, and find links to park websites.</p>\r\n<p><em>This sample site is an example of using the core of Joomla! to create a basic website, whether a \"brochure site,\"  a personal blog, or as a way to present information on a topic you are interested in.</em></p>\r\n<p><em> Read more about the site in the About Parks module.</em></p>\r\n<p> </p>', '', '1', '0', '0', '26', '2011-01-01 00:00:01', '242', 'Parks Webmaster', '2011-09-06 06:20:19', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}', '2', '0', '1', '', '', '1', '1', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('7', '103', 'Banner Module', 'banner-module', '', '<p>The banner module is used to display the banners that are managed by the banners component in the site administrator. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Banners\">Help</a>.</p>\r\n<div class=\"sample-module\">{loadmodule banners,Banners}</div>', '', '1', '0', '0', '66', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-09-17 22:32:58', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}', '4', '0', '6', '', '', '1', '4', '', '0', '*', ''),
('8', '104', 'Beginners', 'beginners', '', '<p>If this is your first Joomla! site or your first web site, you have come to the right place. Joomla will help you get your website up and running quickly and easily.</p>\r\n<p>Start off using your site by logging in using the administrator account you created when you installed Joomla.</p>\r\n', '\r\n<p>Explore the articles and other resources right here on your site data to learn more about how Joomla works. (When you\'re done reading, you can delete or archive all of this.) You will also probably want to visit the Beginners\' Areas of the <a href=\"http://docs.joomla.org/Beginners\">Joomla documentation</a> and <a href=\"http://forum.joomla.org\">support forums</a>.</p>\r\n<p>You\'ll also want to sign up for the Joomla Security Mailing list and the Announcements mailing list. For inspiration visit the <a href=\"http://community.joomla.org/showcase/\">Joomla! Site Showcase</a> to see an amazing array of ways people use Joomla to tell their stories on the web.</p>\r\n<p>The basic Joomla installation will let you get a great site up and running, but when you are ready for more features the power of Joomla is in the creative ways that developers have extended it to do all kinds of things. Visit the <a href=\"http://extensions.joomla.org/\">Joomla! Extensions Directory</a> to see thousands of extensions that can do almost anything you could want on a website. Can\'t find what you need? You may want to find a Joomla professional in the <a href=\"http://resources.joomla.org/\">Joomla! Resource Directory</a>.</p>\r\n<p>Want to learn more? Consider attending a <a href=\"http://community.joomla.org/events.html\">Joomla! Day</a> or other event or joining a local <a href=\"http://community.joomla.org/user-groups.html\">Joomla! Users Group</a>. Can\'t find one near you? Start one yourself.</p>', '-2', '0', '0', '19', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-12-27 11:10:49', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '4', '0', '4', '', '', '1', '2', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '1', '*', ''),
('9', '105', 'Contacts', 'contact', '', '<p>The contact component provides a way to provide contact forms and information for your site or to create a complex directory that can be used for many different purposes. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Components_Contacts_Contacts\">Help</a></p>', '', '1', '0', '0', '21', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-01-10 04:15:37', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}', '2', '0', '2', '', '', '1', '3', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('10', '106', 'Content', 'content', '', '<p>The content component (com_content) is what you use to write articles. It is extremely flexible and has the largest number of built in views. Articles can be created and edited from the front end, making content the easiest component to use to create your site content. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Content_Article_Manager\">Help</a></p>', '', '1', '0', '0', '21', '2011-01-01 00:00:01', '242', '', '2011-01-10 04:28:12', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}', '2', '0', '1', '', '', '1', '5', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('11', '107', 'Cradle Mountain', 'cradle-mountain', '', '<p> </p>\r\n', '\r\n<p> </p>', '1', '0', '0', '73', '2011-01-01 00:00:01', '242', 'Parks Webmaster', '2012-01-17 04:42:36', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/sampledata\\/parks\\/landscape\\/250px_cradle_mountain_seen_from_barn_bluff.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"Cradle Mountain\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/sampledata\\/parks\\/landscape\\/800px_cradle_mountain_seen_from_barn_bluff.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"Cradle Mountain\",\"image_fulltext_caption\":\"Source: http:\\/\\/commons.wikimedia.org\\/wiki\\/File:Rainforest,bluemountainsNSW.jpg Author: Alan J.W.C. License: GNU Free Documentation License v . 1.2 or later\"}', '{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '4', '0', '1', '', '', '1', '1', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('12', '110', 'Custom HTML Module', 'custom-html-module', '', '<p>This module allows you to create your own HTML Module using a WYSIWYG editor. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Custom_HTML\" title=\"Custom HTML Module\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule custom,Custom HTML}</div>', '', '1', '0', '0', '66', '2011-01-01 00:00:01', '242', '', '2011-12-27 11:12:46', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '13', '0', '1', '', '', '1', '13', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('13', '111', 'Directions', 'directions', '', '<p>Here\'s how to find our shop.</p><p>By car</p><p>Drive along Main Street to the intersection with First Avenue.  Look for our sign.</p><p>By foot</p><p>From the center of town, walk north on Main Street until you see our sign.</p><p>By bus</p><p>Take the #73 Bus to the last stop. We are on the north east corner.</p>', '', '1', '0', '0', '29', '2011-01-01 00:00:01', '242', 'Fruit Shop Webmaster', '2011-01-01 00:00:01', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}', '1', '0', '2', '', '', '1', '0', '', '0', '*', ''),
('14', '112', 'Editors', 'editors', '', '<p>Editors are used thoughout Joomla! where content is created. TinyMCE is the default choice in most locations although CodeMirror is used in the template manager. No Editor provides a text box for html content.</p>\r\n<p>Default on:</p>\r\n<ul>\r\n<li>CodeMirror <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Editor_-_CodeMirror\">Help</a></li>\r\n<li>TinyMCE<a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Editor_-_TinyMCE\"> Help</a></li>\r\n<li>No Editor <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Editor_-_None\">Help</a></li>\r\n</ul>\r\n<p>Default off:</p>\r\n<ul>\r\n<li>None</li>\r\n</ul>', '', '1', '0', '0', '25', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-09-06 05:45:40', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}', '2', '0', '5', '', '', '1', '0', '', '0', '*', ''),
('15', '113', 'Editors-xtd', 'editors-xtd', '', '<p>These plugins are the buttons found beneath your editor. They only run when an editor plugin runs.</p>\r\n<p>Default on:</p>\r\n<ul>\r\n<li>Editor Button: Image<a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Button_-_Image\"> Help</a></li>\r\n<li>Editor Button: Readmore <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Button_-_Readmore\">Help</a></li>\r\n<li>Editor Button: Page Break <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Button_-_Pagebreak\">Help</a></li>\r\n<li>Editor Button: Article <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Button_-_Article\">Help</a></li>\r\n</ul>\r\n<p>Default off:</p>\r\n<ul>\r\n<li>None</li>\r\n</ul>', '', '1', '0', '0', '25', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-12-27 11:14:12', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '4', '0', '6', '', '', '1', '1', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('16', '114', 'Feed Display', 'feed-display', '', '<p>This module allows the displaying of a syndicated feed. <a href=\"http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Feed_Display\" title=\"Feed Display Module\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule feed,Feed Display}</div>', '', '1', '0', '0', '66', '2011-01-01 00:00:01', '242', '', '2011-09-17 22:22:08', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}', '3', '0', '2', '', '', '1', '3', '', '0', '*', ''),
('17', '115', 'First Blog Post', 'first-blog-post', '', '<p><em>Lorem Ipsum is filler text that is commonly used by designers before the content for a new site is ready.</em></p><p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed faucibus purus vitae diam posuere nec eleifend elit dictum. Aenean sit amet erat purus, id fermentum lorem. Integer elementum tristique lectus, non posuere quam pretium sed. Quisque scelerisque erat at urna condimentum euismod. Fusce vestibulum facilisis est, a accumsan massa aliquam in. In auctor interdum mauris a luctus. Morbi euismod tempor dapibus. Duis dapibus posuere quam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. In eu est nec erat sollicitudin hendrerit. Pellentesque sed turpis nunc, sit amet laoreet velit. Praesent vulputate semper nulla nec varius. Aenean aliquam, justo at blandit sodales, mauris leo viverra orci, sed sodales mauris orci vitae magna.</p>', '<p>Quisque a massa sed libero tristique suscipit. Morbi tristique molestie metus, vel vehicula nisl ultrices pretium. Sed sit amet est et sapien condimentum viverra. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Phasellus viverra tortor porta orci convallis ac cursus erat sagittis. Vivamus aliquam, purus non luctus adipiscing, orci urna imperdiet eros, sed tincidunt neque sapien et leo. Cras fermentum, dolor id tempor vestibulum, neque lectus luctus mauris, nec congue tellus arcu nec augue. Nulla quis mi arcu, in bibendum quam. Sed placerat laoreet fermentum. In varius lobortis consequat. Proin vulputate felis ac arcu lacinia adipiscing. Morbi molestie, massa id sagittis luctus, sem sapien sollicitudin quam, in vehicula quam lectus quis augue. Integer orci lectus, bibendum in fringilla sit amet, rutrum eget enim. Curabitur at libero vitae lectus gravida luctus. Nam mattis, ligula sit amet vestibulum feugiat, eros sem sodales mi, nec dignissim ante elit quis nisi. Nulla nec magna ut leo convallis sagittis ac non erat. Etiam in augue nulla, sed tristique orci. Vestibulum quis eleifend sapien.</p><p>Nam ut orci vel felis feugiat posuere ut eu lorem. In risus tellus, sodales eu eleifend sed, imperdiet id nulla. Nunc at enim lacus. Etiam dignissim, arcu quis accumsan varius, dui dui faucibus erat, in molestie mauris diam ac lacus. Sed sit amet egestas nunc. Nam sollicitudin lacinia sapien, non gravida eros convallis vitae. Integer vehicula dui a elit placerat venenatis. Nullam tincidunt ligula aliquet dui interdum feugiat. Maecenas ultricies, lacus quis facilisis vehicula, lectus diam consequat nunc, euismod eleifend metus felis eu mauris. Aliquam dapibus, ipsum a dapibus commodo, dolor arcu accumsan neque, et tempor metus arcu ut massa. Curabitur non risus vitae nisl ornare pellentesque. Pellentesque nec ipsum eu dolor sodales aliquet. Vestibulum egestas scelerisque tincidunt. Integer adipiscing ultrices erat vel rhoncus.</p><p>Integer ac lectus ligula. Nam ornare nisl id magna tincidunt ultrices. Phasellus est nisi, condimentum at sollicitudin vel, consequat eu ipsum. In venenatis ipsum in ligula tincidunt bibendum id et leo. Vivamus quis purus massa. Ut enim magna, pharetra ut condimentum malesuada, auctor ut ligula. Proin mollis, urna a aliquam rutrum, risus erat cursus odio, a convallis enim lectus ut lorem. Nullam semper egestas quam non mattis. Vestibulum venenatis aliquet arcu, consectetur pretium erat pulvinar vel. Vestibulum in aliquet arcu. Ut dolor sem, pellentesque sit amet vestibulum nec, tristique in orci. Sed lacinia metus vel purus pretium sit amet commodo neque condimentum.</p><p>Aenean laoreet aliquet ullamcorper. Nunc tincidunt luctus tellus, eu lobortis sapien tincidunt sed. Donec luctus accumsan sem, at porttitor arcu vestibulum in. Sed suscipit malesuada arcu, ac porttitor orci volutpat in. Vestibulum consectetur vulputate eros ut porttitor. Aenean dictum urna quis erat rutrum nec malesuada tellus elementum. Quisque faucibus, turpis nec consectetur vulputate, mi enim semper mi, nec porttitor libero magna ut lacus. Quisque sodales, leo ut fermentum ullamcorper, tellus augue gravida magna, eget ultricies felis dolor vitae justo. Vestibulum blandit placerat neque, imperdiet ornare ipsum malesuada sed. Quisque bibendum quam porta diam molestie luctus. Sed metus lectus, ornare eu vulputate vel, eleifend facilisis augue. Maecenas eget urna velit, ac volutpat velit. Nam id bibendum ligula. Donec pellentesque, velit eu convallis sodales, nisi dui egestas nunc, et scelerisque lectus quam ut ipsum.</p>', '1', '0', '0', '27', '2011-01-01 00:00:01', '242', '', '2011-01-01 00:00:01', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}', '1', '0', '2', '', '', '1', '0', '', '0', '*', ''),
('18', '116', 'Second Blog Post', 'second-blog-post', '', '<p><em>Lorem Ipsum is text that is traditionally used by designers when working on a site before the content is ready.</em></p><p>Pellentesque bibendum metus ut dolor fermentum ut pulvinar tortor hendrerit. Nam vel odio vel diam tempus iaculis in non urna. Curabitur scelerisque, nunc id interdum vestibulum, felis elit luctus dui, ac dapibus tellus mauris tempus augue. Duis congue facilisis lobortis. Phasellus neque erat, tincidunt non lacinia sit amet, rutrum vitae nunc. Sed placerat lacinia fermentum. Integer justo sem, cursus id tristique eget, accumsan vel sapien. Curabitur ipsum neque, elementum vel vestibulum ut, lobortis a nisl. Fusce malesuada mollis purus consectetur auctor. Morbi tellus nunc, dapibus sit amet rutrum vel, laoreet quis mauris. Aenean nec sem nec purus bibendum venenatis. Mauris auctor commodo libero, in adipiscing dui adipiscing eu. Praesent eget orci ac nunc sodales varius.</p>', '<p>Nam eget venenatis lorem. Vestibulum a interdum sapien. Suspendisse potenti. Quisque auctor purus nec sapien venenatis vehicula malesuada velit vehicula. Fusce vel diam dolor, quis facilisis tortor. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Pellentesque libero nisi, pellentesque quis cursus sit amet, vehicula vitae nisl. Curabitur nec nunc ac sem tincidunt auctor. Phasellus in mattis magna. Donec consequat orci eget tortor ultricies rutrum. Mauris luctus vulputate molestie. Proin tincidunt vehicula euismod. Nam congue leo non erat cursus a adipiscing ipsum congue. Nulla iaculis purus sit amet turpis aliquam sit amet dapibus odio tincidunt. Ut augue diam, congue ut commodo pellentesque, fermentum mattis leo. Sed iaculis urna id enim dignissim sodales at a ipsum. Quisque varius lobortis mollis. Nunc purus magna, pellentesque pellentesque convallis sed, varius id ipsum. Etiam commodo mi mollis erat scelerisque fringilla. Nullam bibendum massa sagittis diam ornare rutrum.</p><p>Praesent convallis metus ut elit faucibus tempus in quis dui. Donec fringilla imperdiet nibh, sit amet fringilla velit congue et. Quisque commodo luctus ligula, vitae porttitor eros venenatis in. Praesent aliquet commodo orci id varius. Nulla nulla nibh, varius id volutpat nec, sagittis nec eros. Cras et dui justo. Curabitur malesuada facilisis neque, sed tempus massa tincidunt ut. Sed suscipit odio in lacus auctor vehicula non ut lacus. In hac habitasse platea dictumst. Sed nulla nisi, lacinia in viverra at, blandit vel tellus. Nulla metus erat, ultrices non pretium vel, varius nec sem. Morbi sollicitudin mattis lacus quis pharetra. Donec tincidunt mollis pretium. Proin non libero justo, vitae mattis diam. Integer vel elit in enim varius posuere sed vitae magna. Duis blandit tempor elementum. Vestibulum molestie dui nisi.</p><p>Curabitur volutpat interdum lorem sed tempus. Sed placerat quam non ligula lacinia sodales. Cras ultrices justo at nisi luctus hendrerit. Quisque sit amet placerat justo. In id sapien eu neque varius pharetra sed in sapien. Etiam nisl nunc, suscipit sed gravida sed, scelerisque ut nisl. Mauris quis massa nisl, aliquet posuere ligula. Etiam eget tortor mauris. Sed pellentesque vestibulum commodo. Mauris vitae est a libero dapibus dictum fringilla vitae magna.</p><p>Nulla facilisi. Praesent eget elit et mauris gravida lobortis ac nec risus. Ut vulputate ullamcorper est, volutpat feugiat lacus convallis non. Maecenas quis sem odio, et aliquam libero. Integer vel tortor eget orci tincidunt pulvinar interdum at erat. Integer ullamcorper consequat eros a pellentesque. Cras sagittis interdum enim in malesuada. Etiam non nunc neque. Fusce non ligula at tellus porta venenatis. Praesent tortor orci, fermentum sed tincidunt vel, varius vel dui. Duis pulvinar luctus odio, eget porta justo vulputate ac. Nulla varius feugiat lorem sed tempor. Phasellus pulvinar dapibus magna eget egestas. In malesuada lectus at justo pellentesque vitae rhoncus nulla ultrices. Proin ut sem sem. Donec eu suscipit ipsum. Cras eu arcu porttitor massa feugiat aliquet at quis nisl.</p>', '1', '0', '0', '27', '2011-01-01 00:00:01', '242', '', '2011-01-01 00:00:01', '0', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}', '1', '0', '1', '', '', '1', '0', '', '0', '*', ''),
('19', '117', 'Footer Module', 'footer-module', '', '<p>This module shows the Joomla! copyright information. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Footer\" title=\"Footer Module\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule footer,Footer}</div>', '', '1', '0', '0', '66', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-09-17 22:22:47', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}', '4', '0', '3', '', '', '1', '4', '', '0', '*', ''),
('20', '118', 'Fruit Shop', 'fruit-shop', '', '<h2>Welcome to the Fruit Shop</h2>\r\n<p>We sell fruits from around the world. Please use our website to learn more about our business. We hope you will come to our shop and buy some fruit.</p>\r\n<p><em>This mini site will show you how you might want to set up a site for a business, in this example one selling fruit. It shows how to use access controls to manage your site content. If you were building a real site, you might want to extend it with e-commerce, a catalog, mailing lists or other enhancements, many of which are available through the</em><a href=\"http://extensions.joomla.org\"><em> Joomla! Extensions Directory</em></a>.</p>\r\n<p><em>To understand this site you will probably want to make one user with group set to customer and one with group set to grower. By logging in with different privileges you can see how access control works.</em></p>', '', '1', '0', '0', '29', '2011-01-01 00:00:01', '242', 'Fruit Shop Webmaster', '2011-12-27 11:17:59', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '2', '0', '1', '', '', '1', '0', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('21', '119', 'Getting Help', 'getting-help', '', '<p><img class=\"image-left\" src=\"administrator/templates/hathor/images/header/icon-48-help_header.png\" border=\"0\" /> There are lots of places you can get help with Joomla!. In many places in your site administrator you will see the help icon. Click on this for more information about the options and functions of items on your screen. Other places to get help are:</p>\r\n<ul>\r\n<li><a href=\"http://forum.joomla.org\">Support Forums</a></li>\r\n<li><a href=\"http://docs.joomla.org\">Documentation</a></li>\r\n<li><a href=\"http://resources.joomla.org\">Professionals</a></li>\r\n<li><a href=\"http://shop.joomla.org/amazoncom-bookstores.html\">Books</a></li>\r\n</ul>', '', '1', '0', '0', '19', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-01-10 15:32:54', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}', '10', '0', '8', '', '', '1', '17', '', '0', '*', ''),
('22', '120', 'Getting Started', 'getting-started', '', '<p>It\'s easy to get started creating your website. Knowing some of the basics will help.</p>\r\n<h3>What is a Content Management System?</h3>\r\n<p>A content management system is software that allows you to create and manage webpages easily by separating the creation of your content from the mechanics required to present it on the web.</p>\r\n<p>In this site, the content is stored in a <em>database</em>. The look and feel are created by a <em>template</em>. The Joomla! software brings together the template and the content to create web pages.</p>\r\n<h3>Site and Administrator</h3>\r\n<p>Your site actually has two separate sites. The site (also called the front end) is what visitors to your site will see. The administrator (also called the back end) is only used by people managing your site. You can access the administrator by clicking the \"Site Administrator\" link on the \"This Site\" menu or by adding /administrator to the end of you domain name.</p>\r\n<p>Log in to the administrator using the username and password created during the installation of Joomla.</p>\r\n<h3>Logging in</h3>\r\n<p>To login to the front end of your site use the login form or the login menu link on the \"This Site\" menu. Use the user name and password that were created as part of the installation process. Once logged-in you will be able to create and edit articles.</p>\r\n<p>In managing your site, you will be able to create content that only logged-in users are able to see.</p>\r\n<h3>Creating an article</h3>\r\n<p>Once you are logged-in, a new menu will be visible. To create a new article, click on the \"submit article\" link on that menu.</p>\r\n<p>The new article interface gives you a lot of options, but all you need to do is add a title and put something in the content area. To make it easy to find, set the state to published and put it in the Joomla category.</p>\r\n<div>You can edit an existing article by clicking on the edit icon (this only displays to users who have the right to edit).</div>\r\n<h3>Learn more</h3>\r\n<p>There is much more to learn about how to use Joomla! to create the web site you envision. You can learn much more at the <a href=\"http://docs.joomla.org\">Joomla! documentation site</a> and on the<a href=\"http://forum.joomla.org\"> Joomla! forums</a>.</p>', '', '1', '0', '0', '19', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-12-27 11:21:44', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '2', '0', '9', '', '', '1', '0', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('23', '121', 'Happy Orange Orchard', 'happy-orange-orchard', '', '<p>At our orchard we grow the world\'s best oranges as well as other citrus fruit such as lemons and grapefruit. Our family has been tending this orchard for generations.</p>', '', '1', '0', '0', '30', '2011-01-01 00:00:01', '242', 'Fruit Shop Webmaster', '2011-01-01 00:00:01', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}', '1', '0', '2', '', '', '1', '0', '', '0', '*', ''),
('24', '122', 'Joomla!', 'joomla', '', '<p>Congratulations! You have a Joomla site! Joomla makes it easy to build a website just the way you want it and keep it simple to update and maintain.</p>\r\n<p>Joomla is a flexible and powerful platform, whether you are building a small site for yourself or a huge site with hundreds of thousands of visitors. Joomla is open source, which means you can make it work just the way you want it to.</p>', '', '-2', '0', '0', '19', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-12-27 11:22:23', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '2', '0', '2', '', '', '1', '0', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '1', '*', ''),
('25', '123', 'Koala', 'koala', '', '<p> </p>\r\n<p> </p>\r\n<p> </p>\r\n<p> </p>\r\n<p> </p>\r\n', '\r\n<p> </p>', '1', '0', '0', '72', '2011-01-01 00:00:01', '242', 'Parks Webmaster', '2012-01-17 05:15:00', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/sampledata\\/parks\\/animals\\/180px_koala_ag1.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"Koala  Thumbnail\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/sampledata\\/parks\\/animals\\/800px_koala_ag1.jpg\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"Koala Climbing Tree\",\"image_fulltext_caption\":\"Source: http:\\/\\/commons.wikimedia.org\\/wiki\\/File:Koala-ag1.jpg Author: Arnaud Gaillard License: Creative Commons Share Alike Attribution Generic 1.0\"}', '{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '9', '0', '2', '', '', '1', '2', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('26', '124', 'Language Switcher', 'language-switcher', '', '<p>The language switcher module allows you to take advantage of the language tags that are available when content, modules and menu links are created.</p>\r\n<p>This module displays a list of available Content Languages for switching between them.</p>\r\n<p>When switching languages, it redirects to the Home page, or associated menu item, defined for the chosen language. Thereafter, the navigation will be the one defined for that language.</p>\r\n<p><strong>The language filter plugin must be enabled for this module to work properly.</strong></p>\r\n<p><strong></strong> <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Language_Switcher\" title=\"Language Switcher Module\">Help</a></p>\r\n<p>To view an example of the language switch moduler module, go to the site administrator and enable the language filter plugin and the language switcher module labelled \"language switcher\" and visit the fruit shop or park sample sites. Then follow<a href=\"http://docs.joomla.org/Language_Switcher_Tutorial_for_Joomla_1.6\"> the instructions in this tutorial</a>.</p>', '', '1', '0', '0', '67', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-12-27 11:25:00', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '3', '0', '3', '', '', '1', '3', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('27', '125', 'Latest Articles Module', 'latest-articles-module', '', '<p>This module shows a list of the most recently published and current Articles. Some that are shown may have expired even though they are the most recent. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Latest_News\" title=\"Latest Articles\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule articles_latest,Latest News}</div>', '', '1', '0', '0', '64', '2011-01-01 00:00:01', '242', '', '2011-12-27 11:25:41', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '9', '0', '1', 'modules, content', '', '1', '15', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('28', '126', 'Login Module', 'login-module', '', '<p>This module displays a username and password login form. It also displays a link to retrieve a forgotten password. If user registration is enabled (in the Global Configuration settings), another link will be shown to enable self-registration for users. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Login\" title=\"Login\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule login,login}</div>', '', '1', '0', '0', '65', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-09-17 22:20:35', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}', '4', '0', '2', '', '', '1', '5', '', '0', '*', ''),
('29', '127', 'Menu Module', 'menu-module', '', '<p>This module displays a menu on the site (frontend).  Menus can be displayed in a wide variety of ways by using the menu options and css menu styles. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Menu\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule mod_menu,Menu Example}</div>', '', '1', '0', '0', '75', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-09-17 22:18:45', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}', '8', '0', '1', '', '', '1', '12', '', '0', '*', ''),
('30', '128', 'Most Read Content', 'most-read-content', '', '<p>This module shows a list of the currently published Articles which have the highest number of page views. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Most_Read\" title=\"Most Read Content\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule articles_popular,Articles Most Read}</div>', '', '1', '0', '0', '64', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-12-27 11:26:41', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '6', '0', '2', 'modules, content', '', '1', '10', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('31', '129', 'News Flash', 'news-flash', '', '<p>Displays a set number of articles from a category based on date or random selection. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Articles_Newsflash\" title=\"News Flash Module\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule articles_news,News Flash}</div>', '', '1', '0', '0', '64', '2011-01-01 00:00:01', '242', '', '2011-09-17 22:16:46', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}', '4', '0', '3', 'modules, content', '', '1', '10', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('32', '130', 'Options', 'options', '', '<p>As you make your Joomla! site you will control the details of the display using <em>options</em> also referred to as <em>parameter</em><strong>s</strong>. Options control everything from whether the author\'s name is displayed to who can view what to the number of items shown on a list.</p>\r\n<p>Default options for each component are changed using the Options button on the component toolbar.</p>\r\n<p>Options can also be set on an individual item, such as an article or contact and in menu links.</p>\r\n<p>If you are happy with how your site looks, it is fine to leave all of the options set to the defaults that were created when your site was installed. As you become more experienced with Joomla you will use options more.</p>\r\n<p> </p>', '', '1', '0', '0', '19', '2011-01-01 00:00:01', '242', 'Joomla!', '2012-01-17 16:21:24', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '4', '0', '10', '', '', '1', '3', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('33', '131', 'Phyllopteryx', 'phyllopteryx', '', '<p> </p>\r\n', '\r\n<p> </p>', '1', '0', '0', '72', '2011-01-01 00:00:01', '242', 'Parks Webmaster', '2012-01-17 04:57:58', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/sampledata\\/parks\\/animals\\/200px_phyllopteryx_taeniolatus1.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"Phyllopteryx\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/sampledata\\/parks\\/animals\\/800px_phyllopteryx_taeniolatus1.jpg\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"Phyllopteryx\",\"image_fulltext_caption\":\"Source: http:\\/\\/en.wikipedia.org\\/wiki\\/File:Phyllopteryx_taeniolatus1.jpg Author: Richard Ling License: GNU Free Documentation License v 1.2 or later\"}', '{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '2', '0', '3', '', '', '1', '0', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('34', '132', 'Pinnacles', 'pinnacles', '', '<p> </p>\r\n', '\r\n<p> </p>', '1', '0', '0', '73', '2011-01-01 00:00:01', '242', 'Parks Webmaster', '2012-01-17 04:41:30', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '{\"image_intro\":\"images\\/sampledata\\/parks\\/landscape\\/120px_pinnacles_western_australia.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"Kings Canyon\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/sampledata\\/parks\\/landscape\\/800px_pinnacles_western_australia.jpg\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"Kings Canyon\",\"image_fulltext_caption\":\"Source: http:\\/\\/commons.wikimedia.org\\/wiki\\/File:Pinnacles_Western_Australia.jpg  Author: Martin Gloss  License: GNU Free Documentation license v 1.2 or later.\"}', '{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '3', '0', '4', '', '', '1', '3', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('35', '133', 'Professionals', 'professionals', '', '<p>Joomla! 2.5 continues development of the Joomla Framework and CMS as a powerful and flexible way to bring your vision of the web to reality. With the administrator now fully MVC, the ability to control its look and the management of extensions is now complete.</p>\r\n', '\r\n<p>Working with multiple template styles and overrides for the same views, creating the design you want is easier than it has ever been. Limiting support to PHP 5.2.4 and above makes Joomla lighter and faster than ever. Languages files can now be overridden without having your changes lost during an upgrade.  With the proper xml your users update extensions with a single click.</p>\r\n<p>Access control lists are now incorporated using a new system developed for Joomla. The ACL system is designed with developers in mind, so it is easy to incorporate into your extensions. The new nested sets libraries allow you to incorporate infinitely deep categories but also to use nested sets in a variety of other ways.</p>\r\n<p>A new forms library makes creating all kinds of user interaction simple. MooTools 1.3 provides a highly flexible javascript framework that is a major advance over MooTools 1.0.</p>\r\n<p>New events throughout the core make integration of your plugins where you want them a snap.</p>\r\n<p>The separation of the Joomla! Platform project from the Joomla! CMS project makes continuous development of new, powerful APIs  and continuous improvement of existing APIs possible while maintaining the stability of the CMS that millions of webmasters and professionals rely upon.</p>\r\n<p>Learn about:</p>\r\n<ul>\r\n<li><a href=\"http://docs.joomla.org/What\'s_new_in_Joomla_1.6\">Changes since 1.5</a></li>\r\n<li><a href=\"http://docs.joomla.org/ACL_Tutorial_for_Joomla_1.6\">Working with ACL</a></li>\r\n<li><a href=\"http://docs.joomla.org/API16:JCategories\">Working with nested categories</a></li>\r\n<li><a href=\"http://docs.joomla.org/API16:JForm\">Forms library</a></li>\r\n<li><a href=\"http://docs.joomla.org/Working_with_Mootools_1.3\">Working with Mootools 1.3</a></li>\r\n<li><a href=\"http://docs.joomla.org/Layout_Overrides_in_Joomla_1.6\">Using new features of the override system</a></li>\r\n<li><a href=\"http://api.joomla.org\">Joomla! API</a></li>\r\n<li><a href=\"http://docs.joomla.org/API16:JDatabaseQuery\">Using JDatabaseQuery</a></li>\r\n<li><a href=\"http://docs.joomla.org/What\'s_new_in_Joomla_1.6#Events\">New and updated events</a></li>\r\n<li><a href=\"http://docs.joomla.org/Xml-rpc_changes_in_Joomla!_1.6\">Xmlrpc</a></li>\r\n<li><a href=\"http://docs.joomla.org/What\'s_new_in_Joomla_1.6#Extension_management\">Installing and updating extensions</a></li>\r\n<li><a href=\"http://docs.joomla.org/Setting_up_your_workstation_for_Joomla!_development\">Setting up your development environment</a></li>\r\n<li><a href=\"github.com/joomla\">The Joomla! Platform Repository</a> </li>\r\n</ul>', '-2', '0', '0', '19', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-12-27 11:36:13', '42', '0', '0000-00-00 00:00:00', '2011-01-09 16:41:13', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '16', '0', '5', '', '', '1', '10', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '1', '*', ''),
('36', '134', 'Random Image Module', 'random-image-module', '', '<p>This module displays a random image from your chosen image directory. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Random_Image\" title=\"Random Image Module\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule random_image,Random Image}</div>', '', '1', '0', '0', '66', '2011-01-01 00:00:01', '242', '', '2012-01-17 16:11:13', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '6', '0', '4', '', '', '1', '6', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('37', '135', 'Related Items Module', 'related-items-module', '', '<p>This module displays other Articles that are related to the one currently being viewed. These relations are established by the Meta Keywords.  All the keywords of the current Article are searched against all the keywords of all other published articles. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Articles_Related\" title=\"Related Items Module\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule related_items,Articles Related Items}</div>', '', '1', '0', '0', '64', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-12-27 11:37:34', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '5', '0', '4', 'modules, content', '', '1', '5', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('38', '136', 'Sample Sites', 'sample-sites', '', '<p>Your installation includes sample data, designed to show you some of the options you have for building your website. In addition to information about Joomla! there are two sample \"sites within a site\" designed to help you get started with building your own site.</p>\r\n<p>The first site is a simple site about <a href=\"index.php?Itemid=243\">Australian Parks</a>. It shows how you can quickly and easily build a personal site with just the building blocks that are part of Joomla. It includes a personal blog, weblinks, and a very simple image gallery.</p>\r\n<p>The second site is slightly more complex and represents what you might do if you are building a site for a small business, in this case a <a href=\"index.php/welcome.html\"></a><a href=\"index.php?Itemid=429\">Fruit Shop</a>.</p>\r\n<p>In building either style site, or something completely different, you will probably want to add <a href=\"http://extensions.joomla.org\">extensions</a> and either create or purchase your own template. Many Joomla users start by modifying the <a href=\"http://docs.joomla.org/How_do_you_modify_a_template%3F\">templates</a> that come with the core distribution so that they include special images and other design elements that relate to their site\'s focus.</p>', '', '1', '0', '0', '19', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-12-27 11:39:07', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '2', '0', '11', '', '', '1', '5', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('39', '137', 'Search', 'search-component', '', '<p>Joomla! 2.5 offers two search options.</p>\r\n<p>The Basic Search component provides basic search functionality for the information contained in your core components. Many extensions can also be searched by the search component. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Components_Search\">Help</a></p>\r\n<p>The Smart Search component offers searching similar to that found in major search engines. Smart Search is disabled by default. If you choose to enable it you will need to take several steps. First, enable the Smart Search Plugin in the plugin manager. Then, if you are using the Basic Search Module replace it with the Smart Search Module. Finally, if you have already created content, go to the Smart Search component in your site administrator and click the Index icon. Once indexing of your content is complete, Smart Search will be ready to use. Help.</p>', '', '1', '0', '0', '21', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-12-27 11:41:48', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '4', '0', '3', '', '', '1', '3', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('40', '138', 'Search Module', 'search-module', '', '<p>This module will display a search box. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Search\" title=\"Search\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule search,Search}</div>', '', '1', '0', '0', '67', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-09-17 22:35:56', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}', '4', '0', '4', '', '', '1', '6', '', '0', '*', ''),
('41', '139', 'Search ', 'search-plugin', '', '<p>The search component uses plugins to control which parts of your Joomla! site are searched. You may choose to turn off some areas to improve performance or for other reasons. Many third party Joomla! extensions have search plugins that extend where search takes place.</p>\r\n<p>Default On:</p>\r\n<ul>\r\n<li>Content <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Search_-_Content\">Help</a></li>\r\n<li>Contacts <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Search_-_Contacts\">Help</a></li>\r\n<li>Weblinks <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Search_-_Weblinks\">Help</a></li>\r\n<li>News Feeds <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Search_-_Newsfeeds\">Help</a></li>\r\n<li>Categories <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Search_-_Categories\">Help</a></li>\r\n</ul>', '', '1', '0', '0', '25', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-09-06 06:13:18', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}', '3', '0', '1', '', '', '1', '0', '', '0', '*', ''),
('42', '140', 'Site Map', 'site-map', '', '<p>{loadposition sitemapload}</p><p><em>By putting all of your content into nested categories you can give users and search engines access to everything using a menu.</em></p>', '', '1', '0', '0', '14', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-01-01 00:00:01', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}', '1', '0', '1', '', '', '1', '0', '', '0', '*', ''),
('43', '141', 'Example Pages and Menu Links', 'example-pages-and-menu-links', '', '<p>This page is an example of content that is <em>Uncategorized</em>; that is, it does not belong to any Section or Category. You will see there is a new Menu in the left column. It shows links to the same content presented in 4 different page layouts.</p><ul><li>Section Blog</li><li>Section Table</li><li> Blog Category</li><li>Category Table</li></ul><p>Follow the links in the <strong>Example Pages</strong> Menu to see some of the options available to you to present all the different types of content included within the default installation of Joomla!.</p><p>This includes Components and individual Articles. These links or Menu Item Types (to give them their proper name) are all controlled from within the <strong><font face=\"courier new,courier\">Menu Manager-&gt;[menuname]-&gt;Menu Items Manager</font></strong>. </p>', '', '1', '0', '0', '9', '2006-10-12 09:26:52', '242', '', '2013-09-21 14:52:08', '242', '0', '0000-00-00 00:00:00', '2006-10-11 10:00:00', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '7', '0', '3', 'Uncategorized, Uncategorized, Example Pages and Menu Links', '', '1', '45', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('44', '142', 'Statistics Module', 'statistics', '', '<p>This module shows information about your server installation together with statistics on the Web site users, number of Articles in your database and the number of Web links you provide.</p>\r\n<div class=\"sample-module\">{loadmodule mod_stats,Statistics}</div>', '', '1', '0', '0', '67', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-12-27 11:43:25', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '6', '0', '5', '', '', '1', '5', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('45', '143', 'Syndicate Module', 'syndicate-module', '', '<p>The syndicate module will display a link that allows users to take a feed from your site. It will only display on pages for which feeds are possible. That means it will not display on single article, contact or weblinks pages, such as this one. <a href=\"http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Syndicate\" title=\"Synicate Module\">Help</a></p>\r\n<div class=\"sample-module\">{loadposition syndicate,Syndicate}</div>', '', '1', '0', '0', '67', '2011-01-01 00:00:01', '242', '', '2011-12-27 11:44:16', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '3', '0', '6', '', '', '1', '2', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('46', '144', 'System', 'system', '', '<p>System plugins operate every time a page on your site loads. They control such things as your URLS, whether users can check a \"remember me\" box on the login module, and whether caching is enabled. New is the redirect plugin that together with the redirect component will assist you in managing changes in URLs.</p>\r\n<p>Default on:</p>\r\n<ul>\r\n<li>Remember me <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#System_-_Remember_Me\">Help</a></li>\r\n<li>SEF <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#System_-_SEF\">Help</a></li>\r\n<li>Debug <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#System_-_Debug\">Help</a></li>\r\n</ul>\r\n<p>Default off:</p>\r\n<ul>\r\n<li>Cache <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#System_-_Cache\">Help</a></li>\r\n<li>Log <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#System_-_Log\">Help</a></li>\r\n<li>Redirect <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#System_-_Redirect\">Help</a></li>\r\n</ul>', '', '1', '0', '0', '25', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-12-27 11:45:54', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '5', '0', '2', '', '', '1', '1', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('47', '145', 'The Joomla! Community', 'the-joomla-community', '', '<p>Joomla means All Together, and it is a community of people all working and having fun together that makes Joomla possible. Thousands of people each year participate in the Joomla community, and we hope you will be one of them.</p>\r\n<p>People with all kinds of skills, of all skill levels and from around the world are welcome to join in. Participate in the <a href=\"http://joomla.org\">Joomla.org</a> family of websites (the<a href=\"http://forum.joomla.org\"> forum </a>is a great place to start). Come to a <a href=\"http://community.joomla.org/events.html\">Joomla! event</a>. Join or start a <a href=\"http://community.joomla.org/user-groups.html\">Joomla! Users Group</a>. Whether you are a developer, site administrator, designer, end user or fan, there are ways for you to participate and contribute.</p>', '', '1', '0', '0', '19', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-12-27 11:47:56', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '3', '0', '3', '', '', '1', '0', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('48', '146', 'Stockade Main', 'stockade-main', '', '<hr />\n<br /><br /> <center> \n<table style=\"width: 639px; background-color: #ffff00;\" cellpadding=\"5\" cellspacing=\"0\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"text-align: center;\" rowspan=\"2\" background=\"stockade/newart/grn_new_grad.gif\" valign=\"middle\">\n<p><a href=\"#\" onclick=\"window.open(\'countdown_numbers/index.html\',\'\',\'width=400,height=300,left=\'+(screen.availWidth/2-200)+\',top=\'+(screen.availHeight/2-150)+\'\');return false;\"><img src=\"../stockade/newart/howlong.gif\" height=\"100\" width=\"300\" /></a><span style=\"color: yellow; font-size: xx-small;\"><strong><span style=\"font-family: Arial; color: red;\">&nbsp;</span></strong></span></p>\n</td>\n<td style=\"text-align: center;\" colspan=\"2\" rowspan=\"2\" bgcolor=\"white\" valign=\"middle\">\n<p><a href=\"qow.html\"><strong><span style=\"font-family: Georgia,Times New Roman,Times,serif;\">Old Questions of the Week<br /> are here</span></strong></a></p>\n<p><br /> <img src=\"../stockade/newart/QOW_animated.gif\" height=\"55\" width=\"150\" /><span><br /> </span><span><a href=\"../qow.html\" target=\"_blank\" onclick=\"return CSButtonReturn()\"><img src=\"../stockade/newart/prevqowoff.gif\" name=\"button9\" height=\"24\" width=\"168\" /></a><br /> </span></p>\n</td>\n</tr>\n<tr style=\"text-align: left;\" height=\"1\">\n</tr>\n<tr style=\"text-align: left;\" height=\"99\">\n<td style=\"text-align: left;\" bgcolor=\"blue\" height=\"99\"><span style=\"color: #3300cc;\"><a href=\"stockade/photoalbum/\" target=\"_blank\"><img style=\"display: block; margin-left: auto; margin-right: auto;\" src=\"../stockade/newart/photos_rotate.gif\" height=\"50\" width=\"200\" /></a></span></td>\n<td style=\"text-align: left;\" colspan=\"2\" bgcolor=\"#ffff66\" height=\"99\">\n<h2 style=\"text-align: center;\"><span><strong><a href=\"index.php?option=com_content&amp;view=section&amp;layout=blog&amp;id=8&amp;Itemid=98\">Parent Information<br /> on the group<br /> </a></strong></span></h2>\n</td>\n</tr>\n</tbody>\n</table>\n<p> </p>\n<table style=\"width: 642px; height: 334px; border-width: 0pt; border-style: solid; background-color: #ffffff;\" align=\"center\" border=\"0\" cellpadding=\"5\" cellspacing=\"0\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\" height=\"31\">\n<td style=\"text-align: center;\" colspan=\"3\" background=\"http://www.2047.org/stockade/newart/orangeLtoRgif\" height=\"31\" valign=\"middle\">\n<div style=\"text-align: center;\"></div>\n</td>\n<td style=\"text-align: center;\" rowspan=\"8\" background=\"newart/orangeLtoRgif\" height=\"557\" valign=\"middle\">\n<div style=\"text-align: center;\">\n<p><strong><em><span style=\"color: black;\"><a href=\"7_points/index.html\" target=\"_blank\">What are the<br /> Seven Points<br /> </a></span></em></strong><strong><em><span style=\"color: black;\"><a href=\"7_points/index.html\" target=\"_blank\">of Valor?</a></span></em></strong></p>\n<p><strong><em><span style=\"color: black;\"><br /> </span></em></strong></p>\n<p><a href=\"7_points/index.html\" target=\"_blank\"><img src=\"../stockade/newart/7_points_button.png\" height=\"132\" width=\"131\" /></a></p>\n</div>\n<p> </p>\n<p> </p>\n<p> </p>\n<p><img src=\"../stockade/newart/pirate.jpg\" height=\"118\" width=\"118\" /></p>\n<div style=\"text-align: center;\">\n<p> </p>\n<p><a href=\"parentinfo/pirate.html\" target=\"_blank\"><span>Why the JL\'s use a Pirate</span></a></p>\n</div>\n</td>\n</tr>\n<tr style=\"text-align: left;\" bgcolor=\"#d4f4ff\" height=\"37\">\n<td style=\"text-align: center;\" colspan=\"3\" bgcolor=\"#ff6600\" height=\"37\" valign=\"middle\"><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif; color: black;\"><strong>Here is what Jim is drawing now!</strong></span>\n<p><span style=\"color: #ffb100;\"><img src=\"http://www.kidstimestudio.com/drawingcam/index.jpg\" border=\"0\" /></span></p>\n</td>\n</tr>\n<tr style=\"text-align: left;\" bgcolor=\"#d4f4ff\" height=\"37\">\n<td style=\"text-align: center;\" colspan=\"3\" height=\"37\" valign=\"middle\">\n<div style=\"text-align: center;\"><strong><span>When the when will the Space Station fly over Orchard Park?<br /> <a href=\"http://spaceflight.nasa.gov/realdata/sightings/cities/view.cgi?country=United_States&amp;region=New_York&amp;city=Orchard_Park\" target=\"_blank\">Click here</a> to find out!!!</span></strong></div>\n</td>\n</tr>\n<tr style=\"text-align: left;\" bgcolor=\"#fffda5\" height=\"34\">\n<td style=\"text-align: center;\" colspan=\"3\" height=\"34\" valign=\"middle\">\n<div style=\"text-align: center;\"><strong><span style=\"font-family: Arial; color: #000011;\">North Pole and South Pole Web Cams </span><span style=\"font-family: Arial;\"><a href=\"stockade/webcam.html\" target=\"_blank\">are here</a></span><span style=\"font-family: Arial; color: #ffffff;\">!</span></strong></div>\n</td>\n</tr>\n<tr style=\"text-align: left;\" bgcolor=\"#afffb7\" height=\"32\">\n<td style=\"text-align: center;\" colspan=\"3\" bgcolor=\"#ffcc00\" height=\"32\" valign=\"middle\">\n<p><span style=\"font-family: Arial,Helvetica,Geneva,Swiss,SunSans-Regular; color: black;\"><strong>See a Otter Cam <a href=\"http://www.mbayaq.org/efc/efc_wao/wao_cam.asp\" target=\"_blank\">Here!</a></strong></span></p>\n</td>\n</tr>\n<tr style=\"text-align: left;\" bgcolor=\"#afffb7\" height=\"31\">\n<td style=\"text-align: center;\" colspan=\"3\" bgcolor=\"#66ffff\" height=\"31\" valign=\"middle\">\n<div style=\"text-align: center;\"><span style=\"font-family: Arial,Helvetica,Geneva,Swiss,SunSans-Regular; color: black;\"><strong>See a Penguin Cam <a href=\"http://www.mbayaq.org/efc/efc_splash/splash_cam.aspx\" target=\"_blank\">Here!</a></strong></span></div>\n</td>\n</tr>\n<tr style=\"text-align: left;\" bgcolor=\"#afffb7\" height=\"40\">\n<td style=\"text-align: center;\" colspan=\"3\" bgcolor=\"#ff9999\" height=\"40\" valign=\"middle\"><br /></td>\n</tr>\n<tr style=\"text-align: left;\" bgcolor=\"#afffb7\" height=\"215\">\n<td style=\"text-align: center;\" colspan=\"3\" bgcolor=\"#66ff99\" height=\"215\" valign=\"middle\">\n<div style=\"text-align: center;\">\n<div style=\"text-align: center;\">\n<div style=\"text-align: center;\">\n<div style=\"text-align: center;\">\n<p><img src=\"../derby/pinego.gif\" border=\"0\" height=\"68\" width=\"231\" /></p>\n<p><span><strong><span style=\"color: #000000;\" class=\"Apple-style-span\">Pinewood Derby Dates, Rules, Etc. will appear in January</span><br /> </strong></span></p>\n<p><a href=\"derby/derbylinks.html\" target=\"_blank\"><span><strong>Pinewood Derby Building Hints, Design Ideas Are All Here!</strong></span></a></p>\n<p><a target=\"_self\" href=\"index.php?option=com_wrapper&amp;view=wrapper&amp;Itemid=79\"><span><strong>2003 - 2011 Car Photos are here!</strong></span></a><span><strong><a href=\"stockade/photoalbum/\" target=\"_blank\"></a></strong></span></p>\n</div>\n</div>\n</div>\n</div>\n</td>\n</tr>\n</tbody>\n</table>\n<div style=\"text-align: left;\" align=\"center\">\n<p> </p>\n</div>\n</center>', '', '1', '90', '0', '108', '2008-06-19 14:27:55', '242', '', '2013-09-21 14:59:15', '242', '0', '0000-00-00 00:00:00', '2008-06-21 08:27:55', '0000-00-00 00:00:00', '', '', '{\"show_title\":0,\"link_titles\":0,\"show_intro\":0,\"show_section\":0,\"link_section\":0,\"show_category\":0,\"link_category\":0,\"show_vote\":\"\",\"show_author\":0,\"show_create_date\":0,\"show_modify_date\":0,\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '39', '0', '7', '', '', '1', '236', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('49', '147', 'QOW #187', 'qow-187', '', '<div align=\"center\"><br />  </div><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"558\" height=\"136\" align=\"center\" style=\"background-color: #ffff66\"> <tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66\"><div align=\"center\"><strong>        The first question of the year!</strong></div><h1 align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#187</strong> <br /></h1>        <div align=\"center\"> <br /></div><div align=\"center\">What is the traditional Wednesday Stockade first snack?</div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question! </a></p>  </td></tr></tbody> </table>', '', '1', '90', '0', '109', '2008-06-19 16:00:22', '242', '', '2013-09-21 15:00:08', '242', '0', '0000-00-00 00:00:00', '2008-09-03 21:00:00', '2008-09-10 21:00:00', '', '', '{\"show_title\":0,\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":0,\"link_section\":\"\",\"show_category\":0,\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '10', '0', '25', '', '', '1', '306', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('50', '148', 'Upgraders', 'upgraders', '', '<p>If you are an experienced Joomla! 1.5 user, this Joomla site will seem very familiar. There are new templates and improved user interfaces, but most functionality is the same. The biggest changes are improved access control (ACL) and nested categories. This release of Joomla has strong continuity with Joomla! 1.7 while adding enhancements.</p>\r\n', '\r\n<p>The new user manager will let you manage who has access to what in your site. You can leave access groups exactly the way you had them in Joomla 1.5 or make them as complicated as you want. You can learn more about<a href=\"http://docs.joomla.org/ACL_Tutorial_for_Joomla_1.6\"> how access control works</a> in on the <a href=\"http://docs.joomla.org\">Joomla! Documentation site</a></p>\r\n<p>In Joomla 1.5 and 1.0 content was organized into sections and categories. From 1.6 forward sections are gone, and you can create categories within categories, going as deep as you want. The sample data provides many examples of the use of nested categories.</p>\r\n<p>All layouts have been redesigned to improve accessibility and flexibility. </p>\r\n<p>Updating your site and extensions when needed is easier than ever thanks to installer improvements.</p>\r\n<p> </p>', '-2', '0', '0', '19', '2011-01-01 00:00:01', '242', '', '2012-01-17 04:28:10', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '5', '0', '6', '', '', '1', '3', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '1', '*', '');

INSERT INTO tkt_content
(`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES 
('51', '149', 'TC layout', 'tc-layout', '', '<center> \n<table border=\"1\" cellpadding=\"8\" cellspacing=\"2\" height=\"378\" width=\"640\">\n<tbody>\n<tr height=\"50\">\n<td colspan=\"2\" bgcolor=\"#ffff33\" height=\"50\" width=\"630\">\n<div style=\"color: #000000;\" align=\"center\">\n<h3><strong><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\">Tree Climbers, for boys aged 6 & 7 and their Dad\'s </span></strong></h3>\n<h3><strong><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\">Parent <a href=\"index.php?option=com_content&view=section&layout=blog&id=8&Itemid=98\">information here</a>.</span></strong></h3>\n</div>\n</td>\n</tr>\n<tr height=\"50\">\n<td colspan=\"2\" bgcolor=\"#33ff99\" height=\"50\" width=\"630\">\n<div align=\"center\">\n<h3></h3>\n<p> </p>\n<p> </p>\n<p><strong><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif; color: #000000;\"><img src=\"images/stories/2047_artwork/splash-screen-rev3-2.gif\" /></span></strong></p>\n<h3></h3>\n<h3><strong><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif; color: #000000;\"><br /></span></strong></h3>\n</div>\n</td>\n</tr>\n<tr height=\"50\">\n<td rowspan=\"2\" align=\"center\" bgcolor=\"#ff3333\" height=\"104\" valign=\"middle\" width=\"232\">\n<div align=\"center\">\n<div align=\"center\">\n<h2><span style=\"font-size: 14pt;\"><b><a href=\"index.php?option=com_wrapper&view=wrapper&Itemid=79\"><span style=\"font-size: x-small;\">Brigade Photo</span></a><a href=\"../stockade/photoalbum/\" target=\"_blank\"><span style=\"font-size: x-small;\">Album is Here</span></a></b></span></h2>\n</div>\n</div>\n</td>\n<td align=\"center\" bgcolor=\"#c8fdfd\" height=\"50\" width=\"394\">\n<div align=\"center\">\n<h4><a href=\"index.php?option=com_wrapper&view=wrapper&Itemid=101\"><span style=\"font-family: Arial;\">Permission & T-shirt slips and other</span></a><span style=\"font-family: Arial;\"> </span></h4>\n<h4><span style=\"font-family: Arial;\"> </span><a href=\"index.php?option=com_wrapper&view=wrapper&Itemid=101\"><span style=\"font-family: Arial;\"> Parent Information available here</span></a></h4>\n</div>\n</td>\n</tr>\n<tr height=\"50\">\n<td align=\"center\" bgcolor=\"#a4fd9f\" height=\"50\" valign=\"middle\" width=\"394\">\n<p><a href=\"index.php?option=com_wrapper&view=wrapper&Itemid=93\" target=\"_blank\"><span style=\"font-family: Arial;\"><strong>Tentative Tree Climber <br /> </strong></span></a><a href=\"index.php?option=com_wrapper&view=wrapper&Itemid=93\" target=\"_blank\"><span style=\"font-family: Arial;\"><strong>Schedule For 2010 - 2011</strong></span></a></p>\n</td>\n</tr>\n<tr height=\"66\">\n<td colspan=\"2\" align=\"center\" bgcolor=\"#ffff33\" height=\"66\" width=\"630\">\n<h2><strong style=\"color: #000000;\"><span style=\"font-family: Arial; font-size: xx-small;\"><span style=\"font-size: x-small;\">75 Games to play in 2047 The Gameroom!</span></span></strong></h2>\n</td>\n</tr>\n<tr>\n<td colspan=\"2\" bgcolor=\"#3399ff\" width=\"630\">\n<div align=\"center\">\n<table border=\"3\" cellpadding=\"0\" cellspacing=\"2\" width=\"636\">\n<tbody>\n<tr height=\"64\">\n<td colspan=\"3\" bgcolor=\"blue\" height=\"64\">\n<div align=\"center\"><a href=\"../stockade/stkphotoalbum.html\" target=\"_blank\"><img src=\"../stockade/newart/photos_rotate.gif\" align=\"middle\" border=\"0\" height=\"50\" width=\"200\" /></a></div>\n</td>\n</tr>\n<tr height=\"64\">\n<td colspan=\"3\" bgcolor=\"#ffa500\" height=\"64\">\n<div align=\"center\">\n<div align=\"center\">\n<div align=\"center\">\n<div align=\"center\">\n<p><span><strong><a href=\"../derby/\" target=\"_blank\">Pinewood Derby Building Hints, Design Ideas</a> <a href=\"../derby/\" target=\"_blank\">Are All Here!</a></strong></span></p>\n<p><span><strong><a href=\"../stockade/photoalbum/\" target=\"_blank\">2003 Car Photos</a> <b><span style=\"color: red;\">- </span></b><a href=\"../stockade/photoalbum/\" target=\"_blank\">2010 Car Photos</a></strong></span></p>\n</div>\n</div>\n</div>\n</div>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</td>\n</tr>\n</tbody>\n</table>\n</center>', '', '1', '91', '0', '113', '2008-06-20 13:10:04', '242', '', '2013-09-21 14:58:35', '242', '0', '0000-00-00 00:00:00', '2008-06-20 18:10:04', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '11', '0', '3', '', '', '1', '1971', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('52', '150', 'Users', 'users-component', '', '<p>The users extension lets your site visitors register, login and logout, change their passwords and other information, and recover lost passwords. In the administrator it allows you to create, block and manage users and create user groups and access levels. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Users_User_Manager\">Help</a></p>\r\n<p>Please note that some of the user views will not display if you are not logged-in to the site.</p>', '', '1', '0', '0', '21', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-01-10 04:52:55', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}', '2', '0', '5', '', '', '1', '1', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('53', '151', 'Using Joomla!', 'using-joomla', '', '<p>With Joomla you can create anything from a simple personal website to a complex ecommerce or social site with millions of visitors.</p>\r\n<p>This section of the sample data provides you with a brief introduction to Joomla concepts and reference material to help you understand how Joomla works.</p>\r\n<p><em>When you no longer need the sample data, you can can simply unpublish the sample data category found within each extension in the site administrator or you may completely delete each item and all of the categories. </em></p>', '', '1', '0', '0', '19', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-12-27 11:52:45', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '2', '0', '7', '', '', '1', '9', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('54', '152', 'About CSB 2047', 'about-2047', '', '<p style=\"color: #ffffff;\" mce_style=\"color: #ffffff;\" align=\"center\"><a href=\"leaders.html\" mce_href=\"leaders.html\" target=\"_blank\"><strong><span style=\"color: #ff0000; font-family: Arial;\" mce_style=\"color: #ff0000; font-family: Arial;\"><span style=\"color: white;\" mce_style=\"color: white;\"><br /> </span></span></strong></a><span style=\"font-family: Arial;\" mce_style=\"font-family: Arial;\"> </span></p>\n<p><span style=\"color: #000000;\" mce_style=\"color: #000000;\"><span style=\"color: white;\" mce_style=\"color: white;\"><strong>Christian Service Brigade #2047</strong> is a boys and teens group from the Wesleyan Church of Orchard Park. Brigade #2047 has been active in Orchard Park for nearly 50 years and is comprised of several parts.</span></span></p>\n<p><span style=\"color: #000000;\" mce_style=\"color: #000000;\"><span style=\"color: white;\" mce_style=\"color: white;\"><br /></span></span></p>\n<p><span style=\"color: #000000;\" mce_style=\"color: #000000;\"><span style=\"color: white;\" mce_style=\"color: white;\"><a href=\"index.php?option=com_content&view=category&id=39:tree-climbers&layout=blog&Itemid=55\" mce_href=\"index.php?option=com_content&view=category&id=39:tree-climbers&layout=blog&Itemid=55\"><strong>Tree Climbers</strong></a><a href=\"option=com_content&view=section&layout=blog&id=7&Itemid=55\" mce_href=\"option=com_content&view=section&layout=blog&id=7&Itemid=55\"><strong> </strong></a>(Wednesdays 7-8:30pm) is a Father/Son group for boys aged 6 - 7.</span></span></p>\n<ul>\n<li><span style=\"color: #000000;\" mce_style=\"color: #000000;\"><span style=\"color: white;\" mce_style=\"color: white;\">Fathers and sons spend time in games, crafts, verse memorizing and story time. </span></span></li>\n<li><span style=\"color: #000000;\" mce_style=\"color: #000000;\"><span style=\"color: white;\" mce_style=\"color: white;\"><br /></span></span></li>\n</ul>\n<p><span style=\"color: #000000;\" mce_style=\"color: #000000;\"><span style=\"color: white;\" mce_style=\"color: white;\"><a href=\"index.php?option=com_content&view=category&id=37:stockade&layout=blog&Itemid=53\" mce_href=\"index.php?option=com_content&view=category&id=37:stockade&layout=blog&Itemid=53\"><strong>Stockade</strong></a><strong> </strong>(Wednesdays 7-8:30pm) is a group for 8 - 12 year old boys</span></span></p>\n<p><span style=\"color: #000000;\" mce_style=\"color: #000000;\"><span style=\"color: white;\" mce_style=\"color: white;\">An active group aimed at the junior age boy.</span></span></p>\n<ul>\n<li><span style=\"color: #000000;\" mce_style=\"color: #000000;\"><span style=\"color: white;\" mce_style=\"color: white;\">Boys have a structured and organized meeting time of games, post time (small groups), crafts, special events and story circle.</span></span></li>\n<li><span style=\"color: #000000;\" mce_style=\"color: #000000;\"><span style=\"color: white;\" mce_style=\"color: white;\"><br /></span></span></li>\n<li><span style=\"color: #000000;\" mce_style=\"color: #000000;\"><span style=\"color: white;\" mce_style=\"color: white;\">Stockade also takes part in many extra activities which include, overnights, game nights, camping trips, pinewood derby, reptile night, <a href=\"http://www.camphickoryhill.org\" mce_href=\"http://www.camphickoryhill.org\" target=\"_blank\">Summer Camp</a> and others! </span></span></li>\n<li><span style=\"color: #000000;\" mce_style=\"color: #000000;\"><span style=\"color: white;\" mce_style=\"color: white;\"><br /></span></span></li>\n</ul>\n<p><span style=\"color: #000000;\" mce_style=\"color: #000000;\"><span style=\"color: white;\" mce_style=\"color: white;\"><a href=\"index.php?option=com_content&view=category&id=44:battalion&layout=blog&Itemid=54\" mce_href=\"index.php?option=com_content&view=category&id=44:battalion&layout=blog&Itemid=54\"><strong>Battalion</strong></a><strong> </strong>(Mondays 7-8:30pm) is a group for young men aged 12 - 14.</span></span></p>\n<ul>\n<li><span style=\"color: #000000;\" mce_style=\"color: #000000;\"><span style=\"color: white;\" mce_style=\"color: white;\">A group whose purpose is to build leadership capabilities in today\'s teen. </span></span></li>\n<li><span style=\"color: #000000;\" mce_style=\"color: #000000;\"><span style=\"color: white;\" mce_style=\"color: white;\"><br /></span></span></li>\n<li><span style=\"color: #000000;\" mce_style=\"color: #000000;\"><span style=\"color: white;\" mce_style=\"color: white;\">An organized and structured weekly meeting where teens are given leadership responsibilities. </span></span></li>\n<li><span style=\"color: #000000;\" mce_style=\"color: #000000;\"><span style=\"color: white;\" mce_style=\"color: white;\">Games, Squad Meeting (small groups), Captain\'s Special and Council Ring make up the weekly meeting. </span></span></li>\n<li><span style=\"color: #000000;\" mce_style=\"color: #000000;\"><span style=\"color: white;\" mce_style=\"color: white;\">Special activities consist of overnights, camping, canoe trips, rocket cars to name a few. In the past Battalion has also made their own wood strip canoes for our yearly canoe trips.</span></span></li>\n<li><span style=\"color: #000000;\" mce_style=\"color: #000000;\"><span style=\"color: white;\" mce_style=\"color: white;\"><br /></span></span></li>\n</ul>\n<div align=\"center\"><span style=\"color: white;\" mce_style=\"color: white;\"><a href=\"leaders.html\" mce_href=\"leaders.html\" target=\"_blank\"><strong><span style=\"color: #ff0000; font-family: Arial;\" mce_style=\"color: #ff0000; font-family: Arial;\">|</span></strong></a><a href=\"index.php?option=com_content&view=article&id=177&Itemid=102\" mce_href=\"index.php?option=com_content&view=article&id=177&Itemid=102\"><strong><span style=\"color: #ff0000; font-family: Arial;\" mce_style=\"color: #ff0000; font-family: Arial;\"> </span></strong></a><span style=\"font-family: Arial;\" mce_style=\"font-family: Arial;\"><a href=\"index.php?option=com_content&view=article&id=177&Itemid=102\" mce_href=\"index.php?option=com_content&view=article&id=177&Itemid=102\">About the Leaders</a> </span><strong><span style=\"color: #ff0000; font-family: Arial;\" mce_style=\"color: #ff0000; font-family: Arial;\">|</span></strong></span></div>\n<div align=\"center\"><span style=\"color: white;\" mce_style=\"color: white;\"><strong><span style=\"color: #ff0000; font-family: Arial;\" mce_style=\"color: #ff0000; font-family: Arial;\"><br /></span></strong></span></div>\n<p><span style=\"color: #000000;\" mce_style=\"color: #000000;\"><span style=\"color: white;\" mce_style=\"color: white;\"><strong>Christian Service Brigade #2047 </strong>is one 40+ Brigade Units in our region.<strong> </strong><a href=\"http://www.csbministries.org/\" mce_href=\"http://www.csbministries.org/\">Christian Service Brigade</a> was founded in 1936 and since then has grown to have units throughout the USA and Canada as well as related organizations worlwide.</span></span></p>\n<p><span style=\"color: #000000;\" mce_style=\"color: #000000;\"><span style=\"color: white;\" mce_style=\"color: white;\"><br /></span></span></p>\n<p><span style=\"color: #000000;\" mce_style=\"color: #000000;\"><span style=\"color: white;\" mce_style=\"color: white;\">Our Tree Climbers, Stockade and Battalion are outreach ministries from the Wesleyan Church of Orchard Park. In Brigade we believe and teach basic Christian beliefs. Boys attending Brigade <strong><span style=\"text-decoration: underline;\">do not</span></strong> have to be attenders of this church or any other. Nearly 75% of the boys who attend our group come from outside of our church with nearly half attending local Catholic Churches, Lutheran, Presbyterian and others in Orchard Park, Hamburg and East Aurora. The Wesleyan Church of Orchard Park was founded nearly 110 years ago. Click to learn more about the <a href=\"http://www.opwc.org\" mce_href=\"http://www.opwc.org\" target=\"_blank\">Wesleyan Church of Orchard Park</a> . </span></span></p>\n<p><span style=\"color: #000000;\" mce_style=\"color: #000000;\"><span style=\"color: white;\" mce_style=\"color: white;\"><br /></span></span></p>\n<p><span style=\"color: #000000;\" mce_style=\"color: #000000;\"><span style=\"color: white;\" mce_style=\"color: white;\">Besides the weekly meetings, CSB also offers boy\'s and teen\'s various experiences through Camps which are located in the USA and Canada. Our regional camp is <a href=\"http://www.camphickoryhill.org\" mce_href=\"http://www.camphickoryhill.org\" target=\"_blank\">Camp Hickory Hill</a> in Varysburg, NY.</span></span></p>\n<p><span style=\"color: #000000;\" mce_style=\"color: #000000;\"><span style=\"color: white;\" mce_style=\"color: white;\">If you have any questions on Christian Service Brigade #2047 <a href=\"mailto:jim@2047.org\" mce_href=\"mailto:jim@2047.org\">email here</a>.</span></span></p>', '', '1', '78', '0', '81', '2008-06-21 15:39:19', '242', '', '2013-09-21 14:52:08', '242', '242', '2013-09-22 02:44:53', '2008-06-21 15:39:19', '0000-00-00 00:00:00', '', '', '{\"show_title\":0,\"link_titles\":0,\"show_intro\":0,\"show_section\":0,\"link_section\":0,\"show_category\":0,\"link_category\":\"\",\"show_vote\":0,\"show_author\":0,\"show_create_date\":0,\"show_modify_date\":\"\",\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '21', '0', '2', '', '', '1', '1565', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('55', '153', 'Battalion', 'battalion', '', '<h2 align=\"center\"><span style=\"font-family: Tahoma, Helvetica, Arial, sans-serif; font-size: small; \"><span class=\"Apple-style-span\" style=\"font-size: 12px;\" mce_style=\"font-size: 12px;\"><span style=\"font-family: Arial, Helvetica, sans-serif; font-size: medium; \"><span class=\"Apple-style-span\" style=\"font-size: 14px;\" mce_style=\"font-size: 14px;\"><br /></span></span></span></span></h2><h2 align=\"center\"><b>Battalion begins on<br />Monday, September 20th @ 7pm!</b></h2><p align=\"center\"><strong> Registration Forms will be available here soon.</strong></p><p align=\"center\"><br /></p><p align=\"center\"><strong>Check out some of the things that have happened at Battalion:</strong></p><div align=\"center\">   		</div><table border=\"1\" width=\"400\" align=\"center\"> 			<tbody><tr> 				<th width=\"160\" scope=\"col\">Video segments</th> 				<th width=\"67\" scope=\"col\">link</th> 			</tr> 			<tr> 				<td>Jim\'s Overnight 2003</td> 				<td>  <a href=\"battalion/video/document_Kingsley.swf\" mce_href=\"battalion/video/document_Kingsley.swf\" target=\"_blank\">Play</a></td> 			</tr> 			<tr> 				<td>Winter Camp-O-Rama 2003</td> 				<td>  <a href=\"battalion/video/document_Winter_Camp.swf\" mce_href=\"battalion/video/document_Winter_Camp.swf\" target=\"_blank\">Play</a></td> 			</tr> 			<tr> 				<td height=\"25\">Canoe Trip 2004</td> 				<td>  <a href=\"battalion/video/Battalion_Canoe_2004_short.swf\" mce_href=\"battalion/video/Battalion_Canoe_2004_short.swf\" target=\"_blank\">Play</a></td> 			</tr> 			<tr> 				<td height=\"25\">Canoe Trip 2007 </td> 				<td><a href=\"Battalion_Canoe_2007.wmv\" mce_href=\"Battalion_Canoe_2007.wmv\"> </a>  <a href=\"battalion/video/Battalion_Canoe_2007.wmv\" mce_href=\"battalion/video/Battalion_Canoe_2007.wmv\" target=\"_blank\">Play</a></td> 			</tr> 		</tbody></table><div align=\"center\"> 		</div><div align=\"center\"> 		</div><div align=\"center\"> 		</div><p><br /></p><p><br /></p><div align=\"center\"> 		</div><div align=\"center\"> 		</div><table border=\"1\" width=\"283\" align=\"center\"> 			<tbody><tr> 				<th width=\"160\" scope=\"col\">Photo segments</th> 				<th width=\"225\" scope=\"col\">link</th> 			</tr> 			<tr> 				<td width=\"160\">Canoe Trip - 2003</td> 				<td width=\"225\">  <a href=\"battalion/Photos/Canoe_2003.swf\" mce_href=\"battalion/Photos/Canoe_2003.swf\" target=\"_blank\">Go</a></td> 			</tr> 			<tr> 				<td width=\"160\">Winter Camp-O-Rama 2004</td> 				<td width=\"225\">  <a href=\"battalion/Photos/Winter_Camp_2004.swf\" mce_href=\"battalion/Photos/Winter_Camp_2004.swf\" target=\"_blank\">Go</a></td> 			</tr> 			<tr> 				<td width=\"160\">Jim Struebel Overnight - 2003</td> 				<td width=\"225\">  <a href=\"battalion/Photos/Jim_Struebel_Overnight_2003.swf\" mce_href=\"battalion/Photos/Jim_Struebel_Overnight_2003.swf\" target=\"_blank\">Go</a></td> 			</tr> 			<tr> 				<td width=\"160\">Canoe Trip - 2004</td> 				<td width=\"225\">  <a href=\"battalion/Photos/Canoe_2004/Canoe_2004.htm\" mce_href=\"battalion/Photos/Canoe_2004/Canoe_2004.htm\" target=\"_blank\">Go</a></td> 			</tr> 			<tr> 				<td width=\"160\">Winter Camp - 2005</td> 				<td width=\"225\">  <a href=\"battalion/Photos/Winter_Camp_2005/Winter_Camp_2005.htm\" mce_href=\"battalion/Photos/Winter_Camp_2005/Winter_Camp_2005.htm\" target=\"_blank\">Go</a></td> 			</tr> 			<tr> 				<td width=\"160\">Spring Camp - 2006</td> 				<td width=\"225\">  <a href=\"battalion/Photos/Spring_Camp_2006/Spring_Camp_2006.htm\" mce_href=\"battalion/Photos/Spring_Camp_2006/Spring_Camp_2006.htm\" target=\"_blank\">Go</a></td> 			</tr> 		</tbody></table>', '', '1', '79', '0', '83', '2008-06-22 13:43:34', '242', '', '2013-09-21 14:52:08', '242', '0', '0000-00-00 00:00:00', '2008-06-22 13:43:34', '0000-00-00 00:00:00', '', '', '{\"show_title\":0,\"link_titles\":0,\"show_intro\":0,\"show_section\":0,\"link_section\":0,\"show_category\":0,\"link_category\":0,\"show_vote\":0,\"show_author\":0,\"show_create_date\":0,\"show_modify_date\":0,\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '9', '0', '7', '', '', '1', '403', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('56', '154', 'Who\'s Online', 'whos-online', '', '<p>The Who\'s Online Module displays the number of Anonymous Users (e.g. Guests) and Registered Users (ones logged-in) that are currently accessing the Web site. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Who_Online\" title=\"Who\'s Online\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule whosonline,Who\'s Online}</div>', '', '1', '0', '0', '65', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-09-17 22:19:45', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}', '4', '0', '1', '', '', '1', '5', '', '0', '*', ''),
('57', '155', 'Wed Stockade Leader Schedule', 'wed-stockade-leader-schedule', '', '<center>\n<h2><strong><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif; color: #ffff00;\">Wednesday Stockade Schedule</span></strong></h2>\n<p><strong><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><br /></span></strong></p>\n<p>If you are scheduled for an activity and can\'t make it - contact someone else <br /> to fill in for you from the <a href=\"index.php?option=com_content&view=section&layout=blog&id=11&Itemid=62\">leader contact page</a> or contact <a href=\"mailto:jim@2047.org\">Jim</a>.</p>\n<p> </p>\n</center><center> If the letter does not show up, use this link </center><center><a target=\"_blank\" href=\"../stk_ldr_schedules/wed_leader_rotation.pdf\">http://www.2047.org/stk_ldr_schedules/wed_leader_rotation.pdf </a></center><center><br /></center><center>{pdf=http://www.2047.org/stk_ldr_schedules/wed_leader_rotation.pdf|600|1200}</center>', '', '1', '97', '0', '119', '2008-06-23 14:25:03', '242', '', '2013-09-21 15:00:08', '242', '0', '0000-00-00 00:00:00', '2008-06-25 23:25:03', '0000-00-00 00:00:00', '', '', '{\"show_title\":0,\"link_titles\":0,\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '24', '0', '1', '', '', '1', '300', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('58', '156', 'Wonderful Watermelon', 'wonderful-watermelon', '', '<p>Watermelon is a wonderful and healthy treat. We grow the world\'s sweetest watermelon. We have the largest watermelon patch in our country.</p>', '', '1', '0', '0', '30', '2011-01-01 00:00:01', '242', 'Fruit Shop Webmaster', '2011-01-01 00:00:01', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}', '1', '0', '1', '', '', '1', '0', '', '0', '*', ''),
('59', '157', 'Wrapper Module', 'wrapper-module', '', '<p>This module shows an iFrame window to specified location. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Wrapper\" title=\"Wrapper Module\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule wrapper,Wrapper}</div>', '', '1', '0', '0', '67', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-09-17 22:35:00', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}', '8', '0', '1', '', '', '1', '15', '', '0', '*', ''),
('60', '158', 'Stockade Begins', 'stockade-begins', '', '<center> \n<table cellspacing=\"1\" cellpadding=\"10\" border=\"2\" align=\"center\" style=\"border: 2px solid #000000; background-color: #ffff33; height: 200px; width: 622px;\">\n<tbody>\n<tr align=\"center\" valign=\"middle\">\n<td>\n<h2 align=\"center\"></h2>\n<h2 align=\"center\"><span style=\"font-size: 18pt;\"><span style=\"font-family: verdana,geneva; color: #ff0000;\">Stockade Begins THIS WEEK!<br /></span></span></h2>\n<h2 align=\"center\" dir=\"ltr\"></h2>\n<h2 align=\"center\" dir=\"ltr\"></h2>\n<h2 align=\"center\" dir=\"ltr\"><span style=\"font-size: 18pt;\"><span style=\"font-family: verdana,geneva; color: #ff0000;\"><br />Tuesday Stockade, September 10th @ 7pm</span></span></h2>\n<p><span style=\"font-size: 18pt;\"><span style=\"font-family: verdana,geneva; color: #ff0000;\"><br /></span></span></p>\n<h2 align=\"center\" dir=\"ltr\"><span style=\"font-size: 18pt;\"><span style=\"font-family: verdana,geneva; color: #ff0000;\">Wednesday, September 11th @ 7pm </span></span></h2>\n<p><span style=\"font-size: 18pt;\"><span style=\"font-family: verdana,geneva; color: #ff0000;\"><br /></span></span></p>\n<p><span style=\"font-size: 18pt;\"><span style=\"font-family: verdana,geneva; color: #ff0000;\"><span style=\"font-size: 14pt;\">any questions, contact Jim 662-0335 or <a href=\"mailto:jim@2047.org\">email</a></span></span></span></p>\n<p><span style=\"font-size: 18pt;\"><span style=\"font-family: verdana,geneva; color: #ff0000;\"><span style=\"font-size: 14pt;\"><br /></span></span></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</center>', '', '1', '90', '0', '108', '2013-09-10 05:00:00', '242', '', '2013-09-21 14:59:15', '242', '0', '0000-00-00 00:00:00', '2013-09-10 05:00:00', '2013-09-12 14:00:00', '', '', '{\"show_title\":0,\"link_titles\":0,\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":0,\"show_category\":0,\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '12', '0', '9', '', '', '1', '699', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('61', '159', 'Breadcrumbs Module', 'breadcrumbs-module', '', '<p>Breadcrumbs provide a pathway for users to navigate through the site. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Breadcrumbs\" title=\"Breacrumbs Module\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule breadcrumbs,breadcrumbs}</div>', '', '1', '0', '0', '75', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-09-17 22:10:19', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}', '5', '0', '2', '', '', '1', '9', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('62', '160', 'Balloon Map 08', 'balloon-map-08', '', '<div align=\"center\"><table border=\"1\" cellspacing=\"1\" cellpadding=\"4\" width=\"600\" align=\"center\" style=\"background-color: #8cffc5\"><tbody><tr align=\"center\" valign=\"middle\"><td align=\"center\" valign=\"middle\"><div align=\"center\"><h3><font color=\"#000000\"><strong>Stockade Balloon Launch!</strong></font></h3></div><div align=\"center\"> </div><div align=\"center\"><a href=\"http://www.mapservices.org/myguestmap/map/jimsz\" target=\"_blank\">Did you find a Balloon from our group &<br /></a></div> <p align=\"center\"><a href=\"http://www.mapservices.org/myguestmap/map/jimsz\" target=\"_blank\">Where are the Balloons being found?</a></p><p align=\"center\"><strong><font color=\"#000000\">or you can <a href=\"mailto:jim@2047.org\">Email Jim </a></font></strong></p><p align=\"center\">&nbsp;</p></td></tr></tbody></table></div><p align=\"center\">&nbsp;</p>', '', '1', '90', '0', '108', '2008-09-10 05:00:00', '242', '', '2013-09-21 14:59:15', '242', '0', '0000-00-00 00:00:00', '2008-09-10 21:30:00', '2008-11-20 04:00:00', '', '', '{\"show_title\":0,\"link_titles\":0,\"show_intro\":0,\"show_section\":0,\"link_section\":0,\"show_category\":0,\"link_category\":0,\"show_vote\":0,\"show_author\":0,\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '9', '0', '9', '', '', '1', '371', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('64', '162', 'QOW #189', 'qow-189', '', '<div align=\"center\"><br />  </div><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" height=\"143\" align=\"center\" style=\"background-color: #ffff66\"> <tbody><tr><td valign=\"middle\" style=\"background-color: #ffff66; border-width: 1px; border-color: #cccc99; border-style: solid\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#189</strong> </div>        <div align=\"center\"> <br /></div><div align=\"center\">What are the first names of all of the new Junior Leaders?</div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question! </a></p>  </td></tr></tbody> </table>', '', '1', '90', '0', '109', '2008-09-10 05:00:00', '242', '', '2013-09-21 15:00:08', '242', '0', '0000-00-00 00:00:00', '2008-09-18 00:00:00', '2008-09-24 21:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '4', '0', '22', '', '', '1', '614', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('266', '463', 'QOW #266 Wednesday', 'qow-266-wednesday', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p> </p>\n<table style=\"background-color: #ffff66; width: 600px; height: 300px;\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\" height=\"277\" width=\"600\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px; color: #fc1102; background-color: #ffff66; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<br /><br />\n<h2 style=\"text-align: center;\">Wednesday Question of the Week</h2>\n<p> </p>\n<p> </p>\n<h1 style=\"text-align: center;\"><img src=\"../stockade/newart/QOW_animated.gif\" alt=\" \" height=\"55\" width=\"150\" /><strong>#266</strong></h1>\n<p> </p>\n<p><strong><br /></strong></p>\n<div style=\"text-align: center;\">\n<p><span style=\"font-size: medium; color: #000000;\"><span style=\"font-size: 16px;\"> </span></span><b>What baseball team does A-Rod play for?<br /></b></p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><a href=\"stockade/qownewest.html\" target=\"_blank\"><br /></a><span style=\"font-size: 10pt;\"><strong><a href=\"stockade/qownewest.html\" target=\"_blank\">Click Here to answer the Question!</a></strong></span></p>\n<h2 style=\"font-size: 1.3em; color: #000000; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\"></h2>\n<p style=\"text-align: center;\"><span style=\"font-size: small;\"><span style=\"font-size: 13px;\"><b><span style=\"font-size: large;\"><span style=\"font-size: 18px; font-weight: normal;\"><br /></span></span></b></span></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '2', '90', '0', '109', '2011-03-31 01:15:00', '242', '', '2011-04-01 02:45:49', '242', '0', '0000-00-00 00:00:00', '2011-03-30 20:30:00', '2011-04-06 21:49:59', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '23', '', '', '1', '8', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('65', '163', 'QOW #190', 'qow-190', '', '<div align=\"center\"><br />  </div><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" height=\"143\" align=\"center\" style=\"background-color: #ffff66\"> <tbody><tr><td valign=\"middle\" style=\"background-color: #ffff66; border-width: 1px; border-color: #cccc99; border-style: solid\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#190</strong> </div>        <div align=\"center\"> <br /></div><div align=\"center\">Who does Fred Flintstone work for?</div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question! </a></p>  </td></tr></tbody> </table>', '', '1', '90', '0', '109', '2008-09-10 05:00:00', '242', '', '2013-09-21 15:00:08', '242', '0', '0000-00-00 00:00:00', '2008-09-25 00:00:00', '2008-09-30 21:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":0,\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '5', '0', '23', '', '', '1', '418', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('66', '165', 'Latest Users Module', 'latest-users-module', '', '<p>This module displays the latest registered users. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Latest_Users\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule users_latest,Users Latest}</div>', '', '1', '0', '0', '65', '2011-01-01 00:00:01', '242', 'Joomla!', '2011-09-17 22:21:05', '42', '0', '0000-00-00 00:00:00', '2011-01-01 00:00:01', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"1\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"1\",\"link_category\":\"1\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}', '4', '0', '3', '', '', '1', '6', '', '0', '*', ''),
('67', '168', 'GAME NIGHT', 'game-night', '', '<table style=\"background-color: #f2f20c; height: 150px; width: 600px;\" align=\"center\" background=\"http://www.2047.org/stockade/newart/grn_new_grad.gif\" border=\"0\">\n<tbody>\n<tr>\n<td style=\"font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px; font-style: normal;\" valign=\"middle\">\n<h1 style=\"text-align: center;\"><span style=\"font-size: 12px; font-weight: normal;\" class=\"Apple-style-span\"><img style=\"margin-top: 15px; margin-bottom: 15px;\" src=\"images/stories/wheel.gif\" /></span></h1>\n<h1 style=\"text-align: center;\"><span style=\"font-size: 14pt;\"><span style=\"color: #33cccc;\"><span style=\"font-weight: normal;\" class=\"Apple-style-span\"><span style=\"color: #ff0000; font-weight: bold;\" class=\"Apple-style-span\">STOCKADE GAME NIGHT!<br /> <span class=\"Apple-style-span\"><br />This Week!</span></span></span></span></span></h1>\n<h3 style=\"text-align: center;\"><span style=\"font-size: 14pt;\"><span style=\"color: #1e10ff;\"><br />7:00 - 8:30 pm</span></span></h3>\n<h3 style=\"text-align: center;\"><span style=\"color: #000000;\"><span style=\"font-size: 12px; font-weight: normal;\" class=\"Apple-style-span\"><span style=\"color: #666666;\" class=\"Apple-style-span\"><span style=\"color: #000000;\">any questions call Jim at 662-0335<br /></span> </span></span></span></h3>\n</td>\n</tr>\n</tbody>\n</table>', '', '2', '90', '0', '110', '2011-11-21 05:00:00', '242', '', '2013-09-21 14:58:35', '242', '0', '0000-00-00 00:00:00', '2011-11-21 05:00:00', '2011-11-25 05:00:00', '', '', '{\"show_title\":0,\"link_titles\":0,\"show_intro\":\"\",\"show_section\":0,\"link_section\":0,\"show_category\":0,\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '17', '0', '41', '', '', '1', '258', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('207', '274', 'Wheel Game Night', 'wheel-game-night', '', '<div align=\"center\">\n<table border=\"1\" cellpadding=\"0\" cellspacing=\"2\" width=\"528\">\n<tbody>\n<tr>\n<td bgcolor=\"#ffff33\">\n<p> </p>\n<p> </p>\n<h2 style=\"text-align: center;\"><span style=\"color: #ff0000;\">Stockade Special Spin the Wheel Game Night!</span></h2>\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"><span style=\"color: black;\">November 20th - Tuesday Stockade</span></h2>\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"><span style=\"color: black;\">November 21st - Wednesday Stockade</span></h2>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><img src=\"images/stories/wheel.gif\" /></p>\n<p style=\"text-align: center;\"> </p>\n<h2 style=\"text-align: center;\"><span style=\"color: black;\">Normal Stockade times</span><span style=\"color: black;\"> 7 - 8:30pm<br /><br /></span></h2>\n<p> </p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>', '', '1', '90', '0', '110', '2012-11-15 05:00:00', '242', '', '2012-11-13 18:01:19', '242', '0', '0000-00-00 00:00:00', '2012-11-15 05:00:00', '2012-11-23 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '7', '0', '42', '', '', '1', '30', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('68', '170', 'Captcha', 'captcha', '', '<p>The Captcha plugins are used to prevent spam submissions on your forms such as registration, contact and login. You basic installation of Joomla includes one Captcha plugin which leverages the ReCaptcha® service but you may install other plugins connecting to different Captcha systems.</p>\r\n<p>Default on:</p>\r\n<ul>\r\n<li>ReCaptcha <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit\">help</a></li>\r\n</ul>\r\n<p>Note: ReCaptcha is a the trademark of Google Inc. and is an independent product not associated with or endorsed by the Joomla Project. You will need to register and agree to the Terms of Service at Recaptcha.net to use this plugin. Complete instructions are available if you edit the ReCaptcha plugin in the Plugin Manager.</p>', '', '1', '0', '0', '25', '2012-01-17 03:20:45', '242', 'Joomla!', '2012-01-17 03:35:46', '42', '0', '0000-00-00 00:00:00', '2012-01-17 03:20:45', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '2', '0', '1', '', '', '1', '0', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', ''),
('69', '171', 'QOW #191', 'qow-191', '', '<div align=\"center\"><br />  </div><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" height=\"143\" align=\"center\" style=\"background-color: #ffff66\"> <tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#191</strong> </div>        <div align=\"center\"> <br /></div><div align=\"center\">What creature is found in the Bible verse<br />Mark 9:48?<br /></div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question! </a></p>  </td></tr></tbody> </table>', '', '1', '90', '0', '109', '2008-10-01 22:30:35', '242', '', '2013-09-21 15:00:08', '242', '0', '0000-00-00 00:00:00', '2008-10-02 01:00:00', '2008-10-08 23:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '20', '', '', '1', '622', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('63', '462', 'QOW #188', 'qow-188', '', '<div align=\"center\"><br />  </div><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" height=\"143\" align=\"center\" style=\"background-color: #ffff66\"> <tbody><tr><td valign=\"middle\" style=\"background-color: #ffff66; border-width: 1px; border-color: #cccc99; border-style: solid\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#188</strong> <br /></div>        <div align=\"center\"> <br /></div><div align=\"center\">What creature has the largest eyes in the world?</div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question! </a></p>  </td></tr></tbody> </table>', '', '0', '90', '0', '109', '2008-09-10 13:19:26', '242', '', '2008-09-17 20:49:09', '242', '0', '0000-00-00 00:00:00', '2008-09-10 21:30:00', '2008-09-17 21:00:00', '', '', '{\"show_title\":0,\"link_titles\":0,\"show_intro\":\"\",\"show_section\":0,\"link_section\":\"\",\"show_category\":0,\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '8', '0', '21', '', '', '1', '343', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('70', '172', 'QOW #192', 'qow-192', '', '<div align=\"center\"><br />  </div><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" height=\"143\" align=\"center\" style=\"background-color: #ffff66\"> <tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#192</strong> </div>        <div align=\"center\"> <br /></div><div align=\"center\">What is the name of this animal?<br /><br /></div><div align=\"center\"><img src=\"images/stories/qow192.jpg\" border=\"0\" width=\"220\" height=\"166\" /> <br /></div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question! </a></p>  </td></tr></tbody> </table><div align=\"center\"><br /></div>', '', '1', '90', '0', '109', '2008-10-08 15:15:24', '242', '', '2013-09-21 15:00:08', '242', '0', '0000-00-00 00:00:00', '2008-10-09 01:00:00', '2008-10-15 23:00:00', '', '', '{\"show_title\":0,\"link_titles\":0,\"show_intro\":\"\",\"show_section\":0,\"link_section\":0,\"show_category\":0,\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '19', '', '', '1', '706', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('322', '189', 'Alumni landing page', 'alumni-landing-page', '', '<div style=\"color: #000000;\" align=\"center\">\n<table border=\"0\" cellspacing=\"2\" cellpadding=\"0\" align=\"center\" style=\"width: 500px; height: 883px;\">\n<tbody>\n<tr align=\"center\" valign=\"middle\">\n<td align=\"center\" valign=\"top\">\n<div align=\"center\">\n<p><img src=\"../anniversary/logo-50th.gif\" width=\"250\" height=\"250\" /></p>\n<h2><span style=\"font-size: xx-small;\"><b>Join us to celebrate the 50th Anniversary of</b></span></h2>\n<h2><span style=\"font-size: xx-small;\"><b>Christian Service Brigade #2047</b></span></h2>\n<hr size=\"3\" width=\"300\" />\n<h2><span class=\"Apple-style-span\" style=\"font-size: xx-small;\"><b><i>Everyone -</i></b><i> </i><em><strong>Brigade Sunday</strong></em></span></h2>\n<p><span style=\"font-size: xx-small;\"> Wesleyan Church of Orchard Park</span></p>\n<p><span style=\"font-size: xx-small;\"> 11:15 Service</span></p>\n<p><span style=\"font-size: xx-small;\">Sunday April 14, 2013</span></p>\n<hr size=\"4\" width=\"300\" />\n<h2><span style=\"font-size: xx-small;\"><b><i>Adult Leaders Brunch (by Invitation Only)</i></b></span></h2>\n<p><span style=\"font-size: xx-small;\">Sunday April 14, 2013</span></p>\n<p><span style=\"font-size: xx-small;\">1pm in the Gymnsium</span></p>\n</div>\n</td>\n</tr>\n</tbody>\n</table>\n</div>', '', '1', '0', '0', '9', '2011-12-03 14:08:17', '242', '', '2013-03-23 03:51:29', '242', '0', '0000-00-00 00:00:00', '2013-03-23 14:08:00', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '8', '0', '1', '', '', '1', '782', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('177', '190', 'Leader Biographies', 'leader-biographies', '', '<p style=\"text-align: center;\"><span style=\"font-size: 12pt;\"><strong>Leader\'s of Christian Service Brigade #2047</strong></span><br /><span style=\"font-size: 12pt;\"><strong>from the Wesleyan Church of Orchard Park</strong></span></p>\n<p> </p>\n<p>Leader\'s in CSB #2047 undergo certification training on a regular basis. References are available for the group by contacting the office. It is our belief that if you are sending your boy to our group you have the right and responsibility to know about the group and it\'s leaders. CSB #2047 has an \"open door\" policy and parent\'s are invited to drop in at anytime.</p>\n<p> </p>\n<p> </p>\n<br /> \n<table style=\"width: 456px; height: 1706px;\" align=\"center\" border=\"0\" cellpadding=\"5\" cellspacing=\"0\">\n<tbody>\n<tr>\n<td height=\"234\" valign=\"TOP\" width=\"5%\"><br /></td>\n<td height=\"234\" valign=\"TOP\" width=\"14%\"><img src=\"leaderphotos/jimsz.gif\" naturalsizeflag=\"3\" height=\"87\" width=\"72\" align=\"BOTTOM\" border=\"1\" /></td>\n<td style=\"color: #ffffff;\" height=\"234\" valign=\"TOP\" width=\"57%\">\n<p style=\"text-align: left;\"><b>Jim Szczodrowski<span style=\"font-family: Arial;\"> </span></b><span style=\"font-family: Arial;\">is the Chairman of CSB #2047 and is the Chairman of the Brigade ministry at Orchard Park Wesleyan Church. He\'s also the Chief Ranger of Tuesday and Wednesday Stockade, oversee\'s Tree Climbers and assists with Battalion. </span></p>\n<p style=\"text-align: left;\"> </p>\n<p style=\"text-align: left;\"><span style=\"font-family: Arial;\">A  leader in Brigade since 1979 with several years spent running a Stockade in the Hell\'s Kitchen district of New York City.</span></p>\n<p style=\"text-align: left;\"><span style=\"font-family: Arial;\"><br /></span></p>\n<p><span style=\"font-family: Arial;\">Jim is also a Brigade Staff Associate and assists the Brigade representative and Brigade National with regional responsibilities. </span></p>\n<p> </p>\n<p><span style=\"font-family: Arial;\">Additionally Jim has served on a national committee to update and create new Stockade curriculum.</span></p>\n<p><span style=\"font-family: Arial;\"><br /></span></p>\n<p><span style=\"font-family: Arial;\">Jim is employed as a Computer Graphic Artist for a local company and is a <a href=\"http://www.kidstimestudio.com/\">professional illustrator</a>.</span></p>\n<p><span style=\"font-family: Arial;\"><br /></span></p>\n<p><span style=\"font-family: Arial;\">Jim has lived in Orchard Park for most of his life.</span></p>\n</td>\n</tr>\n<tr>\n<td height=\"28\" valign=\"TOP\" width=\"5%\"><br /></td>\n<td height=\"28\" valign=\"TOP\" width=\"14%\"> </td>\n<td height=\"28\" valign=\"TOP\" width=\"57%\"><br /></td>\n</tr>\n<tr>\n<td height=\"156\" valign=\"TOP\" width=\"5%\"><br /></td>\n<td height=\"156\" valign=\"TOP\" width=\"14%\"><img src=\"leaderphotos/kingsley.jpg\" naturalsizeflag=\"3\" height=\"96\" width=\"72\" align=\"BOTTOM\" border=\"1\" /></td>\n<td style=\"color: #ffffff;\" height=\"156\" valign=\"TOP\" width=\"57%\">\n<p><strong>Ray Seldon</strong> is the Battalion Captain.</p>\n<p> </p>\n<p>Ray has been a  leader in our Brigade since 2007 and has extensive background in Brigade  via Summer Camp as well as being active in various groups in the past.</p>\n<p><br />Ray has been a Pastor for over 10 years and is currently the Youth Pastor at the Wesleyan Church of Orchard Park.</p>\n<p> </p>\n<br /></td>\n</tr>\n<tr>\n<td colspan=\"3\" height=\"28\" valign=\"TOP\"><br /></td>\n</tr>\n<tr>\n<td height=\"28\" valign=\"TOP\" width=\"5%\"><br /></td>\n<td height=\"28\" valign=\"TOP\" width=\"14%\"><br /></td>\n<td height=\"28\" valign=\"TOP\" width=\"57%\"><br /></td>\n</tr>\n<tr>\n<td height=\"28\" valign=\"TOP\" width=\"5%\"><br /></td>\n<td height=\"28\" valign=\"TOP\" width=\"14%\"><br /></td>\n<td height=\"28\" valign=\"TOP\" width=\"57%\"><br /></td>\n</tr>\n<tr>\n<td height=\"123\" valign=\"TOP\" width=\"5%\"><br /></td>\n<td height=\"123\" valign=\"TOP\" width=\"14%\"><img src=\"leaderphotos/doug.jpg\" naturalsizeflag=\"0\" height=\"96\" width=\"72\" align=\"BOTTOM\" border=\"1\" /></td>\n<td style=\"color: #ffffff;\" height=\"123\" valign=\"TOP\" width=\"57%\">\n<p><b>Kingsley Haas</b> is currently a Battalion Lieutenant has been a leader in the Brigade program since 1988. He was the Battalion Captain for 15 years.</p>\n<p><br /> Kingsley is from the Orchard Park area and has attended the<br /> Orchard Park Wesleyan Church all his life.</p>\n<p> </p>\n<p>Kingsley is married and he and his wife Linda with their three children currently live in Clarence.</p>\n<p> </p>\n<p>Kingsley is an Information Technology Analyst for a local financial institution.</p>\n</td>\n</tr>\n<tr>\n<td height=\"28\" valign=\"TOP\" width=\"5%\"><br /></td>\n<td height=\"28\" valign=\"TOP\" width=\"14%\"> </td>\n<td height=\"28\" valign=\"TOP\" width=\"57%\"> </td>\n</tr>\n<tr>\n<td height=\"111\" width=\"5%\"><br /></td>\n<td height=\"111\" valign=\"TOP\" width=\"14%\"><img src=\"leaderphotos/jeff.jpg\" naturalsizeflag=\"3\" height=\"96\" width=\"72\" align=\"BOTTOM\" border=\"1\" /></td>\n<td style=\"color: #ffffff;\" height=\"111\" valign=\"TOP\" width=\"57%\">\n<p><b>Joel Fallon</b> has  been a Stockade Post Ranger for 6 years and is a former Chief Ranger in  charge of Wednesday Stockade. He was a Tree Climber leader for several  years as well.</p>\n<p> </p>\n<p>Joel has past experience working with Young Life.</p>\n<p>Joel works in local law enforcement and he and his family live in West Seneca.</p>\n</td>\n</tr>\n<tr>\n<td height=\"28\" width=\"5%\"><br /></td>\n<td height=\"28\" width=\"14%\"> </td>\n<td height=\"28\" width=\"57%\"> </td>\n</tr>\n<tr>\n<td height=\"28\" width=\"5%\"><br /></td>\n<td height=\"28\" width=\"14%\"><br /></td>\n<td style=\"color: #ffffff;\" height=\"28\" width=\"57%\">\n<p><b>Frank Johnson</b> is a Stockade Leader and a former Tree Climbers Co-ordinator.</p>\n<p> </p>\n<p>He has been a Brigade Leader for 7 years.</p>\n<p> </p>\n<p>Frank and his family live in Orchard Park.</p>\n</td>\n</tr>\n<tr>\n<td height=\"28\" width=\"5%\"><br /></td>\n<td height=\"28\" width=\"14%\"><br /></td>\n<td height=\"28\" width=\"57%\"><br /></td>\n</tr>\n<tr>\n<td height=\"28\" width=\"5%\"><br /></td>\n<td height=\"28\" valign=\"TOP\" width=\"14%\"><br /></td>\n<td style=\"color: #ffffff;\" height=\"28\" valign=\"TOP\" width=\"57%\"></td>\n</tr>\n<tr>\n<td height=\"28\" width=\"5%\"><br /></td>\n<td height=\"28\" width=\"14%\"> </td>\n<td height=\"28\" width=\"57%\"> </td>\n</tr>\n<tr height=\"85\">\n<td height=\"85\" valign=\"TOP\" width=\"5%\"><br /></td>\n<td height=\"85\" valign=\"TOP\" width=\"14%\"><br /></td>\n<td style=\"color: #ffffff;\" height=\"85\" valign=\"TOP\" width=\"57%\">\n<p> </p>\n</td>\n</tr>\n<tr>\n<td height=\"28\" valign=\"TOP\" width=\"5%\"><br /></td>\n<td height=\"28\" valign=\"TOP\" width=\"14%\"> </td>\n<td style=\"color: #ffffff;\" height=\"28\" valign=\"TOP\" width=\"57%\">  <br /></td>\n</tr>\n<tr>\n<td height=\"107\" valign=\"TOP\" width=\"5%\"><br /></td>\n<td height=\"107\" valign=\"TOP\" width=\"14%\"> </td>\n<td height=\"107\" valign=\"TOP\" width=\"57%\"><br /></td>\n</tr>\n<tr>\n<td height=\"28\" valign=\"TOP\" width=\"5%\"><br /></td>\n<td height=\"28\" valign=\"TOP\" width=\"14%\"> </td>\n<td height=\"28\" valign=\"TOP\" width=\"57%\"> </td>\n</tr>\n<tr height=\"21\">\n<td height=\"21\" valign=\"TOP\" width=\"5%\"><br /></td>\n<td height=\"21\" valign=\"TOP\" width=\"14%\"><br /></td>\n<td height=\"21\" valign=\"TOP\" width=\"57%\">\n<p> </p>\n</td>\n</tr>\n<tr>\n<td height=\"28\" valign=\"TOP\" width=\"5%\"><br /></td>\n<td height=\"28\" valign=\"TOP\" width=\"14%\"> </td>\n<td height=\"28\" valign=\"TOP\" width=\"57%\"> </td>\n</tr>\n<tr height=\"21\">\n<td height=\"21\" valign=\"TOP\" width=\"5%\"><br /></td>\n<td height=\"21\" valign=\"TOP\" width=\"14%\"><br /></td>\n<td height=\"21\" valign=\"TOP\" width=\"57%\">\n<p> </p>\n</td>\n</tr>\n<tr>\n<td height=\"28\" valign=\"TOP\" width=\"5%\"><br /></td>\n<td height=\"28\" valign=\"TOP\" width=\"14%\"> </td>\n<td height=\"28\" valign=\"TOP\" width=\"57%\"> </td>\n</tr>\n<tr>\n<td height=\"28\" valign=\"TOP\" width=\"5%\"><br /></td>\n<td height=\"28\" valign=\"TOP\" width=\"14%\"> </td>\n<td height=\"28\" valign=\"TOP\" width=\"57%\"> </td>\n</tr>\n<tr>\n<td height=\"28\" valign=\"TOP\" width=\"5%\"><br /></td>\n<td height=\"28\" valign=\"TOP\" width=\"14%\"> </td>\n<td height=\"28\" valign=\"TOP\" width=\"57%\"> </td>\n</tr>\n<tr>\n<td height=\"28\" valign=\"TOP\" width=\"5%\"><br /></td>\n<td height=\"28\" valign=\"TOP\" width=\"14%\"> </td>\n<td height=\"28\" valign=\"TOP\" width=\"57%\"> </td>\n</tr>\n<tr>\n<td height=\"28\" valign=\"TOP\" width=\"5%\"><br /></td>\n<td height=\"28\" valign=\"TOP\" width=\"14%\"> </td>\n<td height=\"28\" valign=\"TOP\" width=\"57%\"> </td>\n</tr>\n<tr>\n<td height=\"28\" valign=\"TOP\" width=\"5%\"><br /></td>\n<td height=\"28\" valign=\"TOP\" width=\"14%\"> </td>\n<td height=\"28\" valign=\"TOP\" width=\"57%\"> </td>\n</tr>\n<tr height=\"21\">\n<td height=\"21\" valign=\"TOP\" width=\"5%\"><br /></td>\n<td height=\"21\" valign=\"TOP\" width=\"14%\"> </td>\n<td height=\"21\" valign=\"TOP\" width=\"57%\"> </td>\n</tr>\n</tbody>\n</table>', '', '1', '0', '0', '9', '2010-08-23 18:06:38', '242', '', '2011-09-14 15:08:45', '242', '0', '0000-00-00 00:00:00', '2010-08-23 18:06:38', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '3', '0', '2', '', '', '1', '1627', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('104', '191', 'Weather Policy Box', 'weather-policy-box', '', '<div>\n<table style=\"background-color: #ffff66; height: 42px;\" width=\"622\" align=\"center\" border=\"1\" cellpadding=\"15\" cellspacing=\"1\">\n<tbody>\n<tr>\n<td style=\"color: #000000;\"><span style=\"color: #ff0000;\"><strong> WEATHER POLICY:</strong></span> If OP Central Schools are closed the ENTIRE day due to weather, there is no group. If school is started late, dismissed early or others schools are closed, there is Stockade, Battalion, TC. If the weather is bad where you live, stay home.</td>\n</tr>\n</tbody>\n</table>\n</div>\n<div></div>', '', '1', '78', '0', '81', '2009-03-31 16:19:51', '242', '', '2010-08-23 17:15:43', '242', '0', '0000-00-00 00:00:00', '2009-12-01 16:19:51', '2010-02-04 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '5', '0', '1', '', '', '1', '59', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('293', '192', 'Canoe Trip PDF', 'canoe-trip-pdf', '', '<p>{pdf=http://www.2047.org/newweb/images/2011canoe.pdf|635|800}</p>', '', '0', '79', '0', '82', '2011-07-07 16:09:46', '66', '', '2012-08-13 12:17:53', '242', '0', '0000-00-00 00:00:00', '2011-07-07 16:09:46', '2012-08-01 13:17:46', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '3', '0', '2', '', '', '1', '33', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('185', '193', 'About Battalion #2047', 'about-battalion-2047', '', '<p><strong>Christian Service Brigade #2047</strong> is a boys and  teens group from the Wesleyan Church of Orchard Park.  Brigade #2047  has been active in Orchard Park since the early 1960\'s.</p>\n<p><br /></p>\n<ul>\n<li></li>\n</ul>\n<p><a href=\"index.php?option=com_content&view=category&id=44:battalion&layout=blog&Itemid=54\" mce_href=\"index.php?option=com_content&view=category&id=44:battalion&layout=blog&Itemid=54\"><strong>Battalion</strong></a><strong> </strong>(Mondays 7-8:30pm) is a group for young men aged 12 - 14.</p>\n<ul>\n<li>A group whose purpose is to build leadership capabilities in today\'s teen. </li>\n<li></li>\n<li>An organized and structured weekly meeting where teens are given leadership responsibilities. </li>\n<li>Games, Squad Meeting (small groups), Captain\'s Special and Council Ring make up the weekly meeting. </li>\n<li>Special  activities consist of overnights, camping, canoe trips, rocket cars to  name a few. In the past Battalion has also made their own wood strip  canoes for our yearly canoe trips.</li>\n</ul>\n<p><br /> More information on CSB #2047 can be <a href=\"../index.php?option=com_content&view=section&id=13&layout=blog&Itemid=67\" mce_href=\"../index.php?option=com_content&view=section&id=13&layout=blog&Itemid=67\">found here</a>.</p>', '', '1', '79', '0', '82', '2010-08-26 13:24:32', '242', '', '2013-07-24 12:19:31', '242', '0', '0000-00-00 00:00:00', '2010-08-26 13:24:32', '0000-00-00 00:00:00', '', '', '{\"show_title\":0,\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":0,\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '5', '0', '3', '', '', '1', '82', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('368', '194', 'No Battalion Tonight', 'no-battalion-tonight', '', '<h1 style=\"text-align: center;\"><strong><hr /></strong></h1>\n<h1 style=\"text-align: center;\"><strong>&nbsp;</strong></h1>\n<h1 style=\"text-align: center;\"><strong>No Battalion meeting tonight!</strong></h1>\n<h2 style=\"text-align: center;\"><strong><br />It returns next week</strong></h2>\n<p><strong>&nbsp;</strong></p>\n<p><strong><hr /></strong></p>', '', '1', '79', '0', '83', '2013-02-18 05:00:00', '66', '', '2013-02-18 17:02:42', '242', '0', '0000-00-00 00:00:00', '2013-02-18 05:00:00', '2013-02-19 05:00:00', '', '', '{\"show_title\":1,\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '3', '0', '1', '', '', '1', '14', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('296', '195', 'Battalion Begins Tonight!', 'battalion-begins-tonight', '', '<p> </p>\n<p> </p>\n<hr />\n<p> </p>\n<p style=\"text-align: center;\"><span style=\"font-size: 14pt;\"><strong>BATTALION BEGINS TONIGHT</strong></span></p>\n<p style=\"text-align: center;\"><span style=\"font-size: 12pt;\"><em>for guys aged 12 - 14</em></span></p>\n<p style=\"text-align: center;\"><br /><strong><span style=\"font-size: 14pt;\">7pm - 8:30</span></strong></p>\n<p style=\"text-align: center;\"><strong><span style=\"font-size: 14pt;\"> \n<hr />\n<br /></span></strong></p>', '', '1', '79', '0', '83', '2013-09-09 05:00:00', '242', '', '2013-09-09 13:35:32', '242', '0', '0000-00-00 00:00:00', '2013-09-09 05:00:00', '2013-09-10 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '3', '0', '2', '', '', '1', '39', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('237', '196', 'Battalion', 'battaion', '', '<h1 style=\"text-align: center;\"></h1>\n<p> </p>\n<p style=\"text-align: center;\"><img src=\"images/stories/2047_artwork/seal-2047-paths.gif\" /></p>\n<p style=\"text-align: center;\"> </p>\n<h1 style=\"text-align: center;\"></h1>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\"><strong>Monday, January 24</strong></span></h1>\n<h1 style=\"text-align: center;\"></h1>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\"><strong>There will be Battalion tonight.</strong></span></h1>\n<h1 style=\"text-align: center;\"></h1>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\"><strong>7pm - 8:30pm</strong></span></h1>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><strong> \n<hr />\n<br /></strong></p>', '', '1', '79', '0', '83', '2011-01-24 16:03:10', '242', '', '2011-01-24 19:05:32', '242', '0', '0000-00-00 00:00:00', '2011-01-24 16:03:10', '2011-01-25 04:00:00', '', '', '{\"show_title\":0,\"link_titles\":0,\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '4', '', '', '1', '1', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('233', '197', 'Winter Camporama', 'winter-camporama', '', '<h1 style=\"text-align: center;\">\n<hr />\n</h1>\n<h1 style=\"text-align: center;\"></h1>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\"><strong>Winter Camporama</strong></span></h1>\n<h2 style=\"text-align: center;\"><span style=\"color: #ffff00;\"><strong>February 4th - 6th, 2011</strong></span></h2>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"color: #ffff00; font-size: 12pt;\"><strong>Need to sign up by January 31st with Ray.</strong></span></p>\n<p style=\"text-align: center;\"><span style=\"color: #ffff00; font-size: 12pt;\"><strong>Contact Ray @ 946-4210</strong></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><a href=\"index.php?option=com_content&amp;view=article&amp;id=232:battalion-winter-camporama-information&amp;catid=54&amp;Itemid=97\">Additional Information is Here</a></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\">\n<hr />\n</p>', '', '1', '79', '0', '83', '2011-01-18 18:57:35', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-01-18 18:57:35', '2011-02-07 04:59:59', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '5', '', '', '1', '8', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('189', '198', 'Registration Form', 'registration-form', '', '<h2 style=\"text-align: center;\">&nbsp;</h2>\n<h2 style=\"text-align: center;\"><hr /></h2>\n<h2 style=\"text-align: center;\">&nbsp;</h2>\n<h2 style=\"text-align: center;\"><a href=\"index.php?option=com_content&amp;view=article&amp;id=404:2013-14-permission-slip&amp;catid=54:parent-letters&amp;Itemid=97\">Battalion Permission Slip is located here</a></h2>\n<p>&nbsp;</p>\n<p><hr /></p>', '', '1', '79', '0', '83', '2010-09-02 18:03:21', '66', '', '2013-06-14 13:26:15', '242', '0', '0000-00-00 00:00:00', '2010-09-02 18:03:21', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '4', '0', '6', '', '', '1', '338', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('407', '199', 'Twitter Feed btn', 'twitter-feed-btn', '', '<p><strong><span style=\"font-size: 10pt;\">To receive updates by text message - send the text &nbsp;&nbsp; \"follow csb2047\" to&nbsp; 40404</span></strong></p>\n<p> </p>\n<a class=\"twitter-timeline\" data-dnt=true href=\"https://twitter.com/csb2047\" data-widget-id=\"243675580422307840\">Tweets by @csb2047</a>\n<script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0];if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src=\"//platform.twitter.com/widgets.js\";fjs.parentNode.insertBefore(js,fjs);}}(document,\"script\",\"twitter-wjs\");</script>', '', '1', '79', '0', '84', '2013-07-16 18:13:50', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2013-07-16 18:13:50', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '1', '', '', '1', '41', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('406', '200', 'Facebook Feed BTN', 'facebook-feed', '', '<hr><hr><hr>\n\n<i><font color=\"#cccccc\">Facebook Feed - updates to the 2047.org website are automatically fed to facebook. Photo\'s and info as activities are ongoing may be sent directly to facebook. Any photo\'s uploaded to facebook are there temporarily as the event is ongoing. Afterwards the images will be removed and stay resident on 2047.org</font></i><br /><br />\n\n<center><iframe src=\"http://www.facebook.com/plugins/likebox.php?id=107026129324790&width=400&connections=10&stream=true&header=true&height=387\" scrolling=\"no\" frameborder=\"0\" style=\"border:none; overflow:hidden; background-color: white; width:400px; height:400px;\" allowTransparency=\"true\"></iframe></center>', '', '1', '79', '0', '84', '2013-07-16 18:13:13', '242', '', '2013-07-16 18:14:37', '242', '0', '0000-00-00 00:00:00', '2013-07-16 18:13:13', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '2', '', '', '1', '41', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('414', '201', 'Squad Meeting 9-16-13', 'squad-meeting-9-16-13', '', '<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br /><a target=\"_blank\" href=\"images/pdf_files/2013_2014_pdf/battalion/squad_meeting_9_16_13.pdf\">http://www.2047.org/newweb/images/pdf_files/2013_2014_pdf/battalion/squad_meeting_9_16_13.pdf</a><br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2013_2014_pdf/battalion/squad_meeting_9_16_13.pdf|600|800}</p>', '', '1', '80', '0', '85', '2013-09-09 13:30:24', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2013-09-09 13:30:24', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '1', '', '', '1', '2', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('413', '202', 'Squad Meeting 9-23-13', 'squad-meeting-9-23-13', '', '<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br /><a target=\"_blank\" href=\"images/pdf_files/2013_2014_pdf/battalion/squad_meeting_9_23_13.pdf\">http://www.2047.org/newweb/images/pdf_files/2013_2014_pdf/battalion/squad_meeting_9_23_13.pdf</a><br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2013_2014_pdf/battalion/squad_meeting_9_23_13.pdf|600|800}</p>', '', '1', '80', '0', '85', '2013-09-09 13:29:26', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2013-09-09 13:29:26', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '2', '', '', '1', '2', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('412', '203', 'Squad Meeting 9-30-13', 'squad-meeting-9-30-13', '', '<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br /><a target=\"_blank\" href=\"images/pdf_files/2013_2014_pdf/battalion/squad_meeting_9_30_13.pdf\">http://www.2047.org/newweb/images/pdf_files/2013_2014_pdf/battalion/squad_meeting_9_30_13.pdf</a><br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2013_2014_pdf/battalion/squad_meeting_9_30_13.pdf|600|800}</p>', '', '1', '80', '0', '85', '2013-09-09 13:28:30', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2013-09-09 13:28:30', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '3', '', '', '1', '1', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('411', '204', 'Squad Meetings 10-7-13', 'squad-meetings-10-7-13', '', '<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br /><a target=\"_blank\" href=\"images/pdf_files/2013_2014_pdf/battalion/squad_meeting_10_7_13.pdf\">http://www.2047.org/newweb/images/pdf_files/2013_2014_pdf/battalion/squad_meeting_10_7_13.pdf</a><br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2013_2014_pdf/battalion/squad_meeting_10_7_13.pdf|600|800}</p>', '', '1', '80', '0', '85', '2013-09-09 13:22:19', '242', '', '2013-09-09 13:27:44', '242', '0', '0000-00-00 00:00:00', '2013-09-09 13:22:19', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '4', '', '', '1', '3', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('394', '207', '2-26-13 Tues & Wed Stockade Letter', '2-26-13-tues-a-wed-stockade-letter', '', '<p>&nbsp;</p>\n<p>If the letter does not show up, use this link</p>\n<p><br />http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/2-26-13.pdf<br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/2-26-13.pdf|600|800}</p>', '', '1', '86', '0', '87', '2013-02-26 05:00:00', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2013-02-26 05:00:00', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '6', '', '', '1', '144', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('156', '208', '3/3/10 Parent Letter - Stockade & TC', '3310-parent-letter-stockade-a-tc', '', '<p>3/3/10 Parent Letter - Stockade &amp; TC</p>\n<p> </p>\n<p>If the letter does not show up, use this link <a target=\"_blank\" href=\"http://www.2047.org/images/stories/3-3-10.pdf\">http://www.2047.org/images/stories/3-3-10.pdf</a></p>\n<p> </p>\n<p>{pdf=http://www.2047.org/images/stories/3-3-10.pdf|700|1000}</p>', '', '2', '86', '0', '87', '2010-03-02 14:20:45', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2010-03-02 14:20:45', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '7', '', '', '1', '260', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('254', '209', '3-1-11 Parent Letter Tues & Wed Stockade Letter', '3-1-11-parent-letter-tues-a-wed-stockade-letter', '', '3-1-11 Tues &amp; Wed Stockade Letter   If the letter does not show up, use this link http://www.2047.org/newweb/images/pdf_files/letter-3-1-11.pdf   {pdf=http://www.2047.org/newweb/images/pdf_files/letter-3-1-11.pdf|600|800}', '', '2', '86', '0', '87', '2011-03-01 18:44:38', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2011-03-01 18:44:38', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '7', '', '', '1', '88', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('345', '210', '5-1-12 Parent Letter Stockade Tuesday & Wednesday', '5-1-12-parent-letter-stockade-tuesday-a-wednesday', '', '<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br /><a href=\"images/pdf_files/2011_2012_pdf/letter-5-1-12.pdf\" target=\"_blank\">http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/letter-5-1-12.pdf</a><br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/letter-5-1-12.pdf|600|800}</p>', '', '2', '86', '0', '87', '2012-05-01 05:00:00', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2012-05-01 14:52:12', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '7', '', '', '1', '74', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('393', '211', '2-19-13 Tues & Wed Stockade Letter', '2-19-13-tues-a-wed-stockade-letter', '', '<p>&nbsp;</p>\n<p>If the letter does not show up, use this link</p>\n<p><br />http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/2-19-13.pdf<br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/2-19-13.pdf|600|800}</p>', '', '1', '86', '0', '87', '2013-02-19 23:23:37', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2013-02-19 23:23:37', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '7', '', '', '1', '137', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('152', '212', '2/24/10 Parent Letter - Stockade & TC', '22410-parent-letter-stockade-a-tc', '', '<p>2/24/10 Parent Letter - Stockade &amp; TC</p>\n<p> </p>\n<p>If the letter does not show up, use this link <a target=\"_blank\" href=\"http://www.2047.org/images/stories/2-24-10.pdf\">http://www.2047.org/images/stories/2-24-10.pdf</a></p>\n<p> </p>\n<p>{pdf=http://www.2047.org/images/stories/2-24-10.pdf|700|1000}</p>', '', '2', '86', '0', '87', '2010-02-23 13:44:33', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2010-02-23 13:44:33', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '6', '0', '8', '', '', '1', '371', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('251', '213', '2-22-11 Parent Letter Tues & Wed Stockade Letter', '2-22-11-parent-letter-tues-a-wed-stockade-letter', '', '2-22-11 Tues & Wed Stockade Letter\n\n\nIf the letter does not show up, use this link http://www.2047.org/newweb/images/pdf_files/letter_2-22-11.pdf\n\n\n{pdf=http://www.2047.org/newweb/images/pdf_files/letter_2-22-11.pdf|600|800}', '', '2', '86', '0', '87', '2011-02-22 19:02:03', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2011-02-22 19:02:03', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '8', '', '', '1', '63', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('344', '214', '4-17-12 Parent Letter Stockade Tuesday & Wednesday', '4-17-12-parent-letter-stockade-tuesday-a-wednesday', '', '<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br /><a href=\"images/pdf_files/2011_2012_pdf/letter-4-17-12.pdf\" target=\"_blank\">http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/letter-4-17-12.pdf</a><br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/letter-4-17-12.pdf|600|800}</p>', '', '2', '86', '0', '87', '2012-04-17 14:47:07', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2012-04-17 14:47:07', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '8', '', '', '1', '91', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('391', '215', '2-12-13 Tues & Wed Stockade Letter', '2-12-13-tues-a-wed-stockade-letter', '', '<p>&nbsp;</p>\n<p>If the letter does not show up, use this link</p>\n<p><br />http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/2-12-13.pdf<br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/2-12-13.pdf|600|800}</p>', '', '1', '86', '0', '87', '2013-02-12 23:34:06', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2013-02-12 23:34:06', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '8', '', '', '1', '119', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('101', '216', 'Stockade Letter 3/4/09', 'stockade-letter-3409', '', 'Dear Parents,<br /><br />Next Tuesday we will be having our Pinewood Derby. Everyone is invited to attend!<br /><br /><em><strong>The boys can arrive starting at 6:20 and lubricate their car until 6:55. We will begin race preparation at 7pm.</strong></em><br /><br />There will be trophies handed out for 1st - 5th place, Best Looking Car  and Most Original Car. The top racers are invited to compete in the regional race against the best racers from other Stockade groups. The regional race is Saturday, March 14 @ 9:30am in our gymnasium.<br /><br />We could use some Moms to make some cookies, brownies, cupcakes, etc. If you can help out please leave a message on my machine 662-0335 or jim@2047.org email.<br /><br /><h3 align=\"center\"><strong>We can also use refreshments for the regional finals on Saturday, March 14.</strong></h3><br />Next Wednesday there is no Stockade Meeting due to the Pioneer Girls Powderpuff Derby.<br /><br />Our next weekly meeting for Wednesday Stockade is Wednesday, March 18. <br /><br />If you have any questions, please contact me.<br /><br /><br />Jim Szczodrowski<br />662-0335<br />jim@2047.org<br /><br /><h2 align=\"center\"><font color=\"#008000\"><strong>Refreshments are needed for the Pinewood Derby.<br />If you can help, contact Jim @ 662-0335 or jim@2047.org</strong></font></h2><p>&nbsp;</p><h3 align=\"center\"><font color=\"#800000\"><strong> Stockarama Camping Weekend - Friday, May 15, 7pm  - Sunday, May 17, 12:30pm </strong><br /><br /><strong>This is a weekend camping trip to our camp, Camp Hickory Hill, in Varysburg. We will have cabins and tents for sleeping. This weekend is spent, eating, competing against other Stockade groups, eating, hiking, eating and playing games. Additional information will be supplied.</strong></font></h3>', '', '2', '86', '0', '87', '2009-03-05 17:21:13', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2009-03-05 17:21:13', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '3', '0', '9', '', '', '1', '623', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('150', '217', '2/10/10 Parent Letter - Stockade & TC', '21010-parent-letter-stockade-a-tc', '', '<p>If the letter does not show up, use this link <a href=\"http://www.2047.org/images/stories/letter_2-10-10.pdf\">http://www.2047.org/images/stories/letter_2-10-10.pdf</a></p>\n<p> </p>\n<p>{pdf=http://www.2047.org/images/stories/letter_2-10-10.pdf|700|1000}</p>', '', '2', '86', '0', '87', '2010-02-10 18:57:11', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2010-02-10 18:57:11', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '4', '0', '9', '', '', '1', '459', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('246', '218', '2-9-11 Parent Letter Tues & Wed Stockade Letter', '2-9-11-parent-letter-tues-a-wed-stockade-letter', '', '<p>2-9-11 Tues &amp; Wed Stockade Letter</p>\n<p> </p>\n<p>If the letter does not show up, use this link&nbsp;<a href=\"images/pdf_files/letter-2-9-11.pdf\">http://www.2047.org/newweb/images/pdf_files/letter-2-9-11.pdf</a></p>\n<p> </p>\n<p>{pdf=http://www.2047.org/newweb/images/pdf_files/letter-2-9-11.pdf|600|800}</p>', '', '2', '86', '0', '87', '2011-02-09 18:03:46', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2011-02-09 18:03:46', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '9', '', '', '1', '98', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', '');

INSERT INTO tkt_content
(`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES 
('334', '219', '2-28-12 Parent Letter Stockade Tuesday & Wednesday', '2-28-12-parent-letter-stockade-tuesday-a-wednesday', '', '<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br /><a href=\"images/pdf_files/2011_2012_pdf/letter-2-28-12.pdf\" target=\"_blank\">http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/letter-2-28-12.pdf</a><br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/letter-2-28-12.pdf|600|800}</p>', '', '2', '86', '0', '87', '2012-02-28 18:51:35', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2012-02-28 18:51:35', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '9', '', '', '1', '50', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('386', '220', '2-6-13 Wednesday Stockade Letter', '2-6-13-wednesday-stockade-letter', '', '<p>&nbsp;</p>\n<p>If the letter does not show up, use this link</p>\n<p><br />http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/2-6-13.pdf<br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/2-6-13.pdf|600|800}</p>', '', '1', '86', '0', '87', '2013-02-07 13:39:46', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2013-02-07 13:39:46', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '9', '', '', '1', '127', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('147', '221', '2/3/10 Parent Letter - Stockade & TC', '2310-parent-letter-stockade-a-tc', '', '<p>If the letter does not show up, use this link <a href=\"http://www.2047.org/images/stories/letter_2-03-10.pdf\">http://www.2047.org/images/stories/letter_2-03-10.pdf</a></p>\n<p> </p>\n<p>{pdf=http://www.2047.org/images/stories/letter_2-03-10.pdf|700|1000}</p>', '', '2', '86', '0', '87', '2010-02-02 15:28:26', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2010-02-02 15:28:26', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '5', '0', '10', '', '', '1', '541', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('98', '222', 'Stockade Letter 2/25/09', 'stockade-letter-22509', '', '<p>Dear Parents,<br /><br />This Saturday, February 28 from 11am - 3pm is the Derby Test Day. It is optional to attend. We will have the track set-up for test runs & we\'ll weigh and add weight if needed. This is not an all day activity. The boys should come to Test Day with an adult who stays with them through the process. When they are done, they leave. There will be no games, or any other activity going on other than testing the Derby cars. We will not be assembling cars, only adding weight and test racing.<br /><br />Cars are still available if you need to purchase a Derby Car. See Jim or another adult leader. All cars for Stockade and Tree Climbers must have been purchased through Stockade, this year, for this race. Cars purchased for the Cub Scouts, Pioneer Girls, Camp Fire Boys/Girls are not eligible to race. <br /><br />IF YOU NEED A CAR, CONTACT ME AND I CAN MEET YOU AT THE GYM AT ANYTIME.<br /><br />Next week, Wednesday, March 4 the Pinewood Derby Cars are due at Stockade and Tree Climbers. All cars should be handed in with 4 wheels attached, paint dry, weight added and a name clearly written on the bottom. We will add a number to the car on top and written on the bottom.<br /><br />If in the event your boy in unable to attend Stockade next week, I need to have the car either the day before or day after. Contact me to make arrangements.<br /><br />Race day for the all the boys will be on Tuesday, March 10 from 7 - 8:30pm. There is no Stockade on Wednesday, March 11 due to the Pioneer Girls Race Day.<br /><br />Everyone is invited to attend the Pinewood Derby.<br /><br />Regional finals (for the top 5 racers) will be held on Saturday, March 14, 9:30am at our location. Additional information will be provided at our race.<br /><br />If anyone has any questions on making their race car, please feel free to contact me.<br /><br />Jim Szczodrowski<br />662-0335<br />jim@2047.org<br /></p><h2 align=\"center\"><font color=\"#008000\"><strong>Refreshments are needed for the Pinewood Derby.<br />If you can help, contact Jim @ 662-0335 or jim@2047.org</strong></font></h2><p>&nbsp;</p><p>&nbsp;</p><div align=\"center\"><h3><font color=\"#800000\"><strong> Stockarama Camping Weekend - Friday, May 15, 7pm  - Sunday, May 17, 12:30pm </strong><br /><br /><strong>This is a weekend camping trip to our camp, Camp Hickory Hill, in Varysburg. We will have cabins and tents for sleeping. This weekend is spent, eating, competing against other Stockade groups, eating, hiking, eating and playing games. Additional information will be supplied.</strong><br /></font></h3></div><p>&nbsp;</p>', '', '2', '86', '0', '87', '2009-02-24 14:52:44', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2009-02-24 14:52:44', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '10', '', '', '1', '664', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('238', '223', '1-25-11 Tues & Wed Stockade Letter', '1-25-11-tues-a-wed-stockade-letter', '', '<p>1-25-11 Tues & Wed Stockade Letter</p>\n<p> </p>\n<p>If the letter does not show up, use this link&nbsp;<a href=\"images/pdf_files/letter-1-25-11.pdf\">http://www.2047.org/newweb/images/pdf_files/letter-1-25-11.pdf</a></p>\n<p> </p>\n<p>{pdf=http://www.2047.org/newweb/images/pdf_files/letter-1-25-11.pdf|600|800}</p>', '', '2', '86', '0', '87', '2011-01-25 19:08:06', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2011-01-25 19:08:06', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '10', '', '', '1', '83', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('333', '224', '2-21-12 Parent Letter Stockade Tuesday & Wednesday', '2-21-12-parent-letter-stockade-tuesday-a-wednesday', '', '<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br /><a href=\"images/pdf_files/2011_2012_pdf/letter-2-21-12.pdf\" target=\"_blank\">http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/letter-2-21-12.pdf</a><br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/letter-2-21-12.pdf|600|800}</p>', '', '2', '86', '0', '87', '2012-02-21 19:16:42', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2012-02-21 19:16:42', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '10', '', '', '1', '47', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('385', '225', 'Battalion Letter 1-28-13', 'battalion-letter-1-28-13', '', 'If the letter does not show up, use this link\n\nhttp://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/btn-1-28-12.pdf.pdf\n\n{pdf=http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/btn-1-28-12.pdf|600|800}', '', '1', '86', '0', '87', '2013-01-29 02:35:22', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2013-01-29 02:35:22', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '10', '', '', '1', '139', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('142', '226', '1-13-10 Parent Letter - Stockade', '1-13-10-parent-letter-stockade', '', '<font style=\"color: #000000\" color=\"#000000\"><span style=\"color: #000000; font-family: Times; font-size: medium\" class=\"Apple-style-span\"><div style=\"font-family: Verdana,Arial,Helvetica,sans-serif; font-size: 10px; background-color: #ffffff; text-align: left; color: #666666\"><p style=\"font-size: 10px; color: #000000\" align=\"center\"><font style=\"font-size: 12px\"><strong>Christian Service Brigade #2047</strong><br /><em><strong>from the Wesleyan Church of Orchard Park</strong></em>  <br />Tree Climbers    Stockade    Battalion<br /><br />jim@2047.org            www.2047.org</font></p><p>&nbsp;</p><div style=\"text-align: left\">Dear Parents,<br /><br />The next couple activities on our schedule are - <br /><br /><div align=\"center\"><strong>Saturday, January 16th,<br />Stockade Movie Night from <br />7 - 9pm at the gym. <br />There is no cost and boys can just show up.<br /></strong></div><br /><div align=\"center\"><strong>Next week at Stockade, January 20th, 8th Annual Creature Feature Night <br />at Stockade<br />Regular Meeting Time<br /></strong></div><br /><br />Pinewood Derby Cars are now available for $9. The cars will be on sale for the next 5 or 6 weeks. There are help days scheduled for boys or dads needing assistance with the cars (see below). There is also a test day scheduled to test race the cars. The work days and test are optional.<br /><br />Upcoming activities are listed below and a full schedule is on the website  2047.org<br /><br />Should you have any questions now or in the future you can contact me at jim@2047.org email or by phone at 662-0335.<br /><br /></div><div style=\"text-align: left\"> </div><div style=\"text-align: center\"><span style=\"color: #000000; font-weight: bold\" class=\"Apple-style-span\">Stockade Movie Night</span></div><font style=\"font-size: 10px\"><div style=\"text-align: center\">Saturday, January 16, 7:00pm </div><div style=\"text-align: center\"><br /></div><strong><div style=\"text-align: center\">Creature Feature Night</div></strong><div style=\"text-align: center\">Wednesday, January 20</div><div style=\"text-align: center\"><br /></div><strong><div style=\"text-align: center\">Sledding Nights & Overnights</div></strong><div style=\"text-align: center\">to be announced</div><div style=\"text-align: center\"><br /></div><strong><div style=\"text-align: center\">Derby Car Help Days</div></strong><div style=\"text-align: center\">Saturday, January 23, 11-2</div><div style=\"text-align: center\">Saturday, February 6, 9-12</div><div style=\"text-align: center\">Sunday, February 21, 2-5</div><div style=\"text-align: center\"><br /></div><strong><div style=\"text-align: center\">Family Movie Night</div></strong><div style=\"text-align: center\">Saturday, February 13th - 6:30pm</div><div style=\"text-align: center\">\"Down & Derby\" & Cartoons</div><div style=\"text-align: center\"><br /></div><strong><div style=\"text-align: center\">Derby Test Day</div></strong><div style=\"text-align: center\">Saturday, February 27th - 11am - 3pm</div><div style=\"text-align: center\"><br /></div><strong><div style=\"text-align: center\">Tuesday, March 9th </div></strong><div style=\"text-align: center\">RACE DAY FOR </div><div style=\"text-align: center\">STOCKADE & TREE CLIMBERS</div></font><p>&nbsp;</p><p align=\"center\"><font style=\"font-size: 10px\"><strong>Stockade 100 Item Scavengar Hunt</strong><br />to be announced<br /><br /><strong>Stockarama Camping Weekend</strong><br />May 14 - 16</font> </p><div align=\"center\" style=\"font-size: 12px\"><strong><font style=\"font-size: 10px\">During poor weather if Orchard Park Central Schools are closed for the entire day, Stockade is canceled.</font><br /><font style=\"font-size: 10px\">If you are not sure check the Stockade webpage. If school was not cancelled and the weather is poor, stay home.</font></strong><br /></div><p>&nbsp;</p><p>&nbsp;</p><p>&nbsp;</p><p>&nbsp;</p><p>&nbsp;</p></div></span></font>', '', '2', '86', '0', '87', '2010-01-13 22:37:12', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2010-01-14 03:37:12', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '11', '', '', '1', '567', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('256', '265', 'Tuesday Stockade Animation #1', 'tuesday-stockade-animation-1', '', '<center>\n<hr />\n</center><center><br /></center><center>\n<object codebase=\"http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=10,0,32,18\" classid=\"clsid:d27cdb6e-ae6d-11cf-96b8-444553540000\" type=\"application/x-shockwave-flash\" height=\"300\" width=\"400\">\n<param name=\"allowfullscreen\" value=\"true\" />\n<param name=\"allowscriptaccess\" value=\"always\" />\n<param name=\"src\" value=\"http://vimeo.com/moogaloop.swf?clip_id=20533401&amp;server=vimeo.com&amp;show_title=1&amp;show_byline=1&amp;show_portrait=1&amp;color=00ADEF&amp;fullscreen=1&amp;autoplay=0&amp;loop=0\" /><embed height=\"300\" width=\"400\" src=\"http://vimeo.com/moogaloop.swf?clip_id=20533401&amp;server=vimeo.com&amp;show_title=1&amp;show_byline=1&amp;show_portrait=1&amp;color=00ADEF&amp;fullscreen=1&amp;autoplay=0&amp;loop=0\" allowscriptaccess=\"always\" allowfullscreen=\"true\" type=\"application/x-shockwave-flash\"></embed>\n</object>\n</center><center><br /></center><center>\n<p><a href=\"http://vimeo.com/20533401\">Tuesday Stockade Animation #1</a> from <a href=\"http://vimeo.com/user5499876\">Jim Szczodrowski</a> on <a href=\"http://vimeo.com\">Vimeo</a>.</p>\n<p> </p>\n<p>Photos and more animation from <a href=\"index.php?option=com_wrapper&amp;view=wrapper&amp;Itemid=108\">Tuesday Stockade here</a></p>\n</center>', '', '0', '90', '0', '110', '2011-03-02 12:36:15', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-03-02 12:36:15', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '33', '', '', '1', '63', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('236', '266', 'Creature feature - entire video', 'creature-feature-entire-video', '', '<hr />\n<p><span style=\"font-size: 12pt;\"><strong><center>Creature Feature Video of all the creatures!</center></strong></span></p>\n<p><span style=\"font-size: 12pt;\"><strong><br /></strong></span></p>\n<center> \n<table bgcolor=\"#ffff66\" border=\"0\" cellpadding=\"0\" cellspacing=\"2\" width=\"600\">\n<tbody>\n<tr>\n<td><center><br /></center><center><span style=\"font-size: 14pt; color: #000000;\"><strong>Creature Feature - entire show</strong></span></center><center><br /></center><center> \n<object codebase=\"http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=10,0,32,18\" classid=\"clsid:d27cdb6e-ae6d-11cf-96b8-444553540000\" type=\"application/x-shockwave-flash\" height=\"227\" width=\"400\">\n<param name=\"allowfullscreen\" value=\"true\" />\n<param name=\"allowscriptaccess\" value=\"always\" />\n<param name=\"src\" value=\"http://vimeo.com/moogaloop.swf?clip_id=19109845&amp;server=vimeo.com&amp;show_title=1&amp;show_byline=1&amp;show_portrait=1&amp;color=00ADEF&amp;fullscreen=1&amp;autoplay=0&amp;loop=0\" /><embed type=\"application/x-shockwave-flash\" height=\"227\" width=\"400\" src=\"http://vimeo.com/moogaloop.swf?clip_id=19109845&amp;server=vimeo.com&amp;show_title=1&amp;show_byline=1&amp;show_portrait=1&amp;color=00ADEF&amp;fullscreen=1&amp;autoplay=0&amp;loop=0\" allowscriptaccess=\"always\" allowfullscreen=\"true\"></embed>\n</object>\n<p><a href=\"http://vimeo.com/19109845\">Stockade #2047 Creature Feature - 2011</a> from <a href=\"http://vimeo.com/user5499876\">Jim Szczodrowski</a> on <a href=\"http://vimeo.com\">Vimeo</a>.</p>\n</center></td>\n</tr>\n</tbody>\n</table>\n</center> \n<hr />', '', '0', '90', '0', '110', '2011-01-24 00:09:58', '242', '', '2011-11-15 13:22:36', '242', '0', '0000-00-00 00:00:00', '2011-01-24 00:09:58', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '10', '0', '34', '', '', '1', '89', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('218', '267', 'Tuesday Stockade Sledding Movie', 'tuesday-stockade-sledding-movie', '', '<hr />\n\n<center><table width=\"600\" border=\"0\" cellspacing=\"2\" cellpadding=\"0\" bgcolor=\"#ffff66\">\n			<tr>\n				<td><center>\n						<h1><br />\n					<b><font color=\"black\" face=\"Verdana, Arial, Helvetica, sans-serif; color #000000\">Tuesday Stockade Sledding Movie!</font></b>\n					<p>\n							<iframe src=\"http://player.vimeo.com/video/17884424\" width=\"400\" height=\"300\" frameborder=\"0\"></iframe>\n						</p>\n					<p><font size=\"-1\"><a href=\"http://vimeo.com/17884424\">Tuesday Stockade Sledding 12/7/10</a> from <a href=\"http://vimeo.com/user5499876\">Jim Szczodrowski</a> on <a href=\"http://vimeo.com\">Vimeo</a>.</font></p>\n						<p><a href=\"http://www.2047.org/newweb/index.php?option=com_wrapper&view=wrapper&Itemid=108\"><font size=\"-1\">Photo Album Here<br />\n							</font>\n								<br />\n							</a></p>\n					</center></td>\n			</tr>\n		</table></center>\n\n<hr />', '', '0', '90', '0', '110', '2010-12-16 16:44:41', '242', '', '2010-12-16 16:59:05', '242', '0', '0000-00-00 00:00:00', '2010-12-16 16:44:41', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '6', '0', '35', '', '', '1', '89', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('97', '268', 'Weather Policy', 'weather-policy', '', '<center> \n<table style=\"background-color: #ffff66; height: 42px; width: 622px;\" align=\"center\" border=\"1\" cellpadding=\"20\" cellspacing=\"5\">\n<tbody>\n<tr>\n<td>\n<p><span style=\"color: #ff0000;\"><strong> WEATHER POLICY:</strong></span> <span style=\"color: #000000;\">If OP Central Schools are closed the ENTIRE day <span style=\"text-decoration: underline;\"><strong>due to weather</strong></span>, there is no group. If school is started late, dismissed early or others schools are closed, there is Stockade, Battalion, TC. If the weather is bad where you live, stay home. </span></p>\n</td>\n</tr>\n</tbody>\n</table>\n<div align=\"center\"></div>\n</center>', '', '1', '90', '0', '110', '2012-11-25 05:00:00', '242', '', '2012-08-13 12:56:43', '242', '0', '0000-00-00 00:00:00', '2012-11-25 05:00:00', '2013-02-17 05:00:00', '', '', '{\"show_title\":0,\"link_titles\":0,\"show_intro\":0,\"show_section\":0,\"link_section\":0,\"show_category\":0,\"link_category\":0,\"show_vote\":0,\"show_author\":0,\"show_create_date\":0,\"show_modify_date\":0,\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '11', '0', '36', '', '', '1', '267', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('112', '269', 'Stockade Movie Night - Iron Giant', 'stockade-movie-night-iron-giant', '', '<table border=\"0\" cellspacing=\"0\" cellpadding=\"5\" width=\"608\" align=\"center\" style=\"height: 491px\"> 				<tbody><tr> 					<td colspan=\"2\" valign=\"top\" bgcolor=\"black\"> 						<div align=\"center\"> 						<img src=\"userfiles/irongiant/ig-22.gif\" border=\"0\" width=\"601\" height=\"252\" /></div> 					</td> 				</tr> 				<tr height=\"320\"> 				<td width=\"200\" height=\"320\" align=\"center\" valign=\"top\" bgcolor=\"black\"><img src=\"userfiles/irongiant/the_iron_giant_poster.gif\" border=\"0\" width=\"224\" height=\"317\" /></td> 				<td height=\"320\" align=\"center\" valign=\"middle\" bgcolor=\"black\"> 				<div align=\"center\"> 					<object classid=\"clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B\" codebase=\"http://www.apple.com/qtactivex/qtplugin.cab#version=6,0,2,0\" width=\"317\" height=\"197\"><param name=\"width\" value=\"317\" /><param name=\"height\" value=\"197\" /><param name=\"src\" value=\"userfiles/irongiant/irongiantmov.mov\" /><param name=\"autoplay\" value=\"true\" /><param name=\"controller\" value=\"true\" /><embed type=\"video/quicktime\" width=\"317\" height=\"197\" src=\"userfiles/irongiant/irongiantmov.mov\" autoplay=\"true\" controller=\"true\"></embed></object> 			</div></td> 			</tr> 			<tr align=\"center\" valign=\"middle\" style=\"height: 65px\"> 				<td colspan=\"2\" height=\"45\" align=\"center\" valign=\"middle\" bgcolor=\"#ffef3b\"><strong><font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"+1\" color=\"#ff0019\">Stockade Movie Night <br /> 						</font></strong><strong><font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"+1\" color=\"#ff0019\">Saturday, September 26th, 7:00pm </font></strong></td> 			</tr> 		</tbody></table>', '', '2', '90', '0', '110', '2009-08-25 12:26:10', '242', '', '2009-08-29 12:27:31', '242', '0', '0000-00-00 00:00:00', '2009-08-28 12:00:00', '2009-09-27 11:59:00', '', '', '{\"show_title\":0,\"link_titles\":0,\"show_intro\":0,\"show_section\":0,\"link_section\":0,\"show_category\":0,\"link_category\":0,\"show_vote\":0,\"show_author\":0,\"show_create_date\":0,\"show_modify_date\":0,\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '4', '0', '36', '', '', '1', '18', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('244', '270', 'Pinewood Derby Workday #2', 'pinewood-derby-workday-2', '', '<p>&nbsp;</p>\n<hr />\n<p>&nbsp;</p>\n<h1 style=\"text-align: center;\"><img src=\"images/stories/derby-seal.gif\" height=\"150\" width=\"150\" /></h1>\n<p>&nbsp;</p>\n<h1 style=\"text-align: center;\">&nbsp;</h1>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\">Pinewood Derby Workday #2</span></h1>\n<p><span style=\"color: #ffff00;\">&nbsp;</span></p>\n<h1 style=\"text-align: center;\">&nbsp;</h1>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\">Saturday, February 1st - Noon - 3pm<br /></span></h1>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\">@ the gym</span></h1>\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<hr />', '', '1', '90', '0', '110', '2014-01-30 05:00:00', '242', '', '2013-08-19 18:03:04', '242', '0', '0000-00-00 00:00:00', '2014-01-30 05:00:00', '2014-02-02 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '5', '0', '37', '', '', '1', '11', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('234', '271', 'Creature Feature Photo Album 2011', 'creature-feature-photo-album-2011', '', '<div align=\"center\">\n<table width=\"628\" border=\"0\" cellpadding=\"10\" cellspacing=\"1\">\n<tbody>\n<tr>\n<td colspan=\"3\" bgcolor=\"#00ff66\">\n<h1 align=\"center\"></h1>\n<h1 align=\"center\"><span style=\"font-size: small;\"><br /></span></h1>\n<div align=\"center\"><strong><span style=\"color: black; font-size: small;\"><br /></span></strong></div>\n<div align=\"center\">\n<p><span style=\"color: #800000; font-size: medium;\"><span style=\"font-size: 16px;\"><b><a target=\"_blank\" href=\"http://2047.org/stockade/photoalbum/creaturefeature2011/index.html\">Creature Feature 2011<br />Photo Album&nbsp;in Now Online!&nbsp;</a></b></span></span></p>\n<p><span style=\"color: #800000;\"><strong style=\"font-size: 16px;\"><br /></strong></span></p>\n<p>--</p>\n<p><img src=\"images/stories/14.jpg\" />&nbsp;<img src=\"images/stories/30.jpg\" /><br /><img src=\"images/stories/49.jpg\" />&nbsp;<img src=\"images/stories/55.jpg\" />&nbsp;</p>\n<p> </p>\n<p><span style=\"font-size: 12pt;\"><strong>There will be more photos and movies uploaded over the weekend!</strong></span></p>\n<p> </p>\n<p><a href=\"stockade/photoalbum/\" target=\"_blank\">See photographs and movies from the events from other years!</a></p>\n<p> </p>\n<p> </p>\n</div>\n</td>\n</tr>\n</tbody>\n</table>\n</div>', '', '0', '90', '0', '110', '2011-01-21 00:02:52', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-01-21 00:02:52', '2011-02-03 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '38', '', '', '1', '9', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('204', '272', 'Police Dept Field Trip', 'police-dept-field-trip', '', '<p style=\"text-align: center;\"><img width=\"115\" height=\"67\" src=\"images/stories/0064.gif\" style=\"vertical-align: middle;\" /><strong><span style=\"font-size: 18pt; color: red;\">  Wednesday Stockade Field Trip</span></strong> <img width=\"116\" height=\"68\" src=\"images/stories/0064.gif\" style=\"vertical-align: middle;\" /><strong><br /><span style=\"font-size: 12pt;\">to the West Seneca Police Department</span></strong></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><strong>Wednesday, November 17th. </strong></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><strong>Arrive at the gym between 6:30 and 6:45pm. </strong></p>\n<p style=\"text-align: center;\"><strong>We are leaving no later than 7pm so be there by 6:45.<br /></strong></p>\n<p style=\"text-align: center;\"><strong>We will return between 8:30 & 8:45.</strong></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><strong>Any questions call Jim @ 662-0335 or <a href=\"mailto:jim@2047.org\">email</a><br /></strong></p>', '', '0', '90', '0', '110', '2010-11-12 17:54:44', '242', '', '2010-11-18 11:57:05', '242', '0', '0000-00-00 00:00:00', '2010-11-12 17:54:44', '2010-11-18 04:59:00', '', '', '{\"show_title\":0,\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '39', '', '', '1', '9', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('235', '273', 'Derby Workday #1', 'derby-workday-1', '', '<p>&nbsp;</p>\n<hr />\n<p>&nbsp;</p>\n<h1 style=\"text-align: center;\"><img src=\"images/stories/derby-seal.gif\" height=\"150\" width=\"150\" /></h1>\n<p>&nbsp;</p>\n<h1 style=\"text-align: center;\">&nbsp;</h1>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\">Derby Workday #1</span></h1>\n<p><span style=\"color: #ffff00;\">&nbsp;</span></p>\n<h1 style=\"text-align: center;\">&nbsp;</h1>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\">Saturday, January 18th - 11am - 2pm</span></h1>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\">@ the gym</span></h1>\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<hr />', '', '1', '90', '0', '110', '2014-01-16 05:00:00', '242', '', '2013-08-19 18:01:23', '242', '0', '0000-00-00 00:00:00', '2014-01-16 05:00:00', '2014-01-19 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '5', '0', '40', '', '', '1', '36', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('231', '275', 'This week at Stockade!', 'this-week-at-stockade', '', '<p style=\"text-align: center;\"> </p>\n<hr />\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><img src=\"images/stories/derby-seal.gif\" height=\"148\" width=\"148\" /></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"font-size: 14pt; color: #00ffff;\"><strong>Derby cars are now available! $9 each. See Jim</strong></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"color: #ffff00;\"><strong><span style=\"font-size: 14pt;\">Saturday - Derby Work Day - 11am - 2pm</span></strong></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"color: #ffff00;\"><strong><span style=\"font-size: 14pt;\">Let Jim know if you are attending</span></strong></span></p>\n<span style=\"font-size: 14pt;\"><strong>&nbsp;</strong></span>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"> </p>\n<hr />', '', '2', '90', '0', '110', '2011-01-17 14:21:48', '242', '', '2011-01-17 14:29:41', '242', '0', '0000-00-00 00:00:00', '2011-01-17 14:21:48', '2011-01-23 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '4', '0', '42', '', '', '1', '5', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('82', '276', 'Down and Derby', 'a-down-and-derby', '', '<div align=\"center\">\n<table style=\"height: 491px; width: 608px; background-color: #ffffff;\" align=\"center\" border=\"0\" cellpadding=\"5\" cellspacing=\"3\">\n<tbody>\n<tr>\n<td colspan=\"2\" valign=\"top\">\n<div align=\"center\"><img src=\"derby/downandderby/title.gif\" height=\"136\" width=\"200\" border=\"0\" />&nbsp;</div>\n</td>\n</tr>\n<tr height=\"320\">\n<td height=\"320\" valign=\"top\" width=\"200\"><img src=\"derby/downandderby/postacrd.gif\" height=\"319\" width=\"229\" border=\"0\" /></td>\n<td height=\"320\" valign=\"top\">\n<object codebase=\"http://www.apple.com/qtactivex/qtplugin.cab#version=6,0,2,0\" classid=\"clsid:02bf25d5-8c17-4b23-bc80-d3488abddc6b\" type=\"video/quicktime\" height=\"320\" width=\"400\">\n<param name=\"src\" value=\"derby/downandderby/trailer.mov\" />\n<param name=\"autoplay\" value=\"true\" />\n<param name=\"controller\" value=\"true\" /><embed height=\"320\" width=\"400\" controller=\"true\" autoplay=\"true\" src=\"derby/downandderby/trailer.mov\" type=\"video/quicktime\"></embed>\n</object>\n<br /></td>\n</tr>\n<tr style=\"height: 65px;\" valign=\"middle\" align=\"center\">\n<td colspan=\"2\" height=\"45\" valign=\"middle\" align=\"center\" bgcolor=\"#ffdf00\">\n<div align=\"center\"><span style=\"font-size: 14pt;\"><strong><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif; color: #ff0019;\">Stockade/Tree Climbers Family Movie Night</span></strong></span></div>\n<div align=\"center\"></div>\n<div align=\"center\"><span style=\"font-size: 14pt;\"><strong><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif; color: #ff0019;\">Saturday, February 18th, 6:30pm - 8:30pm <br /></span></strong></span></div>\n<div align=\"center\"><span style=\"font-size: 14pt;\"><strong><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif; color: #ff0019;\"><a target=\"_blank\" href=\"index.php?option=com_seminar&amp;task=3&amp;cid=7\">Reserve your seat here!</a><br /><br /></span></strong></span></div>\n</td>\n</tr>\n</tbody>\n</table>\n</div>', '', '1', '90', '0', '110', '2012-01-31 05:00:00', '242', '', '2012-01-31 18:25:10', '242', '0', '0000-00-00 00:00:00', '2012-01-31 05:00:00', '2012-02-19 05:00:00', '', '', '{\"show_title\":0,\"link_titles\":0,\"show_intro\":0,\"show_section\":0,\"link_section\":0,\"show_category\":0,\"link_category\":0,\"show_vote\":0,\"show_author\":0,\"show_create_date\":0,\"show_modify_date\":0,\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '31', '0', '43', '', '', '1', '233', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('74', '277', 'Overnight', 'overnight', '', '<br /><br /><center> \n<table width=\"584\" align=\"center\" border=\"0\" style=\"background-color: #00ffff; height: 150px;\">\n<tbody>\n<tr>\n<td valign=\"middle\" align=\"center\" style=\"font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 10px; font-style: normal; color: #f71607;\">\n<h1><span style=\"color: #ff0000;\"><span style=\"color: #ff0f00;\">STOCKADE OVERNIGHT!<br /> </span></span></h1>\n<h2><span style=\"color: #ff0f00;\"><span style=\"color: #ff0000;\">Games - Food - Movies - Food - Stay up Late! </span><br /> </span></h2>\n<h2 style=\"text-align: center;\"><span style=\"color: #000000;\">This Friday, November 9th, 7:45pm (we can\'t be in the gym until 8pm)<br /> until Saturday, 9:30am<br />Cost: $5<br /></span></h2>\n<h3><span style=\"color: #000000;\">You have to let Jim know if you are attending <br />by Thursday 9pm - 662-0335<br /></span></h3>\n<p><span style=\"color: #000000;\">You need to bring $5, sleeping bag, clothes. No TV\'s, iPods, electronic games, etc.</span></p>\n<p><span style=\"color: #000000;\">(the overnight is for guys attending Stockade, you can\'t invite friends)<br />any questions call Jim at 662-0335</span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</center>', '', '1', '90', '0', '110', '2012-11-07 05:00:00', '242', '', '2012-11-08 03:30:11', '242', '0', '0000-00-00 00:00:00', '2012-11-07 05:00:00', '2012-11-11 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '16', '0', '44', '', '', '1', '599', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('110', '278', 'Drive-In Movie Night! Karate Kid', 'drive-in-movie-night', '', '<table style=\"background-color: #ffff00; height: 150px; border: 6px solid #fc1f16;\" border=\"6\" cellpadding=\"5\" width=\"650\">\n<tbody>\n<tr style=\"background-color: #ffffff;\">\n<td>\n<div align=\"center\"><img src=\"images/stories/coming%20soon.gif\" border=\"0\" /></div>\n</td>\n</tr>\n<tr>\n<td>\n<div align=\"center\"></div>\n<div style=\"font-size: xx-large; font-weight: 600;\" align=\"center\"><span style=\"color: #800000;\" class=\"Apple-style-span\"><br /></span></div>\n<div style=\"font-size: xx-large; font-weight: 600;\" align=\"center\"><span style=\"color: #800000;\">Stockade Movie Night!</span></div>\n<div style=\"font-size: large; font-weight: 600;\" align=\"center\"></div>\n<div style=\"font-size: large; font-weight: 600;\" align=\"center\"><span style=\"color: #800000; font-size: 24px;\" class=\"Apple-style-span\"><br /></span></div>\n<div style=\"font-size: large; font-weight: 600;\" align=\"center\"><span style=\"color: #800000;\">August 25th</span></div>\n<div style=\"font-size: large; font-weight: 600;\" align=\"center\"><span style=\"color: #ff6600;\"><br />Arrive @ 7:45 - Movies begin at dusk.</span></div>\n<div style=\"font-size: large; font-weight: 600;\" align=\"center\"><span style=\"color: #ff6600;\">End about 10:15</span></div>\n<h2 align=\"center\"><span style=\"color: #000000;\"><em><span style=\"color: #666666; font-size: 10px; font-style: normal; font-weight: normal;\" class=\"Apple-style-span\">\n<object codebase=\"http://www.apple.com/qtactivex/qtplugin.cab#version=6,0,2,0\" classid=\"clsid:02bf25d5-8c17-4b23-bc80-d3488abddc6b\" type=\"video/quicktime\" height=\"185\" width=\"313\">\n<param name=\"bgcolor\" value=\"#ffffff\" />\n<param name=\"src\" value=\"userfiles/kktrailer2.mov\" />\n<param name=\"autoplay\" value=\"true\" />\n<param name=\"controller\" value=\"true\" /><embed type=\"video/quicktime\" height=\"185\" width=\"313\" controller=\"true\" autoplay=\"true\" src=\"userfiles/kktrailer2.mov\" bgcolor=\"#ffffff\">&nbsp;</embed>\n</object>\n</span></em></span></h2>\n<p style=\"text-align: center;\"><span style=\"color: #000000;\"><em>Watch some movies under the stars (unless it rains, then we are inside) and eat at the same time!</em></span></p>\n</td>\n</tr>\n</tbody>\n</table>', '', '0', '90', '0', '110', '2009-08-05 17:01:17', '242', '', '2012-08-13 12:30:57', '242', '0', '0000-00-00 00:00:00', '2009-08-07 01:01:17', '2009-08-29 05:00:00', '', '', '{\"show_title\":0,\"link_titles\":0,\"show_intro\":0,\"show_section\":0,\"link_section\":0,\"show_category\":0,\"link_category\":0,\"show_vote\":0,\"show_author\":0,\"show_create_date\":0,\"show_modify_date\":0,\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '15', '0', '45', '', '', '1', '31', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('213', '279', 'Tuesday Stockade Sledding', 'tuesday-stockade-sledding', '', '<div align=\"center\">\n<table width=\"500\" border=\"3\" cellpadding=\"0\" cellspacing=\"2\">\n<tbody>\n<tr>\n<td style=\"font-weight: normal; color: #ffff00;\" valign=\"middle\" align=\"center\" background=\"http://www.2047.org/stockade/newart/bluegrad.gif\">\n<h1 style=\"color: red; text-align: center;\"></h1>\n<p style=\"text-align: center;\"><span style=\"font-size: 12pt;\"><strong><em><br /></em></strong></span></p>\n<h1 style=\"text-align: center;\">Tuesday Stockade Sledding Photos!</h1>\n<h1 style=\"text-align: center;\"></h1>\n<h1 style=\"text-align: center;\">(Coming soon - The Movie)</h1>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><a target=\"_blank\" href=\"http://2047.org/stockade/photoalbum/tue_sled_12-7-10/index.html\"><img src=\"http://2047.org/stockade/photoalbum/tue_sled_12-7-10/Thumbnails/29.jpg\" /></a></p>\n<p style=\"color: #ffff00; text-align: center;\"> </p>\n<a href=\"index.php?option=com_wrapper&amp;view=wrapper&amp;Itemid=108\"><strong><em>Complete 2047 Photoalbum Here</em></strong></a>\n<p style=\"text-align: center;\"> </p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>', '', '0', '90', '0', '110', '2010-12-08 14:05:41', '242', '', '2010-12-08 14:16:54', '242', '0', '0000-00-00 00:00:00', '2010-12-08 14:05:41', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '46', '', '', '1', '3', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('141', '280', 'No Sledding notice', 'sledding-notice', '', '<h3 style=\"text-align: center;\" mce_style=\"text-align: center;\">&nbsp;</h3>\n<table style=\"border: 0pt solid #ffff99; background-color: #ffff99; text-align: center;\" mce_style=\"border: 0pt solid #ffff99; background-color: #ffff99; text-align: center;\" border=\"0\" cellpadding=\"15\" class=\"mceItemTable\">\n<tbody style=\"text-align: center;\" mce_style=\"text-align: center;\">\n<tr style=\"text-align: center;\" mce_style=\"text-align: center;\">\n<td style=\"text-align: center;\" mce_style=\"text-align: center;\">\n<p style=\"color: #ff0000;\" mce_style=\"color: #ff0000;\"><span style=\"font-size: 18pt;\" mce_style=\"font-size: 18pt;\">&nbsp;</span><strong><span style=\"font-size: 18pt;\" mce_style=\"font-size: 18pt;\">NO SLEDDING TONIGHT 1/27/10</span><br /></strong></p>\n<p><strong>If you were planning on Sledding with your post tonigt there will be no sledding brcause there is not enough snow.<br /></strong></p>\n<p><strong>When it is your turn to have sledding i the future a leader will call you the night before.</strong></p>\n<p><strong>Come for a regular Stockade meeting!<br /></strong></p>\n</td>\n</tr>\n</tbody>\n</table>', '', '0', '90', '0', '110', '2010-01-27 12:26:42', '242', '', '2013-01-08 20:32:56', '242', '0', '0000-00-00 00:00:00', '2010-01-27 05:00:00', '2010-01-28 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '7', '0', '47', '', '', '1', '40', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('102', '281', 'Pinewood Derby 10', 'pinewood-derby-tonight', '', '<div align=\"center\">\n<h1><span style=\"color: #800000;\"><strong><img src=\"images/stories/derby-10-logo.gif\" height=\"247\" width=\"332\" /></strong></span></h1>\n<h1><span style=\"color: #800000;\"><strong>46th Annual Pinewood Derby</strong></span></h1>\n<h2><span style=\"color: #800000;\"><strong>for Stockade &amp; Tree Climbers</strong></span></h2>\n<h2><span style=\"color: #800000;\"><strong>Tuesday, March 9 @ 7pm</strong></span></h2>\n<p><strong><em>(you can arrive starting at 6:20pm to test your car)</em></strong></p>\n<p><strong><em>Everyone is invited! </em></strong></p>\n<p><span style=\"color: #ff0000;\"><strong><em>(No Stockade on Wednesday, March 10th due to the girls PowderPuff Derby)</em></strong></span></p>\n<p><strong><em> \n<hr />\n<br /></em></strong></p>\n</div>', '', '2', '90', '0', '110', '2010-03-02 04:00:00', '242', '', '2010-07-28 15:19:31', '242', '0', '0000-00-00 00:00:00', '2010-03-04 06:00:00', '2010-03-10 06:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '16', '0', '51', '', '', '1', '493', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('208', '282', 'West Seneca police Visit Photos', 'west-seneca-police-visit-photos', '', '<p> </p>\n<hr />\n<p> </p>\n<p> </p>\n<p><img style=\"display: block; margin-left: auto; margin-right: auto;\" src=\"images/stories/0064.gif\" height=\"99\" width=\"167\" /></p>\n<p> </p>\n<h2 style=\"text-align: center;\">West Seneca Police Station visit</h2>\n<h2 style=\"text-align: center;\">photos<a href=\"index.php?option=com_wrapper&amp;view=wrapper&amp;Itemid=108\"> are here</a></h2>\n<p> </p>\n<p style=\"text-align: center;\"><img src=\"http://2047.org/stockade/photoalbum/wspolice2010/Thumbnails/17.jpg\" /></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><img src=\"http://2047.org/stockade/photoalbum/wspolice2010/Thumbnails/19.jpg\" /></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"> </p>\n<hr />\n<p> </p>', '', '2', '90', '0', '110', '2010-11-18 11:59:18', '242', '', '2010-12-08 13:59:33', '242', '0', '0000-00-00 00:00:00', '2010-11-18 11:59:18', '0000-00-00 00:00:00', '', '', '{\"show_title\":0,\"link_titles\":0,\"show_intro\":0,\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '3', '0', '52', '', '', '1', '22', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('144', '283', 'Creature #8, 2011', 'creature-8-2011', '', '<div style=\"text-align: center;\"><img src=\"stockade/photoalbum/creaturefeature8/Thumbnails/67.jpg\" border=\"0\" height=\"179\" width=\"240\" /><img src=\"stockade/photoalbum/creaturefeature8/Thumbnails/8.jpg\" border=\"0\" height=\"180\" width=\"240\" /></div>\n<div style=\"text-align: center;\">&nbsp;</div>\n<h1 style=\"text-align: center;\"><span style=\"color: #000000;\"><a href=\"stockade/photoalbum/creaturefeature8/\" target=\"_blank\">Creature Photos are Online!&nbsp;</a></span></h1>\n<p> </p>\n<p style=\"text-align: center;\"><img src=\"stockade/photoalbum/creaturefeature8/Thumbnails/34.jpg\" border=\"0\" height=\"178\" width=\"240\" /><img src=\"stockade/photoalbum/creaturefeature8/Thumbnails/43.jpg\" border=\"0\" height=\"178\" width=\"240\" /></p>', '', '2', '90', '0', '110', '2010-01-21 03:36:41', '242', '', '2010-12-20 15:03:07', '242', '0', '0000-00-00 00:00:00', '2010-01-21 03:36:41', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '3', '0', '53', '', '', '1', '16', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('138', '284', 'Stockade Movie Night, January 16, 7pm', 'stockade-movie-night-january-16-7pm', '', '<table border=\"0\" cellspacing=\"0\" cellpadding=\"5\" width=\"608\" align=\"center\" style=\"height: 491px\"> 				<tbody><tr> 					<td colspan=\"2\" valign=\"top\" bgcolor=\"black\"> 						<div align=\"center\"> 						<img src=\"userfiles/navigator/navigatorimage.gif\" border=\"0\" width=\"601\" height=\"252\" /></div> 					</td> 				</tr> 				<tr height=\"320\"> 				<td width=\"200\" height=\"320\" align=\"center\" valign=\"top\" bgcolor=\"black\"><img src=\"userfiles/navigator/navigator_poster.jpg\" border=\"0\" width=\"246\" height=\"348\" /></td> 				<td height=\"320\" align=\"center\" valign=\"middle\" bgcolor=\"black\"> 				<div align=\"center\"> 					<object classid=\"clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B\" codebase=\"http://www.apple.com/qtactivex/qtplugin.cab#version=6,0,2,0\" width=\"320\" height=\"256\"><param name=\"width\" value=\"320\" /><param name=\"height\" value=\"256\" /><param name=\"src\" value=\"userfiles/navigator/navigator.mov\" /><param name=\"autoplay\" value=\"true\" /><param name=\"controller\" value=\"true\" /><embed type=\"video/quicktime\" width=\"320\" height=\"256\" src=\"userfiles/navigator/navigator.mov\" autoplay=\"true\" controller=\"true\"></embed></object> 			</div></td> 			</tr> 			<tr align=\"center\" valign=\"middle\" style=\"height: 65px\"> 				<td colspan=\"2\" height=\"45\" align=\"center\" valign=\"middle\" bgcolor=\"#ffef3b\"><strong><font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"+1\" color=\"#ff0019\">Stockade Movie Night <br /> 						</font></strong><strong><font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"+1\" color=\"#ff0019\">Saturday, January 16, 7:00pm </font></strong></td> 			</tr> 		</tbody></table>', '', '2', '90', '0', '110', '2010-01-03 16:19:04', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2010-01-03 16:19:04', '2010-01-17 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '55', '', '', '1', '61', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('136', '285', 'JJ Skiing', 'jj-skiing', '', '<p style=\"text-align: center\"><br /> </p><table border=\"0\" cellpadding=\"10\" align=\"center\" style=\"text-align: center\"><tbody><tr><td style=\"width: 500px; background-color: #000000\"><span style=\"-webkit-border-horizontal-spacing: 0px; -webkit-border-vertical-spacing: 0px\" class=\"Apple-style-span\"><p style=\"text-align: center\"><span style=\"font-weight: bold\" class=\"Apple-style-span\"><span style=\"color: #ff0000; font-size: 24px\" class=\"Apple-style-span\">JJ Wipes Out <span style=\"color: #666666; font-size: 10px; font-weight: normal; -webkit-border-horizontal-spacing: 2px; -webkit-border-vertical-spacing: 2px\" class=\"Apple-style-span\"> </span></span></span></p></span><p>&nbsp;</p><object classid=\"clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B\" codebase=\"http://www.apple.com/qtactivex/qtplugin.cab#version=6,0,2,0\" width=\"491\" height=\"381\"><param name=\"width\" value=\"491\" /><param name=\"height\" value=\"381\" /><param name=\"src\" value=\"userfiles/jj.mp4\" /><param name=\"autoplay\" value=\"false\" /><param name=\"controller\" value=\"true\" /><embed type=\"video/quicktime\" width=\"491\" height=\"381\" src=\"userfiles/jj.mp4\" autoplay=\"false\" controller=\"true\"></embed></object><p>&nbsp;</p></td></tr></tbody></table>', '', '2', '90', '0', '110', '2009-12-20 22:39:39', '242', '', '2010-01-03 16:39:58', '242', '0', '0000-00-00 00:00:00', '2009-12-20 15:00:00', '2010-01-02 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '14', '0', '56', '', '', '1', '72', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('120', '286', 'Stockade Balloon Launch 2009', 'stockade-balloon-launch-2009', '', '<div align=\"center\" style=\"color: #000000\"> 			<h2><strong><font color=\"#ff0019\">Stockade Balloon Launch 2009</font></strong></h2> 			<p><font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"-1\" color=\"#000000\"><strong>The Balloons were launched at approx 8pm, September 23, 2009.</strong></font></p> 			<p><font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"-1\" color=\"white\"><strong><font color=\"#000000\">Our previous distance record was the Maine/Canada Border </font><br /> 						and the Atlantic Ocean off the coast of Boston, MA.</strong></font></p> 			<p><a href=\"stockade/balloons/found.html\" onclick=\"window.open(\'stockade/balloons/found.html\',\'\',\'width=500,height=500,left=\'+(screen.availWidth/2-250)+\',top=\'+(screen.availHeight/2-250)+\'\');return false;\"><img src=\"http://www.2047.org/stockade/balloons/balloon-map-09.gif\" border=\"0\" width=\"475\" height=\"342\" /></a></p> 			<p><font color=\"#000000\"><a href=\"stockade/balloons/found.html\" onclick=\"window.open(\'stockade/balloons/found.html\',\'\',\'width=500,height=500,left=\'+(screen.availWidth/2-250)+\',top=\'+(screen.availHeight/2-250)+\'\');return false;\"><font face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Click the map or here to send in the location of a found balloon</strong></font></a></font></p> 			<p><font face=\"Verdana, Arial, Helvetica, sans-serif\" color=\"white\"><strong><font color=\"#000000\">For additional comments and information, </font><a href=\"mailto:jim@2047.org\">email Jim</a>.</strong></font></p><hr width=\"50%\" /><p> </p> 		</div>', '', '2', '90', '0', '110', '2009-09-21 23:00:00', '242', '', '2009-11-22 02:57:06', '242', '0', '0000-00-00 00:00:00', '2009-09-23 09:00:00', '2009-11-20 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '5', '0', '57', '', '', '1', '255', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('107', '287', 'North and South Post Skills Competition', 'north-and-south-post-skills-competition', '', '<table border=\"0\" cellspacing=\"0\" cellpadding=\"5\" width=\"480\" align=\"center\" style=\"background-color: #ffff66; height: 250px; background-image: url(\'stockade/newart/orangeLtoRgif\')\"><tbody><tr align=\"center\"><td><h2><font color=\"#000000\"> North and South Post Skills Competition</font></h2></td></tr><tr align=\"center\"><td style=\"font-size: 14px\"><p><font color=\"#000000\"><strong>Grant Fowler 1st place</strong><br />with a close <strong><br />2nd place going to <br />Josh \"Caz\" Tasker.</strong>  </font></p><p><em><strong><font color=\"#000000\">They each will receive a prize at <br />next week\'s Stockade Meeting</font></strong></em></p></td></tr></tbody></table>', '', '2', '90', '0', '110', '2009-05-28 12:27:08', '242', '', '2009-05-28 12:37:33', '242', '0', '0000-00-00 00:00:00', '2009-05-28 12:27:08', '2009-06-03 23:00:00', '', '', '{\"show_title\":0,\"link_titles\":0,\"show_intro\":0,\"show_section\":0,\"link_section\":0,\"show_category\":0,\"link_category\":0,\"show_vote\":0,\"show_author\":0,\"show_create_date\":0,\"show_modify_date\":0,\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '59', '', '', '1', '0', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('367', '288', 'Stockade Posts tentative 12/13', 'stockade-posts-tentative-1213', '', '<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br /><a target=\"_blank\" href=\"images/pdf_files/2012_2013_pdf/12-13_post.pdf\">http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/12-13_post.pdf</a><br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/12-13_post.pdf|600|800}</p>', '', '1', '102', '0', '124', '2012-10-06 00:00:57', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2012-10-06 00:00:57', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '1', '', '', '1', '2', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('338', '289', 'Camporama 12 Information', 'camporama-12-information', '', '<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br /><a href=\"images/pdf_files/2011_2012_pdf/camporamaspring2012.pdf\" target=\"_blank\">http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/camporamaspring2012.pdf</a><br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/camporamaspring2012.pdf|600|800}</p>', '', '0', '102', '0', '124', '2012-04-04 18:22:17', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2012-04-04 18:22:17', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '2', '', '', '1', '1', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('337', '290', 'Stockarama 12 Event Information', 'stockarama-12-event-information', '', '<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br /><a href=\"images/pdf_files/2011_2012_pdf/stockarama12.pdf\" target=\"_blank\">http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/stockarama12.pdf</a><br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/stockarama12.pdf|600|800}</p>', '', '0', '102', '0', '124', '2012-04-04 18:20:48', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2012-04-04 18:20:48', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '3', '', '', '1', '1', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('336', '291', 'Stockarama 12 Verses', 'stockarama-12-verses', '', '<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br /><a href=\"images/pdf_files/2011_2012_pdf/stockarama12verses.pdf\" target=\"_blank\">http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/stockarama12verses.pdf</a><br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/stockarama12verses.pdf|600|800}</p>', '', '0', '102', '0', '124', '2012-04-04 18:17:50', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2012-04-04 18:17:50', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '4', '', '', '1', '0', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('264', '292', 'Stockade - 2011 Stockarama Information', 'stockade-2011-stockarama-information', '', '<p>Here is the latest information on Stockarama competitions</p>\n<p> </p>\n<p>2011_stockarama_ldr.pdf</p>\n<p> </p>\n<p>If the letter does not show up,  use this link  http://www.2047.org/newweb/images/pdf_files/2011_stockarama_ldr.pdf    {pdf=http://www.2047.org/newweb/images/pdf_files/2011_stockarama_ldr.pdf|600|800}</p>', '', '0', '102', '0', '124', '2011-03-24 13:43:28', '242', '', '2012-04-04 18:17:44', '242', '0', '0000-00-00 00:00:00', '2011-03-24 13:43:28', '2011-05-17 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '5', '', '', '1', '1', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('263', '293', 'Leader Section test', 'leader-section-test', '', 'Leader Section test', '', '0', '102', '0', '124', '2011-03-24 13:37:33', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-03-24 13:37:33', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '6', '', '', '1', '0', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('188', '294', 'Battalion Directory', 'battalion-directory', '', '<p>{pdf=http://www.2047.org/newweb/images/battdirect.pdf|650|700}</p>', '', '1', '101', '0', '123', '2010-08-28 14:42:55', '66', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2010-08-28 14:42:55', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '1', '', '', '1', '56', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('126', '295', 'Battalion Teen Contact 2009 - 2010', 'battalion-teen-contact', '', '<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"650\" class=\"mceItemTable\"> 			<tbody><tr> 				<td align=\"center\" bgcolor=\"#006600\"> 					<p><span style=\"font-family: Georgia, \'Times New Roman\', Times, serif; color: white; font-size: x-small; \"><strong>First</strong></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#006600\"> 					<p><span style=\"font-family: Georgia, \'Times New Roman\', Times, serif; color: white; font-size: x-small; \"><strong>Last</strong></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#006600\"> 					<p><span style=\"font-family: Georgia, \'Times New Roman\', Times, serif; color: white; font-size: x-small; \"><strong>Address</strong></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#006600\"> 					<p><span style=\"font-family: Georgia, \'Times New Roman\', Times, serif; color: white; font-size: x-small; \"><strong>City</strong></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#006600\"> 					<p><span style=\"font-family: Georgia, \'Times New Roman\', Times, serif; color: white; font-size: x-small; \"><strong>State</strong></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#006600\"> 					<p><span style=\"font-family: Georgia, \'Times New Roman\', Times, serif; color: white; font-size: x-small; \"><strong>Zip</strong></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#006600\"> 					<p><span style=\"font-family: Georgia, \'Times New Roman\', Times, serif; color: white; font-size: x-small; \"><strong>Phone</strong></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#006600\"> 					<p><span style=\"font-family: Georgia, \'Times New Roman\', Times, serif; color: white; font-size: x-small; \"><strong>Birthday</strong></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#006600\"> 					<p><span style=\"font-family: Georgia, \'Times New Roman\', Times, serif; color: white; font-size: x-small; \"><strong>Parents</strong></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#006600\"> 					<p><span style=\"font-family: Georgia, \'Times New Roman\', Times, serif; color: white; font-size: x-small; \"><strong>Squad</strong></span></p> 				</td> 			</tr> 			<tr> 				<td align=\"center\" style=\"font-size: 9px\" mce_style=\"font-size: 9px\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">AJ</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Balester</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">6158 Berkley Dr</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Orchard Park</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">NY</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">14127</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">716-390-7746</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">4/2/1997 00:00:00</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><br /></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Tim Ruhl</span></span></p> 				</td> 			</tr> 			<tr> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Eric</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Bischof</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">2762 Blakeley Corners Rd</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">South Wales</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">NY</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">14139</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">(716) 652-1172</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">5/15/1995 00:00:00</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Tom (Stepdad) & Beth (Mark)</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Ryan O\'Vell</span></span></p> 				</td> 			</tr> 			<tr> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Jordan</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Bischof</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">2762 Blakeley Corners Rd</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">South Wales</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">NY</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">14139</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">(716) 652-1172</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">6/13/1992 00:00:00</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Beth/Tom(S)/Mark(F)</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Jordan Bishof</span></span></p> 				</td> 			</tr> 			<tr> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Danny</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Brown</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">271 Sycamore St</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">East Aurora</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">NY</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">14052</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">(716) 652-2886</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">9/8/1994 00:00:00</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Kate & Earl</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Jordan Bishof</span></span></p> 				</td> 			</tr> 			<tr> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Robert</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Doerfel</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">1030 Olean Rd</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">East Aurora</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">NY</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">14052</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">716-652-6193</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">9/5/1991 00:00:00</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Becky</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Tim Ruhl</span></span></p> 				</td> 			</tr> 			<tr> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Aaron</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Ellison</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">69 Carrow St</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Orchard Park</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">NY</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">14127</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">(716) 662-0473</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">5/17/1992 00:00:00</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Dale</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Jordan Bishof</span></span></p> 				</td> 			</tr> 			<tr> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Brendan</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Fitzgerald</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">60 Green Meadow Dr</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Orchard Park</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">NY</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">14127</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">716-662-1982</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">2/26/1997 00:00:00</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><br /></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Tim Ruhl</span></span></p> 				</td> 			</tr> 			<tr> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Bill</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Flaherty</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">5918 Benning Rd</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">West Falls</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">NY</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">14170</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">(716) 662-3453</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">10/31/1989 00:00:00</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Candice & Kevin</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Tim Ruhl</span></span></p> 				</td> 			</tr> 			<tr> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Grant</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Fowler</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">86 Hillside Dr</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Orchard Park</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">NY</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">14127</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">716-667-1597</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">11/7/1996 00:00:00</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><br /></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Ryan O\'Vell</span></span></p> 				</td> 			</tr> 			<tr> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Peter</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Fowler</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">86 Hillside Dr.</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Orchard Park</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">NY</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">14127</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">716-667-1597</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">6/2/1995 00:00:00</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Mike & Sue</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Tim Ruhl</span></span></p> 				</td> 			</tr> 			<tr> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Nick</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Frappa</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">6716 Gartman Rd</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Orchard Park</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">NY</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">14127</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">(716) 662-6847</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">6/12/1995 00:00:00</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Rick & Marilyn</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Jordan Bishof</span></span></p> 				</td> 			</tr> 			<tr> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Colin</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Hassen</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">25 Ventura Dr</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Orchard Park</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">NY</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">14127</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">716-662-5726</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">5/9/1996 00:00:00</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><br /></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Ryan O\'Vell</span></span></p> 				</td> 			</tr> 			<tr> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Caleb</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Johnson</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><br /></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><br /></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><br /></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><br /></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><br /></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><br /></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Frank</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Ryan O\'Vell</span></span></p> 				</td> 			</tr> 			<tr> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Brenden</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Keany</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">220 Sycamore St</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">East Aurora</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">NY</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">14052</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">(716) 655-5554</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">1/29/1995 00:00:00</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Ryan & Tammy</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Jordan Bishof</span></span></p> 				</td> 			</tr> 			<tr> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Danny</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Lumbar</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">81 Woodbine Ct</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Orchard Park</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">NY</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">14127</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">(716) 667-9748</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">5/13/1995 00:00:00</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Frank & Debbie</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Ryan O\'Vell</span></span></p> 				</td> 			</tr> 			<tr> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Zach</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">McLellan</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">7179 Ellicott Road</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Orchard Park</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">NY</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">14127</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">716-462-5167</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">1/26/1997 00:00:00</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><br /></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Ryan O\'Vell</span></span></p> 				</td> 			</tr> 			<tr> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Gary</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Newkirk</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">3474 Baker Rd</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Orchard Park</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">NY</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">14127</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">716-662-0007</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">11/9/1996 00:00:00</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><br /></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Ryan O\'Vell</span></span></p> 				</td> 			</tr> 			<tr> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Alex</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">O\'Brien</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">1030 Olean Rd</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">East Aurora</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">NY</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">14052</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">(716) 652-6193</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">3/22/1992 00:00:00</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Jim/Becky</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Jordan Bishof</span></span></p> 				</td> 			</tr> 			<tr> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Ryan</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">O\'Vell</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">7305 Ellicott Rd</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Orchard Park</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">NY</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">14127</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">(716) 667-3099</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">6/18/1992 00:00:00</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Jeff/Pam</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Ryan O\'Vell</span></span></p> 				</td> 			</tr> 			<tr> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Willy</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Rave</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">6263 Newton Rd</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Orchard Park</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">NY</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">14127</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">(716) 662-7118</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">7/17/1995 00:00:00</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Adoleh & Kristine</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Jordan Bishof</span></span></p> 				</td> 			</tr> 			<tr> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Tim</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Ruhl</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">165 Center Street</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">East Aurora</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">NY</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">14052</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">(716) 652-3711</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">12/1/1991 00:00:00</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Mark/Kellee</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Tim Ruhl</span></span></p> 				</td> 			</tr> 			<tr> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Ben</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Selden</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">7263 Ellicott Rd</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Orchard Park</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">NY</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">14127</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">716-662-6033</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><br /></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Ray & Mary</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Tim Ruhl</span></span></p> 				</td> 			</tr> 			<tr> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Drew</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Walbridge</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><br /></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><br /></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><br /></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><br /></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><br /></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><br /></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><br /></p> 				</td> 				<td align=\"center\" bgcolor=\"#eeeeee\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Jordan Bishof</span></span></p> 				</td> 			</tr> 			<tr> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Kris</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Zeigler</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">5241 S. Freeman Rd</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Orchard Park</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">NY</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">14127</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">(716) 662-4904</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">12/7/1994 00:00:00</span></span></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><br /></p> 				</td> 				<td align=\"center\" bgcolor=\"#99cc99\"> 					<p><span style=\"font-size: 9px; font-family: Arial, Helvetica, Geneva, Swiss, SunSans-Regular; \"><span style=\"font-family: Verdana, Arial, Helvetica, sans-serif; color: black; \">Jordan Bishof</span></span></p> 				</td> 			</tr> 		</tbody></table>', '', '1', '101', '0', '123', '2009-11-17 17:57:08', '242', '', '2010-08-26 13:51:04', '66', '0', '0000-00-00 00:00:00', '2009-11-18 08:57:08', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '6', '0', '2', '', '', '1', '30', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('292', '296', 'Thank you', 'thank-you', '', 'Thank you for your donation!', '', '1', '103', '0', '125', '2011-06-27 11:01:26', '242', '', '2011-06-27 11:10:27', '242', '0', '0000-00-00 00:00:00', '2011-06-27 11:01:26', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '5', '0', '1', '', '', '1', '2', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('243', '297', 'No Tree Climbers', 'no-tree-climbers', '', '<h2 style=\"text-align: center;\">\n<hr />\n</h2>\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"><span style=\"color: #ff0000;\">DUE TO ORCHARD PARK SCHOOLS <br />BEING CLOSED</span><span style=\"color: #ff0000;\"> DUE TO WEATHER</span></h2>\n<h2 style=\"text-align: center;\"><span style=\"color: #ff0000;\"><br />THERE IS NO TREE CLIMBERS OR WEDNESDAY STOCKADE TONIGHT (2/2/11)</span></h2>\n<h2 style=\"text-align: center;\"><span style=\"color: #ffff00;\"><br /><strong>IF YOU NEED TO BUY A DERBY CAR BEFORE NEXT WEDNESDAY<br />CALL ME @ 662-0335 AND I CAN MEET YOU AT THE GYM ANYTIME</strong></span><span style=\"color: #ffff00;\"><strong>&nbsp;</strong> </span></h2>\n<p><span style=\"color: #ffff00;\"><br /></span></p>\n<p> </p>\n<hr />', '', '1', '91', '0', '112', '2011-02-02 18:32:07', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-02-02 18:32:07', '2011-02-03 04:59:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '1', '', '', '1', '0', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('184', '298', 'About Tree Climbers', 'about-tree-climbers', '', '<p><strong>Christian Service Brigade #2047</strong> is a boys and teens group from the Wesleyan Church of Orchard Park.  Brigade #2047 has been active in Orchard Park since the early 1960\'s.</p>\n<p> </p>\n<p><a href=\"index.php?option=com_content&view=category&id=39:tree-climbers&layout=blog&Itemid=55\"><strong>Tree Climbers</strong></a><a href=\"option=com_content&view=section&layout=blog&id=7&Itemid=55\"><strong> </strong></a>(Wednesday\'s 7-8:30pm) is a Father/Son group for boys aged 6 - 7.</p>\n<ul>\n<li>Fathers and sons spend time in games, crafts, verse memorizing and story time. </li>\n</ul>\n<p> </p>\n<p>Tree Climbers has a number of special activities during the year including a <a href=\"index.php?option=com_wrapper&view=wrapper&Itemid=79\">Pinewood Derby</a> & <a href=\"index.php?option=com_wrapper&view=wrapper&Itemid=79\">Creature Feature</a>!</p>\n<p><br /> More information on CSB #2047 can be <a href=\"../index.php?option=com_content&view=section&id=13&layout=blog&Itemid=67\">found here</a>.</p>', '', '1', '91', '0', '112', '2010-08-26 13:21:27', '242', '', '2010-08-31 13:10:44', '242', '0', '0000-00-00 00:00:00', '2010-08-26 13:21:27', '0000-00-00 00:00:00', '', '', '{\"show_title\":0,\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":0,\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '3', '0', '2', '', '', '1', '86', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('299', '299', 'TREE CLIMBERS BEGINS TONIGHT!', 'tree-climbers-begins-tonight', '', '<p> </p>\n<hr />\n<p style=\"text-align: center;\"><span style=\"font-size: 18pt; color: #ffff00;\"><strong>TREE CLIMBERS BEGINS TONIGHT!</strong></span></p>\n<p style=\"text-align: center;\"><span style=\"font-size: 18pt; color: #ffff00;\"><em><br />for boys aged 6 &amp; 7 and their Dad<br /></em></span></p>\n<p style=\"text-align: center;\"><br /><span style=\"font-size: 18pt; color: #ffff00;\"> <strong>7pm - 8:30</strong></span></p>\n<p style=\"text-align: center;\"><strong> \n<hr />\n<br /></strong></p>', '', '2', '91', '0', '113', '2011-09-14 05:00:00', '242', '', '2011-09-09 15:15:16', '242', '0', '0000-00-00 00:00:00', '2011-09-14 05:00:00', '2011-09-14 16:50:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '1', '', '', '1', '2', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('343', '300', 'No Tree Climbers', 'no-tree-climbers', '', '<p> </p>\n<p style=\"text-align: center;\"><img width=\"84\" height=\"84\" src=\"images/stories/exclamation.gif\" /></p>\n<p style=\"text-align: center;\"><strong><br /> <br /><span style=\"font-size: 12pt;\">Tree Climbers will not be active this year.</span></strong></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"font-size: 12pt;\"><strong>If during the year we have enough boys and a leader <br />we will schedule a start date.</strong></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"font-size: 12pt;\"><strong>Until then look for Tree Climbers next year.</strong></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"font-size: 12pt;\">Any questions, <a href=\"mailto:jim@2047.org\">contact Jim</a>.</span></p>\n<p> </p>\n<p><strong><br /></strong></p>', '', '1', '91', '0', '113', '2012-09-08 05:00:00', '242', '', '2012-09-08 18:00:34', '242', '0', '0000-00-00 00:00:00', '2012-09-08 05:00:00', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '6', '0', '1', '', '', '1', '168', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('139', '301', 'Pinewood Derby \'10', 'pinewood-derby-10', '', '<br /><table border=\"1\" cellspacing=\"2\" cellpadding=\"0\" width=\"550\" style=\"text-align: center\"> 				<tbody><tr> 					<td bgcolor=\"#beffff\"> 						<div align=\"center\"> </div><div align=\"center\"><span style=\"color: #000000; font-size: 32px; font-weight: bold\" class=\"Apple-style-span\">It\'s Pinewood Derby Time!</span></div><div align=\"center\"><span style=\"color: #000000; font-weight: bold\" class=\"Apple-style-span\"> 								Cars available starting January 6</span></div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"><table border=\"1\" cellspacing=\"2\" cellpadding=\"0\" width=\"386\" bgcolor=\"#fffaaa\"> 								<tbody><tr> 									<td> 										<div align=\"center\"> 											<p><font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"-1\">Kit \'s available for purchase until March 1st. <br /> 													Cost is $9/kit.</font><font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"-1\"><br /> 												</font></p> 											<p><font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"-1\"><em><font size=\"+1\" color=\"#ff6600\"><strong>Need help making the derby car?</strong></font><font color=\"#ff6600\"><strong> <br /> 															</strong></font></em></font></p> 											<p><font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"-1\"><em><font color=\"#ff6600\"><strong>Derby Car Help Days</strong></font></em></font></p> 											<p><font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"-1\" color=\"#ff6600\"><strong>Saturday, January 23, 11-2 <br /> 														Saturday, February 6, 9-12 <br /> 														Sunday, February 21, 2-5</strong></font></p> 											<hr width=\"75%\" size=\"7\" /> 											<p><font face=\"Trebuchet MS, Geneva, Arial, Helvetica, SunSans-Regular, sans-serif\" size=\"+2\" color=\"#cc0033\"><strong>Important Dates</strong></font></p> 											<p><font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"-1\"><strong>Saturday, February 27th -<br /> 														Test Day (voluntary) 11-3</strong></font></p> 											<p><font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"-1\"><strong>Wednesday March 3rd <br /> 													</strong>Wednesday Stockade & TC Due Day</font></p> 											<p><font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"-1\"><strong>Tuesday, March 9th<br /> 													</strong>RACE DAY FOR STOCKADE AND TC</font></p> 											<p><font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"-1\"><em><strong>Wednesday, March 10th<br /> 														</strong>No Stockade (Pioneer Girls Derby)</em></font></p> 											<p><font face=\"Verdana, Arial, Helvetica, sans-serif\" size=\"-1\">Saturday, March 13th<br /> 													REGIONAL FINALS FOR TOP 5 RACERS</font></p> 										</div> 									</td> 								</tr> 							</tbody></table> 							<p><font color=\"#cc0033\"><span style=\"color: #ff0000; font-size: 24px; font-weight: bold\" class=\"Apple-style-span\">Race Day is Tuesday, March 9th!</span><br /> 									 							</font><font size=\"-1\"><strong>Races begin at 7pm, you can arrive starting at 6:20 to lubricate your car. <br /> 											Cars will be collected at 6:55pm!<br /> 									</strong></font></p> 							<div align=\"center\"> 								<h3><font color=\"#8e0000\"><strong>Time to buy and work on your car - if you need help contact Jim</strong></font></h3> 							</div> 							<div align=\"center\"> 								<p><strong><a href=\"derby/\" target=\"_blank\">All the dates and information are here</a></strong></p> 								<p><img src=\"stockade/photoalbum/derby09/Thumbnails/1.jpg\" border=\"0\" width=\"240\" height=\"180\" align=\"middle\" />. . <img src=\"stockade/photoalbum/derby09/Thumbnails/24.jpg\" border=\"0\" align=\"middle\" /></p> 								<p><font size=\"-1\"><strong><a href=\"stockade/photoalbum/\" target=\"_blank\">2003 Car Photos</a> <font color=\"#ff0000\">\"</font> <a href=\"stockade/photoalbum/\" target=\"_blank\">2004 Car Photos</a> <font color=\"#ff0000\">\"</font> <a href=\"stockade/photoalbum/\" target=\"_blank\">2005 Car Photos</a> <br /> 											<a href=\"stockade/photoalbum/\" target=\"_blank\">2006 Car Photos</a> <font color=\"#ff0000\">\"</font> <a href=\"stockade/photoalbum/\" target=\"_blank\">2007 Car Photos</a> <font color=\"#ff0000\">\"</font> <a href=\"stockade/photoalbum/\" target=\"_blank\">2008 Car Photos</a> <span style=\"color: #ff0000\" class=\"Apple-style-span\">\"</span> <a href=\"stockade/photoalbum/\" target=\"_blank\">2009 Car Photos</a><span style=\"font-size: 24px; font-weight: normal\" class=\"Apple-style-span\"> </span></strong></font></p> 								<p><a href=\"derby/derbylinks.html\" target=\"_blank\">Page with Derby Links, How-to Video\'s, etc. </a></p> 								<p style=\"text-align: center\"><img src=\"derby/pinem1.gif\" border=\"0\" title=\"Derby\" width=\"540\" height=\"20\" align=\"middle\" /></p> 							</div> 						</div> 					</td> 				</tr> 			</tbody></table>', '', '2', '91', '0', '113', '2010-01-04 01:49:44', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2010-01-04 01:49:44', '2010-03-12 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '2', '', '', '1', '283', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('219', '302', 'Creature Feature 2012 TC', 'creature-feature-2011', '', '<div align=\"center\">\n<table border=\"0\" cellpadding=\"10\" cellspacing=\"1\" width=\"628\">\n<tbody>\n<tr>\n<td colspan=\"3\" bgcolor=\"#00ff66\">\n<h1 align=\"center\"></h1>\n<h1 align=\"center\"><strong><span style=\"color: black; font-size: small;\">Creature Feature 10<br /></span></strong></h1>\n<div align=\"center\"><strong><span style=\"color: black; font-size: small;\"><br /></span></strong></div>\n<div align=\"center\">\n<p><span style=\"color: #800000;\"><strong style=\"font-size: 16px;\">January 18th - You Don\'t Want to Miss This!</strong></span></p>\n<p><span style=\"color: #800000;\"><strong style=\"font-size: 16px;\"><br /></strong></span></p>\n<p><img src=\"../stockade/photoalbum/reptile.gif\" align=\"middle\" border=\"0\" />--<img style=\"vertical-align: middle;\" src=\"stockade/photoalbum/creaturefeature8/Thumbnails/67.jpg\" height=\"179\" width=\"240\" /></p>\n<p><img src=\"stockade/photoalbum/creaturefeature8/Thumbnails/34.jpg\" border=\"0\" height=\"178\" width=\"240\" />&nbsp; <img src=\"stockade/photoalbum/creaturefeature8/Thumbnails/8.jpg\" border=\"0\" height=\"180\" width=\"240\" /></p>\n<p><a href=\"stockade/photoalbum/\" target=\"_blank\">See photographs and movies from the events from other years!</a></p>\n<p> </p>\n<p> </p>\n</div>\n</td>\n</tr>\n</tbody>\n</table>\n</div>', '', '1', '91', '0', '113', '2011-12-27 05:00:00', '242', '', '2011-12-27 14:16:22', '242', '0', '0000-00-00 00:00:00', '2011-12-27 05:00:00', '2012-01-20 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '4', '0', '2', '', '', '1', '35', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('221', '303', 'Derby Time! 11', 'derby-time-11', '', '<br /> \n<table style=\"text-align: center; width: 550px;\" border=\"1\" cellpadding=\"0\" cellspacing=\"2\">\n<tbody>\n<tr>\n<td bgcolor=\"#beffff\">\n<div align=\"center\"><span style=\"color: #000000; font-size: xx-large;\"><span style=\"font-size: 32px;\"><strong><br /></strong></span></span></div>\n<div align=\"center\"><img src=\"images/stories/derby-seal.gif\" height=\"133\" width=\"133\" /></div>\n<div align=\"center\"></div>\n<div align=\"center\"><span style=\"color: #000000; font-size: 32px; font-weight: bold;\">It\'s Pinewood Derby Time!</span><span style=\"color: #000000; font-weight: bold;\"><br /> </span></div>\n<div align=\"center\"></div>\n<div align=\"center\"><span style=\"color: #000000; font-weight: bold;\">Cars available starting January 5<br /></span></div>\n<div align=\"center\">&nbsp;</div>\n<div align=\"center\">\n<table style=\"width: 386px;\" bgcolor=\"#fffaaa\" border=\"1\" cellpadding=\"0\" cellspacing=\"2\">\n<tbody>\n<tr>\n<td>\n<div style=\"color: #000000;\" align=\"center\">\n<p> </p>\n<p><em><strong style=\"color: #000000;\"><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\">Kit \'s available for purchase until March 1st. <br /> Cost is $9/kit.</span><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\">&nbsp;</span></strong></em></p>\n<p><em><strong><br /></strong></em></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><em><span style=\"color: #ff6600; font-size: xx-small;\"><strong>Need help making the derby car?</strong></span><span style=\"color: #ff6600;\"><strong> <br /> </strong></span></em></span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><em><span style=\"color: #ff6600;\"><strong>Derby Car Help Days</strong></span></em></span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif; color: #ff6600;\"><strong>Saturday, January 22, 11-2 <br /> Saturday, February 5, 9-12 <br /> Saturday, February 19, 2-5</strong></span></p>\n<hr />\n<p><span style=\"font-family: Trebuchet MS,Geneva,Arial,Helvetica,SunSans-Regular,sans-serif; color: #cc0033; font-size: x-small;\"><strong>Important Dates</strong></span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><strong>Saturday, February 26th -<br /> Test Day (voluntary) 11-3</strong></span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><strong><br /></strong></span></p>\n<p><span style=\"font-family: verdana,geneva;\"><strong>Tuesday March 1st </strong></span><strong><br />&nbsp; </strong><span style=\"font-family: verdana,geneva;\">Tuesday Stockade Due Day</span><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><strong><br /><br />Wednesday March 2nd <br /> </strong>Wednesday Stockade &amp; TC Due Day</span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><br /></span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif; color: #000000;\"><strong>Tuesday, March 8th<br /> </strong>RACE DAY FOR STOCKADE AND TC</span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif; color: #000000;\"><br /></span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><em><strong>Wednesday, March 9th<br /> </strong>No Stockade (Pioneer Girls Derby)</em></span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><em><br /></em></span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><strong>Saturday, March 12th</strong><br /> REGIONAL FINALS FOR TOP 5 RACERS</span></p>\n<p> </p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><a href=\"index.php?option=com_content&amp;view=article&amp;id=220:pinewood-derby-rules-a-information-2011&amp;catid=54&amp;Itemid=97\"><strong>Derby Instruction &amp; Rule sheet available here</strong></a><br /></span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><br /></span></p>\n</div>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n<div align=\"center\">\n<p> </p>\n<p> </p>\n<p><span style=\"color: #cc0033;\"><span style=\"color: #ff0000; font-size: 24px; font-weight: bold;\">Race Day is Tuesday, March 8th!</span><br /> </span><strong>&nbsp;</strong></p>\n<p> </p>\n<p><strong style=\"color: #000000;\">Races begin at 7pm, you can arrive starting at 6:20 to lubricate your car. <br /> Cars will be collected at 6:55pm!<br /> </strong></p>\n<div align=\"center\">\n<h3><span style=\"color: #8e0000;\"><strong>Time to buy and work on your car - if you need help contact Jim</strong></span></h3>\n</div>\n<div align=\"center\">\n<p><strong><a target=\"_blank\" href=\"derby/\">All the dates and information are here</a></strong></p>\n<p> </p>\n<p><img src=\"stockade/photoalbum/derby09/Thumbnails/1.jpg\" height=\"180\" width=\"240\" align=\"middle\" border=\"0\" />. . <img src=\"stockade/photoalbum/derby09/Thumbnails/24.jpg\" align=\"middle\" border=\"0\" /></p>\n<p> </p>\n<p><strong><a target=\"_blank\" href=\"stockade/photoalbum/\">2003 Car Photos</a> <span style=\"color: #ff0000;\">\"</span> <a target=\"_blank\" href=\"stockade/photoalbum/\">2004 Car Photos</a> <span style=\"color: #ff0000;\">\"</span> <a target=\"_blank\" href=\"stockade/photoalbum/\">2005 Car Photos</a> <br /> <a target=\"_blank\" href=\"stockade/photoalbum/\">2006 Car Photos</a> <span style=\"color: #ff0000;\">\"</span> <a target=\"_blank\" href=\"stockade/photoalbum/\">2007 Car Photos</a> <span style=\"color: #ff0000;\">\"</span> <a target=\"_blank\" href=\"stockade/photoalbum/\">2008 Car Photos</a> <br /><span style=\"color: #ff0000;\">\"</span> <a target=\"_blank\" href=\"stockade/photoalbum/\">2009 Car Photos</a> </strong><strong style=\"color: #fc0c02;\">\" </strong><strong><a href=\"../stockade/photoalbum/derby10/\" target=\"_blank\">2010 Car Photos</a><a target=\"_blank\" href=\"stockade/photoalbum/\"></a><span style=\"font-size: 24px; font-weight: normal;\"> </span></strong></p>\n<p> </p>\n<p><a target=\"_blank\" href=\"derby/derbylinks.html\">Page with Derby Links, How-to Video\'s, etc.</a></p>\n<p> </p>\n<p style=\"text-align: center;\"><img title=\"Derby\" src=\"derby/pinem1.gif\" height=\"20\" width=\"540\" align=\"middle\" border=\"0\" /></p>\n</div>\n</div>\n</td>\n</tr>\n</tbody>\n</table>', '', '2', '91', '0', '113', '2010-12-27 18:20:47', '242', '', '2010-12-27 19:12:36', '242', '0', '0000-00-00 00:00:00', '2010-12-27 05:00:00', '2011-03-13 06:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '5', '0', '2', '', '', '1', '34', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('155', '304', 'QOW #236', 'qow-236', '', '<div style=\"font-size: 10px; text-align: left; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666; background-color: #ffffff;\">\n<p> </p>\n<table style=\"background-color: #ffff66; height: 143px; width: 621px;\" align=\"center\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\">\n<tbody>\n<tr>\n<td style=\"border: 1px solid #cccc99; background-color: #ffff66; font-family: Verdana,Arial,Helvetica,sans-serif; font-size: 10px;\" valign=\"middle\">\n<h2 align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" alt=\" \" align=\"middle\" border=\"0\" height=\"55\" width=\"150\" /><strong style=\"color: #000000;\">#236</strong></h2>\n<div align=\"center\"><br /><img src=\"images/stories/pinego.gif\" /></div>\n<h2 style=\"color: #000000;\" align=\"center\">Who came in First Place at this year\'s (2010) Pinewood Derby?</h2>\n<p> </p>\n<p style=\"text-align: center;\"><img src=\"images/stories/pinem1.gif\" /></p>\n<p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question!</a></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>', '', '0', '90', '0', '109', '2010-02-23 14:04:57', '242', '', '2010-02-23 14:09:31', '242', '0', '0000-00-00 00:00:00', '2010-03-10 01:00:00', '2010-03-17 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '3', '0', '52', '', '', '1', '7', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('154', '305', 'QOW #235', 'qow-235', '', '<div style=\"font-size: 10px; text-align: left; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666; background-color: #ffffff;\">\n<p> </p>\n<table style=\"background-color: #ffff66; height: 143px; width: 621px;\" align=\"center\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\">\n<tbody>\n<tr>\n<td style=\"border: 1px solid #cccc99; background-color: #ffff66; font-family: Verdana,Arial,Helvetica,sans-serif; font-size: 10px;\" valign=\"middle\">\n<h2 align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" alt=\" \" align=\"middle\" border=\"0\" height=\"55\" width=\"150\" /><strong style=\"color: #000000;\">#235</strong></h2>\n<div align=\"center\"><br /><img src=\"images/stories/pinego.gif\" /></div>\n<h2 style=\"color: #000000;\" align=\"center\">Who came in First Place at last year\'s (2009) Pinewood Derby?</h2>\n<p> </p>\n<p style=\"text-align: center;\"><img src=\"images/stories/pinem1.gif\" /></p>\n<p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question!</a></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>', '', '0', '90', '0', '109', '2010-02-23 14:02:07', '242', '', '2010-02-23 14:04:46', '242', '0', '0000-00-00 00:00:00', '2010-03-04 01:00:00', '2010-03-09 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '53', '', '', '1', '7', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('153', '306', 'QOW #234', 'qow-234', '', '<div style=\"font-size: 10px; text-align: left; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666; background-color: #ffffff;\">\n<p> </p>\n<table style=\"background-color: #ffff66; height: 143px; width: 621px;\" align=\"center\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\">\n<tbody>\n<tr>\n<td style=\"border: 1px solid #cccc99; background-color: #ffff66; font-family: Verdana,Arial,Helvetica,sans-serif; font-size: 10px;\" valign=\"middle\">\n<h2 align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" alt=\" \" align=\"middle\" border=\"0\" height=\"55\" width=\"150\" /><strong style=\"color: #000000;\">#234</strong></h2>\n<div align=\"center\"><br /><img src=\"images/stories/pinego.gif\" /></div>\n<h2 style=\"color: #000000;\" align=\"center\">Our Stockade has been having a yearly Pinewood Derby for a long time. <br />What number Pinewood Derby will this year\'s be?</h2>\n<p> </p>\n<p style=\"text-align: center;\"><img src=\"images/stories/pinem1.gif\" /></p>\n<p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question!</a></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>', '', '0', '90', '0', '109', '2010-02-23 13:55:19', '242', '', '2010-02-25 12:27:43', '242', '0', '0000-00-00 00:00:00', '2010-02-25 11:00:00', '2010-03-04 08:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '3', '0', '54', '', '', '1', '51', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('167', '307', 'QOW# 241', 'qow-241', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666; background-color: #ffffff;\">\n<p> </p>\n<table style=\"background-color: #ffff66; width: 621px; height: 143px;\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"border: 1px solid #cccc99; background-color: #ffff66; font-family: Verdana,Arial,Helvetica,sans-serif; font-size: 10px; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\">Question of the Week</h2>\n<h2 style=\"text-align: center;\"><img alt=\" \" src=\"stockade/newart/QOW_animated.gif\" border=\"0\" height=\"55\" width=\"150\" /><strong>#241</strong></h2>\n<div style=\"text-align: center;\"><br />\n<h2 style=\"color: #000000; text-align: center;\">How many pounds of \"Beef\" did our Stockade use <br />to make our Hobo Stew at Stockarama?</h2>\n<p> </p>\n<p><img src=\"stockade/photoalbum/stockarama2010/Thumbnails/91.jpg\" /></p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\" href=\"stockade/qownewest.html\">Click Here to answer the Question!</a></strong></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '2', '90', '0', '109', '2010-05-11 12:37:38', '242', '', '2010-05-20 18:13:39', '242', '0', '0000-00-00 00:00:00', '2010-05-11 12:37:38', '2010-05-26 23:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '55', '', '', '1', '14', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', '');

INSERT INTO tkt_content
(`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES 
('117', '308', 'QOW #215', 'qow-217', '', '<p>&nbsp;</p><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" align=\"center\" style=\"background-color: #ffff66; height: 143px\"> <tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; font-size: 12px; background-color: #ffff66\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#217</strong> </div>        <div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"><font style=\"font-size: 14px\" color=\"#ff0000\"><strong>THE SANDLOT TRIVIA!</strong></font></div><div align=\"center\"> </div><div align=\"center\"><img src=\"images/stories/images-1.jpeg\" border=\"0\" /> <br /></div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"><font style=\"font-size: 12px\" color=\"#000000\">What is this kid\'s nickname in \"The Sandlot\"</font></div><div align=\"center\"> </div><div align=\"center\"><font color=\"#000000\">- AND -<br /></font></div><div align=\"center\"><font color=\"#000000\"> </font></div><div align=\"center\"><font color=\"#000000\">What is it his friends kept telling him that he was doing to them? </font><br /></div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question! </a></p>  </td></tr></tbody> </table><div align=\"center\"><br /></div><div align=\"center\"><br /></div><div align=\"center\"><br /></div>', '', '0', '90', '0', '109', '2009-09-02 12:40:31', '242', '', '2009-09-02 13:00:52', '242', '0', '0000-00-00 00:00:00', '2009-09-10 00:30:00', '2009-09-16 21:30:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '3', '0', '55', '', '', '1', '0', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('163', '309', 'QOW #240', 'qow-240', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666; background-color: #ffffff;\">\n<p> </p>\n<table style=\"background-color: #ffff66; width: 621px; height: 143px;\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"border: 1px solid #cccc99; background-color: #ffff66; font-family: Verdana,Arial,Helvetica,sans-serif; font-size: 10px; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\"><img alt=\" \" src=\"stockade/newart/QOW_animated.gif\" border=\"0\" height=\"55\" width=\"150\" /><strong>#240</strong></h2>\n<div style=\"text-align: center;\"><br />\n<h2 style=\"color: #000000; text-align: center;\">What is the name of this cartoon character?</h2>\n<p><img src=\"images/stories/qow240.jpg\" /></p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\" href=\"stockade/qownewest.html\">Click Here to answer the Question!</a></strong></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '2', '90', '0', '109', '2010-04-29 13:29:27', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2010-04-29 13:29:27', '2010-05-05 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '56', '', '', '1', '4', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('95', '310', 'QOW #209', 'qow-209', '', '<p>&nbsp;</p><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" align=\"center\" style=\"background-color: #ffff66; height: 143px\"> <tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#209</strong> </div>        <div align=\"center\"> <br /></div><p align=\"center\">If you had a patrol boat and a submarine, what game would you be playing? </p><div align=\"center\"> <br /></div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question! </a></p>  </td></tr></tbody> </table><div align=\"center\"><br /></div><div align=\"center\"><br /></div><div align=\"center\"><br /></div>', '', '0', '90', '0', '109', '2009-02-19 17:11:10', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2009-03-12 03:30:00', '2009-03-18 21:30:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '56', '', '', '1', '310', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('106', '311', 'QOW #212', 'qow-212', '', '<div><br />  </div><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"492\" align=\"center\" style=\"background-color: #ffff66; height: 173px\"> <tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#212</strong> </div>        <div align=\"center\"> <br /></div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div><div align=\"center\"><a href=\"stockade/qow212puzzle\">CLICK HERE TO SOLVE THE PUZZLE</a><br /></div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\"></a></p>  </td></tr></tbody> </table>', '', '2', '90', '0', '109', '2009-05-26 17:08:35', '242', '', '2009-05-26 17:17:17', '242', '0', '0000-00-00 00:00:00', '2009-05-26 17:08:35', '2009-05-27 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '3', '0', '57', '', '', '1', '2', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('116', '312', 'QOW #216', 'qow-216', '', '<p>&nbsp;</p><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" align=\"center\" style=\"background-color: #ffff66; height: 143px\"> <tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#216</strong> </div>        <div align=\"center\"> </div><div align=\"center\"><font style=\"font-size: 14px\" color=\"#ff0000\"><strong>THE SANDLOT TRIVIA  </strong></font><br /></div><div align=\"center\"> </div><div align=\"center\"><img src=\"images/stories/images.jpeg\" border=\"0\" /> <br /></div><div align=\"center\"> </div><div align=\"center\"><font style=\"font-size: 12px\" color=\"#000000\">When Squints told the boys about the legend of \"The Beast\", <br />he told them that \"The Beast\" was ordered to be locked up in the backyard for how long?</font></div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question! </a></p>  </td></tr></tbody> </table><div align=\"center\"><br /></div><div align=\"center\"><br /></div><div align=\"center\"><br /></div>', '', '0', '90', '0', '109', '2009-09-02 12:33:24', '242', '', '2009-09-02 12:57:50', '242', '0', '0000-00-00 00:00:00', '2009-09-17 00:30:00', '2009-09-23 21:30:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '57', '', '', '1', '0', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('161', '313', 'QOW #239', 'qow-239', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666; background-color: #ffffff;\">\n<p> </p>\n<table cellspacing=\"3\" cellpadding=\"4\" border=\"3\" style=\"background-color: #ffff66; width: 621px; height: 143px;\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66; font-family: Verdana,Arial,Helvetica,sans-serif; font-size: 10px; text-align: left;\">\n<h2 style=\"text-align: center;\"><img width=\"150\" height=\"55\" border=\"0\" alt=\" \" src=\"stockade/newart/QOW_animated.gif\" /><strong>#239</strong></h2>\n<div style=\"text-align: center;\"><br />\n<h2 style=\"color: #000000; text-align: center;\">Identify the 3 Stockaders in this photograph. <br />Only the first name is OK.</h2>\n<p><img src=\"stockade/photoalbum/hiking/Thumbnails/4.jpg\" /></p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\" href=\"stockade/qownewest.html\">Click Here to answer the Question!</a></strong></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '2', '90', '0', '109', '2010-04-12 11:28:12', '242', '', '2010-04-15 00:26:16', '242', '0', '0000-00-00 00:00:00', '2010-04-12 11:28:12', '2010-04-28 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '58', '', '', '1', '57', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('94', '314', 'QOW #208', 'qow-208', '', '<div><br />  </div><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" align=\"center\" style=\"background-color: #ffff66; height: 143px\"> <tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#208</strong> </div>        <div align=\"center\"> <br /></div><p align=\"center\">In the TV Show \"Home Improvement\", Al has a brother named what?<br /> </p><div align=\"center\"> <br /></div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question! </a></p>  </td></tr></tbody> </table><div align=\"center\"><br /></div><div align=\"center\"><br /></div><div align=\"center\"><br /></div>', '', '0', '90', '0', '109', '2009-02-19 17:02:22', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2009-03-05 03:00:00', '2009-03-11 21:30:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '58', '', '', '1', '321', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('160', '315', 'QOW #238', 'qow-238', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666; background-color: #ffffff;\">\n<p> </p>\n<table style=\"background-color: #ffff66; height: 143px; width: 621px;\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"border: 1px solid #cccc99; background-color: #ffff66; font-family: Verdana,Arial,Helvetica,sans-serif; font-size: 10px; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\"><img src=\"stockade/newart/QOW_animated.gif\" alt=\" \" border=\"0\" height=\"55\" width=\"150\" /><strong style=\"color: #000000;\">#238</strong></h2>\n<div style=\"text-align: center;\"><br />\n<h2 style=\"color: #000000; text-align: center;\">The Brigade Flag we use at line-up has a symbol on it. <br />What items are in this symbol?</h2>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question!</a></strong></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '2', '90', '0', '109', '2010-03-25 13:39:44', '242', '', '2010-03-25 13:45:10', '242', '0', '0000-00-00 00:00:00', '2010-03-25 13:39:44', '2010-03-31 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '59', '', '', '1', '19', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('93', '316', 'QOW #207', 'qow-207', '', '<div><br />  </div><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" align=\"center\" style=\"background-color: #ffff66; height: 143px\"> <tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#207</strong> </div>        <div align=\"center\"> <br /></div><p align=\"center\">What are the names of the kids in the Brady Bunch? <br /> </p><div align=\"center\"> <br /></div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question! </a></p>  </td></tr></tbody> </table><div align=\"center\"><br /></div><div align=\"center\"><br /></div><div align=\"center\"><br /></div>', '', '0', '90', '0', '109', '2009-02-19 16:59:33', '242', '', '2009-02-19 17:02:11', '242', '0', '0000-00-00 00:00:00', '2009-02-25 16:59:33', '2009-03-04 21:30:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '59', '', '', '1', '346', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('92', '317', 'QOW #206', 'qow-206', '', '<div><br />  </div><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" align=\"center\" style=\"background-color: #ffff66; height: 143px\"> <tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#206</strong> </div>        <div align=\"center\"> <br /></div><p align=\"center\">In a professional Baseball game, where do pitchers get warmed up? </p><div align=\"center\"> <br /></div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question! </a></p>  </td></tr></tbody> </table><div align=\"center\"><br /></div><div align=\"center\"><br /></div><div align=\"center\"><br /></div>', '', '0', '90', '0', '109', '2009-02-19 16:52:57', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2009-02-19 16:52:57', '2009-02-25 21:30:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '60', '', '', '1', '538', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('88', '318', 'QOW #203', 'qow-203', '', '<div><br />  </div><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" align=\"center\" style=\"background-color: #ffff66; height: 143px\"> <tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#203</strong> </div>        <div align=\"center\"> <br /></div><p align=\"center\">Former prisoners from England came to settle which colony? <br /> </p><div align=\"center\"> <br /></div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question! </a></p>  </td></tr></tbody> </table><div align=\"center\"><br /></div><div align=\"center\"><br /></div><div align=\"center\"><br /></div>', '', '0', '90', '0', '109', '2009-01-09 01:36:35', '242', '', '2009-01-15 03:45:10', '242', '0', '0000-00-00 00:00:00', '2009-01-22 03:30:00', '2009-01-28 21:30:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '4', '0', '61', '', '', '1', '757', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('87', '319', 'QOW #202', 'qow-202', '', '<div><br />  </div><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" align=\"center\" style=\"background-color: #ffff66; height: 143px\"> <tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#202</strong> </div>        <div align=\"center\"> <br /></div><p align=\"center\">In honor of Creature Feature Week, what is the name of this creature? </p><div align=\"center\"><img src=\"images/stories/25.jpg\" border=\"0\" /><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question! </a></p>  </td></tr></tbody> </table><div align=\"center\"><br /></div><div align=\"center\"><br /></div><div align=\"center\"><br /></div>', '', '0', '90', '0', '109', '2009-01-09 01:32:13', '242', '', '2009-01-15 03:44:34', '242', '0', '0000-00-00 00:00:00', '2009-01-15 03:05:00', '2009-01-21 08:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '7', '0', '62', '', '', '1', '672', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('89', '320', 'QOW #205', 'qow-205', '', '<div><br />  </div><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" align=\"center\" style=\"background-color: #ffff66; height: 143px\"> <tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#205</strong> </div>        <div align=\"center\"> <br /></div><p align=\"center\">Out of the first 5 Presidents, 4 came from which colony?  <br /> </p><div align=\"center\"> <br /></div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question! </a></p>  </td></tr></tbody> </table><div align=\"center\"><br /></div><div align=\"center\"><br /></div><div align=\"center\"><br /></div>', '', '0', '90', '0', '109', '2009-01-09 01:40:48', '242', '', '2009-01-15 03:46:04', '242', '0', '0000-00-00 00:00:00', '2009-02-05 03:30:00', '2009-02-11 21:30:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '5', '0', '63', '', '', '1', '605', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('146', '321', 'QOW #231', 'qow-231', '', '<div style=\"font-size: 10px; text-align: left; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666; background-color: #ffffff;\">\n<p> </p>\n<table style=\"background-color: #ffff66; height: 143px; width: 621px;\" align=\"center\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\">\n<tbody>\n<tr>\n<td style=\"border: 1px solid #cccc99; background-color: #ffff66; font-family: Verdana,Arial,Helvetica,sans-serif; font-size: 10px;\" valign=\"middle\">\n<h2 align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" alt=\" \" align=\"middle\" border=\"0\" height=\"55\" width=\"150\" /><span style=\"font-size: 12pt;\"><strong style=\"color: #000000;\">#231</strong></span></h2>\n<div align=\"center\"><br /><img src=\"images/stories/31.jpg\" /></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<h2 style=\"color: #000000;\" align=\"center\">What is the name of this creature from Creature Feature night?</h2>\n<p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question!</a></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>', '', '2', '90', '0', '109', '2010-01-22 12:15:08', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2010-01-28 01:00:00', '2010-02-03 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '64', '', '', '1', '21', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('86', '322', 'QOW #201', 'qow-201', '', '<div><br />  </div><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" height=\"143\" style=\"background-color: #ffff66\"> <tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#201</strong> </div>        <div align=\"center\"> <br /></div><p align=\"center\">One of thirteen original colonies was named after someone who\'s first name was Henrietta. Which state? </p><div align=\"center\"> <br /></div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question! </a></p>  </td></tr></tbody> </table><div align=\"center\"><br /></div><div align=\"center\"><br /></div>', '', '0', '90', '0', '109', '2009-01-09 01:23:40', '242', '', '2009-01-09 01:50:14', '242', '0', '0000-00-00 00:00:00', '2009-01-09 01:23:40', '2009-01-14 21:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '64', '', '', '1', '612', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('137', '323', 'QOW #228', 'qow-228', '', '<div><br />  </div><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"492\" align=\"center\" style=\"background-color: #ffff66; height: 173px\"> <tbody><tr><td valign=\"middle\" style=\"background-color: #ffff66; border-width: 1px; border-color: #cccc99; border-style: solid\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong style=\"font-size: 24px; color: #000000\"><span style=\"text-decoration: underline\" class=\"Apple-style-span\">#228</span></strong></div>        <div align=\"center\"> <br /></div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div><div align=\"center\"><a href=\"stockade/qow228puzzle\" target=\"_blank\">CLICK HERE TO SOLVE THE PUZZLE</a><br /></div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\"></a></p>  </td></tr></tbody> </table>', '', '2', '90', '0', '109', '2009-12-28 05:00:00', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2010-01-07 01:00:00', '2010-01-13 23:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '65', '', '', '1', '36', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('80', '324', 'QOW #200', 'qow-200', '', '<div><br />  </div><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"600\" align=\"center\" style=\"background-color: #ffff66; height: 173px\"> <tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#200</strong> </div>        <div align=\"center\"> <br /></div><div align=\"center\"> </div><div align=\"center\"><a href=\"stockade/quiz/quiz.html\" target=\"_blank\"><br /></a></div><div align=\"center\"> </div><div align=\"center\"><a href=\"stockade/quiz/quiz.html\" target=\"_blank\"><strong>CLICK HERE TO TAKE THE QOW #200 QUIZ!</strong></a></div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"><font color=\"#ff0000\"><strong>EVERYONE WHO SUCCESSFULLY COMPLETES THE QUIZ WINS!</strong></font></div><div align=\"center\"> </div><div align=\"center\"><a href=\"cgi-sys/guestbook.cgi?action=listguests&user=twozerf4\" target=\"_blank\"><strong>See who has won so far!</strong></a> <br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\"></a></p>  </td></tr></tbody> </table>', '', '0', '90', '0', '109', '2008-12-12 15:01:47', '242', '', '2008-12-13 04:36:00', '242', '0', '0000-00-00 00:00:00', '2008-12-12 04:00:00', '2008-12-17 21:00:00', '', '', '{\"show_title\":0,\"link_titles\":0,\"show_intro\":0,\"show_section\":0,\"link_section\":0,\"show_category\":0,\"link_category\":0,\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '5', '0', '65', '', '', '1', '349', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('127', '325', 'QOW #224', 'qow-224', '', '<span style=\"color: #000000; font-family: Times; font-size: 16px\" class=\"Apple-style-span\"><div style=\"font-size: 10px; text-align: left; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666; background-color: #ffffff\"><span style=\"color: #000000; font-family: Times; font-size: 16px\" class=\"Apple-style-span\"><div style=\"font-size: 10px; text-align: left; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666; background-color: #ffffff\"><p>&nbsp;</p><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" align=\"center\" style=\"background-color: #ffff66; height: 143px\"><tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66; font-family: Verdana,Arial,Helvetica,sans-serif; font-size: 10px\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#224</strong></div><div align=\"center\"><br /><img src=\"images/stories/images.jpg\" border=\"0\" /><br /></div><div align=\"center\"> </div><div align=\"center\"><span style=\"color: #000000; font-size: 12px\" class=\"Apple-style-span\">What is the only fish that can blink with both eyes?<br /></span></div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"><br /></div><p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question!</a></p></td></tr></tbody></table><div align=\"center\"><br /></div></div></span></div></span>', '', '2', '90', '0', '109', '2009-11-30 18:39:27', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2009-11-30 18:39:27', '2009-12-02 21:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '66', '', '', '1', '29', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('145', '326', 'QOW 230', 'qow-230', '', '<div style=\"font-size: 10px; text-align: left; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666; background-color: #ffffff;\">\n<p> </p>\n<table style=\"background-color: #ffff66; height: 143px; width: 621px;\" align=\"center\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\">\n<tbody>\n<tr>\n<td style=\"border: 1px solid #cccc99; background-color: #ffff66; font-family: Verdana,Arial,Helvetica,sans-serif; font-size: 10px;\" valign=\"middle\">\n<div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" alt=\" \" align=\"middle\" border=\"0\" height=\"55\" width=\"150\" /><span style=\"font-size: 12pt;\"><strong style=\"color: #000000;\">#230</strong></span></div>\n<div align=\"center\"><br /><img src=\"images/stories/8.jpg\" /></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div style=\"color: #000000;\" align=\"center\"><strong><span style=\"font-size: 10pt;\">What is the name of this creature from Creature Feature night?</span></strong></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question!</a></p>\n</td>\n</tr>\n</tbody>\n</table>\n<div align=\"center\"></div>\n</div>', '', '2', '90', '0', '109', '2010-01-22 12:12:06', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2010-01-22 12:12:06', '2010-01-27 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '67', '', '', '1', '14', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('143', '327', 'QOW #229', 'qow-229', '', '<span style=\"color: #000000; font-family: Times; font-size: 16px\" class=\"Apple-style-span\"><div style=\"font-size: 10px; text-align: left; font-family: Verdana, Arial, Helvetica, sans-serif; color: #666666; background-color: #ffffff\"><span style=\"color: #000000; font-family: Times; font-size: 16px\" class=\"Apple-style-span\"><div style=\"font-size: 10px; text-align: left; font-family: Verdana, Arial, Helvetica, sans-serif; color: #666666; background-color: #ffffff\"><p>&nbsp;</p><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" align=\"center\" style=\"background-color: #ffff66; height: 143px\"><tbody><tr><td valign=\"middle\" style=\"background-color: #ffff66; font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 10px; border-width: 1px; border-color: #cccc99; border-style: solid\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#229</strong></div><div align=\"center\"><br /><img src=\"images/stories/galaxy.jpg\" border=\"0\" /></div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"><span style=\"color: #000000; font-size: 12px\" class=\"Apple-style-span\">What is the brightest star visable from the South Pole?</span></div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"><br /></div><p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question!</a></p></td></tr></tbody></table><div align=\"center\"><br /></div></div></span></div></span>', '', '2', '90', '0', '109', '2010-01-15 01:49:36', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2010-01-15 01:49:36', '2010-01-20 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '68', '', '', '1', '43', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('108', '328', 'QOW #213', 'qow-213', '', '<p>&nbsp;</p><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" align=\"center\" style=\"background-color: #ffff66; height: 143px\"> <tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#213</strong> </div>        <div align=\"center\"> <br /></div><div align=\"center\">The final Question of the Week for the year!</div><div align=\"center\"> </div><div align=\"center\">Break the code and it will give you the answer</div><div align=\"center\"> </div><div align=\"center\"><strong><font color=\"#000000\">20 - 8 - 5 - 1 - 14 - 19 - 23 - 5 - 18 - 9 - 19 - 7 - 21 - 13 - 2 - 1 - 12 - 12 - 7 - 1 - 14 - 7 </font></strong><br /></div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question! </a></p>  </td></tr></tbody> </table><div align=\"center\"><br /></div><div align=\"center\"><br /></div><div align=\"center\"><br /></div>', '', '2', '90', '0', '109', '2009-05-30 02:18:56', '242', '', '2009-06-03 12:34:29', '242', '0', '0000-00-00 00:00:00', '2009-05-30 06:18:56', '2009-06-03 04:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '69', '', '', '1', '35', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('130', '329', 'QOW #227', 'qow-227', '', '<span style=\"color: #000000; font-family: Times; font-size: 16px\" class=\"Apple-style-span\"><div style=\"font-size: 10px; text-align: left; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666; background-color: #ffffff\"><span style=\"color: #000000; font-family: Times; font-size: 16px\" class=\"Apple-style-span\"><div style=\"font-size: 10px; text-align: left; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666; background-color: #ffffff\"><p>&nbsp;</p><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" align=\"center\" style=\"background-color: #ffff66; height: 143px\"><tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66; font-family: Verdana,Arial,Helvetica,sans-serif; font-size: 10px\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#227</strong></div><div align=\"center\"><br /><img src=\"images/stories/images-3.jpg\" border=\"0\" /><br /></div><div align=\"center\"> </div><div align=\"center\"><span style=\"color: #000000; font-size: 12px\" class=\"Apple-style-span\">What did the 3 Kings (the Magi) bring as gifts to Jesus? </span></div><div align=\"center\"> </div><div align=\"center\">(Here is a hint - look up Matthew 2:1-12 in the Bible!) </div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"><br /></div><p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question!</a></p></td></tr></tbody></table><div align=\"center\"><br /></div></div></span></div></span>', '', '2', '90', '0', '109', '2009-11-30 18:51:39', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2009-12-17 00:00:00', '2009-12-23 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '70', '', '', '1', '17', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('125', '330', 'QOW #223', 'qow-223', '', '<span style=\"color: #000000; font-family: Times; font-size: 16px\" class=\"Apple-style-span\"><div style=\"font-size: 10px; text-align: left; font-family: Verdana, Arial, Helvetica, sans-serif; color: #666666; background-color: #ffffff\"><span style=\"color: #000000; font-family: Times; font-size: 16px\" class=\"Apple-style-span\"><div style=\"font-size: 10px; text-align: left; font-family: Verdana, Arial, Helvetica, sans-serif; color: #666666; background-color: #ffffff\"><p> </p><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" align=\"center\" style=\"background-color: #ffff66; height: 143px\"><tbody><tr><td valign=\"middle\" style=\"background-color: #ffff66; font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 10px; border-width: 1px; border-color: #cccc99; border-style: solid\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#223</strong></div><div align=\"center\"><br /><span style=\"color: #000000; font-size: 12px\" class=\"Apple-style-span\"><img src=\"images/stories/orbit.jpg\" border=\"0\" /><br /></span></div><div align=\"center\"> </div><div align=\"center\"><span style=\"color: #000000; font-size: 12px\" class=\"Apple-style-span\">What was the first satellite to orbit the Earth?</span></div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"><br /></div><p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question!</a></p></td></tr></tbody></table><div align=\"center\"><br /></div></div></span></div></span>', '', '2', '90', '0', '109', '2009-11-07 01:58:19', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2009-11-12 00:00:00', '2009-11-18 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '71', '', '', '1', '80', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('124', '331', 'QOW #222', 'qow-222', '', '<span style=\"color: #000000; font-family: Times; font-size: 16px\" class=\"Apple-style-span\"><div style=\"font-size: 10px; text-align: left; font-family: Verdana, Arial, Helvetica, sans-serif; color: #666666; background-color: #ffffff\"><p> </p><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" align=\"center\" style=\"background-color: #ffff66; height: 143px\"><tbody><tr><td valign=\"middle\" style=\"background-color: #ffff66; font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 10px; border-width: 1px; border-color: #cccc99; border-style: solid\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#222</strong></div><div align=\"center\"><br /><span style=\"color: #000000; font-size: 12px\" class=\"Apple-style-span\"><img src=\"images/stories/planets.jpg\" border=\"0\" /></span></div><div align=\"center\"> </div><div align=\"center\"><span style=\"color: #000000; font-size: 12px\" class=\"Apple-style-span\">Which \"Planet\" is not a Planet?</span></div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"><br /></div><p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question!</a></p></td></tr></tbody></table><div align=\"center\"><br /></div><div align=\"center\"><br /></div></div></span>', '', '2', '90', '0', '109', '2009-11-07 01:51:35', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2009-11-07 01:51:35', '2009-11-11 23:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '72', '', '', '1', '39', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('123', '332', 'QOW #221', 'qow-221', '', '<p>&nbsp;</p><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" align=\"center\" style=\"background-color: #ffff66; height: 143px\"> <tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#221</strong> </div>        <div align=\"center\"> <br /><font style=\"font-size: 12px\" color=\"#000000\">Put these letters in the correct order to spell <br />out a character\'s name from Toy Story</font></div><div align=\"center\"><font color=\"#000000\"> </font></div><div align=\"center\"><h1><font color=\"#000000\">H - A - M - M </font></h1></div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"><img src=\"images/stories/fp0741.jpg\" border=\"0\" /></div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question! </a></p>  </td></tr></tbody> </table><div align=\"center\"><br /></div><div align=\"center\"><br /></div><div align=\"center\"><br /></div>', '', '2', '90', '0', '109', '2009-10-14 12:52:52', '242', '', '2009-10-23 23:50:28', '242', '0', '0000-00-00 00:00:00', '2009-10-22 02:00:00', '2009-10-28 23:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '73', '', '', '1', '41', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('103', '333', 'QOW #211', 'qow-211', '', '<p> </p><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" align=\"center\" style=\"background-color: #ffff66; height: 143px\"> <tbody><tr><td valign=\"middle\" style=\"background-color: #ffff66; border-width: 1px; border-color: #cccc99; border-style: solid\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#211</strong> </div>        <div align=\"center\"> <br /></div><p align=\"center\">A Junior Leader was recently awarded a couple of items that are given only to Junior leaders. <br />What are the two items they receive? </p><div align=\"center\"> <br /></div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question! </a></p>  </td></tr></tbody> </table><div align=\"center\"><br /></div><div align=\"center\"><br /></div><div align=\"center\"><br /></div>', '', '2', '90', '0', '109', '2009-03-28 14:29:59', '242', '', '2009-04-01 21:53:18', '242', '0', '0000-00-00 00:00:00', '2009-03-28 19:29:59', '2009-04-01 21:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '3', '0', '74', '', '', '1', '139', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('122', '334', 'QOW #220', 'qow-220', '', '<p>&nbsp;</p><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" align=\"center\" style=\"background-color: #ffff66; height: 143px\"> <tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#220</strong> </div>        <div align=\"center\" style=\"font-size: 12px; color: #000000\"> <br />Name this Villain</div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"><img src=\"images/stories/qow220.gif\" border=\"0\" width=\"258\" height=\"174\" /></div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question! </a></p>  </td></tr></tbody> </table><div align=\"center\"><br /></div><div align=\"center\"><br /></div><div align=\"center\"><br /></div>', '', '2', '90', '0', '109', '2009-10-14 12:35:29', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2009-10-15 05:00:00', '2009-10-22 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '75', '', '', '1', '19', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('119', '335', 'QOW #218', 'qow-218', '', '<p>&nbsp;</p><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" align=\"center\" style=\"background-color: #ffff66; height: 143px\"> <tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#218</strong> </div>        <div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"><font style=\"font-size: 14px\" color=\"#ff0000\"><strong>THE SANDLOT TRIVIA - Final Question!  </strong></font></div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"><img src=\"images/stories/dog.jpeg\" border=\"0\" /> <br /></div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"><font style=\"font-size: 12px\" color=\"#000000\">What is the dog\'s name in The Sandlot?</font></div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question! </a></p>  </td></tr></tbody> </table><div align=\"center\"><br /></div><div align=\"center\"><br /></div><div align=\"center\"><br /></div>', '', '2', '90', '0', '109', '2009-09-02 13:06:03', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2009-10-01 00:30:00', '2009-10-07 21:30:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '76', '', '', '1', '19', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('96', '336', 'QOW #210', 'qow-210', '', '<p>&nbsp;</p><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" align=\"center\" style=\"background-color: #ffff66; height: 143px\"> <tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#210</strong> </div>        <div align=\"center\"> <br /></div><p align=\"center\">Which planet in our Solar System is named after the ancient Roman god of war? </p><div align=\"center\"> <br /></div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question! </a></p>  </td></tr></tbody> </table><div align=\"center\"><br /></div><div align=\"center\"><br /></div><div align=\"center\"><br /></div>', '', '2', '90', '0', '109', '2009-02-19 17:14:55', '242', '', '2009-02-19 17:19:22', '242', '0', '0000-00-00 00:00:00', '2009-03-19 03:00:00', '2009-03-25 21:30:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '78', '', '', '1', '146', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('115', '337', 'QOW #219', 'qow-215', '', '<p>&nbsp;</p><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" align=\"center\" style=\"background-color: #ffff66; height: 143px\"> <tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#219</strong> </div>        <div align=\"center\"> <br />What living creature has the largest eyes?</div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"><img src=\"images/stories/blinking_eyes_2.gif\" border=\"0\" /></div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question! </a></p>  </td></tr></tbody> </table><div align=\"center\"><br /></div><div align=\"center\"><br /></div><div align=\"center\"><br /></div>', '', '2', '90', '0', '109', '2009-09-02 12:30:09', '242', '', '2009-09-02 13:00:09', '242', '0', '0000-00-00 00:00:00', '2009-10-08 00:30:00', '2009-10-14 21:30:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '83', '', '', '1', '9', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('114', '338', 'QOW #214', 'qow-214', '', '<p> </p><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" align=\"center\" style=\"background-color: #ffff66; height: 143px\"> <tbody><tr><td valign=\"middle\" style=\"font-size: 12px; background-color: #ffff66; border-width: 1px; border-color: #cccc99; border-style: solid\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#214</strong> </div>        <div align=\"center\"> </div><div align=\"center\" style=\"font-size: 14px\"><font color=\"#ff0000\"><strong>THE SANDLOT TRIVIA </strong></font><br /></div><div align=\"center\"> </div><div align=\"center\"><font color=\"#000000\">In the movie \"The Sandlot\", </font></div><div align=\"center\"><font color=\"#000000\"> </font></div><div align=\"center\"><font color=\"#000000\"><img src=\"images/stories/squints.jpg\" border=\"0\" /><br /></font> </div><div align=\"center\"><font color=\"#000000\"> </font></div><div align=\"center\"><font color=\"#000000\">What did Squints do when he jumped off the diving board at the community pool?</font></div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question! </a></p>  </td></tr></tbody> </table><div align=\"center\"><br /></div><div align=\"center\"><br /></div><div align=\"center\"><br /></div>', '', '2', '90', '0', '109', '2009-09-02 12:26:19', '242', '', '2009-09-02 13:14:58', '242', '0', '0000-00-00 00:00:00', '2009-09-02 08:00:00', '2009-09-10 01:30:00', '', '', '{\"show_title\":0,\"link_titles\":0,\"show_intro\":0,\"show_section\":0,\"link_section\":0,\"show_category\":0,\"link_category\":0,\"show_vote\":0,\"show_author\":0,\"show_create_date\":0,\"show_modify_date\":0,\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '3', '0', '84', '', '', '1', '5', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('90', '339', 'QOW #204', 'qow-2047', '', '<div><br />  </div><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"492\" align=\"center\" style=\"background-color: #ffff66; height: 173px\"> <tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#204</strong> </div>        <div align=\"center\"> <br /></div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div><div align=\"center\"><a href=\"stockade/qow204puzzle\">CLICK HERE TO SOLVE THE PUZZLE</a><br /></div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\"></a></p>  </td></tr></tbody> </table>', '', '2', '90', '0', '109', '2009-01-09 01:50:53', '242', '', '2009-01-15 03:46:43', '242', '0', '0000-00-00 00:00:00', '2009-01-29 03:30:00', '2009-02-04 21:30:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '6', '0', '85', '', '', '1', '697', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('79', '340', 'QOW #199', 'qow-199', '', '<div><br />  </div><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"492\" align=\"center\" style=\"background-color: #ffff66; height: 173px\"> <tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#199</strong> </div>        <div align=\"center\"> <br /></div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div><div align=\"center\"><a href=\"stockade/qow199puzzle\">CLICK HERE TO SOLVE THE PUZZLE</a><br /></div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"><font color=\"#ff0000\"><strong>NEXT WEEKS QUESTION IS QOW #200!<br />WATCH FOR A EXTRA HARD QUIZ AND A PRIZE EVERYONE CAN WIN!!</strong></font><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\"></a></p>  </td></tr></tbody> </table>', '', '2', '90', '0', '109', '2008-12-05 13:46:36', '242', '', '2008-12-05 13:49:54', '242', '0', '0000-00-00 00:00:00', '2008-12-05 13:46:36', '2008-12-10 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '93', '', '', '1', '589', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('78', '341', 'QOW #198', 'qow-198', '', '<div align=\"center\"><br />  </div><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" height=\"143\" align=\"center\" style=\"background-color: #ffff66\"> <tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#198</strong> </div>        <div align=\"center\"> <br /></div><div align=\"center\">Stockade is broken up into smaller groups called Posts.</div><div align=\"center\">What are the names of these Posts? <br /></div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question! </a></p>  </td></tr></tbody> </table><div align=\"center\"><br /></div>', '', '2', '90', '0', '109', '2008-11-20 17:50:29', '242', '', '2008-11-20 17:53:50', '242', '0', '0000-00-00 00:00:00', '2008-11-20 17:50:29', '2008-12-03 22:00:00', '', '', '{\"show_title\":0,\"link_titles\":0,\"show_intro\":0,\"show_section\":0,\"link_section\":0,\"show_category\":0,\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '94', '', '', '1', '563', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('77', '342', 'QOW #197', 'qow-197', '', '<div align=\"center\"><br />  </div><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"609\" height=\"186\" align=\"center\" style=\"background-color: #ffff66\"> <tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#197</strong> </div>        <div align=\"center\"> <br /></div><div align=\"center\" style=\"font-size: 12px; color: #000000\"><strong>Multiple Part Presidential Trivia!</strong></div><div align=\"center\"> </div><div align=\"center\"><br />1. Which President is on the Half Dollar coin?</div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\">2. Which President was a 5 Star General in World War 2?</div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\">3. Who was the 40th President? </div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question! </a></p>  </td></tr></tbody> </table><div align=\"center\"><br /></div>', '', '2', '90', '0', '109', '2008-11-14 15:12:00', '242', '', '2008-11-14 18:00:02', '242', '0', '0000-00-00 00:00:00', '2008-11-14 04:00:00', '2008-11-19 21:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '4', '0', '95', '', '', '1', '575', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('76', '343', 'QOW #196', 'qow-196', '', '<div><br />  </div><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"492\" align=\"center\" style=\"background-color: #ffff66; height: 173px\"> <tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#196</strong> </div>        <div align=\"center\"> <br /></div><div align=\"center\" style=\"font-size: 12px; color: #000000\">Puzzle #2!<br /></div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div><div align=\"center\"><a href=\"stockade/qow196puzzle\" target=\"_blank\">CLICK HERE TO SOLVE THE PUZZLE</a><br /></div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\"></a></p>  </td></tr></tbody> </table>', '', '2', '90', '0', '109', '2008-11-06 13:33:35', '242', '', '2008-11-14 15:18:00', '242', '0', '0000-00-00 00:00:00', '2008-11-06 13:33:35', '2008-11-12 04:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '3', '0', '96', '', '', '1', '614', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('75', '344', 'QOW #195', 'qow-195', '', '<div><br />  </div><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"492\" align=\"center\" style=\"background-color: #ffff66; height: 173px\"> <tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#195</strong> </div>        <div align=\"center\"> <br /></div><div align=\"center\" style=\"font-size: 12px; color: #000000\">Something new!<br /></div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div><div align=\"center\"><a href=\"http://www.2047.org/stockade/qow195/\">CLICK HERE TO SOLVE THE PUZZLE</a><br /></div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\"></a></p>  </td></tr></tbody> </table>', '', '2', '90', '0', '109', '2008-10-30 18:00:36', '242', '', '2008-10-30 18:04:28', '242', '0', '0000-00-00 00:00:00', '2008-10-30 18:00:36', '2008-11-05 21:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '97', '', '', '1', '756', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('72', '345', 'QOW #194', 'qow-194', '', '<div align=\"center\"><br />  </div><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" height=\"143\" align=\"center\" style=\"background-color: #ffff66\"> <tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#194</strong> </div>        <div align=\"center\"> <br /></div><div align=\"center\" style=\"font-size: 12px; color: #000000\"><strong>Cartoon Trivia Continues!</strong></div><div align=\"center\"> </div><div align=\"center\">What is the name of this cartoon character?<br /><br /></div><div align=\"center\"><img src=\"images/stories/194.jpg\" border=\"0\" /> <br /></div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question! </a></p>  </td></tr></tbody> </table><div align=\"center\"><br /></div>', '', '2', '90', '0', '109', '2008-10-20 04:00:00', '242', '', '2008-10-20 23:43:17', '242', '0', '0000-00-00 00:00:00', '2008-10-23 10:00:00', '2008-10-29 21:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '3', '0', '98', '', '', '1', '748', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('71', '346', 'QOW #193', 'qow-193', '', '<div align=\"center\"><br />  </div><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" height=\"143\" align=\"center\" style=\"background-color: #ffff66\"> <tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#193</strong> </div>        <div align=\"center\"> <br /></div><div align=\"center\">What is the name of this character AND his best friend?<br /><br /></div><div align=\"center\"><img src=\"images/stories/193.gif\" border=\"0\" /> <br /></div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div>        <p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question! </a></p>  </td></tr></tbody> </table><div align=\"center\"><br /></div>', '', '2', '90', '0', '109', '2008-10-15 21:35:24', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2008-10-16 00:15:24', '2008-10-22 21:30:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '99', '', '', '1', '674', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('388', '347', 'Stockade Meeting Tonight - 2-27-13', 'stockade-meeting-tonight-2-27-13', '', '<p>&nbsp;</p>\n<hr />\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<h2 style=\"text-align: center;\"><strong><span style=\"font-family: verdana,geneva;\">Wednesday Stockade Boys - We have a regular meeting tonight even though the Pioneer Girls are not meeting. 7 - 8:30pm!</span></strong></h2>\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<hr />\n<p>&nbsp;</p>', '', '0', '90', '0', '108', '2013-02-27 05:00:00', '242', '', '2013-02-28 03:39:27', '242', '0', '0000-00-00 00:00:00', '2013-02-27 05:00:00', '2013-02-28 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '1', '', '', '1', '22', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('387', '348', 'Wednesday Stockade Meeting Tonight!', 'wednesday-stockade-meeting-tonight', '', '<p>&nbsp;</p>\n<hr />\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<h2 style=\"text-align: center;\"><strong><span style=\"font-family: verdana,geneva;\">Wednesday Stockade Boys - We have a regular meeting tonight even though the Pioneer Girls are not meeting. 7 - 8:30pm!</span></strong></h2>\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<hr />\n<p>&nbsp;</p>', '', '1', '90', '0', '108', '2013-02-13 05:00:00', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2013-02-13 05:00:00', '2013-02-14 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '2', '', '', '1', '22', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('377', '349', 'No Stockade - Halloween', 'no-stockade-halloween', '', '<h1 style=\"text-align: center;\"></h1>\n<h1 style=\"text-align: center;\"></h1>\n<p> </p>\n<p style=\"text-align: center;\"> </p>\n<hr />\n<br /><br /><img style=\"display: block; margin-left: auto; margin-right: auto;\" width=\"84\" height=\"84\" src=\"images/stories/exclamation.gif\" />\n<p style=\"text-align: center;\"> </p>\n<h1 style=\"text-align: center;\"></h1>\n<h1 style=\"text-align: center;\"></h1>\n<h1 style=\"text-align: center;\"></h1>\n<h1 style=\"text-align: center;\"></h1>\n<h1 style=\"text-align: center;\"></h1>\n<h1 style=\"font-size: 1.4em; text-align: center; padding: 0px; margin: 0px;\"></h1>\n<h1 style=\"font-size: 1.4em; text-align: center; padding: 0px; margin: 0px;\"></h1>\n<h1 style=\"font-size: 1.4em; text-align: center; padding: 0px; margin: 0px;\"><strong style=\"padding: 0px; margin: 0px; border: 0px initial initial;\">THERE IS NO WEDNESDAY STOCKADE</strong></h1>\n<h1 style=\"text-align: center;\"></h1>\n<h1 style=\"text-align: center;\"><strong>Happy Halloween - Don\'t do anything dumb!!! </strong></h1>\n<p> </p>\n<p><strong><img src=\"images/stories/sadpumpkin.png\" style=\"display: block; margin-left: auto; margin-right: auto;\" width=\"150\" /></strong></p>\n<h1 style=\"font-size: 1.4em; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\"></h1>\n<h1 style=\"font-size: 1.4em; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\"></h1>\n<h1 style=\"font-size: 1.4em; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\"></h1>\n<h1 style=\"font-size: 1.4em; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\"><strong style=\"padding: 0px; margin: 0px; border: 0px initial initial;\">Wednesday Stockade will return next week, November 7th!!</strong></h1>\n<p> </p>\n<p><strong style=\"padding: 0px; margin: 0px; border: 0px initial initial;\"> </strong></p>\n<hr />\n<strong style=\"padding: 0px; margin: 0px; border: 0px initial initial;\"> <br /></strong>\n<p> </p>\n<p><strong><br /></strong></p>\n<h1 style=\"text-align: center;\"><strong> </strong></h1>\n<p><strong><br /><br /><br /></strong></p>\n<p> </p>\n<div></div>\n<div></div>', '', '1', '90', '0', '108', '2012-10-30 02:48:42', '242', '', '2012-10-31 19:33:39', '242', '0', '0000-00-00 00:00:00', '2012-10-31 05:00:00', '2012-11-02 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '3', '0', '3', '', '', '1', '21', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('342', '350', 'No Wednesday Stockade', 'no-wednesday-stockade', '', '<p> </p>\n<p style=\"text-align: center;\"><img src=\"images/stories/exclamation.gif\" height=\"84\" width=\"84\" /></p>\n<h1 style=\"text-align: center;\"><strong><br /> <br /> There is no Wednesday Stockade <br />or Tree Climbers tonight. </strong></h1>\n<h1 style=\"text-align: center;\"></h1>\n<h1 style=\"text-align: center;\"><strong><br />See you next week! </strong></h1>\n<p> </p>\n<p> </p>\n<p><strong><br /></strong></p>', '', '1', '90', '0', '108', '2012-04-10 12:38:18', '242', '', '2012-04-10 12:40:10', '242', '0', '0000-00-00 00:00:00', '2012-04-11 05:00:00', '2012-04-12 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '4', '', '', '1', '12', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('341', '351', 'No Tuesday Stockade Tonight', 'no-tuesday-stockade-tonight', '', '<h1 style=\"text-align: center;\"></h1>\n<h1 style=\"text-align: center;\"></h1>\n<p> </p>\n<p style=\"text-align: center;\"><img src=\"images/stories/exclamation.gif\" height=\"84\" width=\"84\" /></p>\n<h1 style=\"text-align: center;\"></h1>\n<h1 style=\"text-align: center;\"></h1>\n<h1 style=\"text-align: center;\"></h1>\n<h1 style=\"text-align: center;\"><strong><br /><br />There is no Tuesday Stockade tonight.   See you next week!&nbsp;<span class=\"small\">&nbsp;</span></strong></h1>\n<p> </p>\n<p> </p>\n<p><strong><span class=\"small\"><br /></span></strong></p>', '', '1', '90', '0', '108', '2012-04-10 12:29:35', '242', '', '2012-04-10 12:37:46', '242', '0', '0000-00-00 00:00:00', '2012-04-10 05:00:00', '2012-04-11 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '5', '', '', '1', '5', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('217', '352', 'Slooh Telescope', 'slooh-telescope', '', '<center>\n<h2>\n<hr />\n</h2>\n<h2></h2>\n<h2><strong>Live View from the Slooh Telescope Camera</strong></h2><br />\n\n</center><center><iframe src=\"http://slooh-apps.appspot.com/syndicated-reticle\" width=\"300px\" height=\"250px\" frameborder=\"no\" scrolling=\"no\"></iframe></center></center>\n<hr />', '', '0', '90', '0', '108', '2010-12-16 03:40:39', '242', '', '2011-05-16 11:57:05', '242', '0', '0000-00-00 00:00:00', '2010-12-16 03:40:39', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '8', '0', '6', '', '', '1', '84', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('179', '353', 'Stockade 2 nights', 'stockade-2-nights', '', '<center><img src=\"images/stories/stockade-2-choices_600px.gif\" /></center>', '', '0', '90', '0', '108', '2010-08-24 17:22:40', '242', '', '2010-10-29 18:51:53', '242', '0', '0000-00-00 00:00:00', '2010-08-24 17:22:40', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '6', '0', '8', '', '', '1', '24', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('81', '354', 'Jim s DrawingCam', 'jims-drawingcam', '', '<div align=\"center\"><table border=\"0\" cellspacing=\"5\" width=\"600\" align=\"center\" style=\"background-color: #116dee\"><tbody><tr align=\"center\" valign=\"middle\"><td dir=\"ltr\" align=\"center\" valign=\"middle\"><h2><strong><strong style=\"color: #ffffff\">Here is what Jim was drawing last.</strong></strong></h2><div><img src=\"http://www.kidstimestudio.com/drawingcam/index.jpg\" border=\"0\" width=\"414\" height=\"*\" />  </div></td></tr></tbody></table><h2><strong><br /></strong></h2></div>', '', '2', '90', '0', '108', '2008-12-13 04:24:15', '242', '', '2008-12-15 21:41:10', '242', '0', '0000-00-00 00:00:00', '2008-12-13 16:24:15', '0000-00-00 00:00:00', '', '', '{\"show_title\":0,\"link_titles\":0,\"show_intro\":0,\"show_section\":0,\"link_section\":0,\"show_category\":0,\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '6', '0', '10', '', '', '1', '364', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('410', '355', 'Stockade Scavenger Hunt 2013', 'stockade-scavenger-hunt-2013', '', '<hr /><center>\n<p><img src=\"images/stories/13-14_artwork_specific/scav-hunt-5-title-400px.png\" alt=\"\" /></p>\n</center>\n<p style=\"text-align: center;\">&nbsp;</p>\n<p style=\"text-align: center;\"><span style=\"font-size: 18pt; color: #ffff00;\"><strong></strong></span></p>\n<p style=\"text-align: center;\">If the letter does not show up, use this link</p>\n<p style=\"text-align: center;\"><span style=\"font-size: 18pt; color: #ffff00;\"><strong></strong></span></p>\n<p style=\"text-align: center;\"><br /><a href=\"images/pdf_files/2011_2012_pdf/scav4.pdf\">http://www.2047.org/newweb/images/pdf_files/2013_2014_pdf/scav_2013.pdf</a></p>\n<p style=\"text-align: center;\"><span style=\"font-size: 18pt; color: #ffff00;\"><strong></strong></span></p>\n<p style=\"text-align: center;\">{pdf=<a href=\"images/pdf_files/2013_2014_pdf/scav_2013.pdf\">http://www.2047.org/newweb/images/pdf_files/2013_2014_pdf/scav_2013.pdf</a><a href=\"images/pdf_files/2011_2012_pdf/scav4.pdf|600|800}\">|400|600}</a></p>\n<p style=\"text-align: center;\"><span style=\"font-size: 18pt; color: #ffff00;\"><strong>&nbsp;</strong></span></p>\n<p style=\"text-align: center;\">&nbsp;</p>\n<p style=\"text-align: center;\">&nbsp;</p>\n<hr />\n<p>&nbsp;</p>', '', '1', '90', '0', '110', '2013-10-10 05:00:00', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2013-10-10 05:00:00', '2013-11-15 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '1', '', '', '1', '0', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('409', '356', 'Stockade Scavenger Hunt 5', 'stockade-scavenger-hunt-5', '', '<hr /><center>\n<p><img src=\"images/stories/13-14_artwork_specific/scav-hunt-5-title-400px.png\" alt=\"\" /></p>\n</center>\n<p>&nbsp;</p>\n<p style=\"text-align: center;\"><span style=\"font-size: 18pt; color: #ffff00;\"><strong><br />Begins October 8th!</strong></span></p>\n<p style=\"text-align: center;\">&nbsp;</p>\n<p style=\"text-align: center;\">&nbsp;</p>\n<hr />\n<p>&nbsp;</p>', '', '1', '90', '0', '110', '2013-08-21 14:57:37', '242', '', '2013-08-21 15:05:14', '242', '0', '0000-00-00 00:00:00', '2013-08-21 14:57:37', '2013-10-10 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '3', '0', '2', '', '', '1', '39', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('347', '357', 'Attending Stockarama or Camporama?', 'attending-stockarama-or-camporama', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p>&nbsp;</p>\n<table style=\"background-color: #ffff66; width: 400px; height: 579px;\" align=\"center\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px; color: #fc1102; background-color: #ffff66; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\">&nbsp;</h2>\n<h2 style=\"text-align: center;\">&nbsp;</h2>\n<br /><br /><img style=\"display: block; margin-left: auto; margin-right: auto;\" src=\"images/stories/question_mark.png\" height=\"132\" width=\"134\" /><br />\n<h2 style=\"text-align: center;\">Attending Stockarama<br />or Camporama?</h2>\n<p style=\"text-align: center;\"><a target=\"_blank\" href=\"stockade/qownewest.html\"><br /></a><strong><a target=\"_blank\" href=\"../stockade/stockarama_form.html\">Let us know here!</a></strong></p>\n<p style=\"text-align: center;\">&nbsp;</p>\n<object codebase=\"http://www.apple.com/qtactivex/qtplugin.cab#version=6,0,2,0\" classid=\"clsid:02bf25d5-8c17-4b23-bc80-d3488abddc6b\" height=\"258\" width=\"320\" style=\"display: block; margin-left: auto; margin-right: auto;\"><param name=\"src\" value=\"http://2047.org/stockade/photoalbum/stockarama11/stockarama_2011-2.m4v\" /><param name=\"autoplay\" value=\"false\" /><param name=\"controller\" value=\"true\" /><embed height=\"258\" width=\"320\" controller=\"true\" autoplay=\"false\" src=\"http://2047.org/stockade/photoalbum/stockarama11/stockarama_2011-2.m4v\" type=\"video/quicktime\"></embed>&nbsp;&nbsp; </object>\n &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;\n<p style=\"text-align: center;\"><br /><span style=\"font-size: 10pt;\"><strong><a target=\"_blank\" href=\"stockade/qownewest.html\"></a></strong></span></p>\n<h2 style=\"font-size: 1.3em; color: #000000; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\">&nbsp;</h2>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '0', '90', '0', '110', '2013-04-09 05:00:00', '242', '', '2013-04-09 13:38:26', '242', '0', '0000-00-00 00:00:00', '2013-04-09 05:00:00', '2013-05-18 05:00:00', '', '', '{\"show_title\":0,\"link_titles\":0,\"show_intro\":0,\"show_section\":0,\"link_section\":0,\"show_category\":0,\"link_category\":0,\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '12', '0', '3', '', '', '1', '94', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', '');

INSERT INTO tkt_content
(`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES 
('324', '358', 'Scav Hunt items due', 'scav-hunt-items-due', '', '<p style=\"text-align: center;\"> </p>\n<hr />\n<img style=\"display: block; margin-left: auto; margin-right: auto;\" src=\"images/stories/art-4.png\" height=\"147\" width=\"253\" />\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><strong><span style=\"color: #ff0000;\"><em><span style=\"font-size: 18pt;\">ITEMS ARE DUE THIS WEEK!</span></em></span><br /></strong></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"font-size: 12pt; color: #ffff00;\"><strong>The Stockade Scavenger Hunt items are due on </strong><strong> </strong></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"font-size: 12pt; color: #ffff00;\"><strong>Tuesday Stockade December 13th &amp; Wednesday Stockade December 12th</strong></span></p>\n<p style=\"text-align: center;\"><span style=\"font-size: 12pt; color: #ffff00;\"><strong><br /></strong></span></p>\n<p style=\"text-align: center;\"><span style=\"font-size: 12pt; color: #ffff00;\"><strong>All items should be turned in marked with the item number and a filled in check list</strong></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"> </p>\n<hr />', '', '2', '90', '0', '110', '2011-12-06 18:48:28', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-12-08 05:00:00', '2011-12-14 16:59:59', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '4', '', '', '1', '13', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('276', '359', 'Stockarama \'13', 'stockarama-13', '', '<div align=\"center\">\n<table style=\"height: 25px; width: 650px;\" border=\"1\" cellpadding=\"25\" cellspacing=\"1\">\n<tbody>\n<tr height=\"40\">\n<td bgcolor=\"#ff3300\" height=\"40\" width=\"500\">\n<div align=\"center\"><b><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif; font-size: 14px;\">STOCKARAMA \'13 INFORMATION</span></b></div>\n</td>\n</tr>\n<tr>\n<td style=\"color: #000000;\" bgcolor=\"#fff5a5\" width=\"500\">\n<p>&nbsp;</p>\n<p><b><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\">&nbsp; May 13th</span></b></p>\n<p style=\"padding-left: 30px;\">Deadline to notify Jim about attending (662-0335, <a href=\"mailto:jim@2047.org\">email</a> or see Jim at Stockade)</p>\n<p>&nbsp;</p>\n<p><b><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\">&nbsp; May 14 &amp; 15th</span></b></p>\n<p style=\"padding-left: 30px;\">Money due $55/boy, $15/dad</p>\n<p>&nbsp;</p>\n<p><b>&nbsp; May 17th</b></p>\n<p style=\"padding-left: 30px;\"><em><strong>6:15</strong></em> - sign in time at the gym. Have all your gear packed AND labeled. It is easiest to have clothes and sleeping bag inside a large plastic bag with the boy\'s name on the outside. We have a bus to transport us to Stockarama. Arrive at gym, check in, hand in gear, hand in McDonald\'s Money, listen to instructions.</p>\n<p>&nbsp;</p>\n<p><b><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\">&nbsp; May 19th</span></b></p>\n<p style=\"padding-left: 30px;\">We are leaving camp at approx. 11:00. On the ride home we will be stopping at Burger King. The boy\'s will receive their fast food money collected on Friday.<em><strong>&nbsp;</strong></em></p>\n<p>&nbsp;</p>\n<p style=\"padding-left: 30px;\"><em><strong>12:45 - 1±</strong></em> - Bus returns to Gym for pick up. Please be waiting at the gymnasium.</p>\n<p style=\"padding-left: 30px;\">&nbsp;</p>\n<p>&nbsp;</p>\n<p><a href=\"index.php?option=com_content&amp;view=article&amp;id=345:5-1-12-parent-letter-stockade-tuesday-a-wednesday&amp;catid=54:parent-letters&amp;Itemid=97\"><br /></a></p>\n<div align=\"center\">\n<p><a href=\"index.php?option=com_content&amp;view=article&amp;id=398:4-9-13-tues-a-wed-stockade-letter&amp;catid=54:parent-letters&amp;Itemid=97\">Parent Letter with details and gear list</a></p>\n<p>&nbsp;</p>\n</div>\n<p>&nbsp;</p>\n</td>\n</tr>\n<tr>\n<td bgcolor=\"#ff3300\" height=\"25\" width=\"500\">\n<div align=\"center\"><span style=\"color: #ff3300; font-family: Verdana,Arial,Helvetica,sans-serif;\"><b><a href=\"mailto:jim@2047.org\">CONTACT JIM</a></b></span></div>\n</td>\n</tr>\n</tbody>\n</table>\n</div>', '', '1', '90', '0', '110', '2013-04-09 05:00:00', '242', '', '2013-04-09 13:43:12', '242', '0', '0000-00-00 00:00:00', '2013-04-09 05:00:00', '2013-05-20 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '21', '0', '4', '', '', '1', '56', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('397', '360', 'Regional Derby Race!', 'regional-derby-race', '', '<center>\n<table style=\"width: 474px; height: 518px;\" border=\"1\" cellpadding=\"20\" cellspacing=\"2\">\n<tbody>\n<tr>\n<td bgcolor=\"#ffd700\">\n<div align=\"center\">\n<p style=\"text-align: center;\">&nbsp;</p>\n<p style=\"text-align: center;\"><img src=\"images/stories/derby-seal.gif\" height=\"146\" width=\"146\" /></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><span style=\"border-style: initial; border-color: initial; color: #ffff00; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\">&nbsp;</strong></span></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><span style=\"border-style: initial; border-color: initial; color: #ffff00; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\"><span color=\"black\" style=\"color: black;\">Congratulations to</span></strong></span></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><span style=\"border-style: initial; border-color: initial; color: #ffff00; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\"><span color=\"black\" style=\"color: black;\">the guys that represented 2047 in the regional finals!</span></strong></span></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><span style=\"border-style: initial; border-color: initial; color: #ffff00; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\"><span color=\"black\" style=\"color: black;\">Tim Kwiatkowski, Mateusz Jasinski, Warren Welch, Isaac Johnson, Will Lehsten, Krystian Jasinski &amp; Kevin Krolikowski.</span></strong></span></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><span style=\"border-style: initial; border-color: initial; color: #ffff00; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\">&nbsp;</strong></span></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><span style=\"border-style: initial; border-color: initial; color: #ffff00; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\"><img src=\"images/stories/kevin_2013.jpg\" alt=\"kevin 2013\" height=\"241\" width=\"155\" /></strong></span></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><span style=\"border-style: initial; border-color: initial; color: #ffff00; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\">&nbsp;</strong></span></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><span style=\"border-style: initial; border-color: initial; color: #ffff00; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\"><span color=\"black\" style=\"color: black;\">Regional 3rd Place Champion<br /> Kevin Krolikowski!</span></strong></span></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\">&nbsp;</strong></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\">2014 Regional Finals are to be held at our gymnasium!</strong></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\">&nbsp;</p>\n</div>\n</td>\n</tr>\n</tbody>\n</table>\n</center>', '', '1', '90', '0', '110', '2013-03-09 22:12:57', '242', '', '2013-04-09 13:27:59', '242', '0', '0000-00-00 00:00:00', '2013-03-09 22:12:57', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '5', '', '', '1', '123', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('396', '361', 'Pinewood Derby Tonight @ 7pm!', 'who-will-win-at-pinewood-derby-2014', '', '<center>\n<table style=\"background-color: #ffff66; width: 495px; height: 400px;\" align=\"center\">\n<tbody>\n<tr>\n<td>\n<p style=\"text-align: center;\"><img src=\"images/stories/derby-seal.gif\" height=\"146\" width=\"146\" /></p>\n<p style=\"border-width: 0px; padding: 0px; margin: 0px; text-align: center;\"><span style=\"color: #ffff00; border-width: 0px; padding: 0px; margin: 0px;\"><b style=\"border-width: 0px; padding: 0px; margin: 0px;\">&nbsp;</b></span></p>\n<p style=\"text-align: center;\"><b>&nbsp;</b></p>\n<p style=\"text-align: center;\"><span style=\"color: #000000;\"><b>Stockade #2047 Pinewood Derby</b></span></p>\n<div style=\"text-align: center;\" align=\"center\"><span style=\"color: #000000;\"><b>Tonight @ 7pm!</b></span></div>\n<div style=\"text-align: center;\" align=\"center\"><span style=\"color: #000000;\"><b>Everyone is invited!</b></span></div>\n<span style=\"color: #000000;\"><b><br /></b></span>\n<p style=\"border-width: 0px; padding: 0px; margin: 0px; text-align: center;\"><span style=\"color: #000000;\"><b style=\"border-width: 0px; padding: 0px; margin: 0px;\">Trophies given out for Speed, Best Looking Car, <br />Most Original Design and Most Cautious Driver!<br /></b></span></p>\n<p style=\"border-width: 0px; padding: 0px; margin: 0px; text-align: center;\"><span style=\"color: #000000;\"><b style=\"border-width: 0px; padding: 0px; margin: 0px;\">&nbsp;</b></span></p>\n<p style=\"border-width: 0px; padding: 0px; margin: 0px; text-align: center;\"><span style=\"color: #000000;\"><b style=\"border-width: 0px; padding: 0px; margin: 0px;\"><b style=\"border-width: 0px; padding: 0px; margin: 0px;\">After the race the complete results and photos will be posted</b></b></span></p>\n<br style=\"border-width: 0px; padding: 0px; margin: 0px;\" /></td>\n</tr>\n</tbody>\n</table>\n</center>', '', '1', '90', '0', '110', '2014-03-04 12:42:13', '242', '', '2013-08-19 17:59:55', '242', '0', '0000-00-00 00:00:00', '2014-03-04 12:42:13', '2014-03-05 01:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '7', '0', '6', '', '', '1', '24', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('298', '362', 'Wednesday Stockade Begins Tonight!', 'wednesday-stockade-begins-tonight', '', '<p> </p>\n<hr />\n<p style=\"text-align: center;\"><span style=\"font-size: 18pt; color: #ffff00;\"><strong>WEDNESDAY STOCKADE BEGINS TONIGHT!</strong></span></p>\n<p style=\"text-align: center;\"><span style=\"font-size: 18pt; color: #ffff00;\"><em><br />for boys aged 8 - 12</em></span></p>\n<p style=\"text-align: center;\"><br /><span style=\"font-size: 18pt; color: #ffff00;\"> <strong>7pm - 8:30</strong></span></p>\n<p style=\"text-align: center;\"><strong> \n<hr />\n<br /></strong></p>', '', '2', '90', '0', '110', '2011-09-14 05:00:00', '242', '', '2011-09-09 15:13:36', '242', '0', '0000-00-00 00:00:00', '2011-09-14 05:00:00', '2011-09-14 16:50:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '7', '', '', '1', '2', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('395', '363', 'Pinewood Derby 2013!', 'pinewood-derby-2013', '', '<center>\n<table style=\"width: 474px; height: 518px;\" border=\"1\" cellpadding=\"20\" cellspacing=\"2\">\n<tbody>\n<tr>\n<td bgcolor=\"#ff9933\">\n<div align=\"center\">\n<p style=\"text-align: center;\">&nbsp;</p>\n<p style=\"text-align: center;\"><img src=\"images/stories/derby-seal.gif\" height=\"146\" width=\"146\" /></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><span style=\"border-style: initial; border-color: initial; color: #ffff00; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\">&nbsp;</strong></span></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><span style=\"border-style: initial; border-color: initial; color: #ffff00; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\">Congratulations to</strong></span></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><span style=\"border-style: initial; border-color: initial; color: #ffff00; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\">the winners of the 2013 Pinewood Derby!</strong></span></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><span style=\"border-style: initial; border-color: initial; color: #ffff00; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\">&nbsp;</strong></span></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><span style=\"border-style: initial; border-color: initial; color: #ffff00; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\"><img src=\"images/stories/2047_artwork/100_2865_small.jpg\" width=\"400\" height=\"299\" alt=\"100 2865 small\" /><br /></strong></span></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><span style=\"border-style: initial; border-color: initial; color: #ffff00; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\">&nbsp;</strong></span></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><span style=\"border-style: initial; border-color: initial; color: #ffff00; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\">2nd year in a row - 1st Place<br />&amp; Best Looking Car</strong></span></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\">&nbsp;</strong></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\">1st Place - Kevin Krolikowski<br data-mce-bogus=\"1\" /></strong></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\">2nd Place - Tim Kwiatkowski<br data-mce-bogus=\"1\" /></strong></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\">3rd Place - <strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\">Mateusz Jasinski</strong><br data-mce-bogus=\"1\" /></strong></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\">4th Place - Warren Welch<br data-mce-bogus=\"1\" /></strong></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\">5th Place - Isaac Johnson<br data-mce-bogus=\"1\" /></strong></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\">6th Place - Will Lehsten</strong></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\">&nbsp;</strong></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\">Most Cautious Driver Award - Chris White</strong></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\">&nbsp;</strong></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\">Best Looking Car Trophy - &nbsp;Kevin Krolikowski<br data-mce-bogus=\"1\" /></strong></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\">&nbsp;</strong></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\">Best Looking Car Trophy - Nick Mortenson</strong></strong></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\">Best Looking Car Medal - Charlie Hanlon<br data-mce-bogus=\"1\" /></strong></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-width: 0px; padding: 0px; margin: 0px;\">Best Looking Car Medal -Cullen McDade</strong></strong></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-width: 0px; padding: 0px; margin: 0px;\">Best Looking Car Medal - Doug Jones</strong></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-width: 0px; padding: 0px; margin: 0px;\">&nbsp;</strong></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-width: 0px; padding: 0px; margin: 0px;\">Most Original Car Trophy - Daniel Sterba<br />Most Original car Medal - Francis Desmond<br data-mce-bogus=\"1\" /></strong></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-width: 0px; padding: 0px; margin: 0px;\">Most Original Car Medal - Riley Winnert<br data-mce-bogus=\"1\" /></strong></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-width: 0px; padding: 0px; margin: 0px;\">Most Original Car Medal - Isaac Johnson</strong></strong></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-width: 0px; padding: 0px; margin: 0px;\">&nbsp;</strong></strong></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><a target=\"_blank\" href=\"images/pdf_files/2012_2013_pdf/derby13results.pdf\"><strong style=\"border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-width: 0px; padding: 0px; margin: 0px;\">You can view the entire score and place sheet here<br data-mce-bogus=\"1\" /></strong></strong></a></p>\n<p style=\"border-style: initial; border-color: initial; text-align: center; border-width: 0px; padding: 0px; margin: 0px;\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\">&nbsp;</strong></p>\n<p style=\"color: #0000ff; text-align: center; padding: 0px; margin: 0px; border-width: 0px;\"><a href=\"../stockade/photoalbum/2012-13/derby13/\" target=\"_blank\"><strong style=\"border-style: initial; border-color: initial; border-width: 0px; padding: 0px; margin: 0px;\">2013 Pinewood Derby Cars Are Here</strong></a></p>\n</div>\n</td>\n</tr>\n</tbody>\n</table>\n<p style=\"text-align: center;\">&nbsp;</p>\n<div align=\"center\">\n<table style=\"width: 472px; height: 65px;\" border=\"1\" cellpadding=\"20\" cellspacing=\"2\">\n<tbody>\n<tr>\n<td bgcolor=\"yellow\">\n<div align=\"center\">\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a target=\"_blank\" href=\"../derby/derby_finals_directions.html\">The Stockade Buffalo Region Derby <br />Information is here</a></strong></span>&nbsp;</p>\n</div>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '1', '90', '0', '110', '2013-03-06 02:30:00', '242', '', '2013-03-06 11:52:00', '242', '0', '0000-00-00 00:00:00', '2013-03-06 01:30:00', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '10', '0', '7', '', '', '1', '202', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('260', '364', 'Stockade Loop Races!', 'stockade-loop-races', '', '<center> \n<table border=\"1\" cellpadding=\"20\" cellspacing=\"2\" width=\"575\">\n<tbody>\n<tr>\n<td align=\"center\" bgcolor=\"#ffcc00\" valign=\"middle\">\n<div align=\"center\">\n<h2></h2>\n<h2></h2>\n<h2></h2><p> </P>\n<h2><span style=\"font-family: verdana,geneva; font-size: 18pt; color: #000000;\"><br /><b>Stockade Loop Races!</b></span></h2>\n<p> </p>\n<p><span style=\"font-size: 12pt; color: #800000;\"><strong><span style=\"font-family: verdana,geneva;\"><i>Tuesday Stockade - March 22 <br />Wednesday Stockade - March 23</i></span></strong></span></p>\n<p><span style=\"font-family: verdana,geneva;\"><b><i><br /></i></b></span></p>\n<p><span style=\"font-family: verdana,geneva;\"> \n<object codebase=\"http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=10,0,32,18\" classid=\"clsid:d27cdb6e-ae6d-11cf-96b8-444553540000\" type=\"application/x-shockwave-flash\" height=\"385\" width=\"480\" style=\"display: block; margin-left: auto; margin-right: auto;\">\n<param name=\"allowfullscreen\" value=\"true\" />\n<param name=\"allowscriptaccess\" value=\"always\" />\n<param name=\"src\" value=\"http://www.youtube.com/v/jNOE7_6Pg48&amp;hl=en&amp;fs=1\" /><embed height=\"385\" width=\"480\" src=\"http://www.youtube.com/v/jNOE7_6Pg48&amp;hl=en&amp;fs=1\" allowscriptaccess=\"always\" allowfullscreen=\"true\" type=\"application/x-shockwave-flash\">&nbsp;</embed>&nbsp;\n</object>\n&nbsp; </span></p>\n<span style=\"font-size: 10pt;\"><span style=\"font-family: verdana,geneva;\"><br /></span> <span style=\"font-family: verdana,geneva; color: #000000;\"><b>Bring this year\'s car or one from another year! <br />In order to race your car will need to fit on the loop.</b> </span></span></div>\n<div align=\"center\"><br /><span style=\"font-size: 10pt; color: #000000;\"><span style=\"font-family: verdana,geneva;\"><b>This is just a fun event since we did not get to do this at our <br /> races a couple weeks ago.</b></span></span></div>\n<div align=\"center\"><span style=\"font-size: 10pt; color: #000000;\"><span style=\"font-family: verdana,geneva;\"><b>&nbsp;</b></span><span style=\"font-family: verdana,geneva;\"><b><br /></b></span> <span style=\"font-family: verdana,geneva;\">Any questions call Jim at 662-0335 or see him at Stockade.</span></span></div>\n<div align=\"center\"><span style=\"font-size: 10pt;\"><span style=\"font-family: verdana,geneva;\"><br /></span></span></div>\n</td>\n</tr>\n</tbody>\n</table>\n</center>', '', '2', '90', '0', '110', '2011-03-22 15:29:49', '242', '', '2011-03-22 15:44:32', '242', '0', '0000-00-00 00:00:00', '2011-03-22 15:29:49', '2011-03-25 05:00:00', '', '', '{\"show_title\":0,\"link_titles\":0,\"show_intro\":0,\"show_section\":0,\"link_section\":0,\"show_category\":0,\"link_category\":0,\"show_vote\":0,\"show_author\":0,\"show_create_date\":0,\"show_modify_date\":0,\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '5', '0', '8', '', '', '1', '18', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('392', '365', 'Stockade Derby Workday 3 - Today!', 'stockade-derby-workday-3-today', '', '<p>&nbsp;</p>\n<hr />\n<p>&nbsp;</p>\n<h1 style=\"text-align: center;\">Derby Workday #3</h1>\n<p>&nbsp;</p>\n<p style=\"text-align: center;\"><img src=\"images/stories/derby-seal.gif\" height=\"150\" width=\"150\" /></p>\n<p>&nbsp;</p>\n<h1 style=\"text-align: center;\">&nbsp;</h1>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\">Pinewood Derby Workday #3</span></h1>\n<p><span style=\"color: #ffff00;\">&nbsp;</span></p>\n<h1 style=\"text-align: center;\">&nbsp;</h1>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\">TODAY - 2pm- 5pm<br /></span></h1>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\">@ the gym</span></h1>\n<p><span style=\"color: #ffff00;\">&nbsp;</span></p>\n<p><span style=\"color: #ffff00;\">&nbsp;</span></p>\n<p><span style=\"color: #ffff00;\">&nbsp;</span></p>\n<p style=\"text-align: center;\"><span style=\"color: #ffff00; font-size: 12pt;\"><b>Next Saturday is Test Day - 11am - 3pm</b></span></p>\n<p><span style=\"color: #ffff00;\">&nbsp;</span></p>\n<p style=\"text-align: center;\"><span style=\"color: #ffff00;\">Any questions <a href=\"mailto:jim@2047.org\">contact Jim</a><br data-mce-bogus=\"1\" /></span></p>\n<p>&nbsp;</p>\n<h1 style=\"text-align: -webkit-auto;\">&nbsp;</h1>\n<p>&nbsp;</p>\n<hr />', '', '1', '90', '0', '110', '2013-02-16 12:44:10', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2013-02-16 12:44:10', '2013-02-17 04:59:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '8', '', '', '1', '19', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('297', '366', 'Tuesday Stockade Begins Tonight!', 'tuesday-stockade-begins-tonght', '', '<p> </p>\n<hr />\n<p style=\"text-align: center;\"><span style=\"font-size: 18pt; color: #ffff00;\"><strong>TUESDAY STOCKADE BEGINS TONIGHT!</strong></span></p>\n<p style=\"text-align: center;\"><span style=\"font-size: 18pt; color: #ffff00;\"><em><br />for boys aged 8 - 12</em></span></p>\n<p style=\"text-align: center;\"><br /><span style=\"font-size: 18pt; color: #ffff00;\"> <strong>7pm - 8:30</strong></span></p>\n<p style=\"text-align: center;\"><strong> \n<hr />\n<br /></strong></p>', '', '2', '90', '0', '110', '2011-09-13 05:00:00', '242', '', '2011-09-09 15:14:16', '242', '0', '0000-00-00 00:00:00', '2011-09-13 05:00:00', '2011-09-14 04:50:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '9', '', '', '1', '2', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('390', '367', 'Derby Test Day Today!', 'derby-test-day-today', '', '<p>&nbsp;</p>\n<hr />\n<p>&nbsp;</p>\n<h1 style=\"text-align: center;\">Derby Test Day Today!</h1>\n<p>&nbsp;</p>\n<p style=\"text-align: center;\"><img src=\"images/stories/derby-seal.gif\" height=\"150\" width=\"150\" /></p>\n<p>&nbsp;</p>\n<h1 style=\"text-align: center;\">&nbsp;</h1>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\">Pinewood Derby Test Day<br /></span></h1>\n<h3 style=\"text-align: center;\"><span style=\"color: #ffff00;\">Weigh your car, add weight and test run on the track! <br />This is not a work day. The cars should be fully assembled except for the weight.<br data-mce-bogus=\"1\" /></span></h3>\n<p><span style=\"color: #ffff00;\">&nbsp;</span></p>\n<h1 style=\"text-align: center;\">&nbsp;</h1>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\">TODAY - Saturday, February 23rd - 11am - 3pm<br /></span></h1>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\">@ the gym</span></h1>\n<p><span style=\"color: #ffff00;\">&nbsp;</span></p>\n<p style=\"text-align: center;\"><span style=\"color: #ffff00;\">Any questions <a href=\"mailto:jim@2047.org\">contact Jim</a><br data-mce-bogus=\"1\" /></span></p>\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<hr />', '', '1', '90', '0', '110', '2013-02-23 05:00:00', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2013-02-23 05:00:00', '2013-02-25 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '9', '', '', '1', '33', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('389', '368', 'Derby Test Day 2014!', 'derby-test-day-2014', '', '<p>&nbsp;</p>\n<hr />\n<p>&nbsp;</p>\n<h1 style=\"text-align: center;\">Derby Test Day</h1>\n<p>&nbsp;</p>\n<p style=\"text-align: center;\"><img src=\"images/stories/derby-seal.gif\" height=\"150\" width=\"150\" /></p>\n<p>&nbsp;</p>\n<h1 style=\"text-align: center;\">&nbsp;</h1>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\">Pinewood Derby Test Day<br /></span></h1>\n<h3 style=\"text-align: center;\"><span style=\"color: #ffff00;\">Weigh your car, add weight and test run on the track! <br data-mce-bogus=\"1\" /></span></h3>\n<p><span style=\"color: #ffff00;\">&nbsp;</span></p>\n<h1 style=\"text-align: center;\">&nbsp;</h1>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\">Saturday, February 22nd - 11am - 3pm<br /></span></h1>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\">@ the gym</span></h1>\n<p><span style=\"color: #ffff00;\">&nbsp;</span></p>\n<p style=\"text-align: center;\"><span style=\"color: #ffff00;\">Any questions <a href=\"mailto:jim@2047.org\">contact Jim</a><br data-mce-bogus=\"1\" /></span></p>\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<hr />', '', '1', '90', '0', '110', '2014-02-18 05:00:00', '242', '', '2013-08-19 17:57:23', '242', '0', '0000-00-00 00:00:00', '2014-02-18 05:00:00', '2014-02-24 04:59:59', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '10', '', '', '1', '31', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('323', '369', 'Scavenger Hunt - 1 Week extension', 'scavenger-hunt-1-week-extension', '', '<p style=\"text-align: center;\"> </p>\n<hr />\n<img style=\"display: block; margin-left: auto; margin-right: auto;\" src=\"images/stories/art-4.png\" height=\"147\" width=\"253\" />\n<p> </p>\n<p style=\"text-align: center;\"><span style=\"font-size: 14pt; color: #ffff00;\"><strong>1 Week Extension!</strong></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"font-size: 14pt;\"><strong><span style=\"color: #ff6600;\">The Stockade Scavenger Hunt items are due next week - </span></strong></span><span style=\"font-size: 14pt;\"><strong><span style=\"color: #ff6600;\">&nbsp;</span></strong></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"font-size: 14pt;\"><strong><span style=\"color: #ff6600;\">Tuesday Stockade December 13th &amp; Wednesday Stockade December 12th</span></strong></span></p>\n<p style=\"text-align: center;\"><span style=\"font-size: 14pt;\"><strong><span style=\"color: #ff6600;\"><br /></span></strong></span></p>\n<p style=\"text-align: center;\"><span style=\"font-size: 14pt;\"><strong><span style=\"color: #ff6600;\">All items should be turned in marked with the item number and a filled in check list</span></strong></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"> </p>\n<hr />\n<p> </p>', '', '2', '90', '0', '110', '2011-12-06 18:43:32', '242', '', '2011-12-06 18:48:23', '242', '0', '0000-00-00 00:00:00', '2011-12-06 18:43:32', '2011-12-08 04:59:59', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '11', '', '', '1', '15', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('381', '370', 'Creature Feature \'13', 'creature-feature-13', '', '<div align=\"center\">\n<table class=\"mceItemTable\" border=\"0\" cellpadding=\"10\" cellspacing=\"1\" width=\"628\">\n<tbody>\n<tr>\n<td colspan=\"3\" bgcolor=\"#00ff66\">\n<h1 align=\"center\"></h1><div align=\"center\">\n<p><span style=\"color: #800000;\" mce_style=\"color: #800000;\"><b style=\"font-size: 16px;\" mce_style=\"font-size: 16px;\">Creature Feature \'13<br />January 30th - You Don\'t Want to Miss This!</b></span></p>\n<p><span style=\"color: #800000;\" mce_style=\"color: #800000;\"><b style=\"font-size: 16px;\" mce_style=\"font-size: 16px;\"><br /></b></span></p>\n<p><img src=\"../stockade/photoalbum/reptile.gif\" mce_src=\"../stockade/photoalbum/reptile.gif\" align=\"middle\" border=\"0\">--<img style=\"vertical-align: middle;\" mce_style=\"vertical-align: middle;\" src=\"http://2047.org/stockade/photoalbum/creaturefeature2011/Thumbnails/33.jpg\" mce_src=\"http://2047.org/stockade/photoalbum/creaturefeature2011/Thumbnails/33.jpg\" height=\"179\" width=\"240\"></p>\n<p><img src=\"http://2047.org/stockade/photoalbum/creaturefeature2011/Thumbnails/53.jpg\" mce_src=\"http://2047.org/stockade/photoalbum/creaturefeature2011/Thumbnails/53.jpg\" height=\"178\" width=\"240\">&nbsp; <img src=\"stockade/photoalbum/creaturefeature8/Thumbnails/8.jpg\" mce_src=\"stockade/photoalbum/creaturefeature8/Thumbnails/8.jpg\" border=\"0\" height=\"180\" width=\"240\"></p>\n<h2><b><a href=\"stockade/photoalbum/\" mce_href=\"stockade/photoalbum/\" target=\"_blank\">See photographs and movies from the events from other years!</a></b><br mce_bogus=\"1\"></h2>\n\n\n</div>\n</td>\n</tr>\n</tbody>\n</table>\n</div>', '', '0', '90', '0', '110', '2013-01-04 15:17:30', '242', '', '2013-01-04 15:21:41', '242', '0', '0000-00-00 00:00:00', '2013-01-04 05:00:00', '2013-01-31 05:00:00', '', '', '{\"show_title\":1,\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '12', '', '', '1', '0', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('380', '371', 'Tuesday Stockade Chuck E Cheese Night!', 'tuesday-stockade-chuck-e-cheese-night', '', '<p style=\"text-align: center;\"><hr /></p>\n<p style=\"text-align: center;\">&nbsp;</p>\n<p style=\"text-align: center;\"><img src=\"images/stories/chuck-e-cheese-logo1.jpg\" width=\"300\" height=\"163\" /></p>\n<p style=\"text-align: center;\">&nbsp;</p>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\"><strong>Tuesday Stockade @ Chuck E Cheese</strong></span></h1>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\"><strong>Tuesday, December 4, 7 - 8:30pm</strong></span></h1>\n<p style=\"text-align: center;\">&nbsp;</p>\n<p style=\"text-align: center;\">Meet at Chuck E Cheese in the <br />BJs Plaza across from the McKinley Mall</p>\n<p style=\"text-align: center;\">&nbsp;</p>\n<p style=\"text-align: center;\"><hr /></p>', '', '1', '90', '0', '110', '2012-12-04 17:57:49', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2012-12-04 17:57:49', '2012-12-06 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '13', '', '', '1', '19', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('313', '372', 'Scavenger Hunt 4', 'scavenger-hunt-4', '', '<center> \n<hr />\n<br /></center><center><img src=\"images/stories/art-4.png\" />\n<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br /><a target=\"_blank\" href=\"images/pdf_files/2011_2012_pdf/scav4.pdf\">http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/scav4.pdf</a><br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/scav4.pdf|600|800}</p>\n<p> </p>\n<p> </p>\n<hr />\n<p> </p>\n</center>', '', '2', '90', '0', '110', '2011-10-20 00:32:29', '242', '', '2011-10-19 16:38:02', '242', '0', '0000-00-00 00:00:00', '2011-10-20 00:32:29', '2011-12-08 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '4', '0', '14', '', '', '1', '13', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('290', '373', 'Final Wednesday Meeting Tonight!', 'final-wednesday-meeting-tonight', '', '<div align=\"center\">\n<table border=\"0\" cellpadding=\"10\" cellspacing=\"1\" height=\"254\" width=\"100\">\n<tbody>\n<tr>\n<td colspan=\"3\" bgcolor=\"#ffa441\">\n<h1 align=\"center\"></h1>\n<h1 align=\"center\"><span style=\"font-size: small;\"><br /></span></h1>\n<div align=\"center\"><strong><span style=\"color: black; font-size: small;\"><br /></span></strong></div>\n<div align=\"center\">\n<p><span style=\"font-size: medium; color: #020703;\"><span style=\"font-size: 16px;\"><b>FINAL WEDNESDAY STOCKADE MEETING TONIGHT!</b></span></span></p>\n<p> </p>\n<div align=\"center\"><span style=\"font-size: 12pt;\"><b>7pm - 8:30pm</b></span></div>\n<div align=\"center\"></div>\n<div align=\"center\"><b><span style=\"font-size: 12pt;\">Food • Game • Prizes • Special Activities</span><br /></b></div>\n<p>--</p>\n<p><img src=\"http://2047.org/stockade/photoalbum/final_meeting_2010/panorama/Thumbnails/1.jpg\" height=\"153\" width=\"500\" /></p>\n<p> </p>\n<p> </p>\n<p> </p>\n</div>\n</td>\n</tr>\n</tbody>\n</table>\n</div>', '', '2', '90', '0', '110', '2011-06-08 13:21:58', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-06-08 13:21:58', '2011-06-09 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '15', '', '', '1', '4', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('376', '374', 'No Stockade - Bad Weather!', 'no-stockade-bad-weather', '', '<h1 style=\"text-align: center;\"></h1>\n<h1 style=\"text-align: center;\"></h1>\n<p> </p>\n<p style=\"text-align: center;\"><br /><br /><img width=\"84\" height=\"84\" src=\"images/stories/exclamation.gif\" /></p>\n<h1 style=\"text-align: center;\"></h1>\n<h1 style=\"text-align: center;\"></h1>\n<h1 style=\"text-align: center;\"></h1>\n<h1 style=\"text-align: center;\"><strong><br /><br />Orchard Park Schools are closed the entire day Tuesday due to weather&nbsp;</strong></h1>\n<p> </p>\n<p><strong><img src=\"images/stories/73_73.gif\" style=\"margin-top: 0px; margin-right: auto; margin-bottom: 0px; margin-left: auto; display: block; padding: 0px; border: 0px initial initial;\" /></strong></p>\n<p><strong><br /></strong></p>\n<h1 style=\"text-align: center;\"><strong>&nbsp;</strong><strong>THERE IS NO TUESDAY STOCKADE</strong></h1>\n<p><strong><br /><img src=\"images/stories/hiding.gif\" style=\"margin-top: 0px; margin-right: auto; margin-bottom: 0px; margin-left: auto; display: block; padding: 0px; border: 0px initial initial;\" /><br /></strong></p>\n<h1 style=\"text-align: center;\"><strong>See you next week, November 6th!</strong></h1>\n<h1 style=\"text-align: center;\"></h1>\n<p><img src=\"images/stories/umbrellasmilef.gif\" style=\"margin-top: 0px; margin-bottom: 0px; display: block; margin-left: auto; margin-right: auto; padding: 0px;\" /></p>\n<p> </p>\n<p><strong><span class=\"small\"><br /></span></strong></p>\n<div></div>\n<div></div>', '', '1', '90', '0', '110', '2012-10-30 02:39:08', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2012-10-30 02:39:08', '2012-10-31 05:01:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '15', '', '', '1', '27', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('291', '375', 'Final Tuesday Stockade June 14th', 'final-tuesday-stockade-june-14th', '', '<div align=\"center\">\n<table style=\"background-color: #ffff33; width: 499px; height: 191px;\" border=\"0\" cellpadding=\"10\" cellspacing=\"1\">\n<tbody>\n<tr>\n<td colspan=\"3\" bgcolor=\"#ffff00\">\n<h1 align=\"center\"><span style=\"font-size: medium; color: #008000;\"><span style=\"font-size: 16px;\"><b>FINAL TUESDAY STOCKADE MEETING!</b></span></span></h1>\n<div align=\"center\"><span style=\"font-size: medium; color: #008000;\"><span style=\"font-size: 16px;\"><b>Tuesday, June 14th<br /></b></span></span></div>\n<div align=\"center\">\n<p> </p>\n<div align=\"center\"><span style=\"font-size: 12pt; color: #008000;\"><b>7pm - 8:30pm</b></span></div>\n<div align=\"center\"></div>\n<div align=\"center\"><b><span style=\"font-size: 12pt; color: #008000;\">Food • Games • BB Guns • Water Balloon Launcher!</span><br /></b></div>\n</div>\n</td>\n</tr>\n</tbody>\n</table>\n</div>', '', '2', '90', '0', '110', '2011-06-12 21:23:05', '242', '', '2011-06-13 12:40:59', '242', '0', '0000-00-00 00:00:00', '2011-06-12 21:23:05', '2011-06-15 02:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '3', '0', '16', '', '', '1', '7', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('173', '376', 'Derby Time! 12', 'derby-time-11', '', '<br /> <center> \n<table style=\"text-align: center; width: 550px;\" border=\"1\" cellpadding=\"0\" cellspacing=\"2\">\n<tbody>\n<tr>\n<td bgcolor=\"#beffff\">\n<div align=\"center\"><span style=\"color: #000000; font-size: xx-large;\"><span style=\"font-size: 32px;\"><strong><br /></strong></span></span></div>\n<div align=\"center\"><a href=\"index.php?option=com_wrapper&amp;view=wrapper&amp;Itemid=108\"><span style=\"font-size: 14pt;\"><strong>2012 Derby Cars Photos are now online!</strong></span></a></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"><img style=\"margin-bottom: 15px;\" src=\"images/stories/derby-seal.gif\" height=\"133\" width=\"133\" /></div>\n<div align=\"center\"></div>\n<div align=\"center\"><span style=\"color: #000000; font-size: 32px; font-weight: bold;\">It\'s Pinewood Derby Time!</span><span style=\"color: #000000; font-weight: bold;\"><br /> </span></div>\n<div align=\"center\"></div>\n<div align=\"center\"><span style=\"color: #000000; font-weight: bold;\"><br />Cars available starting January 10<br /></span></div>\n<div align=\"center\">&nbsp;</div>\n<div align=\"center\">\n<table style=\"width: 386px;\" bgcolor=\"#fffaaa\" border=\"1\" cellpadding=\"0\" cellspacing=\"2\">\n<tbody>\n<tr>\n<td>\n<div style=\"color: #000000;\" align=\"center\">\n<p> </p>\n<p><em><strong style=\"color: #000000;\"><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\">Kit \'s available for purchase until March 1st. <br /> Cost is $10/kit.</span><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\">&nbsp;</span></strong></em></p>\n<p><em><strong><br /></strong></em></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><em><span style=\"color: #ff6600; font-size: xx-small;\"><strong>Need help making the derby car?</strong></span><span style=\"color: #ff6600;\"><strong> <br /> </strong></span></em></span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><em><span style=\"color: #ff6600;\"><strong>Derby Car Help Days</strong></span></em></span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif; color: #ff6600;\"><strong>Saturday, January 21, 11-2 <br /> Saturday, February 4, 9-12 <br /> Saturday, February 18, 2-5</strong></span></p>\n<hr />\n<p><span style=\"font-family: Trebuchet MS,Geneva,Arial,Helvetica,SunSans-Regular,sans-serif; color: #cc0033; font-size: x-small;\"><strong>Important Dates</strong></span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><strong>Saturday, February 25th -<br /> Test Day (voluntary) 11-3</strong></span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><strong><br /></strong></span></p>\n<p><span style=\"font-family: verdana,geneva;\"><strong>Tuesday February 28th </strong></span><strong><br />&nbsp; </strong><span style=\"font-family: verdana,geneva;\">Tuesday Stockade Due Day</span><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><strong><br /><br />Wednesday </strong></span><strong>February 29th</strong><br /><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><strong> </strong>Wednesday Stockade &amp; TC Due Day</span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><br /></span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif; color: #000000;\"><strong>Tuesday, March 6th<br /> </strong>RACE DAY FOR STOCKADE AND TC</span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif; color: #000000;\"><br /></span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><em><strong>Wednesday, March 7th<br /> <span style=\"color: #ff0000;\">No Stockade (Pioneer Girls Derby)</span></strong></em></span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><em><br /></em></span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><strong>Saturday, March 10th</strong><br /> REGIONAL FINALS FOR TOP 5 RACERS</span></p>\n<p> </p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><a href=\"index.php?option=com_content&amp;view=article&amp;id=328:2012-pinewood-derby-instructions-and-information&amp;catid=54:parent-letters&amp;Itemid=97\"><strong>Derby Instruction &amp; Rule sheet available here</strong></a><br /></span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><br /></span></p>\n</div>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n<div align=\"center\">\n<p> </p>\n<p> </p>\n<p><span style=\"color: #cc0033;\"><span style=\"color: #ff0000; font-size: 24px; font-weight: bold;\">Race Day is Tuesday, March 6th!</span><br /> </span><strong>&nbsp;</strong></p>\n<p> </p>\n<p><strong style=\"color: #000000;\">Races begin at 7pm, you can arrive starting at 6:20 to lubricate your car. <br /> Cars will be collected at 6:55pm!<br /> </strong></p>\n<div align=\"center\">\n<h3><span style=\"color: #8e0000;\"><strong>Time to buy and work on your car - if you need help contact Jim</strong></span></h3>\n</div>\n<div align=\"center\">\n<p><strong><a target=\"_blank\" href=\"index.php?option=com_content&amp;view=article&amp;id=328:2012-pinewood-derby-instructions-and-information&amp;catid=54:parent-letters&amp;Itemid=97\">All the dates and information are here</a></strong></p>\n<p> </p>\n<p><img src=\"stockade/photoalbum/derby09/Thumbnails/1.jpg\" align=\"middle\" border=\"0\" height=\"180\" width=\"240\" />. . <img src=\"stockade/photoalbum/derby09/Thumbnails/24.jpg\" align=\"middle\" border=\"0\" /></p>\n<p> </p>\n<p><strong><a target=\"_blank\" href=\"stockade/photoalbum/\">2003 Car Photos</a> <span style=\"color: #ff0000;\">\"</span> <a target=\"_blank\" href=\"stockade/photoalbum/\">2004 Car Photos</a> <span style=\"color: #ff0000;\">\"</span> <a target=\"_blank\" href=\"stockade/photoalbum/\">2005 Car Photos</a> <br /> <a target=\"_blank\" href=\"stockade/photoalbum/\">2006 Car Photos</a> <span style=\"color: #ff0000;\">\"</span> <a target=\"_blank\" href=\"stockade/photoalbum/\">2007 Car Photos</a> <span style=\"color: #ff0000;\">\"</span> <a target=\"_blank\" href=\"stockade/photoalbum/\">2008 Car Photos</a> <br /><span style=\"color: #ff0000;\">\"</span> <a target=\"_blank\" href=\"stockade/photoalbum/\">2009 Car Photos</a> </strong><strong style=\"color: #fc0c02;\">\" </strong><strong><a href=\"../stockade/photoalbum/derby10/\" target=\"_blank\">2010 Car Photos</a></strong><strong style=\"color: #fc0c02;\">\"</strong><strong style=\"color: #fc0c02;\"> </strong><a target=\"_blank\" href=\"http://2047.org/stockade/photoalbum/derby_2011/\"><strong>2011 Car Photos</strong></a><br /><strong><a target=\"_blank\" href=\"http://2047.org/stockade/photoalbum/tues_loop_11/\">2011 Loop Races</a></strong></p>\n<p> </p>\n<p><a target=\"_blank\" href=\"derby/derbylinks.html\">Page with Derby Links, How-to Video\'s, etc.</a></p>\n<p> </p>\n<p style=\"text-align: center;\"><img title=\"Derby\" src=\"derby/pinem1.gif\" align=\"middle\" border=\"0\" height=\"20\" width=\"540\" /></p>\n</div>\n</div>\n</td>\n</tr>\n</tbody>\n</table>\n</center>', '', '2', '90', '0', '110', '2011-12-27 05:00:00', '242', '', '2012-03-03 17:25:06', '242', '0', '0000-00-00 00:00:00', '2011-12-27 05:00:00', '2012-03-12 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '11', '0', '17', '', '', '1', '44', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('361', '377', 'Survey Tuesday Stockade', 'survey-tuesday-stockade', '', '<br /><br />\n<div align=\"center\">\n<p> </p>\n<table border=\"0\" cellpadding=\"0\" cellspacing=\"2\" height=\"135\" width=\"350\">\n<tbody>\n<tr>\n<td bgcolor=\"white\">\n<div align=\"center\">\n<h3><img src=\"images/stories/attention-green-clip-art.jpg\" height=\"138\" width=\"138\" /></h3>\n</div>\n</td>\n<td bgcolor=\"#ffff66\" width=\"388\">\n<h1 align=\"center\"><span style=\"font-size: 10pt;\"><b><a style=\"color: #0d08f6;\" href=\"../tues-survey.html\" target=\"_blank\">Tuesday Stockade<br /> Parent Survey</a></b></span></h1>\n</td>\n</tr>\n</tbody>\n</table>\n</div>', '', '0', '90', '0', '110', '2012-08-15 17:47:53', '242', '', '2012-08-15 17:57:30', '242', '0', '0000-00-00 00:00:00', '2012-08-15 17:47:53', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '17', '', '', '1', '39', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('359', '378', 'Stockade movie Night - the original Karate Kid!', 'stockade-movie-night-the-original-karate-kid', '', '<center> \n<table style=\"background-color: #ffff00; height: 150px; border: 6px solid #fc1f16;\" border=\"6\" cellpadding=\"5\" width=\"650\">\n<tbody>\n<tr style=\"background-color: #ffffff;\">\n<td>\n<div align=\"center\"><img src=\"images/stories/coming%20soon.gif\" border=\"0\" /></div>\n</td>\n</tr>\n<tr>\n<td>\n<div align=\"center\"></div>\n<div style=\"font-size: xx-large; font-weight: 600;\" align=\"center\"><span style=\"color: #800000;\" class=\"Apple-style-span\"><br /></span></div>\n<div style=\"font-size: xx-large; font-weight: 600;\" align=\"center\"><span style=\"color: #800000;\">Stockade Movie Night!</span></div>\n<div style=\"font-size: large; font-weight: 600;\" align=\"center\"></div>\n<div style=\"font-size: large; font-weight: 600;\" align=\"center\"><span style=\"color: #800000; font-size: 24px;\" class=\"Apple-style-span\"><br /></span></div>\n<div style=\"font-size: large; font-weight: 600;\" align=\"center\"><span style=\"color: #800000;\">August 25th</span></div>\n<div style=\"font-size: large; font-weight: 600;\" align=\"center\"><span style=\"color: #ff6600;\"><br />Arrive @ 7:45 - Movies begin at dusk.</span></div>\n<div style=\"font-size: large; font-weight: 600;\" align=\"center\"><span style=\"color: #ff6600;\">End about 10:15</span></div>\n<div style=\"font-size: large; font-weight: 600;\" align=\"center\"><span style=\"color: #ff6600;\"><br /></span></div>\n<div style=\"font-size: large; font-weight: 600;\" align=\"center\"></div>\n<div style=\"font-size: large; font-weight: 600;\" align=\"center\"></div>\n<div style=\"font-size: large; font-weight: 600;\" align=\"center\"><span style=\"color: #ff6600;\"><br /><img src=\"images/stories/the-karate-kid-1984-small.jpg\" height=\"303\" width=\"218\" /></span></div>\n<div style=\"font-size: large; font-weight: 600;\" align=\"center\"></div>\n<div style=\"font-size: large; font-weight: 600;\" align=\"center\"></div>\n<div style=\"font-size: large; font-weight: 600;\" align=\"center\"><span style=\"color: #ff6600;\"><br /></span></div>\n<h2 align=\"center\"></h2>\n<h2 align=\"center\"></h2>\n<h2 align=\"center\"><span style=\"color: #000000;\"><em><span style=\"color: #666666; font-size: 10px; font-style: normal; font-weight: normal;\" class=\"Apple-style-span\"> \n<object codebase=\"http://www.apple.com/qtactivex/qtplugin.cab#version=6,0,2,0\" classid=\"clsid:02bf25d5-8c17-4b23-bc80-d3488abddc6b\" type=\"video/quicktime\" height=\"185\" width=\"313\">\n<param name=\"bgcolor\" value=\"#ffffff\" />\n<param name=\"src\" value=\"../userfiles/kktrailer2.mov\" />\n<param name=\"autoplay\" value=\"true\" />\n<param name=\"controller\" value=\"true\" /><embed height=\"185\" width=\"313\" controller=\"true\" autoplay=\"true\" src=\"../userfiles/kktrailer2.mov\" bgcolor=\"#ffffff\" type=\"video/quicktime\">&nbsp;</embed>&nbsp;\n</object>\n&nbsp; </span> &nbsp; </em></span><em> &nbsp; </em><em> &nbsp; </em><em> &nbsp; </em><em> </em><em> </em></h2>\n<h2 align=\"center\"><span style=\"color: #000000;\"><em><span style=\"color: #666666; font-size: 10px; font-style: normal; font-weight: normal;\" class=\"Apple-style-span\">&nbsp; </span> </em></span><em> </em></h2>\n<p style=\"text-align: center;\"><span style=\"color: #000000;\"><em>Watch some movies under the stars (unless it rains, then we are inside) and eat at the same time!</em></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</center>', '', '1', '90', '0', '110', '2012-08-15 05:00:00', '242', '', '2012-08-15 11:32:16', '242', '0', '0000-00-00 00:00:00', '2012-08-15 05:00:00', '2012-08-26 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '4', '0', '18', '', '', '1', '31', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('357', '379', 'Derby Time! 2014', 'derby-time-2014', '', '<p>&nbsp;</p>\n<center>\n<table style=\"text-align: center; width: 550px;\" border=\"1\" cellpadding=\"0\" cellspacing=\"2\">\n<tbody>\n<tr>\n<td bgcolor=\"#beffff\">\n<div align=\"center\"><span style=\"color: #000000; font-size: xx-large;\"><span style=\"font-size: 32px;\"><strong>&nbsp;</strong></span></span></div>\n<div align=\"center\"><a href=\"index.php?option=com_wrapper&amp;view=wrapper&amp;Itemid=108\"><span style=\"font-size: 14pt;\"><strong>&nbsp;</strong></span></a></div>\n<div align=\"center\">&nbsp;</div>\n<div align=\"center\">&nbsp;</div>\n<div align=\"center\">&nbsp;</div>\n<div align=\"center\">&nbsp;</div>\n<div align=\"center\">&nbsp;</div>\n<div align=\"center\">&nbsp;</div>\n<div align=\"center\">&nbsp;</div>\n<div align=\"center\">&nbsp;</div>\n<div align=\"center\"><img style=\"margin-bottom: 15px;\" src=\"images/stories/derby-seal.gif\" height=\"133\" width=\"133\" /></div>\n<div align=\"center\">&nbsp;</div>\n<div align=\"center\"><span style=\"color: #000000; font-size: 32px; font-weight: bold;\">It\'s Pinewood Derby Time!</span><span style=\"color: #000000; font-weight: bold;\"><br /> </span></div>\n<div align=\"center\">&nbsp;</div>\n<div align=\"center\"><span style=\"color: #000000; font-weight: bold;\"><br />Cars available starting January 7th<br /></span></div>\n<div align=\"center\">&nbsp;</div>\n<div align=\"center\">\n<table style=\"width: 386px;\" bgcolor=\"#fffaaa\" border=\"1\" cellpadding=\"0\" cellspacing=\"2\">\n<tbody>\n<tr>\n<td>\n<div style=\"color: #000000;\" align=\"center\">\n<p>&nbsp;</p>\n<p><em><strong style=\"color: #000000;\"><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\">Kit \'s available for purchase until March 1st. <br /> Cost is $10/kit.</span><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\">&nbsp;</span></strong></em></p>\n<p><em><strong>&nbsp;</strong></em></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><em><span style=\"color: #ff6600; font-size: xx-small;\"><strong>Need help making the derby car?</strong></span><span style=\"color: #ff6600;\"><strong> <br /> </strong></span></em></span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><em><span style=\"color: #ff6600;\"><strong>Derby Car Help Days</strong></span></em></span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif; color: #ff6600;\"><strong>Saturday, January 18, 11-2 <br /> Saturday, February 1, 12-3 <br /> Saturday, February 15, 2-5</strong></span></p>\n<hr />\n<p><span style=\"font-family: Trebuchet MS,Geneva,Arial,Helvetica,SunSans-Regular,sans-serif; color: #cc0033; font-size: x-small;\"><strong>Important Dates</strong></span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><strong>Saturday, February 22nd -<br /> Test Day (voluntary) 11-3</strong></span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><strong>&nbsp;</strong></span></p>\n<p><span style=\"font-family: verdana,geneva;\"><strong>Tuesday February 25th </strong></span><strong><br />&nbsp; </strong><span style=\"font-family: verdana,geneva;\">Tuesday Stockade Due Day</span><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><strong><br /><br />Wednesday </strong></span><strong>February 26th</strong><br /><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><strong> </strong>Wednesday Stockade &amp; TC Due Day</span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\">&nbsp;</span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif; color: #000000;\"><strong>Tuesday, March 4th<br /> RACE DAY FOR STOCKADE AND TC</strong></span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif; color: #000000;\">&nbsp;</span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><em><strong>Wednesday, March 5th<br /> <span style=\"color: #ff0000;\">No Stockade (Pioneer Girls Derby)</span></strong></em></span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><em>&nbsp;</em></span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><strong>Saturday, March 8th</strong><br /> REGIONAL FINALS FOR TOP 5 RACERS<br />at our Gymnasium<br /></span></p>\n<p>&nbsp;</p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\"><a href=\"index.php?option=com_content&amp;view=category&amp;id=54&amp;Itemid=97\"><strong>Derby Instruction &amp; Rule sheet available here</strong></a><br /></span></p>\n<p><span style=\"font-family: Verdana,Arial,Helvetica,sans-serif;\">&nbsp;</span></p>\n</div>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n<div align=\"center\">\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<p><span style=\"color: #cc0033;\"><span style=\"color: #ff0000; font-size: 24px; font-weight: bold;\">Race Day is Tuesday, March 4th!</span><br /> </span><strong>&nbsp;</strong></p>\n<p>&nbsp;</p>\n<p><strong style=\"color: #000000;\">Races begin at 7pm, you can arrive starting at 6:20 to lubricate your car. <br /> Cars will be collected at 6:55pm!<br /> </strong></p>\n<div align=\"center\">\n<h3><span style=\"color: #8e0000;\"><strong>Time to buy and work on your car - if you need help contact Jim</strong></span></h3>\n</div>\n<div align=\"center\">\n<p><strong><a target=\"_blank\" href=\"index.php?option=com_content&amp;view=category&amp;id=54&amp;Itemid=97\">All the dates and information are here</a></strong></p>\n<p>&nbsp;</p>\n<p><img style=\"vertical-align: middle;\" src=\"../stockade/photoalbum/2011-12/derby12/Thumbnails/1.jpg\" height=\"180\" width=\"240\" />. . <img style=\"vertical-align: middle;\" src=\"../stockade/photoalbum/2011-12/derby12/Thumbnails/17.jpg\" /></p>\n<p>&nbsp;</p>\n<p><strong><a target=\"_blank\" href=\"stockade/photoalbum/\">2003 Car Photos</a> <span style=\"color: #ff0000;\">\"</span> <a target=\"_blank\" href=\"stockade/photoalbum/\">2004 Car Photos</a> <span style=\"color: #ff0000;\">\"</span> <a target=\"_blank\" href=\"stockade/photoalbum/\">2005 Car Photos</a> <br /> <a target=\"_blank\" href=\"stockade/photoalbum/\">2006 Car Photos</a> <span style=\"color: #ff0000;\">\"</span> <a target=\"_blank\" href=\"stockade/photoalbum/\">2007 Car Photos</a> <span style=\"color: #ff0000;\">\"</span> <a target=\"_blank\" href=\"stockade/photoalbum/\">2008 Car Photos</a> <br /><span style=\"color: #ff0000;\">\"</span> <a target=\"_blank\" href=\"stockade/photoalbum/\">2009 Car Photos</a> </strong><strong style=\"color: #fc0c02;\">\" </strong><strong><a href=\"../stockade/photoalbum/derby10/\" target=\"_blank\">2010 Car Photos</a></strong><strong style=\"color: #fc0c02;\">\"</strong><strong style=\"color: #fc0c02;\"> </strong><a target=\"_blank\" href=\"http://2047.org/stockade/photoalbum/derby_2011/\"><strong>2011 Car Photos</strong></a><br /><strong><a target=\"_blank\" href=\"http://2047.org/stockade/photoalbum/tues_loop_11/\">2011 Loop Races </a></strong><strong>&nbsp;</strong><strong style=\"color: #fc0c02;\">\"</strong><strong style=\"color: #fc0c02;\"> </strong><a target=\"_blank\" href=\"../stockade/photoalbum/2011-12/derby12/\"><strong style=\"color: #fc0c02;\">2012 Car Photos </strong></a><strong style=\"color: #fc0c02;\"><strong style=\"color: #fc0c02;\">\"</strong><a href=\"../stockade/photoalbum/2012-13/derby13/\"><strong style=\"color: #fc0c02;\"> </strong><strong style=\"color: #fc0c02;\">2013 Car Photos</strong></a></strong><a target=\"_blank\" href=\"../stockade/photoalbum/2011-12/derby12/\"><strong style=\"color: #fc0c02;\"><br /></strong></a></p>\n<p>&nbsp;</p>\n<p><a target=\"_blank\" href=\"derby/derbylinks.html\">Page with Derby Links, How-to Video\'s, etc.</a></p>\n<p>&nbsp;</p>\n<p style=\"text-align: center;\"><img title=\"Derby\" src=\"derby/pinem1.gif\" align=\"middle\" border=\"0\" height=\"20\" width=\"540\" /></p>\n</div>\n</div>\n</td>\n</tr>\n</tbody>\n</table>\n</center>', '', '1', '90', '0', '110', '2013-12-27 05:00:00', '242', '', '2013-08-19 17:56:19', '242', '0', '0000-00-00 00:00:00', '2013-12-27 05:00:00', '2014-03-10 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '5', '0', '19', '', '', '1', '46', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('352', '380', 'Tuesday Stockade Ends', 'tuesday-stockade-ends', '', '<hr />\n<br /> <center> \n<table border=\"1\" cellpadding=\"10\" cellspacing=\"2\" height=\"125\" width=\"437\">\n<tbody>\n<tr>\n<td bgcolor=\"white\" width=\"87\">\n<p><img alt=\"attention-green-clip-art\" style=\"float: right;\" src=\"images/stories/attention-green-clip-art.jpg\" height=\"87\" width=\"87\" /></p>\n<p> </p>\n<p> </p>\n</td>\n<td bgcolor=\"#ffff33\">\n<div align=\"center\">\n<h2 style=\"color: #000000; text-align: center;\"><span style=\"font-size: 12pt;\"><b>Tuesday Stockade Final Meeting<br /> Rocket Launch<br /> June 12 - 7:00 - 8:30pm<br /> </b>@ Chestnut Ridge Park, Casino Side</span></h2>\n<p style=\"color: #000000;\"> </p>\n<p style=\"color: #000000;\"><span style=\"font-size: 10pt;\"><i>follow the signs (hopefully we are at the bottom of the sledding hill)</i></span></p>\n</div>\n</td>\n</tr>\n</tbody>\n</table>\n</center> <br /> \n<hr />', '', '1', '90', '0', '110', '2012-06-12 16:54:24', '242', '', '2012-06-12 18:06:53', '242', '0', '0000-00-00 00:00:00', '2012-06-12 16:54:24', '2012-06-13 05:01:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '20', '', '', '1', '13', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('245', '381', 'Test Day #2 - 9am -Noon', 'test-day-2-9am-noon', '', '<br /> \n<hr />\n<br />\n<h1 style=\"text-align: center;\">TODAY 9AM - NOON</h1>\n<p> </p>\n<p style=\"text-align: center;\"><img src=\"images/stories/derby-seal.gif\" height=\"150\" width=\"150\" /></p>\n<p> </p>\n<h1 style=\"text-align: center;\"></h1>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\">Pinewood Derby Workday #2</span></h1>\n<p><span style=\"color: #ffff00;\"><br /></span></p>\n<h1 style=\"text-align: center;\"></h1>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\">Saturday, February 5th - 9am - noon<br /></span></h1>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\">@ the gym</span></h1>\n<p> </p>\n<p> </p>\n<hr />', '', '2', '90', '0', '110', '2011-02-05 12:51:03', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-02-05 12:51:03', '2011-02-06 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '21', '', '', '1', '6', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('335', '382', 'Pinewood Derby 2012 Results!', 'pinewood-derby-2012-results', '', '<center> \n<table border=\"1\" cellpadding=\"20\" cellspacing=\"2\" width=\"450\">\n<tbody>\n<tr>\n<td bgcolor=\"#ff9933\">\n<div align=\"center\">\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><img src=\"images/stories/derby-seal.gif\" height=\"146\" width=\"146\" /></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"color: #ffff00;\"><strong>Congratulations to </strong></span></p>\n<p style=\"text-align: center;\"><span style=\"color: #ffff00;\"><strong>the winners of the 2012 Pinewood Derby!</strong></span></p>\n<p style=\"text-align: center;\"><strong>1st - Kevin Krolikowski</strong></p>\n<p style=\"text-align: center;\"><strong>2nd - Isaac Johnson</strong></p>\n<p style=\"text-align: center;\"><strong>3rd - Tim Kwiatkowski</strong></p>\n<p style=\"text-align: center;\"><strong>4th - Jack Thomas</strong></p>\n<p style=\"text-align: center;\"><strong>5th - Jake Vergien</strong></p>\n<p style=\"text-align: center;\"><strong>6th - Kasper #2</strong></p>\n<p><strong>7th - Kasper #1</strong></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><strong><a href=\"../stockade/photoalbum/2011-12/derby12/\" target=\"_blank\">Photo Album Here</a></strong></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><strong>Best Looking Car - Kevin Krolikowski &amp; <br /> Tim Kwiatkowski<br /> </strong><strong> <br /> </strong></p>\n<p style=\"text-align: center;\"><strong>Most Original&nbsp; - Riley Winnert</strong></p>\n<p style=\"text-align: center;\"><strong><br /></strong></p>\n</div>\n</td>\n</tr>\n</tbody>\n</table>\n<p style=\"text-align: center;\"> </p>\n<div align=\"center\">\n<table border=\"1\" cellpadding=\"20\" cellspacing=\"2\" width=\"450\">\n<tbody>\n<tr>\n<td bgcolor=\"yellow\">\n<div align=\"center\">\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><img src=\"../stockade/photoalbum/2011-12/derby12/Thumbnails/56.jpg\" border=\"0\" /></p>\n<h1 style=\"text-align: center;\"></h1>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\"><strong><span style=\"color: black;\">Congratulations to </span></strong></span></h1>\n<h1 style=\"text-align: center;\"></h1>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\"><strong><span style=\"color: black;\">Kevin Krolikowski<br /> </span></strong></span></h1>\n<h1 style=\"text-align: center;\"></h1>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\"><strong><span style=\"color: black;\">Regional Champion</span></strong></span></h1>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"color: #ffff00;\"><strong><span style=\"color: black;\">11 Races - 11 First Place Finishes!</span></strong></span></p>\n<p style=\"text-align: center;\"><span style=\"color: #ffff00;\"><strong><span style=\"color: black;\">and</span></strong></span></p>\n<p style=\"text-align: center;\"><span style=\"color: #ffff00;\"><strong><span style=\"color: black;\">Tim Kwiatkowski<br /> Regional Best Looking Car</span></strong></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"color: black;\">&nbsp;</span></p>\n<p style=\"text-align: center;\"><strong><a href=\"../stockade/photoalbum/2011-12/derby12/\" target=\"_blank\"><span style=\"color: black;\">Photo Album Here</span></a></strong></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"color: black;\"><img src=\"../stockade/photoalbum/2011-12/derby12/Thumbnails/58.jpg\" /></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"color: black;\"><br /></span></p>\n</div>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '0', '90', '0', '110', '2012-03-13 14:14:49', '242', '', '2012-03-29 16:10:21', '242', '0', '0000-00-00 00:00:00', '2012-03-13 14:14:49', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '3', '0', '21', '', '', '1', '82', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('311', '383', 'Stockade Movie Night - Treasure Planet! you tube embed view only without editor', 'stockade-movie-night-treasure-planet', '', '<br /><center> \n<table style=\"background-color: black; width: 510px; height: 525px;\" align=\"center\" border=\"0\" cellpadding=\"7\" cellspacing=\"0\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\" height=\"176\">\n<td colspan=\"3\" style=\"text-align: left;\" bgcolor=\"black\" height=\"176\">\n<div><img src=\"images/stories/treasureplanet2.jpg\" /></div>\n</td>\n</tr>\n<tr style=\"text-align: left;\" height=\"250\">\n<td style=\"text-align: left;\" bgcolor=\"black\" height=\"250\" valign=\"top\" width=\"176\"><img src=\"images/stories/treasureplanet1.jpg\" /></td>\n<td colspan=\"2\" style=\"text-align: left;\" bgcolor=\"black\" height=\"250\" valign=\"top\">\n<div style=\"text-align: center;\">\n<iframe width=\"320\" height=\"217\" src=\"http://www.youtube.com/embed/OcC7nZwhTKo\" frameborder=\"0\" allowfullscreen></iframe>\n</object>\n&nbsp;</div>\n</td>\n</tr>\n<tr style=\"text-align: left;\">\n<td colspan=\"3\" style=\"text-align: center;\" bgcolor=\"#ffe649\">\n<div style=\"text-align: center;\">\n<p> </p>\n<h2><span style=\"font-family: verdana,geneva;\"><strong><span style=\"color: #ff0019;\">Stockade Movie Night</span></strong><strong><span style=\"color: #ff0019;\">&nbsp;</span></strong><strong><span style=\"color: #ff0019;\">&nbsp;</span></strong><strong><span style=\"color: #ff0019;\"> </span></strong></span></h2>\n<h2><span style=\"font-family: verdana,geneva;\"><strong><span style=\"color: #ff0019;\">Friday, October 21st, 7:15pm - 9:15pm</span></strong></span></h2>\n<p><span style=\"font-family: verdana,geneva;\"><span style=\"font-size: 14pt;\"><strong><span style=\"color: #ff0019;\"><br /></span></strong></span></span></p>\n</div>\n</td>\n</tr>\n</tbody>\n</table>\n<p> </p>\n</center>', '', '0', '90', '0', '110', '2011-10-18 17:58:35', '242', '', '2011-10-18 18:10:55', '242', '0', '0000-00-00 00:00:00', '2011-10-18 05:00:00', '0000-00-00 00:00:00', '', '', '{\"show_title\":0,\"link_titles\":0,\"show_intro\":0,\"show_section\":0,\"link_section\":0,\"show_category\":0,\"link_category\":0,\"show_vote\":0,\"show_author\":0,\"show_create_date\":0,\"show_modify_date\":0,\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '3', '0', '22', '', '', '1', '10', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('286', '384', 'Tuesday Stockade Fishing', 'tuesday-stockade-fishing', '', '<div align=\"center\">\n<table width=\"400\" border=\"0\" cellpadding=\"10\" cellspacing=\"1\">\n<tbody>\n<tr>\n<td colspan=\"3\" bgcolor=\"#00ff66\">\n<h1 align=\"center\"></h1>\n<h1 align=\"center\"><span style=\"font-size: small;\"><br /></span></h1>\n<div align=\"center\"><strong><span style=\"color: black; font-size: small;\"><br /></span></strong></div>\n<div style=\"color: #000000;\" align=\"center\">\n<h1><span style=\"color: #000000; font-size: medium;\"><span style=\"font-size: 16px;\"><b>Tuesday Stockade&nbsp;</b></span></span></h1>\n<h1><span style=\"color: #800000; font-size: medium;\"><span style=\"font-size: 16px;\"><b><span style=\"color: #000000;\">will be going fishing this week!</span></b></span></span></h1>\n<p> </p>\n<p><span style=\"color: #800000; font-size: medium;\"><span style=\"font-size: 16px;\"><b><span style=\"color: #000000;\">We leave the gym @ 7pm and <br />will return between 8:30 &amp; 8:45</span></b></span></span></p>\n<p> </p>\n<p><span style=\"color: #800000; font-size: medium;\"><span style=\"font-size: 16px;\"><b><span style=\"color: #000000;\">We have fishing poles for everyone.</span></b></span></span></p>\n<p> </p>\n<p><span style=\"color: #800000; font-size: medium;\"><span style=\"font-size: 16px;\"><b><span style=\"color: #000000;\">Any questions contact Jim @ 662-0335<br /></span></b></span></span></p>\n<p><span style=\"color: #800000;\"><strong style=\"font-size: 16px;\"><br /></strong></span></p>\n<p>--</p>\n<p> </p>\n<p> </p>\n</div>\n</td>\n</tr>\n</tbody>\n</table>\n</div>', '', '0', '90', '0', '110', '2011-05-31 11:51:03', '242', '', '2011-05-31 14:09:00', '242', '0', '0000-00-00 00:00:00', '2011-05-31 11:51:03', '2011-06-01 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '4', '0', '23', '', '', '1', '4', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('240', '385', 'Paradise Island Photos - Tuesday Stockade', 'paradise-island-photos-tuesday-stockade', '', '<div align=\"center\">\n<table style=\"background-color: #ed9911; width: 628px;\" border=\"0\" cellpadding=\"10\" cellspacing=\"1\">\n<tbody>\n<tr>\n<td colspan=\"3\" bgcolor=\"#ffcc33\">\n<h1 align=\"center\"></h1>\n<h1 align=\"center\"><strong><span style=\"color: black; font-size: small;\">Tuesday Stockade</span></strong></h1>\n<h1 align=\"center\"><strong><span style=\"color: black; font-size: small;\"><br />Paradise Island Field Trip</span></strong></h1>\n<p><strong><span style=\"color: black; font-size: small;\"><br /></span></strong></p>\n<p style=\"text-align: center;\"><strong><span style=\"color: black; font-size: small;\"><a target=\"_blank\" href=\"http://2047.org/stockade/photoalbum/paradise_island_tues/index.html\">Photos here!</a></span></strong></p>\n<p style=\"text-align: center;\"><strong><span style=\"color: black; font-size: small;\"><br /></span></strong></p>\n<div align=\"center\">\n<p><img style=\"vertical-align: middle;\" src=\"http://2047.org/stockade/photoalbum/paradise_island_tues/Thumbnails/1.jpg\" height=\"179\" width=\"240\" /><img style=\"vertical-align: middle;\" src=\"http://2047.org/stockade/photoalbum/paradise_island_tues/Thumbnails/32.jpg\" height=\"180\" width=\"239\" /></p>\n<p><img src=\"http://2047.org/stockade/photoalbum/paradise_island_tues/Thumbnails/47.jpg\" height=\"180\" width=\"242\" /><img src=\"http://2047.org/stockade/photoalbum/paradise_island_tues/Thumbnails/61.jpg\" height=\"180\" width=\"240\" /></p>\n<p> </p>\n<p><a href=\"index.php?option=com_wrapper&amp;view=wrapper&amp;Itemid=108\">Stockade Photo Album is Here</a></p>\n<p> </p>\n</div>\n</td>\n</tr>\n</tbody>\n</table>\n</div>', '', '0', '90', '0', '110', '2011-01-28 14:54:15', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-01-28 14:54:15', '2011-02-10 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '24', '', '', '1', '6', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('83', '386', 'Creature Feature 2012', 'creature-feature', '', '<div align=\"center\">\n<table border=\"0\" cellpadding=\"10\" cellspacing=\"1\" width=\"628\">\n<tbody>\n<tr>\n<td colspan=\"3\" bgcolor=\"#00ff66\">\n<h1 align=\"center\"></h1>\n<h1 align=\"center\"><strong><span style=\"color: black; font-size: small;\">Creature Feature 10<br /></span></strong></h1>\n<div align=\"center\"><strong><span style=\"color: black; font-size: small;\"><br /></span></strong></div>\n<div align=\"center\">\n<p><span style=\"color: #800000;\"><strong style=\"font-size: 16px;\">January 18th - You Don\'t Want to Miss This!</strong></span></p>\n<p><span style=\"color: #800000;\"><strong style=\"font-size: 16px;\"><br /></strong></span></p>\n<p><img src=\"../stockade/photoalbum/reptile.gif\" align=\"middle\" border=\"0\" />--<img style=\"vertical-align: middle;\" src=\"http://2047.org/stockade/photoalbum/creaturefeature2011/Thumbnails/33.jpg\" height=\"179\" width=\"240\" /></p>\n<p><img src=\"http://2047.org/stockade/photoalbum/creaturefeature2011/Thumbnails/53.jpg\" height=\"178\" width=\"240\" />&nbsp; <img src=\"stockade/photoalbum/creaturefeature8/Thumbnails/8.jpg\" border=\"0\" height=\"180\" width=\"240\" /></p>\n<p><a href=\"stockade/photoalbum/\" target=\"_blank\">See photographs and movies from the events from other years!</a></p>\n<p> </p>\n<p> </p>\n</div>\n</td>\n</tr>\n</tbody>\n</table>\n</div>', '', '1', '90', '0', '110', '2011-12-27 05:00:00', '242', '', '2011-12-27 14:15:25', '242', '0', '0000-00-00 00:00:00', '2011-12-27 05:00:00', '2012-01-20 05:00:00', '', '', '{\"show_title\":0,\"link_titles\":0,\"show_intro\":0,\"show_section\":0,\"link_section\":0,\"show_category\":0,\"link_category\":0,\"show_vote\":0,\"show_author\":0,\"show_create_date\":0,\"show_modify_date\":0,\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '7', '0', '25', '', '', '1', '322', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('230', '387', 'Tuesday Stockade - Paradise Island Special', 'tuesday-stockade-paradise-island-special', '', '<div align=\"center\">\n<table style=\"background-color: #ffff33; width: 500px;\" border=\"3\" cellpadding=\"0\" cellspacing=\"2\">\n<tbody>\n<tr>\n<td style=\"color: #009933;\" align=\"center\" valign=\"middle\">\n<p style=\"color: red; text-align: center;\"> </p>\n<p style=\"color: red; text-align: center;\"><span style=\"font-size: 18pt;\"><strong>Tuesday Stockade</strong></span></p>\n<p style=\"color: red; text-align: center;\"> </p>\n<p style=\"color: red; text-align: center;\"><span style=\"font-size: 14pt; color: #009933;\"><strong><em>a special Thursday Night activity</em></strong></span></p>\n<p style=\"color: red; text-align: center;\"> </p>\n<p style=\"color: red; text-align: center;\"><strong><span style=\"font-size: 24pt;\"><em>PARADISE ISLAND!</em></span></strong></p>\n<p style=\"color: red; text-align: center;\"><em><strong><br /></strong></em></p>\n<p style=\"text-align: center;\"><span style=\"font-size: 12pt;\"><strong><br /><em style=\"color: #ff0033;\">Thursday, February 9th</em></strong></span></p>\n<p style=\"text-align: center;\"><span style=\"font-size: 12pt;\"><strong><em style=\"color: #ff0033;\">meet at gym @ 5:45pm </em></strong></span></p>\n<p style=\"text-align: center;\"><span style=\"font-size: 12pt;\"><strong><em style=\"color: #ff0033;\">and we will return @ about 9:15</em><br /></strong></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><img src=\"images/stories/paradise_island_small1.jpg\" /><img src=\"images/stories/paradise_island_small2.jpg\" /></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><em><strong><span style=\"font-size: 12pt;\">Rock Climbing • Swimming • Neon Miniature Golf!</span></strong></em></p>\n<p style=\"text-align: center;\"><em><strong><span style=\"font-size: 12pt;\">Information at Stockade this week</span></strong></em></p>\n<p style=\"text-align: center;\"><em><strong><span style=\"font-size: 12pt;\">Permission Slip Required • Cost: $10</span></strong></em></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><em><strong><span style=\"font-size: 12pt;\"><br /></span></strong></em></p>\n<p style=\"text-align: center;\"><strong><a target=\"_blank\" href=\"images/pdf_files/pi_permission.pdf\">Permission Slip is Here</a></strong></p>\n<p style=\"text-align: center;\"><strong><br /></strong></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>', '', '1', '90', '0', '110', '2012-01-31 05:00:00', '242', '', '2012-01-31 15:34:16', '242', '0', '0000-00-00 00:00:00', '2012-01-31 05:00:00', '2012-02-10 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '4', '0', '26', '', '', '1', '11', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('172', '388', 'Pinewood Derby 11', 'pinewood-derby-11', '', '<div align=\"center\">\n<hr />\n</div>\n<div align=\"center\"></div>\n<div align=\"center\"><img src=\"images/stories/derby-seal.gif\" height=\"133\" width=\"133\" /></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\">\n<h1><span style=\"color: #ffcc00;\"><strong>48th Annual Pinewood Derby</strong></span></h1>\n<h2><span style=\"color: #ffcc00;\"><strong>for Stockade &amp; Tree Climbers</strong></span></h2>\n<h2><span style=\"color: #ffcc00;\"><strong>Tuesday, March 6 @ 7pm</strong></span></h2>\n<p><span style=\"color: #ffcc00;\"><strong><br /></strong></span></p>\n<p><strong><em>(you can arrive starting at 6:20pm to test your car)</em></strong></p>\n<p><strong><em>Everyone is invited! </em></strong></p>\n<p><span style=\"color: #ff0000;\"><strong><em>(No Stockade on Wednesday, March 9th due to the girls PowderPuff Derby)</em></strong></span></p>\n<p><span style=\"color: #ff0000;\"><strong><em><br /></em></strong></span></p>\n<p><strong><em> \n<hr />\n<br /></em></strong></p>\n</div>', '', '2', '90', '0', '110', '2012-03-05 05:00:00', '242', '', '2011-08-31 15:43:56', '242', '0', '0000-00-00 00:00:00', '2012-03-05 05:00:00', '2012-03-07 05:00:00', '', '', '{\"show_title\":0,\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '5', '0', '27', '', '', '1', '14', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('257', '389', 'Regional Finals', 'regional-finals', '', '<p style=\"text-align: center;\"><img src=\"images/stories/derby-seal.gif\" height=\"146\" width=\"146\" /></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"color: #ffff00;\"><strong>Congratulations to </strong></span></p>\n<p style=\"text-align: center;\"><span style=\"color: #ffff00;\"><strong>the winners of the 2012 Pinewood Derby!</strong></span></p>\n<p style=\"text-align: center;\"><strong><br /></strong></p>\n<p style=\"text-align: center;\"><strong>- - - - </strong></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><strong>Photographs to come<br /></strong></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><strong>Best Looking Car - <br /></strong></p>\n<p style=\"text-align: center;\"><strong>Best Looking Medal - <br /></strong></p>\n<p style=\"text-align: center;\"><strong>Most Original&nbsp; - <br /></strong></p>\n<p style=\"text-align: center;\"><strong> </strong></p>\n<hr />\n<strong> <br /></strong>\n<p> </p>\n<p style=\"text-align: center;\"> </p>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\"><strong>Regional Finals this Saturday</strong></span></h1>\n<p style=\"text-align: center;\"><span style=\"color: #ffff00;\">Hamburg Wesleyan Church, 4999 McKinley Drive</span></p>\n<p style=\"text-align: center;\"><a target=\"_blank\" href=\"http://maps.google.com/maps?daddr=4999+McKinley+Parkway,+Hamburg,+NY+14075-1027+%28Wesleyan+Church+of+Hamburg%29&amp;geocode=CaXLEJ7s4eGPFbhRjAIdJn9N-yFCNorc8Ncn9A&amp;dirflg=&amp;saddr=&amp;f=d&amp;dq=wesleyan+church+of+hamburg&amp;sll=42.750392,-78.807258&amp;sspn=0.071946,0.071946&amp;ie=UTF8&amp;ll=42.750195,-78.807249&amp;spn=0.010273,0.022724&amp;z=16\">Directions Here</a></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\">Weigh-in begins @ 9:30am sharp! Races begin after weighin is complete. BE ON TIME</p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\">Contact Jim if you can\'t attend - 662-0335 or <a href=\"mailto:jim@2047.org\">email</a></p>\n<p style=\"text-align: center;\"> </p>\n<hr />', '', '1', '90', '0', '110', '2012-03-06 05:00:00', '242', '', '2012-03-13 14:02:19', '242', '0', '0000-00-00 00:00:00', '2012-03-07 01:00:00', '2012-03-12 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '5', '0', '27', '', '', '1', '43', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('171', '390', 'Stockade Movie Night', 'stockade-movie-night', '', '<center>\n<h1>\n<div style=\"text-align: center;\"></div>\n<table style=\"background-color: black; width: 510px; height: 525px;\" align=\"center\" border=\"0\" cellpadding=\"7\" cellspacing=\"0\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\" height=\"176\">\n<td colspan=\"3\" style=\"text-align: left;\" bgcolor=\"black\" height=\"176\">\n<div><img src=\"http://www.2047.org/userfiles/goonies/webmonster.gif\" border=\"0\" height=\"176\" width=\"185\" /><img src=\"http://www.2047.org/userfiles/goonies/webkids.gif\" border=\"0\" height=\"176\" width=\"320\" /></div>\n</td>\n</tr>\n<tr style=\"text-align: left;\" height=\"250\">\n<td style=\"text-align: left;\" bgcolor=\"black\" height=\"250\" valign=\"top\" width=\"176\"><img src=\"http://www.2047.org/userfiles/goonies/webposter.gif\" border=\"0\" height=\"249\" width=\"176\" /></td>\n<td colspan=\"2\" style=\"text-align: left;\" bgcolor=\"black\" height=\"250\" valign=\"top\">\n<div style=\"text-align: center;\">\n<object height=\"253\" width=\"320\" codebase=\"http://www.apple.com/qtactivex/qtplugin.cab#version=6,0,2,0\" classid=\"clsid:02bf25d5-8c17-4b23-bc80-d3488abddc6b\">\n<param name=\"src\" value=\"http://www.2047.org/userfiles/goonies/web1.mov\" />\n<param name=\"autoplay\" value=\"true\" />\n<param name=\"controller\" value=\"true\" /><embed height=\"253\" width=\"320\" controller=\"true\" autoplay=\"true\" src=\"http://www.2047.org/userfiles/goonies/web1.mov\" type=\"video/quicktime\"></embed>\n</object>\n</div>\n</td>\n</tr>\n<tr style=\"text-align: left;\">\n<td colspan=\"3\" style=\"text-align: center;\" bgcolor=\"#ffe649\">\n<div style=\"text-align: center;\">\n<p><span style=\"font-family: verdana,geneva;\"><span style=\"font-size: 14pt;\"><strong><span style=\"color: #ff0019;\">Stockade/Tree Climbers Outdoor Movie Night</span></strong><strong><span style=\"color: #ff0019;\">&nbsp;</span></strong><strong><span style=\"color: #ff0019;\">&nbsp;</span></strong><strong><span style=\"color: #ff0019;\"> Friday, August 20th, 7:30pm - 10:00pm</span></strong></span></span></p>\n</div>\n</td>\n</tr>\n</tbody>\n</table>\n<p> </p>\n</h1>\n</center>', '', '2', '90', '0', '110', '2010-07-22 16:40:38', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2010-07-22 16:40:38', '2010-08-22 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '28', '', '', '1', '20', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('285', '391', 'Wednesday Stockade Fishing 2011', 'wednesday-stockade-fishing-2011', '', '<div align=\"center\">\n<table width=\"628\" border=\"0\" cellpadding=\"10\" cellspacing=\"1\">\n<tbody>\n<tr>\n<td colspan=\"3\" bgcolor=\"#ffa441\">\n<h1 align=\"center\"></h1>\n<h1 align=\"center\"><span style=\"font-size: small;\"><br /></span></h1>\n<div align=\"center\"><strong><span style=\"color: black; font-size: small;\"><br /></span></strong></div>\n<div align=\"center\">\n<p><span style=\"color: #800000; font-size: medium;\"><span style=\"font-size: 16px;\"><a target=\"_blank\" href=\"../stockade/photoalbum/fishingwed11/\"><b>2011 Wednesday Stockade Fishing Night<br /></b></a></span></span></p>\n<p>--</p>\n<p><img src=\"../stockade/photoalbum/fishingwed11/Thumbnails/2.jpg\" />&nbsp;<img src=\"../stockade/photoalbum/fishingwed11/Thumbnails/11.jpg\" /><img src=\"../stockade/photoalbum/fishingwed11/Thumbnails/17.jpg\" />&nbsp;<img src=\"../stockade/photoalbum/fishingwed11/Thumbnails/8.jpg\" />&nbsp;</p>\n<p> </p>\n<p> </p>\n<p><a href=\"stockade/photoalbum/\" target=\"_blank\">See photographs and movies from the events from other years!</a></p>\n<p> </p>\n<p> </p>\n</div>\n</td>\n</tr>\n</tbody>\n</table>\n</div>', '', '0', '90', '0', '110', '2011-05-26 12:05:32', '242', '', '2011-05-26 12:15:38', '242', '0', '0000-00-00 00:00:00', '2011-05-26 12:05:32', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '4', '0', '28', '', '', '1', '55', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('255', '392', 'Derby Cars are Due', 'derby-cars-are-due', '', '<div align=\"center\"><hr /></div>\n<div align=\"center\">&nbsp;</div>\n<div align=\"center\"><img style=\"margin-top: 15px; margin-bottom: 15px;\" src=\"images/stories/derby-seal.gif\" height=\"133\" width=\"133\" /></div>\n<div align=\"center\">&nbsp;</div>\n<div align=\"center\">\n<h1><span style=\"color: #ffff00;\"><strong>&nbsp;</strong></span><span style=\"color: #ffff00;\"><strong>Stockade &amp; Tree Climbers Derby Cars are due at Stockade &amp; Tree Climbers</strong></span><span style=\"color: #ffff00;\"><strong>&nbsp;</strong></span></h1>\n<h1><span style=\"color: #ffff00;\"><strong><br />Tuesday, February 25 and Wednesday February 26<br /></strong></span></h1>\n<p><span style=\"color: #ffff00;\"><strong>&nbsp;</strong></span></p>\n<p><strong><em>(if you have a car and did not hand it in at Stockade or TC you must contact Jim no later than Wednesday night.)</em></strong></p>\n<p><span style=\"color: #ff0000;\"><strong><em>(Our Pinewood Derby is on Tuesday, March 54@ 7pm for Both Stockades &amp; Tree Climbers)<br /></em></strong></span></p>\n<p><span style=\"color: #ff0000;\"><strong><em>&nbsp;</em></strong></span></p>\n<p>&nbsp;</p>\n<hr /><strong><em> <br /></em></strong>\n<p>&nbsp;</p>\n</div>', '', '1', '90', '0', '110', '2014-02-22 05:00:00', '242', '', '2013-08-19 17:58:54', '242', '0', '0000-00-00 00:00:00', '2014-02-22 05:00:00', '2014-03-01 05:00:00', '', '', '{\"show_title\":1,\"link_titles\":0,\"show_intro\":0,\"show_section\":0,\"link_section\":0,\"show_category\":0,\"link_category\":0,\"show_vote\":0,\"show_author\":0,\"show_create_date\":0,\"show_modify_date\":0,\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '6', '0', '29', '', '', '1', '28', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('283', '393', '2011 Stockarama Photo Album', '2011-stockarama-photo-album', '', '<div align=\"center\">\n<table width=\"628\" border=\"0\" cellpadding=\"10\" cellspacing=\"1\">\n<tbody>\n<tr>\n<td colspan=\"3\" bgcolor=\"#00ff66\">\n<h1 align=\"center\"></h1>\n<h1 align=\"center\"><span style=\"font-size: small;\"><br /></span></h1>\n<div align=\"center\"><strong><span style=\"color: black; font-size: small;\"><br /></span></strong></div>\n<div align=\"center\">\n<p><span style=\"color: #800000; font-size: medium;\"><span style=\"font-size: 16px;\"><a target=\"_blank\" href=\"http://2047.org/stockade/photoalbum/stockarama11/\"><b>2011 Stockarama Photo Album!</b></a></span></span></p>\n<p>--</p>\n<p><img src=\"http://2047.org/stockade/photoalbum/stockarama11/Thumbnails/4.jpg\" />&nbsp;<img src=\"http://2047.org/stockade/photoalbum/stockarama11/Thumbnails/179.jpg\" /><img src=\"http://2047.org/stockade/photoalbum/stockarama11/Thumbnails/119.jpg\" />&nbsp;<img src=\"http://2047.org/stockade/photoalbum/stockarama11/Thumbnails/93.jpg\" />&nbsp;</p>\n<p> </p>\n<p>A couple movies have been added!</p>\n<p> </p>\n<p><a href=\"stockade/photoalbum/\" target=\"_blank\">See photographs and movies from the events from other years!</a></p>\n<p> </p>\n<p> </p>\n</div>\n</td>\n</tr>\n</tbody>\n</table>\n</div>', '', '0', '90', '0', '110', '2011-05-19 15:19:28', '242', '', '2011-05-26 12:12:39', '242', '0', '0000-00-00 00:00:00', '2011-05-19 15:19:28', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '4', '0', '30', '', '', '1', '82', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('248', '394', 'Derby Work Day #3', 'derby-work-day-3', '', '<p>&nbsp;</p>\n<hr />\n<p>&nbsp;</p>\n<h1 style=\"text-align: center;\">DERBY HELP DAY #3</h1>\n<p>&nbsp;</p>\n<p style=\"text-align: center;\"><img src=\"images/stories/derby-seal.gif\" height=\"150\" width=\"150\" /></p>\n<p>&nbsp;</p>\n<h1 style=\"text-align: center;\">&nbsp;</h1>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\">Pinewood Derby Workday #3</span></h1>\n<p><span style=\"color: #ffff00;\">&nbsp;</span></p>\n<h1 style=\"text-align: center;\">&nbsp;</h1>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\">Saturday, February 15th - 2pm - 5pm<br /></span></h1>\n<h1 style=\"text-align: center;\"><span style=\"color: #ffff00;\">@ the gym</span></h1>\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<hr />', '', '1', '90', '0', '110', '2014-02-13 05:00:00', '242', '', '2013-08-19 18:04:19', '242', '0', '0000-00-00 00:00:00', '2014-02-13 05:00:00', '2014-02-17 06:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '6', '0', '31', '', '', '1', '8', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('100', '395', 'Derby Test Day Car Camera!', 'derby-test-day-car-camera', '', '<div align=\"center\"><div align=\"center\"><h2><span style=\"color: #800000\" class=\"Apple-style-span\">Video from our Derby Test Day and Pinewood Derby Race</span><br /></h2></div></div> 		<div align=\"center\"> 			<br /> 			<object classid=\"clsid:d27cdb6e-ae6d-11cf-96b8-444553540000\" codebase=\"http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,40,0\" width=\"480\" height=\"385\"><param name=\"width\" value=\"480\" /><param name=\"height\" value=\"385\" /><param name=\"allowfullscreen\" value=\"true\" /><param name=\"allowscriptaccess\" value=\"always\" /><param name=\"src\" value=\"http://www.youtube.com/v/PpE_TEF5oEc&hl=en&fs=1\" /><embed type=\"application/x-shockwave-flash\" width=\"480\" height=\"385\" allowfullscreen=\"true\" allowscriptaccess=\"always\" src=\"http://www.youtube.com/v/PpE_TEF5oEc&hl=en&fs=1\"></embed></object></div> 		<p align=\"center\"> </p> 		<p align=\"center\"> </p> 		<div align=\"center\"> 			<object classid=\"clsid:d27cdb6e-ae6d-11cf-96b8-444553540000\" codebase=\"http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,40,0\" width=\"480\" height=\"385\"><param name=\"width\" value=\"480\" /><param name=\"height\" value=\"385\" /><param name=\"allowfullscreen\" value=\"true\" /><param name=\"allowscriptaccess\" value=\"always\" /><param name=\"src\" value=\"http://www.youtube.com/v/jNOE7_6Pg48&hl=en&fs=1\" /><embed type=\"application/x-shockwave-flash\" width=\"480\" height=\"385\" allowfullscreen=\"true\" allowscriptaccess=\"always\" src=\"http://www.youtube.com/v/jNOE7_6Pg48&hl=en&fs=1\"></embed></object></div>', '', '2', '90', '0', '110', '2009-03-01 05:13:10', '242', '', '2009-08-15 14:23:25', '242', '0', '0000-00-00 00:00:00', '2009-03-02 09:13:10', '0000-00-00 00:00:00', '', '', '{\"show_title\":0,\"link_titles\":0,\"show_intro\":0,\"show_section\":0,\"link_section\":0,\"show_category\":0,\"link_category\":0,\"show_vote\":0,\"show_author\":0,\"show_create_date\":0,\"show_modify_date\":0,\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '15', '0', '32', '', '', '1', '132', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('267', '396', 'Stockade Movie Night - Tron', 'stockade-movie-night-tron', '', '<br /><center> \n<table style=\"background-color: black; width: 510px; height: 525px;\" align=\"center\" border=\"0\" cellpadding=\"7\" cellspacing=\"0\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\" height=\"176\">\n<td colspan=\"3\" style=\"text-align: left;\" bgcolor=\"black\" height=\"176\">\n<div><img src=\"images/stories/tron_legacy_by_rehsup1-500x312.jpg\" height=\"313\" width=\"504\" /></div>\n</td>\n</tr>\n<tr style=\"text-align: left;\" height=\"250\">\n<td style=\"text-align: left;\" bgcolor=\"black\" height=\"250\" valign=\"top\" width=\"176\"><img src=\"images/stories/tronlegacyb.jpg\" height=\"254\" width=\"177\" /></td>\n<td colspan=\"2\" style=\"text-align: left;\" bgcolor=\"black\" height=\"250\" valign=\"top\">\n<div style=\"text-align: center;\">\n<object codebase=\"http://www.apple.com/qtactivex/qtplugin.cab#version=6,0,2,0\" classid=\"clsid:02bf25d5-8c17-4b23-bc80-d3488abddc6b\" type=\"video/quicktime\" height=\"*\" width=\"320\">\n<param name=\"src\" value=\"../userfiles/tron.mov\" />\n<param name=\"autoplay\" value=\"true\" />\n<param name=\"controller\" value=\"true\" /><embed height=\"*\" width=\"320\" controller=\"true\" autoplay=\"true\" src=\"../userfiles/tron.mov\" type=\"video/quicktime\"></embed>&nbsp;\n</object>\n</div>\n</td>\n</tr>\n<tr style=\"text-align: left;\">\n<td colspan=\"3\" style=\"text-align: center;\" bgcolor=\"#ffe649\">\n<div style=\"text-align: center;\">\n<p> </p>\n<h2><span style=\"font-family: verdana,geneva;\"><strong><span style=\"color: #ff0019;\">Stockade Movie Night</span></strong><strong><span style=\"color: #ff0019;\">&nbsp;</span></strong><strong><span style=\"color: #ff0019;\">&nbsp;</span></strong><strong><span style=\"color: #ff0019;\"> </span></strong></span></h2>\n<h2><span style=\"font-family: verdana,geneva;\"><strong><span style=\"color: #ff0019;\">Saturday, April 9th, 6:30pm - 9:00pm</span></strong></span></h2>\n<p><span style=\"font-family: verdana,geneva;\"><span style=\"font-size: 14pt;\"><strong><span style=\"color: #ff0019;\"><br /></span></strong></span></span></p>\n</div>\n</td>\n</tr>\n</tbody>\n</table>\n<p> </p>\n</center>', '', '1', '90', '0', '110', '2011-04-05 15:23:53', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-04-05 15:23:53', '2011-04-10 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '32', '', '', '1', '20', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('151', '397', 'Movie Night June 5, 2010', 'movie-night-june-5-2010', '', '<center>\n<h1>\n<div style=\"text-align: center;\"></div>\n<table cellspacing=\"0\" cellpadding=\"7\" border=\"0\" align=\"center\" style=\"background-color: black; width: 510px; height: 525px;\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td bgcolor=\"black\" colspan=\"3\" style=\"text-align: left;\">\n<div></div>\n<div style=\"text-align: center;\"><img width=\"187\" height=\"157\" border=\"0\" src=\"userfiles/harry_hendersons/FilmHarryHendersons.jpg\" /><img width=\"281\" height=\"157\" border=\"0\" src=\"userfiles/harry_hendersons/harry_and_the_hendersons_1987_685x385.jpg\" /></div>\n</td>\n</tr>\n<tr style=\"text-align: left;\">\n<td width=\"176\" bgcolor=\"black\" style=\"text-align: left;\"><img width=\"176\" height=\"241\" border=\"0\" src=\"userfiles/harry_hendersons/HarryAndTheHendersons.jpg\" /></td>\n<td bgcolor=\"black\" colspan=\"2\" style=\"text-align: left;\">\n<div style=\"text-align: center;\">\n<object height=\"188\" width=\"246\" codebase=\"http://www.apple.com/qtactivex/qtplugin.cab#version=6,0,2,0\" classid=\"clsid:02bf25d5-8c17-4b23-bc80-d3488abddc6b\">\n<param name=\"src\" value=\"userfiles/harry_hendersons/harry2.mov\" />\n<param name=\"autoplay\" value=\"true\" />\n<param name=\"controller\" value=\"true\" /><embed height=\"188\" width=\"246\" controller=\"true\" autoplay=\"true\" src=\"userfiles/harry_hendersons/harry2.mov\" type=\"video/quicktime\"></embed>\n</object>\n</div>\n</td>\n</tr>\n<tr style=\"text-align: left;\">\n<td bgcolor=\"#ffe649\" colspan=\"3\" style=\"text-align: center;\">\n<div style=\"text-align: center;\">\n<p><span style=\"font-family: verdana,geneva;\"><span style=\"font-size: 14pt;\"><strong><span style=\"color: #ff0019;\">Stockade/Tree Climbers Outdoor Movie Night</span></strong><strong><span style=\"color: #ff0019;\">&nbsp;</span></strong><strong><span style=\"color: #ff0019;\">&nbsp;</span></strong><strong><span style=\"color: #ff0019;\"> Saturday, June 5th, 8:30pm - 10:30pm</span></strong></span></span></p>\n</div>\n</td>\n</tr>\n</tbody>\n</table>\n<p> </p>\n</h1>\n</center>', '', '2', '90', '0', '110', '2010-02-15 12:34:16', '242', '', '2010-06-06 13:22:31', '242', '0', '0000-00-00 00:00:00', '2010-04-17 04:34:16', '2010-06-06 05:01:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '11', '0', '33', '', '', '1', '63', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('212', '398', '11-30-10 Tuesday Stockade letter', '11-30-10-tuesday-stockade-letter', '', '<p>11/30/2010 Tuesday Stockade Letter</p>\n<p> </p>\n<p>If the letter does not show up, use this link&nbsp;<a href=\"images/pdf_files/letter-11-30-10.pdf\">http://www.2047.org/newweb/images/pdf_files/letter-11-30-10.pdf</a></p>\n<p> </p>\n<p>{pdf=http://www.2047.org/newweb/images/pdf_files/letter-11-30-10.pdf|600|800}</p>', '', '2', '86', '0', '87', '2010-12-01 13:28:43', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2010-12-01 13:28:43', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '16', '', '', '1', '140', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('320', '399', '11-15-11 Parent Letter Stockade Tues & Wed', '11-15-11-parent-letter-stockade-tues-a-wed', '', '<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br /><a target=\"_blank\" href=\"images/pdf_files/2011_2012_pdf/letter-11-15-11.pdf\">http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/letter-11-15-11.pdf</a><br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/letter-11-15-11.pdf|600|800}</p>', '', '2', '86', '0', '87', '2011-11-15 13:05:08', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-11-15 13:05:08', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '16', '', '', '1', '53', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('366', '400', '10-2-12 Tues & Wed Stockade Letter', '10-2-12-tues-a-wed-stockade-letter', '', '<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br />http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/10-2-12.pdf<br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/10-2-12.pdf|600|800}</p>', '', '1', '86', '0', '87', '2012-10-02 23:06:48', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2012-10-02 23:06:48', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '16', '', '', '1', '169', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('113', '401', 'Stockade Parent Letter 9/9/09', 'stockade-parent-letter-9909', '', '<font color=\"#000000\">Dear Parents and Boys,<br /><br />Welcome to Stockade!  <br /><br />Stockade meetings run from 7-8:30pm with boys being dropped off no earlier than 6:45pm and picked up no later than 8:45pm. If drop off or pick up will differ from these times let me know ahead of time.<br /><br />We have a web site at  www.2047.org for information on our group. The site includes current  information on Stockade, Tree Climbers, Battalion, Junior Staff, parent information, leader biographies, schedule, leader assignment schedule, and an online gameroom for the boys. Announcements and copies of the send home letters will be posted online as well.<br /><br />Please fill out the Permission/T-shirt slip and return to Stockade ASAP. If a replacement or additional copy is needed you can print one from our web page <strong>www.2047.org</strong> or see me for a replacement.<br /><br />All boy\'s taking part in any CSB activity must be registered members of Stockade and have their permission/medical slips on file. Permission slips are due ASAP and registration is due by the first week of October. Visitors to the group will have time to try us for several weeks before their registration is due.<br /><br />Registration for Stockade is unchanged from last year $60/boy. This is for the 09/10 brigade year, not a calendar year. This fee includes the fee we have to send to CSB National, various supplies, & Stockade T-Shirt.  Check\'s can be made out to CSB 2047 or Stockade 2047. If there is any problem in paying the registration,  or costs involved , let me know. Boy\'s will never miss and activity because of a lack of finances if we know the situation ahead of time.  <br /><br />Stockade does not have a “dues” and we don\'t sell candy bars, hold raffles or take part in any fund-raising. Some of our operating money comes from a voluntary giving we call shares. We request that each boy bring  50¢ - $1.00 a week.  A complete financial accounting will be posted at various times during the year and is available in the \"Parent Section\" of our web site.<br /><br />Besides Stockade we have Battalion for boy\'s aged 12 - 18, Tree Climber\'s for boy\'s aged 6 & 7 and their Dad\'s (or another responsible adult or teen). You can obtain information on any of the other groups either from me or on the web site.<br /><br />At Stockade we have an open door policy. Parent\'s are always welcome to drop by a meeting or activity to see what we do. Should you decide to drop by, please be as inconspicuous as possible and don\'t interrupt the boys or leaders during an ongoing activity.  References are also available on the group and myself by contacting the church office at 662-9842.<br /><a href=\"index.php?option=com_wrapper&view=wrapper&Itemid=58\" target=\"_blank\">The calendar for the year is available online here</a>. There will be date changes and additional activities scheduled as the year progresses. You\'ll be notified of these via hand-outs and online.<br /><br />Should you have any questions now or in the future you can contact me at jim@2047.org email or by phone at 662-0335.<br /><br />Sincerely,<br />Jim Szczodrowski<br />Chairman - Brigade #2047 <br /></font>', '', '2', '86', '0', '87', '2009-08-31 10:46:31', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2009-08-31 10:46:31', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '17', '', '', '1', '1154', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('319', '402', '11-15-11 Parent Letter TUESDAY Stockade', '11-15-11-parent-letter-tuesday-stockade', '', '<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br /><a target=\"_blank\" href=\"images/pdf_files/2011_2012_pdf/tues-special-11-15-11.pdf\">http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/tues-special-11-15-11.pdf</a><br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/tues-special-11-15-11.pdf|600|800}</p>', '', '2', '86', '0', '87', '2011-11-15 13:01:03', '242', '', '2011-11-15 13:10:37', '242', '0', '0000-00-00 00:00:00', '2011-11-15 13:01:03', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '4', '0', '17', '', '', '1', '37', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('364', '403', '9-6-12 Tree Climbers Memo', '9-6-12-tree-climbers-memo', '', '<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br />http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/tcmemo-9-6-12.pdf<br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/tcmemo-9-6-12.pdf|600|800}</p>', '', '1', '86', '0', '87', '2012-09-08 00:21:41', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2012-09-08 00:21:41', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '17', '', '', '1', '169', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('210', '404', '11-23-10 Tuesday Stockade letter', '11-23-10-tuesday-stockade-letter', '', '<p>11/23/2010 Tuesday Stockade Letter</p>\n<p> </p>\n<p>If the letter does not show up, use this link&nbsp;<a href=\"images/pdf_files/letter-11-23-10.pdf\">http://www.2047.org/newweb/images/pdf_files/letter-11-23-10.pdf</a></p>\n<p> </p>\n<p>{pdf=http://www.2047.org/newweb/images/pdf_files/letter-11-23-10.pdf|600|800}</p>', '', '2', '86', '0', '87', '2010-11-24 16:32:15', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2010-11-24 16:32:15', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '18', '', '', '1', '93', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('314', '405', '10-19-11 Parent Letter Stockade', '10-19-11-parent-letter-stockade', '', '<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br /><a target=\"_blank\" href=\"images/pdf_files/2011_2012_pdf/letter-10-18-11.pdf\">http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/letter-10-18-11.pdf</a><br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/letter-10-18-11.pdf|600|800}</p>', '', '2', '86', '0', '87', '2011-10-19 18:01:59', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-10-19 18:01:59', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '18', '', '', '1', '55', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('363', '406', '12-13 Informational Brochure', '12-13-informational-brochure', '', 'If the letter does not show up, use this link <a href=\"images/pdf_files/2012_2013_pdf/info_brochure_12-13.pdf\" target=\"_blank\">http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/info_brochure_12-13.pdf</a> {pdf=http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/info_brochure_12-13.pdf|900|1300}', '', '1', '86', '0', '87', '2012-08-23 22:49:53', '242', '', '2012-08-23 22:54:41', '242', '0', '0000-00-00 00:00:00', '2012-08-23 22:49:53', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '6', '0', '18', '', '', '1', '205', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('206', '407', '11-16-10 Tuesday Stockade Parent Letter', '11-16-10-tuesday-stockade-parent-letter', '', '<p>11/102010 Wednesday Stockade Letter</p>\n<p> </p>\n<p>If the letter does not show up, use this link&nbsp;<a href=\"images/pdf_files/letter-11-16-10.pdf\">http://www.2047.org/newweb/images/pdf_files/letter-11-16-10.pdf</a></p>\n<p> </p>\n<p>{pdf=http://www.2047.org/newweb/images/pdf_files/letter-11-16-10.pdf|600|800}</p>', '', '2', '86', '0', '87', '2010-11-16 19:00:35', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2010-11-16 19:00:35', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '19', '', '', '1', '127', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', '');

INSERT INTO tkt_content
(`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES 
('312', '408', '10-19-11 Stockade Scavenger Hunt 4', '10-19-11-stockade-scavenger-hunt-4', '', '<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br /><a target=\"_blank\" href=\"images/pdf_files/2011_2012_pdf/scav4.pdf\">http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/scav4.pdf</a><br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/scav4.pdf|600|800}</p>', '', '2', '86', '0', '87', '2011-10-20 00:00:16', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-10-20 00:00:16', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '19', '', '', '1', '69', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('362', '409', '9-11-12 Stockade First Night Letter', '9-11-12-stockade-first-night-letter', '', '<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br />http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/first_night_send_home_12-13.pdf<br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/first_night_send_home_12-13.pdf|600|800}</p>', '', '1', '86', '0', '87', '2012-08-23 12:11:56', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2012-08-23 12:11:56', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '19', '', '', '1', '213', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('202', '410', '11-10-10 Wednesday Stockade Parent Letter', '11-10-10-wednesday-stockade-parent-letter', '', '<p>11/102010 Wednesday Stockade Letter</p>\n<p> </p>\n<p>If the letter does not show up, use this link&nbsp;<a href=\"images/pdf_files/letter-11-10-10.pdf\">http://www.2047.org/newweb/images/pdf_files/letter-11-10-10.pdf</a></p>\n<p> </p>\n<p>{pdf=http://www.2047.org/newweb/images/pdf_files/letter-11-10-10.pdf|600|800}</p>', '', '2', '86', '0', '87', '2010-11-10 22:37:26', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2010-11-10 22:37:26', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '20', '', '', '1', '106', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('310', '411', '10-11-11 Parent Letter Stockade', '10-11-11-parent-letter-stockade', '', '<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br /><a target=\"_blank\" href=\"images/pdf_files/2011_2012_pdf/letter-10-11-11.pdf\">http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/letter-10-11-11.pdf</a><br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/letter-10-11-11.pdf|600|800}</p>', '', '2', '86', '0', '87', '2011-10-11 17:39:15', '242', '', '2011-10-19 18:04:40', '242', '0', '0000-00-00 00:00:00', '2011-10-11 17:39:15', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '20', '', '', '1', '54', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('360', '412', '8-16-12 Parent Letter Tuesday Stockade', '8-16-12-parent-letter-tuesday-stockade', '', '<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br />http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/letter-8-14-12-tues-ltr.pdf<br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/letter-8-14-12-tues-ltr.pdf|600|800}</p>', '', '1', '86', '0', '87', '2012-08-15 17:32:52', '242', '', '2012-08-15 17:58:32', '242', '0', '0000-00-00 00:00:00', '2012-08-15 05:00:00', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '20', '', '', '1', '182', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('199', '413', '10-19-2010 Stockade Parent Letter', '10-19-2010-stockade-parent-letter', '', '<p>10/19 &amp; 20/2010 Stockade Letter</p>\n<p> </p>\n<p>If the letter does not show up, use this link&nbsp;<a href=\"images/pdf_files/letter-10-19-10.pdf\">http://www.2047.org/newweb/images/pdf_files/letter-10-19-10.pdf</a></p>\n<p> </p>\n<p>{pdf=http://www.2047.org/newweb/images/pdf_files/letter-10-19-10.pdf|600|800}</p>', '', '2', '86', '0', '87', '2010-10-19 13:02:12', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2010-10-19 13:02:12', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '21', '', '', '1', '141', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('295', '414', 'First Night Send Home - Stockade', 'first-night-send-home-stockade', '', '<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br /><a target=\"_blank\" href=\"images/pdf_files/2011_2012_pdf/first_night_send_home_11-12.pdf\">http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/first_night_send_home_11-12.pdf</a><br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/first_night_send_home_11-12.pdf|600|800}</p>', '', '2', '86', '0', '87', '2011-09-07 11:10:29', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-09-07 11:10:29', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '21', '', '', '1', '101', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('358', '415', 'Derby Rules & Instructions 2013', 'derby-rules-a-instructions-2013', '', '<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br />http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/derby_rules_13.pdf<br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/derby_rules_13.pdf|600|800}</p>', '', '1', '86', '0', '87', '2012-12-27 05:00:00', '242', '', '2012-07-27 16:12:27', '242', '0', '0000-00-00 00:00:00', '2012-12-27 05:00:00', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '4', '0', '21', '', '', '1', '119', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('196', '416', '10-5-2010 Stockade Parent Letter', '10-5-2010-stockade-parent-letter', '', '<p>10/5 &amp; 6/2010 Stockade Letter</p>\n<p> </p>\n<p>If the letter does not show up, use this link&nbsp;<a href=\"images/pdf_files/letter-10-5-10.pdf\">http://www.2047.org/newweb/images/pdf_files/letter-10-5-10.pdf</a></p>\n<p> </p>\n<p>{pdf=http://www.2047.org/newweb/images/pdf_files/letter-10-5-10.pdf|600|800}</p>', '', '2', '86', '0', '87', '2010-10-05 15:57:18', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2010-10-05 15:57:18', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '22', '', '', '1', '181', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('294', '417', '2011-12 Permission Slip', '2011-12-permission-slip', '', '<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br />http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/permission%20_slip_11-12.pdf<br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/permission%20_slip_11-12.pdf|600|800}</p>', '', '2', '86', '0', '87', '2011-08-24 15:53:04', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-08-24 15:53:04', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '22', '', '', '1', '91', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('190', '418', 'Permission Slip 2010-11', 'permission-slip-2010-11', '', '<p>5/26/10 Parent Letter - Stockade</p>\n<p> </p>\n<p>If the letter does not show up, use this link&nbsp;<a href=\"images/pdf_files/permission_10-11.pdf\" target=\"_blank\">http://www.2047.org/newweb/images/pdf_files/permission_10-11.pdf</a></p>\n<p> </p>\n<p>{pdf=http://www.2047.org/newweb/images/pdf_files/permission_10-11.pdf|600|800}</p>', '', '2', '86', '0', '87', '2010-09-09 11:58:42', '242', '', '2010-09-09 12:03:58', '242', '0', '0000-00-00 00:00:00', '2010-09-09 11:58:42', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '4', '0', '23', '', '', '1', '1731', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('282', '419', '5-18-11 Parent Letter Wed Stockade', '5-18-11-parent-letter-wed-stockade', '', '&nbsp;If the letter does not show up, use this link <br /><br /><a href=\"images/pdf_files/letter-5-18-11.pdf\">http://www.2047.org/newweb/images/pdf_files/letter-5-18-11.pdf</a> <br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/letter-5-18-11.pdf|600|800}', '', '2', '86', '0', '87', '2011-05-19 14:30:13', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-05-19 14:30:13', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '23', '', '', '1', '142', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('349', '420', 'Stockarama Gear List', 'stockarama-gear-list', '', '<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br /><a href=\"images/pdf_files/2011_2012_pdf/stockarama_gear_list.pdf\" target=\"_blank\">http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/stockarama_gear_list.pdf</a><br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/stockarama_gear_list.pdf|600|800}</p>', '', '1', '86', '0', '87', '2013-05-01 18:19:35', '242', '', '2012-07-27 16:17:27', '242', '0', '0000-00-00 00:00:00', '2013-05-01 18:19:35', '2013-05-20 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '23', '', '', '1', '96', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('191', '421', '9/14/10 Stockade Parent Letter', '91410-stockade-parent-letter', '', '<p>9/14 &amp; 15/2010 Stockade Letter</p>\n<p> </p>\n<p>If the letter does not show up, use this link&nbsp;<a href=\"images/pdf_files/first_night_10-11.pdf\">http://www.2047.org/newweb/images/pdf_files/first_night_10-11.pdf</a></p>\n<p> </p>\n<p>{pdf=http://www.2047.org/newweb/images/pdf_files/first_night_10-11.pdf|600|800}</p>', '', '2', '86', '0', '87', '2010-09-14 17:31:55', '242', '', '2010-09-14 17:35:03', '242', '0', '0000-00-00 00:00:00', '2010-09-14 17:31:55', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '3', '0', '24', '', '', '1', '175', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('281', '422', '5-10-11 Parent Letter Tues & Wed Stockade', '5-10-11-parent-letter-tues-a-wed-stockade', '', 'If the letter does not show up, use this link <br /><br /><a href=\"images/pdf_files/letter-5-10-11.pdf\">http://www.2047.org/newweb/images/pdf_files/letter-5-10-11.pdf.pdf</a> <br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/letter-5-10-11.pdf|600|800}', '', '2', '86', '0', '87', '2011-05-11 11:49:56', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-05-11 11:49:56', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '24', '', '', '1', '148', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('211', '423', 'Paradise Island permission slip', 'paradise-island-permission-slip', '', '<p>Paradise Island Permission Slip</p>\n<p> </p>\n<p>If the letter does not show up, use this link&nbsp;<a href=\"images/pdf_files/pi_permission.pdf\">http://www.2047.org/newweb/images/pdf_files/pi_permission.pdf</a></p>\n<p> </p>\n<p>{pdf=http://www.2047.org/newweb/images/pdf_files/pi_permission.pdf|600|800}</p>', '', '2', '86', '0', '87', '2011-12-06 05:00:00', '242', '', '2011-12-06 22:34:35', '242', '0', '0000-00-00 00:00:00', '2011-12-06 05:00:00', '2011-12-09 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '5', '0', '25', '', '', '1', '116', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('402', '424', 'Wednesday Stockade is Fishing Tonight', 'wednesday-stockade-is-fishing-tonight', '', 'Wednesday Stockade is Fishing Tonight we leave at 7 and will return between 8 and 8:45\n\n<span class=\"small\">Posted from my iPhone using <a href=\"http://www.covertapps.com/jam\">Joomla Admin Mobile!</a></span>', '', '1', '90', '0', '107', '2013-05-29 21:21:07', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '2013-05-30 01:20:54', '', '', '{}', '1', '0', '0', '', '', '1', '26', '{}', '1', '*', ''),
('287', '425', 'Parent Survey 2011', 'parent-survey-2011', '', '<hr />\n<div align=\"center\">\n<table border=\"2\" cellpadding=\"5\" cellspacing=\"2\" width=\"400\">\n<tbody>\n<tr>\n<td bgcolor=\"white\"><img style=\"float: right;\" src=\"images/stories/2047_artwork/survey_clipart.png\" height=\"105\" width=\"146\" /></td>\n<th background=\"http://www.2047.org/stockade/newart/org_new_grad.gif\">\n<h2 style=\"color: #000000;\">PARENTS<br /> <a href=\"http://2047.org/survey.html\" target=\"_blank\"> Take our Survey</a></h2>\n</th>\n</tr>\n</tbody>\n</table>\n</div>\n<hr />', '', '0', '90', '0', '107', '2011-05-31 13:58:21', '242', '', '2011-06-15 11:15:58', '242', '0', '0000-00-00 00:00:00', '2011-05-31 13:58:21', '0000-00-00 00:00:00', '', '', '{\"show_title\":0,\"link_titles\":0,\"show_intro\":0,\"show_section\":0,\"link_section\":0,\"show_category\":0,\"link_category\":0,\"show_vote\":0,\"show_author\":0,\"show_create_date\":0,\"show_modify_date\":0,\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '11', '0', '2', '', '', '1', '37', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('242', '426', 'No Stockade', 'no-stockade', '', '<h2 style=\"text-align: center;\">\n<hr />\n</h2>\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"><span style=\"color: #ff0000;\">DUE TO ORCHARD PARK SCHOOLS <br />BEING CLOSED</span><span style=\"color: #ff0000;\"> DUE TO WEATHER</span></h2>\n<h2 style=\"text-align: center;\"><span style=\"color: #ff0000;\"><br />THERE IS NO WEDNESDAY STOCKADE TONIGHT (2/2/11)</span></h2>\n<h2 style=\"text-align: center;\"><span style=\"color: #ffff00;\"><br /><strong>IF YOU NEED TO BUY A DERBY CAR BEFORE NEXT WEDNESDAY<br />CALL ME @ 662-0335 AND I CAN MEET YOU AT THE GYM ANYTIME</strong></span><span style=\"color: #ffff00;\"><strong>&nbsp;</strong> </span></h2>\n<p><span style=\"color: #ffff00;\"><br /></span></p>\n<p> </p>\n<hr />', '', '1', '90', '0', '107', '2011-02-02 14:40:55', '242', '', '2011-02-02 14:47:11', '242', '0', '0000-00-00 00:00:00', '2011-02-02 14:40:55', '2011-02-03 06:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '4', '0', '3', '', '', '1', '8', '{\"robots\":\"\",\"author\":\"\"}', '1', '*', ''),
('182', '427', 'About Stockade #2047', 'about-stockade-2047', '', '<p><strong>Christian Service Brigade #2047</strong> is a boys and teens group from the Wesleyan Church of Orchard Park.  Brigade #2047 has been active in Orchard Park since the early 1960\'s.</p>\n<p> </p>\n<p><span style=\"color: #000000;\"><span style=\"color: white;\"><a href=\"index.php?option=com_content&view=category&id=37:stockade&layout=blog&Itemid=53\"><strong>Stockade</strong></a><strong> </strong>(Tuesday or Wednesday\'s 7-8:30pm) is an active group aimed at the 8 - 12 year old boy.</span></span></p>\n<ul>\n<li><span style=\"color: #000000;\"><span style=\"color: white;\">Boys have a structured and organized meeting time of games, post time (small group\'s), crafts, special events and story circle.</span></span></li>\n<li><span style=\"color: #000000;\"><span style=\"color: white;\"><br /></span></span></li>\n<li><span style=\"color: #000000;\"><span style=\"color: white;\">Stockade also takes part in many extra activities which include, overnights, game nights, camping trips, pinewood derby, reptile night, <a href=\"http://www.camphickoryhill.org\" target=\"_blank\">Summer Camp</a> and others! </span></span></li>\n</ul>\n<p> </p>\n<p>CSB 2047 has two Stockade groups. Tuesday, a smaller group and Wednesday a larger group. They takje aprt in the same activities, schedule, etc. The only difference is the size of the group.</p>\n<br />More information on CSB #2047 can be <a href=\"index.php?option=com_content&view=section&id=13&layout=blog&Itemid=67\">found here</a>.<br />', '', '1', '90', '0', '107', '2010-08-26 12:33:54', '242', '', '2010-08-31 13:10:07', '242', '0', '0000-00-00 00:00:00', '2010-08-26 12:33:54', '0000-00-00 00:00:00', '', '', '{\"show_title\":0,\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '9', '0', '5', '', '', '1', '136', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('405', '428', 'Facebook Feed', 'facebook-feed', '', '<hr><hr><hr>\n\n<i><font color=\"#cccccc\">Facebook Feed - updates to the 2047.org website are automatically fed to facebook. Photo\'s and info as activities are ongoing may be sent directly to facebook. Any photo\'s uploaded to facebook are there temporarily as the event is ongoing. Afterwards the images will be removed and stay resident on 2047.org</font></i><br /><br />\n\n<center><iframe src=\"http://www.facebook.com/plugins/likebox.php?id=107026129324790&width=400&connections=10&stream=true&header=true&height=387\" scrolling=\"no\" frameborder=\"0\" style=\"border:none; overflow:hidden; background-color: white; width:400px; height:400px;\" allowTransparency=\"true\"></iframe></center>', '', '1', '90', '0', '111', '2013-07-16 18:11:25', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2013-07-16 18:11:25', '0000-00-00 00:00:00', '', '', '{\"show_title\":0,\"link_titles\":0,\"show_intro\":0,\"show_section\":0,\"link_section\":0,\"show_category\":0,\"link_category\":0,\"show_vote\":0,\"show_author\":0,\"show_create_date\":0,\"show_modify_date\":0,\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '1', '', '', '1', '23', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('371', '429', 'twitter test', 'twitter-test', '', '<p><strong><span style=\"font-size: 10pt;\">To receive updates by text message - send the text &nbsp;&nbsp; \"follow csb2047\" to&nbsp; 40404</span></strong></p>\n<p> </p>\n<a class=\"twitter-timeline\" data-dnt=true href=\"https://twitter.com/csb2047\" data-widget-id=\"243675580422307840\">Tweets by @csb2047</a>\n<script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0];if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src=\"//platform.twitter.com/widgets.js\";fjs.parentNode.insertBefore(js,fjs);}}(document,\"script\",\"twitter-wjs\");</script>', '', '1', '90', '0', '111', '2012-10-23 17:26:10', '242', '', '2013-07-16 18:10:08', '242', '0', '0000-00-00 00:00:00', '2012-10-23 17:26:10', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '6', '0', '2', '', '', '1', '153', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('408', '430', 'FishCam', 'fishcam', '', '<center><span style=\"font-size: 14pt;\"><strong>2047 Aquarium</strong></span></center><center><br />Can you see the Shrimp, Ghost Cat Fish or African Frogs?</center><center></center><center>The time at the bottom right is when the image was taken. </center><center></center><center>When the camera is on it uploads a new picture every 1 minute.<br />Reload the page to update the picture.<br /><br /></center><center></center><center><img name=\"webcam\" src=\"../fishcam/index.jpg\" width=\"510\" height=\"382\" /><center></center></center>', '', '0', '90', '0', '111', '2013-08-03 15:36:10', '242', '', '2013-08-03 15:45:27', '242', '0', '0000-00-00 00:00:00', '2013-08-03 15:36:10', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '7', '0', '3', '', '', '1', '25', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('375', '431', 'QOW #293 - Wednesday Stockade', 'qow-293-wednesday-stockade', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p> </p>\n<table width=\"600\" height=\"277\" cellspacing=\"3\" cellpadding=\"4\" border=\"3\" style=\"background-color: #ffff66; width: 600px; height: 300px;\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td valign=\"middle\" style=\"font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px; color: #fc1102; background-color: #ffff66; text-align: left;\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<br /><br />\n<h2 style=\"text-align: center;\">Wednesday Question of the Week</h2>\n<p> </p>\n<p> </p>\n<h1 style=\"text-align: center;\"><img width=\"150\" height=\"55\" src=\"../stockade/newart/QOW_animated.gif\" alt=\" \" /><strong>#293</strong></h1>\n<p><strong><br /></strong></p>\n<h2 style=\"text-align: center;\"><img src=\"https://encrypted-tbn3.gstatic.com/images?q=tbn:ANd9GcRqR_jFg8C13r9SSRiCVcrDJXL_T-kIIkNW0T7htAbr5RydWNF_7Q\" width=\"250\" /></h2>\n<p><strong><br /></strong></p>\n<p style=\"text-align: center;\"><span style=\"font-size: medium; color: #000000;\"><span style=\"font-size: 16px;\">&nbsp;</span></span><b>What US State only has 1 syllable?<br />(no checking on google or online)</b></p>\n<p style=\"text-align: center;\"><a href=\"stockade/qownewest.html\" target=\"_blank\"><br /></a><span style=\"font-size: 10pt;\"><strong><a href=\"stockade/qownewest.html\" target=\"_blank\">Click Here to answer the Question!</a></strong></span></p>\n<h2 style=\"font-size: 1.3em; color: #000000; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\"></h2>\n<p style=\"text-align: center;\"><span style=\"font-size: small;\"><span style=\"font-size: 13px;\"><b><span style=\"font-size: large;\"><span style=\"font-size: 18px; font-weight: normal;\"><br /></span></span></b></span></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '1', '90', '0', '109', '2012-10-24 17:24:49', '242', '', '2012-10-24 17:27:29', '242', '0', '0000-00-00 00:00:00', '2012-10-25 01:00:49', '2012-11-07 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '1', '', '', '1', '27', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('374', '432', 'QOW #292 - Tuesday Stockade', 'qow-292-tuesday-stockade', '', '<center>\n<p> </p>\n<p> </p>\n<table width=\"600\" cellspacing=\"2\" cellpadding=\"25\" border=\"1\" background=\"http://www.2047.org/stockade/newart/bluegrad.gif\">\n<tbody>\n<tr>\n<td style=\"color: #000099; text-align: center;\">\n<p> </p>\n<h1 style=\"text-align: center;\"><img width=\"150\" height=\"55\" src=\"../stockade/newart/QOW_animated.gif\" alt=\" \" /></h1>\n<h1><span style=\"font-size: 14pt; color: #000080;\"><br />#292 Tuesday Question of the Week</span></h1>\n<p> </p>\n<p> </p>\n<p><img width=\"200\" src=\"http://t0.gstatic.com/images?q=tbn:ANd9GcSyaTen32uyh6PJtw6fgA2MzBf8Bv7YrJ7s4nY82F6QqSl6O95Z7Q\" /></p>\n<br />\n<div align=\"center\"><b>Hw many Super Bowls did the Buffalo Bills play in?</b></div>\n<div style=\"text-align: center;\">\n<p> </p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a target=\"_blank\" href=\"stockade/qownewest.html\">Click Here to answer the Question!</a></strong></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><br /></strong></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</center>', '', '1', '90', '0', '109', '2012-10-24 17:18:22', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2012-10-24 17:18:22', '2012-10-30 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '2', '', '', '1', '19', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('216', '433', 'QOW #254', 'qow-254', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p> </p>\n<table style=\"background-color: #ffff66; width: 600px; height: 300px;\" height=\"277\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\" width=\"600\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px; color: #fc1102; background-color: #ffff66; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\">Question of the Week</h2>\n<p> </p>\n<p> </p>\n<h1 style=\"text-align: center;\"><img src=\"../stockade/newart/QOW_animated.gif\" alt=\" \" height=\"55\" width=\"150\" /><strong>#253</strong></h1>\n<h2 style=\"text-align: center;\"><strong><br /></strong></h2>\n<div style=\"text-align: center;\"><img src=\"images/stories/starwars.jpg\" height=\"93\" width=\"155\" /><br />\n<p><span style=\"font-size: medium; color: #000000;\"><span style=\"font-size: 16px;\">In \"Star Wars\",what is the name of Hans Solo\'s ship?</span></p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a href=\"stockade/qownewest.html\" target=\"_blank\">Click Here to answer the Question!</a></strong></span></p>\n<h2 style=\"font-size: 1.3em; color: #000000; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\"></h2>\n<p style=\"text-align: center;\"><span style=\"font-size: small;\"><span style=\"font-size: 13px;\"><b><span style=\"font-size: large;\"><span style=\"font-size: 18px; font-weight: normal;\"><br /></span></span></b></span></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '2', '90', '0', '109', '2010-12-16 00:56:13', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2010-12-16 03:00:00', '2010-12-22 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '3', '', '', '1', '4', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('330', '434', 'QOW #289 Wednesday', 'qow-289-wednesday', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p> </p>\n<table style=\"background-color: #ffff66; width: 600px; height: 300px;\" height=\"277\" width=\"600\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px; color: #fc1102; background-color: #ffff66; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<br /><br />\n<h2 style=\"text-align: center;\"># 289 Wednesday Question of the Week</h2>\n<p> </p>\n<p> </p>\n<h1 style=\"text-align: center;\"><img alt=\" \" src=\"../stockade/newart/QOW_animated.gif\" height=\"55\" width=\"150\" /><strong>#289</strong></h1>\n<p><strong><br /></strong></p>\n<p> </p>\n<p><img style=\"display: block; margin-left: auto; margin-right: auto;\" src=\"images/stories/qow_images/mowgli.jpg\" height=\"232\" width=\"318\" /></p>\n<p><strong><br /></strong></p>\n<p style=\"text-align: center;\"><span style=\"font-size: medium; color: #000000;\"><span style=\"font-size: 16px;\"> </span></span><b>Name on both of these characters and <br />the movie they appeared in<br /></b></p>\n<p style=\"text-align: center;\"><a target=\"_blank\" href=\"stockade/qownewest.html\"><br /></a><span style=\"font-size: 10pt;\"><strong><a target=\"_blank\" href=\"stockade/qownewest.html\">Click Here to answer the Question!</a></strong></span></p>\n<h2 style=\"font-size: 1.3em; color: #000000; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\"></h2>\n<p style=\"text-align: center;\"><span style=\"font-size: small;\"><span style=\"font-size: 13px;\"><b><span style=\"font-size: large;\"><span style=\"font-size: 18px; font-weight: normal;\"><br /></span></span></b></span></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '2', '90', '0', '109', '2012-01-31 15:57:40', '242', '', '2012-02-04 13:37:14', '242', '0', '0000-00-00 00:00:00', '2012-02-02 01:00:00', '2012-02-08 05:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '3', '', '', '1', '4', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('370', '435', 'QOW #291 - Wednesday Stockade', 'qow-291-wednesday-stockade', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p> </p>\n<table style=\"background-color: #ffff66; width: 600px; height: 300px;\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\" height=\"277\" width=\"600\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px; color: #fc1102; background-color: #ffff66; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<br /><br />\n<h2 style=\"text-align: center;\">Wednesday Question of the Week</h2>\n<p> </p>\n<p> </p>\n<h1 style=\"text-align: center;\"><img alt=\" \" src=\"../stockade/newart/QOW_animated.gif\" height=\"55\" width=\"150\" /><strong>#291</strong></h1>\n<p><strong><br /></strong></p>\n<h2 style=\"text-align: center;\"><img src=\"images/stories/qow_images/fred.jpg\" height=\"231\" width=\"308\" /></h2>\n<p><strong><br /></strong></p>\n<p style=\"text-align: center;\"><span style=\"font-size: medium; color: #000000;\"><span style=\"font-size: 16px;\">&nbsp;</span></span><b>What \"Company\" does Fred Flinstone work for?<br /></b></p>\n<p style=\"text-align: center;\"><a target=\"_blank\" href=\"stockade/qownewest.html\"><br /></a><span style=\"font-size: 10pt;\"><strong><a target=\"_blank\" href=\"stockade/qownewest.html\">Click Here to answer the Question!</a></strong></span></p>\n<h2 style=\"font-size: 1.3em; color: #000000; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\"></h2>\n<p style=\"text-align: center;\"><span style=\"font-size: small;\"><span style=\"font-size: 13px;\"><b><span style=\"font-size: large;\"><span style=\"font-size: 18px; font-weight: normal;\"><br /></span></span></b></span></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '1', '90', '0', '109', '2012-10-17 14:43:26', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2012-10-18 01:15:26', '2012-10-24 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '3', '', '', '1', '29', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('329', '436', 'QOW #288 Tuesday', 'qow-288-tuesday', '', '<center>\n<p> </p>\n<p> </p>\n<table width=\"600\" background=\"http://www.2047.org/stockade/newart/bluegrad.gif\" border=\"1\" cellpadding=\"25\" cellspacing=\"2\">\n<tbody>\n<tr>\n<td style=\"color: #000099; text-align: center;\">\n<p> </p>\n<h1 style=\"text-align: center;\"><img alt=\" \" src=\"../stockade/newart/QOW_animated.gif\" height=\"55\" width=\"150\" /></h1>\n<h1><span style=\"font-size: 14pt; color: #000080;\"><br />#288 Tuesday Question of the Week</span></h1>\n<p> </p>\n<p><img src=\"images/stories/qow_images/et_qow288.jpg\" height=\"214\" width=\"300\" /></p>\n<p> </p>\n<p> </p>\n<strong> </strong> <b>What is this guy\'s name and what movie is he from?</b>\n<div style=\"text-align: center;\">\n<p> </p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a href=\"stockade/qownewest.html\" target=\"_blank\">Click Here to answer the Question!</a></strong></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><br /></strong></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</center>', '', '2', '90', '0', '109', '2012-01-31 15:37:12', '242', '', '2012-01-31 16:02:02', '242', '0', '0000-00-00 00:00:00', '2012-02-01 01:00:00', '2012-02-07 19:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '4', '', '', '1', '3', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('369', '437', 'QOW #290 - Tuesday Stockade', 'qow-290-tuesday-stockade', '', '<center>\n<p> </p>\n<p> </p>\n<table background=\"http://www.2047.org/stockade/newart/bluegrad.gif\" border=\"1\" cellpadding=\"25\" cellspacing=\"2\" width=\"600\">\n<tbody>\n<tr>\n<td style=\"color: #000099; text-align: center;\">\n<p> </p>\n<h1 style=\"text-align: center;\"><img alt=\" \" src=\"../stockade/newart/QOW_animated.gif\" height=\"55\" width=\"150\" /></h1>\n<h1><span style=\"font-size: 14pt; color: #000080;\"><br />#290 Tuesday Question of the Week</span></h1>\n<p> </p>\n<p><img src=\"images/stories/qow_images/eye.jpg\" /></p>\n<p> </p>\n<p> </p>\n<br />\n<div align=\"center\"><strong>What creature has the largest eye in the world?</strong></div>\n<div style=\"text-align: center;\">\n<p> </p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a href=\"stockade/qownewest.html\" target=\"_blank\">Click Here to answer the Question!</a></strong></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><br /></strong></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</center>', '', '1', '90', '0', '109', '2012-10-17 14:37:57', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2012-10-17 14:37:57', '2012-10-23 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '4', '', '', '1', '26', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('326', '438', 'QOW #287 Wednesday', '287-qow-wednesday', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p> </p>\n<table style=\"background-color: #ffff66; width: 600px; height: 300px;\" height=\"277\" width=\"600\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px; color: #fc1102; background-color: #ffff66; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<br /><br />\n<h2 style=\"text-align: center;\"># 287 Wednesday Question of the Week</h2>\n<p> </p>\n<p> </p>\n<h1 style=\"text-align: center;\"><img alt=\" \" src=\"../stockade/newart/QOW_animated.gif\" height=\"55\" width=\"150\" /><strong>#287</strong></h1>\n<p><strong><br /></strong></p>\n<p> </p>\n<p><img style=\"display: block; margin-left: auto; margin-right: auto;\" src=\"images/stories/images.jpg\" height=\"166\" width=\"168\" /></p>\n<p><strong><br /></strong></p>\n<p style=\"text-align: center;\"><span style=\"font-size: medium; color: #000000;\"><span style=\"font-size: 16px;\">&nbsp;</span></span><b>What President is on the Nickel?<br /></b></p>\n<p style=\"text-align: center;\"><a target=\"_blank\" href=\"stockade/qownewest.html\"><br /></a><span style=\"font-size: 10pt;\"><strong><a target=\"_blank\" href=\"stockade/qownewest.html\">Click Here to answer the Question!</a></strong></span></p>\n<h2 style=\"font-size: 1.3em; color: #000000; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\"></h2>\n<p style=\"text-align: center;\"><span style=\"font-size: small;\"><span style=\"font-size: 13px;\"><b><span style=\"font-size: large;\"><span style=\"font-size: 18px; font-weight: normal;\"><br /></span></span></b></span></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '2', '90', '0', '109', '2011-12-08 00:00:00', '242', '', '2011-12-06 19:00:40', '242', '0', '0000-00-00 00:00:00', '2011-12-08 00:00:00', '2011-12-14 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '5', '', '', '1', '20', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('317', '439', 'QOW #283 Wednesday', 'qow-283-wednesday', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p> </p>\n<table style=\"background-color: #ffff66; width: 600px; height: 300px;\" height=\"277\" width=\"600\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px; color: #fc1102; background-color: #ffff66; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<br /><br />\n<h2 style=\"text-align: center;\"># 283 Wednesday Question of the Week</h2>\n<p> </p>\n<p> </p>\n<h1 style=\"text-align: center;\"><img alt=\" \" src=\"../stockade/newart/QOW_animated.gif\" height=\"55\" width=\"150\" /><strong>#283</strong></h1>\n<p> </p>\n<p> </p>\n<p><strong><br /></strong></p>\n<p style=\"text-align: center;\"><span style=\"font-size: medium; color: #000000;\"><span style=\"font-size: 16px;\">&nbsp;</span></span><b>What is item #10 from the Stockade Scavenger Hunt? <br /></b></p>\n<p style=\"text-align: center;\"><a target=\"_blank\" href=\"stockade/qownewest.html\"><br /></a><span style=\"font-size: 10pt;\"><strong><a target=\"_blank\" href=\"stockade/qownewest.html\">Click Here to answer the Question!</a></strong></span></p>\n<h2 style=\"font-size: 1.3em; color: #000000; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\"></h2>\n<p style=\"text-align: center;\"><span style=\"font-size: small;\"><span style=\"font-size: 13px;\"><b><span style=\"font-size: large;\"><span style=\"font-size: 18px; font-weight: normal;\"><br /></span></span></b></span></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '1', '90', '0', '109', '2011-11-11 17:39:00', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-11-11 17:39:00', '2011-11-16 20:30:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '5', '', '', '1', '5', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('288', '440', 'QOW #271 Wednesday', 'qow-271-wednesday', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p> </p>\n<table width=\"600\" height=\"277\" cellspacing=\"3\" cellpadding=\"4\" border=\"3\" style=\"background-color: #ffff66; width: 600px; height: 300px;\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td valign=\"middle\" style=\"font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px; color: #fc1102; background-color: #ffff66; text-align: left;\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<br /><br />\n<h2 style=\"text-align: center;\">Wednesday Question of the Week</h2>\n<p> </p>\n<p> </p>\n<h1 style=\"text-align: center;\"><img width=\"150\" height=\"55\" alt=\" \" src=\"../stockade/newart/QOW_animated.gif\" /><strong>#271</strong></h1>\n<p> </p>\n<p><strong><br /></strong></p>\n<p style=\"text-align: center;\"><span style=\"font-size: medium; color: #000000;\"><span style=\"font-size: 16px;\">&nbsp;</span></span><b>How many Wednesday Stockade meetings have there been this year? (count next week too)</b></p>\n<p style=\"text-align: center;\"><a target=\"_blank\" href=\"stockade/qownewest.html\"><br /></a><span style=\"font-size: 10pt;\"><strong><a target=\"_blank\" href=\"stockade/qownewest.html\">Click Here to answer the Question!</a></strong></span></p>\n<h2 style=\"font-size: 1.3em; color: #000000; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\"></h2>\n<p style=\"text-align: center;\"><span style=\"font-size: small;\"><span style=\"font-size: 13px;\"><b><span style=\"font-size: large;\"><span style=\"font-size: 18px; font-weight: normal;\"><br /></span></span></b></span></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '2', '90', '0', '109', '2011-06-02 05:00:00', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-06-02 05:00:00', '2011-06-08 22:30:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '6', '', '', '1', '11', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('325', '441', 'QOW #286 Tuesday', 'qow-286-tuesday', '', '<center>\n<p> </p>\n<p> </p>\n<table width=\"600\" background=\"http://www.2047.org/stockade/newart/bluegrad.gif\" border=\"1\" cellpadding=\"25\" cellspacing=\"2\">\n<tbody>\n<tr>\n<td style=\"color: #000099; text-align: center;\">\n<p> </p>\n<h1 style=\"text-align: center;\"><img alt=\" \" src=\"../stockade/newart/QOW_animated.gif\" height=\"55\" width=\"150\" /></h1>\n<h1><span style=\"font-size: 14pt; color: #000080;\"><br />#286 Tuesday Question of the Week</span></h1>\n<p> </p>\n<p> </p>\n<p> </p>\n<p><img style=\"display: block; margin-left: auto; margin-right: auto;\" alt=\"hundred20dollar20bill\" src=\"images/stories/qow_images/hundred20dollar20bill.jpg\" height=\"154\" width=\"365\" /></p>\n<strong> </strong> <b>Which President is on the $100 bill?</b>\n<div style=\"text-align: center;\">\n<p> </p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a href=\"stockade/qownewest.html\" target=\"_blank\">Click Here to answer the Question!</a></strong></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><br /></strong></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</center>', '', '2', '90', '0', '109', '2011-12-07 01:00:00', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-12-07 01:00:00', '2011-12-13 18:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '6', '', '', '1', '8', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('316', '442', 'QOW #284 Tuesday', 'qow-284-tuesday', '', '<center>\n<p> </p>\n<p> </p>\n<table width=\"600\" background=\"http://www.2047.org/stockade/newart/bluegrad.gif\" border=\"1\" cellpadding=\"25\" cellspacing=\"2\">\n<tbody>\n<tr>\n<td style=\"color: #000099; text-align: center;\">\n<p> </p>\n<p> </p>\n<h1><span style=\"font-size: 14pt; color: #000080;\">#284 Tuesday Question of the Week</span></h1>\n<p> </p>\n<p> </p>\n<p> </p>\n<img src=\"../stockade/newart/QOW_animated.gif\" alt=\" \" height=\"55\" width=\"150\" /><span style=\"font-size: 12pt; color: #ff0000;\"><strong>#284</strong></span>\n<p> </p>\n<p><strong><br /></strong></p>\n<div style=\"text-align: center;\">\n<p><img src=\"images/stories/qow_images/8eyes.png\" height=\"223\" width=\"337\" /></p>\n<p> </p>\n<p> </p>\n<p><span style=\"font-size: 12pt;\"><span style=\"color: #000000;\">&nbsp;</span><b>How many eyes does a spider normally have?<br /></b></span></p>\n<p> </p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a href=\"stockade/qownewest.html\" target=\"_blank\">Click Here to answer the Question!</a></strong></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><br /></strong></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</center>', '', '1', '90', '0', '109', '2011-11-15 23:30:00', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-11-15 23:30:00', '2011-11-22 20:30:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '6', '', '', '1', '12', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('318', '443', 'QOW #285 Wednesday', 'qow-285-wednesday', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p> </p>\n<table style=\"background-color: #ffff66; width: 600px; height: 300px;\" height=\"277\" width=\"600\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px; color: #fc1102; background-color: #ffff66; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<br /><br />\n<h2 style=\"text-align: center;\"># 285 Wednesday Question of the Week</h2>\n<p> </p>\n<p> </p>\n<h1 style=\"text-align: center;\"><img alt=\" \" src=\"../stockade/newart/QOW_animated.gif\" height=\"55\" width=\"150\" /><strong>#285</strong></h1>\n<p><strong><br /></strong></p>\n<p> </p>\n<p><img style=\"display: block; margin-left: auto; margin-right: auto;\" src=\"images/stories/qow_images/ant.png\" height=\"222\" width=\"176\" /></p>\n<p><strong><br /></strong></p>\n<p style=\"text-align: center;\"><span style=\"font-size: medium; color: #000000;\"><span style=\"font-size: 16px;\">&nbsp;</span></span><b>What is this creature? <br /></b></p>\n<p style=\"text-align: center;\"><a target=\"_blank\" href=\"stockade/qownewest.html\"><br /></a><span style=\"font-size: 10pt;\"><strong><a target=\"_blank\" href=\"stockade/qownewest.html\">Click Here to answer the Question!</a></strong></span></p>\n<h2 style=\"font-size: 1.3em; color: #000000; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\"></h2>\n<p style=\"text-align: center;\"><span style=\"font-size: small;\"><span style=\"font-size: 13px;\"><b><span style=\"font-size: large;\"><span style=\"font-size: 18px; font-weight: normal;\"><br /></span></span></b></span></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '2', '90', '0', '109', '2011-11-16 23:30:00', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-11-16 23:30:00', '2011-11-23 21:30:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '7', '', '', '1', '10', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('315', '444', 'QOW #282 Tuesday', 'qow-282-tuesday', '', '<center>\n<p> </p>\n<p> </p>\n<table width=\"600\" background=\"http://www.2047.org/stockade/newart/bluegrad.gif\" border=\"1\" cellpadding=\"25\" cellspacing=\"2\">\n<tbody>\n<tr>\n<td style=\"color: #000099; text-align: center;\">\n<p> </p>\n<p> </p>\n<h1><span style=\"font-size: 14pt; color: #000080;\">#282 Tuesday Question of the Week</span></h1>\n<p> </p>\n<p> </p>\n<p> </p>\n<img src=\"../stockade/newart/QOW_animated.gif\" alt=\" \" height=\"55\" width=\"150\" /><span style=\"font-size: 12pt; color: #ff0000;\"><strong>#282</strong></span>\n<p> </p>\n<p><strong>&nbsp;</strong></p>\n<div style=\"text-align: center;\">\n<p> </p>\n<p> </p>\n<p><span style=\"font-size: 12pt;\"><span style=\"color: #000000;\">&nbsp;</span><b>What is item #6 in the Stockade Scavenger Hunt?<br /></b></span></p>\n<p> </p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a href=\"stockade/qownewest.html\" target=\"_blank\">Click Here to answer the Question!</a></strong></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><br /></strong></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</center>', '', '1', '90', '0', '109', '2011-11-11 17:28:51', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-11-11 17:28:51', '2011-11-15 20:30:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '7', '', '', '1', '4', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('309', '445', 'QOW #278 - Tuesday Stockade', 'qow-278-tuesday-stockade', '', '<center>\n<p> </p>\n<p> </p>\n<table width=\"600\" background=\"http://www.2047.org/stockade/newart/bluegrad.gif\" border=\"1\" cellpadding=\"25\" cellspacing=\"2\">\n<tbody>\n<tr>\n<td style=\"color: #000099; text-align: center;\">\n<p> </p>\n<p> </p>\n<h1><span style=\"font-size: 14pt; color: #000080;\">Tuesday Question of the Week</span></h1>\n<p> </p>\n<p> </p>\n<p> </p>\n<img src=\"../stockade/newart/QOW_animated.gif\" alt=\" \" height=\"55\" width=\"150\" /><span style=\"font-size: 12pt; color: #ff0000;\"><strong>#278</strong></span>\n<p> </p>\n<p><strong><br /></strong></p>\n<div style=\"text-align: center;\">\n<p> </p>\n<p> </p>\n<p> </p>\n<p><span style=\"font-size: 12pt;\"><span style=\"color: #000000;\">&nbsp;</span><b>How many innings are in a World series baseball game?<br /></b></span></p>\n<p> </p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a href=\"stockade/qownewest.html\" target=\"_blank\">Click Here to answer the Question!</a></strong></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><br /></strong></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</center>', '', '1', '90', '0', '109', '2011-10-04 05:00:00', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-10-05 01:00:00', '2011-10-11 04:59:59', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '8', '', '', '1', '1', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('269', '446', 'QOW #268 Wednesday', 'qow-268-wednesday', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p> </p>\n<table style=\"background-color: #ffff66; width: 600px; height: 300px;\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\" height=\"277\" width=\"600\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px; color: #fc1102; background-color: #ffff66; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<br /><br />\n<h2 style=\"text-align: center;\">Wednesday Question of the Week</h2>\n<p> </p>\n<p> </p>\n<h1 style=\"text-align: center;\"><img src=\"../stockade/newart/QOW_animated.gif\" alt=\" \" height=\"55\" width=\"150\" /><strong>#268</strong></h1>\n<p> </p>\n<p><strong><img style=\"display: block; margin-left: auto; margin-right: auto;\" src=\"images/stories/cars---sarge-01.jpg\" /><br /></strong></p>\n<p style=\"text-align: center;\"><span style=\"font-size: medium; color: #000000;\"><span style=\"font-size: 16px;\">&nbsp;</span></span><b>What is the name of this character from Cars?<br /></b></p>\n<div style=\"text-align: center;\">\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><a href=\"stockade/qownewest.html\" target=\"_blank\"><br /></a><span style=\"font-size: 10pt;\"><strong><a href=\"stockade/qownewest.html\" target=\"_blank\">Click Here to answer the Question!</a></strong></span></p>\n<h2 style=\"font-size: 1.3em; color: #000000; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\"></h2>\n<p style=\"text-align: center;\"><span style=\"font-size: small;\"><span style=\"font-size: 13px;\"><b><span style=\"font-size: large;\"><span style=\"font-size: 18px; font-weight: normal;\"><br /></span></span></b></span></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '2', '90', '0', '109', '2011-04-05 17:58:56', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-04-07 01:00:00', '2011-04-13 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '9', '', '', '1', '6', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('308', '447', 'QOW #279 - Wednesday Stockade', 'qow-279-wednesday-stockade', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p> </p>\n<table style=\"background-color: #ffff66; width: 600px; height: 300px;\" height=\"277\" width=\"600\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px; color: #fc1102; background-color: #ffff66; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<br /><br />\n<h2 style=\"text-align: center;\">Wednesday Question of the Week</h2>\n<p> </p>\n<p> </p>\n<h1 style=\"text-align: center;\"><img alt=\" \" src=\"../stockade/newart/QOW_animated.gif\" height=\"55\" width=\"150\" /><strong>#279</strong></h1>\n<p> </p>\n<p><img style=\"display: block; margin-left: auto; margin-right: auto;\" alt=\"hundred20dollar20bill\" src=\"images/stories/qow_images/hundred20dollar20bill.jpg\" height=\"154\" width=\"365\" /></p>\n<p style=\"text-align: center;\"><strong>&nbsp;</strong><span style=\"font-size: medium; color: #000000;\"><span style=\"font-size: 16px;\"> </span></span><b>Which President is on the $100 bill?<br /></b></p>\n<p style=\"text-align: center;\"><a target=\"_blank\" href=\"stockade/qownewest.html\"><br /></a><span style=\"font-size: 10pt;\"><strong><a target=\"_blank\" href=\"stockade/qownewest.html\">Click Here to answer the Question!</a></strong></span></p>\n<h2 style=\"font-size: 1.3em; color: #000000; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\"></h2>\n<p style=\"text-align: center;\"><span style=\"font-size: small;\"><span style=\"font-size: 13px;\"><b><span style=\"font-size: large;\"><span style=\"font-size: 18px; font-weight: normal;\"><br /></span></span></b></span></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '1', '90', '0', '109', '2011-10-05 05:00:00', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-10-06 01:00:00', '2011-10-12 04:59:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '9', '', '', '1', '2', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('307', '448', 'QOW #277 - Wednesday Stockade', 'qow-277-wednesday-stockade', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p> </p>\n<table style=\"background-color: #ffff66; width: 600px; height: 300px;\" height=\"277\" width=\"600\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px; color: #fc1102; background-color: #ffff66; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<br /><br />\n<h2 style=\"text-align: center;\">Wednesday Question of the Week</h2>\n<p> </p>\n<p> </p>\n<h1 style=\"text-align: center;\"><img alt=\" \" src=\"../stockade/newart/QOW_animated.gif\" height=\"55\" width=\"150\" /><strong>#277</strong></h1>\n<p> </p>\n<p><img style=\"display: block; margin-left: auto; margin-right: auto;\" alt=\"1888_cent_obverse\" src=\"images/stories/qow_images/1888_cent_obverse.jpg\" height=\"147\" width=\"147\" /></p>\n<p><strong><br /></strong></p>\n<p style=\"text-align: center;\"><span style=\"font-size: medium; color: #000000;\"><span style=\"font-size: 16px;\">&nbsp;</span></span><b>What was the last year of the Indian head penny?<br /></b></p>\n<p style=\"text-align: center;\"><a target=\"_blank\" href=\"stockade/qownewest.html\"><br /></a><span style=\"font-size: 10pt;\"><strong><a target=\"_blank\" href=\"stockade/qownewest.html\">Click Here to answer the Question!</a></strong></span></p>\n<h2 style=\"font-size: 1.3em; color: #000000; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\"></h2>\n<p style=\"text-align: center;\"><span style=\"font-size: small;\"><span style=\"font-size: 13px;\"><b><span style=\"font-size: large;\"><span style=\"font-size: 18px; font-weight: normal;\"><br /></span></span></b></span></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '1', '90', '0', '109', '2011-09-28 05:00:00', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-09-29 01:00:00', '2011-10-05 04:59:59', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '10', '', '', '1', '1', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('306', '449', 'QOW #276 - Tuesday Stockade', 'qow-276-tuesday-stockade', '', '<center>\n<p> </p>\n<p> </p>\n<table width=\"600\" background=\"http://www.2047.org/stockade/newart/bluegrad.gif\" border=\"1\" cellpadding=\"25\" cellspacing=\"2\">\n<tbody>\n<tr>\n<td style=\"color: #000099; text-align: center;\">\n<p> </p>\n<p> </p>\n<h1><span style=\"font-size: 14pt; color: #000080;\">Tuesday Question of the Week</span></h1>\n<p> </p>\n<p> </p>\n<p> </p>\n<img src=\"../stockade/newart/QOW_animated.gif\" alt=\" \" height=\"55\" width=\"150\" /><span style=\"font-size: 12pt; color: #ff0000;\"><strong>#276</strong></span>\n<p> </p>\n<p><strong><br /></strong></p>\n<div style=\"text-align: center;\">\n<p><img alt=\"1909penny\" src=\"images/stories/qow_images/1909penny.jpg\" height=\"175\" width=\"176\" /></p>\n<p> </p>\n<p> </p>\n<p><span style=\"font-size: 12pt;\"><span style=\"color: #000000;\">&nbsp;</span><b>What was the first year for the Lincoln penny?<br /></b></span></p>\n<p> </p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a href=\"stockade/qownewest.html\" target=\"_blank\">Click Here to answer the Question!</a></strong></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><br /></strong></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</center>', '', '1', '90', '0', '109', '2011-09-27 05:00:00', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-09-28 01:00:00', '2011-10-04 04:59:59', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '11', '', '', '1', '1', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('241', '450', 'QOW #257', 'qow-257', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p> </p>\n<table style=\"background-color: #ffff66; width: 600px; height: 300px;\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\" height=\"277\" width=\"600\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px; color: #fc1102; background-color: #ffff66; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\">Question of the Week</h2>\n<p> </p>\n<p> </p>\n<h1 style=\"text-align: center;\"><img src=\"../stockade/newart/QOW_animated.gif\" alt=\" \" height=\"55\" width=\"150\" /><strong>#257</strong></h1>\n<h2 style=\"text-align: center;\"><strong><br /></strong></h2>\n<div style=\"text-align: center;\"><img width=\"150\" src=\"http://2047.org/stockade/photoalbum/creaturefeature2011/Thumbnails/52.jpg\" /><img width=\"150\" src=\"http://2047.org/stockade/photoalbum/creaturefeature2011/Thumbnails/45.jpg\" /><img width=\"150\" src=\"http://2047.org/stockade/photoalbum/creaturefeature2011/Thumbnails/22.jpg\" /><img width=\"150\" src=\"http://2047.org/stockade/photoalbum/creaturefeature2011/Thumbnails/30.jpg\" />\n<p><span style=\"font-size: medium; color: #000000;\"><span style=\"font-size: 16px;\">&nbsp;</span></span><b>Name 3 out of these 4 animals from the Creature Feature!<br />(bonus if you are the first and name all 4!)&nbsp;</b></p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a href=\"stockade/qownewest.html\" target=\"_blank\">Click Here to answer the Question!</a></strong></span></p>\n<h2 style=\"font-size: 1.3em; color: #000000; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\"></h2>\n<p style=\"text-align: center;\"><span style=\"font-size: small;\"><span style=\"font-size: 13px;\"><b><span style=\"font-size: large;\"><span style=\"font-size: 18px; font-weight: normal;\"><br /></span></span></b></span></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '2', '90', '0', '109', '2011-01-28 18:25:44', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-01-28 18:25:44', '2011-02-02 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '12', '', '', '1', '9', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('305', '451', 'QOW #275 Puzzle - Wednesday Stockade', 'qow-275-puzzle-wednesday-stockade', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p> </p>\n<table style=\"background-color: #ffff66; width: 600px; height: 300px;\" height=\"277\" width=\"600\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px; color: #fc1102; background-color: #ffff66; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<br /><br />\n<h2 style=\"text-align: center;\">Wednesday Question of the Week</h2>\n<p> </p>\n<p> </p>\n<h1 style=\"text-align: center;\"><img alt=\" \" src=\"../stockade/newart/QOW_animated.gif\" height=\"55\" width=\"150\" /><strong>#275</strong></h1>\n<p> </p>\n<p> </p>\n<div align=\"center\"><strong><a target=\"_blank\" href=\"../stockade/qow275puzzle\">CLICK HERE TO SOLVE THE PUZZLE</a></strong></div>\n<div style=\"color: #000000;\" align=\"center\"><br />NOTE: This will not work on an iPhone, iPad or iPod.</div>\n<h2 style=\"font-size: 1.3em; color: #000000; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\"></h2>\n<p style=\"text-align: center;\"><span style=\"font-size: small;\"><span style=\"font-size: 13px;\"><b><span style=\"font-size: large;\"><span style=\"font-size: 18px; font-weight: normal;\"><br /></span></span></b></span></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '1', '90', '0', '109', '2011-09-21 05:00:00', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-09-22 01:00:00', '2011-09-27 16:59:59', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '12', '', '', '1', '3', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('280', '452', 'QOW #270 Wednesday', 'qow-270-wednesday', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p> </p>\n<table style=\"background-color: #ffff66; width: 600px; height: 300px;\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\" height=\"277\" width=\"600\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px; color: #fc1102; background-color: #ffff66; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<br /><br />\n<h2 style=\"text-align: center;\">Wednesday Question of the Week</h2>\n<p> </p>\n<p> </p>\n<h1 style=\"text-align: center;\"><img src=\"../stockade/newart/QOW_animated.gif\" alt=\" \" height=\"55\" width=\"150\" /><strong>#270</strong></h1>\n<p><br /><img style=\"display: block; margin-left: auto; margin-right: auto;\" src=\"images/stories/0064.gif\" height=\"101\" width=\"169\" /></p>\n<p><strong><br /></strong></p>\n<p style=\"text-align: center;\"><span style=\"font-size: medium; color: #000000;\"><span style=\"font-size: 16px;\">&nbsp;</span></span><b>Which Wednesday Stockade Leader <br />is a Police Officer?<br /></b></p>\n<div style=\"text-align: center;\">\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><a href=\"stockade/qownewest.html\" target=\"_blank\"><br /></a><span style=\"font-size: 10pt;\"><strong><a href=\"stockade/qownewest.html\" target=\"_blank\">Click Here to answer the Question!</a></strong></span></p>\n<h2 style=\"font-size: 1.3em; color: #000000; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\"></h2>\n<p style=\"text-align: center;\"><span style=\"font-size: small;\"><span style=\"font-size: 13px;\"><b><span style=\"font-size: large;\"><span style=\"font-size: 18px; font-weight: normal;\"><br /></span></span></b></span></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '2', '90', '0', '109', '2011-05-05 17:39:39', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-05-06 01:00:00', '2011-05-11 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '13', '', '', '1', '1', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('304', '453', 'QOW #274 - Tuesday Stockade - puzzle', 'qow-274-tuesday-stockade-puzzle', '', '<center>\n<p> </p>\n<p> </p>\n<table width=\"600\" background=\"http://www.2047.org/stockade/newart/bluegrad.gif\" border=\"1\" cellpadding=\"25\" cellspacing=\"2\">\n<tbody>\n<tr>\n<td style=\"color: #000099; text-align: center;\">\n<p> </p>\n<p> </p>\n<h1><span style=\"font-size: 14pt; color: #000080;\">Tuesday Question of the Week</span></h1>\n<p> </p>\n<p> </p>\n<p> </p>\n<img src=\"../stockade/newart/QOW_animated.gif\" alt=\" \" height=\"55\" width=\"150\" /><span style=\"font-size: 12pt; color: #ff0000;\"><strong>#274</strong></span>\n<p> </p>\n<p><strong><br /></strong></p>\n<div style=\"text-align: center;\">\n<div align=\"center\"><span style=\"font-size: 12pt;\"><strong><a target=\"_blank\" href=\"../stockade/qow274puzzle\">CLICK HERE TO SOLVE THE PUZZLE</a></strong></span></div>\n<div style=\"color: #000000;\" align=\"center\"><br />NOTE: This will not work on an iPhone, iPad or iPod.</div>\n<p> </p>\n<p> </p>\n<p> </p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><br /></strong></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</center>', '', '1', '90', '0', '109', '2011-09-20 05:00:00', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-09-21 01:00:00', '2011-09-26 16:59:59', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '13', '', '', '1', '1', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('303', '454', 'QOW #281 - Wednesday Stockade', 'qow-281-wednesday-stockade', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p> </p>\n<table style=\"background-color: #ffff66; width: 600px; height: 300px;\" height=\"277\" width=\"600\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px; color: #fc1102; background-color: #ffff66; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<br /><br />\n<h2 style=\"text-align: center;\"># 281 Wednesday Question of the Week</h2>\n<p> </p>\n<p> </p>\n<h1 style=\"text-align: center;\"><img alt=\" \" src=\"../stockade/newart/QOW_animated.gif\" height=\"55\" width=\"150\" /><strong>#281</strong></h1>\n<p> </p>\n<p><img style=\"display: block; margin-left: auto; margin-right: auto;\" alt=\"gogo-ghost\" src=\"images/stories/qow_images/gogo-ghost.png\" height=\"227\" width=\"187\" /></p>\n<p><strong><br /></strong></p>\n<p style=\"text-align: center;\"><span style=\"font-size: medium; color: #000000;\"><span style=\"font-size: 16px;\">&nbsp;</span></span><b>What is the name of this GoGo?<br /></b></p>\n<p style=\"text-align: center;\"><a target=\"_blank\" href=\"stockade/qownewest.html\"><br /></a><span style=\"font-size: 10pt;\"><strong><a target=\"_blank\" href=\"stockade/qownewest.html\">Click Here to answer the Question!</a></strong></span></p>\n<h2 style=\"font-size: 1.3em; color: #000000; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\"></h2>\n<p style=\"text-align: center;\"><span style=\"font-size: small;\"><span style=\"font-size: 13px;\"><b><span style=\"font-size: large;\"><span style=\"font-size: 18px; font-weight: normal;\"><br /></span></span></b></span></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '1', '90', '0', '109', '2011-10-12 05:00:00', '242', '', '2011-10-12 15:30:47', '242', '0', '0000-00-00 00:00:00', '2011-10-13 01:30:00', '2011-10-18 16:59:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '3', '0', '14', '', '', '1', '3', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('214', '455', 'QOW #253', 'qow-253', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p> </p>\n<table style=\"background-color: #ffff66; width: 600px; height: 300px;\" height=\"277\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\" width=\"600\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px; color: #fc1102; background-color: #ffff66; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\">Question of the Week</h2>\n<p> </p>\n<p> </p>\n<h1 style=\"text-align: center;\"><img src=\"../stockade/newart/QOW_animated.gif\" alt=\" \" height=\"55\" width=\"150\" /><strong>#253</strong></h1>\n<h2 style=\"text-align: center;\"><strong><br /></strong></h2>\n<div style=\"text-align: center;\"><img src=\"images/stories/starwars.jpg\" height=\"93\" width=\"155\" /><br />\n<p><span style=\"font-size: medium; color: #000000;\"><span style=\"font-size: 16px;\">In \"Star Wars\", who is considered <br />the most powerful or \"Master\" Jedi Knight?</span></span></p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a href=\"stockade/qownewest.html\" target=\"_blank\">Click Here to answer the Question!</a></strong></span></p>\n<h2 style=\"font-size: 1.3em; color: #000000; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\"></h2>\n<p style=\"text-align: center;\"><span style=\"font-size: small;\"><span style=\"font-size: 13px;\"><b><span style=\"font-size: large;\"><span style=\"font-size: 18px; font-weight: normal;\"><br /></span></span></b></span></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '2', '90', '0', '109', '2010-12-08 19:10:17', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2010-12-09 02:10:17', '2010-12-15 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '15', '', '', '1', '2', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('302', '456', 'QOW #280 - Tuesday Stockade', 'qow-280-tuesday-stockade', '', '<center>\n<p> </p>\n<p> </p>\n<table width=\"600\" background=\"http://www.2047.org/stockade/newart/bluegrad.gif\" border=\"1\" cellpadding=\"25\" cellspacing=\"2\">\n<tbody>\n<tr>\n<td style=\"color: #000099; text-align: center;\">\n<p> </p>\n<p> </p>\n<h1><span style=\"font-size: 14pt; color: #000080;\">#280 Tuesday Question of the Week</span></h1>\n<p> </p>\n<p> </p>\n<p> </p>\n<img src=\"../stockade/newart/QOW_animated.gif\" alt=\" \" height=\"55\" width=\"150\" /><span style=\"font-size: 12pt; color: #ff0000;\"><strong>#280</strong></span>\n<p> </p>\n<p><strong><br /></strong></p>\n<div style=\"text-align: center;\">\n<p><img alt=\"gogo-yuza\" src=\"images/stories/qow_images/gogo-yuza.png\" height=\"225\" width=\"190\" /></p>\n<p> </p>\n<p> </p>\n<p><span style=\"font-size: 12pt;\"><span style=\"color: #000000;\">&nbsp;</span><b>What is the name of this GoGo?<br /></b></span></p>\n<p> </p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a href=\"stockade/qownewest.html\" target=\"_blank\">Click Here to answer the Question!</a></strong></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><br /></strong></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</center>', '', '1', '90', '0', '109', '2011-10-11 05:00:00', '242', '', '2011-10-12 15:31:06', '242', '0', '0000-00-00 00:00:00', '2011-10-12 01:00:00', '2011-10-17 16:59:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '3', '0', '15', '', '', '1', '4', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('301', '457', 'QOW #273 - Wednesday Stockade', 'qow-273', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p> </p>\n<table style=\"background-color: #ffff66; width: 600px; height: 300px;\" height=\"277\" width=\"600\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px; color: #fc1102; background-color: #ffff66; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<br /><br />\n<h2 style=\"text-align: center;\">Wednesday Question of the Week</h2>\n<p> </p>\n<p> </p>\n<h1 style=\"text-align: center;\"><img alt=\" \" src=\"../stockade/newart/QOW_animated.gif\" height=\"55\" width=\"150\" /><strong>#273</strong></h1>\n<p> </p>\n<p><img style=\"display: block; margin-left: auto; margin-right: auto;\" alt=\"gogo-bking\" src=\"images/stories/qow_images/gogo-bking.png\" height=\"225\" width=\"192\" /></p>\n<p><strong><br /></strong></p>\n<p style=\"text-align: center;\"><span style=\"font-size: medium; color: #000000;\"><span style=\"font-size: 16px;\">&nbsp;</span></span><b>What is the name of this GoGo?<br /></b></p>\n<p style=\"text-align: center;\"><a target=\"_blank\" href=\"stockade/qownewest.html\"><br /></a><span style=\"font-size: 10pt;\"><strong><a target=\"_blank\" href=\"stockade/qownewest.html\">Click Here to answer the Question!</a></strong></span></p>\n<h2 style=\"font-size: 1.3em; color: #000000; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\"></h2>\n<p style=\"text-align: center;\"><span style=\"font-size: small;\"><span style=\"font-size: 13px;\"><b><span style=\"font-size: large;\"><span style=\"font-size: 18px; font-weight: normal;\"><br /></span></span></b></span></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '1', '90', '0', '109', '2011-09-14 05:00:00', '242', '', '2011-09-12 14:39:50', '242', '0', '0000-00-00 00:00:00', '2011-09-15 01:00:00', '2011-09-20 16:59:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '16', '', '', '1', '5', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', '');

INSERT INTO tkt_content
(`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES 
('300', '458', 'QOW #272 - Tuesday Stockade', 'qow-272-tuesday-stockade', '', '<center>\n<p> </p>\n<p> </p>\n<table border=\"1\" cellpadding=\"25\" cellspacing=\"2\" width=\"600\">\n<tbody>\n<tr>\n<td style=\"color: #000099; text-align: center;\">\n<p> </p>\n<p> </p>\n<h1><span style=\"font-size: 14pt; color: #000080;\">Tuesday Question of the Week</span></h1>\n<p> </p>\n<p> </p>\n<p> </p>\n<img src=\"../stockade/newart/QOW_animated.gif\" alt=\" \" height=\"55\" width=\"150\" /><span style=\"font-size: 12pt; color: #ff0000;\"><strong>#272</strong></span>\n<p> </p>\n<p><strong><br /></strong></p>\n<div style=\"text-align: center;\">\n<p><img alt=\"gogo-tut\" src=\"images/stories/qow_images/gogo-tut.png\" height=\"226\" width=\"189\" /></p>\n<p> </p>\n<p> </p>\n<p><span style=\"font-size: 12pt;\"><span style=\"color: #000000;\"> </span><b>What is the name of this GoGo?<br /></b></span></p>\n<p> </p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a href=\"stockade/qownewest.html\" target=\"_blank\">Click Here to answer the Question!</a></strong></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><br /></strong></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</center>', '', '1', '90', '0', '109', '2011-09-14 01:00:00', '242', '', '2011-09-22 12:12:30', '242', '0', '0000-00-00 00:00:00', '2011-09-14 01:00:00', '2011-09-21 04:59:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '3', '0', '17', '', '', '1', '2', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('268', '459', 'QOW #267 Tuesday', 'qow-267-tuesday', '', '<center>\n<p> </p>\n<p> </p>\n<table background=\"http://www.2047.org/stockade/newart/bluegrad.gif\" border=\"1\" cellpadding=\"25\" cellspacing=\"2\" width=\"600\">\n<tbody>\n<tr>\n<td style=\"color: #ff0000; text-align: center;\">\n<p> </p>\n<p> </p>\n<h1><span style=\"font-size: 14pt; color: #000080;\">Tuesday Question of the Week</span></h1>\n<p> </p>\n<p> </p>\n<p> </p>\n<img src=\"../stockade/newart/QOW_animated.gif\" alt=\" \" height=\"55\" width=\"150\" /><span style=\"font-size: 12pt; color: #ff0000;\"><strong>#267</strong></span>\n<p> </p>\n<p><strong><br /></strong></p>\n<div style=\"text-align: center;\">\n<p><span style=\"font-size: 12pt;\"><span style=\"color: #000000;\">&nbsp;</span><b>What is the name of this character from Cars?<br /></b></span></p>\n<p> </p>\n<p> </p>\n<p><img src=\"images/stories/cars---doc-hudson-02.jpg\" /></p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a href=\"stockade/qownewest.html\" target=\"_blank\">Click Here to answer the Question!</a></strong></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><br /></strong></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</center>', '', '2', '90', '0', '109', '2011-04-05 05:00:00', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-04-06 02:00:10', '2011-04-12 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '18', '', '', '1', '1', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('195', '460', 'QOW #247 Puzzle', 'qow-247', '', '<div></div>\n<table width=\"492\" cellspacing=\"3\" cellpadding=\"4\" border=\"3\" align=\"center\" style=\"background-color: #ffff66; height: 173px;\">\n<tbody>\n<tr>\n<td valign=\"middle\" style=\"background-color: #ffff66; border: 1px solid #cccc99;\">\n<div align=\"center\"></div>\n<div align=\"center\"><img width=\"150\" height=\"55\" border=\"0\" align=\"middle\" alt=\" \" src=\"stockade/newart/QOW_animated.gif\" /><strong style=\"font-size: 24px; color: #000000;\"><span style=\"text-decoration: underline;\">#247</span></strong></div>\n<div align=\"center\"></div>\n<div align=\"center\"><strong style=\"font-size: 24px; color: #000000;\"><span style=\"text-decoration: underline;\"><br /></span></strong></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"><a target=\"_blank\" href=\"../stockade/qow247puzzle\">CLICK HERE TO SOLVE THE PUZZLE</a></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\" style=\"color: #000000;\">NOTE: This will not work on an iPhone, iPad or iPod.</div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<p align=\"center\"><a onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\" href=\"stockade/qownewest.html\"></a></p>\n</td>\n</tr>\n</tbody>\n</table>', '', '0', '90', '0', '109', '2010-10-04 15:38:35', '242', '', '2011-02-25 15:00:17', '242', '0', '0000-00-00 00:00:00', '2010-10-07 05:00:00', '2010-10-13 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '4', '0', '18', '', '', '1', '2', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('279', '461', 'QOW #269 Tuesday', 'qow-269-tuesday', '', '<center>\n<p> </p>\n<p> </p>\n<table background=\"http://www.2047.org/stockade/newart/bluegrad.gif\" border=\"1\" cellpadding=\"25\" cellspacing=\"2\" width=\"600\">\n<tbody>\n<tr>\n<td style=\"color: #000099; text-align: center;\">\n<p> </p>\n<p> </p>\n<h1><span style=\"font-size: 14pt; color: #000080;\">Tuesday Question of the Week</span></h1>\n<p> </p>\n<p> </p>\n<p> </p>\n<img src=\"../stockade/newart/QOW_animated.gif\" alt=\" \" height=\"55\" width=\"150\" /><span style=\"font-size: 12pt; color: #ff0000;\"><strong>#269</strong></span>\n<p> </p>\n<p><strong><br /></strong></p>\n<div style=\"text-align: center;\">\n<p><span style=\"font-size: 12pt;\"><span style=\"color: #000000;\">&nbsp;</span><b>What person from the Bible did Tuesday Stockade <br />start learning about for Stockarama?<br /></b></span></p>\n<p> </p>\n<p>(clue, you can find the answer in Daniel 1)</p>\n<p> </p>\n<p> </p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a href=\"stockade/qownewest.html\" target=\"_blank\">Click Here to answer the Question!</a></strong></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><br /></strong></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</center>', '', '2', '90', '0', '109', '2011-05-05 17:33:40', '242', '', '2011-05-05 17:42:25', '242', '0', '0000-00-00 00:00:00', '2011-05-06 01:00:00', '2011-05-10 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '20', '', '', '1', '2', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('265', '464', 'QOW #265 Tuesday', 'qow-265-tuesday', '', '<center>\n<p> </p>\n<p> </p>\n<table width=\"600\" cellspacing=\"2\" cellpadding=\"25\" border=\"1\" background=\"http://www.2047.org/stockade/newart/bluegrad.gif\">\n<tbody>\n<tr>\n<td style=\"color: #ff0000; text-align: center;\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<p> </p>\n<p> </p>\n<h1><span style=\"font-size: 14pt; color: #000080;\">Tuesday Question of the Week</span></h1>\n<p> </p>\n<p> </p>\n<p> </p>\n<img width=\"150\" height=\"55\" src=\"../stockade/newart/QOW_animated.gif\" alt=\" \" /><span style=\"font-size: 12pt; color: #ff0000;\"><strong>#265</strong></span>\n<p> </p>\n<p><strong><br /></strong></p>\n<div style=\"text-align: center;\">\n<p><span style=\"font-size: 12pt;\"><span style=\"color: #000000;\">&nbsp;</span><b>Which baseball team does Derek Jeter play for?</b></span></p>\n<p> </p>\n<p></p>\n<p><span style=\"font-size: 12pt;\"><b><br /></b></span></p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a href=\"stockade/qownewest.html\" target=\"_blank\">Click Here to answer the Question!</a></strong></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><br /></strong></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</center>', '', '0', '90', '0', '109', '2011-03-29 22:36:17', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-03-30 01:25:17', '2011-04-05 19:30:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '24', '', '', '1', '5', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('226', '465', 'QOW #256', 'qow-256', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p> </p>\n<table style=\"background-color: #ffff66; width: 600px; height: 300px;\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\" height=\"277\" width=\"600\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px; color: #fc1102; background-color: #ffff66; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\">Question of the Week</h2>\n<p> </p>\n<p> </p>\n<h1 style=\"text-align: center;\"><img src=\"../stockade/newart/QOW_animated.gif\" alt=\" \" height=\"55\" width=\"150\" /><strong>#256</strong></h1>\n<h2 style=\"text-align: center;\"><strong><br /></strong></h2>\n<div style=\"text-align: center;\"><br />\n<p><span style=\"font-size: medium; color: #000000;\"><span style=\"font-size: 16px;\">&nbsp;</span></span><b>What are Stockaders supposed to wish for at 11:11?</b></p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a href=\"stockade/qownewest.html\" target=\"_blank\">Click Here to answer the Question!</a></strong></span></p>\n<h2 style=\"font-size: 1.3em; color: #000000; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\"></h2>\n<p style=\"text-align: center;\"><span style=\"font-size: small;\"><span style=\"font-size: 13px;\"><b><span style=\"font-size: large;\"><span style=\"font-size: 18px; font-weight: normal;\"><br /></span></span></b></span></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '0', '90', '0', '109', '2011-01-13 02:00:28', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-01-13 02:00:28', '2011-01-19 21:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '26', '', '', '1', '8', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('203', '466', 'QOW #252', 'qow-252', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p> </p>\n<table style=\"background-color: #ffff66; width: 600px; height: 300px;\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\" height=\"277\" width=\"600\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px; color: #fc1102; background-color: #ffff66; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\">Question of the Week</h2>\n<p> </p>\n<p> </p>\n<h1 style=\"text-align: center;\"><img src=\"../stockade/newart/QOW_animated.gif\" alt=\" \" height=\"55\" width=\"150\" /><strong>#252</strong></h1>\n<h2 style=\"text-align: center;\"><strong><br /></strong></h2>\n<div style=\"text-align: center;\"><br />\n<p><span style=\"font-size: medium; color: #000000;\"><span style=\"font-size: 16px;\">Who is this kid\'s name and what book series is he from?</span></span>&nbsp;</p>\n<p style=\"font-style: italic; color: #000000;\"><span style=\"font-size: 10pt;\">(1 prize for the correct answer to both parts of the question!)</span></p>\n<p style=\"font-style: italic; color: #000000;\"> </p>\n<p><img style=\"vertical-align: middle;\" src=\"images/stories/2047_artwork/wimpykid.gif\" /></p>\n<p> </p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a href=\"stockade/qownewest.html\" target=\"_blank\">Click Here to answer the Question!</a></strong></span></p>\n<h2 style=\"font-size: 1.3em; color: #000000; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\"></h2>\n<p style=\"text-align: center;\"><span style=\"font-size: small;\"><span style=\"font-size: 13px;\"><b><span style=\"font-size: large;\"><span style=\"font-size: 18px; font-weight: normal;\"><br /></span></span></b></span></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '0', '90', '0', '109', '2010-11-12 17:45:53', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2010-11-13 18:00:00', '2010-11-17 23:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '27', '', '', '1', '2', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('262', '467', 'QOW #264 Wednesday', 'qow-264-wednesday', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p> </p>\n<table width=\"600\" height=\"277\" cellspacing=\"3\" cellpadding=\"4\" border=\"3\" style=\"background-color: #ffff66; width: 600px; height: 300px;\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td valign=\"middle\" style=\"font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px; color: #fc1102; background-color: #ffff66; text-align: left;\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<br /><br />\n<h2 style=\"text-align: center;\">Wednesday Question of the Week</h2>\n<p> </p>\n<p> </p>\n<h1 style=\"text-align: center;\"><img width=\"150\" height=\"55\" alt=\" \" src=\"../stockade/newart/QOW_animated.gif\" /><strong>#264</strong></h1>\n<p> </p>\n<p><strong><br /></strong></p>\n<div style=\"text-align: center;\">\n<p><span style=\"font-size: medium; color: #000000;\"><span style=\"font-size: 16px;\">&nbsp;</span></span><b>Who did Jesus get the 2 fish and 5 loaves of bread <br />to feed the 5000 people from? <br />(hint: look up John 6:1-13)<br /></b></p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><a target=\"_blank\" href=\"stockade/qownewest.html\"><br /></a><span style=\"font-size: 10pt;\"><strong><a target=\"_blank\" href=\"stockade/qownewest.html\">Click Here to answer the Question!</a></strong></span></p>\n<h2 style=\"font-size: 1.3em; color: #000000; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\"></h2>\n<p style=\"text-align: center;\"><span style=\"font-size: small;\"><span style=\"font-size: 13px;\"><b><span style=\"font-size: large;\"><span style=\"font-size: 18px; font-weight: normal;\"><br /></span></span></b></span></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '0', '90', '0', '109', '2011-03-23 20:34:27', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-03-24 02:00:00', '2011-03-30 19:30:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '28', '', '', '1', '5', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('261', '468', 'QOW #263 Tuesday', 'qow-263-tuesday', '', '<center>\n<p> </p>\n<p> </p>\n<table width=\"600\" cellspacing=\"2\" cellpadding=\"25\" border=\"1\" background=\"http://www.2047.org/stockade/newart/bluegrad.gif\">\n<tbody>\n<tr>\n<td style=\"color: #ff0000; text-align: center;\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<p> </p>\n<p> </p>\n<h1><span style=\"font-size: 14pt; color: #000080;\">Tuesday Question of the Week</span></h1>\n<p> </p>\n<p> </p>\n<p> </p>\n<img width=\"150\" height=\"55\" src=\"../stockade/newart/QOW_animated.gif\" alt=\" \" /><span style=\"font-size: 12pt; color: #ff0000;\"><strong>#263</strong></span>\n<p> </p>\n<p><strong><br /></strong></p>\n<div style=\"text-align: center;\">\n<p><span style=\"font-size: 12pt;\"><span style=\"color: #000000;\">&nbsp;</span><b>What is Spiderman\'s real name?</b></span></p>\n<p> </p>\n<p><span style=\"font-size: 12pt;\"><b><img src=\"images/stories/spiderman.jpg\" /></b></span></p>\n<p><span style=\"font-size: 12pt;\"><b><br /></b></span></p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a href=\"stockade/qownewest.html\" target=\"_blank\">Click Here to answer the Question!</a></strong></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><br /></strong></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</center>', '', '0', '90', '0', '109', '2011-03-23 20:22:24', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-03-23 20:22:24', '2011-03-29 22:30:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '29', '', '', '1', '8', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('201', '469', 'QOW #251', 'qow-251', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p> </p>\n<table style=\"background-color: #ffff66; width: 600px; height: 300px;\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\" height=\"277\" width=\"600\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px; color: #fc1102; background-color: #ffff66; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\">Question of the Week</h2>\n<p> </p>\n<p> </p>\n<h1 style=\"text-align: center;\"><img src=\"../stockade/newart/QOW_animated.gif\" alt=\" \" height=\"55\" width=\"150\" /><strong>#251</strong></h1>\n<h2 style=\"text-align: center;\"><strong><br /></strong></h2>\n<div style=\"text-align: center;\"><br />\n<p style=\"color: #000000; text-align: center;\"><span style=\"font-size: medium;\"><span style=\"font-size: 16px;\">Which villain was in both Toy Story 1 &amp; 3?</span></span></p>\n<p style=\"color: #000000; text-align: center;\"><span style=\"font-size: medium;\"><span style=\"font-size: 16px;\">Bonus, what was his job in Toy Story 3?</span></span></p>\n<p> </p>\n<p><img src=\"images/stories/2047_artwork/sid29.jpg\" /></p>\n<p> </p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a href=\"stockade/qownewest.html\" target=\"_blank\">Click Here to answer the Question!</a></strong></span></p>\n<h2 style=\"font-size: 1.3em; color: #000000; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\"></h2>\n<p style=\"text-align: center;\"><span style=\"font-size: small;\"><span style=\"font-size: 13px;\"><b><span style=\"font-size: large;\"><span style=\"font-size: 18px; font-weight: normal;\"><br /></span></span></b></span></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '0', '90', '0', '109', '2010-11-06 19:04:55', '242', '', '2010-11-12 17:45:50', '242', '0', '0000-00-00 00:00:00', '2010-11-06 19:04:55', '2010-11-10 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '31', '', '', '1', '0', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('259', '470', 'QOW #262 Wednesday', 'qow-262-wednesday', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p> </p>\n<table style=\"background-color: #ffff66; width: 600px; height: 300px;\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\" height=\"277\" width=\"600\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px; color: #fc1102; background-color: #ffff66; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\">Question of the Week</h2>\n<p> </p>\n<p> </p>\n<h1 style=\"text-align: center;\"><img src=\"../stockade/newart/QOW_animated.gif\" alt=\" \" height=\"55\" width=\"150\" /><strong>#262</strong></h1>\n<p> </p>\n<p><strong><br /></strong></p>\n<div style=\"text-align: center;\">\n<p><span style=\"font-size: medium; color: #000000;\"><span style=\"font-size: 16px;\">&nbsp;</span></span><b>Which Wednesday Stockade made this \"Best Looking\" trophy winning car?<br /></b></p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><a href=\"stockade/qownewest.html\" target=\"_blank\"><img style=\"display: block; margin-left: auto; margin-right: auto;\" src=\"http://2047.org/stockade/photoalbum/derby_2011/Thumbnails/12.jpg\" /></a><span style=\"font-size: 10pt;\"><strong><a href=\"stockade/qownewest.html\" target=\"_blank\">Click Here to answer the Question!</a></strong></span></p>\n<h2 style=\"font-size: 1.3em; color: #000000; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\"></h2>\n<p style=\"text-align: center;\"><span style=\"font-size: small;\"><span style=\"font-size: 13px;\"><b><span style=\"font-size: large;\"><span style=\"font-size: 18px; font-weight: normal;\"><br /></span></span></b></span></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '0', '90', '0', '109', '2011-03-16 18:25:01', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-03-17 01:45:00', '2011-03-23 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '32', '', '', '1', '8', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('224', '471', 'QOW #255', 'qow-255', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p> </p>\n<table style=\"background-color: #ffff66; width: 600px; height: 300px;\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\" height=\"277\" width=\"600\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px; color: #fc1102; background-color: #ffff66; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\">Question of the Week</h2>\n<p> </p>\n<p> </p>\n<h1 style=\"text-align: center;\"><img src=\"../stockade/newart/QOW_animated.gif\" alt=\" \" height=\"55\" width=\"150\" /><strong>#255</strong></h1>\n<h2 style=\"text-align: center;\"><strong><br /></strong></h2>\n<div style=\"text-align: center;\"><br />\n<p><span style=\"font-size: medium; color: #000000;\"><span style=\"font-size: 16px;\">&nbsp;</span></span><b>Who lives in a pineapple under the sea?</b></p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a href=\"stockade/qownewest.html\" target=\"_blank\">Click Here to answer the Question!</a></strong></span></p>\n<h2 style=\"font-size: 1.3em; color: #000000; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\"></h2>\n<p style=\"text-align: center;\"><span style=\"font-size: small;\"><span style=\"font-size: 13px;\"><b><span style=\"font-size: large;\"><span style=\"font-size: 18px; font-weight: normal;\"><br /></span></span></b></span></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '0', '90', '0', '109', '2011-01-05 19:14:29', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-01-06 02:30:00', '2011-01-12 21:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '33', '', '', '1', '0', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('258', '472', 'QOW # 261 Tuesday', 'qow-261-tuesday', '', '<center>\n<p> </p>\n<p> </p>\n<table background=\"http://www.2047.org/stockade/newart/bluegrad.gif\" border=\"1\" cellpadding=\"25\" cellspacing=\"2\" width=\"600\">\n<tbody>\n<tr>\n<td style=\"color: #ff0000; text-align: center;\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<p> </p>\n<p> </p>\n<h1><span style=\"color: #000000;\">Tuesday Question of the Week</span></h1>\n<p> </p>\n<p> </p>\n<p> </p>\n<img alt=\" \" src=\"../stockade/newart/QOW_animated.gif\" height=\"55\" width=\"150\" /><span style=\"color: #000000;\"><strong>#261</strong></span>\n<p> </p>\n<p><strong><br /></strong></p>\n<div style=\"text-align: center;\">\n<p><span style=\"font-size: 12pt;\"><span style=\"color: #000000;\">&nbsp;</span><b>Which Tuesday Stockader made this Derby car?</b></span></p>\n<p> </p>\n<p><span style=\"font-size: 12pt;\"><b><img src=\"http://2047.org/stockade/photoalbum/derby_2011/Thumbnails/3.jpg\" /><br /></b></span></p>\n<p> </p>\n<p><span style=\"font-size: 12pt;\"><b><br /></b></span></p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a target=\"_blank\" href=\"stockade/qownewest.html\">Click Here to answer the Question!</a></strong></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><br /></strong></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</center>', '', '0', '90', '0', '109', '2011-03-16 18:23:59', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2011-03-16 18:23:59', '2011-03-22 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '34', '', '', '1', '6', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('129', '473', 'QOW #226', 'qow-226', '', '<span style=\"color: #000000; font-family: Times; font-size: 16px\" class=\"Apple-style-span\"><div style=\"font-size: 10px; text-align: left; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666; background-color: #ffffff\"><span style=\"color: #000000; font-family: Times; font-size: 16px\" class=\"Apple-style-span\"><div style=\"font-size: 10px; text-align: left; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666; background-color: #ffffff\"><p>&nbsp;</p><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" align=\"center\" style=\"background-color: #ffff66; height: 143px\"><tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66; font-family: Verdana,Arial,Helvetica,sans-serif; font-size: 10px\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#226</strong></div><div align=\"center\"><br /><img src=\"images/stories/images-2.jpg\" border=\"0\" /><br /></div><div align=\"center\"> </div><div align=\"center\"><span style=\"color: #000000; font-size: 12px\" class=\"Apple-style-span\">What US state has a 1 syllable name? </span></div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"><br /></div><p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question!</a></p></td></tr></tbody></table><div align=\"center\"><br /></div></div></span></div></span>', '', '0', '90', '0', '109', '2009-11-30 18:44:38', '242', '', '2009-11-30 18:51:35', '242', '0', '0000-00-00 00:00:00', '2009-12-10 00:00:00', '2009-12-16 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '3', '0', '35', '', '', '1', '80', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('253', '474', 'QOW #260 Wednesday', 'qow-260-wednesday', '', '<center><br /></center><center><br /></center><center> \n<table width=\"600\" cellspacing=\"3\" cellpadding=\"4\" border=\"3\" align=\"center\" style=\"background-color: #ffff66; height: 250px;\">\n<tbody>\n<tr>\n<td valign=\"middle\" style=\"color: #ff0000; background-color: #ffff66;\">\n<div align=\"center\"></div>\n<h1 align=\"center\"></h1>\n<h1 align=\"center\"><span style=\"color: #000000;\">Wednesday Question of the Week</span></h1>\n<p> </p>\n<p> </p>\n<div align=\"center\"></div>\n<div align=\"center\"><img width=\"150\" height=\"55\" border=\"0\" align=\"middle\" alt=\" \" src=\"stockade/newart/QOW_animated.gif\" /><span style=\"color: #ff0000;\"><strong style=\"font-size: 24px; color: #000000;\">#260</strong></span></div>\n<div align=\"center\"></div>\n<div align=\"center\"><strong style=\"font-size: 24px; color: #000000;\"><span style=\"text-decoration: underline;\"><br /></span></strong></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"><a target=\"_blank\" href=\"../stockade/qow260puzzle\">CLICK HERE TO SOLVE THE PUZZLE</a></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\" style=\"color: #000000;\">NOTE: This will not work on an iPhone, iPad or iPod.</div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<p align=\"center\"><a onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\" href=\"stockade/qownewest.html\"></a></p>\n</td>\n</tr>\n</tbody>\n</table>\n</center>', '', '0', '90', '0', '109', '2011-02-25 15:00:24', '242', '', '2011-02-25 15:10:13', '242', '0', '0000-00-00 00:00:00', '2011-02-25 15:00:24', '2011-03-02 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '4', '0', '36', '', '', '1', '6', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('252', '475', 'QOW #259 - Tuesday Stockade', 'qow-259-tuesday-stockade', '', '<center>\n<p> </p>\n<p> </p>\n<table width=\"600\" border=\"1\" cellspacing=\"2\" cellpadding=\"25\" background=\"http://www.2047.org/stockade/newart/bluegrad.gif\">\n<tbody>\n<tr>\n<td style=\"color: #ff0000; text-align: center;\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<p> </p>\n<p> </p>\n<h1><span style=\"color: #000000;\">Tuesday Question of the Week</span></h1>\n<p> </p>\n<p> </p>\n<p> </p>\n<img width=\"150\" height=\"55\" alt=\" \" src=\"../stockade/newart/QOW_animated.gif\" /><span style=\"color: #000000;\"><strong>#259</strong></span>\n<p> </p>\n<p><strong><br /></strong></p>\n<div style=\"text-align: center;\">\n<p><span style=\"font-size: 12pt;\"><span style=\"color: #000000;\">&nbsp;</span><b>Tuesday Stockade originally came <br />from which other day Stockade?</b></span></p>\n<p> </p>\n<p><span style=\"font-size: 12pt;\"><b><br /></b></span></p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a target=\"_blank\" href=\"stockade/qownewest.html\">Click Here to answer the Question!</a></strong></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><br /></strong></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</center>', '', '0', '90', '0', '109', '2011-02-22 19:09:16', '242', '', '2011-02-25 14:37:59', '242', '0', '0000-00-00 00:00:00', '2011-02-23 02:00:00', '2011-03-01 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '8', '0', '37', '', '', '1', '7', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('247', '476', 'QOW #258', 'qow-258', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p> </p>\n<table style=\"background-color: #ffff66; width: 600px; height: 300px;\" height=\"277\" width=\"600\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px; color: #fc1102; background-color: #ffff66; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\">Question of the Week</h2>\n<p> </p>\n<p> </p>\n<h1 style=\"text-align: center;\"><img src=\"../stockade/newart/QOW_animated.gif\" alt=\" \" height=\"55\" width=\"150\" /><strong>#258</strong></h1>\n<p> </p>\n<p><strong><img style=\"display: block; margin-left: auto; margin-right: auto;\" src=\"images/stories/pinego.gif\" height=\"61\" width=\"202\" /><br /></strong></p>\n<div style=\"text-align: center;\">\n<p><span style=\"font-size: medium; color: #000000;\"><span style=\"font-size: 16px;\">&nbsp;</span></span><b>Who won last year\'s (2010) Stockade Pinewood Derby?</b></p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a href=\"stockade/qownewest.html\" target=\"_blank\">Click Here to answer the Question!</a></strong></span></p>\n<h2 style=\"font-size: 1.3em; color: #000000; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\"></h2>\n<p style=\"text-align: center;\"><span style=\"font-size: small;\"><span style=\"font-size: 13px;\"><b><span style=\"font-size: large;\"><span style=\"font-size: 18px; font-weight: normal;\"><br /></span></span></b></span></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '0', '90', '0', '109', '2011-02-09 05:00:00', '242', '', '2011-02-09 18:17:06', '242', '0', '0000-00-00 00:00:00', '2011-02-10 02:25:00', '2011-02-16 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '38', '', '', '1', '1', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('200', '477', 'QOW #250', 'qow-250', '', '<center> \n<table style=\"background-color: #ffff66; height: 173px;\" align=\"center\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\" height=\"195\" width=\"492\">\n<tbody>\n<tr>\n<td style=\"background-color: #ffff66; border: 1px solid #cccc99;\" valign=\"middle\">\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"><br /><br /><br /><img src=\"stockade/newart/QOW_animated.gif\" alt=\" \" align=\"middle\" border=\"0\" height=\"55\" width=\"150\" /><strong style=\"font-size: 24px; color: #000000;\"><span style=\"text-decoration: underline;\" class=\"Apple-style-span\">#250</span></strong></div>\n<div align=\"center\"></div>\n<div align=\"center\"><strong style=\"font-size: 24px; color: #000000;\"><span style=\"text-decoration: underline;\" class=\"Apple-style-span\"><br /></span></strong></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"><a target=\"_blank\" href=\"../stockade/quiz/qow250.html\"><span style=\"font-size: 14pt;\"><strong>Question of the Week #250 is here!</strong></span></a><br /><br /><br /></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"><span style=\"font-size: 14pt;\"><strong style=\"color: #000000;\">GOOD LUCK!</strong></span></div>\n<div align=\"center\"><span style=\"font-size: 14pt;\"><strong style=\"color: #000000;\"><br /></strong></span></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div style=\"color: #000000;\" align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<div align=\"center\"></div>\n<p align=\"center\"><a href=\"stockade/qownewest.html\"></a></p>\n</td>\n</tr>\n</tbody>\n</table>\n</center>', '', '0', '90', '0', '109', '2010-10-29 18:21:22', '242', '', '2010-10-29 18:51:27', '242', '0', '0000-00-00 00:00:00', '2010-10-29 18:21:22', '2010-11-03 23:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '3', '0', '39', '', '', '1', '2', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('198', '478', 'QOW #249', 'qow-249', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p> </p>\n<table style=\"background-color: #ffff66; width: 600px; height: 300px;\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\" height=\"277\" width=\"600\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 18px; color: #fc1102; background-color: #ffff66; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\">Question of the Week</h2>\n<p> </p>\n<p> </p>\n<h1 style=\"text-align: center;\"><img alt=\" \" src=\"../stockade/newart/QOW_animated.gif\" height=\"55\" width=\"150\" /><strong>#249</strong></h1>\n<h2 style=\"text-align: center;\"><strong><br /></strong></h2>\n<div style=\"text-align: center;\"><br />\n<p style=\"color: #000000; text-align: center;\"><span style=\"font-size: 12pt;\">Last week we learned that 10 - 12 year olds in Stockade are called Sentinels,</span><br /><br /></p>\n<p> </p>\n<p><img src=\"images/stories/2047_artwork/29.jpg\" /></p>\n<p> </p>\n<p style=\"color: #000000; text-align: center;\"><span style=\"font-size: 12pt;\">what are the 8 &amp; 9 year olds called? </span><br /><span style=\"font-size: 12pt;\">(hint, I told you last week &amp; at Stockade)</span></p>\n<p> </p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a target=\"_blank\" href=\"stockade/qownewest.html\">Click Here to answer the Question!</a></strong></span></p>\n<h2 style=\"font-size: 1.3em; color: #000000; text-align: center; padding: 0px; margin: 0px; border: 0px initial initial;\"></h2>\n<br />\n<h1 style=\"font-size: 12pt; color: #ff0000; text-align: center;\">Check back next week for QOW #250! If you win you receive 2 prizes!</h1>\n<h1 style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><br /></strong></span></h1>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><br /></strong></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '0', '90', '0', '109', '2010-10-20 05:00:00', '242', '', '2010-10-19 12:37:56', '242', '0', '0000-00-00 00:00:00', '2010-10-21 01:00:00', '2010-10-27 20:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '4', '0', '40', '', '', '1', '4', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('197', '479', 'QOW #248', 'qow-248', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p> </p>\n<table style=\"background-color: #ffff66; width: 600px; height: 300px;\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\" height=\"277\" width=\"600\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"border: 1px solid #cccc99; background-color: #ffff66; font-family: Verdana,Arial,Helvetica,sans-serif; font-size: 10px; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\">Question of the Week</h2>\n<p> </p>\n<p> </p>\n<h2 style=\"text-align: center;\"><img alt=\" \" src=\"../stockade/newart/QOW_animated.gif\" height=\"55\" width=\"150\" /><strong>#248</strong></h2>\n<h2 style=\"text-align: center;\"><strong><br /></strong></h2>\n<div style=\"text-align: center;\"><br />\n<h2 style=\"color: #000000; text-align: center;\">In Stockade - 8 &amp; 9 year olds are called Builders, <br /><br /></h2>\n<p> </p>\n<p><img src=\"images/stories/2047_artwork/30.jpg\" />&nbsp;</p>\n<p> </p>\n<h2 style=\"color: #000000; text-align: center;\">what are the 10 &amp; 11 year olds called?</h2>\n<p> </p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a target=\"_blank\" href=\"stockade/qownewest.html\">Click Here to answer the Question!</a></strong></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><br /></strong></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '0', '90', '0', '109', '2010-10-15 11:56:01', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2010-10-15 11:56:01', '2010-10-20 23:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '41', '', '', '1', '11', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('109', '480', 'QOW over for the year', 'qow-over-for-the-year', '', '<p>&nbsp;</p><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" align=\"center\" style=\"background-color: #ffff66; height: 143px\"> <tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; font-size: 12px; background-color: #ffff66\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /> </div>        <div align=\"center\"> <br /><font color=\"#000000\"><strong>The Question of the Week is finished for the year.</strong></font></div><font color=\"#000000\"><strong><br /></strong></font><div align=\"center\"><font color=\"#000000\"><strong>Check back here for QOW #214 when we begin <br />a new year of Stockade in September! </strong></font><br /></div><div align=\"center\"> </div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"> </div>          </td></tr></tbody> </table><div align=\"center\"><br /></div><div align=\"center\"><br /></div><div align=\"center\"><br /></div>', '', '0', '90', '0', '109', '2009-06-03 12:42:32', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2009-06-03 04:00:00', '2009-09-02 12:41:40', '', '', '{}', '1', '0', '42', '', '', '1', '346', '{}', '0', '*', ''),
('194', '481', 'QOW #246', 'qow-246', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p> </p>\n<table style=\"background-color: #ffff66; width: 600px; height: 300px;\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\" height=\"277\" width=\"600\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"border: 1px solid #cccc99; background-color: #ffff66; font-family: Verdana,Arial,Helvetica,sans-serif; font-size: 10px; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\"></h2>\n<h2 style=\"text-align: center;\">Question of the Week</h2>\n<p> </p>\n<p> </p>\n<h2 style=\"text-align: center;\"><img alt=\" \" src=\"../stockade/newart/QOW_animated.gif\" height=\"55\" width=\"150\" /><strong>#246</strong></h2>\n<h2 style=\"text-align: center;\"><strong><br /></strong></h2>\n<div style=\"text-align: center;\"><br />\n<h2 style=\"color: #000000; text-align: center;\">Name these 3 ducks.</h2>\n<p> </p>\n<p><img src=\"images/stories/2047_artwork/donald.jpg\" /><img src=\"images/stories/2047_artwork/daffy.jpg\" /><img src=\"images/stories/2047_artwork/mighty.jpg\" height=\"196\" width=\"217\" /></p>\n<p> </p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a target=\"_blank\" href=\"stockade/qownewest.html\">Click Here to answer the Question!</a></strong></span></p>\n<p style=\"text-align: center;\"> </p>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><br /></strong></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '0', '90', '0', '109', '2010-10-04 15:31:03', '242', '', '2010-10-04 15:41:18', '242', '0', '0000-00-00 00:00:00', '2010-10-04 15:31:03', '2010-10-06 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '3', '0', '43', '', '', '1', '11', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('149', '482', 'QOW 232', 'qow-232', '', '<div style=\"font-size: 10px; text-align: left; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666; background-color: #ffffff;\">\n<p> </p>\n<table style=\"background-color: #ffff66; height: 143px; width: 621px;\" align=\"center\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\">\n<tbody>\n<tr>\n<td style=\"border: 1px solid #cccc99; background-color: #ffff66; font-family: Verdana,Arial,Helvetica,sans-serif; font-size: 10px;\" valign=\"middle\">\n<h2 align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" alt=\" \" align=\"middle\" border=\"0\" height=\"55\" width=\"150\" /><strong style=\"color: #000000;\">#232</strong></h2>\n<div align=\"center\"><br /><img src=\"images/stories/pacman_avatar_by_purplekiwi126.gif\" height=\"120\" width=\"120\" />&nbsp; <img src=\"images/stories/pacmanicon.png\" height=\"121\" width=\"215\" /> &nbsp;<img src=\"images/stories/pacman ghosts.jpg\" /></div>\n<h2 style=\"color: #000000;\" align=\"center\">What are the Character names and Nicknames of the 4 ghosts in Pac-Man?</h2>\n<p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question!</a></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>', '', '0', '90', '0', '109', '2010-02-04 17:11:19', '242', '', '2010-02-04 17:21:07', '242', '0', '0000-00-00 00:00:00', '2010-02-04 17:11:19', '2010-02-10 22:30:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '44', '', '', '1', '29', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('183', '483', 'QOW #244', 'qow-244', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p> </p>\n<table style=\"background-color: #ffff66; width: 600px; height: 300px;\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\" height=\"277\" width=\"600\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"border: 1px solid #cccc99; background-color: #ffff66; font-family: Verdana,Arial,Helvetica,sans-serif; font-size: 10px; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\">Question of the Week</h2>\n<p> </p>\n<p> </p>\n<h2 style=\"text-align: center;\"><img alt=\" \" src=\"../stockade/newart/QOW_animated.gif\" height=\"55\" width=\"150\" /><strong>#244</strong></h2>\n<h2 style=\"text-align: center;\"><strong><br /></strong></h2>\n<div style=\"text-align: center;\"><br />\n<h2 style=\"color: #000000; text-align: center;\">How many U.S. states have two words in their name?</h2>\n<p> </p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a href=\"stockade/qownewest.html\">Click Here to answer the Question!</a></strong></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '0', '90', '0', '109', '2010-08-26 13:04:09', '242', '', '2010-09-21 21:33:59', '242', '0', '0000-00-00 00:00:00', '2010-09-15 00:00:00', '2010-09-21 23:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '4', '0', '45', '', '', '1', '1', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('180', '484', 'QOW #243', 'qow-243', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666;\">\n<p> </p>\n<table style=\"background-color: #ffff66; width: 600px; height: 300px;\" height=\"277\" width=\"600\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"border: 1px solid #cccc99; background-color: #ffff66; font-family: Verdana,Arial,Helvetica,sans-serif; font-size: 10px; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\">Question of the Week</h2>\n<p> </p>\n<p> </p>\n<h2 style=\"text-align: center;\"><img alt=\" \" src=\"../stockade/newart/QOW_animated.gif\" height=\"55\" width=\"150\" /><strong>#243</strong></h2>\n<h2 style=\"text-align: center;\"><strong><br /></strong></h2>\n<div style=\"text-align: center;\"><br />\n<h2 style=\"color: #000000; text-align: center;\">Last June was the final Stockade meeting for which <br />Junior Leader who moved to Philadelphia for college?</h2>\n<p> </p>\n<p> </p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\" href=\"stockade/qownewest.html\">Click Here to answer the Question!</a></strong></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '0', '90', '0', '109', '2010-08-25 12:16:48', '242', '', '2010-09-07 13:22:52', '242', '0', '0000-00-00 00:00:00', '2010-08-25 12:16:48', '2010-09-15 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '7', '0', '47', '', '', '1', '15', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('128', '485', 'QOW #225', 'qow-225', '', '<span style=\"color: #000000; font-family: Times; font-size: 16px\" class=\"Apple-style-span\"><div style=\"font-size: 10px; text-align: left; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666; background-color: #ffffff\"><span style=\"color: #000000; font-family: Times; font-size: 16px\" class=\"Apple-style-span\"><div style=\"font-size: 10px; text-align: left; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666; background-color: #ffffff\"><p>&nbsp;</p><table border=\"3\" cellspacing=\"3\" cellpadding=\"4\" width=\"621\" align=\"center\" style=\"background-color: #ffff66; height: 143px\"><tbody><tr><td valign=\"middle\" style=\"border: 1px solid #cccc99; background-color: #ffff66; font-family: Verdana,Arial,Helvetica,sans-serif; font-size: 10px\"><div align=\"center\"><img src=\"stockade/newart/QOW_animated.gif\" border=\"0\" alt=\" \" width=\"150\" height=\"55\" align=\"middle\" /><strong>#225</strong></div><div align=\"center\"><br /><img src=\"images/stories/images-1.jpg\" border=\"0\" /><br /></div><div align=\"center\"> </div><div align=\"center\"><span style=\"color: #000000; font-size: 12px\" class=\"Apple-style-span\">What are the two things striped on a tiger?<br /></span></div><div align=\"center\"> </div><div align=\"center\"><br /></div><div align=\"center\"><br /></div><p align=\"center\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question!</a></p></td></tr></tbody></table><div align=\"center\"><br /></div></div></span></div></span>', '', '0', '90', '0', '109', '2009-11-30 18:41:51', '242', '', '2009-11-30 18:44:35', '242', '0', '0000-00-00 00:00:00', '2009-12-03 00:00:00', '2009-12-09 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '48', '', '', '1', '80', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('169', '486', 'QOW #242', 'qow-242', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666; background-color: #ffffff;\">\n<p> </p>\n<table style=\"background-color: #ffff66; width: 621px; height: 143px;\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"border: 1px solid #cccc99; background-color: #ffff66; font-family: Verdana,Arial,Helvetica,sans-serif; font-size: 10px; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\">Question of the Week</h2>\n<h2 style=\"text-align: center;\"><img alt=\" \" src=\"stockade/newart/QOW_animated.gif\" border=\"0\" height=\"55\" width=\"150\" /><strong>#242</strong></h2>\n<p style=\"text-align: center;\"><strong><span style=\"color: #ff0000;\"><span style=\"font-size: 14pt;\"><blink>The final Question of the Week for this year!</blink></span></span><br /></strong></p>\n<div style=\"text-align: center;\"><br />\n<h2 style=\"color: #000000; text-align: center;\">What did we do at the first Stockade Meeting of the year?</h2>\n<h2><span style=\"color: #000000;\">Launch Balloons? Mummy Wrap? Chew and Stick Gumballs?</span></h2>\n<p> </p>\n<p><img src=\"stockade/photoalbum/balloonlaunch09/index-Thumbnails/5.jpg\" height=\"152\" width=\"114\" />&nbsp; <img src=\"http://www.2047.org/stockade/photoalbum/first_mtg_09-10/index-Thumbnails/24.jpg\" height=\"151\" width=\"112\" />&nbsp; <img src=\"http://www.2047.org/stockade/photoalbum/mtg09-2/index-Thumbnails/10.jpg\" /></p>\n</div>\n<p style=\"text-align: center;\"><span style=\"font-size: 10pt;\"><strong><a onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\" href=\"stockade/qownewest.html\">Click Here to answer the Question!</a></strong></span></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '0', '90', '0', '109', '2010-05-20 18:14:56', '242', '', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '2010-05-26 23:00:00', '2010-06-02 23:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '49', '', '', '1', '7', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('157', '487', 'QOW #237', 'qow-237', '', '<center>\n<div style=\"font-size: 10px; font-family: Verdana,Arial,Helvetica,sans-serif; color: #666666; background-color: #ffffff;\">\n<p> </p>\n<table style=\"background-color: #ffff66; height: 143px; width: 621px;\" border=\"3\" cellpadding=\"4\" cellspacing=\"3\">\n<tbody style=\"text-align: left;\">\n<tr style=\"text-align: left;\">\n<td style=\"border: 1px solid #cccc99; background-color: #ffff66; font-family: Verdana,Arial,Helvetica,sans-serif; font-size: 10px; text-align: left;\" valign=\"middle\">\n<h2 style=\"text-align: center;\"><img src=\"stockade/newart/QOW_animated.gif\" alt=\" \" border=\"0\" height=\"55\" width=\"150\" /><strong style=\"color: #000000;\">#237</strong></h2>\n<div style=\"text-align: center;\"><br />\n<h2 style=\"color: #000000; text-align: center;\">The final Pinewood Derby question of the year!</h2>\n<img src=\"images/stories/pinego.gif\" /></div>\n<h2 style=\"color: #000000; text-align: center;\">In this year\'s race, who had Car #1 &amp; Car #29?</h2>\n<p style=\"text-align: center;\"><img src=\"images/stories/0.jpg\" height=\"108\" width=\"144\" /><img src=\"images/stories/27.jpg\" height=\"108\" width=\"144\" /></p>\n<p style=\"text-align: center;\">(If you check out <a target=\"_blank\" href=\"index.php?option=com_wrapper&amp;view=wrapper&amp;Itemid=79\">the photoalbum</a> you may find the answer!)</p>\n<p> </p>\n<p style=\"text-align: center;\"><img src=\"images/stories/pinem1.gif\" /></p>\n<p style=\"text-align: center;\"><a href=\"stockade/qownewest.html\" onclick=\"window.open(\'http://www.2047.org/stockade/qownewest.html\',\'\',\'width=500,height=500\');return false;\">Click Here to answer the Question!</a></p>\n</td>\n</tr>\n</tbody>\n</table>\n</div>\n</center>', '', '0', '90', '0', '109', '2010-03-18 12:38:39', '242', '', '2010-03-18 12:46:12', '242', '0', '0000-00-00 00:00:00', '2010-03-18 12:38:39', '2010-03-24 22:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '51', '', '', '1', '15', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('232', '488', 'Battalion Winter Camporama Information', 'battalion-winter-camporama-information', '', '<p>Battalion Winter Camporama Information</p>\n<p> </p>\n<p>If the letter does not show up, use this link&nbsp;<a href=\"images/pdf_files/winter_camporama11.pdf\">http://www.2047.org/newweb/images/pdf_files/winter_camporama11.pdf</a></p>\n<p> </p>\n<p>{pdf=http://www.2047.org/newweb/images/pdf_files/winter_camporama11.pdf|600|800}</p>', '', '2', '86', '0', '87', '2011-01-18 18:55:20', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2011-01-18 18:55:20', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '11', '', '', '1', '105', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('332', '489', '2-15-12 Parent Letter Stockade Tuesday & Wednesday', '2-15-12-parent-letter-stockade-tuesday-a-wednesday', '', '<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br /><a href=\"images/pdf_files/2011_2012_pdf/letter-2-15-12.pdf\" target=\"_blank\">http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/letter-2-15-12.pdf</a><br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/letter-2-15-12.pdf|600|800}</p>', '', '2', '86', '0', '87', '2012-02-16 11:29:32', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2012-02-16 11:29:32', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '11', '', '', '1', '42', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('383', '490', '1-9-13 Wednesday Stockade Letter', '1-9-13-wednesday-stockade-letter', '', '<p><br /></p>\n<p>If the letter does not show up, use this link</p>\n<p><br />http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/1-9-13_wed.pdf<br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/1-9-13_wed.pdf|600|800}</p>', '', '1', '86', '0', '87', '2013-01-06 21:17:24', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2013-01-06 21:17:24', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '11', '', '', '1', '149', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('140', '491', '1-6-10 Parent Letter - Stockade', '1-6-10-parent-letter-stockade', '', '<p style=\"font-size: 10px; color: #000000\" align=\"center\"><font style=\"font-size: 12px\" color=\"#000000\"><strong>Christian Service Brigade #2047</strong><br /><em><strong>from the Wesleyan Church of Orchard Park</strong></em>  <br />Tree Climbers    Stockade    Battalion<br /><br />jim@2047.org            www.2047.org</font></p><p><font color=\"#000000\"> </font></p><p><font color=\"#000000\"> </font></p><p><font color=\"#000000\"> </font></p><p><font style=\"font-size: 10px\" color=\"#000000\">Dear Parents,<br /><br />Pinewood Derby cars are now available for our race in March! The purpose of the derby is for your boy to spend some fun time making a car with an adult. We do have several \"help\" days scheduled to assist Stockaders and Tree Climbers with their cars as well as a \'test day\" where we can add weight and test the cars on our race track.  Note, the Work Days are for Stockade and Tree Climber cars only. The test day is open to Pioneer Girls.<br /><br />If your boy does not have anyone to help him with his car please let me know. We are willing and happy to assist any of the boys with their car.<br /><br />While we do award trophies to the winners, as well as \"Best Looking\" & \"Most Original\", the purpose of the race is for the boy to spend some time having fun making and racing his car. The competition is secondary.<br /><br />The cars for this years race must be kits purchased from Stockade this year and must be newly made for this year\'s race. Cars made for Cub Scouts, Royal Rangers, school, or for a previous Stockade year etc., are not able to be used.<br /><br />Wednesday, January 20 is our annual Creature Feature night! If any parents would like to attend let me know. Space is limited.<br /><br />Upcoming activities are listed below and a full schedule is on the website  2047.org<br /><br />Should you have any questions now or in the future you can contact me at jim@2047.org email or by phone at 662-0335.<br /><br /></font></p><p align=\"center\"><font style=\"font-size: 10px\" color=\"#000000\"><strong>Stockade Movie Night</strong><br />Saturday, January 16, 7:00pm <br /><br /><strong>Creature Feature Night</strong><br />Wednesday, January 20<br /><br /><strong>Sledding Nights & Overnights</strong><br />to be announced<br /><br /><strong>Derby Car Help Days</strong><br />Saturday, January 23, 11-2<br />Saturday, February 6, 9-12<br />Sunday, February 21, 2-5<br /><br /><strong>Family Movie Night</strong><br />Saturday, February 13th - 6:30pm<br />\"Down & Derby\" & Cartoons<br /><br /><strong>Derby Test Day</strong><br />Saturday, February 27th - 11am - 3pm<br /><br /><strong>Tuesday, March 9th </strong><br />RACE DAY FOR <br />STOCKADE & TREE CLIMBERS</font></p><p align=\"center\"><font style=\"font-size: 10px\" color=\"#000000\"><strong>Stockade 100 Item Scavengar Hunt</strong><br /> to be announced<br /> <br /> <strong>Stockarama Camping Weekend</strong><br /> May 14 - 16</font>  </p><div align=\"center\" style=\"font-size: 12px\"><font color=\"#800000\"><strong><font style=\"font-size: 10px\">During poor weather if Orchard Park Central Schools are closed for the entire day, Stockade is canceled.</font><br /><font style=\"font-size: 10px\">If you are not sure check the Stockade webpage. If school was not cancelled and the weather is poor, stay home.</font></strong></font><br /></div><p>&nbsp;</p><p><font color=\"#000000\"> </font></p><p><font color=\"#000000\"> </font></p><p><font color=\"#000000\"> </font></p><p><font color=\"#000000\"> </font></p>', '', '2', '86', '0', '87', '2010-01-06 15:17:05', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2010-01-06 15:17:05', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":1,\"show_print_icon\":1,\"show_email_icon\":1,\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '12', '', '', '1', '663', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('228', '492', '1-12-11 Wednesday Stockade Letter', '1-12-11-wednesday-stockade-letter', '', '<p>1/12/2011 Wednesday Stockade Letter</p>\n<p> </p>\n<p>If the letter does not show up, use this link&nbsp;<a href=\"images/pdf_files/letter-1-12-11.pdf\">http://www.2047.org/newweb/images/pdf_files/letter-1-12-11.pdf</a></p>\n<p> </p>\n<p>{pdf=http://www.2047.org/newweb/images/pdf_files/letter-1-12-11.pdf|600|800}</p>', '', '2', '86', '0', '87', '2011-01-13 23:33:25', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2011-01-13 23:33:25', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '12', '', '', '1', '94', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('331', '493', '1-31-12 Parent Letter Stockade Tuesday & Wednesday', '1-31-12-parent-letter-stockade-tuesday-a-wednesday', '', '<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br /><a href=\"images/pdf_files/2011_2012_pdf/letter-1-31-12.pdf\" target=\"_blank\">http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/letter-1-31-12.pdf</a><br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/letter-1-31-12.pdf|600|800}</p>', '', '2', '86', '0', '87', '2012-01-31 17:17:41', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2012-01-31 17:17:41', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '12', '', '', '1', '40', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('382', '494', '1-8-13 Tuesday Stockade Letter', '1-8-13-tuesday-stockade-letter', '', '<p><br /></p>\n<p>If the letter does not show up, use this link</p>\n<p><br />http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/1-8-13_tues.pdf<br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/1-8-13_tues.pdf|600|800}</p>', '', '1', '86', '0', '87', '2013-01-06 21:15:08', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2013-01-06 21:15:08', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '12', '', '', '1', '128', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('135', '495', '12/16/09 Stockade Parent Letter', '121609-stockade-parent-letter', '', '<font color=\"#000000\"><strong style=\"font-size: 12px\"><span style=\"font-family: Helvetica; font-weight: normal\" class=\"Apple-style-span\"><div style=\"margin: 0px\"><font face=\"Times\" size=\"3\" style=\"font: normal normal normal 11px/normal Times\">Dear Parents,</font></div><div style=\"text-align: justify; font: normal normal normal 11px/normal Times; min-height: 13px; margin: 0px\"><br /></div><div style=\"text-align: justify; margin: 0px\"><font face=\"Times\" size=\"3\" style=\"font: normal normal normal 11px/normal Times\">Next week, December 23, we will be having Stockade during the regular time. The following week, December 30, there will be no Stockade meeting. The weekly schedule resumes January 6th.</font></div><div style=\"text-align: justify; font: normal normal normal 11px/normal Times; min-height: 13px; margin: 0px\"><br /></div><div style=\"text-align: justify; margin: 0px\"><font face=\"Times\" size=\"3\" style=\"font: normal normal normal 11px/normal Times\">Starting January 13th Pinewood Derby Cars will be available for purchase.</font></div><div style=\"text-align: justify; font: normal normal normal 11px/normal Times; min-height: 13px; margin: 0px\"><br /></div><div style=\"text-align: justify; margin: 0px\"><font face=\"Times\" size=\"3\" style=\"font: normal normal normal 11px/normal Times\">The Pinewood Derby is a yearly activity where the boys construct a car with an adult (if your boy needs assistance, let me know) and we spend an evening in March racing the cars. The top racers have the option of racing against others in our regional race.</font></div><div style=\"text-align: justify; font: normal normal normal 11px/normal Times; min-height: 13px; margin: 0px\"><br /></div><div style=\"text-align: justify; margin: 0px\"><font face=\"Times\" size=\"3\" style=\"font: normal normal normal 11px/normal Times\">While we do award trophies to the winners, as well as \"Best Looking\" & \"Most Original\", the purpose of the race is for the boy to spend some time having fun making and racing his car. The competition is secondary.</font></div><div style=\"text-align: justify; font: normal normal normal 11px/normal Times; min-height: 13px; margin: 0px\"><br /></div><div style=\"text-align: justify; margin: 0px\"><font face=\"Times\" size=\"3\" style=\"font: normal normal normal 11px/normal Times\">The cars for this years race must be kits purchased from Stockade this year and must be newly made for this year\'s race. Cars made for Cub Scouts, Royal Rangers, school, or for a previous Stockade year etc., are not able to be used in the main race.</font></div><div style=\"text-align: justify; font: normal normal normal 11px/normal Times; min-height: 13px; margin: 0px\"><br /></div><div style=\"text-align: justify; margin: 0px\"><font face=\"Times\" size=\"3\" style=\"font: normal normal normal 11px/normal Times\">For those that do not have the tools or for boys needing assistance we will be having several \"Pinewood Derby Work Days\" in January and February</font></div><div style=\"text-align: justify; font: normal normal normal 11px/normal Times; min-height: 13px; margin: 0px\"><br /></div><div style=\"text-align: center; margin: 0px\"><font face=\"Times\" size=\"3\" style=\"font: normal normal normal 11px/normal Times\"><strong>January 23, 11am - 2pm  •  Feb. 6, 9am - 11:30am  •  3rd date TBA<br />Derby Test Day - February 27th - 11 - 3</strong></font></div><div style=\"text-align: justify; font: normal normal normal 11px/normal Times; min-height: 13px; margin: 0px\"><br /></div><div style=\"text-align: justify; margin: 0px\"><font face=\"Times\" size=\"3\" style=\"font: normal normal normal 11px/normal Times\">The work days are for Stockade and Tree Climbers only. We will not be able to work on Pioneer Girl cars, school cars, etc.</font></div><div style=\"text-align: justify; font: normal normal normal 11px/normal Times; min-height: 13px; margin: 0px\"><br /></div><div style=\"text-align: justify; margin: 0px\"><font face=\"Times\" size=\"3\" style=\"font: normal normal normal 11px/normal Times\"><strong>Also coming up in January & February will be  Stockade Sledding Night, Creature Feature, Movie Night, All-Nighter #2 & the Derby Work Days.</strong></font></div><div style=\"text-align: justify; font: normal normal normal 11px/normal Times; min-height: 13px; margin: 0px\"><br /></div><div style=\"text-align: justify; margin: 0px\"><font face=\"Times\" size=\"3\" style=\"font: normal normal normal 11px/normal Times\">Should you have any questions now or in the future you can contact me at <strong><a href=\"mailto:jim@2047.org\">jim@2047.org</a></strong> email or by phone at <strong>662-0335</strong>.</font></div></span></strong></font>', '', '2', '86', '0', '87', '2009-12-15 15:11:07', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2009-12-15 20:11:07', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '13', '', '', '1', '1194', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('225', '496', '1-11-11 Tuesday Stockade Letter', '1-11-11-tuesday-stockade-letter', '', '<p>1/11/2011 Tuesday Stockade Letter</p>\n<p> </p>\n<p>If the letter does not show up, use this link&nbsp;<a href=\"images/pdf_files/letter-1-11-11.pdf\">http://www.2047.org/newweb/images/pdf_files/letter-1-11-11.pdf</a></p>\n<p> </p>\n<p>{pdf=http://www.2047.org/newweb/images/pdf_files/letter-1-11-11.pdf|600|800}</p>', '', '2', '86', '0', '87', '2011-01-11 14:15:22', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2011-01-11 14:15:22', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '13', '', '', '1', '83', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('328', '497', '2012 Pinewood Derby Instructions and Information', '2012-pinewood-derby-instructions-and-information', '', 'If the letter does not show up, use this link\n<p><br /><a href=\"images/pdf_files/2011_2012_pdf/derby-rules-12.pdf\" target=\"_blank\">http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/derby-rules-12.pdf</a><br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/derby-rules-12.pdf|600|800}</p>', '', '2', '86', '0', '87', '2012-01-09 12:37:16', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2012-01-09 12:37:16', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '13', '', '', '1', '79', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('379', '498', '12-5-12 Wednesday Stockade Letter', '12-5-12-wednesday-stockade-letter', '', '<p>&nbsp;</p>\n<p>If the letter does not show up, use this link</p>\n<p><br />http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/12-5-12_wed.pdf<br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/12-5-12_wed.pdf|600|800}</p>', '', '1', '86', '0', '87', '2012-11-29 23:41:40', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2012-11-29 23:41:40', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '13', '', '', '1', '163', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('134', '499', '11/18/09 Parent Letter Stockade', '111809-parent-letter-stockade', '', '<font style=\"font-size: 12px\" color=\"#000000\">Dear Parents,<br /><br />Next Wednesday, November 25, Stockade will be having a game night during the regular meeting. The Pioneer Girls and Tree Climbers will not be meeting but the boys will have their meeting the regular time.<br /><br />If you have not already done so - please send in the registration and the first aid form. I\'d like to wrap this up asap. ?The yearly registration fee is $60. Checks can be made out to Stockade.<br /><br />After a 1 year absence there are tentative plans to restart our Tuesday Stockade. The Tuesday Stockade is run the same as the Wednesday group but is limited in size to no more than 20 boys.  Wednesday Stockade boys can switch to Tuesday if they prefer a smaller group. However, Stockaders can not attend both Tuesday and Wednesday. If you would like additional information on the Tuesday Stockade or if your boy has an interest, contact me asap so we can begin to finalize the plans.<br /><br />Should you have any questions now or in the future you can contact me at jim@2047.org email or by phone at 662-0335.<br /><br /><br /><br /></font><div align=\"center\"><font color=\"#ff0000\"><strong><font style=\"font-size: 12px\">During poor weather if Orchard Park Central Schools are </font><br /><font style=\"font-size: 12px\">closed for the entire day, Stockade is cancelled.</font><br /><font style=\"font-size: 12px\">If you are not sure check the Stockade webpage.</font><br /><font style=\"font-size: 12px\">If school was not cancelled and the weather is poor, stay home.</font></strong></font><br /></div><font style=\"font-size: 12px\" color=\"#000000\"><br /></font>', '', '2', '86', '0', '87', '2009-12-15 15:00:09', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2009-12-15 15:00:09', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '14', '', '', '1', '817', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('223', '500', '1-5-11 Stockade Letter', '1-5-11-stockade-letter', '', 'letter-1-5-11.pdf\n\n<p>1/5/2011 Stockade Letter</p>\n<p> </p>\n<p>If the letter does not show up, use this link&nbsp;<a href=\"images/pdf_files/letter-1-5-11.pdf\">http://www.2047.org/newweb/images/pdf_files/letter-1-5-11.pdf</a></p>\n<p> </p>\n<p>{pdf=http://www.2047.org/newweb/images/pdf_files/letter-1-5-11.pdf|600|800}</p>', '', '2', '86', '0', '87', '2011-01-05 12:58:06', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2011-01-05 12:58:06', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '14', '', '', '1', '95', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('327', '501', '1-4-12 Parent Letter Stockade Tuesday & Wednesday', '1-4-11-parent-letter-stockade-tuesday-a-wednesday', '', '<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br /><a href=\"images/pdf_files/2011_2012_pdf/letter-1-4-11.pdf\" target=\"_blank\">http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/letter-1-4-11.pdf</a><br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/letter-1-4-11.pdf|600|800}</p>', '', '2', '86', '0', '87', '2012-01-04 14:48:59', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2012-01-04 14:48:59', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '2', '0', '14', '', '', '1', '46', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('378', '502', '11-27-12 Tuesday Stockade Letter', '11-27-12-tuesday-stockade-letter', '', '<p>&nbsp;</p>\n<p>If the letter does not show up, use this link</p>\n<p><br />http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/11-27-12_tues.pdf<br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/11-27-12_tues.pdf|600|800}</p>', '', '1', '86', '0', '87', '2012-11-27 18:45:05', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2012-11-27 18:45:05', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '14', '', '', '1', '186', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('133', '503', '11/4/09 Parent Letter - Stockade', '11409-parent-letter-stockade', '', '<font style=\"font-size: 12px\" color=\"#000000\">Dear Parents,<br /><br />A reminder on several items - <br /><br />If you have not already done so - please send in the registration and the first aid form. I\'d like to wrap this up asap. ?The yearly registration fee is $60. Checks can be made out to Stockade.<br /><br />Even though next week is a school holiday we still have Stockade during the regular hours.<br /><br />After a 1 year absence there are tentative plans to restart our Tuesday Stockade. The Tuesday Stockade is run the same as the Wednesday group but is limited in size to no more than 20 boys. Currently  Wednesday is currently running about 40 boys and is growing. As the group increases in size some boys become intimidated, with Tuesday Stockade there will be an alternative. Wednesday Stockade boys can switch to Tuesday if they prefer a smaller group. However, Stockaders can not attend both Tuesday and Wednesday. If you would like additional information on the Tuesday Stockade or if your boy has an interest, contact me asap so we can begin to finalize the plans.<br /><br />Wednesday, November 25, the day before Than ksgiving stockade will be having a game night during the regular meeting times.<br /><br />Should you have any questions now or in the future you can contact me at jim@2047.org email or by phone at 662-0335.<br /><br /><br /></font><div align=\"center\"><font color=\"#008000\"><strong><font style=\"font-size: 12px\">PARENTS OF </font><br /><font style=\"font-size: 12px\">WEDNESDAY STOCKADE</font><br /><font style=\"font-size: 12px\">Stick around when your boy is at stockade and enjoy a Latté, Cappuccino, Mocha, Italian Soda, Hot Tea or just plain coffee!</font><br /><font style=\"font-size: 12px\">From The Grounds Up Café!</font><br /><font style=\"font-size: 12px\">in the main church building</font></strong></font><br /></div><font style=\"font-size: 12px\" color=\"#000000\"><br /></font><div align=\"center\"><em><strong><font style=\"font-size: 12px\" color=\"#000000\">During poor weather if Orchard Park Central Schools are </font><br /><font style=\"font-size: 12px\" color=\"#000000\">closed for the entire day, Stockade is cancelled.</font><br /><font style=\"font-size: 12px\" color=\"#000000\">If you are not sure check the Stockade webpage.</font><br /><font style=\"font-size: 12px\" color=\"#000000\">If school was not cancelled and the weather is poor, stay home.</font></strong></em></div>', '', '2', '86', '0', '87', '2009-12-15 14:57:43', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2009-12-15 14:57:43', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '15', '', '', '1', '1175', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('220', '504', 'Pinewood Derby Rules & Information 2011', 'pinewood-derby-rules-a-information-2011', '', '<p>Pinewood Derby Rules and Information 2011 - Stockade & Tree Climbers</p>\n<p> </p>\n<p>If the letter does not show up, use this link&nbsp;<a href=\"images/pdf_files/derby_rules_11.pdf\">http://www.2047.org/newweb/images/pdf_files/derby_rules_11.pdf</a></p>\n<p> </p>\n<p>{pdf=http://www.2047.org/newweb/images/pdf_files/derby_rules_11.pdf|600|800}</p>', '', '2', '86', '0', '87', '2010-12-27 17:55:16', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2010-12-27 17:55:16', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '15', '', '', '1', '310', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('321', '505', '11-29-11 Parent Letter Stockade Tuesday', '11-29-11-parent-letter-stockade-tuesday', '', '<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br /><a href=\"images/pdf_files/2011_2012_pdf/letter-11-29-11.pdf\" target=\"_blank\">http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/letter-11-29-11.pdf</a><br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2011_2012_pdf/letter-11-29-11.pdf|600|800}</p>', '', '2', '86', '0', '87', '2011-11-30 21:19:57', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2011-11-30 21:19:57', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '15', '', '', '1', '49', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('372', '506', '10-23-12 Tues & Wed Stockade Letter', '10-23-12-tues-a-wed-stockade-letter', '', '<p> </p>\n<p>If the letter does not show up, use this link</p>\n<p><br />http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/10-23-12.pdf<br /><br />{pdf=http://www.2047.org/newweb/images/pdf_files/2012_2013_pdf/10-23-12.pdf|600|800}</p>', '', '1', '86', '0', '87', '2012-10-24 01:35:55', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2012-10-24 01:35:55', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '15', '', '', '1', '168', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('121', '507', 'Stockade Parent Letter 9/23/09', 'stockade-parent-letter-92309', '', '<p style=\"font-size: 12px\"><font face=\"verdana,geneva\" color=\"#000000\">Dear Parents,</font></p><p><font face=\"verdana,geneva\" style=\"font-size: 12px\" color=\"#000000\">All the boys have been given permission slips over the last couple weeks. Can you send those back ASAP. They not only give us the required emergency contact information but also the T-Shirt information. The T-Shirt order will be sent in approx. 2 weeks. If you need another permission slip see me at Stockade, call, or print one from the website.</font></p><p><font face=\"verdana,geneva\" style=\"font-size: 12px\" color=\"#000000\">When there is a handout it will also be posted online. If your boy misses the week there is a handout check the website.</font></p><p><font face=\"verdana,geneva\" style=\"font-size: 12px\" color=\"#000000\">There have been numerous questions on friends coming to visit Stockade and if it is allowed. Boys can invite their friends to the regular meetings anytime, visitors are always welcome. We will obtain the contact info on the visitor and send the parents information on Stockade. Visitors are not able to attend All-Nighters, Stockarama Camping weekend or an activity when traveling is required unless they receive permission from me ahead of time.</font></p><p><font face=\"verdana,geneva\" style=\"font-size: 12px\" color=\"#000000\">If you ever have any questions please feel free to contact me at 662-0335, jim@2047.org or see me at Stockade.</font></p><p><font face=\"verdana,geneva\" style=\"font-size: 12px\" color=\"#000000\">Sincerely,<br />Jim Szczodrowski<br />Chairman - Brigade #2047</font></p><p>&nbsp;</p><p>&nbsp;</p><h1 align=\"center\"><font color=\"#0000ff\">Stockade Movie Night<br />Saturday, September 26th, 7 - 9pm<br /></font></h1><h3 align=\"center\"><font color=\"#0000ff\">Weather permitting we will be outside.<br />Otherwise we will be in the gym</font></h3><h1 align=\"center\"> </h1>', '', '2', '86', '0', '87', '2009-09-23 11:19:58', '242', '', '2013-09-22 02:43:58', '242', '0', '0000-00-00 00:00:00', '2009-09-23 11:19:58', '0000-00-00 00:00:00', '', '', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}', '1', '0', '16', '', '', '1', '1140', '{\"robots\":\"\",\"author\":\"\"}', '0', '*', ''),
('681', '508', 'Welcome to #2047', 'welcome-to-2047', '', '<div align=\"center\"> </div>\r\n<p> </p>\r\n<p style=\"text-align: center;\"><img src=\"images/stories/13-14_artwork_specific/splash-screen-13-14-no-dates-no-tc-v1.gif\" border=\"0\" alt=\"\" /></p>\r\n<div style=\"color: #ff0000; text-align: justify;\" align=\"center\">\r\n<p> </p>\r\n</div>\r\n<div style=\"text-align: justify;\" align=\"center\"> </div>\r\n<div style=\"text-align: justify;\" align=\"center\"><strong>Christian Service Brigade #2047</strong> is a boys and teens group from the Wesleyan Church of Orchard Park. Brigade #2047 has been active in Orchard Park since 1963 and is comprised of several age specific groups.</div>\r\n<div align=\"center\"> </div>\r\n<div align=\"center\"> </div>\r\n<p><strong><br /></strong><img src=\"images/stories/drew_mud.jpg\" border=\"0\" alt=\"drew&amp;brian\" width=\"92\" height=\"117\" style=\"margin: 0px 10px; float: left;\" /><a href=\"index.php?option=com_content&amp;view=section&amp;layout=blog&amp;id=7&amp;Itemid=55\"><strong>Tree Climbers</strong></a>(Wednesdays 7-8:30pm) is a Father/Son group for boys aged 6 - 7.</p>\r\n<ul>\r\n<li>Fathers and sons spend time in games, crafts, verse memorizing and story time.</li>\r\n</ul>\r\n<p><a href=\"index.php?option=com_content&amp;view=section&amp;layout=blog&amp;id=5&amp;Itemid=53\"><strong>Stockade</strong></a>(Wednesdays 7-8:30pm) is a group for 8 - 12 year old boys</p>\r\n<p>An active group aimed at the junior age boy.</p>\r\n<blockquote>\r\n<blockquote>\r\n<ul>\r\n<li>Boys have a structured and organized meeting time of games, post time (small groups), crafts, special events and story circle</li>\r\n<li>Stockade also takes part in many extra activities which include, overnights, game nights, camping trips, pinewood derby, reptile night, Summer Camp and others!</li>\r\n</ul>\r\n</blockquote>\r\n</blockquote>\r\n<p><a href=\"index.php?option=com_content&amp;view=section&amp;layout=blog&amp;id=6&amp;Itemid=54\"><strong>Battalion</strong></a>(Mondays 7-8:30pm) is a group for young men aged 12 - 14.</p>\r\n<ul>\r\n<li>A group whose purpose is to build leadership capabilities in today\'s teen.</li>\r\n<li>An organized and structured weekly meeting where teens are given leadership responsibilities.</li>\r\n<li>Games, Squad Meeting (small groups), Captain\'s Special and Council Ring make up the weekly meeting.</li>\r\n<li>Special activities consist of overnights, camping, canoe trips, rocket cars to name a few. In the past Battalion has also made their own wood strip canoes for our yearly canoe trips.</li>\r\n</ul>\r\n<p>There is additional information on CSB #2047, the Leaders, Yearly &amp; Weekly Schedule, etc.</p>\r\n<p>If you have any questions, please use the contact link or see one of the leaders at any of the weekly meetings.</p>', '', '1', '0', '0', '104', '2013-09-22 02:46:29', '242', '', '2013-09-23 15:02:57', '242', '0', '0000-00-00 00:00:00', '2013-09-22 02:46:29', '0000-00-00 00:00:00', '{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}', '{\"urla\":false,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":false,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":false,\"urlctext\":\"\",\"targetc\":\"\"}', '{\"show_title\":\"0\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}', '2', '0', '0', '', '', '1', '0', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '0', '*', '');

DROP TABLE IF EXISTS `tkt_content_frontpage`;
CREATE TABLE `tkt_content_frontpage` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`content_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO tkt_content_frontpage
(`content_id`, `ordering`) VALUES 
('8', '3'),
('35', '7'),
('24', '1'),
('50', '5'),
('368', '8'),
('296', '6'),
('244', '33'),
('204', '35'),
('235', '23'),
('207', '12'),
('74', '18'),
('141', '37'),
('102', '38'),
('299', '20'),
('387', '9'),
('377', '11'),
('342', '15'),
('341', '16'),
('60', '4'),
('347', '14'),
('324', '17'),
('298', '21'),
('260', '27'),
('297', '22'),
('323', '19'),
('380', '10'),
('290', '24'),
('361', '13'),
('245', '32'),
('286', '26'),
('172', '36'),
('257', '28'),
('255', '29'),
('248', '31'),
('267', '30'),
('402', '2'),
('287', '25'),
('242', '34');

DROP TABLE IF EXISTS `tkt_content_rating`;
CREATE TABLE `tkt_content_rating` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `rating_sum` int(10) unsigned NOT NULL DEFAULT '0',
  `rating_count` int(10) unsigned NOT NULL DEFAULT '0',
  `lastip` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`content_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_core_log_searches`;
CREATE TABLE `tkt_core_log_searches` (
  `search_term` varchar(128) NOT NULL DEFAULT '',
  `hits` int(10) unsigned NOT NULL DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_extensions`;
CREATE TABLE `tkt_extensions` (
  `extension_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `type` varchar(20) NOT NULL,
  `element` varchar(100) NOT NULL,
  `folder` varchar(100) NOT NULL,
  `client_id` tinyint(3) NOT NULL,
  `enabled` tinyint(3) NOT NULL DEFAULT '1',
  `access` int(10) unsigned NOT NULL DEFAULT '1',
  `protected` tinyint(3) NOT NULL DEFAULT '0',
  `manifest_cache` text NOT NULL,
  `params` text NOT NULL,
  `custom_data` text NOT NULL,
  `system_data` text NOT NULL,
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) DEFAULT '0',
  `state` int(11) DEFAULT '0',
  PRIMARY KEY (`extension_id`),
  KEY `element_clientid` (`element`,`client_id`),
  KEY `element_folder_clientid` (`element`,`folder`,`client_id`),
  KEY `extension` (`type`,`element`,`folder`,`client_id`)
) ENGINE=MyISAM AUTO_INCREMENT=10047 DEFAULT CHARSET=utf8;

INSERT INTO tkt_extensions
(`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES 
('1', 'com_mailto', 'component', 'com_mailto', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_mailto\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_MAILTO_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('2', 'com_wrapper', 'component', 'com_wrapper', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_wrapper\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_WRAPPER_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('3', 'com_admin', 'component', 'com_admin', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_admin\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_ADMIN_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('4', 'com_banners', 'component', 'com_banners', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"com_banners\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_BANNERS_XML_DESCRIPTION\",\"group\":\"\"}', '{\"purchase_type\":\"3\",\"track_impressions\":\"0\",\"track_clicks\":\"0\",\"metakey_prefix\":\"\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('5', 'com_cache', 'component', 'com_cache', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_cache\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_CACHE_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('6', 'com_categories', 'component', 'com_categories', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_categories\",\"type\":\"component\",\"creationDate\":\"December 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('7', 'com_checkin', 'component', 'com_checkin', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_checkin\",\"type\":\"component\",\"creationDate\":\"Unknown\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2008 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_CHECKIN_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('8', 'com_contact', 'component', 'com_contact', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"com_contact\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_CONTACT_XML_DESCRIPTION\",\"group\":\"\"}', '{\"show_contact_category\":\"hide\",\"show_contact_list\":\"0\",\"presentation_style\":\"sliders\",\"show_name\":\"1\",\"show_position\":\"1\",\"show_email\":\"0\",\"show_street_address\":\"1\",\"show_suburb\":\"1\",\"show_state\":\"1\",\"show_postcode\":\"1\",\"show_country\":\"1\",\"show_telephone\":\"1\",\"show_mobile\":\"1\",\"show_fax\":\"1\",\"show_webpage\":\"1\",\"show_misc\":\"1\",\"show_image\":\"1\",\"image\":\"\",\"allow_vcard\":\"0\",\"show_articles\":\"0\",\"show_profile\":\"0\",\"show_links\":\"0\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"contact_icons\":\"0\",\"icon_address\":\"\",\"icon_email\":\"\",\"icon_telephone\":\"\",\"icon_mobile\":\"\",\"icon_fax\":\"\",\"icon_misc\":\"\",\"show_headings\":\"1\",\"show_position_headings\":\"1\",\"show_email_headings\":\"0\",\"show_telephone_headings\":\"1\",\"show_mobile_headings\":\"0\",\"show_fax_headings\":\"0\",\"allow_vcard_headings\":\"0\",\"show_suburb_headings\":\"1\",\"show_state_headings\":\"1\",\"show_country_headings\":\"1\",\"show_email_form\":\"1\",\"show_email_copy\":\"1\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"1\",\"custom_reply\":\"0\",\"redirect\":\"\",\"show_category_crumb\":\"0\",\"metakey\":\"\",\"metadesc\":\"\",\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('9', 'com_cpanel', 'component', 'com_cpanel', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_cpanel\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_CPANEL_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10', 'com_installer', 'component', 'com_installer', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_installer\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_INSTALLER_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('11', 'com_languages', 'component', 'com_languages', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_languages\",\"type\":\"component\",\"creationDate\":\"2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_LANGUAGES_XML_DESCRIPTION\",\"group\":\"\"}', '{\"administrator\":\"en-GB\",\"site\":\"en-GB\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('12', 'com_login', 'component', 'com_login', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_login\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_LOGIN_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('13', 'com_media', 'component', 'com_media', '', '1', '1', '0', '1', '{\"legacy\":false,\"name\":\"com_media\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_MEDIA_XML_DESCRIPTION\",\"group\":\"\"}', '{\"upload_extensions\":\"bmp,csv,doc,gif,ico,jpg,jpeg,odg,odp,ods,odt,pdf,png,ppt,swf,txt,xcf,xls,BMP,CSV,DOC,GIF,ICO,JPG,JPEG,ODG,ODP,ODS,ODT,PDF,PNG,PPT,SWF,TXT,XCF,XLS\",\"upload_maxsize\":\"10\",\"file_path\":\"images\",\"image_path\":\"images\",\"restrict_uploads\":\"1\",\"allowed_media_usergroup\":\"3\",\"check_mime\":\"1\",\"image_extensions\":\"bmp,gif,jpg,png\",\"ignore_extensions\":\"\",\"upload_mime\":\"image\\/jpeg,image\\/gif,image\\/png,image\\/bmp,application\\/x-shockwave-flash,application\\/msword,application\\/excel,application\\/pdf,application\\/powerpoint,text\\/plain,application\\/x-zip\",\"upload_mime_illegal\":\"text\\/html\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('14', 'com_menus', 'component', 'com_menus', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_menus\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_MENUS_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('15', 'com_messages', 'component', 'com_messages', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_messages\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_MESSAGES_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('16', 'com_modules', 'component', 'com_modules', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_modules\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_MODULES_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('17', 'com_newsfeeds', 'component', 'com_newsfeeds', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"com_newsfeeds\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_NEWSFEEDS_XML_DESCRIPTION\",\"group\":\"\"}', '{\"show_feed_image\":\"1\",\"show_feed_description\":\"1\",\"show_item_description\":\"1\",\"feed_word_count\":\"0\",\"show_headings\":\"1\",\"show_name\":\"1\",\"show_articles\":\"0\",\"show_link\":\"1\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"display_num\":\"\",\"show_pagination_limit\":\"1\",\"show_pagination\":\"1\",\"show_pagination_results\":\"1\",\"show_cat_items\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('18', 'com_plugins', 'component', 'com_plugins', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_plugins\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_PLUGINS_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('19', 'com_search', 'component', 'com_search', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_search\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_SEARCH_XML_DESCRIPTION\",\"group\":\"\"}', '{\"enabled\":\"0\",\"show_date\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('20', 'com_templates', 'component', 'com_templates', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"com_templates\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_TEMPLATES_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('21', 'com_weblinks', 'component', 'com_weblinks', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"com_weblinks\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}', '{\"show_comp_description\":\"1\",\"comp_description\":\"\",\"show_link_hits\":\"1\",\"show_link_description\":\"1\",\"show_other_cats\":\"0\",\"show_headings\":\"0\",\"show_numbers\":\"0\",\"show_report\":\"1\",\"count_clicks\":\"1\",\"target\":\"0\",\"link_icons\":\"\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('22', 'com_content', 'component', 'com_content', '', '1', '1', '0', '1', '{\"legacy\":false,\"name\":\"com_content\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_CONTENT_XML_DESCRIPTION\",\"group\":\"\"}', '{\"article_layout\":\"_:default\",\"show_title\":\"1\",\"link_titles\":\"1\",\"show_intro\":\"1\",\"show_category\":\"1\",\"link_category\":\"1\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"1\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"1\",\"show_item_navigation\":\"1\",\"show_vote\":\"0\",\"show_readmore\":\"1\",\"show_readmore_title\":\"1\",\"readmore_limit\":\"100\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"1\",\"show_hits\":\"1\",\"show_noauth\":\"0\",\"show_publishing_options\":\"1\",\"show_article_options\":\"1\",\"show_urls_images_frontend\":\"0\",\"show_urls_images_backend\":\"1\",\"targeta\":0,\"targetb\":0,\"targetc\":0,\"float_intro\":\"left\",\"float_fulltext\":\"left\",\"category_layout\":\"_:blog\",\"show_category_title\":\"0\",\"show_description\":\"0\",\"show_description_image\":\"0\",\"maxLevel\":\"1\",\"show_empty_categories\":\"0\",\"show_no_articles\":\"1\",\"show_subcat_desc\":\"1\",\"show_cat_num_articles\":\"0\",\"show_base_description\":\"1\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"0\",\"show_subcat_desc_cat\":\"1\",\"show_cat_num_articles_cat\":\"1\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"0\",\"show_subcategory_content\":\"0\",\"show_pagination_limit\":\"1\",\"filter_field\":\"hide\",\"show_headings\":\"1\",\"list_show_date\":\"0\",\"date_format\":\"\",\"list_show_hits\":\"1\",\"list_show_author\":\"1\",\"orderby_pri\":\"order\",\"orderby_sec\":\"rdate\",\"order_date\":\"published\",\"show_pagination\":\"2\",\"show_pagination_results\":\"1\",\"show_feed_link\":\"1\",\"feed_summary\":\"0\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('23', 'com_config', 'component', 'com_config', '', '1', '1', '0', '1', '{\"legacy\":false,\"name\":\"com_config\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_CONFIG_XML_DESCRIPTION\",\"group\":\"\"}', '{\"filters\":{\"1\":{\"filter_type\":\"NH\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"6\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"7\":{\"filter_type\":\"NONE\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"2\":{\"filter_type\":\"NH\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"3\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"4\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"5\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"10\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"12\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"8\":{\"filter_type\":\"NONE\",\"filter_tags\":\"\",\"filter_attributes\":\"\"}}}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('24', 'com_redirect', 'component', 'com_redirect', '', '1', '1', '0', '1', '{\"legacy\":false,\"name\":\"com_redirect\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_REDIRECT_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('25', 'com_users', 'component', 'com_users', '', '1', '1', '0', '1', '{\"legacy\":false,\"name\":\"com_users\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_USERS_XML_DESCRIPTION\",\"group\":\"\"}', '{\"allowUserRegistration\":\"1\",\"new_usertype\":\"2\",\"guest_usergroup\":\"1\",\"sendpassword\":\"1\",\"useractivation\":\"2\",\"mail_to_admin\":\"1\",\"captcha\":\"\",\"frontend_userparams\":\"1\",\"site_language\":\"0\",\"change_login_name\":\"0\",\"reset_count\":\"10\",\"reset_time\":\"1\",\"mailSubjectPrefix\":\"\",\"mailBodySuffix\":\"\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('27', 'com_finder', 'component', 'com_finder', '', '1', '1', '0', '0', '{\"legacy\":false,\"name\":\"com_finder\",\"type\":\"component\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_FINDER_XML_DESCRIPTION\",\"group\":\"\"}', '{\"show_description\":\"1\",\"description_length\":255,\"allow_empty_query\":\"0\",\"show_url\":\"1\",\"show_advanced\":\"1\",\"expand_advanced\":\"0\",\"show_date_filters\":\"0\",\"highlight_terms\":\"1\",\"opensearch_name\":\"\",\"opensearch_description\":\"\",\"batch_size\":\"50\",\"memory_table_limit\":30000,\"title_multiplier\":\"1.7\",\"text_multiplier\":\"0.7\",\"meta_multiplier\":\"1.2\",\"path_multiplier\":\"2.0\",\"misc_multiplier\":\"0.3\",\"stemmer\":\"snowball\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('28', 'com_joomlaupdate', 'component', 'com_joomlaupdate', '', '1', '1', '0', '1', '{\"legacy\":false,\"name\":\"com_joomlaupdate\",\"type\":\"component\",\"creationDate\":\"February 2012\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_JOOMLAUPDATE_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('100', 'PHPMailer', 'library', 'phpmailer', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"PHPMailer\",\"type\":\"library\",\"creationDate\":\"2001\",\"author\":\"PHPMailer\",\"copyright\":\"(c) 2001-2003, Brent R. Matzelle, (c) 2004-2009, Andy Prevost. All Rights Reserved., (c) 2010-2011, Jim Jagielski. All Rights Reserved.\",\"authorEmail\":\"jimjag@gmail.com\",\"authorUrl\":\"https:\\/\\/code.google.com\\/a\\/apache-extras.org\\/p\\/phpmailer\\/\",\"version\":\"5.2\",\"description\":\"LIB_PHPMAILER_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('101', 'SimplePie', 'library', 'simplepie', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"SimplePie\",\"type\":\"library\",\"creationDate\":\"2004\",\"author\":\"SimplePie\",\"copyright\":\"Copyright (c) 2004-2009, Ryan Parman and Geoffrey Sneddon\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/simplepie.org\\/\",\"version\":\"1.2\",\"description\":\"LIB_SIMPLEPIE_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('102', 'phputf8', 'library', 'phputf8', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"phputf8\",\"type\":\"library\",\"creationDate\":\"2006\",\"author\":\"Harry Fuecks\",\"copyright\":\"Copyright various authors\",\"authorEmail\":\"hfuecks@gmail.com\",\"authorUrl\":\"http:\\/\\/sourceforge.net\\/projects\\/phputf8\",\"version\":\"0.5\",\"description\":\"LIB_PHPUTF8_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('103', 'Joomla! Platform', 'library', 'joomla', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"Joomla! Platform\",\"type\":\"library\",\"creationDate\":\"2008\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"http:\\/\\/www.joomla.org\",\"version\":\"11.4\",\"description\":\"LIB_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('200', 'mod_articles_archive', 'module', 'mod_articles_archive', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_articles_archive\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters.\\n\\t\\tAll rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_ARTICLES_ARCHIVE_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('201', 'mod_articles_latest', 'module', 'mod_articles_latest', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_articles_latest\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_LATEST_NEWS_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('202', 'mod_articles_popular', 'module', 'mod_articles_popular', '', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_articles_popular\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_POPULAR_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('203', 'mod_banners', 'module', 'mod_banners', '', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_banners\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_BANNERS_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('204', 'mod_breadcrumbs', 'module', 'mod_breadcrumbs', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_breadcrumbs\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_BREADCRUMBS_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('205', 'mod_custom', 'module', 'mod_custom', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_custom\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_CUSTOM_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('206', 'mod_feed', 'module', 'mod_feed', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_feed\",\"type\":\"module\",\"creationDate\":\"July 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_FEED_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('207', 'mod_footer', 'module', 'mod_footer', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_footer\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_FOOTER_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('208', 'mod_login', 'module', 'mod_login', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_login\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_LOGIN_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('209', 'mod_menu', 'module', 'mod_menu', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_menu\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_MENU_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('210', 'mod_articles_news', 'module', 'mod_articles_news', '', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_articles_news\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_ARTICLES_NEWS_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('211', 'mod_random_image', 'module', 'mod_random_image', '', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_random_image\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_RANDOM_IMAGE_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('212', 'mod_related_items', 'module', 'mod_related_items', '', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_related_items\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_RELATED_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('213', 'mod_search', 'module', 'mod_search', '', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_search\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_SEARCH_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('214', 'mod_stats', 'module', 'mod_stats', '', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_stats\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_STATS_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('215', 'mod_syndicate', 'module', 'mod_syndicate', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_syndicate\",\"type\":\"module\",\"creationDate\":\"May 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_SYNDICATE_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('216', 'mod_users_latest', 'module', 'mod_users_latest', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_users_latest\",\"type\":\"module\",\"creationDate\":\"December 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_USERS_LATEST_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('217', 'mod_weblinks', 'module', 'mod_weblinks', '', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_weblinks\",\"type\":\"module\",\"creationDate\":\"July 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('218', 'mod_whosonline', 'module', 'mod_whosonline', '', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_whosonline\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_WHOSONLINE_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0');

INSERT INTO tkt_extensions
(`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES 
('219', 'mod_wrapper', 'module', 'mod_wrapper', '', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_wrapper\",\"type\":\"module\",\"creationDate\":\"October 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_WRAPPER_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('220', 'mod_articles_category', 'module', 'mod_articles_category', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_articles_category\",\"type\":\"module\",\"creationDate\":\"February 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_ARTICLES_CATEGORY_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('221', 'mod_articles_categories', 'module', 'mod_articles_categories', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_articles_categories\",\"type\":\"module\",\"creationDate\":\"February 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_ARTICLES_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('222', 'mod_languages', 'module', 'mod_languages', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_languages\",\"type\":\"module\",\"creationDate\":\"February 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_LANGUAGES_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('223', 'mod_finder', 'module', 'mod_finder', '', '0', '1', '0', '0', '{\"legacy\":false,\"name\":\"mod_finder\",\"type\":\"module\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_FINDER_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('300', 'mod_custom', 'module', 'mod_custom', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_custom\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_CUSTOM_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('301', 'mod_feed', 'module', 'mod_feed', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_feed\",\"type\":\"module\",\"creationDate\":\"July 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_FEED_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('302', 'mod_latest', 'module', 'mod_latest', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_latest\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_LATEST_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('303', 'mod_logged', 'module', 'mod_logged', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_logged\",\"type\":\"module\",\"creationDate\":\"January 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_LOGGED_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('304', 'mod_login', 'module', 'mod_login', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_login\",\"type\":\"module\",\"creationDate\":\"March 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_LOGIN_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('305', 'mod_menu', 'module', 'mod_menu', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_menu\",\"type\":\"module\",\"creationDate\":\"March 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_MENU_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('307', 'mod_popular', 'module', 'mod_popular', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_popular\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_POPULAR_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('308', 'mod_quickicon', 'module', 'mod_quickicon', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_quickicon\",\"type\":\"module\",\"creationDate\":\"Nov 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_QUICKICON_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('309', 'mod_status', 'module', 'mod_status', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_status\",\"type\":\"module\",\"creationDate\":\"Feb 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_STATUS_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('310', 'mod_submenu', 'module', 'mod_submenu', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_submenu\",\"type\":\"module\",\"creationDate\":\"Feb 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_SUBMENU_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('311', 'mod_title', 'module', 'mod_title', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_title\",\"type\":\"module\",\"creationDate\":\"Nov 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_TITLE_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('312', 'mod_toolbar', 'module', 'mod_toolbar', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"mod_toolbar\",\"type\":\"module\",\"creationDate\":\"Nov 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_TOOLBAR_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('313', 'mod_multilangstatus', 'module', 'mod_multilangstatus', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_multilangstatus\",\"type\":\"module\",\"creationDate\":\"September 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_MULTILANGSTATUS_XML_DESCRIPTION\",\"group\":\"\"}', '{\"cache\":\"0\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('314', 'mod_version', 'module', 'mod_version', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"mod_version\",\"type\":\"module\",\"creationDate\":\"January 2012\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_VERSION_XML_DESCRIPTION\",\"group\":\"\"}', '{\"format\":\"short\",\"product\":\"1\",\"cache\":\"0\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('400', 'plg_authentication_gmail', 'plugin', 'gmail', 'authentication', '0', '0', '1', '0', '{\"legacy\":false,\"name\":\"plg_authentication_gmail\",\"type\":\"plugin\",\"creationDate\":\"February 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_GMAIL_XML_DESCRIPTION\",\"group\":\"\"}', '{\"applysuffix\":\"0\",\"suffix\":\"\",\"verifypeer\":\"1\",\"user_blacklist\":\"\"}', '', '', '0', '0000-00-00 00:00:00', '1', '0'),
('401', 'plg_authentication_joomla', 'plugin', 'joomla', 'authentication', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_authentication_joomla\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_AUTH_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('402', 'plg_authentication_ldap', 'plugin', 'ldap', 'authentication', '0', '0', '1', '0', '{\"legacy\":false,\"name\":\"plg_authentication_ldap\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_LDAP_XML_DESCRIPTION\",\"group\":\"\"}', '{\"host\":\"\",\"port\":\"389\",\"use_ldapV3\":\"0\",\"negotiate_tls\":\"0\",\"no_referrals\":\"0\",\"auth_method\":\"bind\",\"base_dn\":\"\",\"search_string\":\"\",\"users_dn\":\"\",\"username\":\"admin\",\"password\":\"bobby7\",\"ldap_fullname\":\"fullName\",\"ldap_email\":\"mail\",\"ldap_uid\":\"uid\"}', '', '', '0', '0000-00-00 00:00:00', '3', '0'),
('404', 'plg_content_emailcloak', 'plugin', 'emailcloak', 'content', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_content_emailcloak\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_CONTENT_EMAILCLOAK_XML_DESCRIPTION\",\"group\":\"\"}', '{\"mode\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '1', '0'),
('405', 'plg_content_geshi', 'plugin', 'geshi', 'content', '0', '0', '1', '0', '{\"legacy\":false,\"name\":\"plg_content_geshi\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"\",\"authorUrl\":\"qbnz.com\\/highlighter\",\"version\":\"2.5.0\",\"description\":\"PLG_CONTENT_GESHI_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '2', '0'),
('406', 'plg_content_loadmodule', 'plugin', 'loadmodule', 'content', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_content_loadmodule\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_LOADMODULE_XML_DESCRIPTION\",\"group\":\"\"}', '{\"style\":\"xhtml\"}', '', '', '0', '2011-09-18 15:22:50', '0', '0'),
('407', 'plg_content_pagebreak', 'plugin', 'pagebreak', 'content', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_content_pagebreak\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_CONTENT_PAGEBREAK_XML_DESCRIPTION\",\"group\":\"\"}', '{\"title\":\"1\",\"multipage_toc\":\"1\",\"showall\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '4', '0'),
('408', 'plg_content_pagenavigation', 'plugin', 'pagenavigation', 'content', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_content_pagenavigation\",\"type\":\"plugin\",\"creationDate\":\"January 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_PAGENAVIGATION_XML_DESCRIPTION\",\"group\":\"\"}', '{\"position\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '5', '0'),
('409', 'plg_content_vote', 'plugin', 'vote', 'content', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_content_vote\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_VOTE_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '6', '0'),
('410', 'plg_editors_codemirror', 'plugin', 'codemirror', 'editors', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_editors_codemirror\",\"type\":\"plugin\",\"creationDate\":\"28 March 2011\",\"author\":\"Marijn Haverbeke\",\"copyright\":\"\",\"authorEmail\":\"N\\/A\",\"authorUrl\":\"\",\"version\":\"1.0\",\"description\":\"PLG_CODEMIRROR_XML_DESCRIPTION\",\"group\":\"\"}', '{\"linenumbers\":\"0\",\"tabmode\":\"indent\"}', '', '', '0', '0000-00-00 00:00:00', '1', '0'),
('411', 'plg_editors_none', 'plugin', 'none', 'editors', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_editors_none\",\"type\":\"plugin\",\"creationDate\":\"August 2004\",\"author\":\"Unknown\",\"copyright\":\"\",\"authorEmail\":\"N\\/A\",\"authorUrl\":\"\",\"version\":\"2.5.0\",\"description\":\"PLG_NONE_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '2', '0'),
('412', 'plg_editors_tinymce', 'plugin', 'tinymce', 'editors', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_editors_tinymce\",\"type\":\"plugin\",\"creationDate\":\"2005-2013\",\"author\":\"Moxiecode Systems AB\",\"copyright\":\"Moxiecode Systems AB\",\"authorEmail\":\"N\\/A\",\"authorUrl\":\"tinymce.moxiecode.com\\/\",\"version\":\"3.5.4.1\",\"description\":\"PLG_TINY_XML_DESCRIPTION\",\"group\":\"\"}', '{\"mode\":\"1\",\"skin\":\"0\",\"entity_encoding\":\"raw\",\"lang_mode\":\"0\",\"lang_code\":\"en\",\"text_direction\":\"ltr\",\"content_css\":\"1\",\"content_css_custom\":\"\",\"relative_urls\":\"1\",\"newlines\":\"0\",\"invalid_elements\":\"script,applet,iframe\",\"extended_elements\":\"\",\"toolbar\":\"top\",\"toolbar_align\":\"left\",\"html_height\":\"550\",\"html_width\":\"750\",\"resizing\":\"true\",\"resize_horizontal\":\"false\",\"element_path\":\"1\",\"fonts\":\"1\",\"paste\":\"1\",\"searchreplace\":\"1\",\"insertdate\":\"1\",\"format_date\":\"%Y-%m-%d\",\"inserttime\":\"1\",\"format_time\":\"%H:%M:%S\",\"colors\":\"1\",\"table\":\"1\",\"smilies\":\"1\",\"media\":\"1\",\"hr\":\"1\",\"directionality\":\"1\",\"fullscreen\":\"1\",\"style\":\"1\",\"layer\":\"1\",\"xhtmlxtras\":\"1\",\"visualchars\":\"1\",\"nonbreaking\":\"1\",\"template\":\"1\",\"blockquote\":\"1\",\"wordcount\":\"1\",\"advimage\":\"1\",\"advlink\":\"1\",\"advlist\":\"1\",\"autosave\":\"1\",\"contextmenu\":\"1\",\"inlinepopups\":\"1\",\"custom_plugin\":\"\",\"custom_button\":\"\"}', '', '', '0', '0000-00-00 00:00:00', '3', '0'),
('413', 'plg_editors-xtd_article', 'plugin', 'article', 'editors-xtd', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_editors-xtd_article\",\"type\":\"plugin\",\"creationDate\":\"October 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_ARTICLE_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '1', '0'),
('414', 'plg_editors-xtd_image', 'plugin', 'image', 'editors-xtd', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_editors-xtd_image\",\"type\":\"plugin\",\"creationDate\":\"August 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_IMAGE_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '2', '0'),
('415', 'plg_editors-xtd_pagebreak', 'plugin', 'pagebreak', 'editors-xtd', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_editors-xtd_pagebreak\",\"type\":\"plugin\",\"creationDate\":\"August 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_EDITORSXTD_PAGEBREAK_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '3', '0'),
('416', 'plg_editors-xtd_readmore', 'plugin', 'readmore', 'editors-xtd', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_editors-xtd_readmore\",\"type\":\"plugin\",\"creationDate\":\"March 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_READMORE_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '4', '0'),
('417', 'plg_search_categories', 'plugin', 'categories', 'search', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_search_categories\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SEARCH_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}', '{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('418', 'plg_search_contacts', 'plugin', 'contacts', 'search', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_search_contacts\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SEARCH_CONTACTS_XML_DESCRIPTION\",\"group\":\"\"}', '{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('419', 'plg_search_content', 'plugin', 'content', 'search', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_search_content\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SEARCH_CONTENT_XML_DESCRIPTION\",\"group\":\"\"}', '{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('420', 'plg_search_newsfeeds', 'plugin', 'newsfeeds', 'search', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_search_newsfeeds\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SEARCH_NEWSFEEDS_XML_DESCRIPTION\",\"group\":\"\"}', '{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('421', 'plg_search_weblinks', 'plugin', 'weblinks', 'search', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_search_weblinks\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SEARCH_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}', '{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('422', 'plg_system_languagefilter', 'plugin', 'languagefilter', 'system', '0', '0', '1', '1', '{\"legacy\":false,\"name\":\"plg_system_languagefilter\",\"type\":\"plugin\",\"creationDate\":\"July 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SYSTEM_LANGUAGEFILTER_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '1', '0'),
('423', 'plg_system_p3p', 'plugin', 'p3p', 'system', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_system_p3p\",\"type\":\"plugin\",\"creationDate\":\"September 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_P3P_XML_DESCRIPTION\",\"group\":\"\"}', '{\"headers\":\"NOI ADM DEV PSAi COM NAV OUR OTRo STP IND DEM\"}', '', '', '0', '0000-00-00 00:00:00', '2', '0'),
('424', 'plg_system_cache', 'plugin', 'cache', 'system', '0', '0', '1', '1', '{\"legacy\":false,\"name\":\"plg_system_cache\",\"type\":\"plugin\",\"creationDate\":\"February 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_CACHE_XML_DESCRIPTION\",\"group\":\"\"}', '{\"browsercache\":\"0\",\"cachetime\":\"15\"}', '', '', '0', '0000-00-00 00:00:00', '9', '0'),
('425', 'plg_system_debug', 'plugin', 'debug', 'system', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_system_debug\",\"type\":\"plugin\",\"creationDate\":\"December 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_DEBUG_XML_DESCRIPTION\",\"group\":\"\"}', '{\"profile\":\"1\",\"queries\":\"1\",\"memory\":\"1\",\"language_files\":\"1\",\"language_strings\":\"1\",\"strip-first\":\"1\",\"strip-prefix\":\"\",\"strip-suffix\":\"\"}', '', '', '0', '0000-00-00 00:00:00', '4', '0'),
('426', 'plg_system_log', 'plugin', 'log', 'system', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_system_log\",\"type\":\"plugin\",\"creationDate\":\"April 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_LOG_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '5', '0'),
('427', 'plg_system_redirect', 'plugin', 'redirect', 'system', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_system_redirect\",\"type\":\"plugin\",\"creationDate\":\"April 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_REDIRECT_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '6', '0'),
('428', 'plg_system_remember', 'plugin', 'remember', 'system', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_system_remember\",\"type\":\"plugin\",\"creationDate\":\"April 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_REMEMBER_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '7', '0'),
('429', 'plg_system_sef', 'plugin', 'sef', 'system', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_system_sef\",\"type\":\"plugin\",\"creationDate\":\"December 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SEF_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '8', '0'),
('430', 'plg_system_logout', 'plugin', 'logout', 'system', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_system_logout\",\"type\":\"plugin\",\"creationDate\":\"April 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SYSTEM_LOGOUT_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '3', '0'),
('431', 'plg_user_contactcreator', 'plugin', 'contactcreator', 'user', '0', '0', '1', '1', '{\"legacy\":false,\"name\":\"plg_user_contactcreator\",\"type\":\"plugin\",\"creationDate\":\"August 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_CONTACTCREATOR_XML_DESCRIPTION\",\"group\":\"\"}', '{\"autowebpage\":\"\",\"category\":\"34\",\"autopublish\":\"0\"}', '', '', '0', '0000-00-00 00:00:00', '1', '0');

INSERT INTO tkt_extensions
(`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES 
('432', 'plg_user_joomla', 'plugin', 'joomla', 'user', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_user_joomla\",\"type\":\"plugin\",\"creationDate\":\"December 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2009 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_USER_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}', '{\"autoregister\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '2', '0'),
('433', 'plg_user_profile', 'plugin', 'profile', 'user', '0', '0', '1', '1', '{\"legacy\":false,\"name\":\"plg_user_profile\",\"type\":\"plugin\",\"creationDate\":\"January 2008\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_USER_PROFILE_XML_DESCRIPTION\",\"group\":\"\"}', '{\"register-require_address1\":\"1\",\"register-require_address2\":\"1\",\"register-require_city\":\"1\",\"register-require_region\":\"1\",\"register-require_country\":\"1\",\"register-require_postal_code\":\"1\",\"register-require_phone\":\"1\",\"register-require_website\":\"1\",\"register-require_favoritebook\":\"1\",\"register-require_aboutme\":\"1\",\"register-require_tos\":\"1\",\"register-require_dob\":\"1\",\"profile-require_address1\":\"1\",\"profile-require_address2\":\"1\",\"profile-require_city\":\"1\",\"profile-require_region\":\"1\",\"profile-require_country\":\"1\",\"profile-require_postal_code\":\"1\",\"profile-require_phone\":\"1\",\"profile-require_website\":\"1\",\"profile-require_favoritebook\":\"1\",\"profile-require_aboutme\":\"1\",\"profile-require_tos\":\"1\",\"profile-require_dob\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('434', 'plg_extension_joomla', 'plugin', 'joomla', 'extension', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_extension_joomla\",\"type\":\"plugin\",\"creationDate\":\"May 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_EXTENSION_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '1', '0'),
('435', 'plg_content_joomla', 'plugin', 'joomla', 'content', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_content_joomla\",\"type\":\"plugin\",\"creationDate\":\"November 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_CONTENT_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('436', 'plg_system_languagecode', 'plugin', 'languagecode', 'system', '0', '0', '1', '0', '{\"legacy\":false,\"name\":\"plg_system_languagecode\",\"type\":\"plugin\",\"creationDate\":\"November 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SYSTEM_LANGUAGECODE_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '10', '0'),
('437', 'plg_quickicon_joomlaupdate', 'plugin', 'joomlaupdate', 'quickicon', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_quickicon_joomlaupdate\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_QUICKICON_JOOMLAUPDATE_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('438', 'plg_quickicon_extensionupdate', 'plugin', 'extensionupdate', 'quickicon', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_quickicon_extensionupdate\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_QUICKICON_EXTENSIONUPDATE_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('439', 'plg_captcha_recaptcha', 'plugin', 'recaptcha', 'captcha', '0', '0', '1', '0', '{\"legacy\":false,\"name\":\"plg_captcha_recaptcha\",\"type\":\"plugin\",\"creationDate\":\"December 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_CAPTCHA_RECAPTCHA_XML_DESCRIPTION\",\"group\":\"\"}', '{\"public_key\":\"\",\"private_key\":\"\",\"theme\":\"clean\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('440', 'plg_system_highlight', 'plugin', 'highlight', 'system', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_system_highlight\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SYSTEM_HIGHLIGHT_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '7', '0'),
('441', 'plg_content_finder', 'plugin', 'finder', 'content', '0', '0', '1', '0', '{\"legacy\":false,\"name\":\"plg_content_finder\",\"type\":\"plugin\",\"creationDate\":\"December 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_CONTENT_FINDER_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('442', 'plg_finder_categories', 'plugin', 'categories', 'finder', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_finder_categories\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_FINDER_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '1', '0'),
('443', 'plg_finder_contacts', 'plugin', 'contacts', 'finder', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_finder_contacts\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_FINDER_CONTACTS_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '2', '0'),
('444', 'plg_finder_content', 'plugin', 'content', 'finder', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_finder_content\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_FINDER_CONTENT_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '3', '0'),
('445', 'plg_finder_newsfeeds', 'plugin', 'newsfeeds', 'finder', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_finder_newsfeeds\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_FINDER_NEWSFEEDS_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '4', '0'),
('446', 'plg_finder_weblinks', 'plugin', 'weblinks', 'finder', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"plg_finder_weblinks\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_FINDER_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '5', '0'),
('500', 'atomic', 'template', 'atomic', '', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"atomic\",\"type\":\"template\",\"creationDate\":\"10\\/10\\/09\",\"author\":\"Ron Severdia\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"contact@kontentdesign.com\",\"authorUrl\":\"http:\\/\\/www.kontentdesign.com\",\"version\":\"2.5.0\",\"description\":\"TPL_ATOMIC_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('502', 'bluestork', 'template', 'bluestork', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"bluestork\",\"type\":\"template\",\"creationDate\":\"07\\/02\\/09\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"TPL_BLUESTORK_XML_DESCRIPTION\",\"group\":\"\"}', '{\"useRoundedCorners\":\"1\",\"showSiteName\":\"0\",\"textBig\":\"0\",\"highContrast\":\"0\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('503', 'beez_20', 'template', 'beez_20', '', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"beez_20\",\"type\":\"template\",\"creationDate\":\"25 November 2009\",\"author\":\"Angie Radtke\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"a.radtke@derauftritt.de\",\"authorUrl\":\"http:\\/\\/www.der-auftritt.de\",\"version\":\"2.5.0\",\"description\":\"TPL_BEEZ2_XML_DESCRIPTION\",\"group\":\"\"}', '{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"sitetitle\":\"\",\"sitedescription\":\"\",\"navposition\":\"center\",\"templatecolor\":\"nature\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('504', 'hathor', 'template', 'hathor', '', '1', '1', '1', '0', '{\"legacy\":false,\"name\":\"hathor\",\"type\":\"template\",\"creationDate\":\"May 2010\",\"author\":\"Andrea Tarr\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"hathor@tarrconsulting.com\",\"authorUrl\":\"http:\\/\\/www.tarrconsulting.com\",\"version\":\"2.5.0\",\"description\":\"TPL_HATHOR_XML_DESCRIPTION\",\"group\":\"\"}', '{\"showSiteName\":\"0\",\"colourChoice\":\"0\",\"boldText\":\"0\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('505', 'beez5', 'template', 'beez5', '', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"beez5\",\"type\":\"template\",\"creationDate\":\"21 May 2010\",\"author\":\"Angie Radtke\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"a.radtke@derauftritt.de\",\"authorUrl\":\"http:\\/\\/www.der-auftritt.de\",\"version\":\"2.5.0\",\"description\":\"TPL_BEEZ5_XML_DESCRIPTION\",\"group\":\"\"}', '{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"sitetitle\":\"\",\"sitedescription\":\"\",\"navposition\":\"center\",\"html5\":\"0\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('600', 'English (United Kingdom)', 'language', 'en-GB', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"English (United Kingdom)\",\"type\":\"language\",\"creationDate\":\"2008-03-15\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.10\",\"description\":\"en-GB site language\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('601', 'English (United Kingdom)', 'language', 'en-GB', '', '1', '1', '1', '1', '{\"legacy\":false,\"name\":\"English (United Kingdom)\",\"type\":\"language\",\"creationDate\":\"2008-03-15\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.10\",\"description\":\"en-GB administrator language\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('700', 'files_joomla', 'file', 'joomla', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"files_joomla\",\"type\":\"file\",\"creationDate\":\"August 2013\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2013 Open Source Matters. All rights reserved\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.14\",\"description\":\"FILES_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('800', 'PKG_JOOMLA', 'package', 'pkg_joomla', '', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"PKG_JOOMLA\",\"type\":\"package\",\"creationDate\":\"2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"http:\\/\\/www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PKG_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}', '', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10000', 'com_gcalendar', 'component', 'com_gcalendar', '', '1', '1', '0', '0', '{\"legacy\":false,\"name\":\"COM_GCALENDAR\",\"type\":\"component\",\"creationDate\":\"Sep 2013\",\"author\":\"G4J Project\",\"copyright\":\"This extension is released under the GNU\\/GPL License.\\n\\t\",\"authorEmail\":\"info@digital-peak.com\",\"authorUrl\":\"g4j.digital-peak.com\",\"version\":\"3.1.5\",\"description\":\"COM_GCALENDAR_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10001', 'MOD_GCALENDAR', 'module', 'mod_gcalendar', '', '0', '1', '0', '0', '{\"legacy\":false,\"name\":\"MOD_GCALENDAR\",\"type\":\"module\",\"creationDate\":\"Sep 2013\",\"author\":\"G4J Project\",\"copyright\":\"This extension is released under the GNU\\/GPL License.\\n\\t\",\"authorEmail\":\"info@digital-peak.com\",\"authorUrl\":\"g4j.digital-peak.com\",\"version\":\"3.1.5\",\"description\":\"MOD_GCALENDAR_XML_DESCRIPTION\",\"group\":\"\"}', '{\"calendarids\":\"\",\"compact_events\":\"2\",\"weekstart\":\"1\",\"titleformat_month\":\"M Y\",\"calendar_height\":\"\",\"event_color\":\"135CAE\",\"theme\":\"\",\"@spacer\":\"\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10002', 'MOD_GCALENDAR_UPCOMING', 'module', 'mod_gcalendar_upcoming', '', '0', '1', '0', '0', '{\"legacy\":false,\"name\":\"MOD_GCALENDAR_UPCOMING\",\"type\":\"module\",\"creationDate\":\"Sep 2013\",\"author\":\"G4J Project\",\"copyright\":\"This extension is released under the GNU\\/GPL License.\\n\\t\",\"authorEmail\":\"info@digital-peak.com\\n\\t\",\"authorUrl\":\"g4j.digital-peak.com\",\"version\":\"3.1.5\",\"description\":\"MOD_GCALENDAR_UPCOMING_XML_DESCRIPTION\",\"group\":\"\"}', '{\"calendarids\":\"\",\"max_events\":\"5\",\"order\":\"1\",\"find\":\"\",\"@spacer\":\"\",\"output\":\"\",\"output_grouping\":\"\",\"start_date\":\"\",\"end_date\":\"\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10003', 'MOD_GCALENDAR_NEXT', 'module', 'mod_gcalendar_next', '', '0', '1', '0', '0', '{\"legacy\":false,\"name\":\"MOD_GCALENDAR_NEXT\",\"type\":\"module\",\"creationDate\":\"Sep 2013\",\"author\":\"G4J Project\",\"copyright\":\"This extension is released under the GNU\\/GPL License.\\n\\t\",\"authorEmail\":\"info@digital-peak.com\\n\\t\",\"authorUrl\":\"g4j.digital-peak.com\",\"version\":\"3.1.5\",\"description\":\"MOD_GCALENDAR_NEXT_XML_DESCRIPTION\",\"group\":\"\"}', '{\"calendarids\":\"\",\"style_parameters\":\"\",\"moduleclass_sfx\":\"\",\"offset\":\"0\",\"output\":\"\",\"past_events\":\"1\",\"output_now\":\"\",\"find\":\"\",\"title_filter\":\".*\",\"max_events\":\"10\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10004', 'plg_search_gcalendar', 'plugin', 'gcalendar', 'search', '0', '0', '1', '0', '{\"legacy\":false,\"name\":\"plg_search_gcalendar\",\"type\":\"plugin\",\"creationDate\":\"Sep 2013\",\"author\":\"G4J Project\",\"copyright\":\"This extension is released under the GNU\\/GPL License.\\n\\t\",\"authorEmail\":\"info@digital-peak.com\\n\\t\",\"authorUrl\":\"g4j.digital-peak.com\",\"version\":\"3.1.5\",\"description\":\"PLG_SEARCH_GCALENDAR_XML_DESCRIPTION\",\"group\":\"\"}', '{\"calendarids\":\"\",\"search_limit\":\"50\",\"pastevents\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10005', 'plg_gcalendar_next', 'plugin', 'gcalendar_next', 'content', '0', '0', '1', '0', '{\"legacy\":false,\"name\":\"plg_gcalendar_next\",\"type\":\"plugin\",\"creationDate\":\"Sep 2013\",\"author\":\"G4J Project\",\"copyright\":\"This extension is released under the GNU\\/GPL License.\\n\\t\",\"authorEmail\":\"info@digital-peak.com\",\"authorUrl\":\"g4j.digital-peak.com\",\"version\":\"3.1.5\",\"description\":\"PLG_GCALENDAR_NEXT_XML_DESCRIPTION\",\"group\":\"\"}', '{\"calendarids\":\"\",\"find\":\"\",\"max_events\":\"2\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10006', 'GCalendar', 'package', 'pkg_GCalendar', '', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"GCalendar\",\"type\":\"package\",\"creationDate\":\"Sep 2013\",\"author\":\"G4J Project\",\"copyright\":\"This extension is released under the GNU\\/GPL License.\",\"authorEmail\":\"info@digital-peak.com\",\"authorUrl\":\"g4j.digital-peak.com\",\"version\":\"3.1.5\",\"description\":\"\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10007', 'com_zweather', 'component', 'com_zweather', '', '1', '1', '0', '0', '{\"legacy\":false,\"name\":\"com_zweather\",\"type\":\"component\",\"creationDate\":\"June 25, 2013\",\"author\":\"Z Content\",\"copyright\":\"(C) 2005 - 2013 Dan Cogliano\\n\\t\",\"authorEmail\":\"dan@zcontent.net\",\"authorUrl\":\"www.zcontent.net\",\"version\":\"8.0.2\",\"description\":\"\\n\\n<div>\\n<h1>Zap Weather<\\/h1>\\n<p>Zap Weather is a component for displaying U.S.A. weather on your Joomla web site. Zap Weather uses data provided by the\\nNational Weather Service.<\\/p>\\n<p>Z Weather is developed and maintained by <a href=\\\"http:\\/\\/zcontent.net\\\" target=\\\"_blank\\\">Z Content<\\/a><\\/p>\\n<\\/div>\\n\\n\\t\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10008', 'Zap Weather', 'module', 'mod_zweather', '', '0', '1', '0', '0', '{\"legacy\":false,\"name\":\"Zap Weather\",\"type\":\"module\",\"creationDate\":\"June 22, 2013\",\"author\":\"Z Content\",\"copyright\":\"Copyright (C) 2006,2007,2008,2009,2010,2011,2012,2013 Dan Cogliano, zcontent.net\",\"authorEmail\":\"dan@zcontent.net\",\"authorUrl\":\"www.zcontent.net\",\"version\":\"8.0.1\",\"description\":\"Display a location\'s weather from a module\",\"group\":\"\"}', '{\"id\":\"\",\"num_periods24\":\"7\",\"num_periods12\":\"6\",\"num_periods3\":\"8\",\"show_observation_title\":\"1\",\"show_observation_time\":\"1\",\"show_observation_weather\":\"1\",\"show_observation_temperature\":\"1\",\"show_observation_wind\":\"1\",\"show_observation_pressure\":\"1\",\"show_observation_dewpoint\":\"1\",\"show_observation_windchill\":\"1\",\"show_observation_relativehumidity\":\"1\",\"show_observation_visibility\":\"1\",\"show_observation_icon\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10009', 'Content - Zap Weather', 'plugin', 'zapweather', 'content', '0', '0', '1', '0', '{\"legacy\":true,\"name\":\"Content - Zap Weather\",\"type\":\"plugin\",\"creationDate\":\"June 22, 2013\",\"author\":\"Z Content\",\"copyright\":\"(C) 2013 Dan Cogliano. All rights reserved.\",\"authorEmail\":\"dan@zcontent.net\",\"authorUrl\":\"www.zcontent.net\",\"version\":\"8.0.1\",\"description\":\"\\n\\t\\n<p>This plugin inserts weather data directly into articles or custom HTML modules using the\\n{zapweather var=$v,loc=$l,index=$k} tag, where:<br\\/>\\n$v = Zap Weather variable,<br\\/>\\n$l = weather location,<br\\/>\\n$index = array index (used for multi-day variables, index 0 is first day).<br\\/>\\nUse the comma character to delimit settings. Visit www.zcontent.net\\nfor more information on this plugin.<\\/p>\\n<p>\\nNotes:<br\\/>\\nThe Zap Weather component must be installed in order to use this plugin.<br\\/>\\nThis plugin must be enabled from the plugin manager screen in order to use it.<br\\/>\\n<\\/p>\\n\\t\\n\\t\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10010', 'zapweather', 'package', 'pkg_zapweather', '', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"Zap Weather Package\",\"type\":\"package\",\"creationDate\":\"June 25, 2013\",\"author\":\"Z Content\",\"copyright\":\"\",\"authorEmail\":\"dan@zcontent.net\",\"authorUrl\":\"www.zcontent.net\",\"version\":\"8.0.2\",\"description\":\"Zap Weather provides U.S.A. weather data for your Joomla site using data from the National Weather Service\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10020', 'jsn_metro_pro', 'template', 'jsn_metro_pro', '', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"jsn_metro_pro\",\"type\":\"template\",\"creationDate\":\"06\\/25\\/2013\",\"author\":\"JoomlaShine.com\",\"copyright\":\"Copyright (c) 2008 - 2013 - JoomlaShine.com\",\"authorEmail\":\"support@joomlashine.com\",\"authorUrl\":\"http:\\/\\/www.joomlashine.com\",\"version\":\"1.0.0\",\"description\":\"JSN_METRO_PRO_XML_DESCRIPTION\",\"group\":\"jsntemplate\"}', '[]', 'jsntemplate', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10018', 'j2xmlimporter', 'component', 'com_j2xmlimporter', '', '1', '1', '0', '0', '{\"legacy\":false,\"name\":\"J2XML Importer\",\"type\":\"component\",\"creationDate\":\"March 2012\",\"author\":\"Helios Ciancio\",\"copyright\":\"(C) 2010-2012, Helios Ciancio. All rights reserved.\",\"authorEmail\":\"info@eshiol.it\",\"authorUrl\":\"www.eshiol.it\",\"version\":\"1.6.0.72\",\"description\":\"COM_J2XMLIMPORTER_DESCRIPTION\",\"group\":\"\"}', '{\"import_content\":\"2\",\"import_images\":\"1\",\"import_categories\":\"1\",\"import_users\":\"1\",\"import_weblinks\":\"1\",\"keep_access\":\"0\",\"keep_state\":\"2\",\"keep_author\":\"1\",\"keep_category\":\"1\",\"keep_attribs\":\"1\",\"keep_metadata\":\"1\",\"keep_frontpage\":\"1\",\"keep_rating\":\"1\",\"keep_id\":\"1\"}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10019', 'plg_system_jsntplframework', 'plugin', 'jsntplframework', 'system', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_system_jsntplframework\",\"type\":\"plugin\",\"creationDate\":\"06\\/25\\/2013\",\"author\":\"JoomlaShine.com\",\"copyright\":\"Copyright (C) 2012 JoomlaShine.com. All Rights Reserved.\",\"authorEmail\":\"admin@joomlashine.com\",\"authorUrl\":\"www.joomlashine.com\",\"version\":\"2.0.5\",\"description\":\"\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '9999', '0'),
('10021', 'imageshow', 'component', 'com_imageshow', '', '1', '1', '0', '0', '{\"legacy\":false,\"name\":\"ImageShow\",\"type\":\"component\",\"creationDate\":\"06\\/17\\/2013\",\"author\":\"JoomlaShine.com\",\"copyright\":\"Copyright (c) 2008 - 2013 - JoomlaShine.com\",\"authorEmail\":\"admin@joomlashine.com\",\"authorUrl\":\"http:\\/\\/www.joomlashine.com\",\"version\":\"4.7.0\",\"description\":\"JSN IMAGESHOW FREE\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10022', 'Content - JSN ImageShow', 'plugin', 'imageshow', 'content', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"Content - JSN ImageShow\",\"type\":\"plugin\",\"creationDate\":\"06/17/2013\",\"author\":\"JoomlaShine.com\",\"copyright\":\"Copyright (c) 2008 - 2013 - JoomlaShine.com\",\"authorEmail\":\"admin@joomlashine.com\",\"authorUrl\":\"http://www.joomlashine.com\",\"version\":\"4.7.0\",\"description\":\"JSN_IMAGESHOW_CONTENT_PLUGIN\",\"group\":\"\",\"dependency\":[\"imageshow\"]}', '{\"imageshow\":\"imageshow\"}', '[\"imageshow\"]', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10023', 'System - JSN ImageShow', 'plugin', 'imageshow', 'system', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"System - JSN ImageShow\",\"type\":\"plugin\",\"creationDate\":\"06/17/2013\",\"author\":\"JoomlaShine.com\",\"copyright\":\"Copyright (c) 2008 - 2013 - JoomlaShine.com\",\"authorEmail\":\"admin@joomlashine.com\",\"authorUrl\":\"http://www.joomlashine.com\",\"version\":\"4.7.0\",\"description\":\"JSN_IMAGESHOW_SYSTEM_PLUGIN\",\"group\":\"\",\"dependency\":[\"imageshow\"]}', '{\"imageshow\":\"imageshow\"}', '[\"imageshow\"]', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10024', 'Button - ImageShow', 'plugin', 'imageshow', 'editors-xtd', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"Button - ImageShow\",\"type\":\"plugin\",\"creationDate\":\"06/17/2013\",\"author\":\"JoomlaShine.com\",\"copyright\":\"Copyright (c) 2008 - 2013 - JoomlaShine.com\",\"authorEmail\":\"admin@joomlashine.com\",\"authorUrl\":\"http://www.joomlashine.com\",\"version\":\"4.7.0\",\"description\":\"PLG_EDITOR_JSN_IMAGESHOW_XML_DESCRIPTION\",\"group\":\"\",\"dependency\":[\"imageshow\"]}', '{\"imageshow\":\"imageshow\"}', '[\"imageshow\"]', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10025', 'JSN ImageShow', 'module', 'mod_imageshow', '', '0', '1', '0', '1', '{\"legacy\":false,\"name\":\"JSN ImageShow\",\"type\":\"module\",\"creationDate\":\"06/17/2013\",\"author\":\"JoomlaShine.com\",\"copyright\":\"Copyright (c) 2008 - 2013 - JoomlaShine.com\",\"authorEmail\":\"admin@joomlashine.com\",\"authorUrl\":\"http://www.joomlashine.com\",\"version\":\"4.7.0\",\"description\":\"JSN_MODULE_JSN_IMAGESHOW_MODULE\",\"group\":\"\",\"dependency\":[\"imageshow\"]}', '{\"imageshow\":\"imageshow\"}', '[\"imageshow\"]', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10026', 'JSN ImageShow Quick Icons', 'module', 'mod_imageshow_quickicon', '', '1', '1', '2', '1', '{\"legacy\":false,\"name\":\"JSN ImageShow Quick Icons\",\"type\":\"module\",\"creationDate\":\"06/17/2013\",\"author\":\"JoomlaShine.com\",\"copyright\":\"Copyright (c) 2008 - 2013 - JoomlaShine.com\",\"authorEmail\":\"admin@joomlashine.com\",\"authorUrl\":\"www.joomlashine.com\",\"version\":\"4.7.0\",\"description\":\"Quick access icon to reach JSN ImageShow Launch Pad\",\"group\":\"\",\"dependency\":[\"imageshow\"]}', '{\"imageshow\":\"imageshow\"}', '[\"imageshow\"]', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10027', 'plg_system_jsnframework', 'plugin', 'jsnframework', 'system', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"plg_system_jsnframework\",\"type\":\"plugin\",\"creationDate\":\"09\\/12\\/2013\",\"author\":\"JoomlaShine.com\",\"copyright\":\"Copyright (C) 2013 JoomlaShine.com. All Rights Reserved.\",\"authorEmail\":\"admin@joomlashine.com\",\"authorUrl\":\"www.joomlashine.com\",\"version\":\"1.3.2\",\"description\":\"PLG_SYSTEM_JSNFRAMEWORK_XML_DESCRIPTION\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '-9999', '0'),
('10028', 'Source Picasa', 'plugin', 'sourcepicasa', 'jsnimageshow', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"Source Picasa\",\"type\":\"plugin\",\"creationDate\":\"05\\/09\\/2013\",\"author\":\"JoomlaShine.com\",\"copyright\":\"Copyright (c) 2008 - 2013 - JoomlaShine.com\",\"authorEmail\":\"admin@joomlashine.com\",\"authorUrl\":\"http:\\/\\/www.joomlashine.com\",\"version\":\"1.1.4\",\"description\":\"JSN IMAGESHOW IMAGE SOURCE PICASA\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10029', 'Source Flickr', 'plugin', 'sourceflickr', 'jsnimageshow', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"Source Flickr\",\"type\":\"plugin\",\"creationDate\":\"05\\/09\\/2013\",\"author\":\"JoomlaShine.com\",\"copyright\":\"Copyright (c) 2008 - 2013 - JoomlaShine.com\",\"authorEmail\":\"admin@joomlashine.com\",\"authorUrl\":\"http:\\/\\/www.joomlashine.com\",\"version\":\"1.1.5\",\"description\":\"JSN IMAGESHOW IMAGE SOURCE FLICKR\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10030', 'Theme Classic', 'plugin', 'themeclassic', 'jsnimageshow', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"Theme Classic\",\"type\":\"plugin\",\"creationDate\":\"07\\/16\\/2013\",\"author\":\"JoomlaShine.com\",\"copyright\":\"Copyright (c) 2008 - 2013 - JoomlaShine.com\",\"authorEmail\":\"admin@joomlashine.com\",\"authorUrl\":\"http:\\/\\/www.joomlashine.com\",\"version\":\"1.2.4\",\"description\":\"JSN IMAGESHOW SHOWCASE THEME CLASSIC PLUGIN\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10031', 'Theme Grid', 'plugin', 'themegrid', 'jsnimageshow', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"Theme Grid\",\"type\":\"plugin\",\"creationDate\":\"06\\/13\\/2013\",\"author\":\"JoomlaShine.com\",\"copyright\":\"Copyright (c) 2008 - 2013 - JoomlaShine.com\",\"authorEmail\":\"admin@joomlashine.com\",\"authorUrl\":\"http:\\/\\/www.joomlashine.com\",\"version\":\"1.0.8\",\"description\":\"JSN IMAGESHOW SHOWCASE THEME GRID PLUGIN\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10032', 'Theme Slider', 'plugin', 'themeslider', 'jsnimageshow', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"Theme Slider\",\"type\":\"plugin\",\"creationDate\":\"06\\/13\\/2013\",\"author\":\"JoomlaShine.com\",\"copyright\":\"Copyright (c) 2008 - 2013 - JoomlaShine.com\",\"authorEmail\":\"admin@joomlashine.com\",\"authorUrl\":\"http:\\/\\/www.joomlashine.com\",\"version\":\"1.1.4\",\"description\":\"JSN IMAGESHOW SHOWCASE THEME SLIDER PLUGIN\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0');

INSERT INTO tkt_extensions
(`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES 
('10033', 'Theme Carousel', 'plugin', 'themecarousel', 'jsnimageshow', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"Theme Carousel\",\"type\":\"plugin\",\"creationDate\":\"05\\/09\\/2013\",\"author\":\"JoomlaShine.com\",\"copyright\":\"Copyright (c) 2008 - 2013 - JoomlaShine.com\",\"authorEmail\":\"admin@joomlashine.com\",\"authorUrl\":\"http:\\/\\/www.joomlashine.com\",\"version\":\"1.0.6\",\"description\":\"JSN IMAGESHOW SHOWCASE THEME CAROUSEL PLUGIN\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10034', 'Theme Flow', 'plugin', 'themeflow', 'jsnimageshow', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"Theme Flow\",\"type\":\"plugin\",\"creationDate\":\"06\\/13\\/2013\",\"author\":\"JoomlaShine.com\",\"copyright\":\"Copyright (c) 2008 - 2013 - JoomlaShine.com\",\"authorEmail\":\"admin@joomlashine.com\",\"authorUrl\":\"http:\\/\\/www.joomlashine.com\",\"version\":\"1.0.3\",\"description\":\"JSN IMAGESHOW SHOWCASE THEME FLOW PLUGIN\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10035', 'Theme Strip', 'plugin', 'themestrip', 'jsnimageshow', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"Theme Strip\",\"type\":\"plugin\",\"creationDate\":\"06\\/13\\/2013\",\"author\":\"JoomlaShine.com\",\"copyright\":\"Copyright (c) 2008 - 2012 - JoomlaShine.com\",\"authorEmail\":\"admin@joomlashine.com\",\"authorUrl\":\"http:\\/\\/www.joomlashine.com\",\"version\":\"1.0.4\",\"description\":\"JSN IMAGESHOW SHOWCASE THEME STRIP PLUGIN\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10036', 'poweradmin', 'component', 'com_poweradmin', '', '1', '1', '0', '0', '{\"legacy\":false,\"name\":\"PowerAdmin\",\"type\":\"component\",\"creationDate\":\"08\\/03\\/2013\",\"author\":\"JoomlaShine.com\",\"copyright\":\"Copyright (c) 2013 - JoomlaShine.com\",\"authorEmail\":\"support@joomlashine.com\",\"authorUrl\":\"http:\\/\\/www.joomlashine.com\",\"version\":\"2.1.0\",\"description\":\"JSN PowerAdmin\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10037', 'System - JSN PowerAdmin', 'plugin', 'jsnpoweradmin', 'system', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"System - JSN PowerAdmin\",\"type\":\"plugin\",\"creationDate\":\"08/03/2013\",\"author\":\"JoomlaShine.com\",\"copyright\":\"Copyright (c) 2012 - JoomlaShine.com\",\"authorEmail\":\"support@joomlashine.com\",\"authorUrl\":\"http://www.joomlashine.com\",\"version\":\"2.1.0\",\"description\":\"System - JSN PowerAdmin plugin\",\"group\":\"\",\"dependency\":[\"poweradmin\"]}', '{\"poweradmin\":\"poweradmin\"}', '[\"poweradmin\"]', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10038', 'JSN PowerAdmin extended - com_content', 'plugin', 'content', 'jsnpoweradmin', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"JSN PowerAdmin extended - com_content\",\"type\":\"plugin\",\"creationDate\":\"08/03/2013\",\"author\":\"JoomlaShine.com\",\"copyright\":\"Copyright (c) 2012 - JoomlaShine.com\",\"authorEmail\":\"support@joomlashine.com\",\"authorUrl\":\"http://www.joomlashine.com\",\"version\":\"2.1.0\",\"description\":\"Support view for com_content in site manager (from PowerAdmin 1.3.0)\",\"group\":\"\",\"dependency\":[\"poweradmin\"]}', '{\"poweradmin\":\"poweradmin\"}', '[\"poweradmin\"]', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10039', 'JSN PowerAdmin extended - com_contact', 'plugin', 'contact', 'jsnpoweradmin', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"JSN PowerAdmin extended - com_contact\",\"type\":\"plugin\",\"creationDate\":\"08/03/2013\",\"author\":\"JoomlaShine.com\",\"copyright\":\"Copyright (c) 2012 - JoomlaShine.com\",\"authorEmail\":\"support@joomlashine.com\",\"authorUrl\":\"http://www.joomlashine.com\",\"version\":\"2.1.0\",\"description\":\"Support view for com_contact in site manager (from PowerAdmin 2.0)\",\"group\":\"\",\"dependency\":[\"poweradmin\"]}', '{\"poweradmin\":\"poweradmin\"}', '[\"poweradmin\"]', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10040', 'JSN PowerAdmin extended - com_users', 'plugin', 'users', 'jsnpoweradmin', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"JSN PowerAdmin extended - com_users\",\"type\":\"plugin\",\"creationDate\":\"08/03/2013\",\"author\":\"JoomlaShine.com\",\"copyright\":\"Copyright (c) 2012 - JoomlaShine.com\",\"authorEmail\":\"support@joomlashine.com\",\"authorUrl\":\"http://www.joomlashine.com\",\"version\":\"2.1.0\",\"description\":\"Support view for com_users in site manager (from PowerAdmin 2.0)\",\"group\":\"\",\"dependency\":[\"poweradmin\"]}', '{\"poweradmin\":\"poweradmin\"}', '[\"poweradmin\"]', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10041', 'JSN PowerAdmin extended - com_weblinks', 'plugin', 'weblinks', 'jsnpoweradmin', '0', '1', '1', '0', '{\"legacy\":false,\"name\":\"JSN PowerAdmin extended - com_weblinks\",\"type\":\"plugin\",\"creationDate\":\"08/03/2013\",\"author\":\"JoomlaShine.com\",\"copyright\":\"Copyright (c) 2012 - JoomlaShine.com\",\"authorEmail\":\"support@joomlashine.com\",\"authorUrl\":\"http://www.joomlashine.com\",\"version\":\"2.1.0\",\"description\":\"Support view for com_weblinks in site manager (from PowerAdmin 2.0)\",\"group\":\"\",\"dependency\":[\"poweradmin\"]}', '{\"poweradmin\":\"poweradmin\"}', '[\"poweradmin\"]', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10042', 'mod_poweradmin', 'module', 'mod_poweradmin', '', '1', '1', '2', '0', '{\"legacy\":false,\"name\":\"mod_poweradmin\",\"type\":\"module\",\"creationDate\":\"08/03/2013\",\"author\":\"JoomlaShine.com\",\"copyright\":\"Copyright (c) 2012 - JoomlaShine.com\",\"authorEmail\":\"support@joomlashine.com\",\"authorUrl\":\"http://www.joomlashine.com\",\"version\":\"2.1.0\",\"description\":\"JSN PowerAdmin Quick Icons\",\"group\":\"\",\"dependency\":[\"poweradmin\"]}', '{\"poweradmin\":\"poweradmin\"}', '[\"poweradmin\"]', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10043', 'uniform', 'component', 'com_uniform', '', '1', '1', '0', '0', '{\"legacy\":false,\"name\":\"UniForm\",\"type\":\"component\",\"creationDate\":\"09\\/11\\/2013\",\"author\":\"JoomlaShine.com\",\"copyright\":\"Copyright (c) 2012 - JoomlaShine.com\",\"authorEmail\":\"support@joomlashine.com\",\"authorUrl\":\"http:\\/\\/www.joomlashine.com\",\"version\":\"2.0.1\",\"description\":\"JSN UniForm FREE \\u2013 A very simple solution to build forms for your Joomla website.\",\"group\":\"\"}', '{}', '', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10044', 'JSN UniForm', 'module', 'mod_uniform', '', '0', '1', '0', '1', '{\"legacy\":false,\"name\":\"JSN UniForm\",\"type\":\"module\",\"creationDate\":\"09/11/2013\",\"author\":\"JoomlaShine.com\",\"copyright\":\"Copyright (C) 2012 JoomlaShine.com. All Rights Reserved.\",\"authorEmail\":\"admin@joomlashine.com\",\"authorUrl\":\"www.joomlashine.com\",\"version\":\"2.0.1\",\"description\":\"JSN_UNIFORM_MODULE_DES\",\"group\":\"\",\"dependency\":[\"uniform\"]}', '{\"uniform\":\"uniform\"}', '[\"uniform\"]', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10045', 'JSN_UNIFORM_PLUGIN_CONTENT_TITLE', 'plugin', 'uniform', 'content', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"JSN_UNIFORM_PLUGIN_CONTENT_TITLE\",\"type\":\"plugin\",\"creationDate\":\"09/11/2013\",\"author\":\"JoomlaShine.com\",\"copyright\":\"Copyright (C) 2012 JoomlaShine.com. All Rights Reserved.\",\"authorEmail\":\"admin@joomlashine.com\",\"authorUrl\":\"www.joomlashine.com\",\"version\":\"2.0.1\",\"description\":\"JSN_UNIFORM_PLUGIN_CONTENT_DES\",\"group\":\"\",\"dependency\":[\"uniform\"]}', '{\"uniform\":\"uniform\"}', '[\"uniform\"]', '', '0', '0000-00-00 00:00:00', '0', '0'),
('10046', 'JSN_UNIFORM_PLUGIN_BUTTON_TITLE', 'plugin', 'uniform', 'editors-xtd', '0', '1', '1', '1', '{\"legacy\":false,\"name\":\"JSN_UNIFORM_PLUGIN_BUTTON_TITLE\",\"type\":\"plugin\",\"creationDate\":\"09/11/2013\",\"author\":\"JoomlaShine.com\",\"copyright\":\"Copyright (C) 2012 JoomlaShine.com. All Rights Reserved.\",\"authorEmail\":\"admin@joomlashine.com\",\"authorUrl\":\"www.joomlashine.com\",\"version\":\"2.0.1\",\"description\":\"JSN_UNIFORM_PLUGIN_BUTTON_DES\",\"group\":\"\",\"dependency\":[\"uniform\"]}', '{\"uniform\":\"uniform\"}', '[\"uniform\"]', '', '0', '0000-00-00 00:00:00', '0', '0');

DROP TABLE IF EXISTS `tkt_finder_filters`;
CREATE TABLE `tkt_finder_filters` (
  `filter_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL,
  `state` tinyint(1) NOT NULL DEFAULT '1',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL,
  `created_by_alias` varchar(255) NOT NULL,
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `map_count` int(10) unsigned NOT NULL DEFAULT '0',
  `data` text NOT NULL,
  `params` mediumtext,
  PRIMARY KEY (`filter_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_finder_links`;
CREATE TABLE `tkt_finder_links` (
  `link_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `url` varchar(255) NOT NULL,
  `route` varchar(255) NOT NULL,
  `title` varchar(255) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `indexdate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `md5sum` varchar(32) DEFAULT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '1',
  `state` int(5) DEFAULT '1',
  `access` int(5) DEFAULT '0',
  `language` varchar(8) NOT NULL,
  `publish_start_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_end_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `start_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `end_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `list_price` double unsigned NOT NULL DEFAULT '0',
  `sale_price` double unsigned NOT NULL DEFAULT '0',
  `type_id` int(11) NOT NULL,
  `object` mediumblob NOT NULL,
  PRIMARY KEY (`link_id`),
  KEY `idx_type` (`type_id`),
  KEY `idx_title` (`title`),
  KEY `idx_md5` (`md5sum`),
  KEY `idx_url` (`url`(75)),
  KEY `idx_published_list` (`published`,`state`,`access`,`publish_start_date`,`publish_end_date`,`list_price`),
  KEY `idx_published_sale` (`published`,`state`,`access`,`publish_start_date`,`publish_end_date`,`sale_price`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_finder_links_terms0`;
CREATE TABLE `tkt_finder_links_terms0` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_finder_links_terms1`;
CREATE TABLE `tkt_finder_links_terms1` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_finder_links_terms2`;
CREATE TABLE `tkt_finder_links_terms2` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_finder_links_terms3`;
CREATE TABLE `tkt_finder_links_terms3` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_finder_links_terms4`;
CREATE TABLE `tkt_finder_links_terms4` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_finder_links_terms5`;
CREATE TABLE `tkt_finder_links_terms5` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_finder_links_terms6`;
CREATE TABLE `tkt_finder_links_terms6` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_finder_links_terms7`;
CREATE TABLE `tkt_finder_links_terms7` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_finder_links_terms8`;
CREATE TABLE `tkt_finder_links_terms8` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_finder_links_terms9`;
CREATE TABLE `tkt_finder_links_terms9` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_finder_links_termsa`;
CREATE TABLE `tkt_finder_links_termsa` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_finder_links_termsb`;
CREATE TABLE `tkt_finder_links_termsb` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_finder_links_termsc`;
CREATE TABLE `tkt_finder_links_termsc` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_finder_links_termsd`;
CREATE TABLE `tkt_finder_links_termsd` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_finder_links_termse`;
CREATE TABLE `tkt_finder_links_termse` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_finder_links_termsf`;
CREATE TABLE `tkt_finder_links_termsf` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_finder_taxonomy`;
CREATE TABLE `tkt_finder_taxonomy` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL,
  `state` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `access` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `parent_id` (`parent_id`),
  KEY `state` (`state`),
  KEY `ordering` (`ordering`),
  KEY `access` (`access`),
  KEY `idx_parent_published` (`parent_id`,`state`,`access`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

INSERT INTO tkt_finder_taxonomy
(`id`, `parent_id`, `title`, `state`, `access`, `ordering`) VALUES 
('1', '0', 'ROOT', '0', '0', '0');

DROP TABLE IF EXISTS `tkt_finder_taxonomy_map`;
CREATE TABLE `tkt_finder_taxonomy_map` (
  `link_id` int(10) unsigned NOT NULL,
  `node_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`node_id`),
  KEY `link_id` (`link_id`),
  KEY `node_id` (`node_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_finder_terms`;
CREATE TABLE `tkt_finder_terms` (
  `term_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `weight` float unsigned NOT NULL DEFAULT '0',
  `soundex` varchar(75) NOT NULL,
  `links` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_id`),
  UNIQUE KEY `idx_term` (`term`),
  KEY `idx_term_phrase` (`term`,`phrase`),
  KEY `idx_stem_phrase` (`stem`,`phrase`),
  KEY `idx_soundex_phrase` (`soundex`,`phrase`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_finder_terms_common`;
CREATE TABLE `tkt_finder_terms_common` (
  `term` varchar(75) NOT NULL,
  `language` varchar(3) NOT NULL,
  KEY `idx_word_lang` (`term`,`language`),
  KEY `idx_lang` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO tkt_finder_terms_common
(`term`, `language`) VALUES 
('a', 'en'),
('about', 'en'),
('after', 'en'),
('ago', 'en'),
('all', 'en'),
('am', 'en'),
('an', 'en'),
('and', 'en'),
('ani', 'en'),
('any', 'en'),
('are', 'en'),
('aren\'t', 'en'),
('as', 'en'),
('at', 'en'),
('be', 'en'),
('but', 'en'),
('by', 'en'),
('for', 'en'),
('from', 'en'),
('get', 'en'),
('go', 'en'),
('how', 'en'),
('if', 'en'),
('in', 'en'),
('into', 'en'),
('is', 'en'),
('isn\'t', 'en'),
('it', 'en'),
('its', 'en'),
('me', 'en'),
('more', 'en'),
('most', 'en'),
('must', 'en'),
('my', 'en'),
('new', 'en'),
('no', 'en'),
('none', 'en'),
('not', 'en'),
('noth', 'en'),
('nothing', 'en'),
('of', 'en'),
('off', 'en'),
('often', 'en'),
('old', 'en'),
('on', 'en'),
('onc', 'en'),
('once', 'en'),
('onli', 'en'),
('only', 'en'),
('or', 'en');

INSERT INTO tkt_finder_terms_common
(`term`, `language`) VALUES 
('other', 'en'),
('our', 'en'),
('ours', 'en'),
('out', 'en'),
('over', 'en'),
('page', 'en'),
('she', 'en'),
('should', 'en'),
('small', 'en'),
('so', 'en'),
('some', 'en'),
('than', 'en'),
('thank', 'en'),
('that', 'en'),
('the', 'en'),
('their', 'en'),
('theirs', 'en'),
('them', 'en'),
('then', 'en'),
('there', 'en'),
('these', 'en'),
('they', 'en'),
('this', 'en'),
('those', 'en'),
('thus', 'en'),
('time', 'en'),
('times', 'en'),
('to', 'en'),
('too', 'en'),
('true', 'en'),
('under', 'en'),
('until', 'en'),
('up', 'en'),
('upon', 'en'),
('use', 'en'),
('user', 'en'),
('users', 'en'),
('veri', 'en'),
('version', 'en'),
('very', 'en'),
('via', 'en'),
('want', 'en'),
('was', 'en'),
('way', 'en'),
('were', 'en'),
('what', 'en'),
('when', 'en'),
('where', 'en'),
('whi', 'en'),
('which', 'en');

INSERT INTO tkt_finder_terms_common
(`term`, `language`) VALUES 
('who', 'en'),
('whom', 'en'),
('whose', 'en'),
('why', 'en'),
('wide', 'en'),
('will', 'en'),
('with', 'en'),
('within', 'en'),
('without', 'en'),
('would', 'en'),
('yes', 'en'),
('yet', 'en'),
('you', 'en'),
('your', 'en'),
('yours', 'en');

DROP TABLE IF EXISTS `tkt_finder_tokens`;
CREATE TABLE `tkt_finder_tokens` (
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `weight` float unsigned NOT NULL DEFAULT '1',
  `context` tinyint(1) unsigned NOT NULL DEFAULT '2',
  KEY `idx_word` (`term`),
  KEY `idx_context` (`context`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_finder_tokens_aggregate`;
CREATE TABLE `tkt_finder_tokens_aggregate` (
  `term_id` int(10) unsigned NOT NULL,
  `map_suffix` char(1) NOT NULL,
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `term_weight` float unsigned NOT NULL,
  `context` tinyint(1) unsigned NOT NULL DEFAULT '2',
  `context_weight` float unsigned NOT NULL,
  `total_weight` float unsigned NOT NULL,
  KEY `token` (`term`),
  KEY `keyword_id` (`term_id`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_finder_types`;
CREATE TABLE `tkt_finder_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL,
  `mime` varchar(100) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `title` (`title`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_gcalendar`;
CREATE TABLE `tkt_gcalendar` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `calendar_id` text NOT NULL,
  `name` text NOT NULL,
  `magic_cookie` text NOT NULL,
  `username` varchar(255) DEFAULT NULL,
  `password` text,
  `color` text NOT NULL,
  `access` tinyint(3) unsigned NOT NULL DEFAULT '1',
  `access_content` tinyint(3) unsigned NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_imageshow_external_source_flickr`;
CREATE TABLE `tkt_imageshow_external_source_flickr` (
  `external_source_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `external_source_profile_title` varchar(255) DEFAULT NULL,
  `flickr_api_key` char(150) DEFAULT NULL,
  `flickr_secret_key` char(150) DEFAULT NULL,
  `flickr_username` char(50) DEFAULT NULL,
  `flickr_caching` tinyint(1) DEFAULT '0',
  `flickr_cache_expiration` char(30) DEFAULT NULL,
  `flickr_thumbnail_size` char(30) DEFAULT '100',
  `flickr_image_size` tinyint(2) DEFAULT '0',
  PRIMARY KEY (`external_source_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_imageshow_external_source_picasa`;
CREATE TABLE `tkt_imageshow_external_source_picasa` (
  `external_source_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `external_source_profile_title` varchar(255) DEFAULT NULL,
  `picasa_username` varchar(255) DEFAULT '',
  `picasa_thumbnail_size` char(30) DEFAULT '144',
  `picasa_image_size` char(30) DEFAULT '1024',
  PRIMARY KEY (`external_source_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_imageshow_images`;
CREATE TABLE `tkt_imageshow_images` (
  `image_id` int(11) NOT NULL AUTO_INCREMENT,
  `showlist_id` int(11) NOT NULL,
  `image_extid` varchar(255) DEFAULT NULL,
  `album_extid` varchar(255) DEFAULT NULL,
  `image_small` varchar(255) DEFAULT NULL,
  `image_medium` varchar(255) DEFAULT NULL,
  `image_big` text,
  `image_title` varchar(255) DEFAULT NULL,
  `image_description` text,
  `image_link` varchar(255) DEFAULT NULL,
  `ordering` int(11) DEFAULT '0',
  `custom_data` tinyint(1) DEFAULT '0',
  `sync` tinyint(1) DEFAULT '0',
  `image_size` varchar(25) DEFAULT NULL,
  `exif_data` text,
  PRIMARY KEY (`image_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_imageshow_log`;
CREATE TABLE `tkt_imageshow_log` (
  `log_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(11) DEFAULT NULL,
  `url` varchar(255) DEFAULT NULL,
  `result` varchar(255) DEFAULT NULL,
  `screen` varchar(100) DEFAULT NULL,
  `action` varchar(50) DEFAULT NULL,
  `time_created` datetime DEFAULT NULL,
  PRIMARY KEY (`log_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_imageshow_showcase`;
CREATE TABLE `tkt_imageshow_showcase` (
  `showcase_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `showcase_title` varchar(255) DEFAULT NULL,
  `published` tinyint(1) DEFAULT '0',
  `ordering` int(11) DEFAULT '0',
  `general_overall_width` char(30) DEFAULT NULL,
  `general_overall_height` char(30) DEFAULT NULL,
  `date_created` datetime DEFAULT '0000-00-00 00:00:00',
  `date_modified` datetime DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`showcase_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_imageshow_showlist`;
CREATE TABLE `tkt_imageshow_showlist` (
  `showlist_id` int(11) NOT NULL AUTO_INCREMENT,
  `showlist_title` varchar(255) DEFAULT NULL,
  `published` tinyint(1) DEFAULT '0',
  `override_title` tinyint(1) DEFAULT '0',
  `override_description` tinyint(1) DEFAULT '0',
  `override_link` tinyint(1) DEFAULT '0',
  `ordering` int(11) DEFAULT '0',
  `access` tinyint(3) DEFAULT NULL,
  `hits` int(11) DEFAULT NULL,
  `description` text,
  `showlist_link` text,
  `alter_autid` int(11) DEFAULT '0',
  `date_create` datetime DEFAULT NULL,
  `image_source_type` varchar(45) DEFAULT '',
  `image_source_name` varchar(45) DEFAULT '',
  `image_source_profile_id` int(11) DEFAULT '0',
  `authorization_status` tinyint(1) DEFAULT '0',
  `date_modified` datetime DEFAULT '0000-00-00 00:00:00',
  `image_loading_order` char(30) DEFAULT NULL,
  `show_exif_data` char(100) DEFAULT '',
  PRIMARY KEY (`showlist_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_imageshow_source_profile`;
CREATE TABLE `tkt_imageshow_source_profile` (
  `external_source_profile_id` int(11) NOT NULL AUTO_INCREMENT,
  `external_source_id` int(11) NOT NULL,
  PRIMARY KEY (`external_source_profile_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_imageshow_theme_carousel`;
CREATE TABLE `tkt_imageshow_theme_carousel` (
  `theme_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `image_source` char(150) DEFAULT 'thumbnails',
  `image_width` char(150) DEFAULT '',
  `image_height` char(150) DEFAULT '',
  `image_border_thickness` char(150) DEFAULT '5',
  `image_border_color` char(150) DEFAULT '#666666',
  `view_angle` char(150) DEFAULT '0',
  `transparency` char(150) DEFAULT '50',
  `scale` char(150) DEFAULT '35',
  `diameter` char(150) DEFAULT '50',
  `animation_duration` char(150) DEFAULT '0.6',
  `click_action` char(150) DEFAULT 'show_original_image',
  `open_link_in` char(150) DEFAULT 'current_browser',
  `orientation` char(150) DEFAULT 'horizontal',
  `enable_drag_action` char(150) DEFAULT 'no',
  `show_caption` char(150) DEFAULT 'yes',
  `caption_background_color` char(150) DEFAULT '#000000',
  `caption_opacity` char(150) DEFAULT '75',
  `caption_show_title` char(150) DEFAULT 'yes',
  `caption_title_css` text,
  `caption_show_description` char(150) DEFAULT 'yes',
  `caption_description_length_limitation` char(150) DEFAULT '50',
  `caption_description_css` text,
  `navigation_presentation` char(150) DEFAULT 'show',
  `auto_play` char(150) DEFAULT 'no',
  `slide_timing` char(150) DEFAULT '3',
  `pause_on_mouse_over` char(150) DEFAULT 'yes',
  PRIMARY KEY (`theme_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_imageshow_theme_classic_flash`;
CREATE TABLE `tkt_imageshow_theme_classic_flash` (
  `theme_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `imgpanel_presentation_mode` char(30) DEFAULT '0',
  `imgpanel_img_transition_type_fit` char(30) DEFAULT '',
  `imgpanel_img_click_action_fit` char(30) DEFAULT '',
  `imgpanel_img_open_link_in_fit` char(30) DEFAULT 'new-browser',
  `imgpanel_img_transition_type_expand` char(30) DEFAULT '',
  `imgpanel_img_motion_type_expand` char(30) DEFAULT '',
  `imgpanel_img_zooming_type_expand` char(30) DEFAULT 'center',
  `imgpanel_img_click_action_expand` char(30) DEFAULT '',
  `imgpanel_img_open_link_in_expand` char(30) DEFAULT 'new-browser',
  `imgpanel_img_show_image_shadow_fit` char(30) DEFAULT 'yes',
  `imgpanel_bg_type` char(30) DEFAULT '',
  `imgpanel_bg_value` char(255) DEFAULT NULL,
  `imgpanel_show_watermark` char(30) DEFAULT 'no',
  `imgpanel_watermark_path` char(255) DEFAULT NULL,
  `imgpanel_watermark_position` char(30) DEFAULT '',
  `imgpanel_watermark_offset` char(30) DEFAULT NULL,
  `imgpanel_watermark_opacity` char(30) DEFAULT NULL,
  `imgpanel_show_overlay_effect` char(30) DEFAULT 'no',
  `imgpanel_overlay_effect_type` char(30) DEFAULT NULL,
  `imgpanel_show_inner_shawdow` char(30) DEFAULT 'yes',
  `imgpanel_inner_shawdow_color` char(30) DEFAULT NULL,
  `thumbpanel_show_panel` char(30) DEFAULT NULL,
  `thumbpanel_panel_position` char(30) DEFAULT '',
  `thumbpanel_collapsible_position` char(30) DEFAULT 'yes',
  `thumbpanel_thumb_browsing_mode` char(30) DEFAULT '',
  `thumbpanel_show_thumb_status` char(30) DEFAULT 'yes',
  `thumbpanel_active_state_color` char(30) DEFAULT NULL,
  `thumbpanel_presentation_mode` char(30) DEFAULT '',
  `thumbpanel_border` char(30) DEFAULT NULL,
  `thumbpanel_enable_big_thumb` char(30) DEFAULT 'yes',
  `thumbpanel_big_thumb_size` char(30) DEFAULT NULL,
  `thumbpanel_thumb_row` char(30) DEFAULT NULL,
  `thumbpanel_thumb_width` char(30) DEFAULT NULL,
  `thumbpanel_thumb_height` char(30) DEFAULT NULL,
  `thumbpanel_thumb_opacity` char(30) DEFAULT '50',
  `thumbpanel_big_thumb_color` char(30) DEFAULT NULL,
  `thumbpanel_thumb_border` char(30) DEFAULT NULL,
  `thumbpanel_thumnail_panel_color` char(30) DEFAULT NULL,
  `thumbpanel_thumnail_normal_state` char(30) DEFAULT NULL,
  `infopanel_panel_position` char(30) DEFAULT '',
  `infopanel_presentation` char(30) DEFAULT NULL,
  `infopanel_bg_color_fill` char(30) DEFAULT NULL,
  `infopanel_panel_click_action` char(30) DEFAULT NULL,
  `infopanel_open_link_in` char(30) DEFAULT 'new-browser',
  `infopanel_show_title` char(30) DEFAULT 'yes',
  `infopanel_title_css` char(250) DEFAULT NULL,
  `infopanel_show_des` char(30) DEFAULT 'yes',
  `infopanel_des_lenght_limitation` char(30) DEFAULT '',
  `infopanel_des_css` char(250) DEFAULT NULL,
  `infopanel_show_link` char(30) DEFAULT 'no',
  `infopanel_link_css` char(250) DEFAULT NULL,
  `toolbarpanel_panel_position` char(30) DEFAULT '',
  `toolbarpanel_presentation` char(30) DEFAULT '0',
  `toolbarpanel_show_image_navigation` char(30) DEFAULT 'yes',
  `toolbarpanel_slideshow_player` char(30) DEFAULT 'yes',
  `toolbarpanel_show_fullscreen_switcher` char(30) DEFAULT 'yes',
  `toolbarpanel_show_tooltip` char(30) DEFAULT 'no',
  `slideshow_hide_thumb_panel` char(30) DEFAULT 'yes',
  `slideshow_slide_timing` char(50) DEFAULT NULL,
  `slideshow_hide_image_navigation` char(30) DEFAULT 'yes',
  `slideshow_auto_play` char(30) DEFAULT 'no',
  `slideshow_show_status` char(30) DEFAULT 'yes',
  `slideshow_enable_ken_burn_effect` char(30) DEFAULT 'yes',
  `slideshow_looping` char(30) DEFAULT 'yes',
  `general_round_corner_radius` char(30) DEFAULT '',
  `general_border_color` char(30) DEFAULT '',
  `general_background_color` char(30) DEFAULT '',
  `general_border_stroke` char(30) DEFAULT '',
  PRIMARY KEY (`theme_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_imageshow_theme_classic_javascript`;
CREATE TABLE `tkt_imageshow_theme_classic_javascript` (
  `theme_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `imgpanel_presentation_mode` char(30) DEFAULT '0',
  `imgpanel_img_click_action_fit` char(30) DEFAULT '',
  `imgpanel_img_open_link_in_fit` char(30) DEFAULT 'new-browser',
  `imgpanel_img_click_action_expand` char(30) DEFAULT '',
  `imgpanel_img_open_link_in_expand` char(30) DEFAULT 'new-browser',
  `imgpanel_bg_type` char(30) DEFAULT '',
  `imgpanel_bg_value` char(255) DEFAULT NULL,
  `thumbpanel_show_panel` char(30) DEFAULT NULL,
  `thumbpanel_panel_position` char(30) DEFAULT '',
  `thumbpanel_active_state_color` char(30) DEFAULT NULL,
  `thumbpanel_thumnail_normal_state` char(30) DEFAULT NULL,
  `thumbpanel_border` char(30) DEFAULT NULL,
  `thumbpanel_thumb_width` char(30) DEFAULT NULL,
  `thumbpanel_thumb_height` char(30) DEFAULT NULL,
  `thumbpanel_thumnail_panel_color` char(30) DEFAULT NULL,
  `infopanel_panel_position` char(30) DEFAULT '',
  `infopanel_presentation` char(30) DEFAULT NULL,
  `infopanel_bg_color_fill` char(30) DEFAULT NULL,
  `infopanel_panel_click_action` char(30) DEFAULT NULL,
  `infopanel_open_link_in` char(30) DEFAULT 'new-browser',
  `infopanel_show_title` char(30) DEFAULT 'yes',
  `infopanel_title_css` char(250) DEFAULT NULL,
  `infopanel_show_des` char(30) DEFAULT 'yes',
  `infopanel_des_lenght_limitation` char(30) DEFAULT '',
  `infopanel_des_css` char(250) DEFAULT NULL,
  `infopanel_show_link` char(30) DEFAULT 'no',
  `infopanel_link_css` char(250) DEFAULT NULL,
  `toolbarpanel_presentation` char(30) DEFAULT '0',
  `slideshow_slide_timing` char(50) DEFAULT NULL,
  `slideshow_auto_play` char(30) DEFAULT 'no',
  `slideshow_looping` char(30) DEFAULT 'yes',
  `general_round_corner_radius` char(30) DEFAULT '',
  `general_border_color` char(30) DEFAULT '',
  `general_background_color` char(30) DEFAULT '',
  `general_border_stroke` char(30) DEFAULT '',
  PRIMARY KEY (`theme_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_imageshow_theme_classic_parameters`;
CREATE TABLE `tkt_imageshow_theme_classic_parameters` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `general_swf_library` tinyint(1) DEFAULT '0',
  `root_url` tinyint(1) DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_imageshow_theme_flow`;
CREATE TABLE `tkt_imageshow_theme_flow` (
  `theme_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `image_source` char(150) DEFAULT 'thumbnails',
  `image_width` char(150) DEFAULT '150',
  `image_height` char(150) DEFAULT '150',
  `image_border_thickness` char(150) DEFAULT '3',
  `image_border_rounded_corner` char(150) DEFAULT '2',
  `image_border_color` char(150) DEFAULT '#eeeeee',
  `image_effect` char(150) DEFAULT 'yes',
  `transparency` char(150) DEFAULT '50',
  `background_type` char(150) DEFAULT 'transparent',
  `background_color` char(150) DEFAULT '#ffffff',
  `container_side_fade` char(150) DEFAULT 'white',
  `animation_duration` char(150) DEFAULT '1',
  `click_action` char(150) DEFAULT 'show_original_image',
  `open_link_in` char(150) DEFAULT 'current_browser',
  `orientation` char(150) DEFAULT 'horizontal',
  `enable_keyboard_action` char(150) DEFAULT 'yes',
  `enable_mouse_wheel_action` char(150) DEFAULT 'yes',
  `show_caption` char(150) DEFAULT 'yes',
  `caption_background_color` char(150) DEFAULT '#000000',
  `caption_opacity` char(150) DEFAULT '75',
  `caption_show_title` char(150) DEFAULT 'yes',
  `caption_title_css` text,
  `caption_show_description` char(150) DEFAULT 'yes',
  `caption_description_length_limitation` char(150) DEFAULT '50',
  `caption_description_css` text,
  `auto_play` char(150) DEFAULT 'no',
  `slide_timing` char(150) DEFAULT '3',
  `pause_on_mouse_over` char(150) DEFAULT 'yes',
  PRIMARY KEY (`theme_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_imageshow_theme_grid`;
CREATE TABLE `tkt_imageshow_theme_grid` (
  `theme_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `image_source` char(150) NOT NULL DEFAULT 'thumbnail',
  `show_caption` char(150) DEFAULT 'yes',
  `caption_show_description` char(150) DEFAULT 'yes',
  `show_close` char(150) DEFAULT 'yes',
  `show_thumbs` char(150) DEFAULT 'yes',
  `click_action` char(150) DEFAULT 'show_original_image',
  `open_link_in` char(150) DEFAULT 'current_browser',
  `img_layout` char(5) DEFAULT 'fixed',
  `background_color` char(30) DEFAULT '#ffffff',
  `thumbnail_width` int(11) DEFAULT '50',
  `thumbnail_height` int(11) DEFAULT '50',
  `thumbnail_space` int(11) DEFAULT '10',
  `thumbnail_border` int(11) DEFAULT '3',
  `thumbnail_rounded_corner` int(11) DEFAULT '3',
  `thumbnail_border_color` char(30) DEFAULT '#ffffff',
  `thumbnail_shadow` char(1) DEFAULT '1',
  PRIMARY KEY (`theme_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_imageshow_theme_profile`;
CREATE TABLE `tkt_imageshow_theme_profile` (
  `theme_id` int(11) NOT NULL DEFAULT '0',
  `showcase_id` int(11) NOT NULL DEFAULT '0',
  `theme_name` varchar(255) NOT NULL DEFAULT '',
  `theme_style_name` varchar(255) NOT NULL DEFAULT ''
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_imageshow_theme_slider`;
CREATE TABLE `tkt_imageshow_theme_slider` (
  `theme_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `img_transition_effect` char(30) DEFAULT 'random',
  `toolbar_navigation_arrows_presentation` char(30) DEFAULT 'show-on-mouse-over',
  `toolbar_slideshow_player_presentation` char(30) DEFAULT 'hide',
  `caption_show_caption` char(30) DEFAULT 'yes',
  `caption_title_css` text,
  `caption_description_css` text,
  `caption_link_css` text,
  `caption_caption_opacity` char(30) DEFAULT '75',
  `caption_title_show` char(30) DEFAULT 'yes',
  `caption_description_show` char(30) DEFAULT 'yes',
  `caption_link_show` char(30) DEFAULT 'no',
  `caption_position` char(150) DEFAULT 'bottom',
  `slideshow_slide_timming` int(11) DEFAULT '6',
  `slideshow_pause_on_mouseover` char(30) DEFAULT 'yes',
  `slideshow_auto_play` char(30) DEFAULT 'yes',
  `thumnail_panel_position` char(30) DEFAULT 'right',
  `thumbnail_panel_presentation` char(30) DEFAULT 'show',
  `thumbnail_presentation_mode` char(30) DEFAULT 'numbers',
  `thumbnail_active_state_color` char(30) DEFAULT '#CC3333',
  `click_action` char(150) DEFAULT 'no_action',
  `open_link_in` char(150) DEFAULT 'current_browser',
  PRIMARY KEY (`theme_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_imageshow_theme_strip`;
CREATE TABLE `tkt_imageshow_theme_strip` (
  `theme_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `slideshow_sliding_speed` char(150) NOT NULL DEFAULT '500',
  `image_orientation` char(150) NOT NULL DEFAULT 'horizontal',
  `image_width` char(150) NOT NULL DEFAULT '130',
  `image_height` char(150) NOT NULL DEFAULT '130',
  `image_space` char(150) NOT NULL DEFAULT '10',
  `image_border` char(150) NOT NULL DEFAULT '3',
  `image_rounded_corner` char(150) NOT NULL DEFAULT '3',
  `image_shadow` char(150) NOT NULL DEFAULT 'no-shadow',
  `image_border_color` char(150) NOT NULL DEFAULT '#cccccc',
  `image_click_action` char(150) NOT NULL DEFAULT 'no-action',
  `image_source` char(150) NOT NULL DEFAULT 'thumbnail',
  `show_caption` char(150) NOT NULL DEFAULT 'yes',
  `caption_background_color` char(150) NOT NULL DEFAULT '#000000',
  `caption_opacity` char(150) NOT NULL DEFAULT '75',
  `caption_show_title` char(150) NOT NULL DEFAULT 'yes',
  `caption_title_css` text NOT NULL,
  `caption_show_description` char(150) NOT NULL DEFAULT 'yes',
  `caption_description_length_limitation` char(150) NOT NULL DEFAULT '50',
  `caption_description_css` text NOT NULL,
  `container_type` char(150) NOT NULL DEFAULT 'elastislide-default',
  `container_border_color` char(150) NOT NULL DEFAULT '#cccccc',
  `container_border` char(150) NOT NULL DEFAULT '1',
  `container_round_corner` char(150) NOT NULL DEFAULT '0',
  `container_background_color` char(150) NOT NULL DEFAULT '#ffffff',
  `container_side_fade` char(150) NOT NULL DEFAULT 'white',
  `open_link_in` char(150) DEFAULT 'current_browser',
  PRIMARY KEY (`theme_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_j2xml_websites`;
CREATE TABLE `tkt_j2xml_websites` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL DEFAULT '',
  `remote_url` varchar(255) NOT NULL DEFAULT '',
  `username` varchar(255) NOT NULL DEFAULT '',
  `password` varchar(255) NOT NULL DEFAULT '',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `version` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_jsn_imageshow_config`;
CREATE TABLE `tkt_jsn_imageshow_config` (
  `name` varchar(255) NOT NULL,
  `value` text NOT NULL,
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_jsn_imageshow_messages`;
CREATE TABLE `tkt_jsn_imageshow_messages` (
  `msg_id` int(11) NOT NULL AUTO_INCREMENT,
  `msg_screen` varchar(150) DEFAULT NULL,
  `published` tinyint(1) DEFAULT '1',
  `ordering` int(11) DEFAULT '0',
  PRIMARY KEY (`msg_id`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;

INSERT INTO tkt_jsn_imageshow_messages
(`msg_id`, `msg_screen`, `published`, `ordering`) VALUES 
('1', 'LAUNCH_PAD', '1', '1'),
('2', 'LAUNCH_PAD', '1', '2'),
('3', 'SHOWLISTS', '1', '1');

DROP TABLE IF EXISTS `tkt_jsn_poweradmin_config`;
CREATE TABLE `tkt_jsn_poweradmin_config` (
  `name` varchar(255) NOT NULL,
  `value` text NOT NULL,
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_jsn_poweradmin_favourite`;
CREATE TABLE `tkt_jsn_poweradmin_favourite` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `title` varchar(500) NOT NULL,
  `icon` text NOT NULL,
  `created_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `url` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_jsn_poweradmin_history`;
CREATE TABLE `tkt_jsn_poweradmin_history` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL,
  `object_key` varchar(255) NOT NULL,
  `object_id` int(11) NOT NULL,
  `component` varchar(255) NOT NULL,
  `list_page` varchar(255) NOT NULL,
  `list_page_params` varchar(255) NOT NULL,
  `title` varchar(255) NOT NULL,
  `description` tinytext NOT NULL,
  `form` text NOT NULL,
  `form_hash` varchar(32) NOT NULL,
  `params` varchar(255) NOT NULL,
  `icon` varchar(255) NOT NULL,
  `css` varchar(100) NOT NULL,
  `is_deleted` tinyint(1) NOT NULL DEFAULT '0',
  `visited` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_jsn_poweradmin_menu_assets`;
CREATE TABLE `tkt_jsn_poweradmin_menu_assets` (
  `menuId` int(16) NOT NULL,
  `assets` text,
  `type` enum('css','js') NOT NULL DEFAULT 'css',
  `legacy` tinyint(2) NOT NULL DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_jsn_uniform_config`;
CREATE TABLE `tkt_jsn_uniform_config` (
  `name` varchar(255) NOT NULL,
  `value` text NOT NULL,
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_jsn_uniform_data`;
CREATE TABLE `tkt_jsn_uniform_data` (
  `data_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `form_id` int(10) unsigned NOT NULL,
  `user_id` int(10) unsigned DEFAULT NULL,
  `data_ip` varchar(40) NOT NULL,
  `data_country` varchar(45) NOT NULL,
  `data_country_code` varchar(4) NOT NULL,
  `data_browser` varchar(45) NOT NULL,
  `data_browser_version` varchar(20) NOT NULL,
  `data_browser_agent` varchar(255) NOT NULL,
  `data_os` varchar(45) NOT NULL,
  `data_created_by` int(10) unsigned NOT NULL COMMENT '0 = Guest',
  `data_created_at` datetime NOT NULL,
  `data_state` tinyint(1) unsigned NOT NULL COMMENT '-1 = Trashed; 0 = Unpublish; 1 = Published',
  PRIMARY KEY (`data_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_jsn_uniform_emails`;
CREATE TABLE `tkt_jsn_uniform_emails` (
  `email_id` int(11) NOT NULL AUTO_INCREMENT,
  `form_id` int(11) NOT NULL,
  `user_id` int(10) unsigned DEFAULT NULL,
  `email_name` varchar(70) DEFAULT NULL,
  `email_address` varchar(255) NOT NULL,
  `email_state` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`email_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_jsn_uniform_fields`;
CREATE TABLE `tkt_jsn_uniform_fields` (
  `field_id` int(11) NOT NULL AUTO_INCREMENT,
  `form_id` int(11) NOT NULL,
  `field_type` varchar(45) NOT NULL,
  `field_identifier` varchar(255) NOT NULL,
  `field_title` varchar(255) DEFAULT NULL,
  `field_instructions` text,
  `field_position` varchar(50) NOT NULL,
  `field_ordering` int(10) unsigned NOT NULL DEFAULT '0',
  `field_settings` text,
  PRIMARY KEY (`field_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_jsn_uniform_form_pages`;
CREATE TABLE `tkt_jsn_uniform_form_pages` (
  `page_id` int(11) NOT NULL AUTO_INCREMENT,
  `page_title` varchar(255) NOT NULL,
  `form_id` int(11) NOT NULL,
  `page_content` longtext NOT NULL,
  `page_template` longtext NOT NULL,
  `page_container` longtext NOT NULL,
  PRIMARY KEY (`page_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_jsn_uniform_forms`;
CREATE TABLE `tkt_jsn_uniform_forms` (
  `form_id` int(11) NOT NULL AUTO_INCREMENT,
  `form_title` varchar(255) NOT NULL,
  `form_description` text,
  `form_layout` varchar(50) NOT NULL,
  `form_theme` varchar(45) NOT NULL,
  `form_style` text,
  `form_notify_submitter` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `form_post_action` tinyint(1) unsigned NOT NULL COMMENT '1 = Redirect to URL; 2 = Redirect to Menu Item; 3 = Show Article; 4 = Show custom message',
  `form_post_action_data` text NOT NULL,
  `form_captcha` tinyint(1) unsigned NOT NULL,
  `form_state` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `form_access` int(11) NOT NULL,
  `form_created_by` int(10) unsigned NOT NULL,
  `form_created_at` datetime DEFAULT NULL,
  `form_modified_by` int(10) unsigned DEFAULT '0',
  `form_modified_at` datetime DEFAULT NULL,
  `form_checked_out` int(10) unsigned DEFAULT '0',
  `form_checked_out_time` datetime DEFAULT NULL,
  `form_submission_cout` int(11) NOT NULL,
  `form_last_submitted` datetime NOT NULL,
  `form_submitter` varchar(255) NOT NULL,
  `form_type` int(11) NOT NULL,
  `form_settings` longtext NOT NULL,
  `form_edit_submission` int(11) NOT NULL,
  PRIMARY KEY (`form_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_jsn_uniform_messages`;
CREATE TABLE `tkt_jsn_uniform_messages` (
  `msg_id` int(11) NOT NULL AUTO_INCREMENT,
  `msg_screen` varchar(150) DEFAULT NULL,
  `published` tinyint(1) DEFAULT '1',
  `ordering` int(11) DEFAULT '0',
  PRIMARY KEY (`msg_id`),
  UNIQUE KEY `message` (`msg_screen`,`ordering`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_jsn_uniform_templates`;
CREATE TABLE `tkt_jsn_uniform_templates` (
  `template_id` int(11) NOT NULL AUTO_INCREMENT,
  `form_id` int(11) NOT NULL,
  `template_notify_to` tinyint(1) NOT NULL COMMENT '0 = Send to submitter; 1 = Send to added emails',
  `template_from` varchar(75) NOT NULL,
  `template_reply_to` varchar(75) NOT NULL,
  `template_subject` varchar(255) NOT NULL,
  `template_message` longtext NOT NULL,
  PRIMARY KEY (`template_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_languages`;
CREATE TABLE `tkt_languages` (
  `lang_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `lang_code` char(7) NOT NULL,
  `title` varchar(50) NOT NULL,
  `title_native` varchar(50) NOT NULL,
  `sef` varchar(50) NOT NULL,
  `image` varchar(50) NOT NULL,
  `description` varchar(512) NOT NULL,
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `sitename` varchar(1024) NOT NULL DEFAULT '',
  `published` int(11) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`lang_id`),
  UNIQUE KEY `idx_sef` (`sef`),
  UNIQUE KEY `idx_image` (`image`),
  UNIQUE KEY `idx_langcode` (`lang_code`),
  KEY `idx_access` (`access`),
  KEY `idx_ordering` (`ordering`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

INSERT INTO tkt_languages
(`lang_id`, `lang_code`, `title`, `title_native`, `sef`, `image`, `description`, `metakey`, `metadesc`, `sitename`, `published`, `access`, `ordering`) VALUES 
('1', 'en-GB', 'English (UK)', 'English (UK)', 'en', 'en', '', '', '', '', '1', '0', '1');

DROP TABLE IF EXISTS `tkt_menu`;
CREATE TABLE `tkt_menu` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL COMMENT 'The type of menu this item belongs to. FK to #__menu_types.menutype',
  `title` varchar(255) NOT NULL COMMENT 'The display title of the menu item.',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL COMMENT 'The SEF alias of the menu item.',
  `note` varchar(255) NOT NULL DEFAULT '',
  `path` varchar(1024) NOT NULL COMMENT 'The computed path of the menu item based on the alias field.',
  `link` varchar(1024) NOT NULL COMMENT 'The actually link the menu item refers to.',
  `type` varchar(16) NOT NULL COMMENT 'The type of link: Component, URL, Alias, Separator',
  `published` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The published state of the menu link.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '1' COMMENT 'The parent menu item in the menu tree.',
  `level` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The relative level in the tree.',
  `component_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__extensions.id',
  `ordering` int(11) NOT NULL DEFAULT '0' COMMENT 'The relative ordering of the menu item in the tree.',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__users.id',
  `checked_out_time` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'The time the menu item was checked out.',
  `browserNav` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The click behaviour of the link.',
  `access` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The access level required to view the menu item.',
  `img` varchar(255) NOT NULL COMMENT 'The image of the menu item.',
  `template_style_id` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL COMMENT 'JSON encoded data for the menu item.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `home` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Indicates if this menu item is the home or default page.',
  `language` char(7) NOT NULL DEFAULT '',
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_client_id_parent_id_alias_language` (`client_id`,`parent_id`,`alias`,`language`),
  KEY `idx_componentid` (`component_id`,`menutype`,`published`,`access`),
  KEY `idx_menutype` (`menutype`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_path` (`path`(333)),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM AUTO_INCREMENT=506 DEFAULT CHARSET=utf8;

INSERT INTO tkt_menu
(`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `ordering`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES 
('1', '', 'Menu_Item_Root', 'root', '', '', '', '', '1', '0', '0', '0', '0', '0', '0000-00-00 00:00:00', '0', '0', '', '0', '', '0', '307', '0', '*', '0'),
('2', 'menu', 'com_banners', 'Banners', '', 'Banners', 'index.php?option=com_banners', 'component', '0', '1', '1', '4', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:banners', '0', '', '11', '20', '0', '*', '1'),
('3', 'menu', 'com_banners', 'Banners', '', 'Banners/Banners', 'index.php?option=com_banners', 'component', '0', '2', '2', '4', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:banners', '0', '', '12', '13', '0', '*', '1'),
('4', 'menu', 'com_banners_categories', 'Categories', '', 'Banners/Categories', 'index.php?option=com_categories&extension=com_banners', 'component', '0', '2', '2', '6', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:banners-cat', '0', '', '14', '15', '0', '*', '1'),
('5', 'menu', 'com_banners_clients', 'Clients', '', 'Banners/Clients', 'index.php?option=com_banners&view=clients', 'component', '0', '2', '2', '4', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:banners-clients', '0', '', '16', '17', '0', '*', '1'),
('6', 'menu', 'com_banners_tracks', 'Tracks', '', 'Banners/Tracks', 'index.php?option=com_banners&view=tracks', 'component', '0', '2', '2', '4', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:banners-tracks', '0', '', '18', '19', '0', '*', '1'),
('7', 'menu', 'com_contact', 'Contacts', '', 'Contacts', 'index.php?option=com_contact', 'component', '0', '1', '1', '8', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:contact', '0', '', '21', '26', '0', '*', '1'),
('8', 'menu', 'com_contact', 'Contacts', '', 'Contacts/Contacts', 'index.php?option=com_contact', 'component', '0', '7', '2', '8', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:contact', '0', '', '22', '23', '0', '*', '1'),
('9', 'menu', 'com_contact_categories', 'Categories', '', 'Contacts/Categories', 'index.php?option=com_categories&extension=com_contact', 'component', '0', '7', '2', '6', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:contact-cat', '0', '', '24', '25', '0', '*', '1'),
('10', 'menu', 'com_messages', 'Messaging', '', 'Messaging', 'index.php?option=com_messages', 'component', '0', '1', '1', '15', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:messages', '0', '', '27', '32', '0', '*', '1'),
('11', 'menu', 'com_messages_add', 'New Private Message', '', 'Messaging/New Private Message', 'index.php?option=com_messages&task=message.add', 'component', '0', '10', '2', '15', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:messages-add', '0', '', '28', '29', '0', '*', '1'),
('12', 'menu', 'com_messages_read', 'Read Private Message', '', 'Messaging/Read Private Message', 'index.php?option=com_messages', 'component', '0', '10', '2', '15', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:messages-read', '0', '', '30', '31', '0', '*', '1'),
('13', 'menu', 'com_newsfeeds', 'News Feeds', '', 'News Feeds', 'index.php?option=com_newsfeeds', 'component', '0', '1', '1', '17', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:newsfeeds', '0', '', '33', '38', '0', '*', '1'),
('14', 'menu', 'com_newsfeeds_feeds', 'Feeds', '', 'News Feeds/Feeds', 'index.php?option=com_newsfeeds', 'component', '0', '13', '2', '17', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:newsfeeds', '0', '', '34', '35', '0', '*', '1'),
('15', 'menu', 'com_newsfeeds_categories', 'Categories', '', 'News Feeds/Categories', 'index.php?option=com_categories&extension=com_newsfeeds', 'component', '0', '13', '2', '6', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:newsfeeds-cat', '0', '', '36', '37', '0', '*', '1'),
('16', 'menu', 'com_redirect', 'Redirect', '', 'Redirect', 'index.php?option=com_redirect', 'component', '0', '1', '1', '24', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:redirect', '0', '', '53', '54', '0', '*', '1'),
('17', 'menu', 'com_search', 'Basic Search', '', 'Basic Search', 'index.php?option=com_search', 'component', '0', '1', '1', '19', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:search', '0', '', '43', '44', '0', '*', '1'),
('18', 'menu', 'com_weblinks', 'Weblinks', '', 'Weblinks', 'index.php?option=com_weblinks', 'component', '0', '1', '1', '21', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:weblinks', '0', '', '47', '52', '0', '*', '1'),
('19', 'menu', 'com_weblinks_links', 'Links', '', 'Weblinks/Links', 'index.php?option=com_weblinks', 'component', '0', '18', '2', '21', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:weblinks', '0', '', '48', '49', '0', '*', '1'),
('20', 'menu', 'com_weblinks_categories', 'Categories', '', 'Weblinks/Categories', 'index.php?option=com_categories&extension=com_weblinks', 'component', '0', '18', '2', '6', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:weblinks-cat', '0', '', '50', '51', '0', '*', '1'),
('21', 'menu', 'com_finder', 'Smart Search', '', 'Smart Search', 'index.php?option=com_finder', 'component', '0', '1', '1', '27', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:finder', '0', '', '41', '42', '0', '*', '1'),
('22', 'menu', 'com_joomlaupdate', 'Joomla! Update', '', 'Joomla! Update', 'index.php?option=com_joomlaupdate', 'component', '0', '1', '1', '28', '0', '0', '0000-00-00 00:00:00', '0', '0', 'class:joomlaupdate', '0', '', '39', '40', '0', '*', '1'),
('201', 'usermenu', 'Your Profile', 'your-profile', '', 'your-profile', 'index.php?option=com_users&view=profile', 'component', '1', '1', '1', '25', '0', '0', '0000-00-00 00:00:00', '0', '2', '', '115', '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '237', '238', '0', '*', '0'),
('207', 'top', 'Joomla.org', 'joomlaorg', '', 'joomlaorg', 'http://joomla.org', 'url', '1', '1', '1', '0', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\"}', '235', '236', '0', '*', '0'),
('227', 'aboutjoomla', 'Weblinks Categories', 'weblinks-categories', '', 'using-joomla/extensions/components/weblinks-component/weblinks-categories', 'index.php?option=com_weblinks&view=categories&id=18', 'component', '1', '265', '5', '21', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_num_links_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"-1\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_links\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_link_description\":\"\",\"show_link_hits\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '89', '90', '0', '*', '0'),
('229', 'aboutjoomla', 'Single Contact', 'single-contact', '', 'using-joomla/extensions/components/contact-component/single-contact', 'index.php?option=com_contact&view=contact&id=1', 'component', '1', '270', '5', '8', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_category_crumb\":\"\",\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '79', '80', '0', '*', '0'),
('233', 'mainmenu', 'Login', 'login', '', 'login', 'index.php?option=com_users&view=login', 'component', '1', '1', '1', '25', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '271', '272', '0', '*', '0'),
('490', 'main', 'COM_IMAGESHOW', 'com-imageshow', '', 'com-imageshow', 'index.php?option=com_imageshow', 'component', '0', '1', '1', '10021', '0', '0', '0000-00-00 00:00:00', '0', '1', 'components/com_imageshow/assets/images/icons-16/icon-picture.png', '0', '', '275', '286', '0', '', '1'),
('491', 'main', 'LAUNCH_PAD', 'launch-pad', '', 'com-imageshow/launch-pad', 'index.php?option=com_imageshow', 'component', '0', '490', '2', '10021', '0', '0', '0000-00-00 00:00:00', '0', '1', 'components/com_imageshow/assets/images/icons-16/icon-off.png', '0', '', '276', '277', '0', '', '1'),
('492', 'main', 'SHOWLISTS', 'showlists', '', 'com-imageshow/showlists', 'index.php?option=com_imageshow&controller=showlist', 'component', '0', '490', '2', '10021', '0', '0', '0000-00-00 00:00:00', '0', '1', 'components/com_imageshow/assets/images/icons-16/icon-file.png', '0', '', '278', '279', '0', '', '1'),
('493', 'main', 'SHOWCASES', 'showcases', '', 'com-imageshow/showcases', 'index.php?option=com_imageshow&controller=showcase', 'component', '0', '490', '2', '10021', '0', '0', '0000-00-00 00:00:00', '0', '1', 'components/com_imageshow/assets/images/icons-16/icon-monitor.png', '0', '', '280', '281', '0', '', '1'),
('494', 'main', 'CONFIGURATION_AND_MAINTENANCE', 'configuration-and-maintenance', '', 'com-imageshow/configuration-and-maintenance', 'index.php?option=com_imageshow&controller=maintenance&type=configs', 'component', '0', '490', '2', '10021', '0', '0', '0000-00-00 00:00:00', '0', '1', 'components/com_imageshow/assets/images/icons-16/icon-cog.png', '0', '', '282', '283', '0', '', '1'),
('238', 'mainmenu', 'Sample Sites', 'sample-sites', '', 'sample-sites', 'index.php?option=com_content&view=article&id=38', 'component', '-2', '1', '1', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"0\",\"link_category\":\"\",\"show_parent_category\":\"0\",\"link_parent_category\":\"\",\"show_author\":\"0\",\"link_author\":\"\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"0\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '239', '244', '0', '*', '0'),
('249', 'aboutjoomla', 'Submit a Weblink', 'submit-a-weblink', '', 'using-joomla/extensions/components/weblinks-component/submit-a-weblink', 'index.php?option=com_weblinks&view=form&layout=edit', 'component', '1', '265', '5', '21', '0', '0', '0000-00-00 00:00:00', '0', '3', '', '115', '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '85', '86', '0', '*', '0'),
('251', 'aboutjoomla', 'Contact Categories', 'contact-categories', '', 'using-joomla/extensions/components/contact-component/contact-categories', 'index.php?option=com_contact&view=categories&id=16', 'component', '1', '270', '5', '8', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevel\":\"-1\",\"show_empty_categories\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"display_num\":\"\",\"show_headings\":\"\",\"filter_field\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"presentation_style\":\"sliders\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"1\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '75', '76', '0', '*', '0'),
('252', 'aboutjoomla', 'News Feed Categories', 'new-feed-categories', '', 'using-joomla/extensions/components/news-feeds-component/new-feed-categories', 'index.php?option=com_newsfeeds&view=categories&id=0', 'component', '1', '267', '5', '17', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_base_description\":\"1\",\"categories_description\":\"Because this links to the root category the \"uncategorised\" category is displayed. \",\"maxLevel\":\"-1\",\"show_empty_categories\":\"1\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"show_cat_num_articles\":\"1\",\"display_num\":\"\",\"show_headings\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '93', '94', '0', '*', '0'),
('253', 'aboutjoomla', 'News Feed Category', 'news-feed-category', '', 'using-joomla/extensions/components/news-feeds-component/news-feed-category', 'index.php?option=com_newsfeeds&view=category&id=17', 'component', '1', '267', '5', '17', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"maxLevel\":\"-1\",\"show_empty_categories\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"display_num\":\"\",\"show_headings\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '97', '98', '0', '*', '0'),
('254', 'aboutjoomla', 'Single News Feed', 'single-news-feed', '', 'using-joomla/extensions/components/news-feeds-component/single-news-feed', 'index.php?option=com_newsfeeds&view=newsfeed&id=4', 'component', '1', '267', '5', '17', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '95', '96', '0', '*', '0'),
('255', 'aboutjoomla', 'Search', 'search', '', 'using-joomla/extensions/components/search-component/search', 'index.php?option=com_search&view=search', 'component', '1', '276', '5', '19', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"search_areas\":\"1\",\"show_date\":\"1\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '115', '116', '0', '*', '0'),
('256', 'aboutjoomla', 'Archived Articles', 'archived-articles', '', 'using-joomla/extensions/components/content-component/archived-articles', 'index.php?option=com_content&view=archive', 'component', '1', '266', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"orderby_sec\":\"\",\"order_date\":\"\",\"display_num\":\"\",\"filter_field\":\"\",\"show_category\":\"1\",\"link_category\":\"1\",\"show_title\":\"1\",\"link_titles\":\"1\",\"show_intro\":\"1\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_hits\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '69', '70', '0', '*', '0'),
('257', 'aboutjoomla', 'Single Article', 'single-article', '', 'using-joomla/extensions/components/content-component/single-article', 'index.php?option=com_content&view=article&id=6', 'component', '1', '266', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '59', '60', '0', '*', '0'),
('259', 'aboutjoomla', 'Article Category Blog', 'article-category-blog', '', 'using-joomla/extensions/components/content-component/article-category-blog', 'index.php?option=com_content&view=category&layout=blog&id=27', 'component', '1', '266', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"0\",\"show_description_image\":\"0\",\"show_category_title\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"2\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '63', '64', '0', '*', '0'),
('260', 'aboutjoomla', 'Article Category List', 'article-category-list', '', 'using-joomla/extensions/components/content-component/article-category-list', 'index.php?option=com_content&view=category&id=19', 'component', '1', '266', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"alpha\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"display_num\":\"10\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '65', '66', '0', '*', '0'),
('262', 'aboutjoomla', 'Featured Articles', 'featured-articles', '', 'using-joomla/extensions/components/content-component/featured-articles', 'index.php?option=com_content&view=featured', 'component', '1', '266', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"1\",\"orderby_pri\":\"\",\"orderby_sec\":\"front\",\"order_date\":\"\",\"show_pagination\":\"2\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '67', '68', '0', '*', '0'),
('263', 'aboutjoomla', 'Submit Article', 'submit-article', '', 'using-joomla/extensions/components/content-component/submit-article', 'index.php?option=com_content&view=form&layout=edit', 'component', '1', '266', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '3', '', '115', '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '71', '72', '0', '*', '0'),
('265', 'aboutjoomla', 'Weblinks Component', 'weblinks-component', '', 'using-joomla/extensions/components/weblinks-component', 'index.php?option=com_content&view=article&id=54', 'component', '1', '268', '4', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '84', '91', '0', '*', '0'),
('266', 'aboutjoomla', 'Content Component', 'content-component', '', 'using-joomla/extensions/components/content-component', 'index.php?option=com_content&view=article&id=10', 'component', '1', '268', '4', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"article-allow_ratings\":\"\",\"article-allow_comments\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '58', '73', '0', '*', '0'),
('267', 'aboutjoomla', 'News Feeds Component', 'news-feeds-component', '', 'using-joomla/extensions/components/news-feeds-component', 'index.php?option=com_content&view=article&id=60', 'component', '1', '268', '4', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":1,\"page_title\":\"Newsfeeds Categories View \",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '92', '99', '0', '*', '0'),
('268', 'aboutjoomla', 'Components', 'components', '', 'using-joomla/extensions/components', 'index.php?option=com_content&view=category&layout=blog&id=21', 'component', '1', '277', '3', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_category_title\":\"\",\"show_description\":\"1\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"0\",\"num_intro_articles\":\"7\",\"num_columns\":\"1\",\"num_links\":\"0\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"order\",\"order_date\":\"\",\"show_pagination\":\"0\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"0\",\"link_category\":\"\",\"show_parent_category\":\"0\",\"link_parent_category\":\"\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_readmore\":\"\",\"show_icons\":\"0\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '57', '122', '0', '*', '0'),
('270', 'aboutjoomla', 'Contact Component', 'contact-component', '', 'using-joomla/extensions/components/contact-component', 'index.php?option=com_content&view=article&id=9', 'component', '1', '268', '4', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '74', '83', '0', '*', '0');

INSERT INTO tkt_menu
(`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `ordering`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES 
('271', 'aboutjoomla', 'Users Component', 'users-component', '', 'using-joomla/extensions/components/users-component', 'index.php?option=com_content&view=article&id=52', 'component', '1', '268', '4', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '100', '113', '0', '*', '0'),
('272', 'aboutjoomla', 'Article Categories', 'article-categories', '', 'using-joomla/extensions/components/content-component/article-categories', 'index.php?option=com_content&view=categories&id=14', 'component', '1', '266', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevel\":\"-1\",\"show_empty_categories\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"display_num\":\"\",\"category_layout\":\"\",\"show_headings\":\"\",\"show_date\":\"\",\"date_format\":\"\",\"filter_field\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '61', '62', '0', '*', '0'),
('273', 'aboutjoomla', 'Administrator Components', 'administrator-components', '', 'using-joomla/extensions/components/administrator-components', 'index.php?option=com_content&view=article&id=1', 'component', '1', '268', '4', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '120', '121', '0', '*', '0'),
('274', 'aboutjoomla', 'Weblinks Single Category', 'weblinks-single-category', '', 'using-joomla/extensions/components/weblinks-component/weblinks-single-category', 'index.php?option=com_weblinks&view=category&id=32', 'component', '1', '265', '5', '21', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"maxLevel\":\"-1\",\"show_empty_categories\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"display_num\":\"\",\"show_headings\":\"\",\"orderby_pri\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '87', '88', '0', '*', '0'),
('275', 'aboutjoomla', 'Contact Single Category', 'contact-single-category', '', 'using-joomla/extensions/components/contact-component/contact-single-category', 'index.php?option=com_contact&view=category&catid=26&id=36', 'component', '1', '270', '5', '8', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"maxLevel\":\"-1\",\"show_empty_categories\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"display_num\":\"20\",\"show_headings\":\"\",\"filter_field\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"presentation_style\":\"sliders\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"1\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '77', '78', '0', '*', '0'),
('276', 'aboutjoomla', 'Search Components', 'search-component', '', 'using-joomla/extensions/components/search-component', 'index.php?option=com_content&view=article&id=39', 'component', '1', '268', '4', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '114', '119', '0', '*', '0'),
('277', 'aboutjoomla', 'Using Extensions', 'extensions', '', 'using-joomla/extensions', 'index.php?option=com_content&view=categories&id=20', 'component', '1', '280', '2', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_base_description\":\"1\",\"categories_description\":\"\",\"maxLevelcat\":\"1\",\"show_empty_categories_cat\":\"1\",\"show_subcat_desc_cat\":\"1\",\"show_cat_num_articles_cat\":\"0\",\"drill_down_layout\":\"0\",\"show_category_title\":\"\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"maxLevel\":\"1\",\"show_empty_categories\":\"1\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '56', '221', '0', '*', '0'),
('278', 'aboutjoomla', 'The Joomla! Project', 'the-joomla-project', '', 'the-joomla-project', 'index.php?option=com_content&view=article&id=48', 'component', '1', '1', '1', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"1\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"0\",\"link_category\":\"\",\"show_parent_category\":\"0\",\"link_parent_category\":\"\",\"show_author\":\"0\",\"link_author\":\"\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"0\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '229', '230', '0', '*', '0'),
('279', 'aboutjoomla', 'The Joomla! Community', 'the-joomla-community', '', 'the-joomla-community', 'index.php?option=com_content&view=article&id=47', 'component', '1', '1', '1', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"0\",\"show_intro\":\"\",\"show_category\":\"0\",\"link_category\":\"\",\"show_parent_category\":\"0\",\"link_parent_category\":\"\",\"show_author\":\"0\",\"link_author\":\"\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"0\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '231', '232', '0', '*', '0'),
('280', 'aboutjoomla', 'Using Joomla!', 'using-joomla', '', 'using-joomla', 'index.php?option=com_content&view=article&id=53', 'component', '1', '1', '1', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"1\",\"show_category\":\"0\",\"link_category\":\"\",\"show_parent_category\":\"0\",\"link_parent_category\":\"\",\"show_author\":\"0\",\"link_author\":\"\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"0\",\"show_noauth\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '55', '226', '0', '*', '0'),
('281', 'aboutjoomla', 'Modules', 'modules', '', 'using-joomla/extensions/modules', 'index.php?option=com_content&view=category&id=22', 'component', '1', '277', '3', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_category_title\":\"\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"maxLevel\":\"1\",\"show_empty_categories\":\"1\",\"show_no_articles\":\"0\",\"show_subcat_desc\":\"1\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"1\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"\",\"show_readmore\":\"0\",\"show_icons\":\"0\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '123', '182', '0', '*', '0'),
('282', 'aboutjoomla', 'Templates', 'templates', '', 'using-joomla/extensions/templates', 'index.php?option=com_content&view=category&id=23', 'component', '1', '277', '3', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_category_title\":\"\",\"show_description\":\"1\",\"show_description_image\":\"\",\"maxLevel\":\"2\",\"show_empty_categories\":\"1\",\"show_no_articles\":\"0\",\"show_subcat_desc\":\"1\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"show_pagination_limit\":\"0\",\"filter_field\":\"hide\",\"show_headings\":\"0\",\"list_show_date\":\"0\",\"date_format\":\"\",\"list_show_hits\":\"0\",\"list_show_author\":\"0\",\"show_pagination\":\"0\",\"show_pagination_results\":\"\",\"show_title\":\"1\",\"link_titles\":\"1\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"Templates\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '183', '202', '0', '*', '0'),
('283', 'aboutjoomla', 'Languages', 'languages', '', 'using-joomla/extensions/languages', 'index.php?option=com_content&view=category&layout=blog&id=24', 'component', '1', '277', '3', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"show_category_title\":\"1\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '203', '204', '0', '*', '0'),
('284', 'aboutjoomla', 'Plugins', 'plugins', '', 'using-joomla/extensions/plugins', 'index.php?option=com_content&view=category&layout=blog&id=25', 'component', '1', '277', '3', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"1\",\"show_description_image\":\"\",\"show_category_title\":\"1\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"0\",\"num_intro_articles\":\"7\",\"num_columns\":\"1\",\"num_links\":\"0\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"order\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"0\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '205', '220', '0', '*', '0'),
('285', 'aboutjoomla', 'Typography Atomic', 'typography-atomic', '', 'using-joomla/extensions/templates/atomic/typography-atomic', 'index.php?option=com_content&view=article&id=49', 'component', '1', '422', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '197', '198', '0', '*', '0'),
('290', 'mainmenu', 'Articles', 'articles', '', 'site-map/articles', 'index.php?option=com_content&view=categories&id=0', 'component', '-2', '294', '2', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"categories_description\":\"\",\"maxLevel\":\"-1\",\"show_empty_categories\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"display_num\":\"\",\"category_layout\":\"\",\"show_headings\":\"\",\"show_date\":\"\",\"date_format\":\"\",\"filter_field\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"article-allow_ratings\":\"\",\"article-allow_comments\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '4', '5', '0', '*', '0'),
('294', 'mainmenu', 'Site Map', 'site-map', '', 'site-map', 'index.php?option=com_content&view=article&id=42', 'component', '-2', '1', '1', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"0\",\"link_category\":\"\",\"show_parent_category\":\"0\",\"link_parent_category\":\"\",\"show_author\":\"0\",\"link_author\":\"\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"0\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '3', '10', '0', '*', '0'),
('300', 'aboutjoomla', 'Latest Users', 'latest-users', '', 'using-joomla/extensions/modules/user-modules/latest-users', 'index.php?option=com_content&view=article&id=66', 'component', '1', '412', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '147', '148', '0', '*', '0'),
('301', 'aboutjoomla', 'Who\'s Online', 'whos-online', '', 'using-joomla/extensions/modules/user-modules/whos-online', 'index.php?option=com_content&view=article&id=56', 'component', '1', '412', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '149', '150', '0', '*', '0'),
('302', 'aboutjoomla', 'Most Read', 'most-read', '', 'using-joomla/extensions/modules/content-modules/most-read', 'index.php?option=com_content&view=article&id=30', 'component', '1', '411', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '131', '132', '0', '*', '0'),
('303', 'aboutjoomla', 'Menu', 'menu', '', 'using-joomla/extensions/modules/navigation-modules/menu', 'index.php?option=com_content&view=article&id=29', 'component', '1', '415', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '125', '126', '0', '*', '0'),
('304', 'aboutjoomla', 'Statistics', 'statistics', '', 'using-joomla/extensions/modules/utility-modules/statistics', 'index.php?option=com_content&view=article&id=44', 'component', '1', '414', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '171', '172', '0', '*', '0'),
('305', 'aboutjoomla', 'Banner', 'banner', '', 'using-joomla/extensions/modules/display-modules/banner', 'index.php?option=com_content&view=article&id=7', 'component', '1', '413', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '157', '158', '0', '*', '0'),
('306', 'aboutjoomla', 'Search', 'search', '', 'using-joomla/extensions/modules/utility-modules/search', 'index.php?option=com_content&view=article&id=40', 'component', '1', '414', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '173', '174', '0', '*', '0'),
('307', 'aboutjoomla', 'Random Image', 'random-image', '', 'using-joomla/extensions/modules/display-modules/random-image', 'index.php?option=com_content&view=article&id=36', 'component', '1', '413', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '155', '156', '0', '*', '0'),
('309', 'aboutjoomla', 'News Flash', 'news-flash', '', 'using-joomla/extensions/modules/content-modules/news-flash', 'index.php?option=com_content&view=article&id=31', 'component', '1', '411', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '133', '134', '0', '*', '0'),
('310', 'aboutjoomla', 'Latest Articles', 'latest-articles', '', 'using-joomla/extensions/modules/content-modules/latest-articles', 'index.php?option=com_content&view=article&id=27', 'component', '1', '411', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '135', '136', '0', '*', '0'),
('311', 'aboutjoomla', 'Syndicate', 'syndicate', '', 'using-joomla/extensions/modules/utility-modules/syndicate', 'index.php?option=com_content&view=article&id=45', 'component', '1', '414', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '169', '170', '0', '*', '0'),
('312', 'aboutjoomla', 'Login', 'login', '', 'using-joomla/extensions/modules/user-modules/login', 'index.php?option=com_content&view=article&id=28', 'component', '1', '412', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '151', '152', '0', '*', '0'),
('313', 'aboutjoomla', 'Wrapper', 'wrapper', '', 'using-joomla/extensions/modules/utility-modules/wrapper', 'index.php?option=com_content&view=article&id=59', 'component', '1', '414', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '177', '178', '0', '*', '0'),
('316', 'aboutjoomla', 'Home Page Atomic', 'home-page-atomic', '', 'using-joomla/extensions/templates/atomic/home-page-atomic', 'index.php?option=com_content&view=featured', 'component', '1', '422', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"3\",\"num_columns\":\"3\",\"num_links\":\"0\",\"multi_column_order\":\"1\",\"orderby_pri\":\"\",\"orderby_sec\":\"front\",\"order_date\":\"\",\"show_pagination\":\"2\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '199', '200', '0', '*', '0'),
('317', 'aboutjoomla', 'System', 'system', '', 'using-joomla/extensions/plugins/system', 'index.php?option=com_content&view=article&id=46', 'component', '1', '284', '4', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '218', '219', '0', '*', '0'),
('318', 'aboutjoomla', 'Authentication', 'authentication', '', 'using-joomla/extensions/plugins/authentication', 'index.php?option=com_content&view=article&id=5', 'component', '1', '284', '4', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '206', '207', '0', '*', '0'),
('319', 'aboutjoomla', 'Content', 'content', '', 'using-joomla/extensions/plugins/content', 'index.php?option=com_content&view=article&id=62', 'component', '1', '284', '4', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '208', '209', '0', '*', '0'),
('320', 'aboutjoomla', 'Editors', 'editors', '', 'using-joomla/extensions/plugins/editors', 'index.php?option=com_content&view=article&id=14', 'component', '1', '284', '4', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '210', '211', '0', '*', '0'),
('321', 'aboutjoomla', 'Editors Extended', 'editors-extended', '', 'using-joomla/extensions/plugins/editors-extended', 'index.php?option=com_content&view=article&id=15', 'component', '1', '284', '4', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '212', '213', '0', '*', '0'),
('322', 'aboutjoomla', 'Search', 'search', '', 'using-joomla/extensions/plugins/search', 'index.php?option=com_content&view=article&id=41', 'component', '1', '284', '4', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '214', '215', '0', '*', '0'),
('323', 'aboutjoomla', 'User', 'user', '', 'using-joomla/extensions/plugins/user', 'index.php?option=com_content&view=article&id=51', 'component', '1', '284', '4', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '216', '217', '0', '*', '0'),
('324', 'aboutjoomla', 'Footer', 'footer', '', 'using-joomla/extensions/modules/display-modules/footer', 'index.php?option=com_content&view=article&id=19', 'component', '1', '413', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '161', '162', '0', '*', '0'),
('325', 'aboutjoomla', 'Archive', 'archive', '', 'using-joomla/extensions/modules/content-modules/archive', 'index.php?option=com_content&view=article&id=2', 'component', '1', '411', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '137', '138', '0', '*', '0'),
('326', 'aboutjoomla', 'Related Items', 'related-items', '', 'using-joomla/extensions/modules/content-modules/related-items', 'index.php?option=com_content&view=article&id=37', 'component', '1', '411', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '139', '140', '0', '*', '0'),
('488', 'mainmenu', 'Location & Directions', 'location-directions', '', 'location-directions', 'index.php?option=com_wrapper&view=wrapper', 'component', '1', '1', '1', '2', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"url\":\"http:\\/\\/2047.org\\/who_where\\/\",\"scrolling\":\"auto\",\"width\":\"100%\",\"height\":\"1750\",\"height_auto\":\"0\",\"add_scheme\":\"1\",\"frameborder\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '267', '268', '0', '*', '0'),
('489', 'mainmenu', 'Contact Us', 'contact-us', '', 'contact-us', 'index.php?option=com_contact&view=contact&id=9', 'component', '1', '1', '1', '8', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '269', '270', '0', '*', '0'),
('487', 'mainmenu', 'Calendar', 'calendar', '', 'calendar', 'index.php?option=com_wrapper&view=wrapper', 'component', '1', '1', '1', '2', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"url\":\"http:\\/\\/www.google.com\\/calendar\\/embed?height=600&wkst=1&bgcolor=%23FFFFFF&src=od6b95bhukc4rc9q9se2ejnbo8%40group.calendar.google.com&color=%232952A3&src=6gp4kk15ol53ptdhc7hjjetjko%40group.calendar.google.com&color=%23125A12&ctz=America%2FNew_York\\\" style=\\\" border-width:0 \\\" width=\\\"650\\\" height=\\\"550\\\" frameborder=\\\"0\\\" scrolling=\\\"no\",\"scrolling\":\"auto\",\"width\":\"100%\",\"height\":\"500\",\"height_auto\":\"0\",\"add_scheme\":\"1\",\"frameborder\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '265', '266', '0', '*', '0'),
('402', 'aboutjoomla', 'Login Form', 'login-form', '', 'using-joomla/extensions/components/users-component/login-form', 'index.php?option=com_users&view=login', 'component', '1', '271', '5', '25', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"login_redirect_url\":\"\",\"logindescription_show\":\"1\",\"login_description\":\"\",\"login_image\":\"\",\"logout_redirect_url\":\"\",\"logoutdescription_show\":\"1\",\"logout_description\":\"\",\"logout_image\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '101', '102', '0', '*', '0'),
('403', 'aboutjoomla', 'User Profile', 'user-profile', '', 'using-joomla/extensions/components/users-component/user-profile', 'index.php?option=com_users&view=profile', 'component', '1', '271', '5', '25', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '103', '104', '0', '*', '0'),
('404', 'aboutjoomla', 'Edit User Profile', 'edit-user-profile', '', 'using-joomla/extensions/components/users-component/edit-user-profile', 'index.php?option=com_users&view=profile&layout=edit', 'component', '1', '271', '5', '25', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '105', '106', '0', '*', '0'),
('405', 'aboutjoomla', 'Registration Form', 'registration-form', '', 'using-joomla/extensions/components/users-component/registration-form', 'index.php?option=com_users&view=registration', 'component', '1', '271', '5', '25', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '107', '108', '0', '*', '0'),
('406', 'aboutjoomla', 'Username Reminder Request', 'username-reminder', '', 'using-joomla/extensions/components/users-component/username-reminder', 'index.php?option=com_users&view=remind', 'component', '1', '271', '5', '25', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '109', '110', '0', '*', '0'),
('409', 'aboutjoomla', 'Password Reset', 'password-reset', '', 'using-joomla/extensions/components/users-component/password-reset', 'index.php?option=com_users&view=reset', 'component', '1', '271', '5', '25', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '111', '112', '0', '*', '0');

INSERT INTO tkt_menu
(`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `ordering`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES 
('410', 'aboutjoomla', 'Feed Display', 'feed-display', '', 'using-joomla/extensions/modules/display-modules/feed-display', 'index.php?option=com_content&view=article&id=16', 'component', '1', '413', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '159', '160', '0', '*', '0'),
('411', 'aboutjoomla', 'Content Modules', 'content-modules', '', 'using-joomla/extensions/modules/content-modules', 'index.php?option=com_content&view=category&id=64', 'component', '1', '281', '4', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"maxLevel\":\"0\",\"show_category_title\":\"1\",\"page_subheading\":\"\",\"show_empty_categories\":\"1\",\"show_description\":\"1\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"display_num\":\"0\",\"show_headings\":\"0\",\"list_show_title\":\"1\",\"list_show_date\":\"0\",\"date_format\":\"\",\"list_show_hits\":\"0\",\"list_show_author\":\"0\",\"filter_field\":\"hide\",\"orderby_pri\":\"\",\"orderby_sec\":\"order\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_limit\":\"0\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"1\",\"link_category\":\"1\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '130', '145', '0', '*', '0'),
('412', 'aboutjoomla', 'User Modules', 'user-modules', '', 'using-joomla/extensions/modules/user-modules', 'index.php?option=com_content&view=category&id=65', 'component', '1', '281', '4', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"maxLevel\":\"0\",\"show_category_title\":\"1\",\"page_subheading\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"1\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"display_num\":\"0\",\"show_headings\":\"0\",\"list_show_title\":\"1\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"0\",\"list_show_author\":\"0\",\"filter_field\":\"hide\",\"orderby_pri\":\"\",\"orderby_sec\":\"order\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_limit\":\"0\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"1\",\"link_category\":\"1\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '146', '153', '0', '*', '0'),
('413', 'aboutjoomla', 'Display Modules', 'display-modules', '', 'using-joomla/extensions/modules/display-modules', 'index.php?option=com_content&view=category&id=66', 'component', '1', '281', '4', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"maxLevel\":\"0\",\"show_category_title\":\"1\",\"page_subheading\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"show_cat_num_articles\":\"\",\"display_num\":\"0\",\"show_headings\":\"0\",\"list_show_title\":\"1\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"0\",\"list_show_author\":\"0\",\"filter_field\":\"hide\",\"orderby_pri\":\"\",\"orderby_sec\":\"order\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_limit\":\"0\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"1\",\"link_category\":\"1\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '154', '167', '0', '*', '0'),
('414', 'aboutjoomla', 'Utility Modules', 'utility-modules', '', 'using-joomla/extensions/modules/utility-modules', 'index.php?option=com_content&view=category&id=67', 'component', '1', '281', '4', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"maxLevel\":\"0\",\"show_category_title\":\"1\",\"page_subheading\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"show_cat_num_articles\":\"\",\"display_num\":\"0\",\"show_headings\":\"0\",\"list_show_title\":\"0\",\"list_show_date\":\"0\",\"date_format\":\"\",\"list_show_hits\":\"0\",\"list_show_author\":\"0\",\"filter_field\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"order\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_limit\":\"0\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"1\",\"link_category\":\"1\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '168', '181', '0', '*', '0'),
('415', 'aboutjoomla', 'Navigation Modules', 'navigation-modules', '', 'using-joomla/extensions/modules/navigation-modules', 'index.php?option=com_content&view=category&id=75', 'component', '1', '281', '4', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"maxLevel\":\"\",\"show_category_title\":\"\",\"page_subheading\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"display_num\":\"\",\"show_headings\":\"\",\"list_show_title\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"filter_field\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_limit\":\"\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '124', '129', '0', '*', '0'),
('416', 'aboutjoomla', 'Breadcrumbs', 'breadcrumbs', '', 'using-joomla/extensions/modules/navigation-modules/breadcrumbs', 'index.php?option=com_content&view=article&id=61', 'component', '1', '415', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '127', '128', '0', '*', '0'),
('417', 'aboutjoomla', 'Weblinks', 'weblinks', '', 'using-joomla/extensions/modules/display-modules/weblinks', 'index.php?option=com_content&view=article&id=55', 'component', '1', '413', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '163', '164', '0', '*', '0'),
('418', 'aboutjoomla', 'Custom HTML', 'custom-html', '', 'using-joomla/extensions/modules/display-modules/custom-html', 'index.php?option=com_content&view=article&id=12', 'component', '1', '413', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '165', '166', '0', '*', '0'),
('419', 'aboutjoomla', 'Beez 2', 'beez-2', '', 'using-joomla/extensions/templates/beez-2', 'index.php?option=com_content&view=category&layout=blog&id=69', 'component', '1', '282', '4', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"1\",\"show_description_image\":\"\",\"show_category_title\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '184', '189', '0', '*', '0'),
('422', 'aboutjoomla', 'Atomic', 'atomic', '', 'using-joomla/extensions/templates/atomic', 'index.php?option=com_content&view=category&layout=blog&id=68', 'component', '1', '282', '4', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"1\",\"show_description_image\":\"\",\"show_category_title\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"2\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '196', '201', '0', '*', '0'),
('423', 'aboutjoomla', 'Typography Beez 2', 'typography-beez-2', '', 'using-joomla/extensions/templates/beez-2/typography-beez-2', 'index.php?option=com_content&view=article&id=49', 'component', '1', '419', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '185', '186', '0', '*', '0'),
('424', 'aboutjoomla', 'Home Page Beez 2', 'home-page-beez-2', '', 'using-joomla/extensions/templates/beez-2/home-page-beez-2', 'index.php?option=com_content&view=featured', 'component', '1', '419', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"3\",\"num_columns\":\"3\",\"num_links\":\"0\",\"multi_column_order\":\"1\",\"orderby_pri\":\"\",\"orderby_sec\":\"front\",\"order_date\":\"\",\"show_pagination\":\"2\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '187', '188', '0', '*', '0'),
('505', 'main', 'JSN_UNIFORM_MENU_ABOUT_TEXT', 'jsn-uniform-menu-about-text', '', 'jsn-uniform-menu-text/jsn-uniform-menu-about-text', 'index.php?option=com_uniform&view=about', 'component', '0', '501', '2', '10043', '0', '0', '0000-00-00 00:00:00', '0', '1', 'components/com_uniform/assets/images/icons-16/icon-about.png', '0', '', '304', '305', '0', '', '1'),
('503', 'main', 'JSN_UNIFORM_MENU_SUBMISSIONS_TEXT', 'jsn-uniform-menu-submissions-text', '', 'jsn-uniform-menu-text/jsn-uniform-menu-submissions-text', 'index.php?option=com_uniform&view=submissions', 'component', '0', '501', '2', '10043', '0', '0', '0000-00-00 00:00:00', '0', '1', 'components/com_uniform/assets/images/icons-16/icon-submissions.png', '0', '', '300', '301', '0', '', '1'),
('504', 'main', 'JSN_UNIFORM_MENU_CONFIGURATION_TEXT', 'jsn-uniform-menu-configuration-text', '', 'jsn-uniform-menu-text/jsn-uniform-menu-configuration-text', 'index.php?option=com_uniform&view=configuration', 'component', '0', '501', '2', '10043', '0', '0', '0000-00-00 00:00:00', '0', '1', 'components/com_uniform/assets/images/icons-16/icon-cog.png', '0', '', '302', '303', '0', '', '1'),
('500', 'main', 'JSN_POWERADMIN_MENU_HELP_TEXT', 'jsn-poweradmin-menu-help-text', '', 'jsn-poweradmin-menu-text/jsn-poweradmin-menu-help-text', 'index.php?option=com_poweradmin&view=about', 'component', '0', '496', '2', '10036', '0', '0', '0000-00-00 00:00:00', '0', '1', 'components/com_poweradmin/assets/images/icons-16/icon-star.png', '0', '', '294', '295', '0', '', '1'),
('501', 'main', 'JSN_UNIFORM_MENU_TEXT', 'jsn-uniform-menu-text', '', 'jsn-uniform-menu-text', 'index.php?option=com_uniform', 'component', '0', '1', '1', '10043', '0', '0', '0000-00-00 00:00:00', '0', '1', 'components/com_uniform/assets/images/icons-16/icon-uniform.png', '0', '', '297', '306', '0', '', '1'),
('502', 'main', 'JSN_UNIFORM_MENU_FORMS_TEXT', 'jsn-uniform-menu-forms-text', '', 'jsn-uniform-menu-text/jsn-uniform-menu-forms-text', 'index.php?option=com_uniform&view=forms', 'component', '0', '501', '2', '10043', '0', '0', '0000-00-00 00:00:00', '0', '1', 'components/com_uniform/assets/images/icons-16/icon-forms.png', '0', '', '298', '299', '0', '', '1'),
('435', 'mainmenu', 'Home', 'homepage', '', 'homepage', 'index.php?option=com_content&view=category&layout=blog&id=104', 'component', '1', '1', '1', '22', '0', '242', '2013-09-23 16:07:50', '0', '1', '', '115', '{\"layout_type\":\"blog\",\"show_category_heading_title_text\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"1\",\"num_links\":\"4\",\"multi_column_order\":\"1\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"front\",\"order_date\":\"\",\"show_pagination\":\"2\",\"show_pagination_results\":\"\",\"show_title\":\"1\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"\",\"show_readmore\":\"1\",\"show_readmore_title\":\"\",\"show_icons\":\"0\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '1', '2', '1', '*', '0'),
('436', 'aboutjoomla', 'Getting Help', 'getting-help', '', 'using-joomla/getting-help', 'index.php?option=com_content&view=article&id=21', 'component', '1', '280', '2', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"0\",\"link_category\":\"\",\"show_parent_category\":\"0\",\"link_parent_category\":\"\",\"show_author\":\"0\",\"link_author\":\"\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"0\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '224', '225', '0', '*', '0'),
('437', 'aboutjoomla', 'Getting Started', 'getting-started', '', 'getting-started', 'index.php?option=com_content&view=article&id=22', 'component', '1', '1', '1', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"\",\"show_category\":\"0\",\"link_category\":\"\",\"show_parent_category\":\"0\",\"link_parent_category\":\"\",\"show_author\":\"0\",\"link_author\":\"\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '45', '46', '0', '*', '0'),
('438', 'mainmenu', 'Weblinks', 'weblinks', '', 'site-map/weblinks', 'index.php?option=com_weblinks&view=categories&id=0', 'component', '-2', '294', '2', '21', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"categories_description\":\"\",\"maxLevel\":\"-1\",\"show_empty_categories\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"display_num\":\"\",\"show_headings\":\"\",\"orderby_pri\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"article-allow_ratings\":\"\",\"article-allow_comments\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '6', '7', '0', '*', '0'),
('439', 'mainmenu', 'Contacts', 'contacts', '', 'site-map/contacts', 'index.php?option=com_contact&view=categories&id=0', 'component', '-2', '294', '2', '8', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"categories_description\":\"\",\"maxLevel\":\"-1\",\"show_empty_categories\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"display_num\":\"\",\"show_headings\":\"\",\"filter_field\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"1\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"article-allow_ratings\":\"\",\"article-allow_comments\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '8', '9', '0', '*', '0'),
('443', 'aboutjoomla', 'Article Categories', 'article-categories-view', '', 'using-joomla/extensions/modules/content-modules/article-categories-view', 'index.php?option=com_content&view=article&id=3', 'component', '1', '411', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '141', '142', '0', '*', '0'),
('444', 'top', 'Sample Sites', 'sample-sites-2', '', 'sample-sites-2', 'index.php?Itemid=', 'alias', '1', '1', '1', '0', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"aliasoptions\":\"238\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\"}', '233', '234', '0', '*', '0'),
('445', 'mainmenu', 'Parks', 'parks', '', 'sample-sites/parks', 'index.php?Itemid=', 'alias', '-2', '238', '2', '0', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"aliasoptions\":\"243\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\"}', '240', '241', '0', '*', '0'),
('446', 'mainmenu', 'Shop', 'shop', '', 'sample-sites/shop', 'index.php?Itemid=', 'alias', '-2', '238', '2', '0', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"aliasoptions\":\"429\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\"}', '242', '243', '0', '*', '0'),
('447', 'aboutjoomla', 'Language Switcher', 'language-switcher', '', 'using-joomla/extensions/modules/utility-modules/language-switcher', 'index.php?option=com_content&view=article&id=26', 'component', '1', '414', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '175', '176', '0', '*', '0'),
('448', 'mainmenu', 'Site Administrator', 'site-administrator', '', 'site-administrator', 'administrator', 'url', '1', '1', '1', '0', '0', '0', '0000-00-00 00:00:00', '1', '1', '', '115', '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\"}', '273', '274', '0', '*', '0'),
('449', 'usermenu', 'Submit an Article', 'submit-an-article', '', 'submit-an-article', 'index.php?option=com_content&view=form&layout=edit', 'component', '1', '1', '1', '22', '0', '0', '0000-00-00 00:00:00', '0', '3', '', '115', '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '245', '246', '0', '*', '0'),
('450', 'usermenu', 'Submit a Web Link', 'submit-a-web-link', '', 'submit-a-web-link', 'index.php?option=com_weblinks&view=form&layout=edit', 'component', '1', '1', '1', '21', '0', '0', '0000-00-00 00:00:00', '0', '3', '', '115', '{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '247', '248', '0', '*', '0'),
('452', 'aboutjoomla', 'Featured Contacts', 'featured-contacts', '', 'using-joomla/extensions/components/contact-component/featured-contacts', 'index.php?option=com_contact&view=featured&id=16', 'component', '1', '270', '5', '8', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"maxLevel\":\"-1\",\"show_empty_categories\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"display_num\":\"\",\"show_headings\":\"\",\"filter_field\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"presentation_style\":\"sliders\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"1\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":1,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '81', '82', '0', '*', '0'),
('453', 'aboutjoomla', 'Parameters', 'parameters', '', 'using-joomla/parameters', 'index.php?option=com_content&view=article&id=32', 'component', '1', '280', '2', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"1\",\"show_title\":\"1\",\"link_titles\":\"1\",\"show_intro\":\"1\",\"show_category\":\"1\",\"link_category\":\"1\",\"show_parent_category\":\"1\",\"link_parent_category\":\"1\",\"show_author\":\"1\",\"link_author\":\"1\",\"show_create_date\":\"1\",\"show_modify_date\":\"1\",\"show_publish_date\":\"1\",\"show_item_navigation\":\"1\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"1\",\"show_hits\":\"1\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '222', '223', '0', '*', '0'),
('455', 'mainmenu', 'Example Pages', 'example-pages', '', 'example-pages', 'index.php?Itemid=', 'alias', '-2', '1', '1', '0', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '0', '{\"aliasoptions\":\"268\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\"}', '249', '250', '0', '*', '0'),
('456', 'aboutjoomla', 'Beez5', 'beez5', '', 'using-joomla/extensions/templates/beez5', 'index.php?option=com_content&view=category&layout=blog&id=70', 'component', '1', '282', '4', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"1\",\"show_description_image\":\"\",\"show_category_title\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":1,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '190', '195', '0', '*', '0'),
('457', 'aboutjoomla', 'Typography Beez5', 'typography-beez-5', '', 'using-joomla/extensions/templates/beez5/typography-beez-5', 'index.php?option=com_content&view=article&id=49', 'component', '1', '456', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":1,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '191', '192', '0', '*', '0'),
('458', 'aboutjoomla', 'Home Page Beez5', 'home-page-beez5', '', 'using-joomla/extensions/templates/beez5/home-page-beez5', 'index.php?option=com_content&view=featured', 'component', '1', '456', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"3\",\"num_columns\":\"3\",\"num_links\":\"0\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"front\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":1,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '193', '194', '0', '*', '0'),
('459', 'aboutjoomla', 'Article Category', 'article-category', '', 'using-joomla/extensions/modules/content-modules/article-category', 'index.php?option=com_content&view=article&id=4', 'component', '1', '411', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":1,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}', '143', '144', '0', '*', '0'),
('499', 'main', 'JSN_POWERADMIN_MENU_CONFIGURATION_TEXT', 'jsn-poweradmin-menu-configuration-text', '', 'jsn-poweradmin-menu-text/jsn-poweradmin-menu-configuration-text', 'index.php?option=com_poweradmin&view=configuration', 'component', '0', '496', '2', '10036', '0', '0', '0000-00-00 00:00:00', '0', '1', 'components/com_poweradmin/assets/images/icons-16/icon-cog.png', '0', '', '292', '293', '0', '', '1'),
('495', 'main', 'ABOUT', 'about', '', 'com-imageshow/about', 'index.php?option=com_imageshow&controller=about', 'component', '0', '490', '2', '10021', '0', '0', '0000-00-00 00:00:00', '0', '1', 'components/com_imageshow/assets/images/icons-16/icon-star.png', '0', '', '284', '285', '0', '', '1'),
('496', 'main', 'JSN_POWERADMIN_MENU_TEXT', 'jsn-poweradmin-menu-text', '', 'jsn-poweradmin-menu-text', 'index.php?option=com_poweradmin', 'component', '0', '1', '1', '10036', '0', '0', '0000-00-00 00:00:00', '0', '1', 'components/com_poweradmin/assets/images/icons-16/icon-wrench.png', '0', '', '287', '296', '0', '', '1'),
('497', 'main', 'JSN_POWERADMIN_MENU_RAWMODE_TEXT', 'jsn-poweradmin-menu-rawmode-text', '', 'jsn-poweradmin-menu-text/jsn-poweradmin-menu-rawmode-text', 'index.php?option=com_poweradmin&view=rawmode', 'component', '0', '496', '2', '10036', '0', '0', '0000-00-00 00:00:00', '0', '1', 'components/com_poweradmin/assets/images/icons-16/icon-monitor.png', '0', '', '288', '289', '0', '', '1'),
('498', 'main', 'JSN_POWERADMIN_MENU_SITESEARCH_TEXT', 'jsn-poweradmin-menu-sitesearch-text', '', 'jsn-poweradmin-menu-text/jsn-poweradmin-menu-sitesearch-text', 'index.php?option=com_poweradmin&task=search.query', 'component', '0', '496', '2', '10036', '0', '0', '0000-00-00 00:00:00', '0', '1', 'components/com_poweradmin/assets/images/icons-16/icon-search.png', '0', '', '290', '291', '0', '', '1'),
('464', 'top', 'Home', 'home', '', 'home', 'index.php?Itemid=', 'alias', '1', '1', '1', '0', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"aliasoptions\":\"435\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\"}', '227', '228', '0', '*', '0'),
('466', 'aboutjoomla', 'Smart Search', 'smart-search', '', 'using-joomla/extensions/components/search-component/smart-search', 'index.php?option=com_finder&view=search&q=&f=', 'component', '1', '276', '5', '27', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_date_filters\":\"\",\"show_advanced\":\"\",\"expand_advanced\":\"\",\"show_description\":\"\",\"description_length\":255,\"show_url\":\"\",\"show_pagination_limit\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"allow_empty_query\":\"0\",\"search_order\":\"\",\"show_feed\":\"0\",\"show_feed_text\":\"0\",\"show_feed_link\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '117', '118', '0', '*', '0'),
('467', 'aboutjoomla', 'Smart Search', 'smart-search', '', 'using-joomla/extensions/modules/utility-modules/smart-search', 'index.php?option=com_content&view=article&id=70', 'component', '1', '414', '5', '22', '0', '0', '0000-00-00 00:00:00', '0', '1', '', '115', '{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}', '179', '180', '0', '*', '0'),
('468', 'main', 'COM_GCALENDAR', 'com-gcalendar', '', 'com-gcalendar', 'index.php?option=com_gcalendar', 'component', '0', '1', '1', '10000', '0', '0', '0000-00-00 00:00:00', '0', '1', 'class:component', '0', '', '251', '260', '0', '', '1'),
('469', 'main', 'COM_GCALENDAR_SUBMENU_CPANEL', 'com-gcalendar-submenu-cpanel', '', 'com-gcalendar/com-gcalendar-submenu-cpanel', 'index.php?option=com_gcalendar&view=cpanel', 'component', '0', '468', '2', '10000', '0', '0', '0000-00-00 00:00:00', '0', '1', 'class:component', '0', '', '252', '253', '0', '', '1'),
('470', 'main', 'COM_GCALENDAR_SUBMENU_GCALENDARS', 'com-gcalendar-submenu-gcalendars', '', 'com-gcalendar/com-gcalendar-submenu-gcalendars', 'index.php?option=com_gcalendar&view=gcalendars', 'component', '0', '468', '2', '10000', '0', '0', '0000-00-00 00:00:00', '0', '1', 'class:component', '0', '', '254', '255', '0', '', '1');

INSERT INTO tkt_menu
(`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `ordering`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES 
('471', 'main', 'COM_GCALENDAR_SUBMENU_TOOLS', 'com-gcalendar-submenu-tools', '', 'com-gcalendar/com-gcalendar-submenu-tools', 'index.php?option=com_gcalendar&view=tools', 'component', '0', '468', '2', '10000', '0', '0', '0000-00-00 00:00:00', '0', '1', 'class:component', '0', '', '256', '257', '0', '', '1'),
('472', 'main', 'COM_GCALENDAR_SUBMENU_SUPPORT', 'com-gcalendar-submenu-support', '', 'com-gcalendar/com-gcalendar-submenu-support', 'index.php?option=com_gcalendar&view=support', 'component', '0', '468', '2', '10000', '0', '0', '0000-00-00 00:00:00', '0', '1', 'class:component', '0', '', '258', '259', '0', '', '1'),
('473', 'main', 'COM_ZWEATHER', 'com-zweather', '', 'com-zweather', 'index.php?option=com_zweather', 'component', '0', '1', '1', '10007', '0', '0', '0000-00-00 00:00:00', '0', '1', 'class:component', '0', '', '261', '262', '0', '', '1'),
('486', 'main', 'J2XMLImporter', 'j2xmlimporter', '', 'j2xmlimporter', 'index.php?option=com_j2xmlimporter', 'component', '0', '1', '1', '10018', '0', '0', '0000-00-00 00:00:00', '0', '1', 'components/com_j2xmlimporter/assets/images/menu/icon-16-j2xmlimporter.png', '0', '', '263', '264', '0', '', '1');

DROP TABLE IF EXISTS `tkt_menu_types`;
CREATE TABLE `tkt_menu_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL,
  `title` varchar(48) NOT NULL,
  `description` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_menutype` (`menutype`)
) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=utf8;

INSERT INTO tkt_menu_types
(`id`, `menutype`, `title`, `description`) VALUES 
('2', 'usermenu', 'User Menu', 'A Menu for logged-in Users'),
('3', 'top', 'Top', 'Links for major types of users'),
('4', 'aboutjoomla', 'About Joomla', 'All about Joomla!'),
('6', 'mainmenu', 'Main Menu', 'Simple Home Menu');

DROP TABLE IF EXISTS `tkt_messages`;
CREATE TABLE `tkt_messages` (
  `message_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id_from` int(10) unsigned NOT NULL DEFAULT '0',
  `user_id_to` int(10) unsigned NOT NULL DEFAULT '0',
  `folder_id` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `date_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `priority` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `subject` varchar(255) NOT NULL DEFAULT '',
  `message` text NOT NULL,
  PRIMARY KEY (`message_id`),
  KEY `useridto_state` (`user_id_to`,`state`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_messages_cfg`;
CREATE TABLE `tkt_messages_cfg` (
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `cfg_name` varchar(100) NOT NULL DEFAULT '',
  `cfg_value` varchar(255) NOT NULL DEFAULT '',
  UNIQUE KEY `idx_user_var_name` (`user_id`,`cfg_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_modules`;
CREATE TABLE `tkt_modules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `content` text NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  `position` varchar(50) NOT NULL DEFAULT '',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `module` varchar(50) DEFAULT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `showtitle` tinyint(3) unsigned NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `published` (`published`,`access`),
  KEY `newsfeeds` (`module`,`published`),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM AUTO_INCREMENT=95 DEFAULT CHARSET=utf8;

INSERT INTO tkt_modules
(`id`, `title`, `note`, `content`, `ordering`, `position`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `published`, `module`, `access`, `showtitle`, `params`, `client_id`, `language`) VALUES 
('1', 'Main Menu', '', '', '1', 'position-7', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_menu', '1', '1', '{\"menutype\":\"mainmenu\",\"startLevel\":\"0\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"\",\"moduleclass_sfx\":\"_menu\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}', '0', '*'),
('2', 'Login', '', '', '1', 'login', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_login', '1', '1', '', '1', '*'),
('3', 'Popular Articles', '', '', '3', 'cpanel', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_popular', '3', '1', '{\"count\":\"5\",\"catid\":\"\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}', '1', '*'),
('4', 'Recently Added Articles', '', '', '4', 'cpanel', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_latest', '3', '1', '{\"count\":\"5\",\"ordering\":\"c_dsc\",\"catid\":\"\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}', '1', '*'),
('8', 'Toolbar', '', '', '1', 'toolbar', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_toolbar', '3', '1', '', '1', '*'),
('9', 'Quick Icons', '', '', '1', 'icon', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_quickicon', '3', '1', '', '1', '*'),
('10', 'Logged-in Users', '', '', '2', 'cpanel', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_logged', '3', '1', '{\"count\":\"5\",\"name\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}', '1', '*'),
('12', 'Admin Menu', '', '', '1', 'menu', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_menu', '3', '1', '{\"layout\":\"\",\"moduleclass_sfx\":\"\",\"shownew\":\"1\",\"showhelp\":\"1\",\"cache\":\"0\"}', '1', '*'),
('13', 'Admin Submenu', '', '', '1', 'submenu', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_submenu', '3', '1', '', '1', '*'),
('14', 'User Status', '', '', '2', 'status', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_status', '3', '1', '', '1', '*'),
('15', 'Title', '', '', '1', 'title', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_title', '3', '1', '', '1', '*'),
('16', 'Login Form', '', '', '7', 'position-7', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_login', '1', '1', '{\"greeting\":\"1\",\"name\":\"0\"}', '0', '*'),
('17', 'Breadcrumbs', '', '', '1', 'position-2', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_breadcrumbs', '1', '1', '{\"moduleclass_sfx\":\"\",\"showHome\":\"1\",\"homeText\":\"Home\",\"showComponent\":\"1\",\"separator\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}', '0', '*'),
('79', 'Multilanguage status', '', '', '1', 'status', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0', 'mod_multilangstatus', '3', '1', '{\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}', '1', '*'),
('86', 'Joomla Version', '', '', '1', 'footer', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_version', '3', '1', '{\"format\":\"short\",\"product\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}', '1', '*'),
('18', 'Book Store', '', '', '1', 'position-10', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_banners', '1', '0', '{\"target\":\"1\",\"count\":\"1\",\"cid\":\"3\",\"catid\":[\"\"],\"tag_search\":\"0\",\"ordering\":\"0\",\"header_text\":\"\",\"footer_text\":\"Books!\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\"}', '0', '*'),
('19', 'User Menu', '', '', '3', 'position-7', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_menu', '2', '1', '{\"menutype\":\"usermenu\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"\",\"moduleclass_sfx\":\"_menu\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}', '0', '*'),
('20', 'Top', '', '', '1', 'position-1', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_menu', '1', '1', '{\"menutype\":\"top\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}', '0', '*'),
('91', 'JSN imageshow Module', '', '', '0', '', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_imageshow', '1', '1', '', '0', '*'),
('92', 'JSN imageshow Quick Icons', '', '', '0', 'icon', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_imageshow_quickicon', '1', '1', '', '1', '*'),
('93', 'JSN PowerAdmin Quick Icons', '', '', '1', 'icon', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_poweradmin', '1', '1', '', '1', '*'),
('94', 'JSN UniForm Module', '', '', '0', '', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_uniform', '1', '1', '', '0', '*'),
('23', 'About Joomla!', '', '', '4', 'position-7', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_menu', '1', '1', '{\"menutype\":\"aboutjoomla\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"\",\"moduleclass_sfx\":\"_menu\",\"cache\":\"0\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}', '0', '*'),
('68', 'About Parks', '', '<p>The Parks sample site is designed as a simple site that can be routinely updated from the front end of Joomla!.</p><p>As a site, it is largely focused on a blog which can be updated using the front end article submission.</p><p>New weblinks can also be added through the front end.</p><p>A simple image gallery uses com_content with thumbnails displayed in a blog layout and full size images shown in article layout.</p><p>The Parks site features the language switch module. All of the content and modules are tagged as English (en-GB). If a second language pack is added with sample data this can be filtered using the language switch.</p><p>Parks uses HTML5 which is a major web standard (along with XHTML which is used in other areas of sample data).</p>', '2', 'position-4', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_custom', '1', '1', '{\"prepare_content\":\"1\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*'),
('67', 'Extensions', '', '', '2', 'position-7', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0', 'mod_menu', '1', '1', '{\"menutype\":\"aboutjoomla\",\"startLevel\":\"1\",\"endLevel\":\"6\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"-menu\",\"window_open\":\"\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}', '0', '*'),
('25', 'Site Map', '', '', '1', 'sitemapload', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_menu', '1', '0', '{\"menutype\":\"mainmenu\",\"startLevel\":\"2\",\"endLevel\":\"3\",\"showAllChildren\":\"1\",\"tag_id\":\"\",\"class_sfx\":\"sitemap\",\"window_open\":\"\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}', '0', '*'),
('26', 'This Site', '', '', '5', 'position-7', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_menu', '1', '1', '{\"menutype\":\"mainmenu\",\"startLevel\":\"1\",\"endLevel\":\"1\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"\",\"moduleclass_sfx\":\"_menu\",\"cache\":\"0\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}', '0', '*'),
('27', 'Archived Articles', '', '', '1', '', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_articles_archive', '1', '1', '{\"count\":\"10\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*'),
('28', 'Latest News', '', '', '1', '', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_articles_latest', '1', '1', '{\"catid\":[\"19\"],\"count\":\"5\",\"show_featured\":\"\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*'),
('29', 'Articles Most Read', '', '', '1', '', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_articles_popular', '1', '1', '{\"catid\":[\"26\",\"29\"],\"count\":\"5\",\"show_front\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*'),
('30', 'Feed Display', '', '', '1', '', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_feed', '1', '1', '{\"rssurl\":\"http:\\/\\/community.joomla.org\\/blogs\\/community.feed?type=rss\",\"rssrtl\":\"0\",\"rsstitle\":\"1\",\"rssdesc\":\"1\",\"rssimage\":\"1\",\"rssitems\":\"3\",\"rssitemdesc\":\"1\",\"word_count\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\"}', '0', '*'),
('31', 'News Flash', '', '', '1', '', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_articles_news', '1', '1', '{\"catid\":[\"19\"],\"image\":\"0\",\"item_title\":\"0\",\"link_titles\":\"\",\"item_heading\":\"h4\",\"showLastSeparator\":\"1\",\"readmore\":\"1\",\"count\":\"1\",\"ordering\":\"a.publish_up\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}', '0', '*'),
('33', 'Random Image', '', '', '1', '', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_random_image', '1', '1', '{\"type\":\"jpg\",\"folder\":\"images\\/sampledata\\/parks\\/animals\",\"link\":\"\",\"width\":\"180\",\"height\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}', '0', '*'),
('34', 'Articles Related Items', '', '', '1', '', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_related_items', '1', '1', '{\"showDate\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"owncache\":\"1\"}', '0', '*'),
('35', 'Search', '', '', '1', '', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_search', '1', '1', '{\"label\":\"\",\"width\":\"20\",\"text\":\"\",\"button\":\"\",\"button_pos\":\"right\",\"imagebutton\":\"\",\"button_text\":\"\",\"opensearch\":\"1\",\"opensearch_title\":\"\",\"set_itemid\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}', '0', '*'),
('36', 'Statistics', '', '', '1', '', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_stats', '1', '1', '{\"serverinfo\":\"1\",\"siteinfo\":\"1\",\"counter\":\"1\",\"increase\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*'),
('37', 'Syndicate Feeds', '', '', '1', 'syndicateload', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_syndicate', '1', '1', '{\"text\":\"Feed Entries\",\"format\":\"rss\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}', '0', '*'),
('38', 'Users Latest', '', '', '1', '', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_users_latest', '1', '1', '{\"shownumber\":\"5\",\"linknames\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*'),
('39', 'Who\'s Online', '', '', '1', '', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_whosonline', '1', '1', '{\"showmode\":\"2\",\"linknames\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}', '0', '*'),
('40', 'Wrapper', '', '', '1', '', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_wrapper', '1', '1', '{\"url\":\"http:\\/\\/www.youtube.com\\/embed\\/vb2eObvmvdI\",\"add\":\"1\",\"scrolling\":\"auto\",\"width\":\"640\",\"height\":\"390\",\"height_auto\":\"1\",\"target\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*'),
('41', 'Footer', '', '', '1', '', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_footer', '1', '1', '{\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*'),
('44', 'Login', '', '', '1', '', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_login', '1', '1', '{\"pretext\":\"\",\"posttext\":\"\",\"login\":\"280\",\"logout\":\"280\",\"greeting\":\"1\",\"name\":\"0\",\"usesecure\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}', '0', '*'),
('45', 'Menu Example', '', '', '1', '', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_menu', '1', '1', '{\"menutype\":\"mainmenu\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}', '0', '*'),
('47', 'Latest Park Blogs', '', '', '6', 'position-7', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_articles_latest', '1', '1', '{\"count\":\"5\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"show_front\":\"1\",\"catid\":\"35\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\"}', '0', 'en-GB'),
('48', 'Custom HTML', '', '<p>This is a custom html module. That means you can enter whatever content you want.</p>', '1', '', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_custom', '1', '1', '{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*'),
('49', 'Weblinks', '', '', '1', '', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_weblinks', '1', '1', '{\"catid\":\"32\",\"count\":\"5\",\"ordering\":\"title\",\"direction\":\"asc\",\"target\":\"3\",\"description\":\"0\",\"hits\":\"0\",\"count_clicks\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*'),
('52', 'Breadcrumbs', '', '', '1', '', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_breadcrumbs', '1', '1', '{\"showHere\":\"1\",\"showHome\":\"1\",\"homeText\":\"Home\",\"showLast\":\"1\",\"separator\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}', '0', '*'),
('61', 'Articles Categories', '', '', '1', '', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_articles_categories', '1', '1', '{\"parent\":\"29\",\"show_description\":\"0\",\"show_children\":\"0\",\"count\":\"0\",\"maxlevel\":\"0\",\"layout\":\"_:default\",\"item_heading\":\"4\",\"moduleclass_sfx\":\"\",\"owncache\":\"1\",\"cache_time\":\"900\"}', '0', '*'),
('56', 'Banners', '', '', '1', '', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_banners', '1', '1', '{\"target\":\"1\",\"count\":\"1\",\"cid\":\"1\",\"catid\":[\"15\"],\"tag_search\":\"0\",\"ordering\":\"random\",\"header_text\":\"\",\"footer_text\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\"}', '0', '*'),
('58', 'Special!', '', '<h1>This week we have a special, half price on delicious oranges!</h1><div>Only for our special customers!</div><div>Use the code: Joomla! when ordering</div><p><em>This module can only be seen by people in the customers group or higher.</em></p>', '1', 'position-12', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_custom', '4', '1', '{\"prepare_content\":\"1\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*');

INSERT INTO tkt_modules
(`id`, `title`, `note`, `content`, `ordering`, `position`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `published`, `module`, `access`, `showtitle`, `params`, `client_id`, `language`) VALUES 
('62', 'Language Switcher', '', '', '3', 'position-4', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0', 'mod_languages', '1', '1', '{\"header_text\":\"\",\"footer_text\":\"\",\"image\":\"1\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*'),
('63', 'Search', '', '', '1', 'position-0', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_search', '1', '1', '{\"width\":\"20\",\"text\":\"\",\"button\":\"\",\"button_pos\":\"right\",\"imagebutton\":\"1\",\"button_text\":\"\",\"set_itemid\":\"\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}', '0', '*'),
('64', 'Language Switcher', '', '', '1', 'languageswitcherload', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0', 'mod_languages', '1', '1', '{\"header_text\":\"\",\"footer_text\":\"\",\"image\":\"1\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*'),
('65', 'About Fruit Shop', '', '<p>The Fruit Shop site shows a number of Joomla! features.</p><p>The template uses classes in cascading style sheets to change the layout of items, such as creating the horizontal alphabetical list in the Fruit Encyclopedia.</p><p> </p>', '1', 'position-4', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_custom', '1', '1', '{\"prepare_content\":\"1\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*'),
('69', 'Articles Category', '', '', '1', '', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_articles_category', '1', '1', '{\"mode\":\"normal\",\"show_on_article_page\":\"1\",\"show_front\":\"show\",\"count\":\"0\",\"category_filtering_type\":\"1\",\"catid\":[\"72\"],\"show_child_category_articles\":\"0\",\"levels\":\"1\",\"author_filtering_type\":\"1\",\"created_by\":[\"\"],\"author_alias_filtering_type\":\"1\",\"created_by_alias\":[\"\"],\"excluded_articles\":\"\",\"date_filtering\":\"off\",\"date_field\":\"a.created\",\"start_date_range\":\"\",\"end_date_range\":\"\",\"relative_date\":\"30\",\"article_ordering\":\"a.title\",\"article_ordering_direction\":\"ASC\",\"article_grouping\":\"none\",\"article_grouping_direction\":\"ksort\",\"month_year_format\":\"F Y\",\"item_heading\":\"4\",\"link_titles\":\"1\",\"show_date\":\"0\",\"show_date_field\":\"created\",\"show_date_format\":\"Y-m-d H:i:s\",\"show_category\":\"0\",\"show_hits\":\"0\",\"show_author\":\"0\",\"show_introtext\":\"0\",\"introtext_limit\":\"100\",\"show_readmore\":\"0\",\"show_readmore_title\":\"1\",\"readmore_limit\":\"15\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"owncache\":\"1\",\"cache_time\":\"900\"}', '0', '*'),
('70', 'Search (Atomic Template)', '', '', '1', 'atomic-search', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_search', '1', '0', '{\"width\":\"20\",\"text\":\"\",\"button\":\"\",\"button_pos\":\"right\",\"imagebutton\":\"\",\"button_text\":\"\",\"set_itemid\":\"\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}', '0', '*'),
('71', 'Top Menu (Atomic Template)', '', '', '1', 'atomic-topmenu', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_menu', '1', '0', '{\"menutype\":\"aboutjoomla\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}', '0', '*'),
('72', 'Top Quote (Atomic Template)', '', '<hr />\r\n<h2 class=\"alt\">Powerful Content Management and a Simple Extensible Framework.</h2>\r\n<hr />', '1', 'atomic-topquote', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_custom', '1', '0', '{\"prepare_content\":\"1\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*'),
('73', 'Bottom Left Column (Atomic Template)', '', '<h6>This is a nested column</h6>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>', '1', 'atomic-bottomleft', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_custom', '1', '0', '{\"prepare_content\":\"1\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*'),
('74', 'Bottom Middle Column (Atomic Template)', '', '<h6>This is another nested column</h6>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>', '1', 'atomic-bottommiddle', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_custom', '1', '0', '{\"prepare_content\":\"1\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*'),
('75', 'Sidebar (Atomic Template)', '', '<h3>A <span class=\"alt\">Simple</span> Sidebar</h3>\r\n<p>Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Cras ornare mattis nunc. Mauris venenatis, pede sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue.</p>\r\n<p class=\"quiet\">Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Cras ornare mattis nunc. Mauris venenatis, pede sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue.</p>\r\n<h5>Incremental leading</h5>\r\n<p class=\"incr\">Vestibulum ante ipsum primis in faucibus orci luctus vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Cras ornare mattis nunc. Mauris venenatis, pede sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue. sed aliquet vehicula, lectus tellus.</p>\r\n<p class=\"incr\">Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Cras ornare mattis nunc. Mauris venenatis, pede sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue. sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue. ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Cras ornare mattis nunc. Mauris venenatis, pede sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue. sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue.</p>', '1', 'atomic-sidebar', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_custom', '1', '0', '{\"prepare_content\":\"1\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}', '0', '*'),
('76', 'Login (Atomic Template)', '', '', '2', 'atomic-sidebar', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_login', '1', '0', '{\"pretext\":\"\",\"posttext\":\"\",\"login\":\"\",\"logout\":\"\",\"greeting\":\"1\",\"name\":\"0\",\"usesecure\":\"0\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}', '0', '*'),
('77', 'Shop', '', '', '1', 'position-11', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_banners', '1', '0', '{\"target\":\"1\",\"count\":\"1\",\"cid\":\"2\",\"catid\":[\"15\"],\"tag_search\":\"0\",\"ordering\":\"0\",\"header_text\":\"\",\"footer_text\":\"Shop!\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\"}', '0', '*'),
('78', 'Contribute', '', '', '1', 'position-9', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_banners', '1', '0', '{\"target\":\"1\",\"count\":\"1\",\"cid\":\"1\",\"catid\":[\"15\"],\"tag_search\":\"0\",\"ordering\":\"0\",\"header_text\":\"\",\"footer_text\":\"Contribute! \",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\"}', '0', '*'),
('84', 'Smart Search Module', '', '', '2', '', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '1', 'mod_finder', '1', '1', '{\"searchfilter\":\"\",\"show_autosuggest\":\"1\",\"show_advanced\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"field_size\":20,\"alt_label\":\"\",\"show_label\":\"0\",\"label_pos\":\"top\",\"show_button\":\"0\",\"button_pos\":\"right\",\"opensearch\":\"1\",\"opensearch_title\":\"\"}', '0', '*'),
('87', 'GCalendar Overview', '', '', '0', '', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0', 'mod_gcalendar', '1', '1', '', '0', '*'),
('88', 'GCalendar Upcoming', '', '', '0', '', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0', 'mod_gcalendar_upcoming', '1', '1', '', '0', '*'),
('89', 'GCalendar Next', '', '', '0', '', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0', 'mod_gcalendar_next', '1', '1', '', '0', '*'),
('90', 'Zap Weather', '', '', '0', '', '0', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0', 'mod_zweather', '1', '1', '', '0', '*');

DROP TABLE IF EXISTS `tkt_modules_menu`;
CREATE TABLE `tkt_modules_menu` (
  `moduleid` int(11) NOT NULL DEFAULT '0',
  `menuid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`moduleid`,`menuid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO tkt_modules_menu
(`moduleid`, `menuid`) VALUES 
('1', '101'),
('2', '0'),
('3', '0'),
('4', '0'),
('6', '0'),
('7', '0'),
('8', '0'),
('9', '0'),
('10', '0'),
('12', '0'),
('13', '0'),
('14', '0'),
('15', '0'),
('16', '205'),
('16', '435'),
('17', '0'),
('18', '0'),
('19', '-463'),
('19', '-462'),
('19', '-433'),
('19', '-432'),
('19', '-431'),
('19', '-430'),
('19', '-429'),
('19', '-427'),
('19', '-400'),
('19', '-399'),
('19', '-296'),
('19', '-244'),
('19', '-243'),
('19', '-242'),
('19', '-234'),
('20', '0'),
('22', '231'),
('22', '234'),
('22', '238'),
('22', '242'),
('22', '243'),
('22', '244'),
('22', '296'),
('22', '399'),
('22', '400'),
('23', '-463'),
('23', '-462'),
('23', '-433'),
('23', '-432'),
('23', '-431'),
('23', '-430'),
('23', '-429'),
('23', '-427');

INSERT INTO tkt_modules_menu
(`moduleid`, `menuid`) VALUES 
('23', '-400'),
('23', '-399'),
('23', '-296'),
('23', '-244'),
('23', '-243'),
('23', '-242'),
('23', '-238'),
('23', '-234'),
('25', '294'),
('26', '-463'),
('26', '-462'),
('26', '-433'),
('26', '-432'),
('26', '-431'),
('26', '-430'),
('26', '-429'),
('26', '-427'),
('26', '-400'),
('26', '-399'),
('26', '-296'),
('26', '-244'),
('26', '-243'),
('26', '-242'),
('26', '-238'),
('26', '-234'),
('27', '325'),
('28', '310'),
('29', '302'),
('30', '410'),
('31', '309'),
('32', '309'),
('33', '307'),
('34', '326'),
('35', '306'),
('36', '304'),
('37', '311'),
('38', '300'),
('39', '301'),
('40', '313'),
('41', '324'),
('44', '312'),
('45', '303'),
('47', '231'),
('47', '234'),
('47', '242'),
('47', '243'),
('47', '244'),
('47', '296'),
('47', '399'),
('47', '400');

INSERT INTO tkt_modules_menu
(`moduleid`, `menuid`) VALUES 
('48', '418'),
('49', '417'),
('52', '416'),
('56', '305'),
('57', '238'),
('57', '427'),
('57', '429'),
('57', '430'),
('57', '431'),
('57', '432'),
('57', '433'),
('57', '462'),
('57', '463'),
('58', '427'),
('58', '429'),
('58', '430'),
('58', '431'),
('58', '432'),
('58', '433'),
('58', '462'),
('58', '463'),
('61', '443'),
('62', '231'),
('62', '234'),
('62', '242'),
('62', '243'),
('62', '244'),
('62', '296'),
('62', '399'),
('62', '400'),
('63', '0'),
('64', '447'),
('65', '427'),
('65', '429'),
('65', '430'),
('65', '431'),
('65', '432'),
('65', '433'),
('65', '462'),
('65', '463'),
('68', '243'),
('69', '459'),
('70', '285'),
('70', '316'),
('71', '285'),
('71', '316'),
('72', '285'),
('72', '316'),
('73', '285'),
('73', '316');

INSERT INTO tkt_modules_menu
(`moduleid`, `menuid`) VALUES 
('74', '285'),
('74', '316'),
('75', '285'),
('75', '316'),
('76', '285'),
('76', '316'),
('77', '0'),
('78', '0'),
('79', '0'),
('84', '467'),
('86', '0'),
('92', '0'),
('93', '0');

DROP TABLE IF EXISTS `tkt_newsfeeds`;
CREATE TABLE `tkt_newsfeeds` (
  `catid` int(11) NOT NULL DEFAULT '0',
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `link` varchar(200) NOT NULL DEFAULT '',
  `filename` varchar(200) DEFAULT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `numarticles` int(10) unsigned NOT NULL DEFAULT '1',
  `cache_time` int(10) unsigned NOT NULL DEFAULT '3600',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rtl` tinyint(4) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;

INSERT INTO tkt_newsfeeds
(`catid`, `id`, `name`, `alias`, `link`, `filename`, `published`, `numarticles`, `cache_time`, `checked_out`, `checked_out_time`, `ordering`, `rtl`, `access`, `language`, `params`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `xreference`, `publish_up`, `publish_down`) VALUES 
('17', '1', 'Joomla! Announcements', 'joomla-announcements', 'http://www.joomla.org/announcements.feed?type=rss', '', '1', '5', '3600', '0', '0000-00-00 00:00:00', '1', '1', '1', 'en-GB', '{\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"newsfeed_layout\":\"\",\"feed_display_order\":\"\"}', '2011-01-01 00:00:01', '242', '', '2011-12-27 12:25:05', '42', '', '', '{\"robots\":\"\",\"rights\":\"\"}', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
('17', '2', 'New Joomla! Extensions', 'new-joomla-extensions', 'http://feeds.joomla.org/JoomlaExtensions', '', '1', '5', '3600', '0', '0000-00-00 00:00:00', '4', '1', '1', 'en-GB', '{\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"newsfeed_layout\":\"\",\"feed_display_order\":\"\"}', '2011-01-01 00:00:01', '242', '', '2011-12-27 12:25:36', '42', '', '', '{\"robots\":\"\",\"rights\":\"\"}', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
('17', '3', 'Joomla! Security News', 'joomla-security-news', 'http://feeds.joomla.org/JoomlaSecurityNews', '', '1', '5', '3600', '0', '0000-00-00 00:00:00', '2', '1', '1', 'en-GB', '{\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"newsfeed_layout\":\"\",\"feed_display_order\":\"\"}', '2011-01-01 00:00:01', '242', '', '2011-12-27 12:24:55', '42', '', '', '{\"robots\":\"\",\"rights\":\"\"}', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
('17', '4', 'Joomla! Connect', 'joomla-connect', 'http://feeds.joomla.org/JoomlaConnect', '', '1', '5', '3600', '0', '0000-00-00 00:00:00', '3', '1', '1', 'en-GB', '{\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"newsfeed_layout\":\"\",\"feed_display_order\":\"\"}', '2011-01-01 00:00:01', '242', '', '2011-12-27 12:25:10', '42', '', '', '{\"robots\":\"\",\"rights\":\"\"}', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00');

DROP TABLE IF EXISTS `tkt_overrider`;
CREATE TABLE `tkt_overrider` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `constant` varchar(255) NOT NULL,
  `string` text NOT NULL,
  `file` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_redirect_links`;
CREATE TABLE `tkt_redirect_links` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `old_url` varchar(255) NOT NULL,
  `new_url` varchar(255) NOT NULL,
  `referer` varchar(150) NOT NULL,
  `comment` varchar(255) NOT NULL,
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `published` tinyint(4) NOT NULL,
  `created_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_link_old` (`old_url`),
  KEY `idx_link_modifed` (`modified_date`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_schemas`;
CREATE TABLE `tkt_schemas` (
  `extension_id` int(11) NOT NULL,
  `version_id` varchar(20) NOT NULL,
  PRIMARY KEY (`extension_id`,`version_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO tkt_schemas
(`extension_id`, `version_id`) VALUES 
('700', '2.5.14'),
('10021', '4.5.0'),
('10029', '1.1.4'),
('10030', '1.1.6'),
('10031', '1.0.7'),
('10032', '1.1.3'),
('10033', '1.0.1'),
('10034', '1.0.0'),
('10035', '1.0.3'),
('10036', '2.1.0');

DROP TABLE IF EXISTS `tkt_session`;
CREATE TABLE `tkt_session` (
  `session_id` varchar(200) NOT NULL DEFAULT '',
  `client_id` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `guest` tinyint(4) unsigned DEFAULT '1',
  `time` varchar(14) DEFAULT '',
  `data` mediumtext,
  `userid` int(11) DEFAULT '0',
  `username` varchar(150) DEFAULT '',
  `usertype` varchar(50) DEFAULT '',
  PRIMARY KEY (`session_id`),
  KEY `whosonline` (`guest`,`usertype`),
  KEY `userid` (`userid`),
  KEY `time` (`time`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO tkt_session
(`session_id`, `client_id`, `guest`, `time`, `data`, `userid`, `username`, `usertype`) VALUES 
('kc82dpuk8f86q53c5so4sn9gs4', '0', '1', '1379952568', '__default|a:8:{s:15:\"session.counter\";i:21;s:19:\"session.timer.start\";i:1379947410;s:18:\"session.timer.last\";i:1379952380;s:17:\"session.timer.now\";i:1379952567;s:22:\"session.client.browser\";s:81:\"Mozilla/5.0 (Macintosh; Intel Mac OS X 10.6; rv:18.0) Gecko/20100101 Firefox/18.0\";s:8:\"registry\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":0:{}}s:4:\"user\";O:5:\"JUser\":25:{s:9:\"\0*\0isRoot\";b:0;s:2:\"id\";i:0;s:4:\"name\";N;s:8:\"username\";N;s:5:\"email\";N;s:8:\"password\";N;s:14:\"password_clear\";s:0:\"\";s:8:\"usertype\";N;s:5:\"block\";N;s:9:\"sendEmail\";i:0;s:12:\"registerDate\";N;s:13:\"lastvisitDate\";N;s:10:\"activation\";N;s:6:\"params\";N;s:6:\"groups\";a:0:{}s:5:\"guest\";i:1;s:13:\"lastResetTime\";N;s:10:\"resetCount\";N;s:10:\"\0*\0_params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":0:{}}s:14:\"\0*\0_authGroups\";a:1:{i:0;i:1;}s:14:\"\0*\0_authLevels\";a:2:{i:0;i:1;i:1;i:1;}s:15:\"\0*\0_authActions\";N;s:12:\"\0*\0_errorMsg\";N;s:10:\"\0*\0_errors\";a:0:{}s:3:\"aid\";i:0;}s:13:\"session.token\";s:32:\"a5e99e91cc57e3d1120deb55d9251d3e\";}', '0', '', ''),
('962303c7d1bdf5ba3d7e8bf5ee711474', '1', '0', '1379952609', '__default|a:8:{s:22:\"session.client.browser\";s:81:\"Mozilla/5.0 (Macintosh; Intel Mac OS X 10.6; rv:18.0) Gecko/20100101 Firefox/18.0\";s:15:\"session.counter\";i:51;s:8:\"registry\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":5:{s:11:\"application\";O:8:\"stdClass\":1:{s:4:\"lang\";s:0:\"\";}s:13:\"com_installer\";O:8:\"stdClass\":3:{s:7:\"message\";s:0:\"\";s:17:\"extension_message\";s:0:\"\";s:12:\"redirect_url\";N;}s:13:\"com_templates\";O:8:\"stdClass\":2:{s:6:\"styles\";O:8:\"stdClass\":1:{s:10:\"limitstart\";i:0;}s:4:\"edit\";O:8:\"stdClass\":1:{s:5:\"style\";O:8:\"stdClass\":2:{s:2:\"id\";a:1:{i:0;i:115;}s:4:\"data\";N;}}}s:3:\"jsn\";O:8:\"stdClass\":1:{s:8:\"template\";O:8:\"stdClass\":2:{s:18:\"maxCompressionSize\";s:3:\"100\";s:14:\"cacheDirectory\";s:6:\"cache/\";}}s:9:\"com_menus\";O:8:\"stdClass\":2:{s:5:\"items\";O:8:\"stdClass\":2:{s:6:\"filter\";O:8:\"stdClass\":1:{s:8:\"menutype\";s:8:\"mainmenu\";}s:10:\"limitstart\";i:0;}s:4:\"edit\";O:8:\"stdClass\":1:{s:4:\"item\";O:8:\"stdClass\":4:{s:2:\"id\";a:1:{i:0;i:435;}s:4:\"data\";N;s:4:\"type\";N;s:4:\"link\";N;}}}}}s:4:\"user\";O:5:\"JUser\":25:{s:9:\"\0*\0isRoot\";b:1;s:2:\"id\";s:3:\"242\";s:4:\"name\";s:10:\"Super User\";s:8:\"username\";s:5:\"jimsz\";s:5:\"email\";s:12:\"jim@2047.org\";s:8:\"password\";s:65:\"d560d2456fecbbd640299b647d37f615:vl556mjNDo2hxzCzudIcqXZRAzfkelbi\";s:14:\"password_clear\";s:0:\"\";s:8:\"usertype\";s:10:\"deprecated\";s:5:\"block\";s:1:\"0\";s:9:\"sendEmail\";s:1:\"1\";s:12:\"registerDate\";s:19:\"2013-09-21 13:29:56\";s:13:\"lastvisitDate\";s:19:\"2013-09-23 15:01:46\";s:10:\"activation\";s:1:\"0\";s:6:\"params\";s:0:\"\";s:6:\"groups\";a:1:{i:8;s:1:\"8\";}s:5:\"guest\";i:0;s:13:\"lastResetTime\";s:19:\"0000-00-00 00:00:00\";s:10:\"resetCount\";s:1:\"0\";s:10:\"\0*\0_params\";O:9:\"JRegistry\":1:{s:7:\"\0*\0data\";O:8:\"stdClass\":0:{}}s:14:\"\0*\0_authGroups\";a:2:{i:0;i:1;i:1;i:8;}s:14:\"\0*\0_authLevels\";a:4:{i:0;i:1;i:1;i:1;i:2;i:2;i:3;i:3;}s:15:\"\0*\0_authActions\";N;s:12:\"\0*\0_errorMsg\";N;s:10:\"\0*\0_errors\";a:0:{}s:3:\"aid\";i:0;}s:13:\"session.token\";s:32:\"a208b173caa1e732b34476020d151a78\";s:19:\"session.timer.start\";i:1379951078;s:18:\"session.timer.last\";i:1379952592;s:17:\"session.timer.now\";i:1379952602;}', '242', 'jimsz', '');

DROP TABLE IF EXISTS `tkt_template_styles`;
CREATE TABLE `tkt_template_styles` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `template` varchar(50) NOT NULL DEFAULT '',
  `client_id` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `home` char(7) NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_template` (`template`),
  KEY `idx_home` (`home`)
) ENGINE=MyISAM AUTO_INCREMENT=116 DEFAULT CHARSET=utf8;

INSERT INTO tkt_template_styles
(`id`, `template`, `client_id`, `home`, `title`, `params`) VALUES 
('2', 'bluestork', '1', '1', 'Bluestork - Default', '{\"useRoundedCorners\":\"1\",\"showSiteName\":\"0\"}'),
('3', 'atomic', '0', '0', 'Atomic - Default', '{}'),
('4', 'beez_20', '0', '0', 'Beez2 - Default', '{\"wrapperSmall\":53,\"wrapperLarge\":72,\"logo\":\"images\\/joomla_black.gif\",\"sitetitle\":\"Joomla!\",\"sitedescription\":\"Open Source Content Management\",\"navposition\":\"left\",\"templatecolor\":\"personal\"}'),
('5', 'hathor', '1', '0', 'Hathor - Default', '{\"showSiteName\":\"0\",\"colourChoice\":\"\",\"boldText\":\"0\"}'),
('6', 'beez5', '0', '0', 'Beez5 - Default', '{\"wrapperSmall\":53,\"wrapperLarge\":72,\"logo\":\"images\\/sampledata\\/fruitshop\\/fruits.gif\",\"sitetitle\":\"Joomla!\",\"sitedescription\":\"Open Source Content Management\",\"navposition\":\"left\",\"html5\":0}'),
('114', 'beez_20', '0', '0', 'Beez2 - Parks Site', '{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"logo\":\"\",\"sitetitle\":\"Australian Parks\",\"sitedescription\":\"Parks Sample Site\",\"navposition\":\"center\",\"templatecolor\":\"nature\"}'),
('115', 'jsn_metro_pro', '0', '1', 'JSN Metro PRO - Default', '{\"logoColored\":\"1\",\"logoLink\":\"index.php\",\"logoSlogan\":\"\",\"layoutWidth\":\"float\",\"layoutNarrowWidth\":\"960\",\"layoutWideWidth\":\"1150\",\"layoutFloatWidth\":\"90\",\"showFrontpage\":\"1\",\"columnPromoLeft\":\"23\",\"columnPromoRight\":\"23\",\"columnLeft\":\"23\",\"columnRight\":\"23\",\"columnInnerleft\":\"28\",\"columnInnerright\":\"28\",\"mobileSupport\":\"1\",\"desktopSwitcher\":\"1\",\"mobileLogo\":\"\",\"templateColor\":\"image\",\"templateStyle\":\"business\",\"textSize\":\"medium\",\"useSpecialFont\":\"1\",\"useCSS3Effect\":\"1\",\"mainMenuWidth\":\"205\",\"sideMenuWidth\":\"200\",\"sitetoolStyle\":\"menu\",\"textSizeSelector\":\"1\",\"widthSelector\":\"1\",\"colorSelector\":\"1\",\"sitetoolsColorsItems\":[\"blue\",\"red\",\"green\",\"violet\",\"white\",\"image\"],\"sitetoolsColors\":\"{\\\"list\\\":[\\\"blue\\\",\\\"red\\\",\\\"green\\\",\\\"violet\\\",\\\"orange\\\",\\\"grey\\\"],\\\"colors\\\":[\\\"blue\\\",\\\"red\\\",\\\"green\\\",\\\"violet\\\",\\\"orange\\\",\\\"grey\\\"]}\",\"enableH1\":\"1\",\"gotoTop\":\"1\",\"autoIconLink\":\"0\",\"printOptimize\":\"0\",\"compression\":\"0\",\"maxCompressionSize\":\"100\",\"compressionExclude\":\"\",\"cacheDirectory\":\"cache\\/\",\"codePosition\":\"0\",\"codeAnalytic\":\"\",\"cssFiles\":\"custom.css\",\"useSqueezeBox\":\"0\",\"scriptMovement\":\"0\"}');

DROP TABLE IF EXISTS `tkt_update_categories`;
CREATE TABLE `tkt_update_categories` (
  `categoryid` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(20) DEFAULT '',
  `description` text NOT NULL,
  `parent` int(11) DEFAULT '0',
  `updatesite` int(11) DEFAULT '0',
  PRIMARY KEY (`categoryid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Update Categories';

DROP TABLE IF EXISTS `tkt_update_sites`;
CREATE TABLE `tkt_update_sites` (
  `update_site_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `location` text NOT NULL,
  `enabled` int(11) DEFAULT '0',
  `last_check_timestamp` bigint(20) DEFAULT '0',
  PRIMARY KEY (`update_site_id`)
) ENGINE=MyISAM AUTO_INCREMENT=7 DEFAULT CHARSET=utf8 COMMENT='Update Sites';

INSERT INTO tkt_update_sites
(`update_site_id`, `name`, `type`, `location`, `enabled`, `last_check_timestamp`) VALUES 
('1', 'Joomla Core', 'collection', 'http://update.joomla.org/core/list.xml', '1', '1379948509'),
('2', 'Joomla Extension Directory', 'collection', 'http://update.joomla.org/jed/list.xml', '1', '1379948509'),
('3', 'Accredited Joomla! Translations', 'collection', 'http://update.joomla.org/language/translationlist.xml', '1', '1379948509'),
('4', 'GCalendar Update Site', 'extension', 'http://g4j.digital-peak.com/index.php?option=com_ars&view=update&task=stream&format=xml&id=1&ext=extension.xml', '1', '1379948511'),
('5', 'Z Content Updates', 'extension', 'http://zcontent.net/xml/zweather.xml', '1', '1379948511'),
('6', 'eshiol.it', 'extension', 'http://www.eshiol.it/update/com_j2xmlimporter/extension.xml', '1', '1379948511');

DROP TABLE IF EXISTS `tkt_update_sites_extensions`;
CREATE TABLE `tkt_update_sites_extensions` (
  `update_site_id` int(11) NOT NULL DEFAULT '0',
  `extension_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`update_site_id`,`extension_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Links extensions to update sites';

INSERT INTO tkt_update_sites_extensions
(`update_site_id`, `extension_id`) VALUES 
('1', '700'),
('2', '700'),
('3', '600'),
('4', '10006'),
('5', '10007'),
('6', '10018');

DROP TABLE IF EXISTS `tkt_updates`;
CREATE TABLE `tkt_updates` (
  `update_id` int(11) NOT NULL AUTO_INCREMENT,
  `update_site_id` int(11) DEFAULT '0',
  `extension_id` int(11) DEFAULT '0',
  `categoryid` int(11) DEFAULT '0',
  `name` varchar(100) DEFAULT '',
  `description` text NOT NULL,
  `element` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `folder` varchar(20) DEFAULT '',
  `client_id` tinyint(3) DEFAULT '0',
  `version` varchar(10) DEFAULT '',
  `data` text NOT NULL,
  `detailsurl` text NOT NULL,
  `infourl` text NOT NULL,
  PRIMARY KEY (`update_id`)
) ENGINE=MyISAM AUTO_INCREMENT=64 DEFAULT CHARSET=utf8 COMMENT='Available Updates';

INSERT INTO tkt_updates
(`update_id`, `update_site_id`, `extension_id`, `categoryid`, `name`, `description`, `element`, `type`, `folder`, `client_id`, `version`, `data`, `detailsurl`, `infourl`) VALUES 
('1', '3', '0', '0', 'Armenian', '', 'pkg_hy-AM', 'package', '', '0', '2.5.8.1', '', 'http://update.joomla.org/language/details/hy-AM_details.xml', ''),
('2', '3', '0', '0', 'Bahasa Indonesia', '', 'pkg_id-ID', 'package', '', '0', '2.5.13.1', '', 'http://update.joomla.org/language/details/id-ID_details.xml', ''),
('3', '3', '0', '0', 'Danish', '', 'pkg_da-DK', 'package', '', '0', '2.5.14.1', '', 'http://update.joomla.org/language/details/da-DK_details.xml', ''),
('4', '3', '0', '0', 'Khmer', '', 'pkg_km-KH', 'package', '', '0', '2.5.7.1', '', 'http://update.joomla.org/language/details/km-KH_details.xml', ''),
('5', '3', '0', '0', 'Swedish', '', 'pkg_sv-SE', 'package', '', '0', '2.5.10.1', '', 'http://update.joomla.org/language/details/sv-SE_details.xml', ''),
('6', '3', '0', '0', 'Hungarian', '', 'pkg_hu-HU', 'package', '', '0', '2.5.8.1', '', 'http://update.joomla.org/language/details/hu-HU_details.xml', ''),
('7', '3', '0', '0', 'Bulgarian', '', 'pkg_bg-BG', 'package', '', '0', '2.5.7.1', '', 'http://update.joomla.org/language/details/bg-BG_details.xml', ''),
('8', '3', '0', '0', 'French', '', 'pkg_fr-FR', 'package', '', '0', '2.5.13.1', '', 'http://update.joomla.org/language/details/fr-FR_details.xml', ''),
('9', '3', '0', '0', 'Italian', '', 'pkg_it-IT', 'package', '', '0', '2.5.14.1', '', 'http://update.joomla.org/language/details/it-IT_details.xml', ''),
('10', '3', '0', '0', 'Spanish', '', 'pkg_es-ES', 'package', '', '0', '2.5.14.1', '', 'http://update.joomla.org/language/details/es-ES_details.xml', ''),
('11', '3', '0', '0', 'Dutch', '', 'pkg_nl-NL', 'package', '', '0', '2.5.14.1', '', 'http://update.joomla.org/language/details/nl-NL_details.xml', ''),
('12', '3', '0', '0', 'Turkish', '', 'pkg_tr-TR', 'package', '', '0', '2.5.13.1', '', 'http://update.joomla.org/language/details/tr-TR_details.xml', ''),
('13', '3', '0', '0', 'Ukrainian', '', 'pkg_uk-UA', 'package', '', '0', '2.5.13.11', '', 'http://update.joomla.org/language/details/uk-UA_details.xml', ''),
('14', '3', '0', '0', 'Slovak', '', 'pkg_sk-SK', 'package', '', '0', '2.5.14.2', '', 'http://update.joomla.org/language/details/sk-SK_details.xml', ''),
('15', '3', '0', '0', 'Belarusian', '', 'pkg_be-BY', 'package', '', '0', '2.5.8.1', '', 'http://update.joomla.org/language/details/be-BY_details.xml', ''),
('16', '3', '0', '0', 'Latvian', '', 'pkg_lv-LV', 'package', '', '0', '2.5.13.1', '', 'http://update.joomla.org/language/details/lv-LV_details.xml', ''),
('17', '3', '0', '0', 'Estonian', '', 'pkg_et-EE', 'package', '', '0', '2.5.7.1', '', 'http://update.joomla.org/language/details/et-EE_details.xml', ''),
('18', '3', '0', '0', 'Romanian', '', 'pkg_ro-RO', 'package', '', '0', '2.5.11.1', '', 'http://update.joomla.org/language/details/ro-RO_details.xml', ''),
('19', '3', '0', '0', 'Flemish', '', 'pkg_nl-BE', 'package', '', '0', '2.5.14.1', '', 'http://update.joomla.org/language/details/nl-BE_details.xml', ''),
('20', '3', '0', '0', 'Macedonian', '', 'pkg_mk-MK', 'package', '', '0', '2.5.13.1', '', 'http://update.joomla.org/language/details/mk-MK_details.xml', ''),
('21', '3', '0', '0', 'Japanese', '', 'pkg_ja-JP', 'package', '', '0', '2.5.14.1', '', 'http://update.joomla.org/language/details/ja-JP_details.xml', ''),
('22', '3', '0', '0', 'Serbian Latin', '', 'pkg_sr-YU', 'package', '', '0', '2.5.13.1', '', 'http://update.joomla.org/language/details/sr-YU_details.xml', ''),
('23', '3', '0', '0', 'Arabic Unitag', '', 'pkg_ar-AA', 'package', '', '0', '2.5.13.1', '', 'http://update.joomla.org/language/details/ar-AA_details.xml', ''),
('24', '3', '0', '0', 'German', '', 'pkg_de-DE', 'package', '', '0', '2.5.14.1', '', 'http://update.joomla.org/language/details/de-DE_details.xml', ''),
('25', '3', '0', '0', 'Norwegian Bokmal', '', 'pkg_nb-NO', 'package', '', '0', '2.5.11.1', '', 'http://update.joomla.org/language/details/nb-NO_details.xml', ''),
('26', '3', '0', '0', 'English AU', '', 'pkg_en-AU', 'package', '', '0', '2.5.10.1', '', 'http://update.joomla.org/language/details/en-AU_details.xml', ''),
('27', '3', '0', '0', 'English US', '', 'pkg_en-US', 'package', '', '0', '2.5.10.1', '', 'http://update.joomla.org/language/details/en-US_details.xml', ''),
('28', '3', '0', '0', 'Serbian Cyrillic', '', 'pkg_sr-RS', 'package', '', '0', '2.5.13.1', '', 'http://update.joomla.org/language/details/sr-RS_details.xml', ''),
('29', '3', '0', '0', 'Lithuanian', '', 'pkg_lt-LT', 'package', '', '0', '2.5.7.1', '', 'http://update.joomla.org/language/details/lt-LT_details.xml', ''),
('30', '3', '0', '0', 'Albanian', '', 'pkg_sq-AL', 'package', '', '0', '2.5.1.5', '', 'http://update.joomla.org/language/details/sq-AL_details.xml', ''),
('31', '3', '0', '0', 'Czech', '', 'pkg_cs-CZ', 'package', '', '0', '2.5.13.1', '', 'http://update.joomla.org/language/details/cs-CZ_details.xml', ''),
('32', '3', '0', '0', 'Persian', '', 'pkg_fa-IR', 'package', '', '0', '2.5.13.1', '', 'http://update.joomla.org/language/details/fa-IR_details.xml', ''),
('33', '3', '0', '0', 'Galician', '', 'pkg_gl-ES', 'package', '', '0', '2.5.7.4', '', 'http://update.joomla.org/language/details/gl-ES_details.xml', ''),
('34', '3', '0', '0', 'Polish', '', 'pkg_pl-PL', 'package', '', '0', '2.5.14.1', '', 'http://update.joomla.org/language/details/pl-PL_details.xml', ''),
('35', '3', '0', '0', 'Syriac', '', 'pkg_sy-IQ', 'package', '', '0', '2.5.10.1', '', 'http://update.joomla.org/language/details/sy-IQ_details.xml', ''),
('36', '3', '0', '0', 'Portuguese', '', 'pkg_pt-PT', 'package', '', '0', '2.5.8.1', '', 'http://update.joomla.org/language/details/pt-PT_details.xml', ''),
('37', '3', '0', '0', 'Russian', '', 'pkg_ru-RU', 'package', '', '0', '2.5.13.1', '', 'http://update.joomla.org/language/details/ru-RU_details.xml', ''),
('38', '3', '0', '0', 'Hebrew', '', 'pkg_he-IL', 'package', '', '0', '2.5.7.1', '', 'http://update.joomla.org/language/details/he-IL_details.xml', ''),
('39', '3', '0', '0', 'Catalan', '', 'pkg_ca-ES', 'package', '', '0', '2.5.13.1', '', 'http://update.joomla.org/language/details/ca-ES_details.xml', ''),
('40', '3', '0', '0', 'Laotian', '', 'pkg_lo-LA', 'package', '', '0', '2.5.6.1', '', 'http://update.joomla.org/language/details/lo-LA_details.xml', ''),
('41', '3', '0', '0', 'Afrikaans', '', 'pkg_af-ZA', 'package', '', '0', '2.5.14.1', '', 'http://update.joomla.org/language/details/af-ZA_details.xml', ''),
('42', '3', '0', '0', 'Chinese Simplified', '', 'pkg_zh-CN', 'package', '', '0', '2.5.14.1', '', 'http://update.joomla.org/language/details/zh-CN_details.xml', ''),
('43', '3', '0', '0', 'Greek', '', 'pkg_el-GR', 'package', '', '0', '2.5.6.1', '', 'http://update.joomla.org/language/details/el-GR_details.xml', ''),
('44', '3', '0', '0', 'Esperanto', '', 'pkg_eo-XX', 'package', '', '0', '2.5.6.1', '', 'http://update.joomla.org/language/details/eo-XX_details.xml', ''),
('45', '3', '0', '0', 'Finnish', '', 'pkg_fi-FI', 'package', '', '0', '2.5.13.1', '', 'http://update.joomla.org/language/details/fi-FI_details.xml', ''),
('46', '3', '0', '0', 'Portuguese Brazil', '', 'pkg_pt-BR', 'package', '', '0', '2.5.9.1', '', 'http://update.joomla.org/language/details/pt-BR_details.xml', ''),
('47', '3', '0', '0', 'Chinese Traditional', '', 'pkg_zh-TW', 'package', '', '0', '2.5.13.1', '', 'http://update.joomla.org/language/details/zh-TW_details.xml', ''),
('48', '3', '0', '0', 'Vietnamese', '', 'pkg_vi-VN', 'package', '', '0', '2.5.8.1', '', 'http://update.joomla.org/language/details/vi-VN_details.xml', ''),
('49', '3', '0', '0', 'Kurdish Sorani', '', 'pkg_ckb-IQ', 'package', '', '0', '2.5.9.1', '', 'http://update.joomla.org/language/details/ckb-IQ_details.xml', ''),
('50', '3', '0', '0', 'Bosnian', '', 'pkg_bs-BA', 'package', '', '0', '2.5.11.1', '', 'http://update.joomla.org/language/details/bs-BA_details.xml', '');

INSERT INTO tkt_updates
(`update_id`, `update_site_id`, `extension_id`, `categoryid`, `name`, `description`, `element`, `type`, `folder`, `client_id`, `version`, `data`, `detailsurl`, `infourl`) VALUES 
('51', '3', '0', '0', 'Croatian', '', 'pkg_hr-HR', 'package', '', '0', '2.5.13.1', '', 'http://update.joomla.org/language/details/hr-HR_details.xml', ''),
('52', '3', '0', '0', 'Azeri', '', 'pkg_az-AZ', 'package', '', '0', '2.5.7.1', '', 'http://update.joomla.org/language/details/az-AZ_details.xml', ''),
('53', '3', '0', '0', 'Norwegian Nynorsk', '', 'pkg_nn-NO', 'package', '', '0', '2.5.8.1', '', 'http://update.joomla.org/language/details/nn-NO_details.xml', ''),
('54', '3', '0', '0', 'Tamil India', '', 'pkg_ta-IN', 'package', '', '0', '2.5.14.2', '', 'http://update.joomla.org/language/details/ta-IN_details.xml', ''),
('55', '3', '0', '0', 'Scottish Gaelic', '', 'pkg_gd-GB', 'package', '', '0', '2.5.7.1', '', 'http://update.joomla.org/language/details/gd-GB_details.xml', ''),
('56', '3', '0', '0', 'Thai', '', 'pkg_th-TH', 'package', '', '0', '2.5.13.1', '', 'http://update.joomla.org/language/details/th-TH_details.xml', ''),
('57', '3', '0', '0', 'Basque', '', 'pkg_eu-ES', 'package', '', '0', '1.7.0.1', '', 'http://update.joomla.org/language/details/eu-ES_details.xml', ''),
('58', '3', '0', '0', 'Uyghur', '', 'pkg_ug-CN', 'package', '', '0', '2.5.7.2', '', 'http://update.joomla.org/language/details/ug-CN_details.xml', ''),
('59', '3', '0', '0', 'Korean', '', 'pkg_ko-KR', 'package', '', '0', '2.5.11.1', '', 'http://update.joomla.org/language/details/ko-KR_details.xml', ''),
('60', '3', '0', '0', 'Hindi', '', 'pkg_hi-IN', 'package', '', '0', '2.5.6.1', '', 'http://update.joomla.org/language/details/hi-IN_details.xml', ''),
('61', '3', '0', '0', 'Welsh', '', 'pkg_cy-GB', 'package', '', '0', '2.5.6.1', '', 'http://update.joomla.org/language/details/cy-GB_details.xml', ''),
('62', '3', '0', '0', 'Swahili', '', 'pkg_sw-KE', 'package', '', '0', '2.5.14.1', '', 'http://update.joomla.org/language/details/sw-KE_details.xml', ''),
('63', '5', '10010', '0', 'Zap Weather 8', 'Weather for your Joomla website', 'pkg_zapweather', 'package', '', '0', '8.0.3', '', 'http://zcontent.net/xml/zweather.xml', 'http://zcontent.net/forum/zap-weather-announcements/3792-zap-weather-8-changelog');

DROP TABLE IF EXISTS `tkt_user_notes`;
CREATE TABLE `tkt_user_notes` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `subject` varchar(100) NOT NULL DEFAULT '',
  `body` text NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL,
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `review_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_user_id` (`user_id`),
  KEY `idx_category_id` (`catid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tkt_user_profiles`;
CREATE TABLE `tkt_user_profiles` (
  `user_id` int(11) NOT NULL,
  `profile_key` varchar(100) NOT NULL,
  `profile_value` varchar(255) NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  UNIQUE KEY `idx_user_id_profile_key` (`user_id`,`profile_key`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Simple user profile storage table';

DROP TABLE IF EXISTS `tkt_user_usergroup_map`;
CREATE TABLE `tkt_user_usergroup_map` (
  `user_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Foreign Key to #__users.id',
  `group_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Foreign Key to #__usergroups.id',
  PRIMARY KEY (`user_id`,`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO tkt_user_usergroup_map
(`user_id`, `group_id`) VALUES 
('242', '8');

DROP TABLE IF EXISTS `tkt_usergroups`;
CREATE TABLE `tkt_usergroups` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Adjacency List Reference Id',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `title` varchar(100) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_usergroup_parent_title_lookup` (`parent_id`,`title`),
  KEY `idx_usergroup_title_lookup` (`title`),
  KEY `idx_usergroup_adjacency_lookup` (`parent_id`),
  KEY `idx_usergroup_nested_set_lookup` (`lft`,`rgt`) USING BTREE
) ENGINE=MyISAM AUTO_INCREMENT=13 DEFAULT CHARSET=utf8;

INSERT INTO tkt_usergroups
(`id`, `parent_id`, `lft`, `rgt`, `title`) VALUES 
('1', '0', '1', '20', 'Public'),
('2', '1', '6', '17', 'Registered'),
('3', '2', '7', '14', 'Author'),
('4', '3', '8', '11', 'Editor'),
('5', '4', '9', '10', 'Publisher'),
('6', '1', '2', '5', 'Manager'),
('7', '6', '3', '4', 'Administrator'),
('8', '1', '18', '19', 'Super Users'),
('12', '2', '15', '16', 'Customer Group (Example)'),
('10', '3', '12', '13', 'Shop Suppliers (Example)');

DROP TABLE IF EXISTS `tkt_users`;
CREATE TABLE `tkt_users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `username` varchar(150) NOT NULL DEFAULT '',
  `email` varchar(100) NOT NULL DEFAULT '',
  `password` varchar(100) NOT NULL DEFAULT '',
  `usertype` varchar(25) NOT NULL DEFAULT '',
  `block` tinyint(4) NOT NULL DEFAULT '0',
  `sendEmail` tinyint(4) DEFAULT '0',
  `registerDate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `lastvisitDate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `activation` varchar(100) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  `lastResetTime` datetime NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Date of last password reset',
  `resetCount` int(11) NOT NULL DEFAULT '0' COMMENT 'Count of password resets since lastResetTime',
  PRIMARY KEY (`id`),
  KEY `usertype` (`usertype`),
  KEY `idx_name` (`name`),
  KEY `idx_block` (`block`),
  KEY `username` (`username`),
  KEY `email` (`email`)
) ENGINE=MyISAM AUTO_INCREMENT=244 DEFAULT CHARSET=utf8;

INSERT INTO tkt_users
(`id`, `name`, `username`, `email`, `password`, `usertype`, `block`, `sendEmail`, `registerDate`, `lastvisitDate`, `activation`, `params`, `lastResetTime`, `resetCount`) VALUES 
('242', 'Super User', 'jimsz', 'jim@2047.org', 'd560d2456fecbbd640299b647d37f615:vl556mjNDo2hxzCzudIcqXZRAzfkelbi', 'deprecated', '0', '1', '2013-09-21 13:29:56', '2013-09-23 15:44:38', '0', '', '0000-00-00 00:00:00', '0');

DROP TABLE IF EXISTS `tkt_viewlevels`;
CREATE TABLE `tkt_viewlevels` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `title` varchar(100) NOT NULL DEFAULT '',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_assetgroup_title_lookup` (`title`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;

INSERT INTO tkt_viewlevels
(`id`, `title`, `ordering`, `rules`) VALUES 
('1', 'Public', '0', '[1]'),
('2', 'Registered', '1', '[6,2,8]'),
('3', 'Special', '2', '[6,3,8]'),
('4', 'Customer Access Level (Example)', '3', '[6,3,12]');

DROP TABLE IF EXISTS `tkt_weblinks`;
CREATE TABLE `tkt_weblinks` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `catid` int(11) NOT NULL DEFAULT '0',
  `sid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(250) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `url` varchar(250) NOT NULL DEFAULT '',
  `description` text NOT NULL,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(11) NOT NULL DEFAULT '0',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `archived` tinyint(1) NOT NULL DEFAULT '0',
  `approved` tinyint(1) NOT NULL DEFAULT '1',
  `access` int(11) NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `language` char(7) NOT NULL DEFAULT '',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if link is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;

INSERT INTO tkt_weblinks
(`id`, `catid`, `sid`, `title`, `alias`, `url`, `description`, `date`, `hits`, `state`, `checked_out`, `checked_out_time`, `ordering`, `archived`, `approved`, `access`, `params`, `language`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `featured`, `xreference`, `publish_up`, `publish_down`) VALUES 
('1', '32', '0', 'Joomla!', 'joomla', 'http://www.joomla.org', '<p>Home of Joomla!</p>', '0000-00-00 00:00:00', '3', '1', '0', '0000-00-00 00:00:00', '1', '0', '1', '1', '{\"target\":\"0\",\"count_clicks\":\"\"}', 'en-GB', '2011-01-01 00:00:01', '242', '', '2011-01-01 00:00:01', '42', '', '', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\"}', '0', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
('2', '33', '0', 'php.net', 'php', 'http://www.php.net', '<p>The language that Joomla! is developed in</p>', '0000-00-00 00:00:00', '6', '1', '0', '0000-00-00 00:00:00', '1', '0', '1', '1', '{\"target\":\"\",\"count_clicks\":\"\"}', 'en-GB', '2011-01-01 00:00:01', '242', '', '2011-01-01 00:00:01', '42', '', '', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\"}', '0', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
('3', '33', '0', 'MySQL', 'mysql', 'http://www.mysql.com', '<p>The most commonly used database for Joomla!.</p>', '0000-00-00 00:00:00', '1', '1', '0', '0000-00-00 00:00:00', '2', '0', '1', '1', '{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}', 'en-GB', '2011-01-01 00:00:01', '242', '', '2012-01-17 16:19:43', '42', '', '', '{\"robots\":\"\",\"rights\":\"\"}', '0', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
('4', '32', '0', 'OpenSourceMatters', 'opensourcematters', 'http://www.opensourcematters.org', '<p>Home of OSM</p>', '0000-00-00 00:00:00', '11', '1', '0', '0000-00-00 00:00:00', '3', '0', '1', '1', '{\"target\":\"0\",\"count_clicks\":\"\"}', 'en-GB', '2011-01-01 00:00:01', '242', '', '2011-01-01 00:00:01', '42', '', '', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\"}', '0', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
('5', '32', '0', 'Joomla! - Forums', 'joomla-forums', 'http://forum.joomla.org', '<p>Joomla! Forums</p>', '0000-00-00 00:00:00', '4', '1', '0', '0000-00-00 00:00:00', '2', '0', '1', '1', '{\"target\":\"0\",\"count_clicks\":\"\"}', 'en-GB', '2011-01-01 00:00:01', '242', '', '2011-01-01 00:00:01', '42', '', '', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\"}', '0', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
('6', '33', '0', 'Ohloh Tracking of Joomla!', 'ohloh-tracking-of-joomla', 'http://www.ohloh.net/projects/20', '<p>Objective reports from Ohloh about Joomla\'s development activity. Joomla! has some star developers with serious kudos.</p>', '0000-00-00 00:00:00', '1', '1', '0', '0000-00-00 00:00:00', '3', '0', '1', '1', '{\"target\":\"0\",\"count_clicks\":\"\"}', 'en-GB', '2011-01-01 00:00:01', '242', '', '2011-01-01 00:00:01', '42', '', '', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\"}', '0', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
('7', '31', '0', 'Baw Baw National Park', 'baw-baw-national-park', 'http://www.parkweb.vic.gov.au/1park_display.cfm?park=44', '<p>Park of the Austalian Alps National Parks system, Baw Baw  features sub alpine vegetation, beautiful views, and opportunities for hiking, skiing and other outdoor activities.</p>', '0000-00-00 00:00:00', '0', '1', '0', '0000-00-00 00:00:00', '1', '0', '1', '1', '{\"target\":\"0\",\"count_clicks\":\"\"}', 'en-GB', '2011-01-01 00:00:01', '242', '', '2011-01-01 00:00:01', '42', '', '', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\"}', '0', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
('8', '31', '0', 'Kakadu', 'kakadu', 'http://www.environment.gov.au/parks/kakadu/index.html', '<p>Kakadu is known for both its cultural heritage and its natural features. It is one of a small number of places listed as World Heritage Places for both reasons. Extensive rock art is found there.</p>', '0000-00-00 00:00:00', '0', '1', '0', '0000-00-00 00:00:00', '2', '0', '1', '1', '{\"target\":\"0\",\"count_clicks\":\"\"}', 'en-GB', '2011-01-01 00:00:01', '242', '', '2011-01-01 00:00:01', '42', '', '', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\"}', '0', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
('9', '31', '0', 'Pulu Keeling', 'pulu-keeling', 'http://www.environment.gov.au/parks/cocos/index.html', '<p>Located on an atoll 2000 kilometers north of Perth, Pulu Keeling is Australia\'s smallest national park.</p>', '0000-00-00 00:00:00', '0', '1', '0', '0000-00-00 00:00:00', '3', '0', '1', '1', '{\"target\":\"0\",\"count_clicks\":\"\"}', 'en-GB', '2011-01-01 00:00:01', '242', '', '2011-01-01 00:00:01', '42', '', '', '{\"robots\":\"\",\"author\":\"\",\"rights\":\"\"}', '0', '', '2010-07-10 23:44:03', '0000-00-00 00:00:00');

DROP TABLE IF EXISTS `tkt_zweather_locations`;
CREATE TABLE `tkt_zweather_locations` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL DEFAULT '',
  `latitude` decimal(10,6) NOT NULL DEFAULT '0.000000',
  `longitude` decimal(10,6) NOT NULL DEFAULT '0.000000',
  `observation_loc` varchar(50) NOT NULL DEFAULT '',
  `default_loc` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `cap_zone` varchar(10) NOT NULL DEFAULT '',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `created` datetime NOT NULL,
  `created_by` int(10) NOT NULL,
  `modified` datetime NOT NULL,
  `modified_by` int(10) NOT NULL,
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `params` text NOT NULL,
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;

INSERT INTO tkt_zweather_locations
(`id`, `title`, `latitude`, `longitude`, `observation_loc`, `default_loc`, `cap_zone`, `ordering`, `created`, `created_by`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `published`, `publish_up`, `publish_down`, `params`) VALUES 
('1', 'Los Angeles, CA', '34.020000', '-118.280000', 'KLAX', '0', 'CAZ041', '1', '0000-00-00 00:00:00', '0', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '1', '0000-00-00 00:00:00', '0000-00-00 00:00:00', ''),
('2', 'Chicago, IL', '41.810000', '-87.680000', 'KORD', '0', 'ILZ014', '2', '0000-00-00 00:00:00', '0', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '1', '0000-00-00 00:00:00', '0000-00-00 00:00:00', ''),
('3', 'New York, NY', '40.740000', '-74.010000', 'KLGA', '1', 'NYZ072', '3', '0000-00-00 00:00:00', '0', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '1', '0000-00-00 00:00:00', '0000-00-00 00:00:00', ''),
('4', 'Washington, D.C.', '38.895000', '-77.037300', 'KDCA', '0', 'DCZ001', '4', '0000-00-00 00:00:00', '0', '0000-00-00 00:00:00', '0', '0', '0000-00-00 00:00:00', '1', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '');

DROP TABLE IF EXISTS `tkt_zweather_stations`;
CREATE TABLE `tkt_zweather_stations` (
  `station_id` varchar(4) NOT NULL,
  `state` varchar(2) NOT NULL,
  `station_name` varchar(255) NOT NULL,
  `latitude` decimal(10,6) NOT NULL,
  `longitude` decimal(10,6) NOT NULL,
  `html_url` varchar(255) NOT NULL,
  `rss_url` varchar(255) NOT NULL,
  `xml_url` varchar(255) NOT NULL,
  PRIMARY KEY (`station_id`),
  KEY `state` (`state`,`station_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('TAPA', 'AG', 'Vc Bird Intl Airport Antigua', '17.117000', '-61.783000', 'http://weather.noaa.gov/weather/current/TAPA.html', 'http://weather.gov/data/current_obs/TAPA.rss', 'http://weather.gov/data/current_obs/TAPA.xml'),
('TKPN', 'AG', 'Charlestown/Newcast', '17.200000', '-62.583000', 'http://weather.noaa.gov/weather/current/TKPN.html', 'http://weather.gov/data/current_obs/TKPN.rss', 'http://weather.gov/data/current_obs/TKPN.xml'),
('TRPM', 'AG', 'Blackburne/Plymouth', '16.750000', '-62.167000', 'http://weather.noaa.gov/weather/current/TRPM.html', 'http://weather.gov/data/current_obs/TRPM.rss', 'http://weather.gov/data/current_obs/TRPM.xml'),
('PAAK', 'AK', 'Atka Airport', '52.217000', '-174.200000', 'http://weather.noaa.gov/weather/current/PAAK.html', 'http://weather.gov/data/current_obs/PAAK.rss', 'http://weather.gov/data/current_obs/PAAK.xml'),
('PAAP', 'AK', 'Port Alexander', '56.260000', '-134.660000', 'http://weather.noaa.gov/weather/current/PAAP.html', 'http://weather.gov/data/current_obs/PAAP.rss', 'http://weather.gov/data/current_obs/PAAP.xml'),
('PAAQ', 'AK', 'Palmer', '61.610000', '-149.090000', 'http://weather.noaa.gov/weather/current/PAAQ.html', 'http://weather.gov/data/current_obs/PAAQ.rss', 'http://weather.gov/data/current_obs/PAAQ.xml'),
('PABA', 'AK', 'Barter Island', '70.140000', '-143.590000', 'http://weather.noaa.gov/weather/current/PABA.html', 'http://weather.gov/data/current_obs/PABA.rss', 'http://weather.gov/data/current_obs/PABA.xml'),
('PABE', 'AK', 'Bethel', '60.780000', '-161.800000', 'http://weather.noaa.gov/weather/current/PABE.html', 'http://weather.gov/data/current_obs/PABE.rss', 'http://weather.gov/data/current_obs/PABE.xml'),
('PABI', 'AK', 'Delta Junction/Allan AAF', '63.970000', '-145.700000', 'http://weather.noaa.gov/weather/current/PABI.html', 'http://weather.gov/data/current_obs/PABI.rss', 'http://weather.gov/data/current_obs/PABI.xml'),
('PABL', 'AK', 'Buckland Airport', '65.990000', '-161.120000', 'http://weather.noaa.gov/weather/current/PABL.html', 'http://weather.gov/data/current_obs/PABL.rss', 'http://weather.gov/data/current_obs/PABL.xml'),
('PABN', 'AK', 'Nabesna / Devil Mountain', '62.410000', '-143.000000', 'http://weather.noaa.gov/weather/current/PABN.html', 'http://weather.gov/data/current_obs/PABN.rss', 'http://weather.gov/data/current_obs/PABN.xml'),
('PABR', 'AK', 'Barrow/Wiley Post', '71.290000', '-156.770000', 'http://weather.noaa.gov/weather/current/PABR.html', 'http://weather.gov/data/current_obs/PABR.rss', 'http://weather.gov/data/current_obs/PABR.xml'),
('PABT', 'AK', 'Bettles Airport', '66.920000', '-151.520000', 'http://weather.noaa.gov/weather/current/PABT.html', 'http://weather.gov/data/current_obs/PABT.rss', 'http://weather.gov/data/current_obs/PABT.xml'),
('PABV', 'AK', 'Birchwood', '61.420000', '-149.520000', 'http://weather.noaa.gov/weather/current/PABV.html', 'http://weather.gov/data/current_obs/PABV.rss', 'http://weather.gov/data/current_obs/PABV.xml'),
('PACD', 'AK', 'Cold Bay Airport', '55.210000', '-162.720000', 'http://weather.noaa.gov/weather/current/PACD.html', 'http://weather.gov/data/current_obs/PACD.rss', 'http://weather.gov/data/current_obs/PACD.xml'),
('PACV', 'AK', 'Cordova/Merle K', '60.500000', '-145.500000', 'http://weather.noaa.gov/weather/current/PACV.html', 'http://weather.gov/data/current_obs/PACV.rss', 'http://weather.gov/data/current_obs/PACV.xml'),
('PACZ', 'AK', 'Cape Romanzoff Airways Facilities Sector', '61.783000', '-166.033000', 'http://weather.noaa.gov/weather/current/PACZ.html', 'http://weather.gov/data/current_obs/PACZ.rss', 'http://weather.gov/data/current_obs/PACZ.xml'),
('PADE', 'AK', 'Deering Airport', '66.080000', '-162.750000', 'http://weather.noaa.gov/weather/current/PADE.html', 'http://weather.gov/data/current_obs/PADE.rss', 'http://weather.gov/data/current_obs/PADE.xml'),
('PADK', 'AK', 'Adak Is. NAF', '51.890000', '-176.650000', 'http://weather.noaa.gov/weather/current/PADK.html', 'http://weather.gov/data/current_obs/PADK.rss', 'http://weather.gov/data/current_obs/PADK.xml'),
('PADL', 'AK', 'Dillingham Municipal', '59.050000', '-158.520000', 'http://weather.noaa.gov/weather/current/PADL.html', 'http://weather.gov/data/current_obs/PADL.rss', 'http://weather.gov/data/current_obs/PADL.xml'),
('PADQ', 'AK', 'Kodiak', '57.760000', '-152.500000', 'http://weather.noaa.gov/weather/current/PADQ.html', 'http://weather.gov/data/current_obs/PADQ.rss', 'http://weather.gov/data/current_obs/PADQ.xml'),
('PADT', 'AK', 'Slana Airport', '62.710000', '-143.990000', 'http://weather.noaa.gov/weather/current/PADT.html', 'http://weather.gov/data/current_obs/PADT.rss', 'http://weather.gov/data/current_obs/PADT.xml'),
('PADU', 'AK', 'Unalaska', '53.890000', '-166.530000', 'http://weather.noaa.gov/weather/current/PADU.html', 'http://weather.gov/data/current_obs/PADU.rss', 'http://weather.gov/data/current_obs/PADU.xml'),
('PAEC', 'AK', 'Chulitna', '62.890000', '-149.840000', 'http://weather.noaa.gov/weather/current/PAEC.html', 'http://weather.gov/data/current_obs/PAEC.rss', 'http://weather.gov/data/current_obs/PAEC.xml'),
('PAED', 'AK', 'Anchorage / Elmendorf Air Force Base', '61.250000', '-149.800000', 'http://weather.noaa.gov/weather/current/PAED.html', 'http://weather.gov/data/current_obs/PAED.rss', 'http://weather.gov/data/current_obs/PAED.xml'),
('PAEG', 'AK', 'Eagle Airport', '64.780000', '-141.150000', 'http://weather.noaa.gov/weather/current/PAEG.html', 'http://weather.gov/data/current_obs/PAEG.rss', 'http://weather.gov/data/current_obs/PAEG.xml'),
('PAEH', 'AK', 'Cape Newenham Airways Facilities Sector', '58.660000', '-162.070000', 'http://weather.noaa.gov/weather/current/PAEH.html', 'http://weather.gov/data/current_obs/PAEH.rss', 'http://weather.gov/data/current_obs/PAEH.xml'),
('PAEI', 'AK', 'Fairbanks / Eielson Air Force Base', '64.650000', '-147.067000', 'http://weather.noaa.gov/weather/current/PAEI.html', 'http://weather.gov/data/current_obs/PAEI.rss', 'http://weather.gov/data/current_obs/PAEI.xml'),
('PAEL', 'AK', 'Elfin Cove Seaplane', '58.210000', '-136.350000', 'http://weather.noaa.gov/weather/current/PAEL.html', 'http://weather.gov/data/current_obs/PAEL.rss', 'http://weather.gov/data/current_obs/PAEL.xml'),
('PAEM', 'AK', 'Emmonak', '62.770000', '-164.500000', 'http://weather.noaa.gov/weather/current/PAEM.html', 'http://weather.gov/data/current_obs/PAEM.rss', 'http://weather.gov/data/current_obs/PAEM.xml'),
('PAEN', 'AK', 'Kenai Municipal Airport', '60.580000', '-151.250000', 'http://weather.noaa.gov/weather/current/PAEN.html', 'http://weather.gov/data/current_obs/PAEN.rss', 'http://weather.gov/data/current_obs/PAEN.xml'),
('PAER', 'AK', 'Merrill Pass West', '61.250000', '-153.817000', 'http://weather.noaa.gov/weather/current/PAER.html', 'http://weather.gov/data/current_obs/PAER.rss', 'http://weather.gov/data/current_obs/PAER.xml'),
('PAFA', 'AK', 'Fairbanks International Airport', '64.820000', '-147.870000', 'http://weather.noaa.gov/weather/current/PAFA.html', 'http://weather.gov/data/current_obs/PAFA.rss', 'http://weather.gov/data/current_obs/PAFA.xml'),
('PAFB', 'AK', 'Wainwright U. S. Army Airfield', '64.833000', '-147.617000', 'http://weather.noaa.gov/weather/current/PAFB.html', 'http://weather.gov/data/current_obs/PAFB.rss', 'http://weather.gov/data/current_obs/PAFB.xml'),
('PAFE', 'AK', 'Kake Airport', '56.970000', '-133.950000', 'http://weather.noaa.gov/weather/current/PAFE.html', 'http://weather.gov/data/current_obs/PAFE.rss', 'http://weather.gov/data/current_obs/PAFE.xml'),
('PAFK', 'AK', 'Farewell Lake Seaplane Base', '62.540000', '-153.620000', 'http://weather.noaa.gov/weather/current/PAFK.html', 'http://weather.gov/data/current_obs/PAFK.rss', 'http://weather.gov/data/current_obs/PAFK.xml'),
('PAFM', 'AK', 'Ambler', '67.100000', '-157.850000', 'http://weather.noaa.gov/weather/current/PAFM.html', 'http://weather.gov/data/current_obs/PAFM.rss', 'http://weather.gov/data/current_obs/PAFM.xml'),
('PAGA', 'AK', 'Galena A.', '64.740000', '-156.940000', 'http://weather.noaa.gov/weather/current/PAGA.html', 'http://weather.gov/data/current_obs/PAGA.rss', 'http://weather.gov/data/current_obs/PAGA.xml'),
('PAGB', 'AK', 'Galbraith Lake', '68.490000', '-149.490000', 'http://weather.noaa.gov/weather/current/PAGB.html', 'http://weather.gov/data/current_obs/PAGB.rss', 'http://weather.gov/data/current_obs/PAGB.xml'),
('PAGK', 'AK', 'Gulkana Airport', '62.150000', '-145.450000', 'http://weather.noaa.gov/weather/current/PAGK.html', 'http://weather.gov/data/current_obs/PAGK.rss', 'http://weather.gov/data/current_obs/PAGK.xml'),
('PAGL', 'AK', 'Golovin Airport', '64.540000', '-163.040000', 'http://weather.noaa.gov/weather/current/PAGL.html', 'http://weather.gov/data/current_obs/PAGL.rss', 'http://weather.gov/data/current_obs/PAGL.xml'),
('PAGM', 'AK', 'Gambell Airport', '63.770000', '-171.740000', 'http://weather.noaa.gov/weather/current/PAGM.html', 'http://weather.gov/data/current_obs/PAGM.rss', 'http://weather.gov/data/current_obs/PAGM.xml'),
('PAGS', 'AK', 'Gustavus', '58.420000', '-135.730000', 'http://weather.noaa.gov/weather/current/PAGS.html', 'http://weather.gov/data/current_obs/PAGS.rss', 'http://weather.gov/data/current_obs/PAGS.xml'),
('PAGY', 'AK', 'Skagway', '59.480000', '-135.320000', 'http://weather.noaa.gov/weather/current/PAGY.html', 'http://weather.gov/data/current_obs/PAGY.rss', 'http://weather.gov/data/current_obs/PAGY.xml'),
('PAHN', 'AK', 'Haines Airport', '59.250000', '-135.520000', 'http://weather.noaa.gov/weather/current/PAHN.html', 'http://weather.gov/data/current_obs/PAHN.rss', 'http://weather.gov/data/current_obs/PAHN.xml'),
('PAHO', 'AK', 'Homer', '59.640000', '-151.500000', 'http://weather.noaa.gov/weather/current/PAHO.html', 'http://weather.gov/data/current_obs/PAHO.rss', 'http://weather.gov/data/current_obs/PAHO.xml'),
('PAHP', 'AK', 'Hooper Bay Automatic Weather Observing / Reporting', '61.540000', '-166.160000', 'http://weather.noaa.gov/weather/current/PAHP.html', 'http://weather.gov/data/current_obs/PAHP.rss', 'http://weather.gov/data/current_obs/PAHP.xml'),
('PAHS', 'AK', 'Huslia', '65.700000', '-156.390000', 'http://weather.noaa.gov/weather/current/PAHS.html', 'http://weather.gov/data/current_obs/PAHS.rss', 'http://weather.gov/data/current_obs/PAHS.xml'),
('PAHV', 'AK', 'Healy River Airport', '63.890000', '-149.020000', 'http://weather.noaa.gov/weather/current/PAHV.html', 'http://weather.gov/data/current_obs/PAHV.rss', 'http://weather.gov/data/current_obs/PAHV.xml'),
('PAHY', 'AK', 'Hydaburg Seaplane Base', '55.210000', '-132.840000', 'http://weather.noaa.gov/weather/current/PAHY.html', 'http://weather.gov/data/current_obs/PAHY.rss', 'http://weather.gov/data/current_obs/PAHY.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('PAHZ', 'AK', 'Hayes River', '61.990000', '-152.090000', 'http://weather.noaa.gov/weather/current/PAHZ.html', 'http://weather.gov/data/current_obs/PAHZ.rss', 'http://weather.gov/data/current_obs/PAHZ.xml'),
('PAII', 'AK', 'Egegik Automatic Weather Observing / Reporting Sys', '58.420000', '-157.370000', 'http://weather.noaa.gov/weather/current/PAII.html', 'http://weather.gov/data/current_obs/PAII.rss', 'http://weather.gov/data/current_obs/PAII.xml'),
('PAIL', 'AK', 'Iliamna / Iliamna Airport', '59.760000', '-154.920000', 'http://weather.noaa.gov/weather/current/PAIL.html', 'http://weather.gov/data/current_obs/PAIL.rss', 'http://weather.gov/data/current_obs/PAIL.xml'),
('PAIM', 'AK', 'Indian Mountain Airways Facilities Sector', '66.000000', '-153.700000', 'http://weather.noaa.gov/weather/current/PAIM.html', 'http://weather.gov/data/current_obs/PAIM.rss', 'http://weather.gov/data/current_obs/PAIM.xml'),
('PAIN', 'AK', 'McKinley National Park Airport', '63.730000', '-148.920000', 'http://weather.noaa.gov/weather/current/PAIN.html', 'http://weather.gov/data/current_obs/PAIN.rss', 'http://weather.gov/data/current_obs/PAIN.xml'),
('PAJC', 'AK', 'Chignik Airport', '56.310000', '-158.370000', 'http://weather.noaa.gov/weather/current/PAJC.html', 'http://weather.gov/data/current_obs/PAJC.rss', 'http://weather.gov/data/current_obs/PAJC.xml'),
('PAJN', 'AK', 'Juneau International Airport', '58.380000', '-134.580000', 'http://weather.noaa.gov/weather/current/PAJN.html', 'http://weather.gov/data/current_obs/PAJN.rss', 'http://weather.gov/data/current_obs/PAJN.xml'),
('PAJV', 'AK', 'Sutton', '61.720000', '-148.890000', 'http://weather.noaa.gov/weather/current/PAJV.html', 'http://weather.gov/data/current_obs/PAJV.rss', 'http://weather.gov/data/current_obs/PAJV.xml'),
('PAKK', 'AK', 'Koyuk Airport', '64.930000', '-165.150000', 'http://weather.noaa.gov/weather/current/PAKK.html', 'http://weather.gov/data/current_obs/PAKK.rss', 'http://weather.gov/data/current_obs/PAKK.xml'),
('PAKN', 'AK', 'King Salmon Airport', '58.680000', '-156.650000', 'http://weather.noaa.gov/weather/current/PAKN.html', 'http://weather.gov/data/current_obs/PAKN.rss', 'http://weather.gov/data/current_obs/PAKN.xml'),
('PAKP', 'AK', 'Anaktuvuk Pass', '68.130000', '-151.730000', 'http://weather.noaa.gov/weather/current/PAKP.html', 'http://weather.gov/data/current_obs/PAKP.rss', 'http://weather.gov/data/current_obs/PAKP.xml'),
('PAKT', 'AK', 'Ketchikan International Airport', '55.350000', '-131.700000', 'http://weather.noaa.gov/weather/current/PAKT.html', 'http://weather.gov/data/current_obs/PAKT.rss', 'http://weather.gov/data/current_obs/PAKT.xml'),
('PAKU', 'AK', 'Kuparuk Airport', '70.317000', '-149.583000', 'http://weather.noaa.gov/weather/current/PAKU.html', 'http://weather.gov/data/current_obs/PAKU.rss', 'http://weather.gov/data/current_obs/PAKU.xml'),
('PAKV', 'AK', 'Kaltag Airport', '64.330000', '-158.750000', 'http://weather.noaa.gov/weather/current/PAKV.html', 'http://weather.gov/data/current_obs/PAKV.rss', 'http://weather.gov/data/current_obs/PAKV.xml'),
('PAKW', 'AK', 'Klawock Airport', '55.590000', '-133.090000', 'http://weather.noaa.gov/weather/current/PAKW.html', 'http://weather.gov/data/current_obs/PAKW.rss', 'http://weather.gov/data/current_obs/PAKW.xml'),
('PALH', 'AK', 'Lake Hood Seaplane', '61.190000', '-149.970000', 'http://weather.noaa.gov/weather/current/PALH.html', 'http://weather.gov/data/current_obs/PALH.rss', 'http://weather.gov/data/current_obs/PALH.xml'),
('PALJ', 'AK', 'Port Alsworth', '60.210000', '-154.310000', 'http://weather.noaa.gov/weather/current/PALJ.html', 'http://weather.gov/data/current_obs/PALJ.rss', 'http://weather.gov/data/current_obs/PALJ.xml'),
('PALK', 'AK', 'Snowshoe Lake', '62.030000', '-146.680000', 'http://weather.noaa.gov/weather/current/PALK.html', 'http://weather.gov/data/current_obs/PALK.rss', 'http://weather.gov/data/current_obs/PALK.xml'),
('PALR', 'AK', 'Chandalar Lake', '67.500000', '-148.490000', 'http://weather.noaa.gov/weather/current/PALR.html', 'http://weather.gov/data/current_obs/PALR.rss', 'http://weather.gov/data/current_obs/PALR.xml'),
('PALU', 'AK', 'Cape Lisburne Airways Fac Sec', '68.890000', '-166.140000', 'http://weather.noaa.gov/weather/current/PALU.html', 'http://weather.gov/data/current_obs/PALU.rss', 'http://weather.gov/data/current_obs/PALU.xml'),
('PALV', 'AK', 'Big River Lake', '60.820000', '-152.310000', 'http://weather.noaa.gov/weather/current/PALV.html', 'http://weather.gov/data/current_obs/PALV.rss', 'http://weather.gov/data/current_obs/PALV.xml'),
('PAMC', 'AK', 'McGrath Airport', '62.950000', '-155.610000', 'http://weather.noaa.gov/weather/current/PAMC.html', 'http://weather.gov/data/current_obs/PAMC.rss', 'http://weather.gov/data/current_obs/PAMC.xml'),
('PAMD', 'AK', 'Middleton Island, Ak', '59.440000', '-146.330000', 'http://weather.noaa.gov/weather/current/PAMD.html', 'http://weather.gov/data/current_obs/PAMD.rss', 'http://weather.gov/data/current_obs/PAMD.xml'),
('PAMH', 'AK', 'Minchumina', '63.910000', '-152.160000', 'http://weather.noaa.gov/weather/current/PAMH.html', 'http://weather.gov/data/current_obs/PAMH.rss', 'http://weather.gov/data/current_obs/PAMH.xml'),
('PAML', 'AK', 'Manley Hot Springs', '65.000000', '-150.650000', 'http://weather.noaa.gov/weather/current/PAML.html', 'http://weather.gov/data/current_obs/PAML.rss', 'http://weather.gov/data/current_obs/PAML.xml'),
('PAMM', 'AK', 'Metlakatla Seaplane Base', '55.080000', '-131.350000', 'http://weather.noaa.gov/weather/current/PAMM.html', 'http://weather.gov/data/current_obs/PAMM.rss', 'http://weather.gov/data/current_obs/PAMM.xml'),
('PAMR', 'AK', 'Merrill Field', '61.214000', '-149.846000', 'http://weather.noaa.gov/weather/current/PAMR.html', 'http://weather.gov/data/current_obs/PAMR.rss', 'http://weather.gov/data/current_obs/PAMR.xml'),
('PAMX', 'AK', 'McCarthy', '61.440000', '-142.940000', 'http://weather.noaa.gov/weather/current/PAMX.html', 'http://weather.gov/data/current_obs/PAMX.rss', 'http://weather.gov/data/current_obs/PAMX.xml'),
('PAMY', 'AK', 'Mekoryuk', '60.370000', '-166.270000', 'http://weather.noaa.gov/weather/current/PAMY.html', 'http://weather.gov/data/current_obs/PAMY.rss', 'http://weather.gov/data/current_obs/PAMY.xml'),
('PANC', 'AK', 'Anchorage International Airport', '61.170000', '-150.000000', 'http://weather.noaa.gov/weather/current/PANC.html', 'http://weather.gov/data/current_obs/PANC.rss', 'http://weather.gov/data/current_obs/PANC.xml'),
('PANI', 'AK', 'Aniak', '61.580000', '-159.530000', 'http://weather.noaa.gov/weather/current/PANI.html', 'http://weather.gov/data/current_obs/PANI.rss', 'http://weather.gov/data/current_obs/PANI.xml'),
('PANN', 'AK', 'Nenana Municipal Airport', '64.547300', '-149.074000', 'http://weather.noaa.gov/weather/current/PANN.html', 'http://weather.gov/data/current_obs/PANN.rss', 'http://weather.gov/data/current_obs/PANN.xml'),
('PANT', 'AK', 'Annette Island', '55.040000', '-131.570000', 'http://weather.noaa.gov/weather/current/PANT.html', 'http://weather.gov/data/current_obs/PANT.rss', 'http://weather.gov/data/current_obs/PANT.xml'),
('PANV', 'AK', 'Annik Airport', '62.650000', '-160.180000', 'http://weather.noaa.gov/weather/current/PANV.html', 'http://weather.gov/data/current_obs/PANV.rss', 'http://weather.gov/data/current_obs/PANV.xml'),
('PAOH', 'AK', 'Hoonah Seaplane', '58.120000', '-135.450000', 'http://weather.noaa.gov/weather/current/PAOH.html', 'http://weather.gov/data/current_obs/PAOH.rss', 'http://weather.gov/data/current_obs/PAOH.xml'),
('PAOM', 'AK', 'Nome Airport', '64.500000', '-165.440000', 'http://weather.noaa.gov/weather/current/PAOM.html', 'http://weather.gov/data/current_obs/PAOM.rss', 'http://weather.gov/data/current_obs/PAOM.xml'),
('PAOR', 'AK', 'Northway Airport', '62.970000', '-141.940000', 'http://weather.noaa.gov/weather/current/PAOR.html', 'http://weather.gov/data/current_obs/PAOR.rss', 'http://weather.gov/data/current_obs/PAOR.xml'),
('PAOT', 'AK', 'Kotzebue, Wien Memorial Airport', '66.870000', '-162.640000', 'http://weather.noaa.gov/weather/current/PAOT.html', 'http://weather.gov/data/current_obs/PAOT.rss', 'http://weather.gov/data/current_obs/PAOT.xml'),
('PAPB', 'AK', 'St. George Airport', '56.350000', '-169.400000', 'http://weather.noaa.gov/weather/current/PAPB.html', 'http://weather.gov/data/current_obs/PAPB.rss', 'http://weather.gov/data/current_obs/PAPB.xml'),
('PAPG', 'AK', 'Petersburg', '56.820000', '-132.970000', 'http://weather.noaa.gov/weather/current/PAPG.html', 'http://weather.gov/data/current_obs/PAPG.rss', 'http://weather.gov/data/current_obs/PAPG.xml'),
('PAPH', 'AK', 'Port Heiden', '56.960000', '-158.620000', 'http://weather.noaa.gov/weather/current/PAPH.html', 'http://weather.gov/data/current_obs/PAPH.rss', 'http://weather.gov/data/current_obs/PAPH.xml'),
('PAPO', 'AK', 'Point Hope Automatic Weather Observing / Reporting', '68.350000', '-166.810000', 'http://weather.noaa.gov/weather/current/PAPO.html', 'http://weather.gov/data/current_obs/PAPO.rss', 'http://weather.gov/data/current_obs/PAPO.xml'),
('PAPR', 'AK', 'Prospect Creek Airport', '66.817000', '-150.650000', 'http://weather.noaa.gov/weather/current/PAPR.html', 'http://weather.gov/data/current_obs/PAPR.rss', 'http://weather.gov/data/current_obs/PAPR.xml'),
('PAPT', 'AK', 'Puntilla', '62.100000', '-152.750000', 'http://weather.noaa.gov/weather/current/PAPT.html', 'http://weather.gov/data/current_obs/PAPT.rss', 'http://weather.gov/data/current_obs/PAPT.xml'),
('PAQT', 'AK', 'Nuiqsut Airport', '70.210000', '-151.010000', 'http://weather.noaa.gov/weather/current/PAQT.html', 'http://weather.gov/data/current_obs/PAQT.rss', 'http://weather.gov/data/current_obs/PAQT.xml'),
('PARC', 'AK', 'Arctic Village', '68.120000', '-145.570000', 'http://weather.noaa.gov/weather/current/PARC.html', 'http://weather.gov/data/current_obs/PARC.rss', 'http://weather.gov/data/current_obs/PARC.xml'),
('PARD', 'AK', 'Red Dog Airport', '68.080000', '-162.830000', 'http://weather.noaa.gov/weather/current/PARD.html', 'http://weather.gov/data/current_obs/PARD.rss', 'http://weather.gov/data/current_obs/PARD.xml'),
('PARL', 'AK', 'Central Airport', '65.570000', '-144.770000', 'http://weather.noaa.gov/weather/current/PARL.html', 'http://weather.gov/data/current_obs/PARL.rss', 'http://weather.gov/data/current_obs/PARL.xml'),
('PASA', 'AK', 'Savoonga Airport', '63.690000', '-170.500000', 'http://weather.noaa.gov/weather/current/PASA.html', 'http://weather.gov/data/current_obs/PASA.rss', 'http://weather.gov/data/current_obs/PASA.xml'),
('PASC', 'AK', 'Deadhorse Airport', '70.200000', '-148.470000', 'http://weather.noaa.gov/weather/current/PASC.html', 'http://weather.gov/data/current_obs/PASC.rss', 'http://weather.gov/data/current_obs/PASC.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('PASD', 'AK', 'Sand Point', '55.320000', '-160.520000', 'http://weather.noaa.gov/weather/current/PASD.html', 'http://weather.gov/data/current_obs/PASD.rss', 'http://weather.gov/data/current_obs/PASD.xml'),
('PASH', 'AK', 'Shishmaref Automatic Wx Obs', '66.270000', '-166.050000', 'http://weather.noaa.gov/weather/current/PASH.html', 'http://weather.gov/data/current_obs/PASH.rss', 'http://weather.gov/data/current_obs/PASH.xml'),
('PASI', 'AK', 'Sitka', '57.070000', '-135.350000', 'http://weather.noaa.gov/weather/current/PASI.html', 'http://weather.gov/data/current_obs/PASI.rss', 'http://weather.gov/data/current_obs/PASI.xml'),
('PASK', 'AK', 'Selawik', '66.620000', '-160.000000', 'http://weather.noaa.gov/weather/current/PASK.html', 'http://weather.gov/data/current_obs/PASK.rss', 'http://weather.gov/data/current_obs/PASK.xml'),
('PASL', 'AK', 'Sleetmute', '61.720000', '-157.150000', 'http://weather.noaa.gov/weather/current/PASL.html', 'http://weather.gov/data/current_obs/PASL.rss', 'http://weather.gov/data/current_obs/PASL.xml'),
('PASM', 'AK', 'St. Marys Airport', '62.070000', '-163.300000', 'http://weather.noaa.gov/weather/current/PASM.html', 'http://weather.gov/data/current_obs/PASM.rss', 'http://weather.gov/data/current_obs/PASM.xml'),
('PASN', 'AK', 'St. Paul Is.', '57.150000', '-170.220000', 'http://weather.noaa.gov/weather/current/PASN.html', 'http://weather.gov/data/current_obs/PASN.rss', 'http://weather.gov/data/current_obs/PASN.xml'),
('PASO', 'AK', 'Seldova Airport', '59.440000', '-151.700000', 'http://weather.noaa.gov/weather/current/PASO.html', 'http://weather.gov/data/current_obs/PASO.rss', 'http://weather.gov/data/current_obs/PASO.xml'),
('PASP', 'AK', 'Sheep Mountain Airport', '61.820000', '-147.500000', 'http://weather.noaa.gov/weather/current/PASP.html', 'http://weather.gov/data/current_obs/PASP.rss', 'http://weather.gov/data/current_obs/PASP.xml'),
('PASV', 'AK', 'Sparrevohn', '61.100000', '-155.567000', 'http://weather.noaa.gov/weather/current/PASV.html', 'http://weather.gov/data/current_obs/PASV.rss', 'http://weather.gov/data/current_obs/PASV.xml'),
('PASW', 'AK', 'Skwentna', '61.970000', '-151.180000', 'http://weather.noaa.gov/weather/current/PASW.html', 'http://weather.gov/data/current_obs/PASW.rss', 'http://weather.gov/data/current_obs/PASW.xml'),
('PASX', 'AK', 'Soldotna', '60.480000', '-151.030000', 'http://weather.noaa.gov/weather/current/PASX.html', 'http://weather.gov/data/current_obs/PASX.rss', 'http://weather.gov/data/current_obs/PASX.xml'),
('PASY', 'AK', 'Shemya AFB', '52.720000', '174.120000', 'http://weather.noaa.gov/weather/current/PASY.html', 'http://weather.gov/data/current_obs/PASY.rss', 'http://weather.gov/data/current_obs/PASY.xml'),
('PATA', 'AK', 'Tanana, Calhoun Memorial Airport', '65.170000', '-152.100000', 'http://weather.noaa.gov/weather/current/PATA.html', 'http://weather.gov/data/current_obs/PATA.rss', 'http://weather.gov/data/current_obs/PATA.xml'),
('PATC', 'AK', 'Tin City Airways Facilities Sector', '65.570000', '-167.920000', 'http://weather.noaa.gov/weather/current/PATC.html', 'http://weather.gov/data/current_obs/PATC.rss', 'http://weather.gov/data/current_obs/PATC.xml'),
('PATG', 'AK', 'Togiak Airport', '59.050000', '-160.410000', 'http://weather.noaa.gov/weather/current/PATG.html', 'http://weather.gov/data/current_obs/PATG.rss', 'http://weather.gov/data/current_obs/PATG.xml'),
('PATK', 'AK', 'Talkeetna', '62.300000', '-150.100000', 'http://weather.noaa.gov/weather/current/PATK.html', 'http://weather.gov/data/current_obs/PATK.rss', 'http://weather.gov/data/current_obs/PATK.xml'),
('PATO', 'AK', 'Portage Glacier', '60.783000', '-148.833000', 'http://weather.noaa.gov/weather/current/PATO.html', 'http://weather.gov/data/current_obs/PATO.rss', 'http://weather.gov/data/current_obs/PATO.xml'),
('PATW', 'AK', 'Cantwell', '63.410000', '-148.950000', 'http://weather.noaa.gov/weather/current/PATW.html', 'http://weather.gov/data/current_obs/PATW.rss', 'http://weather.gov/data/current_obs/PATW.xml'),
('PAUN', 'AK', 'Unalakleet', '63.890000', '-160.810000', 'http://weather.noaa.gov/weather/current/PAUN.html', 'http://weather.gov/data/current_obs/PAUN.rss', 'http://weather.gov/data/current_obs/PAUN.xml'),
('PAUO', 'AK', 'Willow Airport', '61.760000', '-150.060000', 'http://weather.noaa.gov/weather/current/PAUO.html', 'http://weather.gov/data/current_obs/PAUO.rss', 'http://weather.gov/data/current_obs/PAUO.xml'),
('PAVD', 'AK', 'Valdez 2', '61.130000', '-146.250000', 'http://weather.noaa.gov/weather/current/PAVD.html', 'http://weather.gov/data/current_obs/PAVD.rss', 'http://weather.gov/data/current_obs/PAVD.xml'),
('PAVL', 'AK', 'Kivalina Airport', '67.730000', '-164.550000', 'http://weather.noaa.gov/weather/current/PAVL.html', 'http://weather.gov/data/current_obs/PAVL.rss', 'http://weather.gov/data/current_obs/PAVL.xml'),
('PAVW', 'AK', 'Valdez Weather Station Office', '61.130000', '-146.350000', 'http://weather.noaa.gov/weather/current/PAVW.html', 'http://weather.gov/data/current_obs/PAVW.rss', 'http://weather.gov/data/current_obs/PAVW.xml'),
('PAWD', 'AK', 'Seward Airport', '60.120000', '-149.450000', 'http://weather.noaa.gov/weather/current/PAWD.html', 'http://weather.gov/data/current_obs/PAWD.rss', 'http://weather.gov/data/current_obs/PAWD.xml'),
('PAWG', 'AK', 'Wrangell', '56.480000', '-132.370000', 'http://weather.noaa.gov/weather/current/PAWG.html', 'http://weather.gov/data/current_obs/PAWG.rss', 'http://weather.gov/data/current_obs/PAWG.xml'),
('PAWI', 'AK', 'Wainwright Airport', '70.620000', '-159.860000', 'http://weather.noaa.gov/weather/current/PAWI.html', 'http://weather.gov/data/current_obs/PAWI.rss', 'http://weather.gov/data/current_obs/PAWI.xml'),
('PAWN', 'AK', 'Noatak', '67.570000', '-162.980000', 'http://weather.noaa.gov/weather/current/PAWN.html', 'http://weather.gov/data/current_obs/PAWN.rss', 'http://weather.gov/data/current_obs/PAWN.xml'),
('PAWR', 'AK', 'Whittier', '60.770000', '-148.690000', 'http://weather.noaa.gov/weather/current/PAWR.html', 'http://weather.gov/data/current_obs/PAWR.rss', 'http://weather.gov/data/current_obs/PAWR.xml'),
('PAWS', 'AK', 'Wasilla Airport', '61.580000', '-149.450000', 'http://weather.noaa.gov/weather/current/PAWS.html', 'http://weather.gov/data/current_obs/PAWS.rss', 'http://weather.gov/data/current_obs/PAWS.xml'),
('PAXK', 'AK', 'Paxson', '63.033000', '-145.500000', 'http://weather.noaa.gov/weather/current/PAXK.html', 'http://weather.gov/data/current_obs/PAXK.rss', 'http://weather.gov/data/current_obs/PAXK.xml'),
('PAYA', 'AK', 'Yakutat', '59.520000', '-139.670000', 'http://weather.noaa.gov/weather/current/PAYA.html', 'http://weather.gov/data/current_obs/PAYA.rss', 'http://weather.gov/data/current_obs/PAYA.xml'),
('PAZK', 'AK', 'Eureka', '61.930000', '-147.170000', 'http://weather.noaa.gov/weather/current/PAZK.html', 'http://weather.gov/data/current_obs/PAZK.rss', 'http://weather.gov/data/current_obs/PAZK.xml'),
('PFYU', 'AK', 'Fort Yukon', '66.570000', '-145.270000', 'http://weather.noaa.gov/weather/current/PFYU.html', 'http://weather.gov/data/current_obs/PFYU.rss', 'http://weather.gov/data/current_obs/PFYU.xml'),
('PPIZ', 'AK', 'Point Lay LRRS', '69.730000', '-163.020000', 'http://weather.noaa.gov/weather/current/PPIZ.html', 'http://weather.gov/data/current_obs/PPIZ.rss', 'http://weather.gov/data/current_obs/PPIZ.xml'),
('PAIG', 'AK', 'Igiugig Airport', '59.324000', '-155.902000', 'http://weather.noaa.gov/weather/current/PAIG.html', 'http://weather.gov/data/current_obs/PAIG.rss', 'http://weather.gov/data/current_obs/PAIG.xml'),
('PAMB', 'AK', 'Manokotak Airport', '58.990200', '-159.050000', 'http://weather.noaa.gov/weather/current/PAMB.html', 'http://weather.gov/data/current_obs/PAMB.rss', 'http://weather.gov/data/current_obs/PAMB.xml'),
('PAPN', 'AK', 'Pilot Point Airport', '57.580400', '-157.572000', 'http://weather.noaa.gov/weather/current/PAPN.html', 'http://weather.gov/data/current_obs/PAPN.rss', 'http://weather.gov/data/current_obs/PAPN.xml'),
('PAPM', 'AK', 'Platinum Airport', '59.011400', '-161.820000', 'http://weather.noaa.gov/weather/current/PAPM.html', 'http://weather.gov/data/current_obs/PAPM.rss', 'http://weather.gov/data/current_obs/PAPM.xml'),
('PAGN', 'AK', 'Angoon Seaplane Base', '57.503600', '-134.585000', 'http://weather.noaa.gov/weather/current/PAGN.html', 'http://weather.gov/data/current_obs/PAGN.rss', 'http://weather.gov/data/current_obs/PAGN.xml'),
('PAFS', 'AK', 'Nikolai Airport', '63.018600', '-154.358000', 'http://weather.noaa.gov/weather/current/PAFS.html', 'http://weather.gov/data/current_obs/PAFS.rss', 'http://weather.gov/data/current_obs/PAFS.xml'),
('PATQ', 'AK', 'Atqasuk Edward Burnell Sr. Memorial Airport', '70.467300', '-157.436000', 'http://weather.noaa.gov/weather/current/PATQ.html', 'http://weather.gov/data/current_obs/PATQ.rss', 'http://weather.gov/data/current_obs/PATQ.xml'),
('PALP', 'AK', 'Alpine Airstrip', '70.344300', '-150.945000', 'http://weather.noaa.gov/weather/current/PALP.html', 'http://weather.gov/data/current_obs/PALP.rss', 'http://weather.gov/data/current_obs/PALP.xml'),
('PAMK', 'AK', 'St Michael Airport', '63.490100', '-162.110000', 'http://weather.noaa.gov/weather/current/PAMK.html', 'http://weather.gov/data/current_obs/PAMK.rss', 'http://weather.gov/data/current_obs/PAMK.xml'),
('PAMO', 'AK', 'Mountain Village Airport', '62.095400', '-163.682000', 'http://weather.noaa.gov/weather/current/PAMO.html', 'http://weather.gov/data/current_obs/PAMO.rss', 'http://weather.gov/data/current_obs/PAMO.xml'),
('PACM', 'AK', 'Scammon Bay Airport', '61.845300', '-165.571000', 'http://weather.noaa.gov/weather/current/PACM.html', 'http://weather.gov/data/current_obs/PACM.rss', 'http://weather.gov/data/current_obs/PACM.xml'),
('PAHC', 'AK', 'Holy Cross Airport', '62.188300', '-159.775000', 'http://weather.noaa.gov/weather/current/PAHC.html', 'http://weather.gov/data/current_obs/PAHC.rss', 'http://weather.gov/data/current_obs/PAHC.xml'),
('PARS', 'AK', 'Russian Mission Airport', '61.774900', '-161.319000', 'http://weather.noaa.gov/weather/current/PARS.html', 'http://weather.gov/data/current_obs/PARS.rss', 'http://weather.gov/data/current_obs/PARS.xml'),
('PARY', 'AK', 'Ruby Airport', '64.727200', '-155.470000', 'http://weather.noaa.gov/weather/current/PARY.html', 'http://weather.gov/data/current_obs/PARY.rss', 'http://weather.gov/data/current_obs/PARY.xml'),
('PATL', 'AK', 'Tatalina LRRS Airport', '62.894400', '-155.977000', 'http://weather.noaa.gov/weather/current/PATL.html', 'http://weather.gov/data/current_obs/PATL.rss', 'http://weather.gov/data/current_obs/PATL.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('PALG', 'AK', 'Kalskag Airport', '61.536300', '-160.341000', 'http://weather.noaa.gov/weather/current/PALG.html', 'http://weather.gov/data/current_obs/PALG.rss', 'http://weather.gov/data/current_obs/PALG.xml'),
('PAOO', 'AK', 'Toksook Bay Airport', '60.541400', '-165.087000', 'http://weather.noaa.gov/weather/current/PAOO.html', 'http://weather.gov/data/current_obs/PAOO.rss', 'http://weather.gov/data/current_obs/PAOO.xml'),
('PADM', 'AK', 'Marshall Don Hunter Sr Airport', '61.864300', '-162.026000', 'http://weather.noaa.gov/weather/current/PADM.html', 'http://weather.gov/data/current_obs/PADM.rss', 'http://weather.gov/data/current_obs/PADM.xml'),
('PAVC', 'AK', 'King Cove Airport', '55.116300', '-162.266000', 'http://weather.noaa.gov/weather/current/PAVC.html', 'http://weather.gov/data/current_obs/PAVC.rss', 'http://weather.gov/data/current_obs/PAVC.xml'),
('PAOU', 'AK', 'Nelson Lagoon Airport', '56.007500', '-161.160000', 'http://weather.noaa.gov/weather/current/PAOU.html', 'http://weather.gov/data/current_obs/PAOU.rss', 'http://weather.gov/data/current_obs/PAOU.xml'),
('K3A1', 'AL', 'Folsom Field Airport', '34.269000', '-86.858000', 'http://weather.noaa.gov/weather/current/K3A1.html', 'http://weather.gov/data/current_obs/K3A1.rss', 'http://weather.gov/data/current_obs/K3A1.xml'),
('K4A9', 'AL', 'Isbell Field Airport', '34.467000', '-85.717000', 'http://weather.noaa.gov/weather/current/K4A9.html', 'http://weather.gov/data/current_obs/K4A9.rss', 'http://weather.gov/data/current_obs/K4A9.xml'),
('K79J', 'AL', 'Andalusia-Opp Municipal Airport', '31.317000', '-86.400000', 'http://weather.noaa.gov/weather/current/K79J.html', 'http://weather.gov/data/current_obs/K79J.rss', 'http://weather.gov/data/current_obs/K79J.xml'),
('KALX', 'AL', 'Alexander City/T.C. Russell Field', '32.915000', '-85.963000', 'http://weather.noaa.gov/weather/current/KALX.html', 'http://weather.gov/data/current_obs/KALX.rss', 'http://weather.gov/data/current_obs/KALX.xml'),
('KANB', 'AL', 'Anniston Metropolitan Airport', '33.590000', '-85.850000', 'http://weather.noaa.gov/weather/current/KANB.html', 'http://weather.gov/data/current_obs/KANB.rss', 'http://weather.gov/data/current_obs/KANB.xml'),
('KAUO', 'AL', 'Auburn-Opelika Airport', '32.620000', '-85.440000', 'http://weather.noaa.gov/weather/current/KAUO.html', 'http://weather.gov/data/current_obs/KAUO.rss', 'http://weather.gov/data/current_obs/KAUO.xml'),
('KBFM', 'AL', 'Mobile Downtown Airport', '30.640000', '-88.070000', 'http://weather.noaa.gov/weather/current/KBFM.html', 'http://weather.gov/data/current_obs/KBFM.rss', 'http://weather.gov/data/current_obs/KBFM.xml'),
('KBHM', 'AL', 'Birmingham International Airport', '33.560000', '-86.750000', 'http://weather.noaa.gov/weather/current/KBHM.html', 'http://weather.gov/data/current_obs/KBHM.rss', 'http://weather.gov/data/current_obs/KBHM.xml'),
('KCKL', 'AL', 'Centreville', '32.900000', '-87.250000', 'http://weather.noaa.gov/weather/current/KCKL.html', 'http://weather.gov/data/current_obs/KCKL.rss', 'http://weather.gov/data/current_obs/KCKL.xml'),
('KDCU', 'AL', 'Decatur, Pryor Field', '34.660000', '-86.940000', 'http://weather.noaa.gov/weather/current/KDCU.html', 'http://weather.gov/data/current_obs/KDCU.rss', 'http://weather.gov/data/current_obs/KDCU.xml'),
('KDHN', 'AL', 'Dothan Airport', '31.320000', '-85.450000', 'http://weather.noaa.gov/weather/current/KDHN.html', 'http://weather.gov/data/current_obs/KDHN.rss', 'http://weather.gov/data/current_obs/KDHN.xml'),
('KEET', 'AL', 'Calera, Shelby County Airport', '33.180000', '-86.780000', 'http://weather.noaa.gov/weather/current/KEET.html', 'http://weather.gov/data/current_obs/KEET.rss', 'http://weather.gov/data/current_obs/KEET.xml'),
('KGAD', 'AL', 'Gadsden Municipal Automatic Weather Observing', '33.970000', '-86.090000', 'http://weather.noaa.gov/weather/current/KGAD.html', 'http://weather.gov/data/current_obs/KGAD.rss', 'http://weather.gov/data/current_obs/KGAD.xml'),
('KGZH', 'AL', 'Evergreen, Middleton Field', '31.420000', '-87.040000', 'http://weather.noaa.gov/weather/current/KGZH.html', 'http://weather.gov/data/current_obs/KGZH.rss', 'http://weather.gov/data/current_obs/KGZH.xml'),
('KHSV', 'AL', 'Huntsville International / Jones Field', '34.660000', '-86.770000', 'http://weather.noaa.gov/weather/current/KHSV.html', 'http://weather.gov/data/current_obs/KHSV.rss', 'http://weather.gov/data/current_obs/KHSV.xml'),
('KHUA', 'AL', 'Redstone Army Airfield', '34.683000', '-86.683000', 'http://weather.noaa.gov/weather/current/KHUA.html', 'http://weather.gov/data/current_obs/KHUA.rss', 'http://weather.gov/data/current_obs/KHUA.xml'),
('KM82', 'AL', 'Huntsville, Madison County Executive Airport', '34.850000', '-86.550000', 'http://weather.noaa.gov/weather/current/KM82.html', 'http://weather.gov/data/current_obs/KM82.rss', 'http://weather.gov/data/current_obs/KM82.xml'),
('KMDQ', 'AL', 'Huntsville-Madison Co Exec Airport', '34.860000', '-86.560000', 'http://weather.noaa.gov/weather/current/KMDQ.html', 'http://weather.gov/data/current_obs/KMDQ.rss', 'http://weather.gov/data/current_obs/KMDQ.xml'),
('KMGM', 'AL', 'Montgomery, Dannelly Field', '32.300000', '-86.400000', 'http://weather.noaa.gov/weather/current/KMGM.html', 'http://weather.gov/data/current_obs/KMGM.rss', 'http://weather.gov/data/current_obs/KMGM.xml'),
('KMOB', 'AL', 'Mobile Regional Airport', '30.680000', '-88.250000', 'http://weather.noaa.gov/weather/current/KMOB.html', 'http://weather.gov/data/current_obs/KMOB.rss', 'http://weather.gov/data/current_obs/KMOB.xml'),
('KMSL', 'AL', 'Muscle Shoals, North West Alabama Regional Airport', '34.750000', '-87.610000', 'http://weather.noaa.gov/weather/current/KMSL.html', 'http://weather.gov/data/current_obs/KMSL.rss', 'http://weather.gov/data/current_obs/KMSL.xml'),
('KMXF', 'AL', 'Maxwell Air Force Base / Montgomery', '32.383000', '-86.367000', 'http://weather.noaa.gov/weather/current/KMXF.html', 'http://weather.gov/data/current_obs/KMXF.rss', 'http://weather.gov/data/current_obs/KMXF.xml'),
('KOZR', 'AL', 'Cairns Army Air Field / Ozark', '31.283000', '-85.717000', 'http://weather.noaa.gov/weather/current/KOZR.html', 'http://weather.gov/data/current_obs/KOZR.rss', 'http://weather.gov/data/current_obs/KOZR.xml'),
('KTCL', 'AL', 'Tuscaloosa Regional Airport', '33.230000', '-87.620000', 'http://weather.noaa.gov/weather/current/KTCL.html', 'http://weather.gov/data/current_obs/KTCL.rss', 'http://weather.gov/data/current_obs/KTCL.xml'),
('KTOI', 'AL', 'Troy Municipal Airport', '31.860000', '-86.010000', 'http://weather.noaa.gov/weather/current/KTOI.html', 'http://weather.gov/data/current_obs/KTOI.rss', 'http://weather.gov/data/current_obs/KTOI.xml'),
('KHEY', 'AL', 'Hanchey Army Heliport (Fort Rucker)', '31.346000', '-86.654000', 'http://weather.noaa.gov/weather/current/KHEY.html', 'http://weather.gov/data/current_obs/KHEY.rss', 'http://weather.gov/data/current_obs/KHEY.xml'),
('KPRN', 'AL', 'Mac Crenshaw Memorial Airport', '31.845700', '-86.610700', 'http://weather.noaa.gov/weather/current/KPRN.html', 'http://weather.gov/data/current_obs/KPRN.rss', 'http://weather.gov/data/current_obs/KPRN.xml'),
('K1M4', 'AL', 'Posey Field Airport', '34.280000', '-87.600000', 'http://weather.noaa.gov/weather/current/K1M4.html', 'http://weather.gov/data/current_obs/K1M4.rss', 'http://weather.gov/data/current_obs/K1M4.xml'),
('KJKA', 'AL', 'Jack Edwards Airport', '30.289600', '-87.671800', 'http://weather.noaa.gov/weather/current/KJKA.html', 'http://weather.gov/data/current_obs/KJKA.rss', 'http://weather.gov/data/current_obs/KJKA.xml'),
('K8A0', 'AL', 'Albertville Regional Airport-Thomas J Brumlik Fiel', '34.229100', '-86.255800', 'http://weather.noaa.gov/weather/current/K8A0.html', 'http://weather.gov/data/current_obs/K8A0.rss', 'http://weather.gov/data/current_obs/K8A0.xml'),
('KARG', 'AR', 'Walnut Ridge Automatic Weather Observing / Report', '36.140000', '-90.920000', 'http://weather.noaa.gov/weather/current/KARG.html', 'http://weather.gov/data/current_obs/KARG.rss', 'http://weather.gov/data/current_obs/KARG.xml'),
('KASG', 'AR', 'Springdale Municipal', '36.190000', '-94.120000', 'http://weather.noaa.gov/weather/current/KASG.html', 'http://weather.gov/data/current_obs/KASG.rss', 'http://weather.gov/data/current_obs/KASG.xml'),
('KAWM', 'AR', 'West Memphis', '35.135000', '-90.234000', 'http://weather.noaa.gov/weather/current/KAWM.html', 'http://weather.gov/data/current_obs/KAWM.rss', 'http://weather.gov/data/current_obs/KAWM.xml'),
('KBPK', 'AR', 'Mountain Home, Ozark Regional Airport', '36.370000', '-92.470000', 'http://weather.noaa.gov/weather/current/KBPK.html', 'http://weather.gov/data/current_obs/KBPK.rss', 'http://weather.gov/data/current_obs/KBPK.xml'),
('KBVX', 'AR', 'Batesville Automatic Weather Observing / Reporting', '35.730000', '-91.650000', 'http://weather.noaa.gov/weather/current/KBVX.html', 'http://weather.gov/data/current_obs/KBVX.rss', 'http://weather.gov/data/current_obs/KBVX.xml'),
('KBYH', 'AR', 'Eaker Air Force Base', '35.967000', '-89.950000', 'http://weather.noaa.gov/weather/current/KBYH.html', 'http://weather.gov/data/current_obs/KBYH.rss', 'http://weather.gov/data/current_obs/KBYH.xml'),
('KDEQ', 'AR', 'De Queen, Helms Sevier County Airport', '34.050000', '-94.400000', 'http://weather.noaa.gov/weather/current/KDEQ.html', 'http://weather.gov/data/current_obs/KDEQ.rss', 'http://weather.gov/data/current_obs/KDEQ.xml'),
('KELD', 'AR', 'El Dorado, So. Arkansas Regional at Goodwin Field', '33.230000', '-92.800000', 'http://weather.noaa.gov/weather/current/KELD.html', 'http://weather.gov/data/current_obs/KELD.rss', 'http://weather.gov/data/current_obs/KELD.xml'),
('KFLP', 'AR', 'Flippin Automatic Weather Observing/Reporting Sys', '36.290000', '-92.590000', 'http://weather.noaa.gov/weather/current/KFLP.html', 'http://weather.gov/data/current_obs/KFLP.rss', 'http://weather.gov/data/current_obs/KFLP.xml'),
('KFSM', 'AR', 'Fort Smith Regional Airport', '35.340000', '-94.370000', 'http://weather.noaa.gov/weather/current/KFSM.html', 'http://weather.gov/data/current_obs/KFSM.rss', 'http://weather.gov/data/current_obs/KFSM.xml'),
('KFYV', 'AR', 'Fayetteville, Drake Field', '36.010000', '-94.170000', 'http://weather.noaa.gov/weather/current/KFYV.html', 'http://weather.gov/data/current_obs/KFYV.rss', 'http://weather.gov/data/current_obs/KFYV.xml'),
('KHKA', 'AR', 'Blytheville Municipal Airport', '35.940000', '-89.830000', 'http://weather.noaa.gov/weather/current/KHKA.html', 'http://weather.gov/data/current_obs/KHKA.rss', 'http://weather.gov/data/current_obs/KHKA.xml'),
('KHOT', 'AR', 'Hot Springs, Memorial Field Airport', '34.480000', '-93.100000', 'http://weather.noaa.gov/weather/current/KHOT.html', 'http://weather.gov/data/current_obs/KHOT.rss', 'http://weather.gov/data/current_obs/KHOT.xml'),
('KHRO', 'AR', 'Harrison, Boone County Airport', '36.280000', '-93.150000', 'http://weather.noaa.gov/weather/current/KHRO.html', 'http://weather.gov/data/current_obs/KHRO.rss', 'http://weather.gov/data/current_obs/KHRO.xml'),
('KJBR', 'AR', 'Jonesboro Municipal Airport', '35.830000', '-90.650000', 'http://weather.noaa.gov/weather/current/KJBR.html', 'http://weather.gov/data/current_obs/KJBR.rss', 'http://weather.gov/data/current_obs/KJBR.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('KLIT', 'AR', 'Little Rock, Adams Field', '34.730000', '-92.230000', 'http://weather.noaa.gov/weather/current/KLIT.html', 'http://weather.gov/data/current_obs/KLIT.rss', 'http://weather.gov/data/current_obs/KLIT.xml'),
('KLLQ', 'AR', 'Monticello Municipal Airport', '33.640000', '-91.750000', 'http://weather.noaa.gov/weather/current/KLLQ.html', 'http://weather.gov/data/current_obs/KLLQ.rss', 'http://weather.gov/data/current_obs/KLLQ.xml'),
('KLRF', 'AR', 'Little Rock Air Force Base', '34.917000', '-92.150000', 'http://weather.noaa.gov/weather/current/KLRF.html', 'http://weather.gov/data/current_obs/KLRF.rss', 'http://weather.gov/data/current_obs/KLRF.xml'),
('KMEZ', 'AR', 'Mena Intermountain Municipal Airport', '34.550000', '-93.583000', 'http://weather.noaa.gov/weather/current/KMEZ.html', 'http://weather.gov/data/current_obs/KMEZ.rss', 'http://weather.gov/data/current_obs/KMEZ.xml'),
('KMWT', 'AR', 'Mount Ida', '34.547000', '-93.578000', 'http://weather.noaa.gov/weather/current/KMWT.html', 'http://weather.gov/data/current_obs/KMWT.rss', 'http://weather.gov/data/current_obs/KMWT.xml'),
('KPBF', 'AR', 'Pine Bluff, Grider Field Airport', '34.180000', '-91.930000', 'http://weather.noaa.gov/weather/current/KPBF.html', 'http://weather.gov/data/current_obs/KPBF.rss', 'http://weather.gov/data/current_obs/KPBF.xml'),
('KROG', 'AR', 'Rogers Automatic Weather Observing / Reporting Sys', '36.380000', '-94.110000', 'http://weather.noaa.gov/weather/current/KROG.html', 'http://weather.gov/data/current_obs/KROG.rss', 'http://weather.gov/data/current_obs/KROG.xml'),
('KRUE', 'AR', 'Russellville Municipal Airport', '35.260000', '-93.090000', 'http://weather.noaa.gov/weather/current/KRUE.html', 'http://weather.gov/data/current_obs/KRUE.rss', 'http://weather.gov/data/current_obs/KRUE.xml'),
('KSGT', 'AR', 'Stuttgart Automatic Weather Observing / Reporting', '34.610000', '-91.570000', 'http://weather.noaa.gov/weather/current/KSGT.html', 'http://weather.gov/data/current_obs/KSGT.rss', 'http://weather.gov/data/current_obs/KSGT.xml'),
('KSLG', 'AR', 'Siloam Springs Automatic Weather Observing/Report', '36.190000', '-94.490000', 'http://weather.noaa.gov/weather/current/KSLG.html', 'http://weather.gov/data/current_obs/KSLG.rss', 'http://weather.gov/data/current_obs/KSLG.xml'),
('KM19', 'AR', 'Newport Municipal Airport', '35.600000', '-91.200000', 'http://weather.noaa.gov/weather/current/KM19.html', 'http://weather.gov/data/current_obs/KM19.rss', 'http://weather.gov/data/current_obs/KM19.xml'),
('KTXK', 'AR', 'Texarkana Regional-Webb Field', '33.460000', '-94.000000', 'http://weather.noaa.gov/weather/current/KTXK.html', 'http://weather.gov/data/current_obs/KTXK.rss', 'http://weather.gov/data/current_obs/KTXK.xml'),
('KVBT', 'AR', 'Bentonville Automatic Weather Observing/Reporting', '36.350000', '-94.220000', 'http://weather.noaa.gov/weather/current/KVBT.html', 'http://weather.gov/data/current_obs/KVBT.rss', 'http://weather.gov/data/current_obs/KVBT.xml'),
('KXNA', 'AR', 'Fayetteville/Springdale, NW Arkansas Regl Airport', '36.282000', '-94.307000', 'http://weather.noaa.gov/weather/current/KXNA.html', 'http://weather.gov/data/current_obs/KXNA.rss', 'http://weather.gov/data/current_obs/KXNA.xml'),
('KM89', 'AR', 'Dexter B Florence Memorial Field Airport', '34.100000', '-93.070000', 'http://weather.noaa.gov/weather/current/KM89.html', 'http://weather.gov/data/current_obs/KM89.rss', 'http://weather.gov/data/current_obs/KM89.xml'),
('KCCA', 'AR', 'Clinton Municipal Airport', '35.598000', '-92.352000', 'http://weather.noaa.gov/weather/current/KCCA.html', 'http://weather.gov/data/current_obs/KCCA.rss', 'http://weather.gov/data/current_obs/KCCA.xml'),
('KCDH', 'AR', 'Harrell Field Airport', '33.623000', '-92.763000', 'http://weather.noaa.gov/weather/current/KCDH.html', 'http://weather.gov/data/current_obs/KCDH.rss', 'http://weather.gov/data/current_obs/KCDH.xml'),
('NSTU', 'AS', 'Pago Pago', '-14.333000', '-170.717000', 'http://weather.noaa.gov/weather/current/NSTU.html', 'http://weather.gov/data/current_obs/NSTU.rss', 'http://weather.gov/data/current_obs/NSTU.xml'),
('TNCA', 'AW', 'Queen Beatrix Airport', '12.500000', '-70.017000', 'http://weather.noaa.gov/weather/current/TNCA.html', 'http://weather.gov/data/current_obs/TNCA.rss', 'http://weather.gov/data/current_obs/TNCA.xml'),
('K40G', 'AZ', 'Grand Canyon, Valle Airport', '35.650000', '-112.150000', 'http://weather.noaa.gov/weather/current/K40G.html', 'http://weather.gov/data/current_obs/K40G.rss', 'http://weather.gov/data/current_obs/K40G.xml'),
('KCGZ', 'AZ', 'Casa Grande (awos)', '32.960000', '-111.770000', 'http://weather.noaa.gov/weather/current/KCGZ.html', 'http://weather.gov/data/current_obs/KCGZ.rss', 'http://weather.gov/data/current_obs/KCGZ.xml'),
('KCHD', 'AZ', 'Chandler Municipal Airport', '33.270000', '-111.810000', 'http://weather.noaa.gov/weather/current/KCHD.html', 'http://weather.gov/data/current_obs/KCHD.rss', 'http://weather.gov/data/current_obs/KCHD.xml'),
('KDMA', 'AZ', 'Davis-Monthan AFB', '32.180000', '-110.880000', 'http://weather.noaa.gov/weather/current/KDMA.html', 'http://weather.gov/data/current_obs/KDMA.rss', 'http://weather.gov/data/current_obs/KDMA.xml'),
('KDUG', 'AZ', 'Douglas Bisbee Intl Airport', '31.450000', '-109.600000', 'http://weather.noaa.gov/weather/current/KDUG.html', 'http://weather.gov/data/current_obs/KDUG.rss', 'http://weather.gov/data/current_obs/KDUG.xml'),
('KDVT', 'AZ', 'Deer Valley/Phoenix', '33.690000', '-112.080000', 'http://weather.noaa.gov/weather/current/KDVT.html', 'http://weather.gov/data/current_obs/KDVT.rss', 'http://weather.gov/data/current_obs/KDVT.xml'),
('KFFZ', 'AZ', 'Mesa/Falcon Field', '33.460000', '-111.730000', 'http://weather.noaa.gov/weather/current/KFFZ.html', 'http://weather.gov/data/current_obs/KFFZ.rss', 'http://weather.gov/data/current_obs/KFFZ.xml'),
('KFHU', 'AZ', 'Fort Huachuca/Libby', '31.580000', '-110.330000', 'http://weather.noaa.gov/weather/current/KFHU.html', 'http://weather.gov/data/current_obs/KFHU.rss', 'http://weather.gov/data/current_obs/KFHU.xml'),
('KFLG', 'AZ', 'Flagstaff (amos)', '35.140000', '-111.670000', 'http://weather.noaa.gov/weather/current/KFLG.html', 'http://weather.gov/data/current_obs/KFLG.rss', 'http://weather.gov/data/current_obs/KFLG.xml'),
('KGBN', 'AZ', 'Gila Bend (aaf)', '32.890000', '-112.720000', 'http://weather.noaa.gov/weather/current/KGBN.html', 'http://weather.gov/data/current_obs/KGBN.rss', 'http://weather.gov/data/current_obs/KGBN.xml'),
('KGCN', 'AZ', 'Grand Canyon Park', '35.960000', '-112.150000', 'http://weather.noaa.gov/weather/current/KGCN.html', 'http://weather.gov/data/current_obs/KGCN.rss', 'http://weather.gov/data/current_obs/KGCN.xml'),
('KGEU', 'AZ', 'Glendale', '33.530000', '-112.300000', 'http://weather.noaa.gov/weather/current/KGEU.html', 'http://weather.gov/data/current_obs/KGEU.rss', 'http://weather.gov/data/current_obs/KGEU.xml'),
('KGYR', 'AZ', 'Goodyear Municipal', '33.420000', '-112.390000', 'http://weather.noaa.gov/weather/current/KGYR.html', 'http://weather.gov/data/current_obs/KGYR.rss', 'http://weather.gov/data/current_obs/KGYR.xml'),
('KIFP', 'AZ', 'Bull Head City', '35.110000', '-114.500000', 'http://weather.noaa.gov/weather/current/KIFP.html', 'http://weather.gov/data/current_obs/KIFP.rss', 'http://weather.gov/data/current_obs/KIFP.xml'),
('KIGM', 'AZ', 'Kingman (amos)', '35.280000', '-113.950000', 'http://weather.noaa.gov/weather/current/KIGM.html', 'http://weather.gov/data/current_obs/KIGM.rss', 'http://weather.gov/data/current_obs/KIGM.xml'),
('KINW', 'AZ', 'Winslow (aut)', '35.030000', '-110.730000', 'http://weather.noaa.gov/weather/current/KINW.html', 'http://weather.gov/data/current_obs/KINW.rss', 'http://weather.gov/data/current_obs/KINW.xml'),
('KIWA', 'AZ', 'Williams AFB/Chandl', '33.300000', '-111.670000', 'http://weather.noaa.gov/weather/current/KIWA.html', 'http://weather.gov/data/current_obs/KIWA.rss', 'http://weather.gov/data/current_obs/KIWA.xml'),
('KLUF', 'AZ', 'Luke AFB/Phoenix', '33.590000', '-112.370000', 'http://weather.noaa.gov/weather/current/KLUF.html', 'http://weather.gov/data/current_obs/KLUF.rss', 'http://weather.gov/data/current_obs/KLUF.xml'),
('KNYL', 'AZ', 'Yuma Mcas', '32.390000', '-114.370000', 'http://weather.noaa.gov/weather/current/KNYL.html', 'http://weather.gov/data/current_obs/KNYL.rss', 'http://weather.gov/data/current_obs/KNYL.xml'),
('KOLS', 'AZ', 'Nogales Intl Airport', '31.420000', '-110.850000', 'http://weather.noaa.gov/weather/current/KOLS.html', 'http://weather.gov/data/current_obs/KOLS.rss', 'http://weather.gov/data/current_obs/KOLS.xml'),
('KPGA', 'AZ', 'Page Muni (amos)', '36.940000', '-111.450000', 'http://weather.noaa.gov/weather/current/KPGA.html', 'http://weather.gov/data/current_obs/KPGA.rss', 'http://weather.gov/data/current_obs/KPGA.xml'),
('KPHX', 'AZ', 'Phoenix/Sky Harbor', '33.440000', '-112.020000', 'http://weather.noaa.gov/weather/current/KPHX.html', 'http://weather.gov/data/current_obs/KPHX.rss', 'http://weather.gov/data/current_obs/KPHX.xml'),
('KPRC', 'AZ', 'Prescott/Love Fld', '34.650000', '-112.420000', 'http://weather.noaa.gov/weather/current/KPRC.html', 'http://weather.gov/data/current_obs/KPRC.rss', 'http://weather.gov/data/current_obs/KPRC.xml'),
('KRQE', 'AZ', 'Window Rock (was P34)', '35.657000', '-109.061000', 'http://weather.noaa.gov/weather/current/KRQE.html', 'http://weather.gov/data/current_obs/KRQE.rss', 'http://weather.gov/data/current_obs/KRQE.xml'),
('KSAD', 'AZ', 'Safford Municipal', '32.850000', '-109.640000', 'http://weather.noaa.gov/weather/current/KSAD.html', 'http://weather.gov/data/current_obs/KSAD.rss', 'http://weather.gov/data/current_obs/KSAD.xml'),
('KSDL', 'AZ', 'Scottsdale Muni', '33.610000', '-111.910000', 'http://weather.noaa.gov/weather/current/KSDL.html', 'http://weather.gov/data/current_obs/KSDL.rss', 'http://weather.gov/data/current_obs/KSDL.xml'),
('KSJN', 'AZ', 'St. Johns Air Park', '34.520000', '-109.380000', 'http://weather.noaa.gov/weather/current/KSJN.html', 'http://weather.gov/data/current_obs/KSJN.rss', 'http://weather.gov/data/current_obs/KSJN.xml'),
('KSOW', 'AZ', 'Show Low Municipal', '34.280000', '-110.000000', 'http://weather.noaa.gov/weather/current/KSOW.html', 'http://weather.gov/data/current_obs/KSOW.rss', 'http://weather.gov/data/current_obs/KSOW.xml'),
('KTUS', 'AZ', 'Tucson Intl Airport', '32.120000', '-110.930000', 'http://weather.noaa.gov/weather/current/KTUS.html', 'http://weather.gov/data/current_obs/KTUS.rss', 'http://weather.gov/data/current_obs/KTUS.xml'),
('KWTR', 'AZ', 'Whiteriver Airport', '41.400000', '-104.867000', 'http://weather.noaa.gov/weather/current/KWTR.html', 'http://weather.gov/data/current_obs/KWTR.rss', 'http://weather.gov/data/current_obs/KWTR.xml'),
('KYUM', 'AZ', 'Yuma', '32.667000', '-114.600000', 'http://weather.noaa.gov/weather/current/KYUM.html', 'http://weather.gov/data/current_obs/KYUM.rss', 'http://weather.gov/data/current_obs/KYUM.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('TBPB', 'BB', 'Grantley Adams', '13.067000', '-59.483000', 'http://weather.noaa.gov/weather/current/TBPB.html', 'http://weather.gov/data/current_obs/TBPB.rss', 'http://weather.gov/data/current_obs/TBPB.xml'),
('MYNN', 'BH', 'Nassau Bahamas', '25.050000', '-77.467000', 'http://weather.noaa.gov/weather/current/MYNN.html', 'http://weather.gov/data/current_obs/MYNN.rss', 'http://weather.gov/data/current_obs/MYNN.xml'),
('K3A6', 'CA', 'Newhall', '34.400000', '-118.600000', 'http://weather.noaa.gov/weather/current/K3A6.html', 'http://weather.gov/data/current_obs/K3A6.rss', 'http://weather.gov/data/current_obs/K3A6.xml'),
('K87Q', 'CA', 'Pt Piedras(cg/Amos)', '35.680000', '-121.280000', 'http://weather.noaa.gov/weather/current/K87Q.html', 'http://weather.gov/data/current_obs/K87Q.rss', 'http://weather.gov/data/current_obs/K87Q.xml'),
('K9L2', 'CA', 'Edwards Air Force Aux No Base', '34.983000', '-117.867000', 'http://weather.noaa.gov/weather/current/K9L2.html', 'http://weather.gov/data/current_obs/K9L2.rss', 'http://weather.gov/data/current_obs/K9L2.xml'),
('KAAT', 'CA', 'Alturas (was O00)', '41.491000', '-120.564000', 'http://weather.noaa.gov/weather/current/KAAT.html', 'http://weather.gov/data/current_obs/KAAT.rss', 'http://weather.gov/data/current_obs/KAAT.xml'),
('KACV', 'CA', 'Arcata/Eureka Airport', '40.990000', '-124.100000', 'http://weather.noaa.gov/weather/current/KACV.html', 'http://weather.gov/data/current_obs/KACV.rss', 'http://weather.gov/data/current_obs/KACV.xml'),
('KAPC', 'CA', 'Napa Co. Airport', '38.210000', '-122.280000', 'http://weather.noaa.gov/weather/current/KAPC.html', 'http://weather.gov/data/current_obs/KAPC.rss', 'http://weather.gov/data/current_obs/KAPC.xml'),
('KAUN', 'CA', 'Auburn Muni Airport', '38.955000', '-121.082000', 'http://weather.noaa.gov/weather/current/KAUN.html', 'http://weather.gov/data/current_obs/KAUN.rss', 'http://weather.gov/data/current_obs/KAUN.xml'),
('KAVX', 'CA', 'Avalon, Catalina Airport', '33.410000', '-118.420000', 'http://weather.noaa.gov/weather/current/KAVX.html', 'http://weather.gov/data/current_obs/KAVX.rss', 'http://weather.gov/data/current_obs/KAVX.xml'),
('KBAB', 'CA', 'Beale AFB/Marysville', '39.140000', '-121.440000', 'http://weather.noaa.gov/weather/current/KBAB.html', 'http://weather.gov/data/current_obs/KBAB.rss', 'http://weather.gov/data/current_obs/KBAB.xml'),
('KBFL', 'CA', 'Bakersfield/Meadows', '35.430000', '-119.050000', 'http://weather.noaa.gov/weather/current/KBFL.html', 'http://weather.gov/data/current_obs/KBFL.rss', 'http://weather.gov/data/current_obs/KBFL.xml'),
('KBIH', 'CA', 'Bishop Airport', '37.370000', '-118.370000', 'http://weather.noaa.gov/weather/current/KBIH.html', 'http://weather.gov/data/current_obs/KBIH.rss', 'http://weather.gov/data/current_obs/KBIH.xml'),
('KBLH', 'CA', 'Blythe Airport', '33.620000', '-114.720000', 'http://weather.noaa.gov/weather/current/KBLH.html', 'http://weather.gov/data/current_obs/KBLH.rss', 'http://weather.gov/data/current_obs/KBLH.xml'),
('KBLU', 'CA', 'Blue Canyon (amos)', '39.290000', '-120.700000', 'http://weather.noaa.gov/weather/current/KBLU.html', 'http://weather.gov/data/current_obs/KBLU.rss', 'http://weather.gov/data/current_obs/KBLU.xml'),
('KBNY', 'CA', 'Burney', '40.883000', '-121.667000', 'http://weather.noaa.gov/weather/current/KBNY.html', 'http://weather.gov/data/current_obs/KBNY.rss', 'http://weather.gov/data/current_obs/KBNY.xml'),
('KBUR', 'CA', 'Burbank/Glendale', '34.200000', '-118.360000', 'http://weather.noaa.gov/weather/current/KBUR.html', 'http://weather.gov/data/current_obs/KBUR.rss', 'http://weather.gov/data/current_obs/KBUR.xml'),
('KCCR', 'CA', 'Concord/Buchanan', '37.980000', '-122.050000', 'http://weather.noaa.gov/weather/current/KCCR.html', 'http://weather.gov/data/current_obs/KCCR.rss', 'http://weather.gov/data/current_obs/KCCR.xml'),
('KCEC', 'CA', 'Crescent City', '41.790000', '-124.240000', 'http://weather.noaa.gov/weather/current/KCEC.html', 'http://weather.gov/data/current_obs/KCEC.rss', 'http://weather.gov/data/current_obs/KCEC.xml'),
('KCIC', 'CA', 'Chico Municipal', '39.790000', '-121.850000', 'http://weather.noaa.gov/weather/current/KCIC.html', 'http://weather.gov/data/current_obs/KCIC.rss', 'http://weather.gov/data/current_obs/KCIC.xml'),
('KCMA', 'CA', 'Camarillo (awos)', '34.210000', '-119.090000', 'http://weather.noaa.gov/weather/current/KCMA.html', 'http://weather.gov/data/current_obs/KCMA.rss', 'http://weather.gov/data/current_obs/KCMA.xml'),
('KCNO', 'CA', 'Chino Airport', '33.970000', '-117.640000', 'http://weather.noaa.gov/weather/current/KCNO.html', 'http://weather.gov/data/current_obs/KCNO.rss', 'http://weather.gov/data/current_obs/KCNO.xml'),
('KCQT', 'CA', 'Los Angeles Downtown/Usc', '34.020000', '-118.280000', 'http://weather.noaa.gov/weather/current/KCQT.html', 'http://weather.gov/data/current_obs/KCQT.rss', 'http://weather.gov/data/current_obs/KCQT.xml'),
('KCRQ', 'CA', 'Carlsbad/Palomar', '33.140000', '-117.280000', 'http://weather.noaa.gov/weather/current/KCRQ.html', 'http://weather.gov/data/current_obs/KCRQ.rss', 'http://weather.gov/data/current_obs/KCRQ.xml'),
('KCZZ', 'CA', 'Campo (awrs)', '32.620000', '-116.470000', 'http://weather.noaa.gov/weather/current/KCZZ.html', 'http://weather.gov/data/current_obs/KCZZ.rss', 'http://weather.gov/data/current_obs/KCZZ.xml'),
('KDAG', 'CA', 'Barstow-Daggett', '34.880000', '-116.780000', 'http://weather.noaa.gov/weather/current/KDAG.html', 'http://weather.gov/data/current_obs/KDAG.rss', 'http://weather.gov/data/current_obs/KDAG.xml'),
('KEDW', 'CA', 'Edwards AFB', '34.910000', '-117.870000', 'http://weather.noaa.gov/weather/current/KEDW.html', 'http://weather.gov/data/current_obs/KEDW.rss', 'http://weather.gov/data/current_obs/KEDW.xml'),
('KEED', 'CA', 'Needles Airport', '34.780000', '-114.620000', 'http://weather.noaa.gov/weather/current/KEED.html', 'http://weather.gov/data/current_obs/KEED.rss', 'http://weather.gov/data/current_obs/KEED.xml'),
('KEKA', 'CA', 'Eureka', '40.800000', '-124.167000', 'http://weather.noaa.gov/weather/current/KEKA.html', 'http://weather.gov/data/current_obs/KEKA.rss', 'http://weather.gov/data/current_obs/KEKA.xml'),
('KEMT', 'CA', 'El Monte', '34.090000', '-118.030000', 'http://weather.noaa.gov/weather/current/KEMT.html', 'http://weather.gov/data/current_obs/KEMT.rss', 'http://weather.gov/data/current_obs/KEMT.xml'),
('KFAT', 'CA', 'Fresno Air Terminal', '36.780000', '-119.720000', 'http://weather.noaa.gov/weather/current/KFAT.html', 'http://weather.gov/data/current_obs/KFAT.rss', 'http://weather.gov/data/current_obs/KFAT.xml'),
('KFUL', 'CA', 'Fullerton Municipal', '33.870000', '-117.980000', 'http://weather.noaa.gov/weather/current/KFUL.html', 'http://weather.gov/data/current_obs/KFUL.rss', 'http://weather.gov/data/current_obs/KFUL.xml'),
('KHHR', 'CA', 'Hawthorne Municipal', '33.930000', '-118.340000', 'http://weather.noaa.gov/weather/current/KHHR.html', 'http://weather.gov/data/current_obs/KHHR.rss', 'http://weather.gov/data/current_obs/KHHR.xml'),
('KHJO', 'CA', 'Hanford', '36.318000', '-119.629000', 'http://weather.noaa.gov/weather/current/KHJO.html', 'http://weather.gov/data/current_obs/KHJO.rss', 'http://weather.gov/data/current_obs/KHJO.xml'),
('KHWD', 'CA', 'Hayward Air Term', '37.660000', '-122.120000', 'http://weather.noaa.gov/weather/current/KHWD.html', 'http://weather.gov/data/current_obs/KHWD.rss', 'http://weather.gov/data/current_obs/KHWD.xml'),
('KIPL', 'CA', 'Imperial', '32.840000', '-115.570000', 'http://weather.noaa.gov/weather/current/KIPL.html', 'http://weather.gov/data/current_obs/KIPL.rss', 'http://weather.gov/data/current_obs/KIPL.xml'),
('KIYK', 'CA', 'Inyokern', '35.660000', '-117.830000', 'http://weather.noaa.gov/weather/current/KIYK.html', 'http://weather.gov/data/current_obs/KIYK.rss', 'http://weather.gov/data/current_obs/KIYK.xml'),
('KIZA', 'CA', 'Santa Ynez Airport', '34.600000', '-120.067000', 'http://weather.noaa.gov/weather/current/KIZA.html', 'http://weather.gov/data/current_obs/KIZA.rss', 'http://weather.gov/data/current_obs/KIZA.xml'),
('KLAX', 'CA', 'Los Angeles Intl Airport', '33.940000', '-118.400000', 'http://weather.noaa.gov/weather/current/KLAX.html', 'http://weather.gov/data/current_obs/KLAX.rss', 'http://weather.gov/data/current_obs/KLAX.xml'),
('KLGB', 'CA', 'Long Beach Airport', '33.830000', '-118.150000', 'http://weather.noaa.gov/weather/current/KLGB.html', 'http://weather.gov/data/current_obs/KLGB.rss', 'http://weather.gov/data/current_obs/KLGB.xml'),
('KLPC', 'CA', 'Lompoc (awos)', '34.670000', '-120.470000', 'http://weather.noaa.gov/weather/current/KLPC.html', 'http://weather.gov/data/current_obs/KLPC.rss', 'http://weather.gov/data/current_obs/KLPC.xml'),
('KLVK', 'CA', 'Livermore Municipal', '37.700000', '-121.820000', 'http://weather.noaa.gov/weather/current/KLVK.html', 'http://weather.gov/data/current_obs/KLVK.rss', 'http://weather.gov/data/current_obs/KLVK.xml'),
('KMAE', 'CA', 'Madera Municipal Airport', '36.990000', '-120.110000', 'http://weather.noaa.gov/weather/current/KMAE.html', 'http://weather.gov/data/current_obs/KMAE.rss', 'http://weather.gov/data/current_obs/KMAE.xml'),
('KMCC', 'CA', 'McClellan Airfield', '38.667000', '-121.400000', 'http://weather.noaa.gov/weather/current/KMCC.html', 'http://weather.gov/data/current_obs/KMCC.rss', 'http://weather.gov/data/current_obs/KMCC.xml'),
('KMCE', 'CA', 'Merced/Macready Fld', '37.290000', '-120.520000', 'http://weather.noaa.gov/weather/current/KMCE.html', 'http://weather.gov/data/current_obs/KMCE.rss', 'http://weather.gov/data/current_obs/KMCE.xml'),
('KMHR', 'CA', 'Mather Field', '38.580000', '-121.300000', 'http://weather.noaa.gov/weather/current/KMHR.html', 'http://weather.gov/data/current_obs/KMHR.rss', 'http://weather.gov/data/current_obs/KMHR.xml'),
('KMHS', 'CA', 'Mount Shasta (amos)', '41.330000', '-122.320000', 'http://weather.noaa.gov/weather/current/KMHS.html', 'http://weather.gov/data/current_obs/KMHS.rss', 'http://weather.gov/data/current_obs/KMHS.xml'),
('KMHV', 'CA', 'Mojave', '35.070000', '-118.160000', 'http://weather.noaa.gov/weather/current/KMHV.html', 'http://weather.gov/data/current_obs/KMHV.rss', 'http://weather.gov/data/current_obs/KMHV.xml'),
('KMMH', 'CA', 'Mammoth/June Lakes', '37.640000', '-118.920000', 'http://weather.noaa.gov/weather/current/KMMH.html', 'http://weather.gov/data/current_obs/KMMH.rss', 'http://weather.gov/data/current_obs/KMMH.xml'),
('KMOD', 'CA', 'Modesto City/Sham', '37.630000', '-120.950000', 'http://weather.noaa.gov/weather/current/KMOD.html', 'http://weather.gov/data/current_obs/KMOD.rss', 'http://weather.gov/data/current_obs/KMOD.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('KMRY', 'CA', 'Monterey Peninsula', '36.590000', '-121.840000', 'http://weather.noaa.gov/weather/current/KMRY.html', 'http://weather.gov/data/current_obs/KMRY.rss', 'http://weather.gov/data/current_obs/KMRY.xml'),
('KMWS', 'CA', 'Mount Wilson', '34.233000', '-118.067000', 'http://weather.noaa.gov/weather/current/KMWS.html', 'http://weather.gov/data/current_obs/KMWS.rss', 'http://weather.gov/data/current_obs/KMWS.xml'),
('KMYF', 'CA', 'San Diego/Montg', '32.830000', '-117.130000', 'http://weather.noaa.gov/weather/current/KMYF.html', 'http://weather.gov/data/current_obs/KMYF.rss', 'http://weather.gov/data/current_obs/KMYF.xml'),
('KMYV', 'CA', 'Marysville/Yuba Co.', '39.110000', '-121.570000', 'http://weather.noaa.gov/weather/current/KMYV.html', 'http://weather.gov/data/current_obs/KMYV.rss', 'http://weather.gov/data/current_obs/KMYV.xml'),
('KNFG', 'CA', 'Camp Pendleton Mcas', '33.300000', '-117.350000', 'http://weather.noaa.gov/weather/current/KNFG.html', 'http://weather.gov/data/current_obs/KNFG.rss', 'http://weather.gov/data/current_obs/KNFG.xml'),
('KNID', 'CA', 'China Lake (naf)', '35.690000', '-117.680000', 'http://weather.noaa.gov/weather/current/KNID.html', 'http://weather.gov/data/current_obs/KNID.rss', 'http://weather.gov/data/current_obs/KNID.xml'),
('KNJK', 'CA', 'El Centro Naf', '32.830000', '-115.680000', 'http://weather.noaa.gov/weather/current/KNJK.html', 'http://weather.gov/data/current_obs/KNJK.rss', 'http://weather.gov/data/current_obs/KNJK.xml'),
('KNKX', 'CA', 'Miramar Nas', '32.880000', '-117.150000', 'http://weather.noaa.gov/weather/current/KNKX.html', 'http://weather.gov/data/current_obs/KNKX.rss', 'http://weather.gov/data/current_obs/KNKX.xml'),
('KNLC', 'CA', 'Lemoore Nas/Reeves', '36.300000', '-119.900000', 'http://weather.noaa.gov/weather/current/KNLC.html', 'http://weather.gov/data/current_obs/KNLC.rss', 'http://weather.gov/data/current_obs/KNLC.xml'),
('KNRS', 'CA', 'Imperial Beach/Ream', '32.580000', '-117.120000', 'http://weather.noaa.gov/weather/current/KNRS.html', 'http://weather.gov/data/current_obs/KNRS.rss', 'http://weather.gov/data/current_obs/KNRS.xml'),
('KNSI', 'CA', 'San Nicolas Island', '33.260000', '-119.450000', 'http://weather.noaa.gov/weather/current/KNSI.html', 'http://weather.gov/data/current_obs/KNSI.rss', 'http://weather.gov/data/current_obs/KNSI.xml'),
('KNTD', 'CA', 'Pt Mugu Naws', '34.120000', '-119.120000', 'http://weather.noaa.gov/weather/current/KNTD.html', 'http://weather.gov/data/current_obs/KNTD.rss', 'http://weather.gov/data/current_obs/KNTD.xml'),
('KNUC', 'CA', 'Naval Auxiliary Landing Field', '33.030000', '-118.580000', 'http://weather.noaa.gov/weather/current/KNUC.html', 'http://weather.gov/data/current_obs/KNUC.rss', 'http://weather.gov/data/current_obs/KNUC.xml'),
('KNUQ', 'CA', 'Moffett Nas/Mtn Vie', '37.430000', '-122.050000', 'http://weather.noaa.gov/weather/current/KNUQ.html', 'http://weather.gov/data/current_obs/KNUQ.rss', 'http://weather.gov/data/current_obs/KNUQ.xml'),
('KNXP', 'CA', 'Twentynine Palms', '34.300000', '-116.170000', 'http://weather.noaa.gov/weather/current/KNXP.html', 'http://weather.gov/data/current_obs/KNXP.rss', 'http://weather.gov/data/current_obs/KNXP.xml'),
('KNZY', 'CA', 'North Island Nas', '32.710000', '-117.200000', 'http://weather.noaa.gov/weather/current/KNZY.html', 'http://weather.gov/data/current_obs/KNZY.rss', 'http://weather.gov/data/current_obs/KNZY.xml'),
('KO87', 'CA', 'Shelter Cove', '40.040000', '-124.070000', 'http://weather.noaa.gov/weather/current/KO87.html', 'http://weather.gov/data/current_obs/KO87.rss', 'http://weather.gov/data/current_obs/KO87.xml'),
('KOAK', 'CA', 'Oakland', '37.700000', '-122.220000', 'http://weather.noaa.gov/weather/current/KOAK.html', 'http://weather.gov/data/current_obs/KOAK.rss', 'http://weather.gov/data/current_obs/KOAK.xml'),
('KOKB', 'CA', 'Oceanside Municipal (was L32)', '33.219000', '-117.349000', 'http://weather.noaa.gov/weather/current/KOKB.html', 'http://weather.gov/data/current_obs/KOKB.rss', 'http://weather.gov/data/current_obs/KOKB.xml'),
('KONT', 'CA', 'Ontario Intl Arpt', '34.060000', '-117.600000', 'http://weather.noaa.gov/weather/current/KONT.html', 'http://weather.gov/data/current_obs/KONT.rss', 'http://weather.gov/data/current_obs/KONT.xml'),
('KOVE', 'CA', 'Oroville', '39.490000', '-121.620000', 'http://weather.noaa.gov/weather/current/KOVE.html', 'http://weather.gov/data/current_obs/KOVE.rss', 'http://weather.gov/data/current_obs/KOVE.xml'),
('KOXR', 'CA', 'Oxnard', '34.210000', '-119.200000', 'http://weather.noaa.gov/weather/current/KOXR.html', 'http://weather.gov/data/current_obs/KOXR.rss', 'http://weather.gov/data/current_obs/KOXR.xml'),
('KPAO', 'CA', 'Palo Alto Airport', '37.480000', '-122.120000', 'http://weather.noaa.gov/weather/current/KPAO.html', 'http://weather.gov/data/current_obs/KPAO.rss', 'http://weather.gov/data/current_obs/KPAO.xml'),
('KPMD', 'CA', 'Palmdale Production', '34.630000', '-118.080000', 'http://weather.noaa.gov/weather/current/KPMD.html', 'http://weather.gov/data/current_obs/KPMD.rss', 'http://weather.gov/data/current_obs/KPMD.xml'),
('KPOC', 'CA', 'La Verne/Brackett', '34.110000', '-117.780000', 'http://weather.noaa.gov/weather/current/KPOC.html', 'http://weather.gov/data/current_obs/KPOC.rss', 'http://weather.gov/data/current_obs/KPOC.xml'),
('KPRB', 'CA', 'Paso Robles Muni', '35.680000', '-120.630000', 'http://weather.noaa.gov/weather/current/KPRB.html', 'http://weather.gov/data/current_obs/KPRB.rss', 'http://weather.gov/data/current_obs/KPRB.xml'),
('KPSP', 'CA', 'Palm Springs Rgnl', '33.840000', '-116.500000', 'http://weather.noaa.gov/weather/current/KPSP.html', 'http://weather.gov/data/current_obs/KPSP.rss', 'http://weather.gov/data/current_obs/KPSP.xml'),
('KPTV', 'CA', 'Porterville (awos)', '36.040000', '-119.070000', 'http://weather.noaa.gov/weather/current/KPTV.html', 'http://weather.gov/data/current_obs/KPTV.rss', 'http://weather.gov/data/current_obs/KPTV.xml'),
('KRAL', 'CA', 'Riverside Municipal', '33.950000', '-117.450000', 'http://weather.noaa.gov/weather/current/KRAL.html', 'http://weather.gov/data/current_obs/KRAL.rss', 'http://weather.gov/data/current_obs/KRAL.xml'),
('KRBL', 'CA', 'Red Bluff Municipal', '40.150000', '-122.250000', 'http://weather.noaa.gov/weather/current/KRBL.html', 'http://weather.gov/data/current_obs/KRBL.rss', 'http://weather.gov/data/current_obs/KRBL.xml'),
('KRDD', 'CA', 'Redding Municipal', '40.510000', '-122.300000', 'http://weather.noaa.gov/weather/current/KRDD.html', 'http://weather.gov/data/current_obs/KRDD.rss', 'http://weather.gov/data/current_obs/KRDD.xml'),
('KRHV', 'CA', 'San Jose/Reid/Hillv', '37.340000', '-121.820000', 'http://weather.noaa.gov/weather/current/KRHV.html', 'http://weather.gov/data/current_obs/KRHV.rss', 'http://weather.gov/data/current_obs/KRHV.xml'),
('KRIV', 'CA', 'March AFB/Riverside', '33.890000', '-117.270000', 'http://weather.noaa.gov/weather/current/KRIV.html', 'http://weather.gov/data/current_obs/KRIV.rss', 'http://weather.gov/data/current_obs/KRIV.xml'),
('KRNM', 'CA', 'Ramona Airport', '33.040000', '-116.910000', 'http://weather.noaa.gov/weather/current/KRNM.html', 'http://weather.gov/data/current_obs/KRNM.rss', 'http://weather.gov/data/current_obs/KRNM.xml'),
('KSAC', 'CA', 'Sacramento/Executiv', '38.520000', '-121.500000', 'http://weather.noaa.gov/weather/current/KSAC.html', 'http://weather.gov/data/current_obs/KSAC.rss', 'http://weather.gov/data/current_obs/KSAC.xml'),
('KSAN', 'CA', 'San Diego/Lindbergh', '32.730000', '-117.170000', 'http://weather.noaa.gov/weather/current/KSAN.html', 'http://weather.gov/data/current_obs/KSAN.rss', 'http://weather.gov/data/current_obs/KSAN.xml'),
('KSBA', 'CA', 'Santa Barbara Muni', '34.440000', '-119.830000', 'http://weather.noaa.gov/weather/current/KSBA.html', 'http://weather.gov/data/current_obs/KSBA.rss', 'http://weather.gov/data/current_obs/KSBA.xml'),
('KSBP', 'CA', 'San Luis Obispo', '35.240000', '-120.640000', 'http://weather.noaa.gov/weather/current/KSBP.html', 'http://weather.gov/data/current_obs/KSBP.rss', 'http://weather.gov/data/current_obs/KSBP.xml'),
('KSCK', 'CA', 'Stockton Metro', '37.910000', '-121.250000', 'http://weather.noaa.gov/weather/current/KSCK.html', 'http://weather.gov/data/current_obs/KSCK.rss', 'http://weather.gov/data/current_obs/KSCK.xml'),
('KSDB', 'CA', 'Sandberg (aut)', '34.760000', '-118.730000', 'http://weather.noaa.gov/weather/current/KSDB.html', 'http://weather.gov/data/current_obs/KSDB.rss', 'http://weather.gov/data/current_obs/KSDB.xml'),
('KSDM', 'CA', 'San Diego/Brown Fld', '32.580000', '-116.980000', 'http://weather.noaa.gov/weather/current/KSDM.html', 'http://weather.gov/data/current_obs/KSDM.rss', 'http://weather.gov/data/current_obs/KSDM.xml'),
('KSEE', 'CA', 'San Diego/Gillespie', '32.830000', '-116.970000', 'http://weather.noaa.gov/weather/current/KSEE.html', 'http://weather.gov/data/current_obs/KSEE.rss', 'http://weather.gov/data/current_obs/KSEE.xml'),
('KSFO', 'CA', 'San Francisco Intl Airport', '37.620000', '-122.360000', 'http://weather.noaa.gov/weather/current/KSFO.html', 'http://weather.gov/data/current_obs/KSFO.rss', 'http://weather.gov/data/current_obs/KSFO.xml'),
('KSIY', 'CA', 'Montague/Siskiyou', '41.790000', '-122.470000', 'http://weather.noaa.gov/weather/current/KSIY.html', 'http://weather.gov/data/current_obs/KSIY.rss', 'http://weather.gov/data/current_obs/KSIY.xml'),
('KSJC', 'CA', 'San Jose International Airport', '37.370000', '-121.930000', 'http://weather.noaa.gov/weather/current/KSJC.html', 'http://weather.gov/data/current_obs/KSJC.rss', 'http://weather.gov/data/current_obs/KSJC.xml'),
('KSLI', 'CA', 'Los Alamitos Aaf', '33.790000', '-118.050000', 'http://weather.noaa.gov/weather/current/KSLI.html', 'http://weather.gov/data/current_obs/KSLI.rss', 'http://weather.gov/data/current_obs/KSLI.xml'),
('KSMF', 'CA', 'Sacramento Metro', '38.700000', '-121.600000', 'http://weather.noaa.gov/weather/current/KSMF.html', 'http://weather.gov/data/current_obs/KSMF.rss', 'http://weather.gov/data/current_obs/KSMF.xml'),
('KSMO', 'CA', 'Santa Monica Muni', '34.030000', '-118.450000', 'http://weather.noaa.gov/weather/current/KSMO.html', 'http://weather.gov/data/current_obs/KSMO.rss', 'http://weather.gov/data/current_obs/KSMO.xml'),
('KSMX', 'CA', 'Santa Maria Public', '34.910000', '-120.450000', 'http://weather.noaa.gov/weather/current/KSMX.html', 'http://weather.gov/data/current_obs/KSMX.rss', 'http://weather.gov/data/current_obs/KSMX.xml'),
('KSNA', 'CA', 'Santa Ana/John-Wayne', '33.680000', '-117.880000', 'http://weather.noaa.gov/weather/current/KSNA.html', 'http://weather.gov/data/current_obs/KSNA.rss', 'http://weather.gov/data/current_obs/KSNA.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('KSNS', 'CA', 'Salinas Municipal', '36.660000', '-121.610000', 'http://weather.noaa.gov/weather/current/KSNS.html', 'http://weather.gov/data/current_obs/KSNS.rss', 'http://weather.gov/data/current_obs/KSNS.xml'),
('KSQL', 'CA', 'San Carlos Airport', '37.530000', '-122.250000', 'http://weather.noaa.gov/weather/current/KSQL.html', 'http://weather.gov/data/current_obs/KSQL.rss', 'http://weather.gov/data/current_obs/KSQL.xml'),
('KSTS', 'CA', 'Santa Rosa (awos)', '38.510000', '-122.810000', 'http://weather.noaa.gov/weather/current/KSTS.html', 'http://weather.gov/data/current_obs/KSTS.rss', 'http://weather.gov/data/current_obs/KSTS.xml'),
('KSUU', 'CA', 'Travis AFB/Fairfield', '38.280000', '-121.930000', 'http://weather.noaa.gov/weather/current/KSUU.html', 'http://weather.gov/data/current_obs/KSUU.rss', 'http://weather.gov/data/current_obs/KSUU.xml'),
('KTOA', 'CA', 'Torrance Municipal', '33.800000', '-118.330000', 'http://weather.noaa.gov/weather/current/KTOA.html', 'http://weather.gov/data/current_obs/KTOA.rss', 'http://weather.gov/data/current_obs/KTOA.xml'),
('KTRK', 'CA', 'Truckee-Tahoe', '39.330000', '-120.130000', 'http://weather.noaa.gov/weather/current/KTRK.html', 'http://weather.gov/data/current_obs/KTRK.rss', 'http://weather.gov/data/current_obs/KTRK.xml'),
('KTRM', 'CA', 'Thermal Airport', '33.640000', '-116.170000', 'http://weather.noaa.gov/weather/current/KTRM.html', 'http://weather.gov/data/current_obs/KTRM.rss', 'http://weather.gov/data/current_obs/KTRM.xml'),
('KTVL', 'CA', 'South Lake Tahoe', '38.910000', '-120.000000', 'http://weather.noaa.gov/weather/current/KTVL.html', 'http://weather.gov/data/current_obs/KTVL.rss', 'http://weather.gov/data/current_obs/KTVL.xml'),
('KUKI', 'CA', 'Ukiah Muni (awos)', '39.140000', '-123.200000', 'http://weather.noaa.gov/weather/current/KUKI.html', 'http://weather.gov/data/current_obs/KUKI.rss', 'http://weather.gov/data/current_obs/KUKI.xml'),
('KVBG', 'CA', 'Vandenberg AFB', '34.730000', '-120.550000', 'http://weather.noaa.gov/weather/current/KVBG.html', 'http://weather.gov/data/current_obs/KVBG.rss', 'http://weather.gov/data/current_obs/KVBG.xml'),
('KVCB', 'CA', 'Nut Tree Airport', '38.378000', '-121.957000', 'http://weather.noaa.gov/weather/current/KVCB.html', 'http://weather.gov/data/current_obs/KVCB.rss', 'http://weather.gov/data/current_obs/KVCB.xml'),
('KVCV', 'CA', 'Southern California Logisitics Airport', '34.583000', '-117.383000', 'http://weather.noaa.gov/weather/current/KVCV.html', 'http://weather.gov/data/current_obs/KVCV.rss', 'http://weather.gov/data/current_obs/KVCV.xml'),
('KVIS', 'CA', 'Visalia Muni', '36.330000', '-119.400000', 'http://weather.noaa.gov/weather/current/KVIS.html', 'http://weather.gov/data/current_obs/KVIS.rss', 'http://weather.gov/data/current_obs/KVIS.xml'),
('KVNY', 'CA', 'Van Nuys Airport', '34.210000', '-118.490000', 'http://weather.noaa.gov/weather/current/KVNY.html', 'http://weather.gov/data/current_obs/KVNY.rss', 'http://weather.gov/data/current_obs/KVNY.xml'),
('KWHP', 'CA', 'Los Angeles-Whiteman Airport', '34.260000', '-118.410000', 'http://weather.noaa.gov/weather/current/KWHP.html', 'http://weather.gov/data/current_obs/KWHP.rss', 'http://weather.gov/data/current_obs/KWHP.xml'),
('KWJF', 'CA', 'Lancaster/Fox F', '34.730000', '-118.220000', 'http://weather.noaa.gov/weather/current/KWJF.html', 'http://weather.gov/data/current_obs/KWJF.rss', 'http://weather.gov/data/current_obs/KWJF.xml'),
('KWVI', 'CA', 'Bami11', '36.940000', '-121.790000', 'http://weather.noaa.gov/weather/current/KWVI.html', 'http://weather.gov/data/current_obs/KWVI.rss', 'http://weather.gov/data/current_obs/KWVI.xml'),
('KXVW', 'CA', 'Vandenberg Range', '34.717000', '-120.567000', 'http://weather.noaa.gov/weather/current/KXVW.html', 'http://weather.gov/data/current_obs/KXVW.rss', 'http://weather.gov/data/current_obs/KXVW.xml'),
('K04V', 'CO', 'Saguache', '38.100000', '-106.167000', 'http://weather.noaa.gov/weather/current/K04V.html', 'http://weather.gov/data/current_obs/K04V.rss', 'http://weather.gov/data/current_obs/K04V.xml'),
('K20V', 'CO', 'Kremmling County/McElroy Airfield Airport', '40.050000', '-106.360000', 'http://weather.noaa.gov/weather/current/K20V.html', 'http://weather.gov/data/current_obs/K20V.rss', 'http://weather.gov/data/current_obs/K20V.xml'),
('K3MW', 'CO', 'Mount Werner', '40.267000', '-106.450000', 'http://weather.noaa.gov/weather/current/K3MW.html', 'http://weather.gov/data/current_obs/K3MW.rss', 'http://weather.gov/data/current_obs/K3MW.xml'),
('K4BM', 'CO', 'Wilkerson Pass', '39.050000', '-105.514000', 'http://weather.noaa.gov/weather/current/K4BM.html', 'http://weather.gov/data/current_obs/K4BM.rss', 'http://weather.gov/data/current_obs/K4BM.xml'),
('K5SM', 'CO', 'Sunlight', '39.417000', '-107.367000', 'http://weather.noaa.gov/weather/current/K5SM.html', 'http://weather.gov/data/current_obs/K5SM.rss', 'http://weather.gov/data/current_obs/K5SM.xml'),
('K7BM', 'CO', 'Cottonwood Pass', '38.800000', '-106.217000', 'http://weather.noaa.gov/weather/current/K7BM.html', 'http://weather.gov/data/current_obs/K7BM.rss', 'http://weather.gov/data/current_obs/K7BM.xml'),
('KAFF', 'CO', 'Air Force Academy', '38.980000', '-104.820000', 'http://weather.noaa.gov/weather/current/KAFF.html', 'http://weather.gov/data/current_obs/KAFF.rss', 'http://weather.gov/data/current_obs/KAFF.xml'),
('KAKO', 'CO', 'Akron/Washington Co', '40.170000', '-103.220000', 'http://weather.noaa.gov/weather/current/KAKO.html', 'http://weather.gov/data/current_obs/KAKO.rss', 'http://weather.gov/data/current_obs/KAKO.xml'),
('KALS', 'CO', 'Alamosa Muni(awos)', '37.460000', '-105.870000', 'http://weather.noaa.gov/weather/current/KALS.html', 'http://weather.gov/data/current_obs/KALS.rss', 'http://weather.gov/data/current_obs/KALS.xml'),
('KAPA', 'CO', 'Denver/Centennial', '39.570000', '-104.850000', 'http://weather.noaa.gov/weather/current/KAPA.html', 'http://weather.gov/data/current_obs/KAPA.rss', 'http://weather.gov/data/current_obs/KAPA.xml'),
('KASE', 'CO', 'Aspen/Sardy Field', '39.220000', '-106.870000', 'http://weather.noaa.gov/weather/current/KASE.html', 'http://weather.gov/data/current_obs/KASE.rss', 'http://weather.gov/data/current_obs/KASE.xml'),
('KBJC', 'CO', 'Broomfield/Jeffco', '39.910000', '-105.120000', 'http://weather.noaa.gov/weather/current/KBJC.html', 'http://weather.gov/data/current_obs/KBJC.rss', 'http://weather.gov/data/current_obs/KBJC.xml'),
('KBKF', 'CO', 'Buckley AFB/Aurora', '39.730000', '-104.750000', 'http://weather.noaa.gov/weather/current/KBKF.html', 'http://weather.gov/data/current_obs/KBKF.rss', 'http://weather.gov/data/current_obs/KBKF.xml'),
('KCAG', 'CO', 'Craig-Moffat(amos)', '40.510000', '-107.530000', 'http://weather.noaa.gov/weather/current/KCAG.html', 'http://weather.gov/data/current_obs/KCAG.rss', 'http://weather.gov/data/current_obs/KCAG.xml'),
('KCCU', 'CO', 'Copper Mountain (12,400 feet)', '39.475000', '-106.153000', 'http://weather.noaa.gov/weather/current/KCCU.html', 'http://weather.gov/data/current_obs/KCCU.rss', 'http://weather.gov/data/current_obs/KCCU.xml'),
('KCEZ', 'CO', 'Cortez/Montezuma Co', '37.300000', '-108.630000', 'http://weather.noaa.gov/weather/current/KCEZ.html', 'http://weather.gov/data/current_obs/KCEZ.rss', 'http://weather.gov/data/current_obs/KCEZ.xml'),
('KCOS', 'CO', 'Colorado Springs', '38.830000', '-104.720000', 'http://weather.noaa.gov/weather/current/KCOS.html', 'http://weather.gov/data/current_obs/KCOS.rss', 'http://weather.gov/data/current_obs/KCOS.xml'),
('KCPW', 'CO', 'Wolf Creek Pass (11,760 feet)', '37.464000', '-106.804000', 'http://weather.noaa.gov/weather/current/KCPW.html', 'http://weather.gov/data/current_obs/KCPW.rss', 'http://weather.gov/data/current_obs/KCPW.xml'),
('KDEN', 'CO', 'Denver Intnl Arpt', '39.870000', '-104.670000', 'http://weather.noaa.gov/weather/current/KDEN.html', 'http://weather.gov/data/current_obs/KDEN.rss', 'http://weather.gov/data/current_obs/KDEN.xml'),
('KDRO', 'CO', 'Durango/La Plata Co', '37.160000', '-107.750000', 'http://weather.noaa.gov/weather/current/KDRO.html', 'http://weather.gov/data/current_obs/KDRO.rss', 'http://weather.gov/data/current_obs/KDRO.xml'),
('KEEO', 'CO', 'Meeker', '40.040000', '-107.890000', 'http://weather.noaa.gov/weather/current/KEEO.html', 'http://weather.gov/data/current_obs/KEEO.rss', 'http://weather.gov/data/current_obs/KEEO.xml'),
('KEGE', 'CO', 'Eagle Co. Regional', '39.660000', '-106.920000', 'http://weather.noaa.gov/weather/current/KEGE.html', 'http://weather.gov/data/current_obs/KEGE.rss', 'http://weather.gov/data/current_obs/KEGE.xml'),
('KFCS', 'CO', 'Fort Carson/Butts', '38.690000', '-104.770000', 'http://weather.noaa.gov/weather/current/KFCS.html', 'http://weather.gov/data/current_obs/KFCS.rss', 'http://weather.gov/data/current_obs/KFCS.xml'),
('KFNL', 'CO', 'Fort Collins (awos)', '40.460000', '-105.010000', 'http://weather.noaa.gov/weather/current/KFNL.html', 'http://weather.gov/data/current_obs/KFNL.rss', 'http://weather.gov/data/current_obs/KFNL.xml'),
('KFTG', 'CO', 'Front Range Airport', '39.785000', '-104.543000', 'http://weather.noaa.gov/weather/current/KFTG.html', 'http://weather.gov/data/current_obs/KFTG.rss', 'http://weather.gov/data/current_obs/KFTG.xml'),
('KGJT', 'CO', 'Grand Junction', '39.120000', '-108.530000', 'http://weather.noaa.gov/weather/current/KGJT.html', 'http://weather.gov/data/current_obs/KGJT.rss', 'http://weather.gov/data/current_obs/KGJT.xml'),
('KGUC', 'CO', 'Gunnison Co. (awos)', '38.550000', '-106.920000', 'http://weather.noaa.gov/weather/current/KGUC.html', 'http://weather.gov/data/current_obs/KGUC.rss', 'http://weather.gov/data/current_obs/KGUC.xml'),
('KGXY', 'CO', 'Greeley/Weld (awos)', '40.430000', '-104.630000', 'http://weather.noaa.gov/weather/current/KGXY.html', 'http://weather.gov/data/current_obs/KGXY.rss', 'http://weather.gov/data/current_obs/KGXY.xml'),
('KHDN', 'CO', 'Hayden/Yampa (awos)', '40.510000', '-107.250000', 'http://weather.noaa.gov/weather/current/KHDN.html', 'http://weather.gov/data/current_obs/KHDN.rss', 'http://weather.gov/data/current_obs/KHDN.xml'),
('KITR', 'CO', 'Burlington', '39.240000', '-102.290000', 'http://weather.noaa.gov/weather/current/KITR.html', 'http://weather.gov/data/current_obs/KITR.rss', 'http://weather.gov/data/current_obs/KITR.xml'),
('KLAA', 'CO', 'Lamar', '38.070000', '-102.680000', 'http://weather.noaa.gov/weather/current/KLAA.html', 'http://weather.gov/data/current_obs/KLAA.rss', 'http://weather.gov/data/current_obs/KLAA.xml'),
('KLHX', 'CO', 'La Junta Municipal', '38.050000', '-103.520000', 'http://weather.noaa.gov/weather/current/KLHX.html', 'http://weather.gov/data/current_obs/KLHX.rss', 'http://weather.gov/data/current_obs/KLHX.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('KLIC', 'CO', 'Limon Municipal', '39.260000', '-103.660000', 'http://weather.noaa.gov/weather/current/KLIC.html', 'http://weather.gov/data/current_obs/KLIC.rss', 'http://weather.gov/data/current_obs/KLIC.xml'),
('KLXV', 'CO', 'Leadville/Lake Co.', '39.220000', '-106.320000', 'http://weather.noaa.gov/weather/current/KLXV.html', 'http://weather.gov/data/current_obs/KLXV.rss', 'http://weather.gov/data/current_obs/KLXV.xml'),
('KMNH', 'CO', 'Elbert Mountain', '39.219000', '-104.641000', 'http://weather.noaa.gov/weather/current/KMNH.html', 'http://weather.gov/data/current_obs/KMNH.rss', 'http://weather.gov/data/current_obs/KMNH.xml'),
('KMTJ', 'CO', 'Montrose Co. Arpt', '38.510000', '-107.880000', 'http://weather.noaa.gov/weather/current/KMTJ.html', 'http://weather.gov/data/current_obs/KMTJ.rss', 'http://weather.gov/data/current_obs/KMTJ.xml'),
('KMYP', 'CO', 'Monarch Pass (12,030 feet)', '38.497000', '-106.320000', 'http://weather.noaa.gov/weather/current/KMYP.html', 'http://weather.gov/data/current_obs/KMYP.rss', 'http://weather.gov/data/current_obs/KMYP.xml'),
('KPUB', 'CO', 'Pueblo Memorial(aw)', '38.290000', '-104.520000', 'http://weather.noaa.gov/weather/current/KPUB.html', 'http://weather.gov/data/current_obs/KPUB.rss', 'http://weather.gov/data/current_obs/KPUB.xml'),
('KRIL', 'CO', 'Rifle/Garfield Rgnl', '39.540000', '-107.720000', 'http://weather.noaa.gov/weather/current/KRIL.html', 'http://weather.gov/data/current_obs/KRIL.rss', 'http://weather.gov/data/current_obs/KRIL.xml'),
('KSBS', 'CO', 'Steamboat Springs', '40.480000', '-106.820000', 'http://weather.noaa.gov/weather/current/KSBS.html', 'http://weather.gov/data/current_obs/KSBS.rss', 'http://weather.gov/data/current_obs/KSBS.xml'),
('KSPD', 'CO', 'Springfield/Comanche Natl Grass', '37.280000', '-102.610000', 'http://weather.noaa.gov/weather/current/KSPD.html', 'http://weather.gov/data/current_obs/KSPD.rss', 'http://weather.gov/data/current_obs/KSPD.xml'),
('KTAD', 'CO', 'Trinidad/Animas Co.', '37.260000', '-104.330000', 'http://weather.noaa.gov/weather/current/KTAD.html', 'http://weather.gov/data/current_obs/KTAD.rss', 'http://weather.gov/data/current_obs/KTAD.xml'),
('KTEX', 'CO', 'Telluride Regional', '37.940000', '-107.770000', 'http://weather.noaa.gov/weather/current/KTEX.html', 'http://weather.gov/data/current_obs/KTEX.rss', 'http://weather.gov/data/current_obs/KTEX.xml'),
('KVTP', 'CO', 'South La Veta Pass (10,216 feet)', '37.512000', '-105.171000', 'http://weather.noaa.gov/weather/current/KVTP.html', 'http://weather.gov/data/current_obs/KVTP.rss', 'http://weather.gov/data/current_obs/KVTP.xml'),
('KBDL', 'CT', 'Windsor Locks, Bradley International Airport', '41.940000', '-72.680000', 'http://weather.noaa.gov/weather/current/KBDL.html', 'http://weather.gov/data/current_obs/KBDL.rss', 'http://weather.gov/data/current_obs/KBDL.xml'),
('KBDR', 'CT', 'Bridgeport/Igor|Sikorsky Memorial', '41.180000', '-73.130000', 'http://weather.noaa.gov/weather/current/KBDR.html', 'http://weather.gov/data/current_obs/KBDR.rss', 'http://weather.gov/data/current_obs/KBDR.xml'),
('KDXR', 'CT', 'Danbury Municipal Airport', '41.370000', '-73.480000', 'http://weather.noaa.gov/weather/current/KDXR.html', 'http://weather.gov/data/current_obs/KDXR.rss', 'http://weather.gov/data/current_obs/KDXR.xml'),
('KGON', 'CT', 'Groton / New London Airport', '41.330000', '-72.050000', 'http://weather.noaa.gov/weather/current/KGON.html', 'http://weather.gov/data/current_obs/KGON.rss', 'http://weather.gov/data/current_obs/KGON.xml'),
('KHFD', 'CT', 'Hartford-Brainard Airport', '41.730000', '-72.650000', 'http://weather.noaa.gov/weather/current/KHFD.html', 'http://weather.gov/data/current_obs/KHFD.rss', 'http://weather.gov/data/current_obs/KHFD.xml'),
('KHVN', 'CT', 'New Haven/Tweed', '41.280000', '-72.880000', 'http://weather.noaa.gov/weather/current/KHVN.html', 'http://weather.gov/data/current_obs/KHVN.rss', 'http://weather.gov/data/current_obs/KHVN.xml'),
('KIJD', 'CT', 'Willimantic, Windham Airport', '41.750000', '-72.180000', 'http://weather.noaa.gov/weather/current/KIJD.html', 'http://weather.gov/data/current_obs/KIJD.rss', 'http://weather.gov/data/current_obs/KIJD.xml'),
('KMMK', 'CT', 'Meriden Markham Municipal Airport', '41.510000', '-72.830000', 'http://weather.noaa.gov/weather/current/KMMK.html', 'http://weather.gov/data/current_obs/KMMK.rss', 'http://weather.gov/data/current_obs/KMMK.xml'),
('KOXC', 'CT', 'Oxford Automatic Weather Observing / Reporting Sys', '41.410000', '-73.100000', 'http://weather.noaa.gov/weather/current/KOXC.html', 'http://weather.gov/data/current_obs/KOXC.rss', 'http://weather.gov/data/current_obs/KOXC.xml'),
('KDOV', 'DE', 'Dover Air Force Base', '39.140000', '-75.470000', 'http://weather.noaa.gov/weather/current/KDOV.html', 'http://weather.gov/data/current_obs/KDOV.rss', 'http://weather.gov/data/current_obs/KDOV.xml'),
('KGED', 'DE', 'Georgetown, Sussex County Airport', '38.700000', '-75.360000', 'http://weather.noaa.gov/weather/current/KGED.html', 'http://weather.gov/data/current_obs/KGED.rss', 'http://weather.gov/data/current_obs/KGED.xml'),
('KILG', 'DE', 'Wilmington, New Castle County Airport', '39.680000', '-75.600000', 'http://weather.noaa.gov/weather/current/KILG.html', 'http://weather.gov/data/current_obs/KILG.rss', 'http://weather.gov/data/current_obs/KILG.xml'),
('TDCF', 'DM', 'Canefield Airport', '15.533000', '-61.400000', 'http://weather.noaa.gov/weather/current/TDCF.html', 'http://weather.gov/data/current_obs/TDCF.rss', 'http://weather.gov/data/current_obs/TDCF.xml'),
('NFFN', 'FJ', 'Nandi', '-17.750000', '177.450000', 'http://weather.noaa.gov/weather/current/NFFN.html', 'http://weather.gov/data/current_obs/NFFN.rss', 'http://weather.gov/data/current_obs/NFFN.xml'),
('NFNA', 'FJ', 'Nausori', '-18.050000', '178.567000', 'http://weather.noaa.gov/weather/current/NFNA.html', 'http://weather.gov/data/current_obs/NFNA.rss', 'http://weather.gov/data/current_obs/NFNA.xml'),
('KCEW', 'FL', 'Crestview, Sikes Airport', '30.790000', '-86.520000', 'http://weather.noaa.gov/weather/current/KCEW.html', 'http://weather.gov/data/current_obs/KCEW.rss', 'http://weather.gov/data/current_obs/KCEW.xml'),
('KDTS', 'FL', 'Destin, Ft. Walton Beach Airport', '30.400000', '-86.470000', 'http://weather.noaa.gov/weather/current/KDTS.html', 'http://weather.gov/data/current_obs/KDTS.rss', 'http://weather.gov/data/current_obs/KDTS.xml'),
('KMAI', 'FL', 'Marianna Municipal Airport', '30.800000', '-85.210000', 'http://weather.noaa.gov/weather/current/KMAI.html', 'http://weather.gov/data/current_obs/KMAI.rss', 'http://weather.gov/data/current_obs/KMAI.xml'),
('KPAM', 'FL', 'Tyndall Air Force Base', '30.070000', '-85.590000', 'http://weather.noaa.gov/weather/current/KPAM.html', 'http://weather.gov/data/current_obs/KPAM.rss', 'http://weather.gov/data/current_obs/KPAM.xml'),
('KPFN', 'FL', 'Panama City-Bay County Intl Airport', '30.200000', '-85.680000', 'http://weather.noaa.gov/weather/current/KPFN.html', 'http://weather.gov/data/current_obs/KPFN.rss', 'http://weather.gov/data/current_obs/KPFN.xml'),
('K0J4', 'FL', 'Florala Municipal Airport', '31.033000', '-86.317000', 'http://weather.noaa.gov/weather/current/K0J4.html', 'http://weather.gov/data/current_obs/K0J4.rss', 'http://weather.gov/data/current_obs/K0J4.xml'),
('K40J', 'FL', 'Perry-Foley Airport', '30.070000', '-83.570000', 'http://weather.noaa.gov/weather/current/K40J.html', 'http://weather.gov/data/current_obs/K40J.rss', 'http://weather.gov/data/current_obs/K40J.xml'),
('KAAF', 'FL', 'Apalachicola', '29.728000', '-85.027000', 'http://weather.noaa.gov/weather/current/KAAF.html', 'http://weather.gov/data/current_obs/KAAF.rss', 'http://weather.gov/data/current_obs/KAAF.xml'),
('KAMX', 'FL', 'Miami Nexrad', '25.617000', '-80.417000', 'http://weather.noaa.gov/weather/current/KAMX.html', 'http://weather.gov/data/current_obs/KAMX.rss', 'http://weather.gov/data/current_obs/KAMX.xml'),
('KAPF', 'FL', 'Naples Municipal', '26.150000', '-81.770000', 'http://weather.noaa.gov/weather/current/KAPF.html', 'http://weather.gov/data/current_obs/KAPF.rss', 'http://weather.gov/data/current_obs/KAPF.xml'),
('KBCT', 'FL', 'Boca Raton Airport', '26.380000', '-80.100000', 'http://weather.noaa.gov/weather/current/KBCT.html', 'http://weather.gov/data/current_obs/KBCT.rss', 'http://weather.gov/data/current_obs/KBCT.xml'),
('KBKV', 'FL', 'Brooksville, Hernando County Airport', '28.470000', '-82.450000', 'http://weather.noaa.gov/weather/current/KBKV.html', 'http://weather.gov/data/current_obs/KBKV.rss', 'http://weather.gov/data/current_obs/KBKV.xml'),
('KBOW', 'FL', 'Bartow Municipal', '27.950000', '-81.780000', 'http://weather.noaa.gov/weather/current/KBOW.html', 'http://weather.gov/data/current_obs/KBOW.rss', 'http://weather.gov/data/current_obs/KBOW.xml'),
('KCOF', 'FL', 'Cocoa / Patrick Air Force Base', '28.230000', '-80.600000', 'http://weather.noaa.gov/weather/current/KCOF.html', 'http://weather.gov/data/current_obs/KCOF.rss', 'http://weather.gov/data/current_obs/KCOF.xml'),
('KCRG', 'FL', 'Jacksonville, Craig Municipal Airport', '30.330000', '-81.520000', 'http://weather.noaa.gov/weather/current/KCRG.html', 'http://weather.gov/data/current_obs/KCRG.rss', 'http://weather.gov/data/current_obs/KCRG.xml'),
('KCTY', 'FL', 'Cross City Airport', '29.640000', '-83.100000', 'http://weather.noaa.gov/weather/current/KCTY.html', 'http://weather.gov/data/current_obs/KCTY.rss', 'http://weather.gov/data/current_obs/KCTY.xml'),
('KDAB', 'FL', 'Daytona Beach International Airport', '29.180000', '-81.050000', 'http://weather.noaa.gov/weather/current/KDAB.html', 'http://weather.gov/data/current_obs/KDAB.rss', 'http://weather.gov/data/current_obs/KDAB.xml'),
('KEVB', 'FL', 'New Smyrna Beach Municipal Airport', '29.050000', '-80.950000', 'http://weather.noaa.gov/weather/current/KEVB.html', 'http://weather.gov/data/current_obs/KEVB.rss', 'http://weather.gov/data/current_obs/KEVB.xml'),
('KEYW', 'FL', 'Key West Airport', '24.550000', '-81.750000', 'http://weather.noaa.gov/weather/current/KEYW.html', 'http://weather.gov/data/current_obs/KEYW.rss', 'http://weather.gov/data/current_obs/KEYW.xml'),
('KFLL', 'FL', 'Fort Lauderdale / Hollywood Intl Airport', '26.070000', '-80.150000', 'http://weather.noaa.gov/weather/current/KFLL.html', 'http://weather.gov/data/current_obs/KFLL.rss', 'http://weather.gov/data/current_obs/KFLL.xml'),
('KFMY', 'FL', 'Fort Myers, Page Field', '26.580000', '-81.870000', 'http://weather.noaa.gov/weather/current/KFMY.html', 'http://weather.gov/data/current_obs/KFMY.rss', 'http://weather.gov/data/current_obs/KFMY.xml'),
('KFPR', 'FL', 'Fort Pierce, St. Lucie County Intl Airport', '27.500000', '-80.370000', 'http://weather.noaa.gov/weather/current/KFPR.html', 'http://weather.gov/data/current_obs/KFPR.rss', 'http://weather.gov/data/current_obs/KFPR.xml'),
('KFXE', 'FL', 'Fort Lauderdale Executive Airport', '26.200000', '-80.170000', 'http://weather.noaa.gov/weather/current/KFXE.html', 'http://weather.gov/data/current_obs/KFXE.rss', 'http://weather.gov/data/current_obs/KFXE.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('KGIF', 'FL', 'Gilbert Field', '28.050000', '-81.750000', 'http://weather.noaa.gov/weather/current/KGIF.html', 'http://weather.gov/data/current_obs/KGIF.rss', 'http://weather.gov/data/current_obs/KGIF.xml'),
('KGNV', 'FL', 'Gainesville Regional Airport', '29.680000', '-82.270000', 'http://weather.noaa.gov/weather/current/KGNV.html', 'http://weather.gov/data/current_obs/KGNV.rss', 'http://weather.gov/data/current_obs/KGNV.xml'),
('KHRT', 'FL', 'Hurlburt Field', '30.430000', '-86.680000', 'http://weather.noaa.gov/weather/current/KHRT.html', 'http://weather.gov/data/current_obs/KHRT.rss', 'http://weather.gov/data/current_obs/KHRT.xml'),
('KHST', 'FL', 'Homestead Air Force Base', '25.480000', '-80.380000', 'http://weather.noaa.gov/weather/current/KHST.html', 'http://weather.gov/data/current_obs/KHST.rss', 'http://weather.gov/data/current_obs/KHST.xml'),
('KHWO', 'FL', 'Hollywood, North Perry Airport', '26.000000', '-80.240000', 'http://weather.noaa.gov/weather/current/KHWO.html', 'http://weather.gov/data/current_obs/KHWO.rss', 'http://weather.gov/data/current_obs/KHWO.xml'),
('KISM', 'FL', 'Orlando, Kissimmee Municipal Airport', '28.290000', '-81.437000', 'http://weather.noaa.gov/weather/current/KISM.html', 'http://weather.gov/data/current_obs/KISM.rss', 'http://weather.gov/data/current_obs/KISM.xml'),
('KJAX', 'FL', 'Jacksonville International Airport', '30.430000', '-81.700000', 'http://weather.noaa.gov/weather/current/KJAX.html', 'http://weather.gov/data/current_obs/KJAX.rss', 'http://weather.gov/data/current_obs/KJAX.xml'),
('KLAL', 'FL', 'Lakeland Regional', '28.040000', '-81.950000', 'http://weather.noaa.gov/weather/current/KLAL.html', 'http://weather.gov/data/current_obs/KLAL.rss', 'http://weather.gov/data/current_obs/KLAL.xml'),
('KLEE', 'FL', 'Leesburg Municipal Airport', '28.820000', '-81.810000', 'http://weather.noaa.gov/weather/current/KLEE.html', 'http://weather.gov/data/current_obs/KLEE.rss', 'http://weather.gov/data/current_obs/KLEE.xml'),
('KMCF', 'FL', 'Macdill Air Force Base, Fl.', '27.860000', '-82.520000', 'http://weather.noaa.gov/weather/current/KMCF.html', 'http://weather.gov/data/current_obs/KMCF.rss', 'http://weather.gov/data/current_obs/KMCF.xml'),
('KMCO', 'FL', 'Orlando International Airport', '28.430000', '-81.320000', 'http://weather.noaa.gov/weather/current/KMCO.html', 'http://weather.gov/data/current_obs/KMCO.rss', 'http://weather.gov/data/current_obs/KMCO.xml'),
('KMIA', 'FL', 'Miami International Airport', '25.820000', '-80.280000', 'http://weather.noaa.gov/weather/current/KMIA.html', 'http://weather.gov/data/current_obs/KMIA.rss', 'http://weather.gov/data/current_obs/KMIA.xml'),
('KMLB', 'FL', 'Melbourne International Airport', '28.110000', '-80.630000', 'http://weather.noaa.gov/weather/current/KMLB.html', 'http://weather.gov/data/current_obs/KMLB.rss', 'http://weather.gov/data/current_obs/KMLB.xml'),
('KMTH', 'FL', 'Marathon Airport', '24.740000', '-81.050000', 'http://weather.noaa.gov/weather/current/KMTH.html', 'http://weather.gov/data/current_obs/KMTH.rss', 'http://weather.gov/data/current_obs/KMTH.xml'),
('KNIP', 'FL', 'Jacksonville, Naval Air Station', '30.230000', '-81.680000', 'http://weather.noaa.gov/weather/current/KNIP.html', 'http://weather.gov/data/current_obs/KNIP.rss', 'http://weather.gov/data/current_obs/KNIP.xml'),
('KNPA', 'FL', 'Pensacola, Naval Air Station', '30.360000', '-87.320000', 'http://weather.noaa.gov/weather/current/KNPA.html', 'http://weather.gov/data/current_obs/KNPA.rss', 'http://weather.gov/data/current_obs/KNPA.xml'),
('KNQX', 'FL', 'Boca Chica Naval Air Station', '24.570000', '-81.680000', 'http://weather.noaa.gov/weather/current/KNQX.html', 'http://weather.gov/data/current_obs/KNQX.rss', 'http://weather.gov/data/current_obs/KNQX.xml'),
('KNRB', 'FL', 'Mayport Naval Station', '30.400000', '-81.420000', 'http://weather.noaa.gov/weather/current/KNRB.html', 'http://weather.gov/data/current_obs/KNRB.rss', 'http://weather.gov/data/current_obs/KNRB.xml'),
('KNSE', 'FL', 'Milton, Whiting Field North', '30.720000', '-87.020000', 'http://weather.noaa.gov/weather/current/KNSE.html', 'http://weather.gov/data/current_obs/KNSE.rss', 'http://weather.gov/data/current_obs/KNSE.xml'),
('KOCF', 'FL', 'Ocala Municipal Automatic Weather Observing', '29.180000', '-82.220000', 'http://weather.noaa.gov/weather/current/KOCF.html', 'http://weather.gov/data/current_obs/KOCF.rss', 'http://weather.gov/data/current_obs/KOCF.xml'),
('KOMN', 'FL', 'Ormond Beach Municipal Airport', '29.300000', '-81.100000', 'http://weather.noaa.gov/weather/current/KOMN.html', 'http://weather.gov/data/current_obs/KOMN.rss', 'http://weather.gov/data/current_obs/KOMN.xml'),
('KOPF', 'FL', 'Miami, Opa Locka Airport', '25.910000', '-80.280000', 'http://weather.noaa.gov/weather/current/KOPF.html', 'http://weather.gov/data/current_obs/KOPF.rss', 'http://weather.gov/data/current_obs/KOPF.xml'),
('KORL', 'FL', 'Orlando Executive Airport', '28.550000', '-81.330000', 'http://weather.noaa.gov/weather/current/KORL.html', 'http://weather.gov/data/current_obs/KORL.rss', 'http://weather.gov/data/current_obs/KORL.xml'),
('KPBI', 'FL', 'West Palm Beach, Palm Beach International Airport', '26.680000', '-80.120000', 'http://weather.noaa.gov/weather/current/KPBI.html', 'http://weather.gov/data/current_obs/KPBI.rss', 'http://weather.gov/data/current_obs/KPBI.xml'),
('KPGD', 'FL', 'Punta Gorda, Charlotte County Airport', '26.920000', '-81.990000', 'http://weather.noaa.gov/weather/current/KPGD.html', 'http://weather.gov/data/current_obs/KPGD.rss', 'http://weather.gov/data/current_obs/KPGD.xml'),
('KPIE', 'FL', 'St. Petersburg / Clea', '27.910000', '-82.690000', 'http://weather.noaa.gov/weather/current/KPIE.html', 'http://weather.gov/data/current_obs/KPIE.rss', 'http://weather.gov/data/current_obs/KPIE.xml'),
('KPMP', 'FL', 'Pompano Beach Airpark', '26.250000', '-80.110000', 'http://weather.noaa.gov/weather/current/KPMP.html', 'http://weather.gov/data/current_obs/KPMP.rss', 'http://weather.gov/data/current_obs/KPMP.xml'),
('KPNS', 'FL', 'Pensacola Regional Airport', '30.470000', '-87.200000', 'http://weather.noaa.gov/weather/current/KPNS.html', 'http://weather.gov/data/current_obs/KPNS.rss', 'http://weather.gov/data/current_obs/KPNS.xml'),
('KRSW', 'FL', 'Fort Myers, SW Florida Intl Airport', '26.540000', '-81.760000', 'http://weather.noaa.gov/weather/current/KRSW.html', 'http://weather.gov/data/current_obs/KRSW.rss', 'http://weather.gov/data/current_obs/KRSW.xml'),
('KSFB', 'FL', 'Orlando / Sanford Airport', '28.780000', '-81.240000', 'http://weather.noaa.gov/weather/current/KSFB.html', 'http://weather.gov/data/current_obs/KSFB.rss', 'http://weather.gov/data/current_obs/KSFB.xml'),
('KSGJ', 'FL', 'St. Augustine Airport', '29.970000', '-81.330000', 'http://weather.noaa.gov/weather/current/KSGJ.html', 'http://weather.gov/data/current_obs/KSGJ.rss', 'http://weather.gov/data/current_obs/KSGJ.xml'),
('KSPG', 'FL', 'St. Petersburg, Whitted Airport', '27.770000', '-82.630000', 'http://weather.noaa.gov/weather/current/KSPG.html', 'http://weather.gov/data/current_obs/KSPG.rss', 'http://weather.gov/data/current_obs/KSPG.xml'),
('KSRQ', 'FL', 'Sarasota-Bradenton Intl Airport', '27.400000', '-82.550000', 'http://weather.noaa.gov/weather/current/KSRQ.html', 'http://weather.gov/data/current_obs/KSRQ.rss', 'http://weather.gov/data/current_obs/KSRQ.xml'),
('KSUA', 'FL', 'Stuart, Witham Field Airport', '27.182000', '-80.221000', 'http://weather.noaa.gov/weather/current/KSUA.html', 'http://weather.gov/data/current_obs/KSUA.rss', 'http://weather.gov/data/current_obs/KSUA.xml'),
('KTIX', 'FL', 'Titusville', '28.520000', '-80.800000', 'http://weather.noaa.gov/weather/current/KTIX.html', 'http://weather.gov/data/current_obs/KTIX.rss', 'http://weather.gov/data/current_obs/KTIX.xml'),
('KTLH', 'FL', 'Tallahassee Regional Airport', '30.400000', '-84.350000', 'http://weather.noaa.gov/weather/current/KTLH.html', 'http://weather.gov/data/current_obs/KTLH.rss', 'http://weather.gov/data/current_obs/KTLH.xml'),
('KTMB', 'FL', 'Miami, Kendall-Tamiami Executive Airport', '25.650000', '-80.430000', 'http://weather.noaa.gov/weather/current/KTMB.html', 'http://weather.gov/data/current_obs/KTMB.rss', 'http://weather.gov/data/current_obs/KTMB.xml'),
('KTPA', 'FL', 'Tampa International Airport', '27.970000', '-82.530000', 'http://weather.noaa.gov/weather/current/KTPA.html', 'http://weather.gov/data/current_obs/KTPA.rss', 'http://weather.gov/data/current_obs/KTPA.xml'),
('KTTS', 'FL', 'NASA Shuttle Landing Facility', '28.620000', '-80.720000', 'http://weather.noaa.gov/weather/current/KTTS.html', 'http://weather.gov/data/current_obs/KTTS.rss', 'http://weather.gov/data/current_obs/KTTS.xml'),
('KVDF', 'FL', 'Vandenberg Airport', '28.010000', '-82.350000', 'http://weather.noaa.gov/weather/current/KVDF.html', 'http://weather.gov/data/current_obs/KVDF.rss', 'http://weather.gov/data/current_obs/KVDF.xml'),
('KVPS', 'FL', 'Valparaiso / Eglin Air Force Base', '30.480000', '-86.530000', 'http://weather.noaa.gov/weather/current/KVPS.html', 'http://weather.gov/data/current_obs/KVPS.rss', 'http://weather.gov/data/current_obs/KVPS.xml'),
('KVQQ', 'FL', 'Jacksonville, Cecil Field Airport', '30.217000', '-81.876000', 'http://weather.noaa.gov/weather/current/KVQQ.html', 'http://weather.gov/data/current_obs/KVQQ.rss', 'http://weather.gov/data/current_obs/KVQQ.xml'),
('KVRB', 'FL', 'Vero Beach Municipal Airport', '27.650000', '-80.420000', 'http://weather.noaa.gov/weather/current/KVRB.html', 'http://weather.gov/data/current_obs/KVRB.rss', 'http://weather.gov/data/current_obs/KVRB.xml'),
('KVVG', 'FL', 'The Villages', '28.962000', '-81.970000', 'http://weather.noaa.gov/weather/current/KVVG.html', 'http://weather.gov/data/current_obs/KVVG.rss', 'http://weather.gov/data/current_obs/KVVG.xml'),
('KOBE', 'FL', 'Okeechobee County Airport', '27.260000', '-80.850000', 'http://weather.noaa.gov/weather/current/KOBE.html', 'http://weather.gov/data/current_obs/KOBE.rss', 'http://weather.gov/data/current_obs/KOBE.xml'),
('KTPF', 'FL', 'Peter O Knight Airport', '27.915600', '-82.449300', 'http://weather.noaa.gov/weather/current/KTPF.html', 'http://weather.gov/data/current_obs/KTPF.rss', 'http://weather.gov/data/current_obs/KTPF.xml'),
('KPCM', 'FL', 'Plant City Airport', '28.000200', '-82.164200', 'http://weather.noaa.gov/weather/current/KPCM.html', 'http://weather.gov/data/current_obs/KPCM.rss', 'http://weather.gov/data/current_obs/KPCM.xml'),
('PTPN', 'FM', 'Pohnpei Intl Airport', '6.970000', '158.220000', 'http://weather.noaa.gov/weather/current/PTPN.html', 'http://weather.gov/data/current_obs/PTPN.rss', 'http://weather.gov/data/current_obs/PTPN.xml'),
('PTSA', 'FM', 'Kosrae Island Airport', '5.333000', '163.033000', 'http://weather.noaa.gov/weather/current/PTSA.html', 'http://weather.gov/data/current_obs/PTSA.rss', 'http://weather.gov/data/current_obs/PTSA.xml'),
('PTTP', 'FM', 'Pohnpei', '6.950000', '158.250000', 'http://weather.noaa.gov/weather/current/PTTP.html', 'http://weather.gov/data/current_obs/PTTP.rss', 'http://weather.gov/data/current_obs/PTTP.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('PTKK', 'FM', 'Chuuk Intl Weno Is', '7.470000', '151.850000', 'http://weather.noaa.gov/weather/current/PTKK.html', 'http://weather.gov/data/current_obs/PTKK.rss', 'http://weather.gov/data/current_obs/PTKK.xml'),
('PTYA', 'FM', 'Yap Intl Airport', '9.483000', '138.083000', 'http://weather.noaa.gov/weather/current/PTYA.html', 'http://weather.gov/data/current_obs/PTYA.rss', 'http://weather.gov/data/current_obs/PTYA.xml'),
('K11J', 'GA', 'Early County Airport', '31.397000', '-84.895000', 'http://weather.noaa.gov/weather/current/K11J.html', 'http://weather.gov/data/current_obs/K11J.rss', 'http://weather.gov/data/current_obs/K11J.xml'),
('K27A', 'GA', 'Elbert Co. Airport-Patz Field', '34.095000', '-82.816000', 'http://weather.noaa.gov/weather/current/K27A.html', 'http://weather.gov/data/current_obs/K27A.rss', 'http://weather.gov/data/current_obs/K27A.xml'),
('K3J7', 'GA', 'Greene County Regional Airport', '33.600000', '-83.133000', 'http://weather.noaa.gov/weather/current/K3J7.html', 'http://weather.gov/data/current_obs/K3J7.rss', 'http://weather.gov/data/current_obs/K3J7.xml'),
('K47A', 'GA', 'Cherokee County Airport', '34.300000', '-84.417000', 'http://weather.noaa.gov/weather/current/K47A.html', 'http://weather.gov/data/current_obs/K47A.rss', 'http://weather.gov/data/current_obs/K47A.xml'),
('KABY', 'GA', 'Albany, Southwest Georgia Regional Airport', '31.540000', '-84.180000', 'http://weather.noaa.gov/weather/current/KABY.html', 'http://weather.gov/data/current_obs/KABY.rss', 'http://weather.gov/data/current_obs/KABY.xml'),
('KAGS', 'GA', 'Augusta, Bush Field', '33.380000', '-81.970000', 'http://weather.noaa.gov/weather/current/KAGS.html', 'http://weather.gov/data/current_obs/KAGS.rss', 'http://weather.gov/data/current_obs/KAGS.xml'),
('KAHN', 'GA', 'Athens Airport', '33.960000', '-83.320000', 'http://weather.noaa.gov/weather/current/KAHN.html', 'http://weather.gov/data/current_obs/KAHN.rss', 'http://weather.gov/data/current_obs/KAHN.xml'),
('KAMG', 'GA', 'Alma, Bacon County Airport', '31.540000', '-82.500000', 'http://weather.noaa.gov/weather/current/KAMG.html', 'http://weather.gov/data/current_obs/KAMG.rss', 'http://weather.gov/data/current_obs/KAMG.xml'),
('KATL', 'GA', 'Hartsfield-Jackson/Atlanta International Airport', '33.660000', '-84.420000', 'http://weather.noaa.gov/weather/current/KATL.html', 'http://weather.gov/data/current_obs/KATL.rss', 'http://weather.gov/data/current_obs/KATL.xml'),
('KAYS', 'GA', 'Waycross / Ware County', '31.250000', '-82.400000', 'http://weather.noaa.gov/weather/current/KAYS.html', 'http://weather.gov/data/current_obs/KAYS.rss', 'http://weather.gov/data/current_obs/KAYS.xml'),
('KBGE', 'GA', 'Bainbridge', '30.970000', '-84.630000', 'http://weather.noaa.gov/weather/current/KBGE.html', 'http://weather.gov/data/current_obs/KBGE.rss', 'http://weather.gov/data/current_obs/KBGE.xml'),
('KBQK', 'GA', 'Brunswick / Glynco', '31.150000', '-81.380000', 'http://weather.noaa.gov/weather/current/KBQK.html', 'http://weather.gov/data/current_obs/KBQK.rss', 'http://weather.gov/data/current_obs/KBQK.xml'),
('KCCO', 'GA', 'Newnan Coweta County Airport', '33.310000', '-84.770000', 'http://weather.noaa.gov/weather/current/KCCO.html', 'http://weather.gov/data/current_obs/KCCO.rss', 'http://weather.gov/data/current_obs/KCCO.xml'),
('KCSG', 'GA', 'Columbus Metropolitan Airport', '32.530000', '-84.930000', 'http://weather.noaa.gov/weather/current/KCSG.html', 'http://weather.gov/data/current_obs/KCSG.rss', 'http://weather.gov/data/current_obs/KCSG.xml'),
('KDBN', 'GA', 'W H `Bud` Barron Airport', '32.567000', '-82.983000', 'http://weather.noaa.gov/weather/current/KDBN.html', 'http://weather.gov/data/current_obs/KDBN.rss', 'http://weather.gov/data/current_obs/KDBN.xml'),
('KDNL', 'GA', 'Augusta, Daniel Field', '33.470000', '-82.030000', 'http://weather.noaa.gov/weather/current/KDNL.html', 'http://weather.gov/data/current_obs/KDNL.rss', 'http://weather.gov/data/current_obs/KDNL.xml'),
('KDNN', 'GA', 'Dalton Municipal Airport', '34.720000', '-84.870000', 'http://weather.noaa.gov/weather/current/KDNN.html', 'http://weather.gov/data/current_obs/KDNN.rss', 'http://weather.gov/data/current_obs/KDNN.xml'),
('KDQH', 'GA', 'Douglas Municipal Airport', '31.477000', '-82.861000', 'http://weather.noaa.gov/weather/current/KDQH.html', 'http://weather.gov/data/current_obs/KDQH.rss', 'http://weather.gov/data/current_obs/KDQH.xml'),
('KFFC', 'GA', 'Atlanta, Peachtree City-Falcon Field', '33.350000', '-84.560000', 'http://weather.noaa.gov/weather/current/KFFC.html', 'http://weather.gov/data/current_obs/KFFC.rss', 'http://weather.gov/data/current_obs/KFFC.xml'),
('KFTY', 'GA', 'Atlanta, Fulton County Airport-Brown Field', '33.780000', '-84.520000', 'http://weather.noaa.gov/weather/current/KFTY.html', 'http://weather.gov/data/current_obs/KFTY.rss', 'http://weather.gov/data/current_obs/KFTY.xml'),
('KGVL', 'GA', 'Gainesville, Gilmer Memorial Airport', '34.260000', '-83.830000', 'http://weather.noaa.gov/weather/current/KGVL.html', 'http://weather.gov/data/current_obs/KGVL.rss', 'http://weather.gov/data/current_obs/KGVL.xml'),
('KHQU', 'GA', 'Thomson-McDuffie County Airport', '33.530000', '-82.516000', 'http://weather.noaa.gov/weather/current/KHQU.html', 'http://weather.gov/data/current_obs/KHQU.rss', 'http://weather.gov/data/current_obs/KHQU.xml'),
('KIIY', 'GA', 'Washington-Wilkes County Airport', '33.780000', '-82.820000', 'http://weather.noaa.gov/weather/current/KIIY.html', 'http://weather.gov/data/current_obs/KIIY.rss', 'http://weather.gov/data/current_obs/KIIY.xml'),
('KJYL', 'GA', 'Plantation Airpark', '32.645000', '-81.596000', 'http://weather.noaa.gov/weather/current/KJYL.html', 'http://weather.gov/data/current_obs/KJYL.rss', 'http://weather.gov/data/current_obs/KJYL.xml'),
('KLGC', 'GA', 'La Grange-Callawy Airport', '33.009000', '-85.073000', 'http://weather.noaa.gov/weather/current/KLGC.html', 'http://weather.gov/data/current_obs/KLGC.rss', 'http://weather.gov/data/current_obs/KLGC.xml'),
('KLHW', 'GA', 'Ft. Stewart', '31.880000', '-81.570000', 'http://weather.noaa.gov/weather/current/KLHW.html', 'http://weather.gov/data/current_obs/KLHW.rss', 'http://weather.gov/data/current_obs/KLHW.xml'),
('KLSF', 'GA', 'Fort Benning', '32.340000', '-85.000000', 'http://weather.noaa.gov/weather/current/KLSF.html', 'http://weather.gov/data/current_obs/KLSF.rss', 'http://weather.gov/data/current_obs/KLSF.xml'),
('KLZU', 'GA', 'Lawrenceville, Gwinnett Co-Briscoe Field Airport', '33.978000', '-83.962000', 'http://weather.noaa.gov/weather/current/KLZU.html', 'http://weather.gov/data/current_obs/KLZU.rss', 'http://weather.gov/data/current_obs/KLZU.xml'),
('KMCN', 'GA', 'Macon, Middle Georgia Regional Airport', '32.710000', '-83.650000', 'http://weather.noaa.gov/weather/current/KMCN.html', 'http://weather.gov/data/current_obs/KMCN.rss', 'http://weather.gov/data/current_obs/KMCN.xml'),
('KMGE', 'GA', 'Marietta / Dobbins Air Force Base', '33.930000', '-84.520000', 'http://weather.noaa.gov/weather/current/KMGE.html', 'http://weather.gov/data/current_obs/KMGE.rss', 'http://weather.gov/data/current_obs/KMGE.xml'),
('KMGR', 'GA', 'Moultrie Municipal Airport', '31.085000', '-83.803000', 'http://weather.noaa.gov/weather/current/KMGR.html', 'http://weather.gov/data/current_obs/KMGR.rss', 'http://weather.gov/data/current_obs/KMGR.xml'),
('KMLJ', 'GA', 'Baldwin County Airport', '33.150000', '-83.233000', 'http://weather.noaa.gov/weather/current/KMLJ.html', 'http://weather.gov/data/current_obs/KMLJ.rss', 'http://weather.gov/data/current_obs/KMLJ.xml'),
('KOPN', 'GA', 'Thomaston-Upson County Airport', '32.955000', '-84.263000', 'http://weather.noaa.gov/weather/current/KOPN.html', 'http://weather.gov/data/current_obs/KOPN.rss', 'http://weather.gov/data/current_obs/KOPN.xml'),
('KPDK', 'GA', 'Atlanta, De Kalb-Peachtree Airport', '33.880000', '-84.300000', 'http://weather.noaa.gov/weather/current/KPDK.html', 'http://weather.gov/data/current_obs/KPDK.rss', 'http://weather.gov/data/current_obs/KPDK.xml'),
('KRMG', 'GA', 'Rome, R. B. Russell Airport', '34.360000', '-85.170000', 'http://weather.noaa.gov/weather/current/KRMG.html', 'http://weather.gov/data/current_obs/KRMG.rss', 'http://weather.gov/data/current_obs/KRMG.xml'),
('KRYY', 'GA', 'Marietta, Cobb County-McCollum Field Airport', '34.013000', '-84.599000', 'http://weather.noaa.gov/weather/current/KRYY.html', 'http://weather.gov/data/current_obs/KRYY.rss', 'http://weather.gov/data/current_obs/KRYY.xml'),
('KSAV', 'GA', 'Savannah International Airport', '32.140000', '-81.200000', 'http://weather.noaa.gov/weather/current/KSAV.html', 'http://weather.gov/data/current_obs/KSAV.rss', 'http://weather.gov/data/current_obs/KSAV.xml'),
('KSSI', 'GA', 'Brunswick/Malcom-McKinnon', '31.150000', '-81.380000', 'http://weather.noaa.gov/weather/current/KSSI.html', 'http://weather.gov/data/current_obs/KSSI.rss', 'http://weather.gov/data/current_obs/KSSI.xml'),
('KSVN', 'GA', 'Hunter U. S. Army Airfield', '32.030000', '-81.150000', 'http://weather.noaa.gov/weather/current/KSVN.html', 'http://weather.gov/data/current_obs/KSVN.rss', 'http://weather.gov/data/current_obs/KSVN.xml'),
('KTBR', 'GA', 'Statesboro-Bulloch County Airport', '32.482000', '-81.737000', 'http://weather.noaa.gov/weather/current/KTBR.html', 'http://weather.gov/data/current_obs/KTBR.rss', 'http://weather.gov/data/current_obs/KTBR.xml'),
('KVAD', 'GA', 'Moody Air Force Base', '30.970000', '-83.200000', 'http://weather.noaa.gov/weather/current/KVAD.html', 'http://weather.gov/data/current_obs/KVAD.rss', 'http://weather.gov/data/current_obs/KVAD.xml'),
('KVDI', 'GA', 'Vidalia Municipal Airport', '32.193000', '-82.372000', 'http://weather.noaa.gov/weather/current/KVDI.html', 'http://weather.gov/data/current_obs/KVDI.rss', 'http://weather.gov/data/current_obs/KVDI.xml'),
('KVLD', 'GA', 'Valdosta Regional Airport', '30.790000', '-83.280000', 'http://weather.noaa.gov/weather/current/KVLD.html', 'http://weather.gov/data/current_obs/KVLD.rss', 'http://weather.gov/data/current_obs/KVLD.xml'),
('KVPC', 'GA', 'Cartersville Airport', '34.130000', '-84.850000', 'http://weather.noaa.gov/weather/current/KVPC.html', 'http://weather.gov/data/current_obs/KVPC.rss', 'http://weather.gov/data/current_obs/KVPC.xml'),
('KWDR', 'GA', 'Winder-Barrow Airport', '33.982000', '-83.668000', 'http://weather.noaa.gov/weather/current/KWDR.html', 'http://weather.gov/data/current_obs/KWDR.rss', 'http://weather.gov/data/current_obs/KWDR.xml'),
('KWRB', 'GA', 'Robins Air Force Base', '32.640000', '-83.600000', 'http://weather.noaa.gov/weather/current/KWRB.html', 'http://weather.gov/data/current_obs/KWRB.rss', 'http://weather.gov/data/current_obs/KWRB.xml'),
('TGPY', 'GD', 'Point Salines Airport', '12.000000', '-61.783000', 'http://weather.noaa.gov/weather/current/TGPY.html', 'http://weather.gov/data/current_obs/TGPY.rss', 'http://weather.gov/data/current_obs/TGPY.xml'),
('PGRO', 'GU', 'Rota/Intl', '14.180000', '145.250000', 'http://weather.noaa.gov/weather/current/PGRO.html', 'http://weather.gov/data/current_obs/PGRO.rss', 'http://weather.gov/data/current_obs/PGRO.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('PGSN', 'GU', 'Saipan Intl Airport', '15.120000', '145.730000', 'http://weather.noaa.gov/weather/current/PGSN.html', 'http://weather.gov/data/current_obs/PGSN.rss', 'http://weather.gov/data/current_obs/PGSN.xml'),
('PGUA', 'GU', 'Anderson AFB', '13.580000', '144.930000', 'http://weather.noaa.gov/weather/current/PGUA.html', 'http://weather.gov/data/current_obs/PGUA.rss', 'http://weather.gov/data/current_obs/PGUA.xml'),
('PGUM', 'GU', 'Guam International', '13.480000', '144.800000', 'http://weather.noaa.gov/weather/current/PGUM.html', 'http://weather.gov/data/current_obs/PGUM.rss', 'http://weather.gov/data/current_obs/PGUM.xml'),
('PGWT', 'GU', 'West Tinian Tinian Is', '14.970000', '145.600000', 'http://weather.noaa.gov/weather/current/PGWT.html', 'http://weather.gov/data/current_obs/PGWT.rss', 'http://weather.gov/data/current_obs/PGWT.xml'),
('PHBK', 'HI', 'Kekaha / Barking Sand', '22.070000', '-159.780000', 'http://weather.noaa.gov/weather/current/PHBK.html', 'http://weather.gov/data/current_obs/PHBK.rss', 'http://weather.gov/data/current_obs/PHBK.xml'),
('PHHI', 'HI', 'Wheeler Army Airfield', '21.480000', '-158.030000', 'http://weather.noaa.gov/weather/current/PHHI.html', 'http://weather.gov/data/current_obs/PHHI.rss', 'http://weather.gov/data/current_obs/PHHI.xml'),
('PHHN', 'HI', 'Hana', '20.784000', '-156.014000', 'http://weather.noaa.gov/weather/current/PHHN.html', 'http://weather.gov/data/current_obs/PHHN.rss', 'http://weather.gov/data/current_obs/PHHN.xml'),
('PHJH', 'HI', 'Lahaina / West Maui', '21.020000', '-156.630000', 'http://weather.noaa.gov/weather/current/PHJH.html', 'http://weather.gov/data/current_obs/PHJH.rss', 'http://weather.gov/data/current_obs/PHJH.xml'),
('PHJR', 'HI', 'Kalaeloa Airport', '21.320000', '-158.070000', 'http://weather.noaa.gov/weather/current/PHJR.html', 'http://weather.gov/data/current_obs/PHJR.rss', 'http://weather.gov/data/current_obs/PHJR.xml'),
('PHKO', 'HI', 'Kailua / Kona, Keahole Airport', '19.650000', '-156.000000', 'http://weather.noaa.gov/weather/current/PHKO.html', 'http://weather.gov/data/current_obs/PHKO.rss', 'http://weather.gov/data/current_obs/PHKO.xml'),
('PHLI', 'HI', 'Lihue Airport', '21.980000', '-159.350000', 'http://weather.noaa.gov/weather/current/PHLI.html', 'http://weather.gov/data/current_obs/PHLI.rss', 'http://weather.gov/data/current_obs/PHLI.xml'),
('PHMK', 'HI', 'Molokai Airport', '21.150000', '-157.100000', 'http://weather.noaa.gov/weather/current/PHMK.html', 'http://weather.gov/data/current_obs/PHMK.rss', 'http://weather.gov/data/current_obs/PHMK.xml'),
('PHNG', 'HI', 'Kaneohe Bay MCAF', '21.450000', '-157.783000', 'http://weather.noaa.gov/weather/current/PHNG.html', 'http://weather.gov/data/current_obs/PHNG.rss', 'http://weather.gov/data/current_obs/PHNG.xml'),
('PHNL', 'HI', 'Honolulu International Airport', '21.350000', '-157.930000', 'http://weather.noaa.gov/weather/current/PHNL.html', 'http://weather.gov/data/current_obs/PHNL.rss', 'http://weather.gov/data/current_obs/PHNL.xml'),
('PHNY', 'HI', 'Lanai City Airport', '20.780000', '-156.950000', 'http://weather.noaa.gov/weather/current/PHNY.html', 'http://weather.gov/data/current_obs/PHNY.rss', 'http://weather.gov/data/current_obs/PHNY.xml'),
('PHOG', 'HI', 'Kahului Airport', '20.900000', '-156.430000', 'http://weather.noaa.gov/weather/current/PHOG.html', 'http://weather.gov/data/current_obs/PHOG.rss', 'http://weather.gov/data/current_obs/PHOG.xml'),
('PHSF', 'HI', 'Bradshaw Army Air Field', '19.780000', '-155.550000', 'http://weather.noaa.gov/weather/current/PHSF.html', 'http://weather.gov/data/current_obs/PHSF.rss', 'http://weather.gov/data/current_obs/PHSF.xml'),
('PHTO', 'HI', 'Hilo International Airport', '19.720000', '-155.070000', 'http://weather.noaa.gov/weather/current/PHTO.html', 'http://weather.gov/data/current_obs/PHTO.rss', 'http://weather.gov/data/current_obs/PHTO.xml'),
('PJON', 'HI', 'Johnson Island', '16.733000', '-169.517000', 'http://weather.noaa.gov/weather/current/PJON.html', 'http://weather.gov/data/current_obs/PJON.rss', 'http://weather.gov/data/current_obs/PJON.xml'),
('PWAK', 'HI', 'Wake Island Airfield', '19.283000', '166.500000', 'http://weather.noaa.gov/weather/current/PWAK.html', 'http://weather.gov/data/current_obs/PWAK.rss', 'http://weather.gov/data/current_obs/PWAK.xml'),
('PMDY', 'HI', 'Midway NAF', '28.220000', '-177.370000', 'http://weather.noaa.gov/weather/current/PMDY.html', 'http://weather.gov/data/current_obs/PMDY.rss', 'http://weather.gov/data/current_obs/PMDY.xml'),
('KGGI', 'IA', 'Grinnell Regional Airport', '41.709200', '-92.734900', 'http://weather.noaa.gov/weather/current/KGGI.html', 'http://weather.gov/data/current_obs/KGGI.rss', 'http://weather.gov/data/current_obs/KGGI.xml'),
('KADU', 'IA', 'Audubon County Airport', '41.700000', '-94.920000', 'http://weather.noaa.gov/weather/current/KADU.html', 'http://weather.gov/data/current_obs/KADU.rss', 'http://weather.gov/data/current_obs/KADU.xml'),
('KAIO', 'IA', 'Atlantic', '41.400000', '-95.050000', 'http://weather.noaa.gov/weather/current/KAIO.html', 'http://weather.gov/data/current_obs/KAIO.rss', 'http://weather.gov/data/current_obs/KAIO.xml'),
('KALO', 'IA', 'Waterloo Municipal Airport', '42.550000', '-92.400000', 'http://weather.noaa.gov/weather/current/KALO.html', 'http://weather.gov/data/current_obs/KALO.rss', 'http://weather.gov/data/current_obs/KALO.xml'),
('KAMW', 'IA', 'Ames Municipal Airport', '41.990000', '-93.620000', 'http://weather.noaa.gov/weather/current/KAMW.html', 'http://weather.gov/data/current_obs/KAMW.rss', 'http://weather.gov/data/current_obs/KAMW.xml'),
('KAWG', 'IA', 'Washington', '41.280000', '-91.670000', 'http://weather.noaa.gov/weather/current/KAWG.html', 'http://weather.gov/data/current_obs/KAWG.rss', 'http://weather.gov/data/current_obs/KAWG.xml'),
('KAXA', 'IA', 'Algona', '43.080000', '-94.270000', 'http://weather.noaa.gov/weather/current/KAXA.html', 'http://weather.gov/data/current_obs/KAXA.rss', 'http://weather.gov/data/current_obs/KAXA.xml'),
('KBNW', 'IA', 'Boone Municipal', '42.050000', '-93.850000', 'http://weather.noaa.gov/weather/current/KBNW.html', 'http://weather.gov/data/current_obs/KBNW.rss', 'http://weather.gov/data/current_obs/KBNW.xml'),
('KBRL', 'IA', 'Burlington Regional Airport', '40.790000', '-91.120000', 'http://weather.noaa.gov/weather/current/KBRL.html', 'http://weather.gov/data/current_obs/KBRL.rss', 'http://weather.gov/data/current_obs/KBRL.xml'),
('KCAV', 'IA', 'Clarion', '42.750000', '-93.770000', 'http://weather.noaa.gov/weather/current/KCAV.html', 'http://weather.gov/data/current_obs/KCAV.rss', 'http://weather.gov/data/current_obs/KCAV.xml'),
('KCBF', 'IA', 'Council Bluffs', '41.270000', '-95.770000', 'http://weather.noaa.gov/weather/current/KCBF.html', 'http://weather.gov/data/current_obs/KCBF.rss', 'http://weather.gov/data/current_obs/KCBF.xml'),
('KCCY', 'IA', 'Charles City', '43.070000', '-92.620000', 'http://weather.noaa.gov/weather/current/KCCY.html', 'http://weather.gov/data/current_obs/KCCY.rss', 'http://weather.gov/data/current_obs/KCCY.xml'),
('KCID', 'IA', 'Cedar Rapids, The Eastern Iowa Airport', '41.890000', '-91.700000', 'http://weather.noaa.gov/weather/current/KCID.html', 'http://weather.gov/data/current_obs/KCID.rss', 'http://weather.gov/data/current_obs/KCID.xml'),
('KCIN', 'IA', 'Carroll', '42.050000', '-94.780000', 'http://weather.noaa.gov/weather/current/KCIN.html', 'http://weather.gov/data/current_obs/KCIN.rss', 'http://weather.gov/data/current_obs/KCIN.xml'),
('KCKP', 'IA', 'Cherokee Municipal Airport', '42.732000', '-95.556000', 'http://weather.noaa.gov/weather/current/KCKP.html', 'http://weather.gov/data/current_obs/KCKP.rss', 'http://weather.gov/data/current_obs/KCKP.xml'),
('KCNC', 'IA', 'Chariton', '41.030000', '-93.370000', 'http://weather.noaa.gov/weather/current/KCNC.html', 'http://weather.gov/data/current_obs/KCNC.rss', 'http://weather.gov/data/current_obs/KCNC.xml'),
('KCSQ', 'IA', 'Creston', '41.020000', '-94.370000', 'http://weather.noaa.gov/weather/current/KCSQ.html', 'http://weather.gov/data/current_obs/KCSQ.rss', 'http://weather.gov/data/current_obs/KCSQ.xml'),
('KCWI', 'IA', 'Clinton Municipal Automatic Weather Observing', '41.840000', '-90.340000', 'http://weather.noaa.gov/weather/current/KCWI.html', 'http://weather.gov/data/current_obs/KCWI.rss', 'http://weather.gov/data/current_obs/KCWI.xml'),
('KDBQ', 'IA', 'Dubuque Regional Airport', '42.410000', '-90.700000', 'http://weather.noaa.gov/weather/current/KDBQ.html', 'http://weather.gov/data/current_obs/KDBQ.rss', 'http://weather.gov/data/current_obs/KDBQ.xml'),
('KDEH', 'IA', 'Decorah', '43.280000', '-91.730000', 'http://weather.noaa.gov/weather/current/KDEH.html', 'http://weather.gov/data/current_obs/KDEH.rss', 'http://weather.gov/data/current_obs/KDEH.xml'),
('KDNS', 'IA', 'Denison', '41.980000', '-95.380000', 'http://weather.noaa.gov/weather/current/KDNS.html', 'http://weather.gov/data/current_obs/KDNS.rss', 'http://weather.gov/data/current_obs/KDNS.xml'),
('KDSM', 'IA', 'Des Moines International Airport', '41.540000', '-93.650000', 'http://weather.noaa.gov/weather/current/KDSM.html', 'http://weather.gov/data/current_obs/KDSM.rss', 'http://weather.gov/data/current_obs/KDSM.xml'),
('KDVN', 'IA', 'Davenport Municipal Airport', '41.620000', '-90.580000', 'http://weather.noaa.gov/weather/current/KDVN.html', 'http://weather.gov/data/current_obs/KDVN.rss', 'http://weather.gov/data/current_obs/KDVN.xml'),
('KEBS', 'IA', 'Webster City', '42.430000', '-93.870000', 'http://weather.noaa.gov/weather/current/KEBS.html', 'http://weather.gov/data/current_obs/KEBS.rss', 'http://weather.gov/data/current_obs/KEBS.xml'),
('KEOK', 'IA', 'Keokuk Municipal', '40.470000', '-91.430000', 'http://weather.noaa.gov/weather/current/KEOK.html', 'http://weather.gov/data/current_obs/KEOK.rss', 'http://weather.gov/data/current_obs/KEOK.xml'),
('KEST', 'IA', 'Estherville Municipal Airport', '43.400000', '-94.750000', 'http://weather.noaa.gov/weather/current/KEST.html', 'http://weather.gov/data/current_obs/KEST.rss', 'http://weather.gov/data/current_obs/KEST.xml'),
('KFFL', 'IA', 'Fair Field', '41.050000', '-91.980000', 'http://weather.noaa.gov/weather/current/KFFL.html', 'http://weather.gov/data/current_obs/KFFL.rss', 'http://weather.gov/data/current_obs/KFFL.xml'),
('KFOD', 'IA', 'Fort Dodge', '42.550000', '-94.180000', 'http://weather.noaa.gov/weather/current/KFOD.html', 'http://weather.gov/data/current_obs/KFOD.rss', 'http://weather.gov/data/current_obs/KFOD.xml'),
('KFSW', 'IA', 'Fort Madison', '40.670000', '-91.330000', 'http://weather.noaa.gov/weather/current/KFSW.html', 'http://weather.gov/data/current_obs/KFSW.rss', 'http://weather.gov/data/current_obs/KFSW.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('KHNR', 'IA', 'Harlan Municipal Airport', '41.584000', '-95.340000', 'http://weather.noaa.gov/weather/current/KHNR.html', 'http://weather.gov/data/current_obs/KHNR.rss', 'http://weather.gov/data/current_obs/KHNR.xml'),
('KICL', 'IA', 'Clarinda', '40.720000', '-95.030000', 'http://weather.noaa.gov/weather/current/KICL.html', 'http://weather.gov/data/current_obs/KICL.rss', 'http://weather.gov/data/current_obs/KICL.xml'),
('KIIB', 'IA', 'Independence Muni Airport', '42.454000', '-91.948000', 'http://weather.noaa.gov/weather/current/KIIB.html', 'http://weather.gov/data/current_obs/KIIB.rss', 'http://weather.gov/data/current_obs/KIIB.xml'),
('KIKV', 'IA', 'Ankeny Regional Airport', '41.690000', '-93.570000', 'http://weather.noaa.gov/weather/current/KIKV.html', 'http://weather.gov/data/current_obs/KIKV.rss', 'http://weather.gov/data/current_obs/KIKV.xml'),
('KIOW', 'IA', 'Iowa City Municipal Airport', '41.633000', '-91.543000', 'http://weather.noaa.gov/weather/current/KIOW.html', 'http://weather.gov/data/current_obs/KIOW.rss', 'http://weather.gov/data/current_obs/KIOW.xml'),
('KLRJ', 'IA', 'Le Mars Municipal Airport', '42.780000', '-96.200000', 'http://weather.noaa.gov/weather/current/KLRJ.html', 'http://weather.gov/data/current_obs/KLRJ.rss', 'http://weather.gov/data/current_obs/KLRJ.xml'),
('KLWD', 'IA', 'Lamoni Municipal Airport', '40.631000', '-93.901000', 'http://weather.noaa.gov/weather/current/KLWD.html', 'http://weather.gov/data/current_obs/KLWD.rss', 'http://weather.gov/data/current_obs/KLWD.xml'),
('KMCW', 'IA', 'Mason City Municipal Airport', '43.160000', '-93.330000', 'http://weather.noaa.gov/weather/current/KMCW.html', 'http://weather.gov/data/current_obs/KMCW.rss', 'http://weather.gov/data/current_obs/KMCW.xml'),
('KMIW', 'IA', 'Marshalltown Municipal Airport', '42.110000', '-92.910000', 'http://weather.noaa.gov/weather/current/KMIW.html', 'http://weather.gov/data/current_obs/KMIW.rss', 'http://weather.gov/data/current_obs/KMIW.xml'),
('KMPZ', 'IA', 'Mount Pleasant Muni Airport', '40.950000', '-91.510000', 'http://weather.noaa.gov/weather/current/KMPZ.html', 'http://weather.gov/data/current_obs/KMPZ.rss', 'http://weather.gov/data/current_obs/KMPZ.xml'),
('KMUT', 'IA', 'Muscatine', '41.370000', '-91.150000', 'http://weather.noaa.gov/weather/current/KMUT.html', 'http://weather.gov/data/current_obs/KMUT.rss', 'http://weather.gov/data/current_obs/KMUT.xml'),
('KMXO', 'IA', 'Monticello Municipal', '42.230000', '-91.170000', 'http://weather.noaa.gov/weather/current/KMXO.html', 'http://weather.gov/data/current_obs/KMXO.rss', 'http://weather.gov/data/current_obs/KMXO.xml'),
('KOLZ', 'IA', 'Oelwein Municipal Airport', '42.680000', '-91.960000', 'http://weather.noaa.gov/weather/current/KOLZ.html', 'http://weather.gov/data/current_obs/KOLZ.rss', 'http://weather.gov/data/current_obs/KOLZ.xml'),
('KOOA', 'IA', 'Oskaloosa Municipal Airport', '41.233000', '-92.483000', 'http://weather.noaa.gov/weather/current/KOOA.html', 'http://weather.gov/data/current_obs/KOOA.rss', 'http://weather.gov/data/current_obs/KOOA.xml'),
('KORC', 'IA', 'Orange City', '42.980000', '-96.070000', 'http://weather.noaa.gov/weather/current/KORC.html', 'http://weather.gov/data/current_obs/KORC.rss', 'http://weather.gov/data/current_obs/KORC.xml'),
('KOTM', 'IA', 'Ottumwa Industrial Airport', '41.110000', '-92.450000', 'http://weather.noaa.gov/weather/current/KOTM.html', 'http://weather.gov/data/current_obs/KOTM.rss', 'http://weather.gov/data/current_obs/KOTM.xml'),
('KOXV', 'IA', 'Knoxville', '41.300000', '-93.120000', 'http://weather.noaa.gov/weather/current/KOXV.html', 'http://weather.gov/data/current_obs/KOXV.rss', 'http://weather.gov/data/current_obs/KOXV.xml'),
('KPEA', 'IA', 'Pella Muni Airport', '41.400000', '-92.950000', 'http://weather.noaa.gov/weather/current/KPEA.html', 'http://weather.gov/data/current_obs/KPEA.rss', 'http://weather.gov/data/current_obs/KPEA.xml'),
('KRDK', 'IA', 'Red Oak', '41.020000', '-95.270000', 'http://weather.noaa.gov/weather/current/KRDK.html', 'http://weather.gov/data/current_obs/KRDK.rss', 'http://weather.gov/data/current_obs/KRDK.xml'),
('KSDA', 'IA', 'Shenandoah Municipal', '40.750000', '-95.420000', 'http://weather.noaa.gov/weather/current/KSDA.html', 'http://weather.gov/data/current_obs/KSDA.rss', 'http://weather.gov/data/current_obs/KSDA.xml'),
('KSHL', 'IA', 'Sheldon', '43.220000', '-95.830000', 'http://weather.noaa.gov/weather/current/KSHL.html', 'http://weather.gov/data/current_obs/KSHL.rss', 'http://weather.gov/data/current_obs/KSHL.xml'),
('KSLB', 'IA', 'Storm Lake', '42.600000', '-95.230000', 'http://weather.noaa.gov/weather/current/KSLB.html', 'http://weather.gov/data/current_obs/KSLB.rss', 'http://weather.gov/data/current_obs/KSLB.xml'),
('KSPW', 'IA', 'Spencer Municipal Airport', '43.170000', '-95.210000', 'http://weather.noaa.gov/weather/current/KSPW.html', 'http://weather.gov/data/current_obs/KSPW.rss', 'http://weather.gov/data/current_obs/KSPW.xml'),
('KSUX', 'IA', 'Sioux Gateway Airport', '42.410000', '-96.380000', 'http://weather.noaa.gov/weather/current/KSUX.html', 'http://weather.gov/data/current_obs/KSUX.rss', 'http://weather.gov/data/current_obs/KSUX.xml'),
('KTNU', 'IA', 'Newton Municipal', '41.680000', '-93.020000', 'http://weather.noaa.gov/weather/current/KTNU.html', 'http://weather.gov/data/current_obs/KTNU.rss', 'http://weather.gov/data/current_obs/KTNU.xml'),
('KVTI', 'IA', 'Vinton Veterans Mem Airpark Airport', '42.219000', '-92.026000', 'http://weather.noaa.gov/weather/current/KVTI.html', 'http://weather.gov/data/current_obs/KVTI.rss', 'http://weather.gov/data/current_obs/KVTI.xml'),
('K77M', 'ID', 'Malta', '42.300000', '-113.370000', 'http://weather.noaa.gov/weather/current/K77M.html', 'http://weather.gov/data/current_obs/K77M.rss', 'http://weather.gov/data/current_obs/K77M.xml'),
('KBOI', 'ID', 'Boise Municipal', '43.580000', '-116.220000', 'http://weather.noaa.gov/weather/current/KBOI.html', 'http://weather.gov/data/current_obs/KBOI.rss', 'http://weather.gov/data/current_obs/KBOI.xml'),
('KBYI', 'ID', 'Burley Municipal', '42.540000', '-113.770000', 'http://weather.noaa.gov/weather/current/KBYI.html', 'http://weather.gov/data/current_obs/KBYI.rss', 'http://weather.gov/data/current_obs/KBYI.xml'),
('KEUL', 'ID', 'Caldwell', '43.640000', '-116.640000', 'http://weather.noaa.gov/weather/current/KEUL.html', 'http://weather.gov/data/current_obs/KEUL.rss', 'http://weather.gov/data/current_obs/KEUL.xml'),
('KIDA', 'ID', 'Idaho Falls/Fanning', '43.530000', '-112.070000', 'http://weather.noaa.gov/weather/current/KIDA.html', 'http://weather.gov/data/current_obs/KIDA.rss', 'http://weather.gov/data/current_obs/KIDA.xml'),
('KJER', 'ID', 'Jerome County Airport', '42.728000', '-114.453000', 'http://weather.noaa.gov/weather/current/KJER.html', 'http://weather.gov/data/current_obs/KJER.rss', 'http://weather.gov/data/current_obs/KJER.xml'),
('KLLJ', 'ID', 'Challis (amos)', '44.523000', '-114.215000', 'http://weather.noaa.gov/weather/current/KLLJ.html', 'http://weather.gov/data/current_obs/KLLJ.rss', 'http://weather.gov/data/current_obs/KLLJ.xml'),
('KMLD', 'ID', 'Malad City', '42.180000', '-112.320000', 'http://weather.noaa.gov/weather/current/KMLD.html', 'http://weather.gov/data/current_obs/KMLD.rss', 'http://weather.gov/data/current_obs/KMLD.xml'),
('KMLP', 'ID', 'Mullan Pass Vor', '47.450000', '-115.670000', 'http://weather.noaa.gov/weather/current/KMLP.html', 'http://weather.gov/data/current_obs/KMLP.rss', 'http://weather.gov/data/current_obs/KMLP.xml'),
('KMUO', 'ID', 'Mountain Home AFB', '43.050000', '-115.870000', 'http://weather.noaa.gov/weather/current/KMUO.html', 'http://weather.gov/data/current_obs/KMUO.rss', 'http://weather.gov/data/current_obs/KMUO.xml'),
('KMYL', 'ID', 'Mc Call', '44.890000', '-116.100000', 'http://weather.noaa.gov/weather/current/KMYL.html', 'http://weather.gov/data/current_obs/KMYL.rss', 'http://weather.gov/data/current_obs/KMYL.xml'),
('KPIH', 'ID', 'Pocatello Municipal', '42.930000', '-112.600000', 'http://weather.noaa.gov/weather/current/KPIH.html', 'http://weather.gov/data/current_obs/KPIH.rss', 'http://weather.gov/data/current_obs/KPIH.xml'),
('KRXE', 'ID', 'Rexburg-Madison County Airport', '43.830000', '-111.810000', 'http://weather.noaa.gov/weather/current/KRXE.html', 'http://weather.gov/data/current_obs/KRXE.rss', 'http://weather.gov/data/current_obs/KRXE.xml'),
('KSMN', 'ID', 'Salmon/Lemhi (awos)', '45.120000', '-113.880000', 'http://weather.noaa.gov/weather/current/KSMN.html', 'http://weather.gov/data/current_obs/KSMN.rss', 'http://weather.gov/data/current_obs/KSMN.xml'),
('KSNT', 'ID', 'Stanley Ranger Station', '44.170000', '-114.930000', 'http://weather.noaa.gov/weather/current/KSNT.html', 'http://weather.gov/data/current_obs/KSNT.rss', 'http://weather.gov/data/current_obs/KSNT.xml'),
('KSUN', 'ID', 'Hailey/Friedman Mem', '43.510000', '-114.300000', 'http://weather.noaa.gov/weather/current/KSUN.html', 'http://weather.gov/data/current_obs/KSUN.rss', 'http://weather.gov/data/current_obs/KSUN.xml'),
('KSZT', 'ID', 'Sandpoint Airport', '48.300000', '-116.550000', 'http://weather.noaa.gov/weather/current/KSZT.html', 'http://weather.gov/data/current_obs/KSZT.rss', 'http://weather.gov/data/current_obs/KSZT.xml'),
('KTWF', 'ID', 'Twin Falls/Joslin', '42.480000', '-114.480000', 'http://weather.noaa.gov/weather/current/KTWF.html', 'http://weather.gov/data/current_obs/KTWF.rss', 'http://weather.gov/data/current_obs/KTWF.xml'),
('KU78', 'ID', 'Soda Springs/Tigert', '42.660000', '-111.580000', 'http://weather.noaa.gov/weather/current/KU78.html', 'http://weather.gov/data/current_obs/KU78.rss', 'http://weather.gov/data/current_obs/KU78.xml'),
('KCOE', 'ID', 'COEUR D\'ALENE(AWOS)', '47.780000', '-116.820000', 'http://weather.noaa.gov/weather/current/KCOE.html', 'http://weather.gov/data/current_obs/KCOE.rss', 'http://weather.gov/data/current_obs/KCOE.xml'),
('KLWS', 'ID', 'Lewiston (amos)', '46.390000', '-117.020000', 'http://weather.noaa.gov/weather/current/KLWS.html', 'http://weather.gov/data/current_obs/KLWS.rss', 'http://weather.gov/data/current_obs/KLWS.xml'),
('KP69', 'ID', 'Lowell', '46.150000', '-115.600000', 'http://weather.noaa.gov/weather/current/KP69.html', 'http://weather.gov/data/current_obs/KP69.rss', 'http://weather.gov/data/current_obs/KP69.xml'),
('KS14', 'ID', 'Spencer', '44.300000', '-112.100000', 'http://weather.noaa.gov/weather/current/KS14.html', 'http://weather.gov/data/current_obs/KS14.rss', 'http://weather.gov/data/current_obs/KS14.xml'),
('K1H2', 'IL', 'Effingham', '39.070000', '-88.530000', 'http://weather.noaa.gov/weather/current/K1H2.html', 'http://weather.gov/data/current_obs/K1H2.rss', 'http://weather.gov/data/current_obs/K1H2.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('K3LF', 'IL', 'Litchfield Municipal Airport', '39.163000', '-89.675000', 'http://weather.noaa.gov/weather/current/K3LF.html', 'http://weather.gov/data/current_obs/K3LF.rss', 'http://weather.gov/data/current_obs/K3LF.xml'),
('KAAA', 'IL', 'Logan County Airport', '40.160000', '-89.330000', 'http://weather.noaa.gov/weather/current/KAAA.html', 'http://weather.gov/data/current_obs/KAAA.rss', 'http://weather.gov/data/current_obs/KAAA.xml'),
('KAJG', 'IL', 'Mount Carmel Municipal Airport', '38.607000', '-87.727000', 'http://weather.noaa.gov/weather/current/KAJG.html', 'http://weather.gov/data/current_obs/KAJG.rss', 'http://weather.gov/data/current_obs/KAJG.xml'),
('KALN', 'IL', 'Alton / St. Louis Regional', '38.910000', '-90.050000', 'http://weather.noaa.gov/weather/current/KALN.html', 'http://weather.gov/data/current_obs/KALN.rss', 'http://weather.gov/data/current_obs/KALN.xml'),
('KARR', 'IL', 'Aurora Municipal Airport', '41.770000', '-88.470000', 'http://weather.noaa.gov/weather/current/KARR.html', 'http://weather.gov/data/current_obs/KARR.rss', 'http://weather.gov/data/current_obs/KARR.xml'),
('KBLV', 'IL', 'Scott Air Force Base / Belleville', '38.550000', '-89.850000', 'http://weather.noaa.gov/weather/current/KBLV.html', 'http://weather.gov/data/current_obs/KBLV.rss', 'http://weather.gov/data/current_obs/KBLV.xml'),
('KBMI', 'IL', 'Bloomington / Normal', '40.480000', '-88.930000', 'http://weather.noaa.gov/weather/current/KBMI.html', 'http://weather.gov/data/current_obs/KBMI.rss', 'http://weather.gov/data/current_obs/KBMI.xml'),
('KC09', 'IL', 'Morris Muni-James R Washburn Field Airport', '41.430000', '-88.420000', 'http://weather.noaa.gov/weather/current/KC09.html', 'http://weather.gov/data/current_obs/KC09.rss', 'http://weather.gov/data/current_obs/KC09.xml'),
('KC75', 'IL', 'Lacon', '41.020000', '-89.390000', 'http://weather.noaa.gov/weather/current/KC75.html', 'http://weather.gov/data/current_obs/KC75.rss', 'http://weather.gov/data/current_obs/KC75.xml'),
('KCIR', 'IL', 'Cairo Regional Airport', '37.067000', '-89.217000', 'http://weather.noaa.gov/weather/current/KCIR.html', 'http://weather.gov/data/current_obs/KCIR.rss', 'http://weather.gov/data/current_obs/KCIR.xml'),
('KCMI', 'IL', 'Champaign / Urbana, University of Illinois-Willard', '40.040000', '-88.280000', 'http://weather.noaa.gov/weather/current/KCMI.html', 'http://weather.gov/data/current_obs/KCMI.rss', 'http://weather.gov/data/current_obs/KCMI.xml'),
('KCPS', 'IL', 'Cahokia / St. Louis, St. Louis Downtown Airport', '38.580000', '-90.150000', 'http://weather.noaa.gov/weather/current/KCPS.html', 'http://weather.gov/data/current_obs/KCPS.rss', 'http://weather.gov/data/current_obs/KCPS.xml'),
('KCUL', 'IL', 'Carmi Municipal Airport', '38.090000', '-88.123000', 'http://weather.noaa.gov/weather/current/KCUL.html', 'http://weather.gov/data/current_obs/KCUL.rss', 'http://weather.gov/data/current_obs/KCUL.xml'),
('KDEC', 'IL', 'Decatur Airport', '39.840000', '-88.870000', 'http://weather.noaa.gov/weather/current/KDEC.html', 'http://weather.gov/data/current_obs/KDEC.rss', 'http://weather.gov/data/current_obs/KDEC.xml'),
('KDKB', 'IL', 'DeKalb Taylor Municipal Airport', '41.930000', '-88.720000', 'http://weather.noaa.gov/weather/current/KDKB.html', 'http://weather.gov/data/current_obs/KDKB.rss', 'http://weather.gov/data/current_obs/KDKB.xml'),
('KDNV', 'IL', 'Danville, Vermilion County Airport', '40.200000', '-87.600000', 'http://weather.noaa.gov/weather/current/KDNV.html', 'http://weather.gov/data/current_obs/KDNV.rss', 'http://weather.gov/data/current_obs/KDNV.xml'),
('KDPA', 'IL', 'Chicago / West Chicago, Dupage Airport', '41.930000', '-88.250000', 'http://weather.noaa.gov/weather/current/KDPA.html', 'http://weather.gov/data/current_obs/KDPA.rss', 'http://weather.gov/data/current_obs/KDPA.xml'),
('KENL', 'IL', 'Centralia Municipal Airport', '38.520000', '-89.080000', 'http://weather.noaa.gov/weather/current/KENL.html', 'http://weather.gov/data/current_obs/KENL.rss', 'http://weather.gov/data/current_obs/KENL.xml'),
('KFEP', 'IL', 'Albertus Airport', '42.250000', '-89.580000', 'http://weather.noaa.gov/weather/current/KFEP.html', 'http://weather.gov/data/current_obs/KFEP.rss', 'http://weather.gov/data/current_obs/KFEP.xml'),
('KFOA', 'IL', 'Flora Municipal Airport', '38.670000', '-88.450000', 'http://weather.noaa.gov/weather/current/KFOA.html', 'http://weather.gov/data/current_obs/KFOA.rss', 'http://weather.gov/data/current_obs/KFOA.xml'),
('KFWC', 'IL', 'Fairfield Municipal Airport', '38.380000', '-88.420000', 'http://weather.noaa.gov/weather/current/KFWC.html', 'http://weather.gov/data/current_obs/KFWC.rss', 'http://weather.gov/data/current_obs/KFWC.xml'),
('KGBG', 'IL', 'Galesburg Municipal Airport', '40.940000', '-90.430000', 'http://weather.noaa.gov/weather/current/KGBG.html', 'http://weather.gov/data/current_obs/KGBG.rss', 'http://weather.gov/data/current_obs/KGBG.xml'),
('KHSB', 'IL', 'Harrisburg-Raleigh Airport', '37.820000', '-88.550000', 'http://weather.noaa.gov/weather/current/KHSB.html', 'http://weather.gov/data/current_obs/KHSB.rss', 'http://weather.gov/data/current_obs/KHSB.xml'),
('KIGQ', 'IL', 'Lansing Municipal Airport', '41.530000', '-87.530000', 'http://weather.noaa.gov/weather/current/KIGQ.html', 'http://weather.gov/data/current_obs/KIGQ.rss', 'http://weather.gov/data/current_obs/KIGQ.xml'),
('KIJX', 'IL', 'Jacksonville Municipal Airport', '39.780000', '-90.230000', 'http://weather.noaa.gov/weather/current/KIJX.html', 'http://weather.gov/data/current_obs/KIJX.rss', 'http://weather.gov/data/current_obs/KIJX.xml'),
('KIKK', 'IL', 'Greater Kankakee Airport', '41.070000', '-87.850000', 'http://weather.noaa.gov/weather/current/KIKK.html', 'http://weather.gov/data/current_obs/KIKK.rss', 'http://weather.gov/data/current_obs/KIKK.xml'),
('KJOT', 'IL', 'Joliet Park district', '41.520000', '-88.180000', 'http://weather.noaa.gov/weather/current/KJOT.html', 'http://weather.gov/data/current_obs/KJOT.rss', 'http://weather.gov/data/current_obs/KJOT.xml'),
('KLOT', 'IL', 'Chicago/Romeoville, Lewis University Airport', '41.610000', '-88.100000', 'http://weather.noaa.gov/weather/current/KLOT.html', 'http://weather.gov/data/current_obs/KLOT.rss', 'http://weather.gov/data/current_obs/KLOT.xml'),
('KLWV', 'IL', 'Lawrenceville-Vincennes Intl Airport', '38.760000', '-87.600000', 'http://weather.noaa.gov/weather/current/KLWV.html', 'http://weather.gov/data/current_obs/KLWV.rss', 'http://weather.gov/data/current_obs/KLWV.xml'),
('KM30', 'IL', 'Metropolis Municipal Airport', '37.183000', '-88.750000', 'http://weather.noaa.gov/weather/current/KM30.html', 'http://weather.gov/data/current_obs/KM30.rss', 'http://weather.gov/data/current_obs/KM30.xml'),
('KMDH', 'IL', 'Carbondale/Murphysboro, Southern Illinois Airport', '37.790000', '-89.250000', 'http://weather.noaa.gov/weather/current/KMDH.html', 'http://weather.gov/data/current_obs/KMDH.rss', 'http://weather.gov/data/current_obs/KMDH.xml'),
('KMDW', 'IL', 'Chicago Midway Airport', '41.790000', '-87.750000', 'http://weather.noaa.gov/weather/current/KMDW.html', 'http://weather.gov/data/current_obs/KMDW.rss', 'http://weather.gov/data/current_obs/KMDW.xml'),
('KMLI', 'IL', 'Moline, Quad-City Airport', '41.460000', '-90.520000', 'http://weather.noaa.gov/weather/current/KMLI.html', 'http://weather.gov/data/current_obs/KMLI.rss', 'http://weather.gov/data/current_obs/KMLI.xml'),
('KMQB', 'IL', 'Macomb Muni Airport', '40.520000', '-90.650000', 'http://weather.noaa.gov/weather/current/KMQB.html', 'http://weather.gov/data/current_obs/KMQB.rss', 'http://weather.gov/data/current_obs/KMQB.xml'),
('KMTO', 'IL', 'Mattoon/Charleston, Coles County Memorial Airport', '39.480000', '-88.280000', 'http://weather.noaa.gov/weather/current/KMTO.html', 'http://weather.gov/data/current_obs/KMTO.rss', 'http://weather.gov/data/current_obs/KMTO.xml'),
('KMVN', 'IL', 'Mount Vernon Automatic Weather Observing/Reporting', '38.330000', '-88.870000', 'http://weather.noaa.gov/weather/current/KMVN.html', 'http://weather.gov/data/current_obs/KMVN.rss', 'http://weather.gov/data/current_obs/KMVN.xml'),
('KMWA', 'IL', 'Marion Regional', '37.760000', '-89.000000', 'http://weather.noaa.gov/weather/current/KMWA.html', 'http://weather.gov/data/current_obs/KMWA.rss', 'http://weather.gov/data/current_obs/KMWA.xml'),
('KOLY', 'IL', 'Olney-Noble Airport', '38.730000', '-88.180000', 'http://weather.noaa.gov/weather/current/KOLY.html', 'http://weather.gov/data/current_obs/KOLY.rss', 'http://weather.gov/data/current_obs/KOLY.xml'),
('KORD', 'IL', 'Chicago/Ohare', '41.980000', '-87.900000', 'http://weather.noaa.gov/weather/current/KORD.html', 'http://weather.gov/data/current_obs/KORD.rss', 'http://weather.gov/data/current_obs/KORD.xml'),
('KPIA', 'IL', 'Greater Peoria Regional Airport', '40.660000', '-89.680000', 'http://weather.noaa.gov/weather/current/KPIA.html', 'http://weather.gov/data/current_obs/KPIA.rss', 'http://weather.gov/data/current_obs/KPIA.xml'),
('KPNT', 'IL', 'Pontiac Municipal Airport', '40.920000', '-88.630000', 'http://weather.noaa.gov/weather/current/KPNT.html', 'http://weather.gov/data/current_obs/KPNT.rss', 'http://weather.gov/data/current_obs/KPNT.xml'),
('KPPQ', 'IL', 'Pittsfield Penstone Municipal Airport', '39.630000', '-90.780000', 'http://weather.noaa.gov/weather/current/KPPQ.html', 'http://weather.gov/data/current_obs/KPPQ.rss', 'http://weather.gov/data/current_obs/KPPQ.xml'),
('KPRG', 'IL', 'Edgar County Airport', '39.700000', '-87.670000', 'http://weather.noaa.gov/weather/current/KPRG.html', 'http://weather.gov/data/current_obs/KPRG.rss', 'http://weather.gov/data/current_obs/KPRG.xml'),
('KPWK', 'IL', 'Chicago / Wheeling, Pal-Waukee Airport', '42.110000', '-87.900000', 'http://weather.noaa.gov/weather/current/KPWK.html', 'http://weather.gov/data/current_obs/KPWK.rss', 'http://weather.gov/data/current_obs/KPWK.xml'),
('KRFD', 'IL', 'Chicago Rockford International Airport', '42.210000', '-89.100000', 'http://weather.noaa.gov/weather/current/KRFD.html', 'http://weather.gov/data/current_obs/KRFD.rss', 'http://weather.gov/data/current_obs/KRFD.xml'),
('KRPJ', 'IL', 'Rochelle Muni-Koritz Field Airport', '41.890000', '-89.080000', 'http://weather.noaa.gov/weather/current/KRPJ.html', 'http://weather.gov/data/current_obs/KRPJ.rss', 'http://weather.gov/data/current_obs/KRPJ.xml'),
('KRSV', 'IL', 'Robinson Municipal Airport', '39.016000', '-87.650000', 'http://weather.noaa.gov/weather/current/KRSV.html', 'http://weather.gov/data/current_obs/KRSV.rss', 'http://weather.gov/data/current_obs/KRSV.xml'),
('KSAR', 'IL', 'Sparta Community-Hunter Field Airport', '38.150000', '-89.700000', 'http://weather.noaa.gov/weather/current/KSAR.html', 'http://weather.gov/data/current_obs/KSAR.rss', 'http://weather.gov/data/current_obs/KSAR.xml'),
('KSFY', 'IL', 'Tri-Township Airport', '42.050000', '-90.100000', 'http://weather.noaa.gov/weather/current/KSFY.html', 'http://weather.gov/data/current_obs/KSFY.rss', 'http://weather.gov/data/current_obs/KSFY.xml'),
('KSLO', 'IL', 'Salem-Leckrone', '38.650000', '-88.970000', 'http://weather.noaa.gov/weather/current/KSLO.html', 'http://weather.gov/data/current_obs/KSLO.rss', 'http://weather.gov/data/current_obs/KSLO.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('KSPI', 'IL', 'Springfield, Capital Airport', '39.860000', '-89.670000', 'http://weather.noaa.gov/weather/current/KSPI.html', 'http://weather.gov/data/current_obs/KSPI.rss', 'http://weather.gov/data/current_obs/KSPI.xml'),
('KSQI', 'IL', 'Sterling Rockfalls', '41.750000', '-89.670000', 'http://weather.noaa.gov/weather/current/KSQI.html', 'http://weather.gov/data/current_obs/KSQI.rss', 'http://weather.gov/data/current_obs/KSQI.xml'),
('KTAZ', 'IL', 'Taylorville Municipal Airport', '39.530000', '-89.330000', 'http://weather.noaa.gov/weather/current/KTAZ.html', 'http://weather.gov/data/current_obs/KTAZ.rss', 'http://weather.gov/data/current_obs/KTAZ.xml'),
('KTIP', 'IL', 'Rantoul Natl Avn Cntr-Frank Elliot Field Airport', '40.290000', '-88.140000', 'http://weather.noaa.gov/weather/current/KTIP.html', 'http://weather.gov/data/current_obs/KTIP.rss', 'http://weather.gov/data/current_obs/KTIP.xml'),
('KUGN', 'IL', 'Chicago / Waukegan, Waukegan Regional Airport', '42.420000', '-87.870000', 'http://weather.noaa.gov/weather/current/KUGN.html', 'http://weather.gov/data/current_obs/KUGN.rss', 'http://weather.gov/data/current_obs/KUGN.xml'),
('KUIN', 'IL', 'Quincy Regional-Baldwin Field Airport', '39.940000', '-91.200000', 'http://weather.noaa.gov/weather/current/KUIN.html', 'http://weather.gov/data/current_obs/KUIN.rss', 'http://weather.gov/data/current_obs/KUIN.xml'),
('KVYS', 'IL', 'Illinois Valley Rgnl-Walter A Duncan Field Airport', '41.350000', '-89.150000', 'http://weather.noaa.gov/weather/current/KVYS.html', 'http://weather.gov/data/current_obs/KVYS.rss', 'http://weather.gov/data/current_obs/KVYS.xml'),
('KEVV', 'IN', 'Evansville Regional Airport', '38.050000', '-87.530000', 'http://weather.noaa.gov/weather/current/KEVV.html', 'http://weather.gov/data/current_obs/KEVV.rss', 'http://weather.gov/data/current_obs/KEVV.xml'),
('KGYY', 'IN', 'Gary Regional', '41.620000', '-87.420000', 'http://weather.noaa.gov/weather/current/KGYY.html', 'http://weather.gov/data/current_obs/KGYY.rss', 'http://weather.gov/data/current_obs/KGYY.xml'),
('KHNB', 'IN', 'Huntingburg', '38.260000', '-86.950000', 'http://weather.noaa.gov/weather/current/KHNB.html', 'http://weather.gov/data/current_obs/KHNB.rss', 'http://weather.gov/data/current_obs/KHNB.xml'),
('KVPZ', 'IN', 'Valparaiso, Porter County Municipal Airport', '41.450000', '-87.010000', 'http://weather.noaa.gov/weather/current/KVPZ.html', 'http://weather.gov/data/current_obs/KVPZ.rss', 'http://weather.gov/data/current_obs/KVPZ.xml'),
('KAID', 'IN', 'Anderson Municipal', '40.120000', '-85.620000', 'http://weather.noaa.gov/weather/current/KAID.html', 'http://weather.gov/data/current_obs/KAID.rss', 'http://weather.gov/data/current_obs/KAID.xml'),
('KASW', 'IN', 'Warsaw Municipal Airport', '41.275000', '-85.840000', 'http://weather.noaa.gov/weather/current/KASW.html', 'http://weather.gov/data/current_obs/KASW.rss', 'http://weather.gov/data/current_obs/KASW.xml'),
('KBAK', 'IN', 'Columbus / Bakalar', '39.260000', '-85.880000', 'http://weather.noaa.gov/weather/current/KBAK.html', 'http://weather.gov/data/current_obs/KBAK.rss', 'http://weather.gov/data/current_obs/KBAK.xml'),
('KBMG', 'IN', 'Bloomington, Monroe County Airport', '39.140000', '-86.620000', 'http://weather.noaa.gov/weather/current/KBMG.html', 'http://weather.gov/data/current_obs/KBMG.rss', 'http://weather.gov/data/current_obs/KBMG.xml'),
('KEKM', 'IN', 'Elkhart Municipal', '41.730000', '-86.000000', 'http://weather.noaa.gov/weather/current/KEKM.html', 'http://weather.gov/data/current_obs/KEKM.rss', 'http://weather.gov/data/current_obs/KEKM.xml'),
('KEYE', 'IN', 'Indianapolis, Eagle Creek Airpark', '39.825000', '-86.296000', 'http://weather.noaa.gov/weather/current/KEYE.html', 'http://weather.gov/data/current_obs/KEYE.rss', 'http://weather.gov/data/current_obs/KEYE.xml'),
('KFWA', 'IN', 'Fort Wayne International Airport', '41.010000', '-85.200000', 'http://weather.noaa.gov/weather/current/KFWA.html', 'http://weather.gov/data/current_obs/KFWA.rss', 'http://weather.gov/data/current_obs/KFWA.xml'),
('KGEZ', 'IN', 'Shelbyville Municipal Airport', '39.596000', '-85.800000', 'http://weather.noaa.gov/weather/current/KGEZ.html', 'http://weather.gov/data/current_obs/KGEZ.rss', 'http://weather.gov/data/current_obs/KGEZ.xml'),
('KGSH', 'IN', 'Goshen Municipal Airport', '41.530000', '-85.790000', 'http://weather.noaa.gov/weather/current/KGSH.html', 'http://weather.gov/data/current_obs/KGSH.rss', 'http://weather.gov/data/current_obs/KGSH.xml'),
('KGUS', 'IN', 'Grissom Air Force Base / Peru', '40.650000', '-86.150000', 'http://weather.noaa.gov/weather/current/KGUS.html', 'http://weather.gov/data/current_obs/KGUS.rss', 'http://weather.gov/data/current_obs/KGUS.xml'),
('KHUF', 'IN', 'Terre Haute International Airport', '39.460000', '-87.300000', 'http://weather.noaa.gov/weather/current/KHUF.html', 'http://weather.gov/data/current_obs/KHUF.rss', 'http://weather.gov/data/current_obs/KHUF.xml'),
('KIND', 'IN', 'Indianapolis International Airport', '39.730000', '-86.270000', 'http://weather.noaa.gov/weather/current/KIND.html', 'http://weather.gov/data/current_obs/KIND.rss', 'http://weather.gov/data/current_obs/KIND.xml'),
('KLAF', 'IN', 'Lafayette, Purdue University Airport', '40.430000', '-86.930000', 'http://weather.noaa.gov/weather/current/KLAF.html', 'http://weather.gov/data/current_obs/KLAF.rss', 'http://weather.gov/data/current_obs/KLAF.xml'),
('KMIE', 'IN', 'Muncie, Delaware County-Johnson Field', '40.242000', '-85.396000', 'http://weather.noaa.gov/weather/current/KMIE.html', 'http://weather.gov/data/current_obs/KMIE.rss', 'http://weather.gov/data/current_obs/KMIE.xml'),
('KOKK', 'IN', 'Kokomo Muni Airport', '40.530000', '-86.060000', 'http://weather.noaa.gov/weather/current/KOKK.html', 'http://weather.gov/data/current_obs/KOKK.rss', 'http://weather.gov/data/current_obs/KOKK.xml'),
('KSBN', 'IN', 'South Bend Regional Airport', '41.710000', '-86.320000', 'http://weather.noaa.gov/weather/current/KSBN.html', 'http://weather.gov/data/current_obs/KSBN.rss', 'http://weather.gov/data/current_obs/KSBN.xml'),
('NGTA', 'KB', 'Tarawa', '1.350000', '172.917000', 'http://weather.noaa.gov/weather/current/NGTA.html', 'http://weather.gov/data/current_obs/NGTA.rss', 'http://weather.gov/data/current_obs/NGTA.xml'),
('KAAO', 'KS', 'Wichita Colonel James Jabara Airport', '37.750000', '-97.220000', 'http://weather.noaa.gov/weather/current/KAAO.html', 'http://weather.gov/data/current_obs/KAAO.rss', 'http://weather.gov/data/current_obs/KAAO.xml'),
('KCFV', 'KS', 'Coffeyville Municipal Airport', '37.080000', '-95.570000', 'http://weather.noaa.gov/weather/current/KCFV.html', 'http://weather.gov/data/current_obs/KCFV.rss', 'http://weather.gov/data/current_obs/KCFV.xml'),
('KCNK', 'KS', 'Concordia, Blosser Municipal Airport', '39.550000', '-97.650000', 'http://weather.noaa.gov/weather/current/KCNK.html', 'http://weather.gov/data/current_obs/KCNK.rss', 'http://weather.gov/data/current_obs/KCNK.xml'),
('KCNU', 'KS', 'Chanute Martin Johnson Airport', '37.680000', '-95.480000', 'http://weather.noaa.gov/weather/current/KCNU.html', 'http://weather.gov/data/current_obs/KCNU.rss', 'http://weather.gov/data/current_obs/KCNU.xml'),
('KDDC', 'KS', 'Dodge City Regional Airport', '37.780000', '-99.970000', 'http://weather.noaa.gov/weather/current/KDDC.html', 'http://weather.gov/data/current_obs/KDDC.rss', 'http://weather.gov/data/current_obs/KDDC.xml'),
('KEHA', 'KS', 'Elkhart Automatic Weather Observing / Reporting', '37.010000', '-101.880000', 'http://weather.noaa.gov/weather/current/KEHA.html', 'http://weather.gov/data/current_obs/KEHA.rss', 'http://weather.gov/data/current_obs/KEHA.xml'),
('KEMP', 'KS', 'Emporia Kansas', '38.340000', '-96.200000', 'http://weather.noaa.gov/weather/current/KEMP.html', 'http://weather.gov/data/current_obs/KEMP.rss', 'http://weather.gov/data/current_obs/KEMP.xml'),
('KEWK', 'KS', 'Newton Automatic Weather Observing / Reporting Sys', '38.050000', '-97.290000', 'http://weather.noaa.gov/weather/current/KEWK.html', 'http://weather.gov/data/current_obs/KEWK.rss', 'http://weather.gov/data/current_obs/KEWK.xml'),
('KFOE', 'KS', 'Topeka, Forbes Field', '38.960000', '-95.670000', 'http://weather.noaa.gov/weather/current/KFOE.html', 'http://weather.gov/data/current_obs/KFOE.rss', 'http://weather.gov/data/current_obs/KFOE.xml'),
('KFRI', 'KS', 'Fort Riley', '39.050000', '-96.767000', 'http://weather.noaa.gov/weather/current/KFRI.html', 'http://weather.gov/data/current_obs/KFRI.rss', 'http://weather.gov/data/current_obs/KFRI.xml'),
('KGBD', 'KS', 'Great Bend Automatic Weather Observing / Reporting', '38.340000', '-98.860000', 'http://weather.noaa.gov/weather/current/KGBD.html', 'http://weather.gov/data/current_obs/KGBD.rss', 'http://weather.gov/data/current_obs/KGBD.xml'),
('KGCK', 'KS', 'Garden City Regional Airport', '37.940000', '-100.720000', 'http://weather.noaa.gov/weather/current/KGCK.html', 'http://weather.gov/data/current_obs/KGCK.rss', 'http://weather.gov/data/current_obs/KGCK.xml'),
('KHLC', 'KS', 'Hill City Municipal Airport', '39.390000', '-99.830000', 'http://weather.noaa.gov/weather/current/KHLC.html', 'http://weather.gov/data/current_obs/KHLC.rss', 'http://weather.gov/data/current_obs/KHLC.xml'),
('KHUT', 'KS', 'Hutchinson Municipal Airport', '38.080000', '-97.870000', 'http://weather.noaa.gov/weather/current/KHUT.html', 'http://weather.gov/data/current_obs/KHUT.rss', 'http://weather.gov/data/current_obs/KHUT.xml'),
('KHYS', 'KS', 'Hays Municipal Automatic Weather Observing/Report', '38.860000', '-99.270000', 'http://weather.noaa.gov/weather/current/KHYS.html', 'http://weather.gov/data/current_obs/KHYS.rss', 'http://weather.gov/data/current_obs/KHYS.xml'),
('KIAB', 'KS', 'McConnell Air Force Base', '37.617000', '-97.267000', 'http://weather.noaa.gov/weather/current/KIAB.html', 'http://weather.gov/data/current_obs/KIAB.rss', 'http://weather.gov/data/current_obs/KIAB.xml'),
('KICT', 'KS', 'Wichita Mid-Continent Airport', '37.660000', '-97.430000', 'http://weather.noaa.gov/weather/current/KICT.html', 'http://weather.gov/data/current_obs/KICT.rss', 'http://weather.gov/data/current_obs/KICT.xml'),
('KIXD', 'KS', 'Olathe, New Century Aircenter', '38.830000', '-94.890000', 'http://weather.noaa.gov/weather/current/KIXD.html', 'http://weather.gov/data/current_obs/KIXD.rss', 'http://weather.gov/data/current_obs/KIXD.xml'),
('KLBL', 'KS', 'Liberal Municipal Automatic Weather Observing', '37.050000', '-100.970000', 'http://weather.noaa.gov/weather/current/KLBL.html', 'http://weather.gov/data/current_obs/KLBL.rss', 'http://weather.gov/data/current_obs/KLBL.xml'),
('KLWC', 'KS', 'Lawrence Municipal Airport', '39.020000', '-95.220000', 'http://weather.noaa.gov/weather/current/KLWC.html', 'http://weather.gov/data/current_obs/KLWC.rss', 'http://weather.gov/data/current_obs/KLWC.xml'),
('KMHK', 'KS', 'Manhattan Municipal Airport', '39.160000', '-96.670000', 'http://weather.noaa.gov/weather/current/KMHK.html', 'http://weather.gov/data/current_obs/KMHK.rss', 'http://weather.gov/data/current_obs/KMHK.xml'),
('KOJC', 'KS', 'Olathe, Johnson County Executive Airport', '38.850000', '-94.740000', 'http://weather.noaa.gov/weather/current/KOJC.html', 'http://weather.gov/data/current_obs/KOJC.rss', 'http://weather.gov/data/current_obs/KOJC.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('KP28', 'KS', 'Medicine Lodge', '37.300000', '-98.580000', 'http://weather.noaa.gov/weather/current/KP28.html', 'http://weather.gov/data/current_obs/KP28.rss', 'http://weather.gov/data/current_obs/KP28.xml'),
('KPPF', 'KS', 'Parsons, Tri-City Airport', '37.300000', '-95.500000', 'http://weather.noaa.gov/weather/current/KPPF.html', 'http://weather.gov/data/current_obs/KPPF.rss', 'http://weather.gov/data/current_obs/KPPF.xml'),
('KPTT', 'KS', 'Pratt Industrial Airport', '37.702000', '-98.747000', 'http://weather.noaa.gov/weather/current/KPTT.html', 'http://weather.gov/data/current_obs/KPTT.rss', 'http://weather.gov/data/current_obs/KPTT.xml'),
('KRSL', 'KS', 'Russell Municipal Airport', '38.870000', '-98.810000', 'http://weather.noaa.gov/weather/current/KRSL.html', 'http://weather.gov/data/current_obs/KRSL.rss', 'http://weather.gov/data/current_obs/KRSL.xml'),
('KS58', 'KS', 'Foster Field Airport', '28.533000', '-90.583000', 'http://weather.noaa.gov/weather/current/KS58.html', 'http://weather.gov/data/current_obs/KS58.rss', 'http://weather.gov/data/current_obs/KS58.xml'),
('KSLN', 'KS', 'Salina Municipal Airport', '38.800000', '-97.650000', 'http://weather.noaa.gov/weather/current/KSLN.html', 'http://weather.gov/data/current_obs/KSLN.rss', 'http://weather.gov/data/current_obs/KSLN.xml'),
('KTOP', 'KS', 'Topeka, Philip Billard Municipal Airport', '39.080000', '-95.620000', 'http://weather.noaa.gov/weather/current/KTOP.html', 'http://weather.gov/data/current_obs/KTOP.rss', 'http://weather.gov/data/current_obs/KTOP.xml'),
('KUKL', 'KS', 'Coffey County Airport', '38.300000', '-95.717000', 'http://weather.noaa.gov/weather/current/KUKL.html', 'http://weather.gov/data/current_obs/KUKL.rss', 'http://weather.gov/data/current_obs/KUKL.xml'),
('KWLD', 'KS', 'Winfield / Arkansas City, Strother Field', '37.160000', '-97.030000', 'http://weather.noaa.gov/weather/current/KWLD.html', 'http://weather.gov/data/current_obs/KWLD.rss', 'http://weather.gov/data/current_obs/KWLD.xml'),
('KGLD', 'KS', 'Goodland, Renner Field', '39.380000', '-101.700000', 'http://weather.noaa.gov/weather/current/KGLD.html', 'http://weather.gov/data/current_obs/KGLD.rss', 'http://weather.gov/data/current_obs/KGLD.xml'),
('NCRG', 'KU', 'Rarotonga', '-21.200000', '-159.817000', 'http://weather.noaa.gov/weather/current/NCRG.html', 'http://weather.gov/data/current_obs/NCRG.rss', 'http://weather.gov/data/current_obs/NCRG.xml'),
('NIUE', 'KU', 'Alofi/Niue', '-19.067000', '-169.917000', 'http://weather.noaa.gov/weather/current/NIUE.html', 'http://weather.gov/data/current_obs/NIUE.rss', 'http://weather.gov/data/current_obs/NIUE.xml'),
('KBWG', 'KY', 'Bowling Green-Warren County Regional Airport', '36.960000', '-86.420000', 'http://weather.noaa.gov/weather/current/KBWG.html', 'http://weather.gov/data/current_obs/KBWG.rss', 'http://weather.gov/data/current_obs/KBWG.xml'),
('KEHR', 'KY', 'Henderson City', '37.820000', '-87.690000', 'http://weather.noaa.gov/weather/current/KEHR.html', 'http://weather.gov/data/current_obs/KEHR.rss', 'http://weather.gov/data/current_obs/KEHR.xml'),
('KHOP', 'KY', 'Fort Campbell U. S. Army Airfield', '36.669000', '-87.496000', 'http://weather.noaa.gov/weather/current/KHOP.html', 'http://weather.gov/data/current_obs/KHOP.rss', 'http://weather.gov/data/current_obs/KHOP.xml'),
('KOWB', 'KY', 'Owensboro / Daviess', '37.760000', '-87.170000', 'http://weather.noaa.gov/weather/current/KOWB.html', 'http://weather.gov/data/current_obs/KOWB.rss', 'http://weather.gov/data/current_obs/KOWB.xml'),
('KPAH', 'KY', 'Paducah, Barkley Regional Airport', '37.070000', '-88.770000', 'http://weather.noaa.gov/weather/current/KPAH.html', 'http://weather.gov/data/current_obs/KPAH.rss', 'http://weather.gov/data/current_obs/KPAH.xml'),
('K1A6', 'KY', 'Middlesboro-Bell County Airport', '36.611000', '-83.737000', 'http://weather.noaa.gov/weather/current/K1A6.html', 'http://weather.gov/data/current_obs/K1A6.rss', 'http://weather.gov/data/current_obs/K1A6.xml'),
('KCVG', 'KY', 'Covington / Cincinnati / Northern Kentucky', '39.050000', '-84.670000', 'http://weather.noaa.gov/weather/current/KCVG.html', 'http://weather.gov/data/current_obs/KCVG.rss', 'http://weather.gov/data/current_obs/KCVG.xml'),
('KEKQ', 'KY', 'Wayne County Airport', '36.855000', '-84.856000', 'http://weather.noaa.gov/weather/current/KEKQ.html', 'http://weather.gov/data/current_obs/KEKQ.rss', 'http://weather.gov/data/current_obs/KEKQ.xml'),
('KFFT', 'KY', 'Frankfort, Capital City Airport', '38.180000', '-84.900000', 'http://weather.noaa.gov/weather/current/KFFT.html', 'http://weather.gov/data/current_obs/KFFT.rss', 'http://weather.gov/data/current_obs/KFFT.xml'),
('KFTK', 'KY', 'Fort Knox', '37.900000', '-85.967000', 'http://weather.noaa.gov/weather/current/KFTK.html', 'http://weather.gov/data/current_obs/KFTK.rss', 'http://weather.gov/data/current_obs/KFTK.xml'),
('KGLW', 'KY', 'Glasgow Municipal Airport', '36.963000', '-85.946000', 'http://weather.noaa.gov/weather/current/KGLW.html', 'http://weather.gov/data/current_obs/KGLW.rss', 'http://weather.gov/data/current_obs/KGLW.xml'),
('KI16', 'KY', 'Kee Field Airport', '37.600000', '-81.559000', 'http://weather.noaa.gov/weather/current/KI16.html', 'http://weather.gov/data/current_obs/KI16.rss', 'http://weather.gov/data/current_obs/KI16.xml'),
('KJKL', 'KY', 'Julian Caroll Airport', '37.580000', '-83.320000', 'http://weather.noaa.gov/weather/current/KJKL.html', 'http://weather.gov/data/current_obs/KJKL.rss', 'http://weather.gov/data/current_obs/KJKL.xml'),
('KLEX', 'KY', 'Lexington, Blue Grass Airport', '38.050000', '-84.600000', 'http://weather.noaa.gov/weather/current/KLEX.html', 'http://weather.gov/data/current_obs/KLEX.rss', 'http://weather.gov/data/current_obs/KLEX.xml'),
('KLOU', 'KY', 'Louisville, Bowman Field Airport', '38.230000', '-85.670000', 'http://weather.noaa.gov/weather/current/KLOU.html', 'http://weather.gov/data/current_obs/KLOU.rss', 'http://weather.gov/data/current_obs/KLOU.xml'),
('KLOZ', 'KY', 'London-Corbin Airport-Magee Field', '37.090000', '-84.040000', 'http://weather.noaa.gov/weather/current/KLOZ.html', 'http://weather.gov/data/current_obs/KLOZ.rss', 'http://weather.gov/data/current_obs/KLOZ.xml'),
('KSDF', 'KY', 'Louisville, Standiford Field', '38.190000', '-85.730000', 'http://weather.noaa.gov/weather/current/KSDF.html', 'http://weather.gov/data/current_obs/KSDF.rss', 'http://weather.gov/data/current_obs/KSDF.xml'),
('KSME', 'KY', 'Somerset-Pulaski County-J.T. Wilson Field Airport', '37.055000', '-84.614000', 'http://weather.noaa.gov/weather/current/KSME.html', 'http://weather.gov/data/current_obs/KSME.rss', 'http://weather.gov/data/current_obs/KSME.xml'),
('KY15', 'KY', 'Brennan Farm Airport', '45.650000', '-84.467000', 'http://weather.noaa.gov/weather/current/KY15.html', 'http://weather.gov/data/current_obs/KY15.rss', 'http://weather.gov/data/current_obs/KY15.xml'),
('K1B7', 'LA', 'Boothville Heliport', '29.350000', '-89.433000', 'http://weather.noaa.gov/weather/current/K1B7.html', 'http://weather.gov/data/current_obs/K1B7.rss', 'http://weather.gov/data/current_obs/K1B7.xml'),
('K2GL', 'LA', 'Galliano Heliport', '29.417000', '-90.300000', 'http://weather.noaa.gov/weather/current/K2GL.html', 'http://weather.gov/data/current_obs/K2GL.rss', 'http://weather.gov/data/current_obs/K2GL.xml'),
('K3B6', 'LA', 'Eugene Island 300', '28.083000', '-92.700000', 'http://weather.noaa.gov/weather/current/K3B6.html', 'http://weather.gov/data/current_obs/K3B6.rss', 'http://weather.gov/data/current_obs/K3B6.xml'),
('K7R3', 'LA', 'Amelia / Lake Palourd', '29.700000', '-91.100000', 'http://weather.noaa.gov/weather/current/K7R3.html', 'http://weather.gov/data/current_obs/K7R3.rss', 'http://weather.gov/data/current_obs/K7R3.xml'),
('K7R4', 'LA', 'Intracoastal City', '29.783000', '-92.133000', 'http://weather.noaa.gov/weather/current/K7R4.html', 'http://weather.gov/data/current_obs/K7R4.rss', 'http://weather.gov/data/current_obs/K7R4.xml'),
('K7R5', 'LA', 'Cameron Heliport', '29.783000', '-93.300000', 'http://weather.noaa.gov/weather/current/K7R5.html', 'http://weather.gov/data/current_obs/K7R5.rss', 'http://weather.gov/data/current_obs/K7R5.xml'),
('K7R8', 'LA', 'South Marsh Island', '28.300000', '-91.983000', 'http://weather.noaa.gov/weather/current/K7R8.html', 'http://weather.gov/data/current_obs/K7R8.rss', 'http://weather.gov/data/current_obs/K7R8.xml'),
('KAEX', 'LA', 'Alexandria International Airport', '31.330000', '-92.550000', 'http://weather.noaa.gov/weather/current/KAEX.html', 'http://weather.gov/data/current_obs/KAEX.rss', 'http://weather.gov/data/current_obs/KAEX.xml'),
('KAQV', 'LA', 'Ft. Polk/Peason Ridge', '31.400000', '-93.283000', 'http://weather.noaa.gov/weather/current/KAQV.html', 'http://weather.gov/data/current_obs/KAQV.rss', 'http://weather.gov/data/current_obs/KAQV.xml'),
('KARA', 'LA', 'New Iberia, Acadiana Regional Airport', '30.030000', '-91.880000', 'http://weather.noaa.gov/weather/current/KARA.html', 'http://weather.gov/data/current_obs/KARA.rss', 'http://weather.gov/data/current_obs/KARA.xml'),
('KASD', 'LA', 'Slidell Airport', '30.350000', '-89.820000', 'http://weather.noaa.gov/weather/current/KASD.html', 'http://weather.gov/data/current_obs/KASD.rss', 'http://weather.gov/data/current_obs/KASD.xml'),
('KBAD', 'LA', 'Barksdale Air Force Base', '32.500000', '-93.683000', 'http://weather.noaa.gov/weather/current/KBAD.html', 'http://weather.gov/data/current_obs/KBAD.rss', 'http://weather.gov/data/current_obs/KBAD.xml'),
('KBKB', 'LA', 'Ft. Polk/Fullerton Landing', '31.000000', '-92.967000', 'http://weather.noaa.gov/weather/current/KBKB.html', 'http://weather.gov/data/current_obs/KBKB.rss', 'http://weather.gov/data/current_obs/KBKB.xml'),
('KBTR', 'LA', 'Baton Rouge Metropolitan, Ryan Field', '30.540000', '-91.150000', 'http://weather.noaa.gov/weather/current/KBTR.html', 'http://weather.gov/data/current_obs/KBTR.rss', 'http://weather.gov/data/current_obs/KBTR.xml'),
('KBVE', 'LA', 'Boothville', '29.333000', '-89.400000', 'http://weather.noaa.gov/weather/current/KBVE.html', 'http://weather.gov/data/current_obs/KBVE.rss', 'http://weather.gov/data/current_obs/KBVE.xml'),
('KCWF', 'LA', 'Chenault Airpark', '30.220000', '-93.150000', 'http://weather.noaa.gov/weather/current/KCWF.html', 'http://weather.gov/data/current_obs/KCWF.rss', 'http://weather.gov/data/current_obs/KCWF.xml'),
('KDNK', 'LA', 'Ft. Polk/Self Strip', '31.100000', '-93.000000', 'http://weather.noaa.gov/weather/current/KDNK.html', 'http://weather.gov/data/current_obs/KDNK.rss', 'http://weather.gov/data/current_obs/KDNK.xml'),
('KDRI', 'LA', 'Beauregard Regional Airport', '30.833000', '-93.333000', 'http://weather.noaa.gov/weather/current/KDRI.html', 'http://weather.gov/data/current_obs/KDRI.rss', 'http://weather.gov/data/current_obs/KDRI.xml'),
('KDTN', 'LA', 'Shreveport Downtown Airport', '32.530000', '-93.750000', 'http://weather.noaa.gov/weather/current/KDTN.html', 'http://weather.gov/data/current_obs/KDTN.rss', 'http://weather.gov/data/current_obs/KDTN.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('KE12', 'LA', 'East Cameron 345', '28.083000', '-92.700000', 'http://weather.noaa.gov/weather/current/KE12.html', 'http://weather.gov/data/current_obs/KE12.rss', 'http://weather.gov/data/current_obs/KE12.xml'),
('KESF', 'LA', 'Alexandria Esler Regional Airport', '31.400000', '-92.300000', 'http://weather.noaa.gov/weather/current/KESF.html', 'http://weather.gov/data/current_obs/KESF.rss', 'http://weather.gov/data/current_obs/KESF.xml'),
('KGSM', 'LA', 'Ship Shoal 207A', '28.533000', '-90.983000', 'http://weather.noaa.gov/weather/current/KGSM.html', 'http://weather.gov/data/current_obs/KGSM.rss', 'http://weather.gov/data/current_obs/KGSM.xml'),
('KH08', 'LA', 'High Island 264C', '28.467000', '-93.733000', 'http://weather.noaa.gov/weather/current/KH08.html', 'http://weather.gov/data/current_obs/KH08.rss', 'http://weather.gov/data/current_obs/KH08.xml'),
('KHDC', 'LA', 'Hammond Municipal Airport', '30.520000', '-90.420000', 'http://weather.noaa.gov/weather/current/KHDC.html', 'http://weather.gov/data/current_obs/KHDC.rss', 'http://weather.gov/data/current_obs/KHDC.xml'),
('KHUM', 'LA', 'Houma-Terrebonne', '29.570000', '-90.670000', 'http://weather.noaa.gov/weather/current/KHUM.html', 'http://weather.gov/data/current_obs/KHUM.rss', 'http://weather.gov/data/current_obs/KHUM.xml'),
('KIER', 'LA', 'Natchitoches Regional Airport', '31.733000', '-93.100000', 'http://weather.noaa.gov/weather/current/KIER.html', 'http://weather.gov/data/current_obs/KIER.rss', 'http://weather.gov/data/current_obs/KIER.xml'),
('KLCH', 'LA', 'Lake Charles Regional Airport', '30.120000', '-93.220000', 'http://weather.noaa.gov/weather/current/KLCH.html', 'http://weather.gov/data/current_obs/KLCH.rss', 'http://weather.gov/data/current_obs/KLCH.xml'),
('KLFT', 'LA', 'Lafayette Regional Airport', '30.200000', '-92.000000', 'http://weather.noaa.gov/weather/current/KLFT.html', 'http://weather.gov/data/current_obs/KLFT.rss', 'http://weather.gov/data/current_obs/KLFT.xml'),
('KMLU', 'LA', 'Monroe Regional Airport', '32.510000', '-92.040000', 'http://weather.noaa.gov/weather/current/KMLU.html', 'http://weather.gov/data/current_obs/KMLU.rss', 'http://weather.gov/data/current_obs/KMLU.xml'),
('KMSY', 'LA', 'New Orleans International Airport', '29.980000', '-90.250000', 'http://weather.noaa.gov/weather/current/KMSY.html', 'http://weather.gov/data/current_obs/KMSY.rss', 'http://weather.gov/data/current_obs/KMSY.xml'),
('KNBG', 'LA', 'New Orleans, Naval Air Station', '29.833000', '-90.017000', 'http://weather.noaa.gov/weather/current/KNBG.html', 'http://weather.gov/data/current_obs/KNBG.rss', 'http://weather.gov/data/current_obs/KNBG.xml'),
('KNEW', 'LA', 'New Orleans Lakefront Airport', '30.040000', '-90.030000', 'http://weather.noaa.gov/weather/current/KNEW.html', 'http://weather.gov/data/current_obs/KNEW.rss', 'http://weather.gov/data/current_obs/KNEW.xml'),
('KP92', 'LA', 'Salt Point', '29.600000', '-91.300000', 'http://weather.noaa.gov/weather/current/KP92.html', 'http://weather.gov/data/current_obs/KP92.rss', 'http://weather.gov/data/current_obs/KP92.xml'),
('KPOE', 'LA', 'Fort Polk', '31.050000', '-93.183000', 'http://weather.noaa.gov/weather/current/KPOE.html', 'http://weather.gov/data/current_obs/KPOE.rss', 'http://weather.gov/data/current_obs/KPOE.xml'),
('KPTN', 'LA', 'Patterson Memorial', '29.720000', '-91.330000', 'http://weather.noaa.gov/weather/current/KPTN.html', 'http://weather.gov/data/current_obs/KPTN.rss', 'http://weather.gov/data/current_obs/KPTN.xml'),
('KSHV', 'LA', 'Shreveport Regional Airport', '32.450000', '-93.830000', 'http://weather.noaa.gov/weather/current/KSHV.html', 'http://weather.gov/data/current_obs/KSHV.rss', 'http://weather.gov/data/current_obs/KSHV.xml'),
('KSRN', 'LA', 'South Marsh 268A', '29.117000', '-91.867000', 'http://weather.noaa.gov/weather/current/KSRN.html', 'http://weather.gov/data/current_obs/KSRN.rss', 'http://weather.gov/data/current_obs/KSRN.xml'),
('KTVR', 'LA', 'Vicksburg / Tallulah Regional Airport', '32.350000', '-91.030000', 'http://weather.noaa.gov/weather/current/KTVR.html', 'http://weather.gov/data/current_obs/KTVR.rss', 'http://weather.gov/data/current_obs/KTVR.xml'),
('KW60', 'LA', 'West Cameron 560', '29.150000', '-93.350000', 'http://weather.noaa.gov/weather/current/KW60.html', 'http://weather.gov/data/current_obs/KW60.rss', 'http://weather.gov/data/current_obs/KW60.xml'),
('KXCN', 'LA', 'Green Canyon 184', '27.767000', '-91.517000', 'http://weather.noaa.gov/weather/current/KXCN.html', 'http://weather.gov/data/current_obs/KXCN.rss', 'http://weather.gov/data/current_obs/KXCN.xml'),
('TLPC', 'LC', 'Vigie', '14.017000', '-61.000000', 'http://weather.noaa.gov/weather/current/TLPC.html', 'http://weather.gov/data/current_obs/TLPC.rss', 'http://weather.gov/data/current_obs/TLPC.xml'),
('TLPL', 'LC', 'Hewanorra Intl Airport', '13.750000', '-60.950000', 'http://weather.noaa.gov/weather/current/TLPL.html', 'http://weather.gov/data/current_obs/TLPL.rss', 'http://weather.gov/data/current_obs/TLPL.xml'),
('KACK', 'MA', 'Nantucket Memorial Airport', '41.260000', '-70.070000', 'http://weather.noaa.gov/weather/current/KACK.html', 'http://weather.gov/data/current_obs/KACK.rss', 'http://weather.gov/data/current_obs/KACK.xml'),
('KAQW', 'MA', 'North Adams, Harriman-And-West Airport', '42.710000', '-73.170000', 'http://weather.noaa.gov/weather/current/KAQW.html', 'http://weather.gov/data/current_obs/KAQW.rss', 'http://weather.gov/data/current_obs/KAQW.xml'),
('KBAF', 'MA', 'Westfield, Barnes Municipal Airport', '42.160000', '-72.720000', 'http://weather.noaa.gov/weather/current/KBAF.html', 'http://weather.gov/data/current_obs/KBAF.rss', 'http://weather.gov/data/current_obs/KBAF.xml'),
('KBED', 'MA', 'Bedford, Hanscom Field', '42.470000', '-71.290000', 'http://weather.noaa.gov/weather/current/KBED.html', 'http://weather.gov/data/current_obs/KBED.rss', 'http://weather.gov/data/current_obs/KBED.xml'),
('KBOS', 'MA', 'Boston, Logan International Airport', '42.380000', '-71.030000', 'http://weather.noaa.gov/weather/current/KBOS.html', 'http://weather.gov/data/current_obs/KBOS.rss', 'http://weather.gov/data/current_obs/KBOS.xml'),
('KBVY', 'MA', 'Beverly Municipal Airport', '42.590000', '-70.920000', 'http://weather.noaa.gov/weather/current/KBVY.html', 'http://weather.gov/data/current_obs/KBVY.rss', 'http://weather.gov/data/current_obs/KBVY.xml'),
('KCEF', 'MA', 'Chicopee Falls / Westover Air Force Base', '42.210000', '-72.530000', 'http://weather.noaa.gov/weather/current/KCEF.html', 'http://weather.gov/data/current_obs/KCEF.rss', 'http://weather.gov/data/current_obs/KCEF.xml'),
('KCHH', 'MA', 'Chatham', '41.667000', '-69.967000', 'http://weather.noaa.gov/weather/current/KCHH.html', 'http://weather.gov/data/current_obs/KCHH.rss', 'http://weather.gov/data/current_obs/KCHH.xml'),
('KCQX', 'MA', 'Chatham Municipal Airport', '41.700000', '-69.990000', 'http://weather.noaa.gov/weather/current/KCQX.html', 'http://weather.gov/data/current_obs/KCQX.rss', 'http://weather.gov/data/current_obs/KCQX.xml'),
('KEWB', 'MA', 'New Bedford Regional Airport', '41.690000', '-70.970000', 'http://weather.noaa.gov/weather/current/KEWB.html', 'http://weather.gov/data/current_obs/KEWB.rss', 'http://weather.gov/data/current_obs/KEWB.xml'),
('KFIT', 'MA', 'Fitchburg Municipal Airport', '42.550000', '-71.760000', 'http://weather.noaa.gov/weather/current/KFIT.html', 'http://weather.gov/data/current_obs/KFIT.rss', 'http://weather.gov/data/current_obs/KFIT.xml'),
('KFMH', 'MA', 'Otis Air National Guard Base', '41.660000', '-70.520000', 'http://weather.noaa.gov/weather/current/KFMH.html', 'http://weather.gov/data/current_obs/KFMH.rss', 'http://weather.gov/data/current_obs/KFMH.xml'),
('KHYA', 'MA', 'Hyannis, Barnstable Municipal-Boardman Airport', '41.680000', '-70.280000', 'http://weather.noaa.gov/weather/current/KHYA.html', 'http://weather.gov/data/current_obs/KHYA.rss', 'http://weather.gov/data/current_obs/KHYA.xml'),
('KLWM', 'MA', 'Lawrence Municipal Airport', '42.730000', '-71.120000', 'http://weather.noaa.gov/weather/current/KLWM.html', 'http://weather.gov/data/current_obs/KLWM.rss', 'http://weather.gov/data/current_obs/KLWM.xml'),
('KMQE', 'MA', 'East Milton', '42.210000', '-71.110000', 'http://weather.noaa.gov/weather/current/KMQE.html', 'http://weather.gov/data/current_obs/KMQE.rss', 'http://weather.gov/data/current_obs/KMQE.xml'),
('KMVY', 'MA', 'Marthas Vineyard Airport', '41.410000', '-70.620000', 'http://weather.noaa.gov/weather/current/KMVY.html', 'http://weather.gov/data/current_obs/KMVY.rss', 'http://weather.gov/data/current_obs/KMVY.xml'),
('KORE', 'MA', 'Orange Municipal Airport', '42.580000', '-72.280000', 'http://weather.noaa.gov/weather/current/KORE.html', 'http://weather.gov/data/current_obs/KORE.rss', 'http://weather.gov/data/current_obs/KORE.xml'),
('KORH', 'MA', 'Worcester Regional Airport', '42.280000', '-71.870000', 'http://weather.noaa.gov/weather/current/KORH.html', 'http://weather.gov/data/current_obs/KORH.rss', 'http://weather.gov/data/current_obs/KORH.xml'),
('KOWD', 'MA', 'Norwood Memorial Airport', '42.190000', '-71.170000', 'http://weather.noaa.gov/weather/current/KOWD.html', 'http://weather.gov/data/current_obs/KOWD.rss', 'http://weather.gov/data/current_obs/KOWD.xml'),
('KPSF', 'MA', 'Pittsfield Municipal Airport', '42.430000', '-73.290000', 'http://weather.noaa.gov/weather/current/KPSF.html', 'http://weather.gov/data/current_obs/KPSF.rss', 'http://weather.gov/data/current_obs/KPSF.xml'),
('KPVC', 'MA', 'Provincetown Automatic Weather Observing/Reporting', '42.010000', '-70.200000', 'http://weather.noaa.gov/weather/current/KPVC.html', 'http://weather.gov/data/current_obs/KPVC.rss', 'http://weather.gov/data/current_obs/KPVC.xml'),
('KPYM', 'MA', 'Plymouth Municipal Airport', '41.910000', '-70.730000', 'http://weather.noaa.gov/weather/current/KPYM.html', 'http://weather.gov/data/current_obs/KPYM.rss', 'http://weather.gov/data/current_obs/KPYM.xml'),
('KTAN', 'MA', 'Taunton', '41.890000', '-71.020000', 'http://weather.noaa.gov/weather/current/KTAN.html', 'http://weather.gov/data/current_obs/KTAN.rss', 'http://weather.gov/data/current_obs/KTAN.xml'),
('KADW', 'MD', 'Camp Springs / Andrews Air Force Base', '38.830000', '-76.870000', 'http://weather.noaa.gov/weather/current/KADW.html', 'http://weather.gov/data/current_obs/KADW.rss', 'http://weather.gov/data/current_obs/KADW.xml'),
('KAPG', 'MD', 'Phillips Army Air Field / Aberdeen', '39.470000', '-76.170000', 'http://weather.noaa.gov/weather/current/KAPG.html', 'http://weather.gov/data/current_obs/KAPG.rss', 'http://weather.gov/data/current_obs/KAPG.xml'),
('KBWI', 'MD', 'Baltimore-Washington International Airport', '39.190000', '-76.670000', 'http://weather.noaa.gov/weather/current/KBWI.html', 'http://weather.gov/data/current_obs/KBWI.rss', 'http://weather.gov/data/current_obs/KBWI.xml'),
('KCBE', 'MD', 'Greater Cumberland Regional Airport', '39.617000', '-78.767000', 'http://weather.noaa.gov/weather/current/KCBE.html', 'http://weather.gov/data/current_obs/KCBE.rss', 'http://weather.gov/data/current_obs/KCBE.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('KDMH', 'MD', 'Baltimore, Inner Harbor', '39.280000', '-76.610000', 'http://weather.noaa.gov/weather/current/KDMH.html', 'http://weather.gov/data/current_obs/KDMH.rss', 'http://weather.gov/data/current_obs/KDMH.xml'),
('KESN', 'MD', 'Easton/Newman Field Airport', '38.800000', '-76.067000', 'http://weather.noaa.gov/weather/current/KESN.html', 'http://weather.gov/data/current_obs/KESN.rss', 'http://weather.gov/data/current_obs/KESN.xml'),
('KFDK', 'MD', 'Frederick Municipal Airport', '39.418000', '-77.374000', 'http://weather.noaa.gov/weather/current/KFDK.html', 'http://weather.gov/data/current_obs/KFDK.rss', 'http://weather.gov/data/current_obs/KFDK.xml'),
('KFME', 'MD', 'Ft Meade/Tipton', '39.083000', '-76.767000', 'http://weather.noaa.gov/weather/current/KFME.html', 'http://weather.gov/data/current_obs/KFME.rss', 'http://weather.gov/data/current_obs/KFME.xml'),
('KHGR', 'MD', 'Hagerstown, Washington County Regional Airport', '39.710000', '-77.730000', 'http://weather.noaa.gov/weather/current/KHGR.html', 'http://weather.gov/data/current_obs/KHGR.rss', 'http://weather.gov/data/current_obs/KHGR.xml'),
('KMTN', 'MD', 'Baltimore / Martin', '39.340000', '-76.420000', 'http://weather.noaa.gov/weather/current/KMTN.html', 'http://weather.gov/data/current_obs/KMTN.rss', 'http://weather.gov/data/current_obs/KMTN.xml'),
('KNAK', 'MD', 'Annapolis (U.S. Naval Academy)', '38.980000', '-76.480000', 'http://weather.noaa.gov/weather/current/KNAK.html', 'http://weather.gov/data/current_obs/KNAK.rss', 'http://weather.gov/data/current_obs/KNAK.xml'),
('KNHK', 'MD', 'Patuxent River, Naval Air Station', '38.290000', '-76.400000', 'http://weather.noaa.gov/weather/current/KNHK.html', 'http://weather.gov/data/current_obs/KNHK.rss', 'http://weather.gov/data/current_obs/KNHK.xml'),
('KOXB', 'MD', 'Ocean City Municipal Airport', '38.308000', '-75.124000', 'http://weather.noaa.gov/weather/current/KOXB.html', 'http://weather.gov/data/current_obs/KOXB.rss', 'http://weather.gov/data/current_obs/KOXB.xml'),
('KSBY', 'MD', 'Salisbury-Wicomico County Regional Airport', '38.340000', '-75.500000', 'http://weather.noaa.gov/weather/current/KSBY.html', 'http://weather.gov/data/current_obs/KSBY.rss', 'http://weather.gov/data/current_obs/KSBY.xml'),
('K40B', 'ME', 'Clayton Lake', '46.617000', '-69.533000', 'http://weather.noaa.gov/weather/current/K40B.html', 'http://weather.gov/data/current_obs/K40B.rss', 'http://weather.gov/data/current_obs/K40B.xml'),
('KAUG', 'ME', 'Augusta State Airport', '44.320000', '-69.800000', 'http://weather.noaa.gov/weather/current/KAUG.html', 'http://weather.gov/data/current_obs/KAUG.rss', 'http://weather.gov/data/current_obs/KAUG.xml'),
('KBGR', 'ME', 'Bangor International Airport', '44.810000', '-68.830000', 'http://weather.noaa.gov/weather/current/KBGR.html', 'http://weather.gov/data/current_obs/KBGR.rss', 'http://weather.gov/data/current_obs/KBGR.xml'),
('KBHB', 'ME', 'Bar Harbor Automatic Weather Observing / Reporting', '44.460000', '-68.370000', 'http://weather.noaa.gov/weather/current/KBHB.html', 'http://weather.gov/data/current_obs/KBHB.rss', 'http://weather.gov/data/current_obs/KBHB.xml'),
('KCAR', 'ME', 'Caribou Municipal Airport', '46.880000', '-68.020000', 'http://weather.noaa.gov/weather/current/KCAR.html', 'http://weather.gov/data/current_obs/KCAR.rss', 'http://weather.gov/data/current_obs/KCAR.xml'),
('KFVE', 'ME', 'Frenchville, Northern Aroostook Regional Airport', '47.290000', '-68.320000', 'http://weather.noaa.gov/weather/current/KFVE.html', 'http://weather.gov/data/current_obs/KFVE.rss', 'http://weather.gov/data/current_obs/KFVE.xml'),
('KGNR', 'ME', 'Greenville', '45.462000', '-69.595000', 'http://weather.noaa.gov/weather/current/KGNR.html', 'http://weather.gov/data/current_obs/KGNR.rss', 'http://weather.gov/data/current_obs/KGNR.xml'),
('KHUL', 'ME', 'Houlton International Airport', '46.140000', '-67.780000', 'http://weather.noaa.gov/weather/current/KHUL.html', 'http://weather.gov/data/current_obs/KHUL.rss', 'http://weather.gov/data/current_obs/KHUL.xml'),
('KIWI', 'ME', 'Wiscasset Airport', '43.950000', '-69.700000', 'http://weather.noaa.gov/weather/current/KIWI.html', 'http://weather.gov/data/current_obs/KIWI.rss', 'http://weather.gov/data/current_obs/KIWI.xml'),
('KIZG', 'ME', 'Fryeburg, Eastern Slopes Regional Airport', '43.980000', '-70.950000', 'http://weather.noaa.gov/weather/current/KIZG.html', 'http://weather.gov/data/current_obs/KIZG.rss', 'http://weather.gov/data/current_obs/KIZG.xml'),
('KLEW', 'ME', 'Auburn-Lewiston', '44.050000', '-70.290000', 'http://weather.noaa.gov/weather/current/KLEW.html', 'http://weather.gov/data/current_obs/KLEW.rss', 'http://weather.gov/data/current_obs/KLEW.xml'),
('KMLT', 'ME', 'Millinocket Municipal Airport', '45.660000', '-68.680000', 'http://weather.noaa.gov/weather/current/KMLT.html', 'http://weather.gov/data/current_obs/KMLT.rss', 'http://weather.gov/data/current_obs/KMLT.xml'),
('KNHZ', 'ME', 'Brunswick, Naval Air Station', '43.890000', '-69.930000', 'http://weather.noaa.gov/weather/current/KNHZ.html', 'http://weather.gov/data/current_obs/KNHZ.rss', 'http://weather.gov/data/current_obs/KNHZ.xml'),
('KOLD', 'ME', 'Old Town / Dewitt Field Airport', '44.950000', '-68.667000', 'http://weather.noaa.gov/weather/current/KOLD.html', 'http://weather.gov/data/current_obs/KOLD.rss', 'http://weather.gov/data/current_obs/KOLD.xml'),
('KPQI', 'ME', 'Presque Isle', '46.690000', '-68.050000', 'http://weather.noaa.gov/weather/current/KPQI.html', 'http://weather.gov/data/current_obs/KPQI.rss', 'http://weather.gov/data/current_obs/KPQI.xml'),
('KPWM', 'ME', 'Portland International Jetport', '43.660000', '-70.320000', 'http://weather.noaa.gov/weather/current/KPWM.html', 'http://weather.gov/data/current_obs/KPWM.rss', 'http://weather.gov/data/current_obs/KPWM.xml'),
('KRKD', 'ME', 'Rockland / Knox Automatic Weather Observing', '44.080000', '-69.120000', 'http://weather.noaa.gov/weather/current/KRKD.html', 'http://weather.gov/data/current_obs/KRKD.rss', 'http://weather.gov/data/current_obs/KRKD.xml'),
('KSFM', 'ME', 'Sanford Municipal Automatic Weather Observing', '43.400000', '-70.700000', 'http://weather.noaa.gov/weather/current/KSFM.html', 'http://weather.gov/data/current_obs/KSFM.rss', 'http://weather.gov/data/current_obs/KSFM.xml'),
('KWVL', 'ME', 'Waterville Automatic Weather Observing / Reporting', '44.540000', '-69.690000', 'http://weather.noaa.gov/weather/current/KWVL.html', 'http://weather.gov/data/current_obs/KWVL.rss', 'http://weather.gov/data/current_obs/KWVL.xml'),
('KGYX', 'ME', 'Portland', '43.883000', '-70.250000', 'http://weather.noaa.gov/weather/current/KGYX.html', 'http://weather.gov/data/current_obs/KGYX.rss', 'http://weather.gov/data/current_obs/KGYX.xml'),
('PKMJ', 'MH', 'Marjuro WSO AP', '7.083000', '171.383000', 'http://weather.noaa.gov/weather/current/PKMJ.html', 'http://weather.gov/data/current_obs/PKMJ.rss', 'http://weather.gov/data/current_obs/PKMJ.xml'),
('PKMR', 'MH', 'Majuro Atoll', '7.060000', '171.270000', 'http://weather.noaa.gov/weather/current/PKMR.html', 'http://weather.gov/data/current_obs/PKMR.rss', 'http://weather.gov/data/current_obs/PKMR.xml'),
('PKWA', 'MH', 'Kwajalein Atoll', '8.733000', '167.733000', 'http://weather.noaa.gov/weather/current/PKWA.html', 'http://weather.gov/data/current_obs/PKWA.rss', 'http://weather.gov/data/current_obs/PKWA.xml'),
('K78D', 'MI', 'Caro', '43.450000', '-83.450000', 'http://weather.noaa.gov/weather/current/K78D.html', 'http://weather.gov/data/current_obs/K78D.rss', 'http://weather.gov/data/current_obs/K78D.xml'),
('K7D2', 'MI', 'Troy', '42.550000', '-83.183000', 'http://weather.noaa.gov/weather/current/K7D2.html', 'http://weather.gov/data/current_obs/K7D2.rss', 'http://weather.gov/data/current_obs/K7D2.xml'),
('KFKS', 'MI', 'Frankfort', '44.617000', '-86.200000', 'http://weather.noaa.gov/weather/current/KFKS.html', 'http://weather.gov/data/current_obs/KFKS.rss', 'http://weather.gov/data/current_obs/KFKS.xml'),
('KHAI', 'MI', 'Three Rivers Municipal Dr Haines Airport', '41.959000', '-85.590000', 'http://weather.noaa.gov/weather/current/KHAI.html', 'http://weather.gov/data/current_obs/KHAI.rss', 'http://weather.gov/data/current_obs/KHAI.xml'),
('KIMT', 'MI', 'Iron Mountain / Kingsford, Ford Airport', '45.810000', '-88.110000', 'http://weather.noaa.gov/weather/current/KIMT.html', 'http://weather.gov/data/current_obs/KIMT.rss', 'http://weather.gov/data/current_obs/KIMT.xml'),
('KIWD', 'MI', 'Ironwood Automatic Weather Observing / Reporting', '46.540000', '-90.130000', 'http://weather.noaa.gov/weather/current/KIWD.html', 'http://weather.gov/data/current_obs/KIWD.rss', 'http://weather.gov/data/current_obs/KIWD.xml'),
('KMNM', 'MI', 'Menominee Automatic Weather Observing / Reporting', '45.120000', '-87.630000', 'http://weather.noaa.gov/weather/current/KMNM.html', 'http://weather.gov/data/current_obs/KMNM.rss', 'http://weather.gov/data/current_obs/KMNM.xml'),
('KONZ', 'MI', 'Grosse Ile Municipal Airport', '42.100000', '-83.160000', 'http://weather.noaa.gov/weather/current/KONZ.html', 'http://weather.gov/data/current_obs/KONZ.rss', 'http://weather.gov/data/current_obs/KONZ.xml'),
('KACB', 'MI', 'Bellaire, Antrim County Airport', '44.990000', '-85.200000', 'http://weather.noaa.gov/weather/current/KACB.html', 'http://weather.gov/data/current_obs/KACB.rss', 'http://weather.gov/data/current_obs/KACB.xml'),
('KADG', 'MI', 'Adrian, Lenawee County Airport', '41.870000', '-84.070000', 'http://weather.noaa.gov/weather/current/KADG.html', 'http://weather.gov/data/current_obs/KADG.rss', 'http://weather.gov/data/current_obs/KADG.xml'),
('KAMN', 'MI', 'Alma, Gratiot Community Airport', '43.320000', '-84.690000', 'http://weather.noaa.gov/weather/current/KAMN.html', 'http://weather.gov/data/current_obs/KAMN.rss', 'http://weather.gov/data/current_obs/KAMN.xml'),
('KANJ', 'MI', 'Sault Ste. Marie', '46.485000', '-84.366000', 'http://weather.noaa.gov/weather/current/KANJ.html', 'http://weather.gov/data/current_obs/KANJ.rss', 'http://weather.gov/data/current_obs/KANJ.xml'),
('KAPN', 'MI', 'Alpena County Regional Airport', '45.080000', '-83.570000', 'http://weather.noaa.gov/weather/current/KAPN.html', 'http://weather.gov/data/current_obs/KAPN.rss', 'http://weather.gov/data/current_obs/KAPN.xml'),
('KARB', 'MI', 'Ann Arbor Municipal Airport', '42.220000', '-83.750000', 'http://weather.noaa.gov/weather/current/KARB.html', 'http://weather.gov/data/current_obs/KARB.rss', 'http://weather.gov/data/current_obs/KARB.xml'),
('KAZO', 'MI', 'Kalamazoo / Battle Creek International', '42.240000', '-85.550000', 'http://weather.noaa.gov/weather/current/KAZO.html', 'http://weather.gov/data/current_obs/KAZO.rss', 'http://weather.gov/data/current_obs/KAZO.xml'),
('KBAX', 'MI', 'Bad Axe, Huron County Memorial Airport', '43.790000', '-82.990000', 'http://weather.noaa.gov/weather/current/KBAX.html', 'http://weather.gov/data/current_obs/KBAX.rss', 'http://weather.gov/data/current_obs/KBAX.xml'),
('KBEH', 'MI', 'Benton Harbor, Southwest Michigan Regional Airport', '42.140000', '-86.440000', 'http://weather.noaa.gov/weather/current/KBEH.html', 'http://weather.gov/data/current_obs/KBEH.rss', 'http://weather.gov/data/current_obs/KBEH.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('KBIV', 'MI', 'Holland, Tulip City Airport', '42.750000', '-86.100000', 'http://weather.noaa.gov/weather/current/KBIV.html', 'http://weather.gov/data/current_obs/KBIV.rss', 'http://weather.gov/data/current_obs/KBIV.xml'),
('KBTL', 'MI', 'Battle Creek, Kellogg Airport', '42.300000', '-85.250000', 'http://weather.noaa.gov/weather/current/KBTL.html', 'http://weather.gov/data/current_obs/KBTL.rss', 'http://weather.gov/data/current_obs/KBTL.xml'),
('KCAD', 'MI', 'Cadillac / Wexford County', '44.290000', '-85.420000', 'http://weather.noaa.gov/weather/current/KCAD.html', 'http://weather.gov/data/current_obs/KCAD.rss', 'http://weather.gov/data/current_obs/KCAD.xml'),
('KCFS', 'MI', 'Caro', '43.459000', '-83.445000', 'http://weather.noaa.gov/weather/current/KCFS.html', 'http://weather.gov/data/current_obs/KCFS.rss', 'http://weather.gov/data/current_obs/KCFS.xml'),
('KCIU', 'MI', 'Chippewa International Automatic Weather Observing', '46.260000', '-84.470000', 'http://weather.noaa.gov/weather/current/KCIU.html', 'http://weather.gov/data/current_obs/KCIU.rss', 'http://weather.gov/data/current_obs/KCIU.xml'),
('KCMX', 'MI', 'Hancock, Houghton County Memorial Airport', '47.180000', '-88.500000', 'http://weather.noaa.gov/weather/current/KCMX.html', 'http://weather.gov/data/current_obs/KCMX.rss', 'http://weather.gov/data/current_obs/KCMX.xml'),
('KCVX', 'MI', 'Charlevoix Municipal Airport', '45.300000', '-85.270000', 'http://weather.noaa.gov/weather/current/KCVX.html', 'http://weather.gov/data/current_obs/KCVX.rss', 'http://weather.gov/data/current_obs/KCVX.xml'),
('KDET', 'MI', 'Detroit City Airport', '42.430000', '-83.020000', 'http://weather.noaa.gov/weather/current/KDET.html', 'http://weather.gov/data/current_obs/KDET.rss', 'http://weather.gov/data/current_obs/KDET.xml'),
('KDTW', 'MI', 'Detroit Metropolitan Wayne County Airport', '42.230000', '-83.330000', 'http://weather.noaa.gov/weather/current/KDTW.html', 'http://weather.gov/data/current_obs/KDTW.rss', 'http://weather.gov/data/current_obs/KDTW.xml'),
('KDUH', 'MI', 'Toledo Suburban Airport', '41.730000', '-83.650000', 'http://weather.noaa.gov/weather/current/KDUH.html', 'http://weather.gov/data/current_obs/KDUH.rss', 'http://weather.gov/data/current_obs/KDUH.xml'),
('KERY', 'MI', 'Newberry, Luce County Airport', '46.310000', '-85.460000', 'http://weather.noaa.gov/weather/current/KERY.html', 'http://weather.gov/data/current_obs/KERY.rss', 'http://weather.gov/data/current_obs/KERY.xml'),
('KESC', 'MI', 'Escanaba-Delta County Airport', '45.730000', '-87.080000', 'http://weather.noaa.gov/weather/current/KESC.html', 'http://weather.gov/data/current_obs/KESC.rss', 'http://weather.gov/data/current_obs/KESC.xml'),
('KFNT', 'MI', 'Flint, Bishop International Airport', '42.980000', '-83.730000', 'http://weather.noaa.gov/weather/current/KFNT.html', 'http://weather.gov/data/current_obs/KFNT.rss', 'http://weather.gov/data/current_obs/KFNT.xml'),
('KFPK', 'MI', 'Fitch Beach Airport', '42.570000', '-84.810000', 'http://weather.noaa.gov/weather/current/KFPK.html', 'http://weather.gov/data/current_obs/KFPK.rss', 'http://weather.gov/data/current_obs/KFPK.xml'),
('KGLR', 'MI', 'Gaylord, Otsego County Airport', '45.024000', '-84.678000', 'http://weather.noaa.gov/weather/current/KGLR.html', 'http://weather.gov/data/current_obs/KGLR.rss', 'http://weather.gov/data/current_obs/KGLR.xml'),
('KGOV', 'MI', 'Grayling AAF Airport', '44.680000', '-84.720000', 'http://weather.noaa.gov/weather/current/KGOV.html', 'http://weather.gov/data/current_obs/KGOV.rss', 'http://weather.gov/data/current_obs/KGOV.xml'),
('KGRR', 'MI', 'Grand Rapids, Gerald R. Ford International Airport', '42.890000', '-85.520000', 'http://weather.noaa.gov/weather/current/KGRR.html', 'http://weather.gov/data/current_obs/KGRR.rss', 'http://weather.gov/data/current_obs/KGRR.xml'),
('KHTL', 'MI', 'Houghton Lake, Roscommon County Airport', '44.380000', '-84.680000', 'http://weather.noaa.gov/weather/current/KHTL.html', 'http://weather.gov/data/current_obs/KHTL.rss', 'http://weather.gov/data/current_obs/KHTL.xml'),
('KHYX', 'MI', 'Saginaw County H.W. Browne Airport', '43.433000', '-83.862000', 'http://weather.noaa.gov/weather/current/KHYX.html', 'http://weather.gov/data/current_obs/KHYX.rss', 'http://weather.gov/data/current_obs/KHYX.xml'),
('KIRS', 'MI', 'Sturgis, Kirsch Municipal Airport', '41.810000', '-85.440000', 'http://weather.noaa.gov/weather/current/KIRS.html', 'http://weather.gov/data/current_obs/KIRS.rss', 'http://weather.gov/data/current_obs/KIRS.xml'),
('KISQ', 'MI', 'Manistique, Schoolcraft County Airport', '45.970000', '-86.170000', 'http://weather.noaa.gov/weather/current/KISQ.html', 'http://weather.gov/data/current_obs/KISQ.rss', 'http://weather.gov/data/current_obs/KISQ.xml'),
('KJXN', 'MI', 'Jackson County-Reynolds Field Airport', '42.270000', '-84.470000', 'http://weather.noaa.gov/weather/current/KJXN.html', 'http://weather.gov/data/current_obs/KJXN.rss', 'http://weather.gov/data/current_obs/KJXN.xml'),
('KJYM', 'MI', 'Hillsdale Municipal Airport', '41.921000', '-84.586000', 'http://weather.noaa.gov/weather/current/KJYM.html', 'http://weather.gov/data/current_obs/KJYM.rss', 'http://weather.gov/data/current_obs/KJYM.xml'),
('KLAN', 'MI', 'Lansing, Capital City Airport', '42.780000', '-84.600000', 'http://weather.noaa.gov/weather/current/KLAN.html', 'http://weather.gov/data/current_obs/KLAN.rss', 'http://weather.gov/data/current_obs/KLAN.xml'),
('KLDM', 'MI', 'Ludington, Mason County Airport', '43.960000', '-86.410000', 'http://weather.noaa.gov/weather/current/KLDM.html', 'http://weather.gov/data/current_obs/KLDM.rss', 'http://weather.gov/data/current_obs/KLDM.xml'),
('KLWA', 'MI', 'South Haven', '42.351000', '-86.256000', 'http://weather.noaa.gov/weather/current/KLWA.html', 'http://weather.gov/data/current_obs/KLWA.rss', 'http://weather.gov/data/current_obs/KLWA.xml'),
('KMBL', 'MI', 'Manistee County-Blacker Airport', '44.280000', '-86.250000', 'http://weather.noaa.gov/weather/current/KMBL.html', 'http://weather.gov/data/current_obs/KMBL.rss', 'http://weather.gov/data/current_obs/KMBL.xml'),
('KMBS', 'MI', 'Saginaw, MBS International Airport', '43.530000', '-84.080000', 'http://weather.noaa.gov/weather/current/KMBS.html', 'http://weather.gov/data/current_obs/KMBS.rss', 'http://weather.gov/data/current_obs/KMBS.xml'),
('KMCD', 'MI', 'Mackinac Island Airport', '45.860000', '-84.640000', 'http://weather.noaa.gov/weather/current/KMCD.html', 'http://weather.gov/data/current_obs/KMCD.rss', 'http://weather.gov/data/current_obs/KMCD.xml'),
('KMGN', 'MI', 'Harbor Springs Airport', '45.420000', '-84.910000', 'http://weather.noaa.gov/weather/current/KMGN.html', 'http://weather.gov/data/current_obs/KMGN.rss', 'http://weather.gov/data/current_obs/KMGN.xml'),
('KMKG', 'MI', 'Muskegon County Airport', '43.180000', '-86.270000', 'http://weather.noaa.gov/weather/current/KMKG.html', 'http://weather.gov/data/current_obs/KMKG.rss', 'http://weather.gov/data/current_obs/KMKG.xml'),
('KMOP', 'MI', 'Mount Pleasant Municipal Airport', '43.620000', '-84.740000', 'http://weather.noaa.gov/weather/current/KMOP.html', 'http://weather.gov/data/current_obs/KMOP.rss', 'http://weather.gov/data/current_obs/KMOP.xml'),
('KMQT', 'MI', 'Marquette', '46.533000', '-87.550000', 'http://weather.noaa.gov/weather/current/KMQT.html', 'http://weather.gov/data/current_obs/KMQT.rss', 'http://weather.gov/data/current_obs/KMQT.xml'),
('KMTC', 'MI', 'Selfridge Air National Guard Base', '42.620000', '-82.840000', 'http://weather.noaa.gov/weather/current/KMTC.html', 'http://weather.gov/data/current_obs/KMTC.rss', 'http://weather.gov/data/current_obs/KMTC.xml'),
('KOEB', 'MI', 'Coldwater, Branch County Memorial Airport', '41.930000', '-85.050000', 'http://weather.noaa.gov/weather/current/KOEB.html', 'http://weather.gov/data/current_obs/KOEB.rss', 'http://weather.gov/data/current_obs/KOEB.xml'),
('KOSC', 'MI', 'Oscoda-Wurtsmith Airport', '44.460000', '-83.400000', 'http://weather.noaa.gov/weather/current/KOSC.html', 'http://weather.gov/data/current_obs/KOSC.rss', 'http://weather.gov/data/current_obs/KOSC.xml'),
('KOZW', 'MI', 'Howell, Livingston County Airport', '42.630000', '-83.980000', 'http://weather.noaa.gov/weather/current/KOZW.html', 'http://weather.gov/data/current_obs/KOZW.rss', 'http://weather.gov/data/current_obs/KOZW.xml'),
('KP53', 'MI', 'Munising', '46.400000', '-86.650000', 'http://weather.noaa.gov/weather/current/KP53.html', 'http://weather.gov/data/current_obs/KP53.rss', 'http://weather.gov/data/current_obs/KP53.xml'),
('KP58', 'MI', 'Port Hope', '44.022000', '-82.793000', 'http://weather.noaa.gov/weather/current/KP58.html', 'http://weather.gov/data/current_obs/KP58.rss', 'http://weather.gov/data/current_obs/KP58.xml'),
('KP59', 'MI', 'Copper Harbor', '47.450000', '-87.900000', 'http://weather.noaa.gov/weather/current/KP59.html', 'http://weather.gov/data/current_obs/KP59.rss', 'http://weather.gov/data/current_obs/KP59.xml'),
('KP75', 'MI', 'Marquette', '45.930000', '-85.920000', 'http://weather.noaa.gov/weather/current/KP75.html', 'http://weather.gov/data/current_obs/KP75.rss', 'http://weather.gov/data/current_obs/KP75.xml'),
('KPHN', 'MI', 'St. Clair County International', '42.920000', '-82.530000', 'http://weather.noaa.gov/weather/current/KPHN.html', 'http://weather.gov/data/current_obs/KPHN.rss', 'http://weather.gov/data/current_obs/KPHN.xml'),
('KPLN', 'MI', 'Pellston Regional Airport of Emmet County', '45.580000', '-84.800000', 'http://weather.noaa.gov/weather/current/KPLN.html', 'http://weather.gov/data/current_obs/KPLN.rss', 'http://weather.gov/data/current_obs/KPLN.xml'),
('KPTK', 'MI', 'Pontiac, Oakland County International Airport', '42.670000', '-83.420000', 'http://weather.noaa.gov/weather/current/KPTK.html', 'http://weather.gov/data/current_obs/KPTK.rss', 'http://weather.gov/data/current_obs/KPTK.xml'),
('KPZQ', 'MI', 'Presque Isle County Airport', '45.400000', '-83.817000', 'http://weather.noaa.gov/weather/current/KPZQ.html', 'http://weather.gov/data/current_obs/KPZQ.rss', 'http://weather.gov/data/current_obs/KPZQ.xml'),
('KRMY', 'MI', 'Marshall, Brooks Field Airport', '42.240000', '-84.960000', 'http://weather.noaa.gov/weather/current/KRMY.html', 'http://weather.gov/data/current_obs/KRMY.rss', 'http://weather.gov/data/current_obs/KRMY.xml'),
('KRNP', 'MI', 'Owosso Community Airport', '42.993000', '-84.139000', 'http://weather.noaa.gov/weather/current/KRNP.html', 'http://weather.gov/data/current_obs/KRNP.rss', 'http://weather.gov/data/current_obs/KRNP.xml'),
('KRQB', 'MI', 'Big Rapids, Roben-Hood Airport', '43.720000', '-85.500000', 'http://weather.noaa.gov/weather/current/KRQB.html', 'http://weather.gov/data/current_obs/KRQB.rss', 'http://weather.gov/data/current_obs/KRQB.xml'),
('KSAW', 'MI', 'Gwinn, Sawyer Airport', '46.354000', '-87.394000', 'http://weather.noaa.gov/weather/current/KSAW.html', 'http://weather.gov/data/current_obs/KSAW.rss', 'http://weather.gov/data/current_obs/KSAW.xml'),
('KSJX', 'MI', 'Beaver Island Airport', '45.700000', '-85.570000', 'http://weather.noaa.gov/weather/current/KSJX.html', 'http://weather.gov/data/current_obs/KSJX.rss', 'http://weather.gov/data/current_obs/KSJX.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('KSLH', 'MI', 'Cheboygan Co Airport', '45.650000', '-84.520000', 'http://weather.noaa.gov/weather/current/KSLH.html', 'http://weather.gov/data/current_obs/KSLH.rss', 'http://weather.gov/data/current_obs/KSLH.xml'),
('KTEW', 'MI', 'Mason Jewett Field Airport', '42.570000', '-84.420000', 'http://weather.noaa.gov/weather/current/KTEW.html', 'http://weather.gov/data/current_obs/KTEW.rss', 'http://weather.gov/data/current_obs/KTEW.xml'),
('KTTF', 'MI', 'Monroe, Custer Airport', '41.940000', '-83.430000', 'http://weather.noaa.gov/weather/current/KTTF.html', 'http://weather.gov/data/current_obs/KTTF.rss', 'http://weather.gov/data/current_obs/KTTF.xml'),
('KTVC', 'MI', 'Traverse City, Cherry Capital Airport', '44.730000', '-85.580000', 'http://weather.noaa.gov/weather/current/KTVC.html', 'http://weather.gov/data/current_obs/KTVC.rss', 'http://weather.gov/data/current_obs/KTVC.xml'),
('KVLL', 'MI', 'Troy', '42.543000', '-83.178000', 'http://weather.noaa.gov/weather/current/KVLL.html', 'http://weather.gov/data/current_obs/KVLL.rss', 'http://weather.gov/data/current_obs/KVLL.xml'),
('KYIP', 'MI', 'Detroit, Willow Run Airport', '42.230000', '-83.530000', 'http://weather.noaa.gov/weather/current/KYIP.html', 'http://weather.gov/data/current_obs/KYIP.rss', 'http://weather.gov/data/current_obs/KYIP.xml'),
('KACQ', 'MN', 'Waseca Muni Airport', '44.070000', '-93.550000', 'http://weather.noaa.gov/weather/current/KACQ.html', 'http://weather.gov/data/current_obs/KACQ.rss', 'http://weather.gov/data/current_obs/KACQ.xml'),
('KADC', 'MN', 'Wadena Municipal Airport', '46.447000', '-95.212000', 'http://weather.noaa.gov/weather/current/KADC.html', 'http://weather.gov/data/current_obs/KADC.rss', 'http://weather.gov/data/current_obs/KADC.xml'),
('KAEL', 'MN', 'Albert Lea Automatic Weather Observing / Reporting', '43.690000', '-93.370000', 'http://weather.noaa.gov/weather/current/KAEL.html', 'http://weather.gov/data/current_obs/KAEL.rss', 'http://weather.gov/data/current_obs/KAEL.xml'),
('KAIT', 'MN', 'Aitkin NDB Automatic Weather Observing / Reporting', '46.550000', '-93.690000', 'http://weather.noaa.gov/weather/current/KAIT.html', 'http://weather.gov/data/current_obs/KAIT.rss', 'http://weather.gov/data/current_obs/KAIT.xml'),
('KANE', 'MN', 'Minneapolis / Blaine', '45.160000', '-93.220000', 'http://weather.noaa.gov/weather/current/KANE.html', 'http://weather.gov/data/current_obs/KANE.rss', 'http://weather.gov/data/current_obs/KANE.xml'),
('KAQP', 'MN', 'Appleton Municipal Airport', '45.230000', '-96.000000', 'http://weather.noaa.gov/weather/current/KAQP.html', 'http://weather.gov/data/current_obs/KAQP.rss', 'http://weather.gov/data/current_obs/KAQP.xml'),
('KAUM', 'MN', 'Austin Municipal', '43.670000', '-92.940000', 'http://weather.noaa.gov/weather/current/KAUM.html', 'http://weather.gov/data/current_obs/KAUM.rss', 'http://weather.gov/data/current_obs/KAUM.xml'),
('KAXN', 'MN', 'Alexandria, Chandler Field', '45.870000', '-95.410000', 'http://weather.noaa.gov/weather/current/KAXN.html', 'http://weather.gov/data/current_obs/KAXN.rss', 'http://weather.gov/data/current_obs/KAXN.xml'),
('KBBB', 'MN', 'Benson Municipal', '45.320000', '-95.650000', 'http://weather.noaa.gov/weather/current/KBBB.html', 'http://weather.gov/data/current_obs/KBBB.rss', 'http://weather.gov/data/current_obs/KBBB.xml'),
('KBDE', 'MN', 'Baudette International Airport', '48.730000', '-94.600000', 'http://weather.noaa.gov/weather/current/KBDE.html', 'http://weather.gov/data/current_obs/KBDE.rss', 'http://weather.gov/data/current_obs/KBDE.xml'),
('KBDH', 'MN', 'Willmar Municipal Airport', '45.120000', '-95.130000', 'http://weather.noaa.gov/weather/current/KBDH.html', 'http://weather.gov/data/current_obs/KBDH.rss', 'http://weather.gov/data/current_obs/KBDH.xml'),
('KBFW', 'MN', 'Silver Bay', '47.210000', '-91.410000', 'http://weather.noaa.gov/weather/current/KBFW.html', 'http://weather.gov/data/current_obs/KBFW.rss', 'http://weather.gov/data/current_obs/KBFW.xml'),
('KBJI', 'MN', 'Bemidji', '47.510000', '-94.930000', 'http://weather.noaa.gov/weather/current/KBJI.html', 'http://weather.gov/data/current_obs/KBJI.rss', 'http://weather.gov/data/current_obs/KBJI.xml'),
('KBRD', 'MN', 'Brainerd-Crow Wing County Regional Airport', '46.400000', '-94.130000', 'http://weather.noaa.gov/weather/current/KBRD.html', 'http://weather.gov/data/current_obs/KBRD.rss', 'http://weather.gov/data/current_obs/KBRD.xml'),
('KCBG', 'MN', 'Cambridge Municipal', '45.570000', '-93.270000', 'http://weather.noaa.gov/weather/current/KCBG.html', 'http://weather.gov/data/current_obs/KCBG.rss', 'http://weather.gov/data/current_obs/KCBG.xml'),
('KCDD', 'MN', 'Crane Lake, Scotts Seaplane Base', '48.270000', '-92.570000', 'http://weather.noaa.gov/weather/current/KCDD.html', 'http://weather.gov/data/current_obs/KCDD.rss', 'http://weather.gov/data/current_obs/KCDD.xml'),
('KCKC', 'MN', 'Grand Marais/Cook County Airport', '47.840000', '-90.380000', 'http://weather.noaa.gov/weather/current/KCKC.html', 'http://weather.gov/data/current_obs/KCKC.rss', 'http://weather.gov/data/current_obs/KCKC.xml'),
('KCKN', 'MN', 'Crookston Municipal Field', '47.860000', '-96.620000', 'http://weather.noaa.gov/weather/current/KCKN.html', 'http://weather.gov/data/current_obs/KCKN.rss', 'http://weather.gov/data/current_obs/KCKN.xml'),
('KCNB', 'MN', 'Canby Myers Field Airport', '44.720000', '-96.260000', 'http://weather.noaa.gov/weather/current/KCNB.html', 'http://weather.gov/data/current_obs/KCNB.rss', 'http://weather.gov/data/current_obs/KCNB.xml'),
('KCOQ', 'MN', 'Cloquet Automatic Weather Observing / Reporting', '46.710000', '-92.500000', 'http://weather.noaa.gov/weather/current/KCOQ.html', 'http://weather.gov/data/current_obs/KCOQ.rss', 'http://weather.gov/data/current_obs/KCOQ.xml'),
('KCQM', 'MN', 'Cook Municipal Airport', '47.820000', '-92.690000', 'http://weather.noaa.gov/weather/current/KCQM.html', 'http://weather.gov/data/current_obs/KCQM.rss', 'http://weather.gov/data/current_obs/KCQM.xml'),
('KDLH', 'MN', 'Duluth International Airport', '46.840000', '-92.180000', 'http://weather.noaa.gov/weather/current/KDLH.html', 'http://weather.gov/data/current_obs/KDLH.rss', 'http://weather.gov/data/current_obs/KDLH.xml'),
('KDTL', 'MN', 'Detroit Lakes Automatic Weather Observing / Report', '46.830000', '-95.880000', 'http://weather.noaa.gov/weather/current/KDTL.html', 'http://weather.gov/data/current_obs/KDTL.rss', 'http://weather.gov/data/current_obs/KDTL.xml'),
('KDVP', 'MN', 'Slayton Municipal Airport', '43.987000', '-95.783000', 'http://weather.noaa.gov/weather/current/KDVP.html', 'http://weather.gov/data/current_obs/KDVP.rss', 'http://weather.gov/data/current_obs/KDVP.xml'),
('KDXX', 'MN', 'Madison-Lac Qui Parle County Airport', '44.990000', '-96.180000', 'http://weather.noaa.gov/weather/current/KDXX.html', 'http://weather.gov/data/current_obs/KDXX.rss', 'http://weather.gov/data/current_obs/KDXX.xml'),
('KDYT', 'MN', 'Sky Harbor Airport', '46.720000', '-92.040000', 'http://weather.noaa.gov/weather/current/KDYT.html', 'http://weather.gov/data/current_obs/KDYT.rss', 'http://weather.gov/data/current_obs/KDYT.xml'),
('KELO', 'MN', 'Ely Municipal Automatic Weather Observing / Report', '47.910000', '-91.820000', 'http://weather.noaa.gov/weather/current/KELO.html', 'http://weather.gov/data/current_obs/KELO.rss', 'http://weather.gov/data/current_obs/KELO.xml'),
('KETH', 'MN', 'Wheaton NDB Automatic Weather Observing/Reporting', '45.710000', '-96.500000', 'http://weather.noaa.gov/weather/current/KETH.html', 'http://weather.gov/data/current_obs/KETH.rss', 'http://weather.gov/data/current_obs/KETH.xml'),
('KEVM', 'MN', 'Eveleth Municipal Automatic Weather Observing', '47.410000', '-92.500000', 'http://weather.noaa.gov/weather/current/KEVM.html', 'http://weather.gov/data/current_obs/KEVM.rss', 'http://weather.gov/data/current_obs/KEVM.xml'),
('KFBL', 'MN', 'Faribault Municipal Automatic Weather Observing', '44.340000', '-93.310000', 'http://weather.noaa.gov/weather/current/KFBL.html', 'http://weather.gov/data/current_obs/KFBL.rss', 'http://weather.gov/data/current_obs/KFBL.xml'),
('KFCM', 'MN', 'Minneapolis, Flying Cloud Airport', '44.840000', '-93.470000', 'http://weather.noaa.gov/weather/current/KFCM.html', 'http://weather.gov/data/current_obs/KFCM.rss', 'http://weather.gov/data/current_obs/KFCM.xml'),
('KFFM', 'MN', 'Fergus Falls Automatic Weather Observing/Reporting', '46.300000', '-96.070000', 'http://weather.noaa.gov/weather/current/KFFM.html', 'http://weather.gov/data/current_obs/KFFM.rss', 'http://weather.gov/data/current_obs/KFFM.xml'),
('KFGN', 'MN', 'Flag Island', '49.320000', '-94.880000', 'http://weather.noaa.gov/weather/current/KFGN.html', 'http://weather.gov/data/current_obs/KFGN.rss', 'http://weather.gov/data/current_obs/KFGN.xml'),
('KFKA', 'MN', 'Preston-Fillmore Co Airport', '43.677000', '-92.180000', 'http://weather.noaa.gov/weather/current/KFKA.html', 'http://weather.gov/data/current_obs/KFKA.rss', 'http://weather.gov/data/current_obs/KFKA.xml'),
('KFOZ', 'MN', 'Bigfork Municipal Airport', '47.780000', '-93.650000', 'http://weather.noaa.gov/weather/current/KFOZ.html', 'http://weather.gov/data/current_obs/KFOZ.rss', 'http://weather.gov/data/current_obs/KFOZ.xml'),
('KFRM', 'MN', 'Fairmont Municipal Automatic Weather Observing', '43.660000', '-94.420000', 'http://weather.noaa.gov/weather/current/KFRM.html', 'http://weather.gov/data/current_obs/KFRM.rss', 'http://weather.gov/data/current_obs/KFRM.xml'),
('KFSE', 'MN', 'Fosston Automatic Weather Observing/Reporting Sys', '47.593000', '-95.773000', 'http://weather.noaa.gov/weather/current/KFSE.html', 'http://weather.gov/data/current_obs/KFSE.rss', 'http://weather.gov/data/current_obs/KFSE.xml'),
('KGHW', 'MN', 'Glenwood Automatic Surface Observing System', '45.650000', '-95.320000', 'http://weather.noaa.gov/weather/current/KGHW.html', 'http://weather.gov/data/current_obs/KGHW.rss', 'http://weather.gov/data/current_obs/KGHW.xml'),
('KGNA', 'MN', 'The Bay of Grand Marais', '47.750000', '-90.340000', 'http://weather.noaa.gov/weather/current/KGNA.html', 'http://weather.gov/data/current_obs/KGNA.rss', 'http://weather.gov/data/current_obs/KGNA.xml'),
('KGPZ', 'MN', 'Grand Rapids Automatic Weather Observing/Reporting', '47.230000', '-93.520000', 'http://weather.noaa.gov/weather/current/KGPZ.html', 'http://weather.gov/data/current_obs/KGPZ.rss', 'http://weather.gov/data/current_obs/KGPZ.xml'),
('KGYL', 'MN', 'Glencoe Municipal Airport', '44.757000', '-94.082000', 'http://weather.noaa.gov/weather/current/KGYL.html', 'http://weather.gov/data/current_obs/KGYL.rss', 'http://weather.gov/data/current_obs/KGYL.xml'),
('KHCD', 'MN', 'Hutchinson Automatic Weather Observing / Reporting', '44.870000', '-94.390000', 'http://weather.noaa.gov/weather/current/KHCD.html', 'http://weather.gov/data/current_obs/KHCD.rss', 'http://weather.gov/data/current_obs/KHCD.xml'),
('KHCO', 'MN', 'Hallock Municipal Airport', '48.790000', '-96.950000', 'http://weather.noaa.gov/weather/current/KHCO.html', 'http://weather.gov/data/current_obs/KHCO.rss', 'http://weather.gov/data/current_obs/KHCO.xml'),
('KHIB', 'MN', 'Chisholm-Hibbing Airport', '47.390000', '-92.850000', 'http://weather.noaa.gov/weather/current/KHIB.html', 'http://weather.gov/data/current_obs/KHIB.rss', 'http://weather.gov/data/current_obs/KHIB.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('KHZX', 'MN', 'Isedor Iverson Airport', '46.617000', '-93.317000', 'http://weather.noaa.gov/weather/current/KHZX.html', 'http://weather.gov/data/current_obs/KHZX.rss', 'http://weather.gov/data/current_obs/KHZX.xml'),
('KILL', 'MN', 'Willmar / Rice Automatic Weather Observing/Report', '45.110000', '-95.090000', 'http://weather.noaa.gov/weather/current/KILL.html', 'http://weather.gov/data/current_obs/KILL.rss', 'http://weather.gov/data/current_obs/KILL.xml'),
('KINL', 'MN', 'Falls International Airport', '48.580000', '-93.380000', 'http://weather.noaa.gov/weather/current/KINL.html', 'http://weather.gov/data/current_obs/KINL.rss', 'http://weather.gov/data/current_obs/KINL.xml'),
('KJKJ', 'MN', 'Moorhead Municipal Airport', '46.840000', '-96.660000', 'http://weather.noaa.gov/weather/current/KJKJ.html', 'http://weather.gov/data/current_obs/KJKJ.rss', 'http://weather.gov/data/current_obs/KJKJ.xml'),
('KJMR', 'MN', 'Mora Municipal Airport', '45.890000', '-93.270000', 'http://weather.noaa.gov/weather/current/KJMR.html', 'http://weather.gov/data/current_obs/KJMR.rss', 'http://weather.gov/data/current_obs/KJMR.xml'),
('KJYG', 'MN', 'St. James Municipal Airport', '43.990000', '-94.560000', 'http://weather.noaa.gov/weather/current/KJYG.html', 'http://weather.gov/data/current_obs/KJYG.rss', 'http://weather.gov/data/current_obs/KJYG.xml'),
('KLJF', 'MN', 'Litchfield Municipal Airport', '45.140000', '-94.520000', 'http://weather.noaa.gov/weather/current/KLJF.html', 'http://weather.gov/data/current_obs/KLJF.rss', 'http://weather.gov/data/current_obs/KLJF.xml'),
('KLVN', 'MN', 'Minneapolis, Airlake Airport', '44.640000', '-93.240000', 'http://weather.noaa.gov/weather/current/KLVN.html', 'http://weather.gov/data/current_obs/KLVN.rss', 'http://weather.gov/data/current_obs/KLVN.xml'),
('KLXL', 'MN', 'Little Falls Automatic Weather Observing/Reporting', '45.960000', '-94.350000', 'http://weather.noaa.gov/weather/current/KLXL.html', 'http://weather.gov/data/current_obs/KLXL.rss', 'http://weather.gov/data/current_obs/KLXL.xml'),
('KLYV', 'MN', 'Luverne-Quentin Aanenson Field', '43.621000', '-96.216000', 'http://weather.noaa.gov/weather/current/KLYV.html', 'http://weather.gov/data/current_obs/KLYV.rss', 'http://weather.gov/data/current_obs/KLYV.xml'),
('KMGG', 'MN', 'Maple Lake Municipal Airport', '45.236000', '-93.986000', 'http://weather.noaa.gov/weather/current/KMGG.html', 'http://weather.gov/data/current_obs/KMGG.rss', 'http://weather.gov/data/current_obs/KMGG.xml'),
('KMIC', 'MN', 'Minneapolis, Crystal Airport', '45.080000', '-93.380000', 'http://weather.noaa.gov/weather/current/KMIC.html', 'http://weather.gov/data/current_obs/KMIC.rss', 'http://weather.gov/data/current_obs/KMIC.xml'),
('KMJQ', 'MN', 'Jackson Municipal Automatic Weather Observing', '43.660000', '-94.990000', 'http://weather.noaa.gov/weather/current/KMJQ.html', 'http://weather.gov/data/current_obs/KMJQ.rss', 'http://weather.gov/data/current_obs/KMJQ.xml'),
('KMKT', 'MN', 'Mankato Automatic Weather Observing / Reporting', '44.230000', '-93.920000', 'http://weather.noaa.gov/weather/current/KMKT.html', 'http://weather.gov/data/current_obs/KMKT.rss', 'http://weather.gov/data/current_obs/KMKT.xml'),
('KMML', 'MN', 'Marshall / Ryan Automatic Weather Observing', '44.460000', '-95.820000', 'http://weather.noaa.gov/weather/current/KMML.html', 'http://weather.gov/data/current_obs/KMML.rss', 'http://weather.gov/data/current_obs/KMML.xml'),
('KMOX', 'MN', 'Morris Municipal Automatic Weather Observing', '45.570000', '-95.970000', 'http://weather.noaa.gov/weather/current/KMOX.html', 'http://weather.gov/data/current_obs/KMOX.rss', 'http://weather.gov/data/current_obs/KMOX.xml'),
('KMSP', 'MN', 'Minneapolis-St. Paul International Airport', '44.890000', '-93.220000', 'http://weather.noaa.gov/weather/current/KMSP.html', 'http://weather.gov/data/current_obs/KMSP.rss', 'http://weather.gov/data/current_obs/KMSP.xml'),
('KMVE', 'MN', 'Montevideo Automatic Weather Observing / Reporting', '44.970000', '-95.720000', 'http://weather.noaa.gov/weather/current/KMVE.html', 'http://weather.gov/data/current_obs/KMVE.rss', 'http://weather.gov/data/current_obs/KMVE.xml'),
('KMWM', 'MN', 'Windom Municipal Airport', '43.910000', '-95.110000', 'http://weather.noaa.gov/weather/current/KMWM.html', 'http://weather.gov/data/current_obs/KMWM.rss', 'http://weather.gov/data/current_obs/KMWM.xml'),
('KMZH', 'MN', 'Moose Lake Carlton County Airport', '46.417000', '-92.800000', 'http://weather.noaa.gov/weather/current/KMZH.html', 'http://weather.gov/data/current_obs/KMZH.rss', 'http://weather.gov/data/current_obs/KMZH.xml'),
('KONA', 'MN', 'Winona Municipal Automatic Weather Observing', '44.090000', '-91.700000', 'http://weather.noaa.gov/weather/current/KONA.html', 'http://weather.gov/data/current_obs/KONA.rss', 'http://weather.gov/data/current_obs/KONA.xml'),
('KORB', 'MN', 'Orr', '48.020000', '-92.870000', 'http://weather.noaa.gov/weather/current/KORB.html', 'http://weather.gov/data/current_obs/KORB.rss', 'http://weather.gov/data/current_obs/KORB.xml'),
('KOTG', 'MN', 'Worthington Automatic Weather Observing/Reporting', '43.660000', '-95.580000', 'http://weather.noaa.gov/weather/current/KOTG.html', 'http://weather.gov/data/current_obs/KOTG.rss', 'http://weather.gov/data/current_obs/KOTG.xml'),
('KOVL', 'MN', 'Olivia Regional Airport', '44.780000', '-95.030000', 'http://weather.noaa.gov/weather/current/KOVL.html', 'http://weather.gov/data/current_obs/KOVL.rss', 'http://weather.gov/data/current_obs/KOVL.xml'),
('KOWA', 'MN', 'Owatonna Automatic Weather Observing / Reporting', '44.120000', '-93.250000', 'http://weather.noaa.gov/weather/current/KOWA.html', 'http://weather.gov/data/current_obs/KOWA.rss', 'http://weather.gov/data/current_obs/KOWA.xml'),
('KPKD', 'MN', 'Park Rapids Municipal Airport', '46.910000', '-95.070000', 'http://weather.noaa.gov/weather/current/KPKD.html', 'http://weather.gov/data/current_obs/KPKD.rss', 'http://weather.gov/data/current_obs/KPKD.xml'),
('KPNM', 'MN', 'Princeton', '45.560000', '-93.610000', 'http://weather.noaa.gov/weather/current/KPNM.html', 'http://weather.gov/data/current_obs/KPNM.rss', 'http://weather.gov/data/current_obs/KPNM.xml'),
('KPQN', 'MN', 'Pipestone Automatic Weather Observing / Reporting', '43.990000', '-96.320000', 'http://weather.noaa.gov/weather/current/KPQN.html', 'http://weather.gov/data/current_obs/KPQN.rss', 'http://weather.gov/data/current_obs/KPQN.xml'),
('KPWC', 'MN', 'Pine River Regional Airport', '46.720000', '-94.380000', 'http://weather.noaa.gov/weather/current/KPWC.html', 'http://weather.gov/data/current_obs/KPWC.rss', 'http://weather.gov/data/current_obs/KPWC.xml'),
('KRGK', 'MN', 'Red Wing Municipal Airport', '44.590000', '-92.490000', 'http://weather.noaa.gov/weather/current/KRGK.html', 'http://weather.gov/data/current_obs/KRGK.rss', 'http://weather.gov/data/current_obs/KRGK.xml'),
('KROS', 'MN', 'Rush City Regional Airport', '45.698000', '-92.953000', 'http://weather.noaa.gov/weather/current/KROS.html', 'http://weather.gov/data/current_obs/KROS.rss', 'http://weather.gov/data/current_obs/KROS.xml'),
('KROX', 'MN', 'Roseau Municipal Automatic Weather Observing', '48.860000', '-95.690000', 'http://weather.noaa.gov/weather/current/KROX.html', 'http://weather.gov/data/current_obs/KROX.rss', 'http://weather.gov/data/current_obs/KROX.xml'),
('KRRT', 'MN', 'Warroad International-Swede Carlson Field', '48.940000', '-95.350000', 'http://weather.noaa.gov/weather/current/KRRT.html', 'http://weather.gov/data/current_obs/KRRT.rss', 'http://weather.gov/data/current_obs/KRRT.xml'),
('KRST', 'MN', 'Rochester International Airport', '43.930000', '-92.500000', 'http://weather.noaa.gov/weather/current/KRST.html', 'http://weather.gov/data/current_obs/KRST.rss', 'http://weather.gov/data/current_obs/KRST.xml'),
('KRWF', 'MN', 'Redwood Falls Municipal Airport', '44.550000', '-95.080000', 'http://weather.noaa.gov/weather/current/KRWF.html', 'http://weather.gov/data/current_obs/KRWF.rss', 'http://weather.gov/data/current_obs/KRWF.xml'),
('KSAZ', 'MN', 'Staples Municipal Airport', '46.380000', '-94.810000', 'http://weather.noaa.gov/weather/current/KSAZ.html', 'http://weather.gov/data/current_obs/KSAZ.rss', 'http://weather.gov/data/current_obs/KSAZ.xml'),
('KSGS', 'MN', 'South St. Paul Municipal-Richard E', '44.850000', '-93.150000', 'http://weather.noaa.gov/weather/current/KSGS.html', 'http://weather.gov/data/current_obs/KSGS.rss', 'http://weather.gov/data/current_obs/KSGS.xml'),
('KSTC', 'MN', 'St. Cloud Regional Airport', '45.550000', '-94.070000', 'http://weather.noaa.gov/weather/current/KSTC.html', 'http://weather.gov/data/current_obs/KSTC.rss', 'http://weather.gov/data/current_obs/KSTC.xml'),
('KSTP', 'MN', 'St. Paul Downtown Holman Field', '44.940000', '-93.050000', 'http://weather.noaa.gov/weather/current/KSTP.html', 'http://weather.gov/data/current_obs/KSTP.rss', 'http://weather.gov/data/current_obs/KSTP.xml'),
('KSYN', 'MN', 'Stanton Airfield', '44.467000', '-93.017000', 'http://weather.noaa.gov/weather/current/KSYN.html', 'http://weather.gov/data/current_obs/KSYN.rss', 'http://weather.gov/data/current_obs/KSYN.xml'),
('KTKC', 'MN', 'Tracy Municipal Airport', '44.249000', '-95.607000', 'http://weather.noaa.gov/weather/current/KTKC.html', 'http://weather.gov/data/current_obs/KTKC.rss', 'http://weather.gov/data/current_obs/KTKC.xml'),
('KTOB', 'MN', 'Dodge Center Airport', '44.018000', '-92.831000', 'http://weather.noaa.gov/weather/current/KTOB.html', 'http://weather.gov/data/current_obs/KTOB.rss', 'http://weather.gov/data/current_obs/KTOB.xml'),
('KTVF', 'MN', 'Thief River Automatic Weather Observing/Reporting', '48.080000', '-96.180000', 'http://weather.noaa.gov/weather/current/KTVF.html', 'http://weather.gov/data/current_obs/KTVF.rss', 'http://weather.gov/data/current_obs/KTVF.xml'),
('KTWM', 'MN', 'Two Harbors', '47.050000', '-91.750000', 'http://weather.noaa.gov/weather/current/KTWM.html', 'http://weather.gov/data/current_obs/KTWM.rss', 'http://weather.gov/data/current_obs/KTWM.xml'),
('KULM', 'MN', 'New Ulm Municipal Automatic Weather Observing', '44.320000', '-94.500000', 'http://weather.noaa.gov/weather/current/KULM.html', 'http://weather.gov/data/current_obs/KULM.rss', 'http://weather.gov/data/current_obs/KULM.xml'),
('KVVV', 'MN', 'Ortonville Municipal-Martinson Field Airport', '45.310000', '-96.420000', 'http://weather.noaa.gov/weather/current/KVVV.html', 'http://weather.gov/data/current_obs/KVVV.rss', 'http://weather.gov/data/current_obs/KVVV.xml'),
('KVWU', 'MN', 'Waskish Municipal Airport', '48.150000', '-94.520000', 'http://weather.noaa.gov/weather/current/KVWU.html', 'http://weather.gov/data/current_obs/KVWU.rss', 'http://weather.gov/data/current_obs/KVWU.xml'),
('KXVG', 'MN', 'Longville Municipal Airport', '46.992000', '-94.200000', 'http://weather.noaa.gov/weather/current/KXVG.html', 'http://weather.gov/data/current_obs/KXVG.rss', 'http://weather.gov/data/current_obs/KXVG.xml'),
('KCFE', 'MN', 'Buffalo Municipal Airport', '45.159000', '-93.843000', 'http://weather.noaa.gov/weather/current/KCFE.html', 'http://weather.gov/data/current_obs/KCFE.rss', 'http://weather.gov/data/current_obs/KCFE.xml'),
('KGDB', 'MN', 'Granite Falls Municipal Airport', '44.753300', '-95.556000', 'http://weather.noaa.gov/weather/current/KGDB.html', 'http://weather.gov/data/current_obs/KGDB.rss', 'http://weather.gov/data/current_obs/KGDB.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('KAIZ', 'MO', 'Kaiser Memorial Automatic Weather Observing', '38.110000', '-92.550000', 'http://weather.noaa.gov/weather/current/KAIZ.html', 'http://weather.gov/data/current_obs/KAIZ.rss', 'http://weather.gov/data/current_obs/KAIZ.xml'),
('KCDJ', 'MO', 'Chillicothe Agri-Science Center', '39.820000', '-93.580000', 'http://weather.noaa.gov/weather/current/KCDJ.html', 'http://weather.gov/data/current_obs/KCDJ.rss', 'http://weather.gov/data/current_obs/KCDJ.xml'),
('KCGI', 'MO', 'Cape Girardeau Regional Airport', '37.230000', '-89.580000', 'http://weather.noaa.gov/weather/current/KCGI.html', 'http://weather.gov/data/current_obs/KCGI.rss', 'http://weather.gov/data/current_obs/KCGI.xml'),
('KCOU', 'MO', 'Columbia Regional Airport', '38.830000', '-92.220000', 'http://weather.noaa.gov/weather/current/KCOU.html', 'http://weather.gov/data/current_obs/KCOU.rss', 'http://weather.gov/data/current_obs/KCOU.xml'),
('KDMO', 'MO', 'Sedalia Memorial Airport', '38.710000', '-93.160000', 'http://weather.noaa.gov/weather/current/KDMO.html', 'http://weather.gov/data/current_obs/KDMO.rss', 'http://weather.gov/data/current_obs/KDMO.xml'),
('KFAM', 'MO', 'Farmington Airport', '37.760000', '-90.430000', 'http://weather.noaa.gov/weather/current/KFAM.html', 'http://weather.gov/data/current_obs/KFAM.rss', 'http://weather.gov/data/current_obs/KFAM.xml'),
('KIRK', 'MO', 'Kirksville Regional Airport', '40.110000', '-92.550000', 'http://weather.noaa.gov/weather/current/KIRK.html', 'http://weather.gov/data/current_obs/KIRK.rss', 'http://weather.gov/data/current_obs/KIRK.xml'),
('KJEF', 'MO', 'Jefferson City Memorial Airport', '38.590000', '-92.160000', 'http://weather.noaa.gov/weather/current/KJEF.html', 'http://weather.gov/data/current_obs/KJEF.rss', 'http://weather.gov/data/current_obs/KJEF.xml'),
('KJLN', 'MO', 'Joplin Regional Airport', '37.180000', '-94.500000', 'http://weather.noaa.gov/weather/current/KJLN.html', 'http://weather.gov/data/current_obs/KJLN.rss', 'http://weather.gov/data/current_obs/KJLN.xml'),
('KLXT', 'MO', 'Lees Summit', '38.964000', '-94.374000', 'http://weather.noaa.gov/weather/current/KLXT.html', 'http://weather.gov/data/current_obs/KLXT.rss', 'http://weather.gov/data/current_obs/KLXT.xml'),
('KMCI', 'MO', 'Kansas City International Airport', '39.330000', '-94.720000', 'http://weather.noaa.gov/weather/current/KMCI.html', 'http://weather.gov/data/current_obs/KMCI.rss', 'http://weather.gov/data/current_obs/KMCI.xml'),
('KMKC', 'MO', 'Charles B Wheeler Downtown Airport', '39.120000', '-94.600000', 'http://weather.noaa.gov/weather/current/KMKC.html', 'http://weather.gov/data/current_obs/KMKC.rss', 'http://weather.gov/data/current_obs/KMKC.xml'),
('KPOF', 'MO', 'Poplar Bluff Municipal Airport', '36.770000', '-90.320000', 'http://weather.noaa.gov/weather/current/KPOF.html', 'http://weather.gov/data/current_obs/KPOF.rss', 'http://weather.gov/data/current_obs/KPOF.xml'),
('KSET', 'MO', 'St. Charles County Smartt Airport', '38.931000', '-90.433000', 'http://weather.noaa.gov/weather/current/KSET.html', 'http://weather.gov/data/current_obs/KSET.rss', 'http://weather.gov/data/current_obs/KSET.xml'),
('KSGF', 'MO', 'Springfield Regional Airport', '37.230000', '-93.400000', 'http://weather.noaa.gov/weather/current/KSGF.html', 'http://weather.gov/data/current_obs/KSGF.rss', 'http://weather.gov/data/current_obs/KSGF.xml'),
('KSTJ', 'MO', 'St. Joseph, Rosecrans Memorial Airport', '39.770000', '-94.910000', 'http://weather.noaa.gov/weather/current/KSTJ.html', 'http://weather.gov/data/current_obs/KSTJ.rss', 'http://weather.gov/data/current_obs/KSTJ.xml'),
('KSTL', 'MO', 'Lambert-St. Louis International Airport', '38.760000', '-90.370000', 'http://weather.noaa.gov/weather/current/KSTL.html', 'http://weather.gov/data/current_obs/KSTL.rss', 'http://weather.gov/data/current_obs/KSTL.xml'),
('KSUS', 'MO', 'Spirit Of St. Louis Airport', '38.660000', '-90.630000', 'http://weather.noaa.gov/weather/current/KSUS.html', 'http://weather.gov/data/current_obs/KSUS.rss', 'http://weather.gov/data/current_obs/KSUS.xml'),
('KSZL', 'MO', 'Whiteman Air Force Base', '38.733000', '-93.567000', 'http://weather.noaa.gov/weather/current/KSZL.html', 'http://weather.gov/data/current_obs/KSZL.rss', 'http://weather.gov/data/current_obs/KSZL.xml'),
('KTBN', 'MO', 'Fort Leonard Wood', '37.733000', '-92.150000', 'http://weather.noaa.gov/weather/current/KTBN.html', 'http://weather.gov/data/current_obs/KTBN.rss', 'http://weather.gov/data/current_obs/KTBN.xml'),
('KUNO', 'MO', 'West Plains Municipal Airport', '36.880000', '-91.900000', 'http://weather.noaa.gov/weather/current/KUNO.html', 'http://weather.gov/data/current_obs/KUNO.rss', 'http://weather.gov/data/current_obs/KUNO.xml'),
('KVIH', 'MO', 'Rolla National Airport', '38.140000', '-91.770000', 'http://weather.noaa.gov/weather/current/KVIH.html', 'http://weather.gov/data/current_obs/KVIH.rss', 'http://weather.gov/data/current_obs/KVIH.xml'),
('TFFF', 'MQ', 'Le Lamentin', '14.600000', '-61.000000', 'http://weather.noaa.gov/weather/current/TFFF.html', 'http://weather.gov/data/current_obs/TFFF.rss', 'http://weather.gov/data/current_obs/TFFF.xml'),
('KBIX', 'MS', 'Keesler Air Force Base / Biloxi', '30.417000', '-88.917000', 'http://weather.noaa.gov/weather/current/KBIX.html', 'http://weather.gov/data/current_obs/KBIX.rss', 'http://weather.gov/data/current_obs/KBIX.xml'),
('KCBM', 'MS', 'Columbus Air Force Base', '33.633000', '-88.450000', 'http://weather.noaa.gov/weather/current/KCBM.html', 'http://weather.gov/data/current_obs/KCBM.rss', 'http://weather.gov/data/current_obs/KCBM.xml'),
('KGLH', 'MS', 'Greenville Municipal Airport', '33.480000', '-90.980000', 'http://weather.noaa.gov/weather/current/KGLH.html', 'http://weather.gov/data/current_obs/KGLH.rss', 'http://weather.gov/data/current_obs/KGLH.xml'),
('KGPT', 'MS', 'Gulfport-Biloxi Regional Airport', '30.400000', '-89.070000', 'http://weather.noaa.gov/weather/current/KGPT.html', 'http://weather.gov/data/current_obs/KGPT.rss', 'http://weather.gov/data/current_obs/KGPT.xml'),
('KGTR', 'MS', 'Golden Tri Automatic Weather Observing / Reporting', '33.460000', '-88.580000', 'http://weather.noaa.gov/weather/current/KGTR.html', 'http://weather.gov/data/current_obs/KGTR.rss', 'http://weather.gov/data/current_obs/KGTR.xml'),
('KGWO', 'MS', 'Greenwood-LeFlore Airport', '33.510000', '-90.080000', 'http://weather.noaa.gov/weather/current/KGWO.html', 'http://weather.gov/data/current_obs/KGWO.rss', 'http://weather.gov/data/current_obs/KGWO.xml'),
('KHBG', 'MS', 'Hattiesburg, Bobby L Chain Municipal Airport', '31.270000', '-89.250000', 'http://weather.noaa.gov/weather/current/KHBG.html', 'http://weather.gov/data/current_obs/KHBG.rss', 'http://weather.gov/data/current_obs/KHBG.xml'),
('KHEZ', 'MS', 'Natchez / Hardy Automatic Weather Observing/Report', '31.620000', '-91.250000', 'http://weather.noaa.gov/weather/current/KHEZ.html', 'http://weather.gov/data/current_obs/KHEZ.rss', 'http://weather.gov/data/current_obs/KHEZ.xml'),
('KHKS', 'MS', 'Jackson, Hawkins Field Airport', '32.330000', '-90.220000', 'http://weather.noaa.gov/weather/current/KHKS.html', 'http://weather.gov/data/current_obs/KHKS.rss', 'http://weather.gov/data/current_obs/KHKS.xml'),
('KJAN', 'MS', 'Jackson International Airport', '32.330000', '-90.080000', 'http://weather.noaa.gov/weather/current/KJAN.html', 'http://weather.gov/data/current_obs/KJAN.rss', 'http://weather.gov/data/current_obs/KJAN.xml'),
('KM97', 'MS', 'Tunica Municipal Airport', '34.683000', '-90.333000', 'http://weather.noaa.gov/weather/current/KM97.html', 'http://weather.gov/data/current_obs/KM97.rss', 'http://weather.gov/data/current_obs/KM97.xml'),
('KMCB', 'MS', 'McComb / Pike County / John E Lewis Field', '31.180000', '-90.470000', 'http://weather.noaa.gov/weather/current/KMCB.html', 'http://weather.gov/data/current_obs/KMCB.rss', 'http://weather.gov/data/current_obs/KMCB.xml'),
('KMEI', 'MS', 'Meridian, Key Field', '32.340000', '-88.750000', 'http://weather.noaa.gov/weather/current/KMEI.html', 'http://weather.gov/data/current_obs/KMEI.rss', 'http://weather.gov/data/current_obs/KMEI.xml'),
('KNMM', 'MS', 'Meridian, Naval Air Station', '32.550000', '-88.567000', 'http://weather.noaa.gov/weather/current/KNMM.html', 'http://weather.gov/data/current_obs/KNMM.rss', 'http://weather.gov/data/current_obs/KNMM.xml'),
('KOLV', 'MS', 'Olive Branch Airport', '34.980000', '-89.790000', 'http://weather.noaa.gov/weather/current/KOLV.html', 'http://weather.gov/data/current_obs/KOLV.rss', 'http://weather.gov/data/current_obs/KOLV.xml'),
('KPGL', 'MS', 'Pascagoula / Jackson', '30.400000', '-88.483000', 'http://weather.noaa.gov/weather/current/KPGL.html', 'http://weather.gov/data/current_obs/KPGL.rss', 'http://weather.gov/data/current_obs/KPGL.xml'),
('KPIB', 'MS', 'Pine Belt Regional Automatic Weather Observing', '31.470000', '-89.330000', 'http://weather.noaa.gov/weather/current/KPIB.html', 'http://weather.gov/data/current_obs/KPIB.rss', 'http://weather.gov/data/current_obs/KPIB.xml'),
('KPQL', 'MS', 'Pascagoula, Lott International Airport', '30.460000', '-88.530000', 'http://weather.noaa.gov/weather/current/KPQL.html', 'http://weather.gov/data/current_obs/KPQL.rss', 'http://weather.gov/data/current_obs/KPQL.xml'),
('KTUP', 'MS', 'Tupelo Regional Airport', '34.280000', '-88.770000', 'http://weather.noaa.gov/weather/current/KTUP.html', 'http://weather.gov/data/current_obs/KTUP.rss', 'http://weather.gov/data/current_obs/KTUP.xml'),
('KUTA', 'MS', 'Tunica Municipal Airport', '34.683100', '-90.347200', 'http://weather.noaa.gov/weather/current/KUTA.html', 'http://weather.gov/data/current_obs/KUTA.rss', 'http://weather.gov/data/current_obs/KUTA.xml'),
('K3DU', 'MT', 'Drummond', '46.680000', '-113.150000', 'http://weather.noaa.gov/weather/current/K3DU.html', 'http://weather.gov/data/current_obs/K3DU.rss', 'http://weather.gov/data/current_obs/K3DU.xml'),
('K3HT', 'MT', 'Harlowton', '46.440000', '-109.840000', 'http://weather.noaa.gov/weather/current/K3HT.html', 'http://weather.gov/data/current_obs/K3HT.rss', 'http://weather.gov/data/current_obs/K3HT.xml'),
('K3TH', 'MT', 'Thompson Falls', '47.600000', '-115.367000', 'http://weather.noaa.gov/weather/current/K3TH.html', 'http://weather.gov/data/current_obs/K3TH.rss', 'http://weather.gov/data/current_obs/K3TH.xml'),
('KBHK', 'MT', 'Baker', '46.333000', '-104.250000', 'http://weather.noaa.gov/weather/current/KBHK.html', 'http://weather.gov/data/current_obs/KBHK.rss', 'http://weather.gov/data/current_obs/KBHK.xml'),
('KBIL', 'MT', 'Billings/Logan Intl Airport', '45.800000', '-108.530000', 'http://weather.noaa.gov/weather/current/KBIL.html', 'http://weather.gov/data/current_obs/KBIL.rss', 'http://weather.gov/data/current_obs/KBIL.xml'),
('KBTM', 'MT', 'Butte/Bert Mooney', '45.960000', '-112.500000', 'http://weather.noaa.gov/weather/current/KBTM.html', 'http://weather.gov/data/current_obs/KBTM.rss', 'http://weather.gov/data/current_obs/KBTM.xml'),
('KBZN', 'MT', 'Bozeman/Gallatin', '45.790000', '-111.150000', 'http://weather.noaa.gov/weather/current/KBZN.html', 'http://weather.gov/data/current_obs/KBZN.rss', 'http://weather.gov/data/current_obs/KBZN.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('KCTB', 'MT', 'Cut Bank (awos)', '48.610000', '-112.370000', 'http://weather.noaa.gov/weather/current/KCTB.html', 'http://weather.gov/data/current_obs/KCTB.rss', 'http://weather.gov/data/current_obs/KCTB.xml'),
('KDLN', 'MT', 'Dillon Airport', '45.260000', '-112.550000', 'http://weather.noaa.gov/weather/current/KDLN.html', 'http://weather.gov/data/current_obs/KDLN.rss', 'http://weather.gov/data/current_obs/KDLN.xml'),
('KFCA', 'MT', 'Kalispell/Glacier', '48.300000', '-114.270000', 'http://weather.noaa.gov/weather/current/KFCA.html', 'http://weather.gov/data/current_obs/KFCA.rss', 'http://weather.gov/data/current_obs/KFCA.xml'),
('KGDV', 'MT', 'Glendive(awos)', '47.140000', '-104.800000', 'http://weather.noaa.gov/weather/current/KGDV.html', 'http://weather.gov/data/current_obs/KGDV.rss', 'http://weather.gov/data/current_obs/KGDV.xml'),
('KGFA', 'MT', 'Malmstrom Air Morce Base', '47.517000', '-111.183000', 'http://weather.noaa.gov/weather/current/KGFA.html', 'http://weather.gov/data/current_obs/KGFA.rss', 'http://weather.gov/data/current_obs/KGFA.xml'),
('KGGW', 'MT', 'Glasgow Intl Arpt', '48.210000', '-106.630000', 'http://weather.noaa.gov/weather/current/KGGW.html', 'http://weather.gov/data/current_obs/KGGW.rss', 'http://weather.gov/data/current_obs/KGGW.xml'),
('KGTF', 'MT', 'Great Falls Intl Airport', '47.480000', '-111.350000', 'http://weather.noaa.gov/weather/current/KGTF.html', 'http://weather.gov/data/current_obs/KGTF.rss', 'http://weather.gov/data/current_obs/KGTF.xml'),
('KHLN', 'MT', 'Helena Regional', '46.610000', '-112.000000', 'http://weather.noaa.gov/weather/current/KHLN.html', 'http://weather.gov/data/current_obs/KHLN.rss', 'http://weather.gov/data/current_obs/KHLN.xml'),
('KHVR', 'MT', 'Havre (amos)', '48.550000', '-109.770000', 'http://weather.noaa.gov/weather/current/KHVR.html', 'http://weather.gov/data/current_obs/KHVR.rss', 'http://weather.gov/data/current_obs/KHVR.xml'),
('KJDN', 'MT', 'Jordan (ramos)', '47.330000', '-106.930000', 'http://weather.noaa.gov/weather/current/KJDN.html', 'http://weather.gov/data/current_obs/KJDN.rss', 'http://weather.gov/data/current_obs/KJDN.xml'),
('KLVM', 'MT', 'Livingston/Mission', '45.710000', '-110.430000', 'http://weather.noaa.gov/weather/current/KLVM.html', 'http://weather.gov/data/current_obs/KLVM.rss', 'http://weather.gov/data/current_obs/KLVM.xml'),
('KLWT', 'MT', 'Lewistown Municipal', '47.050000', '-109.450000', 'http://weather.noaa.gov/weather/current/KLWT.html', 'http://weather.gov/data/current_obs/KLWT.rss', 'http://weather.gov/data/current_obs/KLWT.xml'),
('KMLS', 'MT', 'Miles City', '46.440000', '-105.870000', 'http://weather.noaa.gov/weather/current/KMLS.html', 'http://weather.gov/data/current_obs/KMLS.rss', 'http://weather.gov/data/current_obs/KMLS.xml'),
('KMSO', 'MT', 'Missoula/Bell Field', '46.930000', '-114.080000', 'http://weather.noaa.gov/weather/current/KMSO.html', 'http://weather.gov/data/current_obs/KMSO.rss', 'http://weather.gov/data/current_obs/KMSO.xml'),
('KOLF', 'MT', 'Wolf Point Intl Airport', '48.090000', '-105.580000', 'http://weather.noaa.gov/weather/current/KOLF.html', 'http://weather.gov/data/current_obs/KOLF.rss', 'http://weather.gov/data/current_obs/KOLF.xml'),
('KSDY', 'MT', 'Sidney-Richland', '47.730000', '-104.180000', 'http://weather.noaa.gov/weather/current/KSDY.html', 'http://weather.gov/data/current_obs/KSDY.rss', 'http://weather.gov/data/current_obs/KSDY.xml'),
('KWEY', 'MT', 'West Yellowston', '44.660000', '-111.100000', 'http://weather.noaa.gov/weather/current/KWEY.html', 'http://weather.gov/data/current_obs/KWEY.rss', 'http://weather.gov/data/current_obs/KWEY.xml'),
('KWYS', 'MT', 'West Yellowstone', '44.683000', '-111.117000', 'http://weather.noaa.gov/weather/current/KWYS.html', 'http://weather.gov/data/current_obs/KWYS.rss', 'http://weather.gov/data/current_obs/KWYS.xml'),
('MMUN', 'MX', 'Cancun Mexico', '21.030000', '-86.870000', 'http://weather.noaa.gov/weather/current/MMUN.html', 'http://weather.gov/data/current_obs/MMUN.rss', 'http://weather.gov/data/current_obs/MMUN.xml'),
('MMCS', 'MX', 'MMCS Ob Site', '31.633000', '-106.417000', 'http://weather.noaa.gov/weather/current/MMCS.html', 'http://weather.gov/data/current_obs/MMCS.rss', 'http://weather.gov/data/current_obs/MMCS.xml'),
('K1A5', 'NC', 'Franklin/Macon County Airport', '35.217000', '-83.417000', 'http://weather.noaa.gov/weather/current/K1A5.html', 'http://weather.gov/data/current_obs/K1A5.rss', 'http://weather.gov/data/current_obs/K1A5.xml'),
('K45J', 'NC', 'Rockingham', '34.883000', '-79.750000', 'http://weather.noaa.gov/weather/current/K45J.html', 'http://weather.gov/data/current_obs/K45J.rss', 'http://weather.gov/data/current_obs/K45J.xml'),
('KAKH', 'NC', 'Gastonia Municipal Airport', '35.200000', '-81.150000', 'http://weather.noaa.gov/weather/current/KAKH.html', 'http://weather.gov/data/current_obs/KAKH.rss', 'http://weather.gov/data/current_obs/KAKH.xml'),
('KASJ', 'NC', 'Ahoskie, Tri-County Airport', '36.300000', '-77.170000', 'http://weather.noaa.gov/weather/current/KASJ.html', 'http://weather.gov/data/current_obs/KASJ.rss', 'http://weather.gov/data/current_obs/KASJ.xml'),
('KAVL', 'NC', 'Asheville Regional Airport', '35.440000', '-82.550000', 'http://weather.noaa.gov/weather/current/KAVL.html', 'http://weather.gov/data/current_obs/KAVL.rss', 'http://weather.gov/data/current_obs/KAVL.xml'),
('KBUY', 'NC', 'Burlington Alamance Regional Airport', '36.050000', '-79.470000', 'http://weather.noaa.gov/weather/current/KBUY.html', 'http://weather.gov/data/current_obs/KBUY.rss', 'http://weather.gov/data/current_obs/KBUY.xml'),
('KCLT', 'NC', 'Charlotte/Douglas International Airport', '35.210000', '-80.940000', 'http://weather.noaa.gov/weather/current/KCLT.html', 'http://weather.gov/data/current_obs/KCLT.rss', 'http://weather.gov/data/current_obs/KCLT.xml'),
('KCPC', 'NC', 'Whiteville-Columbus Co Muni Airport', '34.280000', '-78.710000', 'http://weather.noaa.gov/weather/current/KCPC.html', 'http://weather.gov/data/current_obs/KCPC.rss', 'http://weather.gov/data/current_obs/KCPC.xml'),
('KCTZ', 'NC', 'Sampson County Airport', '34.983000', '-78.367000', 'http://weather.noaa.gov/weather/current/KCTZ.html', 'http://weather.gov/data/current_obs/KCTZ.rss', 'http://weather.gov/data/current_obs/KCTZ.xml'),
('KDPL', 'NC', 'Kenansville, Duplin County Airport', '35.000000', '-77.980000', 'http://weather.noaa.gov/weather/current/KDPL.html', 'http://weather.gov/data/current_obs/KDPL.rss', 'http://weather.gov/data/current_obs/KDPL.xml'),
('KECG', 'NC', 'Elizabeth City Coast Guard Air Sta', '36.260000', '-76.170000', 'http://weather.noaa.gov/weather/current/KECG.html', 'http://weather.gov/data/current_obs/KECG.rss', 'http://weather.gov/data/current_obs/KECG.xml'),
('KEDE', 'NC', 'Edenton, Northeastern Regional Airport', '36.030000', '-76.570000', 'http://weather.noaa.gov/weather/current/KEDE.html', 'http://weather.gov/data/current_obs/KEDE.rss', 'http://weather.gov/data/current_obs/KEDE.xml'),
('KEHO', 'NC', 'Shelby Municipal Airport', '35.250000', '-81.600000', 'http://weather.noaa.gov/weather/current/KEHO.html', 'http://weather.gov/data/current_obs/KEHO.rss', 'http://weather.gov/data/current_obs/KEHO.xml'),
('KEQY', 'NC', 'Monroe Airport', '35.017000', '-80.617000', 'http://weather.noaa.gov/weather/current/KEQY.html', 'http://weather.gov/data/current_obs/KEQY.rss', 'http://weather.gov/data/current_obs/KEQY.xml'),
('KEWN', 'NC', 'New Bern, Craven County Regional Airport', '35.090000', '-77.050000', 'http://weather.noaa.gov/weather/current/KEWN.html', 'http://weather.gov/data/current_obs/KEWN.rss', 'http://weather.gov/data/current_obs/KEWN.xml'),
('KEXX', 'NC', 'Lexington, Davidson County Airport', '35.783000', '-80.300000', 'http://weather.noaa.gov/weather/current/KEXX.html', 'http://weather.gov/data/current_obs/KEXX.rss', 'http://weather.gov/data/current_obs/KEXX.xml'),
('KEYF', 'NC', 'Elizabethtown-Curtis L Brown Field Airport', '34.602000', '-78.579000', 'http://weather.noaa.gov/weather/current/KEYF.html', 'http://weather.gov/data/current_obs/KEYF.rss', 'http://weather.gov/data/current_obs/KEYF.xml'),
('KFAY', 'NC', 'Fayetteville Regional Airport', '34.990000', '-78.880000', 'http://weather.noaa.gov/weather/current/KFAY.html', 'http://weather.gov/data/current_obs/KFAY.rss', 'http://weather.gov/data/current_obs/KFAY.xml'),
('KFBG', 'NC', 'Fort Bragg / Simmons Army Airfield', '35.140000', '-78.930000', 'http://weather.noaa.gov/weather/current/KFBG.html', 'http://weather.gov/data/current_obs/KFBG.rss', 'http://weather.gov/data/current_obs/KFBG.xml'),
('KFFA', 'NC', 'First Flight Airport', '36.017000', '-75.667000', 'http://weather.noaa.gov/weather/current/KFFA.html', 'http://weather.gov/data/current_obs/KFFA.rss', 'http://weather.gov/data/current_obs/KFFA.xml'),
('KFQD', 'NC', 'Rutherfordton/Rutherford Co-Marchman Field Airport', '35.430000', '-81.940000', 'http://weather.noaa.gov/weather/current/KFQD.html', 'http://weather.gov/data/current_obs/KFQD.rss', 'http://weather.gov/data/current_obs/KFQD.xml'),
('KGEV', 'NC', 'Jefferson, Ashe County Airport', '36.430000', '-81.420000', 'http://weather.noaa.gov/weather/current/KGEV.html', 'http://weather.gov/data/current_obs/KGEV.rss', 'http://weather.gov/data/current_obs/KGEV.xml'),
('KGSB', 'NC', 'Seymour-Johnson Air Force Base', '35.340000', '-77.970000', 'http://weather.noaa.gov/weather/current/KGSB.html', 'http://weather.gov/data/current_obs/KGSB.rss', 'http://weather.gov/data/current_obs/KGSB.xml'),
('KGSO', 'NC', 'Greensboro, Piedmont Triad International Airport', '36.010000', '-79.950000', 'http://weather.noaa.gov/weather/current/KGSO.html', 'http://weather.gov/data/current_obs/KGSO.rss', 'http://weather.gov/data/current_obs/KGSO.xml'),
('KGWW', 'NC', 'Goldsboro-Wayne Muni Airport', '35.460000', '-77.960000', 'http://weather.noaa.gov/weather/current/KGWW.html', 'http://weather.gov/data/current_obs/KGWW.rss', 'http://weather.gov/data/current_obs/KGWW.xml'),
('KHBI', 'NC', 'Asheboro Municipal Airport', '35.650000', '-79.900000', 'http://weather.noaa.gov/weather/current/KHBI.html', 'http://weather.gov/data/current_obs/KHBI.rss', 'http://weather.gov/data/current_obs/KHBI.xml'),
('KHFF', 'NC', 'Mackall U. S. Army Airfield', '35.033000', '-79.500000', 'http://weather.noaa.gov/weather/current/KHFF.html', 'http://weather.gov/data/current_obs/KHFF.rss', 'http://weather.gov/data/current_obs/KHFF.xml'),
('KHKY', 'NC', 'Hickory Regional Airport', '35.760000', '-81.380000', 'http://weather.noaa.gov/weather/current/KHKY.html', 'http://weather.gov/data/current_obs/KHKY.rss', 'http://weather.gov/data/current_obs/KHKY.xml'),
('KHNZ', 'NC', 'Henderson-Oxford Airport', '36.360000', '-78.530000', 'http://weather.noaa.gov/weather/current/KHNZ.html', 'http://weather.gov/data/current_obs/KHNZ.rss', 'http://weather.gov/data/current_obs/KHNZ.xml'),
('KHRJ', 'NC', 'Erwin, Harnett County Airport', '35.380000', '-78.730000', 'http://weather.noaa.gov/weather/current/KHRJ.html', 'http://weather.gov/data/current_obs/KHRJ.rss', 'http://weather.gov/data/current_obs/KHRJ.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('KHSE', 'NC', 'Hatteras, Mitchell Field', '35.220000', '-75.620000', 'http://weather.noaa.gov/weather/current/KHSE.html', 'http://weather.gov/data/current_obs/KHSE.rss', 'http://weather.gov/data/current_obs/KHSE.xml'),
('KHSS', 'NC', 'Hot Springs Aviation Weather Reporting Station', '35.900000', '-82.817000', 'http://weather.noaa.gov/weather/current/KHSS.html', 'http://weather.gov/data/current_obs/KHSS.rss', 'http://weather.gov/data/current_obs/KHSS.xml'),
('KIGX', 'NC', 'Chapel Hill, Williams Airport', '35.940000', '-79.070000', 'http://weather.noaa.gov/weather/current/KIGX.html', 'http://weather.gov/data/current_obs/KIGX.rss', 'http://weather.gov/data/current_obs/KIGX.xml'),
('KILM', 'NC', 'Wilmington, New Hanover International Airport', '34.280000', '-77.920000', 'http://weather.noaa.gov/weather/current/KILM.html', 'http://weather.gov/data/current_obs/KILM.rss', 'http://weather.gov/data/current_obs/KILM.xml'),
('KINT', 'NC', 'Winston Salem, Smith Reynolds Airport', '36.130000', '-80.220000', 'http://weather.noaa.gov/weather/current/KINT.html', 'http://weather.gov/data/current_obs/KINT.rss', 'http://weather.gov/data/current_obs/KINT.xml'),
('KIPJ', 'NC', 'Lincolnton-Lincoln County Regional Airport', '35.483000', '-81.167000', 'http://weather.noaa.gov/weather/current/KIPJ.html', 'http://weather.gov/data/current_obs/KIPJ.rss', 'http://weather.gov/data/current_obs/KIPJ.xml'),
('KISO', 'NC', 'Kinston / Stallings', '35.330000', '-77.630000', 'http://weather.noaa.gov/weather/current/KISO.html', 'http://weather.gov/data/current_obs/KISO.rss', 'http://weather.gov/data/current_obs/KISO.xml'),
('KJNX', 'NC', 'Smithfield, Johnston County Airport', '35.541000', '-78.390000', 'http://weather.noaa.gov/weather/current/KJNX.html', 'http://weather.gov/data/current_obs/KJNX.rss', 'http://weather.gov/data/current_obs/KJNX.xml'),
('KJQF', 'NC', 'Concord Regional Airport', '35.390000', '-80.710000', 'http://weather.noaa.gov/weather/current/KJQF.html', 'http://weather.gov/data/current_obs/KJQF.rss', 'http://weather.gov/data/current_obs/KJQF.xml'),
('KLBT', 'NC', 'Lumberton Municipal Airport', '34.610000', '-79.060000', 'http://weather.noaa.gov/weather/current/KLBT.html', 'http://weather.gov/data/current_obs/KLBT.rss', 'http://weather.gov/data/current_obs/KLBT.xml'),
('KLHZ', 'NC', 'Louisburg', '36.023000', '-78.330000', 'http://weather.noaa.gov/weather/current/KLHZ.html', 'http://weather.gov/data/current_obs/KLHZ.rss', 'http://weather.gov/data/current_obs/KLHZ.xml'),
('KMEB', 'NC', 'Laurinburg-Maxton Airport', '34.790000', '-79.370000', 'http://weather.noaa.gov/weather/current/KMEB.html', 'http://weather.gov/data/current_obs/KMEB.rss', 'http://weather.gov/data/current_obs/KMEB.xml'),
('KMQI', 'NC', 'Manteo / Dare County Regional', '35.920000', '-75.700000', 'http://weather.noaa.gov/weather/current/KMQI.html', 'http://weather.gov/data/current_obs/KMQI.rss', 'http://weather.gov/data/current_obs/KMQI.xml'),
('KMRH', 'NC', 'Beaufort, Michael J Smith Field Airport', '34.717000', '-76.650000', 'http://weather.noaa.gov/weather/current/KMRH.html', 'http://weather.gov/data/current_obs/KMRH.rss', 'http://weather.gov/data/current_obs/KMRH.xml'),
('KMRN', 'NC', 'Morganton-Lenoir Airport', '35.820000', '-81.610000', 'http://weather.noaa.gov/weather/current/KMRN.html', 'http://weather.gov/data/current_obs/KMRN.rss', 'http://weather.gov/data/current_obs/KMRN.xml'),
('KMWK', 'NC', 'Mount Airy / Surry County Airport', '36.460000', '-80.550000', 'http://weather.noaa.gov/weather/current/KMWK.html', 'http://weather.gov/data/current_obs/KMWK.rss', 'http://weather.gov/data/current_obs/KMWK.xml'),
('KNCA', 'NC', 'Jacksonville, New River, Marine Corps Air Station', '34.710000', '-77.430000', 'http://weather.noaa.gov/weather/current/KNCA.html', 'http://weather.gov/data/current_obs/KNCA.rss', 'http://weather.gov/data/current_obs/KNCA.xml'),
('KNKT', 'NC', 'Cherry Point, Marine Corps Air Station', '34.860000', '-76.880000', 'http://weather.noaa.gov/weather/current/KNKT.html', 'http://weather.gov/data/current_obs/KNKT.rss', 'http://weather.gov/data/current_obs/KNKT.xml'),
('KOAJ', 'NC', 'Jacksonville Automatic Weather Observing/Reporting', '34.830000', '-77.620000', 'http://weather.noaa.gov/weather/current/KOAJ.html', 'http://weather.gov/data/current_obs/KOAJ.rss', 'http://weather.gov/data/current_obs/KOAJ.xml'),
('KOCW', 'NC', 'Washington, Warren Field Airport', '35.570000', '-77.050000', 'http://weather.noaa.gov/weather/current/KOCW.html', 'http://weather.gov/data/current_obs/KOCW.rss', 'http://weather.gov/data/current_obs/KOCW.xml'),
('KPGV', 'NC', 'Pitt-Greenville Airport', '35.630000', '-77.400000', 'http://weather.noaa.gov/weather/current/KPGV.html', 'http://weather.gov/data/current_obs/KPGV.rss', 'http://weather.gov/data/current_obs/KPGV.xml'),
('KPOB', 'NC', 'Pope Air Force Base', '35.180000', '-79.020000', 'http://weather.noaa.gov/weather/current/KPOB.html', 'http://weather.gov/data/current_obs/KPOB.rss', 'http://weather.gov/data/current_obs/KPOB.xml'),
('KRDU', 'NC', 'Raleigh-Durham International Airport', '35.880000', '-78.780000', 'http://weather.noaa.gov/weather/current/KRDU.html', 'http://weather.gov/data/current_obs/KRDU.rss', 'http://weather.gov/data/current_obs/KRDU.xml'),
('KRHP', 'NC', 'Andrews-Murphy Airport', '35.190000', '-83.860000', 'http://weather.noaa.gov/weather/current/KRHP.html', 'http://weather.gov/data/current_obs/KRHP.rss', 'http://weather.gov/data/current_obs/KRHP.xml'),
('KRUQ', 'NC', 'Salisbury, Rowan County Airport', '35.650000', '-80.517000', 'http://weather.noaa.gov/weather/current/KRUQ.html', 'http://weather.gov/data/current_obs/KRUQ.rss', 'http://weather.gov/data/current_obs/KRUQ.xml'),
('KRWI', 'NC', 'Rocky Mount-Wilson Regional Airport', '35.860000', '-77.880000', 'http://weather.noaa.gov/weather/current/KRWI.html', 'http://weather.gov/data/current_obs/KRWI.rss', 'http://weather.gov/data/current_obs/KRWI.xml'),
('KRZZ', 'NC', 'Roanoke Rapids, Halifax County Airport', '36.440000', '-77.710000', 'http://weather.noaa.gov/weather/current/KRZZ.html', 'http://weather.gov/data/current_obs/KRZZ.rss', 'http://weather.gov/data/current_obs/KRZZ.xml'),
('KSOP', 'NC', 'Southern Pines Automatic Weather Observing/Report', '35.240000', '-79.410000', 'http://weather.noaa.gov/weather/current/KSOP.html', 'http://weather.gov/data/current_obs/KSOP.rss', 'http://weather.gov/data/current_obs/KSOP.xml'),
('KSUT', 'NC', 'Brunswick County Airport', '33.930000', '-78.070000', 'http://weather.noaa.gov/weather/current/KSUT.html', 'http://weather.gov/data/current_obs/KSUT.rss', 'http://weather.gov/data/current_obs/KSUT.xml'),
('KSVH', 'NC', 'Statesville Municipal Airport', '35.760000', '-80.960000', 'http://weather.noaa.gov/weather/current/KSVH.html', 'http://weather.gov/data/current_obs/KSVH.rss', 'http://weather.gov/data/current_obs/KSVH.xml'),
('KTDF', 'NC', 'Roxboro, Person County Airport', '36.285000', '-78.984000', 'http://weather.noaa.gov/weather/current/KTDF.html', 'http://weather.gov/data/current_obs/KTDF.rss', 'http://weather.gov/data/current_obs/KTDF.xml'),
('KTNB', 'NC', 'Boone, Watauga County Hospital Heliport', '36.199000', '-81.651000', 'http://weather.noaa.gov/weather/current/KTNB.html', 'http://weather.gov/data/current_obs/KTNB.rss', 'http://weather.gov/data/current_obs/KTNB.xml'),
('KTTA', 'NC', 'Sanford-Lee County Regional Airport', '35.580000', '-79.100000', 'http://weather.noaa.gov/weather/current/KTTA.html', 'http://weather.gov/data/current_obs/KTTA.rss', 'http://weather.gov/data/current_obs/KTTA.xml'),
('KUKF', 'NC', 'North Wilkesboro, Wilkes County Airport', '36.220000', '-81.100000', 'http://weather.noaa.gov/weather/current/KUKF.html', 'http://weather.gov/data/current_obs/KUKF.rss', 'http://weather.gov/data/current_obs/KUKF.xml'),
('KVUJ', 'NC', 'Albemarle, Stanly County Airport', '35.417000', '-80.151000', 'http://weather.noaa.gov/weather/current/KVUJ.html', 'http://weather.gov/data/current_obs/KVUJ.rss', 'http://weather.gov/data/current_obs/KVUJ.xml'),
('KBIS', 'ND', 'Bismarck Municipal Airport', '46.780000', '-100.750000', 'http://weather.noaa.gov/weather/current/KBIS.html', 'http://weather.gov/data/current_obs/KBIS.rss', 'http://weather.gov/data/current_obs/KBIS.xml'),
('KBWP', 'ND', 'Harry Stern Airport', '46.233000', '-96.600000', 'http://weather.noaa.gov/weather/current/KBWP.html', 'http://weather.gov/data/current_obs/KBWP.rss', 'http://weather.gov/data/current_obs/KBWP.xml'),
('KDVL', 'ND', 'Devils Lake Automatic Weather Observing/Reporting', '48.120000', '-98.900000', 'http://weather.noaa.gov/weather/current/KDVL.html', 'http://weather.gov/data/current_obs/KDVL.rss', 'http://weather.gov/data/current_obs/KDVL.xml'),
('KFAR', 'ND', 'Fargo, Hector International Airport', '46.910000', '-96.800000', 'http://weather.noaa.gov/weather/current/KFAR.html', 'http://weather.gov/data/current_obs/KFAR.rss', 'http://weather.gov/data/current_obs/KFAR.xml'),
('KGFK', 'ND', 'Grand Forks International Airport', '47.960000', '-97.180000', 'http://weather.noaa.gov/weather/current/KGFK.html', 'http://weather.gov/data/current_obs/KGFK.rss', 'http://weather.gov/data/current_obs/KGFK.xml'),
('KISN', 'ND', 'Williston, Sloulin Field International Airport', '48.160000', '-103.600000', 'http://weather.noaa.gov/weather/current/KISN.html', 'http://weather.gov/data/current_obs/KISN.rss', 'http://weather.gov/data/current_obs/KISN.xml'),
('KJMS', 'ND', 'Jamestown Municipal Airport', '46.930000', '-98.680000', 'http://weather.noaa.gov/weather/current/KJMS.html', 'http://weather.gov/data/current_obs/KJMS.rss', 'http://weather.gov/data/current_obs/KJMS.xml'),
('KMIB', 'ND', 'Minot Air Force Base', '48.417000', '-101.350000', 'http://weather.noaa.gov/weather/current/KMIB.html', 'http://weather.gov/data/current_obs/KMIB.rss', 'http://weather.gov/data/current_obs/KMIB.xml'),
('KMOT', 'ND', 'Minot International Airport', '48.280000', '-101.280000', 'http://weather.noaa.gov/weather/current/KMOT.html', 'http://weather.gov/data/current_obs/KMOT.rss', 'http://weather.gov/data/current_obs/KMOT.xml'),
('KN60', 'ND', 'Garrison', '47.610000', '-101.400000', 'http://weather.noaa.gov/weather/current/KN60.html', 'http://weather.gov/data/current_obs/KN60.rss', 'http://weather.gov/data/current_obs/KN60.xml'),
('KRDR', 'ND', 'Grand Forks Air Force Base', '47.933000', '-97.383000', 'http://weather.noaa.gov/weather/current/KRDR.html', 'http://weather.gov/data/current_obs/KRDR.rss', 'http://weather.gov/data/current_obs/KRDR.xml'),
('KDIK', 'ND', 'Dickinson Theodore Roosevelt Regional Airport', '46.790000', '-102.800000', 'http://weather.noaa.gov/weather/current/KDIK.html', 'http://weather.gov/data/current_obs/KDIK.rss', 'http://weather.gov/data/current_obs/KDIK.xml'),
('KHEI', 'ND', 'Hettinger Municipal Airport', '46.000000', '-102.650000', 'http://weather.noaa.gov/weather/current/KHEI.html', 'http://weather.gov/data/current_obs/KHEI.rss', 'http://weather.gov/data/current_obs/KHEI.xml'),
('KAFK', 'NE', 'Nebraska City Municipal Airport', '40.600000', '-95.870000', 'http://weather.noaa.gov/weather/current/KAFK.html', 'http://weather.gov/data/current_obs/KAFK.rss', 'http://weather.gov/data/current_obs/KAFK.xml'),
('KANW', 'NE', 'Ainsworth Municipal', '42.590000', '-99.990000', 'http://weather.noaa.gov/weather/current/KANW.html', 'http://weather.gov/data/current_obs/KANW.rss', 'http://weather.gov/data/current_obs/KANW.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('KAUH', 'NE', 'Aurora Municipal Airport', '40.880000', '-98.000000', 'http://weather.noaa.gov/weather/current/KAUH.html', 'http://weather.gov/data/current_obs/KAUH.rss', 'http://weather.gov/data/current_obs/KAUH.xml'),
('KBBW', 'NE', 'Broken Bow Municipal Airport', '41.440000', '-99.660000', 'http://weather.noaa.gov/weather/current/KBBW.html', 'http://weather.gov/data/current_obs/KBBW.rss', 'http://weather.gov/data/current_obs/KBBW.xml'),
('KBIE', 'NE', 'Beatrice Municipal', '40.300000', '-96.750000', 'http://weather.noaa.gov/weather/current/KBIE.html', 'http://weather.gov/data/current_obs/KBIE.rss', 'http://weather.gov/data/current_obs/KBIE.xml'),
('KBVN', 'NE', 'Albion Municipal Airport', '41.733000', '-98.050000', 'http://weather.noaa.gov/weather/current/KBVN.html', 'http://weather.gov/data/current_obs/KBVN.rss', 'http://weather.gov/data/current_obs/KBVN.xml'),
('KCZD', 'NE', 'Cozad Municipal Airport', '40.867000', '-100.000000', 'http://weather.noaa.gov/weather/current/KCZD.html', 'http://weather.gov/data/current_obs/KCZD.rss', 'http://weather.gov/data/current_obs/KCZD.xml'),
('KEAR', 'NE', 'Kearney Municipal Automatic Weather Observing', '40.730000', '-99.000000', 'http://weather.noaa.gov/weather/current/KEAR.html', 'http://weather.gov/data/current_obs/KEAR.rss', 'http://weather.gov/data/current_obs/KEAR.xml'),
('KFET', 'NE', 'Fremont Municipal Airport', '41.450000', '-96.530000', 'http://weather.noaa.gov/weather/current/KFET.html', 'http://weather.gov/data/current_obs/KFET.rss', 'http://weather.gov/data/current_obs/KFET.xml'),
('KFNB', 'NE', 'Falls City, Brenner Field Airport', '40.080000', '-95.580000', 'http://weather.noaa.gov/weather/current/KFNB.html', 'http://weather.gov/data/current_obs/KFNB.rss', 'http://weather.gov/data/current_obs/KFNB.xml'),
('KGRI', 'NE', 'Grand Island, Central Nebraska Regional Airport', '40.980000', '-98.320000', 'http://weather.noaa.gov/weather/current/KGRI.html', 'http://weather.gov/data/current_obs/KGRI.rss', 'http://weather.gov/data/current_obs/KGRI.xml'),
('KHDE', 'NE', 'Brewster Field Airport', '40.450000', '-99.330000', 'http://weather.noaa.gov/weather/current/KHDE.html', 'http://weather.gov/data/current_obs/KHDE.rss', 'http://weather.gov/data/current_obs/KHDE.xml'),
('KHJH', 'NE', 'Hebron Municipal Airport', '40.152000', '-97.587000', 'http://weather.noaa.gov/weather/current/KHJH.html', 'http://weather.gov/data/current_obs/KHJH.rss', 'http://weather.gov/data/current_obs/KHJH.xml'),
('KHSI', 'NE', 'Hastings Municipal Airport', '40.610000', '-98.430000', 'http://weather.noaa.gov/weather/current/KHSI.html', 'http://weather.gov/data/current_obs/KHSI.rss', 'http://weather.gov/data/current_obs/KHSI.xml'),
('KJYR', 'NE', 'York Municipal Airport', '40.900000', '-97.620000', 'http://weather.noaa.gov/weather/current/KJYR.html', 'http://weather.gov/data/current_obs/KJYR.rss', 'http://weather.gov/data/current_obs/KJYR.xml'),
('KLBF', 'NE', 'North Platte Regional Airport', '41.140000', '-100.680000', 'http://weather.noaa.gov/weather/current/KLBF.html', 'http://weather.gov/data/current_obs/KLBF.rss', 'http://weather.gov/data/current_obs/KLBF.xml'),
('KLCG', 'NE', 'Wayne Municipal Airport', '42.242000', '-96.981000', 'http://weather.noaa.gov/weather/current/KLCG.html', 'http://weather.gov/data/current_obs/KLCG.rss', 'http://weather.gov/data/current_obs/KLCG.xml'),
('KLNK', 'NE', 'Lincoln Municipal Airport', '40.860000', '-96.750000', 'http://weather.noaa.gov/weather/current/KLNK.html', 'http://weather.gov/data/current_obs/KLNK.rss', 'http://weather.gov/data/current_obs/KLNK.xml'),
('KLXN', 'NE', 'Lexington, Jim Kelly Field Airport', '40.780000', '-99.770000', 'http://weather.noaa.gov/weather/current/KLXN.html', 'http://weather.gov/data/current_obs/KLXN.rss', 'http://weather.gov/data/current_obs/KLXN.xml'),
('KMCK', 'NE', 'McCook Municipal Airport', '40.230000', '-100.580000', 'http://weather.noaa.gov/weather/current/KMCK.html', 'http://weather.gov/data/current_obs/KMCK.rss', 'http://weather.gov/data/current_obs/KMCK.xml'),
('KMHN', 'NE', 'Mullen / Hooker County', '42.050000', '-101.067000', 'http://weather.noaa.gov/weather/current/KMHN.html', 'http://weather.gov/data/current_obs/KMHN.rss', 'http://weather.gov/data/current_obs/KMHN.xml'),
('KMLE', 'NE', 'Millard Airport', '41.196000', '-96.112000', 'http://weather.noaa.gov/weather/current/KMLE.html', 'http://weather.gov/data/current_obs/KMLE.rss', 'http://weather.gov/data/current_obs/KMLE.xml'),
('KODX', 'NE', 'Ord, Evelyn Sharp Field Airport', '41.620000', '-98.950000', 'http://weather.noaa.gov/weather/current/KODX.html', 'http://weather.gov/data/current_obs/KODX.rss', 'http://weather.gov/data/current_obs/KODX.xml'),
('KOFF', 'NE', 'Omaha / Offutt Air Force Base', '41.117000', '-95.917000', 'http://weather.noaa.gov/weather/current/KOFF.html', 'http://weather.gov/data/current_obs/KOFF.rss', 'http://weather.gov/data/current_obs/KOFF.xml'),
('KOFK', 'NE', 'Norfolk, Stefan Memorial Airport', '41.980000', '-97.430000', 'http://weather.noaa.gov/weather/current/KOFK.html', 'http://weather.gov/data/current_obs/KOFK.rss', 'http://weather.gov/data/current_obs/KOFK.xml'),
('KOLU', 'NE', 'Columbus Municipal Automatic Weather Observing', '41.460000', '-97.350000', 'http://weather.noaa.gov/weather/current/KOLU.html', 'http://weather.gov/data/current_obs/KOLU.rss', 'http://weather.gov/data/current_obs/KOLU.xml'),
('KOMA', 'NE', 'Omaha, Eppley Airfield', '41.300000', '-95.900000', 'http://weather.noaa.gov/weather/current/KOMA.html', 'http://weather.gov/data/current_obs/KOMA.rss', 'http://weather.gov/data/current_obs/KOMA.xml'),
('KONL', 'NE', 'O Neill (Baker Field)', '42.480000', '-98.680000', 'http://weather.noaa.gov/weather/current/KONL.html', 'http://weather.gov/data/current_obs/KONL.rss', 'http://weather.gov/data/current_obs/KONL.xml'),
('KTIF', 'NE', 'Thomas County Airport', '41.962000', '-100.569000', 'http://weather.noaa.gov/weather/current/KTIF.html', 'http://weather.gov/data/current_obs/KTIF.rss', 'http://weather.gov/data/current_obs/KTIF.xml'),
('KTQE', 'NE', 'Tekamah Municipal Airport', '41.710000', '-96.100000', 'http://weather.noaa.gov/weather/current/KTQE.html', 'http://weather.gov/data/current_obs/KTQE.rss', 'http://weather.gov/data/current_obs/KTQE.xml'),
('KVTN', 'NE', 'Valentine, Miller Field', '42.860000', '-100.550000', 'http://weather.noaa.gov/weather/current/KVTN.html', 'http://weather.gov/data/current_obs/KVTN.rss', 'http://weather.gov/data/current_obs/KVTN.xml'),
('KAIA', 'NE', 'Alliance Municipal Airport', '42.050000', '-102.800000', 'http://weather.noaa.gov/weather/current/KAIA.html', 'http://weather.gov/data/current_obs/KAIA.rss', 'http://weather.gov/data/current_obs/KAIA.xml'),
('KBFF', 'NE', 'Scottsbluff, Heilig Field', '41.880000', '-103.600000', 'http://weather.noaa.gov/weather/current/KBFF.html', 'http://weather.gov/data/current_obs/KBFF.rss', 'http://weather.gov/data/current_obs/KBFF.xml'),
('KCDR', 'NE', 'Chadron Municipal Airport', '42.840000', '-103.080000', 'http://weather.noaa.gov/weather/current/KCDR.html', 'http://weather.gov/data/current_obs/KCDR.rss', 'http://weather.gov/data/current_obs/KCDR.xml'),
('KIBM', 'NE', 'Kimball Municipal Airport', '41.188000', '-103.677000', 'http://weather.noaa.gov/weather/current/KIBM.html', 'http://weather.gov/data/current_obs/KIBM.rss', 'http://weather.gov/data/current_obs/KIBM.xml'),
('KIML', 'NE', 'Imperial Municipal Airport', '40.540000', '-101.630000', 'http://weather.noaa.gov/weather/current/KIML.html', 'http://weather.gov/data/current_obs/KIML.rss', 'http://weather.gov/data/current_obs/KIML.xml'),
('KOGA', 'NE', 'Ogallala, Searle Field Airport', '41.050000', '-101.800000', 'http://weather.noaa.gov/weather/current/KOGA.html', 'http://weather.gov/data/current_obs/KOGA.rss', 'http://weather.gov/data/current_obs/KOGA.xml'),
('KSNY', 'NE', 'Sidney Municipal Airport', '41.110000', '-102.980000', 'http://weather.noaa.gov/weather/current/KSNY.html', 'http://weather.gov/data/current_obs/KSNY.rss', 'http://weather.gov/data/current_obs/KSNY.xml'),
('KK46', 'NE', 'Blair Municipal Airport', '41.418100', '-96.113600', 'http://weather.noaa.gov/weather/current/KK46.html', 'http://weather.gov/data/current_obs/KK46.rss', 'http://weather.gov/data/current_obs/KK46.xml'),
('KPMV', 'NE', 'Plattsmouth Municipal Airport', '40.948400', '-95.917400', 'http://weather.noaa.gov/weather/current/KPMV.html', 'http://weather.gov/data/current_obs/KPMV.rss', 'http://weather.gov/data/current_obs/KPMV.xml'),
('KAFN', 'NH', 'Jaffrey Municipal-Silver Ranch Airport', '42.800000', '-72.000000', 'http://weather.noaa.gov/weather/current/KAFN.html', 'http://weather.gov/data/current_obs/KAFN.rss', 'http://weather.gov/data/current_obs/KAFN.xml'),
('KASH', 'NH', 'Nashua / Boire Field', '42.790000', '-71.520000', 'http://weather.noaa.gov/weather/current/KASH.html', 'http://weather.gov/data/current_obs/KASH.rss', 'http://weather.gov/data/current_obs/KASH.xml'),
('KBML', 'NH', 'Berlin Municipal Airport', '44.590000', '-71.180000', 'http://weather.noaa.gov/weather/current/KBML.html', 'http://weather.gov/data/current_obs/KBML.rss', 'http://weather.gov/data/current_obs/KBML.xml'),
('KCON', 'NH', 'Concord Municipal Airport', '43.210000', '-71.500000', 'http://weather.noaa.gov/weather/current/KCON.html', 'http://weather.gov/data/current_obs/KCON.rss', 'http://weather.gov/data/current_obs/KCON.xml'),
('KDAW', 'NH', 'Rochester, Skyhaven Airport', '43.278000', '-79.922000', 'http://weather.noaa.gov/weather/current/KDAW.html', 'http://weather.gov/data/current_obs/KDAW.rss', 'http://weather.gov/data/current_obs/KDAW.xml'),
('KEEN', 'NH', 'Keene / Dillant Automatic Weather Observing/Report', '42.910000', '-72.270000', 'http://weather.noaa.gov/weather/current/KEEN.html', 'http://weather.gov/data/current_obs/KEEN.rss', 'http://weather.gov/data/current_obs/KEEN.xml'),
('KHIE', 'NH', 'Whitefield, Mount Washington Regional Airport', '44.360000', '-71.530000', 'http://weather.noaa.gov/weather/current/KHIE.html', 'http://weather.gov/data/current_obs/KHIE.rss', 'http://weather.gov/data/current_obs/KHIE.xml'),
('KLCI', 'NH', 'Laconia Municipal Automatic Weather Observing', '43.580000', '-71.430000', 'http://weather.noaa.gov/weather/current/KLCI.html', 'http://weather.gov/data/current_obs/KLCI.rss', 'http://weather.gov/data/current_obs/KLCI.xml'),
('KLEB', 'NH', 'Lebanon Municipal Airport', '43.630000', '-72.300000', 'http://weather.noaa.gov/weather/current/KLEB.html', 'http://weather.gov/data/current_obs/KLEB.rss', 'http://weather.gov/data/current_obs/KLEB.xml'),
('KMHT', 'NH', 'Manchester Airport', '42.940000', '-71.430000', 'http://weather.noaa.gov/weather/current/KMHT.html', 'http://weather.gov/data/current_obs/KMHT.rss', 'http://weather.gov/data/current_obs/KMHT.xml'),
('KMWN', 'NH', 'Mount Washington', '44.280000', '-71.300000', 'http://weather.noaa.gov/weather/current/KMWN.html', 'http://weather.gov/data/current_obs/KMWN.rss', 'http://weather.gov/data/current_obs/KMWN.xml'),
('KPSM', 'NH', 'Pease Air Force Base / Portsmouth', '43.090000', '-70.820000', 'http://weather.noaa.gov/weather/current/KPSM.html', 'http://weather.gov/data/current_obs/KPSM.rss', 'http://weather.gov/data/current_obs/KPSM.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('K1P1', 'NH', 'Plymouth Municipal Airport', '43.780000', '-71.530000', 'http://weather.noaa.gov/weather/current/K1P1.html', 'http://weather.gov/data/current_obs/K1P1.rss', 'http://weather.gov/data/current_obs/K1P1.xml'),
('K12N', 'NJ', 'Aeroflex-Andover Airport', '41.010000', '-74.740000', 'http://weather.noaa.gov/weather/current/K12N.html', 'http://weather.gov/data/current_obs/K12N.rss', 'http://weather.gov/data/current_obs/K12N.xml'),
('KACY', 'NJ', 'Atlantic City International Airport', '39.460000', '-74.570000', 'http://weather.noaa.gov/weather/current/KACY.html', 'http://weather.gov/data/current_obs/KACY.rss', 'http://weather.gov/data/current_obs/KACY.xml'),
('KBLM', 'NJ', 'Belmar-Farmingdale', '40.180000', '-74.130000', 'http://weather.noaa.gov/weather/current/KBLM.html', 'http://weather.gov/data/current_obs/KBLM.rss', 'http://weather.gov/data/current_obs/KBLM.xml'),
('KCDW', 'NJ', 'Caldwell, Essex County Airport', '40.880000', '-74.280000', 'http://weather.noaa.gov/weather/current/KCDW.html', 'http://weather.gov/data/current_obs/KCDW.rss', 'http://weather.gov/data/current_obs/KCDW.xml'),
('KEWR', 'NJ', 'Newark International Airport', '40.710000', '-74.170000', 'http://weather.noaa.gov/weather/current/KEWR.html', 'http://weather.gov/data/current_obs/KEWR.rss', 'http://weather.gov/data/current_obs/KEWR.xml'),
('KFWN', 'NJ', 'Sussex Airport', '41.210000', '-74.630000', 'http://weather.noaa.gov/weather/current/KFWN.html', 'http://weather.gov/data/current_obs/KFWN.rss', 'http://weather.gov/data/current_obs/KFWN.xml'),
('KMIV', 'NJ', 'Millville Municipal Airport', '39.380000', '-75.070000', 'http://weather.noaa.gov/weather/current/KMIV.html', 'http://weather.gov/data/current_obs/KMIV.rss', 'http://weather.gov/data/current_obs/KMIV.xml'),
('KMMU', 'NJ', 'Morristown Municipal', '40.800000', '-74.420000', 'http://weather.noaa.gov/weather/current/KMMU.html', 'http://weather.gov/data/current_obs/KMMU.rss', 'http://weather.gov/data/current_obs/KMMU.xml'),
('KNEL', 'NJ', 'Lakehurst Naval Air Station', '40.040000', '-74.320000', 'http://weather.noaa.gov/weather/current/KNEL.html', 'http://weather.gov/data/current_obs/KNEL.rss', 'http://weather.gov/data/current_obs/KNEL.xml'),
('KSMQ', 'NJ', 'Somerville, Somerset Airport', '40.624000', '-74.669000', 'http://weather.noaa.gov/weather/current/KSMQ.html', 'http://weather.gov/data/current_obs/KSMQ.rss', 'http://weather.gov/data/current_obs/KSMQ.xml'),
('KTEB', 'NJ', 'Teterboro Airport', '40.860000', '-74.050000', 'http://weather.noaa.gov/weather/current/KTEB.html', 'http://weather.gov/data/current_obs/KTEB.rss', 'http://weather.gov/data/current_obs/KTEB.xml'),
('KTTN', 'NJ', 'Trenton, Mercer County Airport', '40.290000', '-74.820000', 'http://weather.noaa.gov/weather/current/KTTN.html', 'http://weather.gov/data/current_obs/KTTN.rss', 'http://weather.gov/data/current_obs/KTTN.xml'),
('KVAY', 'NJ', 'Mount Holly, South Jersey Regional Airport', '39.950000', '-74.840000', 'http://weather.noaa.gov/weather/current/KVAY.html', 'http://weather.gov/data/current_obs/KVAY.rss', 'http://weather.gov/data/current_obs/KVAY.xml'),
('KWRI', 'NJ', 'Mcguire Air Force Base', '40.020000', '-74.600000', 'http://weather.noaa.gov/weather/current/KWRI.html', 'http://weather.gov/data/current_obs/KWRI.rss', 'http://weather.gov/data/current_obs/KWRI.xml'),
('KWWD', 'NJ', 'Wildwood Automatic Weather Observing / Reporting', '39.010000', '-74.900000', 'http://weather.noaa.gov/weather/current/KWWD.html', 'http://weather.gov/data/current_obs/KWWD.rss', 'http://weather.gov/data/current_obs/KWWD.xml'),
('KMJX', 'NJ', 'Robert J. Miller Air Park', '39.927500', '-74.292400', 'http://weather.noaa.gov/weather/current/KMJX.html', 'http://weather.gov/data/current_obs/KMJX.rss', 'http://weather.gov/data/current_obs/KMJX.xml'),
('NWWW', 'NL', 'La Tontouta Nlle-Caledonia', '-22.017000', '166.217000', 'http://weather.noaa.gov/weather/current/NWWW.html', 'http://weather.gov/data/current_obs/NWWW.rss', 'http://weather.gov/data/current_obs/NWWW.xml'),
('K4CR', 'NM', 'Corona/Lincoln', '34.110000', '-105.680000', 'http://weather.noaa.gov/weather/current/K4CR.html', 'http://weather.gov/data/current_obs/K4CR.rss', 'http://weather.gov/data/current_obs/K4CR.xml'),
('K4MY', 'NM', 'Moriarty', '34.980000', '-106.050000', 'http://weather.noaa.gov/weather/current/K4MY.html', 'http://weather.gov/data/current_obs/K4MY.rss', 'http://weather.gov/data/current_obs/K4MY.xml'),
('K4SL', 'NM', 'Torreon', '36.030000', '-106.950000', 'http://weather.noaa.gov/weather/current/K4SL.html', 'http://weather.gov/data/current_obs/K4SL.rss', 'http://weather.gov/data/current_obs/K4SL.xml'),
('KABQ', 'NM', 'Albuquerque Intl Airport', '35.050000', '-106.620000', 'http://weather.noaa.gov/weather/current/KABQ.html', 'http://weather.gov/data/current_obs/KABQ.rss', 'http://weather.gov/data/current_obs/KABQ.xml'),
('KAEG', 'NM', 'Albuquerque/Double Eagle Ii Apt', '35.150000', '-106.800000', 'http://weather.noaa.gov/weather/current/KAEG.html', 'http://weather.gov/data/current_obs/KAEG.rss', 'http://weather.gov/data/current_obs/KAEG.xml'),
('KALM', 'NM', 'Alamogordo-White', '32.840000', '-105.990000', 'http://weather.noaa.gov/weather/current/KALM.html', 'http://weather.gov/data/current_obs/KALM.rss', 'http://weather.gov/data/current_obs/KALM.xml'),
('KATS', 'NM', 'Artesia', '32.850000', '-104.470000', 'http://weather.noaa.gov/weather/current/KATS.html', 'http://weather.gov/data/current_obs/KATS.rss', 'http://weather.gov/data/current_obs/KATS.xml'),
('KCAO', 'NM', 'Clayton Muni(amos)', '36.460000', '-103.150000', 'http://weather.noaa.gov/weather/current/KCAO.html', 'http://weather.gov/data/current_obs/KCAO.rss', 'http://weather.gov/data/current_obs/KCAO.xml'),
('KCNM', 'NM', 'Carlsbad/Cavern Cty', '32.340000', '-104.270000', 'http://weather.noaa.gov/weather/current/KCNM.html', 'http://weather.gov/data/current_obs/KCNM.rss', 'http://weather.gov/data/current_obs/KCNM.xml'),
('KCQC', 'NM', 'Clines Corners', '35.000000', '-105.660000', 'http://weather.noaa.gov/weather/current/KCQC.html', 'http://weather.gov/data/current_obs/KCQC.rss', 'http://weather.gov/data/current_obs/KCQC.xml'),
('KCVN', 'NM', 'Clovis Muni (awos)', '34.430000', '-103.080000', 'http://weather.noaa.gov/weather/current/KCVN.html', 'http://weather.gov/data/current_obs/KCVN.rss', 'http://weather.gov/data/current_obs/KCVN.xml'),
('KCVS', 'NM', 'Cannon AFB/Clovis', '34.390000', '-103.320000', 'http://weather.noaa.gov/weather/current/KCVS.html', 'http://weather.gov/data/current_obs/KCVS.rss', 'http://weather.gov/data/current_obs/KCVS.xml'),
('KDMN', 'NM', 'Deming Municipal', '32.260000', '-107.700000', 'http://weather.noaa.gov/weather/current/KDMN.html', 'http://weather.gov/data/current_obs/KDMN.rss', 'http://weather.gov/data/current_obs/KDMN.xml'),
('KE33', 'NM', 'Chama', '36.910000', '-106.570000', 'http://weather.noaa.gov/weather/current/KE33.html', 'http://weather.gov/data/current_obs/KE33.rss', 'http://weather.gov/data/current_obs/KE33.xml'),
('KFMN', 'NM', 'Farmington Regional', '36.760000', '-108.230000', 'http://weather.noaa.gov/weather/current/KFMN.html', 'http://weather.gov/data/current_obs/KFMN.rss', 'http://weather.gov/data/current_obs/KFMN.xml'),
('KGNT', 'NM', 'Grants-Milan Municipal Airport', '35.180000', '-107.900000', 'http://weather.noaa.gov/weather/current/KGNT.html', 'http://weather.gov/data/current_obs/KGNT.rss', 'http://weather.gov/data/current_obs/KGNT.xml'),
('KGUP', 'NM', 'Gallup Muni/Clarke', '35.530000', '-108.780000', 'http://weather.noaa.gov/weather/current/KGUP.html', 'http://weather.gov/data/current_obs/KGUP.rss', 'http://weather.gov/data/current_obs/KGUP.xml'),
('KHMN', 'NM', 'Holloman AFB', '32.860000', '-106.100000', 'http://weather.noaa.gov/weather/current/KHMN.html', 'http://weather.gov/data/current_obs/KHMN.rss', 'http://weather.gov/data/current_obs/KHMN.xml'),
('KHOB', 'NM', 'Hobbs/Lea Co.', '32.690000', '-103.200000', 'http://weather.noaa.gov/weather/current/KHOB.html', 'http://weather.gov/data/current_obs/KHOB.rss', 'http://weather.gov/data/current_obs/KHOB.xml'),
('KLAM', 'NM', 'Los Alamos Airport', '35.883000', '-106.283000', 'http://weather.noaa.gov/weather/current/KLAM.html', 'http://weather.gov/data/current_obs/KLAM.rss', 'http://weather.gov/data/current_obs/KLAM.xml'),
('KLRU', 'NM', 'Las Cruces Intl Airport', '32.300000', '-106.770000', 'http://weather.noaa.gov/weather/current/KLRU.html', 'http://weather.gov/data/current_obs/KLRU.rss', 'http://weather.gov/data/current_obs/KLRU.xml'),
('KLVS', 'NM', 'Las Vegas Municipal', '35.660000', '-105.150000', 'http://weather.noaa.gov/weather/current/KLVS.html', 'http://weather.gov/data/current_obs/KLVS.rss', 'http://weather.gov/data/current_obs/KLVS.xml'),
('KROW', 'NM', 'Roswell/Industrial', '33.310000', '-104.510000', 'http://weather.noaa.gov/weather/current/KROW.html', 'http://weather.gov/data/current_obs/KROW.rss', 'http://weather.gov/data/current_obs/KROW.xml'),
('KRTN', 'NM', 'Raton Municipal Crews Field', '36.740000', '-104.500000', 'http://weather.noaa.gov/weather/current/KRTN.html', 'http://weather.gov/data/current_obs/KRTN.rss', 'http://weather.gov/data/current_obs/KRTN.xml'),
('KSAF', 'NM', 'Santa Fe County Municipal Airport', '35.620000', '-106.080000', 'http://weather.noaa.gov/weather/current/KSAF.html', 'http://weather.gov/data/current_obs/KSAF.rss', 'http://weather.gov/data/current_obs/KSAF.xml'),
('KSKX', 'NM', 'Taos Muni Apt(awos)', '36.460000', '-105.670000', 'http://weather.noaa.gov/weather/current/KSKX.html', 'http://weather.gov/data/current_obs/KSKX.rss', 'http://weather.gov/data/current_obs/KSKX.xml'),
('KSRR', 'NM', 'Ruidoso Regional', '33.360000', '-105.670000', 'http://weather.noaa.gov/weather/current/KSRR.html', 'http://weather.gov/data/current_obs/KSRR.rss', 'http://weather.gov/data/current_obs/KSRR.xml'),
('KSVC', 'NM', 'Silver City/Grant', '32.640000', '-108.160000', 'http://weather.noaa.gov/weather/current/KSVC.html', 'http://weather.gov/data/current_obs/KSVC.rss', 'http://weather.gov/data/current_obs/KSVC.xml'),
('KTCC', 'NM', 'Tucumcari Municipal', '35.190000', '-103.600000', 'http://weather.noaa.gov/weather/current/KTCC.html', 'http://weather.gov/data/current_obs/KTCC.rss', 'http://weather.gov/data/current_obs/KTCC.xml'),
('KTCS', 'NM', 'Truth Or Consequenc', '33.230000', '-107.270000', 'http://weather.noaa.gov/weather/current/KTCS.html', 'http://weather.gov/data/current_obs/KTCS.rss', 'http://weather.gov/data/current_obs/KTCS.xml'),
('KAXX', 'NM', 'Angel Fire Airport', '36.420000', '-105.290000', 'http://weather.noaa.gov/weather/current/KAXX.html', 'http://weather.gov/data/current_obs/KAXX.rss', 'http://weather.gov/data/current_obs/KAXX.xml'),
('K9BB', 'NV', 'Wells', '41.160000', '-114.970000', 'http://weather.noaa.gov/weather/current/K9BB.html', 'http://weather.gov/data/current_obs/K9BB.rss', 'http://weather.gov/data/current_obs/K9BB.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('KAWH', 'NV', 'Wildhorse Res/Elko', '41.670000', '-115.790000', 'http://weather.noaa.gov/weather/current/KAWH.html', 'http://weather.gov/data/current_obs/KAWH.rss', 'http://weather.gov/data/current_obs/KAWH.xml'),
('KB23', 'NV', 'Battle Mountain', '40.610000', '-116.870000', 'http://weather.noaa.gov/weather/current/KB23.html', 'http://weather.gov/data/current_obs/KB23.rss', 'http://weather.gov/data/current_obs/KB23.xml'),
('KBJN', 'NV', 'Tonopah Range #74 Nellis AFB', '37.617000', '-116.250000', 'http://weather.noaa.gov/weather/current/KBJN.html', 'http://weather.gov/data/current_obs/KBJN.rss', 'http://weather.gov/data/current_obs/KBJN.xml'),
('KDRA', 'NV', 'Mercury/Desert Rock', '36.620000', '-116.020000', 'http://weather.noaa.gov/weather/current/KDRA.html', 'http://weather.gov/data/current_obs/KDRA.rss', 'http://weather.gov/data/current_obs/KDRA.xml'),
('KEKO', 'NV', 'Elko', '40.840000', '-115.780000', 'http://weather.noaa.gov/weather/current/KEKO.html', 'http://weather.gov/data/current_obs/KEKO.rss', 'http://weather.gov/data/current_obs/KEKO.xml'),
('KELY', 'NV', 'Ely/Yelland Field', '39.290000', '-114.850000', 'http://weather.noaa.gov/weather/current/KELY.html', 'http://weather.gov/data/current_obs/KELY.rss', 'http://weather.gov/data/current_obs/KELY.xml'),
('KHND', 'NV', 'Las Vegas-Henerson Airport', '35.976000', '-115.133000', 'http://weather.noaa.gov/weather/current/KHND.html', 'http://weather.gov/data/current_obs/KHND.rss', 'http://weather.gov/data/current_obs/KHND.xml'),
('KHTH', 'NV', 'Hawthorne Municipal Airport', '38.550000', '-118.633000', 'http://weather.noaa.gov/weather/current/KHTH.html', 'http://weather.gov/data/current_obs/KHTH.rss', 'http://weather.gov/data/current_obs/KHTH.xml'),
('KINS', 'NV', 'Indian Srings Aux AFLD Nellis AFB', '36.583000', '-115.667000', 'http://weather.noaa.gov/weather/current/KINS.html', 'http://weather.gov/data/current_obs/KINS.rss', 'http://weather.gov/data/current_obs/KINS.xml'),
('KLAS', 'NV', 'Las Vegas/Mccarran', '36.090000', '-115.170000', 'http://weather.noaa.gov/weather/current/KLAS.html', 'http://weather.gov/data/current_obs/KLAS.rss', 'http://weather.gov/data/current_obs/KLAS.xml'),
('KLOL', 'NV', 'Lovelock/Derby Fld', '40.080000', '-118.550000', 'http://weather.noaa.gov/weather/current/KLOL.html', 'http://weather.gov/data/current_obs/KLOL.rss', 'http://weather.gov/data/current_obs/KLOL.xml'),
('KLSV', 'NV', 'Nellis AFB', '36.230000', '-115.030000', 'http://weather.noaa.gov/weather/current/KLSV.html', 'http://weather.gov/data/current_obs/KLSV.rss', 'http://weather.gov/data/current_obs/KLSV.xml'),
('KNFL', 'NV', 'Fallon Nas', '39.430000', '-118.700000', 'http://weather.noaa.gov/weather/current/KNFL.html', 'http://weather.gov/data/current_obs/KNFL.rss', 'http://weather.gov/data/current_obs/KNFL.xml'),
('KOWY', 'NV', 'Owyhee', '41.950000', '-116.100000', 'http://weather.noaa.gov/weather/current/KOWY.html', 'http://weather.gov/data/current_obs/KOWY.rss', 'http://weather.gov/data/current_obs/KOWY.xml'),
('KP38', 'NV', 'Caliente (amos)', '37.617000', '-114.517000', 'http://weather.noaa.gov/weather/current/KP38.html', 'http://weather.gov/data/current_obs/KP38.rss', 'http://weather.gov/data/current_obs/KP38.xml'),
('KP68', 'NV', 'Eureka (ramos)', '39.510000', '-115.970000', 'http://weather.noaa.gov/weather/current/KP68.html', 'http://weather.gov/data/current_obs/KP68.rss', 'http://weather.gov/data/current_obs/KP68.xml'),
('KRNO', 'NV', 'Reno Tahoe International Airport', '39.510000', '-119.780000', 'http://weather.noaa.gov/weather/current/KRNO.html', 'http://weather.gov/data/current_obs/KRNO.rss', 'http://weather.gov/data/current_obs/KRNO.xml'),
('KTPH', 'NV', 'Tonopah Airport', '38.080000', '-117.080000', 'http://weather.noaa.gov/weather/current/KTPH.html', 'http://weather.gov/data/current_obs/KTPH.rss', 'http://weather.gov/data/current_obs/KTPH.xml'),
('KU31', 'NV', 'Austin', '39.500000', '-117.083000', 'http://weather.noaa.gov/weather/current/KU31.html', 'http://weather.gov/data/current_obs/KU31.rss', 'http://weather.gov/data/current_obs/KU31.xml'),
('KVGT', 'NV', 'North Las Vegas', '36.210000', '-115.200000', 'http://weather.noaa.gov/weather/current/KVGT.html', 'http://weather.gov/data/current_obs/KVGT.rss', 'http://weather.gov/data/current_obs/KVGT.xml'),
('KWMC', 'NV', 'Winnemucca Muni', '40.910000', '-117.800000', 'http://weather.noaa.gov/weather/current/KWMC.html', 'http://weather.gov/data/current_obs/KWMC.rss', 'http://weather.gov/data/current_obs/KWMC.xml'),
('KALB', 'NY', 'Albany International Airport', '42.760000', '-73.800000', 'http://weather.noaa.gov/weather/current/KALB.html', 'http://weather.gov/data/current_obs/KALB.rss', 'http://weather.gov/data/current_obs/KALB.xml'),
('KART', 'NY', 'Watertown International Airport', '44.010000', '-76.020000', 'http://weather.noaa.gov/weather/current/KART.html', 'http://weather.gov/data/current_obs/KART.rss', 'http://weather.gov/data/current_obs/KART.xml'),
('KBGM', 'NY', 'Binghamton Regional Airport', '42.230000', '-75.980000', 'http://weather.noaa.gov/weather/current/KBGM.html', 'http://weather.gov/data/current_obs/KBGM.rss', 'http://weather.gov/data/current_obs/KBGM.xml'),
('KBUF', 'NY', 'Greater Buffalo International Airport', '42.940000', '-78.730000', 'http://weather.noaa.gov/weather/current/KBUF.html', 'http://weather.gov/data/current_obs/KBUF.rss', 'http://weather.gov/data/current_obs/KBUF.xml'),
('KDKK', 'NY', 'Chautauqua County / Dunkirk Airport', '42.500000', '-79.280000', 'http://weather.noaa.gov/weather/current/KDKK.html', 'http://weather.gov/data/current_obs/KDKK.rss', 'http://weather.gov/data/current_obs/KDKK.xml'),
('KDSV', 'NY', 'Dansville Municipal Airport', '42.567000', '-77.717000', 'http://weather.noaa.gov/weather/current/KDSV.html', 'http://weather.gov/data/current_obs/KDSV.rss', 'http://weather.gov/data/current_obs/KDSV.xml'),
('KELM', 'NY', 'Elmira / Corning Regional Airport', '42.180000', '-76.900000', 'http://weather.noaa.gov/weather/current/KELM.html', 'http://weather.gov/data/current_obs/KELM.rss', 'http://weather.gov/data/current_obs/KELM.xml'),
('KELZ', 'NY', 'Wellsville Municipal Airport', '42.100000', '-77.983000', 'http://weather.noaa.gov/weather/current/KELZ.html', 'http://weather.gov/data/current_obs/KELZ.rss', 'http://weather.gov/data/current_obs/KELZ.xml'),
('KFOK', 'NY', 'Westhampton Beach, The Gabreski Airport', '40.840000', '-72.630000', 'http://weather.noaa.gov/weather/current/KFOK.html', 'http://weather.gov/data/current_obs/KFOK.rss', 'http://weather.gov/data/current_obs/KFOK.xml'),
('KFRG', 'NY', 'Farmingdale, Republic Airport', '40.730000', '-73.410000', 'http://weather.noaa.gov/weather/current/KFRG.html', 'http://weather.gov/data/current_obs/KFRG.rss', 'http://weather.gov/data/current_obs/KFRG.xml'),
('KFZY', 'NY', 'Fulton, Oswego County Airport', '43.360000', '-76.390000', 'http://weather.noaa.gov/weather/current/KFZY.html', 'http://weather.gov/data/current_obs/KFZY.rss', 'http://weather.gov/data/current_obs/KFZY.xml'),
('KGFL', 'NY', 'Glens Falls, Warren County Airport', '43.360000', '-73.620000', 'http://weather.noaa.gov/weather/current/KGFL.html', 'http://weather.gov/data/current_obs/KGFL.rss', 'http://weather.gov/data/current_obs/KGFL.xml'),
('KGTB', 'NY', 'Fort Drum / Wheeler-Sack U. S. Army Airfield', '44.050000', '-75.740000', 'http://weather.noaa.gov/weather/current/KGTB.html', 'http://weather.gov/data/current_obs/KGTB.rss', 'http://weather.gov/data/current_obs/KGTB.xml'),
('KHPN', 'NY', 'White Plains, Westchester County Airport', '41.080000', '-73.720000', 'http://weather.noaa.gov/weather/current/KHPN.html', 'http://weather.gov/data/current_obs/KHPN.rss', 'http://weather.gov/data/current_obs/KHPN.xml'),
('KHTO', 'NY', 'East Hampton Airport', '40.980000', '-72.250000', 'http://weather.noaa.gov/weather/current/KHTO.html', 'http://weather.gov/data/current_obs/KHTO.rss', 'http://weather.gov/data/current_obs/KHTO.xml'),
('KHWV', 'NY', 'Shirley, Brookhaven Airport', '40.817000', '-72.867000', 'http://weather.noaa.gov/weather/current/KHWV.html', 'http://weather.gov/data/current_obs/KHWV.rss', 'http://weather.gov/data/current_obs/KHWV.xml'),
('KIAG', 'NY', 'Niagara Falls International Airport', '43.110000', '-78.950000', 'http://weather.noaa.gov/weather/current/KIAG.html', 'http://weather.gov/data/current_obs/KIAG.rss', 'http://weather.gov/data/current_obs/KIAG.xml'),
('KISP', 'NY', 'Islip, Long Island Mac Arthur Airport', '40.800000', '-73.100000', 'http://weather.noaa.gov/weather/current/KISP.html', 'http://weather.gov/data/current_obs/KISP.rss', 'http://weather.gov/data/current_obs/KISP.xml'),
('KITH', 'NY', 'Ithaca / Tompkins County', '42.480000', '-76.470000', 'http://weather.noaa.gov/weather/current/KITH.html', 'http://weather.gov/data/current_obs/KITH.rss', 'http://weather.gov/data/current_obs/KITH.xml'),
('KJFK', 'NY', 'New York/John F. Kennedy Intl Airport', '40.660000', '-73.780000', 'http://weather.noaa.gov/weather/current/KJFK.html', 'http://weather.gov/data/current_obs/KJFK.rss', 'http://weather.gov/data/current_obs/KJFK.xml'),
('KJHW', 'NY', 'Jamestown Automatic Weather Observing / Reporting', '42.160000', '-79.250000', 'http://weather.noaa.gov/weather/current/KJHW.html', 'http://weather.gov/data/current_obs/KJHW.rss', 'http://weather.gov/data/current_obs/KJHW.xml'),
('KLGA', 'NY', 'New York, La Guardia Airport', '40.770000', '-73.900000', 'http://weather.noaa.gov/weather/current/KLGA.html', 'http://weather.gov/data/current_obs/KLGA.rss', 'http://weather.gov/data/current_obs/KLGA.xml'),
('KMGJ', 'NY', 'Montgomery, Orange County Airport', '41.510000', '-74.260000', 'http://weather.noaa.gov/weather/current/KMGJ.html', 'http://weather.gov/data/current_obs/KMGJ.rss', 'http://weather.gov/data/current_obs/KMGJ.xml'),
('KMSS', 'NY', 'Massena International-Richards Field', '44.940000', '-74.850000', 'http://weather.noaa.gov/weather/current/KMSS.html', 'http://weather.gov/data/current_obs/KMSS.rss', 'http://weather.gov/data/current_obs/KMSS.xml'),
('KMSV', 'NY', 'Monticello Automatic Weather Observing / Reporting', '41.710000', '-74.800000', 'http://weather.noaa.gov/weather/current/KMSV.html', 'http://weather.gov/data/current_obs/KMSV.rss', 'http://weather.gov/data/current_obs/KMSV.xml'),
('KMTP', 'NY', 'Montauk Airport', '41.080000', '-71.920000', 'http://weather.noaa.gov/weather/current/KMTP.html', 'http://weather.gov/data/current_obs/KMTP.rss', 'http://weather.gov/data/current_obs/KMTP.xml'),
('KNYC', 'NY', 'New York City, Central Park', '40.783000', '-73.967000', 'http://weather.noaa.gov/weather/current/KNYC.html', 'http://weather.gov/data/current_obs/KNYC.rss', 'http://weather.gov/data/current_obs/KNYC.xml'),
('KPEO', 'NY', 'Penn Yan Airport', '42.650000', '-77.050000', 'http://weather.noaa.gov/weather/current/KPEO.html', 'http://weather.gov/data/current_obs/KPEO.rss', 'http://weather.gov/data/current_obs/KPEO.xml'),
('KRME', 'NY', 'Rome Griffiss Airfield', '43.234000', '-75.407000', 'http://weather.noaa.gov/weather/current/KRME.html', 'http://weather.gov/data/current_obs/KRME.rss', 'http://weather.gov/data/current_obs/KRME.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('KPOU', 'NY', 'Poughkeepsie, Dutchess County Airport', '41.640000', '-73.880000', 'http://weather.noaa.gov/weather/current/KPOU.html', 'http://weather.gov/data/current_obs/KPOU.rss', 'http://weather.gov/data/current_obs/KPOU.xml'),
('KROC', 'NY', 'Greater Rochester International Airport', '43.120000', '-77.670000', 'http://weather.noaa.gov/weather/current/KROC.html', 'http://weather.gov/data/current_obs/KROC.rss', 'http://weather.gov/data/current_obs/KROC.xml'),
('KSCH', 'NY', 'Schenectady Airport', '42.860000', '-73.930000', 'http://weather.noaa.gov/weather/current/KSCH.html', 'http://weather.gov/data/current_obs/KSCH.rss', 'http://weather.gov/data/current_obs/KSCH.xml'),
('KSLK', 'NY', 'Saranac Lake, Adirondack Regional Airport', '44.390000', '-74.200000', 'http://weather.noaa.gov/weather/current/KSLK.html', 'http://weather.gov/data/current_obs/KSLK.rss', 'http://weather.gov/data/current_obs/KSLK.xml'),
('KSWF', 'NY', 'Newburgh / Stewart', '41.510000', '-74.100000', 'http://weather.noaa.gov/weather/current/KSWF.html', 'http://weather.gov/data/current_obs/KSWF.rss', 'http://weather.gov/data/current_obs/KSWF.xml'),
('KSYR', 'NY', 'Syracuse Hancock International Airport', '43.120000', '-76.120000', 'http://weather.noaa.gov/weather/current/KSYR.html', 'http://weather.gov/data/current_obs/KSYR.rss', 'http://weather.gov/data/current_obs/KSYR.xml'),
('KUCA', 'NY', 'Utica, Oneida County Airport', '43.160000', '-75.380000', 'http://weather.noaa.gov/weather/current/KUCA.html', 'http://weather.gov/data/current_obs/KUCA.rss', 'http://weather.gov/data/current_obs/KUCA.xml'),
('KPBG', 'NY', 'Plattsburgh International Airport', '44.650900', '-73.468100', 'http://weather.noaa.gov/weather/current/KPBG.html', 'http://weather.gov/data/current_obs/KPBG.rss', 'http://weather.gov/data/current_obs/KPBG.xml'),
('KAKR', 'OH', 'Akron Fulton International Airport', '41.033000', '-81.467000', 'http://weather.noaa.gov/weather/current/KAKR.html', 'http://weather.gov/data/current_obs/KAKR.rss', 'http://weather.gov/data/current_obs/KAKR.xml'),
('KAOH', 'OH', 'Lima Allen County Airport', '40.710000', '-84.030000', 'http://weather.noaa.gov/weather/current/KAOH.html', 'http://weather.gov/data/current_obs/KAOH.rss', 'http://weather.gov/data/current_obs/KAOH.xml'),
('KBJJ', 'OH', 'Wooster, Wayne County Airport', '40.870000', '-81.890000', 'http://weather.noaa.gov/weather/current/KBJJ.html', 'http://weather.gov/data/current_obs/KBJJ.rss', 'http://weather.gov/data/current_obs/KBJJ.xml'),
('KBKL', 'OH', 'Cleveland/Burke Lakefront', '41.520000', '-81.680000', 'http://weather.noaa.gov/weather/current/KBKL.html', 'http://weather.gov/data/current_obs/KBKL.rss', 'http://weather.gov/data/current_obs/KBKL.xml'),
('KCAK', 'OH', 'Akron-Canton Regional Airport', '40.930000', '-81.430000', 'http://weather.noaa.gov/weather/current/KCAK.html', 'http://weather.gov/data/current_obs/KCAK.rss', 'http://weather.gov/data/current_obs/KCAK.xml'),
('KCGF', 'OH', 'Cleveland / Cuyahoga', '41.580000', '-81.480000', 'http://weather.noaa.gov/weather/current/KCGF.html', 'http://weather.gov/data/current_obs/KCGF.rss', 'http://weather.gov/data/current_obs/KCGF.xml'),
('KCLE', 'OH', 'Cleveland-Hopkins International Airport', '41.430000', '-81.870000', 'http://weather.noaa.gov/weather/current/KCLE.html', 'http://weather.gov/data/current_obs/KCLE.rss', 'http://weather.gov/data/current_obs/KCLE.xml'),
('KCMH', 'OH', 'Port Columbus International Airport', '40.010000', '-82.880000', 'http://weather.noaa.gov/weather/current/KCMH.html', 'http://weather.gov/data/current_obs/KCMH.rss', 'http://weather.gov/data/current_obs/KCMH.xml'),
('KDAY', 'OH', 'Cox Dayton International Airport', '39.910000', '-84.200000', 'http://weather.noaa.gov/weather/current/KDAY.html', 'http://weather.gov/data/current_obs/KDAY.rss', 'http://weather.gov/data/current_obs/KDAY.xml'),
('KDFI', 'OH', 'Defiance Memorial Airport', '41.340000', '-84.430000', 'http://weather.noaa.gov/weather/current/KDFI.html', 'http://weather.gov/data/current_obs/KDFI.rss', 'http://weather.gov/data/current_obs/KDFI.xml'),
('KFDY', 'OH', 'Findlay Airport', '41.030000', '-83.670000', 'http://weather.noaa.gov/weather/current/KFDY.html', 'http://weather.gov/data/current_obs/KFDY.rss', 'http://weather.gov/data/current_obs/KFDY.xml'),
('KFFO', 'OH', 'Dayton / Wright-Patterson Air Force Base', '39.840000', '-84.050000', 'http://weather.noaa.gov/weather/current/KFFO.html', 'http://weather.gov/data/current_obs/KFFO.rss', 'http://weather.gov/data/current_obs/KFFO.xml'),
('KHAO', 'OH', 'Hamilton, Butler County Regional Airport', '39.360000', '-84.520000', 'http://weather.noaa.gov/weather/current/KHAO.html', 'http://weather.gov/data/current_obs/KHAO.rss', 'http://weather.gov/data/current_obs/KHAO.xml'),
('KHZY', 'OH', 'Ashtabula County Airport', '41.779000', '-80.697000', 'http://weather.noaa.gov/weather/current/KHZY.html', 'http://weather.gov/data/current_obs/KHZY.rss', 'http://weather.gov/data/current_obs/KHZY.xml'),
('KILN', 'OH', 'Wilmington, Airborne Airpark Airport', '39.430000', '-83.800000', 'http://weather.noaa.gov/weather/current/KILN.html', 'http://weather.gov/data/current_obs/KILN.rss', 'http://weather.gov/data/current_obs/KILN.xml'),
('KLCK', 'OH', 'Rickenbacker Air National Guard Base', '39.830000', '-82.930000', 'http://weather.noaa.gov/weather/current/KLCK.html', 'http://weather.gov/data/current_obs/KLCK.rss', 'http://weather.gov/data/current_obs/KLCK.xml'),
('KLHQ', 'OH', 'Lancaster, Fairfield County Airport', '39.750000', '-82.670000', 'http://weather.noaa.gov/weather/current/KLHQ.html', 'http://weather.gov/data/current_obs/KLHQ.rss', 'http://weather.gov/data/current_obs/KLHQ.xml'),
('KLPR', 'OH', 'Lorain County Regional Airport', '41.346000', '-82.179000', 'http://weather.noaa.gov/weather/current/KLPR.html', 'http://weather.gov/data/current_obs/KLPR.rss', 'http://weather.gov/data/current_obs/KLPR.xml'),
('KLUK', 'OH', 'Cincinnati Municipal Airport Lunken Field', '39.100000', '-84.420000', 'http://weather.noaa.gov/weather/current/KLUK.html', 'http://weather.gov/data/current_obs/KLUK.rss', 'http://weather.gov/data/current_obs/KLUK.xml'),
('KMFD', 'OH', 'Mansfield Lahm Municipal Airport', '40.830000', '-82.520000', 'http://weather.noaa.gov/weather/current/KMFD.html', 'http://weather.gov/data/current_obs/KMFD.rss', 'http://weather.gov/data/current_obs/KMFD.xml'),
('KMGY', 'OH', 'Dayton General Airport South Airport', '39.590000', '-84.220000', 'http://weather.noaa.gov/weather/current/KMGY.html', 'http://weather.gov/data/current_obs/KMGY.rss', 'http://weather.gov/data/current_obs/KMGY.xml'),
('KMNN', 'OH', 'Marion Municipal Airport', '40.620000', '-83.060000', 'http://weather.noaa.gov/weather/current/KMNN.html', 'http://weather.gov/data/current_obs/KMNN.rss', 'http://weather.gov/data/current_obs/KMNN.xml'),
('KOSU', 'OH', 'Columbus, Ohio State University Airport', '40.090000', '-83.070000', 'http://weather.noaa.gov/weather/current/KOSU.html', 'http://weather.gov/data/current_obs/KOSU.rss', 'http://weather.gov/data/current_obs/KOSU.xml'),
('KPHD', 'OH', 'New Philadelphia, Harry Clever Field', '40.470000', '-81.420000', 'http://weather.noaa.gov/weather/current/KPHD.html', 'http://weather.gov/data/current_obs/KPHD.rss', 'http://weather.gov/data/current_obs/KPHD.xml'),
('KSGH', 'OH', 'Springfield-Beckley Municipal Airport', '39.833000', '-83.833000', 'http://weather.noaa.gov/weather/current/KSGH.html', 'http://weather.gov/data/current_obs/KSGH.rss', 'http://weather.gov/data/current_obs/KSGH.xml'),
('KTDZ', 'OH', 'Toledo, Metcalf Field', '41.560000', '-83.480000', 'http://weather.noaa.gov/weather/current/KTDZ.html', 'http://weather.gov/data/current_obs/KTDZ.rss', 'http://weather.gov/data/current_obs/KTDZ.xml'),
('KTOL', 'OH', 'Toledo Express Airport', '41.610000', '-83.800000', 'http://weather.noaa.gov/weather/current/KTOL.html', 'http://weather.gov/data/current_obs/KTOL.rss', 'http://weather.gov/data/current_obs/KTOL.xml'),
('KTZR', 'OH', 'Columbus, Bolton Field Airport', '39.900000', '-83.130000', 'http://weather.noaa.gov/weather/current/KTZR.html', 'http://weather.gov/data/current_obs/KTZR.rss', 'http://weather.gov/data/current_obs/KTZR.xml'),
('KVTA', 'OH', 'Newark Heath Airport', '40.023000', '-82.462000', 'http://weather.noaa.gov/weather/current/KVTA.html', 'http://weather.gov/data/current_obs/KVTA.rss', 'http://weather.gov/data/current_obs/KVTA.xml'),
('KYNG', 'OH', 'Youngstown-Warren Regional Airport', '41.270000', '-80.670000', 'http://weather.noaa.gov/weather/current/KYNG.html', 'http://weather.gov/data/current_obs/KYNG.rss', 'http://weather.gov/data/current_obs/KYNG.xml'),
('KZZV', 'OH', 'Zanesville Municipal Airport', '39.960000', '-81.900000', 'http://weather.noaa.gov/weather/current/KZZV.html', 'http://weather.gov/data/current_obs/KZZV.rss', 'http://weather.gov/data/current_obs/KZZV.xml'),
('K1F0', 'OK', 'Ardmore Downtown Executive Airport', '34.150000', '-97.120000', 'http://weather.noaa.gov/weather/current/K1F0.html', 'http://weather.gov/data/current_obs/K1F0.rss', 'http://weather.gov/data/current_obs/K1F0.xml'),
('K4O4', 'OK', 'Mc Curtain County Regional Airport', '33.900000', '-94.867000', 'http://weather.noaa.gov/weather/current/K4O4.html', 'http://weather.gov/data/current_obs/K4O4.rss', 'http://weather.gov/data/current_obs/K4O4.xml'),
('KADH', 'OK', 'Ada Municipal Airport', '34.804000', '-96.671000', 'http://weather.noaa.gov/weather/current/KADH.html', 'http://weather.gov/data/current_obs/KADH.rss', 'http://weather.gov/data/current_obs/KADH.xml'),
('KADM', 'OK', 'Ardmore Municipal', '34.300000', '-97.020000', 'http://weather.noaa.gov/weather/current/KADM.html', 'http://weather.gov/data/current_obs/KADM.rss', 'http://weather.gov/data/current_obs/KADM.xml'),
('KAQR', 'OK', 'Atoka Municipal Airport', '34.400000', '-96.150000', 'http://weather.noaa.gov/weather/current/KAQR.html', 'http://weather.gov/data/current_obs/KAQR.rss', 'http://weather.gov/data/current_obs/KAQR.xml'),
('KAVK', 'OK', 'Alva Regional Airport', '36.770000', '-98.670000', 'http://weather.noaa.gov/weather/current/KAVK.html', 'http://weather.gov/data/current_obs/KAVK.rss', 'http://weather.gov/data/current_obs/KAVK.xml'),
('KAXS', 'OK', 'Altus/Quartz Mountain Regional Airport', '34.700000', '-99.333000', 'http://weather.noaa.gov/weather/current/KAXS.html', 'http://weather.gov/data/current_obs/KAXS.rss', 'http://weather.gov/data/current_obs/KAXS.xml'),
('KBVO', 'OK', 'Bartlesville Municipal Airport', '36.760000', '-96.010000', 'http://weather.noaa.gov/weather/current/KBVO.html', 'http://weather.gov/data/current_obs/KBVO.rss', 'http://weather.gov/data/current_obs/KBVO.xml'),
('KCHK', 'OK', 'Chickasha Municipal Airport', '35.100000', '-97.970000', 'http://weather.noaa.gov/weather/current/KCHK.html', 'http://weather.gov/data/current_obs/KCHK.rss', 'http://weather.gov/data/current_obs/KCHK.xml'),
('KCLK', 'OK', 'Clinton Regional Airport', '35.533000', '-98.933000', 'http://weather.noaa.gov/weather/current/KCLK.html', 'http://weather.gov/data/current_obs/KCLK.rss', 'http://weather.gov/data/current_obs/KCLK.xml'),
('KCQB', 'OK', 'Chandler Municipal Airport', '35.720000', '-96.820000', 'http://weather.noaa.gov/weather/current/KCQB.html', 'http://weather.gov/data/current_obs/KCQB.rss', 'http://weather.gov/data/current_obs/KCQB.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('KCSM', 'OK', 'Clinton-Sherman Airport', '35.360000', '-99.200000', 'http://weather.noaa.gov/weather/current/KCSM.html', 'http://weather.gov/data/current_obs/KCSM.rss', 'http://weather.gov/data/current_obs/KCSM.xml'),
('KCUH', 'OK', 'Cushing Municipal Airport', '35.950000', '-96.767000', 'http://weather.noaa.gov/weather/current/KCUH.html', 'http://weather.gov/data/current_obs/KCUH.rss', 'http://weather.gov/data/current_obs/KCUH.xml'),
('KDUA', 'OK', 'Durant/Eaker Field Airport', '33.940000', '-96.390000', 'http://weather.noaa.gov/weather/current/KDUA.html', 'http://weather.gov/data/current_obs/KDUA.rss', 'http://weather.gov/data/current_obs/KDUA.xml'),
('KDUC', 'OK', 'Duncan/Halliburton Field Airport', '34.470000', '-97.960000', 'http://weather.noaa.gov/weather/current/KDUC.html', 'http://weather.gov/data/current_obs/KDUC.rss', 'http://weather.gov/data/current_obs/KDUC.xml'),
('KEND', 'OK', 'Vance Air Force Base / Enid', '36.333000', '-97.917000', 'http://weather.noaa.gov/weather/current/KEND.html', 'http://weather.gov/data/current_obs/KEND.rss', 'http://weather.gov/data/current_obs/KEND.xml'),
('KFDR', 'OK', 'Frederick Municipal Airport', '34.350000', '-98.980000', 'http://weather.noaa.gov/weather/current/KFDR.html', 'http://weather.gov/data/current_obs/KFDR.rss', 'http://weather.gov/data/current_obs/KFDR.xml'),
('KFSI', 'OK', 'Fort Sill', '34.650000', '-98.383000', 'http://weather.noaa.gov/weather/current/KFSI.html', 'http://weather.gov/data/current_obs/KFSI.rss', 'http://weather.gov/data/current_obs/KFSI.xml'),
('KGAG', 'OK', 'Gage Airport', '36.300000', '-99.770000', 'http://weather.noaa.gov/weather/current/KGAG.html', 'http://weather.gov/data/current_obs/KGAG.rss', 'http://weather.gov/data/current_obs/KGAG.xml'),
('KGCM', 'OK', 'Claremore Regional Airport', '36.290000', '-95.480000', 'http://weather.noaa.gov/weather/current/KGCM.html', 'http://weather.gov/data/current_obs/KGCM.rss', 'http://weather.gov/data/current_obs/KGCM.xml'),
('KGMJ', 'OK', 'Grove Municipal Airport', '36.605000', '-94.738000', 'http://weather.noaa.gov/weather/current/KGMJ.html', 'http://weather.gov/data/current_obs/KGMJ.rss', 'http://weather.gov/data/current_obs/KGMJ.xml'),
('KGOK', 'OK', 'Guthrie-Edmond Regional Airport', '35.850000', '-97.420000', 'http://weather.noaa.gov/weather/current/KGOK.html', 'http://weather.gov/data/current_obs/KGOK.rss', 'http://weather.gov/data/current_obs/KGOK.xml'),
('KGUY', 'OK', 'Guymon / Guymon Municipal Airport', '36.690000', '-101.510000', 'http://weather.noaa.gov/weather/current/KGUY.html', 'http://weather.gov/data/current_obs/KGUY.rss', 'http://weather.gov/data/current_obs/KGUY.xml'),
('KHBR', 'OK', 'Hobart Municipal Airport', '35.010000', '-99.050000', 'http://weather.noaa.gov/weather/current/KHBR.html', 'http://weather.gov/data/current_obs/KHBR.rss', 'http://weather.gov/data/current_obs/KHBR.xml'),
('KJSV', 'OK', 'Sallisaw Municipal Airport', '35.440000', '-94.800000', 'http://weather.noaa.gov/weather/current/KJSV.html', 'http://weather.gov/data/current_obs/KJSV.rss', 'http://weather.gov/data/current_obs/KJSV.xml'),
('KJWG', 'OK', 'Watonga Airport', '35.860000', '-98.420000', 'http://weather.noaa.gov/weather/current/KJWG.html', 'http://weather.gov/data/current_obs/KJWG.rss', 'http://weather.gov/data/current_obs/KJWG.xml'),
('KLAW', 'OK', 'Lawton-Fort Sill Regional Airport', '34.570000', '-98.420000', 'http://weather.noaa.gov/weather/current/KLAW.html', 'http://weather.gov/data/current_obs/KLAW.rss', 'http://weather.gov/data/current_obs/KLAW.xml'),
('KLTS', 'OK', 'Altus Air Force Base', '34.800000', '-99.000000', 'http://weather.noaa.gov/weather/current/KLTS.html', 'http://weather.gov/data/current_obs/KLTS.rss', 'http://weather.gov/data/current_obs/KLTS.xml'),
('KMKO', 'OK', 'Muskogee, Davis Field', '35.660000', '-95.360000', 'http://weather.noaa.gov/weather/current/KMKO.html', 'http://weather.gov/data/current_obs/KMKO.rss', 'http://weather.gov/data/current_obs/KMKO.xml'),
('KMLC', 'OK', 'McAlester Regional Airport', '34.890000', '-95.780000', 'http://weather.noaa.gov/weather/current/KMLC.html', 'http://weather.gov/data/current_obs/KMLC.rss', 'http://weather.gov/data/current_obs/KMLC.xml'),
('KOKC', 'OK', 'Oklahoma City, Will Rogers World Airport', '35.410000', '-97.600000', 'http://weather.noaa.gov/weather/current/KOKC.html', 'http://weather.gov/data/current_obs/KOKC.rss', 'http://weather.gov/data/current_obs/KOKC.xml'),
('KOKM', 'OK', 'Okmulgee Regional Airport', '35.670000', '-95.950000', 'http://weather.noaa.gov/weather/current/KOKM.html', 'http://weather.gov/data/current_obs/KOKM.rss', 'http://weather.gov/data/current_obs/KOKM.xml'),
('KOUN', 'OK', 'Norman / Max Westheimer', '35.246000', '-97.472000', 'http://weather.noaa.gov/weather/current/KOUN.html', 'http://weather.gov/data/current_obs/KOUN.rss', 'http://weather.gov/data/current_obs/KOUN.xml'),
('KPNC', 'OK', 'Ponca City Municipal Airport', '36.730000', '-97.100000', 'http://weather.noaa.gov/weather/current/KPNC.html', 'http://weather.gov/data/current_obs/KPNC.rss', 'http://weather.gov/data/current_obs/KPNC.xml'),
('KPVJ', 'OK', 'Pauls Valley Municipal Airport', '34.711000', '-97.223000', 'http://weather.noaa.gov/weather/current/KPVJ.html', 'http://weather.gov/data/current_obs/KPVJ.rss', 'http://weather.gov/data/current_obs/KPVJ.xml'),
('KPWA', 'OK', 'Oklahoma City, Wiley Post Airport', '35.540000', '-97.650000', 'http://weather.noaa.gov/weather/current/KPWA.html', 'http://weather.gov/data/current_obs/KPWA.rss', 'http://weather.gov/data/current_obs/KPWA.xml'),
('KRKR', 'OK', 'Poteau/Robert S. Kerr Airport', '35.022000', '-94.621000', 'http://weather.noaa.gov/weather/current/KRKR.html', 'http://weather.gov/data/current_obs/KRKR.rss', 'http://weather.gov/data/current_obs/KRKR.xml'),
('KRVS', 'OK', 'Tulsa, Jones Jr. Airport', '36.040000', '-95.980000', 'http://weather.noaa.gov/weather/current/KRVS.html', 'http://weather.gov/data/current_obs/KRVS.rss', 'http://weather.gov/data/current_obs/KRVS.xml'),
('KSNL', 'OK', 'Shawnee Municipal Airport', '35.360000', '-96.940000', 'http://weather.noaa.gov/weather/current/KSNL.html', 'http://weather.gov/data/current_obs/KSNL.rss', 'http://weather.gov/data/current_obs/KSNL.xml'),
('KSWO', 'OK', 'Stillwater Regional Airport', '36.160000', '-97.090000', 'http://weather.noaa.gov/weather/current/KSWO.html', 'http://weather.gov/data/current_obs/KSWO.rss', 'http://weather.gov/data/current_obs/KSWO.xml'),
('KTIK', 'OK', 'Tinker Air Force Base', '35.417000', '-97.383000', 'http://weather.noaa.gov/weather/current/KTIK.html', 'http://weather.gov/data/current_obs/KTIK.rss', 'http://weather.gov/data/current_obs/KTIK.xml'),
('KTQH', 'OK', 'Tahlequah Municipal Airport', '35.930000', '-95.000000', 'http://weather.noaa.gov/weather/current/KTQH.html', 'http://weather.gov/data/current_obs/KTQH.rss', 'http://weather.gov/data/current_obs/KTQH.xml'),
('KTUL', 'OK', 'Tulsa International Airport', '36.210000', '-95.900000', 'http://weather.noaa.gov/weather/current/KTUL.html', 'http://weather.gov/data/current_obs/KTUL.rss', 'http://weather.gov/data/current_obs/KTUL.xml'),
('KWDG', 'OK', 'Enid / Woodring Municipal', '36.390000', '-97.800000', 'http://weather.noaa.gov/weather/current/KWDG.html', 'http://weather.gov/data/current_obs/KWDG.rss', 'http://weather.gov/data/current_obs/KWDG.xml'),
('KWWR', 'OK', 'West Woodward', '36.440000', '-99.520000', 'http://weather.noaa.gov/weather/current/KWWR.html', 'http://weather.gov/data/current_obs/KWWR.rss', 'http://weather.gov/data/current_obs/KWWR.xml'),
('KSRE', 'OK', 'Seminole Municipal Airport', '35.274400', '-96.675000', 'http://weather.noaa.gov/weather/current/KSRE.html', 'http://weather.gov/data/current_obs/KSRE.rss', 'http://weather.gov/data/current_obs/KSRE.xml'),
('KONO', 'OR', 'Ontario Municipal', '44.020000', '-117.010000', 'http://weather.noaa.gov/weather/current/KONO.html', 'http://weather.gov/data/current_obs/KONO.rss', 'http://weather.gov/data/current_obs/KONO.xml'),
('KREO', 'OR', 'Rome', '42.580000', '-117.890000', 'http://weather.noaa.gov/weather/current/KREO.html', 'http://weather.gov/data/current_obs/KREO.rss', 'http://weather.gov/data/current_obs/KREO.xml'),
('K4BK', 'OR', 'Brookings', '42.050000', '-124.283000', 'http://weather.noaa.gov/weather/current/K4BK.html', 'http://weather.gov/data/current_obs/K4BK.rss', 'http://weather.gov/data/current_obs/K4BK.xml'),
('K5J0', 'OR', 'John Day State Arpt', '44.420000', '-118.950000', 'http://weather.noaa.gov/weather/current/K5J0.html', 'http://weather.gov/data/current_obs/K5J0.rss', 'http://weather.gov/data/current_obs/K5J0.xml'),
('K92S', 'OR', 'Cape Blanco (cgs)', '42.833000', '-124.567000', 'http://weather.noaa.gov/weather/current/K92S.html', 'http://weather.gov/data/current_obs/K92S.rss', 'http://weather.gov/data/current_obs/K92S.xml'),
('KAST', 'OR', 'Astoria/Clatsop', '46.160000', '-123.880000', 'http://weather.noaa.gov/weather/current/KAST.html', 'http://weather.gov/data/current_obs/KAST.rss', 'http://weather.gov/data/current_obs/KAST.xml'),
('KBKE', 'OR', 'Baker Municipal', '44.840000', '-117.820000', 'http://weather.noaa.gov/weather/current/KBKE.html', 'http://weather.gov/data/current_obs/KBKE.rss', 'http://weather.gov/data/current_obs/KBKE.xml'),
('KBNO', 'OR', 'Burns Muni (amos)', '43.580000', '-118.950000', 'http://weather.noaa.gov/weather/current/KBNO.html', 'http://weather.gov/data/current_obs/KBNO.rss', 'http://weather.gov/data/current_obs/KBNO.xml'),
('KBOK', 'OR', 'Brookings Airport', '42.083000', '-124.283000', 'http://weather.noaa.gov/weather/current/KBOK.html', 'http://weather.gov/data/current_obs/KBOK.rss', 'http://weather.gov/data/current_obs/KBOK.xml'),
('KCVO', 'OR', 'Corvallis Muni Awos', '44.510000', '-123.290000', 'http://weather.noaa.gov/weather/current/KCVO.html', 'http://weather.gov/data/current_obs/KCVO.rss', 'http://weather.gov/data/current_obs/KCVO.xml'),
('KCZK', 'OR', 'Cascade Locks State', '45.690000', '-121.880000', 'http://weather.noaa.gov/weather/current/KCZK.html', 'http://weather.gov/data/current_obs/KCZK.rss', 'http://weather.gov/data/current_obs/KCZK.xml'),
('KDLS', 'OR', 'The Dalles Muni', '45.620000', '-121.150000', 'http://weather.noaa.gov/weather/current/KDLS.html', 'http://weather.gov/data/current_obs/KDLS.rss', 'http://weather.gov/data/current_obs/KDLS.xml'),
('KEUG', 'OR', 'Eugene/Mahlon Sweet', '44.120000', '-123.220000', 'http://weather.noaa.gov/weather/current/KEUG.html', 'http://weather.gov/data/current_obs/KEUG.rss', 'http://weather.gov/data/current_obs/KEUG.xml'),
('KHIO', 'OR', 'Portland/Hillsboro', '45.540000', '-122.950000', 'http://weather.noaa.gov/weather/current/KHIO.html', 'http://weather.gov/data/current_obs/KHIO.rss', 'http://weather.gov/data/current_obs/KHIO.xml'),
('KHRI', 'OR', 'Hermiston (was S22)', '45.826000', '-119.261000', 'http://weather.noaa.gov/weather/current/KHRI.html', 'http://weather.gov/data/current_obs/KHRI.rss', 'http://weather.gov/data/current_obs/KHRI.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('KJNW', 'OR', 'Newport', '44.583000', '-124.067000', 'http://weather.noaa.gov/weather/current/KJNW.html', 'http://weather.gov/data/current_obs/KJNW.rss', 'http://weather.gov/data/current_obs/KJNW.xml'),
('KLGD', 'OR', 'La Grande (awos)', '45.283000', '-118.000000', 'http://weather.noaa.gov/weather/current/KLGD.html', 'http://weather.gov/data/current_obs/KLGD.rss', 'http://weather.gov/data/current_obs/KLGD.xml'),
('KLKV', 'OR', 'Lakeview (awos)', '42.190000', '-120.350000', 'http://weather.noaa.gov/weather/current/KLKV.html', 'http://weather.gov/data/current_obs/KLKV.rss', 'http://weather.gov/data/current_obs/KLKV.xml'),
('KLMT', 'OR', 'Klamath Falls/Kings', '42.160000', '-121.730000', 'http://weather.noaa.gov/weather/current/KLMT.html', 'http://weather.gov/data/current_obs/KLMT.rss', 'http://weather.gov/data/current_obs/KLMT.xml'),
('KMEH', 'OR', 'Meacham (amos)', '45.510000', '-118.400000', 'http://weather.noaa.gov/weather/current/KMEH.html', 'http://weather.gov/data/current_obs/KMEH.rss', 'http://weather.gov/data/current_obs/KMEH.xml'),
('KMFR', 'OR', 'Medford/Jackson Co.', '42.380000', '-122.870000', 'http://weather.noaa.gov/weather/current/KMFR.html', 'http://weather.gov/data/current_obs/KMFR.rss', 'http://weather.gov/data/current_obs/KMFR.xml'),
('KMMV', 'OR', 'Mcminnville Municipal Airport', '45.190000', '-123.140000', 'http://weather.noaa.gov/weather/current/KMMV.html', 'http://weather.gov/data/current_obs/KMMV.rss', 'http://weather.gov/data/current_obs/KMMV.xml'),
('KONP', 'OR', 'Newport Municip', '44.580000', '-124.050000', 'http://weather.noaa.gov/weather/current/KONP.html', 'http://weather.gov/data/current_obs/KONP.rss', 'http://weather.gov/data/current_obs/KONP.xml'),
('KOTH', 'OR', 'North Bend (awos)', '43.430000', '-124.250000', 'http://weather.noaa.gov/weather/current/KOTH.html', 'http://weather.gov/data/current_obs/KOTH.rss', 'http://weather.gov/data/current_obs/KOTH.xml'),
('KPDT', 'OR', 'Pendleton Municipal', '45.690000', '-118.850000', 'http://weather.noaa.gov/weather/current/KPDT.html', 'http://weather.gov/data/current_obs/KPDT.rss', 'http://weather.gov/data/current_obs/KPDT.xml'),
('KPDX', 'OR', 'Portland Intl Arpt', '45.610000', '-122.600000', 'http://weather.noaa.gov/weather/current/KPDX.html', 'http://weather.gov/data/current_obs/KPDX.rss', 'http://weather.gov/data/current_obs/KPDX.xml'),
('KRBG', 'OR', 'Roseburg Municipal', '43.230000', '-123.370000', 'http://weather.noaa.gov/weather/current/KRBG.html', 'http://weather.gov/data/current_obs/KRBG.rss', 'http://weather.gov/data/current_obs/KRBG.xml'),
('KRDM', 'OR', 'Redmond (awos)', '44.280000', '-121.150000', 'http://weather.noaa.gov/weather/current/KRDM.html', 'http://weather.gov/data/current_obs/KRDM.rss', 'http://weather.gov/data/current_obs/KRDM.xml'),
('KS47', 'OR', 'Tillamook Municipal Airport', '45.417000', '-123.817000', 'http://weather.noaa.gov/weather/current/KS47.html', 'http://weather.gov/data/current_obs/KS47.rss', 'http://weather.gov/data/current_obs/KS47.xml'),
('KSLE', 'OR', 'Salem/Mcnary', '44.930000', '-123.020000', 'http://weather.noaa.gov/weather/current/KSLE.html', 'http://weather.gov/data/current_obs/KSLE.rss', 'http://weather.gov/data/current_obs/KSLE.xml'),
('KSPB', 'OR', 'Scappoose Industrial Apk (1s4)', '45.769000', '-122.862000', 'http://weather.noaa.gov/weather/current/KSPB.html', 'http://weather.gov/data/current_obs/KSPB.rss', 'http://weather.gov/data/current_obs/KSPB.xml'),
('KSXT', 'OR', 'Sexton Summit(amos)', '42.620000', '-123.370000', 'http://weather.noaa.gov/weather/current/KSXT.html', 'http://weather.gov/data/current_obs/KSXT.rss', 'http://weather.gov/data/current_obs/KSXT.xml'),
('KTTD', 'OR', 'Portland/Troutdale', '45.550000', '-122.400000', 'http://weather.noaa.gov/weather/current/KTTD.html', 'http://weather.gov/data/current_obs/KTTD.rss', 'http://weather.gov/data/current_obs/KTTD.xml'),
('KUAO', 'OR', 'Aurora State', '45.250000', '-122.770000', 'http://weather.noaa.gov/weather/current/KUAO.html', 'http://weather.gov/data/current_obs/KUAO.rss', 'http://weather.gov/data/current_obs/KUAO.xml'),
('KMPO', 'PA', 'Pocono Mountains Municipal Airport', '41.140000', '-75.380000', 'http://weather.noaa.gov/weather/current/KMPO.html', 'http://weather.gov/data/current_obs/KMPO.rss', 'http://weather.gov/data/current_obs/KMPO.xml'),
('KABE', 'PA', 'Allentown Lehigh Valley International Airport', '40.660000', '-75.430000', 'http://weather.noaa.gov/weather/current/KABE.html', 'http://weather.gov/data/current_obs/KABE.rss', 'http://weather.gov/data/current_obs/KABE.xml'),
('KAFJ', 'PA', 'Washington Automatic Weather Observing / Reporting', '40.140000', '-80.290000', 'http://weather.noaa.gov/weather/current/KAFJ.html', 'http://weather.gov/data/current_obs/KAFJ.rss', 'http://weather.gov/data/current_obs/KAFJ.xml'),
('KAGC', 'PA', 'Pittsburgh, Allegheny County Airport', '40.360000', '-79.940000', 'http://weather.noaa.gov/weather/current/KAGC.html', 'http://weather.gov/data/current_obs/KAGC.rss', 'http://weather.gov/data/current_obs/KAGC.xml'),
('KAOO', 'PA', 'Altoona-Blair County Airport', '40.300000', '-78.320000', 'http://weather.noaa.gov/weather/current/KAOO.html', 'http://weather.gov/data/current_obs/KAOO.rss', 'http://weather.gov/data/current_obs/KAOO.xml'),
('KAVP', 'PA', 'Wilkes-Barre / Scranton Intl Airport', '41.330000', '-75.730000', 'http://weather.noaa.gov/weather/current/KAVP.html', 'http://weather.gov/data/current_obs/KAVP.rss', 'http://weather.gov/data/current_obs/KAVP.xml'),
('KBFD', 'PA', 'Bradford Regional Airport', '41.800000', '-78.640000', 'http://weather.noaa.gov/weather/current/KBFD.html', 'http://weather.gov/data/current_obs/KBFD.rss', 'http://weather.gov/data/current_obs/KBFD.xml'),
('KBTP', 'PA', 'Butler County Automatic Weather Observing / Report', '40.790000', '-79.950000', 'http://weather.noaa.gov/weather/current/KBTP.html', 'http://weather.gov/data/current_obs/KBTP.rss', 'http://weather.gov/data/current_obs/KBTP.xml'),
('KBVI', 'PA', 'Beaver Falls Airport', '40.760000', '-80.330000', 'http://weather.noaa.gov/weather/current/KBVI.html', 'http://weather.gov/data/current_obs/KBVI.rss', 'http://weather.gov/data/current_obs/KBVI.xml'),
('KCXY', 'PA', 'Harrisburg, Capital City Airport', '40.230000', '-76.850000', 'http://weather.noaa.gov/weather/current/KCXY.html', 'http://weather.gov/data/current_obs/KCXY.rss', 'http://weather.gov/data/current_obs/KCXY.xml'),
('KDUJ', 'PA', 'Du Bois-Jefferson County Airport', '41.190000', '-78.900000', 'http://weather.noaa.gov/weather/current/KDUJ.html', 'http://weather.gov/data/current_obs/KDUJ.rss', 'http://weather.gov/data/current_obs/KDUJ.xml'),
('KDYL', 'PA', 'Doylestown Airport', '40.330000', '-75.120000', 'http://weather.noaa.gov/weather/current/KDYL.html', 'http://weather.gov/data/current_obs/KDYL.rss', 'http://weather.gov/data/current_obs/KDYL.xml'),
('KERI', 'PA', 'Erie International Airport', '42.080000', '-80.180000', 'http://weather.noaa.gov/weather/current/KERI.html', 'http://weather.gov/data/current_obs/KERI.rss', 'http://weather.gov/data/current_obs/KERI.xml'),
('KFIG', 'PA', 'Clearfield-Lawrence Airport', '41.047000', '-78.412000', 'http://weather.noaa.gov/weather/current/KFIG.html', 'http://weather.gov/data/current_obs/KFIG.rss', 'http://weather.gov/data/current_obs/KFIG.xml'),
('KFKL', 'PA', 'Franklin Automatic Weather Observing / Reporting', '41.390000', '-79.870000', 'http://weather.noaa.gov/weather/current/KFKL.html', 'http://weather.gov/data/current_obs/KFKL.rss', 'http://weather.gov/data/current_obs/KFKL.xml'),
('KGKJ', 'PA', 'Port Meadville Airport', '41.620000', '-80.210000', 'http://weather.noaa.gov/weather/current/KGKJ.html', 'http://weather.gov/data/current_obs/KGKJ.rss', 'http://weather.gov/data/current_obs/KGKJ.xml'),
('KIDI', 'PA', 'Indiana / Stewart Field', '40.630000', '-79.100000', 'http://weather.noaa.gov/weather/current/KIDI.html', 'http://weather.gov/data/current_obs/KIDI.rss', 'http://weather.gov/data/current_obs/KIDI.xml'),
('KIPT', 'PA', 'Williamsport-Lycoming County Airport', '41.260000', '-76.920000', 'http://weather.noaa.gov/weather/current/KIPT.html', 'http://weather.gov/data/current_obs/KIPT.rss', 'http://weather.gov/data/current_obs/KIPT.xml'),
('KJST', 'PA', 'Johnstown-Cambria County Airport', '40.330000', '-78.830000', 'http://weather.noaa.gov/weather/current/KJST.html', 'http://weather.gov/data/current_obs/KJST.rss', 'http://weather.gov/data/current_obs/KJST.xml'),
('KLBE', 'PA', 'Latrobe/Westmoreland', '40.290000', '-79.400000', 'http://weather.noaa.gov/weather/current/KLBE.html', 'http://weather.gov/data/current_obs/KLBE.rss', 'http://weather.gov/data/current_obs/KLBE.xml'),
('KLNS', 'PA', 'Lancaster Airport', '40.120000', '-76.300000', 'http://weather.noaa.gov/weather/current/KLNS.html', 'http://weather.gov/data/current_obs/KLNS.rss', 'http://weather.gov/data/current_obs/KLNS.xml'),
('KLOM', 'PA', 'Wings Field Airport', '40.138000', '-75.265000', 'http://weather.noaa.gov/weather/current/KLOM.html', 'http://weather.gov/data/current_obs/KLOM.rss', 'http://weather.gov/data/current_obs/KLOM.xml'),
('KMDT', 'PA', 'Harrisburg International Airport', '40.210000', '-76.770000', 'http://weather.noaa.gov/weather/current/KMDT.html', 'http://weather.gov/data/current_obs/KMDT.rss', 'http://weather.gov/data/current_obs/KMDT.xml'),
('KMUI', 'PA', 'Muir Army Air Field / Indiantown', '40.440000', '-76.570000', 'http://weather.noaa.gov/weather/current/KMUI.html', 'http://weather.gov/data/current_obs/KMUI.rss', 'http://weather.gov/data/current_obs/KMUI.xml'),
('KNXX', 'PA', 'Willow Grove, Naval Air Station', '40.190000', '-75.130000', 'http://weather.noaa.gov/weather/current/KNXX.html', 'http://weather.gov/data/current_obs/KNXX.rss', 'http://weather.gov/data/current_obs/KNXX.xml'),
('KPHL', 'PA', 'Philadelphia International Airport', '39.890000', '-75.250000', 'http://weather.noaa.gov/weather/current/KPHL.html', 'http://weather.gov/data/current_obs/KPHL.rss', 'http://weather.gov/data/current_obs/KPHL.xml'),
('KPIT', 'PA', 'Pittsburgh International Airport', '40.510000', '-80.220000', 'http://weather.noaa.gov/weather/current/KPIT.html', 'http://weather.gov/data/current_obs/KPIT.rss', 'http://weather.gov/data/current_obs/KPIT.xml'),
('KPNE', 'PA', 'Northeast Philadelphia Airport', '40.090000', '-75.020000', 'http://weather.noaa.gov/weather/current/KPNE.html', 'http://weather.gov/data/current_obs/KPNE.rss', 'http://weather.gov/data/current_obs/KPNE.xml'),
('KPTW', 'PA', 'Pottstown Limerick Airport', '40.240000', '-75.560000', 'http://weather.noaa.gov/weather/current/KPTW.html', 'http://weather.gov/data/current_obs/KPTW.rss', 'http://weather.gov/data/current_obs/KPTW.xml'),
('KRDG', 'PA', 'Reading Regional/Carl A. Spaatz Field Airport', '40.390000', '-75.970000', 'http://weather.noaa.gov/weather/current/KRDG.html', 'http://weather.gov/data/current_obs/KRDG.rss', 'http://weather.gov/data/current_obs/KRDG.xml'),
('KSEG', 'PA', 'Selinsgrove, Penn Valley Airport', '40.820000', '-76.860000', 'http://weather.noaa.gov/weather/current/KSEG.html', 'http://weather.gov/data/current_obs/KSEG.rss', 'http://weather.gov/data/current_obs/KSEG.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('KTHV', 'PA', 'York Airport', '39.920000', '-76.870000', 'http://weather.noaa.gov/weather/current/KTHV.html', 'http://weather.gov/data/current_obs/KTHV.rss', 'http://weather.gov/data/current_obs/KTHV.xml'),
('KUKT', 'PA', 'Quakertown Airport', '40.435000', '-75.382000', 'http://weather.noaa.gov/weather/current/KUKT.html', 'http://weather.gov/data/current_obs/KUKT.rss', 'http://weather.gov/data/current_obs/KUKT.xml'),
('KUNV', 'PA', 'State College', '40.860000', '-77.830000', 'http://weather.noaa.gov/weather/current/KUNV.html', 'http://weather.gov/data/current_obs/KUNV.rss', 'http://weather.gov/data/current_obs/KUNV.xml'),
('NTAA', 'PF', 'Tahiti-Faaa', '-17.550000', '-149.617000', 'http://weather.noaa.gov/weather/current/NTAA.html', 'http://weather.gov/data/current_obs/NTAA.rss', 'http://weather.gov/data/current_obs/NTAA.xml'),
('TDPD', 'PR', 'Melville Hall Airport', '15.533000', '-61.300000', 'http://weather.noaa.gov/weather/current/TDPD.html', 'http://weather.gov/data/current_obs/TDPD.rss', 'http://weather.gov/data/current_obs/TDPD.xml'),
('TFFR', 'PR', 'La Raizet Guadeloupe', '16.267000', '-61.600000', 'http://weather.noaa.gov/weather/current/TFFR.html', 'http://weather.gov/data/current_obs/TFFR.rss', 'http://weather.gov/data/current_obs/TFFR.xml'),
('TJBQ', 'PR', 'Aquadilla (Boriquen)', '18.500000', '-67.130000', 'http://weather.noaa.gov/weather/current/TJBQ.html', 'http://weather.gov/data/current_obs/TJBQ.rss', 'http://weather.gov/data/current_obs/TJBQ.xml'),
('TJMZ', 'PR', 'Mayaguez', '18.270000', '-67.150000', 'http://weather.noaa.gov/weather/current/TJMZ.html', 'http://weather.gov/data/current_obs/TJMZ.rss', 'http://weather.gov/data/current_obs/TJMZ.xml'),
('TJNR', 'PR', 'Roosevelt Roads Naval Station', '18.250000', '-65.633000', 'http://weather.noaa.gov/weather/current/TJNR.html', 'http://weather.gov/data/current_obs/TJNR.rss', 'http://weather.gov/data/current_obs/TJNR.xml'),
('TJPS', 'PR', 'Ponce', '18.020000', '-66.570000', 'http://weather.noaa.gov/weather/current/TJPS.html', 'http://weather.gov/data/current_obs/TJPS.rss', 'http://weather.gov/data/current_obs/TJPS.xml'),
('TJSJ', 'PR', 'Luiz Munoz International Airport', '18.430000', '-66.000000', 'http://weather.noaa.gov/weather/current/TJSJ.html', 'http://weather.gov/data/current_obs/TJSJ.rss', 'http://weather.gov/data/current_obs/TJSJ.xml'),
('TNCB', 'PR', 'Bonaire/Flamingo', '12.150000', '-68.283000', 'http://weather.noaa.gov/weather/current/TNCB.html', 'http://weather.gov/data/current_obs/TNCB.rss', 'http://weather.gov/data/current_obs/TNCB.xml'),
('TNCC', 'PR', 'Curacao/Aeropuerto Hato', '12.200000', '-68.967000', 'http://weather.noaa.gov/weather/current/TNCC.html', 'http://weather.gov/data/current_obs/TNCC.rss', 'http://weather.gov/data/current_obs/TNCC.xml'),
('TNCE', 'PR', 'St. Eustatius/F.D.Roosevelt', '17.483000', '-62.983000', 'http://weather.noaa.gov/weather/current/TNCE.html', 'http://weather.gov/data/current_obs/TNCE.rss', 'http://weather.gov/data/current_obs/TNCE.xml'),
('TNCM', 'PR', 'St. Maarten/Princess Juliana', '18.033000', '-63.117000', 'http://weather.noaa.gov/weather/current/TNCM.html', 'http://weather.gov/data/current_obs/TNCM.rss', 'http://weather.gov/data/current_obs/TNCM.xml'),
('TXKF', 'PR', 'Burmuda', '32.367000', '-64.683000', 'http://weather.noaa.gov/weather/current/TXKF.html', 'http://weather.gov/data/current_obs/TXKF.rss', 'http://weather.gov/data/current_obs/TXKF.xml'),
('PTKR', 'PW', 'Koror', '7.270000', '134.450000', 'http://weather.noaa.gov/weather/current/PTKR.html', 'http://weather.gov/data/current_obs/PTKR.rss', 'http://weather.gov/data/current_obs/PTKR.xml'),
('PTRO', 'PW', 'Babelthuap/Koror', '7.330000', '134.480000', 'http://weather.noaa.gov/weather/current/PTRO.html', 'http://weather.gov/data/current_obs/PTRO.rss', 'http://weather.gov/data/current_obs/PTRO.xml'),
('KBID', 'RI', 'Block Island Automatic Weather Observing / Report', '41.180000', '-71.580000', 'http://weather.noaa.gov/weather/current/KBID.html', 'http://weather.gov/data/current_obs/KBID.rss', 'http://weather.gov/data/current_obs/KBID.xml'),
('KOQU', 'RI', 'North Kingstown/Quonset State', '41.610000', '-71.420000', 'http://weather.noaa.gov/weather/current/KOQU.html', 'http://weather.gov/data/current_obs/KOQU.rss', 'http://weather.gov/data/current_obs/KOQU.xml'),
('KPVD', 'RI', 'Providence, Green State Airport', '41.730000', '-71.430000', 'http://weather.noaa.gov/weather/current/KPVD.html', 'http://weather.gov/data/current_obs/KPVD.rss', 'http://weather.gov/data/current_obs/KPVD.xml'),
('KSFZ', 'RI', 'Smithfield', '41.910000', '-71.400000', 'http://weather.noaa.gov/weather/current/KSFZ.html', 'http://weather.gov/data/current_obs/KSFZ.rss', 'http://weather.gov/data/current_obs/KSFZ.xml'),
('KUUU', 'RI', 'Newport State Airport', '41.540000', '-71.280000', 'http://weather.noaa.gov/weather/current/KUUU.html', 'http://weather.gov/data/current_obs/KUUU.rss', 'http://weather.gov/data/current_obs/KUUU.xml'),
('KWST', 'RI', 'Westerly State Airport', '41.350000', '-71.800000', 'http://weather.noaa.gov/weather/current/KWST.html', 'http://weather.gov/data/current_obs/KWST.rss', 'http://weather.gov/data/current_obs/KWST.xml'),
('KAND', 'SC', 'Anderson County Airport', '34.510000', '-82.720000', 'http://weather.noaa.gov/weather/current/KAND.html', 'http://weather.gov/data/current_obs/KAND.rss', 'http://weather.gov/data/current_obs/KAND.xml'),
('KCAE', 'SC', 'Columbia Metropolitan Airport', '33.960000', '-81.120000', 'http://weather.noaa.gov/weather/current/KCAE.html', 'http://weather.gov/data/current_obs/KCAE.rss', 'http://weather.gov/data/current_obs/KCAE.xml'),
('KCEU', 'SC', 'Clemson-Oconee County Airport', '34.667000', '-82.867000', 'http://weather.noaa.gov/weather/current/KCEU.html', 'http://weather.gov/data/current_obs/KCEU.rss', 'http://weather.gov/data/current_obs/KCEU.xml'),
('KCHS', 'SC', 'Charleston Air Force Base', '32.910000', '-80.030000', 'http://weather.noaa.gov/weather/current/KCHS.html', 'http://weather.gov/data/current_obs/KCHS.rss', 'http://weather.gov/data/current_obs/KCHS.xml'),
('KCRE', 'SC', 'North Myrtle Beach, Grand Strand Airport', '33.810000', '-78.720000', 'http://weather.noaa.gov/weather/current/KCRE.html', 'http://weather.gov/data/current_obs/KCRE.rss', 'http://weather.gov/data/current_obs/KCRE.xml'),
('KCUB', 'SC', 'Columbia Owens Downtown Airport', '33.990000', '-81.000000', 'http://weather.noaa.gov/weather/current/KCUB.html', 'http://weather.gov/data/current_obs/KCUB.rss', 'http://weather.gov/data/current_obs/KCUB.xml'),
('KFLO', 'SC', 'Florence Regional Airport', '34.190000', '-79.720000', 'http://weather.noaa.gov/weather/current/KFLO.html', 'http://weather.gov/data/current_obs/KFLO.rss', 'http://weather.gov/data/current_obs/KFLO.xml'),
('KGMU', 'SC', 'Greenville Downtown Airport', '34.850000', '-82.350000', 'http://weather.noaa.gov/weather/current/KGMU.html', 'http://weather.gov/data/current_obs/KGMU.rss', 'http://weather.gov/data/current_obs/KGMU.xml'),
('KGRD', 'SC', 'Greenwood County Airport', '34.233000', '-82.150000', 'http://weather.noaa.gov/weather/current/KGRD.html', 'http://weather.gov/data/current_obs/KGRD.rss', 'http://weather.gov/data/current_obs/KGRD.xml'),
('KGSP', 'SC', 'Greer, Greenville-Spartanburg Airport', '34.910000', '-82.220000', 'http://weather.noaa.gov/weather/current/KGSP.html', 'http://weather.gov/data/current_obs/KGSP.rss', 'http://weather.gov/data/current_obs/KGSP.xml'),
('KGYH', 'SC', 'Donaldson Center Airport', '34.750000', '-82.367000', 'http://weather.noaa.gov/weather/current/KGYH.html', 'http://weather.gov/data/current_obs/KGYH.rss', 'http://weather.gov/data/current_obs/KGYH.xml'),
('KHXD', 'SC', 'Hilton Head Airport', '32.232000', '-80.700000', 'http://weather.noaa.gov/weather/current/KHXD.html', 'http://weather.gov/data/current_obs/KHXD.rss', 'http://weather.gov/data/current_obs/KHXD.xml'),
('KMMT', 'SC', 'McEntire Air National Guard Weather Facility Base', '33.930000', '-80.800000', 'http://weather.noaa.gov/weather/current/KMMT.html', 'http://weather.gov/data/current_obs/KMMT.rss', 'http://weather.gov/data/current_obs/KMMT.xml'),
('KMYR', 'SC', 'Myrtle Beach International Airport', '33.690000', '-78.930000', 'http://weather.noaa.gov/weather/current/KMYR.html', 'http://weather.gov/data/current_obs/KMYR.rss', 'http://weather.gov/data/current_obs/KMYR.xml'),
('KNBC', 'SC', 'Beaufort, Marine Corps Air Station', '32.480000', '-80.720000', 'http://weather.noaa.gov/weather/current/KNBC.html', 'http://weather.gov/data/current_obs/KNBC.rss', 'http://weather.gov/data/current_obs/KNBC.xml'),
('KOGB', 'SC', 'Orangeburg Municipal Airport', '33.470000', '-80.850000', 'http://weather.noaa.gov/weather/current/KOGB.html', 'http://weather.gov/data/current_obs/KOGB.rss', 'http://weather.gov/data/current_obs/KOGB.xml'),
('KSSC', 'SC', 'Shaw Air Force Base', '33.980000', '-80.470000', 'http://weather.noaa.gov/weather/current/KSSC.html', 'http://weather.gov/data/current_obs/KSSC.rss', 'http://weather.gov/data/current_obs/KSSC.xml'),
('KUDG', 'SC', 'Darlington County Jetport Airport', '34.450000', '-79.883000', 'http://weather.noaa.gov/weather/current/KUDG.html', 'http://weather.gov/data/current_obs/KUDG.rss', 'http://weather.gov/data/current_obs/KUDG.xml'),
('KUZA', 'SC', 'Rock Hill - York County Airport', '34.984000', '-81.056000', 'http://weather.noaa.gov/weather/current/KUZA.html', 'http://weather.gov/data/current_obs/KUZA.rss', 'http://weather.gov/data/current_obs/KUZA.xml'),
('K8D3', 'SD', 'Sisseton Municipal Airport', '45.670000', '-97.000000', 'http://weather.noaa.gov/weather/current/K8D3.html', 'http://weather.gov/data/current_obs/K8D3.rss', 'http://weather.gov/data/current_obs/K8D3.xml'),
('K9V9', 'SD', 'Chamberlain Municipal Airport', '43.800000', '-99.320000', 'http://weather.noaa.gov/weather/current/K9V9.html', 'http://weather.gov/data/current_obs/K9V9.rss', 'http://weather.gov/data/current_obs/K9V9.xml'),
('KABR', 'SD', 'Aberdeen Regional Airport', '45.460000', '-98.430000', 'http://weather.noaa.gov/weather/current/KABR.html', 'http://weather.gov/data/current_obs/KABR.rss', 'http://weather.gov/data/current_obs/KABR.xml'),
('KATY', 'SD', 'Watertown Municipal Airport', '44.920000', '-97.160000', 'http://weather.noaa.gov/weather/current/KATY.html', 'http://weather.gov/data/current_obs/KATY.rss', 'http://weather.gov/data/current_obs/KATY.xml'),
('KBKX', 'SD', 'Brookings Automatic Weather Observing / Reporting', '44.300000', '-96.800000', 'http://weather.noaa.gov/weather/current/KBKX.html', 'http://weather.gov/data/current_obs/KBKX.rss', 'http://weather.gov/data/current_obs/KBKX.xml'),
('KFSD', 'SD', 'Sioux Falls, Foss Field', '43.590000', '-96.740000', 'http://weather.noaa.gov/weather/current/KFSD.html', 'http://weather.gov/data/current_obs/KFSD.rss', 'http://weather.gov/data/current_obs/KFSD.xml'),
('KHON', 'SD', 'Huron Regional Airport', '44.390000', '-98.220000', 'http://weather.noaa.gov/weather/current/KHON.html', 'http://weather.gov/data/current_obs/KHON.rss', 'http://weather.gov/data/current_obs/KHON.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('KMBG', 'SD', 'Mobridge Municipal Airport', '45.550000', '-100.410000', 'http://weather.noaa.gov/weather/current/KMBG.html', 'http://weather.gov/data/current_obs/KMBG.rss', 'http://weather.gov/data/current_obs/KMBG.xml'),
('KMHE', 'SD', 'Mitchell Municipal Airport', '43.770000', '-98.040000', 'http://weather.noaa.gov/weather/current/KMHE.html', 'http://weather.gov/data/current_obs/KMHE.rss', 'http://weather.gov/data/current_obs/KMHE.xml'),
('KPIR', 'SD', 'Pierre Regional Airport', '44.390000', '-100.280000', 'http://weather.noaa.gov/weather/current/KPIR.html', 'http://weather.gov/data/current_obs/KPIR.rss', 'http://weather.gov/data/current_obs/KPIR.xml'),
('KICR', 'SD', 'Winner Regional Airport', '43.380000', '-99.850000', 'http://weather.noaa.gov/weather/current/KICR.html', 'http://weather.gov/data/current_obs/KICR.rss', 'http://weather.gov/data/current_obs/KICR.xml'),
('KYKN', 'SD', 'Yankton Automatic Weather Observing/Reporting Sys', '42.920000', '-97.380000', 'http://weather.noaa.gov/weather/current/KYKN.html', 'http://weather.gov/data/current_obs/KYKN.rss', 'http://weather.gov/data/current_obs/KYKN.xml'),
('K2WX', 'SD', 'Buffalo', '45.570000', '-103.530000', 'http://weather.noaa.gov/weather/current/K2WX.html', 'http://weather.gov/data/current_obs/K2WX.rss', 'http://weather.gov/data/current_obs/K2WX.xml'),
('KCUT', 'SD', 'Custer County Airport', '43.733000', '-103.618000', 'http://weather.noaa.gov/weather/current/KCUT.html', 'http://weather.gov/data/current_obs/KCUT.rss', 'http://weather.gov/data/current_obs/KCUT.xml'),
('KD07', 'SD', 'Faith', '45.040000', '-102.020000', 'http://weather.noaa.gov/weather/current/KD07.html', 'http://weather.gov/data/current_obs/KD07.rss', 'http://weather.gov/data/current_obs/KD07.xml'),
('KEFC', 'SD', 'Belle Fourche Municipal Airport', '44.710000', '-103.800000', 'http://weather.noaa.gov/weather/current/KEFC.html', 'http://weather.gov/data/current_obs/KEFC.rss', 'http://weather.gov/data/current_obs/KEFC.xml'),
('KIEN', 'SD', 'Pine Ridge Airport', '43.010000', '-102.510000', 'http://weather.noaa.gov/weather/current/KIEN.html', 'http://weather.gov/data/current_obs/KIEN.rss', 'http://weather.gov/data/current_obs/KIEN.xml'),
('KPHP', 'SD', 'Philip Airport', '44.050000', '-101.600000', 'http://weather.noaa.gov/weather/current/KPHP.html', 'http://weather.gov/data/current_obs/KPHP.rss', 'http://weather.gov/data/current_obs/KPHP.xml'),
('KRAP', 'SD', 'Rapid City Regional Airport', '44.050000', '-103.070000', 'http://weather.noaa.gov/weather/current/KRAP.html', 'http://weather.gov/data/current_obs/KRAP.rss', 'http://weather.gov/data/current_obs/KRAP.xml'),
('KRCA', 'SD', 'Ellsworth Air Force Base', '44.150000', '-103.100000', 'http://weather.noaa.gov/weather/current/KRCA.html', 'http://weather.gov/data/current_obs/KRCA.rss', 'http://weather.gov/data/current_obs/KRCA.xml'),
('KBNA', 'TN', 'Nashville International Airport', '36.120000', '-86.680000', 'http://weather.noaa.gov/weather/current/KBNA.html', 'http://weather.gov/data/current_obs/KBNA.rss', 'http://weather.gov/data/current_obs/KBNA.xml'),
('KCKV', 'TN', 'Clarksville, Outlaw Field Airport', '36.620000', '-87.420000', 'http://weather.noaa.gov/weather/current/KCKV.html', 'http://weather.gov/data/current_obs/KCKV.rss', 'http://weather.gov/data/current_obs/KCKV.xml'),
('KCSV', 'TN', 'Crossville Memorial-Whitson Field Airport', '35.960000', '-85.080000', 'http://weather.noaa.gov/weather/current/KCSV.html', 'http://weather.gov/data/current_obs/KCSV.rss', 'http://weather.gov/data/current_obs/KCSV.xml'),
('KDYR', 'TN', 'Dyersburg Automatic Weather Observing / Reporting', '36.030000', '-89.400000', 'http://weather.noaa.gov/weather/current/KDYR.html', 'http://weather.gov/data/current_obs/KDYR.rss', 'http://weather.gov/data/current_obs/KDYR.xml'),
('KMEM', 'TN', 'Memphis International Airport', '35.040000', '-89.980000', 'http://weather.noaa.gov/weather/current/KMEM.html', 'http://weather.gov/data/current_obs/KMEM.rss', 'http://weather.gov/data/current_obs/KMEM.xml'),
('KMKL', 'TN', 'Jackson, McKellar-Sipes Regional Airport', '35.610000', '-88.920000', 'http://weather.noaa.gov/weather/current/KMKL.html', 'http://weather.gov/data/current_obs/KMKL.rss', 'http://weather.gov/data/current_obs/KMKL.xml'),
('KMQY', 'TN', 'Smyrna', '36.010000', '-86.500000', 'http://weather.noaa.gov/weather/current/KMQY.html', 'http://weather.gov/data/current_obs/KMQY.rss', 'http://weather.gov/data/current_obs/KMQY.xml'),
('KNQA', 'TN', 'Millington Municipal Airport', '35.360000', '-89.870000', 'http://weather.noaa.gov/weather/current/KNQA.html', 'http://weather.gov/data/current_obs/KNQA.rss', 'http://weather.gov/data/current_obs/KNQA.xml'),
('KCHA', 'TN', 'Chattanooga, Lovell Field', '35.040000', '-85.200000', 'http://weather.noaa.gov/weather/current/KCHA.html', 'http://weather.gov/data/current_obs/KCHA.rss', 'http://weather.gov/data/current_obs/KCHA.xml'),
('KMRX', 'TN', 'Morristown Nexrad', '36.167000', '-83.400000', 'http://weather.noaa.gov/weather/current/KMRX.html', 'http://weather.gov/data/current_obs/KMRX.rss', 'http://weather.gov/data/current_obs/KMRX.xml'),
('KOQT', 'TN', 'Oak Ridge', '36.020000', '-84.230000', 'http://weather.noaa.gov/weather/current/KOQT.html', 'http://weather.gov/data/current_obs/KOQT.rss', 'http://weather.gov/data/current_obs/KOQT.xml'),
('KTRI', 'TN', 'Tri-Cities Airport', '36.480000', '-82.400000', 'http://weather.noaa.gov/weather/current/KTRI.html', 'http://weather.gov/data/current_obs/KTRI.rss', 'http://weather.gov/data/current_obs/KTRI.xml'),
('KTYS', 'TN', 'Knoxville, McGhee Tyson Airport', '35.810000', '-83.980000', 'http://weather.noaa.gov/weather/current/KTYS.html', 'http://weather.gov/data/current_obs/KTYS.rss', 'http://weather.gov/data/current_obs/KTYS.xml'),
('NFTF', 'TO', 'Fau Amotu', '-21.233000', '-175.150000', 'http://weather.noaa.gov/weather/current/NFTF.html', 'http://weather.gov/data/current_obs/NFTF.rss', 'http://weather.gov/data/current_obs/NFTF.xml'),
('NFTV', 'TO', 'Vavu International', '-18.583000', '-173.950000', 'http://weather.noaa.gov/weather/current/NFTV.html', 'http://weather.gov/data/current_obs/NFTV.rss', 'http://weather.gov/data/current_obs/NFTV.xml'),
('TTCP', 'TT', 'Crown Pt./Scarborou', '11.150000', '-60.833000', 'http://weather.noaa.gov/weather/current/TTCP.html', 'http://weather.gov/data/current_obs/TTCP.rss', 'http://weather.gov/data/current_obs/TTCP.xml'),
('TTPP', 'TT', 'Piarco Intl Airport/Trinidad', '10.617000', '-61.350000', 'http://weather.noaa.gov/weather/current/TTPP.html', 'http://weather.gov/data/current_obs/TTPP.rss', 'http://weather.gov/data/current_obs/TTPP.xml'),
('NGFU', 'TV', 'Funafuti', '-8.533000', '179.217000', 'http://weather.noaa.gov/weather/current/NGFU.html', 'http://weather.gov/data/current_obs/NGFU.rss', 'http://weather.gov/data/current_obs/NGFU.xml'),
('K11R', 'TX', 'Brenham Municipal Airport', '30.219000', '-96.374000', 'http://weather.noaa.gov/weather/current/K11R.html', 'http://weather.gov/data/current_obs/K11R.rss', 'http://weather.gov/data/current_obs/K11R.xml'),
('K2R8', 'TX', 'Mustang Beach Airport', '27.817000', '-97.083000', 'http://weather.noaa.gov/weather/current/K2R8.html', 'http://weather.gov/data/current_obs/K2R8.rss', 'http://weather.gov/data/current_obs/K2R8.xml'),
('K3T5', 'TX', 'La Grange', '29.910000', '-96.950000', 'http://weather.noaa.gov/weather/current/K3T5.html', 'http://weather.gov/data/current_obs/K3T5.rss', 'http://weather.gov/data/current_obs/K3T5.xml'),
('K6R6', 'TX', 'Dryden Terrel County Airport', '30.422000', '-102.278000', 'http://weather.noaa.gov/weather/current/K6R6.html', 'http://weather.gov/data/current_obs/K6R6.rss', 'http://weather.gov/data/current_obs/K6R6.xml'),
('KABI', 'TX', 'Abilene Regional Airport', '32.430000', '-99.680000', 'http://weather.noaa.gov/weather/current/KABI.html', 'http://weather.gov/data/current_obs/KABI.rss', 'http://weather.gov/data/current_obs/KABI.xml'),
('KACT', 'TX', 'Waco Regional Airport', '31.620000', '-97.220000', 'http://weather.noaa.gov/weather/current/KACT.html', 'http://weather.gov/data/current_obs/KACT.rss', 'http://weather.gov/data/current_obs/KACT.xml'),
('KADS', 'TX', 'Dallas / Addison Airport', '32.980000', '-96.830000', 'http://weather.noaa.gov/weather/current/KADS.html', 'http://weather.gov/data/current_obs/KADS.rss', 'http://weather.gov/data/current_obs/KADS.xml'),
('KAFW', 'TX', 'Fort Worth Alliance Airport', '32.980000', '-97.320000', 'http://weather.noaa.gov/weather/current/KAFW.html', 'http://weather.gov/data/current_obs/KAFW.rss', 'http://weather.gov/data/current_obs/KAFW.xml'),
('KALI', 'TX', 'Alice International Airport', '27.740000', '-98.040000', 'http://weather.noaa.gov/weather/current/KALI.html', 'http://weather.gov/data/current_obs/KALI.rss', 'http://weather.gov/data/current_obs/KALI.xml'),
('KAMA', 'TX', 'Rick Husband Amarillo Intl Airport', '35.230000', '-101.700000', 'http://weather.noaa.gov/weather/current/KAMA.html', 'http://weather.gov/data/current_obs/KAMA.rss', 'http://weather.gov/data/current_obs/KAMA.xml'),
('KARM', 'TX', 'Wharton Regional Airport', '29.250000', '-96.117000', 'http://weather.noaa.gov/weather/current/KARM.html', 'http://weather.gov/data/current_obs/KARM.rss', 'http://weather.gov/data/current_obs/KARM.xml'),
('KATT', 'TX', 'Camp Mabry / Austin City', '30.320000', '-97.770000', 'http://weather.noaa.gov/weather/current/KATT.html', 'http://weather.gov/data/current_obs/KATT.rss', 'http://weather.gov/data/current_obs/KATT.xml'),
('KAUS', 'TX', 'Austin-Bergstrom International Airport', '30.200000', '-97.680000', 'http://weather.noaa.gov/weather/current/KAUS.html', 'http://weather.gov/data/current_obs/KAUS.rss', 'http://weather.gov/data/current_obs/KAUS.xml'),
('KBAZ', 'TX', 'New Braunfels Municipal Airport', '29.709000', '-98.045000', 'http://weather.noaa.gov/weather/current/KBAZ.html', 'http://weather.gov/data/current_obs/KBAZ.rss', 'http://weather.gov/data/current_obs/KBAZ.xml'),
('KBBD', 'TX', 'Curtis Field Airport', '31.183000', '-99.317000', 'http://weather.noaa.gov/weather/current/KBBD.html', 'http://weather.gov/data/current_obs/KBBD.rss', 'http://weather.gov/data/current_obs/KBBD.xml'),
('KBGD', 'TX', 'Borger, Hutchinson County Airport', '35.710000', '-101.400000', 'http://weather.noaa.gov/weather/current/KBGD.html', 'http://weather.gov/data/current_obs/KBGD.rss', 'http://weather.gov/data/current_obs/KBGD.xml'),
('KBKS', 'TX', 'Brooks County Airport', '27.207000', '-98.121000', 'http://weather.noaa.gov/weather/current/KBKS.html', 'http://weather.gov/data/current_obs/KBKS.rss', 'http://weather.gov/data/current_obs/KBKS.xml'),
('KBMQ', 'TX', 'Burnet Municipal Craddock Field', '30.740000', '-98.230000', 'http://weather.noaa.gov/weather/current/KBMQ.html', 'http://weather.gov/data/current_obs/KBMQ.rss', 'http://weather.gov/data/current_obs/KBMQ.xml'),
('KBPG', 'TX', 'Big Spring', '32.213000', '-101.522000', 'http://weather.noaa.gov/weather/current/KBPG.html', 'http://weather.gov/data/current_obs/KBPG.rss', 'http://weather.gov/data/current_obs/KBPG.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('KBPT', 'TX', 'Beaumont/Port Arthur, SE Texas Regional Airport', '29.950000', '-94.020000', 'http://weather.noaa.gov/weather/current/KBPT.html', 'http://weather.gov/data/current_obs/KBPT.rss', 'http://weather.gov/data/current_obs/KBPT.xml'),
('KBRO', 'TX', 'Brownsville / South Padre Island Intl Airport', '25.900000', '-97.430000', 'http://weather.noaa.gov/weather/current/KBRO.html', 'http://weather.gov/data/current_obs/KBRO.rss', 'http://weather.gov/data/current_obs/KBRO.xml'),
('KBWD', 'TX', 'Brownwood', '31.800000', '-98.950000', 'http://weather.noaa.gov/weather/current/KBWD.html', 'http://weather.gov/data/current_obs/KBWD.rss', 'http://weather.gov/data/current_obs/KBWD.xml'),
('KBYY', 'TX', 'Bay City', '28.973000', '-95.863000', 'http://weather.noaa.gov/weather/current/KBYY.html', 'http://weather.gov/data/current_obs/KBYY.rss', 'http://weather.gov/data/current_obs/KBYY.xml'),
('KCDS', 'TX', 'Childress Municipal Airport', '34.440000', '-100.280000', 'http://weather.noaa.gov/weather/current/KCDS.html', 'http://weather.gov/data/current_obs/KCDS.rss', 'http://weather.gov/data/current_obs/KCDS.xml'),
('KCLL', 'TX', 'College Station, Easterwood Field', '30.580000', '-96.370000', 'http://weather.noaa.gov/weather/current/KCLL.html', 'http://weather.gov/data/current_obs/KCLL.rss', 'http://weather.gov/data/current_obs/KCLL.xml'),
('KCOT', 'TX', 'Cotulla-La Salle County Airport', '28.450000', '-99.220000', 'http://weather.noaa.gov/weather/current/KCOT.html', 'http://weather.gov/data/current_obs/KCOT.rss', 'http://weather.gov/data/current_obs/KCOT.xml'),
('KCPT', 'TX', 'Cleburne Municipal Airport', '32.350000', '-97.433000', 'http://weather.noaa.gov/weather/current/KCPT.html', 'http://weather.gov/data/current_obs/KCPT.rss', 'http://weather.gov/data/current_obs/KCPT.xml'),
('KCRP', 'TX', 'Corpus Christi International Airport', '27.770000', '-97.500000', 'http://weather.noaa.gov/weather/current/KCRP.html', 'http://weather.gov/data/current_obs/KCRP.rss', 'http://weather.gov/data/current_obs/KCRP.xml'),
('KCRS', 'TX', 'Campbell Field-Corsicana Municipal Airport', '32.030000', '-96.400000', 'http://weather.noaa.gov/weather/current/KCRS.html', 'http://weather.gov/data/current_obs/KCRS.rss', 'http://weather.gov/data/current_obs/KCRS.xml'),
('KCXO', 'TX', 'Conroe, Montgomery County Airport', '30.360000', '-95.410000', 'http://weather.noaa.gov/weather/current/KCXO.html', 'http://weather.gov/data/current_obs/KCXO.rss', 'http://weather.gov/data/current_obs/KCXO.xml'),
('KDAL', 'TX', 'Dallas Love Field', '32.860000', '-96.850000', 'http://weather.noaa.gov/weather/current/KDAL.html', 'http://weather.gov/data/current_obs/KDAL.rss', 'http://weather.gov/data/current_obs/KDAL.xml'),
('KDFW', 'TX', 'Dallas / Fort Worth International Airport', '32.910000', '-97.030000', 'http://weather.noaa.gov/weather/current/KDFW.html', 'http://weather.gov/data/current_obs/KDFW.rss', 'http://weather.gov/data/current_obs/KDFW.xml'),
('KDHT', 'TX', 'Dalhart Municipal Airport', '36.030000', '-102.550000', 'http://weather.noaa.gov/weather/current/KDHT.html', 'http://weather.gov/data/current_obs/KDHT.rss', 'http://weather.gov/data/current_obs/KDHT.xml'),
('KDLF', 'TX', 'Laughlin Air Force Base Auxiliary Airfield', '29.367000', '-100.783000', 'http://weather.noaa.gov/weather/current/KDLF.html', 'http://weather.gov/data/current_obs/KDLF.rss', 'http://weather.gov/data/current_obs/KDLF.xml'),
('KDRT', 'TX', 'Del Rio International Airport', '29.380000', '-100.920000', 'http://weather.noaa.gov/weather/current/KDRT.html', 'http://weather.gov/data/current_obs/KDRT.rss', 'http://weather.gov/data/current_obs/KDRT.xml'),
('KDTO', 'TX', 'Denton Municipal Airport', '33.200000', '-97.180000', 'http://weather.noaa.gov/weather/current/KDTO.html', 'http://weather.gov/data/current_obs/KDTO.rss', 'http://weather.gov/data/current_obs/KDTO.xml'),
('KDUX', 'TX', 'Moore County Airport', '35.850000', '-102.017000', 'http://weather.noaa.gov/weather/current/KDUX.html', 'http://weather.gov/data/current_obs/KDUX.rss', 'http://weather.gov/data/current_obs/KDUX.xml'),
('KDWH', 'TX', 'Houston, Hooks Memorial Airport', '30.070000', '-95.550000', 'http://weather.noaa.gov/weather/current/KDWH.html', 'http://weather.gov/data/current_obs/KDWH.rss', 'http://weather.gov/data/current_obs/KDWH.xml'),
('KDYS', 'TX', 'Abilene, Dyess Air Force Base', '32.417000', '-99.850000', 'http://weather.noaa.gov/weather/current/KDYS.html', 'http://weather.gov/data/current_obs/KDYS.rss', 'http://weather.gov/data/current_obs/KDYS.xml'),
('KE38', 'TX', 'Casparis Municipal Airport', '30.384000', '-103.684000', 'http://weather.noaa.gov/weather/current/KE38.html', 'http://weather.gov/data/current_obs/KE38.rss', 'http://weather.gov/data/current_obs/KE38.xml'),
('KEBG', 'TX', 'Edinburg Intl Airport', '26.442000', '-98.129000', 'http://weather.noaa.gov/weather/current/KEBG.html', 'http://weather.gov/data/current_obs/KEBG.rss', 'http://weather.gov/data/current_obs/KEBG.xml'),
('KECU', 'TX', 'Edwards County Airport', '29.950000', '-100.167000', 'http://weather.noaa.gov/weather/current/KECU.html', 'http://weather.gov/data/current_obs/KECU.rss', 'http://weather.gov/data/current_obs/KECU.xml'),
('KEFD', 'TX', 'Houston / Ellington', '29.620000', '-95.170000', 'http://weather.noaa.gov/weather/current/KEFD.html', 'http://weather.gov/data/current_obs/KEFD.rss', 'http://weather.gov/data/current_obs/KEFD.xml'),
('KERV', 'TX', 'Kerrville', '29.980000', '-99.080000', 'http://weather.noaa.gov/weather/current/KERV.html', 'http://weather.gov/data/current_obs/KERV.rss', 'http://weather.gov/data/current_obs/KERV.xml'),
('KF05', 'TX', 'Vernon', '34.226000', '-99.284000', 'http://weather.noaa.gov/weather/current/KF05.html', 'http://weather.gov/data/current_obs/KF05.rss', 'http://weather.gov/data/current_obs/KF05.xml'),
('KF39', 'TX', 'Sherman-Denison', '33.717000', '-96.667000', 'http://weather.noaa.gov/weather/current/KF39.html', 'http://weather.gov/data/current_obs/KF39.rss', 'http://weather.gov/data/current_obs/KF39.xml'),
('KFST', 'TX', 'Fort Stockton-Pecos County Airport', '30.910000', '-102.910000', 'http://weather.noaa.gov/weather/current/KFST.html', 'http://weather.gov/data/current_obs/KFST.rss', 'http://weather.gov/data/current_obs/KFST.xml'),
('KFTW', 'TX', 'Fort Worth, Meacham International Airport', '32.830000', '-97.350000', 'http://weather.noaa.gov/weather/current/KFTW.html', 'http://weather.gov/data/current_obs/KFTW.rss', 'http://weather.gov/data/current_obs/KFTW.xml'),
('KFWS', 'TX', 'Fort Worth Spinks Airport', '32.510000', '-97.300000', 'http://weather.noaa.gov/weather/current/KFWS.html', 'http://weather.gov/data/current_obs/KFWS.rss', 'http://weather.gov/data/current_obs/KFWS.xml'),
('KGDJ', 'TX', 'Granbury Municipal Airport', '32.444000', '-97.817000', 'http://weather.noaa.gov/weather/current/KGDJ.html', 'http://weather.gov/data/current_obs/KGDJ.rss', 'http://weather.gov/data/current_obs/KGDJ.xml'),
('KGDP', 'TX', 'Pine Springs, Guadalupe Mountains National Park', '31.830000', '-104.800000', 'http://weather.noaa.gov/weather/current/KGDP.html', 'http://weather.gov/data/current_obs/KGDP.rss', 'http://weather.gov/data/current_obs/KGDP.xml'),
('KGGG', 'TX', 'Longview, Gregg County Airport', '32.380000', '-94.710000', 'http://weather.noaa.gov/weather/current/KGGG.html', 'http://weather.gov/data/current_obs/KGGG.rss', 'http://weather.gov/data/current_obs/KGGG.xml'),
('KGKY', 'TX', 'Arlington Municipal Airport', '32.664000', '-97.096000', 'http://weather.noaa.gov/weather/current/KGKY.html', 'http://weather.gov/data/current_obs/KGKY.rss', 'http://weather.gov/data/current_obs/KGKY.xml'),
('KGLE', 'TX', 'Gainesville Municipal Airport', '33.652000', '-97.200000', 'http://weather.noaa.gov/weather/current/KGLE.html', 'http://weather.gov/data/current_obs/KGLE.rss', 'http://weather.gov/data/current_obs/KGLE.xml'),
('KGLS', 'TX', 'Galveston, Scholes Field', '29.270000', '-94.870000', 'http://weather.noaa.gov/weather/current/KGLS.html', 'http://weather.gov/data/current_obs/KGLS.rss', 'http://weather.gov/data/current_obs/KGLS.xml'),
('KGNC', 'TX', 'Gaines County Airport', '32.667000', '-102.650000', 'http://weather.noaa.gov/weather/current/KGNC.html', 'http://weather.gov/data/current_obs/KGNC.rss', 'http://weather.gov/data/current_obs/KGNC.xml'),
('KGOP', 'TX', 'Gatesville', '31.417000', '-97.783000', 'http://weather.noaa.gov/weather/current/KGOP.html', 'http://weather.gov/data/current_obs/KGOP.rss', 'http://weather.gov/data/current_obs/KGOP.xml'),
('KGPM', 'TX', 'Grand Prairie Municipal Airport', '32.699000', '-97.047000', 'http://weather.noaa.gov/weather/current/KGPM.html', 'http://weather.gov/data/current_obs/KGPM.rss', 'http://weather.gov/data/current_obs/KGPM.xml'),
('KGRK', 'TX', 'Killeen - Robert Gray International Airport', '31.067000', '-97.833000', 'http://weather.noaa.gov/weather/current/KGRK.html', 'http://weather.gov/data/current_obs/KGRK.rss', 'http://weather.gov/data/current_obs/KGRK.xml'),
('KGTU', 'TX', 'Georgetown Automatic Weather Observing / Reporting', '30.690000', '-97.690000', 'http://weather.noaa.gov/weather/current/KGTU.html', 'http://weather.gov/data/current_obs/KGTU.rss', 'http://weather.gov/data/current_obs/KGTU.xml'),
('KGVT', 'TX', 'Greenville / Majors', '33.080000', '-96.070000', 'http://weather.noaa.gov/weather/current/KGVT.html', 'http://weather.gov/data/current_obs/KGVT.rss', 'http://weather.gov/data/current_obs/KGVT.xml'),
('KGYI', 'TX', 'Grayson County Airport', '33.730000', '-96.670000', 'http://weather.noaa.gov/weather/current/KGYI.html', 'http://weather.gov/data/current_obs/KGYI.rss', 'http://weather.gov/data/current_obs/KGYI.xml'),
('KHBV', 'TX', 'Jim Hogg County Airport', '27.333000', '-98.733000', 'http://weather.noaa.gov/weather/current/KHBV.html', 'http://weather.gov/data/current_obs/KHBV.rss', 'http://weather.gov/data/current_obs/KHBV.xml'),
('KHDO', 'TX', 'Hondo Municipal Airport', '29.360000', '-99.160000', 'http://weather.noaa.gov/weather/current/KHDO.html', 'http://weather.gov/data/current_obs/KHDO.rss', 'http://weather.gov/data/current_obs/KHDO.xml'),
('KHHF', 'TX', 'Hemphill County Airport', '35.895000', '-100.404000', 'http://weather.noaa.gov/weather/current/KHHF.html', 'http://weather.gov/data/current_obs/KHHF.rss', 'http://weather.gov/data/current_obs/KHHF.xml'),
('KHLR', 'TX', 'Fort Hood', '31.150000', '-97.717000', 'http://weather.noaa.gov/weather/current/KHLR.html', 'http://weather.gov/data/current_obs/KHLR.rss', 'http://weather.gov/data/current_obs/KHLR.xml'),
('KHOU', 'TX', 'Houston Hobby Airport', '29.650000', '-95.280000', 'http://weather.noaa.gov/weather/current/KHOU.html', 'http://weather.gov/data/current_obs/KHOU.rss', 'http://weather.gov/data/current_obs/KHOU.xml'),
('KHQZ', 'TX', 'Mesquite Metro Airport', '32.747000', '-96.530000', 'http://weather.noaa.gov/weather/current/KHQZ.html', 'http://weather.gov/data/current_obs/KHQZ.rss', 'http://weather.gov/data/current_obs/KHQZ.xml'),
('KHRL', 'TX', 'Harlingen, Rio Grande Valley International Airport', '26.230000', '-97.670000', 'http://weather.noaa.gov/weather/current/KHRL.html', 'http://weather.gov/data/current_obs/KHRL.rss', 'http://weather.gov/data/current_obs/KHRL.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('KHYI', 'TX', 'San Marcos Municipal Airport', '29.900000', '-97.870000', 'http://weather.noaa.gov/weather/current/KHYI.html', 'http://weather.gov/data/current_obs/KHYI.rss', 'http://weather.gov/data/current_obs/KHYI.xml'),
('KIAH', 'TX', 'Houston Intercontinental Airport', '29.970000', '-95.350000', 'http://weather.noaa.gov/weather/current/KIAH.html', 'http://weather.gov/data/current_obs/KIAH.rss', 'http://weather.gov/data/current_obs/KIAH.xml'),
('KILE', 'TX', 'Killeen - Skylark Field', '31.090000', '-97.690000', 'http://weather.noaa.gov/weather/current/KILE.html', 'http://weather.gov/data/current_obs/KILE.rss', 'http://weather.gov/data/current_obs/KILE.xml'),
('KINJ', 'TX', 'Hillsboro Municipal Airport', '32.083000', '-97.097000', 'http://weather.noaa.gov/weather/current/KINJ.html', 'http://weather.gov/data/current_obs/KINJ.rss', 'http://weather.gov/data/current_obs/KINJ.xml'),
('KINK', 'TX', 'Winkler County Airport', '31.790000', '-103.200000', 'http://weather.noaa.gov/weather/current/KINK.html', 'http://weather.gov/data/current_obs/KINK.rss', 'http://weather.gov/data/current_obs/KINK.xml'),
('KJAS', 'TX', 'Jasper', '30.890000', '-94.030000', 'http://weather.noaa.gov/weather/current/KJAS.html', 'http://weather.gov/data/current_obs/KJAS.rss', 'http://weather.gov/data/current_obs/KJAS.xml'),
('KJCT', 'TX', 'Junction, Kimble County Airport', '30.500000', '-99.770000', 'http://weather.noaa.gov/weather/current/KJCT.html', 'http://weather.gov/data/current_obs/KJCT.rss', 'http://weather.gov/data/current_obs/KJCT.xml'),
('KJSO', 'TX', 'Cherokee County Airport', '31.869000', '-95.217000', 'http://weather.noaa.gov/weather/current/KJSO.html', 'http://weather.gov/data/current_obs/KJSO.rss', 'http://weather.gov/data/current_obs/KJSO.xml'),
('KJWY', 'TX', 'Midlothian-Waxahachie Midway Airport', '32.456000', '-96.912000', 'http://weather.noaa.gov/weather/current/KJWY.html', 'http://weather.gov/data/current_obs/KJWY.rss', 'http://weather.gov/data/current_obs/KJWY.xml'),
('KLBB', 'TX', 'Lubbock International Airport', '33.660000', '-101.820000', 'http://weather.noaa.gov/weather/current/KLBB.html', 'http://weather.gov/data/current_obs/KLBB.rss', 'http://weather.gov/data/current_obs/KLBB.xml'),
('KLBR', 'TX', 'Clarksville', '33.593000', '-95.064000', 'http://weather.noaa.gov/weather/current/KLBR.html', 'http://weather.gov/data/current_obs/KLBR.rss', 'http://weather.gov/data/current_obs/KLBR.xml'),
('KLBX', 'TX', 'Angleton / Lake Jackson, Brazoria County Airport', '29.120000', '-95.470000', 'http://weather.noaa.gov/weather/current/KLBX.html', 'http://weather.gov/data/current_obs/KLBX.rss', 'http://weather.gov/data/current_obs/KLBX.xml'),
('KLFK', 'TX', 'Lufkin, Angelina County Airport', '31.230000', '-94.750000', 'http://weather.noaa.gov/weather/current/KLFK.html', 'http://weather.gov/data/current_obs/KLFK.rss', 'http://weather.gov/data/current_obs/KLFK.xml'),
('KLHB', 'TX', 'Hearne Municipal Airport', '30.872000', '-96.622000', 'http://weather.noaa.gov/weather/current/KLHB.html', 'http://weather.gov/data/current_obs/KLHB.rss', 'http://weather.gov/data/current_obs/KLHB.xml'),
('KLNC', 'TX', 'Lancaster Airport', '32.579000', '-96.719000', 'http://weather.noaa.gov/weather/current/KLNC.html', 'http://weather.gov/data/current_obs/KLNC.rss', 'http://weather.gov/data/current_obs/KLNC.xml'),
('KLRD', 'TX', 'Laredo International Airport', '27.540000', '-99.470000', 'http://weather.noaa.gov/weather/current/KLRD.html', 'http://weather.gov/data/current_obs/KLRD.rss', 'http://weather.gov/data/current_obs/KLRD.xml'),
('KLUD', 'TX', 'Decatur Municipal Airport', '33.255000', '-97.581000', 'http://weather.noaa.gov/weather/current/KLUD.html', 'http://weather.gov/data/current_obs/KLUD.rss', 'http://weather.gov/data/current_obs/KLUD.xml'),
('KLVJ', 'TX', 'Pearland Regional Airport', '29.519000', '-95.242000', 'http://weather.noaa.gov/weather/current/KLVJ.html', 'http://weather.gov/data/current_obs/KLVJ.rss', 'http://weather.gov/data/current_obs/KLVJ.xml'),
('KMAF', 'TX', 'Midland International Airport', '31.950000', '-102.180000', 'http://weather.noaa.gov/weather/current/KMAF.html', 'http://weather.gov/data/current_obs/KMAF.rss', 'http://weather.gov/data/current_obs/KMAF.xml'),
('KMDD', 'TX', 'Midland Airpark', '32.033000', '-102.100000', 'http://weather.noaa.gov/weather/current/KMDD.html', 'http://weather.gov/data/current_obs/KMDD.rss', 'http://weather.gov/data/current_obs/KMDD.xml'),
('KMFE', 'TX', 'McAllen, Miller International Airport', '26.180000', '-98.240000', 'http://weather.noaa.gov/weather/current/KMFE.html', 'http://weather.gov/data/current_obs/KMFE.rss', 'http://weather.gov/data/current_obs/KMFE.xml'),
('KMKN', 'TX', 'Comanche County Airport', '31.917000', '-98.600000', 'http://weather.noaa.gov/weather/current/KMKN.html', 'http://weather.gov/data/current_obs/KMKN.rss', 'http://weather.gov/data/current_obs/KMKN.xml'),
('KMRF', 'TX', 'Marfa', '30.380000', '-104.020000', 'http://weather.noaa.gov/weather/current/KMRF.html', 'http://weather.gov/data/current_obs/KMRF.rss', 'http://weather.gov/data/current_obs/KMRF.xml'),
('KMWL', 'TX', 'Mineral Wells Airport', '32.790000', '-98.070000', 'http://weather.noaa.gov/weather/current/KMWL.html', 'http://weather.gov/data/current_obs/KMWL.rss', 'http://weather.gov/data/current_obs/KMWL.xml'),
('KNFW', 'TX', 'Fort Worth, Naval Air Station', '32.767000', '-97.450000', 'http://weather.noaa.gov/weather/current/KNFW.html', 'http://weather.gov/data/current_obs/KNFW.rss', 'http://weather.gov/data/current_obs/KNFW.xml'),
('KNGP', 'TX', 'Corpus Christi, Naval Air Station', '27.683000', '-97.283000', 'http://weather.noaa.gov/weather/current/KNGP.html', 'http://weather.gov/data/current_obs/KNGP.rss', 'http://weather.gov/data/current_obs/KNGP.xml'),
('KNQI', 'TX', 'Kingsville, Naval Air Station', '27.500000', '-97.817000', 'http://weather.noaa.gov/weather/current/KNQI.html', 'http://weather.gov/data/current_obs/KNQI.rss', 'http://weather.gov/data/current_obs/KNQI.xml'),
('KOCH', 'TX', 'Nacogdoches Automatic Weather Observing/Reporting', '31.570000', '-94.700000', 'http://weather.noaa.gov/weather/current/KOCH.html', 'http://weather.gov/data/current_obs/KOCH.rss', 'http://weather.gov/data/current_obs/KOCH.xml'),
('KODO', 'TX', 'Odessa-Schlemeyer Field', '31.921000', '-102.392000', 'http://weather.noaa.gov/weather/current/KODO.html', 'http://weather.gov/data/current_obs/KODO.rss', 'http://weather.gov/data/current_obs/KODO.xml'),
('KORG', 'TX', 'Orange County Airport', '30.067000', '-93.800000', 'http://weather.noaa.gov/weather/current/KORG.html', 'http://weather.gov/data/current_obs/KORG.rss', 'http://weather.gov/data/current_obs/KORG.xml'),
('KOSA', 'TX', 'Mount Pleasant', '33.096000', '-94.962000', 'http://weather.noaa.gov/weather/current/KOSA.html', 'http://weather.gov/data/current_obs/KOSA.rss', 'http://weather.gov/data/current_obs/KOSA.xml'),
('KPEQ', 'TX', 'Pecos Municipal Airport', '31.383000', '-103.500000', 'http://weather.noaa.gov/weather/current/KPEQ.html', 'http://weather.gov/data/current_obs/KPEQ.rss', 'http://weather.gov/data/current_obs/KPEQ.xml'),
('KPIL', 'TX', 'Port Isabel-Cameron County Airport', '26.159000', '-97.338000', 'http://weather.noaa.gov/weather/current/KPIL.html', 'http://weather.gov/data/current_obs/KPIL.rss', 'http://weather.gov/data/current_obs/KPIL.xml'),
('KPKV', 'TX', 'Calhoun County Airport', '28.650000', '-96.667000', 'http://weather.noaa.gov/weather/current/KPKV.html', 'http://weather.gov/data/current_obs/KPKV.rss', 'http://weather.gov/data/current_obs/KPKV.xml'),
('KPPA', 'TX', 'Perry Lefors Field', '35.613000', '-100.996000', 'http://weather.noaa.gov/weather/current/KPPA.html', 'http://weather.gov/data/current_obs/KPPA.rss', 'http://weather.gov/data/current_obs/KPPA.xml'),
('KPRX', 'TX', 'Paris / Cox Field', '33.640000', '-95.450000', 'http://weather.noaa.gov/weather/current/KPRX.html', 'http://weather.gov/data/current_obs/KPRX.rss', 'http://weather.gov/data/current_obs/KPRX.xml'),
('KPSN', 'TX', 'Palestine Municipal Airport', '31.780000', '-95.706000', 'http://weather.noaa.gov/weather/current/KPSN.html', 'http://weather.gov/data/current_obs/KPSN.rss', 'http://weather.gov/data/current_obs/KPSN.xml'),
('KPSX', 'TX', 'Palacios Municipal Airport', '28.720000', '-96.250000', 'http://weather.noaa.gov/weather/current/KPSX.html', 'http://weather.gov/data/current_obs/KPSX.rss', 'http://weather.gov/data/current_obs/KPSX.xml'),
('KPVW', 'TX', 'Hale County Airport', '34.168000', '-101.717000', 'http://weather.noaa.gov/weather/current/KPVW.html', 'http://weather.gov/data/current_obs/KPVW.rss', 'http://weather.gov/data/current_obs/KPVW.xml'),
('KPWG', 'TX', 'Mc Gregor Automatic Weather Observing / Reporting', '31.490000', '-97.320000', 'http://weather.noaa.gov/weather/current/KPWG.html', 'http://weather.gov/data/current_obs/KPWG.rss', 'http://weather.gov/data/current_obs/KPWG.xml'),
('KPYX', 'TX', 'Perryton', '36.414000', '-100.750000', 'http://weather.noaa.gov/weather/current/KPYX.html', 'http://weather.gov/data/current_obs/KPYX.rss', 'http://weather.gov/data/current_obs/KPYX.xml'),
('KRAS', 'TX', 'Mustang Beach Airport', '27.817000', '-97.083000', 'http://weather.noaa.gov/weather/current/KRAS.html', 'http://weather.gov/data/current_obs/KRAS.rss', 'http://weather.gov/data/current_obs/KRAS.xml'),
('KRBD', 'TX', 'Dallas Executive Airport', '32.690000', '-96.870000', 'http://weather.noaa.gov/weather/current/KRBD.html', 'http://weather.gov/data/current_obs/KRBD.rss', 'http://weather.gov/data/current_obs/KRBD.xml'),
('KRBO', 'TX', 'Nueces County Airport', '27.779000', '-97.691000', 'http://weather.noaa.gov/weather/current/KRBO.html', 'http://weather.gov/data/current_obs/KRBO.rss', 'http://weather.gov/data/current_obs/KRBO.xml'),
('KRKP', 'TX', 'Rockport, Aransas County Airport', '28.090000', '-97.050000', 'http://weather.noaa.gov/weather/current/KRKP.html', 'http://weather.gov/data/current_obs/KRKP.rss', 'http://weather.gov/data/current_obs/KRKP.xml'),
('KRND', 'TX', 'Randolph Air Force Base', '29.533000', '-98.283000', 'http://weather.noaa.gov/weather/current/KRND.html', 'http://weather.gov/data/current_obs/KRND.rss', 'http://weather.gov/data/current_obs/KRND.xml'),
('KRPE', 'TX', 'Sabine Pass', '29.700000', '-93.950000', 'http://weather.noaa.gov/weather/current/KRPE.html', 'http://weather.gov/data/current_obs/KRPE.rss', 'http://weather.gov/data/current_obs/KRPE.xml'),
('KRPH', 'TX', 'Graham Municipal Airport', '33.110000', '-98.555000', 'http://weather.noaa.gov/weather/current/KRPH.html', 'http://weather.gov/data/current_obs/KRPH.rss', 'http://weather.gov/data/current_obs/KRPH.xml'),
('KRWV', 'TX', 'Caldwell Municipal Airport', '30.517000', '-96.700000', 'http://weather.noaa.gov/weather/current/KRWV.html', 'http://weather.gov/data/current_obs/KRWV.rss', 'http://weather.gov/data/current_obs/KRWV.xml'),
('KSAT', 'TX', 'San Antonio International Airport', '29.540000', '-98.470000', 'http://weather.noaa.gov/weather/current/KSAT.html', 'http://weather.gov/data/current_obs/KSAT.rss', 'http://weather.gov/data/current_obs/KSAT.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('KSEP', 'TX', 'Stephenville / Clark Field Municipal Airport', '32.215000', '-98.178000', 'http://weather.noaa.gov/weather/current/KSEP.html', 'http://weather.gov/data/current_obs/KSEP.rss', 'http://weather.gov/data/current_obs/KSEP.xml'),
('KSGR', 'TX', 'Houston, Sugar Land Municipal / Hull Field Airport', '29.620000', '-95.650000', 'http://weather.noaa.gov/weather/current/KSGR.html', 'http://weather.gov/data/current_obs/KSGR.rss', 'http://weather.gov/data/current_obs/KSGR.xml'),
('KSJT', 'TX', 'San Angelo, Mathis Field', '31.380000', '-100.500000', 'http://weather.noaa.gov/weather/current/KSJT.html', 'http://weather.gov/data/current_obs/KSJT.rss', 'http://weather.gov/data/current_obs/KSJT.xml'),
('KSKF', 'TX', 'Kelly Air Force Base', '29.383000', '-98.583000', 'http://weather.noaa.gov/weather/current/KSKF.html', 'http://weather.gov/data/current_obs/KSKF.rss', 'http://weather.gov/data/current_obs/KSKF.xml'),
('KSLR', 'TX', 'Sulphur Springs Municipal Airport', '33.167000', '-95.617000', 'http://weather.noaa.gov/weather/current/KSLR.html', 'http://weather.gov/data/current_obs/KSLR.rss', 'http://weather.gov/data/current_obs/KSLR.xml'),
('KSNK', 'TX', 'Winston Field Airport', '32.693000', '-100.950000', 'http://weather.noaa.gov/weather/current/KSNK.html', 'http://weather.gov/data/current_obs/KSNK.rss', 'http://weather.gov/data/current_obs/KSNK.xml'),
('KSOA', 'TX', 'Sonora Municipal Airport', '30.583000', '-100.650000', 'http://weather.noaa.gov/weather/current/KSOA.html', 'http://weather.gov/data/current_obs/KSOA.rss', 'http://weather.gov/data/current_obs/KSOA.xml'),
('KSPS', 'TX', 'Wichita Falls, Sheppard Air Force Base', '33.980000', '-98.480000', 'http://weather.noaa.gov/weather/current/KSPS.html', 'http://weather.gov/data/current_obs/KSPS.rss', 'http://weather.gov/data/current_obs/KSPS.xml'),
('KSSF', 'TX', 'San Antonio, Stinson Municipal Airport', '29.330000', '-98.470000', 'http://weather.noaa.gov/weather/current/KSSF.html', 'http://weather.gov/data/current_obs/KSSF.rss', 'http://weather.gov/data/current_obs/KSSF.xml'),
('KSWW', 'TX', 'Sweetwater', '32.470000', '-100.470000', 'http://weather.noaa.gov/weather/current/KSWW.html', 'http://weather.gov/data/current_obs/KSWW.rss', 'http://weather.gov/data/current_obs/KSWW.xml'),
('KT65', 'TX', 'Weslaco', '26.167000', '-97.967000', 'http://weather.noaa.gov/weather/current/KT65.html', 'http://weather.gov/data/current_obs/KT65.rss', 'http://weather.gov/data/current_obs/KT65.xml'),
('KT82', 'TX', 'Fredericksburg', '30.244000', '-98.910000', 'http://weather.noaa.gov/weather/current/KT82.html', 'http://weather.gov/data/current_obs/KT82.rss', 'http://weather.gov/data/current_obs/KT82.xml'),
('KTKI', 'TX', 'Collin County Regional Airport', '33.180000', '-96.590000', 'http://weather.noaa.gov/weather/current/KTKI.html', 'http://weather.gov/data/current_obs/KTKI.rss', 'http://weather.gov/data/current_obs/KTKI.xml'),
('KTPL', 'TX', 'Temple / Miller Automatic Weather Observing/Report', '31.150000', '-97.420000', 'http://weather.noaa.gov/weather/current/KTPL.html', 'http://weather.gov/data/current_obs/KTPL.rss', 'http://weather.gov/data/current_obs/KTPL.xml'),
('KTRL', 'TX', 'Terrell Municipal Airport', '32.710000', '-96.270000', 'http://weather.noaa.gov/weather/current/KTRL.html', 'http://weather.gov/data/current_obs/KTRL.rss', 'http://weather.gov/data/current_obs/KTRL.xml'),
('KTYR', 'TX', 'Tyler Pounds Field', '32.350000', '-95.400000', 'http://weather.noaa.gov/weather/current/KTYR.html', 'http://weather.gov/data/current_obs/KTYR.rss', 'http://weather.gov/data/current_obs/KTYR.xml'),
('KUTS', 'TX', 'Huntsville Municipal Airport', '30.740000', '-95.590000', 'http://weather.noaa.gov/weather/current/KUTS.html', 'http://weather.gov/data/current_obs/KUTS.rss', 'http://weather.gov/data/current_obs/KUTS.xml'),
('KUVA', 'TX', 'Garner Field Airport', '29.211000', '-99.744000', 'http://weather.noaa.gov/weather/current/KUVA.html', 'http://weather.gov/data/current_obs/KUVA.rss', 'http://weather.gov/data/current_obs/KUVA.xml'),
('KVCT', 'TX', 'Victoria Regional Airport', '28.860000', '-96.920000', 'http://weather.noaa.gov/weather/current/KVCT.html', 'http://weather.gov/data/current_obs/KVCT.rss', 'http://weather.gov/data/current_obs/KVCT.xml'),
('KXBP', 'TX', 'Bridgeport Municipal Airport', '33.167000', '-97.833000', 'http://weather.noaa.gov/weather/current/KXBP.html', 'http://weather.gov/data/current_obs/KXBP.rss', 'http://weather.gov/data/current_obs/KXBP.xml'),
('KELP', 'TX', 'El Paso International Airport', '31.800000', '-106.400000', 'http://weather.noaa.gov/weather/current/KELP.html', 'http://weather.gov/data/current_obs/KELP.rss', 'http://weather.gov/data/current_obs/KELP.xml'),
('KPEZ', 'TX', 'Pleasanton Municipal Airport', '28.950000', '-98.520000', 'http://weather.noaa.gov/weather/current/KPEZ.html', 'http://weather.gov/data/current_obs/KPEZ.rss', 'http://weather.gov/data/current_obs/KPEZ.xml'),
('KT47', 'TX', 'Kickapoo Downtown Airport', '33.858000', '-98.490000', 'http://weather.noaa.gov/weather/current/KT47.html', 'http://weather.gov/data/current_obs/KT47.rss', 'http://weather.gov/data/current_obs/KT47.xml'),
('KHRX', 'TX', 'Hereford Municipal Airport', '34.860000', '-102.330000', 'http://weather.noaa.gov/weather/current/KHRX.html', 'http://weather.gov/data/current_obs/KHRX.rss', 'http://weather.gov/data/current_obs/KHRX.xml'),
('KAQO', 'TX', 'Llano Municipal Airport', '30.783700', '-98.662000', 'http://weather.noaa.gov/weather/current/KAQO.html', 'http://weather.gov/data/current_obs/KAQO.rss', 'http://weather.gov/data/current_obs/KAQO.xml'),
('KGYB', 'TX', 'Giddings-Lee County Airport', '30.169300', '-96.980000', 'http://weather.noaa.gov/weather/current/KGYB.html', 'http://weather.gov/data/current_obs/KGYB.rss', 'http://weather.gov/data/current_obs/KGYB.xml'),
('KJXI', 'TX', 'Fox Stephens Field - Gilmer Municipal Airport', '32.699000', '-94.948000', 'http://weather.noaa.gov/weather/current/KJXI.html', 'http://weather.gov/data/current_obs/KJXI.rss', 'http://weather.gov/data/current_obs/KJXI.xml'),
('KJDD', 'TX', 'Wood County Airport', '32.742000', '-95.496000', 'http://weather.noaa.gov/weather/current/KJDD.html', 'http://weather.gov/data/current_obs/KJDD.rss', 'http://weather.gov/data/current_obs/KJDD.xml'),
('K4BL', 'UT', 'Blanding', '37.620000', '-109.470000', 'http://weather.noaa.gov/weather/current/K4BL.html', 'http://weather.gov/data/current_obs/K4BL.rss', 'http://weather.gov/data/current_obs/K4BL.xml'),
('K4HV', 'UT', 'Hanksville', '38.380000', '-110.720000', 'http://weather.noaa.gov/weather/current/K4HV.html', 'http://weather.gov/data/current_obs/K4HV.rss', 'http://weather.gov/data/current_obs/K4HV.xml'),
('KBCE', 'UT', 'Bryce Canyon', '37.710000', '-112.160000', 'http://weather.noaa.gov/weather/current/KBCE.html', 'http://weather.gov/data/current_obs/KBCE.rss', 'http://weather.gov/data/current_obs/KBCE.xml'),
('KCDC', 'UT', 'Cedar City Muni', '37.700000', '-113.100000', 'http://weather.noaa.gov/weather/current/KCDC.html', 'http://weather.gov/data/current_obs/KCDC.rss', 'http://weather.gov/data/current_obs/KCDC.xml'),
('KCNY', 'UT', 'Moab/Canyonlands', '38.750000', '-109.750000', 'http://weather.noaa.gov/weather/current/KCNY.html', 'http://weather.gov/data/current_obs/KCNY.rss', 'http://weather.gov/data/current_obs/KCNY.xml'),
('KDPG', 'UT', 'Dugway Prvg Ground', '40.210000', '-112.930000', 'http://weather.noaa.gov/weather/current/KDPG.html', 'http://weather.gov/data/current_obs/KDPG.rss', 'http://weather.gov/data/current_obs/KDPG.xml'),
('KENV', 'UT', 'Wendover (aut)', '40.730000', '-114.030000', 'http://weather.noaa.gov/weather/current/KENV.html', 'http://weather.gov/data/current_obs/KENV.rss', 'http://weather.gov/data/current_obs/KENV.xml'),
('KHIF', 'UT', 'Ogden/Hill AFB', '41.120000', '-111.970000', 'http://weather.noaa.gov/weather/current/KHIF.html', 'http://weather.gov/data/current_obs/KHIF.rss', 'http://weather.gov/data/current_obs/KHIF.xml'),
('KLGU', 'UT', 'Logan-Cache Airport', '41.790000', '-111.850000', 'http://weather.noaa.gov/weather/current/KLGU.html', 'http://weather.gov/data/current_obs/KLGU.rss', 'http://weather.gov/data/current_obs/KLGU.xml'),
('KMLF', 'UT', 'Milford Municipal', '38.430000', '-113.020000', 'http://weather.noaa.gov/weather/current/KMLF.html', 'http://weather.gov/data/current_obs/KMLF.rss', 'http://weather.gov/data/current_obs/KMLF.xml'),
('KOGD', 'UT', 'Ogden-Hinckley Muni', '41.200000', '-112.010000', 'http://weather.noaa.gov/weather/current/KOGD.html', 'http://weather.gov/data/current_obs/KOGD.rss', 'http://weather.gov/data/current_obs/KOGD.xml'),
('KPUC', 'UT', 'Price/Carbon County', '39.620000', '-110.750000', 'http://weather.noaa.gov/weather/current/KPUC.html', 'http://weather.gov/data/current_obs/KPUC.rss', 'http://weather.gov/data/current_obs/KPUC.xml'),
('KPVU', 'UT', 'Provo Muni (awos)', '40.230000', '-111.720000', 'http://weather.noaa.gov/weather/current/KPVU.html', 'http://weather.gov/data/current_obs/KPVU.rss', 'http://weather.gov/data/current_obs/KPVU.xml'),
('KSGU', 'UT', 'Saint George (awos)', '37.090000', '-113.600000', 'http://weather.noaa.gov/weather/current/KSGU.html', 'http://weather.gov/data/current_obs/KSGU.rss', 'http://weather.gov/data/current_obs/KSGU.xml'),
('KSLC', 'UT', 'Salt Lake City International', '40.790000', '-111.970000', 'http://weather.noaa.gov/weather/current/KSLC.html', 'http://weather.gov/data/current_obs/KSLC.rss', 'http://weather.gov/data/current_obs/KSLC.xml'),
('KT62', 'UT', 'Tooele', '40.317000', '-112.300000', 'http://weather.noaa.gov/weather/current/KT62.html', 'http://weather.gov/data/current_obs/KT62.rss', 'http://weather.gov/data/current_obs/KT62.xml'),
('KU24', 'UT', 'Delta', '39.340000', '-112.590000', 'http://weather.noaa.gov/weather/current/KU24.html', 'http://weather.gov/data/current_obs/KU24.rss', 'http://weather.gov/data/current_obs/KU24.xml'),
('KU28', 'UT', 'Green River Range', '39.010000', '-110.150000', 'http://weather.noaa.gov/weather/current/KU28.html', 'http://weather.gov/data/current_obs/KU28.rss', 'http://weather.gov/data/current_obs/KU28.xml'),
('KVEL', 'UT', 'Vernal', '40.440000', '-109.510000', 'http://weather.noaa.gov/weather/current/KVEL.html', 'http://weather.gov/data/current_obs/KVEL.rss', 'http://weather.gov/data/current_obs/KVEL.xml'),
('K6V3', 'VA', 'Richlands Tazewell County Airport', '37.064000', '-81.798000', 'http://weather.noaa.gov/weather/current/K6V3.html', 'http://weather.gov/data/current_obs/K6V3.rss', 'http://weather.gov/data/current_obs/K6V3.xml'),
('KAKQ', 'VA', 'Wakefield Municipal Airport', '36.990000', '-77.000000', 'http://weather.noaa.gov/weather/current/KAKQ.html', 'http://weather.gov/data/current_obs/KAKQ.rss', 'http://weather.gov/data/current_obs/KAKQ.xml'),
('KAVC', 'VA', 'South Hill, Mecklenburg-Brunswick Regional Airport', '36.690000', '-78.050000', 'http://weather.noaa.gov/weather/current/KAVC.html', 'http://weather.gov/data/current_obs/KAVC.rss', 'http://weather.gov/data/current_obs/KAVC.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('KBCB', 'VA', 'Virginia Tech Airport', '37.208000', '-80.408000', 'http://weather.noaa.gov/weather/current/KBCB.html', 'http://weather.gov/data/current_obs/KBCB.rss', 'http://weather.gov/data/current_obs/KBCB.xml'),
('KCHO', 'VA', 'Charlottesville-Albemarle Airport', '38.140000', '-78.450000', 'http://weather.noaa.gov/weather/current/KCHO.html', 'http://weather.gov/data/current_obs/KCHO.rss', 'http://weather.gov/data/current_obs/KCHO.xml'),
('KCJR', 'VA', 'Culpeper County Airport', '38.530000', '-77.860000', 'http://weather.noaa.gov/weather/current/KCJR.html', 'http://weather.gov/data/current_obs/KCJR.rss', 'http://weather.gov/data/current_obs/KCJR.xml'),
('KCPK', 'VA', 'Chesapeake Municipal Airport', '36.660000', '-76.320000', 'http://weather.noaa.gov/weather/current/KCPK.html', 'http://weather.gov/data/current_obs/KCPK.rss', 'http://weather.gov/data/current_obs/KCPK.xml'),
('KDAA', 'VA', 'Fort Belvoir', '38.730000', '-77.180000', 'http://weather.noaa.gov/weather/current/KDAA.html', 'http://weather.gov/data/current_obs/KDAA.rss', 'http://weather.gov/data/current_obs/KDAA.xml'),
('KDAN', 'VA', 'Danville Regional Airport', '36.580000', '-79.330000', 'http://weather.noaa.gov/weather/current/KDAN.html', 'http://weather.gov/data/current_obs/KDAN.rss', 'http://weather.gov/data/current_obs/KDAN.xml'),
('KDCA', 'VA', 'Washington DC, Reagan National Airport', '38.860000', '-77.030000', 'http://weather.noaa.gov/weather/current/KDCA.html', 'http://weather.gov/data/current_obs/KDCA.rss', 'http://weather.gov/data/current_obs/KDCA.xml'),
('KEMV', 'VA', 'Emporia-Greensville Reg Airport', '36.690000', '-77.480000', 'http://weather.noaa.gov/weather/current/KEMV.html', 'http://weather.gov/data/current_obs/KEMV.rss', 'http://weather.gov/data/current_obs/KEMV.xml'),
('KEZF', 'VA', 'Shannon Airport', '38.270000', '-77.450000', 'http://weather.noaa.gov/weather/current/KEZF.html', 'http://weather.gov/data/current_obs/KEZF.rss', 'http://weather.gov/data/current_obs/KEZF.xml'),
('KFAF', 'VA', 'Fort Eustis / Felker', '37.140000', '-76.620000', 'http://weather.noaa.gov/weather/current/KFAF.html', 'http://weather.gov/data/current_obs/KFAF.rss', 'http://weather.gov/data/current_obs/KFAF.xml'),
('KFKN', 'VA', 'Franklin / J B Rose', '36.700000', '-76.900000', 'http://weather.noaa.gov/weather/current/KFKN.html', 'http://weather.gov/data/current_obs/KFKN.rss', 'http://weather.gov/data/current_obs/KFKN.xml'),
('KFVX', 'VA', 'Farmville', '37.350000', '-78.430000', 'http://weather.noaa.gov/weather/current/KFVX.html', 'http://weather.gov/data/current_obs/KFVX.rss', 'http://weather.gov/data/current_obs/KFVX.xml'),
('KFYJ', 'VA', 'Middle Peninsula Regional Airport', '37.517000', '-76.767000', 'http://weather.noaa.gov/weather/current/KFYJ.html', 'http://weather.gov/data/current_obs/KFYJ.rss', 'http://weather.gov/data/current_obs/KFYJ.xml'),
('KHEF', 'VA', 'Manassas Municipal Automatic Weather Observing', '38.720000', '-77.520000', 'http://weather.noaa.gov/weather/current/KHEF.html', 'http://weather.gov/data/current_obs/KHEF.rss', 'http://weather.gov/data/current_obs/KHEF.xml'),
('KHLX', 'VA', 'Hillsville', '36.770000', '-80.820000', 'http://weather.noaa.gov/weather/current/KHLX.html', 'http://weather.gov/data/current_obs/KHLX.rss', 'http://weather.gov/data/current_obs/KHLX.xml'),
('KHSP', 'VA', 'Hot Springs / Ingalls', '37.960000', '-79.820000', 'http://weather.noaa.gov/weather/current/KHSP.html', 'http://weather.gov/data/current_obs/KHSP.rss', 'http://weather.gov/data/current_obs/KHSP.xml'),
('KIAD', 'VA', 'Washington-Dulles International Airport', '38.960000', '-77.450000', 'http://weather.noaa.gov/weather/current/KIAD.html', 'http://weather.gov/data/current_obs/KIAD.rss', 'http://weather.gov/data/current_obs/KIAD.xml'),
('KJGG', 'VA', 'Williamsburg-Jamestown Airport', '37.233000', '-76.717000', 'http://weather.noaa.gov/weather/current/KJGG.html', 'http://weather.gov/data/current_obs/KJGG.rss', 'http://weather.gov/data/current_obs/KJGG.xml'),
('KJYO', 'VA', 'Leesburg / Godfrey', '39.080000', '-77.570000', 'http://weather.noaa.gov/weather/current/KJYO.html', 'http://weather.gov/data/current_obs/KJYO.rss', 'http://weather.gov/data/current_obs/KJYO.xml'),
('KLFI', 'VA', 'Langley Air Force Base', '37.090000', '-76.350000', 'http://weather.noaa.gov/weather/current/KLFI.html', 'http://weather.gov/data/current_obs/KLFI.rss', 'http://weather.gov/data/current_obs/KLFI.xml'),
('KLKU', 'VA', 'Louisa County / Freeman Field Airport', '38.011000', '-77.978000', 'http://weather.noaa.gov/weather/current/KLKU.html', 'http://weather.gov/data/current_obs/KLKU.rss', 'http://weather.gov/data/current_obs/KLKU.xml'),
('KLNP', 'VA', 'Wise / Lonesome Pine', '36.980000', '-82.530000', 'http://weather.noaa.gov/weather/current/KLNP.html', 'http://weather.gov/data/current_obs/KLNP.rss', 'http://weather.gov/data/current_obs/KLNP.xml'),
('KLYH', 'VA', 'Lynchburg Regional Airport', '37.340000', '-79.200000', 'http://weather.noaa.gov/weather/current/KLYH.html', 'http://weather.gov/data/current_obs/KLYH.rss', 'http://weather.gov/data/current_obs/KLYH.xml'),
('KMFV', 'VA', 'Melfa / Accomack Airport', '37.650000', '-75.770000', 'http://weather.noaa.gov/weather/current/KMFV.html', 'http://weather.gov/data/current_obs/KMFV.rss', 'http://weather.gov/data/current_obs/KMFV.xml'),
('KMKJ', 'VA', 'Marion / Wytheville', '36.900000', '-81.350000', 'http://weather.noaa.gov/weather/current/KMKJ.html', 'http://weather.gov/data/current_obs/KMKJ.rss', 'http://weather.gov/data/current_obs/KMKJ.xml'),
('KMTV', 'VA', 'Martinsville', '36.630000', '-80.020000', 'http://weather.noaa.gov/weather/current/KMTV.html', 'http://weather.gov/data/current_obs/KMTV.rss', 'http://weather.gov/data/current_obs/KMTV.xml'),
('KNGU', 'VA', 'Norfolk, Naval Air Station', '36.940000', '-76.280000', 'http://weather.noaa.gov/weather/current/KNGU.html', 'http://weather.gov/data/current_obs/KNGU.rss', 'http://weather.gov/data/current_obs/KNGU.xml'),
('KNTU', 'VA', 'Virginia Beach, Oceana, Naval Air Station', '36.830000', '-76.030000', 'http://weather.noaa.gov/weather/current/KNTU.html', 'http://weather.gov/data/current_obs/KNTU.rss', 'http://weather.gov/data/current_obs/KNTU.xml'),
('KNYG', 'VA', 'Quantico Marine Corps Air Facility', '38.510000', '-77.300000', 'http://weather.noaa.gov/weather/current/KNYG.html', 'http://weather.gov/data/current_obs/KNYG.rss', 'http://weather.gov/data/current_obs/KNYG.xml'),
('KOFP', 'VA', 'Ashland, Hanover County Municipal Airport', '37.700000', '-77.430000', 'http://weather.noaa.gov/weather/current/KOFP.html', 'http://weather.gov/data/current_obs/KOFP.rss', 'http://weather.gov/data/current_obs/KOFP.xml'),
('KOKV', 'VA', 'Winchester Regional', '39.150000', '-78.150000', 'http://weather.noaa.gov/weather/current/KOKV.html', 'http://weather.gov/data/current_obs/KOKV.rss', 'http://weather.gov/data/current_obs/KOKV.xml'),
('KOMH', 'VA', 'Orange County Airport', '38.247000', '-78.046000', 'http://weather.noaa.gov/weather/current/KOMH.html', 'http://weather.gov/data/current_obs/KOMH.rss', 'http://weather.gov/data/current_obs/KOMH.xml'),
('KORF', 'VA', 'Norfolk International Airport', '36.910000', '-76.200000', 'http://weather.noaa.gov/weather/current/KORF.html', 'http://weather.gov/data/current_obs/KORF.rss', 'http://weather.gov/data/current_obs/KORF.xml'),
('KPHF', 'VA', 'Newport News / Williamsburg Intl Airport', '37.140000', '-76.500000', 'http://weather.noaa.gov/weather/current/KPHF.html', 'http://weather.gov/data/current_obs/KPHF.rss', 'http://weather.gov/data/current_obs/KPHF.xml'),
('KPSK', 'VA', 'Dublin / New River Valley', '37.140000', '-80.680000', 'http://weather.noaa.gov/weather/current/KPSK.html', 'http://weather.gov/data/current_obs/KPSK.rss', 'http://weather.gov/data/current_obs/KPSK.xml'),
('KPTB', 'VA', 'Petersburg Automatic Weather Observing / Reporting', '37.190000', '-77.520000', 'http://weather.noaa.gov/weather/current/KPTB.html', 'http://weather.gov/data/current_obs/KPTB.rss', 'http://weather.gov/data/current_obs/KPTB.xml'),
('KRIC', 'VA', 'Richmond International Airport', '37.510000', '-77.310000', 'http://weather.noaa.gov/weather/current/KRIC.html', 'http://weather.gov/data/current_obs/KRIC.rss', 'http://weather.gov/data/current_obs/KRIC.xml'),
('KRMN', 'VA', 'Stafford Regional Airport', '38.400000', '-77.450000', 'http://weather.noaa.gov/weather/current/KRMN.html', 'http://weather.gov/data/current_obs/KRMN.rss', 'http://weather.gov/data/current_obs/KRMN.xml'),
('KROA', 'VA', 'Roanoke Regional Airport', '37.330000', '-79.970000', 'http://weather.noaa.gov/weather/current/KROA.html', 'http://weather.gov/data/current_obs/KROA.rss', 'http://weather.gov/data/current_obs/KROA.xml'),
('KSFQ', 'VA', 'Suffolk Municipal Airport', '36.680000', '-76.600000', 'http://weather.noaa.gov/weather/current/KSFQ.html', 'http://weather.gov/data/current_obs/KSFQ.rss', 'http://weather.gov/data/current_obs/KSFQ.xml'),
('KSHD', 'VA', 'Staunton / Shenandoah', '38.280000', '-78.850000', 'http://weather.noaa.gov/weather/current/KSHD.html', 'http://weather.gov/data/current_obs/KSHD.rss', 'http://weather.gov/data/current_obs/KSHD.xml'),
('KVJI', 'VA', 'Abingdon', '36.680000', '-82.030000', 'http://weather.noaa.gov/weather/current/KVJI.html', 'http://weather.gov/data/current_obs/KVJI.rss', 'http://weather.gov/data/current_obs/KVJI.xml'),
('KWAL', 'VA', 'Wallops Flight Facility Airport', '37.940000', '-75.470000', 'http://weather.noaa.gov/weather/current/KWAL.html', 'http://weather.gov/data/current_obs/KWAL.rss', 'http://weather.gov/data/current_obs/KWAL.xml'),
('TVSV', 'VC', 'Arnos Vale', '13.133000', '-61.200000', 'http://weather.noaa.gov/weather/current/TVSV.html', 'http://weather.gov/data/current_obs/TVSV.rss', 'http://weather.gov/data/current_obs/TVSV.xml'),
('TUPJ', 'VG', 'Beef Island-Tortola', '18.450000', '-64.533000', 'http://weather.noaa.gov/weather/current/TUPJ.html', 'http://weather.gov/data/current_obs/TUPJ.rss', 'http://weather.gov/data/current_obs/TUPJ.xml'),
('TIST', 'VI', 'St Thomas-Charlotte Amalie/CyrilE King Int Airport', '18.330000', '-64.970000', 'http://weather.noaa.gov/weather/current/TIST.html', 'http://weather.gov/data/current_obs/TIST.rss', 'http://weather.gov/data/current_obs/TIST.xml'),
('TISX', 'VI', 'St Croix (Christiansted, Henry E. Rohlsen Airport)', '17.700000', '-64.800000', 'http://weather.noaa.gov/weather/current/TISX.html', 'http://weather.gov/data/current_obs/TISX.rss', 'http://weather.gov/data/current_obs/TISX.xml'),
('TKPK', 'VI', 'Golden Rock-Saint Kitts-Nexus', '17.300000', '-62.683000', 'http://weather.noaa.gov/weather/current/TKPK.html', 'http://weather.gov/data/current_obs/TKPK.rss', 'http://weather.gov/data/current_obs/TKPK.xml'),
('TQPF', 'VI', 'Wallblake', '18.200000', '-63.050000', 'http://weather.noaa.gov/weather/current/TQPF.html', 'http://weather.gov/data/current_obs/TQPF.rss', 'http://weather.gov/data/current_obs/TQPF.xml'),
('K1V4', 'VT', 'Saint Johnsbury', '44.420000', '-72.020000', 'http://weather.noaa.gov/weather/current/K1V4.html', 'http://weather.gov/data/current_obs/K1V4.rss', 'http://weather.gov/data/current_obs/K1V4.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('KBTV', 'VT', 'Burlington International Airport', '44.480000', '-73.150000', 'http://weather.noaa.gov/weather/current/KBTV.html', 'http://weather.gov/data/current_obs/KBTV.rss', 'http://weather.gov/data/current_obs/KBTV.xml'),
('KDDH', 'VT', 'Bennington Morse State Airport', '42.890000', '-73.246000', 'http://weather.noaa.gov/weather/current/KDDH.html', 'http://weather.gov/data/current_obs/KDDH.rss', 'http://weather.gov/data/current_obs/KDDH.xml'),
('KMPV', 'VT', 'Barre / Montpelier, Knapp State Airport', '44.210000', '-72.570000', 'http://weather.noaa.gov/weather/current/KMPV.html', 'http://weather.gov/data/current_obs/KMPV.rss', 'http://weather.gov/data/current_obs/KMPV.xml'),
('KMVL', 'VT', 'Morrisville-Stowe State Airport', '44.530000', '-72.610000', 'http://weather.noaa.gov/weather/current/KMVL.html', 'http://weather.gov/data/current_obs/KMVL.rss', 'http://weather.gov/data/current_obs/KMVL.xml'),
('KRUT', 'VT', 'Rutland State Automatic Weather Observing / Report', '43.540000', '-72.950000', 'http://weather.noaa.gov/weather/current/KRUT.html', 'http://weather.gov/data/current_obs/KRUT.rss', 'http://weather.gov/data/current_obs/KRUT.xml'),
('KVSF', 'VT', 'Hartness State Springfield Airport', '43.340000', '-72.520000', 'http://weather.noaa.gov/weather/current/KVSF.html', 'http://weather.gov/data/current_obs/KVSF.rss', 'http://weather.gov/data/current_obs/KVSF.xml'),
('K76S', 'WA', 'Oak Harbor Airport', '48.250000', '-122.667000', 'http://weather.noaa.gov/weather/current/K76S.html', 'http://weather.gov/data/current_obs/K76S.rss', 'http://weather.gov/data/current_obs/K76S.xml'),
('KALW', 'WA', 'Walla Walla Rgn', '46.090000', '-118.290000', 'http://weather.noaa.gov/weather/current/KALW.html', 'http://weather.gov/data/current_obs/KALW.rss', 'http://weather.gov/data/current_obs/KALW.xml'),
('KAWO', 'WA', 'Arlington Muni', '48.170000', '-122.170000', 'http://weather.noaa.gov/weather/current/KAWO.html', 'http://weather.gov/data/current_obs/KAWO.rss', 'http://weather.gov/data/current_obs/KAWO.xml'),
('KBFI', 'WA', 'Seattle/Boeing Fld', '47.540000', '-122.300000', 'http://weather.noaa.gov/weather/current/KBFI.html', 'http://weather.gov/data/current_obs/KBFI.rss', 'http://weather.gov/data/current_obs/KBFI.xml'),
('KBLI', 'WA', 'Bellingham Intl Airport', '48.790000', '-122.540000', 'http://weather.noaa.gov/weather/current/KBLI.html', 'http://weather.gov/data/current_obs/KBLI.rss', 'http://weather.gov/data/current_obs/KBLI.xml'),
('KBVS', 'WA', 'Skagit Regional Airport', '48.467000', '-122.417000', 'http://weather.noaa.gov/weather/current/KBVS.html', 'http://weather.gov/data/current_obs/KBVS.rss', 'http://weather.gov/data/current_obs/KBVS.xml'),
('KCLM', 'WA', 'Port Angeles Intl Airport', '48.120000', '-123.500000', 'http://weather.noaa.gov/weather/current/KCLM.html', 'http://weather.gov/data/current_obs/KCLM.rss', 'http://weather.gov/data/current_obs/KCLM.xml'),
('KCQV', 'WA', 'Colville Municipal', '48.550000', '-117.890000', 'http://weather.noaa.gov/weather/current/KCQV.html', 'http://weather.gov/data/current_obs/KCQV.rss', 'http://weather.gov/data/current_obs/KCQV.xml'),
('KDEW', 'WA', 'Deer Park (was 07s)', '47.974000', '-117.428000', 'http://weather.noaa.gov/weather/current/KDEW.html', 'http://weather.gov/data/current_obs/KDEW.rss', 'http://weather.gov/data/current_obs/KDEW.xml'),
('KEAT', 'WA', 'Wenatchee/Pangborn', '47.410000', '-120.200000', 'http://weather.noaa.gov/weather/current/KEAT.html', 'http://weather.gov/data/current_obs/KEAT.rss', 'http://weather.gov/data/current_obs/KEAT.xml'),
('KELN', 'WA', 'Ellensburg/Bowers', '47.030000', '-120.530000', 'http://weather.noaa.gov/weather/current/KELN.html', 'http://weather.gov/data/current_obs/KELN.rss', 'http://weather.gov/data/current_obs/KELN.xml'),
('KEPH', 'WA', 'Ephrata Municipal', '47.330000', '-119.520000', 'http://weather.noaa.gov/weather/current/KEPH.html', 'http://weather.gov/data/current_obs/KEPH.rss', 'http://weather.gov/data/current_obs/KEPH.xml'),
('KFHR', 'WA', 'Friday Harbor', '48.520000', '-123.020000', 'http://weather.noaa.gov/weather/current/KFHR.html', 'http://weather.gov/data/current_obs/KFHR.rss', 'http://weather.gov/data/current_obs/KFHR.xml'),
('KGEG', 'WA', 'Spokane Intl Arpt', '47.640000', '-117.530000', 'http://weather.noaa.gov/weather/current/KGEG.html', 'http://weather.gov/data/current_obs/KGEG.rss', 'http://weather.gov/data/current_obs/KGEG.xml'),
('KGRF', 'WA', 'Fort Lewis/Gray Aaf', '47.090000', '-122.580000', 'http://weather.noaa.gov/weather/current/KGRF.html', 'http://weather.gov/data/current_obs/KGRF.rss', 'http://weather.gov/data/current_obs/KGRF.xml'),
('KHMS', 'WA', 'Hanford', '46.580000', '-119.580000', 'http://weather.noaa.gov/weather/current/KHMS.html', 'http://weather.gov/data/current_obs/KHMS.rss', 'http://weather.gov/data/current_obs/KHMS.xml'),
('KHQM', 'WA', 'Hoquiam/Bowerman', '46.980000', '-123.970000', 'http://weather.noaa.gov/weather/current/KHQM.html', 'http://weather.gov/data/current_obs/KHQM.rss', 'http://weather.gov/data/current_obs/KHQM.xml'),
('KKLS', 'WA', 'Kelso-Longview AWOS', '46.117000', '-122.900000', 'http://weather.noaa.gov/weather/current/KKLS.html', 'http://weather.gov/data/current_obs/KKLS.rss', 'http://weather.gov/data/current_obs/KKLS.xml'),
('KMWH', 'WA', 'Moses Lake/Grant Co', '47.210000', '-119.320000', 'http://weather.noaa.gov/weather/current/KMWH.html', 'http://weather.gov/data/current_obs/KMWH.rss', 'http://weather.gov/data/current_obs/KMWH.xml'),
('KNUW', 'WA', 'Whidbey Island Nas', '48.360000', '-122.650000', 'http://weather.noaa.gov/weather/current/KNUW.html', 'http://weather.gov/data/current_obs/KNUW.rss', 'http://weather.gov/data/current_obs/KNUW.xml'),
('KOLM', 'WA', 'Olympia', '46.980000', '-122.900000', 'http://weather.noaa.gov/weather/current/KOLM.html', 'http://weather.gov/data/current_obs/KOLM.rss', 'http://weather.gov/data/current_obs/KOLM.xml'),
('KOMK', 'WA', 'Omak Airport', '48.460000', '-119.520000', 'http://weather.noaa.gov/weather/current/KOMK.html', 'http://weather.gov/data/current_obs/KOMK.rss', 'http://weather.gov/data/current_obs/KOMK.xml'),
('KORS', 'WA', 'Orcas Island Airport', '48.717000', '-122.917000', 'http://weather.noaa.gov/weather/current/KORS.html', 'http://weather.gov/data/current_obs/KORS.rss', 'http://weather.gov/data/current_obs/KORS.xml'),
('KPAE', 'WA', 'Everett/Paine Field', '47.910000', '-122.280000', 'http://weather.noaa.gov/weather/current/KPAE.html', 'http://weather.gov/data/current_obs/KPAE.rss', 'http://weather.gov/data/current_obs/KPAE.xml'),
('KPSC', 'WA', 'Pasco/Tri-Cities', '46.270000', '-119.120000', 'http://weather.noaa.gov/weather/current/KPSC.html', 'http://weather.gov/data/current_obs/KPSC.rss', 'http://weather.gov/data/current_obs/KPSC.xml'),
('KPUW', 'WA', 'Pullman/Moscow Rgnl', '46.760000', '-117.120000', 'http://weather.noaa.gov/weather/current/KPUW.html', 'http://weather.gov/data/current_obs/KPUW.rss', 'http://weather.gov/data/current_obs/KPUW.xml'),
('KPWT', 'WA', 'Bremerton Ntnl Awos', '47.480000', '-122.770000', 'http://weather.noaa.gov/weather/current/KPWT.html', 'http://weather.gov/data/current_obs/KPWT.rss', 'http://weather.gov/data/current_obs/KPWT.xml'),
('KRNT', 'WA', 'Renton Municipal', '47.510000', '-122.220000', 'http://weather.noaa.gov/weather/current/KRNT.html', 'http://weather.gov/data/current_obs/KRNT.rss', 'http://weather.gov/data/current_obs/KRNT.xml'),
('KSEA', 'WA', 'Seattle-Tacoma Intl Airport', '47.440000', '-122.310000', 'http://weather.noaa.gov/weather/current/KSEA.html', 'http://weather.gov/data/current_obs/KSEA.rss', 'http://weather.gov/data/current_obs/KSEA.xml'),
('KSFF', 'WA', 'Spokane/Felts Field', '47.680000', '-117.320000', 'http://weather.noaa.gov/weather/current/KSFF.html', 'http://weather.gov/data/current_obs/KSFF.rss', 'http://weather.gov/data/current_obs/KSFF.xml'),
('KSHN', 'WA', 'Shelton/Sanderson', '47.230000', '-123.150000', 'http://weather.noaa.gov/weather/current/KSHN.html', 'http://weather.gov/data/current_obs/KSHN.rss', 'http://weather.gov/data/current_obs/KSHN.xml'),
('KSKA', 'WA', 'Fairchild AFB', '47.620000', '-117.650000', 'http://weather.noaa.gov/weather/current/KSKA.html', 'http://weather.gov/data/current_obs/KSKA.rss', 'http://weather.gov/data/current_obs/KSKA.xml'),
('KSMP', 'WA', 'Stampede Pass(amos)', '47.290000', '-121.330000', 'http://weather.noaa.gov/weather/current/KSMP.html', 'http://weather.gov/data/current_obs/KSMP.rss', 'http://weather.gov/data/current_obs/KSMP.xml'),
('KTCM', 'WA', 'Mc Chord AFB/Tacoma', '47.160000', '-122.480000', 'http://weather.noaa.gov/weather/current/KTCM.html', 'http://weather.gov/data/current_obs/KTCM.rss', 'http://weather.gov/data/current_obs/KTCM.xml'),
('KTDO', 'WA', 'Toledo-Winlock Mem', '46.480000', '-122.800000', 'http://weather.noaa.gov/weather/current/KTDO.html', 'http://weather.gov/data/current_obs/KTDO.rss', 'http://weather.gov/data/current_obs/KTDO.xml'),
('KTIW', 'WA', 'Tacoma Narrows', '47.280000', '-122.580000', 'http://weather.noaa.gov/weather/current/KTIW.html', 'http://weather.gov/data/current_obs/KTIW.rss', 'http://weather.gov/data/current_obs/KTIW.xml'),
('KUIL', 'WA', 'Quillayute State', '47.960000', '-124.550000', 'http://weather.noaa.gov/weather/current/KUIL.html', 'http://weather.gov/data/current_obs/KUIL.rss', 'http://weather.gov/data/current_obs/KUIL.xml'),
('KVUO', 'WA', 'Pearson Airpark Vancouver', '45.620000', '122.660000', 'http://weather.noaa.gov/weather/current/KVUO.html', 'http://weather.gov/data/current_obs/KVUO.rss', 'http://weather.gov/data/current_obs/KVUO.xml'),
('KYKM', 'WA', 'Yakima Air Term', '46.560000', '-120.530000', 'http://weather.noaa.gov/weather/current/KYKM.html', 'http://weather.gov/data/current_obs/KYKM.rss', 'http://weather.gov/data/current_obs/KYKM.xml'),
('KAIG', 'WI', 'Antigo - Lang Automatic Weather Observing / Report', '45.010000', '-89.130000', 'http://weather.noaa.gov/weather/current/KAIG.html', 'http://weather.gov/data/current_obs/KAIG.rss', 'http://weather.gov/data/current_obs/KAIG.xml'),
('KARV', 'WI', 'Minocqua / Woodruff', '45.930000', '-89.730000', 'http://weather.noaa.gov/weather/current/KARV.html', 'http://weather.gov/data/current_obs/KARV.rss', 'http://weather.gov/data/current_obs/KARV.xml'),
('KASX', 'WI', 'Ashland, Kennedy Memorial Airport', '46.550000', '-90.920000', 'http://weather.noaa.gov/weather/current/KASX.html', 'http://weather.gov/data/current_obs/KASX.rss', 'http://weather.gov/data/current_obs/KASX.xml'),
('KATW', 'WI', 'Appleton / Outagamie', '44.260000', '-88.520000', 'http://weather.noaa.gov/weather/current/KATW.html', 'http://weather.gov/data/current_obs/KATW.rss', 'http://weather.gov/data/current_obs/KATW.xml'),
('KAUW', 'WI', 'Wausau Downtown Airport', '44.930000', '-89.620000', 'http://weather.noaa.gov/weather/current/KAUW.html', 'http://weather.gov/data/current_obs/KAUW.rss', 'http://weather.gov/data/current_obs/KAUW.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('KBUU', 'WI', 'Burlington Municipal Airport', '42.691000', '-88.305000', 'http://weather.noaa.gov/weather/current/KBUU.html', 'http://weather.gov/data/current_obs/KBUU.rss', 'http://weather.gov/data/current_obs/KBUU.xml'),
('KCLI', 'WI', 'Clintonville Municipal Airport', '44.610000', '-88.730000', 'http://weather.noaa.gov/weather/current/KCLI.html', 'http://weather.gov/data/current_obs/KCLI.rss', 'http://weather.gov/data/current_obs/KCLI.xml'),
('KCMY', 'WI', 'Sparta / Fort McCoy Airport', '43.958000', '-90.738000', 'http://weather.noaa.gov/weather/current/KCMY.html', 'http://weather.gov/data/current_obs/KCMY.rss', 'http://weather.gov/data/current_obs/KCMY.xml'),
('KCWA', 'WI', 'Mosinee / Central Wisconsin', '44.790000', '-89.670000', 'http://weather.noaa.gov/weather/current/KCWA.html', 'http://weather.gov/data/current_obs/KCWA.rss', 'http://weather.gov/data/current_obs/KCWA.xml'),
('KDLL', 'WI', 'Baraboo Wisconsin Dells Airport', '43.522000', '-89.771000', 'http://weather.noaa.gov/weather/current/KDLL.html', 'http://weather.gov/data/current_obs/KDLL.rss', 'http://weather.gov/data/current_obs/KDLL.xml'),
('KEAU', 'WI', 'Eau Claire, Chippewa Valley Regional Airport', '44.880000', '-91.480000', 'http://weather.noaa.gov/weather/current/KEAU.html', 'http://weather.gov/data/current_obs/KEAU.rss', 'http://weather.gov/data/current_obs/KEAU.xml'),
('KEFT', 'WI', 'Monroe Municipal Airport', '42.610000', '-89.590000', 'http://weather.noaa.gov/weather/current/KEFT.html', 'http://weather.gov/data/current_obs/KEFT.rss', 'http://weather.gov/data/current_obs/KEFT.xml'),
('KEGV', 'WI', 'Eagle River Union Airport', '45.930000', '-89.270000', 'http://weather.noaa.gov/weather/current/KEGV.html', 'http://weather.gov/data/current_obs/KEGV.rss', 'http://weather.gov/data/current_obs/KEGV.xml'),
('KENW', 'WI', 'Kenosha Regional Airport', '42.590000', '-87.940000', 'http://weather.noaa.gov/weather/current/KENW.html', 'http://weather.gov/data/current_obs/KENW.rss', 'http://weather.gov/data/current_obs/KENW.xml'),
('KETB', 'WI', 'West Bend Municipal Airport', '43.440000', '-88.130000', 'http://weather.noaa.gov/weather/current/KETB.html', 'http://weather.gov/data/current_obs/KETB.rss', 'http://weather.gov/data/current_obs/KETB.xml'),
('KFLD', 'WI', 'Fond Du Lac County Airport', '43.770000', '-88.490000', 'http://weather.noaa.gov/weather/current/KFLD.html', 'http://weather.gov/data/current_obs/KFLD.rss', 'http://weather.gov/data/current_obs/KFLD.xml'),
('KGRB', 'WI', 'Green Bay, Austin Straubel International Airport', '44.480000', '-88.130000', 'http://weather.noaa.gov/weather/current/KGRB.html', 'http://weather.gov/data/current_obs/KGRB.rss', 'http://weather.gov/data/current_obs/KGRB.xml'),
('KHYR', 'WI', 'Hayward Municipal Airport', '46.160000', '-91.450000', 'http://weather.noaa.gov/weather/current/KHYR.html', 'http://weather.gov/data/current_obs/KHYR.rss', 'http://weather.gov/data/current_obs/KHYR.xml'),
('KISW', 'WI', 'Wisconsin Rapids, Alexander Field So. Wood County', '44.360000', '-89.830000', 'http://weather.noaa.gov/weather/current/KISW.html', 'http://weather.gov/data/current_obs/KISW.rss', 'http://weather.gov/data/current_obs/KISW.xml'),
('KJVL', 'WI', 'Janesville / Rock County', '42.620000', '-89.030000', 'http://weather.noaa.gov/weather/current/KJVL.html', 'http://weather.gov/data/current_obs/KJVL.rss', 'http://weather.gov/data/current_obs/KJVL.xml'),
('KLNL', 'WI', 'Kings Land O Lakes Airport', '46.150000', '-89.217000', 'http://weather.noaa.gov/weather/current/KLNL.html', 'http://weather.gov/data/current_obs/KLNL.rss', 'http://weather.gov/data/current_obs/KLNL.xml'),
('KLNR', 'WI', 'Lone Rock, Tri-County Regional Airport', '43.210000', '-90.180000', 'http://weather.noaa.gov/weather/current/KLNR.html', 'http://weather.gov/data/current_obs/KLNR.rss', 'http://weather.gov/data/current_obs/KLNR.xml'),
('KLSE', 'WI', 'La Crosse Municipal Airport', '43.880000', '-91.250000', 'http://weather.noaa.gov/weather/current/KLSE.html', 'http://weather.gov/data/current_obs/KLSE.rss', 'http://weather.gov/data/current_obs/KLSE.xml'),
('KLUM', 'WI', 'Menomonie Municipal Airport-Score Field', '44.883000', '-91.867000', 'http://weather.noaa.gov/weather/current/KLUM.html', 'http://weather.gov/data/current_obs/KLUM.rss', 'http://weather.gov/data/current_obs/KLUM.xml'),
('KMDZ', 'WI', 'Medford, Taylor County Airport', '45.100000', '-90.300000', 'http://weather.noaa.gov/weather/current/KMDZ.html', 'http://weather.gov/data/current_obs/KMDZ.rss', 'http://weather.gov/data/current_obs/KMDZ.xml'),
('KMFI', 'WI', 'Marshfield Municipal Airport', '44.630000', '-90.180000', 'http://weather.noaa.gov/weather/current/KMFI.html', 'http://weather.gov/data/current_obs/KMFI.rss', 'http://weather.gov/data/current_obs/KMFI.xml'),
('KMKE', 'WI', 'Milwaukee, General Mitchell International Airport', '42.960000', '-87.900000', 'http://weather.noaa.gov/weather/current/KMKE.html', 'http://weather.gov/data/current_obs/KMKE.rss', 'http://weather.gov/data/current_obs/KMKE.xml'),
('KMRJ', 'WI', 'Mineral Point, Iowa County Airport', '42.890000', '-90.230000', 'http://weather.noaa.gov/weather/current/KMRJ.html', 'http://weather.gov/data/current_obs/KMRJ.rss', 'http://weather.gov/data/current_obs/KMRJ.xml'),
('KMSN', 'WI', 'Madison, Dane County Regional-Truax Field', '43.140000', '-89.330000', 'http://weather.noaa.gov/weather/current/KMSN.html', 'http://weather.gov/data/current_obs/KMSN.rss', 'http://weather.gov/data/current_obs/KMSN.xml'),
('KMTW', 'WI', 'Manitowoc Municipal Automatic Weather Observing', '44.140000', '-87.670000', 'http://weather.noaa.gov/weather/current/KMTW.html', 'http://weather.gov/data/current_obs/KMTW.rss', 'http://weather.gov/data/current_obs/KMTW.xml'),
('KMWC', 'WI', 'Milwaukee / Timmerman', '43.120000', '-88.050000', 'http://weather.noaa.gov/weather/current/KMWC.html', 'http://weather.gov/data/current_obs/KMWC.rss', 'http://weather.gov/data/current_obs/KMWC.xml'),
('KOEO', 'WI', 'Osceola, L O Simenstad Municipal Airport', '45.310000', '-92.690000', 'http://weather.noaa.gov/weather/current/KOEO.html', 'http://weather.gov/data/current_obs/KOEO.rss', 'http://weather.gov/data/current_obs/KOEO.xml'),
('KOSH', 'WI', 'Oshkosh, Wittman Regional Airport', '44.010000', '-88.570000', 'http://weather.noaa.gov/weather/current/KOSH.html', 'http://weather.gov/data/current_obs/KOSH.rss', 'http://weather.gov/data/current_obs/KOSH.xml'),
('KOVS', 'WI', 'Boscobel Airport', '43.160000', '-90.680000', 'http://weather.noaa.gov/weather/current/KOVS.html', 'http://weather.gov/data/current_obs/KOVS.rss', 'http://weather.gov/data/current_obs/KOVS.xml'),
('KPBH', 'WI', 'Phillips / Price County', '45.410000', '-90.240000', 'http://weather.noaa.gov/weather/current/KPBH.html', 'http://weather.gov/data/current_obs/KPBH.rss', 'http://weather.gov/data/current_obs/KPBH.xml'),
('KPCZ', 'WI', 'Waupaca Municipal Airport', '44.333000', '-89.020000', 'http://weather.noaa.gov/weather/current/KPCZ.html', 'http://weather.gov/data/current_obs/KPCZ.rss', 'http://weather.gov/data/current_obs/KPCZ.xml'),
('KPDC', 'WI', 'Prairie Du Chien Municipal Airport', '43.020000', '-91.120000', 'http://weather.noaa.gov/weather/current/KPDC.html', 'http://weather.gov/data/current_obs/KPDC.rss', 'http://weather.gov/data/current_obs/KPDC.xml'),
('KRAC', 'WI', 'Racine, Batten International Airport', '42.760000', '-87.810000', 'http://weather.noaa.gov/weather/current/KRAC.html', 'http://weather.gov/data/current_obs/KRAC.rss', 'http://weather.gov/data/current_obs/KRAC.xml'),
('KRCX', 'WI', 'Rusk County Airport', '45.483000', '-91.000000', 'http://weather.noaa.gov/weather/current/KRCX.html', 'http://weather.gov/data/current_obs/KRCX.rss', 'http://weather.gov/data/current_obs/KRCX.xml'),
('KRHI', 'WI', 'Rhinelander-Oneida County Airport', '45.630000', '-89.470000', 'http://weather.noaa.gov/weather/current/KRHI.html', 'http://weather.gov/data/current_obs/KRHI.rss', 'http://weather.gov/data/current_obs/KRHI.xml'),
('KRNH', 'WI', 'New Richmond Municipal Airport', '45.148000', '-92.538000', 'http://weather.noaa.gov/weather/current/KRNH.html', 'http://weather.gov/data/current_obs/KRNH.rss', 'http://weather.gov/data/current_obs/KRNH.xml'),
('KRPD', 'WI', 'Rice Lake Regl - Carls Field Airport', '45.510000', '-91.730000', 'http://weather.noaa.gov/weather/current/KRPD.html', 'http://weather.gov/data/current_obs/KRPD.rss', 'http://weather.gov/data/current_obs/KRPD.xml'),
('KRRL', 'WI', 'Merrill Municipal Airport', '45.200000', '-89.710000', 'http://weather.noaa.gov/weather/current/KRRL.html', 'http://weather.gov/data/current_obs/KRRL.rss', 'http://weather.gov/data/current_obs/KRRL.xml'),
('KRYV', 'WI', 'Watertown', '43.170000', '-88.720000', 'http://weather.noaa.gov/weather/current/KRYV.html', 'http://weather.gov/data/current_obs/KRYV.rss', 'http://weather.gov/data/current_obs/KRYV.xml'),
('KRZN', 'WI', 'Siren, Burnett County Airport', '45.823000', '-92.373000', 'http://weather.noaa.gov/weather/current/KRZN.html', 'http://weather.gov/data/current_obs/KRZN.rss', 'http://weather.gov/data/current_obs/KRZN.xml'),
('KSBM', 'WI', 'Sheboygan County Memorial Airport', '43.780000', '-87.850000', 'http://weather.noaa.gov/weather/current/KSBM.html', 'http://weather.gov/data/current_obs/KSBM.rss', 'http://weather.gov/data/current_obs/KSBM.xml'),
('KSTE', 'WI', 'Stevens Point Municipal Airport', '44.550000', '-89.530000', 'http://weather.noaa.gov/weather/current/KSTE.html', 'http://weather.gov/data/current_obs/KSTE.rss', 'http://weather.gov/data/current_obs/KSTE.xml'),
('KSUE', 'WI', 'Sturgeon Bay', '44.840000', '-87.370000', 'http://weather.noaa.gov/weather/current/KSUE.html', 'http://weather.gov/data/current_obs/KSUE.rss', 'http://weather.gov/data/current_obs/KSUE.xml'),
('KSUW', 'WI', 'Superior, Richard I. Bong Airport', '46.690000', '-92.095000', 'http://weather.noaa.gov/weather/current/KSUW.html', 'http://weather.gov/data/current_obs/KSUW.rss', 'http://weather.gov/data/current_obs/KSUW.xml'),
('KTKV', 'WI', 'Tomahawk Regional Airport', '45.469000', '-89.806000', 'http://weather.noaa.gov/weather/current/KTKV.html', 'http://weather.gov/data/current_obs/KTKV.rss', 'http://weather.gov/data/current_obs/KTKV.xml'),
('KUES', 'WI', 'Waukesha County Airport', '43.010000', '-88.200000', 'http://weather.noaa.gov/weather/current/KUES.html', 'http://weather.gov/data/current_obs/KUES.rss', 'http://weather.gov/data/current_obs/KUES.xml'),
('KUNU', 'WI', 'Juneau, Dodge County Airport', '43.430000', '-88.700000', 'http://weather.noaa.gov/weather/current/KUNU.html', 'http://weather.gov/data/current_obs/KUNU.rss', 'http://weather.gov/data/current_obs/KUNU.xml'),
('KVOK', 'WI', 'Volk / Camp Douglas', '43.933000', '-90.267000', 'http://weather.noaa.gov/weather/current/KVOK.html', 'http://weather.gov/data/current_obs/KVOK.rss', 'http://weather.gov/data/current_obs/KVOK.xml'),
('NSFA', 'WS', 'Faleolo Intl/Apia', '-13.817000', '-172.000000', 'http://weather.noaa.gov/weather/current/NSFA.html', 'http://weather.gov/data/current_obs/NSFA.rss', 'http://weather.gov/data/current_obs/NSFA.xml'),
('K48I', 'WV', 'Braxton County Airport', '38.733000', '-80.650000', 'http://weather.noaa.gov/weather/current/K48I.html', 'http://weather.gov/data/current_obs/K48I.rss', 'http://weather.gov/data/current_obs/K48I.xml');

INSERT INTO tkt_zweather_stations
(`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES 
('KBKW', 'WV', 'Beckley, Raleigh County Memorial Airport', '37.790000', '-81.120000', 'http://weather.noaa.gov/weather/current/KBKW.html', 'http://weather.gov/data/current_obs/KBKW.rss', 'http://weather.gov/data/current_obs/KBKW.xml'),
('KBLF', 'WV', 'Bluefield, Mercer County Airport', '37.300000', '-81.220000', 'http://weather.noaa.gov/weather/current/KBLF.html', 'http://weather.gov/data/current_obs/KBLF.rss', 'http://weather.gov/data/current_obs/KBLF.xml'),
('KCKB', 'WV', 'Clarksburg Benedum Airport', '39.290000', '-80.230000', 'http://weather.noaa.gov/weather/current/KCKB.html', 'http://weather.gov/data/current_obs/KCKB.rss', 'http://weather.gov/data/current_obs/KCKB.xml'),
('KCRW', 'WV', 'Charleston, Yeager Airport', '38.380000', '-81.600000', 'http://weather.noaa.gov/weather/current/KCRW.html', 'http://weather.gov/data/current_obs/KCRW.rss', 'http://weather.gov/data/current_obs/KCRW.xml'),
('KEKN', 'WV', 'Elkins-Randolph County-Jennings Randolph Field', '38.890000', '-79.850000', 'http://weather.noaa.gov/weather/current/KEKN.html', 'http://weather.gov/data/current_obs/KEKN.rss', 'http://weather.gov/data/current_obs/KEKN.xml'),
('KHLG', 'WV', 'Wheeling Ohio County Airport', '40.170000', '-80.650000', 'http://weather.noaa.gov/weather/current/KHLG.html', 'http://weather.gov/data/current_obs/KHLG.rss', 'http://weather.gov/data/current_obs/KHLG.xml'),
('KHTS', 'WV', 'Huntington, Tri-State Airport', '38.380000', '-82.550000', 'http://weather.noaa.gov/weather/current/KHTS.html', 'http://weather.gov/data/current_obs/KHTS.rss', 'http://weather.gov/data/current_obs/KHTS.xml'),
('KLWB', 'WV', 'Lewisburg / Greenbrier', '37.880000', '-80.400000', 'http://weather.noaa.gov/weather/current/KLWB.html', 'http://weather.gov/data/current_obs/KLWB.rss', 'http://weather.gov/data/current_obs/KLWB.xml'),
('KMGW', 'WV', 'Morgantown Municipal-Hart Field', '39.640000', '-79.920000', 'http://weather.noaa.gov/weather/current/KMGW.html', 'http://weather.gov/data/current_obs/KMGW.rss', 'http://weather.gov/data/current_obs/KMGW.xml'),
('KMRB', 'WV', 'Martinsburg, Eastern W. Virginia Reg/Shepherdstown', '39.410000', '-77.980000', 'http://weather.noaa.gov/weather/current/KMRB.html', 'http://weather.gov/data/current_obs/KMRB.rss', 'http://weather.gov/data/current_obs/KMRB.xml'),
('KPKB', 'WV', 'Parkersburg, Wood County Airport/Gill Robb Wilson', '39.360000', '-81.430000', 'http://weather.noaa.gov/weather/current/KPKB.html', 'http://weather.gov/data/current_obs/KPKB.rss', 'http://weather.gov/data/current_obs/KPKB.xml'),
('KW22', 'WV', 'Buckhannon/Upshur Co. Reg. Airport', '39.000000', '-80.267000', 'http://weather.noaa.gov/weather/current/KW22.html', 'http://weather.gov/data/current_obs/KW22.rss', 'http://weather.gov/data/current_obs/KW22.xml'),
('KW99', 'WV', 'Petersburg, Grant County Airport', '38.983000', '-79.133000', 'http://weather.noaa.gov/weather/current/KW99.html', 'http://weather.gov/data/current_obs/KW99.rss', 'http://weather.gov/data/current_obs/KW99.xml'),
('KARL', 'WY', 'Arlington', '41.583000', '-106.200000', 'http://weather.noaa.gov/weather/current/KARL.html', 'http://weather.gov/data/current_obs/KARL.rss', 'http://weather.gov/data/current_obs/KARL.xml'),
('KBPI', 'WY', 'Big Piney/Marbleton Airport', '42.580000', '-110.100000', 'http://weather.noaa.gov/weather/current/KBPI.html', 'http://weather.gov/data/current_obs/KBPI.rss', 'http://weather.gov/data/current_obs/KBPI.xml'),
('KBRX', 'WY', 'Anonymous Wy Ob', '41.933000', '-104.550000', 'http://weather.noaa.gov/weather/current/KBRX.html', 'http://weather.gov/data/current_obs/KBRX.rss', 'http://weather.gov/data/current_obs/KBRX.xml'),
('KBYG', 'WY', 'Buffalo/Johnson County', '44.380000', '-106.720000', 'http://weather.noaa.gov/weather/current/KBYG.html', 'http://weather.gov/data/current_obs/KBYG.rss', 'http://weather.gov/data/current_obs/KBYG.xml'),
('KCOD', 'WY', 'Cody/Yellowstone Regional Airport', '44.530000', '-109.020000', 'http://weather.noaa.gov/weather/current/KCOD.html', 'http://weather.gov/data/current_obs/KCOD.rss', 'http://weather.gov/data/current_obs/KCOD.xml'),
('KCPR', 'WY', 'Casper/Natrona Intl Airport', '42.930000', '-106.470000', 'http://weather.noaa.gov/weather/current/KCPR.html', 'http://weather.gov/data/current_obs/KCPR.rss', 'http://weather.gov/data/current_obs/KCPR.xml'),
('KCYS', 'WY', 'Cheyenne/Warren AFB', '41.160000', '-104.820000', 'http://weather.noaa.gov/weather/current/KCYS.html', 'http://weather.gov/data/current_obs/KCYS.rss', 'http://weather.gov/data/current_obs/KCYS.xml'),
('KDGW', 'WY', 'Douglas/Converse County Airport', '42.800000', '-105.390000', 'http://weather.noaa.gov/weather/current/KDGW.html', 'http://weather.gov/data/current_obs/KDGW.rss', 'http://weather.gov/data/current_obs/KDGW.xml'),
('KEVW', 'WY', 'Evanston/Burns', '41.270000', '-111.030000', 'http://weather.noaa.gov/weather/current/KEVW.html', 'http://weather.gov/data/current_obs/KEVW.rss', 'http://weather.gov/data/current_obs/KEVW.xml'),
('KGCC', 'WY', 'Gillette', '44.360000', '-105.530000', 'http://weather.noaa.gov/weather/current/KGCC.html', 'http://weather.gov/data/current_obs/KGCC.rss', 'http://weather.gov/data/current_obs/KGCC.xml'),
('KGEY', 'WY', 'Greybull/S Big Horn Airport', '44.520000', '-108.080000', 'http://weather.noaa.gov/weather/current/KGEY.html', 'http://weather.gov/data/current_obs/KGEY.rss', 'http://weather.gov/data/current_obs/KGEY.xml'),
('KJAC', 'WY', 'Jackson Hole Airport', '43.610000', '-110.730000', 'http://weather.noaa.gov/weather/current/KJAC.html', 'http://weather.gov/data/current_obs/KJAC.rss', 'http://weather.gov/data/current_obs/KJAC.xml'),
('KLAR', 'WY', 'Laramie/Gen. Brees', '41.330000', '-105.680000', 'http://weather.noaa.gov/weather/current/KLAR.html', 'http://weather.gov/data/current_obs/KLAR.rss', 'http://weather.gov/data/current_obs/KLAR.xml'),
('KLND', 'WY', 'Lander/Hunt Field', '42.830000', '-108.730000', 'http://weather.noaa.gov/weather/current/KLND.html', 'http://weather.gov/data/current_obs/KLND.rss', 'http://weather.gov/data/current_obs/KLND.xml'),
('KP60', 'WY', 'Lake Yellowstone', '44.550000', '-110.420000', 'http://weather.noaa.gov/weather/current/KP60.html', 'http://weather.gov/data/current_obs/KP60.rss', 'http://weather.gov/data/current_obs/KP60.xml'),
('KPNA', 'WY', 'Ralph Wenz Field Airport', '42.783000', '-109.800000', 'http://weather.noaa.gov/weather/current/KPNA.html', 'http://weather.gov/data/current_obs/KPNA.rss', 'http://weather.gov/data/current_obs/KPNA.xml'),
('KPUM', 'WY', 'Pumpkin Vine', '41.033000', '-105.450000', 'http://weather.noaa.gov/weather/current/KPUM.html', 'http://weather.gov/data/current_obs/KPUM.rss', 'http://weather.gov/data/current_obs/KPUM.xml'),
('KRIW', 'WY', 'Riverton Regional Airport', '43.050000', '-108.450000', 'http://weather.noaa.gov/weather/current/KRIW.html', 'http://weather.gov/data/current_obs/KRIW.rss', 'http://weather.gov/data/current_obs/KRIW.xml'),
('KRKS', 'WY', 'Rock Springs', '41.610000', '-109.070000', 'http://weather.noaa.gov/weather/current/KRKS.html', 'http://weather.gov/data/current_obs/KRKS.rss', 'http://weather.gov/data/current_obs/KRKS.xml'),
('KRWL', 'WY', 'Rawlins Municipal', '41.800000', '-107.200000', 'http://weather.noaa.gov/weather/current/KRWL.html', 'http://weather.gov/data/current_obs/KRWL.rss', 'http://weather.gov/data/current_obs/KRWL.xml'),
('KSHR', 'WY', 'Sheridan Co. Arpt', '44.780000', '-106.970000', 'http://weather.noaa.gov/weather/current/KSHR.html', 'http://weather.gov/data/current_obs/KSHR.rss', 'http://weather.gov/data/current_obs/KSHR.xml'),
('KSIB', 'WY', 'Sibley Peak', '42.433000', '-105.033000', 'http://weather.noaa.gov/weather/current/KSIB.html', 'http://weather.gov/data/current_obs/KSIB.rss', 'http://weather.gov/data/current_obs/KSIB.xml'),
('KTOR', 'WY', 'Torrington Muni', '42.060000', '-104.150000', 'http://weather.noaa.gov/weather/current/KTOR.html', 'http://weather.gov/data/current_obs/KTOR.rss', 'http://weather.gov/data/current_obs/KTOR.xml'),
('KVDW', 'WY', 'Vedauwoo', '41.150000', '-105.400000', 'http://weather.noaa.gov/weather/current/KVDW.html', 'http://weather.gov/data/current_obs/KVDW.rss', 'http://weather.gov/data/current_obs/KVDW.xml'),
('KWRL', 'WY', 'Worland Municip', '43.980000', '-107.970000', 'http://weather.noaa.gov/weather/current/KWRL.html', 'http://weather.gov/data/current_obs/KWRL.rss', 'http://weather.gov/data/current_obs/KWRL.xml');