
CREATE TABLE IF NOT EXISTS `#__zweather_locations` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL DEFAULT '',
  `latitude` decimal(10,6) NOT NULL DEFAULT '0.000000',
  `longitude` decimal(10,6) NOT NULL DEFAULT '0.000000',
  `observation_loc` varchar(50) NOT NULL DEFAULT '',
  `default_loc` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `cap_zone` varchar(10) NOT NULL DEFAULT '',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `created` datetime NOT NULL,
  `created_by` int(10) NOT NULL,
  `modified` datetime NOT NULL,
  `modified_by` int(10) NOT NULL,
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `params` text NOT NULL,
  UNIQUE KEY `id` (`id`)
);

INSERT INTO `#__zweather_locations` (`id`, `title`, `latitude`, `longitude`, `observation_loc`, `default_loc`, `cap_zone`, `ordering`, `published`) VALUES
(1, 'Los Angeles, CA', 34.020000, -118.280000, 'KLAX', 0, 'CAZ041', 1, 1),
(2, 'Chicago, IL', 41.810000, -87.680000, 'KORD', 0, 'ILZ014', 2, 1),
(3, 'New York, NY', 40.740000, -74.010000, 'KLGA', 1, 'NYZ072', 3, 1),
(4, 'Washington, D.C.', 38.895000, -77.037300, 'KDCA', 0, 'DCZ001', 4, 1);

CREATE TABLE IF NOT EXISTS `#__zweather_stations` (
  `station_id` varchar(4) NOT NULL,
  `state` varchar(2) NOT NULL,
  `station_name` varchar(255) NOT NULL,
  `latitude` decimal(10,6) NOT NULL,
  `longitude` decimal(10,6) NOT NULL,
  `html_url` varchar(255) NOT NULL,
  `rss_url` varchar(255) NOT NULL,
  `xml_url` varchar(255) NOT NULL,
  PRIMARY KEY  (`station_id`),
  KEY `state` (`state`,`station_name`)
);
TRUNCATE TABLE `#__zweather_stations`;
INSERT INTO `#__zweather_stations` (`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES
('TAPA', 'AG', 'Vc Bird Intl Airport Antigua', 17.117000, -61.783000, 'http://weather.noaa.gov/weather/current/TAPA.html', 'http://weather.gov/data/current_obs/TAPA.rss', 'http://weather.gov/data/current_obs/TAPA.xml'),
('TKPN', 'AG', 'Charlestown/Newcast', 17.200000, -62.583000, 'http://weather.noaa.gov/weather/current/TKPN.html', 'http://weather.gov/data/current_obs/TKPN.rss', 'http://weather.gov/data/current_obs/TKPN.xml'),
('TRPM', 'AG', 'Blackburne/Plymouth', 16.750000, -62.167000, 'http://weather.noaa.gov/weather/current/TRPM.html', 'http://weather.gov/data/current_obs/TRPM.rss', 'http://weather.gov/data/current_obs/TRPM.xml'),
('PAAK', 'AK', 'Atka Airport', 52.217000, -174.200000, 'http://weather.noaa.gov/weather/current/PAAK.html', 'http://weather.gov/data/current_obs/PAAK.rss', 'http://weather.gov/data/current_obs/PAAK.xml'),
('PAAP', 'AK', 'Port Alexander', 56.260000, -134.660000, 'http://weather.noaa.gov/weather/current/PAAP.html', 'http://weather.gov/data/current_obs/PAAP.rss', 'http://weather.gov/data/current_obs/PAAP.xml'),
('PAAQ', 'AK', 'Palmer', 61.610000, -149.090000, 'http://weather.noaa.gov/weather/current/PAAQ.html', 'http://weather.gov/data/current_obs/PAAQ.rss', 'http://weather.gov/data/current_obs/PAAQ.xml'),
('PABA', 'AK', 'Barter Island', 70.140000, -143.590000, 'http://weather.noaa.gov/weather/current/PABA.html', 'http://weather.gov/data/current_obs/PABA.rss', 'http://weather.gov/data/current_obs/PABA.xml'),
('PABE', 'AK', 'Bethel', 60.780000, -161.800000, 'http://weather.noaa.gov/weather/current/PABE.html', 'http://weather.gov/data/current_obs/PABE.rss', 'http://weather.gov/data/current_obs/PABE.xml'),
('PABI', 'AK', 'Delta Junction/Allan AAF', 63.970000, -145.700000, 'http://weather.noaa.gov/weather/current/PABI.html', 'http://weather.gov/data/current_obs/PABI.rss', 'http://weather.gov/data/current_obs/PABI.xml'),
('PABL', 'AK', 'Buckland Airport', 65.990000, -161.120000, 'http://weather.noaa.gov/weather/current/PABL.html', 'http://weather.gov/data/current_obs/PABL.rss', 'http://weather.gov/data/current_obs/PABL.xml'),
('PABN', 'AK', 'Nabesna / Devil Mountain', 62.410000, -143.000000, 'http://weather.noaa.gov/weather/current/PABN.html', 'http://weather.gov/data/current_obs/PABN.rss', 'http://weather.gov/data/current_obs/PABN.xml'),
('PABR', 'AK', 'Barrow/Wiley Post', 71.290000, -156.770000, 'http://weather.noaa.gov/weather/current/PABR.html', 'http://weather.gov/data/current_obs/PABR.rss', 'http://weather.gov/data/current_obs/PABR.xml'),
('PABT', 'AK', 'Bettles Airport', 66.920000, -151.520000, 'http://weather.noaa.gov/weather/current/PABT.html', 'http://weather.gov/data/current_obs/PABT.rss', 'http://weather.gov/data/current_obs/PABT.xml'),
('PABV', 'AK', 'Birchwood', 61.420000, -149.520000, 'http://weather.noaa.gov/weather/current/PABV.html', 'http://weather.gov/data/current_obs/PABV.rss', 'http://weather.gov/data/current_obs/PABV.xml'),
('PACD', 'AK', 'Cold Bay Airport', 55.210000, -162.720000, 'http://weather.noaa.gov/weather/current/PACD.html', 'http://weather.gov/data/current_obs/PACD.rss', 'http://weather.gov/data/current_obs/PACD.xml'),
('PACV', 'AK', 'Cordova/Merle K', 60.500000, -145.500000, 'http://weather.noaa.gov/weather/current/PACV.html', 'http://weather.gov/data/current_obs/PACV.rss', 'http://weather.gov/data/current_obs/PACV.xml'),
('PACZ', 'AK', 'Cape Romanzoff Airways Facilities Sector', 61.783000, -166.033000, 'http://weather.noaa.gov/weather/current/PACZ.html', 'http://weather.gov/data/current_obs/PACZ.rss', 'http://weather.gov/data/current_obs/PACZ.xml'),
('PADE', 'AK', 'Deering Airport', 66.080000, -162.750000, 'http://weather.noaa.gov/weather/current/PADE.html', 'http://weather.gov/data/current_obs/PADE.rss', 'http://weather.gov/data/current_obs/PADE.xml'),
('PADK', 'AK', 'Adak Is. NAF', 51.890000, -176.650000, 'http://weather.noaa.gov/weather/current/PADK.html', 'http://weather.gov/data/current_obs/PADK.rss', 'http://weather.gov/data/current_obs/PADK.xml'),
('PADL', 'AK', 'Dillingham Municipal', 59.050000, -158.520000, 'http://weather.noaa.gov/weather/current/PADL.html', 'http://weather.gov/data/current_obs/PADL.rss', 'http://weather.gov/data/current_obs/PADL.xml'),
('PADQ', 'AK', 'Kodiak', 57.760000, -152.500000, 'http://weather.noaa.gov/weather/current/PADQ.html', 'http://weather.gov/data/current_obs/PADQ.rss', 'http://weather.gov/data/current_obs/PADQ.xml'),
('PADT', 'AK', 'Slana Airport', 62.710000, -143.990000, 'http://weather.noaa.gov/weather/current/PADT.html', 'http://weather.gov/data/current_obs/PADT.rss', 'http://weather.gov/data/current_obs/PADT.xml'),
('PADU', 'AK', 'Unalaska', 53.890000, -166.530000, 'http://weather.noaa.gov/weather/current/PADU.html', 'http://weather.gov/data/current_obs/PADU.rss', 'http://weather.gov/data/current_obs/PADU.xml'),
('PAEC', 'AK', 'Chulitna', 62.890000, -149.840000, 'http://weather.noaa.gov/weather/current/PAEC.html', 'http://weather.gov/data/current_obs/PAEC.rss', 'http://weather.gov/data/current_obs/PAEC.xml'),
('PAED', 'AK', 'Anchorage / Elmendorf Air Force Base', 61.250000, -149.800000, 'http://weather.noaa.gov/weather/current/PAED.html', 'http://weather.gov/data/current_obs/PAED.rss', 'http://weather.gov/data/current_obs/PAED.xml'),
('PAEG', 'AK', 'Eagle Airport', 64.780000, -141.150000, 'http://weather.noaa.gov/weather/current/PAEG.html', 'http://weather.gov/data/current_obs/PAEG.rss', 'http://weather.gov/data/current_obs/PAEG.xml'),
('PAEH', 'AK', 'Cape Newenham Airways Facilities Sector', 58.660000, -162.070000, 'http://weather.noaa.gov/weather/current/PAEH.html', 'http://weather.gov/data/current_obs/PAEH.rss', 'http://weather.gov/data/current_obs/PAEH.xml'),
('PAEI', 'AK', 'Fairbanks / Eielson Air Force Base', 64.650000, -147.067000, 'http://weather.noaa.gov/weather/current/PAEI.html', 'http://weather.gov/data/current_obs/PAEI.rss', 'http://weather.gov/data/current_obs/PAEI.xml'),
('PAEL', 'AK', 'Elfin Cove Seaplane', 58.210000, -136.350000, 'http://weather.noaa.gov/weather/current/PAEL.html', 'http://weather.gov/data/current_obs/PAEL.rss', 'http://weather.gov/data/current_obs/PAEL.xml'),
('PAEM', 'AK', 'Emmonak', 62.770000, -164.500000, 'http://weather.noaa.gov/weather/current/PAEM.html', 'http://weather.gov/data/current_obs/PAEM.rss', 'http://weather.gov/data/current_obs/PAEM.xml'),
('PAEN', 'AK', 'Kenai Municipal Airport', 60.580000, -151.250000, 'http://weather.noaa.gov/weather/current/PAEN.html', 'http://weather.gov/data/current_obs/PAEN.rss', 'http://weather.gov/data/current_obs/PAEN.xml'),
('PAER', 'AK', 'Merrill Pass West', 61.250000, -153.817000, 'http://weather.noaa.gov/weather/current/PAER.html', 'http://weather.gov/data/current_obs/PAER.rss', 'http://weather.gov/data/current_obs/PAER.xml'),
('PAFA', 'AK', 'Fairbanks International Airport', 64.820000, -147.870000, 'http://weather.noaa.gov/weather/current/PAFA.html', 'http://weather.gov/data/current_obs/PAFA.rss', 'http://weather.gov/data/current_obs/PAFA.xml'),
('PAFB', 'AK', 'Wainwright U. S. Army Airfield', 64.833000, -147.617000, 'http://weather.noaa.gov/weather/current/PAFB.html', 'http://weather.gov/data/current_obs/PAFB.rss', 'http://weather.gov/data/current_obs/PAFB.xml'),
('PAFE', 'AK', 'Kake Airport', 56.970000, -133.950000, 'http://weather.noaa.gov/weather/current/PAFE.html', 'http://weather.gov/data/current_obs/PAFE.rss', 'http://weather.gov/data/current_obs/PAFE.xml'),
('PAFK', 'AK', 'Farewell Lake Seaplane Base', 62.540000, -153.620000, 'http://weather.noaa.gov/weather/current/PAFK.html', 'http://weather.gov/data/current_obs/PAFK.rss', 'http://weather.gov/data/current_obs/PAFK.xml'),
('PAFM', 'AK', 'Ambler', 67.100000, -157.850000, 'http://weather.noaa.gov/weather/current/PAFM.html', 'http://weather.gov/data/current_obs/PAFM.rss', 'http://weather.gov/data/current_obs/PAFM.xml'),
('PAGA', 'AK', 'Galena A.', 64.740000, -156.940000, 'http://weather.noaa.gov/weather/current/PAGA.html', 'http://weather.gov/data/current_obs/PAGA.rss', 'http://weather.gov/data/current_obs/PAGA.xml'),
('PAGB', 'AK', 'Galbraith Lake', 68.490000, -149.490000, 'http://weather.noaa.gov/weather/current/PAGB.html', 'http://weather.gov/data/current_obs/PAGB.rss', 'http://weather.gov/data/current_obs/PAGB.xml'),
('PAGK', 'AK', 'Gulkana Airport', 62.150000, -145.450000, 'http://weather.noaa.gov/weather/current/PAGK.html', 'http://weather.gov/data/current_obs/PAGK.rss', 'http://weather.gov/data/current_obs/PAGK.xml'),
('PAGL', 'AK', 'Golovin Airport', 64.540000, -163.040000, 'http://weather.noaa.gov/weather/current/PAGL.html', 'http://weather.gov/data/current_obs/PAGL.rss', 'http://weather.gov/data/current_obs/PAGL.xml'),
('PAGM', 'AK', 'Gambell Airport', 63.770000, -171.740000, 'http://weather.noaa.gov/weather/current/PAGM.html', 'http://weather.gov/data/current_obs/PAGM.rss', 'http://weather.gov/data/current_obs/PAGM.xml'),
('PAGS', 'AK', 'Gustavus', 58.420000, -135.730000, 'http://weather.noaa.gov/weather/current/PAGS.html', 'http://weather.gov/data/current_obs/PAGS.rss', 'http://weather.gov/data/current_obs/PAGS.xml'),
('PAGY', 'AK', 'Skagway', 59.480000, -135.320000, 'http://weather.noaa.gov/weather/current/PAGY.html', 'http://weather.gov/data/current_obs/PAGY.rss', 'http://weather.gov/data/current_obs/PAGY.xml'),
('PAHN', 'AK', 'Haines Airport', 59.250000, -135.520000, 'http://weather.noaa.gov/weather/current/PAHN.html', 'http://weather.gov/data/current_obs/PAHN.rss', 'http://weather.gov/data/current_obs/PAHN.xml'),
('PAHO', 'AK', 'Homer', 59.640000, -151.500000, 'http://weather.noaa.gov/weather/current/PAHO.html', 'http://weather.gov/data/current_obs/PAHO.rss', 'http://weather.gov/data/current_obs/PAHO.xml'),
('PAHP', 'AK', 'Hooper Bay Automatic Weather Observing / Reporting', 61.540000, -166.160000, 'http://weather.noaa.gov/weather/current/PAHP.html', 'http://weather.gov/data/current_obs/PAHP.rss', 'http://weather.gov/data/current_obs/PAHP.xml'),
('PAHS', 'AK', 'Huslia', 65.700000, -156.390000, 'http://weather.noaa.gov/weather/current/PAHS.html', 'http://weather.gov/data/current_obs/PAHS.rss', 'http://weather.gov/data/current_obs/PAHS.xml'),
('PAHV', 'AK', 'Healy River Airport', 63.890000, -149.020000, 'http://weather.noaa.gov/weather/current/PAHV.html', 'http://weather.gov/data/current_obs/PAHV.rss', 'http://weather.gov/data/current_obs/PAHV.xml'),
('PAHY', 'AK', 'Hydaburg Seaplane Base', 55.210000, -132.840000, 'http://weather.noaa.gov/weather/current/PAHY.html', 'http://weather.gov/data/current_obs/PAHY.rss', 'http://weather.gov/data/current_obs/PAHY.xml'),
('PAHZ', 'AK', 'Hayes River', 61.990000, -152.090000, 'http://weather.noaa.gov/weather/current/PAHZ.html', 'http://weather.gov/data/current_obs/PAHZ.rss', 'http://weather.gov/data/current_obs/PAHZ.xml'),
('PAII', 'AK', 'Egegik Automatic Weather Observing / Reporting Sys', 58.420000, -157.370000, 'http://weather.noaa.gov/weather/current/PAII.html', 'http://weather.gov/data/current_obs/PAII.rss', 'http://weather.gov/data/current_obs/PAII.xml'),
('PAIL', 'AK', 'Iliamna / Iliamna Airport', 59.760000, -154.920000, 'http://weather.noaa.gov/weather/current/PAIL.html', 'http://weather.gov/data/current_obs/PAIL.rss', 'http://weather.gov/data/current_obs/PAIL.xml'),
('PAIM', 'AK', 'Indian Mountain Airways Facilities Sector', 66.000000, -153.700000, 'http://weather.noaa.gov/weather/current/PAIM.html', 'http://weather.gov/data/current_obs/PAIM.rss', 'http://weather.gov/data/current_obs/PAIM.xml'),
('PAIN', 'AK', 'McKinley National Park Airport', 63.730000, -148.920000, 'http://weather.noaa.gov/weather/current/PAIN.html', 'http://weather.gov/data/current_obs/PAIN.rss', 'http://weather.gov/data/current_obs/PAIN.xml'),
('PAJC', 'AK', 'Chignik Airport', 56.310000, -158.370000, 'http://weather.noaa.gov/weather/current/PAJC.html', 'http://weather.gov/data/current_obs/PAJC.rss', 'http://weather.gov/data/current_obs/PAJC.xml'),
('PAJN', 'AK', 'Juneau International Airport', 58.380000, -134.580000, 'http://weather.noaa.gov/weather/current/PAJN.html', 'http://weather.gov/data/current_obs/PAJN.rss', 'http://weather.gov/data/current_obs/PAJN.xml'),
('PAJV', 'AK', 'Sutton', 61.720000, -148.890000, 'http://weather.noaa.gov/weather/current/PAJV.html', 'http://weather.gov/data/current_obs/PAJV.rss', 'http://weather.gov/data/current_obs/PAJV.xml'),
('PAKK', 'AK', 'Koyuk Airport', 64.930000, -165.150000, 'http://weather.noaa.gov/weather/current/PAKK.html', 'http://weather.gov/data/current_obs/PAKK.rss', 'http://weather.gov/data/current_obs/PAKK.xml'),
('PAKN', 'AK', 'King Salmon Airport', 58.680000, -156.650000, 'http://weather.noaa.gov/weather/current/PAKN.html', 'http://weather.gov/data/current_obs/PAKN.rss', 'http://weather.gov/data/current_obs/PAKN.xml'),
('PAKP', 'AK', 'Anaktuvuk Pass', 68.130000, -151.730000, 'http://weather.noaa.gov/weather/current/PAKP.html', 'http://weather.gov/data/current_obs/PAKP.rss', 'http://weather.gov/data/current_obs/PAKP.xml'),
('PAKT', 'AK', 'Ketchikan International Airport', 55.350000, -131.700000, 'http://weather.noaa.gov/weather/current/PAKT.html', 'http://weather.gov/data/current_obs/PAKT.rss', 'http://weather.gov/data/current_obs/PAKT.xml'),
('PAKU', 'AK', 'Kuparuk Airport', 70.317000, -149.583000, 'http://weather.noaa.gov/weather/current/PAKU.html', 'http://weather.gov/data/current_obs/PAKU.rss', 'http://weather.gov/data/current_obs/PAKU.xml'),
('PAKV', 'AK', 'Kaltag Airport', 64.330000, -158.750000, 'http://weather.noaa.gov/weather/current/PAKV.html', 'http://weather.gov/data/current_obs/PAKV.rss', 'http://weather.gov/data/current_obs/PAKV.xml'),
('PAKW', 'AK', 'Klawock Airport', 55.590000, -133.090000, 'http://weather.noaa.gov/weather/current/PAKW.html', 'http://weather.gov/data/current_obs/PAKW.rss', 'http://weather.gov/data/current_obs/PAKW.xml'),
('PALH', 'AK', 'Lake Hood Seaplane', 61.190000, -149.970000, 'http://weather.noaa.gov/weather/current/PALH.html', 'http://weather.gov/data/current_obs/PALH.rss', 'http://weather.gov/data/current_obs/PALH.xml'),
('PALJ', 'AK', 'Port Alsworth', 60.210000, -154.310000, 'http://weather.noaa.gov/weather/current/PALJ.html', 'http://weather.gov/data/current_obs/PALJ.rss', 'http://weather.gov/data/current_obs/PALJ.xml'),
('PALK', 'AK', 'Snowshoe Lake', 62.030000, -146.680000, 'http://weather.noaa.gov/weather/current/PALK.html', 'http://weather.gov/data/current_obs/PALK.rss', 'http://weather.gov/data/current_obs/PALK.xml'),
('PALR', 'AK', 'Chandalar Lake', 67.500000, -148.490000, 'http://weather.noaa.gov/weather/current/PALR.html', 'http://weather.gov/data/current_obs/PALR.rss', 'http://weather.gov/data/current_obs/PALR.xml'),
('PALU', 'AK', 'Cape Lisburne Airways Fac Sec', 68.890000, -166.140000, 'http://weather.noaa.gov/weather/current/PALU.html', 'http://weather.gov/data/current_obs/PALU.rss', 'http://weather.gov/data/current_obs/PALU.xml'),
('PALV', 'AK', 'Big River Lake', 60.820000, -152.310000, 'http://weather.noaa.gov/weather/current/PALV.html', 'http://weather.gov/data/current_obs/PALV.rss', 'http://weather.gov/data/current_obs/PALV.xml'),
('PAMC', 'AK', 'McGrath Airport', 62.950000, -155.610000, 'http://weather.noaa.gov/weather/current/PAMC.html', 'http://weather.gov/data/current_obs/PAMC.rss', 'http://weather.gov/data/current_obs/PAMC.xml'),
('PAMD', 'AK', 'Middleton Island, Ak', 59.440000, -146.330000, 'http://weather.noaa.gov/weather/current/PAMD.html', 'http://weather.gov/data/current_obs/PAMD.rss', 'http://weather.gov/data/current_obs/PAMD.xml'),
('PAMH', 'AK', 'Minchumina', 63.910000, -152.160000, 'http://weather.noaa.gov/weather/current/PAMH.html', 'http://weather.gov/data/current_obs/PAMH.rss', 'http://weather.gov/data/current_obs/PAMH.xml'),
('PAML', 'AK', 'Manley Hot Springs', 65.000000, -150.650000, 'http://weather.noaa.gov/weather/current/PAML.html', 'http://weather.gov/data/current_obs/PAML.rss', 'http://weather.gov/data/current_obs/PAML.xml'),
('PAMM', 'AK', 'Metlakatla Seaplane Base', 55.080000, -131.350000, 'http://weather.noaa.gov/weather/current/PAMM.html', 'http://weather.gov/data/current_obs/PAMM.rss', 'http://weather.gov/data/current_obs/PAMM.xml'),
('PAMR', 'AK', 'Merrill Field', 61.214000, -149.846000, 'http://weather.noaa.gov/weather/current/PAMR.html', 'http://weather.gov/data/current_obs/PAMR.rss', 'http://weather.gov/data/current_obs/PAMR.xml'),
('PAMX', 'AK', 'McCarthy', 61.440000, -142.940000, 'http://weather.noaa.gov/weather/current/PAMX.html', 'http://weather.gov/data/current_obs/PAMX.rss', 'http://weather.gov/data/current_obs/PAMX.xml'),
('PAMY', 'AK', 'Mekoryuk', 60.370000, -166.270000, 'http://weather.noaa.gov/weather/current/PAMY.html', 'http://weather.gov/data/current_obs/PAMY.rss', 'http://weather.gov/data/current_obs/PAMY.xml'),
('PANC', 'AK', 'Anchorage International Airport', 61.170000, -150.000000, 'http://weather.noaa.gov/weather/current/PANC.html', 'http://weather.gov/data/current_obs/PANC.rss', 'http://weather.gov/data/current_obs/PANC.xml'),
('PANI', 'AK', 'Aniak', 61.580000, -159.530000, 'http://weather.noaa.gov/weather/current/PANI.html', 'http://weather.gov/data/current_obs/PANI.rss', 'http://weather.gov/data/current_obs/PANI.xml'),
('PANN', 'AK', 'Nenana Municipal Airport', 64.547300, -149.074000, 'http://weather.noaa.gov/weather/current/PANN.html', 'http://weather.gov/data/current_obs/PANN.rss', 'http://weather.gov/data/current_obs/PANN.xml'),
('PANT', 'AK', 'Annette Island', 55.040000, -131.570000, 'http://weather.noaa.gov/weather/current/PANT.html', 'http://weather.gov/data/current_obs/PANT.rss', 'http://weather.gov/data/current_obs/PANT.xml'),
('PANV', 'AK', 'Annik Airport', 62.650000, -160.180000, 'http://weather.noaa.gov/weather/current/PANV.html', 'http://weather.gov/data/current_obs/PANV.rss', 'http://weather.gov/data/current_obs/PANV.xml'),
('PAOH', 'AK', 'Hoonah Seaplane', 58.120000, -135.450000, 'http://weather.noaa.gov/weather/current/PAOH.html', 'http://weather.gov/data/current_obs/PAOH.rss', 'http://weather.gov/data/current_obs/PAOH.xml'),
('PAOM', 'AK', 'Nome Airport', 64.500000, -165.440000, 'http://weather.noaa.gov/weather/current/PAOM.html', 'http://weather.gov/data/current_obs/PAOM.rss', 'http://weather.gov/data/current_obs/PAOM.xml'),
('PAOR', 'AK', 'Northway Airport', 62.970000, -141.940000, 'http://weather.noaa.gov/weather/current/PAOR.html', 'http://weather.gov/data/current_obs/PAOR.rss', 'http://weather.gov/data/current_obs/PAOR.xml'),
('PAOT', 'AK', 'Kotzebue, Wien Memorial Airport', 66.870000, -162.640000, 'http://weather.noaa.gov/weather/current/PAOT.html', 'http://weather.gov/data/current_obs/PAOT.rss', 'http://weather.gov/data/current_obs/PAOT.xml'),
('PAPB', 'AK', 'St. George Airport', 56.350000, -169.400000, 'http://weather.noaa.gov/weather/current/PAPB.html', 'http://weather.gov/data/current_obs/PAPB.rss', 'http://weather.gov/data/current_obs/PAPB.xml'),
('PAPG', 'AK', 'Petersburg', 56.820000, -132.970000, 'http://weather.noaa.gov/weather/current/PAPG.html', 'http://weather.gov/data/current_obs/PAPG.rss', 'http://weather.gov/data/current_obs/PAPG.xml'),
('PAPH', 'AK', 'Port Heiden', 56.960000, -158.620000, 'http://weather.noaa.gov/weather/current/PAPH.html', 'http://weather.gov/data/current_obs/PAPH.rss', 'http://weather.gov/data/current_obs/PAPH.xml'),
('PAPO', 'AK', 'Point Hope Automatic Weather Observing / Reporting', 68.350000, -166.810000, 'http://weather.noaa.gov/weather/current/PAPO.html', 'http://weather.gov/data/current_obs/PAPO.rss', 'http://weather.gov/data/current_obs/PAPO.xml'),
('PAPR', 'AK', 'Prospect Creek Airport', 66.817000, -150.650000, 'http://weather.noaa.gov/weather/current/PAPR.html', 'http://weather.gov/data/current_obs/PAPR.rss', 'http://weather.gov/data/current_obs/PAPR.xml'),
('PAPT', 'AK', 'Puntilla', 62.100000, -152.750000, 'http://weather.noaa.gov/weather/current/PAPT.html', 'http://weather.gov/data/current_obs/PAPT.rss', 'http://weather.gov/data/current_obs/PAPT.xml'),
('PAQT', 'AK', 'Nuiqsut Airport', 70.210000, -151.010000, 'http://weather.noaa.gov/weather/current/PAQT.html', 'http://weather.gov/data/current_obs/PAQT.rss', 'http://weather.gov/data/current_obs/PAQT.xml'),
('PARC', 'AK', 'Arctic Village', 68.120000, -145.570000, 'http://weather.noaa.gov/weather/current/PARC.html', 'http://weather.gov/data/current_obs/PARC.rss', 'http://weather.gov/data/current_obs/PARC.xml'),
('PARD', 'AK', 'Red Dog Airport', 68.080000, -162.830000, 'http://weather.noaa.gov/weather/current/PARD.html', 'http://weather.gov/data/current_obs/PARD.rss', 'http://weather.gov/data/current_obs/PARD.xml'),
('PARL', 'AK', 'Central Airport', 65.570000, -144.770000, 'http://weather.noaa.gov/weather/current/PARL.html', 'http://weather.gov/data/current_obs/PARL.rss', 'http://weather.gov/data/current_obs/PARL.xml'),
('PASA', 'AK', 'Savoonga Airport', 63.690000, -170.500000, 'http://weather.noaa.gov/weather/current/PASA.html', 'http://weather.gov/data/current_obs/PASA.rss', 'http://weather.gov/data/current_obs/PASA.xml'),
('PASC', 'AK', 'Deadhorse Airport', 70.200000, -148.470000, 'http://weather.noaa.gov/weather/current/PASC.html', 'http://weather.gov/data/current_obs/PASC.rss', 'http://weather.gov/data/current_obs/PASC.xml'),
('PASD', 'AK', 'Sand Point', 55.320000, -160.520000, 'http://weather.noaa.gov/weather/current/PASD.html', 'http://weather.gov/data/current_obs/PASD.rss', 'http://weather.gov/data/current_obs/PASD.xml'),
('PASH', 'AK', 'Shishmaref Automatic Wx Obs', 66.270000, -166.050000, 'http://weather.noaa.gov/weather/current/PASH.html', 'http://weather.gov/data/current_obs/PASH.rss', 'http://weather.gov/data/current_obs/PASH.xml'),
('PASI', 'AK', 'Sitka', 57.070000, -135.350000, 'http://weather.noaa.gov/weather/current/PASI.html', 'http://weather.gov/data/current_obs/PASI.rss', 'http://weather.gov/data/current_obs/PASI.xml'),
('PASK', 'AK', 'Selawik', 66.620000, -160.000000, 'http://weather.noaa.gov/weather/current/PASK.html', 'http://weather.gov/data/current_obs/PASK.rss', 'http://weather.gov/data/current_obs/PASK.xml'),
('PASL', 'AK', 'Sleetmute', 61.720000, -157.150000, 'http://weather.noaa.gov/weather/current/PASL.html', 'http://weather.gov/data/current_obs/PASL.rss', 'http://weather.gov/data/current_obs/PASL.xml'),
('PASM', 'AK', 'St. Marys Airport', 62.070000, -163.300000, 'http://weather.noaa.gov/weather/current/PASM.html', 'http://weather.gov/data/current_obs/PASM.rss', 'http://weather.gov/data/current_obs/PASM.xml'),
('PASN', 'AK', 'St. Paul Is.', 57.150000, -170.220000, 'http://weather.noaa.gov/weather/current/PASN.html', 'http://weather.gov/data/current_obs/PASN.rss', 'http://weather.gov/data/current_obs/PASN.xml'),
('PASO', 'AK', 'Seldova Airport', 59.440000, -151.700000, 'http://weather.noaa.gov/weather/current/PASO.html', 'http://weather.gov/data/current_obs/PASO.rss', 'http://weather.gov/data/current_obs/PASO.xml'),
('PASP', 'AK', 'Sheep Mountain Airport', 61.820000, -147.500000, 'http://weather.noaa.gov/weather/current/PASP.html', 'http://weather.gov/data/current_obs/PASP.rss', 'http://weather.gov/data/current_obs/PASP.xml'),
('PASV', 'AK', 'Sparrevohn', 61.100000, -155.567000, 'http://weather.noaa.gov/weather/current/PASV.html', 'http://weather.gov/data/current_obs/PASV.rss', 'http://weather.gov/data/current_obs/PASV.xml'),
('PASW', 'AK', 'Skwentna', 61.970000, -151.180000, 'http://weather.noaa.gov/weather/current/PASW.html', 'http://weather.gov/data/current_obs/PASW.rss', 'http://weather.gov/data/current_obs/PASW.xml'),
('PASX', 'AK', 'Soldotna', 60.480000, -151.030000, 'http://weather.noaa.gov/weather/current/PASX.html', 'http://weather.gov/data/current_obs/PASX.rss', 'http://weather.gov/data/current_obs/PASX.xml'),
('PASY', 'AK', 'Shemya AFB', 52.720000, 174.120000, 'http://weather.noaa.gov/weather/current/PASY.html', 'http://weather.gov/data/current_obs/PASY.rss', 'http://weather.gov/data/current_obs/PASY.xml'),
('PATA', 'AK', 'Tanana, Calhoun Memorial Airport', 65.170000, -152.100000, 'http://weather.noaa.gov/weather/current/PATA.html', 'http://weather.gov/data/current_obs/PATA.rss', 'http://weather.gov/data/current_obs/PATA.xml'),
('PATC', 'AK', 'Tin City Airways Facilities Sector', 65.570000, -167.920000, 'http://weather.noaa.gov/weather/current/PATC.html', 'http://weather.gov/data/current_obs/PATC.rss', 'http://weather.gov/data/current_obs/PATC.xml'),
('PATG', 'AK', 'Togiak Airport', 59.050000, -160.410000, 'http://weather.noaa.gov/weather/current/PATG.html', 'http://weather.gov/data/current_obs/PATG.rss', 'http://weather.gov/data/current_obs/PATG.xml'),
('PATK', 'AK', 'Talkeetna', 62.300000, -150.100000, 'http://weather.noaa.gov/weather/current/PATK.html', 'http://weather.gov/data/current_obs/PATK.rss', 'http://weather.gov/data/current_obs/PATK.xml'),
('PATO', 'AK', 'Portage Glacier', 60.783000, -148.833000, 'http://weather.noaa.gov/weather/current/PATO.html', 'http://weather.gov/data/current_obs/PATO.rss', 'http://weather.gov/data/current_obs/PATO.xml'),
('PATW', 'AK', 'Cantwell', 63.410000, -148.950000, 'http://weather.noaa.gov/weather/current/PATW.html', 'http://weather.gov/data/current_obs/PATW.rss', 'http://weather.gov/data/current_obs/PATW.xml'),
('PAUN', 'AK', 'Unalakleet', 63.890000, -160.810000, 'http://weather.noaa.gov/weather/current/PAUN.html', 'http://weather.gov/data/current_obs/PAUN.rss', 'http://weather.gov/data/current_obs/PAUN.xml'),
('PAUO', 'AK', 'Willow Airport', 61.760000, -150.060000, 'http://weather.noaa.gov/weather/current/PAUO.html', 'http://weather.gov/data/current_obs/PAUO.rss', 'http://weather.gov/data/current_obs/PAUO.xml'),
('PAVD', 'AK', 'Valdez 2', 61.130000, -146.250000, 'http://weather.noaa.gov/weather/current/PAVD.html', 'http://weather.gov/data/current_obs/PAVD.rss', 'http://weather.gov/data/current_obs/PAVD.xml'),
('PAVL', 'AK', 'Kivalina Airport', 67.730000, -164.550000, 'http://weather.noaa.gov/weather/current/PAVL.html', 'http://weather.gov/data/current_obs/PAVL.rss', 'http://weather.gov/data/current_obs/PAVL.xml'),
('PAVW', 'AK', 'Valdez Weather Station Office', 61.130000, -146.350000, 'http://weather.noaa.gov/weather/current/PAVW.html', 'http://weather.gov/data/current_obs/PAVW.rss', 'http://weather.gov/data/current_obs/PAVW.xml'),
('PAWD', 'AK', 'Seward Airport', 60.120000, -149.450000, 'http://weather.noaa.gov/weather/current/PAWD.html', 'http://weather.gov/data/current_obs/PAWD.rss', 'http://weather.gov/data/current_obs/PAWD.xml'),
('PAWG', 'AK', 'Wrangell', 56.480000, -132.370000, 'http://weather.noaa.gov/weather/current/PAWG.html', 'http://weather.gov/data/current_obs/PAWG.rss', 'http://weather.gov/data/current_obs/PAWG.xml'),
('PAWI', 'AK', 'Wainwright Airport', 70.620000, -159.860000, 'http://weather.noaa.gov/weather/current/PAWI.html', 'http://weather.gov/data/current_obs/PAWI.rss', 'http://weather.gov/data/current_obs/PAWI.xml'),
('PAWN', 'AK', 'Noatak', 67.570000, -162.980000, 'http://weather.noaa.gov/weather/current/PAWN.html', 'http://weather.gov/data/current_obs/PAWN.rss', 'http://weather.gov/data/current_obs/PAWN.xml'),
('PAWR', 'AK', 'Whittier', 60.770000, -148.690000, 'http://weather.noaa.gov/weather/current/PAWR.html', 'http://weather.gov/data/current_obs/PAWR.rss', 'http://weather.gov/data/current_obs/PAWR.xml'),
('PAWS', 'AK', 'Wasilla Airport', 61.580000, -149.450000, 'http://weather.noaa.gov/weather/current/PAWS.html', 'http://weather.gov/data/current_obs/PAWS.rss', 'http://weather.gov/data/current_obs/PAWS.xml'),
('PAXK', 'AK', 'Paxson', 63.033000, -145.500000, 'http://weather.noaa.gov/weather/current/PAXK.html', 'http://weather.gov/data/current_obs/PAXK.rss', 'http://weather.gov/data/current_obs/PAXK.xml'),
('PAYA', 'AK', 'Yakutat', 59.520000, -139.670000, 'http://weather.noaa.gov/weather/current/PAYA.html', 'http://weather.gov/data/current_obs/PAYA.rss', 'http://weather.gov/data/current_obs/PAYA.xml'),
('PAZK', 'AK', 'Eureka', 61.930000, -147.170000, 'http://weather.noaa.gov/weather/current/PAZK.html', 'http://weather.gov/data/current_obs/PAZK.rss', 'http://weather.gov/data/current_obs/PAZK.xml'),
('PFYU', 'AK', 'Fort Yukon', 66.570000, -145.270000, 'http://weather.noaa.gov/weather/current/PFYU.html', 'http://weather.gov/data/current_obs/PFYU.rss', 'http://weather.gov/data/current_obs/PFYU.xml'),
('PPIZ', 'AK', 'Point Lay LRRS', 69.730000, -163.020000, 'http://weather.noaa.gov/weather/current/PPIZ.html', 'http://weather.gov/data/current_obs/PPIZ.rss', 'http://weather.gov/data/current_obs/PPIZ.xml'),
('PAIG', 'AK', 'Igiugig Airport', 59.324000, -155.902000, 'http://weather.noaa.gov/weather/current/PAIG.html', 'http://weather.gov/data/current_obs/PAIG.rss', 'http://weather.gov/data/current_obs/PAIG.xml'),
('PAMB', 'AK', 'Manokotak Airport', 58.990200, -159.050000, 'http://weather.noaa.gov/weather/current/PAMB.html', 'http://weather.gov/data/current_obs/PAMB.rss', 'http://weather.gov/data/current_obs/PAMB.xml'),
('PAPN', 'AK', 'Pilot Point Airport', 57.580400, -157.572000, 'http://weather.noaa.gov/weather/current/PAPN.html', 'http://weather.gov/data/current_obs/PAPN.rss', 'http://weather.gov/data/current_obs/PAPN.xml'),
('PAPM', 'AK', 'Platinum Airport', 59.011400, -161.820000, 'http://weather.noaa.gov/weather/current/PAPM.html', 'http://weather.gov/data/current_obs/PAPM.rss', 'http://weather.gov/data/current_obs/PAPM.xml'),
('PAGN', 'AK', 'Angoon Seaplane Base', 57.503600, -134.585000, 'http://weather.noaa.gov/weather/current/PAGN.html', 'http://weather.gov/data/current_obs/PAGN.rss', 'http://weather.gov/data/current_obs/PAGN.xml'),
('PAFS', 'AK', 'Nikolai Airport', 63.018600, -154.358000, 'http://weather.noaa.gov/weather/current/PAFS.html', 'http://weather.gov/data/current_obs/PAFS.rss', 'http://weather.gov/data/current_obs/PAFS.xml'),
('PATQ', 'AK', 'Atqasuk Edward Burnell Sr. Memorial Airport', 70.467300, -157.436000, 'http://weather.noaa.gov/weather/current/PATQ.html', 'http://weather.gov/data/current_obs/PATQ.rss', 'http://weather.gov/data/current_obs/PATQ.xml'),
('PALP', 'AK', 'Alpine Airstrip', 70.344300, -150.945000, 'http://weather.noaa.gov/weather/current/PALP.html', 'http://weather.gov/data/current_obs/PALP.rss', 'http://weather.gov/data/current_obs/PALP.xml'),
('PAMK', 'AK', 'St Michael Airport', 63.490100, -162.110000, 'http://weather.noaa.gov/weather/current/PAMK.html', 'http://weather.gov/data/current_obs/PAMK.rss', 'http://weather.gov/data/current_obs/PAMK.xml'),
('PAMO', 'AK', 'Mountain Village Airport', 62.095400, -163.682000, 'http://weather.noaa.gov/weather/current/PAMO.html', 'http://weather.gov/data/current_obs/PAMO.rss', 'http://weather.gov/data/current_obs/PAMO.xml'),
('PACM', 'AK', 'Scammon Bay Airport', 61.845300, -165.571000, 'http://weather.noaa.gov/weather/current/PACM.html', 'http://weather.gov/data/current_obs/PACM.rss', 'http://weather.gov/data/current_obs/PACM.xml'),
('PAHC', 'AK', 'Holy Cross Airport', 62.188300, -159.775000, 'http://weather.noaa.gov/weather/current/PAHC.html', 'http://weather.gov/data/current_obs/PAHC.rss', 'http://weather.gov/data/current_obs/PAHC.xml'),
('PARS', 'AK', 'Russian Mission Airport', 61.774900, -161.319000, 'http://weather.noaa.gov/weather/current/PARS.html', 'http://weather.gov/data/current_obs/PARS.rss', 'http://weather.gov/data/current_obs/PARS.xml'),
('PARY', 'AK', 'Ruby Airport', 64.727200, -155.470000, 'http://weather.noaa.gov/weather/current/PARY.html', 'http://weather.gov/data/current_obs/PARY.rss', 'http://weather.gov/data/current_obs/PARY.xml'),
('PATL', 'AK', 'Tatalina LRRS Airport', 62.894400, -155.977000, 'http://weather.noaa.gov/weather/current/PATL.html', 'http://weather.gov/data/current_obs/PATL.rss', 'http://weather.gov/data/current_obs/PATL.xml'),
('PALG', 'AK', 'Kalskag Airport', 61.536300, -160.341000, 'http://weather.noaa.gov/weather/current/PALG.html', 'http://weather.gov/data/current_obs/PALG.rss', 'http://weather.gov/data/current_obs/PALG.xml'),
('PAOO', 'AK', 'Toksook Bay Airport', 60.541400, -165.087000, 'http://weather.noaa.gov/weather/current/PAOO.html', 'http://weather.gov/data/current_obs/PAOO.rss', 'http://weather.gov/data/current_obs/PAOO.xml'),
('PADM', 'AK', 'Marshall Don Hunter Sr Airport', 61.864300, -162.026000, 'http://weather.noaa.gov/weather/current/PADM.html', 'http://weather.gov/data/current_obs/PADM.rss', 'http://weather.gov/data/current_obs/PADM.xml'),
('PAVC', 'AK', 'King Cove Airport', 55.116300, -162.266000, 'http://weather.noaa.gov/weather/current/PAVC.html', 'http://weather.gov/data/current_obs/PAVC.rss', 'http://weather.gov/data/current_obs/PAVC.xml'),
('PAOU', 'AK', 'Nelson Lagoon Airport', 56.007500, -161.160000, 'http://weather.noaa.gov/weather/current/PAOU.html', 'http://weather.gov/data/current_obs/PAOU.rss', 'http://weather.gov/data/current_obs/PAOU.xml'),
('K3A1', 'AL', 'Folsom Field Airport', 34.269000, -86.858000, 'http://weather.noaa.gov/weather/current/K3A1.html', 'http://weather.gov/data/current_obs/K3A1.rss', 'http://weather.gov/data/current_obs/K3A1.xml'),
('K4A9', 'AL', 'Isbell Field Airport', 34.467000, -85.717000, 'http://weather.noaa.gov/weather/current/K4A9.html', 'http://weather.gov/data/current_obs/K4A9.rss', 'http://weather.gov/data/current_obs/K4A9.xml'),
('K79J', 'AL', 'Andalusia-Opp Municipal Airport', 31.317000, -86.400000, 'http://weather.noaa.gov/weather/current/K79J.html', 'http://weather.gov/data/current_obs/K79J.rss', 'http://weather.gov/data/current_obs/K79J.xml'),
('KALX', 'AL', 'Alexander City/T.C. Russell Field', 32.915000, -85.963000, 'http://weather.noaa.gov/weather/current/KALX.html', 'http://weather.gov/data/current_obs/KALX.rss', 'http://weather.gov/data/current_obs/KALX.xml'),
('KANB', 'AL', 'Anniston Metropolitan Airport', 33.590000, -85.850000, 'http://weather.noaa.gov/weather/current/KANB.html', 'http://weather.gov/data/current_obs/KANB.rss', 'http://weather.gov/data/current_obs/KANB.xml'),
('KAUO', 'AL', 'Auburn-Opelika Airport', 32.620000, -85.440000, 'http://weather.noaa.gov/weather/current/KAUO.html', 'http://weather.gov/data/current_obs/KAUO.rss', 'http://weather.gov/data/current_obs/KAUO.xml'),
('KBFM', 'AL', 'Mobile Downtown Airport', 30.640000, -88.070000, 'http://weather.noaa.gov/weather/current/KBFM.html', 'http://weather.gov/data/current_obs/KBFM.rss', 'http://weather.gov/data/current_obs/KBFM.xml'),
('KBHM', 'AL', 'Birmingham International Airport', 33.560000, -86.750000, 'http://weather.noaa.gov/weather/current/KBHM.html', 'http://weather.gov/data/current_obs/KBHM.rss', 'http://weather.gov/data/current_obs/KBHM.xml'),
('KCKL', 'AL', 'Centreville', 32.900000, -87.250000, 'http://weather.noaa.gov/weather/current/KCKL.html', 'http://weather.gov/data/current_obs/KCKL.rss', 'http://weather.gov/data/current_obs/KCKL.xml'),
('KDCU', 'AL', 'Decatur, Pryor Field', 34.660000, -86.940000, 'http://weather.noaa.gov/weather/current/KDCU.html', 'http://weather.gov/data/current_obs/KDCU.rss', 'http://weather.gov/data/current_obs/KDCU.xml'),
('KDHN', 'AL', 'Dothan Airport', 31.320000, -85.450000, 'http://weather.noaa.gov/weather/current/KDHN.html', 'http://weather.gov/data/current_obs/KDHN.rss', 'http://weather.gov/data/current_obs/KDHN.xml'),
('KEET', 'AL', 'Calera, Shelby County Airport', 33.180000, -86.780000, 'http://weather.noaa.gov/weather/current/KEET.html', 'http://weather.gov/data/current_obs/KEET.rss', 'http://weather.gov/data/current_obs/KEET.xml'),
('KGAD', 'AL', 'Gadsden Municipal Automatic Weather Observing', 33.970000, -86.090000, 'http://weather.noaa.gov/weather/current/KGAD.html', 'http://weather.gov/data/current_obs/KGAD.rss', 'http://weather.gov/data/current_obs/KGAD.xml'),
('KGZH', 'AL', 'Evergreen, Middleton Field', 31.420000, -87.040000, 'http://weather.noaa.gov/weather/current/KGZH.html', 'http://weather.gov/data/current_obs/KGZH.rss', 'http://weather.gov/data/current_obs/KGZH.xml'),
('KHSV', 'AL', 'Huntsville International / Jones Field', 34.660000, -86.770000, 'http://weather.noaa.gov/weather/current/KHSV.html', 'http://weather.gov/data/current_obs/KHSV.rss', 'http://weather.gov/data/current_obs/KHSV.xml'),
('KHUA', 'AL', 'Redstone Army Airfield', 34.683000, -86.683000, 'http://weather.noaa.gov/weather/current/KHUA.html', 'http://weather.gov/data/current_obs/KHUA.rss', 'http://weather.gov/data/current_obs/KHUA.xml'),
('KM82', 'AL', 'Huntsville, Madison County Executive Airport', 34.850000, -86.550000, 'http://weather.noaa.gov/weather/current/KM82.html', 'http://weather.gov/data/current_obs/KM82.rss', 'http://weather.gov/data/current_obs/KM82.xml'),
('KMDQ', 'AL', 'Huntsville-Madison Co Exec Airport', 34.860000, -86.560000, 'http://weather.noaa.gov/weather/current/KMDQ.html', 'http://weather.gov/data/current_obs/KMDQ.rss', 'http://weather.gov/data/current_obs/KMDQ.xml'),
('KMGM', 'AL', 'Montgomery, Dannelly Field', 32.300000, -86.400000, 'http://weather.noaa.gov/weather/current/KMGM.html', 'http://weather.gov/data/current_obs/KMGM.rss', 'http://weather.gov/data/current_obs/KMGM.xml'),
('KMOB', 'AL', 'Mobile Regional Airport', 30.680000, -88.250000, 'http://weather.noaa.gov/weather/current/KMOB.html', 'http://weather.gov/data/current_obs/KMOB.rss', 'http://weather.gov/data/current_obs/KMOB.xml'),
('KMSL', 'AL', 'Muscle Shoals, North West Alabama Regional Airport', 34.750000, -87.610000, 'http://weather.noaa.gov/weather/current/KMSL.html', 'http://weather.gov/data/current_obs/KMSL.rss', 'http://weather.gov/data/current_obs/KMSL.xml'),
('KMXF', 'AL', 'Maxwell Air Force Base / Montgomery', 32.383000, -86.367000, 'http://weather.noaa.gov/weather/current/KMXF.html', 'http://weather.gov/data/current_obs/KMXF.rss', 'http://weather.gov/data/current_obs/KMXF.xml'),
('KOZR', 'AL', 'Cairns Army Air Field / Ozark', 31.283000, -85.717000, 'http://weather.noaa.gov/weather/current/KOZR.html', 'http://weather.gov/data/current_obs/KOZR.rss', 'http://weather.gov/data/current_obs/KOZR.xml'),
('KTCL', 'AL', 'Tuscaloosa Regional Airport', 33.230000, -87.620000, 'http://weather.noaa.gov/weather/current/KTCL.html', 'http://weather.gov/data/current_obs/KTCL.rss', 'http://weather.gov/data/current_obs/KTCL.xml'),
('KTOI', 'AL', 'Troy Municipal Airport', 31.860000, -86.010000, 'http://weather.noaa.gov/weather/current/KTOI.html', 'http://weather.gov/data/current_obs/KTOI.rss', 'http://weather.gov/data/current_obs/KTOI.xml'),
('KHEY', 'AL', 'Hanchey Army Heliport (Fort Rucker)', 31.346000, -86.654000, 'http://weather.noaa.gov/weather/current/KHEY.html', 'http://weather.gov/data/current_obs/KHEY.rss', 'http://weather.gov/data/current_obs/KHEY.xml'),
('KPRN', 'AL', 'Mac Crenshaw Memorial Airport', 31.845700, -86.610700, 'http://weather.noaa.gov/weather/current/KPRN.html', 'http://weather.gov/data/current_obs/KPRN.rss', 'http://weather.gov/data/current_obs/KPRN.xml'),
('K1M4', 'AL', 'Posey Field Airport', 34.280000, -87.600000, 'http://weather.noaa.gov/weather/current/K1M4.html', 'http://weather.gov/data/current_obs/K1M4.rss', 'http://weather.gov/data/current_obs/K1M4.xml'),
('KJKA', 'AL', 'Jack Edwards Airport', 30.289600, -87.671800, 'http://weather.noaa.gov/weather/current/KJKA.html', 'http://weather.gov/data/current_obs/KJKA.rss', 'http://weather.gov/data/current_obs/KJKA.xml'),
('K8A0', 'AL', 'Albertville Regional Airport-Thomas J Brumlik Fiel', 34.229100, -86.255800, 'http://weather.noaa.gov/weather/current/K8A0.html', 'http://weather.gov/data/current_obs/K8A0.rss', 'http://weather.gov/data/current_obs/K8A0.xml'),
('KARG', 'AR', 'Walnut Ridge Automatic Weather Observing / Report', 36.140000, -90.920000, 'http://weather.noaa.gov/weather/current/KARG.html', 'http://weather.gov/data/current_obs/KARG.rss', 'http://weather.gov/data/current_obs/KARG.xml'),
('KASG', 'AR', 'Springdale Municipal', 36.190000, -94.120000, 'http://weather.noaa.gov/weather/current/KASG.html', 'http://weather.gov/data/current_obs/KASG.rss', 'http://weather.gov/data/current_obs/KASG.xml'),
('KAWM', 'AR', 'West Memphis', 35.135000, -90.234000, 'http://weather.noaa.gov/weather/current/KAWM.html', 'http://weather.gov/data/current_obs/KAWM.rss', 'http://weather.gov/data/current_obs/KAWM.xml'),
('KBPK', 'AR', 'Mountain Home, Ozark Regional Airport', 36.370000, -92.470000, 'http://weather.noaa.gov/weather/current/KBPK.html', 'http://weather.gov/data/current_obs/KBPK.rss', 'http://weather.gov/data/current_obs/KBPK.xml'),
('KBVX', 'AR', 'Batesville Automatic Weather Observing / Reporting', 35.730000, -91.650000, 'http://weather.noaa.gov/weather/current/KBVX.html', 'http://weather.gov/data/current_obs/KBVX.rss', 'http://weather.gov/data/current_obs/KBVX.xml'),
('KBYH', 'AR', 'Eaker Air Force Base', 35.967000, -89.950000, 'http://weather.noaa.gov/weather/current/KBYH.html', 'http://weather.gov/data/current_obs/KBYH.rss', 'http://weather.gov/data/current_obs/KBYH.xml'),
('KDEQ', 'AR', 'De Queen, Helms Sevier County Airport', 34.050000, -94.400000, 'http://weather.noaa.gov/weather/current/KDEQ.html', 'http://weather.gov/data/current_obs/KDEQ.rss', 'http://weather.gov/data/current_obs/KDEQ.xml'),
('KELD', 'AR', 'El Dorado, So. Arkansas Regional at Goodwin Field', 33.230000, -92.800000, 'http://weather.noaa.gov/weather/current/KELD.html', 'http://weather.gov/data/current_obs/KELD.rss', 'http://weather.gov/data/current_obs/KELD.xml'),
('KFLP', 'AR', 'Flippin Automatic Weather Observing/Reporting Sys', 36.290000, -92.590000, 'http://weather.noaa.gov/weather/current/KFLP.html', 'http://weather.gov/data/current_obs/KFLP.rss', 'http://weather.gov/data/current_obs/KFLP.xml'),
('KFSM', 'AR', 'Fort Smith Regional Airport', 35.340000, -94.370000, 'http://weather.noaa.gov/weather/current/KFSM.html', 'http://weather.gov/data/current_obs/KFSM.rss', 'http://weather.gov/data/current_obs/KFSM.xml'),
('KFYV', 'AR', 'Fayetteville, Drake Field', 36.010000, -94.170000, 'http://weather.noaa.gov/weather/current/KFYV.html', 'http://weather.gov/data/current_obs/KFYV.rss', 'http://weather.gov/data/current_obs/KFYV.xml'),
('KHKA', 'AR', 'Blytheville Municipal Airport', 35.940000, -89.830000, 'http://weather.noaa.gov/weather/current/KHKA.html', 'http://weather.gov/data/current_obs/KHKA.rss', 'http://weather.gov/data/current_obs/KHKA.xml'),
('KHOT', 'AR', 'Hot Springs, Memorial Field Airport', 34.480000, -93.100000, 'http://weather.noaa.gov/weather/current/KHOT.html', 'http://weather.gov/data/current_obs/KHOT.rss', 'http://weather.gov/data/current_obs/KHOT.xml'),
('KHRO', 'AR', 'Harrison, Boone County Airport', 36.280000, -93.150000, 'http://weather.noaa.gov/weather/current/KHRO.html', 'http://weather.gov/data/current_obs/KHRO.rss', 'http://weather.gov/data/current_obs/KHRO.xml'),
('KJBR', 'AR', 'Jonesboro Municipal Airport', 35.830000, -90.650000, 'http://weather.noaa.gov/weather/current/KJBR.html', 'http://weather.gov/data/current_obs/KJBR.rss', 'http://weather.gov/data/current_obs/KJBR.xml'),
('KLIT', 'AR', 'Little Rock, Adams Field', 34.730000, -92.230000, 'http://weather.noaa.gov/weather/current/KLIT.html', 'http://weather.gov/data/current_obs/KLIT.rss', 'http://weather.gov/data/current_obs/KLIT.xml'),
('KLLQ', 'AR', 'Monticello Municipal Airport', 33.640000, -91.750000, 'http://weather.noaa.gov/weather/current/KLLQ.html', 'http://weather.gov/data/current_obs/KLLQ.rss', 'http://weather.gov/data/current_obs/KLLQ.xml'),
('KLRF', 'AR', 'Little Rock Air Force Base', 34.917000, -92.150000, 'http://weather.noaa.gov/weather/current/KLRF.html', 'http://weather.gov/data/current_obs/KLRF.rss', 'http://weather.gov/data/current_obs/KLRF.xml'),
('KMEZ', 'AR', 'Mena Intermountain Municipal Airport', 34.550000, -93.583000, 'http://weather.noaa.gov/weather/current/KMEZ.html', 'http://weather.gov/data/current_obs/KMEZ.rss', 'http://weather.gov/data/current_obs/KMEZ.xml'),
('KMWT', 'AR', 'Mount Ida', 34.547000, -93.578000, 'http://weather.noaa.gov/weather/current/KMWT.html', 'http://weather.gov/data/current_obs/KMWT.rss', 'http://weather.gov/data/current_obs/KMWT.xml'),
('KPBF', 'AR', 'Pine Bluff, Grider Field Airport', 34.180000, -91.930000, 'http://weather.noaa.gov/weather/current/KPBF.html', 'http://weather.gov/data/current_obs/KPBF.rss', 'http://weather.gov/data/current_obs/KPBF.xml'),
('KROG', 'AR', 'Rogers Automatic Weather Observing / Reporting Sys', 36.380000, -94.110000, 'http://weather.noaa.gov/weather/current/KROG.html', 'http://weather.gov/data/current_obs/KROG.rss', 'http://weather.gov/data/current_obs/KROG.xml'),
('KRUE', 'AR', 'Russellville Municipal Airport', 35.260000, -93.090000, 'http://weather.noaa.gov/weather/current/KRUE.html', 'http://weather.gov/data/current_obs/KRUE.rss', 'http://weather.gov/data/current_obs/KRUE.xml'),
('KSGT', 'AR', 'Stuttgart Automatic Weather Observing / Reporting', 34.610000, -91.570000, 'http://weather.noaa.gov/weather/current/KSGT.html', 'http://weather.gov/data/current_obs/KSGT.rss', 'http://weather.gov/data/current_obs/KSGT.xml'),
('KSLG', 'AR', 'Siloam Springs Automatic Weather Observing/Report', 36.190000, -94.490000, 'http://weather.noaa.gov/weather/current/KSLG.html', 'http://weather.gov/data/current_obs/KSLG.rss', 'http://weather.gov/data/current_obs/KSLG.xml'),
('KM19', 'AR', 'Newport Municipal Airport', 35.600000, -91.200000, 'http://weather.noaa.gov/weather/current/KM19.html', 'http://weather.gov/data/current_obs/KM19.rss', 'http://weather.gov/data/current_obs/KM19.xml'),
('KTXK', 'AR', 'Texarkana Regional-Webb Field', 33.460000, -94.000000, 'http://weather.noaa.gov/weather/current/KTXK.html', 'http://weather.gov/data/current_obs/KTXK.rss', 'http://weather.gov/data/current_obs/KTXK.xml'),
('KVBT', 'AR', 'Bentonville Automatic Weather Observing/Reporting', 36.350000, -94.220000, 'http://weather.noaa.gov/weather/current/KVBT.html', 'http://weather.gov/data/current_obs/KVBT.rss', 'http://weather.gov/data/current_obs/KVBT.xml'),
('KXNA', 'AR', 'Fayetteville/Springdale, NW Arkansas Regl Airport', 36.282000, -94.307000, 'http://weather.noaa.gov/weather/current/KXNA.html', 'http://weather.gov/data/current_obs/KXNA.rss', 'http://weather.gov/data/current_obs/KXNA.xml'),
('KM89', 'AR', 'Dexter B Florence Memorial Field Airport', 34.100000, -93.070000, 'http://weather.noaa.gov/weather/current/KM89.html', 'http://weather.gov/data/current_obs/KM89.rss', 'http://weather.gov/data/current_obs/KM89.xml'),
('KCCA', 'AR', 'Clinton Municipal Airport', 35.598000, -92.352000, 'http://weather.noaa.gov/weather/current/KCCA.html', 'http://weather.gov/data/current_obs/KCCA.rss', 'http://weather.gov/data/current_obs/KCCA.xml'),
('KCDH', 'AR', 'Harrell Field Airport', 33.623000, -92.763000, 'http://weather.noaa.gov/weather/current/KCDH.html', 'http://weather.gov/data/current_obs/KCDH.rss', 'http://weather.gov/data/current_obs/KCDH.xml'),
('NSTU', 'AS', 'Pago Pago', -14.333000, -170.717000, 'http://weather.noaa.gov/weather/current/NSTU.html', 'http://weather.gov/data/current_obs/NSTU.rss', 'http://weather.gov/data/current_obs/NSTU.xml'),
('TNCA', 'AW', 'Queen Beatrix Airport', 12.500000, -70.017000, 'http://weather.noaa.gov/weather/current/TNCA.html', 'http://weather.gov/data/current_obs/TNCA.rss', 'http://weather.gov/data/current_obs/TNCA.xml'),
('K40G', 'AZ', 'Grand Canyon, Valle Airport', 35.650000, -112.150000, 'http://weather.noaa.gov/weather/current/K40G.html', 'http://weather.gov/data/current_obs/K40G.rss', 'http://weather.gov/data/current_obs/K40G.xml'),
('KCGZ', 'AZ', 'Casa Grande (awos)', 32.960000, -111.770000, 'http://weather.noaa.gov/weather/current/KCGZ.html', 'http://weather.gov/data/current_obs/KCGZ.rss', 'http://weather.gov/data/current_obs/KCGZ.xml'),
('KCHD', 'AZ', 'Chandler Municipal Airport', 33.270000, -111.810000, 'http://weather.noaa.gov/weather/current/KCHD.html', 'http://weather.gov/data/current_obs/KCHD.rss', 'http://weather.gov/data/current_obs/KCHD.xml'),
('KDMA', 'AZ', 'Davis-Monthan AFB', 32.180000, -110.880000, 'http://weather.noaa.gov/weather/current/KDMA.html', 'http://weather.gov/data/current_obs/KDMA.rss', 'http://weather.gov/data/current_obs/KDMA.xml'),
('KDUG', 'AZ', 'Douglas Bisbee Intl Airport', 31.450000, -109.600000, 'http://weather.noaa.gov/weather/current/KDUG.html', 'http://weather.gov/data/current_obs/KDUG.rss', 'http://weather.gov/data/current_obs/KDUG.xml'),
('KDVT', 'AZ', 'Deer Valley/Phoenix', 33.690000, -112.080000, 'http://weather.noaa.gov/weather/current/KDVT.html', 'http://weather.gov/data/current_obs/KDVT.rss', 'http://weather.gov/data/current_obs/KDVT.xml'),
('KFFZ', 'AZ', 'Mesa/Falcon Field', 33.460000, -111.730000, 'http://weather.noaa.gov/weather/current/KFFZ.html', 'http://weather.gov/data/current_obs/KFFZ.rss', 'http://weather.gov/data/current_obs/KFFZ.xml'),
('KFHU', 'AZ', 'Fort Huachuca/Libby', 31.580000, -110.330000, 'http://weather.noaa.gov/weather/current/KFHU.html', 'http://weather.gov/data/current_obs/KFHU.rss', 'http://weather.gov/data/current_obs/KFHU.xml'),
('KFLG', 'AZ', 'Flagstaff (amos)', 35.140000, -111.670000, 'http://weather.noaa.gov/weather/current/KFLG.html', 'http://weather.gov/data/current_obs/KFLG.rss', 'http://weather.gov/data/current_obs/KFLG.xml'),
('KGBN', 'AZ', 'Gila Bend (aaf)', 32.890000, -112.720000, 'http://weather.noaa.gov/weather/current/KGBN.html', 'http://weather.gov/data/current_obs/KGBN.rss', 'http://weather.gov/data/current_obs/KGBN.xml'),
('KGCN', 'AZ', 'Grand Canyon Park', 35.960000, -112.150000, 'http://weather.noaa.gov/weather/current/KGCN.html', 'http://weather.gov/data/current_obs/KGCN.rss', 'http://weather.gov/data/current_obs/KGCN.xml'),
('KGEU', 'AZ', 'Glendale', 33.530000, -112.300000, 'http://weather.noaa.gov/weather/current/KGEU.html', 'http://weather.gov/data/current_obs/KGEU.rss', 'http://weather.gov/data/current_obs/KGEU.xml'),
('KGYR', 'AZ', 'Goodyear Municipal', 33.420000, -112.390000, 'http://weather.noaa.gov/weather/current/KGYR.html', 'http://weather.gov/data/current_obs/KGYR.rss', 'http://weather.gov/data/current_obs/KGYR.xml'),
('KIFP', 'AZ', 'Bull Head City', 35.110000, -114.500000, 'http://weather.noaa.gov/weather/current/KIFP.html', 'http://weather.gov/data/current_obs/KIFP.rss', 'http://weather.gov/data/current_obs/KIFP.xml'),
('KIGM', 'AZ', 'Kingman (amos)', 35.280000, -113.950000, 'http://weather.noaa.gov/weather/current/KIGM.html', 'http://weather.gov/data/current_obs/KIGM.rss', 'http://weather.gov/data/current_obs/KIGM.xml'),
('KINW', 'AZ', 'Winslow (aut)', 35.030000, -110.730000, 'http://weather.noaa.gov/weather/current/KINW.html', 'http://weather.gov/data/current_obs/KINW.rss', 'http://weather.gov/data/current_obs/KINW.xml');

INSERT INTO `#__zweather_stations` (`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES
('KIWA', 'AZ', 'Williams AFB/Chandl', 33.300000, -111.670000, 'http://weather.noaa.gov/weather/current/KIWA.html', 'http://weather.gov/data/current_obs/KIWA.rss', 'http://weather.gov/data/current_obs/KIWA.xml'),
('KLUF', 'AZ', 'Luke AFB/Phoenix', 33.590000, -112.370000, 'http://weather.noaa.gov/weather/current/KLUF.html', 'http://weather.gov/data/current_obs/KLUF.rss', 'http://weather.gov/data/current_obs/KLUF.xml'),
('KNYL', 'AZ', 'Yuma Mcas', 32.390000, -114.370000, 'http://weather.noaa.gov/weather/current/KNYL.html', 'http://weather.gov/data/current_obs/KNYL.rss', 'http://weather.gov/data/current_obs/KNYL.xml'),
('KOLS', 'AZ', 'Nogales Intl Airport', 31.420000, -110.850000, 'http://weather.noaa.gov/weather/current/KOLS.html', 'http://weather.gov/data/current_obs/KOLS.rss', 'http://weather.gov/data/current_obs/KOLS.xml'),
('KPGA', 'AZ', 'Page Muni (amos)', 36.940000, -111.450000, 'http://weather.noaa.gov/weather/current/KPGA.html', 'http://weather.gov/data/current_obs/KPGA.rss', 'http://weather.gov/data/current_obs/KPGA.xml'),
('KPHX', 'AZ', 'Phoenix/Sky Harbor', 33.440000, -112.020000, 'http://weather.noaa.gov/weather/current/KPHX.html', 'http://weather.gov/data/current_obs/KPHX.rss', 'http://weather.gov/data/current_obs/KPHX.xml'),
('KPRC', 'AZ', 'Prescott/Love Fld', 34.650000, -112.420000, 'http://weather.noaa.gov/weather/current/KPRC.html', 'http://weather.gov/data/current_obs/KPRC.rss', 'http://weather.gov/data/current_obs/KPRC.xml'),
('KRQE', 'AZ', 'Window Rock (was P34)', 35.657000, -109.061000, 'http://weather.noaa.gov/weather/current/KRQE.html', 'http://weather.gov/data/current_obs/KRQE.rss', 'http://weather.gov/data/current_obs/KRQE.xml'),
('KSAD', 'AZ', 'Safford Municipal', 32.850000, -109.640000, 'http://weather.noaa.gov/weather/current/KSAD.html', 'http://weather.gov/data/current_obs/KSAD.rss', 'http://weather.gov/data/current_obs/KSAD.xml'),
('KSDL', 'AZ', 'Scottsdale Muni', 33.610000, -111.910000, 'http://weather.noaa.gov/weather/current/KSDL.html', 'http://weather.gov/data/current_obs/KSDL.rss', 'http://weather.gov/data/current_obs/KSDL.xml'),
('KSJN', 'AZ', 'St. Johns Air Park', 34.520000, -109.380000, 'http://weather.noaa.gov/weather/current/KSJN.html', 'http://weather.gov/data/current_obs/KSJN.rss', 'http://weather.gov/data/current_obs/KSJN.xml'),
('KSOW', 'AZ', 'Show Low Municipal', 34.280000, -110.000000, 'http://weather.noaa.gov/weather/current/KSOW.html', 'http://weather.gov/data/current_obs/KSOW.rss', 'http://weather.gov/data/current_obs/KSOW.xml'),
('KTUS', 'AZ', 'Tucson Intl Airport', 32.120000, -110.930000, 'http://weather.noaa.gov/weather/current/KTUS.html', 'http://weather.gov/data/current_obs/KTUS.rss', 'http://weather.gov/data/current_obs/KTUS.xml'),
('KWTR', 'AZ', 'Whiteriver Airport', 41.400000, -104.867000, 'http://weather.noaa.gov/weather/current/KWTR.html', 'http://weather.gov/data/current_obs/KWTR.rss', 'http://weather.gov/data/current_obs/KWTR.xml'),
('KYUM', 'AZ', 'Yuma', 32.667000, -114.600000, 'http://weather.noaa.gov/weather/current/KYUM.html', 'http://weather.gov/data/current_obs/KYUM.rss', 'http://weather.gov/data/current_obs/KYUM.xml'),
('TBPB', 'BB', 'Grantley Adams', 13.067000, -59.483000, 'http://weather.noaa.gov/weather/current/TBPB.html', 'http://weather.gov/data/current_obs/TBPB.rss', 'http://weather.gov/data/current_obs/TBPB.xml'),
('MYNN', 'BH', 'Nassau Bahamas', 25.050000, -77.467000, 'http://weather.noaa.gov/weather/current/MYNN.html', 'http://weather.gov/data/current_obs/MYNN.rss', 'http://weather.gov/data/current_obs/MYNN.xml'),
('K3A6', 'CA', 'Newhall', 34.400000, -118.600000, 'http://weather.noaa.gov/weather/current/K3A6.html', 'http://weather.gov/data/current_obs/K3A6.rss', 'http://weather.gov/data/current_obs/K3A6.xml'),
('K87Q', 'CA', 'Pt Piedras(cg/Amos)', 35.680000, -121.280000, 'http://weather.noaa.gov/weather/current/K87Q.html', 'http://weather.gov/data/current_obs/K87Q.rss', 'http://weather.gov/data/current_obs/K87Q.xml'),
('K9L2', 'CA', 'Edwards Air Force Aux No Base', 34.983000, -117.867000, 'http://weather.noaa.gov/weather/current/K9L2.html', 'http://weather.gov/data/current_obs/K9L2.rss', 'http://weather.gov/data/current_obs/K9L2.xml'),
('KAAT', 'CA', 'Alturas (was O00)', 41.491000, -120.564000, 'http://weather.noaa.gov/weather/current/KAAT.html', 'http://weather.gov/data/current_obs/KAAT.rss', 'http://weather.gov/data/current_obs/KAAT.xml'),
('KACV', 'CA', 'Arcata/Eureka Airport', 40.990000, -124.100000, 'http://weather.noaa.gov/weather/current/KACV.html', 'http://weather.gov/data/current_obs/KACV.rss', 'http://weather.gov/data/current_obs/KACV.xml'),
('KAPC', 'CA', 'Napa Co. Airport', 38.210000, -122.280000, 'http://weather.noaa.gov/weather/current/KAPC.html', 'http://weather.gov/data/current_obs/KAPC.rss', 'http://weather.gov/data/current_obs/KAPC.xml'),
('KAUN', 'CA', 'Auburn Muni Airport', 38.955000, -121.082000, 'http://weather.noaa.gov/weather/current/KAUN.html', 'http://weather.gov/data/current_obs/KAUN.rss', 'http://weather.gov/data/current_obs/KAUN.xml'),
('KAVX', 'CA', 'Avalon, Catalina Airport', 33.410000, -118.420000, 'http://weather.noaa.gov/weather/current/KAVX.html', 'http://weather.gov/data/current_obs/KAVX.rss', 'http://weather.gov/data/current_obs/KAVX.xml'),
('KBAB', 'CA', 'Beale AFB/Marysville', 39.140000, -121.440000, 'http://weather.noaa.gov/weather/current/KBAB.html', 'http://weather.gov/data/current_obs/KBAB.rss', 'http://weather.gov/data/current_obs/KBAB.xml'),
('KBFL', 'CA', 'Bakersfield/Meadows', 35.430000, -119.050000, 'http://weather.noaa.gov/weather/current/KBFL.html', 'http://weather.gov/data/current_obs/KBFL.rss', 'http://weather.gov/data/current_obs/KBFL.xml'),
('KBIH', 'CA', 'Bishop Airport', 37.370000, -118.370000, 'http://weather.noaa.gov/weather/current/KBIH.html', 'http://weather.gov/data/current_obs/KBIH.rss', 'http://weather.gov/data/current_obs/KBIH.xml'),
('KBLH', 'CA', 'Blythe Airport', 33.620000, -114.720000, 'http://weather.noaa.gov/weather/current/KBLH.html', 'http://weather.gov/data/current_obs/KBLH.rss', 'http://weather.gov/data/current_obs/KBLH.xml'),
('KBLU', 'CA', 'Blue Canyon (amos)', 39.290000, -120.700000, 'http://weather.noaa.gov/weather/current/KBLU.html', 'http://weather.gov/data/current_obs/KBLU.rss', 'http://weather.gov/data/current_obs/KBLU.xml'),
('KBNY', 'CA', 'Burney', 40.883000, -121.667000, 'http://weather.noaa.gov/weather/current/KBNY.html', 'http://weather.gov/data/current_obs/KBNY.rss', 'http://weather.gov/data/current_obs/KBNY.xml'),
('KBUR', 'CA', 'Burbank/Glendale', 34.200000, -118.360000, 'http://weather.noaa.gov/weather/current/KBUR.html', 'http://weather.gov/data/current_obs/KBUR.rss', 'http://weather.gov/data/current_obs/KBUR.xml'),
('KCCR', 'CA', 'Concord/Buchanan', 37.980000, -122.050000, 'http://weather.noaa.gov/weather/current/KCCR.html', 'http://weather.gov/data/current_obs/KCCR.rss', 'http://weather.gov/data/current_obs/KCCR.xml'),
('KCEC', 'CA', 'Crescent City', 41.790000, -124.240000, 'http://weather.noaa.gov/weather/current/KCEC.html', 'http://weather.gov/data/current_obs/KCEC.rss', 'http://weather.gov/data/current_obs/KCEC.xml'),
('KCIC', 'CA', 'Chico Municipal', 39.790000, -121.850000, 'http://weather.noaa.gov/weather/current/KCIC.html', 'http://weather.gov/data/current_obs/KCIC.rss', 'http://weather.gov/data/current_obs/KCIC.xml'),
('KCMA', 'CA', 'Camarillo (awos)', 34.210000, -119.090000, 'http://weather.noaa.gov/weather/current/KCMA.html', 'http://weather.gov/data/current_obs/KCMA.rss', 'http://weather.gov/data/current_obs/KCMA.xml'),
('KCNO', 'CA', 'Chino Airport', 33.970000, -117.640000, 'http://weather.noaa.gov/weather/current/KCNO.html', 'http://weather.gov/data/current_obs/KCNO.rss', 'http://weather.gov/data/current_obs/KCNO.xml'),
('KCQT', 'CA', 'Los Angeles Downtown/Usc', 34.020000, -118.280000, 'http://weather.noaa.gov/weather/current/KCQT.html', 'http://weather.gov/data/current_obs/KCQT.rss', 'http://weather.gov/data/current_obs/KCQT.xml'),
('KCRQ', 'CA', 'Carlsbad/Palomar', 33.140000, -117.280000, 'http://weather.noaa.gov/weather/current/KCRQ.html', 'http://weather.gov/data/current_obs/KCRQ.rss', 'http://weather.gov/data/current_obs/KCRQ.xml'),
('KCZZ', 'CA', 'Campo (awrs)', 32.620000, -116.470000, 'http://weather.noaa.gov/weather/current/KCZZ.html', 'http://weather.gov/data/current_obs/KCZZ.rss', 'http://weather.gov/data/current_obs/KCZZ.xml'),
('KDAG', 'CA', 'Barstow-Daggett', 34.880000, -116.780000, 'http://weather.noaa.gov/weather/current/KDAG.html', 'http://weather.gov/data/current_obs/KDAG.rss', 'http://weather.gov/data/current_obs/KDAG.xml'),
('KEDW', 'CA', 'Edwards AFB', 34.910000, -117.870000, 'http://weather.noaa.gov/weather/current/KEDW.html', 'http://weather.gov/data/current_obs/KEDW.rss', 'http://weather.gov/data/current_obs/KEDW.xml'),
('KEED', 'CA', 'Needles Airport', 34.780000, -114.620000, 'http://weather.noaa.gov/weather/current/KEED.html', 'http://weather.gov/data/current_obs/KEED.rss', 'http://weather.gov/data/current_obs/KEED.xml'),
('KEKA', 'CA', 'Eureka', 40.800000, -124.167000, 'http://weather.noaa.gov/weather/current/KEKA.html', 'http://weather.gov/data/current_obs/KEKA.rss', 'http://weather.gov/data/current_obs/KEKA.xml'),
('KEMT', 'CA', 'El Monte', 34.090000, -118.030000, 'http://weather.noaa.gov/weather/current/KEMT.html', 'http://weather.gov/data/current_obs/KEMT.rss', 'http://weather.gov/data/current_obs/KEMT.xml'),
('KFAT', 'CA', 'Fresno Air Terminal', 36.780000, -119.720000, 'http://weather.noaa.gov/weather/current/KFAT.html', 'http://weather.gov/data/current_obs/KFAT.rss', 'http://weather.gov/data/current_obs/KFAT.xml'),
('KFUL', 'CA', 'Fullerton Municipal', 33.870000, -117.980000, 'http://weather.noaa.gov/weather/current/KFUL.html', 'http://weather.gov/data/current_obs/KFUL.rss', 'http://weather.gov/data/current_obs/KFUL.xml'),
('KHHR', 'CA', 'Hawthorne Municipal', 33.930000, -118.340000, 'http://weather.noaa.gov/weather/current/KHHR.html', 'http://weather.gov/data/current_obs/KHHR.rss', 'http://weather.gov/data/current_obs/KHHR.xml'),
('KHJO', 'CA', 'Hanford', 36.318000, -119.629000, 'http://weather.noaa.gov/weather/current/KHJO.html', 'http://weather.gov/data/current_obs/KHJO.rss', 'http://weather.gov/data/current_obs/KHJO.xml'),
('KHWD', 'CA', 'Hayward Air Term', 37.660000, -122.120000, 'http://weather.noaa.gov/weather/current/KHWD.html', 'http://weather.gov/data/current_obs/KHWD.rss', 'http://weather.gov/data/current_obs/KHWD.xml'),
('KIPL', 'CA', 'Imperial', 32.840000, -115.570000, 'http://weather.noaa.gov/weather/current/KIPL.html', 'http://weather.gov/data/current_obs/KIPL.rss', 'http://weather.gov/data/current_obs/KIPL.xml'),
('KIYK', 'CA', 'Inyokern', 35.660000, -117.830000, 'http://weather.noaa.gov/weather/current/KIYK.html', 'http://weather.gov/data/current_obs/KIYK.rss', 'http://weather.gov/data/current_obs/KIYK.xml'),
('KIZA', 'CA', 'Santa Ynez Airport', 34.600000, -120.067000, 'http://weather.noaa.gov/weather/current/KIZA.html', 'http://weather.gov/data/current_obs/KIZA.rss', 'http://weather.gov/data/current_obs/KIZA.xml'),
('KLAX', 'CA', 'Los Angeles Intl Airport', 33.940000, -118.400000, 'http://weather.noaa.gov/weather/current/KLAX.html', 'http://weather.gov/data/current_obs/KLAX.rss', 'http://weather.gov/data/current_obs/KLAX.xml'),
('KLGB', 'CA', 'Long Beach Airport', 33.830000, -118.150000, 'http://weather.noaa.gov/weather/current/KLGB.html', 'http://weather.gov/data/current_obs/KLGB.rss', 'http://weather.gov/data/current_obs/KLGB.xml'),
('KLPC', 'CA', 'Lompoc (awos)', 34.670000, -120.470000, 'http://weather.noaa.gov/weather/current/KLPC.html', 'http://weather.gov/data/current_obs/KLPC.rss', 'http://weather.gov/data/current_obs/KLPC.xml'),
('KLVK', 'CA', 'Livermore Municipal', 37.700000, -121.820000, 'http://weather.noaa.gov/weather/current/KLVK.html', 'http://weather.gov/data/current_obs/KLVK.rss', 'http://weather.gov/data/current_obs/KLVK.xml'),
('KMAE', 'CA', 'Madera Municipal Airport', 36.990000, -120.110000, 'http://weather.noaa.gov/weather/current/KMAE.html', 'http://weather.gov/data/current_obs/KMAE.rss', 'http://weather.gov/data/current_obs/KMAE.xml'),
('KMCC', 'CA', 'McClellan Airfield', 38.667000, -121.400000, 'http://weather.noaa.gov/weather/current/KMCC.html', 'http://weather.gov/data/current_obs/KMCC.rss', 'http://weather.gov/data/current_obs/KMCC.xml'),
('KMCE', 'CA', 'Merced/Macready Fld', 37.290000, -120.520000, 'http://weather.noaa.gov/weather/current/KMCE.html', 'http://weather.gov/data/current_obs/KMCE.rss', 'http://weather.gov/data/current_obs/KMCE.xml'),
('KMHR', 'CA', 'Mather Field', 38.580000, -121.300000, 'http://weather.noaa.gov/weather/current/KMHR.html', 'http://weather.gov/data/current_obs/KMHR.rss', 'http://weather.gov/data/current_obs/KMHR.xml'),
('KMHS', 'CA', 'Mount Shasta (amos)', 41.330000, -122.320000, 'http://weather.noaa.gov/weather/current/KMHS.html', 'http://weather.gov/data/current_obs/KMHS.rss', 'http://weather.gov/data/current_obs/KMHS.xml'),
('KMHV', 'CA', 'Mojave', 35.070000, -118.160000, 'http://weather.noaa.gov/weather/current/KMHV.html', 'http://weather.gov/data/current_obs/KMHV.rss', 'http://weather.gov/data/current_obs/KMHV.xml'),
('KMMH', 'CA', 'Mammoth/June Lakes', 37.640000, -118.920000, 'http://weather.noaa.gov/weather/current/KMMH.html', 'http://weather.gov/data/current_obs/KMMH.rss', 'http://weather.gov/data/current_obs/KMMH.xml'),
('KMOD', 'CA', 'Modesto City/Sham', 37.630000, -120.950000, 'http://weather.noaa.gov/weather/current/KMOD.html', 'http://weather.gov/data/current_obs/KMOD.rss', 'http://weather.gov/data/current_obs/KMOD.xml'),
('KMRY', 'CA', 'Monterey Peninsula', 36.590000, -121.840000, 'http://weather.noaa.gov/weather/current/KMRY.html', 'http://weather.gov/data/current_obs/KMRY.rss', 'http://weather.gov/data/current_obs/KMRY.xml'),
('KMWS', 'CA', 'Mount Wilson', 34.233000, -118.067000, 'http://weather.noaa.gov/weather/current/KMWS.html', 'http://weather.gov/data/current_obs/KMWS.rss', 'http://weather.gov/data/current_obs/KMWS.xml'),
('KMYF', 'CA', 'San Diego/Montg', 32.830000, -117.130000, 'http://weather.noaa.gov/weather/current/KMYF.html', 'http://weather.gov/data/current_obs/KMYF.rss', 'http://weather.gov/data/current_obs/KMYF.xml'),
('KMYV', 'CA', 'Marysville/Yuba Co.', 39.110000, -121.570000, 'http://weather.noaa.gov/weather/current/KMYV.html', 'http://weather.gov/data/current_obs/KMYV.rss', 'http://weather.gov/data/current_obs/KMYV.xml'),
('KNFG', 'CA', 'Camp Pendleton Mcas', 33.300000, -117.350000, 'http://weather.noaa.gov/weather/current/KNFG.html', 'http://weather.gov/data/current_obs/KNFG.rss', 'http://weather.gov/data/current_obs/KNFG.xml'),
('KNID', 'CA', 'China Lake (naf)', 35.690000, -117.680000, 'http://weather.noaa.gov/weather/current/KNID.html', 'http://weather.gov/data/current_obs/KNID.rss', 'http://weather.gov/data/current_obs/KNID.xml'),
('KNJK', 'CA', 'El Centro Naf', 32.830000, -115.680000, 'http://weather.noaa.gov/weather/current/KNJK.html', 'http://weather.gov/data/current_obs/KNJK.rss', 'http://weather.gov/data/current_obs/KNJK.xml'),
('KNKX', 'CA', 'Miramar Nas', 32.880000, -117.150000, 'http://weather.noaa.gov/weather/current/KNKX.html', 'http://weather.gov/data/current_obs/KNKX.rss', 'http://weather.gov/data/current_obs/KNKX.xml'),
('KNLC', 'CA', 'Lemoore Nas/Reeves', 36.300000, -119.900000, 'http://weather.noaa.gov/weather/current/KNLC.html', 'http://weather.gov/data/current_obs/KNLC.rss', 'http://weather.gov/data/current_obs/KNLC.xml'),
('KNRS', 'CA', 'Imperial Beach/Ream', 32.580000, -117.120000, 'http://weather.noaa.gov/weather/current/KNRS.html', 'http://weather.gov/data/current_obs/KNRS.rss', 'http://weather.gov/data/current_obs/KNRS.xml'),
('KNSI', 'CA', 'San Nicolas Island', 33.260000, -119.450000, 'http://weather.noaa.gov/weather/current/KNSI.html', 'http://weather.gov/data/current_obs/KNSI.rss', 'http://weather.gov/data/current_obs/KNSI.xml'),
('KNTD', 'CA', 'Pt Mugu Naws', 34.120000, -119.120000, 'http://weather.noaa.gov/weather/current/KNTD.html', 'http://weather.gov/data/current_obs/KNTD.rss', 'http://weather.gov/data/current_obs/KNTD.xml'),
('KNUC', 'CA', 'Naval Auxiliary Landing Field', 33.030000, -118.580000, 'http://weather.noaa.gov/weather/current/KNUC.html', 'http://weather.gov/data/current_obs/KNUC.rss', 'http://weather.gov/data/current_obs/KNUC.xml'),
('KNUQ', 'CA', 'Moffett Nas/Mtn Vie', 37.430000, -122.050000, 'http://weather.noaa.gov/weather/current/KNUQ.html', 'http://weather.gov/data/current_obs/KNUQ.rss', 'http://weather.gov/data/current_obs/KNUQ.xml'),
('KNXP', 'CA', 'Twentynine Palms', 34.300000, -116.170000, 'http://weather.noaa.gov/weather/current/KNXP.html', 'http://weather.gov/data/current_obs/KNXP.rss', 'http://weather.gov/data/current_obs/KNXP.xml'),
('KNZY', 'CA', 'North Island Nas', 32.710000, -117.200000, 'http://weather.noaa.gov/weather/current/KNZY.html', 'http://weather.gov/data/current_obs/KNZY.rss', 'http://weather.gov/data/current_obs/KNZY.xml'),
('KO87', 'CA', 'Shelter Cove', 40.040000, -124.070000, 'http://weather.noaa.gov/weather/current/KO87.html', 'http://weather.gov/data/current_obs/KO87.rss', 'http://weather.gov/data/current_obs/KO87.xml'),
('KOAK', 'CA', 'Oakland', 37.700000, -122.220000, 'http://weather.noaa.gov/weather/current/KOAK.html', 'http://weather.gov/data/current_obs/KOAK.rss', 'http://weather.gov/data/current_obs/KOAK.xml'),
('KOKB', 'CA', 'Oceanside Municipal (was L32)', 33.219000, -117.349000, 'http://weather.noaa.gov/weather/current/KOKB.html', 'http://weather.gov/data/current_obs/KOKB.rss', 'http://weather.gov/data/current_obs/KOKB.xml'),
('KONT', 'CA', 'Ontario Intl Arpt', 34.060000, -117.600000, 'http://weather.noaa.gov/weather/current/KONT.html', 'http://weather.gov/data/current_obs/KONT.rss', 'http://weather.gov/data/current_obs/KONT.xml'),
('KOVE', 'CA', 'Oroville', 39.490000, -121.620000, 'http://weather.noaa.gov/weather/current/KOVE.html', 'http://weather.gov/data/current_obs/KOVE.rss', 'http://weather.gov/data/current_obs/KOVE.xml'),
('KOXR', 'CA', 'Oxnard', 34.210000, -119.200000, 'http://weather.noaa.gov/weather/current/KOXR.html', 'http://weather.gov/data/current_obs/KOXR.rss', 'http://weather.gov/data/current_obs/KOXR.xml'),
('KPAO', 'CA', 'Palo Alto Airport', 37.480000, -122.120000, 'http://weather.noaa.gov/weather/current/KPAO.html', 'http://weather.gov/data/current_obs/KPAO.rss', 'http://weather.gov/data/current_obs/KPAO.xml'),
('KPMD', 'CA', 'Palmdale Production', 34.630000, -118.080000, 'http://weather.noaa.gov/weather/current/KPMD.html', 'http://weather.gov/data/current_obs/KPMD.rss', 'http://weather.gov/data/current_obs/KPMD.xml'),
('KPOC', 'CA', 'La Verne/Brackett', 34.110000, -117.780000, 'http://weather.noaa.gov/weather/current/KPOC.html', 'http://weather.gov/data/current_obs/KPOC.rss', 'http://weather.gov/data/current_obs/KPOC.xml'),
('KPRB', 'CA', 'Paso Robles Muni', 35.680000, -120.630000, 'http://weather.noaa.gov/weather/current/KPRB.html', 'http://weather.gov/data/current_obs/KPRB.rss', 'http://weather.gov/data/current_obs/KPRB.xml'),
('KPSP', 'CA', 'Palm Springs Rgnl', 33.840000, -116.500000, 'http://weather.noaa.gov/weather/current/KPSP.html', 'http://weather.gov/data/current_obs/KPSP.rss', 'http://weather.gov/data/current_obs/KPSP.xml'),
('KPTV', 'CA', 'Porterville (awos)', 36.040000, -119.070000, 'http://weather.noaa.gov/weather/current/KPTV.html', 'http://weather.gov/data/current_obs/KPTV.rss', 'http://weather.gov/data/current_obs/KPTV.xml'),
('KRAL', 'CA', 'Riverside Municipal', 33.950000, -117.450000, 'http://weather.noaa.gov/weather/current/KRAL.html', 'http://weather.gov/data/current_obs/KRAL.rss', 'http://weather.gov/data/current_obs/KRAL.xml'),
('KRBL', 'CA', 'Red Bluff Municipal', 40.150000, -122.250000, 'http://weather.noaa.gov/weather/current/KRBL.html', 'http://weather.gov/data/current_obs/KRBL.rss', 'http://weather.gov/data/current_obs/KRBL.xml'),
('KRDD', 'CA', 'Redding Municipal', 40.510000, -122.300000, 'http://weather.noaa.gov/weather/current/KRDD.html', 'http://weather.gov/data/current_obs/KRDD.rss', 'http://weather.gov/data/current_obs/KRDD.xml'),
('KRHV', 'CA', 'San Jose/Reid/Hillv', 37.340000, -121.820000, 'http://weather.noaa.gov/weather/current/KRHV.html', 'http://weather.gov/data/current_obs/KRHV.rss', 'http://weather.gov/data/current_obs/KRHV.xml'),
('KRIV', 'CA', 'March AFB/Riverside', 33.890000, -117.270000, 'http://weather.noaa.gov/weather/current/KRIV.html', 'http://weather.gov/data/current_obs/KRIV.rss', 'http://weather.gov/data/current_obs/KRIV.xml'),
('KRNM', 'CA', 'Ramona Airport', 33.040000, -116.910000, 'http://weather.noaa.gov/weather/current/KRNM.html', 'http://weather.gov/data/current_obs/KRNM.rss', 'http://weather.gov/data/current_obs/KRNM.xml'),
('KSAC', 'CA', 'Sacramento/Executiv', 38.520000, -121.500000, 'http://weather.noaa.gov/weather/current/KSAC.html', 'http://weather.gov/data/current_obs/KSAC.rss', 'http://weather.gov/data/current_obs/KSAC.xml'),
('KSAN', 'CA', 'San Diego/Lindbergh', 32.730000, -117.170000, 'http://weather.noaa.gov/weather/current/KSAN.html', 'http://weather.gov/data/current_obs/KSAN.rss', 'http://weather.gov/data/current_obs/KSAN.xml'),
('KSBA', 'CA', 'Santa Barbara Muni', 34.440000, -119.830000, 'http://weather.noaa.gov/weather/current/KSBA.html', 'http://weather.gov/data/current_obs/KSBA.rss', 'http://weather.gov/data/current_obs/KSBA.xml'),
('KSBP', 'CA', 'San Luis Obispo', 35.240000, -120.640000, 'http://weather.noaa.gov/weather/current/KSBP.html', 'http://weather.gov/data/current_obs/KSBP.rss', 'http://weather.gov/data/current_obs/KSBP.xml'),
('KSCK', 'CA', 'Stockton Metro', 37.910000, -121.250000, 'http://weather.noaa.gov/weather/current/KSCK.html', 'http://weather.gov/data/current_obs/KSCK.rss', 'http://weather.gov/data/current_obs/KSCK.xml'),
('KSDB', 'CA', 'Sandberg (aut)', 34.760000, -118.730000, 'http://weather.noaa.gov/weather/current/KSDB.html', 'http://weather.gov/data/current_obs/KSDB.rss', 'http://weather.gov/data/current_obs/KSDB.xml'),
('KSDM', 'CA', 'San Diego/Brown Fld', 32.580000, -116.980000, 'http://weather.noaa.gov/weather/current/KSDM.html', 'http://weather.gov/data/current_obs/KSDM.rss', 'http://weather.gov/data/current_obs/KSDM.xml'),
('KSEE', 'CA', 'San Diego/Gillespie', 32.830000, -116.970000, 'http://weather.noaa.gov/weather/current/KSEE.html', 'http://weather.gov/data/current_obs/KSEE.rss', 'http://weather.gov/data/current_obs/KSEE.xml'),
('KSFO', 'CA', 'San Francisco Intl Airport', 37.620000, -122.360000, 'http://weather.noaa.gov/weather/current/KSFO.html', 'http://weather.gov/data/current_obs/KSFO.rss', 'http://weather.gov/data/current_obs/KSFO.xml'),
('KSIY', 'CA', 'Montague/Siskiyou', 41.790000, -122.470000, 'http://weather.noaa.gov/weather/current/KSIY.html', 'http://weather.gov/data/current_obs/KSIY.rss', 'http://weather.gov/data/current_obs/KSIY.xml'),
('KSJC', 'CA', 'San Jose International Airport', 37.370000, -121.930000, 'http://weather.noaa.gov/weather/current/KSJC.html', 'http://weather.gov/data/current_obs/KSJC.rss', 'http://weather.gov/data/current_obs/KSJC.xml'),
('KSLI', 'CA', 'Los Alamitos Aaf', 33.790000, -118.050000, 'http://weather.noaa.gov/weather/current/KSLI.html', 'http://weather.gov/data/current_obs/KSLI.rss', 'http://weather.gov/data/current_obs/KSLI.xml'),
('KSMF', 'CA', 'Sacramento Metro', 38.700000, -121.600000, 'http://weather.noaa.gov/weather/current/KSMF.html', 'http://weather.gov/data/current_obs/KSMF.rss', 'http://weather.gov/data/current_obs/KSMF.xml'),
('KSMO', 'CA', 'Santa Monica Muni', 34.030000, -118.450000, 'http://weather.noaa.gov/weather/current/KSMO.html', 'http://weather.gov/data/current_obs/KSMO.rss', 'http://weather.gov/data/current_obs/KSMO.xml'),
('KSMX', 'CA', 'Santa Maria Public', 34.910000, -120.450000, 'http://weather.noaa.gov/weather/current/KSMX.html', 'http://weather.gov/data/current_obs/KSMX.rss', 'http://weather.gov/data/current_obs/KSMX.xml'),
('KSNA', 'CA', 'Santa Ana/John-Wayne', 33.680000, -117.880000, 'http://weather.noaa.gov/weather/current/KSNA.html', 'http://weather.gov/data/current_obs/KSNA.rss', 'http://weather.gov/data/current_obs/KSNA.xml'),
('KSNS', 'CA', 'Salinas Municipal', 36.660000, -121.610000, 'http://weather.noaa.gov/weather/current/KSNS.html', 'http://weather.gov/data/current_obs/KSNS.rss', 'http://weather.gov/data/current_obs/KSNS.xml'),
('KSQL', 'CA', 'San Carlos Airport', 37.530000, -122.250000, 'http://weather.noaa.gov/weather/current/KSQL.html', 'http://weather.gov/data/current_obs/KSQL.rss', 'http://weather.gov/data/current_obs/KSQL.xml'),
('KSTS', 'CA', 'Santa Rosa (awos)', 38.510000, -122.810000, 'http://weather.noaa.gov/weather/current/KSTS.html', 'http://weather.gov/data/current_obs/KSTS.rss', 'http://weather.gov/data/current_obs/KSTS.xml'),
('KSUU', 'CA', 'Travis AFB/Fairfield', 38.280000, -121.930000, 'http://weather.noaa.gov/weather/current/KSUU.html', 'http://weather.gov/data/current_obs/KSUU.rss', 'http://weather.gov/data/current_obs/KSUU.xml'),
('KTOA', 'CA', 'Torrance Municipal', 33.800000, -118.330000, 'http://weather.noaa.gov/weather/current/KTOA.html', 'http://weather.gov/data/current_obs/KTOA.rss', 'http://weather.gov/data/current_obs/KTOA.xml'),
('KTRK', 'CA', 'Truckee-Tahoe', 39.330000, -120.130000, 'http://weather.noaa.gov/weather/current/KTRK.html', 'http://weather.gov/data/current_obs/KTRK.rss', 'http://weather.gov/data/current_obs/KTRK.xml'),
('KTRM', 'CA', 'Thermal Airport', 33.640000, -116.170000, 'http://weather.noaa.gov/weather/current/KTRM.html', 'http://weather.gov/data/current_obs/KTRM.rss', 'http://weather.gov/data/current_obs/KTRM.xml'),
('KTVL', 'CA', 'South Lake Tahoe', 38.910000, -120.000000, 'http://weather.noaa.gov/weather/current/KTVL.html', 'http://weather.gov/data/current_obs/KTVL.rss', 'http://weather.gov/data/current_obs/KTVL.xml'),
('KUKI', 'CA', 'Ukiah Muni (awos)', 39.140000, -123.200000, 'http://weather.noaa.gov/weather/current/KUKI.html', 'http://weather.gov/data/current_obs/KUKI.rss', 'http://weather.gov/data/current_obs/KUKI.xml'),
('KVBG', 'CA', 'Vandenberg AFB', 34.730000, -120.550000, 'http://weather.noaa.gov/weather/current/KVBG.html', 'http://weather.gov/data/current_obs/KVBG.rss', 'http://weather.gov/data/current_obs/KVBG.xml'),
('KVCB', 'CA', 'Nut Tree Airport', 38.378000, -121.957000, 'http://weather.noaa.gov/weather/current/KVCB.html', 'http://weather.gov/data/current_obs/KVCB.rss', 'http://weather.gov/data/current_obs/KVCB.xml'),
('KVCV', 'CA', 'Southern California Logisitics Airport', 34.583000, -117.383000, 'http://weather.noaa.gov/weather/current/KVCV.html', 'http://weather.gov/data/current_obs/KVCV.rss', 'http://weather.gov/data/current_obs/KVCV.xml'),
('KVIS', 'CA', 'Visalia Muni', 36.330000, -119.400000, 'http://weather.noaa.gov/weather/current/KVIS.html', 'http://weather.gov/data/current_obs/KVIS.rss', 'http://weather.gov/data/current_obs/KVIS.xml'),
('KVNY', 'CA', 'Van Nuys Airport', 34.210000, -118.490000, 'http://weather.noaa.gov/weather/current/KVNY.html', 'http://weather.gov/data/current_obs/KVNY.rss', 'http://weather.gov/data/current_obs/KVNY.xml'),
('KWHP', 'CA', 'Los Angeles-Whiteman Airport', 34.260000, -118.410000, 'http://weather.noaa.gov/weather/current/KWHP.html', 'http://weather.gov/data/current_obs/KWHP.rss', 'http://weather.gov/data/current_obs/KWHP.xml'),
('KWJF', 'CA', 'Lancaster/Fox F', 34.730000, -118.220000, 'http://weather.noaa.gov/weather/current/KWJF.html', 'http://weather.gov/data/current_obs/KWJF.rss', 'http://weather.gov/data/current_obs/KWJF.xml'),
('KWVI', 'CA', 'Bami11', 36.940000, -121.790000, 'http://weather.noaa.gov/weather/current/KWVI.html', 'http://weather.gov/data/current_obs/KWVI.rss', 'http://weather.gov/data/current_obs/KWVI.xml'),
('KXVW', 'CA', 'Vandenberg Range', 34.717000, -120.567000, 'http://weather.noaa.gov/weather/current/KXVW.html', 'http://weather.gov/data/current_obs/KXVW.rss', 'http://weather.gov/data/current_obs/KXVW.xml'),
('K04V', 'CO', 'Saguache', 38.100000, -106.167000, 'http://weather.noaa.gov/weather/current/K04V.html', 'http://weather.gov/data/current_obs/K04V.rss', 'http://weather.gov/data/current_obs/K04V.xml'),
('K20V', 'CO', 'Kremmling County/McElroy Airfield Airport', 40.050000, -106.360000, 'http://weather.noaa.gov/weather/current/K20V.html', 'http://weather.gov/data/current_obs/K20V.rss', 'http://weather.gov/data/current_obs/K20V.xml'),
('K3MW', 'CO', 'Mount Werner', 40.267000, -106.450000, 'http://weather.noaa.gov/weather/current/K3MW.html', 'http://weather.gov/data/current_obs/K3MW.rss', 'http://weather.gov/data/current_obs/K3MW.xml'),
('K4BM', 'CO', 'Wilkerson Pass', 39.050000, -105.514000, 'http://weather.noaa.gov/weather/current/K4BM.html', 'http://weather.gov/data/current_obs/K4BM.rss', 'http://weather.gov/data/current_obs/K4BM.xml'),
('K5SM', 'CO', 'Sunlight', 39.417000, -107.367000, 'http://weather.noaa.gov/weather/current/K5SM.html', 'http://weather.gov/data/current_obs/K5SM.rss', 'http://weather.gov/data/current_obs/K5SM.xml'),
('K7BM', 'CO', 'Cottonwood Pass', 38.800000, -106.217000, 'http://weather.noaa.gov/weather/current/K7BM.html', 'http://weather.gov/data/current_obs/K7BM.rss', 'http://weather.gov/data/current_obs/K7BM.xml'),
('KAFF', 'CO', 'Air Force Academy', 38.980000, -104.820000, 'http://weather.noaa.gov/weather/current/KAFF.html', 'http://weather.gov/data/current_obs/KAFF.rss', 'http://weather.gov/data/current_obs/KAFF.xml'),
('KAKO', 'CO', 'Akron/Washington Co', 40.170000, -103.220000, 'http://weather.noaa.gov/weather/current/KAKO.html', 'http://weather.gov/data/current_obs/KAKO.rss', 'http://weather.gov/data/current_obs/KAKO.xml'),
('KALS', 'CO', 'Alamosa Muni(awos)', 37.460000, -105.870000, 'http://weather.noaa.gov/weather/current/KALS.html', 'http://weather.gov/data/current_obs/KALS.rss', 'http://weather.gov/data/current_obs/KALS.xml'),
('KAPA', 'CO', 'Denver/Centennial', 39.570000, -104.850000, 'http://weather.noaa.gov/weather/current/KAPA.html', 'http://weather.gov/data/current_obs/KAPA.rss', 'http://weather.gov/data/current_obs/KAPA.xml'),
('KASE', 'CO', 'Aspen/Sardy Field', 39.220000, -106.870000, 'http://weather.noaa.gov/weather/current/KASE.html', 'http://weather.gov/data/current_obs/KASE.rss', 'http://weather.gov/data/current_obs/KASE.xml'),
('KBJC', 'CO', 'Broomfield/Jeffco', 39.910000, -105.120000, 'http://weather.noaa.gov/weather/current/KBJC.html', 'http://weather.gov/data/current_obs/KBJC.rss', 'http://weather.gov/data/current_obs/KBJC.xml'),
('KBKF', 'CO', 'Buckley AFB/Aurora', 39.730000, -104.750000, 'http://weather.noaa.gov/weather/current/KBKF.html', 'http://weather.gov/data/current_obs/KBKF.rss', 'http://weather.gov/data/current_obs/KBKF.xml'),
('KCAG', 'CO', 'Craig-Moffat(amos)', 40.510000, -107.530000, 'http://weather.noaa.gov/weather/current/KCAG.html', 'http://weather.gov/data/current_obs/KCAG.rss', 'http://weather.gov/data/current_obs/KCAG.xml'),
('KCCU', 'CO', 'Copper Mountain (12,400 feet)', 39.475000, -106.153000, 'http://weather.noaa.gov/weather/current/KCCU.html', 'http://weather.gov/data/current_obs/KCCU.rss', 'http://weather.gov/data/current_obs/KCCU.xml'),
('KCEZ', 'CO', 'Cortez/Montezuma Co', 37.300000, -108.630000, 'http://weather.noaa.gov/weather/current/KCEZ.html', 'http://weather.gov/data/current_obs/KCEZ.rss', 'http://weather.gov/data/current_obs/KCEZ.xml'),
('KCOS', 'CO', 'Colorado Springs', 38.830000, -104.720000, 'http://weather.noaa.gov/weather/current/KCOS.html', 'http://weather.gov/data/current_obs/KCOS.rss', 'http://weather.gov/data/current_obs/KCOS.xml'),
('KCPW', 'CO', 'Wolf Creek Pass (11,760 feet)', 37.464000, -106.804000, 'http://weather.noaa.gov/weather/current/KCPW.html', 'http://weather.gov/data/current_obs/KCPW.rss', 'http://weather.gov/data/current_obs/KCPW.xml'),
('KDEN', 'CO', 'Denver Intnl Arpt', 39.870000, -104.670000, 'http://weather.noaa.gov/weather/current/KDEN.html', 'http://weather.gov/data/current_obs/KDEN.rss', 'http://weather.gov/data/current_obs/KDEN.xml'),
('KDRO', 'CO', 'Durango/La Plata Co', 37.160000, -107.750000, 'http://weather.noaa.gov/weather/current/KDRO.html', 'http://weather.gov/data/current_obs/KDRO.rss', 'http://weather.gov/data/current_obs/KDRO.xml'),
('KEEO', 'CO', 'Meeker', 40.040000, -107.890000, 'http://weather.noaa.gov/weather/current/KEEO.html', 'http://weather.gov/data/current_obs/KEEO.rss', 'http://weather.gov/data/current_obs/KEEO.xml'),
('KEGE', 'CO', 'Eagle Co. Regional', 39.660000, -106.920000, 'http://weather.noaa.gov/weather/current/KEGE.html', 'http://weather.gov/data/current_obs/KEGE.rss', 'http://weather.gov/data/current_obs/KEGE.xml'),
('KFCS', 'CO', 'Fort Carson/Butts', 38.690000, -104.770000, 'http://weather.noaa.gov/weather/current/KFCS.html', 'http://weather.gov/data/current_obs/KFCS.rss', 'http://weather.gov/data/current_obs/KFCS.xml'),
('KFNL', 'CO', 'Fort Collins (awos)', 40.460000, -105.010000, 'http://weather.noaa.gov/weather/current/KFNL.html', 'http://weather.gov/data/current_obs/KFNL.rss', 'http://weather.gov/data/current_obs/KFNL.xml'),
('KFTG', 'CO', 'Front Range Airport', 39.785000, -104.543000, 'http://weather.noaa.gov/weather/current/KFTG.html', 'http://weather.gov/data/current_obs/KFTG.rss', 'http://weather.gov/data/current_obs/KFTG.xml'),
('KGJT', 'CO', 'Grand Junction', 39.120000, -108.530000, 'http://weather.noaa.gov/weather/current/KGJT.html', 'http://weather.gov/data/current_obs/KGJT.rss', 'http://weather.gov/data/current_obs/KGJT.xml'),
('KGUC', 'CO', 'Gunnison Co. (awos)', 38.550000, -106.920000, 'http://weather.noaa.gov/weather/current/KGUC.html', 'http://weather.gov/data/current_obs/KGUC.rss', 'http://weather.gov/data/current_obs/KGUC.xml'),
('KGXY', 'CO', 'Greeley/Weld (awos)', 40.430000, -104.630000, 'http://weather.noaa.gov/weather/current/KGXY.html', 'http://weather.gov/data/current_obs/KGXY.rss', 'http://weather.gov/data/current_obs/KGXY.xml'),
('KHDN', 'CO', 'Hayden/Yampa (awos)', 40.510000, -107.250000, 'http://weather.noaa.gov/weather/current/KHDN.html', 'http://weather.gov/data/current_obs/KHDN.rss', 'http://weather.gov/data/current_obs/KHDN.xml'),
('KITR', 'CO', 'Burlington', 39.240000, -102.290000, 'http://weather.noaa.gov/weather/current/KITR.html', 'http://weather.gov/data/current_obs/KITR.rss', 'http://weather.gov/data/current_obs/KITR.xml'),
('KLAA', 'CO', 'Lamar', 38.070000, -102.680000, 'http://weather.noaa.gov/weather/current/KLAA.html', 'http://weather.gov/data/current_obs/KLAA.rss', 'http://weather.gov/data/current_obs/KLAA.xml'),
('KLHX', 'CO', 'La Junta Municipal', 38.050000, -103.520000, 'http://weather.noaa.gov/weather/current/KLHX.html', 'http://weather.gov/data/current_obs/KLHX.rss', 'http://weather.gov/data/current_obs/KLHX.xml'),
('KLIC', 'CO', 'Limon Municipal', 39.260000, -103.660000, 'http://weather.noaa.gov/weather/current/KLIC.html', 'http://weather.gov/data/current_obs/KLIC.rss', 'http://weather.gov/data/current_obs/KLIC.xml'),
('KLXV', 'CO', 'Leadville/Lake Co.', 39.220000, -106.320000, 'http://weather.noaa.gov/weather/current/KLXV.html', 'http://weather.gov/data/current_obs/KLXV.rss', 'http://weather.gov/data/current_obs/KLXV.xml'),
('KMNH', 'CO', 'Elbert Mountain', 39.219000, -104.641000, 'http://weather.noaa.gov/weather/current/KMNH.html', 'http://weather.gov/data/current_obs/KMNH.rss', 'http://weather.gov/data/current_obs/KMNH.xml'),
('KMTJ', 'CO', 'Montrose Co. Arpt', 38.510000, -107.880000, 'http://weather.noaa.gov/weather/current/KMTJ.html', 'http://weather.gov/data/current_obs/KMTJ.rss', 'http://weather.gov/data/current_obs/KMTJ.xml'),
('KMYP', 'CO', 'Monarch Pass (12,030 feet)', 38.497000, -106.320000, 'http://weather.noaa.gov/weather/current/KMYP.html', 'http://weather.gov/data/current_obs/KMYP.rss', 'http://weather.gov/data/current_obs/KMYP.xml'),
('KPUB', 'CO', 'Pueblo Memorial(aw)', 38.290000, -104.520000, 'http://weather.noaa.gov/weather/current/KPUB.html', 'http://weather.gov/data/current_obs/KPUB.rss', 'http://weather.gov/data/current_obs/KPUB.xml'),
('KRIL', 'CO', 'Rifle/Garfield Rgnl', 39.540000, -107.720000, 'http://weather.noaa.gov/weather/current/KRIL.html', 'http://weather.gov/data/current_obs/KRIL.rss', 'http://weather.gov/data/current_obs/KRIL.xml'),
('KSBS', 'CO', 'Steamboat Springs', 40.480000, -106.820000, 'http://weather.noaa.gov/weather/current/KSBS.html', 'http://weather.gov/data/current_obs/KSBS.rss', 'http://weather.gov/data/current_obs/KSBS.xml'),
('KSPD', 'CO', 'Springfield/Comanche Natl Grass', 37.280000, -102.610000, 'http://weather.noaa.gov/weather/current/KSPD.html', 'http://weather.gov/data/current_obs/KSPD.rss', 'http://weather.gov/data/current_obs/KSPD.xml'),
('KTAD', 'CO', 'Trinidad/Animas Co.', 37.260000, -104.330000, 'http://weather.noaa.gov/weather/current/KTAD.html', 'http://weather.gov/data/current_obs/KTAD.rss', 'http://weather.gov/data/current_obs/KTAD.xml'),
('KTEX', 'CO', 'Telluride Regional', 37.940000, -107.770000, 'http://weather.noaa.gov/weather/current/KTEX.html', 'http://weather.gov/data/current_obs/KTEX.rss', 'http://weather.gov/data/current_obs/KTEX.xml'),
('KVTP', 'CO', 'South La Veta Pass (10,216 feet)', 37.512000, -105.171000, 'http://weather.noaa.gov/weather/current/KVTP.html', 'http://weather.gov/data/current_obs/KVTP.rss', 'http://weather.gov/data/current_obs/KVTP.xml'),
('KBDL', 'CT', 'Windsor Locks, Bradley International Airport', 41.940000, -72.680000, 'http://weather.noaa.gov/weather/current/KBDL.html', 'http://weather.gov/data/current_obs/KBDL.rss', 'http://weather.gov/data/current_obs/KBDL.xml'),
('KBDR', 'CT', 'Bridgeport/Igor|Sikorsky Memorial', 41.180000, -73.130000, 'http://weather.noaa.gov/weather/current/KBDR.html', 'http://weather.gov/data/current_obs/KBDR.rss', 'http://weather.gov/data/current_obs/KBDR.xml'),
('KDXR', 'CT', 'Danbury Municipal Airport', 41.370000, -73.480000, 'http://weather.noaa.gov/weather/current/KDXR.html', 'http://weather.gov/data/current_obs/KDXR.rss', 'http://weather.gov/data/current_obs/KDXR.xml'),
('KGON', 'CT', 'Groton / New London Airport', 41.330000, -72.050000, 'http://weather.noaa.gov/weather/current/KGON.html', 'http://weather.gov/data/current_obs/KGON.rss', 'http://weather.gov/data/current_obs/KGON.xml'),
('KHFD', 'CT', 'Hartford-Brainard Airport', 41.730000, -72.650000, 'http://weather.noaa.gov/weather/current/KHFD.html', 'http://weather.gov/data/current_obs/KHFD.rss', 'http://weather.gov/data/current_obs/KHFD.xml'),
('KHVN', 'CT', 'New Haven/Tweed', 41.280000, -72.880000, 'http://weather.noaa.gov/weather/current/KHVN.html', 'http://weather.gov/data/current_obs/KHVN.rss', 'http://weather.gov/data/current_obs/KHVN.xml'),
('KIJD', 'CT', 'Willimantic, Windham Airport', 41.750000, -72.180000, 'http://weather.noaa.gov/weather/current/KIJD.html', 'http://weather.gov/data/current_obs/KIJD.rss', 'http://weather.gov/data/current_obs/KIJD.xml'),
('KMMK', 'CT', 'Meriden Markham Municipal Airport', 41.510000, -72.830000, 'http://weather.noaa.gov/weather/current/KMMK.html', 'http://weather.gov/data/current_obs/KMMK.rss', 'http://weather.gov/data/current_obs/KMMK.xml'),
('KOXC', 'CT', 'Oxford Automatic Weather Observing / Reporting Sys', 41.410000, -73.100000, 'http://weather.noaa.gov/weather/current/KOXC.html', 'http://weather.gov/data/current_obs/KOXC.rss', 'http://weather.gov/data/current_obs/KOXC.xml'),
('KDOV', 'DE', 'Dover Air Force Base', 39.140000, -75.470000, 'http://weather.noaa.gov/weather/current/KDOV.html', 'http://weather.gov/data/current_obs/KDOV.rss', 'http://weather.gov/data/current_obs/KDOV.xml'),
('KGED', 'DE', 'Georgetown, Sussex County Airport', 38.700000, -75.360000, 'http://weather.noaa.gov/weather/current/KGED.html', 'http://weather.gov/data/current_obs/KGED.rss', 'http://weather.gov/data/current_obs/KGED.xml'),
('KILG', 'DE', 'Wilmington, New Castle County Airport', 39.680000, -75.600000, 'http://weather.noaa.gov/weather/current/KILG.html', 'http://weather.gov/data/current_obs/KILG.rss', 'http://weather.gov/data/current_obs/KILG.xml'),
('TDCF', 'DM', 'Canefield Airport', 15.533000, -61.400000, 'http://weather.noaa.gov/weather/current/TDCF.html', 'http://weather.gov/data/current_obs/TDCF.rss', 'http://weather.gov/data/current_obs/TDCF.xml'),
('NFFN', 'FJ', 'Nandi', -17.750000, 177.450000, 'http://weather.noaa.gov/weather/current/NFFN.html', 'http://weather.gov/data/current_obs/NFFN.rss', 'http://weather.gov/data/current_obs/NFFN.xml'),
('NFNA', 'FJ', 'Nausori', -18.050000, 178.567000, 'http://weather.noaa.gov/weather/current/NFNA.html', 'http://weather.gov/data/current_obs/NFNA.rss', 'http://weather.gov/data/current_obs/NFNA.xml'),
('KCEW', 'FL', 'Crestview, Sikes Airport', 30.790000, -86.520000, 'http://weather.noaa.gov/weather/current/KCEW.html', 'http://weather.gov/data/current_obs/KCEW.rss', 'http://weather.gov/data/current_obs/KCEW.xml'),
('KDTS', 'FL', 'Destin, Ft. Walton Beach Airport', 30.400000, -86.470000, 'http://weather.noaa.gov/weather/current/KDTS.html', 'http://weather.gov/data/current_obs/KDTS.rss', 'http://weather.gov/data/current_obs/KDTS.xml'),
('KMAI', 'FL', 'Marianna Municipal Airport', 30.800000, -85.210000, 'http://weather.noaa.gov/weather/current/KMAI.html', 'http://weather.gov/data/current_obs/KMAI.rss', 'http://weather.gov/data/current_obs/KMAI.xml'),
('KPAM', 'FL', 'Tyndall Air Force Base', 30.070000, -85.590000, 'http://weather.noaa.gov/weather/current/KPAM.html', 'http://weather.gov/data/current_obs/KPAM.rss', 'http://weather.gov/data/current_obs/KPAM.xml'),
('KPFN', 'FL', 'Panama City-Bay County Intl Airport', 30.200000, -85.680000, 'http://weather.noaa.gov/weather/current/KPFN.html', 'http://weather.gov/data/current_obs/KPFN.rss', 'http://weather.gov/data/current_obs/KPFN.xml'),
('K0J4', 'FL', 'Florala Municipal Airport', 31.033000, -86.317000, 'http://weather.noaa.gov/weather/current/K0J4.html', 'http://weather.gov/data/current_obs/K0J4.rss', 'http://weather.gov/data/current_obs/K0J4.xml'),
('K40J', 'FL', 'Perry-Foley Airport', 30.070000, -83.570000, 'http://weather.noaa.gov/weather/current/K40J.html', 'http://weather.gov/data/current_obs/K40J.rss', 'http://weather.gov/data/current_obs/K40J.xml'),
('KAAF', 'FL', 'Apalachicola', 29.728000, -85.027000, 'http://weather.noaa.gov/weather/current/KAAF.html', 'http://weather.gov/data/current_obs/KAAF.rss', 'http://weather.gov/data/current_obs/KAAF.xml'),
('KAMX', 'FL', 'Miami Nexrad', 25.617000, -80.417000, 'http://weather.noaa.gov/weather/current/KAMX.html', 'http://weather.gov/data/current_obs/KAMX.rss', 'http://weather.gov/data/current_obs/KAMX.xml'),
('KAPF', 'FL', 'Naples Municipal', 26.150000, -81.770000, 'http://weather.noaa.gov/weather/current/KAPF.html', 'http://weather.gov/data/current_obs/KAPF.rss', 'http://weather.gov/data/current_obs/KAPF.xml'),
('KBCT', 'FL', 'Boca Raton Airport', 26.380000, -80.100000, 'http://weather.noaa.gov/weather/current/KBCT.html', 'http://weather.gov/data/current_obs/KBCT.rss', 'http://weather.gov/data/current_obs/KBCT.xml'),
('KBKV', 'FL', 'Brooksville, Hernando County Airport', 28.470000, -82.450000, 'http://weather.noaa.gov/weather/current/KBKV.html', 'http://weather.gov/data/current_obs/KBKV.rss', 'http://weather.gov/data/current_obs/KBKV.xml'),
('KBOW', 'FL', 'Bartow Municipal', 27.950000, -81.780000, 'http://weather.noaa.gov/weather/current/KBOW.html', 'http://weather.gov/data/current_obs/KBOW.rss', 'http://weather.gov/data/current_obs/KBOW.xml'),
('KCOF', 'FL', 'Cocoa / Patrick Air Force Base', 28.230000, -80.600000, 'http://weather.noaa.gov/weather/current/KCOF.html', 'http://weather.gov/data/current_obs/KCOF.rss', 'http://weather.gov/data/current_obs/KCOF.xml'),
('KCRG', 'FL', 'Jacksonville, Craig Municipal Airport', 30.330000, -81.520000, 'http://weather.noaa.gov/weather/current/KCRG.html', 'http://weather.gov/data/current_obs/KCRG.rss', 'http://weather.gov/data/current_obs/KCRG.xml'),
('KCTY', 'FL', 'Cross City Airport', 29.640000, -83.100000, 'http://weather.noaa.gov/weather/current/KCTY.html', 'http://weather.gov/data/current_obs/KCTY.rss', 'http://weather.gov/data/current_obs/KCTY.xml'),
('KDAB', 'FL', 'Daytona Beach International Airport', 29.180000, -81.050000, 'http://weather.noaa.gov/weather/current/KDAB.html', 'http://weather.gov/data/current_obs/KDAB.rss', 'http://weather.gov/data/current_obs/KDAB.xml'),
('KEVB', 'FL', 'New Smyrna Beach Municipal Airport', 29.050000, -80.950000, 'http://weather.noaa.gov/weather/current/KEVB.html', 'http://weather.gov/data/current_obs/KEVB.rss', 'http://weather.gov/data/current_obs/KEVB.xml'),
('KEYW', 'FL', 'Key West Airport', 24.550000, -81.750000, 'http://weather.noaa.gov/weather/current/KEYW.html', 'http://weather.gov/data/current_obs/KEYW.rss', 'http://weather.gov/data/current_obs/KEYW.xml'),
('KFLL', 'FL', 'Fort Lauderdale / Hollywood Intl Airport', 26.070000, -80.150000, 'http://weather.noaa.gov/weather/current/KFLL.html', 'http://weather.gov/data/current_obs/KFLL.rss', 'http://weather.gov/data/current_obs/KFLL.xml'),
('KFMY', 'FL', 'Fort Myers, Page Field', 26.580000, -81.870000, 'http://weather.noaa.gov/weather/current/KFMY.html', 'http://weather.gov/data/current_obs/KFMY.rss', 'http://weather.gov/data/current_obs/KFMY.xml'),
('KFPR', 'FL', 'Fort Pierce, St. Lucie County Intl Airport', 27.500000, -80.370000, 'http://weather.noaa.gov/weather/current/KFPR.html', 'http://weather.gov/data/current_obs/KFPR.rss', 'http://weather.gov/data/current_obs/KFPR.xml'),
('KFXE', 'FL', 'Fort Lauderdale Executive Airport', 26.200000, -80.170000, 'http://weather.noaa.gov/weather/current/KFXE.html', 'http://weather.gov/data/current_obs/KFXE.rss', 'http://weather.gov/data/current_obs/KFXE.xml'),
('KGIF', 'FL', 'Gilbert Field', 28.050000, -81.750000, 'http://weather.noaa.gov/weather/current/KGIF.html', 'http://weather.gov/data/current_obs/KGIF.rss', 'http://weather.gov/data/current_obs/KGIF.xml'),
('KGNV', 'FL', 'Gainesville Regional Airport', 29.680000, -82.270000, 'http://weather.noaa.gov/weather/current/KGNV.html', 'http://weather.gov/data/current_obs/KGNV.rss', 'http://weather.gov/data/current_obs/KGNV.xml'),
('KHRT', 'FL', 'Hurlburt Field', 30.430000, -86.680000, 'http://weather.noaa.gov/weather/current/KHRT.html', 'http://weather.gov/data/current_obs/KHRT.rss', 'http://weather.gov/data/current_obs/KHRT.xml'),
('KHST', 'FL', 'Homestead Air Force Base', 25.480000, -80.380000, 'http://weather.noaa.gov/weather/current/KHST.html', 'http://weather.gov/data/current_obs/KHST.rss', 'http://weather.gov/data/current_obs/KHST.xml'),
('KHWO', 'FL', 'Hollywood, North Perry Airport', 26.000000, -80.240000, 'http://weather.noaa.gov/weather/current/KHWO.html', 'http://weather.gov/data/current_obs/KHWO.rss', 'http://weather.gov/data/current_obs/KHWO.xml'),
('KISM', 'FL', 'Orlando, Kissimmee Municipal Airport', 28.290000, -81.437000, 'http://weather.noaa.gov/weather/current/KISM.html', 'http://weather.gov/data/current_obs/KISM.rss', 'http://weather.gov/data/current_obs/KISM.xml'),
('KJAX', 'FL', 'Jacksonville International Airport', 30.430000, -81.700000, 'http://weather.noaa.gov/weather/current/KJAX.html', 'http://weather.gov/data/current_obs/KJAX.rss', 'http://weather.gov/data/current_obs/KJAX.xml'),
('KLAL', 'FL', 'Lakeland Regional', 28.040000, -81.950000, 'http://weather.noaa.gov/weather/current/KLAL.html', 'http://weather.gov/data/current_obs/KLAL.rss', 'http://weather.gov/data/current_obs/KLAL.xml'),
('KLEE', 'FL', 'Leesburg Municipal Airport', 28.820000, -81.810000, 'http://weather.noaa.gov/weather/current/KLEE.html', 'http://weather.gov/data/current_obs/KLEE.rss', 'http://weather.gov/data/current_obs/KLEE.xml'),
('KMCF', 'FL', 'Macdill Air Force Base, Fl.', 27.860000, -82.520000, 'http://weather.noaa.gov/weather/current/KMCF.html', 'http://weather.gov/data/current_obs/KMCF.rss', 'http://weather.gov/data/current_obs/KMCF.xml'),
('KMCO', 'FL', 'Orlando International Airport', 28.430000, -81.320000, 'http://weather.noaa.gov/weather/current/KMCO.html', 'http://weather.gov/data/current_obs/KMCO.rss', 'http://weather.gov/data/current_obs/KMCO.xml'),
('KMIA', 'FL', 'Miami International Airport', 25.820000, -80.280000, 'http://weather.noaa.gov/weather/current/KMIA.html', 'http://weather.gov/data/current_obs/KMIA.rss', 'http://weather.gov/data/current_obs/KMIA.xml'),
('KMLB', 'FL', 'Melbourne International Airport', 28.110000, -80.630000, 'http://weather.noaa.gov/weather/current/KMLB.html', 'http://weather.gov/data/current_obs/KMLB.rss', 'http://weather.gov/data/current_obs/KMLB.xml'),
('KMTH', 'FL', 'Marathon Airport', 24.740000, -81.050000, 'http://weather.noaa.gov/weather/current/KMTH.html', 'http://weather.gov/data/current_obs/KMTH.rss', 'http://weather.gov/data/current_obs/KMTH.xml'),
('KNIP', 'FL', 'Jacksonville, Naval Air Station', 30.230000, -81.680000, 'http://weather.noaa.gov/weather/current/KNIP.html', 'http://weather.gov/data/current_obs/KNIP.rss', 'http://weather.gov/data/current_obs/KNIP.xml'),
('KNPA', 'FL', 'Pensacola, Naval Air Station', 30.360000, -87.320000, 'http://weather.noaa.gov/weather/current/KNPA.html', 'http://weather.gov/data/current_obs/KNPA.rss', 'http://weather.gov/data/current_obs/KNPA.xml'),
('KNQX', 'FL', 'Boca Chica Naval Air Station', 24.570000, -81.680000, 'http://weather.noaa.gov/weather/current/KNQX.html', 'http://weather.gov/data/current_obs/KNQX.rss', 'http://weather.gov/data/current_obs/KNQX.xml'),
('KNRB', 'FL', 'Mayport Naval Station', 30.400000, -81.420000, 'http://weather.noaa.gov/weather/current/KNRB.html', 'http://weather.gov/data/current_obs/KNRB.rss', 'http://weather.gov/data/current_obs/KNRB.xml'),
('KNSE', 'FL', 'Milton, Whiting Field North', 30.720000, -87.020000, 'http://weather.noaa.gov/weather/current/KNSE.html', 'http://weather.gov/data/current_obs/KNSE.rss', 'http://weather.gov/data/current_obs/KNSE.xml'),
('KOCF', 'FL', 'Ocala Municipal Automatic Weather Observing', 29.180000, -82.220000, 'http://weather.noaa.gov/weather/current/KOCF.html', 'http://weather.gov/data/current_obs/KOCF.rss', 'http://weather.gov/data/current_obs/KOCF.xml'),
('KOMN', 'FL', 'Ormond Beach Municipal Airport', 29.300000, -81.100000, 'http://weather.noaa.gov/weather/current/KOMN.html', 'http://weather.gov/data/current_obs/KOMN.rss', 'http://weather.gov/data/current_obs/KOMN.xml'),
('KOPF', 'FL', 'Miami, Opa Locka Airport', 25.910000, -80.280000, 'http://weather.noaa.gov/weather/current/KOPF.html', 'http://weather.gov/data/current_obs/KOPF.rss', 'http://weather.gov/data/current_obs/KOPF.xml');


INSERT INTO `#__zweather_stations` (`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES
('KORL', 'FL', 'Orlando Executive Airport', 28.550000, -81.330000, 'http://weather.noaa.gov/weather/current/KORL.html', 'http://weather.gov/data/current_obs/KORL.rss', 'http://weather.gov/data/current_obs/KORL.xml'),
('KPBI', 'FL', 'West Palm Beach, Palm Beach International Airport', 26.680000, -80.120000, 'http://weather.noaa.gov/weather/current/KPBI.html', 'http://weather.gov/data/current_obs/KPBI.rss', 'http://weather.gov/data/current_obs/KPBI.xml'),
('KPGD', 'FL', 'Punta Gorda, Charlotte County Airport', 26.920000, -81.990000, 'http://weather.noaa.gov/weather/current/KPGD.html', 'http://weather.gov/data/current_obs/KPGD.rss', 'http://weather.gov/data/current_obs/KPGD.xml'),
('KPIE', 'FL', 'St. Petersburg / Clea', 27.910000, -82.690000, 'http://weather.noaa.gov/weather/current/KPIE.html', 'http://weather.gov/data/current_obs/KPIE.rss', 'http://weather.gov/data/current_obs/KPIE.xml'),
('KPMP', 'FL', 'Pompano Beach Airpark', 26.250000, -80.110000, 'http://weather.noaa.gov/weather/current/KPMP.html', 'http://weather.gov/data/current_obs/KPMP.rss', 'http://weather.gov/data/current_obs/KPMP.xml'),
('KPNS', 'FL', 'Pensacola Regional Airport', 30.470000, -87.200000, 'http://weather.noaa.gov/weather/current/KPNS.html', 'http://weather.gov/data/current_obs/KPNS.rss', 'http://weather.gov/data/current_obs/KPNS.xml'),
('KRSW', 'FL', 'Fort Myers, SW Florida Intl Airport', 26.540000, -81.760000, 'http://weather.noaa.gov/weather/current/KRSW.html', 'http://weather.gov/data/current_obs/KRSW.rss', 'http://weather.gov/data/current_obs/KRSW.xml'),
('KSFB', 'FL', 'Orlando / Sanford Airport', 28.780000, -81.240000, 'http://weather.noaa.gov/weather/current/KSFB.html', 'http://weather.gov/data/current_obs/KSFB.rss', 'http://weather.gov/data/current_obs/KSFB.xml'),
('KSGJ', 'FL', 'St. Augustine Airport', 29.970000, -81.330000, 'http://weather.noaa.gov/weather/current/KSGJ.html', 'http://weather.gov/data/current_obs/KSGJ.rss', 'http://weather.gov/data/current_obs/KSGJ.xml'),
('KSPG', 'FL', 'St. Petersburg, Whitted Airport', 27.770000, -82.630000, 'http://weather.noaa.gov/weather/current/KSPG.html', 'http://weather.gov/data/current_obs/KSPG.rss', 'http://weather.gov/data/current_obs/KSPG.xml'),
('KSRQ', 'FL', 'Sarasota-Bradenton Intl Airport', 27.400000, -82.550000, 'http://weather.noaa.gov/weather/current/KSRQ.html', 'http://weather.gov/data/current_obs/KSRQ.rss', 'http://weather.gov/data/current_obs/KSRQ.xml'),
('KSUA', 'FL', 'Stuart, Witham Field Airport', 27.182000, -80.221000, 'http://weather.noaa.gov/weather/current/KSUA.html', 'http://weather.gov/data/current_obs/KSUA.rss', 'http://weather.gov/data/current_obs/KSUA.xml'),
('KTIX', 'FL', 'Titusville', 28.520000, -80.800000, 'http://weather.noaa.gov/weather/current/KTIX.html', 'http://weather.gov/data/current_obs/KTIX.rss', 'http://weather.gov/data/current_obs/KTIX.xml'),
('KTLH', 'FL', 'Tallahassee Regional Airport', 30.400000, -84.350000, 'http://weather.noaa.gov/weather/current/KTLH.html', 'http://weather.gov/data/current_obs/KTLH.rss', 'http://weather.gov/data/current_obs/KTLH.xml'),
('KTMB', 'FL', 'Miami, Kendall-Tamiami Executive Airport', 25.650000, -80.430000, 'http://weather.noaa.gov/weather/current/KTMB.html', 'http://weather.gov/data/current_obs/KTMB.rss', 'http://weather.gov/data/current_obs/KTMB.xml'),
('KTPA', 'FL', 'Tampa International Airport', 27.970000, -82.530000, 'http://weather.noaa.gov/weather/current/KTPA.html', 'http://weather.gov/data/current_obs/KTPA.rss', 'http://weather.gov/data/current_obs/KTPA.xml'),
('KTTS', 'FL', 'NASA Shuttle Landing Facility', 28.620000, -80.720000, 'http://weather.noaa.gov/weather/current/KTTS.html', 'http://weather.gov/data/current_obs/KTTS.rss', 'http://weather.gov/data/current_obs/KTTS.xml'),
('KVDF', 'FL', 'Vandenberg Airport', 28.010000, -82.350000, 'http://weather.noaa.gov/weather/current/KVDF.html', 'http://weather.gov/data/current_obs/KVDF.rss', 'http://weather.gov/data/current_obs/KVDF.xml'),
('KVPS', 'FL', 'Valparaiso / Eglin Air Force Base', 30.480000, -86.530000, 'http://weather.noaa.gov/weather/current/KVPS.html', 'http://weather.gov/data/current_obs/KVPS.rss', 'http://weather.gov/data/current_obs/KVPS.xml'),
('KVQQ', 'FL', 'Jacksonville, Cecil Field Airport', 30.217000, -81.876000, 'http://weather.noaa.gov/weather/current/KVQQ.html', 'http://weather.gov/data/current_obs/KVQQ.rss', 'http://weather.gov/data/current_obs/KVQQ.xml'),
('KVRB', 'FL', 'Vero Beach Municipal Airport', 27.650000, -80.420000, 'http://weather.noaa.gov/weather/current/KVRB.html', 'http://weather.gov/data/current_obs/KVRB.rss', 'http://weather.gov/data/current_obs/KVRB.xml'),
('KVVG', 'FL', 'The Villages', 28.962000, -81.970000, 'http://weather.noaa.gov/weather/current/KVVG.html', 'http://weather.gov/data/current_obs/KVVG.rss', 'http://weather.gov/data/current_obs/KVVG.xml'),
('KOBE', 'FL', 'Okeechobee County Airport', 27.260000, -80.850000, 'http://weather.noaa.gov/weather/current/KOBE.html', 'http://weather.gov/data/current_obs/KOBE.rss', 'http://weather.gov/data/current_obs/KOBE.xml'),
('KTPF', 'FL', 'Peter O Knight Airport', 27.915600, -82.449300, 'http://weather.noaa.gov/weather/current/KTPF.html', 'http://weather.gov/data/current_obs/KTPF.rss', 'http://weather.gov/data/current_obs/KTPF.xml'),
('KPCM', 'FL', 'Plant City Airport', 28.000200, -82.164200, 'http://weather.noaa.gov/weather/current/KPCM.html', 'http://weather.gov/data/current_obs/KPCM.rss', 'http://weather.gov/data/current_obs/KPCM.xml'),
('PTPN', 'FM', 'Pohnpei Intl Airport', 6.970000, 158.220000, 'http://weather.noaa.gov/weather/current/PTPN.html', 'http://weather.gov/data/current_obs/PTPN.rss', 'http://weather.gov/data/current_obs/PTPN.xml'),
('PTSA', 'FM', 'Kosrae Island Airport', 5.333000, 163.033000, 'http://weather.noaa.gov/weather/current/PTSA.html', 'http://weather.gov/data/current_obs/PTSA.rss', 'http://weather.gov/data/current_obs/PTSA.xml'),
('PTTP', 'FM', 'Pohnpei', 6.950000, 158.250000, 'http://weather.noaa.gov/weather/current/PTTP.html', 'http://weather.gov/data/current_obs/PTTP.rss', 'http://weather.gov/data/current_obs/PTTP.xml'),
('PTKK', 'FM', 'Chuuk Intl Weno Is', 7.470000, 151.850000, 'http://weather.noaa.gov/weather/current/PTKK.html', 'http://weather.gov/data/current_obs/PTKK.rss', 'http://weather.gov/data/current_obs/PTKK.xml'),
('PTYA', 'FM', 'Yap Intl Airport', 9.483000, 138.083000, 'http://weather.noaa.gov/weather/current/PTYA.html', 'http://weather.gov/data/current_obs/PTYA.rss', 'http://weather.gov/data/current_obs/PTYA.xml'),
('K11J', 'GA', 'Early County Airport', 31.397000, -84.895000, 'http://weather.noaa.gov/weather/current/K11J.html', 'http://weather.gov/data/current_obs/K11J.rss', 'http://weather.gov/data/current_obs/K11J.xml'),
('K27A', 'GA', 'Elbert Co. Airport-Patz Field', 34.095000, -82.816000, 'http://weather.noaa.gov/weather/current/K27A.html', 'http://weather.gov/data/current_obs/K27A.rss', 'http://weather.gov/data/current_obs/K27A.xml'),
('K3J7', 'GA', 'Greene County Regional Airport', 33.600000, -83.133000, 'http://weather.noaa.gov/weather/current/K3J7.html', 'http://weather.gov/data/current_obs/K3J7.rss', 'http://weather.gov/data/current_obs/K3J7.xml'),
('K47A', 'GA', 'Cherokee County Airport', 34.300000, -84.417000, 'http://weather.noaa.gov/weather/current/K47A.html', 'http://weather.gov/data/current_obs/K47A.rss', 'http://weather.gov/data/current_obs/K47A.xml'),
('KABY', 'GA', 'Albany, Southwest Georgia Regional Airport', 31.540000, -84.180000, 'http://weather.noaa.gov/weather/current/KABY.html', 'http://weather.gov/data/current_obs/KABY.rss', 'http://weather.gov/data/current_obs/KABY.xml'),
('KAGS', 'GA', 'Augusta, Bush Field', 33.380000, -81.970000, 'http://weather.noaa.gov/weather/current/KAGS.html', 'http://weather.gov/data/current_obs/KAGS.rss', 'http://weather.gov/data/current_obs/KAGS.xml'),
('KAHN', 'GA', 'Athens Airport', 33.960000, -83.320000, 'http://weather.noaa.gov/weather/current/KAHN.html', 'http://weather.gov/data/current_obs/KAHN.rss', 'http://weather.gov/data/current_obs/KAHN.xml'),
('KAMG', 'GA', 'Alma, Bacon County Airport', 31.540000, -82.500000, 'http://weather.noaa.gov/weather/current/KAMG.html', 'http://weather.gov/data/current_obs/KAMG.rss', 'http://weather.gov/data/current_obs/KAMG.xml'),
('KATL', 'GA', 'Hartsfield-Jackson/Atlanta International Airport', 33.660000, -84.420000, 'http://weather.noaa.gov/weather/current/KATL.html', 'http://weather.gov/data/current_obs/KATL.rss', 'http://weather.gov/data/current_obs/KATL.xml'),
('KAYS', 'GA', 'Waycross / Ware County', 31.250000, -82.400000, 'http://weather.noaa.gov/weather/current/KAYS.html', 'http://weather.gov/data/current_obs/KAYS.rss', 'http://weather.gov/data/current_obs/KAYS.xml'),
('KBGE', 'GA', 'Bainbridge', 30.970000, -84.630000, 'http://weather.noaa.gov/weather/current/KBGE.html', 'http://weather.gov/data/current_obs/KBGE.rss', 'http://weather.gov/data/current_obs/KBGE.xml'),
('KBQK', 'GA', 'Brunswick / Glynco', 31.150000, -81.380000, 'http://weather.noaa.gov/weather/current/KBQK.html', 'http://weather.gov/data/current_obs/KBQK.rss', 'http://weather.gov/data/current_obs/KBQK.xml'),
('KCCO', 'GA', 'Newnan Coweta County Airport', 33.310000, -84.770000, 'http://weather.noaa.gov/weather/current/KCCO.html', 'http://weather.gov/data/current_obs/KCCO.rss', 'http://weather.gov/data/current_obs/KCCO.xml'),
('KCSG', 'GA', 'Columbus Metropolitan Airport', 32.530000, -84.930000, 'http://weather.noaa.gov/weather/current/KCSG.html', 'http://weather.gov/data/current_obs/KCSG.rss', 'http://weather.gov/data/current_obs/KCSG.xml'),
('KDBN', 'GA', 'W H `Bud` Barron Airport', 32.567000, -82.983000, 'http://weather.noaa.gov/weather/current/KDBN.html', 'http://weather.gov/data/current_obs/KDBN.rss', 'http://weather.gov/data/current_obs/KDBN.xml'),
('KDNL', 'GA', 'Augusta, Daniel Field', 33.470000, -82.030000, 'http://weather.noaa.gov/weather/current/KDNL.html', 'http://weather.gov/data/current_obs/KDNL.rss', 'http://weather.gov/data/current_obs/KDNL.xml'),
('KDNN', 'GA', 'Dalton Municipal Airport', 34.720000, -84.870000, 'http://weather.noaa.gov/weather/current/KDNN.html', 'http://weather.gov/data/current_obs/KDNN.rss', 'http://weather.gov/data/current_obs/KDNN.xml'),
('KDQH', 'GA', 'Douglas Municipal Airport', 31.477000, -82.861000, 'http://weather.noaa.gov/weather/current/KDQH.html', 'http://weather.gov/data/current_obs/KDQH.rss', 'http://weather.gov/data/current_obs/KDQH.xml'),
('KFFC', 'GA', 'Atlanta, Peachtree City-Falcon Field', 33.350000, -84.560000, 'http://weather.noaa.gov/weather/current/KFFC.html', 'http://weather.gov/data/current_obs/KFFC.rss', 'http://weather.gov/data/current_obs/KFFC.xml'),
('KFTY', 'GA', 'Atlanta, Fulton County Airport-Brown Field', 33.780000, -84.520000, 'http://weather.noaa.gov/weather/current/KFTY.html', 'http://weather.gov/data/current_obs/KFTY.rss', 'http://weather.gov/data/current_obs/KFTY.xml'),
('KGVL', 'GA', 'Gainesville, Gilmer Memorial Airport', 34.260000, -83.830000, 'http://weather.noaa.gov/weather/current/KGVL.html', 'http://weather.gov/data/current_obs/KGVL.rss', 'http://weather.gov/data/current_obs/KGVL.xml'),
('KHQU', 'GA', 'Thomson-McDuffie County Airport', 33.530000, -82.516000, 'http://weather.noaa.gov/weather/current/KHQU.html', 'http://weather.gov/data/current_obs/KHQU.rss', 'http://weather.gov/data/current_obs/KHQU.xml'),
('KIIY', 'GA', 'Washington-Wilkes County Airport', 33.780000, -82.820000, 'http://weather.noaa.gov/weather/current/KIIY.html', 'http://weather.gov/data/current_obs/KIIY.rss', 'http://weather.gov/data/current_obs/KIIY.xml'),
('KJYL', 'GA', 'Plantation Airpark', 32.645000, -81.596000, 'http://weather.noaa.gov/weather/current/KJYL.html', 'http://weather.gov/data/current_obs/KJYL.rss', 'http://weather.gov/data/current_obs/KJYL.xml'),
('KLGC', 'GA', 'La Grange-Callawy Airport', 33.009000, -85.073000, 'http://weather.noaa.gov/weather/current/KLGC.html', 'http://weather.gov/data/current_obs/KLGC.rss', 'http://weather.gov/data/current_obs/KLGC.xml'),
('KLHW', 'GA', 'Ft. Stewart', 31.880000, -81.570000, 'http://weather.noaa.gov/weather/current/KLHW.html', 'http://weather.gov/data/current_obs/KLHW.rss', 'http://weather.gov/data/current_obs/KLHW.xml'),
('KLSF', 'GA', 'Fort Benning', 32.340000, -85.000000, 'http://weather.noaa.gov/weather/current/KLSF.html', 'http://weather.gov/data/current_obs/KLSF.rss', 'http://weather.gov/data/current_obs/KLSF.xml'),
('KLZU', 'GA', 'Lawrenceville, Gwinnett Co-Briscoe Field Airport', 33.978000, -83.962000, 'http://weather.noaa.gov/weather/current/KLZU.html', 'http://weather.gov/data/current_obs/KLZU.rss', 'http://weather.gov/data/current_obs/KLZU.xml'),
('KMCN', 'GA', 'Macon, Middle Georgia Regional Airport', 32.710000, -83.650000, 'http://weather.noaa.gov/weather/current/KMCN.html', 'http://weather.gov/data/current_obs/KMCN.rss', 'http://weather.gov/data/current_obs/KMCN.xml'),
('KMGE', 'GA', 'Marietta / Dobbins Air Force Base', 33.930000, -84.520000, 'http://weather.noaa.gov/weather/current/KMGE.html', 'http://weather.gov/data/current_obs/KMGE.rss', 'http://weather.gov/data/current_obs/KMGE.xml'),
('KMGR', 'GA', 'Moultrie Municipal Airport', 31.085000, -83.803000, 'http://weather.noaa.gov/weather/current/KMGR.html', 'http://weather.gov/data/current_obs/KMGR.rss', 'http://weather.gov/data/current_obs/KMGR.xml'),
('KMLJ', 'GA', 'Baldwin County Airport', 33.150000, -83.233000, 'http://weather.noaa.gov/weather/current/KMLJ.html', 'http://weather.gov/data/current_obs/KMLJ.rss', 'http://weather.gov/data/current_obs/KMLJ.xml'),
('KOPN', 'GA', 'Thomaston-Upson County Airport', 32.955000, -84.263000, 'http://weather.noaa.gov/weather/current/KOPN.html', 'http://weather.gov/data/current_obs/KOPN.rss', 'http://weather.gov/data/current_obs/KOPN.xml'),
('KPDK', 'GA', 'Atlanta, De Kalb-Peachtree Airport', 33.880000, -84.300000, 'http://weather.noaa.gov/weather/current/KPDK.html', 'http://weather.gov/data/current_obs/KPDK.rss', 'http://weather.gov/data/current_obs/KPDK.xml'),
('KRMG', 'GA', 'Rome, R. B. Russell Airport', 34.360000, -85.170000, 'http://weather.noaa.gov/weather/current/KRMG.html', 'http://weather.gov/data/current_obs/KRMG.rss', 'http://weather.gov/data/current_obs/KRMG.xml'),
('KRYY', 'GA', 'Marietta, Cobb County-McCollum Field Airport', 34.013000, -84.599000, 'http://weather.noaa.gov/weather/current/KRYY.html', 'http://weather.gov/data/current_obs/KRYY.rss', 'http://weather.gov/data/current_obs/KRYY.xml'),
('KSAV', 'GA', 'Savannah International Airport', 32.140000, -81.200000, 'http://weather.noaa.gov/weather/current/KSAV.html', 'http://weather.gov/data/current_obs/KSAV.rss', 'http://weather.gov/data/current_obs/KSAV.xml'),
('KSSI', 'GA', 'Brunswick/Malcom-McKinnon', 31.150000, -81.380000, 'http://weather.noaa.gov/weather/current/KSSI.html', 'http://weather.gov/data/current_obs/KSSI.rss', 'http://weather.gov/data/current_obs/KSSI.xml'),
('KSVN', 'GA', 'Hunter U. S. Army Airfield', 32.030000, -81.150000, 'http://weather.noaa.gov/weather/current/KSVN.html', 'http://weather.gov/data/current_obs/KSVN.rss', 'http://weather.gov/data/current_obs/KSVN.xml'),
('KTBR', 'GA', 'Statesboro-Bulloch County Airport', 32.482000, -81.737000, 'http://weather.noaa.gov/weather/current/KTBR.html', 'http://weather.gov/data/current_obs/KTBR.rss', 'http://weather.gov/data/current_obs/KTBR.xml'),
('KVAD', 'GA', 'Moody Air Force Base', 30.970000, -83.200000, 'http://weather.noaa.gov/weather/current/KVAD.html', 'http://weather.gov/data/current_obs/KVAD.rss', 'http://weather.gov/data/current_obs/KVAD.xml'),
('KVDI', 'GA', 'Vidalia Municipal Airport', 32.193000, -82.372000, 'http://weather.noaa.gov/weather/current/KVDI.html', 'http://weather.gov/data/current_obs/KVDI.rss', 'http://weather.gov/data/current_obs/KVDI.xml'),
('KVLD', 'GA', 'Valdosta Regional Airport', 30.790000, -83.280000, 'http://weather.noaa.gov/weather/current/KVLD.html', 'http://weather.gov/data/current_obs/KVLD.rss', 'http://weather.gov/data/current_obs/KVLD.xml'),
('KVPC', 'GA', 'Cartersville Airport', 34.130000, -84.850000, 'http://weather.noaa.gov/weather/current/KVPC.html', 'http://weather.gov/data/current_obs/KVPC.rss', 'http://weather.gov/data/current_obs/KVPC.xml'),
('KWDR', 'GA', 'Winder-Barrow Airport', 33.982000, -83.668000, 'http://weather.noaa.gov/weather/current/KWDR.html', 'http://weather.gov/data/current_obs/KWDR.rss', 'http://weather.gov/data/current_obs/KWDR.xml'),
('KWRB', 'GA', 'Robins Air Force Base', 32.640000, -83.600000, 'http://weather.noaa.gov/weather/current/KWRB.html', 'http://weather.gov/data/current_obs/KWRB.rss', 'http://weather.gov/data/current_obs/KWRB.xml'),
('TGPY', 'GD', 'Point Salines Airport', 12.000000, -61.783000, 'http://weather.noaa.gov/weather/current/TGPY.html', 'http://weather.gov/data/current_obs/TGPY.rss', 'http://weather.gov/data/current_obs/TGPY.xml'),
('PGRO', 'GU', 'Rota/Intl', 14.180000, 145.250000, 'http://weather.noaa.gov/weather/current/PGRO.html', 'http://weather.gov/data/current_obs/PGRO.rss', 'http://weather.gov/data/current_obs/PGRO.xml'),
('PGSN', 'GU', 'Saipan Intl Airport', 15.120000, 145.730000, 'http://weather.noaa.gov/weather/current/PGSN.html', 'http://weather.gov/data/current_obs/PGSN.rss', 'http://weather.gov/data/current_obs/PGSN.xml'),
('PGUA', 'GU', 'Anderson AFB', 13.580000, 144.930000, 'http://weather.noaa.gov/weather/current/PGUA.html', 'http://weather.gov/data/current_obs/PGUA.rss', 'http://weather.gov/data/current_obs/PGUA.xml'),
('PGUM', 'GU', 'Guam International', 13.480000, 144.800000, 'http://weather.noaa.gov/weather/current/PGUM.html', 'http://weather.gov/data/current_obs/PGUM.rss', 'http://weather.gov/data/current_obs/PGUM.xml'),
('PGWT', 'GU', 'West Tinian Tinian Is', 14.970000, 145.600000, 'http://weather.noaa.gov/weather/current/PGWT.html', 'http://weather.gov/data/current_obs/PGWT.rss', 'http://weather.gov/data/current_obs/PGWT.xml'),
('PHBK', 'HI', 'Kekaha / Barking Sand', 22.070000, -159.780000, 'http://weather.noaa.gov/weather/current/PHBK.html', 'http://weather.gov/data/current_obs/PHBK.rss', 'http://weather.gov/data/current_obs/PHBK.xml'),
('PHHI', 'HI', 'Wheeler Army Airfield', 21.480000, -158.030000, 'http://weather.noaa.gov/weather/current/PHHI.html', 'http://weather.gov/data/current_obs/PHHI.rss', 'http://weather.gov/data/current_obs/PHHI.xml'),
('PHHN', 'HI', 'Hana', 20.784000, -156.014000, 'http://weather.noaa.gov/weather/current/PHHN.html', 'http://weather.gov/data/current_obs/PHHN.rss', 'http://weather.gov/data/current_obs/PHHN.xml'),
('PHJH', 'HI', 'Lahaina / West Maui', 21.020000, -156.630000, 'http://weather.noaa.gov/weather/current/PHJH.html', 'http://weather.gov/data/current_obs/PHJH.rss', 'http://weather.gov/data/current_obs/PHJH.xml'),
('PHJR', 'HI', 'Kalaeloa Airport', 21.320000, -158.070000, 'http://weather.noaa.gov/weather/current/PHJR.html', 'http://weather.gov/data/current_obs/PHJR.rss', 'http://weather.gov/data/current_obs/PHJR.xml'),
('PHKO', 'HI', 'Kailua / Kona, Keahole Airport', 19.650000, -156.000000, 'http://weather.noaa.gov/weather/current/PHKO.html', 'http://weather.gov/data/current_obs/PHKO.rss', 'http://weather.gov/data/current_obs/PHKO.xml'),
('PHLI', 'HI', 'Lihue Airport', 21.980000, -159.350000, 'http://weather.noaa.gov/weather/current/PHLI.html', 'http://weather.gov/data/current_obs/PHLI.rss', 'http://weather.gov/data/current_obs/PHLI.xml'),
('PHMK', 'HI', 'Molokai Airport', 21.150000, -157.100000, 'http://weather.noaa.gov/weather/current/PHMK.html', 'http://weather.gov/data/current_obs/PHMK.rss', 'http://weather.gov/data/current_obs/PHMK.xml'),
('PHNG', 'HI', 'Kaneohe Bay MCAF', 21.450000, -157.783000, 'http://weather.noaa.gov/weather/current/PHNG.html', 'http://weather.gov/data/current_obs/PHNG.rss', 'http://weather.gov/data/current_obs/PHNG.xml'),
('PHNL', 'HI', 'Honolulu International Airport', 21.350000, -157.930000, 'http://weather.noaa.gov/weather/current/PHNL.html', 'http://weather.gov/data/current_obs/PHNL.rss', 'http://weather.gov/data/current_obs/PHNL.xml'),
('PHNY', 'HI', 'Lanai City Airport', 20.780000, -156.950000, 'http://weather.noaa.gov/weather/current/PHNY.html', 'http://weather.gov/data/current_obs/PHNY.rss', 'http://weather.gov/data/current_obs/PHNY.xml'),
('PHOG', 'HI', 'Kahului Airport', 20.900000, -156.430000, 'http://weather.noaa.gov/weather/current/PHOG.html', 'http://weather.gov/data/current_obs/PHOG.rss', 'http://weather.gov/data/current_obs/PHOG.xml'),
('PHSF', 'HI', 'Bradshaw Army Air Field', 19.780000, -155.550000, 'http://weather.noaa.gov/weather/current/PHSF.html', 'http://weather.gov/data/current_obs/PHSF.rss', 'http://weather.gov/data/current_obs/PHSF.xml'),
('PHTO', 'HI', 'Hilo International Airport', 19.720000, -155.070000, 'http://weather.noaa.gov/weather/current/PHTO.html', 'http://weather.gov/data/current_obs/PHTO.rss', 'http://weather.gov/data/current_obs/PHTO.xml'),
('PJON', 'HI', 'Johnson Island', 16.733000, -169.517000, 'http://weather.noaa.gov/weather/current/PJON.html', 'http://weather.gov/data/current_obs/PJON.rss', 'http://weather.gov/data/current_obs/PJON.xml'),
('PWAK', 'HI', 'Wake Island Airfield', 19.283000, 166.500000, 'http://weather.noaa.gov/weather/current/PWAK.html', 'http://weather.gov/data/current_obs/PWAK.rss', 'http://weather.gov/data/current_obs/PWAK.xml'),
('PMDY', 'HI', 'Midway NAF', 28.220000, -177.370000, 'http://weather.noaa.gov/weather/current/PMDY.html', 'http://weather.gov/data/current_obs/PMDY.rss', 'http://weather.gov/data/current_obs/PMDY.xml'),
('KGGI', 'IA', 'Grinnell Regional Airport', 41.709200, -92.734900, 'http://weather.noaa.gov/weather/current/KGGI.html', 'http://weather.gov/data/current_obs/KGGI.rss', 'http://weather.gov/data/current_obs/KGGI.xml'),
('KADU', 'IA', 'Audubon County Airport', 41.700000, -94.920000, 'http://weather.noaa.gov/weather/current/KADU.html', 'http://weather.gov/data/current_obs/KADU.rss', 'http://weather.gov/data/current_obs/KADU.xml'),
('KAIO', 'IA', 'Atlantic', 41.400000, -95.050000, 'http://weather.noaa.gov/weather/current/KAIO.html', 'http://weather.gov/data/current_obs/KAIO.rss', 'http://weather.gov/data/current_obs/KAIO.xml'),
('KALO', 'IA', 'Waterloo Municipal Airport', 42.550000, -92.400000, 'http://weather.noaa.gov/weather/current/KALO.html', 'http://weather.gov/data/current_obs/KALO.rss', 'http://weather.gov/data/current_obs/KALO.xml'),
('KAMW', 'IA', 'Ames Municipal Airport', 41.990000, -93.620000, 'http://weather.noaa.gov/weather/current/KAMW.html', 'http://weather.gov/data/current_obs/KAMW.rss', 'http://weather.gov/data/current_obs/KAMW.xml'),
('KAWG', 'IA', 'Washington', 41.280000, -91.670000, 'http://weather.noaa.gov/weather/current/KAWG.html', 'http://weather.gov/data/current_obs/KAWG.rss', 'http://weather.gov/data/current_obs/KAWG.xml'),
('KAXA', 'IA', 'Algona', 43.080000, -94.270000, 'http://weather.noaa.gov/weather/current/KAXA.html', 'http://weather.gov/data/current_obs/KAXA.rss', 'http://weather.gov/data/current_obs/KAXA.xml'),
('KBNW', 'IA', 'Boone Municipal', 42.050000, -93.850000, 'http://weather.noaa.gov/weather/current/KBNW.html', 'http://weather.gov/data/current_obs/KBNW.rss', 'http://weather.gov/data/current_obs/KBNW.xml'),
('KBRL', 'IA', 'Burlington Regional Airport', 40.790000, -91.120000, 'http://weather.noaa.gov/weather/current/KBRL.html', 'http://weather.gov/data/current_obs/KBRL.rss', 'http://weather.gov/data/current_obs/KBRL.xml'),
('KCAV', 'IA', 'Clarion', 42.750000, -93.770000, 'http://weather.noaa.gov/weather/current/KCAV.html', 'http://weather.gov/data/current_obs/KCAV.rss', 'http://weather.gov/data/current_obs/KCAV.xml'),
('KCBF', 'IA', 'Council Bluffs', 41.270000, -95.770000, 'http://weather.noaa.gov/weather/current/KCBF.html', 'http://weather.gov/data/current_obs/KCBF.rss', 'http://weather.gov/data/current_obs/KCBF.xml'),
('KCCY', 'IA', 'Charles City', 43.070000, -92.620000, 'http://weather.noaa.gov/weather/current/KCCY.html', 'http://weather.gov/data/current_obs/KCCY.rss', 'http://weather.gov/data/current_obs/KCCY.xml'),
('KCID', 'IA', 'Cedar Rapids, The Eastern Iowa Airport', 41.890000, -91.700000, 'http://weather.noaa.gov/weather/current/KCID.html', 'http://weather.gov/data/current_obs/KCID.rss', 'http://weather.gov/data/current_obs/KCID.xml'),
('KCIN', 'IA', 'Carroll', 42.050000, -94.780000, 'http://weather.noaa.gov/weather/current/KCIN.html', 'http://weather.gov/data/current_obs/KCIN.rss', 'http://weather.gov/data/current_obs/KCIN.xml'),
('KCKP', 'IA', 'Cherokee Municipal Airport', 42.732000, -95.556000, 'http://weather.noaa.gov/weather/current/KCKP.html', 'http://weather.gov/data/current_obs/KCKP.rss', 'http://weather.gov/data/current_obs/KCKP.xml'),
('KCNC', 'IA', 'Chariton', 41.030000, -93.370000, 'http://weather.noaa.gov/weather/current/KCNC.html', 'http://weather.gov/data/current_obs/KCNC.rss', 'http://weather.gov/data/current_obs/KCNC.xml'),
('KCSQ', 'IA', 'Creston', 41.020000, -94.370000, 'http://weather.noaa.gov/weather/current/KCSQ.html', 'http://weather.gov/data/current_obs/KCSQ.rss', 'http://weather.gov/data/current_obs/KCSQ.xml'),
('KCWI', 'IA', 'Clinton Municipal Automatic Weather Observing', 41.840000, -90.340000, 'http://weather.noaa.gov/weather/current/KCWI.html', 'http://weather.gov/data/current_obs/KCWI.rss', 'http://weather.gov/data/current_obs/KCWI.xml'),
('KDBQ', 'IA', 'Dubuque Regional Airport', 42.410000, -90.700000, 'http://weather.noaa.gov/weather/current/KDBQ.html', 'http://weather.gov/data/current_obs/KDBQ.rss', 'http://weather.gov/data/current_obs/KDBQ.xml'),
('KDEH', 'IA', 'Decorah', 43.280000, -91.730000, 'http://weather.noaa.gov/weather/current/KDEH.html', 'http://weather.gov/data/current_obs/KDEH.rss', 'http://weather.gov/data/current_obs/KDEH.xml'),
('KDNS', 'IA', 'Denison', 41.980000, -95.380000, 'http://weather.noaa.gov/weather/current/KDNS.html', 'http://weather.gov/data/current_obs/KDNS.rss', 'http://weather.gov/data/current_obs/KDNS.xml'),
('KDSM', 'IA', 'Des Moines International Airport', 41.540000, -93.650000, 'http://weather.noaa.gov/weather/current/KDSM.html', 'http://weather.gov/data/current_obs/KDSM.rss', 'http://weather.gov/data/current_obs/KDSM.xml'),
('KDVN', 'IA', 'Davenport Municipal Airport', 41.620000, -90.580000, 'http://weather.noaa.gov/weather/current/KDVN.html', 'http://weather.gov/data/current_obs/KDVN.rss', 'http://weather.gov/data/current_obs/KDVN.xml'),
('KEBS', 'IA', 'Webster City', 42.430000, -93.870000, 'http://weather.noaa.gov/weather/current/KEBS.html', 'http://weather.gov/data/current_obs/KEBS.rss', 'http://weather.gov/data/current_obs/KEBS.xml'),
('KEOK', 'IA', 'Keokuk Municipal', 40.470000, -91.430000, 'http://weather.noaa.gov/weather/current/KEOK.html', 'http://weather.gov/data/current_obs/KEOK.rss', 'http://weather.gov/data/current_obs/KEOK.xml'),
('KEST', 'IA', 'Estherville Municipal Airport', 43.400000, -94.750000, 'http://weather.noaa.gov/weather/current/KEST.html', 'http://weather.gov/data/current_obs/KEST.rss', 'http://weather.gov/data/current_obs/KEST.xml'),
('KFFL', 'IA', 'Fair Field', 41.050000, -91.980000, 'http://weather.noaa.gov/weather/current/KFFL.html', 'http://weather.gov/data/current_obs/KFFL.rss', 'http://weather.gov/data/current_obs/KFFL.xml'),
('KFOD', 'IA', 'Fort Dodge', 42.550000, -94.180000, 'http://weather.noaa.gov/weather/current/KFOD.html', 'http://weather.gov/data/current_obs/KFOD.rss', 'http://weather.gov/data/current_obs/KFOD.xml'),
('KFSW', 'IA', 'Fort Madison', 40.670000, -91.330000, 'http://weather.noaa.gov/weather/current/KFSW.html', 'http://weather.gov/data/current_obs/KFSW.rss', 'http://weather.gov/data/current_obs/KFSW.xml'),
('KHNR', 'IA', 'Harlan Municipal Airport', 41.584000, -95.340000, 'http://weather.noaa.gov/weather/current/KHNR.html', 'http://weather.gov/data/current_obs/KHNR.rss', 'http://weather.gov/data/current_obs/KHNR.xml'),
('KICL', 'IA', 'Clarinda', 40.720000, -95.030000, 'http://weather.noaa.gov/weather/current/KICL.html', 'http://weather.gov/data/current_obs/KICL.rss', 'http://weather.gov/data/current_obs/KICL.xml'),
('KIIB', 'IA', 'Independence Muni Airport', 42.454000, -91.948000, 'http://weather.noaa.gov/weather/current/KIIB.html', 'http://weather.gov/data/current_obs/KIIB.rss', 'http://weather.gov/data/current_obs/KIIB.xml'),
('KIKV', 'IA', 'Ankeny Regional Airport', 41.690000, -93.570000, 'http://weather.noaa.gov/weather/current/KIKV.html', 'http://weather.gov/data/current_obs/KIKV.rss', 'http://weather.gov/data/current_obs/KIKV.xml'),
('KIOW', 'IA', 'Iowa City Municipal Airport', 41.633000, -91.543000, 'http://weather.noaa.gov/weather/current/KIOW.html', 'http://weather.gov/data/current_obs/KIOW.rss', 'http://weather.gov/data/current_obs/KIOW.xml'),
('KLRJ', 'IA', 'Le Mars Municipal Airport', 42.780000, -96.200000, 'http://weather.noaa.gov/weather/current/KLRJ.html', 'http://weather.gov/data/current_obs/KLRJ.rss', 'http://weather.gov/data/current_obs/KLRJ.xml'),
('KLWD', 'IA', 'Lamoni Municipal Airport', 40.631000, -93.901000, 'http://weather.noaa.gov/weather/current/KLWD.html', 'http://weather.gov/data/current_obs/KLWD.rss', 'http://weather.gov/data/current_obs/KLWD.xml'),
('KMCW', 'IA', 'Mason City Municipal Airport', 43.160000, -93.330000, 'http://weather.noaa.gov/weather/current/KMCW.html', 'http://weather.gov/data/current_obs/KMCW.rss', 'http://weather.gov/data/current_obs/KMCW.xml'),
('KMIW', 'IA', 'Marshalltown Municipal Airport', 42.110000, -92.910000, 'http://weather.noaa.gov/weather/current/KMIW.html', 'http://weather.gov/data/current_obs/KMIW.rss', 'http://weather.gov/data/current_obs/KMIW.xml'),
('KMPZ', 'IA', 'Mount Pleasant Muni Airport', 40.950000, -91.510000, 'http://weather.noaa.gov/weather/current/KMPZ.html', 'http://weather.gov/data/current_obs/KMPZ.rss', 'http://weather.gov/data/current_obs/KMPZ.xml'),
('KMUT', 'IA', 'Muscatine', 41.370000, -91.150000, 'http://weather.noaa.gov/weather/current/KMUT.html', 'http://weather.gov/data/current_obs/KMUT.rss', 'http://weather.gov/data/current_obs/KMUT.xml'),
('KMXO', 'IA', 'Monticello Municipal', 42.230000, -91.170000, 'http://weather.noaa.gov/weather/current/KMXO.html', 'http://weather.gov/data/current_obs/KMXO.rss', 'http://weather.gov/data/current_obs/KMXO.xml'),
('KOLZ', 'IA', 'Oelwein Municipal Airport', 42.680000, -91.960000, 'http://weather.noaa.gov/weather/current/KOLZ.html', 'http://weather.gov/data/current_obs/KOLZ.rss', 'http://weather.gov/data/current_obs/KOLZ.xml'),
('KOOA', 'IA', 'Oskaloosa Municipal Airport', 41.233000, -92.483000, 'http://weather.noaa.gov/weather/current/KOOA.html', 'http://weather.gov/data/current_obs/KOOA.rss', 'http://weather.gov/data/current_obs/KOOA.xml'),
('KORC', 'IA', 'Orange City', 42.980000, -96.070000, 'http://weather.noaa.gov/weather/current/KORC.html', 'http://weather.gov/data/current_obs/KORC.rss', 'http://weather.gov/data/current_obs/KORC.xml'),
('KOTM', 'IA', 'Ottumwa Industrial Airport', 41.110000, -92.450000, 'http://weather.noaa.gov/weather/current/KOTM.html', 'http://weather.gov/data/current_obs/KOTM.rss', 'http://weather.gov/data/current_obs/KOTM.xml'),
('KOXV', 'IA', 'Knoxville', 41.300000, -93.120000, 'http://weather.noaa.gov/weather/current/KOXV.html', 'http://weather.gov/data/current_obs/KOXV.rss', 'http://weather.gov/data/current_obs/KOXV.xml'),
('KPEA', 'IA', 'Pella Muni Airport', 41.400000, -92.950000, 'http://weather.noaa.gov/weather/current/KPEA.html', 'http://weather.gov/data/current_obs/KPEA.rss', 'http://weather.gov/data/current_obs/KPEA.xml'),
('KRDK', 'IA', 'Red Oak', 41.020000, -95.270000, 'http://weather.noaa.gov/weather/current/KRDK.html', 'http://weather.gov/data/current_obs/KRDK.rss', 'http://weather.gov/data/current_obs/KRDK.xml'),
('KSDA', 'IA', 'Shenandoah Municipal', 40.750000, -95.420000, 'http://weather.noaa.gov/weather/current/KSDA.html', 'http://weather.gov/data/current_obs/KSDA.rss', 'http://weather.gov/data/current_obs/KSDA.xml'),
('KSHL', 'IA', 'Sheldon', 43.220000, -95.830000, 'http://weather.noaa.gov/weather/current/KSHL.html', 'http://weather.gov/data/current_obs/KSHL.rss', 'http://weather.gov/data/current_obs/KSHL.xml'),
('KSLB', 'IA', 'Storm Lake', 42.600000, -95.230000, 'http://weather.noaa.gov/weather/current/KSLB.html', 'http://weather.gov/data/current_obs/KSLB.rss', 'http://weather.gov/data/current_obs/KSLB.xml'),
('KSPW', 'IA', 'Spencer Municipal Airport', 43.170000, -95.210000, 'http://weather.noaa.gov/weather/current/KSPW.html', 'http://weather.gov/data/current_obs/KSPW.rss', 'http://weather.gov/data/current_obs/KSPW.xml'),
('KSUX', 'IA', 'Sioux Gateway Airport', 42.410000, -96.380000, 'http://weather.noaa.gov/weather/current/KSUX.html', 'http://weather.gov/data/current_obs/KSUX.rss', 'http://weather.gov/data/current_obs/KSUX.xml'),
('KTNU', 'IA', 'Newton Municipal', 41.680000, -93.020000, 'http://weather.noaa.gov/weather/current/KTNU.html', 'http://weather.gov/data/current_obs/KTNU.rss', 'http://weather.gov/data/current_obs/KTNU.xml'),
('KVTI', 'IA', 'Vinton Veterans Mem Airpark Airport', 42.219000, -92.026000, 'http://weather.noaa.gov/weather/current/KVTI.html', 'http://weather.gov/data/current_obs/KVTI.rss', 'http://weather.gov/data/current_obs/KVTI.xml'),
('K77M', 'ID', 'Malta', 42.300000, -113.370000, 'http://weather.noaa.gov/weather/current/K77M.html', 'http://weather.gov/data/current_obs/K77M.rss', 'http://weather.gov/data/current_obs/K77M.xml'),
('KBOI', 'ID', 'Boise Municipal', 43.580000, -116.220000, 'http://weather.noaa.gov/weather/current/KBOI.html', 'http://weather.gov/data/current_obs/KBOI.rss', 'http://weather.gov/data/current_obs/KBOI.xml'),
('KBYI', 'ID', 'Burley Municipal', 42.540000, -113.770000, 'http://weather.noaa.gov/weather/current/KBYI.html', 'http://weather.gov/data/current_obs/KBYI.rss', 'http://weather.gov/data/current_obs/KBYI.xml'),
('KEUL', 'ID', 'Caldwell', 43.640000, -116.640000, 'http://weather.noaa.gov/weather/current/KEUL.html', 'http://weather.gov/data/current_obs/KEUL.rss', 'http://weather.gov/data/current_obs/KEUL.xml'),
('KIDA', 'ID', 'Idaho Falls/Fanning', 43.530000, -112.070000, 'http://weather.noaa.gov/weather/current/KIDA.html', 'http://weather.gov/data/current_obs/KIDA.rss', 'http://weather.gov/data/current_obs/KIDA.xml'),
('KJER', 'ID', 'Jerome County Airport', 42.728000, -114.453000, 'http://weather.noaa.gov/weather/current/KJER.html', 'http://weather.gov/data/current_obs/KJER.rss', 'http://weather.gov/data/current_obs/KJER.xml'),
('KLLJ', 'ID', 'Challis (amos)', 44.523000, -114.215000, 'http://weather.noaa.gov/weather/current/KLLJ.html', 'http://weather.gov/data/current_obs/KLLJ.rss', 'http://weather.gov/data/current_obs/KLLJ.xml'),
('KMLD', 'ID', 'Malad City', 42.180000, -112.320000, 'http://weather.noaa.gov/weather/current/KMLD.html', 'http://weather.gov/data/current_obs/KMLD.rss', 'http://weather.gov/data/current_obs/KMLD.xml'),
('KMLP', 'ID', 'Mullan Pass Vor', 47.450000, -115.670000, 'http://weather.noaa.gov/weather/current/KMLP.html', 'http://weather.gov/data/current_obs/KMLP.rss', 'http://weather.gov/data/current_obs/KMLP.xml'),
('KMUO', 'ID', 'Mountain Home AFB', 43.050000, -115.870000, 'http://weather.noaa.gov/weather/current/KMUO.html', 'http://weather.gov/data/current_obs/KMUO.rss', 'http://weather.gov/data/current_obs/KMUO.xml'),
('KMYL', 'ID', 'Mc Call', 44.890000, -116.100000, 'http://weather.noaa.gov/weather/current/KMYL.html', 'http://weather.gov/data/current_obs/KMYL.rss', 'http://weather.gov/data/current_obs/KMYL.xml'),
('KPIH', 'ID', 'Pocatello Municipal', 42.930000, -112.600000, 'http://weather.noaa.gov/weather/current/KPIH.html', 'http://weather.gov/data/current_obs/KPIH.rss', 'http://weather.gov/data/current_obs/KPIH.xml'),
('KRXE', 'ID', 'Rexburg-Madison County Airport', 43.830000, -111.810000, 'http://weather.noaa.gov/weather/current/KRXE.html', 'http://weather.gov/data/current_obs/KRXE.rss', 'http://weather.gov/data/current_obs/KRXE.xml'),
('KSMN', 'ID', 'Salmon/Lemhi (awos)', 45.120000, -113.880000, 'http://weather.noaa.gov/weather/current/KSMN.html', 'http://weather.gov/data/current_obs/KSMN.rss', 'http://weather.gov/data/current_obs/KSMN.xml'),
('KSNT', 'ID', 'Stanley Ranger Station', 44.170000, -114.930000, 'http://weather.noaa.gov/weather/current/KSNT.html', 'http://weather.gov/data/current_obs/KSNT.rss', 'http://weather.gov/data/current_obs/KSNT.xml'),
('KSUN', 'ID', 'Hailey/Friedman Mem', 43.510000, -114.300000, 'http://weather.noaa.gov/weather/current/KSUN.html', 'http://weather.gov/data/current_obs/KSUN.rss', 'http://weather.gov/data/current_obs/KSUN.xml'),
('KSZT', 'ID', 'Sandpoint Airport', 48.300000, -116.550000, 'http://weather.noaa.gov/weather/current/KSZT.html', 'http://weather.gov/data/current_obs/KSZT.rss', 'http://weather.gov/data/current_obs/KSZT.xml'),
('KTWF', 'ID', 'Twin Falls/Joslin', 42.480000, -114.480000, 'http://weather.noaa.gov/weather/current/KTWF.html', 'http://weather.gov/data/current_obs/KTWF.rss', 'http://weather.gov/data/current_obs/KTWF.xml'),
('KU78', 'ID', 'Soda Springs/Tigert', 42.660000, -111.580000, 'http://weather.noaa.gov/weather/current/KU78.html', 'http://weather.gov/data/current_obs/KU78.rss', 'http://weather.gov/data/current_obs/KU78.xml'),
('KCOE', 'ID', 'COEUR D''ALENE(AWOS)', 47.780000, -116.820000, 'http://weather.noaa.gov/weather/current/KCOE.html', 'http://weather.gov/data/current_obs/KCOE.rss', 'http://weather.gov/data/current_obs/KCOE.xml'),
('KLWS', 'ID', 'Lewiston (amos)', 46.390000, -117.020000, 'http://weather.noaa.gov/weather/current/KLWS.html', 'http://weather.gov/data/current_obs/KLWS.rss', 'http://weather.gov/data/current_obs/KLWS.xml'),
('KP69', 'ID', 'Lowell', 46.150000, -115.600000, 'http://weather.noaa.gov/weather/current/KP69.html', 'http://weather.gov/data/current_obs/KP69.rss', 'http://weather.gov/data/current_obs/KP69.xml'),
('KS14', 'ID', 'Spencer', 44.300000, -112.100000, 'http://weather.noaa.gov/weather/current/KS14.html', 'http://weather.gov/data/current_obs/KS14.rss', 'http://weather.gov/data/current_obs/KS14.xml'),
('K1H2', 'IL', 'Effingham', 39.070000, -88.530000, 'http://weather.noaa.gov/weather/current/K1H2.html', 'http://weather.gov/data/current_obs/K1H2.rss', 'http://weather.gov/data/current_obs/K1H2.xml'),
('K3LF', 'IL', 'Litchfield Municipal Airport', 39.163000, -89.675000, 'http://weather.noaa.gov/weather/current/K3LF.html', 'http://weather.gov/data/current_obs/K3LF.rss', 'http://weather.gov/data/current_obs/K3LF.xml'),
('KAAA', 'IL', 'Logan County Airport', 40.160000, -89.330000, 'http://weather.noaa.gov/weather/current/KAAA.html', 'http://weather.gov/data/current_obs/KAAA.rss', 'http://weather.gov/data/current_obs/KAAA.xml'),
('KAJG', 'IL', 'Mount Carmel Municipal Airport', 38.607000, -87.727000, 'http://weather.noaa.gov/weather/current/KAJG.html', 'http://weather.gov/data/current_obs/KAJG.rss', 'http://weather.gov/data/current_obs/KAJG.xml'),
('KALN', 'IL', 'Alton / St. Louis Regional', 38.910000, -90.050000, 'http://weather.noaa.gov/weather/current/KALN.html', 'http://weather.gov/data/current_obs/KALN.rss', 'http://weather.gov/data/current_obs/KALN.xml'),
('KARR', 'IL', 'Aurora Municipal Airport', 41.770000, -88.470000, 'http://weather.noaa.gov/weather/current/KARR.html', 'http://weather.gov/data/current_obs/KARR.rss', 'http://weather.gov/data/current_obs/KARR.xml'),
('KBLV', 'IL', 'Scott Air Force Base / Belleville', 38.550000, -89.850000, 'http://weather.noaa.gov/weather/current/KBLV.html', 'http://weather.gov/data/current_obs/KBLV.rss', 'http://weather.gov/data/current_obs/KBLV.xml'),
('KBMI', 'IL', 'Bloomington / Normal', 40.480000, -88.930000, 'http://weather.noaa.gov/weather/current/KBMI.html', 'http://weather.gov/data/current_obs/KBMI.rss', 'http://weather.gov/data/current_obs/KBMI.xml'),
('KC09', 'IL', 'Morris Muni-James R Washburn Field Airport', 41.430000, -88.420000, 'http://weather.noaa.gov/weather/current/KC09.html', 'http://weather.gov/data/current_obs/KC09.rss', 'http://weather.gov/data/current_obs/KC09.xml'),
('KC75', 'IL', 'Lacon', 41.020000, -89.390000, 'http://weather.noaa.gov/weather/current/KC75.html', 'http://weather.gov/data/current_obs/KC75.rss', 'http://weather.gov/data/current_obs/KC75.xml'),
('KCIR', 'IL', 'Cairo Regional Airport', 37.067000, -89.217000, 'http://weather.noaa.gov/weather/current/KCIR.html', 'http://weather.gov/data/current_obs/KCIR.rss', 'http://weather.gov/data/current_obs/KCIR.xml'),
('KCMI', 'IL', 'Champaign / Urbana, University of Illinois-Willard', 40.040000, -88.280000, 'http://weather.noaa.gov/weather/current/KCMI.html', 'http://weather.gov/data/current_obs/KCMI.rss', 'http://weather.gov/data/current_obs/KCMI.xml'),
('KCPS', 'IL', 'Cahokia / St. Louis, St. Louis Downtown Airport', 38.580000, -90.150000, 'http://weather.noaa.gov/weather/current/KCPS.html', 'http://weather.gov/data/current_obs/KCPS.rss', 'http://weather.gov/data/current_obs/KCPS.xml'),
('KCUL', 'IL', 'Carmi Municipal Airport', 38.090000, -88.123000, 'http://weather.noaa.gov/weather/current/KCUL.html', 'http://weather.gov/data/current_obs/KCUL.rss', 'http://weather.gov/data/current_obs/KCUL.xml'),
('KDEC', 'IL', 'Decatur Airport', 39.840000, -88.870000, 'http://weather.noaa.gov/weather/current/KDEC.html', 'http://weather.gov/data/current_obs/KDEC.rss', 'http://weather.gov/data/current_obs/KDEC.xml'),
('KDKB', 'IL', 'DeKalb Taylor Municipal Airport', 41.930000, -88.720000, 'http://weather.noaa.gov/weather/current/KDKB.html', 'http://weather.gov/data/current_obs/KDKB.rss', 'http://weather.gov/data/current_obs/KDKB.xml'),
('KDNV', 'IL', 'Danville, Vermilion County Airport', 40.200000, -87.600000, 'http://weather.noaa.gov/weather/current/KDNV.html', 'http://weather.gov/data/current_obs/KDNV.rss', 'http://weather.gov/data/current_obs/KDNV.xml'),
('KDPA', 'IL', 'Chicago / West Chicago, Dupage Airport', 41.930000, -88.250000, 'http://weather.noaa.gov/weather/current/KDPA.html', 'http://weather.gov/data/current_obs/KDPA.rss', 'http://weather.gov/data/current_obs/KDPA.xml'),
('KENL', 'IL', 'Centralia Municipal Airport', 38.520000, -89.080000, 'http://weather.noaa.gov/weather/current/KENL.html', 'http://weather.gov/data/current_obs/KENL.rss', 'http://weather.gov/data/current_obs/KENL.xml'),
('KFEP', 'IL', 'Albertus Airport', 42.250000, -89.580000, 'http://weather.noaa.gov/weather/current/KFEP.html', 'http://weather.gov/data/current_obs/KFEP.rss', 'http://weather.gov/data/current_obs/KFEP.xml'),
('KFOA', 'IL', 'Flora Municipal Airport', 38.670000, -88.450000, 'http://weather.noaa.gov/weather/current/KFOA.html', 'http://weather.gov/data/current_obs/KFOA.rss', 'http://weather.gov/data/current_obs/KFOA.xml'),
('KFWC', 'IL', 'Fairfield Municipal Airport', 38.380000, -88.420000, 'http://weather.noaa.gov/weather/current/KFWC.html', 'http://weather.gov/data/current_obs/KFWC.rss', 'http://weather.gov/data/current_obs/KFWC.xml'),
('KGBG', 'IL', 'Galesburg Municipal Airport', 40.940000, -90.430000, 'http://weather.noaa.gov/weather/current/KGBG.html', 'http://weather.gov/data/current_obs/KGBG.rss', 'http://weather.gov/data/current_obs/KGBG.xml'),
('KHSB', 'IL', 'Harrisburg-Raleigh Airport', 37.820000, -88.550000, 'http://weather.noaa.gov/weather/current/KHSB.html', 'http://weather.gov/data/current_obs/KHSB.rss', 'http://weather.gov/data/current_obs/KHSB.xml'),
('KIGQ', 'IL', 'Lansing Municipal Airport', 41.530000, -87.530000, 'http://weather.noaa.gov/weather/current/KIGQ.html', 'http://weather.gov/data/current_obs/KIGQ.rss', 'http://weather.gov/data/current_obs/KIGQ.xml'),
('KIJX', 'IL', 'Jacksonville Municipal Airport', 39.780000, -90.230000, 'http://weather.noaa.gov/weather/current/KIJX.html', 'http://weather.gov/data/current_obs/KIJX.rss', 'http://weather.gov/data/current_obs/KIJX.xml'),
('KIKK', 'IL', 'Greater Kankakee Airport', 41.070000, -87.850000, 'http://weather.noaa.gov/weather/current/KIKK.html', 'http://weather.gov/data/current_obs/KIKK.rss', 'http://weather.gov/data/current_obs/KIKK.xml'),
('KJOT', 'IL', 'Joliet Park district', 41.520000, -88.180000, 'http://weather.noaa.gov/weather/current/KJOT.html', 'http://weather.gov/data/current_obs/KJOT.rss', 'http://weather.gov/data/current_obs/KJOT.xml'),
('KLOT', 'IL', 'Chicago/Romeoville, Lewis University Airport', 41.610000, -88.100000, 'http://weather.noaa.gov/weather/current/KLOT.html', 'http://weather.gov/data/current_obs/KLOT.rss', 'http://weather.gov/data/current_obs/KLOT.xml'),
('KLWV', 'IL', 'Lawrenceville-Vincennes Intl Airport', 38.760000, -87.600000, 'http://weather.noaa.gov/weather/current/KLWV.html', 'http://weather.gov/data/current_obs/KLWV.rss', 'http://weather.gov/data/current_obs/KLWV.xml'),
('KM30', 'IL', 'Metropolis Municipal Airport', 37.183000, -88.750000, 'http://weather.noaa.gov/weather/current/KM30.html', 'http://weather.gov/data/current_obs/KM30.rss', 'http://weather.gov/data/current_obs/KM30.xml'),
('KMDH', 'IL', 'Carbondale/Murphysboro, Southern Illinois Airport', 37.790000, -89.250000, 'http://weather.noaa.gov/weather/current/KMDH.html', 'http://weather.gov/data/current_obs/KMDH.rss', 'http://weather.gov/data/current_obs/KMDH.xml'),
('KMDW', 'IL', 'Chicago Midway Airport', 41.790000, -87.750000, 'http://weather.noaa.gov/weather/current/KMDW.html', 'http://weather.gov/data/current_obs/KMDW.rss', 'http://weather.gov/data/current_obs/KMDW.xml'),
('KMLI', 'IL', 'Moline, Quad-City Airport', 41.460000, -90.520000, 'http://weather.noaa.gov/weather/current/KMLI.html', 'http://weather.gov/data/current_obs/KMLI.rss', 'http://weather.gov/data/current_obs/KMLI.xml'),
('KMQB', 'IL', 'Macomb Muni Airport', 40.520000, -90.650000, 'http://weather.noaa.gov/weather/current/KMQB.html', 'http://weather.gov/data/current_obs/KMQB.rss', 'http://weather.gov/data/current_obs/KMQB.xml'),
('KMTO', 'IL', 'Mattoon/Charleston, Coles County Memorial Airport', 39.480000, -88.280000, 'http://weather.noaa.gov/weather/current/KMTO.html', 'http://weather.gov/data/current_obs/KMTO.rss', 'http://weather.gov/data/current_obs/KMTO.xml'),
('KMVN', 'IL', 'Mount Vernon Automatic Weather Observing/Reporting', 38.330000, -88.870000, 'http://weather.noaa.gov/weather/current/KMVN.html', 'http://weather.gov/data/current_obs/KMVN.rss', 'http://weather.gov/data/current_obs/KMVN.xml'),
('KMWA', 'IL', 'Marion Regional', 37.760000, -89.000000, 'http://weather.noaa.gov/weather/current/KMWA.html', 'http://weather.gov/data/current_obs/KMWA.rss', 'http://weather.gov/data/current_obs/KMWA.xml'),
('KOLY', 'IL', 'Olney-Noble Airport', 38.730000, -88.180000, 'http://weather.noaa.gov/weather/current/KOLY.html', 'http://weather.gov/data/current_obs/KOLY.rss', 'http://weather.gov/data/current_obs/KOLY.xml'),
('KORD', 'IL', 'Chicago/Ohare', 41.980000, -87.900000, 'http://weather.noaa.gov/weather/current/KORD.html', 'http://weather.gov/data/current_obs/KORD.rss', 'http://weather.gov/data/current_obs/KORD.xml'),
('KPIA', 'IL', 'Greater Peoria Regional Airport', 40.660000, -89.680000, 'http://weather.noaa.gov/weather/current/KPIA.html', 'http://weather.gov/data/current_obs/KPIA.rss', 'http://weather.gov/data/current_obs/KPIA.xml'),
('KPNT', 'IL', 'Pontiac Municipal Airport', 40.920000, -88.630000, 'http://weather.noaa.gov/weather/current/KPNT.html', 'http://weather.gov/data/current_obs/KPNT.rss', 'http://weather.gov/data/current_obs/KPNT.xml'),
('KPPQ', 'IL', 'Pittsfield Penstone Municipal Airport', 39.630000, -90.780000, 'http://weather.noaa.gov/weather/current/KPPQ.html', 'http://weather.gov/data/current_obs/KPPQ.rss', 'http://weather.gov/data/current_obs/KPPQ.xml'),
('KPRG', 'IL', 'Edgar County Airport', 39.700000, -87.670000, 'http://weather.noaa.gov/weather/current/KPRG.html', 'http://weather.gov/data/current_obs/KPRG.rss', 'http://weather.gov/data/current_obs/KPRG.xml'),
('KPWK', 'IL', 'Chicago / Wheeling, Pal-Waukee Airport', 42.110000, -87.900000, 'http://weather.noaa.gov/weather/current/KPWK.html', 'http://weather.gov/data/current_obs/KPWK.rss', 'http://weather.gov/data/current_obs/KPWK.xml'),
('KRFD', 'IL', 'Chicago Rockford International Airport', 42.210000, -89.100000, 'http://weather.noaa.gov/weather/current/KRFD.html', 'http://weather.gov/data/current_obs/KRFD.rss', 'http://weather.gov/data/current_obs/KRFD.xml'),
('KRPJ', 'IL', 'Rochelle Muni-Koritz Field Airport', 41.890000, -89.080000, 'http://weather.noaa.gov/weather/current/KRPJ.html', 'http://weather.gov/data/current_obs/KRPJ.rss', 'http://weather.gov/data/current_obs/KRPJ.xml'),
('KRSV', 'IL', 'Robinson Municipal Airport', 39.016000, -87.650000, 'http://weather.noaa.gov/weather/current/KRSV.html', 'http://weather.gov/data/current_obs/KRSV.rss', 'http://weather.gov/data/current_obs/KRSV.xml'),
('KSAR', 'IL', 'Sparta Community-Hunter Field Airport', 38.150000, -89.700000, 'http://weather.noaa.gov/weather/current/KSAR.html', 'http://weather.gov/data/current_obs/KSAR.rss', 'http://weather.gov/data/current_obs/KSAR.xml'),
('KSFY', 'IL', 'Tri-Township Airport', 42.050000, -90.100000, 'http://weather.noaa.gov/weather/current/KSFY.html', 'http://weather.gov/data/current_obs/KSFY.rss', 'http://weather.gov/data/current_obs/KSFY.xml'),
('KSLO', 'IL', 'Salem-Leckrone', 38.650000, -88.970000, 'http://weather.noaa.gov/weather/current/KSLO.html', 'http://weather.gov/data/current_obs/KSLO.rss', 'http://weather.gov/data/current_obs/KSLO.xml'),
('KSPI', 'IL', 'Springfield, Capital Airport', 39.860000, -89.670000, 'http://weather.noaa.gov/weather/current/KSPI.html', 'http://weather.gov/data/current_obs/KSPI.rss', 'http://weather.gov/data/current_obs/KSPI.xml'),
('KSQI', 'IL', 'Sterling Rockfalls', 41.750000, -89.670000, 'http://weather.noaa.gov/weather/current/KSQI.html', 'http://weather.gov/data/current_obs/KSQI.rss', 'http://weather.gov/data/current_obs/KSQI.xml'),
('KTAZ', 'IL', 'Taylorville Municipal Airport', 39.530000, -89.330000, 'http://weather.noaa.gov/weather/current/KTAZ.html', 'http://weather.gov/data/current_obs/KTAZ.rss', 'http://weather.gov/data/current_obs/KTAZ.xml'),
('KTIP', 'IL', 'Rantoul Natl Avn Cntr-Frank Elliot Field Airport', 40.290000, -88.140000, 'http://weather.noaa.gov/weather/current/KTIP.html', 'http://weather.gov/data/current_obs/KTIP.rss', 'http://weather.gov/data/current_obs/KTIP.xml'),
('KUGN', 'IL', 'Chicago / Waukegan, Waukegan Regional Airport', 42.420000, -87.870000, 'http://weather.noaa.gov/weather/current/KUGN.html', 'http://weather.gov/data/current_obs/KUGN.rss', 'http://weather.gov/data/current_obs/KUGN.xml');

INSERT INTO `#__zweather_stations` (`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES
('KUIN', 'IL', 'Quincy Regional-Baldwin Field Airport', 39.940000, -91.200000, 'http://weather.noaa.gov/weather/current/KUIN.html', 'http://weather.gov/data/current_obs/KUIN.rss', 'http://weather.gov/data/current_obs/KUIN.xml'),
('KVYS', 'IL', 'Illinois Valley Rgnl-Walter A Duncan Field Airport', 41.350000, -89.150000, 'http://weather.noaa.gov/weather/current/KVYS.html', 'http://weather.gov/data/current_obs/KVYS.rss', 'http://weather.gov/data/current_obs/KVYS.xml'),
('KEVV', 'IN', 'Evansville Regional Airport', 38.050000, -87.530000, 'http://weather.noaa.gov/weather/current/KEVV.html', 'http://weather.gov/data/current_obs/KEVV.rss', 'http://weather.gov/data/current_obs/KEVV.xml'),
('KGYY', 'IN', 'Gary Regional', 41.620000, -87.420000, 'http://weather.noaa.gov/weather/current/KGYY.html', 'http://weather.gov/data/current_obs/KGYY.rss', 'http://weather.gov/data/current_obs/KGYY.xml'),
('KHNB', 'IN', 'Huntingburg', 38.260000, -86.950000, 'http://weather.noaa.gov/weather/current/KHNB.html', 'http://weather.gov/data/current_obs/KHNB.rss', 'http://weather.gov/data/current_obs/KHNB.xml'),
('KVPZ', 'IN', 'Valparaiso, Porter County Municipal Airport', 41.450000, -87.010000, 'http://weather.noaa.gov/weather/current/KVPZ.html', 'http://weather.gov/data/current_obs/KVPZ.rss', 'http://weather.gov/data/current_obs/KVPZ.xml'),
('KAID', 'IN', 'Anderson Municipal', 40.120000, -85.620000, 'http://weather.noaa.gov/weather/current/KAID.html', 'http://weather.gov/data/current_obs/KAID.rss', 'http://weather.gov/data/current_obs/KAID.xml'),
('KASW', 'IN', 'Warsaw Municipal Airport', 41.275000, -85.840000, 'http://weather.noaa.gov/weather/current/KASW.html', 'http://weather.gov/data/current_obs/KASW.rss', 'http://weather.gov/data/current_obs/KASW.xml'),
('KBAK', 'IN', 'Columbus / Bakalar', 39.260000, -85.880000, 'http://weather.noaa.gov/weather/current/KBAK.html', 'http://weather.gov/data/current_obs/KBAK.rss', 'http://weather.gov/data/current_obs/KBAK.xml'),
('KBMG', 'IN', 'Bloomington, Monroe County Airport', 39.140000, -86.620000, 'http://weather.noaa.gov/weather/current/KBMG.html', 'http://weather.gov/data/current_obs/KBMG.rss', 'http://weather.gov/data/current_obs/KBMG.xml'),
('KEKM', 'IN', 'Elkhart Municipal', 41.730000, -86.000000, 'http://weather.noaa.gov/weather/current/KEKM.html', 'http://weather.gov/data/current_obs/KEKM.rss', 'http://weather.gov/data/current_obs/KEKM.xml'),
('KEYE', 'IN', 'Indianapolis, Eagle Creek Airpark', 39.825000, -86.296000, 'http://weather.noaa.gov/weather/current/KEYE.html', 'http://weather.gov/data/current_obs/KEYE.rss', 'http://weather.gov/data/current_obs/KEYE.xml'),
('KFWA', 'IN', 'Fort Wayne International Airport', 41.010000, -85.200000, 'http://weather.noaa.gov/weather/current/KFWA.html', 'http://weather.gov/data/current_obs/KFWA.rss', 'http://weather.gov/data/current_obs/KFWA.xml'),
('KGEZ', 'IN', 'Shelbyville Municipal Airport', 39.596000, -85.800000, 'http://weather.noaa.gov/weather/current/KGEZ.html', 'http://weather.gov/data/current_obs/KGEZ.rss', 'http://weather.gov/data/current_obs/KGEZ.xml'),
('KGSH', 'IN', 'Goshen Municipal Airport', 41.530000, -85.790000, 'http://weather.noaa.gov/weather/current/KGSH.html', 'http://weather.gov/data/current_obs/KGSH.rss', 'http://weather.gov/data/current_obs/KGSH.xml'),
('KGUS', 'IN', 'Grissom Air Force Base / Peru', 40.650000, -86.150000, 'http://weather.noaa.gov/weather/current/KGUS.html', 'http://weather.gov/data/current_obs/KGUS.rss', 'http://weather.gov/data/current_obs/KGUS.xml'),
('KHUF', 'IN', 'Terre Haute International Airport', 39.460000, -87.300000, 'http://weather.noaa.gov/weather/current/KHUF.html', 'http://weather.gov/data/current_obs/KHUF.rss', 'http://weather.gov/data/current_obs/KHUF.xml'),
('KIND', 'IN', 'Indianapolis International Airport', 39.730000, -86.270000, 'http://weather.noaa.gov/weather/current/KIND.html', 'http://weather.gov/data/current_obs/KIND.rss', 'http://weather.gov/data/current_obs/KIND.xml'),
('KLAF', 'IN', 'Lafayette, Purdue University Airport', 40.430000, -86.930000, 'http://weather.noaa.gov/weather/current/KLAF.html', 'http://weather.gov/data/current_obs/KLAF.rss', 'http://weather.gov/data/current_obs/KLAF.xml'),
('KMIE', 'IN', 'Muncie, Delaware County-Johnson Field', 40.242000, -85.396000, 'http://weather.noaa.gov/weather/current/KMIE.html', 'http://weather.gov/data/current_obs/KMIE.rss', 'http://weather.gov/data/current_obs/KMIE.xml'),
('KOKK', 'IN', 'Kokomo Muni Airport', 40.530000, -86.060000, 'http://weather.noaa.gov/weather/current/KOKK.html', 'http://weather.gov/data/current_obs/KOKK.rss', 'http://weather.gov/data/current_obs/KOKK.xml'),
('KSBN', 'IN', 'South Bend Regional Airport', 41.710000, -86.320000, 'http://weather.noaa.gov/weather/current/KSBN.html', 'http://weather.gov/data/current_obs/KSBN.rss', 'http://weather.gov/data/current_obs/KSBN.xml'),
('NGTA', 'KB', 'Tarawa', 1.350000, 172.917000, 'http://weather.noaa.gov/weather/current/NGTA.html', 'http://weather.gov/data/current_obs/NGTA.rss', 'http://weather.gov/data/current_obs/NGTA.xml'),
('KAAO', 'KS', 'Wichita Colonel James Jabara Airport', 37.750000, -97.220000, 'http://weather.noaa.gov/weather/current/KAAO.html', 'http://weather.gov/data/current_obs/KAAO.rss', 'http://weather.gov/data/current_obs/KAAO.xml'),
('KCFV', 'KS', 'Coffeyville Municipal Airport', 37.080000, -95.570000, 'http://weather.noaa.gov/weather/current/KCFV.html', 'http://weather.gov/data/current_obs/KCFV.rss', 'http://weather.gov/data/current_obs/KCFV.xml'),
('KCNK', 'KS', 'Concordia, Blosser Municipal Airport', 39.550000, -97.650000, 'http://weather.noaa.gov/weather/current/KCNK.html', 'http://weather.gov/data/current_obs/KCNK.rss', 'http://weather.gov/data/current_obs/KCNK.xml'),
('KCNU', 'KS', 'Chanute Martin Johnson Airport', 37.680000, -95.480000, 'http://weather.noaa.gov/weather/current/KCNU.html', 'http://weather.gov/data/current_obs/KCNU.rss', 'http://weather.gov/data/current_obs/KCNU.xml'),
('KDDC', 'KS', 'Dodge City Regional Airport', 37.780000, -99.970000, 'http://weather.noaa.gov/weather/current/KDDC.html', 'http://weather.gov/data/current_obs/KDDC.rss', 'http://weather.gov/data/current_obs/KDDC.xml'),
('KEHA', 'KS', 'Elkhart Automatic Weather Observing / Reporting', 37.010000, -101.880000, 'http://weather.noaa.gov/weather/current/KEHA.html', 'http://weather.gov/data/current_obs/KEHA.rss', 'http://weather.gov/data/current_obs/KEHA.xml'),
('KEMP', 'KS', 'Emporia Kansas', 38.340000, -96.200000, 'http://weather.noaa.gov/weather/current/KEMP.html', 'http://weather.gov/data/current_obs/KEMP.rss', 'http://weather.gov/data/current_obs/KEMP.xml'),
('KEWK', 'KS', 'Newton Automatic Weather Observing / Reporting Sys', 38.050000, -97.290000, 'http://weather.noaa.gov/weather/current/KEWK.html', 'http://weather.gov/data/current_obs/KEWK.rss', 'http://weather.gov/data/current_obs/KEWK.xml'),
('KFOE', 'KS', 'Topeka, Forbes Field', 38.960000, -95.670000, 'http://weather.noaa.gov/weather/current/KFOE.html', 'http://weather.gov/data/current_obs/KFOE.rss', 'http://weather.gov/data/current_obs/KFOE.xml'),
('KFRI', 'KS', 'Fort Riley', 39.050000, -96.767000, 'http://weather.noaa.gov/weather/current/KFRI.html', 'http://weather.gov/data/current_obs/KFRI.rss', 'http://weather.gov/data/current_obs/KFRI.xml'),
('KGBD', 'KS', 'Great Bend Automatic Weather Observing / Reporting', 38.340000, -98.860000, 'http://weather.noaa.gov/weather/current/KGBD.html', 'http://weather.gov/data/current_obs/KGBD.rss', 'http://weather.gov/data/current_obs/KGBD.xml'),
('KGCK', 'KS', 'Garden City Regional Airport', 37.940000, -100.720000, 'http://weather.noaa.gov/weather/current/KGCK.html', 'http://weather.gov/data/current_obs/KGCK.rss', 'http://weather.gov/data/current_obs/KGCK.xml'),
('KHLC', 'KS', 'Hill City Municipal Airport', 39.390000, -99.830000, 'http://weather.noaa.gov/weather/current/KHLC.html', 'http://weather.gov/data/current_obs/KHLC.rss', 'http://weather.gov/data/current_obs/KHLC.xml'),
('KHUT', 'KS', 'Hutchinson Municipal Airport', 38.080000, -97.870000, 'http://weather.noaa.gov/weather/current/KHUT.html', 'http://weather.gov/data/current_obs/KHUT.rss', 'http://weather.gov/data/current_obs/KHUT.xml'),
('KHYS', 'KS', 'Hays Municipal Automatic Weather Observing/Report', 38.860000, -99.270000, 'http://weather.noaa.gov/weather/current/KHYS.html', 'http://weather.gov/data/current_obs/KHYS.rss', 'http://weather.gov/data/current_obs/KHYS.xml'),
('KIAB', 'KS', 'McConnell Air Force Base', 37.617000, -97.267000, 'http://weather.noaa.gov/weather/current/KIAB.html', 'http://weather.gov/data/current_obs/KIAB.rss', 'http://weather.gov/data/current_obs/KIAB.xml'),
('KICT', 'KS', 'Wichita Mid-Continent Airport', 37.660000, -97.430000, 'http://weather.noaa.gov/weather/current/KICT.html', 'http://weather.gov/data/current_obs/KICT.rss', 'http://weather.gov/data/current_obs/KICT.xml'),
('KIXD', 'KS', 'Olathe, New Century Aircenter', 38.830000, -94.890000, 'http://weather.noaa.gov/weather/current/KIXD.html', 'http://weather.gov/data/current_obs/KIXD.rss', 'http://weather.gov/data/current_obs/KIXD.xml'),
('KLBL', 'KS', 'Liberal Municipal Automatic Weather Observing', 37.050000, -100.970000, 'http://weather.noaa.gov/weather/current/KLBL.html', 'http://weather.gov/data/current_obs/KLBL.rss', 'http://weather.gov/data/current_obs/KLBL.xml'),
('KLWC', 'KS', 'Lawrence Municipal Airport', 39.020000, -95.220000, 'http://weather.noaa.gov/weather/current/KLWC.html', 'http://weather.gov/data/current_obs/KLWC.rss', 'http://weather.gov/data/current_obs/KLWC.xml'),
('KMHK', 'KS', 'Manhattan Municipal Airport', 39.160000, -96.670000, 'http://weather.noaa.gov/weather/current/KMHK.html', 'http://weather.gov/data/current_obs/KMHK.rss', 'http://weather.gov/data/current_obs/KMHK.xml'),
('KOJC', 'KS', 'Olathe, Johnson County Executive Airport', 38.850000, -94.740000, 'http://weather.noaa.gov/weather/current/KOJC.html', 'http://weather.gov/data/current_obs/KOJC.rss', 'http://weather.gov/data/current_obs/KOJC.xml'),
('KP28', 'KS', 'Medicine Lodge', 37.300000, -98.580000, 'http://weather.noaa.gov/weather/current/KP28.html', 'http://weather.gov/data/current_obs/KP28.rss', 'http://weather.gov/data/current_obs/KP28.xml'),
('KPPF', 'KS', 'Parsons, Tri-City Airport', 37.300000, -95.500000, 'http://weather.noaa.gov/weather/current/KPPF.html', 'http://weather.gov/data/current_obs/KPPF.rss', 'http://weather.gov/data/current_obs/KPPF.xml'),
('KPTT', 'KS', 'Pratt Industrial Airport', 37.702000, -98.747000, 'http://weather.noaa.gov/weather/current/KPTT.html', 'http://weather.gov/data/current_obs/KPTT.rss', 'http://weather.gov/data/current_obs/KPTT.xml'),
('KRSL', 'KS', 'Russell Municipal Airport', 38.870000, -98.810000, 'http://weather.noaa.gov/weather/current/KRSL.html', 'http://weather.gov/data/current_obs/KRSL.rss', 'http://weather.gov/data/current_obs/KRSL.xml'),
('KS58', 'KS', 'Foster Field Airport', 28.533000, -90.583000, 'http://weather.noaa.gov/weather/current/KS58.html', 'http://weather.gov/data/current_obs/KS58.rss', 'http://weather.gov/data/current_obs/KS58.xml'),
('KSLN', 'KS', 'Salina Municipal Airport', 38.800000, -97.650000, 'http://weather.noaa.gov/weather/current/KSLN.html', 'http://weather.gov/data/current_obs/KSLN.rss', 'http://weather.gov/data/current_obs/KSLN.xml'),
('KTOP', 'KS', 'Topeka, Philip Billard Municipal Airport', 39.080000, -95.620000, 'http://weather.noaa.gov/weather/current/KTOP.html', 'http://weather.gov/data/current_obs/KTOP.rss', 'http://weather.gov/data/current_obs/KTOP.xml'),
('KUKL', 'KS', 'Coffey County Airport', 38.300000, -95.717000, 'http://weather.noaa.gov/weather/current/KUKL.html', 'http://weather.gov/data/current_obs/KUKL.rss', 'http://weather.gov/data/current_obs/KUKL.xml'),
('KWLD', 'KS', 'Winfield / Arkansas City, Strother Field', 37.160000, -97.030000, 'http://weather.noaa.gov/weather/current/KWLD.html', 'http://weather.gov/data/current_obs/KWLD.rss', 'http://weather.gov/data/current_obs/KWLD.xml'),
('KGLD', 'KS', 'Goodland, Renner Field', 39.380000, -101.700000, 'http://weather.noaa.gov/weather/current/KGLD.html', 'http://weather.gov/data/current_obs/KGLD.rss', 'http://weather.gov/data/current_obs/KGLD.xml'),
('NCRG', 'KU', 'Rarotonga', -21.200000, -159.817000, 'http://weather.noaa.gov/weather/current/NCRG.html', 'http://weather.gov/data/current_obs/NCRG.rss', 'http://weather.gov/data/current_obs/NCRG.xml'),
('NIUE', 'KU', 'Alofi/Niue', -19.067000, -169.917000, 'http://weather.noaa.gov/weather/current/NIUE.html', 'http://weather.gov/data/current_obs/NIUE.rss', 'http://weather.gov/data/current_obs/NIUE.xml'),
('KBWG', 'KY', 'Bowling Green-Warren County Regional Airport', 36.960000, -86.420000, 'http://weather.noaa.gov/weather/current/KBWG.html', 'http://weather.gov/data/current_obs/KBWG.rss', 'http://weather.gov/data/current_obs/KBWG.xml'),
('KEHR', 'KY', 'Henderson City', 37.820000, -87.690000, 'http://weather.noaa.gov/weather/current/KEHR.html', 'http://weather.gov/data/current_obs/KEHR.rss', 'http://weather.gov/data/current_obs/KEHR.xml'),
('KHOP', 'KY', 'Fort Campbell U. S. Army Airfield', 36.669000, -87.496000, 'http://weather.noaa.gov/weather/current/KHOP.html', 'http://weather.gov/data/current_obs/KHOP.rss', 'http://weather.gov/data/current_obs/KHOP.xml'),
('KOWB', 'KY', 'Owensboro / Daviess', 37.760000, -87.170000, 'http://weather.noaa.gov/weather/current/KOWB.html', 'http://weather.gov/data/current_obs/KOWB.rss', 'http://weather.gov/data/current_obs/KOWB.xml'),
('KPAH', 'KY', 'Paducah, Barkley Regional Airport', 37.070000, -88.770000, 'http://weather.noaa.gov/weather/current/KPAH.html', 'http://weather.gov/data/current_obs/KPAH.rss', 'http://weather.gov/data/current_obs/KPAH.xml'),
('K1A6', 'KY', 'Middlesboro-Bell County Airport', 36.611000, -83.737000, 'http://weather.noaa.gov/weather/current/K1A6.html', 'http://weather.gov/data/current_obs/K1A6.rss', 'http://weather.gov/data/current_obs/K1A6.xml'),
('KCVG', 'KY', 'Covington / Cincinnati / Northern Kentucky', 39.050000, -84.670000, 'http://weather.noaa.gov/weather/current/KCVG.html', 'http://weather.gov/data/current_obs/KCVG.rss', 'http://weather.gov/data/current_obs/KCVG.xml'),
('KEKQ', 'KY', 'Wayne County Airport', 36.855000, -84.856000, 'http://weather.noaa.gov/weather/current/KEKQ.html', 'http://weather.gov/data/current_obs/KEKQ.rss', 'http://weather.gov/data/current_obs/KEKQ.xml'),
('KFFT', 'KY', 'Frankfort, Capital City Airport', 38.180000, -84.900000, 'http://weather.noaa.gov/weather/current/KFFT.html', 'http://weather.gov/data/current_obs/KFFT.rss', 'http://weather.gov/data/current_obs/KFFT.xml'),
('KFTK', 'KY', 'Fort Knox', 37.900000, -85.967000, 'http://weather.noaa.gov/weather/current/KFTK.html', 'http://weather.gov/data/current_obs/KFTK.rss', 'http://weather.gov/data/current_obs/KFTK.xml'),
('KGLW', 'KY', 'Glasgow Municipal Airport', 36.963000, -85.946000, 'http://weather.noaa.gov/weather/current/KGLW.html', 'http://weather.gov/data/current_obs/KGLW.rss', 'http://weather.gov/data/current_obs/KGLW.xml'),
('KI16', 'KY', 'Kee Field Airport', 37.600000, -81.559000, 'http://weather.noaa.gov/weather/current/KI16.html', 'http://weather.gov/data/current_obs/KI16.rss', 'http://weather.gov/data/current_obs/KI16.xml'),
('KJKL', 'KY', 'Julian Caroll Airport', 37.580000, -83.320000, 'http://weather.noaa.gov/weather/current/KJKL.html', 'http://weather.gov/data/current_obs/KJKL.rss', 'http://weather.gov/data/current_obs/KJKL.xml'),
('KLEX', 'KY', 'Lexington, Blue Grass Airport', 38.050000, -84.600000, 'http://weather.noaa.gov/weather/current/KLEX.html', 'http://weather.gov/data/current_obs/KLEX.rss', 'http://weather.gov/data/current_obs/KLEX.xml'),
('KLOU', 'KY', 'Louisville, Bowman Field Airport', 38.230000, -85.670000, 'http://weather.noaa.gov/weather/current/KLOU.html', 'http://weather.gov/data/current_obs/KLOU.rss', 'http://weather.gov/data/current_obs/KLOU.xml'),
('KLOZ', 'KY', 'London-Corbin Airport-Magee Field', 37.090000, -84.040000, 'http://weather.noaa.gov/weather/current/KLOZ.html', 'http://weather.gov/data/current_obs/KLOZ.rss', 'http://weather.gov/data/current_obs/KLOZ.xml'),
('KSDF', 'KY', 'Louisville, Standiford Field', 38.190000, -85.730000, 'http://weather.noaa.gov/weather/current/KSDF.html', 'http://weather.gov/data/current_obs/KSDF.rss', 'http://weather.gov/data/current_obs/KSDF.xml'),
('KSME', 'KY', 'Somerset-Pulaski County-J.T. Wilson Field Airport', 37.055000, -84.614000, 'http://weather.noaa.gov/weather/current/KSME.html', 'http://weather.gov/data/current_obs/KSME.rss', 'http://weather.gov/data/current_obs/KSME.xml'),
('KY15', 'KY', 'Brennan Farm Airport', 45.650000, -84.467000, 'http://weather.noaa.gov/weather/current/KY15.html', 'http://weather.gov/data/current_obs/KY15.rss', 'http://weather.gov/data/current_obs/KY15.xml'),
('K1B7', 'LA', 'Boothville Heliport', 29.350000, -89.433000, 'http://weather.noaa.gov/weather/current/K1B7.html', 'http://weather.gov/data/current_obs/K1B7.rss', 'http://weather.gov/data/current_obs/K1B7.xml'),
('K2GL', 'LA', 'Galliano Heliport', 29.417000, -90.300000, 'http://weather.noaa.gov/weather/current/K2GL.html', 'http://weather.gov/data/current_obs/K2GL.rss', 'http://weather.gov/data/current_obs/K2GL.xml'),
('K3B6', 'LA', 'Eugene Island 300', 28.083000, -92.700000, 'http://weather.noaa.gov/weather/current/K3B6.html', 'http://weather.gov/data/current_obs/K3B6.rss', 'http://weather.gov/data/current_obs/K3B6.xml'),
('K7R3', 'LA', 'Amelia / Lake Palourd', 29.700000, -91.100000, 'http://weather.noaa.gov/weather/current/K7R3.html', 'http://weather.gov/data/current_obs/K7R3.rss', 'http://weather.gov/data/current_obs/K7R3.xml'),
('K7R4', 'LA', 'Intracoastal City', 29.783000, -92.133000, 'http://weather.noaa.gov/weather/current/K7R4.html', 'http://weather.gov/data/current_obs/K7R4.rss', 'http://weather.gov/data/current_obs/K7R4.xml'),
('K7R5', 'LA', 'Cameron Heliport', 29.783000, -93.300000, 'http://weather.noaa.gov/weather/current/K7R5.html', 'http://weather.gov/data/current_obs/K7R5.rss', 'http://weather.gov/data/current_obs/K7R5.xml'),
('K7R8', 'LA', 'South Marsh Island', 28.300000, -91.983000, 'http://weather.noaa.gov/weather/current/K7R8.html', 'http://weather.gov/data/current_obs/K7R8.rss', 'http://weather.gov/data/current_obs/K7R8.xml'),
('KAEX', 'LA', 'Alexandria International Airport', 31.330000, -92.550000, 'http://weather.noaa.gov/weather/current/KAEX.html', 'http://weather.gov/data/current_obs/KAEX.rss', 'http://weather.gov/data/current_obs/KAEX.xml'),
('KAQV', 'LA', 'Ft. Polk/Peason Ridge', 31.400000, -93.283000, 'http://weather.noaa.gov/weather/current/KAQV.html', 'http://weather.gov/data/current_obs/KAQV.rss', 'http://weather.gov/data/current_obs/KAQV.xml'),
('KARA', 'LA', 'New Iberia, Acadiana Regional Airport', 30.030000, -91.880000, 'http://weather.noaa.gov/weather/current/KARA.html', 'http://weather.gov/data/current_obs/KARA.rss', 'http://weather.gov/data/current_obs/KARA.xml'),
('KASD', 'LA', 'Slidell Airport', 30.350000, -89.820000, 'http://weather.noaa.gov/weather/current/KASD.html', 'http://weather.gov/data/current_obs/KASD.rss', 'http://weather.gov/data/current_obs/KASD.xml'),
('KBAD', 'LA', 'Barksdale Air Force Base', 32.500000, -93.683000, 'http://weather.noaa.gov/weather/current/KBAD.html', 'http://weather.gov/data/current_obs/KBAD.rss', 'http://weather.gov/data/current_obs/KBAD.xml'),
('KBKB', 'LA', 'Ft. Polk/Fullerton Landing', 31.000000, -92.967000, 'http://weather.noaa.gov/weather/current/KBKB.html', 'http://weather.gov/data/current_obs/KBKB.rss', 'http://weather.gov/data/current_obs/KBKB.xml'),
('KBTR', 'LA', 'Baton Rouge Metropolitan, Ryan Field', 30.540000, -91.150000, 'http://weather.noaa.gov/weather/current/KBTR.html', 'http://weather.gov/data/current_obs/KBTR.rss', 'http://weather.gov/data/current_obs/KBTR.xml'),
('KBVE', 'LA', 'Boothville', 29.333000, -89.400000, 'http://weather.noaa.gov/weather/current/KBVE.html', 'http://weather.gov/data/current_obs/KBVE.rss', 'http://weather.gov/data/current_obs/KBVE.xml'),
('KCWF', 'LA', 'Chenault Airpark', 30.220000, -93.150000, 'http://weather.noaa.gov/weather/current/KCWF.html', 'http://weather.gov/data/current_obs/KCWF.rss', 'http://weather.gov/data/current_obs/KCWF.xml'),
('KDNK', 'LA', 'Ft. Polk/Self Strip', 31.100000, -93.000000, 'http://weather.noaa.gov/weather/current/KDNK.html', 'http://weather.gov/data/current_obs/KDNK.rss', 'http://weather.gov/data/current_obs/KDNK.xml'),
('KDRI', 'LA', 'Beauregard Regional Airport', 30.833000, -93.333000, 'http://weather.noaa.gov/weather/current/KDRI.html', 'http://weather.gov/data/current_obs/KDRI.rss', 'http://weather.gov/data/current_obs/KDRI.xml'),
('KDTN', 'LA', 'Shreveport Downtown Airport', 32.530000, -93.750000, 'http://weather.noaa.gov/weather/current/KDTN.html', 'http://weather.gov/data/current_obs/KDTN.rss', 'http://weather.gov/data/current_obs/KDTN.xml'),
('KE12', 'LA', 'East Cameron 345', 28.083000, -92.700000, 'http://weather.noaa.gov/weather/current/KE12.html', 'http://weather.gov/data/current_obs/KE12.rss', 'http://weather.gov/data/current_obs/KE12.xml'),
('KESF', 'LA', 'Alexandria Esler Regional Airport', 31.400000, -92.300000, 'http://weather.noaa.gov/weather/current/KESF.html', 'http://weather.gov/data/current_obs/KESF.rss', 'http://weather.gov/data/current_obs/KESF.xml'),
('KGSM', 'LA', 'Ship Shoal 207A', 28.533000, -90.983000, 'http://weather.noaa.gov/weather/current/KGSM.html', 'http://weather.gov/data/current_obs/KGSM.rss', 'http://weather.gov/data/current_obs/KGSM.xml'),
('KH08', 'LA', 'High Island 264C', 28.467000, -93.733000, 'http://weather.noaa.gov/weather/current/KH08.html', 'http://weather.gov/data/current_obs/KH08.rss', 'http://weather.gov/data/current_obs/KH08.xml'),
('KHDC', 'LA', 'Hammond Municipal Airport', 30.520000, -90.420000, 'http://weather.noaa.gov/weather/current/KHDC.html', 'http://weather.gov/data/current_obs/KHDC.rss', 'http://weather.gov/data/current_obs/KHDC.xml'),
('KHUM', 'LA', 'Houma-Terrebonne', 29.570000, -90.670000, 'http://weather.noaa.gov/weather/current/KHUM.html', 'http://weather.gov/data/current_obs/KHUM.rss', 'http://weather.gov/data/current_obs/KHUM.xml'),
('KIER', 'LA', 'Natchitoches Regional Airport', 31.733000, -93.100000, 'http://weather.noaa.gov/weather/current/KIER.html', 'http://weather.gov/data/current_obs/KIER.rss', 'http://weather.gov/data/current_obs/KIER.xml'),
('KLCH', 'LA', 'Lake Charles Regional Airport', 30.120000, -93.220000, 'http://weather.noaa.gov/weather/current/KLCH.html', 'http://weather.gov/data/current_obs/KLCH.rss', 'http://weather.gov/data/current_obs/KLCH.xml'),
('KLFT', 'LA', 'Lafayette Regional Airport', 30.200000, -92.000000, 'http://weather.noaa.gov/weather/current/KLFT.html', 'http://weather.gov/data/current_obs/KLFT.rss', 'http://weather.gov/data/current_obs/KLFT.xml'),
('KMLU', 'LA', 'Monroe Regional Airport', 32.510000, -92.040000, 'http://weather.noaa.gov/weather/current/KMLU.html', 'http://weather.gov/data/current_obs/KMLU.rss', 'http://weather.gov/data/current_obs/KMLU.xml'),
('KMSY', 'LA', 'New Orleans International Airport', 29.980000, -90.250000, 'http://weather.noaa.gov/weather/current/KMSY.html', 'http://weather.gov/data/current_obs/KMSY.rss', 'http://weather.gov/data/current_obs/KMSY.xml'),
('KNBG', 'LA', 'New Orleans, Naval Air Station', 29.833000, -90.017000, 'http://weather.noaa.gov/weather/current/KNBG.html', 'http://weather.gov/data/current_obs/KNBG.rss', 'http://weather.gov/data/current_obs/KNBG.xml'),
('KNEW', 'LA', 'New Orleans Lakefront Airport', 30.040000, -90.030000, 'http://weather.noaa.gov/weather/current/KNEW.html', 'http://weather.gov/data/current_obs/KNEW.rss', 'http://weather.gov/data/current_obs/KNEW.xml'),
('KP92', 'LA', 'Salt Point', 29.600000, -91.300000, 'http://weather.noaa.gov/weather/current/KP92.html', 'http://weather.gov/data/current_obs/KP92.rss', 'http://weather.gov/data/current_obs/KP92.xml'),
('KPOE', 'LA', 'Fort Polk', 31.050000, -93.183000, 'http://weather.noaa.gov/weather/current/KPOE.html', 'http://weather.gov/data/current_obs/KPOE.rss', 'http://weather.gov/data/current_obs/KPOE.xml'),
('KPTN', 'LA', 'Patterson Memorial', 29.720000, -91.330000, 'http://weather.noaa.gov/weather/current/KPTN.html', 'http://weather.gov/data/current_obs/KPTN.rss', 'http://weather.gov/data/current_obs/KPTN.xml'),
('KSHV', 'LA', 'Shreveport Regional Airport', 32.450000, -93.830000, 'http://weather.noaa.gov/weather/current/KSHV.html', 'http://weather.gov/data/current_obs/KSHV.rss', 'http://weather.gov/data/current_obs/KSHV.xml'),
('KSRN', 'LA', 'South Marsh 268A', 29.117000, -91.867000, 'http://weather.noaa.gov/weather/current/KSRN.html', 'http://weather.gov/data/current_obs/KSRN.rss', 'http://weather.gov/data/current_obs/KSRN.xml'),
('KTVR', 'LA', 'Vicksburg / Tallulah Regional Airport', 32.350000, -91.030000, 'http://weather.noaa.gov/weather/current/KTVR.html', 'http://weather.gov/data/current_obs/KTVR.rss', 'http://weather.gov/data/current_obs/KTVR.xml'),
('KW60', 'LA', 'West Cameron 560', 29.150000, -93.350000, 'http://weather.noaa.gov/weather/current/KW60.html', 'http://weather.gov/data/current_obs/KW60.rss', 'http://weather.gov/data/current_obs/KW60.xml'),
('KXCN', 'LA', 'Green Canyon 184', 27.767000, -91.517000, 'http://weather.noaa.gov/weather/current/KXCN.html', 'http://weather.gov/data/current_obs/KXCN.rss', 'http://weather.gov/data/current_obs/KXCN.xml'),
('TLPC', 'LC', 'Vigie', 14.017000, -61.000000, 'http://weather.noaa.gov/weather/current/TLPC.html', 'http://weather.gov/data/current_obs/TLPC.rss', 'http://weather.gov/data/current_obs/TLPC.xml'),
('TLPL', 'LC', 'Hewanorra Intl Airport', 13.750000, -60.950000, 'http://weather.noaa.gov/weather/current/TLPL.html', 'http://weather.gov/data/current_obs/TLPL.rss', 'http://weather.gov/data/current_obs/TLPL.xml'),
('KACK', 'MA', 'Nantucket Memorial Airport', 41.260000, -70.070000, 'http://weather.noaa.gov/weather/current/KACK.html', 'http://weather.gov/data/current_obs/KACK.rss', 'http://weather.gov/data/current_obs/KACK.xml'),
('KAQW', 'MA', 'North Adams, Harriman-And-West Airport', 42.710000, -73.170000, 'http://weather.noaa.gov/weather/current/KAQW.html', 'http://weather.gov/data/current_obs/KAQW.rss', 'http://weather.gov/data/current_obs/KAQW.xml'),
('KBAF', 'MA', 'Westfield, Barnes Municipal Airport', 42.160000, -72.720000, 'http://weather.noaa.gov/weather/current/KBAF.html', 'http://weather.gov/data/current_obs/KBAF.rss', 'http://weather.gov/data/current_obs/KBAF.xml'),
('KBED', 'MA', 'Bedford, Hanscom Field', 42.470000, -71.290000, 'http://weather.noaa.gov/weather/current/KBED.html', 'http://weather.gov/data/current_obs/KBED.rss', 'http://weather.gov/data/current_obs/KBED.xml'),
('KBOS', 'MA', 'Boston, Logan International Airport', 42.380000, -71.030000, 'http://weather.noaa.gov/weather/current/KBOS.html', 'http://weather.gov/data/current_obs/KBOS.rss', 'http://weather.gov/data/current_obs/KBOS.xml'),
('KBVY', 'MA', 'Beverly Municipal Airport', 42.590000, -70.920000, 'http://weather.noaa.gov/weather/current/KBVY.html', 'http://weather.gov/data/current_obs/KBVY.rss', 'http://weather.gov/data/current_obs/KBVY.xml'),
('KCEF', 'MA', 'Chicopee Falls / Westover Air Force Base', 42.210000, -72.530000, 'http://weather.noaa.gov/weather/current/KCEF.html', 'http://weather.gov/data/current_obs/KCEF.rss', 'http://weather.gov/data/current_obs/KCEF.xml'),
('KCHH', 'MA', 'Chatham', 41.667000, -69.967000, 'http://weather.noaa.gov/weather/current/KCHH.html', 'http://weather.gov/data/current_obs/KCHH.rss', 'http://weather.gov/data/current_obs/KCHH.xml'),
('KCQX', 'MA', 'Chatham Municipal Airport', 41.700000, -69.990000, 'http://weather.noaa.gov/weather/current/KCQX.html', 'http://weather.gov/data/current_obs/KCQX.rss', 'http://weather.gov/data/current_obs/KCQX.xml'),
('KEWB', 'MA', 'New Bedford Regional Airport', 41.690000, -70.970000, 'http://weather.noaa.gov/weather/current/KEWB.html', 'http://weather.gov/data/current_obs/KEWB.rss', 'http://weather.gov/data/current_obs/KEWB.xml'),
('KFIT', 'MA', 'Fitchburg Municipal Airport', 42.550000, -71.760000, 'http://weather.noaa.gov/weather/current/KFIT.html', 'http://weather.gov/data/current_obs/KFIT.rss', 'http://weather.gov/data/current_obs/KFIT.xml'),
('KFMH', 'MA', 'Otis Air National Guard Base', 41.660000, -70.520000, 'http://weather.noaa.gov/weather/current/KFMH.html', 'http://weather.gov/data/current_obs/KFMH.rss', 'http://weather.gov/data/current_obs/KFMH.xml'),
('KHYA', 'MA', 'Hyannis, Barnstable Municipal-Boardman Airport', 41.680000, -70.280000, 'http://weather.noaa.gov/weather/current/KHYA.html', 'http://weather.gov/data/current_obs/KHYA.rss', 'http://weather.gov/data/current_obs/KHYA.xml'),
('KLWM', 'MA', 'Lawrence Municipal Airport', 42.730000, -71.120000, 'http://weather.noaa.gov/weather/current/KLWM.html', 'http://weather.gov/data/current_obs/KLWM.rss', 'http://weather.gov/data/current_obs/KLWM.xml'),
('KMQE', 'MA', 'East Milton', 42.210000, -71.110000, 'http://weather.noaa.gov/weather/current/KMQE.html', 'http://weather.gov/data/current_obs/KMQE.rss', 'http://weather.gov/data/current_obs/KMQE.xml'),
('KMVY', 'MA', 'Marthas Vineyard Airport', 41.410000, -70.620000, 'http://weather.noaa.gov/weather/current/KMVY.html', 'http://weather.gov/data/current_obs/KMVY.rss', 'http://weather.gov/data/current_obs/KMVY.xml'),
('KORE', 'MA', 'Orange Municipal Airport', 42.580000, -72.280000, 'http://weather.noaa.gov/weather/current/KORE.html', 'http://weather.gov/data/current_obs/KORE.rss', 'http://weather.gov/data/current_obs/KORE.xml'),
('KORH', 'MA', 'Worcester Regional Airport', 42.280000, -71.870000, 'http://weather.noaa.gov/weather/current/KORH.html', 'http://weather.gov/data/current_obs/KORH.rss', 'http://weather.gov/data/current_obs/KORH.xml'),
('KOWD', 'MA', 'Norwood Memorial Airport', 42.190000, -71.170000, 'http://weather.noaa.gov/weather/current/KOWD.html', 'http://weather.gov/data/current_obs/KOWD.rss', 'http://weather.gov/data/current_obs/KOWD.xml'),
('KPSF', 'MA', 'Pittsfield Municipal Airport', 42.430000, -73.290000, 'http://weather.noaa.gov/weather/current/KPSF.html', 'http://weather.gov/data/current_obs/KPSF.rss', 'http://weather.gov/data/current_obs/KPSF.xml'),
('KPVC', 'MA', 'Provincetown Automatic Weather Observing/Reporting', 42.010000, -70.200000, 'http://weather.noaa.gov/weather/current/KPVC.html', 'http://weather.gov/data/current_obs/KPVC.rss', 'http://weather.gov/data/current_obs/KPVC.xml'),
('KPYM', 'MA', 'Plymouth Municipal Airport', 41.910000, -70.730000, 'http://weather.noaa.gov/weather/current/KPYM.html', 'http://weather.gov/data/current_obs/KPYM.rss', 'http://weather.gov/data/current_obs/KPYM.xml'),
('KTAN', 'MA', 'Taunton', 41.890000, -71.020000, 'http://weather.noaa.gov/weather/current/KTAN.html', 'http://weather.gov/data/current_obs/KTAN.rss', 'http://weather.gov/data/current_obs/KTAN.xml'),
('KADW', 'MD', 'Camp Springs / Andrews Air Force Base', 38.830000, -76.870000, 'http://weather.noaa.gov/weather/current/KADW.html', 'http://weather.gov/data/current_obs/KADW.rss', 'http://weather.gov/data/current_obs/KADW.xml'),
('KAPG', 'MD', 'Phillips Army Air Field / Aberdeen', 39.470000, -76.170000, 'http://weather.noaa.gov/weather/current/KAPG.html', 'http://weather.gov/data/current_obs/KAPG.rss', 'http://weather.gov/data/current_obs/KAPG.xml'),
('KBWI', 'MD', 'Baltimore-Washington International Airport', 39.190000, -76.670000, 'http://weather.noaa.gov/weather/current/KBWI.html', 'http://weather.gov/data/current_obs/KBWI.rss', 'http://weather.gov/data/current_obs/KBWI.xml'),
('KCBE', 'MD', 'Greater Cumberland Regional Airport', 39.617000, -78.767000, 'http://weather.noaa.gov/weather/current/KCBE.html', 'http://weather.gov/data/current_obs/KCBE.rss', 'http://weather.gov/data/current_obs/KCBE.xml'),
('KDMH', 'MD', 'Baltimore, Inner Harbor', 39.280000, -76.610000, 'http://weather.noaa.gov/weather/current/KDMH.html', 'http://weather.gov/data/current_obs/KDMH.rss', 'http://weather.gov/data/current_obs/KDMH.xml'),
('KESN', 'MD', 'Easton/Newman Field Airport', 38.800000, -76.067000, 'http://weather.noaa.gov/weather/current/KESN.html', 'http://weather.gov/data/current_obs/KESN.rss', 'http://weather.gov/data/current_obs/KESN.xml'),
('KFDK', 'MD', 'Frederick Municipal Airport', 39.418000, -77.374000, 'http://weather.noaa.gov/weather/current/KFDK.html', 'http://weather.gov/data/current_obs/KFDK.rss', 'http://weather.gov/data/current_obs/KFDK.xml'),
('KFME', 'MD', 'Ft Meade/Tipton', 39.083000, -76.767000, 'http://weather.noaa.gov/weather/current/KFME.html', 'http://weather.gov/data/current_obs/KFME.rss', 'http://weather.gov/data/current_obs/KFME.xml'),
('KHGR', 'MD', 'Hagerstown, Washington County Regional Airport', 39.710000, -77.730000, 'http://weather.noaa.gov/weather/current/KHGR.html', 'http://weather.gov/data/current_obs/KHGR.rss', 'http://weather.gov/data/current_obs/KHGR.xml'),
('KMTN', 'MD', 'Baltimore / Martin', 39.340000, -76.420000, 'http://weather.noaa.gov/weather/current/KMTN.html', 'http://weather.gov/data/current_obs/KMTN.rss', 'http://weather.gov/data/current_obs/KMTN.xml'),
('KNAK', 'MD', 'Annapolis (U.S. Naval Academy)', 38.980000, -76.480000, 'http://weather.noaa.gov/weather/current/KNAK.html', 'http://weather.gov/data/current_obs/KNAK.rss', 'http://weather.gov/data/current_obs/KNAK.xml'),
('KNHK', 'MD', 'Patuxent River, Naval Air Station', 38.290000, -76.400000, 'http://weather.noaa.gov/weather/current/KNHK.html', 'http://weather.gov/data/current_obs/KNHK.rss', 'http://weather.gov/data/current_obs/KNHK.xml'),
('KOXB', 'MD', 'Ocean City Municipal Airport', 38.308000, -75.124000, 'http://weather.noaa.gov/weather/current/KOXB.html', 'http://weather.gov/data/current_obs/KOXB.rss', 'http://weather.gov/data/current_obs/KOXB.xml'),
('KSBY', 'MD', 'Salisbury-Wicomico County Regional Airport', 38.340000, -75.500000, 'http://weather.noaa.gov/weather/current/KSBY.html', 'http://weather.gov/data/current_obs/KSBY.rss', 'http://weather.gov/data/current_obs/KSBY.xml'),
('K40B', 'ME', 'Clayton Lake', 46.617000, -69.533000, 'http://weather.noaa.gov/weather/current/K40B.html', 'http://weather.gov/data/current_obs/K40B.rss', 'http://weather.gov/data/current_obs/K40B.xml'),
('KAUG', 'ME', 'Augusta State Airport', 44.320000, -69.800000, 'http://weather.noaa.gov/weather/current/KAUG.html', 'http://weather.gov/data/current_obs/KAUG.rss', 'http://weather.gov/data/current_obs/KAUG.xml'),
('KBGR', 'ME', 'Bangor International Airport', 44.810000, -68.830000, 'http://weather.noaa.gov/weather/current/KBGR.html', 'http://weather.gov/data/current_obs/KBGR.rss', 'http://weather.gov/data/current_obs/KBGR.xml'),
('KBHB', 'ME', 'Bar Harbor Automatic Weather Observing / Reporting', 44.460000, -68.370000, 'http://weather.noaa.gov/weather/current/KBHB.html', 'http://weather.gov/data/current_obs/KBHB.rss', 'http://weather.gov/data/current_obs/KBHB.xml'),
('KCAR', 'ME', 'Caribou Municipal Airport', 46.880000, -68.020000, 'http://weather.noaa.gov/weather/current/KCAR.html', 'http://weather.gov/data/current_obs/KCAR.rss', 'http://weather.gov/data/current_obs/KCAR.xml'),
('KFVE', 'ME', 'Frenchville, Northern Aroostook Regional Airport', 47.290000, -68.320000, 'http://weather.noaa.gov/weather/current/KFVE.html', 'http://weather.gov/data/current_obs/KFVE.rss', 'http://weather.gov/data/current_obs/KFVE.xml'),
('KGNR', 'ME', 'Greenville', 45.462000, -69.595000, 'http://weather.noaa.gov/weather/current/KGNR.html', 'http://weather.gov/data/current_obs/KGNR.rss', 'http://weather.gov/data/current_obs/KGNR.xml'),
('KHUL', 'ME', 'Houlton International Airport', 46.140000, -67.780000, 'http://weather.noaa.gov/weather/current/KHUL.html', 'http://weather.gov/data/current_obs/KHUL.rss', 'http://weather.gov/data/current_obs/KHUL.xml'),
('KIWI', 'ME', 'Wiscasset Airport', 43.950000, -69.700000, 'http://weather.noaa.gov/weather/current/KIWI.html', 'http://weather.gov/data/current_obs/KIWI.rss', 'http://weather.gov/data/current_obs/KIWI.xml'),
('KIZG', 'ME', 'Fryeburg, Eastern Slopes Regional Airport', 43.980000, -70.950000, 'http://weather.noaa.gov/weather/current/KIZG.html', 'http://weather.gov/data/current_obs/KIZG.rss', 'http://weather.gov/data/current_obs/KIZG.xml'),
('KLEW', 'ME', 'Auburn-Lewiston', 44.050000, -70.290000, 'http://weather.noaa.gov/weather/current/KLEW.html', 'http://weather.gov/data/current_obs/KLEW.rss', 'http://weather.gov/data/current_obs/KLEW.xml'),
('KMLT', 'ME', 'Millinocket Municipal Airport', 45.660000, -68.680000, 'http://weather.noaa.gov/weather/current/KMLT.html', 'http://weather.gov/data/current_obs/KMLT.rss', 'http://weather.gov/data/current_obs/KMLT.xml'),
('KNHZ', 'ME', 'Brunswick, Naval Air Station', 43.890000, -69.930000, 'http://weather.noaa.gov/weather/current/KNHZ.html', 'http://weather.gov/data/current_obs/KNHZ.rss', 'http://weather.gov/data/current_obs/KNHZ.xml'),
('KOLD', 'ME', 'Old Town / Dewitt Field Airport', 44.950000, -68.667000, 'http://weather.noaa.gov/weather/current/KOLD.html', 'http://weather.gov/data/current_obs/KOLD.rss', 'http://weather.gov/data/current_obs/KOLD.xml'),
('KPQI', 'ME', 'Presque Isle', 46.690000, -68.050000, 'http://weather.noaa.gov/weather/current/KPQI.html', 'http://weather.gov/data/current_obs/KPQI.rss', 'http://weather.gov/data/current_obs/KPQI.xml'),
('KPWM', 'ME', 'Portland International Jetport', 43.660000, -70.320000, 'http://weather.noaa.gov/weather/current/KPWM.html', 'http://weather.gov/data/current_obs/KPWM.rss', 'http://weather.gov/data/current_obs/KPWM.xml'),
('KRKD', 'ME', 'Rockland / Knox Automatic Weather Observing', 44.080000, -69.120000, 'http://weather.noaa.gov/weather/current/KRKD.html', 'http://weather.gov/data/current_obs/KRKD.rss', 'http://weather.gov/data/current_obs/KRKD.xml'),
('KSFM', 'ME', 'Sanford Municipal Automatic Weather Observing', 43.400000, -70.700000, 'http://weather.noaa.gov/weather/current/KSFM.html', 'http://weather.gov/data/current_obs/KSFM.rss', 'http://weather.gov/data/current_obs/KSFM.xml'),
('KWVL', 'ME', 'Waterville Automatic Weather Observing / Reporting', 44.540000, -69.690000, 'http://weather.noaa.gov/weather/current/KWVL.html', 'http://weather.gov/data/current_obs/KWVL.rss', 'http://weather.gov/data/current_obs/KWVL.xml'),
('KGYX', 'ME', 'Portland', 43.883000, -70.250000, 'http://weather.noaa.gov/weather/current/KGYX.html', 'http://weather.gov/data/current_obs/KGYX.rss', 'http://weather.gov/data/current_obs/KGYX.xml'),
('PKMJ', 'MH', 'Marjuro WSO AP', 7.083000, 171.383000, 'http://weather.noaa.gov/weather/current/PKMJ.html', 'http://weather.gov/data/current_obs/PKMJ.rss', 'http://weather.gov/data/current_obs/PKMJ.xml'),
('PKMR', 'MH', 'Majuro Atoll', 7.060000, 171.270000, 'http://weather.noaa.gov/weather/current/PKMR.html', 'http://weather.gov/data/current_obs/PKMR.rss', 'http://weather.gov/data/current_obs/PKMR.xml'),
('PKWA', 'MH', 'Kwajalein Atoll', 8.733000, 167.733000, 'http://weather.noaa.gov/weather/current/PKWA.html', 'http://weather.gov/data/current_obs/PKWA.rss', 'http://weather.gov/data/current_obs/PKWA.xml'),
('K78D', 'MI', 'Caro', 43.450000, -83.450000, 'http://weather.noaa.gov/weather/current/K78D.html', 'http://weather.gov/data/current_obs/K78D.rss', 'http://weather.gov/data/current_obs/K78D.xml'),
('K7D2', 'MI', 'Troy', 42.550000, -83.183000, 'http://weather.noaa.gov/weather/current/K7D2.html', 'http://weather.gov/data/current_obs/K7D2.rss', 'http://weather.gov/data/current_obs/K7D2.xml'),
('KFKS', 'MI', 'Frankfort', 44.617000, -86.200000, 'http://weather.noaa.gov/weather/current/KFKS.html', 'http://weather.gov/data/current_obs/KFKS.rss', 'http://weather.gov/data/current_obs/KFKS.xml'),
('KHAI', 'MI', 'Three Rivers Municipal Dr Haines Airport', 41.959000, -85.590000, 'http://weather.noaa.gov/weather/current/KHAI.html', 'http://weather.gov/data/current_obs/KHAI.rss', 'http://weather.gov/data/current_obs/KHAI.xml'),
('KIMT', 'MI', 'Iron Mountain / Kingsford, Ford Airport', 45.810000, -88.110000, 'http://weather.noaa.gov/weather/current/KIMT.html', 'http://weather.gov/data/current_obs/KIMT.rss', 'http://weather.gov/data/current_obs/KIMT.xml'),
('KIWD', 'MI', 'Ironwood Automatic Weather Observing / Reporting', 46.540000, -90.130000, 'http://weather.noaa.gov/weather/current/KIWD.html', 'http://weather.gov/data/current_obs/KIWD.rss', 'http://weather.gov/data/current_obs/KIWD.xml'),
('KMNM', 'MI', 'Menominee Automatic Weather Observing / Reporting', 45.120000, -87.630000, 'http://weather.noaa.gov/weather/current/KMNM.html', 'http://weather.gov/data/current_obs/KMNM.rss', 'http://weather.gov/data/current_obs/KMNM.xml'),
('KONZ', 'MI', 'Grosse Ile Municipal Airport', 42.100000, -83.160000, 'http://weather.noaa.gov/weather/current/KONZ.html', 'http://weather.gov/data/current_obs/KONZ.rss', 'http://weather.gov/data/current_obs/KONZ.xml'),
('KACB', 'MI', 'Bellaire, Antrim County Airport', 44.990000, -85.200000, 'http://weather.noaa.gov/weather/current/KACB.html', 'http://weather.gov/data/current_obs/KACB.rss', 'http://weather.gov/data/current_obs/KACB.xml'),
('KADG', 'MI', 'Adrian, Lenawee County Airport', 41.870000, -84.070000, 'http://weather.noaa.gov/weather/current/KADG.html', 'http://weather.gov/data/current_obs/KADG.rss', 'http://weather.gov/data/current_obs/KADG.xml'),
('KAMN', 'MI', 'Alma, Gratiot Community Airport', 43.320000, -84.690000, 'http://weather.noaa.gov/weather/current/KAMN.html', 'http://weather.gov/data/current_obs/KAMN.rss', 'http://weather.gov/data/current_obs/KAMN.xml'),
('KANJ', 'MI', 'Sault Ste. Marie', 46.485000, -84.366000, 'http://weather.noaa.gov/weather/current/KANJ.html', 'http://weather.gov/data/current_obs/KANJ.rss', 'http://weather.gov/data/current_obs/KANJ.xml'),
('KAPN', 'MI', 'Alpena County Regional Airport', 45.080000, -83.570000, 'http://weather.noaa.gov/weather/current/KAPN.html', 'http://weather.gov/data/current_obs/KAPN.rss', 'http://weather.gov/data/current_obs/KAPN.xml'),
('KARB', 'MI', 'Ann Arbor Municipal Airport', 42.220000, -83.750000, 'http://weather.noaa.gov/weather/current/KARB.html', 'http://weather.gov/data/current_obs/KARB.rss', 'http://weather.gov/data/current_obs/KARB.xml'),
('KAZO', 'MI', 'Kalamazoo / Battle Creek International', 42.240000, -85.550000, 'http://weather.noaa.gov/weather/current/KAZO.html', 'http://weather.gov/data/current_obs/KAZO.rss', 'http://weather.gov/data/current_obs/KAZO.xml'),
('KBAX', 'MI', 'Bad Axe, Huron County Memorial Airport', 43.790000, -82.990000, 'http://weather.noaa.gov/weather/current/KBAX.html', 'http://weather.gov/data/current_obs/KBAX.rss', 'http://weather.gov/data/current_obs/KBAX.xml'),
('KBEH', 'MI', 'Benton Harbor, Southwest Michigan Regional Airport', 42.140000, -86.440000, 'http://weather.noaa.gov/weather/current/KBEH.html', 'http://weather.gov/data/current_obs/KBEH.rss', 'http://weather.gov/data/current_obs/KBEH.xml'),
('KBIV', 'MI', 'Holland, Tulip City Airport', 42.750000, -86.100000, 'http://weather.noaa.gov/weather/current/KBIV.html', 'http://weather.gov/data/current_obs/KBIV.rss', 'http://weather.gov/data/current_obs/KBIV.xml'),
('KBTL', 'MI', 'Battle Creek, Kellogg Airport', 42.300000, -85.250000, 'http://weather.noaa.gov/weather/current/KBTL.html', 'http://weather.gov/data/current_obs/KBTL.rss', 'http://weather.gov/data/current_obs/KBTL.xml'),
('KCAD', 'MI', 'Cadillac / Wexford County', 44.290000, -85.420000, 'http://weather.noaa.gov/weather/current/KCAD.html', 'http://weather.gov/data/current_obs/KCAD.rss', 'http://weather.gov/data/current_obs/KCAD.xml'),
('KCFS', 'MI', 'Caro', 43.459000, -83.445000, 'http://weather.noaa.gov/weather/current/KCFS.html', 'http://weather.gov/data/current_obs/KCFS.rss', 'http://weather.gov/data/current_obs/KCFS.xml'),
('KCIU', 'MI', 'Chippewa International Automatic Weather Observing', 46.260000, -84.470000, 'http://weather.noaa.gov/weather/current/KCIU.html', 'http://weather.gov/data/current_obs/KCIU.rss', 'http://weather.gov/data/current_obs/KCIU.xml'),
('KCMX', 'MI', 'Hancock, Houghton County Memorial Airport', 47.180000, -88.500000, 'http://weather.noaa.gov/weather/current/KCMX.html', 'http://weather.gov/data/current_obs/KCMX.rss', 'http://weather.gov/data/current_obs/KCMX.xml'),
('KCVX', 'MI', 'Charlevoix Municipal Airport', 45.300000, -85.270000, 'http://weather.noaa.gov/weather/current/KCVX.html', 'http://weather.gov/data/current_obs/KCVX.rss', 'http://weather.gov/data/current_obs/KCVX.xml'),
('KDET', 'MI', 'Detroit City Airport', 42.430000, -83.020000, 'http://weather.noaa.gov/weather/current/KDET.html', 'http://weather.gov/data/current_obs/KDET.rss', 'http://weather.gov/data/current_obs/KDET.xml'),
('KDTW', 'MI', 'Detroit Metropolitan Wayne County Airport', 42.230000, -83.330000, 'http://weather.noaa.gov/weather/current/KDTW.html', 'http://weather.gov/data/current_obs/KDTW.rss', 'http://weather.gov/data/current_obs/KDTW.xml'),
('KDUH', 'MI', 'Toledo Suburban Airport', 41.730000, -83.650000, 'http://weather.noaa.gov/weather/current/KDUH.html', 'http://weather.gov/data/current_obs/KDUH.rss', 'http://weather.gov/data/current_obs/KDUH.xml'),
('KERY', 'MI', 'Newberry, Luce County Airport', 46.310000, -85.460000, 'http://weather.noaa.gov/weather/current/KERY.html', 'http://weather.gov/data/current_obs/KERY.rss', 'http://weather.gov/data/current_obs/KERY.xml'),
('KESC', 'MI', 'Escanaba-Delta County Airport', 45.730000, -87.080000, 'http://weather.noaa.gov/weather/current/KESC.html', 'http://weather.gov/data/current_obs/KESC.rss', 'http://weather.gov/data/current_obs/KESC.xml'),
('KFNT', 'MI', 'Flint, Bishop International Airport', 42.980000, -83.730000, 'http://weather.noaa.gov/weather/current/KFNT.html', 'http://weather.gov/data/current_obs/KFNT.rss', 'http://weather.gov/data/current_obs/KFNT.xml'),
('KFPK', 'MI', 'Fitch Beach Airport', 42.570000, -84.810000, 'http://weather.noaa.gov/weather/current/KFPK.html', 'http://weather.gov/data/current_obs/KFPK.rss', 'http://weather.gov/data/current_obs/KFPK.xml'),
('KGLR', 'MI', 'Gaylord, Otsego County Airport', 45.024000, -84.678000, 'http://weather.noaa.gov/weather/current/KGLR.html', 'http://weather.gov/data/current_obs/KGLR.rss', 'http://weather.gov/data/current_obs/KGLR.xml'),
('KGOV', 'MI', 'Grayling AAF Airport', 44.680000, -84.720000, 'http://weather.noaa.gov/weather/current/KGOV.html', 'http://weather.gov/data/current_obs/KGOV.rss', 'http://weather.gov/data/current_obs/KGOV.xml'),
('KGRR', 'MI', 'Grand Rapids, Gerald R. Ford International Airport', 42.890000, -85.520000, 'http://weather.noaa.gov/weather/current/KGRR.html', 'http://weather.gov/data/current_obs/KGRR.rss', 'http://weather.gov/data/current_obs/KGRR.xml'),
('KHTL', 'MI', 'Houghton Lake, Roscommon County Airport', 44.380000, -84.680000, 'http://weather.noaa.gov/weather/current/KHTL.html', 'http://weather.gov/data/current_obs/KHTL.rss', 'http://weather.gov/data/current_obs/KHTL.xml'),
('KHYX', 'MI', 'Saginaw County H.W. Browne Airport', 43.433000, -83.862000, 'http://weather.noaa.gov/weather/current/KHYX.html', 'http://weather.gov/data/current_obs/KHYX.rss', 'http://weather.gov/data/current_obs/KHYX.xml'),
('KIRS', 'MI', 'Sturgis, Kirsch Municipal Airport', 41.810000, -85.440000, 'http://weather.noaa.gov/weather/current/KIRS.html', 'http://weather.gov/data/current_obs/KIRS.rss', 'http://weather.gov/data/current_obs/KIRS.xml'),
('KISQ', 'MI', 'Manistique, Schoolcraft County Airport', 45.970000, -86.170000, 'http://weather.noaa.gov/weather/current/KISQ.html', 'http://weather.gov/data/current_obs/KISQ.rss', 'http://weather.gov/data/current_obs/KISQ.xml'),
('KJXN', 'MI', 'Jackson County-Reynolds Field Airport', 42.270000, -84.470000, 'http://weather.noaa.gov/weather/current/KJXN.html', 'http://weather.gov/data/current_obs/KJXN.rss', 'http://weather.gov/data/current_obs/KJXN.xml'),
('KJYM', 'MI', 'Hillsdale Municipal Airport', 41.921000, -84.586000, 'http://weather.noaa.gov/weather/current/KJYM.html', 'http://weather.gov/data/current_obs/KJYM.rss', 'http://weather.gov/data/current_obs/KJYM.xml'),
('KLAN', 'MI', 'Lansing, Capital City Airport', 42.780000, -84.600000, 'http://weather.noaa.gov/weather/current/KLAN.html', 'http://weather.gov/data/current_obs/KLAN.rss', 'http://weather.gov/data/current_obs/KLAN.xml'),
('KLDM', 'MI', 'Ludington, Mason County Airport', 43.960000, -86.410000, 'http://weather.noaa.gov/weather/current/KLDM.html', 'http://weather.gov/data/current_obs/KLDM.rss', 'http://weather.gov/data/current_obs/KLDM.xml'),
('KLWA', 'MI', 'South Haven', 42.351000, -86.256000, 'http://weather.noaa.gov/weather/current/KLWA.html', 'http://weather.gov/data/current_obs/KLWA.rss', 'http://weather.gov/data/current_obs/KLWA.xml'),
('KMBL', 'MI', 'Manistee County-Blacker Airport', 44.280000, -86.250000, 'http://weather.noaa.gov/weather/current/KMBL.html', 'http://weather.gov/data/current_obs/KMBL.rss', 'http://weather.gov/data/current_obs/KMBL.xml'),
('KMBS', 'MI', 'Saginaw, MBS International Airport', 43.530000, -84.080000, 'http://weather.noaa.gov/weather/current/KMBS.html', 'http://weather.gov/data/current_obs/KMBS.rss', 'http://weather.gov/data/current_obs/KMBS.xml'),
('KMCD', 'MI', 'Mackinac Island Airport', 45.860000, -84.640000, 'http://weather.noaa.gov/weather/current/KMCD.html', 'http://weather.gov/data/current_obs/KMCD.rss', 'http://weather.gov/data/current_obs/KMCD.xml'),
('KMGN', 'MI', 'Harbor Springs Airport', 45.420000, -84.910000, 'http://weather.noaa.gov/weather/current/KMGN.html', 'http://weather.gov/data/current_obs/KMGN.rss', 'http://weather.gov/data/current_obs/KMGN.xml'),
('KMKG', 'MI', 'Muskegon County Airport', 43.180000, -86.270000, 'http://weather.noaa.gov/weather/current/KMKG.html', 'http://weather.gov/data/current_obs/KMKG.rss', 'http://weather.gov/data/current_obs/KMKG.xml'),
('KMOP', 'MI', 'Mount Pleasant Municipal Airport', 43.620000, -84.740000, 'http://weather.noaa.gov/weather/current/KMOP.html', 'http://weather.gov/data/current_obs/KMOP.rss', 'http://weather.gov/data/current_obs/KMOP.xml'),
('KMQT', 'MI', 'Marquette', 46.533000, -87.550000, 'http://weather.noaa.gov/weather/current/KMQT.html', 'http://weather.gov/data/current_obs/KMQT.rss', 'http://weather.gov/data/current_obs/KMQT.xml'),
('KMTC', 'MI', 'Selfridge Air National Guard Base', 42.620000, -82.840000, 'http://weather.noaa.gov/weather/current/KMTC.html', 'http://weather.gov/data/current_obs/KMTC.rss', 'http://weather.gov/data/current_obs/KMTC.xml');

INSERT INTO `#__zweather_stations` (`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES
('KOEB', 'MI', 'Coldwater, Branch County Memorial Airport', 41.930000, -85.050000, 'http://weather.noaa.gov/weather/current/KOEB.html', 'http://weather.gov/data/current_obs/KOEB.rss', 'http://weather.gov/data/current_obs/KOEB.xml'),
('KOSC', 'MI', 'Oscoda-Wurtsmith Airport', 44.460000, -83.400000, 'http://weather.noaa.gov/weather/current/KOSC.html', 'http://weather.gov/data/current_obs/KOSC.rss', 'http://weather.gov/data/current_obs/KOSC.xml'),
('KOZW', 'MI', 'Howell, Livingston County Airport', 42.630000, -83.980000, 'http://weather.noaa.gov/weather/current/KOZW.html', 'http://weather.gov/data/current_obs/KOZW.rss', 'http://weather.gov/data/current_obs/KOZW.xml'),
('KP53', 'MI', 'Munising', 46.400000, -86.650000, 'http://weather.noaa.gov/weather/current/KP53.html', 'http://weather.gov/data/current_obs/KP53.rss', 'http://weather.gov/data/current_obs/KP53.xml'),
('KP58', 'MI', 'Port Hope', 44.022000, -82.793000, 'http://weather.noaa.gov/weather/current/KP58.html', 'http://weather.gov/data/current_obs/KP58.rss', 'http://weather.gov/data/current_obs/KP58.xml'),
('KP59', 'MI', 'Copper Harbor', 47.450000, -87.900000, 'http://weather.noaa.gov/weather/current/KP59.html', 'http://weather.gov/data/current_obs/KP59.rss', 'http://weather.gov/data/current_obs/KP59.xml'),
('KP75', 'MI', 'Marquette', 45.930000, -85.920000, 'http://weather.noaa.gov/weather/current/KP75.html', 'http://weather.gov/data/current_obs/KP75.rss', 'http://weather.gov/data/current_obs/KP75.xml'),
('KPHN', 'MI', 'St. Clair County International', 42.920000, -82.530000, 'http://weather.noaa.gov/weather/current/KPHN.html', 'http://weather.gov/data/current_obs/KPHN.rss', 'http://weather.gov/data/current_obs/KPHN.xml'),
('KPLN', 'MI', 'Pellston Regional Airport of Emmet County', 45.580000, -84.800000, 'http://weather.noaa.gov/weather/current/KPLN.html', 'http://weather.gov/data/current_obs/KPLN.rss', 'http://weather.gov/data/current_obs/KPLN.xml'),
('KPTK', 'MI', 'Pontiac, Oakland County International Airport', 42.670000, -83.420000, 'http://weather.noaa.gov/weather/current/KPTK.html', 'http://weather.gov/data/current_obs/KPTK.rss', 'http://weather.gov/data/current_obs/KPTK.xml'),
('KPZQ', 'MI', 'Presque Isle County Airport', 45.400000, -83.817000, 'http://weather.noaa.gov/weather/current/KPZQ.html', 'http://weather.gov/data/current_obs/KPZQ.rss', 'http://weather.gov/data/current_obs/KPZQ.xml'),
('KRMY', 'MI', 'Marshall, Brooks Field Airport', 42.240000, -84.960000, 'http://weather.noaa.gov/weather/current/KRMY.html', 'http://weather.gov/data/current_obs/KRMY.rss', 'http://weather.gov/data/current_obs/KRMY.xml'),
('KRNP', 'MI', 'Owosso Community Airport', 42.993000, -84.139000, 'http://weather.noaa.gov/weather/current/KRNP.html', 'http://weather.gov/data/current_obs/KRNP.rss', 'http://weather.gov/data/current_obs/KRNP.xml'),
('KRQB', 'MI', 'Big Rapids, Roben-Hood Airport', 43.720000, -85.500000, 'http://weather.noaa.gov/weather/current/KRQB.html', 'http://weather.gov/data/current_obs/KRQB.rss', 'http://weather.gov/data/current_obs/KRQB.xml'),
('KSAW', 'MI', 'Gwinn, Sawyer Airport', 46.354000, -87.394000, 'http://weather.noaa.gov/weather/current/KSAW.html', 'http://weather.gov/data/current_obs/KSAW.rss', 'http://weather.gov/data/current_obs/KSAW.xml'),
('KSJX', 'MI', 'Beaver Island Airport', 45.700000, -85.570000, 'http://weather.noaa.gov/weather/current/KSJX.html', 'http://weather.gov/data/current_obs/KSJX.rss', 'http://weather.gov/data/current_obs/KSJX.xml'),
('KSLH', 'MI', 'Cheboygan Co Airport', 45.650000, -84.520000, 'http://weather.noaa.gov/weather/current/KSLH.html', 'http://weather.gov/data/current_obs/KSLH.rss', 'http://weather.gov/data/current_obs/KSLH.xml'),
('KTEW', 'MI', 'Mason Jewett Field Airport', 42.570000, -84.420000, 'http://weather.noaa.gov/weather/current/KTEW.html', 'http://weather.gov/data/current_obs/KTEW.rss', 'http://weather.gov/data/current_obs/KTEW.xml'),
('KTTF', 'MI', 'Monroe, Custer Airport', 41.940000, -83.430000, 'http://weather.noaa.gov/weather/current/KTTF.html', 'http://weather.gov/data/current_obs/KTTF.rss', 'http://weather.gov/data/current_obs/KTTF.xml'),
('KTVC', 'MI', 'Traverse City, Cherry Capital Airport', 44.730000, -85.580000, 'http://weather.noaa.gov/weather/current/KTVC.html', 'http://weather.gov/data/current_obs/KTVC.rss', 'http://weather.gov/data/current_obs/KTVC.xml'),
('KVLL', 'MI', 'Troy', 42.543000, -83.178000, 'http://weather.noaa.gov/weather/current/KVLL.html', 'http://weather.gov/data/current_obs/KVLL.rss', 'http://weather.gov/data/current_obs/KVLL.xml'),
('KYIP', 'MI', 'Detroit, Willow Run Airport', 42.230000, -83.530000, 'http://weather.noaa.gov/weather/current/KYIP.html', 'http://weather.gov/data/current_obs/KYIP.rss', 'http://weather.gov/data/current_obs/KYIP.xml'),
('KACQ', 'MN', 'Waseca Muni Airport', 44.070000, -93.550000, 'http://weather.noaa.gov/weather/current/KACQ.html', 'http://weather.gov/data/current_obs/KACQ.rss', 'http://weather.gov/data/current_obs/KACQ.xml'),
('KADC', 'MN', 'Wadena Municipal Airport', 46.447000, -95.212000, 'http://weather.noaa.gov/weather/current/KADC.html', 'http://weather.gov/data/current_obs/KADC.rss', 'http://weather.gov/data/current_obs/KADC.xml'),
('KAEL', 'MN', 'Albert Lea Automatic Weather Observing / Reporting', 43.690000, -93.370000, 'http://weather.noaa.gov/weather/current/KAEL.html', 'http://weather.gov/data/current_obs/KAEL.rss', 'http://weather.gov/data/current_obs/KAEL.xml'),
('KAIT', 'MN', 'Aitkin NDB Automatic Weather Observing / Reporting', 46.550000, -93.690000, 'http://weather.noaa.gov/weather/current/KAIT.html', 'http://weather.gov/data/current_obs/KAIT.rss', 'http://weather.gov/data/current_obs/KAIT.xml'),
('KANE', 'MN', 'Minneapolis / Blaine', 45.160000, -93.220000, 'http://weather.noaa.gov/weather/current/KANE.html', 'http://weather.gov/data/current_obs/KANE.rss', 'http://weather.gov/data/current_obs/KANE.xml'),
('KAQP', 'MN', 'Appleton Municipal Airport', 45.230000, -96.000000, 'http://weather.noaa.gov/weather/current/KAQP.html', 'http://weather.gov/data/current_obs/KAQP.rss', 'http://weather.gov/data/current_obs/KAQP.xml'),
('KAUM', 'MN', 'Austin Municipal', 43.670000, -92.940000, 'http://weather.noaa.gov/weather/current/KAUM.html', 'http://weather.gov/data/current_obs/KAUM.rss', 'http://weather.gov/data/current_obs/KAUM.xml'),
('KAXN', 'MN', 'Alexandria, Chandler Field', 45.870000, -95.410000, 'http://weather.noaa.gov/weather/current/KAXN.html', 'http://weather.gov/data/current_obs/KAXN.rss', 'http://weather.gov/data/current_obs/KAXN.xml'),
('KBBB', 'MN', 'Benson Municipal', 45.320000, -95.650000, 'http://weather.noaa.gov/weather/current/KBBB.html', 'http://weather.gov/data/current_obs/KBBB.rss', 'http://weather.gov/data/current_obs/KBBB.xml'),
('KBDE', 'MN', 'Baudette International Airport', 48.730000, -94.600000, 'http://weather.noaa.gov/weather/current/KBDE.html', 'http://weather.gov/data/current_obs/KBDE.rss', 'http://weather.gov/data/current_obs/KBDE.xml'),
('KBDH', 'MN', 'Willmar Municipal Airport', 45.120000, -95.130000, 'http://weather.noaa.gov/weather/current/KBDH.html', 'http://weather.gov/data/current_obs/KBDH.rss', 'http://weather.gov/data/current_obs/KBDH.xml'),
('KBFW', 'MN', 'Silver Bay', 47.210000, -91.410000, 'http://weather.noaa.gov/weather/current/KBFW.html', 'http://weather.gov/data/current_obs/KBFW.rss', 'http://weather.gov/data/current_obs/KBFW.xml'),
('KBJI', 'MN', 'Bemidji', 47.510000, -94.930000, 'http://weather.noaa.gov/weather/current/KBJI.html', 'http://weather.gov/data/current_obs/KBJI.rss', 'http://weather.gov/data/current_obs/KBJI.xml'),
('KBRD', 'MN', 'Brainerd-Crow Wing County Regional Airport', 46.400000, -94.130000, 'http://weather.noaa.gov/weather/current/KBRD.html', 'http://weather.gov/data/current_obs/KBRD.rss', 'http://weather.gov/data/current_obs/KBRD.xml'),
('KCBG', 'MN', 'Cambridge Municipal', 45.570000, -93.270000, 'http://weather.noaa.gov/weather/current/KCBG.html', 'http://weather.gov/data/current_obs/KCBG.rss', 'http://weather.gov/data/current_obs/KCBG.xml'),
('KCDD', 'MN', 'Crane Lake, Scotts Seaplane Base', 48.270000, -92.570000, 'http://weather.noaa.gov/weather/current/KCDD.html', 'http://weather.gov/data/current_obs/KCDD.rss', 'http://weather.gov/data/current_obs/KCDD.xml'),
('KCKC', 'MN', 'Grand Marais/Cook County Airport', 47.840000, -90.380000, 'http://weather.noaa.gov/weather/current/KCKC.html', 'http://weather.gov/data/current_obs/KCKC.rss', 'http://weather.gov/data/current_obs/KCKC.xml'),
('KCKN', 'MN', 'Crookston Municipal Field', 47.860000, -96.620000, 'http://weather.noaa.gov/weather/current/KCKN.html', 'http://weather.gov/data/current_obs/KCKN.rss', 'http://weather.gov/data/current_obs/KCKN.xml'),
('KCNB', 'MN', 'Canby Myers Field Airport', 44.720000, -96.260000, 'http://weather.noaa.gov/weather/current/KCNB.html', 'http://weather.gov/data/current_obs/KCNB.rss', 'http://weather.gov/data/current_obs/KCNB.xml'),
('KCOQ', 'MN', 'Cloquet Automatic Weather Observing / Reporting', 46.710000, -92.500000, 'http://weather.noaa.gov/weather/current/KCOQ.html', 'http://weather.gov/data/current_obs/KCOQ.rss', 'http://weather.gov/data/current_obs/KCOQ.xml'),
('KCQM', 'MN', 'Cook Municipal Airport', 47.820000, -92.690000, 'http://weather.noaa.gov/weather/current/KCQM.html', 'http://weather.gov/data/current_obs/KCQM.rss', 'http://weather.gov/data/current_obs/KCQM.xml'),
('KDLH', 'MN', 'Duluth International Airport', 46.840000, -92.180000, 'http://weather.noaa.gov/weather/current/KDLH.html', 'http://weather.gov/data/current_obs/KDLH.rss', 'http://weather.gov/data/current_obs/KDLH.xml'),
('KDTL', 'MN', 'Detroit Lakes Automatic Weather Observing / Report', 46.830000, -95.880000, 'http://weather.noaa.gov/weather/current/KDTL.html', 'http://weather.gov/data/current_obs/KDTL.rss', 'http://weather.gov/data/current_obs/KDTL.xml'),
('KDVP', 'MN', 'Slayton Municipal Airport', 43.987000, -95.783000, 'http://weather.noaa.gov/weather/current/KDVP.html', 'http://weather.gov/data/current_obs/KDVP.rss', 'http://weather.gov/data/current_obs/KDVP.xml'),
('KDXX', 'MN', 'Madison-Lac Qui Parle County Airport', 44.990000, -96.180000, 'http://weather.noaa.gov/weather/current/KDXX.html', 'http://weather.gov/data/current_obs/KDXX.rss', 'http://weather.gov/data/current_obs/KDXX.xml'),
('KDYT', 'MN', 'Sky Harbor Airport', 46.720000, -92.040000, 'http://weather.noaa.gov/weather/current/KDYT.html', 'http://weather.gov/data/current_obs/KDYT.rss', 'http://weather.gov/data/current_obs/KDYT.xml'),
('KELO', 'MN', 'Ely Municipal Automatic Weather Observing / Report', 47.910000, -91.820000, 'http://weather.noaa.gov/weather/current/KELO.html', 'http://weather.gov/data/current_obs/KELO.rss', 'http://weather.gov/data/current_obs/KELO.xml'),
('KETH', 'MN', 'Wheaton NDB Automatic Weather Observing/Reporting', 45.710000, -96.500000, 'http://weather.noaa.gov/weather/current/KETH.html', 'http://weather.gov/data/current_obs/KETH.rss', 'http://weather.gov/data/current_obs/KETH.xml'),
('KEVM', 'MN', 'Eveleth Municipal Automatic Weather Observing', 47.410000, -92.500000, 'http://weather.noaa.gov/weather/current/KEVM.html', 'http://weather.gov/data/current_obs/KEVM.rss', 'http://weather.gov/data/current_obs/KEVM.xml'),
('KFBL', 'MN', 'Faribault Municipal Automatic Weather Observing', 44.340000, -93.310000, 'http://weather.noaa.gov/weather/current/KFBL.html', 'http://weather.gov/data/current_obs/KFBL.rss', 'http://weather.gov/data/current_obs/KFBL.xml'),
('KFCM', 'MN', 'Minneapolis, Flying Cloud Airport', 44.840000, -93.470000, 'http://weather.noaa.gov/weather/current/KFCM.html', 'http://weather.gov/data/current_obs/KFCM.rss', 'http://weather.gov/data/current_obs/KFCM.xml'),
('KFFM', 'MN', 'Fergus Falls Automatic Weather Observing/Reporting', 46.300000, -96.070000, 'http://weather.noaa.gov/weather/current/KFFM.html', 'http://weather.gov/data/current_obs/KFFM.rss', 'http://weather.gov/data/current_obs/KFFM.xml'),
('KFGN', 'MN', 'Flag Island', 49.320000, -94.880000, 'http://weather.noaa.gov/weather/current/KFGN.html', 'http://weather.gov/data/current_obs/KFGN.rss', 'http://weather.gov/data/current_obs/KFGN.xml'),
('KFKA', 'MN', 'Preston-Fillmore Co Airport', 43.677000, -92.180000, 'http://weather.noaa.gov/weather/current/KFKA.html', 'http://weather.gov/data/current_obs/KFKA.rss', 'http://weather.gov/data/current_obs/KFKA.xml'),
('KFOZ', 'MN', 'Bigfork Municipal Airport', 47.780000, -93.650000, 'http://weather.noaa.gov/weather/current/KFOZ.html', 'http://weather.gov/data/current_obs/KFOZ.rss', 'http://weather.gov/data/current_obs/KFOZ.xml'),
('KFRM', 'MN', 'Fairmont Municipal Automatic Weather Observing', 43.660000, -94.420000, 'http://weather.noaa.gov/weather/current/KFRM.html', 'http://weather.gov/data/current_obs/KFRM.rss', 'http://weather.gov/data/current_obs/KFRM.xml'),
('KFSE', 'MN', 'Fosston Automatic Weather Observing/Reporting Sys', 47.593000, -95.773000, 'http://weather.noaa.gov/weather/current/KFSE.html', 'http://weather.gov/data/current_obs/KFSE.rss', 'http://weather.gov/data/current_obs/KFSE.xml'),
('KGHW', 'MN', 'Glenwood Automatic Surface Observing System', 45.650000, -95.320000, 'http://weather.noaa.gov/weather/current/KGHW.html', 'http://weather.gov/data/current_obs/KGHW.rss', 'http://weather.gov/data/current_obs/KGHW.xml'),
('KGNA', 'MN', 'The Bay of Grand Marais', 47.750000, -90.340000, 'http://weather.noaa.gov/weather/current/KGNA.html', 'http://weather.gov/data/current_obs/KGNA.rss', 'http://weather.gov/data/current_obs/KGNA.xml'),
('KGPZ', 'MN', 'Grand Rapids Automatic Weather Observing/Reporting', 47.230000, -93.520000, 'http://weather.noaa.gov/weather/current/KGPZ.html', 'http://weather.gov/data/current_obs/KGPZ.rss', 'http://weather.gov/data/current_obs/KGPZ.xml'),
('KGYL', 'MN', 'Glencoe Municipal Airport', 44.757000, -94.082000, 'http://weather.noaa.gov/weather/current/KGYL.html', 'http://weather.gov/data/current_obs/KGYL.rss', 'http://weather.gov/data/current_obs/KGYL.xml'),
('KHCD', 'MN', 'Hutchinson Automatic Weather Observing / Reporting', 44.870000, -94.390000, 'http://weather.noaa.gov/weather/current/KHCD.html', 'http://weather.gov/data/current_obs/KHCD.rss', 'http://weather.gov/data/current_obs/KHCD.xml'),
('KHCO', 'MN', 'Hallock Municipal Airport', 48.790000, -96.950000, 'http://weather.noaa.gov/weather/current/KHCO.html', 'http://weather.gov/data/current_obs/KHCO.rss', 'http://weather.gov/data/current_obs/KHCO.xml'),
('KHIB', 'MN', 'Chisholm-Hibbing Airport', 47.390000, -92.850000, 'http://weather.noaa.gov/weather/current/KHIB.html', 'http://weather.gov/data/current_obs/KHIB.rss', 'http://weather.gov/data/current_obs/KHIB.xml'),
('KHZX', 'MN', 'Isedor Iverson Airport', 46.617000, -93.317000, 'http://weather.noaa.gov/weather/current/KHZX.html', 'http://weather.gov/data/current_obs/KHZX.rss', 'http://weather.gov/data/current_obs/KHZX.xml'),
('KILL', 'MN', 'Willmar / Rice Automatic Weather Observing/Report', 45.110000, -95.090000, 'http://weather.noaa.gov/weather/current/KILL.html', 'http://weather.gov/data/current_obs/KILL.rss', 'http://weather.gov/data/current_obs/KILL.xml'),
('KINL', 'MN', 'Falls International Airport', 48.580000, -93.380000, 'http://weather.noaa.gov/weather/current/KINL.html', 'http://weather.gov/data/current_obs/KINL.rss', 'http://weather.gov/data/current_obs/KINL.xml'),
('KJKJ', 'MN', 'Moorhead Municipal Airport', 46.840000, -96.660000, 'http://weather.noaa.gov/weather/current/KJKJ.html', 'http://weather.gov/data/current_obs/KJKJ.rss', 'http://weather.gov/data/current_obs/KJKJ.xml'),
('KJMR', 'MN', 'Mora Municipal Airport', 45.890000, -93.270000, 'http://weather.noaa.gov/weather/current/KJMR.html', 'http://weather.gov/data/current_obs/KJMR.rss', 'http://weather.gov/data/current_obs/KJMR.xml'),
('KJYG', 'MN', 'St. James Municipal Airport', 43.990000, -94.560000, 'http://weather.noaa.gov/weather/current/KJYG.html', 'http://weather.gov/data/current_obs/KJYG.rss', 'http://weather.gov/data/current_obs/KJYG.xml'),
('KLJF', 'MN', 'Litchfield Municipal Airport', 45.140000, -94.520000, 'http://weather.noaa.gov/weather/current/KLJF.html', 'http://weather.gov/data/current_obs/KLJF.rss', 'http://weather.gov/data/current_obs/KLJF.xml'),
('KLVN', 'MN', 'Minneapolis, Airlake Airport', 44.640000, -93.240000, 'http://weather.noaa.gov/weather/current/KLVN.html', 'http://weather.gov/data/current_obs/KLVN.rss', 'http://weather.gov/data/current_obs/KLVN.xml'),
('KLXL', 'MN', 'Little Falls Automatic Weather Observing/Reporting', 45.960000, -94.350000, 'http://weather.noaa.gov/weather/current/KLXL.html', 'http://weather.gov/data/current_obs/KLXL.rss', 'http://weather.gov/data/current_obs/KLXL.xml'),
('KLYV', 'MN', 'Luverne-Quentin Aanenson Field', 43.621000, -96.216000, 'http://weather.noaa.gov/weather/current/KLYV.html', 'http://weather.gov/data/current_obs/KLYV.rss', 'http://weather.gov/data/current_obs/KLYV.xml'),
('KMGG', 'MN', 'Maple Lake Municipal Airport', 45.236000, -93.986000, 'http://weather.noaa.gov/weather/current/KMGG.html', 'http://weather.gov/data/current_obs/KMGG.rss', 'http://weather.gov/data/current_obs/KMGG.xml'),
('KMIC', 'MN', 'Minneapolis, Crystal Airport', 45.080000, -93.380000, 'http://weather.noaa.gov/weather/current/KMIC.html', 'http://weather.gov/data/current_obs/KMIC.rss', 'http://weather.gov/data/current_obs/KMIC.xml'),
('KMJQ', 'MN', 'Jackson Municipal Automatic Weather Observing', 43.660000, -94.990000, 'http://weather.noaa.gov/weather/current/KMJQ.html', 'http://weather.gov/data/current_obs/KMJQ.rss', 'http://weather.gov/data/current_obs/KMJQ.xml'),
('KMKT', 'MN', 'Mankato Automatic Weather Observing / Reporting', 44.230000, -93.920000, 'http://weather.noaa.gov/weather/current/KMKT.html', 'http://weather.gov/data/current_obs/KMKT.rss', 'http://weather.gov/data/current_obs/KMKT.xml'),
('KMML', 'MN', 'Marshall / Ryan Automatic Weather Observing', 44.460000, -95.820000, 'http://weather.noaa.gov/weather/current/KMML.html', 'http://weather.gov/data/current_obs/KMML.rss', 'http://weather.gov/data/current_obs/KMML.xml'),
('KMOX', 'MN', 'Morris Municipal Automatic Weather Observing', 45.570000, -95.970000, 'http://weather.noaa.gov/weather/current/KMOX.html', 'http://weather.gov/data/current_obs/KMOX.rss', 'http://weather.gov/data/current_obs/KMOX.xml'),
('KMSP', 'MN', 'Minneapolis-St. Paul International Airport', 44.890000, -93.220000, 'http://weather.noaa.gov/weather/current/KMSP.html', 'http://weather.gov/data/current_obs/KMSP.rss', 'http://weather.gov/data/current_obs/KMSP.xml'),
('KMVE', 'MN', 'Montevideo Automatic Weather Observing / Reporting', 44.970000, -95.720000, 'http://weather.noaa.gov/weather/current/KMVE.html', 'http://weather.gov/data/current_obs/KMVE.rss', 'http://weather.gov/data/current_obs/KMVE.xml'),
('KMWM', 'MN', 'Windom Municipal Airport', 43.910000, -95.110000, 'http://weather.noaa.gov/weather/current/KMWM.html', 'http://weather.gov/data/current_obs/KMWM.rss', 'http://weather.gov/data/current_obs/KMWM.xml'),
('KMZH', 'MN', 'Moose Lake Carlton County Airport', 46.417000, -92.800000, 'http://weather.noaa.gov/weather/current/KMZH.html', 'http://weather.gov/data/current_obs/KMZH.rss', 'http://weather.gov/data/current_obs/KMZH.xml'),
('KONA', 'MN', 'Winona Municipal Automatic Weather Observing', 44.090000, -91.700000, 'http://weather.noaa.gov/weather/current/KONA.html', 'http://weather.gov/data/current_obs/KONA.rss', 'http://weather.gov/data/current_obs/KONA.xml'),
('KORB', 'MN', 'Orr', 48.020000, -92.870000, 'http://weather.noaa.gov/weather/current/KORB.html', 'http://weather.gov/data/current_obs/KORB.rss', 'http://weather.gov/data/current_obs/KORB.xml'),
('KOTG', 'MN', 'Worthington Automatic Weather Observing/Reporting', 43.660000, -95.580000, 'http://weather.noaa.gov/weather/current/KOTG.html', 'http://weather.gov/data/current_obs/KOTG.rss', 'http://weather.gov/data/current_obs/KOTG.xml'),
('KOVL', 'MN', 'Olivia Regional Airport', 44.780000, -95.030000, 'http://weather.noaa.gov/weather/current/KOVL.html', 'http://weather.gov/data/current_obs/KOVL.rss', 'http://weather.gov/data/current_obs/KOVL.xml'),
('KOWA', 'MN', 'Owatonna Automatic Weather Observing / Reporting', 44.120000, -93.250000, 'http://weather.noaa.gov/weather/current/KOWA.html', 'http://weather.gov/data/current_obs/KOWA.rss', 'http://weather.gov/data/current_obs/KOWA.xml'),
('KPKD', 'MN', 'Park Rapids Municipal Airport', 46.910000, -95.070000, 'http://weather.noaa.gov/weather/current/KPKD.html', 'http://weather.gov/data/current_obs/KPKD.rss', 'http://weather.gov/data/current_obs/KPKD.xml'),
('KPNM', 'MN', 'Princeton', 45.560000, -93.610000, 'http://weather.noaa.gov/weather/current/KPNM.html', 'http://weather.gov/data/current_obs/KPNM.rss', 'http://weather.gov/data/current_obs/KPNM.xml'),
('KPQN', 'MN', 'Pipestone Automatic Weather Observing / Reporting', 43.990000, -96.320000, 'http://weather.noaa.gov/weather/current/KPQN.html', 'http://weather.gov/data/current_obs/KPQN.rss', 'http://weather.gov/data/current_obs/KPQN.xml'),
('KPWC', 'MN', 'Pine River Regional Airport', 46.720000, -94.380000, 'http://weather.noaa.gov/weather/current/KPWC.html', 'http://weather.gov/data/current_obs/KPWC.rss', 'http://weather.gov/data/current_obs/KPWC.xml'),
('KRGK', 'MN', 'Red Wing Municipal Airport', 44.590000, -92.490000, 'http://weather.noaa.gov/weather/current/KRGK.html', 'http://weather.gov/data/current_obs/KRGK.rss', 'http://weather.gov/data/current_obs/KRGK.xml'),
('KROS', 'MN', 'Rush City Regional Airport', 45.698000, -92.953000, 'http://weather.noaa.gov/weather/current/KROS.html', 'http://weather.gov/data/current_obs/KROS.rss', 'http://weather.gov/data/current_obs/KROS.xml'),
('KROX', 'MN', 'Roseau Municipal Automatic Weather Observing', 48.860000, -95.690000, 'http://weather.noaa.gov/weather/current/KROX.html', 'http://weather.gov/data/current_obs/KROX.rss', 'http://weather.gov/data/current_obs/KROX.xml'),
('KRRT', 'MN', 'Warroad International-Swede Carlson Field', 48.940000, -95.350000, 'http://weather.noaa.gov/weather/current/KRRT.html', 'http://weather.gov/data/current_obs/KRRT.rss', 'http://weather.gov/data/current_obs/KRRT.xml'),
('KRST', 'MN', 'Rochester International Airport', 43.930000, -92.500000, 'http://weather.noaa.gov/weather/current/KRST.html', 'http://weather.gov/data/current_obs/KRST.rss', 'http://weather.gov/data/current_obs/KRST.xml'),
('KRWF', 'MN', 'Redwood Falls Municipal Airport', 44.550000, -95.080000, 'http://weather.noaa.gov/weather/current/KRWF.html', 'http://weather.gov/data/current_obs/KRWF.rss', 'http://weather.gov/data/current_obs/KRWF.xml'),
('KSAZ', 'MN', 'Staples Municipal Airport', 46.380000, -94.810000, 'http://weather.noaa.gov/weather/current/KSAZ.html', 'http://weather.gov/data/current_obs/KSAZ.rss', 'http://weather.gov/data/current_obs/KSAZ.xml'),
('KSGS', 'MN', 'South St. Paul Municipal-Richard E', 44.850000, -93.150000, 'http://weather.noaa.gov/weather/current/KSGS.html', 'http://weather.gov/data/current_obs/KSGS.rss', 'http://weather.gov/data/current_obs/KSGS.xml'),
('KSTC', 'MN', 'St. Cloud Regional Airport', 45.550000, -94.070000, 'http://weather.noaa.gov/weather/current/KSTC.html', 'http://weather.gov/data/current_obs/KSTC.rss', 'http://weather.gov/data/current_obs/KSTC.xml'),
('KSTP', 'MN', 'St. Paul Downtown Holman Field', 44.940000, -93.050000, 'http://weather.noaa.gov/weather/current/KSTP.html', 'http://weather.gov/data/current_obs/KSTP.rss', 'http://weather.gov/data/current_obs/KSTP.xml'),
('KSYN', 'MN', 'Stanton Airfield', 44.467000, -93.017000, 'http://weather.noaa.gov/weather/current/KSYN.html', 'http://weather.gov/data/current_obs/KSYN.rss', 'http://weather.gov/data/current_obs/KSYN.xml'),
('KTKC', 'MN', 'Tracy Municipal Airport', 44.249000, -95.607000, 'http://weather.noaa.gov/weather/current/KTKC.html', 'http://weather.gov/data/current_obs/KTKC.rss', 'http://weather.gov/data/current_obs/KTKC.xml'),
('KTOB', 'MN', 'Dodge Center Airport', 44.018000, -92.831000, 'http://weather.noaa.gov/weather/current/KTOB.html', 'http://weather.gov/data/current_obs/KTOB.rss', 'http://weather.gov/data/current_obs/KTOB.xml'),
('KTVF', 'MN', 'Thief River Automatic Weather Observing/Reporting', 48.080000, -96.180000, 'http://weather.noaa.gov/weather/current/KTVF.html', 'http://weather.gov/data/current_obs/KTVF.rss', 'http://weather.gov/data/current_obs/KTVF.xml'),
('KTWM', 'MN', 'Two Harbors', 47.050000, -91.750000, 'http://weather.noaa.gov/weather/current/KTWM.html', 'http://weather.gov/data/current_obs/KTWM.rss', 'http://weather.gov/data/current_obs/KTWM.xml'),
('KULM', 'MN', 'New Ulm Municipal Automatic Weather Observing', 44.320000, -94.500000, 'http://weather.noaa.gov/weather/current/KULM.html', 'http://weather.gov/data/current_obs/KULM.rss', 'http://weather.gov/data/current_obs/KULM.xml'),
('KVVV', 'MN', 'Ortonville Municipal-Martinson Field Airport', 45.310000, -96.420000, 'http://weather.noaa.gov/weather/current/KVVV.html', 'http://weather.gov/data/current_obs/KVVV.rss', 'http://weather.gov/data/current_obs/KVVV.xml'),
('KVWU', 'MN', 'Waskish Municipal Airport', 48.150000, -94.520000, 'http://weather.noaa.gov/weather/current/KVWU.html', 'http://weather.gov/data/current_obs/KVWU.rss', 'http://weather.gov/data/current_obs/KVWU.xml'),
('KXVG', 'MN', 'Longville Municipal Airport', 46.992000, -94.200000, 'http://weather.noaa.gov/weather/current/KXVG.html', 'http://weather.gov/data/current_obs/KXVG.rss', 'http://weather.gov/data/current_obs/KXVG.xml'),
('KCFE', 'MN', 'Buffalo Municipal Airport', 45.159000, -93.843000, 'http://weather.noaa.gov/weather/current/KCFE.html', 'http://weather.gov/data/current_obs/KCFE.rss', 'http://weather.gov/data/current_obs/KCFE.xml'),
('KGDB', 'MN', 'Granite Falls Municipal Airport', 44.753300, -95.556000, 'http://weather.noaa.gov/weather/current/KGDB.html', 'http://weather.gov/data/current_obs/KGDB.rss', 'http://weather.gov/data/current_obs/KGDB.xml'),
('KAIZ', 'MO', 'Kaiser Memorial Automatic Weather Observing', 38.110000, -92.550000, 'http://weather.noaa.gov/weather/current/KAIZ.html', 'http://weather.gov/data/current_obs/KAIZ.rss', 'http://weather.gov/data/current_obs/KAIZ.xml'),
('KCDJ', 'MO', 'Chillicothe Agri-Science Center', 39.820000, -93.580000, 'http://weather.noaa.gov/weather/current/KCDJ.html', 'http://weather.gov/data/current_obs/KCDJ.rss', 'http://weather.gov/data/current_obs/KCDJ.xml'),
('KCGI', 'MO', 'Cape Girardeau Regional Airport', 37.230000, -89.580000, 'http://weather.noaa.gov/weather/current/KCGI.html', 'http://weather.gov/data/current_obs/KCGI.rss', 'http://weather.gov/data/current_obs/KCGI.xml'),
('KCOU', 'MO', 'Columbia Regional Airport', 38.830000, -92.220000, 'http://weather.noaa.gov/weather/current/KCOU.html', 'http://weather.gov/data/current_obs/KCOU.rss', 'http://weather.gov/data/current_obs/KCOU.xml'),
('KDMO', 'MO', 'Sedalia Memorial Airport', 38.710000, -93.160000, 'http://weather.noaa.gov/weather/current/KDMO.html', 'http://weather.gov/data/current_obs/KDMO.rss', 'http://weather.gov/data/current_obs/KDMO.xml'),
('KFAM', 'MO', 'Farmington Airport', 37.760000, -90.430000, 'http://weather.noaa.gov/weather/current/KFAM.html', 'http://weather.gov/data/current_obs/KFAM.rss', 'http://weather.gov/data/current_obs/KFAM.xml'),
('KIRK', 'MO', 'Kirksville Regional Airport', 40.110000, -92.550000, 'http://weather.noaa.gov/weather/current/KIRK.html', 'http://weather.gov/data/current_obs/KIRK.rss', 'http://weather.gov/data/current_obs/KIRK.xml'),
('KJEF', 'MO', 'Jefferson City Memorial Airport', 38.590000, -92.160000, 'http://weather.noaa.gov/weather/current/KJEF.html', 'http://weather.gov/data/current_obs/KJEF.rss', 'http://weather.gov/data/current_obs/KJEF.xml'),
('KJLN', 'MO', 'Joplin Regional Airport', 37.180000, -94.500000, 'http://weather.noaa.gov/weather/current/KJLN.html', 'http://weather.gov/data/current_obs/KJLN.rss', 'http://weather.gov/data/current_obs/KJLN.xml'),
('KLXT', 'MO', 'Lees Summit', 38.964000, -94.374000, 'http://weather.noaa.gov/weather/current/KLXT.html', 'http://weather.gov/data/current_obs/KLXT.rss', 'http://weather.gov/data/current_obs/KLXT.xml'),
('KMCI', 'MO', 'Kansas City International Airport', 39.330000, -94.720000, 'http://weather.noaa.gov/weather/current/KMCI.html', 'http://weather.gov/data/current_obs/KMCI.rss', 'http://weather.gov/data/current_obs/KMCI.xml'),
('KMKC', 'MO', 'Charles B Wheeler Downtown Airport', 39.120000, -94.600000, 'http://weather.noaa.gov/weather/current/KMKC.html', 'http://weather.gov/data/current_obs/KMKC.rss', 'http://weather.gov/data/current_obs/KMKC.xml'),
('KPOF', 'MO', 'Poplar Bluff Municipal Airport', 36.770000, -90.320000, 'http://weather.noaa.gov/weather/current/KPOF.html', 'http://weather.gov/data/current_obs/KPOF.rss', 'http://weather.gov/data/current_obs/KPOF.xml'),
('KSET', 'MO', 'St. Charles County Smartt Airport', 38.931000, -90.433000, 'http://weather.noaa.gov/weather/current/KSET.html', 'http://weather.gov/data/current_obs/KSET.rss', 'http://weather.gov/data/current_obs/KSET.xml'),
('KSGF', 'MO', 'Springfield Regional Airport', 37.230000, -93.400000, 'http://weather.noaa.gov/weather/current/KSGF.html', 'http://weather.gov/data/current_obs/KSGF.rss', 'http://weather.gov/data/current_obs/KSGF.xml'),
('KSTJ', 'MO', 'St. Joseph, Rosecrans Memorial Airport', 39.770000, -94.910000, 'http://weather.noaa.gov/weather/current/KSTJ.html', 'http://weather.gov/data/current_obs/KSTJ.rss', 'http://weather.gov/data/current_obs/KSTJ.xml'),
('KSTL', 'MO', 'Lambert-St. Louis International Airport', 38.760000, -90.370000, 'http://weather.noaa.gov/weather/current/KSTL.html', 'http://weather.gov/data/current_obs/KSTL.rss', 'http://weather.gov/data/current_obs/KSTL.xml'),
('KSUS', 'MO', 'Spirit Of St. Louis Airport', 38.660000, -90.630000, 'http://weather.noaa.gov/weather/current/KSUS.html', 'http://weather.gov/data/current_obs/KSUS.rss', 'http://weather.gov/data/current_obs/KSUS.xml'),
('KSZL', 'MO', 'Whiteman Air Force Base', 38.733000, -93.567000, 'http://weather.noaa.gov/weather/current/KSZL.html', 'http://weather.gov/data/current_obs/KSZL.rss', 'http://weather.gov/data/current_obs/KSZL.xml'),
('KTBN', 'MO', 'Fort Leonard Wood', 37.733000, -92.150000, 'http://weather.noaa.gov/weather/current/KTBN.html', 'http://weather.gov/data/current_obs/KTBN.rss', 'http://weather.gov/data/current_obs/KTBN.xml'),
('KUNO', 'MO', 'West Plains Municipal Airport', 36.880000, -91.900000, 'http://weather.noaa.gov/weather/current/KUNO.html', 'http://weather.gov/data/current_obs/KUNO.rss', 'http://weather.gov/data/current_obs/KUNO.xml'),
('KVIH', 'MO', 'Rolla National Airport', 38.140000, -91.770000, 'http://weather.noaa.gov/weather/current/KVIH.html', 'http://weather.gov/data/current_obs/KVIH.rss', 'http://weather.gov/data/current_obs/KVIH.xml'),
('TFFF', 'MQ', 'Le Lamentin', 14.600000, -61.000000, 'http://weather.noaa.gov/weather/current/TFFF.html', 'http://weather.gov/data/current_obs/TFFF.rss', 'http://weather.gov/data/current_obs/TFFF.xml'),
('KBIX', 'MS', 'Keesler Air Force Base / Biloxi', 30.417000, -88.917000, 'http://weather.noaa.gov/weather/current/KBIX.html', 'http://weather.gov/data/current_obs/KBIX.rss', 'http://weather.gov/data/current_obs/KBIX.xml'),
('KCBM', 'MS', 'Columbus Air Force Base', 33.633000, -88.450000, 'http://weather.noaa.gov/weather/current/KCBM.html', 'http://weather.gov/data/current_obs/KCBM.rss', 'http://weather.gov/data/current_obs/KCBM.xml'),
('KGLH', 'MS', 'Greenville Municipal Airport', 33.480000, -90.980000, 'http://weather.noaa.gov/weather/current/KGLH.html', 'http://weather.gov/data/current_obs/KGLH.rss', 'http://weather.gov/data/current_obs/KGLH.xml'),
('KGPT', 'MS', 'Gulfport-Biloxi Regional Airport', 30.400000, -89.070000, 'http://weather.noaa.gov/weather/current/KGPT.html', 'http://weather.gov/data/current_obs/KGPT.rss', 'http://weather.gov/data/current_obs/KGPT.xml'),
('KGTR', 'MS', 'Golden Tri Automatic Weather Observing / Reporting', 33.460000, -88.580000, 'http://weather.noaa.gov/weather/current/KGTR.html', 'http://weather.gov/data/current_obs/KGTR.rss', 'http://weather.gov/data/current_obs/KGTR.xml'),
('KGWO', 'MS', 'Greenwood-LeFlore Airport', 33.510000, -90.080000, 'http://weather.noaa.gov/weather/current/KGWO.html', 'http://weather.gov/data/current_obs/KGWO.rss', 'http://weather.gov/data/current_obs/KGWO.xml'),
('KHBG', 'MS', 'Hattiesburg, Bobby L Chain Municipal Airport', 31.270000, -89.250000, 'http://weather.noaa.gov/weather/current/KHBG.html', 'http://weather.gov/data/current_obs/KHBG.rss', 'http://weather.gov/data/current_obs/KHBG.xml'),
('KHEZ', 'MS', 'Natchez / Hardy Automatic Weather Observing/Report', 31.620000, -91.250000, 'http://weather.noaa.gov/weather/current/KHEZ.html', 'http://weather.gov/data/current_obs/KHEZ.rss', 'http://weather.gov/data/current_obs/KHEZ.xml'),
('KHKS', 'MS', 'Jackson, Hawkins Field Airport', 32.330000, -90.220000, 'http://weather.noaa.gov/weather/current/KHKS.html', 'http://weather.gov/data/current_obs/KHKS.rss', 'http://weather.gov/data/current_obs/KHKS.xml'),
('KJAN', 'MS', 'Jackson International Airport', 32.330000, -90.080000, 'http://weather.noaa.gov/weather/current/KJAN.html', 'http://weather.gov/data/current_obs/KJAN.rss', 'http://weather.gov/data/current_obs/KJAN.xml'),
('KM97', 'MS', 'Tunica Municipal Airport', 34.683000, -90.333000, 'http://weather.noaa.gov/weather/current/KM97.html', 'http://weather.gov/data/current_obs/KM97.rss', 'http://weather.gov/data/current_obs/KM97.xml'),
('KMCB', 'MS', 'McComb / Pike County / John E Lewis Field', 31.180000, -90.470000, 'http://weather.noaa.gov/weather/current/KMCB.html', 'http://weather.gov/data/current_obs/KMCB.rss', 'http://weather.gov/data/current_obs/KMCB.xml'),
('KMEI', 'MS', 'Meridian, Key Field', 32.340000, -88.750000, 'http://weather.noaa.gov/weather/current/KMEI.html', 'http://weather.gov/data/current_obs/KMEI.rss', 'http://weather.gov/data/current_obs/KMEI.xml'),
('KNMM', 'MS', 'Meridian, Naval Air Station', 32.550000, -88.567000, 'http://weather.noaa.gov/weather/current/KNMM.html', 'http://weather.gov/data/current_obs/KNMM.rss', 'http://weather.gov/data/current_obs/KNMM.xml'),
('KOLV', 'MS', 'Olive Branch Airport', 34.980000, -89.790000, 'http://weather.noaa.gov/weather/current/KOLV.html', 'http://weather.gov/data/current_obs/KOLV.rss', 'http://weather.gov/data/current_obs/KOLV.xml'),
('KPGL', 'MS', 'Pascagoula / Jackson', 30.400000, -88.483000, 'http://weather.noaa.gov/weather/current/KPGL.html', 'http://weather.gov/data/current_obs/KPGL.rss', 'http://weather.gov/data/current_obs/KPGL.xml'),
('KPIB', 'MS', 'Pine Belt Regional Automatic Weather Observing', 31.470000, -89.330000, 'http://weather.noaa.gov/weather/current/KPIB.html', 'http://weather.gov/data/current_obs/KPIB.rss', 'http://weather.gov/data/current_obs/KPIB.xml'),
('KPQL', 'MS', 'Pascagoula, Lott International Airport', 30.460000, -88.530000, 'http://weather.noaa.gov/weather/current/KPQL.html', 'http://weather.gov/data/current_obs/KPQL.rss', 'http://weather.gov/data/current_obs/KPQL.xml'),
('KTUP', 'MS', 'Tupelo Regional Airport', 34.280000, -88.770000, 'http://weather.noaa.gov/weather/current/KTUP.html', 'http://weather.gov/data/current_obs/KTUP.rss', 'http://weather.gov/data/current_obs/KTUP.xml'),
('KUTA', 'MS', 'Tunica Municipal Airport', 34.683100, -90.347200, 'http://weather.noaa.gov/weather/current/KUTA.html', 'http://weather.gov/data/current_obs/KUTA.rss', 'http://weather.gov/data/current_obs/KUTA.xml'),
('K3DU', 'MT', 'Drummond', 46.680000, -113.150000, 'http://weather.noaa.gov/weather/current/K3DU.html', 'http://weather.gov/data/current_obs/K3DU.rss', 'http://weather.gov/data/current_obs/K3DU.xml'),
('K3HT', 'MT', 'Harlowton', 46.440000, -109.840000, 'http://weather.noaa.gov/weather/current/K3HT.html', 'http://weather.gov/data/current_obs/K3HT.rss', 'http://weather.gov/data/current_obs/K3HT.xml'),
('K3TH', 'MT', 'Thompson Falls', 47.600000, -115.367000, 'http://weather.noaa.gov/weather/current/K3TH.html', 'http://weather.gov/data/current_obs/K3TH.rss', 'http://weather.gov/data/current_obs/K3TH.xml'),
('KBHK', 'MT', 'Baker', 46.333000, -104.250000, 'http://weather.noaa.gov/weather/current/KBHK.html', 'http://weather.gov/data/current_obs/KBHK.rss', 'http://weather.gov/data/current_obs/KBHK.xml'),
('KBIL', 'MT', 'Billings/Logan Intl Airport', 45.800000, -108.530000, 'http://weather.noaa.gov/weather/current/KBIL.html', 'http://weather.gov/data/current_obs/KBIL.rss', 'http://weather.gov/data/current_obs/KBIL.xml'),
('KBTM', 'MT', 'Butte/Bert Mooney', 45.960000, -112.500000, 'http://weather.noaa.gov/weather/current/KBTM.html', 'http://weather.gov/data/current_obs/KBTM.rss', 'http://weather.gov/data/current_obs/KBTM.xml'),
('KBZN', 'MT', 'Bozeman/Gallatin', 45.790000, -111.150000, 'http://weather.noaa.gov/weather/current/KBZN.html', 'http://weather.gov/data/current_obs/KBZN.rss', 'http://weather.gov/data/current_obs/KBZN.xml'),
('KCTB', 'MT', 'Cut Bank (awos)', 48.610000, -112.370000, 'http://weather.noaa.gov/weather/current/KCTB.html', 'http://weather.gov/data/current_obs/KCTB.rss', 'http://weather.gov/data/current_obs/KCTB.xml'),
('KDLN', 'MT', 'Dillon Airport', 45.260000, -112.550000, 'http://weather.noaa.gov/weather/current/KDLN.html', 'http://weather.gov/data/current_obs/KDLN.rss', 'http://weather.gov/data/current_obs/KDLN.xml'),
('KFCA', 'MT', 'Kalispell/Glacier', 48.300000, -114.270000, 'http://weather.noaa.gov/weather/current/KFCA.html', 'http://weather.gov/data/current_obs/KFCA.rss', 'http://weather.gov/data/current_obs/KFCA.xml'),
('KGDV', 'MT', 'Glendive(awos)', 47.140000, -104.800000, 'http://weather.noaa.gov/weather/current/KGDV.html', 'http://weather.gov/data/current_obs/KGDV.rss', 'http://weather.gov/data/current_obs/KGDV.xml'),
('KGFA', 'MT', 'Malmstrom Air Morce Base', 47.517000, -111.183000, 'http://weather.noaa.gov/weather/current/KGFA.html', 'http://weather.gov/data/current_obs/KGFA.rss', 'http://weather.gov/data/current_obs/KGFA.xml'),
('KGGW', 'MT', 'Glasgow Intl Arpt', 48.210000, -106.630000, 'http://weather.noaa.gov/weather/current/KGGW.html', 'http://weather.gov/data/current_obs/KGGW.rss', 'http://weather.gov/data/current_obs/KGGW.xml'),
('KGTF', 'MT', 'Great Falls Intl Airport', 47.480000, -111.350000, 'http://weather.noaa.gov/weather/current/KGTF.html', 'http://weather.gov/data/current_obs/KGTF.rss', 'http://weather.gov/data/current_obs/KGTF.xml'),
('KHLN', 'MT', 'Helena Regional', 46.610000, -112.000000, 'http://weather.noaa.gov/weather/current/KHLN.html', 'http://weather.gov/data/current_obs/KHLN.rss', 'http://weather.gov/data/current_obs/KHLN.xml'),
('KHVR', 'MT', 'Havre (amos)', 48.550000, -109.770000, 'http://weather.noaa.gov/weather/current/KHVR.html', 'http://weather.gov/data/current_obs/KHVR.rss', 'http://weather.gov/data/current_obs/KHVR.xml'),
('KJDN', 'MT', 'Jordan (ramos)', 47.330000, -106.930000, 'http://weather.noaa.gov/weather/current/KJDN.html', 'http://weather.gov/data/current_obs/KJDN.rss', 'http://weather.gov/data/current_obs/KJDN.xml'),
('KLVM', 'MT', 'Livingston/Mission', 45.710000, -110.430000, 'http://weather.noaa.gov/weather/current/KLVM.html', 'http://weather.gov/data/current_obs/KLVM.rss', 'http://weather.gov/data/current_obs/KLVM.xml'),
('KLWT', 'MT', 'Lewistown Municipal', 47.050000, -109.450000, 'http://weather.noaa.gov/weather/current/KLWT.html', 'http://weather.gov/data/current_obs/KLWT.rss', 'http://weather.gov/data/current_obs/KLWT.xml'),
('KMLS', 'MT', 'Miles City', 46.440000, -105.870000, 'http://weather.noaa.gov/weather/current/KMLS.html', 'http://weather.gov/data/current_obs/KMLS.rss', 'http://weather.gov/data/current_obs/KMLS.xml'),
('KMSO', 'MT', 'Missoula/Bell Field', 46.930000, -114.080000, 'http://weather.noaa.gov/weather/current/KMSO.html', 'http://weather.gov/data/current_obs/KMSO.rss', 'http://weather.gov/data/current_obs/KMSO.xml'),
('KOLF', 'MT', 'Wolf Point Intl Airport', 48.090000, -105.580000, 'http://weather.noaa.gov/weather/current/KOLF.html', 'http://weather.gov/data/current_obs/KOLF.rss', 'http://weather.gov/data/current_obs/KOLF.xml'),
('KSDY', 'MT', 'Sidney-Richland', 47.730000, -104.180000, 'http://weather.noaa.gov/weather/current/KSDY.html', 'http://weather.gov/data/current_obs/KSDY.rss', 'http://weather.gov/data/current_obs/KSDY.xml'),
('KWEY', 'MT', 'West Yellowston', 44.660000, -111.100000, 'http://weather.noaa.gov/weather/current/KWEY.html', 'http://weather.gov/data/current_obs/KWEY.rss', 'http://weather.gov/data/current_obs/KWEY.xml'),
('KWYS', 'MT', 'West Yellowstone', 44.683000, -111.117000, 'http://weather.noaa.gov/weather/current/KWYS.html', 'http://weather.gov/data/current_obs/KWYS.rss', 'http://weather.gov/data/current_obs/KWYS.xml'),
('MMUN', 'MX', 'Cancun Mexico', 21.030000, -86.870000, 'http://weather.noaa.gov/weather/current/MMUN.html', 'http://weather.gov/data/current_obs/MMUN.rss', 'http://weather.gov/data/current_obs/MMUN.xml'),
('MMCS', 'MX', 'MMCS Ob Site', 31.633000, -106.417000, 'http://weather.noaa.gov/weather/current/MMCS.html', 'http://weather.gov/data/current_obs/MMCS.rss', 'http://weather.gov/data/current_obs/MMCS.xml'),
('K1A5', 'NC', 'Franklin/Macon County Airport', 35.217000, -83.417000, 'http://weather.noaa.gov/weather/current/K1A5.html', 'http://weather.gov/data/current_obs/K1A5.rss', 'http://weather.gov/data/current_obs/K1A5.xml'),
('K45J', 'NC', 'Rockingham', 34.883000, -79.750000, 'http://weather.noaa.gov/weather/current/K45J.html', 'http://weather.gov/data/current_obs/K45J.rss', 'http://weather.gov/data/current_obs/K45J.xml'),
('KAKH', 'NC', 'Gastonia Municipal Airport', 35.200000, -81.150000, 'http://weather.noaa.gov/weather/current/KAKH.html', 'http://weather.gov/data/current_obs/KAKH.rss', 'http://weather.gov/data/current_obs/KAKH.xml'),
('KASJ', 'NC', 'Ahoskie, Tri-County Airport', 36.300000, -77.170000, 'http://weather.noaa.gov/weather/current/KASJ.html', 'http://weather.gov/data/current_obs/KASJ.rss', 'http://weather.gov/data/current_obs/KASJ.xml'),
('KAVL', 'NC', 'Asheville Regional Airport', 35.440000, -82.550000, 'http://weather.noaa.gov/weather/current/KAVL.html', 'http://weather.gov/data/current_obs/KAVL.rss', 'http://weather.gov/data/current_obs/KAVL.xml'),
('KBUY', 'NC', 'Burlington Alamance Regional Airport', 36.050000, -79.470000, 'http://weather.noaa.gov/weather/current/KBUY.html', 'http://weather.gov/data/current_obs/KBUY.rss', 'http://weather.gov/data/current_obs/KBUY.xml'),
('KCLT', 'NC', 'Charlotte/Douglas International Airport', 35.210000, -80.940000, 'http://weather.noaa.gov/weather/current/KCLT.html', 'http://weather.gov/data/current_obs/KCLT.rss', 'http://weather.gov/data/current_obs/KCLT.xml'),
('KCPC', 'NC', 'Whiteville-Columbus Co Muni Airport', 34.280000, -78.710000, 'http://weather.noaa.gov/weather/current/KCPC.html', 'http://weather.gov/data/current_obs/KCPC.rss', 'http://weather.gov/data/current_obs/KCPC.xml'),
('KCTZ', 'NC', 'Sampson County Airport', 34.983000, -78.367000, 'http://weather.noaa.gov/weather/current/KCTZ.html', 'http://weather.gov/data/current_obs/KCTZ.rss', 'http://weather.gov/data/current_obs/KCTZ.xml'),
('KDPL', 'NC', 'Kenansville, Duplin County Airport', 35.000000, -77.980000, 'http://weather.noaa.gov/weather/current/KDPL.html', 'http://weather.gov/data/current_obs/KDPL.rss', 'http://weather.gov/data/current_obs/KDPL.xml'),
('KECG', 'NC', 'Elizabeth City Coast Guard Air Sta', 36.260000, -76.170000, 'http://weather.noaa.gov/weather/current/KECG.html', 'http://weather.gov/data/current_obs/KECG.rss', 'http://weather.gov/data/current_obs/KECG.xml'),
('KEDE', 'NC', 'Edenton, Northeastern Regional Airport', 36.030000, -76.570000, 'http://weather.noaa.gov/weather/current/KEDE.html', 'http://weather.gov/data/current_obs/KEDE.rss', 'http://weather.gov/data/current_obs/KEDE.xml'),
('KEHO', 'NC', 'Shelby Municipal Airport', 35.250000, -81.600000, 'http://weather.noaa.gov/weather/current/KEHO.html', 'http://weather.gov/data/current_obs/KEHO.rss', 'http://weather.gov/data/current_obs/KEHO.xml'),
('KEQY', 'NC', 'Monroe Airport', 35.017000, -80.617000, 'http://weather.noaa.gov/weather/current/KEQY.html', 'http://weather.gov/data/current_obs/KEQY.rss', 'http://weather.gov/data/current_obs/KEQY.xml'),
('KEWN', 'NC', 'New Bern, Craven County Regional Airport', 35.090000, -77.050000, 'http://weather.noaa.gov/weather/current/KEWN.html', 'http://weather.gov/data/current_obs/KEWN.rss', 'http://weather.gov/data/current_obs/KEWN.xml'),
('KEXX', 'NC', 'Lexington, Davidson County Airport', 35.783000, -80.300000, 'http://weather.noaa.gov/weather/current/KEXX.html', 'http://weather.gov/data/current_obs/KEXX.rss', 'http://weather.gov/data/current_obs/KEXX.xml'),
('KEYF', 'NC', 'Elizabethtown-Curtis L Brown Field Airport', 34.602000, -78.579000, 'http://weather.noaa.gov/weather/current/KEYF.html', 'http://weather.gov/data/current_obs/KEYF.rss', 'http://weather.gov/data/current_obs/KEYF.xml'),
('KFAY', 'NC', 'Fayetteville Regional Airport', 34.990000, -78.880000, 'http://weather.noaa.gov/weather/current/KFAY.html', 'http://weather.gov/data/current_obs/KFAY.rss', 'http://weather.gov/data/current_obs/KFAY.xml'),
('KFBG', 'NC', 'Fort Bragg / Simmons Army Airfield', 35.140000, -78.930000, 'http://weather.noaa.gov/weather/current/KFBG.html', 'http://weather.gov/data/current_obs/KFBG.rss', 'http://weather.gov/data/current_obs/KFBG.xml'),
('KFFA', 'NC', 'First Flight Airport', 36.017000, -75.667000, 'http://weather.noaa.gov/weather/current/KFFA.html', 'http://weather.gov/data/current_obs/KFFA.rss', 'http://weather.gov/data/current_obs/KFFA.xml'),
('KFQD', 'NC', 'Rutherfordton/Rutherford Co-Marchman Field Airport', 35.430000, -81.940000, 'http://weather.noaa.gov/weather/current/KFQD.html', 'http://weather.gov/data/current_obs/KFQD.rss', 'http://weather.gov/data/current_obs/KFQD.xml'),
('KGEV', 'NC', 'Jefferson, Ashe County Airport', 36.430000, -81.420000, 'http://weather.noaa.gov/weather/current/KGEV.html', 'http://weather.gov/data/current_obs/KGEV.rss', 'http://weather.gov/data/current_obs/KGEV.xml'),
('KGSB', 'NC', 'Seymour-Johnson Air Force Base', 35.340000, -77.970000, 'http://weather.noaa.gov/weather/current/KGSB.html', 'http://weather.gov/data/current_obs/KGSB.rss', 'http://weather.gov/data/current_obs/KGSB.xml'),
('KGSO', 'NC', 'Greensboro, Piedmont Triad International Airport', 36.010000, -79.950000, 'http://weather.noaa.gov/weather/current/KGSO.html', 'http://weather.gov/data/current_obs/KGSO.rss', 'http://weather.gov/data/current_obs/KGSO.xml'),
('KGWW', 'NC', 'Goldsboro-Wayne Muni Airport', 35.460000, -77.960000, 'http://weather.noaa.gov/weather/current/KGWW.html', 'http://weather.gov/data/current_obs/KGWW.rss', 'http://weather.gov/data/current_obs/KGWW.xml'),
('KHBI', 'NC', 'Asheboro Municipal Airport', 35.650000, -79.900000, 'http://weather.noaa.gov/weather/current/KHBI.html', 'http://weather.gov/data/current_obs/KHBI.rss', 'http://weather.gov/data/current_obs/KHBI.xml'),
('KHFF', 'NC', 'Mackall U. S. Army Airfield', 35.033000, -79.500000, 'http://weather.noaa.gov/weather/current/KHFF.html', 'http://weather.gov/data/current_obs/KHFF.rss', 'http://weather.gov/data/current_obs/KHFF.xml'),
('KHKY', 'NC', 'Hickory Regional Airport', 35.760000, -81.380000, 'http://weather.noaa.gov/weather/current/KHKY.html', 'http://weather.gov/data/current_obs/KHKY.rss', 'http://weather.gov/data/current_obs/KHKY.xml'),
('KHNZ', 'NC', 'Henderson-Oxford Airport', 36.360000, -78.530000, 'http://weather.noaa.gov/weather/current/KHNZ.html', 'http://weather.gov/data/current_obs/KHNZ.rss', 'http://weather.gov/data/current_obs/KHNZ.xml'),
('KHRJ', 'NC', 'Erwin, Harnett County Airport', 35.380000, -78.730000, 'http://weather.noaa.gov/weather/current/KHRJ.html', 'http://weather.gov/data/current_obs/KHRJ.rss', 'http://weather.gov/data/current_obs/KHRJ.xml'),
('KHSE', 'NC', 'Hatteras, Mitchell Field', 35.220000, -75.620000, 'http://weather.noaa.gov/weather/current/KHSE.html', 'http://weather.gov/data/current_obs/KHSE.rss', 'http://weather.gov/data/current_obs/KHSE.xml'),
('KHSS', 'NC', 'Hot Springs Aviation Weather Reporting Station', 35.900000, -82.817000, 'http://weather.noaa.gov/weather/current/KHSS.html', 'http://weather.gov/data/current_obs/KHSS.rss', 'http://weather.gov/data/current_obs/KHSS.xml'),
('KIGX', 'NC', 'Chapel Hill, Williams Airport', 35.940000, -79.070000, 'http://weather.noaa.gov/weather/current/KIGX.html', 'http://weather.gov/data/current_obs/KIGX.rss', 'http://weather.gov/data/current_obs/KIGX.xml'),
('KILM', 'NC', 'Wilmington, New Hanover International Airport', 34.280000, -77.920000, 'http://weather.noaa.gov/weather/current/KILM.html', 'http://weather.gov/data/current_obs/KILM.rss', 'http://weather.gov/data/current_obs/KILM.xml'),
('KINT', 'NC', 'Winston Salem, Smith Reynolds Airport', 36.130000, -80.220000, 'http://weather.noaa.gov/weather/current/KINT.html', 'http://weather.gov/data/current_obs/KINT.rss', 'http://weather.gov/data/current_obs/KINT.xml'),
('KIPJ', 'NC', 'Lincolnton-Lincoln County Regional Airport', 35.483000, -81.167000, 'http://weather.noaa.gov/weather/current/KIPJ.html', 'http://weather.gov/data/current_obs/KIPJ.rss', 'http://weather.gov/data/current_obs/KIPJ.xml'),
('KISO', 'NC', 'Kinston / Stallings', 35.330000, -77.630000, 'http://weather.noaa.gov/weather/current/KISO.html', 'http://weather.gov/data/current_obs/KISO.rss', 'http://weather.gov/data/current_obs/KISO.xml'),
('KJNX', 'NC', 'Smithfield, Johnston County Airport', 35.541000, -78.390000, 'http://weather.noaa.gov/weather/current/KJNX.html', 'http://weather.gov/data/current_obs/KJNX.rss', 'http://weather.gov/data/current_obs/KJNX.xml'),
('KJQF', 'NC', 'Concord Regional Airport', 35.390000, -80.710000, 'http://weather.noaa.gov/weather/current/KJQF.html', 'http://weather.gov/data/current_obs/KJQF.rss', 'http://weather.gov/data/current_obs/KJQF.xml'),
('KLBT', 'NC', 'Lumberton Municipal Airport', 34.610000, -79.060000, 'http://weather.noaa.gov/weather/current/KLBT.html', 'http://weather.gov/data/current_obs/KLBT.rss', 'http://weather.gov/data/current_obs/KLBT.xml'),
('KLHZ', 'NC', 'Louisburg', 36.023000, -78.330000, 'http://weather.noaa.gov/weather/current/KLHZ.html', 'http://weather.gov/data/current_obs/KLHZ.rss', 'http://weather.gov/data/current_obs/KLHZ.xml'),
('KMEB', 'NC', 'Laurinburg-Maxton Airport', 34.790000, -79.370000, 'http://weather.noaa.gov/weather/current/KMEB.html', 'http://weather.gov/data/current_obs/KMEB.rss', 'http://weather.gov/data/current_obs/KMEB.xml');

INSERT INTO `#__zweather_stations` (`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES
('KMQI', 'NC', 'Manteo / Dare County Regional', 35.920000, -75.700000, 'http://weather.noaa.gov/weather/current/KMQI.html', 'http://weather.gov/data/current_obs/KMQI.rss', 'http://weather.gov/data/current_obs/KMQI.xml'),
('KMRH', 'NC', 'Beaufort, Michael J Smith Field Airport', 34.717000, -76.650000, 'http://weather.noaa.gov/weather/current/KMRH.html', 'http://weather.gov/data/current_obs/KMRH.rss', 'http://weather.gov/data/current_obs/KMRH.xml'),
('KMRN', 'NC', 'Morganton-Lenoir Airport', 35.820000, -81.610000, 'http://weather.noaa.gov/weather/current/KMRN.html', 'http://weather.gov/data/current_obs/KMRN.rss', 'http://weather.gov/data/current_obs/KMRN.xml'),
('KMWK', 'NC', 'Mount Airy / Surry County Airport', 36.460000, -80.550000, 'http://weather.noaa.gov/weather/current/KMWK.html', 'http://weather.gov/data/current_obs/KMWK.rss', 'http://weather.gov/data/current_obs/KMWK.xml'),
('KNCA', 'NC', 'Jacksonville, New River, Marine Corps Air Station', 34.710000, -77.430000, 'http://weather.noaa.gov/weather/current/KNCA.html', 'http://weather.gov/data/current_obs/KNCA.rss', 'http://weather.gov/data/current_obs/KNCA.xml'),
('KNKT', 'NC', 'Cherry Point, Marine Corps Air Station', 34.860000, -76.880000, 'http://weather.noaa.gov/weather/current/KNKT.html', 'http://weather.gov/data/current_obs/KNKT.rss', 'http://weather.gov/data/current_obs/KNKT.xml'),
('KOAJ', 'NC', 'Jacksonville Automatic Weather Observing/Reporting', 34.830000, -77.620000, 'http://weather.noaa.gov/weather/current/KOAJ.html', 'http://weather.gov/data/current_obs/KOAJ.rss', 'http://weather.gov/data/current_obs/KOAJ.xml'),
('KOCW', 'NC', 'Washington, Warren Field Airport', 35.570000, -77.050000, 'http://weather.noaa.gov/weather/current/KOCW.html', 'http://weather.gov/data/current_obs/KOCW.rss', 'http://weather.gov/data/current_obs/KOCW.xml'),
('KPGV', 'NC', 'Pitt-Greenville Airport', 35.630000, -77.400000, 'http://weather.noaa.gov/weather/current/KPGV.html', 'http://weather.gov/data/current_obs/KPGV.rss', 'http://weather.gov/data/current_obs/KPGV.xml'),
('KPOB', 'NC', 'Pope Air Force Base', 35.180000, -79.020000, 'http://weather.noaa.gov/weather/current/KPOB.html', 'http://weather.gov/data/current_obs/KPOB.rss', 'http://weather.gov/data/current_obs/KPOB.xml'),
('KRDU', 'NC', 'Raleigh-Durham International Airport', 35.880000, -78.780000, 'http://weather.noaa.gov/weather/current/KRDU.html', 'http://weather.gov/data/current_obs/KRDU.rss', 'http://weather.gov/data/current_obs/KRDU.xml'),
('KRHP', 'NC', 'Andrews-Murphy Airport', 35.190000, -83.860000, 'http://weather.noaa.gov/weather/current/KRHP.html', 'http://weather.gov/data/current_obs/KRHP.rss', 'http://weather.gov/data/current_obs/KRHP.xml'),
('KRUQ', 'NC', 'Salisbury, Rowan County Airport', 35.650000, -80.517000, 'http://weather.noaa.gov/weather/current/KRUQ.html', 'http://weather.gov/data/current_obs/KRUQ.rss', 'http://weather.gov/data/current_obs/KRUQ.xml'),
('KRWI', 'NC', 'Rocky Mount-Wilson Regional Airport', 35.860000, -77.880000, 'http://weather.noaa.gov/weather/current/KRWI.html', 'http://weather.gov/data/current_obs/KRWI.rss', 'http://weather.gov/data/current_obs/KRWI.xml'),
('KRZZ', 'NC', 'Roanoke Rapids, Halifax County Airport', 36.440000, -77.710000, 'http://weather.noaa.gov/weather/current/KRZZ.html', 'http://weather.gov/data/current_obs/KRZZ.rss', 'http://weather.gov/data/current_obs/KRZZ.xml'),
('KSOP', 'NC', 'Southern Pines Automatic Weather Observing/Report', 35.240000, -79.410000, 'http://weather.noaa.gov/weather/current/KSOP.html', 'http://weather.gov/data/current_obs/KSOP.rss', 'http://weather.gov/data/current_obs/KSOP.xml'),
('KSUT', 'NC', 'Brunswick County Airport', 33.930000, -78.070000, 'http://weather.noaa.gov/weather/current/KSUT.html', 'http://weather.gov/data/current_obs/KSUT.rss', 'http://weather.gov/data/current_obs/KSUT.xml'),
('KSVH', 'NC', 'Statesville Municipal Airport', 35.760000, -80.960000, 'http://weather.noaa.gov/weather/current/KSVH.html', 'http://weather.gov/data/current_obs/KSVH.rss', 'http://weather.gov/data/current_obs/KSVH.xml'),
('KTDF', 'NC', 'Roxboro, Person County Airport', 36.285000, -78.984000, 'http://weather.noaa.gov/weather/current/KTDF.html', 'http://weather.gov/data/current_obs/KTDF.rss', 'http://weather.gov/data/current_obs/KTDF.xml'),
('KTNB', 'NC', 'Boone, Watauga County Hospital Heliport', 36.199000, -81.651000, 'http://weather.noaa.gov/weather/current/KTNB.html', 'http://weather.gov/data/current_obs/KTNB.rss', 'http://weather.gov/data/current_obs/KTNB.xml'),
('KTTA', 'NC', 'Sanford-Lee County Regional Airport', 35.580000, -79.100000, 'http://weather.noaa.gov/weather/current/KTTA.html', 'http://weather.gov/data/current_obs/KTTA.rss', 'http://weather.gov/data/current_obs/KTTA.xml'),
('KUKF', 'NC', 'North Wilkesboro, Wilkes County Airport', 36.220000, -81.100000, 'http://weather.noaa.gov/weather/current/KUKF.html', 'http://weather.gov/data/current_obs/KUKF.rss', 'http://weather.gov/data/current_obs/KUKF.xml'),
('KVUJ', 'NC', 'Albemarle, Stanly County Airport', 35.417000, -80.151000, 'http://weather.noaa.gov/weather/current/KVUJ.html', 'http://weather.gov/data/current_obs/KVUJ.rss', 'http://weather.gov/data/current_obs/KVUJ.xml'),
('KBIS', 'ND', 'Bismarck Municipal Airport', 46.780000, -100.750000, 'http://weather.noaa.gov/weather/current/KBIS.html', 'http://weather.gov/data/current_obs/KBIS.rss', 'http://weather.gov/data/current_obs/KBIS.xml'),
('KBWP', 'ND', 'Harry Stern Airport', 46.233000, -96.600000, 'http://weather.noaa.gov/weather/current/KBWP.html', 'http://weather.gov/data/current_obs/KBWP.rss', 'http://weather.gov/data/current_obs/KBWP.xml'),
('KDVL', 'ND', 'Devils Lake Automatic Weather Observing/Reporting', 48.120000, -98.900000, 'http://weather.noaa.gov/weather/current/KDVL.html', 'http://weather.gov/data/current_obs/KDVL.rss', 'http://weather.gov/data/current_obs/KDVL.xml'),
('KFAR', 'ND', 'Fargo, Hector International Airport', 46.910000, -96.800000, 'http://weather.noaa.gov/weather/current/KFAR.html', 'http://weather.gov/data/current_obs/KFAR.rss', 'http://weather.gov/data/current_obs/KFAR.xml'),
('KGFK', 'ND', 'Grand Forks International Airport', 47.960000, -97.180000, 'http://weather.noaa.gov/weather/current/KGFK.html', 'http://weather.gov/data/current_obs/KGFK.rss', 'http://weather.gov/data/current_obs/KGFK.xml'),
('KISN', 'ND', 'Williston, Sloulin Field International Airport', 48.160000, -103.600000, 'http://weather.noaa.gov/weather/current/KISN.html', 'http://weather.gov/data/current_obs/KISN.rss', 'http://weather.gov/data/current_obs/KISN.xml'),
('KJMS', 'ND', 'Jamestown Municipal Airport', 46.930000, -98.680000, 'http://weather.noaa.gov/weather/current/KJMS.html', 'http://weather.gov/data/current_obs/KJMS.rss', 'http://weather.gov/data/current_obs/KJMS.xml'),
('KMIB', 'ND', 'Minot Air Force Base', 48.417000, -101.350000, 'http://weather.noaa.gov/weather/current/KMIB.html', 'http://weather.gov/data/current_obs/KMIB.rss', 'http://weather.gov/data/current_obs/KMIB.xml'),
('KMOT', 'ND', 'Minot International Airport', 48.280000, -101.280000, 'http://weather.noaa.gov/weather/current/KMOT.html', 'http://weather.gov/data/current_obs/KMOT.rss', 'http://weather.gov/data/current_obs/KMOT.xml'),
('KN60', 'ND', 'Garrison', 47.610000, -101.400000, 'http://weather.noaa.gov/weather/current/KN60.html', 'http://weather.gov/data/current_obs/KN60.rss', 'http://weather.gov/data/current_obs/KN60.xml'),
('KRDR', 'ND', 'Grand Forks Air Force Base', 47.933000, -97.383000, 'http://weather.noaa.gov/weather/current/KRDR.html', 'http://weather.gov/data/current_obs/KRDR.rss', 'http://weather.gov/data/current_obs/KRDR.xml'),
('KDIK', 'ND', 'Dickinson Theodore Roosevelt Regional Airport', 46.790000, -102.800000, 'http://weather.noaa.gov/weather/current/KDIK.html', 'http://weather.gov/data/current_obs/KDIK.rss', 'http://weather.gov/data/current_obs/KDIK.xml'),
('KHEI', 'ND', 'Hettinger Municipal Airport', 46.000000, -102.650000, 'http://weather.noaa.gov/weather/current/KHEI.html', 'http://weather.gov/data/current_obs/KHEI.rss', 'http://weather.gov/data/current_obs/KHEI.xml'),
('KAFK', 'NE', 'Nebraska City Municipal Airport', 40.600000, -95.870000, 'http://weather.noaa.gov/weather/current/KAFK.html', 'http://weather.gov/data/current_obs/KAFK.rss', 'http://weather.gov/data/current_obs/KAFK.xml'),
('KANW', 'NE', 'Ainsworth Municipal', 42.590000, -99.990000, 'http://weather.noaa.gov/weather/current/KANW.html', 'http://weather.gov/data/current_obs/KANW.rss', 'http://weather.gov/data/current_obs/KANW.xml'),
('KAUH', 'NE', 'Aurora Municipal Airport', 40.880000, -98.000000, 'http://weather.noaa.gov/weather/current/KAUH.html', 'http://weather.gov/data/current_obs/KAUH.rss', 'http://weather.gov/data/current_obs/KAUH.xml'),
('KBBW', 'NE', 'Broken Bow Municipal Airport', 41.440000, -99.660000, 'http://weather.noaa.gov/weather/current/KBBW.html', 'http://weather.gov/data/current_obs/KBBW.rss', 'http://weather.gov/data/current_obs/KBBW.xml'),
('KBIE', 'NE', 'Beatrice Municipal', 40.300000, -96.750000, 'http://weather.noaa.gov/weather/current/KBIE.html', 'http://weather.gov/data/current_obs/KBIE.rss', 'http://weather.gov/data/current_obs/KBIE.xml'),
('KBVN', 'NE', 'Albion Municipal Airport', 41.733000, -98.050000, 'http://weather.noaa.gov/weather/current/KBVN.html', 'http://weather.gov/data/current_obs/KBVN.rss', 'http://weather.gov/data/current_obs/KBVN.xml'),
('KCZD', 'NE', 'Cozad Municipal Airport', 40.867000, -100.000000, 'http://weather.noaa.gov/weather/current/KCZD.html', 'http://weather.gov/data/current_obs/KCZD.rss', 'http://weather.gov/data/current_obs/KCZD.xml'),
('KEAR', 'NE', 'Kearney Municipal Automatic Weather Observing', 40.730000, -99.000000, 'http://weather.noaa.gov/weather/current/KEAR.html', 'http://weather.gov/data/current_obs/KEAR.rss', 'http://weather.gov/data/current_obs/KEAR.xml'),
('KFET', 'NE', 'Fremont Municipal Airport', 41.450000, -96.530000, 'http://weather.noaa.gov/weather/current/KFET.html', 'http://weather.gov/data/current_obs/KFET.rss', 'http://weather.gov/data/current_obs/KFET.xml'),
('KFNB', 'NE', 'Falls City, Brenner Field Airport', 40.080000, -95.580000, 'http://weather.noaa.gov/weather/current/KFNB.html', 'http://weather.gov/data/current_obs/KFNB.rss', 'http://weather.gov/data/current_obs/KFNB.xml'),
('KGRI', 'NE', 'Grand Island, Central Nebraska Regional Airport', 40.980000, -98.320000, 'http://weather.noaa.gov/weather/current/KGRI.html', 'http://weather.gov/data/current_obs/KGRI.rss', 'http://weather.gov/data/current_obs/KGRI.xml'),
('KHDE', 'NE', 'Brewster Field Airport', 40.450000, -99.330000, 'http://weather.noaa.gov/weather/current/KHDE.html', 'http://weather.gov/data/current_obs/KHDE.rss', 'http://weather.gov/data/current_obs/KHDE.xml'),
('KHJH', 'NE', 'Hebron Municipal Airport', 40.152000, -97.587000, 'http://weather.noaa.gov/weather/current/KHJH.html', 'http://weather.gov/data/current_obs/KHJH.rss', 'http://weather.gov/data/current_obs/KHJH.xml'),
('KHSI', 'NE', 'Hastings Municipal Airport', 40.610000, -98.430000, 'http://weather.noaa.gov/weather/current/KHSI.html', 'http://weather.gov/data/current_obs/KHSI.rss', 'http://weather.gov/data/current_obs/KHSI.xml'),
('KJYR', 'NE', 'York Municipal Airport', 40.900000, -97.620000, 'http://weather.noaa.gov/weather/current/KJYR.html', 'http://weather.gov/data/current_obs/KJYR.rss', 'http://weather.gov/data/current_obs/KJYR.xml'),
('KLBF', 'NE', 'North Platte Regional Airport', 41.140000, -100.680000, 'http://weather.noaa.gov/weather/current/KLBF.html', 'http://weather.gov/data/current_obs/KLBF.rss', 'http://weather.gov/data/current_obs/KLBF.xml'),
('KLCG', 'NE', 'Wayne Municipal Airport', 42.242000, -96.981000, 'http://weather.noaa.gov/weather/current/KLCG.html', 'http://weather.gov/data/current_obs/KLCG.rss', 'http://weather.gov/data/current_obs/KLCG.xml'),
('KLNK', 'NE', 'Lincoln Municipal Airport', 40.860000, -96.750000, 'http://weather.noaa.gov/weather/current/KLNK.html', 'http://weather.gov/data/current_obs/KLNK.rss', 'http://weather.gov/data/current_obs/KLNK.xml'),
('KLXN', 'NE', 'Lexington, Jim Kelly Field Airport', 40.780000, -99.770000, 'http://weather.noaa.gov/weather/current/KLXN.html', 'http://weather.gov/data/current_obs/KLXN.rss', 'http://weather.gov/data/current_obs/KLXN.xml'),
('KMCK', 'NE', 'McCook Municipal Airport', 40.230000, -100.580000, 'http://weather.noaa.gov/weather/current/KMCK.html', 'http://weather.gov/data/current_obs/KMCK.rss', 'http://weather.gov/data/current_obs/KMCK.xml'),
('KMHN', 'NE', 'Mullen / Hooker County', 42.050000, -101.067000, 'http://weather.noaa.gov/weather/current/KMHN.html', 'http://weather.gov/data/current_obs/KMHN.rss', 'http://weather.gov/data/current_obs/KMHN.xml'),
('KMLE', 'NE', 'Millard Airport', 41.196000, -96.112000, 'http://weather.noaa.gov/weather/current/KMLE.html', 'http://weather.gov/data/current_obs/KMLE.rss', 'http://weather.gov/data/current_obs/KMLE.xml'),
('KODX', 'NE', 'Ord, Evelyn Sharp Field Airport', 41.620000, -98.950000, 'http://weather.noaa.gov/weather/current/KODX.html', 'http://weather.gov/data/current_obs/KODX.rss', 'http://weather.gov/data/current_obs/KODX.xml'),
('KOFF', 'NE', 'Omaha / Offutt Air Force Base', 41.117000, -95.917000, 'http://weather.noaa.gov/weather/current/KOFF.html', 'http://weather.gov/data/current_obs/KOFF.rss', 'http://weather.gov/data/current_obs/KOFF.xml'),
('KOFK', 'NE', 'Norfolk, Stefan Memorial Airport', 41.980000, -97.430000, 'http://weather.noaa.gov/weather/current/KOFK.html', 'http://weather.gov/data/current_obs/KOFK.rss', 'http://weather.gov/data/current_obs/KOFK.xml'),
('KOLU', 'NE', 'Columbus Municipal Automatic Weather Observing', 41.460000, -97.350000, 'http://weather.noaa.gov/weather/current/KOLU.html', 'http://weather.gov/data/current_obs/KOLU.rss', 'http://weather.gov/data/current_obs/KOLU.xml'),
('KOMA', 'NE', 'Omaha, Eppley Airfield', 41.300000, -95.900000, 'http://weather.noaa.gov/weather/current/KOMA.html', 'http://weather.gov/data/current_obs/KOMA.rss', 'http://weather.gov/data/current_obs/KOMA.xml'),
('KONL', 'NE', 'O Neill (Baker Field)', 42.480000, -98.680000, 'http://weather.noaa.gov/weather/current/KONL.html', 'http://weather.gov/data/current_obs/KONL.rss', 'http://weather.gov/data/current_obs/KONL.xml'),
('KTIF', 'NE', 'Thomas County Airport', 41.962000, -100.569000, 'http://weather.noaa.gov/weather/current/KTIF.html', 'http://weather.gov/data/current_obs/KTIF.rss', 'http://weather.gov/data/current_obs/KTIF.xml'),
('KTQE', 'NE', 'Tekamah Municipal Airport', 41.710000, -96.100000, 'http://weather.noaa.gov/weather/current/KTQE.html', 'http://weather.gov/data/current_obs/KTQE.rss', 'http://weather.gov/data/current_obs/KTQE.xml'),
('KVTN', 'NE', 'Valentine, Miller Field', 42.860000, -100.550000, 'http://weather.noaa.gov/weather/current/KVTN.html', 'http://weather.gov/data/current_obs/KVTN.rss', 'http://weather.gov/data/current_obs/KVTN.xml'),
('KAIA', 'NE', 'Alliance Municipal Airport', 42.050000, -102.800000, 'http://weather.noaa.gov/weather/current/KAIA.html', 'http://weather.gov/data/current_obs/KAIA.rss', 'http://weather.gov/data/current_obs/KAIA.xml'),
('KBFF', 'NE', 'Scottsbluff, Heilig Field', 41.880000, -103.600000, 'http://weather.noaa.gov/weather/current/KBFF.html', 'http://weather.gov/data/current_obs/KBFF.rss', 'http://weather.gov/data/current_obs/KBFF.xml'),
('KCDR', 'NE', 'Chadron Municipal Airport', 42.840000, -103.080000, 'http://weather.noaa.gov/weather/current/KCDR.html', 'http://weather.gov/data/current_obs/KCDR.rss', 'http://weather.gov/data/current_obs/KCDR.xml'),
('KIBM', 'NE', 'Kimball Municipal Airport', 41.188000, -103.677000, 'http://weather.noaa.gov/weather/current/KIBM.html', 'http://weather.gov/data/current_obs/KIBM.rss', 'http://weather.gov/data/current_obs/KIBM.xml'),
('KIML', 'NE', 'Imperial Municipal Airport', 40.540000, -101.630000, 'http://weather.noaa.gov/weather/current/KIML.html', 'http://weather.gov/data/current_obs/KIML.rss', 'http://weather.gov/data/current_obs/KIML.xml'),
('KOGA', 'NE', 'Ogallala, Searle Field Airport', 41.050000, -101.800000, 'http://weather.noaa.gov/weather/current/KOGA.html', 'http://weather.gov/data/current_obs/KOGA.rss', 'http://weather.gov/data/current_obs/KOGA.xml'),
('KSNY', 'NE', 'Sidney Municipal Airport', 41.110000, -102.980000, 'http://weather.noaa.gov/weather/current/KSNY.html', 'http://weather.gov/data/current_obs/KSNY.rss', 'http://weather.gov/data/current_obs/KSNY.xml'),
('KK46', 'NE', 'Blair Municipal Airport', 41.418100, -96.113600, 'http://weather.noaa.gov/weather/current/KK46.html', 'http://weather.gov/data/current_obs/KK46.rss', 'http://weather.gov/data/current_obs/KK46.xml'),
('KPMV', 'NE', 'Plattsmouth Municipal Airport', 40.948400, -95.917400, 'http://weather.noaa.gov/weather/current/KPMV.html', 'http://weather.gov/data/current_obs/KPMV.rss', 'http://weather.gov/data/current_obs/KPMV.xml'),
('KAFN', 'NH', 'Jaffrey Municipal-Silver Ranch Airport', 42.800000, -72.000000, 'http://weather.noaa.gov/weather/current/KAFN.html', 'http://weather.gov/data/current_obs/KAFN.rss', 'http://weather.gov/data/current_obs/KAFN.xml'),
('KASH', 'NH', 'Nashua / Boire Field', 42.790000, -71.520000, 'http://weather.noaa.gov/weather/current/KASH.html', 'http://weather.gov/data/current_obs/KASH.rss', 'http://weather.gov/data/current_obs/KASH.xml'),
('KBML', 'NH', 'Berlin Municipal Airport', 44.590000, -71.180000, 'http://weather.noaa.gov/weather/current/KBML.html', 'http://weather.gov/data/current_obs/KBML.rss', 'http://weather.gov/data/current_obs/KBML.xml'),
('KCON', 'NH', 'Concord Municipal Airport', 43.210000, -71.500000, 'http://weather.noaa.gov/weather/current/KCON.html', 'http://weather.gov/data/current_obs/KCON.rss', 'http://weather.gov/data/current_obs/KCON.xml'),
('KDAW', 'NH', 'Rochester, Skyhaven Airport', 43.278000, -79.922000, 'http://weather.noaa.gov/weather/current/KDAW.html', 'http://weather.gov/data/current_obs/KDAW.rss', 'http://weather.gov/data/current_obs/KDAW.xml'),
('KEEN', 'NH', 'Keene / Dillant Automatic Weather Observing/Report', 42.910000, -72.270000, 'http://weather.noaa.gov/weather/current/KEEN.html', 'http://weather.gov/data/current_obs/KEEN.rss', 'http://weather.gov/data/current_obs/KEEN.xml'),
('KHIE', 'NH', 'Whitefield, Mount Washington Regional Airport', 44.360000, -71.530000, 'http://weather.noaa.gov/weather/current/KHIE.html', 'http://weather.gov/data/current_obs/KHIE.rss', 'http://weather.gov/data/current_obs/KHIE.xml'),
('KLCI', 'NH', 'Laconia Municipal Automatic Weather Observing', 43.580000, -71.430000, 'http://weather.noaa.gov/weather/current/KLCI.html', 'http://weather.gov/data/current_obs/KLCI.rss', 'http://weather.gov/data/current_obs/KLCI.xml'),
('KLEB', 'NH', 'Lebanon Municipal Airport', 43.630000, -72.300000, 'http://weather.noaa.gov/weather/current/KLEB.html', 'http://weather.gov/data/current_obs/KLEB.rss', 'http://weather.gov/data/current_obs/KLEB.xml'),
('KMHT', 'NH', 'Manchester Airport', 42.940000, -71.430000, 'http://weather.noaa.gov/weather/current/KMHT.html', 'http://weather.gov/data/current_obs/KMHT.rss', 'http://weather.gov/data/current_obs/KMHT.xml'),
('KMWN', 'NH', 'Mount Washington', 44.280000, -71.300000, 'http://weather.noaa.gov/weather/current/KMWN.html', 'http://weather.gov/data/current_obs/KMWN.rss', 'http://weather.gov/data/current_obs/KMWN.xml'),
('KPSM', 'NH', 'Pease Air Force Base / Portsmouth', 43.090000, -70.820000, 'http://weather.noaa.gov/weather/current/KPSM.html', 'http://weather.gov/data/current_obs/KPSM.rss', 'http://weather.gov/data/current_obs/KPSM.xml'),
('K1P1', 'NH', 'Plymouth Municipal Airport', 43.780000, -71.530000, 'http://weather.noaa.gov/weather/current/K1P1.html', 'http://weather.gov/data/current_obs/K1P1.rss', 'http://weather.gov/data/current_obs/K1P1.xml'),
('K12N', 'NJ', 'Aeroflex-Andover Airport', 41.010000, -74.740000, 'http://weather.noaa.gov/weather/current/K12N.html', 'http://weather.gov/data/current_obs/K12N.rss', 'http://weather.gov/data/current_obs/K12N.xml'),
('KACY', 'NJ', 'Atlantic City International Airport', 39.460000, -74.570000, 'http://weather.noaa.gov/weather/current/KACY.html', 'http://weather.gov/data/current_obs/KACY.rss', 'http://weather.gov/data/current_obs/KACY.xml'),
('KBLM', 'NJ', 'Belmar-Farmingdale', 40.180000, -74.130000, 'http://weather.noaa.gov/weather/current/KBLM.html', 'http://weather.gov/data/current_obs/KBLM.rss', 'http://weather.gov/data/current_obs/KBLM.xml'),
('KCDW', 'NJ', 'Caldwell, Essex County Airport', 40.880000, -74.280000, 'http://weather.noaa.gov/weather/current/KCDW.html', 'http://weather.gov/data/current_obs/KCDW.rss', 'http://weather.gov/data/current_obs/KCDW.xml'),
('KEWR', 'NJ', 'Newark International Airport', 40.710000, -74.170000, 'http://weather.noaa.gov/weather/current/KEWR.html', 'http://weather.gov/data/current_obs/KEWR.rss', 'http://weather.gov/data/current_obs/KEWR.xml'),
('KFWN', 'NJ', 'Sussex Airport', 41.210000, -74.630000, 'http://weather.noaa.gov/weather/current/KFWN.html', 'http://weather.gov/data/current_obs/KFWN.rss', 'http://weather.gov/data/current_obs/KFWN.xml'),
('KMIV', 'NJ', 'Millville Municipal Airport', 39.380000, -75.070000, 'http://weather.noaa.gov/weather/current/KMIV.html', 'http://weather.gov/data/current_obs/KMIV.rss', 'http://weather.gov/data/current_obs/KMIV.xml'),
('KMMU', 'NJ', 'Morristown Municipal', 40.800000, -74.420000, 'http://weather.noaa.gov/weather/current/KMMU.html', 'http://weather.gov/data/current_obs/KMMU.rss', 'http://weather.gov/data/current_obs/KMMU.xml'),
('KNEL', 'NJ', 'Lakehurst Naval Air Station', 40.040000, -74.320000, 'http://weather.noaa.gov/weather/current/KNEL.html', 'http://weather.gov/data/current_obs/KNEL.rss', 'http://weather.gov/data/current_obs/KNEL.xml'),
('KSMQ', 'NJ', 'Somerville, Somerset Airport', 40.624000, -74.669000, 'http://weather.noaa.gov/weather/current/KSMQ.html', 'http://weather.gov/data/current_obs/KSMQ.rss', 'http://weather.gov/data/current_obs/KSMQ.xml'),
('KTEB', 'NJ', 'Teterboro Airport', 40.860000, -74.050000, 'http://weather.noaa.gov/weather/current/KTEB.html', 'http://weather.gov/data/current_obs/KTEB.rss', 'http://weather.gov/data/current_obs/KTEB.xml'),
('KTTN', 'NJ', 'Trenton, Mercer County Airport', 40.290000, -74.820000, 'http://weather.noaa.gov/weather/current/KTTN.html', 'http://weather.gov/data/current_obs/KTTN.rss', 'http://weather.gov/data/current_obs/KTTN.xml'),
('KVAY', 'NJ', 'Mount Holly, South Jersey Regional Airport', 39.950000, -74.840000, 'http://weather.noaa.gov/weather/current/KVAY.html', 'http://weather.gov/data/current_obs/KVAY.rss', 'http://weather.gov/data/current_obs/KVAY.xml'),
('KWRI', 'NJ', 'Mcguire Air Force Base', 40.020000, -74.600000, 'http://weather.noaa.gov/weather/current/KWRI.html', 'http://weather.gov/data/current_obs/KWRI.rss', 'http://weather.gov/data/current_obs/KWRI.xml'),
('KWWD', 'NJ', 'Wildwood Automatic Weather Observing / Reporting', 39.010000, -74.900000, 'http://weather.noaa.gov/weather/current/KWWD.html', 'http://weather.gov/data/current_obs/KWWD.rss', 'http://weather.gov/data/current_obs/KWWD.xml'),
('KMJX', 'NJ', 'Robert J. Miller Air Park', 39.927500, -74.292400, 'http://weather.noaa.gov/weather/current/KMJX.html', 'http://weather.gov/data/current_obs/KMJX.rss', 'http://weather.gov/data/current_obs/KMJX.xml'),
('NWWW', 'NL', 'La Tontouta Nlle-Caledonia', -22.017000, 166.217000, 'http://weather.noaa.gov/weather/current/NWWW.html', 'http://weather.gov/data/current_obs/NWWW.rss', 'http://weather.gov/data/current_obs/NWWW.xml'),
('K4CR', 'NM', 'Corona/Lincoln', 34.110000, -105.680000, 'http://weather.noaa.gov/weather/current/K4CR.html', 'http://weather.gov/data/current_obs/K4CR.rss', 'http://weather.gov/data/current_obs/K4CR.xml'),
('K4MY', 'NM', 'Moriarty', 34.980000, -106.050000, 'http://weather.noaa.gov/weather/current/K4MY.html', 'http://weather.gov/data/current_obs/K4MY.rss', 'http://weather.gov/data/current_obs/K4MY.xml'),
('K4SL', 'NM', 'Torreon', 36.030000, -106.950000, 'http://weather.noaa.gov/weather/current/K4SL.html', 'http://weather.gov/data/current_obs/K4SL.rss', 'http://weather.gov/data/current_obs/K4SL.xml'),
('KABQ', 'NM', 'Albuquerque Intl Airport', 35.050000, -106.620000, 'http://weather.noaa.gov/weather/current/KABQ.html', 'http://weather.gov/data/current_obs/KABQ.rss', 'http://weather.gov/data/current_obs/KABQ.xml'),
('KAEG', 'NM', 'Albuquerque/Double Eagle Ii Apt', 35.150000, -106.800000, 'http://weather.noaa.gov/weather/current/KAEG.html', 'http://weather.gov/data/current_obs/KAEG.rss', 'http://weather.gov/data/current_obs/KAEG.xml'),
('KALM', 'NM', 'Alamogordo-White', 32.840000, -105.990000, 'http://weather.noaa.gov/weather/current/KALM.html', 'http://weather.gov/data/current_obs/KALM.rss', 'http://weather.gov/data/current_obs/KALM.xml'),
('KATS', 'NM', 'Artesia', 32.850000, -104.470000, 'http://weather.noaa.gov/weather/current/KATS.html', 'http://weather.gov/data/current_obs/KATS.rss', 'http://weather.gov/data/current_obs/KATS.xml'),
('KCAO', 'NM', 'Clayton Muni(amos)', 36.460000, -103.150000, 'http://weather.noaa.gov/weather/current/KCAO.html', 'http://weather.gov/data/current_obs/KCAO.rss', 'http://weather.gov/data/current_obs/KCAO.xml'),
('KCNM', 'NM', 'Carlsbad/Cavern Cty', 32.340000, -104.270000, 'http://weather.noaa.gov/weather/current/KCNM.html', 'http://weather.gov/data/current_obs/KCNM.rss', 'http://weather.gov/data/current_obs/KCNM.xml'),
('KCQC', 'NM', 'Clines Corners', 35.000000, -105.660000, 'http://weather.noaa.gov/weather/current/KCQC.html', 'http://weather.gov/data/current_obs/KCQC.rss', 'http://weather.gov/data/current_obs/KCQC.xml'),
('KCVN', 'NM', 'Clovis Muni (awos)', 34.430000, -103.080000, 'http://weather.noaa.gov/weather/current/KCVN.html', 'http://weather.gov/data/current_obs/KCVN.rss', 'http://weather.gov/data/current_obs/KCVN.xml'),
('KCVS', 'NM', 'Cannon AFB/Clovis', 34.390000, -103.320000, 'http://weather.noaa.gov/weather/current/KCVS.html', 'http://weather.gov/data/current_obs/KCVS.rss', 'http://weather.gov/data/current_obs/KCVS.xml'),
('KDMN', 'NM', 'Deming Municipal', 32.260000, -107.700000, 'http://weather.noaa.gov/weather/current/KDMN.html', 'http://weather.gov/data/current_obs/KDMN.rss', 'http://weather.gov/data/current_obs/KDMN.xml'),
('KE33', 'NM', 'Chama', 36.910000, -106.570000, 'http://weather.noaa.gov/weather/current/KE33.html', 'http://weather.gov/data/current_obs/KE33.rss', 'http://weather.gov/data/current_obs/KE33.xml'),
('KFMN', 'NM', 'Farmington Regional', 36.760000, -108.230000, 'http://weather.noaa.gov/weather/current/KFMN.html', 'http://weather.gov/data/current_obs/KFMN.rss', 'http://weather.gov/data/current_obs/KFMN.xml'),
('KGNT', 'NM', 'Grants-Milan Municipal Airport', 35.180000, -107.900000, 'http://weather.noaa.gov/weather/current/KGNT.html', 'http://weather.gov/data/current_obs/KGNT.rss', 'http://weather.gov/data/current_obs/KGNT.xml'),
('KGUP', 'NM', 'Gallup Muni/Clarke', 35.530000, -108.780000, 'http://weather.noaa.gov/weather/current/KGUP.html', 'http://weather.gov/data/current_obs/KGUP.rss', 'http://weather.gov/data/current_obs/KGUP.xml'),
('KHMN', 'NM', 'Holloman AFB', 32.860000, -106.100000, 'http://weather.noaa.gov/weather/current/KHMN.html', 'http://weather.gov/data/current_obs/KHMN.rss', 'http://weather.gov/data/current_obs/KHMN.xml'),
('KHOB', 'NM', 'Hobbs/Lea Co.', 32.690000, -103.200000, 'http://weather.noaa.gov/weather/current/KHOB.html', 'http://weather.gov/data/current_obs/KHOB.rss', 'http://weather.gov/data/current_obs/KHOB.xml'),
('KLAM', 'NM', 'Los Alamos Airport', 35.883000, -106.283000, 'http://weather.noaa.gov/weather/current/KLAM.html', 'http://weather.gov/data/current_obs/KLAM.rss', 'http://weather.gov/data/current_obs/KLAM.xml'),
('KLRU', 'NM', 'Las Cruces Intl Airport', 32.300000, -106.770000, 'http://weather.noaa.gov/weather/current/KLRU.html', 'http://weather.gov/data/current_obs/KLRU.rss', 'http://weather.gov/data/current_obs/KLRU.xml'),
('KLVS', 'NM', 'Las Vegas Municipal', 35.660000, -105.150000, 'http://weather.noaa.gov/weather/current/KLVS.html', 'http://weather.gov/data/current_obs/KLVS.rss', 'http://weather.gov/data/current_obs/KLVS.xml'),
('KROW', 'NM', 'Roswell/Industrial', 33.310000, -104.510000, 'http://weather.noaa.gov/weather/current/KROW.html', 'http://weather.gov/data/current_obs/KROW.rss', 'http://weather.gov/data/current_obs/KROW.xml'),
('KRTN', 'NM', 'Raton Municipal Crews Field', 36.740000, -104.500000, 'http://weather.noaa.gov/weather/current/KRTN.html', 'http://weather.gov/data/current_obs/KRTN.rss', 'http://weather.gov/data/current_obs/KRTN.xml'),
('KSAF', 'NM', 'Santa Fe County Municipal Airport', 35.620000, -106.080000, 'http://weather.noaa.gov/weather/current/KSAF.html', 'http://weather.gov/data/current_obs/KSAF.rss', 'http://weather.gov/data/current_obs/KSAF.xml'),
('KSKX', 'NM', 'Taos Muni Apt(awos)', 36.460000, -105.670000, 'http://weather.noaa.gov/weather/current/KSKX.html', 'http://weather.gov/data/current_obs/KSKX.rss', 'http://weather.gov/data/current_obs/KSKX.xml'),
('KSRR', 'NM', 'Ruidoso Regional', 33.360000, -105.670000, 'http://weather.noaa.gov/weather/current/KSRR.html', 'http://weather.gov/data/current_obs/KSRR.rss', 'http://weather.gov/data/current_obs/KSRR.xml'),
('KSVC', 'NM', 'Silver City/Grant', 32.640000, -108.160000, 'http://weather.noaa.gov/weather/current/KSVC.html', 'http://weather.gov/data/current_obs/KSVC.rss', 'http://weather.gov/data/current_obs/KSVC.xml'),
('KTCC', 'NM', 'Tucumcari Municipal', 35.190000, -103.600000, 'http://weather.noaa.gov/weather/current/KTCC.html', 'http://weather.gov/data/current_obs/KTCC.rss', 'http://weather.gov/data/current_obs/KTCC.xml'),
('KTCS', 'NM', 'Truth Or Consequenc', 33.230000, -107.270000, 'http://weather.noaa.gov/weather/current/KTCS.html', 'http://weather.gov/data/current_obs/KTCS.rss', 'http://weather.gov/data/current_obs/KTCS.xml'),
('KAXX', 'NM', 'Angel Fire Airport', 36.420000, -105.290000, 'http://weather.noaa.gov/weather/current/KAXX.html', 'http://weather.gov/data/current_obs/KAXX.rss', 'http://weather.gov/data/current_obs/KAXX.xml'),
('K9BB', 'NV', 'Wells', 41.160000, -114.970000, 'http://weather.noaa.gov/weather/current/K9BB.html', 'http://weather.gov/data/current_obs/K9BB.rss', 'http://weather.gov/data/current_obs/K9BB.xml'),
('KAWH', 'NV', 'Wildhorse Res/Elko', 41.670000, -115.790000, 'http://weather.noaa.gov/weather/current/KAWH.html', 'http://weather.gov/data/current_obs/KAWH.rss', 'http://weather.gov/data/current_obs/KAWH.xml'),
('KB23', 'NV', 'Battle Mountain', 40.610000, -116.870000, 'http://weather.noaa.gov/weather/current/KB23.html', 'http://weather.gov/data/current_obs/KB23.rss', 'http://weather.gov/data/current_obs/KB23.xml'),
('KBJN', 'NV', 'Tonopah Range #74 Nellis AFB', 37.617000, -116.250000, 'http://weather.noaa.gov/weather/current/KBJN.html', 'http://weather.gov/data/current_obs/KBJN.rss', 'http://weather.gov/data/current_obs/KBJN.xml'),
('KDRA', 'NV', 'Mercury/Desert Rock', 36.620000, -116.020000, 'http://weather.noaa.gov/weather/current/KDRA.html', 'http://weather.gov/data/current_obs/KDRA.rss', 'http://weather.gov/data/current_obs/KDRA.xml'),
('KEKO', 'NV', 'Elko', 40.840000, -115.780000, 'http://weather.noaa.gov/weather/current/KEKO.html', 'http://weather.gov/data/current_obs/KEKO.rss', 'http://weather.gov/data/current_obs/KEKO.xml'),
('KELY', 'NV', 'Ely/Yelland Field', 39.290000, -114.850000, 'http://weather.noaa.gov/weather/current/KELY.html', 'http://weather.gov/data/current_obs/KELY.rss', 'http://weather.gov/data/current_obs/KELY.xml'),
('KHND', 'NV', 'Las Vegas-Henerson Airport', 35.976000, -115.133000, 'http://weather.noaa.gov/weather/current/KHND.html', 'http://weather.gov/data/current_obs/KHND.rss', 'http://weather.gov/data/current_obs/KHND.xml'),
('KHTH', 'NV', 'Hawthorne Municipal Airport', 38.550000, -118.633000, 'http://weather.noaa.gov/weather/current/KHTH.html', 'http://weather.gov/data/current_obs/KHTH.rss', 'http://weather.gov/data/current_obs/KHTH.xml'),
('KINS', 'NV', 'Indian Srings Aux AFLD Nellis AFB', 36.583000, -115.667000, 'http://weather.noaa.gov/weather/current/KINS.html', 'http://weather.gov/data/current_obs/KINS.rss', 'http://weather.gov/data/current_obs/KINS.xml'),
('KLAS', 'NV', 'Las Vegas/Mccarran', 36.090000, -115.170000, 'http://weather.noaa.gov/weather/current/KLAS.html', 'http://weather.gov/data/current_obs/KLAS.rss', 'http://weather.gov/data/current_obs/KLAS.xml'),
('KLOL', 'NV', 'Lovelock/Derby Fld', 40.080000, -118.550000, 'http://weather.noaa.gov/weather/current/KLOL.html', 'http://weather.gov/data/current_obs/KLOL.rss', 'http://weather.gov/data/current_obs/KLOL.xml'),
('KLSV', 'NV', 'Nellis AFB', 36.230000, -115.030000, 'http://weather.noaa.gov/weather/current/KLSV.html', 'http://weather.gov/data/current_obs/KLSV.rss', 'http://weather.gov/data/current_obs/KLSV.xml'),
('KNFL', 'NV', 'Fallon Nas', 39.430000, -118.700000, 'http://weather.noaa.gov/weather/current/KNFL.html', 'http://weather.gov/data/current_obs/KNFL.rss', 'http://weather.gov/data/current_obs/KNFL.xml'),
('KOWY', 'NV', 'Owyhee', 41.950000, -116.100000, 'http://weather.noaa.gov/weather/current/KOWY.html', 'http://weather.gov/data/current_obs/KOWY.rss', 'http://weather.gov/data/current_obs/KOWY.xml'),
('KP38', 'NV', 'Caliente (amos)', 37.617000, -114.517000, 'http://weather.noaa.gov/weather/current/KP38.html', 'http://weather.gov/data/current_obs/KP38.rss', 'http://weather.gov/data/current_obs/KP38.xml'),
('KP68', 'NV', 'Eureka (ramos)', 39.510000, -115.970000, 'http://weather.noaa.gov/weather/current/KP68.html', 'http://weather.gov/data/current_obs/KP68.rss', 'http://weather.gov/data/current_obs/KP68.xml'),
('KRNO', 'NV', 'Reno Tahoe International Airport', 39.510000, -119.780000, 'http://weather.noaa.gov/weather/current/KRNO.html', 'http://weather.gov/data/current_obs/KRNO.rss', 'http://weather.gov/data/current_obs/KRNO.xml'),
('KTPH', 'NV', 'Tonopah Airport', 38.080000, -117.080000, 'http://weather.noaa.gov/weather/current/KTPH.html', 'http://weather.gov/data/current_obs/KTPH.rss', 'http://weather.gov/data/current_obs/KTPH.xml'),
('KU31', 'NV', 'Austin', 39.500000, -117.083000, 'http://weather.noaa.gov/weather/current/KU31.html', 'http://weather.gov/data/current_obs/KU31.rss', 'http://weather.gov/data/current_obs/KU31.xml'),
('KVGT', 'NV', 'North Las Vegas', 36.210000, -115.200000, 'http://weather.noaa.gov/weather/current/KVGT.html', 'http://weather.gov/data/current_obs/KVGT.rss', 'http://weather.gov/data/current_obs/KVGT.xml'),
('KWMC', 'NV', 'Winnemucca Muni', 40.910000, -117.800000, 'http://weather.noaa.gov/weather/current/KWMC.html', 'http://weather.gov/data/current_obs/KWMC.rss', 'http://weather.gov/data/current_obs/KWMC.xml'),
('KALB', 'NY', 'Albany International Airport', 42.760000, -73.800000, 'http://weather.noaa.gov/weather/current/KALB.html', 'http://weather.gov/data/current_obs/KALB.rss', 'http://weather.gov/data/current_obs/KALB.xml'),
('KART', 'NY', 'Watertown International Airport', 44.010000, -76.020000, 'http://weather.noaa.gov/weather/current/KART.html', 'http://weather.gov/data/current_obs/KART.rss', 'http://weather.gov/data/current_obs/KART.xml'),
('KBGM', 'NY', 'Binghamton Regional Airport', 42.230000, -75.980000, 'http://weather.noaa.gov/weather/current/KBGM.html', 'http://weather.gov/data/current_obs/KBGM.rss', 'http://weather.gov/data/current_obs/KBGM.xml'),
('KBUF', 'NY', 'Greater Buffalo International Airport', 42.940000, -78.730000, 'http://weather.noaa.gov/weather/current/KBUF.html', 'http://weather.gov/data/current_obs/KBUF.rss', 'http://weather.gov/data/current_obs/KBUF.xml'),
('KDKK', 'NY', 'Chautauqua County / Dunkirk Airport', 42.500000, -79.280000, 'http://weather.noaa.gov/weather/current/KDKK.html', 'http://weather.gov/data/current_obs/KDKK.rss', 'http://weather.gov/data/current_obs/KDKK.xml'),
('KDSV', 'NY', 'Dansville Municipal Airport', 42.567000, -77.717000, 'http://weather.noaa.gov/weather/current/KDSV.html', 'http://weather.gov/data/current_obs/KDSV.rss', 'http://weather.gov/data/current_obs/KDSV.xml'),
('KELM', 'NY', 'Elmira / Corning Regional Airport', 42.180000, -76.900000, 'http://weather.noaa.gov/weather/current/KELM.html', 'http://weather.gov/data/current_obs/KELM.rss', 'http://weather.gov/data/current_obs/KELM.xml'),
('KELZ', 'NY', 'Wellsville Municipal Airport', 42.100000, -77.983000, 'http://weather.noaa.gov/weather/current/KELZ.html', 'http://weather.gov/data/current_obs/KELZ.rss', 'http://weather.gov/data/current_obs/KELZ.xml'),
('KFOK', 'NY', 'Westhampton Beach, The Gabreski Airport', 40.840000, -72.630000, 'http://weather.noaa.gov/weather/current/KFOK.html', 'http://weather.gov/data/current_obs/KFOK.rss', 'http://weather.gov/data/current_obs/KFOK.xml'),
('KFRG', 'NY', 'Farmingdale, Republic Airport', 40.730000, -73.410000, 'http://weather.noaa.gov/weather/current/KFRG.html', 'http://weather.gov/data/current_obs/KFRG.rss', 'http://weather.gov/data/current_obs/KFRG.xml'),
('KFZY', 'NY', 'Fulton, Oswego County Airport', 43.360000, -76.390000, 'http://weather.noaa.gov/weather/current/KFZY.html', 'http://weather.gov/data/current_obs/KFZY.rss', 'http://weather.gov/data/current_obs/KFZY.xml'),
('KGFL', 'NY', 'Glens Falls, Warren County Airport', 43.360000, -73.620000, 'http://weather.noaa.gov/weather/current/KGFL.html', 'http://weather.gov/data/current_obs/KGFL.rss', 'http://weather.gov/data/current_obs/KGFL.xml'),
('KGTB', 'NY', 'Fort Drum / Wheeler-Sack U. S. Army Airfield', 44.050000, -75.740000, 'http://weather.noaa.gov/weather/current/KGTB.html', 'http://weather.gov/data/current_obs/KGTB.rss', 'http://weather.gov/data/current_obs/KGTB.xml'),
('KHPN', 'NY', 'White Plains, Westchester County Airport', 41.080000, -73.720000, 'http://weather.noaa.gov/weather/current/KHPN.html', 'http://weather.gov/data/current_obs/KHPN.rss', 'http://weather.gov/data/current_obs/KHPN.xml'),
('KHTO', 'NY', 'East Hampton Airport', 40.980000, -72.250000, 'http://weather.noaa.gov/weather/current/KHTO.html', 'http://weather.gov/data/current_obs/KHTO.rss', 'http://weather.gov/data/current_obs/KHTO.xml'),
('KHWV', 'NY', 'Shirley, Brookhaven Airport', 40.817000, -72.867000, 'http://weather.noaa.gov/weather/current/KHWV.html', 'http://weather.gov/data/current_obs/KHWV.rss', 'http://weather.gov/data/current_obs/KHWV.xml'),
('KIAG', 'NY', 'Niagara Falls International Airport', 43.110000, -78.950000, 'http://weather.noaa.gov/weather/current/KIAG.html', 'http://weather.gov/data/current_obs/KIAG.rss', 'http://weather.gov/data/current_obs/KIAG.xml'),
('KISP', 'NY', 'Islip, Long Island Mac Arthur Airport', 40.800000, -73.100000, 'http://weather.noaa.gov/weather/current/KISP.html', 'http://weather.gov/data/current_obs/KISP.rss', 'http://weather.gov/data/current_obs/KISP.xml'),
('KITH', 'NY', 'Ithaca / Tompkins County', 42.480000, -76.470000, 'http://weather.noaa.gov/weather/current/KITH.html', 'http://weather.gov/data/current_obs/KITH.rss', 'http://weather.gov/data/current_obs/KITH.xml'),
('KJFK', 'NY', 'New York/John F. Kennedy Intl Airport', 40.660000, -73.780000, 'http://weather.noaa.gov/weather/current/KJFK.html', 'http://weather.gov/data/current_obs/KJFK.rss', 'http://weather.gov/data/current_obs/KJFK.xml'),
('KJHW', 'NY', 'Jamestown Automatic Weather Observing / Reporting', 42.160000, -79.250000, 'http://weather.noaa.gov/weather/current/KJHW.html', 'http://weather.gov/data/current_obs/KJHW.rss', 'http://weather.gov/data/current_obs/KJHW.xml'),
('KLGA', 'NY', 'New York, La Guardia Airport', 40.770000, -73.900000, 'http://weather.noaa.gov/weather/current/KLGA.html', 'http://weather.gov/data/current_obs/KLGA.rss', 'http://weather.gov/data/current_obs/KLGA.xml'),
('KMGJ', 'NY', 'Montgomery, Orange County Airport', 41.510000, -74.260000, 'http://weather.noaa.gov/weather/current/KMGJ.html', 'http://weather.gov/data/current_obs/KMGJ.rss', 'http://weather.gov/data/current_obs/KMGJ.xml'),
('KMSS', 'NY', 'Massena International-Richards Field', 44.940000, -74.850000, 'http://weather.noaa.gov/weather/current/KMSS.html', 'http://weather.gov/data/current_obs/KMSS.rss', 'http://weather.gov/data/current_obs/KMSS.xml'),
('KMSV', 'NY', 'Monticello Automatic Weather Observing / Reporting', 41.710000, -74.800000, 'http://weather.noaa.gov/weather/current/KMSV.html', 'http://weather.gov/data/current_obs/KMSV.rss', 'http://weather.gov/data/current_obs/KMSV.xml'),
('KMTP', 'NY', 'Montauk Airport', 41.080000, -71.920000, 'http://weather.noaa.gov/weather/current/KMTP.html', 'http://weather.gov/data/current_obs/KMTP.rss', 'http://weather.gov/data/current_obs/KMTP.xml'),
('KNYC', 'NY', 'New York City, Central Park', 40.783000, -73.967000, 'http://weather.noaa.gov/weather/current/KNYC.html', 'http://weather.gov/data/current_obs/KNYC.rss', 'http://weather.gov/data/current_obs/KNYC.xml'),
('KPEO', 'NY', 'Penn Yan Airport', 42.650000, -77.050000, 'http://weather.noaa.gov/weather/current/KPEO.html', 'http://weather.gov/data/current_obs/KPEO.rss', 'http://weather.gov/data/current_obs/KPEO.xml'),
('KRME', 'NY', 'Rome Griffiss Airfield', 43.234000, -75.407000, 'http://weather.noaa.gov/weather/current/KRME.html', 'http://weather.gov/data/current_obs/KRME.rss', 'http://weather.gov/data/current_obs/KRME.xml'),
('KPOU', 'NY', 'Poughkeepsie, Dutchess County Airport', 41.640000, -73.880000, 'http://weather.noaa.gov/weather/current/KPOU.html', 'http://weather.gov/data/current_obs/KPOU.rss', 'http://weather.gov/data/current_obs/KPOU.xml'),
('KROC', 'NY', 'Greater Rochester International Airport', 43.120000, -77.670000, 'http://weather.noaa.gov/weather/current/KROC.html', 'http://weather.gov/data/current_obs/KROC.rss', 'http://weather.gov/data/current_obs/KROC.xml'),
('KSCH', 'NY', 'Schenectady Airport', 42.860000, -73.930000, 'http://weather.noaa.gov/weather/current/KSCH.html', 'http://weather.gov/data/current_obs/KSCH.rss', 'http://weather.gov/data/current_obs/KSCH.xml'),
('KSLK', 'NY', 'Saranac Lake, Adirondack Regional Airport', 44.390000, -74.200000, 'http://weather.noaa.gov/weather/current/KSLK.html', 'http://weather.gov/data/current_obs/KSLK.rss', 'http://weather.gov/data/current_obs/KSLK.xml'),
('KSWF', 'NY', 'Newburgh / Stewart', 41.510000, -74.100000, 'http://weather.noaa.gov/weather/current/KSWF.html', 'http://weather.gov/data/current_obs/KSWF.rss', 'http://weather.gov/data/current_obs/KSWF.xml'),
('KSYR', 'NY', 'Syracuse Hancock International Airport', 43.120000, -76.120000, 'http://weather.noaa.gov/weather/current/KSYR.html', 'http://weather.gov/data/current_obs/KSYR.rss', 'http://weather.gov/data/current_obs/KSYR.xml'),
('KUCA', 'NY', 'Utica, Oneida County Airport', 43.160000, -75.380000, 'http://weather.noaa.gov/weather/current/KUCA.html', 'http://weather.gov/data/current_obs/KUCA.rss', 'http://weather.gov/data/current_obs/KUCA.xml'),
('KPBG', 'NY', 'Plattsburgh International Airport', 44.650900, -73.468100, 'http://weather.noaa.gov/weather/current/KPBG.html', 'http://weather.gov/data/current_obs/KPBG.rss', 'http://weather.gov/data/current_obs/KPBG.xml'),
('KAKR', 'OH', 'Akron Fulton International Airport', 41.033000, -81.467000, 'http://weather.noaa.gov/weather/current/KAKR.html', 'http://weather.gov/data/current_obs/KAKR.rss', 'http://weather.gov/data/current_obs/KAKR.xml'),
('KAOH', 'OH', 'Lima Allen County Airport', 40.710000, -84.030000, 'http://weather.noaa.gov/weather/current/KAOH.html', 'http://weather.gov/data/current_obs/KAOH.rss', 'http://weather.gov/data/current_obs/KAOH.xml'),
('KBJJ', 'OH', 'Wooster, Wayne County Airport', 40.870000, -81.890000, 'http://weather.noaa.gov/weather/current/KBJJ.html', 'http://weather.gov/data/current_obs/KBJJ.rss', 'http://weather.gov/data/current_obs/KBJJ.xml'),
('KBKL', 'OH', 'Cleveland/Burke Lakefront', 41.520000, -81.680000, 'http://weather.noaa.gov/weather/current/KBKL.html', 'http://weather.gov/data/current_obs/KBKL.rss', 'http://weather.gov/data/current_obs/KBKL.xml'),
('KCAK', 'OH', 'Akron-Canton Regional Airport', 40.930000, -81.430000, 'http://weather.noaa.gov/weather/current/KCAK.html', 'http://weather.gov/data/current_obs/KCAK.rss', 'http://weather.gov/data/current_obs/KCAK.xml'),
('KCGF', 'OH', 'Cleveland / Cuyahoga', 41.580000, -81.480000, 'http://weather.noaa.gov/weather/current/KCGF.html', 'http://weather.gov/data/current_obs/KCGF.rss', 'http://weather.gov/data/current_obs/KCGF.xml'),
('KCLE', 'OH', 'Cleveland-Hopkins International Airport', 41.430000, -81.870000, 'http://weather.noaa.gov/weather/current/KCLE.html', 'http://weather.gov/data/current_obs/KCLE.rss', 'http://weather.gov/data/current_obs/KCLE.xml'),
('KCMH', 'OH', 'Port Columbus International Airport', 40.010000, -82.880000, 'http://weather.noaa.gov/weather/current/KCMH.html', 'http://weather.gov/data/current_obs/KCMH.rss', 'http://weather.gov/data/current_obs/KCMH.xml'),
('KDAY', 'OH', 'Cox Dayton International Airport', 39.910000, -84.200000, 'http://weather.noaa.gov/weather/current/KDAY.html', 'http://weather.gov/data/current_obs/KDAY.rss', 'http://weather.gov/data/current_obs/KDAY.xml'),
('KDFI', 'OH', 'Defiance Memorial Airport', 41.340000, -84.430000, 'http://weather.noaa.gov/weather/current/KDFI.html', 'http://weather.gov/data/current_obs/KDFI.rss', 'http://weather.gov/data/current_obs/KDFI.xml'),
('KFDY', 'OH', 'Findlay Airport', 41.030000, -83.670000, 'http://weather.noaa.gov/weather/current/KFDY.html', 'http://weather.gov/data/current_obs/KFDY.rss', 'http://weather.gov/data/current_obs/KFDY.xml'),
('KFFO', 'OH', 'Dayton / Wright-Patterson Air Force Base', 39.840000, -84.050000, 'http://weather.noaa.gov/weather/current/KFFO.html', 'http://weather.gov/data/current_obs/KFFO.rss', 'http://weather.gov/data/current_obs/KFFO.xml'),
('KHAO', 'OH', 'Hamilton, Butler County Regional Airport', 39.360000, -84.520000, 'http://weather.noaa.gov/weather/current/KHAO.html', 'http://weather.gov/data/current_obs/KHAO.rss', 'http://weather.gov/data/current_obs/KHAO.xml'),
('KHZY', 'OH', 'Ashtabula County Airport', 41.779000, -80.697000, 'http://weather.noaa.gov/weather/current/KHZY.html', 'http://weather.gov/data/current_obs/KHZY.rss', 'http://weather.gov/data/current_obs/KHZY.xml'),
('KILN', 'OH', 'Wilmington, Airborne Airpark Airport', 39.430000, -83.800000, 'http://weather.noaa.gov/weather/current/KILN.html', 'http://weather.gov/data/current_obs/KILN.rss', 'http://weather.gov/data/current_obs/KILN.xml'),
('KLCK', 'OH', 'Rickenbacker Air National Guard Base', 39.830000, -82.930000, 'http://weather.noaa.gov/weather/current/KLCK.html', 'http://weather.gov/data/current_obs/KLCK.rss', 'http://weather.gov/data/current_obs/KLCK.xml'),
('KLHQ', 'OH', 'Lancaster, Fairfield County Airport', 39.750000, -82.670000, 'http://weather.noaa.gov/weather/current/KLHQ.html', 'http://weather.gov/data/current_obs/KLHQ.rss', 'http://weather.gov/data/current_obs/KLHQ.xml'),
('KLPR', 'OH', 'Lorain County Regional Airport', 41.346000, -82.179000, 'http://weather.noaa.gov/weather/current/KLPR.html', 'http://weather.gov/data/current_obs/KLPR.rss', 'http://weather.gov/data/current_obs/KLPR.xml'),
('KLUK', 'OH', 'Cincinnati Municipal Airport Lunken Field', 39.100000, -84.420000, 'http://weather.noaa.gov/weather/current/KLUK.html', 'http://weather.gov/data/current_obs/KLUK.rss', 'http://weather.gov/data/current_obs/KLUK.xml'),
('KMFD', 'OH', 'Mansfield Lahm Municipal Airport', 40.830000, -82.520000, 'http://weather.noaa.gov/weather/current/KMFD.html', 'http://weather.gov/data/current_obs/KMFD.rss', 'http://weather.gov/data/current_obs/KMFD.xml'),
('KMGY', 'OH', 'Dayton General Airport South Airport', 39.590000, -84.220000, 'http://weather.noaa.gov/weather/current/KMGY.html', 'http://weather.gov/data/current_obs/KMGY.rss', 'http://weather.gov/data/current_obs/KMGY.xml'),
('KMNN', 'OH', 'Marion Municipal Airport', 40.620000, -83.060000, 'http://weather.noaa.gov/weather/current/KMNN.html', 'http://weather.gov/data/current_obs/KMNN.rss', 'http://weather.gov/data/current_obs/KMNN.xml'),
('KOSU', 'OH', 'Columbus, Ohio State University Airport', 40.090000, -83.070000, 'http://weather.noaa.gov/weather/current/KOSU.html', 'http://weather.gov/data/current_obs/KOSU.rss', 'http://weather.gov/data/current_obs/KOSU.xml'),
('KPHD', 'OH', 'New Philadelphia, Harry Clever Field', 40.470000, -81.420000, 'http://weather.noaa.gov/weather/current/KPHD.html', 'http://weather.gov/data/current_obs/KPHD.rss', 'http://weather.gov/data/current_obs/KPHD.xml'),
('KSGH', 'OH', 'Springfield-Beckley Municipal Airport', 39.833000, -83.833000, 'http://weather.noaa.gov/weather/current/KSGH.html', 'http://weather.gov/data/current_obs/KSGH.rss', 'http://weather.gov/data/current_obs/KSGH.xml'),
('KTDZ', 'OH', 'Toledo, Metcalf Field', 41.560000, -83.480000, 'http://weather.noaa.gov/weather/current/KTDZ.html', 'http://weather.gov/data/current_obs/KTDZ.rss', 'http://weather.gov/data/current_obs/KTDZ.xml'),
('KTOL', 'OH', 'Toledo Express Airport', 41.610000, -83.800000, 'http://weather.noaa.gov/weather/current/KTOL.html', 'http://weather.gov/data/current_obs/KTOL.rss', 'http://weather.gov/data/current_obs/KTOL.xml'),
('KTZR', 'OH', 'Columbus, Bolton Field Airport', 39.900000, -83.130000, 'http://weather.noaa.gov/weather/current/KTZR.html', 'http://weather.gov/data/current_obs/KTZR.rss', 'http://weather.gov/data/current_obs/KTZR.xml'),
('KVTA', 'OH', 'Newark Heath Airport', 40.023000, -82.462000, 'http://weather.noaa.gov/weather/current/KVTA.html', 'http://weather.gov/data/current_obs/KVTA.rss', 'http://weather.gov/data/current_obs/KVTA.xml'),
('KYNG', 'OH', 'Youngstown-Warren Regional Airport', 41.270000, -80.670000, 'http://weather.noaa.gov/weather/current/KYNG.html', 'http://weather.gov/data/current_obs/KYNG.rss', 'http://weather.gov/data/current_obs/KYNG.xml'),
('KZZV', 'OH', 'Zanesville Municipal Airport', 39.960000, -81.900000, 'http://weather.noaa.gov/weather/current/KZZV.html', 'http://weather.gov/data/current_obs/KZZV.rss', 'http://weather.gov/data/current_obs/KZZV.xml'),
('K1F0', 'OK', 'Ardmore Downtown Executive Airport', 34.150000, -97.120000, 'http://weather.noaa.gov/weather/current/K1F0.html', 'http://weather.gov/data/current_obs/K1F0.rss', 'http://weather.gov/data/current_obs/K1F0.xml'),
('K4O4', 'OK', 'Mc Curtain County Regional Airport', 33.900000, -94.867000, 'http://weather.noaa.gov/weather/current/K4O4.html', 'http://weather.gov/data/current_obs/K4O4.rss', 'http://weather.gov/data/current_obs/K4O4.xml');

INSERT INTO `#__zweather_stations` (`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES
('KADH', 'OK', 'Ada Municipal Airport', 34.804000, -96.671000, 'http://weather.noaa.gov/weather/current/KADH.html', 'http://weather.gov/data/current_obs/KADH.rss', 'http://weather.gov/data/current_obs/KADH.xml'),
('KADM', 'OK', 'Ardmore Municipal', 34.300000, -97.020000, 'http://weather.noaa.gov/weather/current/KADM.html', 'http://weather.gov/data/current_obs/KADM.rss', 'http://weather.gov/data/current_obs/KADM.xml'),
('KAQR', 'OK', 'Atoka Municipal Airport', 34.400000, -96.150000, 'http://weather.noaa.gov/weather/current/KAQR.html', 'http://weather.gov/data/current_obs/KAQR.rss', 'http://weather.gov/data/current_obs/KAQR.xml'),
('KAVK', 'OK', 'Alva Regional Airport', 36.770000, -98.670000, 'http://weather.noaa.gov/weather/current/KAVK.html', 'http://weather.gov/data/current_obs/KAVK.rss', 'http://weather.gov/data/current_obs/KAVK.xml'),
('KAXS', 'OK', 'Altus/Quartz Mountain Regional Airport', 34.700000, -99.333000, 'http://weather.noaa.gov/weather/current/KAXS.html', 'http://weather.gov/data/current_obs/KAXS.rss', 'http://weather.gov/data/current_obs/KAXS.xml'),
('KBVO', 'OK', 'Bartlesville Municipal Airport', 36.760000, -96.010000, 'http://weather.noaa.gov/weather/current/KBVO.html', 'http://weather.gov/data/current_obs/KBVO.rss', 'http://weather.gov/data/current_obs/KBVO.xml'),
('KCHK', 'OK', 'Chickasha Municipal Airport', 35.100000, -97.970000, 'http://weather.noaa.gov/weather/current/KCHK.html', 'http://weather.gov/data/current_obs/KCHK.rss', 'http://weather.gov/data/current_obs/KCHK.xml'),
('KCLK', 'OK', 'Clinton Regional Airport', 35.533000, -98.933000, 'http://weather.noaa.gov/weather/current/KCLK.html', 'http://weather.gov/data/current_obs/KCLK.rss', 'http://weather.gov/data/current_obs/KCLK.xml'),
('KCQB', 'OK', 'Chandler Municipal Airport', 35.720000, -96.820000, 'http://weather.noaa.gov/weather/current/KCQB.html', 'http://weather.gov/data/current_obs/KCQB.rss', 'http://weather.gov/data/current_obs/KCQB.xml'),
('KCSM', 'OK', 'Clinton-Sherman Airport', 35.360000, -99.200000, 'http://weather.noaa.gov/weather/current/KCSM.html', 'http://weather.gov/data/current_obs/KCSM.rss', 'http://weather.gov/data/current_obs/KCSM.xml'),
('KCUH', 'OK', 'Cushing Municipal Airport', 35.950000, -96.767000, 'http://weather.noaa.gov/weather/current/KCUH.html', 'http://weather.gov/data/current_obs/KCUH.rss', 'http://weather.gov/data/current_obs/KCUH.xml'),
('KDUA', 'OK', 'Durant/Eaker Field Airport', 33.940000, -96.390000, 'http://weather.noaa.gov/weather/current/KDUA.html', 'http://weather.gov/data/current_obs/KDUA.rss', 'http://weather.gov/data/current_obs/KDUA.xml'),
('KDUC', 'OK', 'Duncan/Halliburton Field Airport', 34.470000, -97.960000, 'http://weather.noaa.gov/weather/current/KDUC.html', 'http://weather.gov/data/current_obs/KDUC.rss', 'http://weather.gov/data/current_obs/KDUC.xml'),
('KEND', 'OK', 'Vance Air Force Base / Enid', 36.333000, -97.917000, 'http://weather.noaa.gov/weather/current/KEND.html', 'http://weather.gov/data/current_obs/KEND.rss', 'http://weather.gov/data/current_obs/KEND.xml'),
('KFDR', 'OK', 'Frederick Municipal Airport', 34.350000, -98.980000, 'http://weather.noaa.gov/weather/current/KFDR.html', 'http://weather.gov/data/current_obs/KFDR.rss', 'http://weather.gov/data/current_obs/KFDR.xml'),
('KFSI', 'OK', 'Fort Sill', 34.650000, -98.383000, 'http://weather.noaa.gov/weather/current/KFSI.html', 'http://weather.gov/data/current_obs/KFSI.rss', 'http://weather.gov/data/current_obs/KFSI.xml'),
('KGAG', 'OK', 'Gage Airport', 36.300000, -99.770000, 'http://weather.noaa.gov/weather/current/KGAG.html', 'http://weather.gov/data/current_obs/KGAG.rss', 'http://weather.gov/data/current_obs/KGAG.xml'),
('KGCM', 'OK', 'Claremore Regional Airport', 36.290000, -95.480000, 'http://weather.noaa.gov/weather/current/KGCM.html', 'http://weather.gov/data/current_obs/KGCM.rss', 'http://weather.gov/data/current_obs/KGCM.xml'),
('KGMJ', 'OK', 'Grove Municipal Airport', 36.605000, -94.738000, 'http://weather.noaa.gov/weather/current/KGMJ.html', 'http://weather.gov/data/current_obs/KGMJ.rss', 'http://weather.gov/data/current_obs/KGMJ.xml'),
('KGOK', 'OK', 'Guthrie-Edmond Regional Airport', 35.850000, -97.420000, 'http://weather.noaa.gov/weather/current/KGOK.html', 'http://weather.gov/data/current_obs/KGOK.rss', 'http://weather.gov/data/current_obs/KGOK.xml'),
('KGUY', 'OK', 'Guymon / Guymon Municipal Airport', 36.690000, -101.510000, 'http://weather.noaa.gov/weather/current/KGUY.html', 'http://weather.gov/data/current_obs/KGUY.rss', 'http://weather.gov/data/current_obs/KGUY.xml'),
('KHBR', 'OK', 'Hobart Municipal Airport', 35.010000, -99.050000, 'http://weather.noaa.gov/weather/current/KHBR.html', 'http://weather.gov/data/current_obs/KHBR.rss', 'http://weather.gov/data/current_obs/KHBR.xml'),
('KJSV', 'OK', 'Sallisaw Municipal Airport', 35.440000, -94.800000, 'http://weather.noaa.gov/weather/current/KJSV.html', 'http://weather.gov/data/current_obs/KJSV.rss', 'http://weather.gov/data/current_obs/KJSV.xml'),
('KJWG', 'OK', 'Watonga Airport', 35.860000, -98.420000, 'http://weather.noaa.gov/weather/current/KJWG.html', 'http://weather.gov/data/current_obs/KJWG.rss', 'http://weather.gov/data/current_obs/KJWG.xml'),
('KLAW', 'OK', 'Lawton-Fort Sill Regional Airport', 34.570000, -98.420000, 'http://weather.noaa.gov/weather/current/KLAW.html', 'http://weather.gov/data/current_obs/KLAW.rss', 'http://weather.gov/data/current_obs/KLAW.xml'),
('KLTS', 'OK', 'Altus Air Force Base', 34.800000, -99.000000, 'http://weather.noaa.gov/weather/current/KLTS.html', 'http://weather.gov/data/current_obs/KLTS.rss', 'http://weather.gov/data/current_obs/KLTS.xml'),
('KMKO', 'OK', 'Muskogee, Davis Field', 35.660000, -95.360000, 'http://weather.noaa.gov/weather/current/KMKO.html', 'http://weather.gov/data/current_obs/KMKO.rss', 'http://weather.gov/data/current_obs/KMKO.xml'),
('KMLC', 'OK', 'McAlester Regional Airport', 34.890000, -95.780000, 'http://weather.noaa.gov/weather/current/KMLC.html', 'http://weather.gov/data/current_obs/KMLC.rss', 'http://weather.gov/data/current_obs/KMLC.xml'),
('KOKC', 'OK', 'Oklahoma City, Will Rogers World Airport', 35.410000, -97.600000, 'http://weather.noaa.gov/weather/current/KOKC.html', 'http://weather.gov/data/current_obs/KOKC.rss', 'http://weather.gov/data/current_obs/KOKC.xml'),
('KOKM', 'OK', 'Okmulgee Regional Airport', 35.670000, -95.950000, 'http://weather.noaa.gov/weather/current/KOKM.html', 'http://weather.gov/data/current_obs/KOKM.rss', 'http://weather.gov/data/current_obs/KOKM.xml'),
('KOUN', 'OK', 'Norman / Max Westheimer', 35.246000, -97.472000, 'http://weather.noaa.gov/weather/current/KOUN.html', 'http://weather.gov/data/current_obs/KOUN.rss', 'http://weather.gov/data/current_obs/KOUN.xml'),
('KPNC', 'OK', 'Ponca City Municipal Airport', 36.730000, -97.100000, 'http://weather.noaa.gov/weather/current/KPNC.html', 'http://weather.gov/data/current_obs/KPNC.rss', 'http://weather.gov/data/current_obs/KPNC.xml'),
('KPVJ', 'OK', 'Pauls Valley Municipal Airport', 34.711000, -97.223000, 'http://weather.noaa.gov/weather/current/KPVJ.html', 'http://weather.gov/data/current_obs/KPVJ.rss', 'http://weather.gov/data/current_obs/KPVJ.xml'),
('KPWA', 'OK', 'Oklahoma City, Wiley Post Airport', 35.540000, -97.650000, 'http://weather.noaa.gov/weather/current/KPWA.html', 'http://weather.gov/data/current_obs/KPWA.rss', 'http://weather.gov/data/current_obs/KPWA.xml'),
('KRKR', 'OK', 'Poteau/Robert S. Kerr Airport', 35.022000, -94.621000, 'http://weather.noaa.gov/weather/current/KRKR.html', 'http://weather.gov/data/current_obs/KRKR.rss', 'http://weather.gov/data/current_obs/KRKR.xml'),
('KRVS', 'OK', 'Tulsa, Jones Jr. Airport', 36.040000, -95.980000, 'http://weather.noaa.gov/weather/current/KRVS.html', 'http://weather.gov/data/current_obs/KRVS.rss', 'http://weather.gov/data/current_obs/KRVS.xml'),
('KSNL', 'OK', 'Shawnee Municipal Airport', 35.360000, -96.940000, 'http://weather.noaa.gov/weather/current/KSNL.html', 'http://weather.gov/data/current_obs/KSNL.rss', 'http://weather.gov/data/current_obs/KSNL.xml'),
('KSWO', 'OK', 'Stillwater Regional Airport', 36.160000, -97.090000, 'http://weather.noaa.gov/weather/current/KSWO.html', 'http://weather.gov/data/current_obs/KSWO.rss', 'http://weather.gov/data/current_obs/KSWO.xml'),
('KTIK', 'OK', 'Tinker Air Force Base', 35.417000, -97.383000, 'http://weather.noaa.gov/weather/current/KTIK.html', 'http://weather.gov/data/current_obs/KTIK.rss', 'http://weather.gov/data/current_obs/KTIK.xml'),
('KTQH', 'OK', 'Tahlequah Municipal Airport', 35.930000, -95.000000, 'http://weather.noaa.gov/weather/current/KTQH.html', 'http://weather.gov/data/current_obs/KTQH.rss', 'http://weather.gov/data/current_obs/KTQH.xml'),
('KTUL', 'OK', 'Tulsa International Airport', 36.210000, -95.900000, 'http://weather.noaa.gov/weather/current/KTUL.html', 'http://weather.gov/data/current_obs/KTUL.rss', 'http://weather.gov/data/current_obs/KTUL.xml'),
('KWDG', 'OK', 'Enid / Woodring Municipal', 36.390000, -97.800000, 'http://weather.noaa.gov/weather/current/KWDG.html', 'http://weather.gov/data/current_obs/KWDG.rss', 'http://weather.gov/data/current_obs/KWDG.xml'),
('KWWR', 'OK', 'West Woodward', 36.440000, -99.520000, 'http://weather.noaa.gov/weather/current/KWWR.html', 'http://weather.gov/data/current_obs/KWWR.rss', 'http://weather.gov/data/current_obs/KWWR.xml'),
('KSRE', 'OK', 'Seminole Municipal Airport', 35.274400, -96.675000, 'http://weather.noaa.gov/weather/current/KSRE.html', 'http://weather.gov/data/current_obs/KSRE.rss', 'http://weather.gov/data/current_obs/KSRE.xml'),
('KONO', 'OR', 'Ontario Municipal', 44.020000, -117.010000, 'http://weather.noaa.gov/weather/current/KONO.html', 'http://weather.gov/data/current_obs/KONO.rss', 'http://weather.gov/data/current_obs/KONO.xml'),
('KREO', 'OR', 'Rome', 42.580000, -117.890000, 'http://weather.noaa.gov/weather/current/KREO.html', 'http://weather.gov/data/current_obs/KREO.rss', 'http://weather.gov/data/current_obs/KREO.xml'),
('K4BK', 'OR', 'Brookings', 42.050000, -124.283000, 'http://weather.noaa.gov/weather/current/K4BK.html', 'http://weather.gov/data/current_obs/K4BK.rss', 'http://weather.gov/data/current_obs/K4BK.xml'),
('K5J0', 'OR', 'John Day State Arpt', 44.420000, -118.950000, 'http://weather.noaa.gov/weather/current/K5J0.html', 'http://weather.gov/data/current_obs/K5J0.rss', 'http://weather.gov/data/current_obs/K5J0.xml'),
('K92S', 'OR', 'Cape Blanco (cgs)', 42.833000, -124.567000, 'http://weather.noaa.gov/weather/current/K92S.html', 'http://weather.gov/data/current_obs/K92S.rss', 'http://weather.gov/data/current_obs/K92S.xml'),
('KAST', 'OR', 'Astoria/Clatsop', 46.160000, -123.880000, 'http://weather.noaa.gov/weather/current/KAST.html', 'http://weather.gov/data/current_obs/KAST.rss', 'http://weather.gov/data/current_obs/KAST.xml'),
('KBKE', 'OR', 'Baker Municipal', 44.840000, -117.820000, 'http://weather.noaa.gov/weather/current/KBKE.html', 'http://weather.gov/data/current_obs/KBKE.rss', 'http://weather.gov/data/current_obs/KBKE.xml'),
('KBNO', 'OR', 'Burns Muni (amos)', 43.580000, -118.950000, 'http://weather.noaa.gov/weather/current/KBNO.html', 'http://weather.gov/data/current_obs/KBNO.rss', 'http://weather.gov/data/current_obs/KBNO.xml'),
('KBOK', 'OR', 'Brookings Airport', 42.083000, -124.283000, 'http://weather.noaa.gov/weather/current/KBOK.html', 'http://weather.gov/data/current_obs/KBOK.rss', 'http://weather.gov/data/current_obs/KBOK.xml'),
('KCVO', 'OR', 'Corvallis Muni Awos', 44.510000, -123.290000, 'http://weather.noaa.gov/weather/current/KCVO.html', 'http://weather.gov/data/current_obs/KCVO.rss', 'http://weather.gov/data/current_obs/KCVO.xml'),
('KCZK', 'OR', 'Cascade Locks State', 45.690000, -121.880000, 'http://weather.noaa.gov/weather/current/KCZK.html', 'http://weather.gov/data/current_obs/KCZK.rss', 'http://weather.gov/data/current_obs/KCZK.xml'),
('KDLS', 'OR', 'The Dalles Muni', 45.620000, -121.150000, 'http://weather.noaa.gov/weather/current/KDLS.html', 'http://weather.gov/data/current_obs/KDLS.rss', 'http://weather.gov/data/current_obs/KDLS.xml'),
('KEUG', 'OR', 'Eugene/Mahlon Sweet', 44.120000, -123.220000, 'http://weather.noaa.gov/weather/current/KEUG.html', 'http://weather.gov/data/current_obs/KEUG.rss', 'http://weather.gov/data/current_obs/KEUG.xml'),
('KHIO', 'OR', 'Portland/Hillsboro', 45.540000, -122.950000, 'http://weather.noaa.gov/weather/current/KHIO.html', 'http://weather.gov/data/current_obs/KHIO.rss', 'http://weather.gov/data/current_obs/KHIO.xml'),
('KHRI', 'OR', 'Hermiston (was S22)', 45.826000, -119.261000, 'http://weather.noaa.gov/weather/current/KHRI.html', 'http://weather.gov/data/current_obs/KHRI.rss', 'http://weather.gov/data/current_obs/KHRI.xml'),
('KJNW', 'OR', 'Newport', 44.583000, -124.067000, 'http://weather.noaa.gov/weather/current/KJNW.html', 'http://weather.gov/data/current_obs/KJNW.rss', 'http://weather.gov/data/current_obs/KJNW.xml'),
('KLGD', 'OR', 'La Grande (awos)', 45.283000, -118.000000, 'http://weather.noaa.gov/weather/current/KLGD.html', 'http://weather.gov/data/current_obs/KLGD.rss', 'http://weather.gov/data/current_obs/KLGD.xml'),
('KLKV', 'OR', 'Lakeview (awos)', 42.190000, -120.350000, 'http://weather.noaa.gov/weather/current/KLKV.html', 'http://weather.gov/data/current_obs/KLKV.rss', 'http://weather.gov/data/current_obs/KLKV.xml'),
('KLMT', 'OR', 'Klamath Falls/Kings', 42.160000, -121.730000, 'http://weather.noaa.gov/weather/current/KLMT.html', 'http://weather.gov/data/current_obs/KLMT.rss', 'http://weather.gov/data/current_obs/KLMT.xml'),
('KMEH', 'OR', 'Meacham (amos)', 45.510000, -118.400000, 'http://weather.noaa.gov/weather/current/KMEH.html', 'http://weather.gov/data/current_obs/KMEH.rss', 'http://weather.gov/data/current_obs/KMEH.xml'),
('KMFR', 'OR', 'Medford/Jackson Co.', 42.380000, -122.870000, 'http://weather.noaa.gov/weather/current/KMFR.html', 'http://weather.gov/data/current_obs/KMFR.rss', 'http://weather.gov/data/current_obs/KMFR.xml'),
('KMMV', 'OR', 'Mcminnville Municipal Airport', 45.190000, -123.140000, 'http://weather.noaa.gov/weather/current/KMMV.html', 'http://weather.gov/data/current_obs/KMMV.rss', 'http://weather.gov/data/current_obs/KMMV.xml'),
('KONP', 'OR', 'Newport Municip', 44.580000, -124.050000, 'http://weather.noaa.gov/weather/current/KONP.html', 'http://weather.gov/data/current_obs/KONP.rss', 'http://weather.gov/data/current_obs/KONP.xml'),
('KOTH', 'OR', 'North Bend (awos)', 43.430000, -124.250000, 'http://weather.noaa.gov/weather/current/KOTH.html', 'http://weather.gov/data/current_obs/KOTH.rss', 'http://weather.gov/data/current_obs/KOTH.xml'),
('KPDT', 'OR', 'Pendleton Municipal', 45.690000, -118.850000, 'http://weather.noaa.gov/weather/current/KPDT.html', 'http://weather.gov/data/current_obs/KPDT.rss', 'http://weather.gov/data/current_obs/KPDT.xml'),
('KPDX', 'OR', 'Portland Intl Arpt', 45.610000, -122.600000, 'http://weather.noaa.gov/weather/current/KPDX.html', 'http://weather.gov/data/current_obs/KPDX.rss', 'http://weather.gov/data/current_obs/KPDX.xml'),
('KRBG', 'OR', 'Roseburg Municipal', 43.230000, -123.370000, 'http://weather.noaa.gov/weather/current/KRBG.html', 'http://weather.gov/data/current_obs/KRBG.rss', 'http://weather.gov/data/current_obs/KRBG.xml'),
('KRDM', 'OR', 'Redmond (awos)', 44.280000, -121.150000, 'http://weather.noaa.gov/weather/current/KRDM.html', 'http://weather.gov/data/current_obs/KRDM.rss', 'http://weather.gov/data/current_obs/KRDM.xml'),
('KS47', 'OR', 'Tillamook Municipal Airport', 45.417000, -123.817000, 'http://weather.noaa.gov/weather/current/KS47.html', 'http://weather.gov/data/current_obs/KS47.rss', 'http://weather.gov/data/current_obs/KS47.xml'),
('KSLE', 'OR', 'Salem/Mcnary', 44.930000, -123.020000, 'http://weather.noaa.gov/weather/current/KSLE.html', 'http://weather.gov/data/current_obs/KSLE.rss', 'http://weather.gov/data/current_obs/KSLE.xml'),
('KSPB', 'OR', 'Scappoose Industrial Apk (1s4)', 45.769000, -122.862000, 'http://weather.noaa.gov/weather/current/KSPB.html', 'http://weather.gov/data/current_obs/KSPB.rss', 'http://weather.gov/data/current_obs/KSPB.xml'),
('KSXT', 'OR', 'Sexton Summit(amos)', 42.620000, -123.370000, 'http://weather.noaa.gov/weather/current/KSXT.html', 'http://weather.gov/data/current_obs/KSXT.rss', 'http://weather.gov/data/current_obs/KSXT.xml'),
('KTTD', 'OR', 'Portland/Troutdale', 45.550000, -122.400000, 'http://weather.noaa.gov/weather/current/KTTD.html', 'http://weather.gov/data/current_obs/KTTD.rss', 'http://weather.gov/data/current_obs/KTTD.xml'),
('KUAO', 'OR', 'Aurora State', 45.250000, -122.770000, 'http://weather.noaa.gov/weather/current/KUAO.html', 'http://weather.gov/data/current_obs/KUAO.rss', 'http://weather.gov/data/current_obs/KUAO.xml'),
('KMPO', 'PA', 'Pocono Mountains Municipal Airport', 41.140000, -75.380000, 'http://weather.noaa.gov/weather/current/KMPO.html', 'http://weather.gov/data/current_obs/KMPO.rss', 'http://weather.gov/data/current_obs/KMPO.xml'),
('KABE', 'PA', 'Allentown Lehigh Valley International Airport', 40.660000, -75.430000, 'http://weather.noaa.gov/weather/current/KABE.html', 'http://weather.gov/data/current_obs/KABE.rss', 'http://weather.gov/data/current_obs/KABE.xml'),
('KAFJ', 'PA', 'Washington Automatic Weather Observing / Reporting', 40.140000, -80.290000, 'http://weather.noaa.gov/weather/current/KAFJ.html', 'http://weather.gov/data/current_obs/KAFJ.rss', 'http://weather.gov/data/current_obs/KAFJ.xml'),
('KAGC', 'PA', 'Pittsburgh, Allegheny County Airport', 40.360000, -79.940000, 'http://weather.noaa.gov/weather/current/KAGC.html', 'http://weather.gov/data/current_obs/KAGC.rss', 'http://weather.gov/data/current_obs/KAGC.xml'),
('KAOO', 'PA', 'Altoona-Blair County Airport', 40.300000, -78.320000, 'http://weather.noaa.gov/weather/current/KAOO.html', 'http://weather.gov/data/current_obs/KAOO.rss', 'http://weather.gov/data/current_obs/KAOO.xml'),
('KAVP', 'PA', 'Wilkes-Barre / Scranton Intl Airport', 41.330000, -75.730000, 'http://weather.noaa.gov/weather/current/KAVP.html', 'http://weather.gov/data/current_obs/KAVP.rss', 'http://weather.gov/data/current_obs/KAVP.xml'),
('KBFD', 'PA', 'Bradford Regional Airport', 41.800000, -78.640000, 'http://weather.noaa.gov/weather/current/KBFD.html', 'http://weather.gov/data/current_obs/KBFD.rss', 'http://weather.gov/data/current_obs/KBFD.xml'),
('KBTP', 'PA', 'Butler County Automatic Weather Observing / Report', 40.790000, -79.950000, 'http://weather.noaa.gov/weather/current/KBTP.html', 'http://weather.gov/data/current_obs/KBTP.rss', 'http://weather.gov/data/current_obs/KBTP.xml'),
('KBVI', 'PA', 'Beaver Falls Airport', 40.760000, -80.330000, 'http://weather.noaa.gov/weather/current/KBVI.html', 'http://weather.gov/data/current_obs/KBVI.rss', 'http://weather.gov/data/current_obs/KBVI.xml'),
('KCXY', 'PA', 'Harrisburg, Capital City Airport', 40.230000, -76.850000, 'http://weather.noaa.gov/weather/current/KCXY.html', 'http://weather.gov/data/current_obs/KCXY.rss', 'http://weather.gov/data/current_obs/KCXY.xml'),
('KDUJ', 'PA', 'Du Bois-Jefferson County Airport', 41.190000, -78.900000, 'http://weather.noaa.gov/weather/current/KDUJ.html', 'http://weather.gov/data/current_obs/KDUJ.rss', 'http://weather.gov/data/current_obs/KDUJ.xml'),
('KDYL', 'PA', 'Doylestown Airport', 40.330000, -75.120000, 'http://weather.noaa.gov/weather/current/KDYL.html', 'http://weather.gov/data/current_obs/KDYL.rss', 'http://weather.gov/data/current_obs/KDYL.xml'),
('KERI', 'PA', 'Erie International Airport', 42.080000, -80.180000, 'http://weather.noaa.gov/weather/current/KERI.html', 'http://weather.gov/data/current_obs/KERI.rss', 'http://weather.gov/data/current_obs/KERI.xml'),
('KFIG', 'PA', 'Clearfield-Lawrence Airport', 41.047000, -78.412000, 'http://weather.noaa.gov/weather/current/KFIG.html', 'http://weather.gov/data/current_obs/KFIG.rss', 'http://weather.gov/data/current_obs/KFIG.xml'),
('KFKL', 'PA', 'Franklin Automatic Weather Observing / Reporting', 41.390000, -79.870000, 'http://weather.noaa.gov/weather/current/KFKL.html', 'http://weather.gov/data/current_obs/KFKL.rss', 'http://weather.gov/data/current_obs/KFKL.xml'),
('KGKJ', 'PA', 'Port Meadville Airport', 41.620000, -80.210000, 'http://weather.noaa.gov/weather/current/KGKJ.html', 'http://weather.gov/data/current_obs/KGKJ.rss', 'http://weather.gov/data/current_obs/KGKJ.xml'),
('KIDI', 'PA', 'Indiana / Stewart Field', 40.630000, -79.100000, 'http://weather.noaa.gov/weather/current/KIDI.html', 'http://weather.gov/data/current_obs/KIDI.rss', 'http://weather.gov/data/current_obs/KIDI.xml'),
('KIPT', 'PA', 'Williamsport-Lycoming County Airport', 41.260000, -76.920000, 'http://weather.noaa.gov/weather/current/KIPT.html', 'http://weather.gov/data/current_obs/KIPT.rss', 'http://weather.gov/data/current_obs/KIPT.xml'),
('KJST', 'PA', 'Johnstown-Cambria County Airport', 40.330000, -78.830000, 'http://weather.noaa.gov/weather/current/KJST.html', 'http://weather.gov/data/current_obs/KJST.rss', 'http://weather.gov/data/current_obs/KJST.xml'),
('KLBE', 'PA', 'Latrobe/Westmoreland', 40.290000, -79.400000, 'http://weather.noaa.gov/weather/current/KLBE.html', 'http://weather.gov/data/current_obs/KLBE.rss', 'http://weather.gov/data/current_obs/KLBE.xml'),
('KLNS', 'PA', 'Lancaster Airport', 40.120000, -76.300000, 'http://weather.noaa.gov/weather/current/KLNS.html', 'http://weather.gov/data/current_obs/KLNS.rss', 'http://weather.gov/data/current_obs/KLNS.xml'),
('KLOM', 'PA', 'Wings Field Airport', 40.138000, -75.265000, 'http://weather.noaa.gov/weather/current/KLOM.html', 'http://weather.gov/data/current_obs/KLOM.rss', 'http://weather.gov/data/current_obs/KLOM.xml'),
('KMDT', 'PA', 'Harrisburg International Airport', 40.210000, -76.770000, 'http://weather.noaa.gov/weather/current/KMDT.html', 'http://weather.gov/data/current_obs/KMDT.rss', 'http://weather.gov/data/current_obs/KMDT.xml'),
('KMUI', 'PA', 'Muir Army Air Field / Indiantown', 40.440000, -76.570000, 'http://weather.noaa.gov/weather/current/KMUI.html', 'http://weather.gov/data/current_obs/KMUI.rss', 'http://weather.gov/data/current_obs/KMUI.xml'),
('KNXX', 'PA', 'Willow Grove, Naval Air Station', 40.190000, -75.130000, 'http://weather.noaa.gov/weather/current/KNXX.html', 'http://weather.gov/data/current_obs/KNXX.rss', 'http://weather.gov/data/current_obs/KNXX.xml'),
('KPHL', 'PA', 'Philadelphia International Airport', 39.890000, -75.250000, 'http://weather.noaa.gov/weather/current/KPHL.html', 'http://weather.gov/data/current_obs/KPHL.rss', 'http://weather.gov/data/current_obs/KPHL.xml'),
('KPIT', 'PA', 'Pittsburgh International Airport', 40.510000, -80.220000, 'http://weather.noaa.gov/weather/current/KPIT.html', 'http://weather.gov/data/current_obs/KPIT.rss', 'http://weather.gov/data/current_obs/KPIT.xml'),
('KPNE', 'PA', 'Northeast Philadelphia Airport', 40.090000, -75.020000, 'http://weather.noaa.gov/weather/current/KPNE.html', 'http://weather.gov/data/current_obs/KPNE.rss', 'http://weather.gov/data/current_obs/KPNE.xml'),
('KPTW', 'PA', 'Pottstown Limerick Airport', 40.240000, -75.560000, 'http://weather.noaa.gov/weather/current/KPTW.html', 'http://weather.gov/data/current_obs/KPTW.rss', 'http://weather.gov/data/current_obs/KPTW.xml'),
('KRDG', 'PA', 'Reading Regional/Carl A. Spaatz Field Airport', 40.390000, -75.970000, 'http://weather.noaa.gov/weather/current/KRDG.html', 'http://weather.gov/data/current_obs/KRDG.rss', 'http://weather.gov/data/current_obs/KRDG.xml'),
('KSEG', 'PA', 'Selinsgrove, Penn Valley Airport', 40.820000, -76.860000, 'http://weather.noaa.gov/weather/current/KSEG.html', 'http://weather.gov/data/current_obs/KSEG.rss', 'http://weather.gov/data/current_obs/KSEG.xml'),
('KTHV', 'PA', 'York Airport', 39.920000, -76.870000, 'http://weather.noaa.gov/weather/current/KTHV.html', 'http://weather.gov/data/current_obs/KTHV.rss', 'http://weather.gov/data/current_obs/KTHV.xml'),
('KUKT', 'PA', 'Quakertown Airport', 40.435000, -75.382000, 'http://weather.noaa.gov/weather/current/KUKT.html', 'http://weather.gov/data/current_obs/KUKT.rss', 'http://weather.gov/data/current_obs/KUKT.xml'),
('KUNV', 'PA', 'State College', 40.860000, -77.830000, 'http://weather.noaa.gov/weather/current/KUNV.html', 'http://weather.gov/data/current_obs/KUNV.rss', 'http://weather.gov/data/current_obs/KUNV.xml'),
('NTAA', 'PF', 'Tahiti-Faaa', -17.550000, -149.617000, 'http://weather.noaa.gov/weather/current/NTAA.html', 'http://weather.gov/data/current_obs/NTAA.rss', 'http://weather.gov/data/current_obs/NTAA.xml'),
('TDPD', 'PR', 'Melville Hall Airport', 15.533000, -61.300000, 'http://weather.noaa.gov/weather/current/TDPD.html', 'http://weather.gov/data/current_obs/TDPD.rss', 'http://weather.gov/data/current_obs/TDPD.xml'),
('TFFR', 'PR', 'La Raizet Guadeloupe', 16.267000, -61.600000, 'http://weather.noaa.gov/weather/current/TFFR.html', 'http://weather.gov/data/current_obs/TFFR.rss', 'http://weather.gov/data/current_obs/TFFR.xml'),
('TJBQ', 'PR', 'Aquadilla (Boriquen)', 18.500000, -67.130000, 'http://weather.noaa.gov/weather/current/TJBQ.html', 'http://weather.gov/data/current_obs/TJBQ.rss', 'http://weather.gov/data/current_obs/TJBQ.xml'),
('TJMZ', 'PR', 'Mayaguez', 18.270000, -67.150000, 'http://weather.noaa.gov/weather/current/TJMZ.html', 'http://weather.gov/data/current_obs/TJMZ.rss', 'http://weather.gov/data/current_obs/TJMZ.xml'),
('TJNR', 'PR', 'Roosevelt Roads Naval Station', 18.250000, -65.633000, 'http://weather.noaa.gov/weather/current/TJNR.html', 'http://weather.gov/data/current_obs/TJNR.rss', 'http://weather.gov/data/current_obs/TJNR.xml'),
('TJPS', 'PR', 'Ponce', 18.020000, -66.570000, 'http://weather.noaa.gov/weather/current/TJPS.html', 'http://weather.gov/data/current_obs/TJPS.rss', 'http://weather.gov/data/current_obs/TJPS.xml'),
('TJSJ', 'PR', 'Luiz Munoz International Airport', 18.430000, -66.000000, 'http://weather.noaa.gov/weather/current/TJSJ.html', 'http://weather.gov/data/current_obs/TJSJ.rss', 'http://weather.gov/data/current_obs/TJSJ.xml'),
('TNCB', 'PR', 'Bonaire/Flamingo', 12.150000, -68.283000, 'http://weather.noaa.gov/weather/current/TNCB.html', 'http://weather.gov/data/current_obs/TNCB.rss', 'http://weather.gov/data/current_obs/TNCB.xml'),
('TNCC', 'PR', 'Curacao/Aeropuerto Hato', 12.200000, -68.967000, 'http://weather.noaa.gov/weather/current/TNCC.html', 'http://weather.gov/data/current_obs/TNCC.rss', 'http://weather.gov/data/current_obs/TNCC.xml'),
('TNCE', 'PR', 'St. Eustatius/F.D.Roosevelt', 17.483000, -62.983000, 'http://weather.noaa.gov/weather/current/TNCE.html', 'http://weather.gov/data/current_obs/TNCE.rss', 'http://weather.gov/data/current_obs/TNCE.xml'),
('TNCM', 'PR', 'St. Maarten/Princess Juliana', 18.033000, -63.117000, 'http://weather.noaa.gov/weather/current/TNCM.html', 'http://weather.gov/data/current_obs/TNCM.rss', 'http://weather.gov/data/current_obs/TNCM.xml'),
('TXKF', 'PR', 'Burmuda', 32.367000, -64.683000, 'http://weather.noaa.gov/weather/current/TXKF.html', 'http://weather.gov/data/current_obs/TXKF.rss', 'http://weather.gov/data/current_obs/TXKF.xml'),
('PTKR', 'PW', 'Koror', 7.270000, 134.450000, 'http://weather.noaa.gov/weather/current/PTKR.html', 'http://weather.gov/data/current_obs/PTKR.rss', 'http://weather.gov/data/current_obs/PTKR.xml'),
('PTRO', 'PW', 'Babelthuap/Koror', 7.330000, 134.480000, 'http://weather.noaa.gov/weather/current/PTRO.html', 'http://weather.gov/data/current_obs/PTRO.rss', 'http://weather.gov/data/current_obs/PTRO.xml'),
('KBID', 'RI', 'Block Island Automatic Weather Observing / Report', 41.180000, -71.580000, 'http://weather.noaa.gov/weather/current/KBID.html', 'http://weather.gov/data/current_obs/KBID.rss', 'http://weather.gov/data/current_obs/KBID.xml'),
('KOQU', 'RI', 'North Kingstown/Quonset State', 41.610000, -71.420000, 'http://weather.noaa.gov/weather/current/KOQU.html', 'http://weather.gov/data/current_obs/KOQU.rss', 'http://weather.gov/data/current_obs/KOQU.xml'),
('KPVD', 'RI', 'Providence, Green State Airport', 41.730000, -71.430000, 'http://weather.noaa.gov/weather/current/KPVD.html', 'http://weather.gov/data/current_obs/KPVD.rss', 'http://weather.gov/data/current_obs/KPVD.xml'),
('KSFZ', 'RI', 'Smithfield', 41.910000, -71.400000, 'http://weather.noaa.gov/weather/current/KSFZ.html', 'http://weather.gov/data/current_obs/KSFZ.rss', 'http://weather.gov/data/current_obs/KSFZ.xml'),
('KUUU', 'RI', 'Newport State Airport', 41.540000, -71.280000, 'http://weather.noaa.gov/weather/current/KUUU.html', 'http://weather.gov/data/current_obs/KUUU.rss', 'http://weather.gov/data/current_obs/KUUU.xml'),
('KWST', 'RI', 'Westerly State Airport', 41.350000, -71.800000, 'http://weather.noaa.gov/weather/current/KWST.html', 'http://weather.gov/data/current_obs/KWST.rss', 'http://weather.gov/data/current_obs/KWST.xml'),
('KAND', 'SC', 'Anderson County Airport', 34.510000, -82.720000, 'http://weather.noaa.gov/weather/current/KAND.html', 'http://weather.gov/data/current_obs/KAND.rss', 'http://weather.gov/data/current_obs/KAND.xml'),
('KCAE', 'SC', 'Columbia Metropolitan Airport', 33.960000, -81.120000, 'http://weather.noaa.gov/weather/current/KCAE.html', 'http://weather.gov/data/current_obs/KCAE.rss', 'http://weather.gov/data/current_obs/KCAE.xml'),
('KCEU', 'SC', 'Clemson-Oconee County Airport', 34.667000, -82.867000, 'http://weather.noaa.gov/weather/current/KCEU.html', 'http://weather.gov/data/current_obs/KCEU.rss', 'http://weather.gov/data/current_obs/KCEU.xml'),
('KCHS', 'SC', 'Charleston Air Force Base', 32.910000, -80.030000, 'http://weather.noaa.gov/weather/current/KCHS.html', 'http://weather.gov/data/current_obs/KCHS.rss', 'http://weather.gov/data/current_obs/KCHS.xml'),
('KCRE', 'SC', 'North Myrtle Beach, Grand Strand Airport', 33.810000, -78.720000, 'http://weather.noaa.gov/weather/current/KCRE.html', 'http://weather.gov/data/current_obs/KCRE.rss', 'http://weather.gov/data/current_obs/KCRE.xml'),
('KCUB', 'SC', 'Columbia Owens Downtown Airport', 33.990000, -81.000000, 'http://weather.noaa.gov/weather/current/KCUB.html', 'http://weather.gov/data/current_obs/KCUB.rss', 'http://weather.gov/data/current_obs/KCUB.xml'),
('KFLO', 'SC', 'Florence Regional Airport', 34.190000, -79.720000, 'http://weather.noaa.gov/weather/current/KFLO.html', 'http://weather.gov/data/current_obs/KFLO.rss', 'http://weather.gov/data/current_obs/KFLO.xml'),
('KGMU', 'SC', 'Greenville Downtown Airport', 34.850000, -82.350000, 'http://weather.noaa.gov/weather/current/KGMU.html', 'http://weather.gov/data/current_obs/KGMU.rss', 'http://weather.gov/data/current_obs/KGMU.xml'),
('KGRD', 'SC', 'Greenwood County Airport', 34.233000, -82.150000, 'http://weather.noaa.gov/weather/current/KGRD.html', 'http://weather.gov/data/current_obs/KGRD.rss', 'http://weather.gov/data/current_obs/KGRD.xml'),
('KGSP', 'SC', 'Greer, Greenville-Spartanburg Airport', 34.910000, -82.220000, 'http://weather.noaa.gov/weather/current/KGSP.html', 'http://weather.gov/data/current_obs/KGSP.rss', 'http://weather.gov/data/current_obs/KGSP.xml'),
('KGYH', 'SC', 'Donaldson Center Airport', 34.750000, -82.367000, 'http://weather.noaa.gov/weather/current/KGYH.html', 'http://weather.gov/data/current_obs/KGYH.rss', 'http://weather.gov/data/current_obs/KGYH.xml'),
('KHXD', 'SC', 'Hilton Head Airport', 32.232000, -80.700000, 'http://weather.noaa.gov/weather/current/KHXD.html', 'http://weather.gov/data/current_obs/KHXD.rss', 'http://weather.gov/data/current_obs/KHXD.xml'),
('KMMT', 'SC', 'McEntire Air National Guard Weather Facility Base', 33.930000, -80.800000, 'http://weather.noaa.gov/weather/current/KMMT.html', 'http://weather.gov/data/current_obs/KMMT.rss', 'http://weather.gov/data/current_obs/KMMT.xml'),
('KMYR', 'SC', 'Myrtle Beach International Airport', 33.690000, -78.930000, 'http://weather.noaa.gov/weather/current/KMYR.html', 'http://weather.gov/data/current_obs/KMYR.rss', 'http://weather.gov/data/current_obs/KMYR.xml'),
('KNBC', 'SC', 'Beaufort, Marine Corps Air Station', 32.480000, -80.720000, 'http://weather.noaa.gov/weather/current/KNBC.html', 'http://weather.gov/data/current_obs/KNBC.rss', 'http://weather.gov/data/current_obs/KNBC.xml'),
('KOGB', 'SC', 'Orangeburg Municipal Airport', 33.470000, -80.850000, 'http://weather.noaa.gov/weather/current/KOGB.html', 'http://weather.gov/data/current_obs/KOGB.rss', 'http://weather.gov/data/current_obs/KOGB.xml'),
('KSSC', 'SC', 'Shaw Air Force Base', 33.980000, -80.470000, 'http://weather.noaa.gov/weather/current/KSSC.html', 'http://weather.gov/data/current_obs/KSSC.rss', 'http://weather.gov/data/current_obs/KSSC.xml'),
('KUDG', 'SC', 'Darlington County Jetport Airport', 34.450000, -79.883000, 'http://weather.noaa.gov/weather/current/KUDG.html', 'http://weather.gov/data/current_obs/KUDG.rss', 'http://weather.gov/data/current_obs/KUDG.xml'),
('KUZA', 'SC', 'Rock Hill - York County Airport', 34.984000, -81.056000, 'http://weather.noaa.gov/weather/current/KUZA.html', 'http://weather.gov/data/current_obs/KUZA.rss', 'http://weather.gov/data/current_obs/KUZA.xml'),
('K8D3', 'SD', 'Sisseton Municipal Airport', 45.670000, -97.000000, 'http://weather.noaa.gov/weather/current/K8D3.html', 'http://weather.gov/data/current_obs/K8D3.rss', 'http://weather.gov/data/current_obs/K8D3.xml'),
('K9V9', 'SD', 'Chamberlain Municipal Airport', 43.800000, -99.320000, 'http://weather.noaa.gov/weather/current/K9V9.html', 'http://weather.gov/data/current_obs/K9V9.rss', 'http://weather.gov/data/current_obs/K9V9.xml'),
('KABR', 'SD', 'Aberdeen Regional Airport', 45.460000, -98.430000, 'http://weather.noaa.gov/weather/current/KABR.html', 'http://weather.gov/data/current_obs/KABR.rss', 'http://weather.gov/data/current_obs/KABR.xml'),
('KATY', 'SD', 'Watertown Municipal Airport', 44.920000, -97.160000, 'http://weather.noaa.gov/weather/current/KATY.html', 'http://weather.gov/data/current_obs/KATY.rss', 'http://weather.gov/data/current_obs/KATY.xml'),
('KBKX', 'SD', 'Brookings Automatic Weather Observing / Reporting', 44.300000, -96.800000, 'http://weather.noaa.gov/weather/current/KBKX.html', 'http://weather.gov/data/current_obs/KBKX.rss', 'http://weather.gov/data/current_obs/KBKX.xml'),
('KFSD', 'SD', 'Sioux Falls, Foss Field', 43.590000, -96.740000, 'http://weather.noaa.gov/weather/current/KFSD.html', 'http://weather.gov/data/current_obs/KFSD.rss', 'http://weather.gov/data/current_obs/KFSD.xml'),
('KHON', 'SD', 'Huron Regional Airport', 44.390000, -98.220000, 'http://weather.noaa.gov/weather/current/KHON.html', 'http://weather.gov/data/current_obs/KHON.rss', 'http://weather.gov/data/current_obs/KHON.xml'),
('KMBG', 'SD', 'Mobridge Municipal Airport', 45.550000, -100.410000, 'http://weather.noaa.gov/weather/current/KMBG.html', 'http://weather.gov/data/current_obs/KMBG.rss', 'http://weather.gov/data/current_obs/KMBG.xml'),
('KMHE', 'SD', 'Mitchell Municipal Airport', 43.770000, -98.040000, 'http://weather.noaa.gov/weather/current/KMHE.html', 'http://weather.gov/data/current_obs/KMHE.rss', 'http://weather.gov/data/current_obs/KMHE.xml'),
('KPIR', 'SD', 'Pierre Regional Airport', 44.390000, -100.280000, 'http://weather.noaa.gov/weather/current/KPIR.html', 'http://weather.gov/data/current_obs/KPIR.rss', 'http://weather.gov/data/current_obs/KPIR.xml'),
('KICR', 'SD', 'Winner Regional Airport', 43.380000, -99.850000, 'http://weather.noaa.gov/weather/current/KICR.html', 'http://weather.gov/data/current_obs/KICR.rss', 'http://weather.gov/data/current_obs/KICR.xml'),
('KYKN', 'SD', 'Yankton Automatic Weather Observing/Reporting Sys', 42.920000, -97.380000, 'http://weather.noaa.gov/weather/current/KYKN.html', 'http://weather.gov/data/current_obs/KYKN.rss', 'http://weather.gov/data/current_obs/KYKN.xml'),
('K2WX', 'SD', 'Buffalo', 45.570000, -103.530000, 'http://weather.noaa.gov/weather/current/K2WX.html', 'http://weather.gov/data/current_obs/K2WX.rss', 'http://weather.gov/data/current_obs/K2WX.xml'),
('KCUT', 'SD', 'Custer County Airport', 43.733000, -103.618000, 'http://weather.noaa.gov/weather/current/KCUT.html', 'http://weather.gov/data/current_obs/KCUT.rss', 'http://weather.gov/data/current_obs/KCUT.xml'),
('KD07', 'SD', 'Faith', 45.040000, -102.020000, 'http://weather.noaa.gov/weather/current/KD07.html', 'http://weather.gov/data/current_obs/KD07.rss', 'http://weather.gov/data/current_obs/KD07.xml'),
('KEFC', 'SD', 'Belle Fourche Municipal Airport', 44.710000, -103.800000, 'http://weather.noaa.gov/weather/current/KEFC.html', 'http://weather.gov/data/current_obs/KEFC.rss', 'http://weather.gov/data/current_obs/KEFC.xml'),
('KIEN', 'SD', 'Pine Ridge Airport', 43.010000, -102.510000, 'http://weather.noaa.gov/weather/current/KIEN.html', 'http://weather.gov/data/current_obs/KIEN.rss', 'http://weather.gov/data/current_obs/KIEN.xml'),
('KPHP', 'SD', 'Philip Airport', 44.050000, -101.600000, 'http://weather.noaa.gov/weather/current/KPHP.html', 'http://weather.gov/data/current_obs/KPHP.rss', 'http://weather.gov/data/current_obs/KPHP.xml'),
('KRAP', 'SD', 'Rapid City Regional Airport', 44.050000, -103.070000, 'http://weather.noaa.gov/weather/current/KRAP.html', 'http://weather.gov/data/current_obs/KRAP.rss', 'http://weather.gov/data/current_obs/KRAP.xml'),
('KRCA', 'SD', 'Ellsworth Air Force Base', 44.150000, -103.100000, 'http://weather.noaa.gov/weather/current/KRCA.html', 'http://weather.gov/data/current_obs/KRCA.rss', 'http://weather.gov/data/current_obs/KRCA.xml'),
('KBNA', 'TN', 'Nashville International Airport', 36.120000, -86.680000, 'http://weather.noaa.gov/weather/current/KBNA.html', 'http://weather.gov/data/current_obs/KBNA.rss', 'http://weather.gov/data/current_obs/KBNA.xml'),
('KCKV', 'TN', 'Clarksville, Outlaw Field Airport', 36.620000, -87.420000, 'http://weather.noaa.gov/weather/current/KCKV.html', 'http://weather.gov/data/current_obs/KCKV.rss', 'http://weather.gov/data/current_obs/KCKV.xml'),
('KCSV', 'TN', 'Crossville Memorial-Whitson Field Airport', 35.960000, -85.080000, 'http://weather.noaa.gov/weather/current/KCSV.html', 'http://weather.gov/data/current_obs/KCSV.rss', 'http://weather.gov/data/current_obs/KCSV.xml'),
('KDYR', 'TN', 'Dyersburg Automatic Weather Observing / Reporting', 36.030000, -89.400000, 'http://weather.noaa.gov/weather/current/KDYR.html', 'http://weather.gov/data/current_obs/KDYR.rss', 'http://weather.gov/data/current_obs/KDYR.xml'),
('KMEM', 'TN', 'Memphis International Airport', 35.040000, -89.980000, 'http://weather.noaa.gov/weather/current/KMEM.html', 'http://weather.gov/data/current_obs/KMEM.rss', 'http://weather.gov/data/current_obs/KMEM.xml'),
('KMKL', 'TN', 'Jackson, McKellar-Sipes Regional Airport', 35.610000, -88.920000, 'http://weather.noaa.gov/weather/current/KMKL.html', 'http://weather.gov/data/current_obs/KMKL.rss', 'http://weather.gov/data/current_obs/KMKL.xml'),
('KMQY', 'TN', 'Smyrna', 36.010000, -86.500000, 'http://weather.noaa.gov/weather/current/KMQY.html', 'http://weather.gov/data/current_obs/KMQY.rss', 'http://weather.gov/data/current_obs/KMQY.xml'),
('KNQA', 'TN', 'Millington Municipal Airport', 35.360000, -89.870000, 'http://weather.noaa.gov/weather/current/KNQA.html', 'http://weather.gov/data/current_obs/KNQA.rss', 'http://weather.gov/data/current_obs/KNQA.xml'),
('KCHA', 'TN', 'Chattanooga, Lovell Field', 35.040000, -85.200000, 'http://weather.noaa.gov/weather/current/KCHA.html', 'http://weather.gov/data/current_obs/KCHA.rss', 'http://weather.gov/data/current_obs/KCHA.xml'),
('KMRX', 'TN', 'Morristown Nexrad', 36.167000, -83.400000, 'http://weather.noaa.gov/weather/current/KMRX.html', 'http://weather.gov/data/current_obs/KMRX.rss', 'http://weather.gov/data/current_obs/KMRX.xml'),
('KOQT', 'TN', 'Oak Ridge', 36.020000, -84.230000, 'http://weather.noaa.gov/weather/current/KOQT.html', 'http://weather.gov/data/current_obs/KOQT.rss', 'http://weather.gov/data/current_obs/KOQT.xml'),
('KTRI', 'TN', 'Tri-Cities Airport', 36.480000, -82.400000, 'http://weather.noaa.gov/weather/current/KTRI.html', 'http://weather.gov/data/current_obs/KTRI.rss', 'http://weather.gov/data/current_obs/KTRI.xml'),
('KTYS', 'TN', 'Knoxville, McGhee Tyson Airport', 35.810000, -83.980000, 'http://weather.noaa.gov/weather/current/KTYS.html', 'http://weather.gov/data/current_obs/KTYS.rss', 'http://weather.gov/data/current_obs/KTYS.xml'),
('NFTF', 'TO', 'Fau Amotu', -21.233000, -175.150000, 'http://weather.noaa.gov/weather/current/NFTF.html', 'http://weather.gov/data/current_obs/NFTF.rss', 'http://weather.gov/data/current_obs/NFTF.xml'),
('NFTV', 'TO', 'Vavu International', -18.583000, -173.950000, 'http://weather.noaa.gov/weather/current/NFTV.html', 'http://weather.gov/data/current_obs/NFTV.rss', 'http://weather.gov/data/current_obs/NFTV.xml'),
('TTCP', 'TT', 'Crown Pt./Scarborou', 11.150000, -60.833000, 'http://weather.noaa.gov/weather/current/TTCP.html', 'http://weather.gov/data/current_obs/TTCP.rss', 'http://weather.gov/data/current_obs/TTCP.xml'),
('TTPP', 'TT', 'Piarco Intl Airport/Trinidad', 10.617000, -61.350000, 'http://weather.noaa.gov/weather/current/TTPP.html', 'http://weather.gov/data/current_obs/TTPP.rss', 'http://weather.gov/data/current_obs/TTPP.xml'),
('NGFU', 'TV', 'Funafuti', -8.533000, 179.217000, 'http://weather.noaa.gov/weather/current/NGFU.html', 'http://weather.gov/data/current_obs/NGFU.rss', 'http://weather.gov/data/current_obs/NGFU.xml'),
('K11R', 'TX', 'Brenham Municipal Airport', 30.219000, -96.374000, 'http://weather.noaa.gov/weather/current/K11R.html', 'http://weather.gov/data/current_obs/K11R.rss', 'http://weather.gov/data/current_obs/K11R.xml'),
('K2R8', 'TX', 'Mustang Beach Airport', 27.817000, -97.083000, 'http://weather.noaa.gov/weather/current/K2R8.html', 'http://weather.gov/data/current_obs/K2R8.rss', 'http://weather.gov/data/current_obs/K2R8.xml'),
('K3T5', 'TX', 'La Grange', 29.910000, -96.950000, 'http://weather.noaa.gov/weather/current/K3T5.html', 'http://weather.gov/data/current_obs/K3T5.rss', 'http://weather.gov/data/current_obs/K3T5.xml'),
('K6R6', 'TX', 'Dryden Terrel County Airport', 30.422000, -102.278000, 'http://weather.noaa.gov/weather/current/K6R6.html', 'http://weather.gov/data/current_obs/K6R6.rss', 'http://weather.gov/data/current_obs/K6R6.xml'),
('KABI', 'TX', 'Abilene Regional Airport', 32.430000, -99.680000, 'http://weather.noaa.gov/weather/current/KABI.html', 'http://weather.gov/data/current_obs/KABI.rss', 'http://weather.gov/data/current_obs/KABI.xml'),
('KACT', 'TX', 'Waco Regional Airport', 31.620000, -97.220000, 'http://weather.noaa.gov/weather/current/KACT.html', 'http://weather.gov/data/current_obs/KACT.rss', 'http://weather.gov/data/current_obs/KACT.xml'),
('KADS', 'TX', 'Dallas / Addison Airport', 32.980000, -96.830000, 'http://weather.noaa.gov/weather/current/KADS.html', 'http://weather.gov/data/current_obs/KADS.rss', 'http://weather.gov/data/current_obs/KADS.xml'),
('KAFW', 'TX', 'Fort Worth Alliance Airport', 32.980000, -97.320000, 'http://weather.noaa.gov/weather/current/KAFW.html', 'http://weather.gov/data/current_obs/KAFW.rss', 'http://weather.gov/data/current_obs/KAFW.xml'),
('KALI', 'TX', 'Alice International Airport', 27.740000, -98.040000, 'http://weather.noaa.gov/weather/current/KALI.html', 'http://weather.gov/data/current_obs/KALI.rss', 'http://weather.gov/data/current_obs/KALI.xml'),
('KAMA', 'TX', 'Rick Husband Amarillo Intl Airport', 35.230000, -101.700000, 'http://weather.noaa.gov/weather/current/KAMA.html', 'http://weather.gov/data/current_obs/KAMA.rss', 'http://weather.gov/data/current_obs/KAMA.xml'),
('KARM', 'TX', 'Wharton Regional Airport', 29.250000, -96.117000, 'http://weather.noaa.gov/weather/current/KARM.html', 'http://weather.gov/data/current_obs/KARM.rss', 'http://weather.gov/data/current_obs/KARM.xml'),
('KATT', 'TX', 'Camp Mabry / Austin City', 30.320000, -97.770000, 'http://weather.noaa.gov/weather/current/KATT.html', 'http://weather.gov/data/current_obs/KATT.rss', 'http://weather.gov/data/current_obs/KATT.xml'),
('KAUS', 'TX', 'Austin-Bergstrom International Airport', 30.200000, -97.680000, 'http://weather.noaa.gov/weather/current/KAUS.html', 'http://weather.gov/data/current_obs/KAUS.rss', 'http://weather.gov/data/current_obs/KAUS.xml'),
('KBAZ', 'TX', 'New Braunfels Municipal Airport', 29.709000, -98.045000, 'http://weather.noaa.gov/weather/current/KBAZ.html', 'http://weather.gov/data/current_obs/KBAZ.rss', 'http://weather.gov/data/current_obs/KBAZ.xml'),
('KBBD', 'TX', 'Curtis Field Airport', 31.183000, -99.317000, 'http://weather.noaa.gov/weather/current/KBBD.html', 'http://weather.gov/data/current_obs/KBBD.rss', 'http://weather.gov/data/current_obs/KBBD.xml'),
('KBGD', 'TX', 'Borger, Hutchinson County Airport', 35.710000, -101.400000, 'http://weather.noaa.gov/weather/current/KBGD.html', 'http://weather.gov/data/current_obs/KBGD.rss', 'http://weather.gov/data/current_obs/KBGD.xml'),
('KBKS', 'TX', 'Brooks County Airport', 27.207000, -98.121000, 'http://weather.noaa.gov/weather/current/KBKS.html', 'http://weather.gov/data/current_obs/KBKS.rss', 'http://weather.gov/data/current_obs/KBKS.xml'),
('KBMQ', 'TX', 'Burnet Municipal Craddock Field', 30.740000, -98.230000, 'http://weather.noaa.gov/weather/current/KBMQ.html', 'http://weather.gov/data/current_obs/KBMQ.rss', 'http://weather.gov/data/current_obs/KBMQ.xml'),
('KBPG', 'TX', 'Big Spring', 32.213000, -101.522000, 'http://weather.noaa.gov/weather/current/KBPG.html', 'http://weather.gov/data/current_obs/KBPG.rss', 'http://weather.gov/data/current_obs/KBPG.xml'),
('KBPT', 'TX', 'Beaumont/Port Arthur, SE Texas Regional Airport', 29.950000, -94.020000, 'http://weather.noaa.gov/weather/current/KBPT.html', 'http://weather.gov/data/current_obs/KBPT.rss', 'http://weather.gov/data/current_obs/KBPT.xml'),
('KBRO', 'TX', 'Brownsville / South Padre Island Intl Airport', 25.900000, -97.430000, 'http://weather.noaa.gov/weather/current/KBRO.html', 'http://weather.gov/data/current_obs/KBRO.rss', 'http://weather.gov/data/current_obs/KBRO.xml'),
('KBWD', 'TX', 'Brownwood', 31.800000, -98.950000, 'http://weather.noaa.gov/weather/current/KBWD.html', 'http://weather.gov/data/current_obs/KBWD.rss', 'http://weather.gov/data/current_obs/KBWD.xml'),
('KBYY', 'TX', 'Bay City', 28.973000, -95.863000, 'http://weather.noaa.gov/weather/current/KBYY.html', 'http://weather.gov/data/current_obs/KBYY.rss', 'http://weather.gov/data/current_obs/KBYY.xml'),
('KCDS', 'TX', 'Childress Municipal Airport', 34.440000, -100.280000, 'http://weather.noaa.gov/weather/current/KCDS.html', 'http://weather.gov/data/current_obs/KCDS.rss', 'http://weather.gov/data/current_obs/KCDS.xml'),
('KCLL', 'TX', 'College Station, Easterwood Field', 30.580000, -96.370000, 'http://weather.noaa.gov/weather/current/KCLL.html', 'http://weather.gov/data/current_obs/KCLL.rss', 'http://weather.gov/data/current_obs/KCLL.xml'),
('KCOT', 'TX', 'Cotulla-La Salle County Airport', 28.450000, -99.220000, 'http://weather.noaa.gov/weather/current/KCOT.html', 'http://weather.gov/data/current_obs/KCOT.rss', 'http://weather.gov/data/current_obs/KCOT.xml'),
('KCPT', 'TX', 'Cleburne Municipal Airport', 32.350000, -97.433000, 'http://weather.noaa.gov/weather/current/KCPT.html', 'http://weather.gov/data/current_obs/KCPT.rss', 'http://weather.gov/data/current_obs/KCPT.xml'),
('KCRP', 'TX', 'Corpus Christi International Airport', 27.770000, -97.500000, 'http://weather.noaa.gov/weather/current/KCRP.html', 'http://weather.gov/data/current_obs/KCRP.rss', 'http://weather.gov/data/current_obs/KCRP.xml'),
('KCRS', 'TX', 'Campbell Field-Corsicana Municipal Airport', 32.030000, -96.400000, 'http://weather.noaa.gov/weather/current/KCRS.html', 'http://weather.gov/data/current_obs/KCRS.rss', 'http://weather.gov/data/current_obs/KCRS.xml'),
('KCXO', 'TX', 'Conroe, Montgomery County Airport', 30.360000, -95.410000, 'http://weather.noaa.gov/weather/current/KCXO.html', 'http://weather.gov/data/current_obs/KCXO.rss', 'http://weather.gov/data/current_obs/KCXO.xml'),
('KDAL', 'TX', 'Dallas Love Field', 32.860000, -96.850000, 'http://weather.noaa.gov/weather/current/KDAL.html', 'http://weather.gov/data/current_obs/KDAL.rss', 'http://weather.gov/data/current_obs/KDAL.xml'),
('KDFW', 'TX', 'Dallas / Fort Worth International Airport', 32.910000, -97.030000, 'http://weather.noaa.gov/weather/current/KDFW.html', 'http://weather.gov/data/current_obs/KDFW.rss', 'http://weather.gov/data/current_obs/KDFW.xml'),
('KDHT', 'TX', 'Dalhart Municipal Airport', 36.030000, -102.550000, 'http://weather.noaa.gov/weather/current/KDHT.html', 'http://weather.gov/data/current_obs/KDHT.rss', 'http://weather.gov/data/current_obs/KDHT.xml'),
('KDLF', 'TX', 'Laughlin Air Force Base Auxiliary Airfield', 29.367000, -100.783000, 'http://weather.noaa.gov/weather/current/KDLF.html', 'http://weather.gov/data/current_obs/KDLF.rss', 'http://weather.gov/data/current_obs/KDLF.xml'),
('KDRT', 'TX', 'Del Rio International Airport', 29.380000, -100.920000, 'http://weather.noaa.gov/weather/current/KDRT.html', 'http://weather.gov/data/current_obs/KDRT.rss', 'http://weather.gov/data/current_obs/KDRT.xml'),
('KDTO', 'TX', 'Denton Municipal Airport', 33.200000, -97.180000, 'http://weather.noaa.gov/weather/current/KDTO.html', 'http://weather.gov/data/current_obs/KDTO.rss', 'http://weather.gov/data/current_obs/KDTO.xml'),
('KDUX', 'TX', 'Moore County Airport', 35.850000, -102.017000, 'http://weather.noaa.gov/weather/current/KDUX.html', 'http://weather.gov/data/current_obs/KDUX.rss', 'http://weather.gov/data/current_obs/KDUX.xml'),
('KDWH', 'TX', 'Houston, Hooks Memorial Airport', 30.070000, -95.550000, 'http://weather.noaa.gov/weather/current/KDWH.html', 'http://weather.gov/data/current_obs/KDWH.rss', 'http://weather.gov/data/current_obs/KDWH.xml'),
('KDYS', 'TX', 'Abilene, Dyess Air Force Base', 32.417000, -99.850000, 'http://weather.noaa.gov/weather/current/KDYS.html', 'http://weather.gov/data/current_obs/KDYS.rss', 'http://weather.gov/data/current_obs/KDYS.xml'),
('KE38', 'TX', 'Casparis Municipal Airport', 30.384000, -103.684000, 'http://weather.noaa.gov/weather/current/KE38.html', 'http://weather.gov/data/current_obs/KE38.rss', 'http://weather.gov/data/current_obs/KE38.xml'),
('KEBG', 'TX', 'Edinburg Intl Airport', 26.442000, -98.129000, 'http://weather.noaa.gov/weather/current/KEBG.html', 'http://weather.gov/data/current_obs/KEBG.rss', 'http://weather.gov/data/current_obs/KEBG.xml');

INSERT INTO `#__zweather_stations` (`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES
('KECU', 'TX', 'Edwards County Airport', 29.950000, -100.167000, 'http://weather.noaa.gov/weather/current/KECU.html', 'http://weather.gov/data/current_obs/KECU.rss', 'http://weather.gov/data/current_obs/KECU.xml'),
('KEFD', 'TX', 'Houston / Ellington', 29.620000, -95.170000, 'http://weather.noaa.gov/weather/current/KEFD.html', 'http://weather.gov/data/current_obs/KEFD.rss', 'http://weather.gov/data/current_obs/KEFD.xml'),
('KERV', 'TX', 'Kerrville', 29.980000, -99.080000, 'http://weather.noaa.gov/weather/current/KERV.html', 'http://weather.gov/data/current_obs/KERV.rss', 'http://weather.gov/data/current_obs/KERV.xml'),
('KF05', 'TX', 'Vernon', 34.226000, -99.284000, 'http://weather.noaa.gov/weather/current/KF05.html', 'http://weather.gov/data/current_obs/KF05.rss', 'http://weather.gov/data/current_obs/KF05.xml'),
('KF39', 'TX', 'Sherman-Denison', 33.717000, -96.667000, 'http://weather.noaa.gov/weather/current/KF39.html', 'http://weather.gov/data/current_obs/KF39.rss', 'http://weather.gov/data/current_obs/KF39.xml'),
('KFST', 'TX', 'Fort Stockton-Pecos County Airport', 30.910000, -102.910000, 'http://weather.noaa.gov/weather/current/KFST.html', 'http://weather.gov/data/current_obs/KFST.rss', 'http://weather.gov/data/current_obs/KFST.xml'),
('KFTW', 'TX', 'Fort Worth, Meacham International Airport', 32.830000, -97.350000, 'http://weather.noaa.gov/weather/current/KFTW.html', 'http://weather.gov/data/current_obs/KFTW.rss', 'http://weather.gov/data/current_obs/KFTW.xml'),
('KFWS', 'TX', 'Fort Worth Spinks Airport', 32.510000, -97.300000, 'http://weather.noaa.gov/weather/current/KFWS.html', 'http://weather.gov/data/current_obs/KFWS.rss', 'http://weather.gov/data/current_obs/KFWS.xml'),
('KGDJ', 'TX', 'Granbury Municipal Airport', 32.444000, -97.817000, 'http://weather.noaa.gov/weather/current/KGDJ.html', 'http://weather.gov/data/current_obs/KGDJ.rss', 'http://weather.gov/data/current_obs/KGDJ.xml'),
('KGDP', 'TX', 'Pine Springs, Guadalupe Mountains National Park', 31.830000, -104.800000, 'http://weather.noaa.gov/weather/current/KGDP.html', 'http://weather.gov/data/current_obs/KGDP.rss', 'http://weather.gov/data/current_obs/KGDP.xml'),
('KGGG', 'TX', 'Longview, Gregg County Airport', 32.380000, -94.710000, 'http://weather.noaa.gov/weather/current/KGGG.html', 'http://weather.gov/data/current_obs/KGGG.rss', 'http://weather.gov/data/current_obs/KGGG.xml'),
('KGKY', 'TX', 'Arlington Municipal Airport', 32.664000, -97.096000, 'http://weather.noaa.gov/weather/current/KGKY.html', 'http://weather.gov/data/current_obs/KGKY.rss', 'http://weather.gov/data/current_obs/KGKY.xml'),
('KGLE', 'TX', 'Gainesville Municipal Airport', 33.652000, -97.200000, 'http://weather.noaa.gov/weather/current/KGLE.html', 'http://weather.gov/data/current_obs/KGLE.rss', 'http://weather.gov/data/current_obs/KGLE.xml'),
('KGLS', 'TX', 'Galveston, Scholes Field', 29.270000, -94.870000, 'http://weather.noaa.gov/weather/current/KGLS.html', 'http://weather.gov/data/current_obs/KGLS.rss', 'http://weather.gov/data/current_obs/KGLS.xml'),
('KGNC', 'TX', 'Gaines County Airport', 32.667000, -102.650000, 'http://weather.noaa.gov/weather/current/KGNC.html', 'http://weather.gov/data/current_obs/KGNC.rss', 'http://weather.gov/data/current_obs/KGNC.xml'),
('KGOP', 'TX', 'Gatesville', 31.417000, -97.783000, 'http://weather.noaa.gov/weather/current/KGOP.html', 'http://weather.gov/data/current_obs/KGOP.rss', 'http://weather.gov/data/current_obs/KGOP.xml'),
('KGPM', 'TX', 'Grand Prairie Municipal Airport', 32.699000, -97.047000, 'http://weather.noaa.gov/weather/current/KGPM.html', 'http://weather.gov/data/current_obs/KGPM.rss', 'http://weather.gov/data/current_obs/KGPM.xml'),
('KGRK', 'TX', 'Killeen - Robert Gray International Airport', 31.067000, -97.833000, 'http://weather.noaa.gov/weather/current/KGRK.html', 'http://weather.gov/data/current_obs/KGRK.rss', 'http://weather.gov/data/current_obs/KGRK.xml'),
('KGTU', 'TX', 'Georgetown Automatic Weather Observing / Reporting', 30.690000, -97.690000, 'http://weather.noaa.gov/weather/current/KGTU.html', 'http://weather.gov/data/current_obs/KGTU.rss', 'http://weather.gov/data/current_obs/KGTU.xml'),
('KGVT', 'TX', 'Greenville / Majors', 33.080000, -96.070000, 'http://weather.noaa.gov/weather/current/KGVT.html', 'http://weather.gov/data/current_obs/KGVT.rss', 'http://weather.gov/data/current_obs/KGVT.xml'),
('KGYI', 'TX', 'Grayson County Airport', 33.730000, -96.670000, 'http://weather.noaa.gov/weather/current/KGYI.html', 'http://weather.gov/data/current_obs/KGYI.rss', 'http://weather.gov/data/current_obs/KGYI.xml'),
('KHBV', 'TX', 'Jim Hogg County Airport', 27.333000, -98.733000, 'http://weather.noaa.gov/weather/current/KHBV.html', 'http://weather.gov/data/current_obs/KHBV.rss', 'http://weather.gov/data/current_obs/KHBV.xml'),
('KHDO', 'TX', 'Hondo Municipal Airport', 29.360000, -99.160000, 'http://weather.noaa.gov/weather/current/KHDO.html', 'http://weather.gov/data/current_obs/KHDO.rss', 'http://weather.gov/data/current_obs/KHDO.xml'),
('KHHF', 'TX', 'Hemphill County Airport', 35.895000, -100.404000, 'http://weather.noaa.gov/weather/current/KHHF.html', 'http://weather.gov/data/current_obs/KHHF.rss', 'http://weather.gov/data/current_obs/KHHF.xml'),
('KHLR', 'TX', 'Fort Hood', 31.150000, -97.717000, 'http://weather.noaa.gov/weather/current/KHLR.html', 'http://weather.gov/data/current_obs/KHLR.rss', 'http://weather.gov/data/current_obs/KHLR.xml'),
('KHOU', 'TX', 'Houston Hobby Airport', 29.650000, -95.280000, 'http://weather.noaa.gov/weather/current/KHOU.html', 'http://weather.gov/data/current_obs/KHOU.rss', 'http://weather.gov/data/current_obs/KHOU.xml'),
('KHQZ', 'TX', 'Mesquite Metro Airport', 32.747000, -96.530000, 'http://weather.noaa.gov/weather/current/KHQZ.html', 'http://weather.gov/data/current_obs/KHQZ.rss', 'http://weather.gov/data/current_obs/KHQZ.xml'),
('KHRL', 'TX', 'Harlingen, Rio Grande Valley International Airport', 26.230000, -97.670000, 'http://weather.noaa.gov/weather/current/KHRL.html', 'http://weather.gov/data/current_obs/KHRL.rss', 'http://weather.gov/data/current_obs/KHRL.xml'),
('KHYI', 'TX', 'San Marcos Municipal Airport', 29.900000, -97.870000, 'http://weather.noaa.gov/weather/current/KHYI.html', 'http://weather.gov/data/current_obs/KHYI.rss', 'http://weather.gov/data/current_obs/KHYI.xml'),
('KIAH', 'TX', 'Houston Intercontinental Airport', 29.970000, -95.350000, 'http://weather.noaa.gov/weather/current/KIAH.html', 'http://weather.gov/data/current_obs/KIAH.rss', 'http://weather.gov/data/current_obs/KIAH.xml'),
('KILE', 'TX', 'Killeen - Skylark Field', 31.090000, -97.690000, 'http://weather.noaa.gov/weather/current/KILE.html', 'http://weather.gov/data/current_obs/KILE.rss', 'http://weather.gov/data/current_obs/KILE.xml'),
('KINJ', 'TX', 'Hillsboro Municipal Airport', 32.083000, -97.097000, 'http://weather.noaa.gov/weather/current/KINJ.html', 'http://weather.gov/data/current_obs/KINJ.rss', 'http://weather.gov/data/current_obs/KINJ.xml'),
('KINK', 'TX', 'Winkler County Airport', 31.790000, -103.200000, 'http://weather.noaa.gov/weather/current/KINK.html', 'http://weather.gov/data/current_obs/KINK.rss', 'http://weather.gov/data/current_obs/KINK.xml'),
('KJAS', 'TX', 'Jasper', 30.890000, -94.030000, 'http://weather.noaa.gov/weather/current/KJAS.html', 'http://weather.gov/data/current_obs/KJAS.rss', 'http://weather.gov/data/current_obs/KJAS.xml'),
('KJCT', 'TX', 'Junction, Kimble County Airport', 30.500000, -99.770000, 'http://weather.noaa.gov/weather/current/KJCT.html', 'http://weather.gov/data/current_obs/KJCT.rss', 'http://weather.gov/data/current_obs/KJCT.xml'),
('KJSO', 'TX', 'Cherokee County Airport', 31.869000, -95.217000, 'http://weather.noaa.gov/weather/current/KJSO.html', 'http://weather.gov/data/current_obs/KJSO.rss', 'http://weather.gov/data/current_obs/KJSO.xml'),
('KJWY', 'TX', 'Midlothian-Waxahachie Midway Airport', 32.456000, -96.912000, 'http://weather.noaa.gov/weather/current/KJWY.html', 'http://weather.gov/data/current_obs/KJWY.rss', 'http://weather.gov/data/current_obs/KJWY.xml'),
('KLBB', 'TX', 'Lubbock International Airport', 33.660000, -101.820000, 'http://weather.noaa.gov/weather/current/KLBB.html', 'http://weather.gov/data/current_obs/KLBB.rss', 'http://weather.gov/data/current_obs/KLBB.xml'),
('KLBR', 'TX', 'Clarksville', 33.593000, -95.064000, 'http://weather.noaa.gov/weather/current/KLBR.html', 'http://weather.gov/data/current_obs/KLBR.rss', 'http://weather.gov/data/current_obs/KLBR.xml'),
('KLBX', 'TX', 'Angleton / Lake Jackson, Brazoria County Airport', 29.120000, -95.470000, 'http://weather.noaa.gov/weather/current/KLBX.html', 'http://weather.gov/data/current_obs/KLBX.rss', 'http://weather.gov/data/current_obs/KLBX.xml'),
('KLFK', 'TX', 'Lufkin, Angelina County Airport', 31.230000, -94.750000, 'http://weather.noaa.gov/weather/current/KLFK.html', 'http://weather.gov/data/current_obs/KLFK.rss', 'http://weather.gov/data/current_obs/KLFK.xml'),
('KLHB', 'TX', 'Hearne Municipal Airport', 30.872000, -96.622000, 'http://weather.noaa.gov/weather/current/KLHB.html', 'http://weather.gov/data/current_obs/KLHB.rss', 'http://weather.gov/data/current_obs/KLHB.xml'),
('KLNC', 'TX', 'Lancaster Airport', 32.579000, -96.719000, 'http://weather.noaa.gov/weather/current/KLNC.html', 'http://weather.gov/data/current_obs/KLNC.rss', 'http://weather.gov/data/current_obs/KLNC.xml'),
('KLRD', 'TX', 'Laredo International Airport', 27.540000, -99.470000, 'http://weather.noaa.gov/weather/current/KLRD.html', 'http://weather.gov/data/current_obs/KLRD.rss', 'http://weather.gov/data/current_obs/KLRD.xml'),
('KLUD', 'TX', 'Decatur Municipal Airport', 33.255000, -97.581000, 'http://weather.noaa.gov/weather/current/KLUD.html', 'http://weather.gov/data/current_obs/KLUD.rss', 'http://weather.gov/data/current_obs/KLUD.xml'),
('KLVJ', 'TX', 'Pearland Regional Airport', 29.519000, -95.242000, 'http://weather.noaa.gov/weather/current/KLVJ.html', 'http://weather.gov/data/current_obs/KLVJ.rss', 'http://weather.gov/data/current_obs/KLVJ.xml'),
('KMAF', 'TX', 'Midland International Airport', 31.950000, -102.180000, 'http://weather.noaa.gov/weather/current/KMAF.html', 'http://weather.gov/data/current_obs/KMAF.rss', 'http://weather.gov/data/current_obs/KMAF.xml'),
('KMDD', 'TX', 'Midland Airpark', 32.033000, -102.100000, 'http://weather.noaa.gov/weather/current/KMDD.html', 'http://weather.gov/data/current_obs/KMDD.rss', 'http://weather.gov/data/current_obs/KMDD.xml'),
('KMFE', 'TX', 'McAllen, Miller International Airport', 26.180000, -98.240000, 'http://weather.noaa.gov/weather/current/KMFE.html', 'http://weather.gov/data/current_obs/KMFE.rss', 'http://weather.gov/data/current_obs/KMFE.xml'),
('KMKN', 'TX', 'Comanche County Airport', 31.917000, -98.600000, 'http://weather.noaa.gov/weather/current/KMKN.html', 'http://weather.gov/data/current_obs/KMKN.rss', 'http://weather.gov/data/current_obs/KMKN.xml'),
('KMRF', 'TX', 'Marfa', 30.380000, -104.020000, 'http://weather.noaa.gov/weather/current/KMRF.html', 'http://weather.gov/data/current_obs/KMRF.rss', 'http://weather.gov/data/current_obs/KMRF.xml'),
('KMWL', 'TX', 'Mineral Wells Airport', 32.790000, -98.070000, 'http://weather.noaa.gov/weather/current/KMWL.html', 'http://weather.gov/data/current_obs/KMWL.rss', 'http://weather.gov/data/current_obs/KMWL.xml'),
('KNFW', 'TX', 'Fort Worth, Naval Air Station', 32.767000, -97.450000, 'http://weather.noaa.gov/weather/current/KNFW.html', 'http://weather.gov/data/current_obs/KNFW.rss', 'http://weather.gov/data/current_obs/KNFW.xml'),
('KNGP', 'TX', 'Corpus Christi, Naval Air Station', 27.683000, -97.283000, 'http://weather.noaa.gov/weather/current/KNGP.html', 'http://weather.gov/data/current_obs/KNGP.rss', 'http://weather.gov/data/current_obs/KNGP.xml'),
('KNQI', 'TX', 'Kingsville, Naval Air Station', 27.500000, -97.817000, 'http://weather.noaa.gov/weather/current/KNQI.html', 'http://weather.gov/data/current_obs/KNQI.rss', 'http://weather.gov/data/current_obs/KNQI.xml'),
('KOCH', 'TX', 'Nacogdoches Automatic Weather Observing/Reporting', 31.570000, -94.700000, 'http://weather.noaa.gov/weather/current/KOCH.html', 'http://weather.gov/data/current_obs/KOCH.rss', 'http://weather.gov/data/current_obs/KOCH.xml'),
('KODO', 'TX', 'Odessa-Schlemeyer Field', 31.921000, -102.392000, 'http://weather.noaa.gov/weather/current/KODO.html', 'http://weather.gov/data/current_obs/KODO.rss', 'http://weather.gov/data/current_obs/KODO.xml'),
('KORG', 'TX', 'Orange County Airport', 30.067000, -93.800000, 'http://weather.noaa.gov/weather/current/KORG.html', 'http://weather.gov/data/current_obs/KORG.rss', 'http://weather.gov/data/current_obs/KORG.xml'),
('KOSA', 'TX', 'Mount Pleasant', 33.096000, -94.962000, 'http://weather.noaa.gov/weather/current/KOSA.html', 'http://weather.gov/data/current_obs/KOSA.rss', 'http://weather.gov/data/current_obs/KOSA.xml'),
('KPEQ', 'TX', 'Pecos Municipal Airport', 31.383000, -103.500000, 'http://weather.noaa.gov/weather/current/KPEQ.html', 'http://weather.gov/data/current_obs/KPEQ.rss', 'http://weather.gov/data/current_obs/KPEQ.xml'),
('KPIL', 'TX', 'Port Isabel-Cameron County Airport', 26.159000, -97.338000, 'http://weather.noaa.gov/weather/current/KPIL.html', 'http://weather.gov/data/current_obs/KPIL.rss', 'http://weather.gov/data/current_obs/KPIL.xml'),
('KPKV', 'TX', 'Calhoun County Airport', 28.650000, -96.667000, 'http://weather.noaa.gov/weather/current/KPKV.html', 'http://weather.gov/data/current_obs/KPKV.rss', 'http://weather.gov/data/current_obs/KPKV.xml'),
('KPPA', 'TX', 'Perry Lefors Field', 35.613000, -100.996000, 'http://weather.noaa.gov/weather/current/KPPA.html', 'http://weather.gov/data/current_obs/KPPA.rss', 'http://weather.gov/data/current_obs/KPPA.xml'),
('KPRX', 'TX', 'Paris / Cox Field', 33.640000, -95.450000, 'http://weather.noaa.gov/weather/current/KPRX.html', 'http://weather.gov/data/current_obs/KPRX.rss', 'http://weather.gov/data/current_obs/KPRX.xml'),
('KPSN', 'TX', 'Palestine Municipal Airport', 31.780000, -95.706000, 'http://weather.noaa.gov/weather/current/KPSN.html', 'http://weather.gov/data/current_obs/KPSN.rss', 'http://weather.gov/data/current_obs/KPSN.xml'),
('KPSX', 'TX', 'Palacios Municipal Airport', 28.720000, -96.250000, 'http://weather.noaa.gov/weather/current/KPSX.html', 'http://weather.gov/data/current_obs/KPSX.rss', 'http://weather.gov/data/current_obs/KPSX.xml'),
('KPVW', 'TX', 'Hale County Airport', 34.168000, -101.717000, 'http://weather.noaa.gov/weather/current/KPVW.html', 'http://weather.gov/data/current_obs/KPVW.rss', 'http://weather.gov/data/current_obs/KPVW.xml'),
('KPWG', 'TX', 'Mc Gregor Automatic Weather Observing / Reporting', 31.490000, -97.320000, 'http://weather.noaa.gov/weather/current/KPWG.html', 'http://weather.gov/data/current_obs/KPWG.rss', 'http://weather.gov/data/current_obs/KPWG.xml'),
('KPYX', 'TX', 'Perryton', 36.414000, -100.750000, 'http://weather.noaa.gov/weather/current/KPYX.html', 'http://weather.gov/data/current_obs/KPYX.rss', 'http://weather.gov/data/current_obs/KPYX.xml'),
('KRAS', 'TX', 'Mustang Beach Airport', 27.817000, -97.083000, 'http://weather.noaa.gov/weather/current/KRAS.html', 'http://weather.gov/data/current_obs/KRAS.rss', 'http://weather.gov/data/current_obs/KRAS.xml'),
('KRBD', 'TX', 'Dallas Executive Airport', 32.690000, -96.870000, 'http://weather.noaa.gov/weather/current/KRBD.html', 'http://weather.gov/data/current_obs/KRBD.rss', 'http://weather.gov/data/current_obs/KRBD.xml'),
('KRBO', 'TX', 'Nueces County Airport', 27.779000, -97.691000, 'http://weather.noaa.gov/weather/current/KRBO.html', 'http://weather.gov/data/current_obs/KRBO.rss', 'http://weather.gov/data/current_obs/KRBO.xml'),
('KRKP', 'TX', 'Rockport, Aransas County Airport', 28.090000, -97.050000, 'http://weather.noaa.gov/weather/current/KRKP.html', 'http://weather.gov/data/current_obs/KRKP.rss', 'http://weather.gov/data/current_obs/KRKP.xml'),
('KRND', 'TX', 'Randolph Air Force Base', 29.533000, -98.283000, 'http://weather.noaa.gov/weather/current/KRND.html', 'http://weather.gov/data/current_obs/KRND.rss', 'http://weather.gov/data/current_obs/KRND.xml'),
('KRPE', 'TX', 'Sabine Pass', 29.700000, -93.950000, 'http://weather.noaa.gov/weather/current/KRPE.html', 'http://weather.gov/data/current_obs/KRPE.rss', 'http://weather.gov/data/current_obs/KRPE.xml'),
('KRPH', 'TX', 'Graham Municipal Airport', 33.110000, -98.555000, 'http://weather.noaa.gov/weather/current/KRPH.html', 'http://weather.gov/data/current_obs/KRPH.rss', 'http://weather.gov/data/current_obs/KRPH.xml'),
('KRWV', 'TX', 'Caldwell Municipal Airport', 30.517000, -96.700000, 'http://weather.noaa.gov/weather/current/KRWV.html', 'http://weather.gov/data/current_obs/KRWV.rss', 'http://weather.gov/data/current_obs/KRWV.xml'),
('KSAT', 'TX', 'San Antonio International Airport', 29.540000, -98.470000, 'http://weather.noaa.gov/weather/current/KSAT.html', 'http://weather.gov/data/current_obs/KSAT.rss', 'http://weather.gov/data/current_obs/KSAT.xml'),
('KSEP', 'TX', 'Stephenville / Clark Field Municipal Airport', 32.215000, -98.178000, 'http://weather.noaa.gov/weather/current/KSEP.html', 'http://weather.gov/data/current_obs/KSEP.rss', 'http://weather.gov/data/current_obs/KSEP.xml'),
('KSGR', 'TX', 'Houston, Sugar Land Municipal / Hull Field Airport', 29.620000, -95.650000, 'http://weather.noaa.gov/weather/current/KSGR.html', 'http://weather.gov/data/current_obs/KSGR.rss', 'http://weather.gov/data/current_obs/KSGR.xml'),
('KSJT', 'TX', 'San Angelo, Mathis Field', 31.380000, -100.500000, 'http://weather.noaa.gov/weather/current/KSJT.html', 'http://weather.gov/data/current_obs/KSJT.rss', 'http://weather.gov/data/current_obs/KSJT.xml'),
('KSKF', 'TX', 'Kelly Air Force Base', 29.383000, -98.583000, 'http://weather.noaa.gov/weather/current/KSKF.html', 'http://weather.gov/data/current_obs/KSKF.rss', 'http://weather.gov/data/current_obs/KSKF.xml'),
('KSLR', 'TX', 'Sulphur Springs Municipal Airport', 33.167000, -95.617000, 'http://weather.noaa.gov/weather/current/KSLR.html', 'http://weather.gov/data/current_obs/KSLR.rss', 'http://weather.gov/data/current_obs/KSLR.xml'),
('KSNK', 'TX', 'Winston Field Airport', 32.693000, -100.950000, 'http://weather.noaa.gov/weather/current/KSNK.html', 'http://weather.gov/data/current_obs/KSNK.rss', 'http://weather.gov/data/current_obs/KSNK.xml'),
('KSOA', 'TX', 'Sonora Municipal Airport', 30.583000, -100.650000, 'http://weather.noaa.gov/weather/current/KSOA.html', 'http://weather.gov/data/current_obs/KSOA.rss', 'http://weather.gov/data/current_obs/KSOA.xml'),
('KSPS', 'TX', 'Wichita Falls, Sheppard Air Force Base', 33.980000, -98.480000, 'http://weather.noaa.gov/weather/current/KSPS.html', 'http://weather.gov/data/current_obs/KSPS.rss', 'http://weather.gov/data/current_obs/KSPS.xml'),
('KSSF', 'TX', 'San Antonio, Stinson Municipal Airport', 29.330000, -98.470000, 'http://weather.noaa.gov/weather/current/KSSF.html', 'http://weather.gov/data/current_obs/KSSF.rss', 'http://weather.gov/data/current_obs/KSSF.xml'),
('KSWW', 'TX', 'Sweetwater', 32.470000, -100.470000, 'http://weather.noaa.gov/weather/current/KSWW.html', 'http://weather.gov/data/current_obs/KSWW.rss', 'http://weather.gov/data/current_obs/KSWW.xml'),
('KT65', 'TX', 'Weslaco', 26.167000, -97.967000, 'http://weather.noaa.gov/weather/current/KT65.html', 'http://weather.gov/data/current_obs/KT65.rss', 'http://weather.gov/data/current_obs/KT65.xml'),
('KT82', 'TX', 'Fredericksburg', 30.244000, -98.910000, 'http://weather.noaa.gov/weather/current/KT82.html', 'http://weather.gov/data/current_obs/KT82.rss', 'http://weather.gov/data/current_obs/KT82.xml'),
('KTKI', 'TX', 'Collin County Regional Airport', 33.180000, -96.590000, 'http://weather.noaa.gov/weather/current/KTKI.html', 'http://weather.gov/data/current_obs/KTKI.rss', 'http://weather.gov/data/current_obs/KTKI.xml'),
('KTPL', 'TX', 'Temple / Miller Automatic Weather Observing/Report', 31.150000, -97.420000, 'http://weather.noaa.gov/weather/current/KTPL.html', 'http://weather.gov/data/current_obs/KTPL.rss', 'http://weather.gov/data/current_obs/KTPL.xml'),
('KTRL', 'TX', 'Terrell Municipal Airport', 32.710000, -96.270000, 'http://weather.noaa.gov/weather/current/KTRL.html', 'http://weather.gov/data/current_obs/KTRL.rss', 'http://weather.gov/data/current_obs/KTRL.xml'),
('KTYR', 'TX', 'Tyler Pounds Field', 32.350000, -95.400000, 'http://weather.noaa.gov/weather/current/KTYR.html', 'http://weather.gov/data/current_obs/KTYR.rss', 'http://weather.gov/data/current_obs/KTYR.xml'),
('KUTS', 'TX', 'Huntsville Municipal Airport', 30.740000, -95.590000, 'http://weather.noaa.gov/weather/current/KUTS.html', 'http://weather.gov/data/current_obs/KUTS.rss', 'http://weather.gov/data/current_obs/KUTS.xml'),
('KUVA', 'TX', 'Garner Field Airport', 29.211000, -99.744000, 'http://weather.noaa.gov/weather/current/KUVA.html', 'http://weather.gov/data/current_obs/KUVA.rss', 'http://weather.gov/data/current_obs/KUVA.xml'),
('KVCT', 'TX', 'Victoria Regional Airport', 28.860000, -96.920000, 'http://weather.noaa.gov/weather/current/KVCT.html', 'http://weather.gov/data/current_obs/KVCT.rss', 'http://weather.gov/data/current_obs/KVCT.xml'),
('KXBP', 'TX', 'Bridgeport Municipal Airport', 33.167000, -97.833000, 'http://weather.noaa.gov/weather/current/KXBP.html', 'http://weather.gov/data/current_obs/KXBP.rss', 'http://weather.gov/data/current_obs/KXBP.xml'),
('KELP', 'TX', 'El Paso International Airport', 31.800000, -106.400000, 'http://weather.noaa.gov/weather/current/KELP.html', 'http://weather.gov/data/current_obs/KELP.rss', 'http://weather.gov/data/current_obs/KELP.xml'),
('KPEZ', 'TX', 'Pleasanton Municipal Airport', 28.950000, -98.520000, 'http://weather.noaa.gov/weather/current/KPEZ.html', 'http://weather.gov/data/current_obs/KPEZ.rss', 'http://weather.gov/data/current_obs/KPEZ.xml'),
('KT47', 'TX', 'Kickapoo Downtown Airport', 33.858000, -98.490000, 'http://weather.noaa.gov/weather/current/KT47.html', 'http://weather.gov/data/current_obs/KT47.rss', 'http://weather.gov/data/current_obs/KT47.xml'),
('KHRX', 'TX', 'Hereford Municipal Airport', 34.860000, -102.330000, 'http://weather.noaa.gov/weather/current/KHRX.html', 'http://weather.gov/data/current_obs/KHRX.rss', 'http://weather.gov/data/current_obs/KHRX.xml'),
('KAQO', 'TX', 'Llano Municipal Airport', 30.783700, -98.662000, 'http://weather.noaa.gov/weather/current/KAQO.html', 'http://weather.gov/data/current_obs/KAQO.rss', 'http://weather.gov/data/current_obs/KAQO.xml'),
('KGYB', 'TX', 'Giddings-Lee County Airport', 30.169300, -96.980000, 'http://weather.noaa.gov/weather/current/KGYB.html', 'http://weather.gov/data/current_obs/KGYB.rss', 'http://weather.gov/data/current_obs/KGYB.xml'),
('KJXI', 'TX', 'Fox Stephens Field - Gilmer Municipal Airport', 32.699000, -94.948000, 'http://weather.noaa.gov/weather/current/KJXI.html', 'http://weather.gov/data/current_obs/KJXI.rss', 'http://weather.gov/data/current_obs/KJXI.xml'),
('KJDD', 'TX', 'Wood County Airport', 32.742000, -95.496000, 'http://weather.noaa.gov/weather/current/KJDD.html', 'http://weather.gov/data/current_obs/KJDD.rss', 'http://weather.gov/data/current_obs/KJDD.xml'),
('K4BL', 'UT', 'Blanding', 37.620000, -109.470000, 'http://weather.noaa.gov/weather/current/K4BL.html', 'http://weather.gov/data/current_obs/K4BL.rss', 'http://weather.gov/data/current_obs/K4BL.xml'),
('K4HV', 'UT', 'Hanksville', 38.380000, -110.720000, 'http://weather.noaa.gov/weather/current/K4HV.html', 'http://weather.gov/data/current_obs/K4HV.rss', 'http://weather.gov/data/current_obs/K4HV.xml'),
('KBCE', 'UT', 'Bryce Canyon', 37.710000, -112.160000, 'http://weather.noaa.gov/weather/current/KBCE.html', 'http://weather.gov/data/current_obs/KBCE.rss', 'http://weather.gov/data/current_obs/KBCE.xml'),
('KCDC', 'UT', 'Cedar City Muni', 37.700000, -113.100000, 'http://weather.noaa.gov/weather/current/KCDC.html', 'http://weather.gov/data/current_obs/KCDC.rss', 'http://weather.gov/data/current_obs/KCDC.xml'),
('KCNY', 'UT', 'Moab/Canyonlands', 38.750000, -109.750000, 'http://weather.noaa.gov/weather/current/KCNY.html', 'http://weather.gov/data/current_obs/KCNY.rss', 'http://weather.gov/data/current_obs/KCNY.xml'),
('KDPG', 'UT', 'Dugway Prvg Ground', 40.210000, -112.930000, 'http://weather.noaa.gov/weather/current/KDPG.html', 'http://weather.gov/data/current_obs/KDPG.rss', 'http://weather.gov/data/current_obs/KDPG.xml'),
('KENV', 'UT', 'Wendover (aut)', 40.730000, -114.030000, 'http://weather.noaa.gov/weather/current/KENV.html', 'http://weather.gov/data/current_obs/KENV.rss', 'http://weather.gov/data/current_obs/KENV.xml'),
('KHIF', 'UT', 'Ogden/Hill AFB', 41.120000, -111.970000, 'http://weather.noaa.gov/weather/current/KHIF.html', 'http://weather.gov/data/current_obs/KHIF.rss', 'http://weather.gov/data/current_obs/KHIF.xml'),
('KLGU', 'UT', 'Logan-Cache Airport', 41.790000, -111.850000, 'http://weather.noaa.gov/weather/current/KLGU.html', 'http://weather.gov/data/current_obs/KLGU.rss', 'http://weather.gov/data/current_obs/KLGU.xml'),
('KMLF', 'UT', 'Milford Municipal', 38.430000, -113.020000, 'http://weather.noaa.gov/weather/current/KMLF.html', 'http://weather.gov/data/current_obs/KMLF.rss', 'http://weather.gov/data/current_obs/KMLF.xml'),
('KOGD', 'UT', 'Ogden-Hinckley Muni', 41.200000, -112.010000, 'http://weather.noaa.gov/weather/current/KOGD.html', 'http://weather.gov/data/current_obs/KOGD.rss', 'http://weather.gov/data/current_obs/KOGD.xml'),
('KPUC', 'UT', 'Price/Carbon County', 39.620000, -110.750000, 'http://weather.noaa.gov/weather/current/KPUC.html', 'http://weather.gov/data/current_obs/KPUC.rss', 'http://weather.gov/data/current_obs/KPUC.xml'),
('KPVU', 'UT', 'Provo Muni (awos)', 40.230000, -111.720000, 'http://weather.noaa.gov/weather/current/KPVU.html', 'http://weather.gov/data/current_obs/KPVU.rss', 'http://weather.gov/data/current_obs/KPVU.xml'),
('KSGU', 'UT', 'Saint George (awos)', 37.090000, -113.600000, 'http://weather.noaa.gov/weather/current/KSGU.html', 'http://weather.gov/data/current_obs/KSGU.rss', 'http://weather.gov/data/current_obs/KSGU.xml'),
('KSLC', 'UT', 'Salt Lake City International', 40.790000, -111.970000, 'http://weather.noaa.gov/weather/current/KSLC.html', 'http://weather.gov/data/current_obs/KSLC.rss', 'http://weather.gov/data/current_obs/KSLC.xml'),
('KT62', 'UT', 'Tooele', 40.317000, -112.300000, 'http://weather.noaa.gov/weather/current/KT62.html', 'http://weather.gov/data/current_obs/KT62.rss', 'http://weather.gov/data/current_obs/KT62.xml'),
('KU24', 'UT', 'Delta', 39.340000, -112.590000, 'http://weather.noaa.gov/weather/current/KU24.html', 'http://weather.gov/data/current_obs/KU24.rss', 'http://weather.gov/data/current_obs/KU24.xml'),
('KU28', 'UT', 'Green River Range', 39.010000, -110.150000, 'http://weather.noaa.gov/weather/current/KU28.html', 'http://weather.gov/data/current_obs/KU28.rss', 'http://weather.gov/data/current_obs/KU28.xml'),
('KVEL', 'UT', 'Vernal', 40.440000, -109.510000, 'http://weather.noaa.gov/weather/current/KVEL.html', 'http://weather.gov/data/current_obs/KVEL.rss', 'http://weather.gov/data/current_obs/KVEL.xml'),
('K6V3', 'VA', 'Richlands Tazewell County Airport', 37.064000, -81.798000, 'http://weather.noaa.gov/weather/current/K6V3.html', 'http://weather.gov/data/current_obs/K6V3.rss', 'http://weather.gov/data/current_obs/K6V3.xml'),
('KAKQ', 'VA', 'Wakefield Municipal Airport', 36.990000, -77.000000, 'http://weather.noaa.gov/weather/current/KAKQ.html', 'http://weather.gov/data/current_obs/KAKQ.rss', 'http://weather.gov/data/current_obs/KAKQ.xml'),
('KAVC', 'VA', 'South Hill, Mecklenburg-Brunswick Regional Airport', 36.690000, -78.050000, 'http://weather.noaa.gov/weather/current/KAVC.html', 'http://weather.gov/data/current_obs/KAVC.rss', 'http://weather.gov/data/current_obs/KAVC.xml'),
('KBCB', 'VA', 'Virginia Tech Airport', 37.208000, -80.408000, 'http://weather.noaa.gov/weather/current/KBCB.html', 'http://weather.gov/data/current_obs/KBCB.rss', 'http://weather.gov/data/current_obs/KBCB.xml'),
('KCHO', 'VA', 'Charlottesville-Albemarle Airport', 38.140000, -78.450000, 'http://weather.noaa.gov/weather/current/KCHO.html', 'http://weather.gov/data/current_obs/KCHO.rss', 'http://weather.gov/data/current_obs/KCHO.xml'),
('KCJR', 'VA', 'Culpeper County Airport', 38.530000, -77.860000, 'http://weather.noaa.gov/weather/current/KCJR.html', 'http://weather.gov/data/current_obs/KCJR.rss', 'http://weather.gov/data/current_obs/KCJR.xml'),
('KCPK', 'VA', 'Chesapeake Municipal Airport', 36.660000, -76.320000, 'http://weather.noaa.gov/weather/current/KCPK.html', 'http://weather.gov/data/current_obs/KCPK.rss', 'http://weather.gov/data/current_obs/KCPK.xml'),
('KDAA', 'VA', 'Fort Belvoir', 38.730000, -77.180000, 'http://weather.noaa.gov/weather/current/KDAA.html', 'http://weather.gov/data/current_obs/KDAA.rss', 'http://weather.gov/data/current_obs/KDAA.xml'),
('KDAN', 'VA', 'Danville Regional Airport', 36.580000, -79.330000, 'http://weather.noaa.gov/weather/current/KDAN.html', 'http://weather.gov/data/current_obs/KDAN.rss', 'http://weather.gov/data/current_obs/KDAN.xml'),
('KDCA', 'VA', 'Washington DC, Reagan National Airport', 38.860000, -77.030000, 'http://weather.noaa.gov/weather/current/KDCA.html', 'http://weather.gov/data/current_obs/KDCA.rss', 'http://weather.gov/data/current_obs/KDCA.xml'),
('KEMV', 'VA', 'Emporia-Greensville Reg Airport', 36.690000, -77.480000, 'http://weather.noaa.gov/weather/current/KEMV.html', 'http://weather.gov/data/current_obs/KEMV.rss', 'http://weather.gov/data/current_obs/KEMV.xml'),
('KEZF', 'VA', 'Shannon Airport', 38.270000, -77.450000, 'http://weather.noaa.gov/weather/current/KEZF.html', 'http://weather.gov/data/current_obs/KEZF.rss', 'http://weather.gov/data/current_obs/KEZF.xml'),
('KFAF', 'VA', 'Fort Eustis / Felker', 37.140000, -76.620000, 'http://weather.noaa.gov/weather/current/KFAF.html', 'http://weather.gov/data/current_obs/KFAF.rss', 'http://weather.gov/data/current_obs/KFAF.xml'),
('KFKN', 'VA', 'Franklin / J B Rose', 36.700000, -76.900000, 'http://weather.noaa.gov/weather/current/KFKN.html', 'http://weather.gov/data/current_obs/KFKN.rss', 'http://weather.gov/data/current_obs/KFKN.xml'),
('KFVX', 'VA', 'Farmville', 37.350000, -78.430000, 'http://weather.noaa.gov/weather/current/KFVX.html', 'http://weather.gov/data/current_obs/KFVX.rss', 'http://weather.gov/data/current_obs/KFVX.xml'),
('KFYJ', 'VA', 'Middle Peninsula Regional Airport', 37.517000, -76.767000, 'http://weather.noaa.gov/weather/current/KFYJ.html', 'http://weather.gov/data/current_obs/KFYJ.rss', 'http://weather.gov/data/current_obs/KFYJ.xml'),
('KHEF', 'VA', 'Manassas Municipal Automatic Weather Observing', 38.720000, -77.520000, 'http://weather.noaa.gov/weather/current/KHEF.html', 'http://weather.gov/data/current_obs/KHEF.rss', 'http://weather.gov/data/current_obs/KHEF.xml'),
('KHLX', 'VA', 'Hillsville', 36.770000, -80.820000, 'http://weather.noaa.gov/weather/current/KHLX.html', 'http://weather.gov/data/current_obs/KHLX.rss', 'http://weather.gov/data/current_obs/KHLX.xml'),
('KHSP', 'VA', 'Hot Springs / Ingalls', 37.960000, -79.820000, 'http://weather.noaa.gov/weather/current/KHSP.html', 'http://weather.gov/data/current_obs/KHSP.rss', 'http://weather.gov/data/current_obs/KHSP.xml'),
('KIAD', 'VA', 'Washington-Dulles International Airport', 38.960000, -77.450000, 'http://weather.noaa.gov/weather/current/KIAD.html', 'http://weather.gov/data/current_obs/KIAD.rss', 'http://weather.gov/data/current_obs/KIAD.xml'),
('KJGG', 'VA', 'Williamsburg-Jamestown Airport', 37.233000, -76.717000, 'http://weather.noaa.gov/weather/current/KJGG.html', 'http://weather.gov/data/current_obs/KJGG.rss', 'http://weather.gov/data/current_obs/KJGG.xml'),
('KJYO', 'VA', 'Leesburg / Godfrey', 39.080000, -77.570000, 'http://weather.noaa.gov/weather/current/KJYO.html', 'http://weather.gov/data/current_obs/KJYO.rss', 'http://weather.gov/data/current_obs/KJYO.xml'),
('KLFI', 'VA', 'Langley Air Force Base', 37.090000, -76.350000, 'http://weather.noaa.gov/weather/current/KLFI.html', 'http://weather.gov/data/current_obs/KLFI.rss', 'http://weather.gov/data/current_obs/KLFI.xml'),
('KLKU', 'VA', 'Louisa County / Freeman Field Airport', 38.011000, -77.978000, 'http://weather.noaa.gov/weather/current/KLKU.html', 'http://weather.gov/data/current_obs/KLKU.rss', 'http://weather.gov/data/current_obs/KLKU.xml'),
('KLNP', 'VA', 'Wise / Lonesome Pine', 36.980000, -82.530000, 'http://weather.noaa.gov/weather/current/KLNP.html', 'http://weather.gov/data/current_obs/KLNP.rss', 'http://weather.gov/data/current_obs/KLNP.xml'),
('KLYH', 'VA', 'Lynchburg Regional Airport', 37.340000, -79.200000, 'http://weather.noaa.gov/weather/current/KLYH.html', 'http://weather.gov/data/current_obs/KLYH.rss', 'http://weather.gov/data/current_obs/KLYH.xml'),
('KMFV', 'VA', 'Melfa / Accomack Airport', 37.650000, -75.770000, 'http://weather.noaa.gov/weather/current/KMFV.html', 'http://weather.gov/data/current_obs/KMFV.rss', 'http://weather.gov/data/current_obs/KMFV.xml'),
('KMKJ', 'VA', 'Marion / Wytheville', 36.900000, -81.350000, 'http://weather.noaa.gov/weather/current/KMKJ.html', 'http://weather.gov/data/current_obs/KMKJ.rss', 'http://weather.gov/data/current_obs/KMKJ.xml'),
('KMTV', 'VA', 'Martinsville', 36.630000, -80.020000, 'http://weather.noaa.gov/weather/current/KMTV.html', 'http://weather.gov/data/current_obs/KMTV.rss', 'http://weather.gov/data/current_obs/KMTV.xml'),
('KNGU', 'VA', 'Norfolk, Naval Air Station', 36.940000, -76.280000, 'http://weather.noaa.gov/weather/current/KNGU.html', 'http://weather.gov/data/current_obs/KNGU.rss', 'http://weather.gov/data/current_obs/KNGU.xml'),
('KNTU', 'VA', 'Virginia Beach, Oceana, Naval Air Station', 36.830000, -76.030000, 'http://weather.noaa.gov/weather/current/KNTU.html', 'http://weather.gov/data/current_obs/KNTU.rss', 'http://weather.gov/data/current_obs/KNTU.xml'),
('KNYG', 'VA', 'Quantico Marine Corps Air Facility', 38.510000, -77.300000, 'http://weather.noaa.gov/weather/current/KNYG.html', 'http://weather.gov/data/current_obs/KNYG.rss', 'http://weather.gov/data/current_obs/KNYG.xml'),
('KOFP', 'VA', 'Ashland, Hanover County Municipal Airport', 37.700000, -77.430000, 'http://weather.noaa.gov/weather/current/KOFP.html', 'http://weather.gov/data/current_obs/KOFP.rss', 'http://weather.gov/data/current_obs/KOFP.xml'),
('KOKV', 'VA', 'Winchester Regional', 39.150000, -78.150000, 'http://weather.noaa.gov/weather/current/KOKV.html', 'http://weather.gov/data/current_obs/KOKV.rss', 'http://weather.gov/data/current_obs/KOKV.xml'),
('KOMH', 'VA', 'Orange County Airport', 38.247000, -78.046000, 'http://weather.noaa.gov/weather/current/KOMH.html', 'http://weather.gov/data/current_obs/KOMH.rss', 'http://weather.gov/data/current_obs/KOMH.xml'),
('KORF', 'VA', 'Norfolk International Airport', 36.910000, -76.200000, 'http://weather.noaa.gov/weather/current/KORF.html', 'http://weather.gov/data/current_obs/KORF.rss', 'http://weather.gov/data/current_obs/KORF.xml'),
('KPHF', 'VA', 'Newport News / Williamsburg Intl Airport', 37.140000, -76.500000, 'http://weather.noaa.gov/weather/current/KPHF.html', 'http://weather.gov/data/current_obs/KPHF.rss', 'http://weather.gov/data/current_obs/KPHF.xml'),
('KPSK', 'VA', 'Dublin / New River Valley', 37.140000, -80.680000, 'http://weather.noaa.gov/weather/current/KPSK.html', 'http://weather.gov/data/current_obs/KPSK.rss', 'http://weather.gov/data/current_obs/KPSK.xml'),
('KPTB', 'VA', 'Petersburg Automatic Weather Observing / Reporting', 37.190000, -77.520000, 'http://weather.noaa.gov/weather/current/KPTB.html', 'http://weather.gov/data/current_obs/KPTB.rss', 'http://weather.gov/data/current_obs/KPTB.xml'),
('KRIC', 'VA', 'Richmond International Airport', 37.510000, -77.310000, 'http://weather.noaa.gov/weather/current/KRIC.html', 'http://weather.gov/data/current_obs/KRIC.rss', 'http://weather.gov/data/current_obs/KRIC.xml'),
('KRMN', 'VA', 'Stafford Regional Airport', 38.400000, -77.450000, 'http://weather.noaa.gov/weather/current/KRMN.html', 'http://weather.gov/data/current_obs/KRMN.rss', 'http://weather.gov/data/current_obs/KRMN.xml'),
('KROA', 'VA', 'Roanoke Regional Airport', 37.330000, -79.970000, 'http://weather.noaa.gov/weather/current/KROA.html', 'http://weather.gov/data/current_obs/KROA.rss', 'http://weather.gov/data/current_obs/KROA.xml'),
('KSFQ', 'VA', 'Suffolk Municipal Airport', 36.680000, -76.600000, 'http://weather.noaa.gov/weather/current/KSFQ.html', 'http://weather.gov/data/current_obs/KSFQ.rss', 'http://weather.gov/data/current_obs/KSFQ.xml'),
('KSHD', 'VA', 'Staunton / Shenandoah', 38.280000, -78.850000, 'http://weather.noaa.gov/weather/current/KSHD.html', 'http://weather.gov/data/current_obs/KSHD.rss', 'http://weather.gov/data/current_obs/KSHD.xml'),
('KVJI', 'VA', 'Abingdon', 36.680000, -82.030000, 'http://weather.noaa.gov/weather/current/KVJI.html', 'http://weather.gov/data/current_obs/KVJI.rss', 'http://weather.gov/data/current_obs/KVJI.xml'),
('KWAL', 'VA', 'Wallops Flight Facility Airport', 37.940000, -75.470000, 'http://weather.noaa.gov/weather/current/KWAL.html', 'http://weather.gov/data/current_obs/KWAL.rss', 'http://weather.gov/data/current_obs/KWAL.xml'),
('TVSV', 'VC', 'Arnos Vale', 13.133000, -61.200000, 'http://weather.noaa.gov/weather/current/TVSV.html', 'http://weather.gov/data/current_obs/TVSV.rss', 'http://weather.gov/data/current_obs/TVSV.xml'),
('TUPJ', 'VG', 'Beef Island-Tortola', 18.450000, -64.533000, 'http://weather.noaa.gov/weather/current/TUPJ.html', 'http://weather.gov/data/current_obs/TUPJ.rss', 'http://weather.gov/data/current_obs/TUPJ.xml'),
('TIST', 'VI', 'St Thomas-Charlotte Amalie/CyrilE King Int Airport', 18.330000, -64.970000, 'http://weather.noaa.gov/weather/current/TIST.html', 'http://weather.gov/data/current_obs/TIST.rss', 'http://weather.gov/data/current_obs/TIST.xml'),
('TISX', 'VI', 'St Croix (Christiansted, Henry E. Rohlsen Airport)', 17.700000, -64.800000, 'http://weather.noaa.gov/weather/current/TISX.html', 'http://weather.gov/data/current_obs/TISX.rss', 'http://weather.gov/data/current_obs/TISX.xml'),
('TKPK', 'VI', 'Golden Rock-Saint Kitts-Nexus', 17.300000, -62.683000, 'http://weather.noaa.gov/weather/current/TKPK.html', 'http://weather.gov/data/current_obs/TKPK.rss', 'http://weather.gov/data/current_obs/TKPK.xml'),
('TQPF', 'VI', 'Wallblake', 18.200000, -63.050000, 'http://weather.noaa.gov/weather/current/TQPF.html', 'http://weather.gov/data/current_obs/TQPF.rss', 'http://weather.gov/data/current_obs/TQPF.xml'),
('K1V4', 'VT', 'Saint Johnsbury', 44.420000, -72.020000, 'http://weather.noaa.gov/weather/current/K1V4.html', 'http://weather.gov/data/current_obs/K1V4.rss', 'http://weather.gov/data/current_obs/K1V4.xml'),
('KBTV', 'VT', 'Burlington International Airport', 44.480000, -73.150000, 'http://weather.noaa.gov/weather/current/KBTV.html', 'http://weather.gov/data/current_obs/KBTV.rss', 'http://weather.gov/data/current_obs/KBTV.xml'),
('KDDH', 'VT', 'Bennington Morse State Airport', 42.890000, -73.246000, 'http://weather.noaa.gov/weather/current/KDDH.html', 'http://weather.gov/data/current_obs/KDDH.rss', 'http://weather.gov/data/current_obs/KDDH.xml'),
('KMPV', 'VT', 'Barre / Montpelier, Knapp State Airport', 44.210000, -72.570000, 'http://weather.noaa.gov/weather/current/KMPV.html', 'http://weather.gov/data/current_obs/KMPV.rss', 'http://weather.gov/data/current_obs/KMPV.xml'),
('KMVL', 'VT', 'Morrisville-Stowe State Airport', 44.530000, -72.610000, 'http://weather.noaa.gov/weather/current/KMVL.html', 'http://weather.gov/data/current_obs/KMVL.rss', 'http://weather.gov/data/current_obs/KMVL.xml'),
('KRUT', 'VT', 'Rutland State Automatic Weather Observing / Report', 43.540000, -72.950000, 'http://weather.noaa.gov/weather/current/KRUT.html', 'http://weather.gov/data/current_obs/KRUT.rss', 'http://weather.gov/data/current_obs/KRUT.xml'),
('KVSF', 'VT', 'Hartness State Springfield Airport', 43.340000, -72.520000, 'http://weather.noaa.gov/weather/current/KVSF.html', 'http://weather.gov/data/current_obs/KVSF.rss', 'http://weather.gov/data/current_obs/KVSF.xml'),
('K76S', 'WA', 'Oak Harbor Airport', 48.250000, -122.667000, 'http://weather.noaa.gov/weather/current/K76S.html', 'http://weather.gov/data/current_obs/K76S.rss', 'http://weather.gov/data/current_obs/K76S.xml'),
('KALW', 'WA', 'Walla Walla Rgn', 46.090000, -118.290000, 'http://weather.noaa.gov/weather/current/KALW.html', 'http://weather.gov/data/current_obs/KALW.rss', 'http://weather.gov/data/current_obs/KALW.xml'),
('KAWO', 'WA', 'Arlington Muni', 48.170000, -122.170000, 'http://weather.noaa.gov/weather/current/KAWO.html', 'http://weather.gov/data/current_obs/KAWO.rss', 'http://weather.gov/data/current_obs/KAWO.xml'),
('KBFI', 'WA', 'Seattle/Boeing Fld', 47.540000, -122.300000, 'http://weather.noaa.gov/weather/current/KBFI.html', 'http://weather.gov/data/current_obs/KBFI.rss', 'http://weather.gov/data/current_obs/KBFI.xml'),
('KBLI', 'WA', 'Bellingham Intl Airport', 48.790000, -122.540000, 'http://weather.noaa.gov/weather/current/KBLI.html', 'http://weather.gov/data/current_obs/KBLI.rss', 'http://weather.gov/data/current_obs/KBLI.xml'),
('KBVS', 'WA', 'Skagit Regional Airport', 48.467000, -122.417000, 'http://weather.noaa.gov/weather/current/KBVS.html', 'http://weather.gov/data/current_obs/KBVS.rss', 'http://weather.gov/data/current_obs/KBVS.xml'),
('KCLM', 'WA', 'Port Angeles Intl Airport', 48.120000, -123.500000, 'http://weather.noaa.gov/weather/current/KCLM.html', 'http://weather.gov/data/current_obs/KCLM.rss', 'http://weather.gov/data/current_obs/KCLM.xml'),
('KCQV', 'WA', 'Colville Municipal', 48.550000, -117.890000, 'http://weather.noaa.gov/weather/current/KCQV.html', 'http://weather.gov/data/current_obs/KCQV.rss', 'http://weather.gov/data/current_obs/KCQV.xml'),
('KDEW', 'WA', 'Deer Park (was 07s)', 47.974000, -117.428000, 'http://weather.noaa.gov/weather/current/KDEW.html', 'http://weather.gov/data/current_obs/KDEW.rss', 'http://weather.gov/data/current_obs/KDEW.xml'),
('KEAT', 'WA', 'Wenatchee/Pangborn', 47.410000, -120.200000, 'http://weather.noaa.gov/weather/current/KEAT.html', 'http://weather.gov/data/current_obs/KEAT.rss', 'http://weather.gov/data/current_obs/KEAT.xml'),
('KELN', 'WA', 'Ellensburg/Bowers', 47.030000, -120.530000, 'http://weather.noaa.gov/weather/current/KELN.html', 'http://weather.gov/data/current_obs/KELN.rss', 'http://weather.gov/data/current_obs/KELN.xml'),
('KEPH', 'WA', 'Ephrata Municipal', 47.330000, -119.520000, 'http://weather.noaa.gov/weather/current/KEPH.html', 'http://weather.gov/data/current_obs/KEPH.rss', 'http://weather.gov/data/current_obs/KEPH.xml'),
('KFHR', 'WA', 'Friday Harbor', 48.520000, -123.020000, 'http://weather.noaa.gov/weather/current/KFHR.html', 'http://weather.gov/data/current_obs/KFHR.rss', 'http://weather.gov/data/current_obs/KFHR.xml'),
('KGEG', 'WA', 'Spokane Intl Arpt', 47.640000, -117.530000, 'http://weather.noaa.gov/weather/current/KGEG.html', 'http://weather.gov/data/current_obs/KGEG.rss', 'http://weather.gov/data/current_obs/KGEG.xml'),
('KGRF', 'WA', 'Fort Lewis/Gray Aaf', 47.090000, -122.580000, 'http://weather.noaa.gov/weather/current/KGRF.html', 'http://weather.gov/data/current_obs/KGRF.rss', 'http://weather.gov/data/current_obs/KGRF.xml'),
('KHMS', 'WA', 'Hanford', 46.580000, -119.580000, 'http://weather.noaa.gov/weather/current/KHMS.html', 'http://weather.gov/data/current_obs/KHMS.rss', 'http://weather.gov/data/current_obs/KHMS.xml'),
('KHQM', 'WA', 'Hoquiam/Bowerman', 46.980000, -123.970000, 'http://weather.noaa.gov/weather/current/KHQM.html', 'http://weather.gov/data/current_obs/KHQM.rss', 'http://weather.gov/data/current_obs/KHQM.xml'),
('KKLS', 'WA', 'Kelso-Longview AWOS', 46.117000, -122.900000, 'http://weather.noaa.gov/weather/current/KKLS.html', 'http://weather.gov/data/current_obs/KKLS.rss', 'http://weather.gov/data/current_obs/KKLS.xml'),
('KMWH', 'WA', 'Moses Lake/Grant Co', 47.210000, -119.320000, 'http://weather.noaa.gov/weather/current/KMWH.html', 'http://weather.gov/data/current_obs/KMWH.rss', 'http://weather.gov/data/current_obs/KMWH.xml'),
('KNUW', 'WA', 'Whidbey Island Nas', 48.360000, -122.650000, 'http://weather.noaa.gov/weather/current/KNUW.html', 'http://weather.gov/data/current_obs/KNUW.rss', 'http://weather.gov/data/current_obs/KNUW.xml'),
('KOLM', 'WA', 'Olympia', 46.980000, -122.900000, 'http://weather.noaa.gov/weather/current/KOLM.html', 'http://weather.gov/data/current_obs/KOLM.rss', 'http://weather.gov/data/current_obs/KOLM.xml'),
('KOMK', 'WA', 'Omak Airport', 48.460000, -119.520000, 'http://weather.noaa.gov/weather/current/KOMK.html', 'http://weather.gov/data/current_obs/KOMK.rss', 'http://weather.gov/data/current_obs/KOMK.xml'),
('KORS', 'WA', 'Orcas Island Airport', 48.717000, -122.917000, 'http://weather.noaa.gov/weather/current/KORS.html', 'http://weather.gov/data/current_obs/KORS.rss', 'http://weather.gov/data/current_obs/KORS.xml'),
('KPAE', 'WA', 'Everett/Paine Field', 47.910000, -122.280000, 'http://weather.noaa.gov/weather/current/KPAE.html', 'http://weather.gov/data/current_obs/KPAE.rss', 'http://weather.gov/data/current_obs/KPAE.xml'),
('KPSC', 'WA', 'Pasco/Tri-Cities', 46.270000, -119.120000, 'http://weather.noaa.gov/weather/current/KPSC.html', 'http://weather.gov/data/current_obs/KPSC.rss', 'http://weather.gov/data/current_obs/KPSC.xml'),
('KPUW', 'WA', 'Pullman/Moscow Rgnl', 46.760000, -117.120000, 'http://weather.noaa.gov/weather/current/KPUW.html', 'http://weather.gov/data/current_obs/KPUW.rss', 'http://weather.gov/data/current_obs/KPUW.xml'),
('KPWT', 'WA', 'Bremerton Ntnl Awos', 47.480000, -122.770000, 'http://weather.noaa.gov/weather/current/KPWT.html', 'http://weather.gov/data/current_obs/KPWT.rss', 'http://weather.gov/data/current_obs/KPWT.xml'),
('KRNT', 'WA', 'Renton Municipal', 47.510000, -122.220000, 'http://weather.noaa.gov/weather/current/KRNT.html', 'http://weather.gov/data/current_obs/KRNT.rss', 'http://weather.gov/data/current_obs/KRNT.xml'),
('KSEA', 'WA', 'Seattle-Tacoma Intl Airport', 47.440000, -122.310000, 'http://weather.noaa.gov/weather/current/KSEA.html', 'http://weather.gov/data/current_obs/KSEA.rss', 'http://weather.gov/data/current_obs/KSEA.xml'),
('KSFF', 'WA', 'Spokane/Felts Field', 47.680000, -117.320000, 'http://weather.noaa.gov/weather/current/KSFF.html', 'http://weather.gov/data/current_obs/KSFF.rss', 'http://weather.gov/data/current_obs/KSFF.xml'),
('KSHN', 'WA', 'Shelton/Sanderson', 47.230000, -123.150000, 'http://weather.noaa.gov/weather/current/KSHN.html', 'http://weather.gov/data/current_obs/KSHN.rss', 'http://weather.gov/data/current_obs/KSHN.xml'),
('KSKA', 'WA', 'Fairchild AFB', 47.620000, -117.650000, 'http://weather.noaa.gov/weather/current/KSKA.html', 'http://weather.gov/data/current_obs/KSKA.rss', 'http://weather.gov/data/current_obs/KSKA.xml'),
('KSMP', 'WA', 'Stampede Pass(amos)', 47.290000, -121.330000, 'http://weather.noaa.gov/weather/current/KSMP.html', 'http://weather.gov/data/current_obs/KSMP.rss', 'http://weather.gov/data/current_obs/KSMP.xml'),
('KTCM', 'WA', 'Mc Chord AFB/Tacoma', 47.160000, -122.480000, 'http://weather.noaa.gov/weather/current/KTCM.html', 'http://weather.gov/data/current_obs/KTCM.rss', 'http://weather.gov/data/current_obs/KTCM.xml'),
('KTDO', 'WA', 'Toledo-Winlock Mem', 46.480000, -122.800000, 'http://weather.noaa.gov/weather/current/KTDO.html', 'http://weather.gov/data/current_obs/KTDO.rss', 'http://weather.gov/data/current_obs/KTDO.xml'),
('KTIW', 'WA', 'Tacoma Narrows', 47.280000, -122.580000, 'http://weather.noaa.gov/weather/current/KTIW.html', 'http://weather.gov/data/current_obs/KTIW.rss', 'http://weather.gov/data/current_obs/KTIW.xml'),
('KUIL', 'WA', 'Quillayute State', 47.960000, -124.550000, 'http://weather.noaa.gov/weather/current/KUIL.html', 'http://weather.gov/data/current_obs/KUIL.rss', 'http://weather.gov/data/current_obs/KUIL.xml'),
('KVUO', 'WA', 'Pearson Airpark Vancouver', 45.620000, 122.660000, 'http://weather.noaa.gov/weather/current/KVUO.html', 'http://weather.gov/data/current_obs/KVUO.rss', 'http://weather.gov/data/current_obs/KVUO.xml'),
('KYKM', 'WA', 'Yakima Air Term', 46.560000, -120.530000, 'http://weather.noaa.gov/weather/current/KYKM.html', 'http://weather.gov/data/current_obs/KYKM.rss', 'http://weather.gov/data/current_obs/KYKM.xml'),
('KAIG', 'WI', 'Antigo - Lang Automatic Weather Observing / Report', 45.010000, -89.130000, 'http://weather.noaa.gov/weather/current/KAIG.html', 'http://weather.gov/data/current_obs/KAIG.rss', 'http://weather.gov/data/current_obs/KAIG.xml'),
('KARV', 'WI', 'Minocqua / Woodruff', 45.930000, -89.730000, 'http://weather.noaa.gov/weather/current/KARV.html', 'http://weather.gov/data/current_obs/KARV.rss', 'http://weather.gov/data/current_obs/KARV.xml'),
('KASX', 'WI', 'Ashland, Kennedy Memorial Airport', 46.550000, -90.920000, 'http://weather.noaa.gov/weather/current/KASX.html', 'http://weather.gov/data/current_obs/KASX.rss', 'http://weather.gov/data/current_obs/KASX.xml'),
('KATW', 'WI', 'Appleton / Outagamie', 44.260000, -88.520000, 'http://weather.noaa.gov/weather/current/KATW.html', 'http://weather.gov/data/current_obs/KATW.rss', 'http://weather.gov/data/current_obs/KATW.xml'),
('KAUW', 'WI', 'Wausau Downtown Airport', 44.930000, -89.620000, 'http://weather.noaa.gov/weather/current/KAUW.html', 'http://weather.gov/data/current_obs/KAUW.rss', 'http://weather.gov/data/current_obs/KAUW.xml'),
('KBUU', 'WI', 'Burlington Municipal Airport', 42.691000, -88.305000, 'http://weather.noaa.gov/weather/current/KBUU.html', 'http://weather.gov/data/current_obs/KBUU.rss', 'http://weather.gov/data/current_obs/KBUU.xml'),
('KCLI', 'WI', 'Clintonville Municipal Airport', 44.610000, -88.730000, 'http://weather.noaa.gov/weather/current/KCLI.html', 'http://weather.gov/data/current_obs/KCLI.rss', 'http://weather.gov/data/current_obs/KCLI.xml'),
('KCMY', 'WI', 'Sparta / Fort McCoy Airport', 43.958000, -90.738000, 'http://weather.noaa.gov/weather/current/KCMY.html', 'http://weather.gov/data/current_obs/KCMY.rss', 'http://weather.gov/data/current_obs/KCMY.xml'),
('KCWA', 'WI', 'Mosinee / Central Wisconsin', 44.790000, -89.670000, 'http://weather.noaa.gov/weather/current/KCWA.html', 'http://weather.gov/data/current_obs/KCWA.rss', 'http://weather.gov/data/current_obs/KCWA.xml');

INSERT INTO `#__zweather_stations` (`station_id`, `state`, `station_name`, `latitude`, `longitude`, `html_url`, `rss_url`, `xml_url`) VALUES
('KDLL', 'WI', 'Baraboo Wisconsin Dells Airport', 43.522000, -89.771000, 'http://weather.noaa.gov/weather/current/KDLL.html', 'http://weather.gov/data/current_obs/KDLL.rss', 'http://weather.gov/data/current_obs/KDLL.xml'),
('KEAU', 'WI', 'Eau Claire, Chippewa Valley Regional Airport', 44.880000, -91.480000, 'http://weather.noaa.gov/weather/current/KEAU.html', 'http://weather.gov/data/current_obs/KEAU.rss', 'http://weather.gov/data/current_obs/KEAU.xml'),
('KEFT', 'WI', 'Monroe Municipal Airport', 42.610000, -89.590000, 'http://weather.noaa.gov/weather/current/KEFT.html', 'http://weather.gov/data/current_obs/KEFT.rss', 'http://weather.gov/data/current_obs/KEFT.xml'),
('KEGV', 'WI', 'Eagle River Union Airport', 45.930000, -89.270000, 'http://weather.noaa.gov/weather/current/KEGV.html', 'http://weather.gov/data/current_obs/KEGV.rss', 'http://weather.gov/data/current_obs/KEGV.xml'),
('KENW', 'WI', 'Kenosha Regional Airport', 42.590000, -87.940000, 'http://weather.noaa.gov/weather/current/KENW.html', 'http://weather.gov/data/current_obs/KENW.rss', 'http://weather.gov/data/current_obs/KENW.xml'),
('KETB', 'WI', 'West Bend Municipal Airport', 43.440000, -88.130000, 'http://weather.noaa.gov/weather/current/KETB.html', 'http://weather.gov/data/current_obs/KETB.rss', 'http://weather.gov/data/current_obs/KETB.xml'),
('KFLD', 'WI', 'Fond Du Lac County Airport', 43.770000, -88.490000, 'http://weather.noaa.gov/weather/current/KFLD.html', 'http://weather.gov/data/current_obs/KFLD.rss', 'http://weather.gov/data/current_obs/KFLD.xml'),
('KGRB', 'WI', 'Green Bay, Austin Straubel International Airport', 44.480000, -88.130000, 'http://weather.noaa.gov/weather/current/KGRB.html', 'http://weather.gov/data/current_obs/KGRB.rss', 'http://weather.gov/data/current_obs/KGRB.xml'),
('KHYR', 'WI', 'Hayward Municipal Airport', 46.160000, -91.450000, 'http://weather.noaa.gov/weather/current/KHYR.html', 'http://weather.gov/data/current_obs/KHYR.rss', 'http://weather.gov/data/current_obs/KHYR.xml'),
('KISW', 'WI', 'Wisconsin Rapids, Alexander Field So. Wood County', 44.360000, -89.830000, 'http://weather.noaa.gov/weather/current/KISW.html', 'http://weather.gov/data/current_obs/KISW.rss', 'http://weather.gov/data/current_obs/KISW.xml'),
('KJVL', 'WI', 'Janesville / Rock County', 42.620000, -89.030000, 'http://weather.noaa.gov/weather/current/KJVL.html', 'http://weather.gov/data/current_obs/KJVL.rss', 'http://weather.gov/data/current_obs/KJVL.xml'),
('KLNL', 'WI', 'Kings Land O Lakes Airport', 46.150000, -89.217000, 'http://weather.noaa.gov/weather/current/KLNL.html', 'http://weather.gov/data/current_obs/KLNL.rss', 'http://weather.gov/data/current_obs/KLNL.xml'),
('KLNR', 'WI', 'Lone Rock, Tri-County Regional Airport', 43.210000, -90.180000, 'http://weather.noaa.gov/weather/current/KLNR.html', 'http://weather.gov/data/current_obs/KLNR.rss', 'http://weather.gov/data/current_obs/KLNR.xml'),
('KLSE', 'WI', 'La Crosse Municipal Airport', 43.880000, -91.250000, 'http://weather.noaa.gov/weather/current/KLSE.html', 'http://weather.gov/data/current_obs/KLSE.rss', 'http://weather.gov/data/current_obs/KLSE.xml'),
('KLUM', 'WI', 'Menomonie Municipal Airport-Score Field', 44.883000, -91.867000, 'http://weather.noaa.gov/weather/current/KLUM.html', 'http://weather.gov/data/current_obs/KLUM.rss', 'http://weather.gov/data/current_obs/KLUM.xml'),
('KMDZ', 'WI', 'Medford, Taylor County Airport', 45.100000, -90.300000, 'http://weather.noaa.gov/weather/current/KMDZ.html', 'http://weather.gov/data/current_obs/KMDZ.rss', 'http://weather.gov/data/current_obs/KMDZ.xml'),
('KMFI', 'WI', 'Marshfield Municipal Airport', 44.630000, -90.180000, 'http://weather.noaa.gov/weather/current/KMFI.html', 'http://weather.gov/data/current_obs/KMFI.rss', 'http://weather.gov/data/current_obs/KMFI.xml'),
('KMKE', 'WI', 'Milwaukee, General Mitchell International Airport', 42.960000, -87.900000, 'http://weather.noaa.gov/weather/current/KMKE.html', 'http://weather.gov/data/current_obs/KMKE.rss', 'http://weather.gov/data/current_obs/KMKE.xml'),
('KMRJ', 'WI', 'Mineral Point, Iowa County Airport', 42.890000, -90.230000, 'http://weather.noaa.gov/weather/current/KMRJ.html', 'http://weather.gov/data/current_obs/KMRJ.rss', 'http://weather.gov/data/current_obs/KMRJ.xml'),
('KMSN', 'WI', 'Madison, Dane County Regional-Truax Field', 43.140000, -89.330000, 'http://weather.noaa.gov/weather/current/KMSN.html', 'http://weather.gov/data/current_obs/KMSN.rss', 'http://weather.gov/data/current_obs/KMSN.xml'),
('KMTW', 'WI', 'Manitowoc Municipal Automatic Weather Observing', 44.140000, -87.670000, 'http://weather.noaa.gov/weather/current/KMTW.html', 'http://weather.gov/data/current_obs/KMTW.rss', 'http://weather.gov/data/current_obs/KMTW.xml'),
('KMWC', 'WI', 'Milwaukee / Timmerman', 43.120000, -88.050000, 'http://weather.noaa.gov/weather/current/KMWC.html', 'http://weather.gov/data/current_obs/KMWC.rss', 'http://weather.gov/data/current_obs/KMWC.xml'),
('KOEO', 'WI', 'Osceola, L O Simenstad Municipal Airport', 45.310000, -92.690000, 'http://weather.noaa.gov/weather/current/KOEO.html', 'http://weather.gov/data/current_obs/KOEO.rss', 'http://weather.gov/data/current_obs/KOEO.xml'),
('KOSH', 'WI', 'Oshkosh, Wittman Regional Airport', 44.010000, -88.570000, 'http://weather.noaa.gov/weather/current/KOSH.html', 'http://weather.gov/data/current_obs/KOSH.rss', 'http://weather.gov/data/current_obs/KOSH.xml'),
('KOVS', 'WI', 'Boscobel Airport', 43.160000, -90.680000, 'http://weather.noaa.gov/weather/current/KOVS.html', 'http://weather.gov/data/current_obs/KOVS.rss', 'http://weather.gov/data/current_obs/KOVS.xml'),
('KPBH', 'WI', 'Phillips / Price County', 45.410000, -90.240000, 'http://weather.noaa.gov/weather/current/KPBH.html', 'http://weather.gov/data/current_obs/KPBH.rss', 'http://weather.gov/data/current_obs/KPBH.xml'),
('KPCZ', 'WI', 'Waupaca Municipal Airport', 44.333000, -89.020000, 'http://weather.noaa.gov/weather/current/KPCZ.html', 'http://weather.gov/data/current_obs/KPCZ.rss', 'http://weather.gov/data/current_obs/KPCZ.xml'),
('KPDC', 'WI', 'Prairie Du Chien Municipal Airport', 43.020000, -91.120000, 'http://weather.noaa.gov/weather/current/KPDC.html', 'http://weather.gov/data/current_obs/KPDC.rss', 'http://weather.gov/data/current_obs/KPDC.xml'),
('KRAC', 'WI', 'Racine, Batten International Airport', 42.760000, -87.810000, 'http://weather.noaa.gov/weather/current/KRAC.html', 'http://weather.gov/data/current_obs/KRAC.rss', 'http://weather.gov/data/current_obs/KRAC.xml'),
('KRCX', 'WI', 'Rusk County Airport', 45.483000, -91.000000, 'http://weather.noaa.gov/weather/current/KRCX.html', 'http://weather.gov/data/current_obs/KRCX.rss', 'http://weather.gov/data/current_obs/KRCX.xml'),
('KRHI', 'WI', 'Rhinelander-Oneida County Airport', 45.630000, -89.470000, 'http://weather.noaa.gov/weather/current/KRHI.html', 'http://weather.gov/data/current_obs/KRHI.rss', 'http://weather.gov/data/current_obs/KRHI.xml'),
('KRNH', 'WI', 'New Richmond Municipal Airport', 45.148000, -92.538000, 'http://weather.noaa.gov/weather/current/KRNH.html', 'http://weather.gov/data/current_obs/KRNH.rss', 'http://weather.gov/data/current_obs/KRNH.xml'),
('KRPD', 'WI', 'Rice Lake Regl - Carls Field Airport', 45.510000, -91.730000, 'http://weather.noaa.gov/weather/current/KRPD.html', 'http://weather.gov/data/current_obs/KRPD.rss', 'http://weather.gov/data/current_obs/KRPD.xml'),
('KRRL', 'WI', 'Merrill Municipal Airport', 45.200000, -89.710000, 'http://weather.noaa.gov/weather/current/KRRL.html', 'http://weather.gov/data/current_obs/KRRL.rss', 'http://weather.gov/data/current_obs/KRRL.xml'),
('KRYV', 'WI', 'Watertown', 43.170000, -88.720000, 'http://weather.noaa.gov/weather/current/KRYV.html', 'http://weather.gov/data/current_obs/KRYV.rss', 'http://weather.gov/data/current_obs/KRYV.xml'),
('KRZN', 'WI', 'Siren, Burnett County Airport', 45.823000, -92.373000, 'http://weather.noaa.gov/weather/current/KRZN.html', 'http://weather.gov/data/current_obs/KRZN.rss', 'http://weather.gov/data/current_obs/KRZN.xml'),
('KSBM', 'WI', 'Sheboygan County Memorial Airport', 43.780000, -87.850000, 'http://weather.noaa.gov/weather/current/KSBM.html', 'http://weather.gov/data/current_obs/KSBM.rss', 'http://weather.gov/data/current_obs/KSBM.xml'),
('KSTE', 'WI', 'Stevens Point Municipal Airport', 44.550000, -89.530000, 'http://weather.noaa.gov/weather/current/KSTE.html', 'http://weather.gov/data/current_obs/KSTE.rss', 'http://weather.gov/data/current_obs/KSTE.xml'),
('KSUE', 'WI', 'Sturgeon Bay', 44.840000, -87.370000, 'http://weather.noaa.gov/weather/current/KSUE.html', 'http://weather.gov/data/current_obs/KSUE.rss', 'http://weather.gov/data/current_obs/KSUE.xml'),
('KSUW', 'WI', 'Superior, Richard I. Bong Airport', 46.690000, -92.095000, 'http://weather.noaa.gov/weather/current/KSUW.html', 'http://weather.gov/data/current_obs/KSUW.rss', 'http://weather.gov/data/current_obs/KSUW.xml'),
('KTKV', 'WI', 'Tomahawk Regional Airport', 45.469000, -89.806000, 'http://weather.noaa.gov/weather/current/KTKV.html', 'http://weather.gov/data/current_obs/KTKV.rss', 'http://weather.gov/data/current_obs/KTKV.xml'),
('KUES', 'WI', 'Waukesha County Airport', 43.010000, -88.200000, 'http://weather.noaa.gov/weather/current/KUES.html', 'http://weather.gov/data/current_obs/KUES.rss', 'http://weather.gov/data/current_obs/KUES.xml'),
('KUNU', 'WI', 'Juneau, Dodge County Airport', 43.430000, -88.700000, 'http://weather.noaa.gov/weather/current/KUNU.html', 'http://weather.gov/data/current_obs/KUNU.rss', 'http://weather.gov/data/current_obs/KUNU.xml'),
('KVOK', 'WI', 'Volk / Camp Douglas', 43.933000, -90.267000, 'http://weather.noaa.gov/weather/current/KVOK.html', 'http://weather.gov/data/current_obs/KVOK.rss', 'http://weather.gov/data/current_obs/KVOK.xml'),
('NSFA', 'WS', 'Faleolo Intl/Apia', -13.817000, -172.000000, 'http://weather.noaa.gov/weather/current/NSFA.html', 'http://weather.gov/data/current_obs/NSFA.rss', 'http://weather.gov/data/current_obs/NSFA.xml'),
('K48I', 'WV', 'Braxton County Airport', 38.733000, -80.650000, 'http://weather.noaa.gov/weather/current/K48I.html', 'http://weather.gov/data/current_obs/K48I.rss', 'http://weather.gov/data/current_obs/K48I.xml'),
('KBKW', 'WV', 'Beckley, Raleigh County Memorial Airport', 37.790000, -81.120000, 'http://weather.noaa.gov/weather/current/KBKW.html', 'http://weather.gov/data/current_obs/KBKW.rss', 'http://weather.gov/data/current_obs/KBKW.xml'),
('KBLF', 'WV', 'Bluefield, Mercer County Airport', 37.300000, -81.220000, 'http://weather.noaa.gov/weather/current/KBLF.html', 'http://weather.gov/data/current_obs/KBLF.rss', 'http://weather.gov/data/current_obs/KBLF.xml'),
('KCKB', 'WV', 'Clarksburg Benedum Airport', 39.290000, -80.230000, 'http://weather.noaa.gov/weather/current/KCKB.html', 'http://weather.gov/data/current_obs/KCKB.rss', 'http://weather.gov/data/current_obs/KCKB.xml'),
('KCRW', 'WV', 'Charleston, Yeager Airport', 38.380000, -81.600000, 'http://weather.noaa.gov/weather/current/KCRW.html', 'http://weather.gov/data/current_obs/KCRW.rss', 'http://weather.gov/data/current_obs/KCRW.xml'),
('KEKN', 'WV', 'Elkins-Randolph County-Jennings Randolph Field', 38.890000, -79.850000, 'http://weather.noaa.gov/weather/current/KEKN.html', 'http://weather.gov/data/current_obs/KEKN.rss', 'http://weather.gov/data/current_obs/KEKN.xml'),
('KHLG', 'WV', 'Wheeling Ohio County Airport', 40.170000, -80.650000, 'http://weather.noaa.gov/weather/current/KHLG.html', 'http://weather.gov/data/current_obs/KHLG.rss', 'http://weather.gov/data/current_obs/KHLG.xml'),
('KHTS', 'WV', 'Huntington, Tri-State Airport', 38.380000, -82.550000, 'http://weather.noaa.gov/weather/current/KHTS.html', 'http://weather.gov/data/current_obs/KHTS.rss', 'http://weather.gov/data/current_obs/KHTS.xml'),
('KLWB', 'WV', 'Lewisburg / Greenbrier', 37.880000, -80.400000, 'http://weather.noaa.gov/weather/current/KLWB.html', 'http://weather.gov/data/current_obs/KLWB.rss', 'http://weather.gov/data/current_obs/KLWB.xml'),
('KMGW', 'WV', 'Morgantown Municipal-Hart Field', 39.640000, -79.920000, 'http://weather.noaa.gov/weather/current/KMGW.html', 'http://weather.gov/data/current_obs/KMGW.rss', 'http://weather.gov/data/current_obs/KMGW.xml'),
('KMRB', 'WV', 'Martinsburg, Eastern W. Virginia Reg/Shepherdstown', 39.410000, -77.980000, 'http://weather.noaa.gov/weather/current/KMRB.html', 'http://weather.gov/data/current_obs/KMRB.rss', 'http://weather.gov/data/current_obs/KMRB.xml'),
('KPKB', 'WV', 'Parkersburg, Wood County Airport/Gill Robb Wilson', 39.360000, -81.430000, 'http://weather.noaa.gov/weather/current/KPKB.html', 'http://weather.gov/data/current_obs/KPKB.rss', 'http://weather.gov/data/current_obs/KPKB.xml'),
('KW22', 'WV', 'Buckhannon/Upshur Co. Reg. Airport', 39.000000, -80.267000, 'http://weather.noaa.gov/weather/current/KW22.html', 'http://weather.gov/data/current_obs/KW22.rss', 'http://weather.gov/data/current_obs/KW22.xml'),
('KW99', 'WV', 'Petersburg, Grant County Airport', 38.983000, -79.133000, 'http://weather.noaa.gov/weather/current/KW99.html', 'http://weather.gov/data/current_obs/KW99.rss', 'http://weather.gov/data/current_obs/KW99.xml'),
('KARL', 'WY', 'Arlington', 41.583000, -106.200000, 'http://weather.noaa.gov/weather/current/KARL.html', 'http://weather.gov/data/current_obs/KARL.rss', 'http://weather.gov/data/current_obs/KARL.xml'),
('KBPI', 'WY', 'Big Piney/Marbleton Airport', 42.580000, -110.100000, 'http://weather.noaa.gov/weather/current/KBPI.html', 'http://weather.gov/data/current_obs/KBPI.rss', 'http://weather.gov/data/current_obs/KBPI.xml'),
('KBRX', 'WY', 'Anonymous Wy Ob', 41.933000, -104.550000, 'http://weather.noaa.gov/weather/current/KBRX.html', 'http://weather.gov/data/current_obs/KBRX.rss', 'http://weather.gov/data/current_obs/KBRX.xml'),
('KBYG', 'WY', 'Buffalo/Johnson County', 44.380000, -106.720000, 'http://weather.noaa.gov/weather/current/KBYG.html', 'http://weather.gov/data/current_obs/KBYG.rss', 'http://weather.gov/data/current_obs/KBYG.xml'),
('KCOD', 'WY', 'Cody/Yellowstone Regional Airport', 44.530000, -109.020000, 'http://weather.noaa.gov/weather/current/KCOD.html', 'http://weather.gov/data/current_obs/KCOD.rss', 'http://weather.gov/data/current_obs/KCOD.xml'),
('KCPR', 'WY', 'Casper/Natrona Intl Airport', 42.930000, -106.470000, 'http://weather.noaa.gov/weather/current/KCPR.html', 'http://weather.gov/data/current_obs/KCPR.rss', 'http://weather.gov/data/current_obs/KCPR.xml'),
('KCYS', 'WY', 'Cheyenne/Warren AFB', 41.160000, -104.820000, 'http://weather.noaa.gov/weather/current/KCYS.html', 'http://weather.gov/data/current_obs/KCYS.rss', 'http://weather.gov/data/current_obs/KCYS.xml'),
('KDGW', 'WY', 'Douglas/Converse County Airport', 42.800000, -105.390000, 'http://weather.noaa.gov/weather/current/KDGW.html', 'http://weather.gov/data/current_obs/KDGW.rss', 'http://weather.gov/data/current_obs/KDGW.xml'),
('KEVW', 'WY', 'Evanston/Burns', 41.270000, -111.030000, 'http://weather.noaa.gov/weather/current/KEVW.html', 'http://weather.gov/data/current_obs/KEVW.rss', 'http://weather.gov/data/current_obs/KEVW.xml'),
('KGCC', 'WY', 'Gillette', 44.360000, -105.530000, 'http://weather.noaa.gov/weather/current/KGCC.html', 'http://weather.gov/data/current_obs/KGCC.rss', 'http://weather.gov/data/current_obs/KGCC.xml'),
('KGEY', 'WY', 'Greybull/S Big Horn Airport', 44.520000, -108.080000, 'http://weather.noaa.gov/weather/current/KGEY.html', 'http://weather.gov/data/current_obs/KGEY.rss', 'http://weather.gov/data/current_obs/KGEY.xml'),
('KJAC', 'WY', 'Jackson Hole Airport', 43.610000, -110.730000, 'http://weather.noaa.gov/weather/current/KJAC.html', 'http://weather.gov/data/current_obs/KJAC.rss', 'http://weather.gov/data/current_obs/KJAC.xml'),
('KLAR', 'WY', 'Laramie/Gen. Brees', 41.330000, -105.680000, 'http://weather.noaa.gov/weather/current/KLAR.html', 'http://weather.gov/data/current_obs/KLAR.rss', 'http://weather.gov/data/current_obs/KLAR.xml'),
('KLND', 'WY', 'Lander/Hunt Field', 42.830000, -108.730000, 'http://weather.noaa.gov/weather/current/KLND.html', 'http://weather.gov/data/current_obs/KLND.rss', 'http://weather.gov/data/current_obs/KLND.xml'),
('KP60', 'WY', 'Lake Yellowstone', 44.550000, -110.420000, 'http://weather.noaa.gov/weather/current/KP60.html', 'http://weather.gov/data/current_obs/KP60.rss', 'http://weather.gov/data/current_obs/KP60.xml'),
('KPNA', 'WY', 'Ralph Wenz Field Airport', 42.783000, -109.800000, 'http://weather.noaa.gov/weather/current/KPNA.html', 'http://weather.gov/data/current_obs/KPNA.rss', 'http://weather.gov/data/current_obs/KPNA.xml'),
('KPUM', 'WY', 'Pumpkin Vine', 41.033000, -105.450000, 'http://weather.noaa.gov/weather/current/KPUM.html', 'http://weather.gov/data/current_obs/KPUM.rss', 'http://weather.gov/data/current_obs/KPUM.xml'),
('KRIW', 'WY', 'Riverton Regional Airport', 43.050000, -108.450000, 'http://weather.noaa.gov/weather/current/KRIW.html', 'http://weather.gov/data/current_obs/KRIW.rss', 'http://weather.gov/data/current_obs/KRIW.xml'),
('KRKS', 'WY', 'Rock Springs', 41.610000, -109.070000, 'http://weather.noaa.gov/weather/current/KRKS.html', 'http://weather.gov/data/current_obs/KRKS.rss', 'http://weather.gov/data/current_obs/KRKS.xml'),
('KRWL', 'WY', 'Rawlins Municipal', 41.800000, -107.200000, 'http://weather.noaa.gov/weather/current/KRWL.html', 'http://weather.gov/data/current_obs/KRWL.rss', 'http://weather.gov/data/current_obs/KRWL.xml'),
('KSHR', 'WY', 'Sheridan Co. Arpt', 44.780000, -106.970000, 'http://weather.noaa.gov/weather/current/KSHR.html', 'http://weather.gov/data/current_obs/KSHR.rss', 'http://weather.gov/data/current_obs/KSHR.xml'),
('KSIB', 'WY', 'Sibley Peak', 42.433000, -105.033000, 'http://weather.noaa.gov/weather/current/KSIB.html', 'http://weather.gov/data/current_obs/KSIB.rss', 'http://weather.gov/data/current_obs/KSIB.xml'),
('KTOR', 'WY', 'Torrington Muni', 42.060000, -104.150000, 'http://weather.noaa.gov/weather/current/KTOR.html', 'http://weather.gov/data/current_obs/KTOR.rss', 'http://weather.gov/data/current_obs/KTOR.xml'),
('KVDW', 'WY', 'Vedauwoo', 41.150000, -105.400000, 'http://weather.noaa.gov/weather/current/KVDW.html', 'http://weather.gov/data/current_obs/KVDW.rss', 'http://weather.gov/data/current_obs/KVDW.xml'),
('KWRL', 'WY', 'Worland Municip', 43.980000, -107.970000, 'http://weather.noaa.gov/weather/current/KWRL.html', 'http://weather.gov/data/current_obs/KWRL.rss', 'http://weather.gov/data/current_obs/KWRL.xml');
